#ifndef _TEXFONTS
#define _TEXFONTS
/****************************************************************************
 *
 * Copyright(c) 2002-2003, John Forkosh Associates, Inc. All rights reserved.
 * --------------------------------------------------------------------------
 * This file is part of mimeTeX, which is free software. You may redistribute
 * and/or modify it under the terms of the GNU General Public License,
 * version 2 or later, as published by the Free Software Foundation.
 *      MimeTeX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, not even the implied warranty of MERCHANTABILITY.
 * See the GNU General Public License for specific details.
 *      By using mimeTeX, you warrant that you have read, understood and
 * agreed to these terms and conditions, and that you are at least 18 years
 * of age and possess the legal right and ability to enter into this
 * agreement and to use mimeTeX in accordance with it.
 *      Your mimeTeX distribution should contain a copy of the GNU General
 * Public License.  If not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA,
 * or point your browser to  http://www.gnu.org/licenses/gpl.html
 * --------------------------------------------------------------------------
 *
 * Purpose:	chardef structure data for mimetex
 *		generated by gfuntype
 * 
 * Source:	texfonts.h
 *
 * Notes:     o	Each big declaration of static chardef arrays
 *		is generated by a single run of my program gfuntype,
 *		as explained in the notes below, and then all those
 *		separate outputs are gathered together in this file.
 *	      o	You must first run metafont to generate a .gf file,
 *		for example...
 *		  mf '\mode=onetz; mag=magstep(.5); input cmmi10'
 *		will generate file cmmi10.131gf (which corresponds
 *		to size=3 below)
 *	      o	Given that (or any other) .gf file, next run
 *		  gftype -i cmmi10.131gf > typeout
 *		(where  typeout  can be any filename you like)
 *	      o	Then run my program against the above output,
 *		for example...
 *		  gfuntype  -n cmmi131  typeout  cmmi131.h
 *		which generates output file cmmib131.h (or any
 *		filename you supply as the last arg), containing
 *		the  static chardef cmmi131[]  array of data.
 *		(The name of that array is taken from the  -n  arg
 *		you supplied to gfuntype.)
 *	      o	Repeat the above steps for all the arrays you need,
 *		and then gather the output together in this file,
 *		texfonts.h, which will be #include'd by mimetex.h
 *	      o	Finally, manually edit the  fonttable[]  array
 *		in minetex.h, placing the names of all these chardef
 *		arrays in the appropriate fonttable[] cells.
 *	      o	Now you can recompile mimetex.c to use your new fonts.
 *
 * --------------------------------------------------------------------------
 * Revision History:
 * 10/05/02	J.Forkosh	Installation.
 * 07/10/03	J.Forkosh	Added cmmi10 fonts (in addition to cmmib10),
 *				and rsfs fonts.
 * 07/12/03	J.Forkosh	Entirely new set of fonts generated.
 * 10/21/05	J.Forkosh	Compressed fonts generated
 *
 ***************************************************************************/


/* ------------------------------------------------------------------------
font sizes 0-7 for cmr10
------------------------------------------------------------------------ */

/* --- size=0 for .83gf ---
 * mf '\mode=eighthre;  input cmr10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmr83 --- */
static	chardef  cmr83[] =
   {
      /* --- pixel bitmap for cmr83 char#0 \Gamma --- */
      {   0, 1561,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\x28\x0a\x82\x20\x1c" }  },
      /* --- pixel bitmap for cmr83 char#1 \Delta --- */
      {   1, 1588,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x28\x28\x6c\x44\x44\x82\xfe" }  },
      /* --- pixel bitmap for cmr83 char#2 \Theta --- */
      {   2, 1623,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x14\xb6\x61\x28\x31" }  },
      /* --- pixel bitmap for cmr83 char#3 \Lambda --- */
      {   3, 1660,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x85\x42\xa1\x88\xee" }  },
      /* --- pixel bitmap for cmr83 char#4 \Xi --- */
      {   4, 1695,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xa0\xc8\x27\x02\x04\xff" }  },
      /* --- pixel bitmap for cmr83 char#5 \Pi --- */
      {   5, 1726,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xf5\x11\x41\x13\x23" }  },
      /* --- pixel bitmap for cmr83 char#6 \Sigma --- */
      {   6, 1763,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x4a\x42\xac\xfc" }  },
      /* --- pixel bitmap for cmr83 char#7 \Upsilon --- */
      {   7, 1794,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x8a\x20\x08\x82\x70" }  },
      /* --- pixel bitmap for cmr83 char#8 \Phi --- */
      {   8, 1823,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\xb8\x5a\x1d\x71" }  },
      /* --- pixel bitmap for cmr83 char#9 \Psi --- */
      {   9, 1854,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x92\xa6\xab\x87\x70" }  },
      /* --- pixel bitmap for cmr83 char#10 \Omega --- */
      {  10, 1889,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x91\x48\x24\xa2\x54\xef" }  },
      /* --- pixel bitmap for cmr83 char#11 \ff --- */
      {  11, 3214,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x24\x24\x7f\x24\x24\x24\x66" }  },
      /* --- pixel bitmap for cmr83 char#12 \fi --- */
      {  12, 3249,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x41\x7c\x1c\x45\xd9" }  },
      /* --- pixel bitmap for cmr83 char#13 \fl --- */
      {  13, 3278,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x45\x7d\x14\x45\xd9" }  },
      /* --- pixel bitmap for cmr83 char#14 \ffi --- */
      {  14, 3313,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x91\x40\xc2\x7f\xa4\x91\x44\x92\xdd" }  },
      /* --- pixel bitmap for cmr83 char#15 \ffl --- */
      {  15, 3356,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x91\x44\xd2\x7f\x24\x91\x44\x92\xc9" }  },
      /* --- pixel bitmap for cmr83 char#16 \imath --- */
      {  16, 2288,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\x74" }  },
      /* --- pixel bitmap for cmr83 char#17 \jmath --- */
      {  17, 2305,                      /* character number, location */
          5,-1,   -2,-1,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x26\x49\x1e" }  },
      /* --- pixel bitmap for cmr83 char#18 \gravesym --- */
      {  18, 3052,                      /* character number, location */
          8, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09" }  },
      /* --- pixel bitmap for cmr83 char#19 \acutesym --- */
      {  19, 3063,                      /* character number, location */
          8, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06" }  },
      /* --- pixel bitmap for cmr83 char#20 \checksym --- */
      {  20, 3074,                      /* character number, location */
          7, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  3,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07" }  },
      /* --- pixel bitmap for cmr83 char#21 \brevesym --- */
      {  21, 3083,                      /* character number, location */
          8, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  3,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3d" }  },
      /* --- pixel bitmap for cmr83 char#22 (noname) --- */
      {  22, 3096,                      /* character number, location */
          7, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  3,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07" }  },
      /* --- pixel bitmap for cmr83 char#23 (noname) --- */
      {  23, 3105,                      /* character number, location */
          8, 3,    6, 3,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr83 char#24 (noname) --- */
      {  24, 3116,                      /* character number, location */
          0, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e" }  },
      /* --- pixel bitmap for cmr83 char#25 \ss --- */
      {  25, 2326,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\xa9\x25\xa5\x5c" }  },
      /* --- pixel bitmap for cmr83 char#26 \ae --- */
      {  26, 2363,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x7f\x22\x69\x03" }  },
      /* --- pixel bitmap for cmr83 char#27 \oe --- */
      {  27, 2390,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xf1\x11\x91\x6e" }  },
      /* --- pixel bitmap for cmr83 char#28 (noname) --- */
      {  28, 2419,                      /* character number, location */
          6, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd0\xf5\x7a\x5d\x00" }  },
      /* --- pixel bitmap for cmr83 char#29 \AE --- */
      {  29, 2448,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x30\x51\xa2\xc2\x97\xaa\xc4\xf9" }  },
      /* --- pixel bitmap for cmr83 char#30 \OE --- */
      {  30, 2495,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xc9\x14\x5b\x38\xa1\xc6\x28\x23\xff" }  },
      /* --- pixel bitmap for cmr83 char#31 (noname) --- */
      {  31, 2542,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x96\xa6\x6d\x69\x39\x02" }  },
      /* --- pixel bitmap for cmr83 char#32 (noname) --- */
      {  32, 3146,                      /* character number, location */
          4, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          {  2,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03" }  },
      /* --- pixel bitmap for cmr83 char#33 ! --- */
      {  33, 2587,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  1,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f" }  },
      /* --- pixel bitmap for cmr83 char#34 " --- */
      {  34, 3403,                      /* character number, location */
          8, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6d\x01" }  },
      /* --- pixel bitmap for cmr83 char#35 # --- */
      {  35, 2629,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x28\x14\xea\x4f\xa1\x50\xfe\x0a\x05" }  },
      /* --- pixel bitmap for cmr83 char#36 $ --- */
      {  36, 2180,                      /* character number, location */
          9, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\x3f\xff\x12" }  },
      /* --- pixel bitmap for cmr83 char#37 % --- */
      {  37, 2672,                      /* character number, location */
          9, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\x5e\xa9\xa2\x40\x51\xa5\xd2\x10" }  },
      /* --- pixel bitmap for cmr83 char#38 & --- */
      {  38, 2207,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x0a\x87\xed\xca\x44\xdc" }  },
      /* --- pixel bitmap for cmr83 char#39 ' --- */
      {  39, 2729,                      /* character number, location */
          8, 1,    5, 1,      /* topleft row,col, and botleft row,col */
          {  1,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07" }  },
      /* --- pixel bitmap for cmr83 char#40 ( --- */
      {  40, 2742,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  2,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x55\x95\x02" }  },
      /* --- pixel bitmap for cmr83 char#41 ) --- */
      {  41, 2775,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  2,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\xaa\x6a\x01" }  },
      /* --- pixel bitmap for cmr83 char#42 * --- */
      {  42, 2808,                      /* character number, location */
          9, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x2e" }  },
      /* --- pixel bitmap for cmr83 char#43 + --- */
      {  43, 2825,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x31\x26\xf3\x31\x2f" }  },
      /* --- pixel bitmap for cmr83 char#44 (noname) --- */
      {  44, 2850,                      /* character number, location */
          1, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  1,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07" }  },
      /* --- pixel bitmap for cmr83 char#45 (noname) --- */
      {  45, 3422,                      /* character number, location */
          3, 0,    2, 0,      /* topleft row,col, and botleft row,col */
          {  3,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07" }  },
      /* --- pixel bitmap for cmr83 char#46 (noname) --- */
      {  46, 2863,                      /* character number, location */
          1, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  1,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01" }  },
      /* --- pixel bitmap for cmr83 char#47 / --- */
      {  47, 2872,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x25\x49\x4a\x02" }  },
      /* --- pixel bitmap for cmr83 char#48 0 --- */
      {  48, 1930,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc6\x18\xa3\x03" }  },
      /* --- pixel bitmap for cmr83 char#49 1 --- */
      {  49, 1961,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9a\x24\x1d" }  },
      /* --- pixel bitmap for cmr83 char#50 2 --- */
      {  50, 1982,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x88\xa4\x0f" }  },
      /* --- pixel bitmap for cmr83 char#51 3 --- */
      {  51, 2007,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x21\x06\xa3\x03" }  },
      /* --- pixel bitmap for cmr83 char#52 4 --- */
      {  52, 2032,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\xad\x8f\x10\x07" }  },
      /* --- pixel bitmap for cmr83 char#53 5 --- */
      {  53, 2055,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x17\x71\x98\x06" }  },
      /* --- pixel bitmap for cmr83 char#54 6 --- */
      {  54, 2078,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\x84\x17\xa3\x03" }  },
      /* --- pixel bitmap for cmr83 char#55 7 --- */
      {  55, 2103,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x24\x22\x02" }  },
      /* --- pixel bitmap for cmr83 char#56 8 --- */
      {  56, 2126,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x29\x17\xa3\x03" }  },
      /* --- pixel bitmap for cmr83 char#57 9 --- */
      {  57, 2155,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x46\x0f\x91\x01" }  },
      /* --- pixel bitmap for cmr83 char#58 : --- */
      {  58, 2903,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  1,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11" }  },
      /* --- pixel bitmap for cmr83 char#59 ; --- */
      {  59, 2916,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  1,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71" }  },
      /* --- pixel bitmap for cmr83 char#60 (noname) --- */
      {  60, 2608,                      /* character number, location */
          6, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  1,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9" }  },
      /* --- pixel bitmap for cmr83 char#61 = --- */
      {  61, 2933,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    5, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xf2\x66" }  },
      /* --- pixel bitmap for cmr83 char#62 (noname) --- */
      {  62, 2265,                      /* character number, location */
          6, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x20\x22\x79" }  },
      /* --- pixel bitmap for cmr83 char#63 ? --- */
      {  63, 2242,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x24\x02\x20" }  },
      /* --- pixel bitmap for cmr83 char#64 @ --- */
      {  64, 2946,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x37\xcf\xf3\xec\xf3" }  },
      /* --- pixel bitmap for cmr83 char#65 A --- */
      {  65,   35,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x18\x18\x3c\x24\x3c\x24\xe7" }  },
      /* --- pixel bitmap for cmr83 char#66 B --- */
      {  66,   64,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x28\xfa\xb2\x28\x7e" }  },
      /* --- pixel bitmap for cmr83 char#67 C --- */
      {  67,   97,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\xc6\x10\xa2\x64" }  },
      /* --- pixel bitmap for cmr83 char#68 D --- */
      {  68,  128,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x91\x50\x28\x14\x8a\x7e" }  },
      /* --- pixel bitmap for cmr83 char#69 E --- */
      {  69,  163,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x91\xcc\x23\x15\x0a\xff" }  },
      /* --- pixel bitmap for cmr83 char#70 F --- */
      {  70,  198,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\xa8\x3a\x8a\x20\x1c" }  },
      /* --- pixel bitmap for cmr83 char#71 G --- */
      {  71,  229,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x51\x28\x10\x0f\x89\x78" }  },
      /* --- pixel bitmap for cmr83 char#72 H --- */
      {  72,  262,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x42\x42\x7e\x42\x42\x42\xe7" }  },
      /* --- pixel bitmap for cmr83 char#73 I --- */
      {  73,  299,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x97\x24\xe9" }  },
      /* --- pixel bitmap for cmr83 char#74 J --- */
      {  74,  322,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x44\x44\x75" }  },
      /* --- pixel bitmap for cmr83 char#75 K --- */
      {  75,  347,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x32\x1a\x0e\x16\x12\x22\xe7" }  },
      /* --- pixel bitmap for cmr83 char#76 L --- */
      {  76,  384,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x20\x08\xa2\x28\xfe" }  },
      /* --- pixel bitmap for cmr83 char#77 M --- */
      {  77,  413,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x1b\x66\x98\x52\x4a\xc9\x24\xd3\xed" }  },
      /* --- pixel bitmap for cmr83 char#78 N --- */
      {  78,  466,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe3\x46\x4a\x4a\x52\x72\x62\x47" }  },
      /* --- pixel bitmap for cmr83 char#79 O --- */
      {  79,  511,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x14\x86\x61\x28\x31" }  },
      /* --- pixel bitmap for cmr83 char#80 P --- */
      {  80,  546,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x28\x8a\x9e\x20\x1c" }  },
      /* --- pixel bitmap for cmr83 char#81 Q --- */
      {  81,  575,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x14\x86\x61\xe8\x31\x00\x0c" }  },
      /* --- pixel bitmap for cmr83 char#82 R --- */
      {  82,  612,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x91\xc8\x23\x12\x89\xce" }  },
      /* --- pixel bitmap for cmr83 char#83 S --- */
      {  83,  647,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x31\x8c\x79" }  },
      /* --- pixel bitmap for cmr83 char#84 T --- */
      {  84,  674,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x64\x12\x81\x40\x20\x38" }  },
      /* --- pixel bitmap for cmr83 char#85 U --- */
      {  85,  705,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x42\x42\x42\x42\x42\x42\x3c" }  },
      /* --- pixel bitmap for cmr83 char#86 V --- */
      {  86,  742,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x42\x24\x24\x24\x18\x18\x18" }  },
      /* --- pixel bitmap for cmr83 char#87 W --- */
      {  87,  775,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x17\x11\x55\xa8\x42\x15\xaa\x20\x02\x11" }  },
      /* --- pixel bitmap for cmr83 char#88 X --- */
      {  88,  834,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\x24\x18\x18\x18\x34\x24\xe7" }  },
      /* --- pixel bitmap for cmr83 char#89 Y --- */
      {  89,  867,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x24\x28\x38\x10\x10\x10\x38" }  },
      /* --- pixel bitmap for cmr83 char#90 Z --- */
      {  90,  896,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2f\x15\x22\x65\xfc" }  },
      /* --- pixel bitmap for cmr83 char#91 [ --- */
      {  91, 2977,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x57\x55\xd5" }  },
      /* --- pixel bitmap for cmr83 char#92 (noname) --- */
      {  92, 3431,                      /* character number, location */
          8, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6d\x01" }  },
      /* --- pixel bitmap for cmr83 char#93 ] --- */
      {  93, 3008,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xab\xaa\xea" }  },
      /* --- pixel bitmap for cmr83 char#94 \^ --- */
      {  94, 3155,                      /* character number, location */
          8, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  3,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2a" }  },
      /* --- pixel bitmap for cmr83 char#95 (noname) --- */
      {  95, 3168,                      /* character number, location */
          9, 1,    8, 1,      /* topleft row,col, and botleft row,col */
          {  1,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01" }  },
      /* --- pixel bitmap for cmr83 char#96 (noname) --- */
      {  96, 3039,                      /* character number, location */
          8, 1,    5, 1,      /* topleft row,col, and botleft row,col */
          {  1,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07" }  },
      /* --- pixel bitmap for cmr83 char#97 a --- */
      {  97,  929,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\xa5\xec\x01" }  },
      /* --- pixel bitmap for cmr83 char#98 b --- */
      {  98,  950,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x08\x27\xa5\x74" }  },
      /* --- pixel bitmap for cmr83 char#99 c --- */
      {  99,  979,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x91\x06" }  },
      /* --- pixel bitmap for cmr83 char#100 d --- */
      { 100,  998,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x21\x97\x52\xf2" }  },
      /* --- pixel bitmap for cmr83 char#101 e --- */
      { 101, 1027,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x91\x06" }  },
      /* --- pixel bitmap for cmr83 char#102 f --- */
      { 102, 1046,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\x90\x47\x08\x71" }  },
      /* --- pixel bitmap for cmr83 char#103 g --- */
      { 103, 1069,                      /* character number, location */
          5, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\xa5\xe3\x62\x74" }  },
      /* --- pixel bitmap for cmr83 char#104 h --- */
      { 104, 1100,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x08\xa7\x94\xfa" }  },
      /* --- pixel bitmap for cmr83 char#105 i --- */
      { 105, 1129,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x30\x49\x07" }  },
      /* --- pixel bitmap for cmr83 char#106 j --- */
      { 106, 1150,                      /* character number, location */
          9,-1,   -2,-1,      /* topleft row,col, and botleft row,col */
          {  3,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x60\x92\xe4\x01" }  },
      /* --- pixel bitmap for cmr83 char#107 k --- */
      { 107, 1175,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\xe2\x66\xb6" }  },
      /* --- pixel bitmap for cmr83 char#108 l --- */
      { 108, 1200,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\x24\xe9" }  },
      /* --- pixel bitmap for cmr83 char#109 m --- */
      { 109, 1223,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x24\x49\x92\x74\x1b" }  },
      /* --- pixel bitmap for cmr83 char#110 n --- */
      { 110, 1256,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4f\x29\xf5\x01" }  },
      /* --- pixel bitmap for cmr83 char#111 o --- */
      { 111, 1279,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc6\xe8\x00" }  },
      /* --- pixel bitmap for cmr83 char#112 p --- */
      { 112, 1302,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4f\x4a\xe9\xc4\x01" }  },
      /* --- pixel bitmap for cmr83 char#113 q --- */
      { 113, 1329,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xa5\xe4\x10\x07" }  },
      /* --- pixel bitmap for cmr83 char#114 r --- */
      { 114, 1356,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x97\x74" }  },
      /* --- pixel bitmap for cmr83 char#115 s --- */
      { 115, 1373,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x96\x07" }  },
      /* --- pixel bitmap for cmr83 char#116 t --- */
      { 116, 1394,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\x64\x1b" }  },
      /* --- pixel bitmap for cmr83 char#117 u --- */
      { 117, 1415,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4f\x29\xe5\x01" }  },
      /* --- pixel bitmap for cmr83 char#118 v --- */
      { 118, 1438,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5b\x29\x42\x00" }  },
      /* --- pixel bitmap for cmr83 char#119 w --- */
      { 119, 1461,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6b\x9b\xcd\x46\x01" }  },
      /* --- pixel bitmap for cmr83 char#120 x --- */
      { 120, 1490,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdb\x10\xb5\x01" }  },
      /* --- pixel bitmap for cmr83 char#121 y --- */
      { 121, 1513,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5b\x29\x42\xc8\x00" }  },
      /* --- pixel bitmap for cmr83 char#122 z --- */
      { 122, 1540,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5f\xaf\x0f" }  },
      /* --- pixel bitmap for cmr83 char#123 (noname) --- */
      { 123, 3450,                      /* character number, location */
          4, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          {  5,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for cmr83 char#124 (noname) --- */
      { 124, 3459,                      /* character number, location */
          4, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          { 10,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a" }  },
      /* --- pixel bitmap for cmr83 char#125 (noname) --- */
      { 125, 3177,                      /* character number, location */
          8, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  3,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2d" }  },
      /* --- pixel bitmap for cmr83 char#126 \~ --- */
      { 126, 3192,                      /* character number, location */
          8, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  3,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c" }  },
      /* --- pixel bitmap for cmr83 char#127 (noname) --- */
      { 127, 3203,                      /* character number, location */
          9, 1,    8, 1,      /* topleft row,col, and botleft row,col */
          {  3,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=1 for .100gf ---
 * mf '\mode=preview; mag=magstep(-17.87427405946994351363); input cmr10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmr100 --- */
static	chardef  cmr100[] =
   {
      /* --- pixel bitmap for cmr100 char#0 \Gamma --- */
      {   0,51662,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xf2\x21\x41\xf3\x21\x55\x36" }  },
      /* --- pixel bitmap for cmr100 char#1 \Delta --- */
      {   1,52527,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\xc0\x80\x04\x12\x84\x18\x26\xd0\xc0\xff\x03" }  },
      /* --- pixel bitmap for cmr100 char#2 \Theta --- */
      {   2,53612,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x8c\x0d\x0e\x98\x33\xe0\x60\x63\x7c\x00" }  },
      /* --- pixel bitmap for cmr100 char#3 \Lambda --- */
      {   3,54508,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\xc0\x00\x03\x12\x48\x20\x41\x08\x21\xcf\x03" }  },
      /* --- pixel bitmap for cmr100 char#4 \Xi --- */
      {   4,55833,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x20\x40\xe4\x13\x01\x82\x7f" }  },
      /* --- pixel bitmap for cmr100 char#5 \Pi --- */
      {   5,56950,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xf6\x11\x41\x13\x23" }  },
      /* --- pixel bitmap for cmr100 char#6 \Sigma --- */
      {   6,58027,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xc3\x86\x8c\x08\x8c\x84\xc2\xff" }  },
      /* --- pixel bitmap for cmr100 char#7 \Upsilon --- */
      {   7,59081,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\x52\x02\x80\x00\x01\x02\x04\x08\x7c\x00" }  },
      /* --- pixel bitmap for cmr100 char#8 \Phi --- */
      {   8,60071,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x10\x3c\x91\x91\x91\x3c\x10\x7c" }  },
      /* --- pixel bitmap for cmr100 char#9 \Psi --- */
      {   9,61138,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x20\x4c\x96\x24\xc9\x1a\x1f\x08\x7c\x00" }  },
      /* --- pixel bitmap for cmr100 char#10 \Omega --- */
      {  10,62247,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x42\x81\x81\x81\x42\x42\xa5\xe7" }  },
      /* --- pixel bitmap for cmr100 char#11 \ff --- */
      {  11,105922,                     /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x13\x41\x04\x11\xff\x11\x41\x04\x11\x44\x18\x03" }  },
      /* --- pixel bitmap for cmr100 char#12 \fi --- */
      {  12,107044,                     /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x08\x08\x08\x7f\x68\x48\x48\x48\xcc" }  },
      /* --- pixel bitmap for cmr100 char#13 \fl --- */
      {  13,108160,                     /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x48\x48\x48\x7f\x48\x48\x48\x48\xcc" }  },
      /* --- pixel bitmap for cmr100 char#14 \ffi --- */
      {  14,109727,                     /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x87\x08\x88\x80\x08\xff\x87\x68\x88\x84\x48\x88"
            "\xc4\xc8" }  },
      /* --- pixel bitmap for cmr100 char#15 \ffl --- */
      {  15,111304,                     /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x87\x48\x88\x84\x48\xff\x87\x48\x88\x84\x48\x88"
            "\xc4\xc8" }  },
      /* --- pixel bitmap for cmr100 char#16 \imath --- */
      {  16,75438,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\xa4\x03" }  },
      /* --- pixel bitmap for cmr100 char#17 \jmath --- */
      {  17,76102,                      /* character number, location */
          6,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  4,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x88\x88\x88\x07" }  },
      /* --- pixel bitmap for cmr100 char#18 \gravesym --- */
      {  18,97521,                      /* character number, location */
         10, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          {  2,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x29" }  },
      /* --- pixel bitmap for cmr100 char#19 \acutesym --- */
      {  19,98064,                      /* character number, location */
         10, 3,    7, 3,      /* topleft row,col, and botleft row,col */
          {  2,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x16" }  },
      /* --- pixel bitmap for cmr100 char#20 \checksym --- */
      {  20,98663,                      /* character number, location */
          9, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          {  3,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x15" }  },
      /* --- pixel bitmap for cmr100 char#21 \brevesym --- */
      {  21,99253,                      /* character number, location */
         10, 1,    7, 1,      /* topleft row,col, and botleft row,col */
          {  5,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\x3a" }  },
      /* --- pixel bitmap for cmr100 char#22 (noname) --- */
      {  22,99807,                      /* character number, location */
          8, 1,    7, 1,      /* topleft row,col, and botleft row,col */
          {  5,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for cmr100 char#23 (noname) --- */
      {  23,100558,                     /* character number, location */
         10, 3,    7, 3,      /* topleft row,col, and botleft row,col */
          {  4,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x06" }  },
      /* --- pixel bitmap for cmr100 char#24 (noname) --- */
      {  24,101220,                     /* character number, location */
          0, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          {  3,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e" }  },
      /* --- pixel bitmap for cmr100 char#25 \ss --- */
      {  25,77147,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x91\x48\xb4\x11\x09\x85\xc2\x1d" }  },
      /* --- pixel bitmap for cmr100 char#26 \ae --- */
      {  26,78442,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xef\x20\xfa\x8f\x10\xd3\x1d" }  },
      /* --- pixel bitmap for cmr100 char#27 \oe --- */
      {  27,79514,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdc\x03\x63\xf8\x43\x30\x47\xcf\x01" }  },
      /* --- pixel bitmap for cmr100 char#28 (noname) --- */
      {  28,80280,                      /* character number, location */
          7, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\xde\x3c\xdb\x3c\x7b\x06" }  },
      /* --- pixel bitmap for cmr100 char#29 \AE --- */
      {  29,82006,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x87\x42\x28\x86\x62\xf8\x43\xa2\x24\x4a\x42\xe7"
            "\x07" }  },
      /* --- pixel bitmap for cmr100 char#30 \OE --- */
      {  30,83642,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xcf\x08\x0d\xb1\x20\x16\x7c\x82\xe8\x10\x35\x42"
            "\xfc\x0f" }  },
      /* --- pixel bitmap for cmr100 char#31 (noname) --- */
      {  31,84560,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\xf8\x08\x0b\x19\x33\x62\xc6\x84\x86\xf8\x08\x00" }  },
      /* --- pixel bitmap for cmr100 char#32 (noname) --- */
      {  32,101688,                     /* character number, location */
          5, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  4,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr100 char#33 ! --- */
      {  33,85153,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  1,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x02" }  },
      /* --- pixel bitmap for cmr100 char#34 " --- */
      {  34,112195,                     /* character number, location */
         10, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x99\x99" }  },
      /* --- pixel bitmap for cmr100 char#35 # --- */
      {  35,86539,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x41\x31\x1a\x31\x31\x20\xf1\x21\x31\x3a\xf3\x11"
            "\x31\x41" }  },
      /* --- pixel bitmap for cmr100 char#36 $ --- */
      {  36,71874,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xae\xd6\x62\x18\xad\xd5\x11" }  },
      /* --- pixel bitmap for cmr100 char#37 % --- */
      {  37,87726,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xe5\x93\x48\x12\x26\x40\x06\x25\x92\x44\x12\x29"
            "\x18" }  },
      /* --- pixel bitmap for cmr100 char#38 & --- */
      {  38,73090,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x24\x48\xd0\xe0\xde\xc8\x93\x14\x31\xdd\x01" }  },
      /* --- pixel bitmap for cmr100 char#39 ' --- */
      {  39,88316,                      /* character number, location */
         10, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  1,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr100 char#40 ( --- */
      {  40,88860,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x94\x92\x24\x89\x44" }  },
      /* --- pixel bitmap for cmr100 char#41 ) --- */
      {  41,89423,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x48\x92\xa4\x14" }  },
      /* --- pixel bitmap for cmr100 char#42 * --- */
      {  42,90010,                      /* character number, location */
         10, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\x3a\x57\x09" }  },
      /* --- pixel bitmap for cmr100 char#43 + --- */
      {  43,90660,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x41\x49\xf3\x41\x43" }  },
      /* --- pixel bitmap for cmr100 char#44 (noname) --- */
      {  44,91207,                      /* character number, location */
          1, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  1,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr100 char#45 (noname) --- */
      {  45,112664,                     /* character number, location */
          4, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          {  4,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr100 char#46 (noname) --- */
      {  46,91642,                      /* character number, location */
          1, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  1,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01" }  },
      /* --- pixel bitmap for cmr100 char#47 / --- */
      {  47,92120,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x22\x84\x08\x21\x42\x88\x10\x00" }  },
      /* --- pixel bitmap for cmr100 char#48 0 --- */
      {  48,62917,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc6\x18\x63\x8c\x0e" }  },
      /* --- pixel bitmap for cmr100 char#49 1 --- */
      {  49,63645,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe4\x10\x42\x08\x21\x1f" }  },
      /* --- pixel bitmap for cmr100 char#50 2 --- */
      {  50,64578,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x46\x08\x11\x91\x1f" }  },
      /* --- pixel bitmap for cmr100 char#51 3 --- */
      {  51,65566,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x42\xe8\x60\x8c\x0e" }  },
      /* --- pixel bitmap for cmr100 char#52 4 --- */
      {  52,66442,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x0c\x45\x32\xf9\x43\x20\x38" }  },
      /* --- pixel bitmap for cmr100 char#53 5 --- */
      {  53,67430,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x84\x17\x61\x8c\x0e" }  },
      /* --- pixel bitmap for cmr100 char#54 6 --- */
      {  54,68274,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x84\x17\x63\x94\x0e" }  },
      /* --- pixel bitmap for cmr100 char#55 7 --- */
      {  55,69122,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x08\x21\x08\x41\x10\x04" }  },
      /* --- pixel bitmap for cmr100 char#56 8 --- */
      {  56,69996,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x46\xe5\x62\x8c\x0e" }  },
      /* --- pixel bitmap for cmr100 char#57 9 --- */
      {  57,70846,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc5\x18\x3d\x44\x07" }  },
      /* --- pixel bitmap for cmr100 char#58 : --- */
      {  58,92666,                      /* character number, location */
          6, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  1,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21" }  },
      /* --- pixel bitmap for cmr100 char#59 ; --- */
      {  59,93299,                      /* character number, location */
          6, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\x01" }  },
      /* --- pixel bitmap for cmr100 char#60 (noname) --- */
      {  60,85729,                      /* character number, location */
          7, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  1,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x03" }  },
      /* --- pixel bitmap for cmr100 char#61 = --- */
      {  61,93943,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    5, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xf2\x99" }  },
      /* --- pixel bitmap for cmr100 char#62 (noname) --- */
      {  62,74897,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x00\x40\x88\x08\xd1\x01" }  },
      /* --- pixel bitmap for cmr100 char#63 ? --- */
      {  63,73999,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x42\x44\x08\x00\x80\x00" }  },
      /* --- pixel bitmap for cmr100 char#64 @ --- */
      {  64,95087,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\xe9\x2a\x5a\xb4\x68\x51\x7d\x06\xf0\x03" }  },
      /* --- pixel bitmap for cmr100 char#65 A --- */
      {  65, 1000,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\xc0\x00\x03\x12\x48\xe0\x41\x08\x21\xcf\x03" }  },
      /* --- pixel bitmap for cmr100 char#66 B --- */
      {  66, 2276,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\xc2\x82\xc2\x7e\x82\x82\xc2\x7f" }  },
      /* --- pixel bitmap for cmr100 char#67 C --- */
      {  67, 3151,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\xc2\x82\x01\x01\x01\x82\x82\x7c" }  },
      /* --- pixel bitmap for cmr100 char#68 D --- */
      {  68, 4209,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x41\x51\x10\xf4\x21\x61\x21\x51\x18\x21" }  },
      /* --- pixel bitmap for cmr100 char#69 E --- */
      {  69, 5552,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x42\x52\x52\x1e\x92\x92\x42\x7f" }  },
      /* --- pixel bitmap for cmr100 char#70 F --- */
      {  70, 6759,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\xa1\x54\xea\x91\x48\x04\x0f" }  },
      /* --- pixel bitmap for cmr100 char#71 G --- */
      {  71, 7882,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x84\x09\x0a\x10\x3e\x90\x20\x41\xfc\x00" }  },
      /* --- pixel bitmap for cmr100 char#72 H --- */
      {  72, 8999,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x42\x42\x42\x7e\x42\x42\x42\xe7" }  },
      /* --- pixel bitmap for cmr100 char#73 I --- */
      {  73, 9620,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    9, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xf6\x21\x25" }  },
      /* --- pixel bitmap for cmr100 char#74 J --- */
      {  74,10380,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x21\x84\x10\x4a\x07" }  },
      /* --- pixel bitmap for cmr100 char#75 K --- */
      {  75,11511,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\x13\x43\x06\x0d\x3c\x30\x41\x04\x21\xdf\x03" }  },
      /* --- pixel bitmap for cmr100 char#76 L --- */
      {  76,12404,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x04\x04\x04\x04\x84\x84\xc4\xff" }  },
      /* --- pixel bitmap for cmr100 char#77 M --- */
      {  77,13636,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x9e\xc1\x30\x18\x8a\x42\x51\x48\x09\x29\x21\x25"
            "\x5f\x1f" }  },
      /* --- pixel bitmap for cmr100 char#78 N --- */
      {  78,14698,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe3\x46\x46\x4a\x5a\x52\x62\x62\x47" }  },
      /* --- pixel bitmap for cmr100 char#79 O --- */
      {  79,15501,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x8c\x05\x0c\x18\x30\xe0\x60\x63\x7c\x00" }  },
      /* --- pixel bitmap for cmr100 char#80 P --- */
      {  80,16558,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\xa1\x50\xe8\x13\x08\x04\x07" }  },
      /* --- pixel bitmap for cmr100 char#81 Q --- */
      {  81,17531,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x8c\x0d\x0e\x18\x30\xe0\x60\x6f\x7c\x00\x00\x01"
            "\x04" }  },
      /* --- pixel bitmap for cmr100 char#82 R --- */
      {  82,18764,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x84\x08\x11\xe2\x43\x84\x08\x11\xe7\x01" }  },
      /* --- pixel bitmap for cmr100 char#83 S --- */
      {  83,19757,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x18\x0c\x1c\x08\x86\x1f" }  },
      /* --- pixel bitmap for cmr100 char#84 T --- */
      {  84,20785,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x0f\x21\x41\x31\xf3\x51\x40\x35\x21" }  },
      /* --- pixel bitmap for cmr100 char#85 U --- */
      {  85,21725,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x23\xf6\x11\x41\x10\x24\x20" }  },
      /* --- pixel bitmap for cmr100 char#86 V --- */
      {  86,22663,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x13\x42\x08\x12\x48\x20\x01\x03\x0c\x30\x00" }  },
      /* --- pixel bitmap for cmr100 char#87 W --- */
      {  87,24012,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x3d\x31\x42\x8c\x90\x24\x24\x09\x4a\x81\x61\x60"
            "\x18\x10\x02" }  },
      /* --- pixel bitmap for cmr100 char#88 X --- */
      {  88,25057,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x31\x81\x06\x0c\x30\xc0\x80\x04\x21\xcf\x03" }  },
      /* --- pixel bitmap for cmr100 char#89 Y --- */
      {  89,26149,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x13\x82\x0c\x14\x30\x80\x00\x02\x08\x70\x00" }  },
      /* --- pixel bitmap for cmr100 char#90 Z --- */
      {  90,27142,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x14\x25\x0c\x29\xca\x3f" }  },
      /* --- pixel bitmap for cmr100 char#91 [ --- */
      {  91,95760,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x0f\xa1\x23" }  },
      /* --- pixel bitmap for cmr100 char#92 (noname) --- */
      {  92,113505,                     /* character number, location */
         10, 3,    6, 3,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x99\x99" }  },
      /* --- pixel bitmap for cmr100 char#93 ] --- */
      {  93,96408,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xfa\x21\x03" }  },
      /* --- pixel bitmap for cmr100 char#94 \^ --- */
      {  94,102285,                     /* character number, location */
         10, 2,    8, 2,      /* topleft row,col, and botleft row,col */
          {  3,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2a" }  },
      /* --- pixel bitmap for cmr100 char#95 (noname) --- */
      {  95,102722,                     /* character number, location */
         10, 2,    9, 2,      /* topleft row,col, and botleft row,col */
          {  1,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01" }  },
      /* --- pixel bitmap for cmr100 char#96 (noname) --- */
      {  96,96976,                      /* character number, location */
         10, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  1,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr100 char#97 a --- */
      {  97,28238,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xe4\x45\xb1\x0f" }  },
      /* --- pixel bitmap for cmr100 char#98 b --- */
      {  98,29194,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x20\x08\x9e\x28\x8a\xa2\x07" }  },
      /* --- pixel bitmap for cmr100 char#99 c --- */
      {  99,29921,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x84\x10\x1d" }  },
      /* --- pixel bitmap for cmr100 char#100 d --- */
      { 100,30876,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x04\x41\x5e\x14\x45\x91\x0f" }  },
      /* --- pixel bitmap for cmr100 char#101 e --- */
      { 101,31588,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\xf8\x07\x23\x07" }  },
      /* --- pixel bitmap for cmr100 char#102 f --- */
      { 102,32397,                      /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x41\x10\x1f\x41\x10\x84\x03" }  },
      /* --- pixel bitmap for cmr100 char#103 g --- */
      { 103,33592,                      /* character number, location */
          6, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x89\xc4\x21\xf0\x05\x83\x63\x0e" }  },
      /* --- pixel bitmap for cmr100 char#104 h --- */
      { 104,34521,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x20\x08\x8e\x24\x49\xd2\x0d" }  },
      /* --- pixel bitmap for cmr100 char#105 i --- */
      { 105,35164,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x30\x49\x3a" }  },
      /* --- pixel bitmap for cmr100 char#106 j --- */
      { 106,35922,                      /* character number, location */
         10,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x00\x8c\x88\x88\x88\x07" }  },
      /* --- pixel bitmap for cmr100 char#107 k --- */
      { 107,36998,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x81\x40\xa0\x57\x38\x14\x92\x3b" }  },
      /* --- pixel bitmap for cmr100 char#108 l --- */
      { 108,37547,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\x24\x49\x3a" }  },
      /* --- pixel bitmap for cmr100 char#109 m --- */
      { 109,38846,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\x11\x91\x88\x44\x24\xa2\x33\x03" }  },
      /* --- pixel bitmap for cmr100 char#110 n --- */
      { 110,39779,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8f\x24\x49\xd2\x0d" }  },
      /* --- pixel bitmap for cmr100 char#111 o --- */
      { 111,40432,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x71\x30\x38\xe6\x00" }  },
      /* --- pixel bitmap for cmr100 char#112 p --- */
      { 112,41456,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x28\x8a\xa2\x27\x08\x07" }  },
      /* --- pixel bitmap for cmr100 char#113 q --- */
      { 113,42438,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x51\x28\x24\xe3\x81\x40\x70" }  },
      /* --- pixel bitmap for cmr100 char#114 r --- */
      { 114,43249,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5f\x08\x21\x0e" }  },
      /* --- pixel bitmap for cmr100 char#115 s --- */
      { 115,44144,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x19\x1c\x1f" }  },
      /* --- pixel bitmap for cmr100 char#116 t --- */
      { 116,44927,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\xf2\x22\xaa\x04" }  },
      /* --- pixel bitmap for cmr100 char#117 u --- */
      { 117,45812,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9b\x24\x49\x12\x0f" }  },
      /* --- pixel bitmap for cmr100 char#118 v --- */
      { 118,46660,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x11\x85\x42\x41\x00" }  },
      /* --- pixel bitmap for cmr100 char#119 w --- */
      { 119,47871,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\xcb\xc4\x0c\x33\xcc\x30\x03" }  },
      /* --- pixel bitmap for cmr100 char#120 x --- */
      { 120,48812,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x0a\x02\x41\xb9\x03" }  },
      /* --- pixel bitmap for cmr100 char#121 y --- */
      { 121,49861,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x19\x85\xc2\x41\x20\x08\x07" }  },
      /* --- pixel bitmap for cmr100 char#122 z --- */
      { 122,50776,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x39\x2b\x3f" }  },
      /* --- pixel bitmap for cmr100 char#123 (noname) --- */
      { 123,114079,                     /* character number, location */
          4, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          {  7,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f" }  },
      /* --- pixel bitmap for cmr100 char#124 (noname) --- */
      { 124,114873,                     /* character number, location */
          4, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          { 14,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e" }  },
      /* --- pixel bitmap for cmr100 char#125 (noname) --- */
      { 125,103371,                     /* character number, location */
         10, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          {  4,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x05" }  },
      /* --- pixel bitmap for cmr100 char#126 \~ --- */
      { 126,104025,                     /* character number, location */
          9, 1,    7, 1,      /* topleft row,col, and botleft row,col */
          {  5,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb6\x01" }  },
      /* --- pixel bitmap for cmr100 char#127 (noname) --- */
      { 127,104678,                     /* character number, location */
         10, 2,    9, 2,      /* topleft row,col, and botleft row,col */
          {  3,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=2 for .118gf ---
 * mf '\mode=preview; mag=magstep(-16.96645799324018499600); input cmr10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmr118 --- */
static	chardef  cmr118[] =
   {
      /* --- pixel bitmap for cmr118 char#0 \Gamma --- */
      {   0,52128,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x21\x42\xf1\x21\x51\xf5\x21\x65\x41" }  },
      /* --- pixel bitmap for cmr118 char#1 \Delta --- */
      {   1,52997,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x00\x06\x90\x00\x09\x08\x81\x10\x04\x42\x20\x02"
            "\x34\xc0\xff\x0f" }  },
      /* --- pixel bitmap for cmr118 char#2 \Theta --- */
      {   2,54090,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x80\x02\x98\xc8\x7c\x26\x32\x80\x02\x22"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for cmr118 char#3 \Lambda --- */
      {   3,55002,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x00\x01\x14\xa0\x00\x05\x44\x20\x02\x11\x04\x21"
            "\xc8\xe3\x01" }  },
      /* --- pixel bitmap for cmr118 char#4 \Xi --- */
      {   4,56337,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03\x02\x00\x20\xc8\x9f\x20\x00\x01\x03\xfe\x07" }  },
      /* --- pixel bitmap for cmr118 char#5 \Pi --- */
      {   5,57458,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xf8\x21\x61\x25\x25" }  },
      /* --- pixel bitmap for cmr118 char#6 \Sigma --- */
      {   6,58543,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x6c\x20\x81\x08\x40\x80\x00\x83\x04\x0a\xfc"
            "\x3f" }  },
      /* --- pixel bitmap for cmr118 char#7 \Upsilon --- */
      {   7,59601,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x13\x33\x11\x31\x11\x31\xf1\xb0\xf5\x51\x50\x35\x31" }  },
      /* --- pixel bitmap for cmr118 char#8 \Phi --- */
      {   8,60593,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x80\x00\x02\x3f\x23\x87\x38\x32\x3f\x20\x80\x80"
            "\x0f" }  },
      /* --- pixel bitmap for cmr118 char#9 \Psi --- */
      {   9,61664,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x00\xc1\x88\x45\x24\x22\x11\x91\x04\x1f\x20\x00"
            "\x01\x3e\x00" }  },
      /* --- pixel bitmap for cmr118 char#10 \Omega --- */
      {  10,62781,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x08\x14\x60\x80\x01\x06\x28\x10\x21\x85\x2a\xe5"
            "\x1c" }  },
      /* --- pixel bitmap for cmr118 char#11 \ff --- */
      {  11,107078,                     /* character number, location */
         11,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x57\x32\x31\x30\xf1\x31\x41\x3b\x10\xf4\x31\x41\x30"
            "\x22\x43\x11" }  },
      /* --- pixel bitmap for cmr118 char#12 \fi --- */
      {  12,108204,                     /* character number, location */
         11,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x10\x20\x40\xf0\x0f\x19\x22\x44\x88\x10\x31\x06" }  },
      /* --- pixel bitmap for cmr118 char#13 \fl --- */
      {  13,109324,                     /* character number, location */
         11,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x10\x21\x42\xf4\x0f\x11\x22\x44\x88\x10\x31\x06" }  },
      /* --- pixel bitmap for cmr118 char#14 \ffi --- */
      {  14,110895,                     /* character number, location */
         11,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x1f\x46\x80\x10\x20\x04\xff\x1f\x42\x86\x10\x21"
            "\x44\x08\x11\x42\xc4\x10\x03" }  },
      /* --- pixel bitmap for cmr118 char#15 \ffl --- */
      {  15,112478,                     /* character number, location */
         11,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x42\x31\x31\x10\xf1\x31\x41\x31\x1d\x10\xf4\x31"
            "\x41\x31\x10\x23\x23\x13" }  },
      /* --- pixel bitmap for cmr118 char#16 \imath --- */
      {  16,76126,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\x24\x1d" }  },
      /* --- pixel bitmap for cmr118 char#17 \jmath --- */
      {  17,76792,                      /* character number, location */
          7,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x88\x88\x88\x78" }  },
      /* --- pixel bitmap for cmr118 char#18 \gravesym --- */
      {  18,98621,                      /* character number, location */
         11, 2,    8, 2,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x01" }  },
      /* --- pixel bitmap for cmr118 char#19 \acutesym --- */
      {  19,99164,                      /* character number, location */
         11, 3,    8, 3,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x00" }  },
      /* --- pixel bitmap for cmr118 char#20 \checksym --- */
      {  20,99763,                      /* character number, location */
         10, 2,    9, 2,      /* topleft row,col, and botleft row,col */
          {  4,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr118 char#21 \brevesym --- */
      {  21,100349,                     /* character number, location */
         11, 1,    8, 1,      /* topleft row,col, and botleft row,col */
          {  6,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\xec\x01" }  },
      /* --- pixel bitmap for cmr118 char#22 (noname) --- */
      {  22,100903,                     /* character number, location */
          9, 1,    8, 1,      /* topleft row,col, and botleft row,col */
          {  6,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f" }  },
      /* --- pixel bitmap for cmr118 char#23 (noname) --- */
      {  23,101654,                     /* character number, location */
         11, 4,    8, 4,      /* topleft row,col, and botleft row,col */
          {  4,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x06" }  },
      /* --- pixel bitmap for cmr118 char#24 (noname) --- */
      {  24,102316,                     /* character number, location */
          0, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  4,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x0f" }  },
      /* --- pixel bitmap for cmr118 char#25 \ss --- */
      {  25,77839,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x91\x48\xb4\x11\x09\x85\x42\xe1\x0e" }  },
      /* --- pixel bitmap for cmr118 char#26 \ae --- */
      {  26,79138,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x03\x23\xff\x45\x10\x82\x30\x7a\x0e" }  },
      /* --- pixel bitmap for cmr118 char#27 \oe --- */
      {  27,80214,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x27\xc5\xe1\x1f\x02\x21\x20\x85\x8c\x07" }  },
      /* --- pixel bitmap for cmr118 char#28 (noname) --- */
      {  28,80990,                      /* character number, location */
          9, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\xe4\x69\x69\x5b\x5a\x9e\x10\x00" }  },
      /* --- pixel bitmap for cmr118 char#29 \AE --- */
      {  29,82726,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x3f\x50\x18\x28\x08\x12\x05\x89\x80\x7f\x20\x22"
            "\x11\x91\x88\x20\x42\xd0\xf3\x0f" }  },
      /* --- pixel bitmap for cmr118 char#30 \OE --- */
      {  30,84376,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x7f\x84\x61\x82\x41\x81\x51\x01\x11\x01\x1f\x01"
            "\x91\x83\x91\x82\x41\x8c\x41\xf8\x7f" }  },
      /* --- pixel bitmap for cmr118 char#31 (noname) --- */
      {  31,85308,                      /* character number, location */
         12, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xc2\x0f\x61\x04\x15\xc4\x20\x86\x30\x82\x11\x54"
            "\x10\x43\xf8\x21\x00" }  },
      /* --- pixel bitmap for cmr118 char#32 (noname) --- */
      {  32,102812,                     /* character number, location */
          6, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  5,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for cmr118 char#33 ! --- */
      {  33,85939,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x3c" }  },
      /* --- pixel bitmap for cmr118 char#34 " --- */
      {  34,113375,                     /* character number, location */
         11, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7b\x4b\x99\x00" }  },
      /* --- pixel bitmap for cmr118 char#35 # --- */
      {  35,87355,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x51\x31\x2c\xf2\x41\x31\x3c\xf1\x31\x31\x40\xf2"
            "\x21\x31\x51" }  },
      /* --- pixel bitmap for cmr118 char#36 $ --- */
      {  36,72494,                      /* character number, location */
         12, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x97\xa6\x89\xc2\xa1\x69\x9a\x39\x08" }  },
      /* --- pixel bitmap for cmr118 char#37 % --- */
      {  37,88546,                      /* character number, location */
         12, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xa4\x31\xf1\x12\x11\x91\xa0\x04\x4e\x07\x52\x90"
            "\x88\x88\x88\x48\x50\x02\x07" }  },
      /* --- pixel bitmap for cmr118 char#38 & --- */
      {  38,73718,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x20\x01\x09\x68\xc0\x79\x86\x38\x22\x12\x71\x18"
            "\xa3\xe7\x00" }  },
      /* --- pixel bitmap for cmr118 char#39 ' --- */
      {  39,89180,                      /* character number, location */
         11, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaf\x01" }  },
      /* --- pixel bitmap for cmr118 char#40 ( --- */
      {  40,89726,                      /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x22\x11\x11\x11\x21\x42\x08" }  },
      /* --- pixel bitmap for cmr118 char#41 ) --- */
      {  41,90293,                      /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x44\x88\x88\x88\x48\x24\x01" }  },
      /* --- pixel bitmap for cmr118 char#42 * --- */
      {  42,90884,                      /* character number, location */
         12, 1,    5, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xb2\x33\x3b\x82\x00" }  },
      /* --- pixel bitmap for cmr118 char#43 + --- */
      {  43,91532,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x51\x5b\xf4\x51\x52" }  },
      /* --- pixel bitmap for cmr118 char#44 (noname) --- */
      {  44,92109,                      /* character number, location */
          2, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaf\x01" }  },
      /* --- pixel bitmap for cmr118 char#45 (noname) --- */
      {  45,113848,                     /* character number, location */
          4, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          {  4,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr118 char#46 (noname) --- */
      {  46,92572,                      /* character number, location */
          2, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr118 char#47 / --- */
      {  47,93052,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x41\x10\x82\x20\x04\x41\x08\x82\x10\x04" }  },
      /* --- pixel bitmap for cmr118 char#48 0 --- */
      {  48,63463,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x14\x86\x61\x18\x86\xa1\xc4\x00" }  },
      /* --- pixel bitmap for cmr118 char#49 1 --- */
      {  49,64199,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  5,   11, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x23\x20\xf7\x21\x25" }  },
      /* --- pixel bitmap for cmr118 char#50 2 --- */
      {  50,65136,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x14\x86\x20\x04\x21\xa4\xf8\x03" }  },
      /* --- pixel bitmap for cmr118 char#51 3 --- */
      {  51,66132,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x82\x10\x07\x81\x61\xe4\x00" }  },
      /* --- pixel bitmap for cmr118 char#52 4 --- */
      {  52,67014,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x30\x28\x24\x22\x23\xff\x20\x20\x20\xf8" }  },
      /* --- pixel bitmap for cmr118 char#53 5 --- */
      {  53,68008,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\x17\x04\xcd\x04\x82\x61\xe4\x00" }  },
      /* --- pixel bitmap for cmr118 char#54 6 --- */
      {  54,68860,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x28\x04\xcd\x14\x86\xa1\xc4\x00" }  },
      /* --- pixel bitmap for cmr118 char#55 7 --- */
      {  55,69718,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x7f\x30\x04\x81\x20\x10\x04\x02\x81\x00" }  },
      /* --- pixel bitmap for cmr118 char#56 8 --- */
      {  56,70600,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\x9e\x33\x85\x61\xe8\x01" }  },
      /* --- pixel bitmap for cmr118 char#57 9 --- */
      {  57,71456,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x14\x86\xa1\xcc\x82\x50\xe4\x00" }  },
      /* --- pixel bitmap for cmr118 char#58 : --- */
      {  58,93630,                      /* character number, location */
          7, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x3c" }  },
      /* --- pixel bitmap for cmr118 char#59 ; --- */
      {  59,94293,                      /* character number, location */
          7, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  2,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xbc\x06" }  },
      /* --- pixel bitmap for cmr118 char#60 (noname) --- */
      {  60,86543,                      /* character number, location */
          8, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  2,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xfc\x3f" }  },
      /* --- pixel bitmap for cmr118 char#61 = --- */
      {  61,94941,                      /* character number, location */
          7, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 11,    5, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\xf2\xbb" }  },
      /* --- pixel bitmap for cmr118 char#62 (noname) --- */
      {  62,75531,                      /* character number, location */
          8, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x03\x00\x00\x43\x18\x41\xe8\x01" }  },
      /* --- pixel bitmap for cmr118 char#63 ? --- */
      {  63,74631,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x08\x62\x08\x03\x00\x00\xc3\x00" }  },
      /* --- pixel bitmap for cmr118 char#64 @ --- */
      {  64,96085,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x9c\x12\x5b\xd0\x82\x16\x34\xb1\x72\x23"
            "\x00\xfe\x01" }  },
      /* --- pixel bitmap for cmr118 char#65 A --- */
      {  65, 1000,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x52\x50\xf2\x41\x21\x40\x31\x41\x66\x61\x41\x51"
            "\x61\x25\x25" }  },
      /* --- pixel bitmap for cmr118 char#66 B --- */
      {  66, 2284,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x21\x10\x01\x09\x48\x30\xfe\x11\x98\x80\x04\x24"
            "\xd0\x7f\x00" }  },
      /* --- pixel bitmap for cmr118 char#67 C --- */
      {  67, 3167,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x12\x2c\x60\x80\x01\x04\x10\x40\x80\x02\x12\x84"
            "\x0f" }  },
      /* --- pixel bitmap for cmr118 char#68 D --- */
      {  68, 4233,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x51\x51\x41\x61\x10\xf4\x21\x71\x21\x61\x31\x52"
            "\x18\x31" }  },
      /* --- pixel bitmap for cmr118 char#69 E --- */
      {  69, 5584,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x23\x18\x81\x88\x44\x04\x3e\x10\x91\x88\x04\x22"
            "\xd8\xff\x00" }  },
      /* --- pixel bitmap for cmr118 char#70 F --- */
      {  70, 6797,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x13\x4c\x20\xa1\x84\xf0\x43\x08\x21\x04\x10\xf0"
            "\x01" }  },
      /* --- pixel bitmap for cmr118 char#71 G --- */
      {  71, 7924,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x22\x98\x80\x02\x14\x80\x00\x04\x3e\x40\x02\x22"
            "\x10\xfe\x00" }  },
      /* --- pixel bitmap for cmr118 char#72 H --- */
      {  72, 9047,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x25\xf3\x21\x61\x20\x28\x20\xf3\x21\x61\x25\x25" }  },
      /* --- pixel bitmap for cmr118 char#73 I --- */
      {  73, 9702,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   11, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xf8\x21\x25" }  },
      /* --- pixel bitmap for cmr118 char#74 J --- */
      {  74,10466,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\xf7\x41\x11\x31\x23\x28" }  },
      /* --- pixel bitmap for cmr118 char#75 K --- */
      {  75,11601,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x4f\x10\x84\x40\x04\x24\x40\x05\x8c\x40\x08\x04"
            "\x41\x20\x1f\x0f" }  },
      /* --- pixel bitmap for cmr118 char#76 L --- */
      {  76,12506,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x40\xf4\x21\x60\xf2\x21\x51\x21\x4b" }  },
      /* --- pixel bitmap for cmr118 char#77 M --- */
      {  77,13744,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x78\x06\x0c\x05\x85\x82\x42\x41\x21\x91\x90\x48"
            "\x88\x22\x44\x11\xa2\xc8\x27\x1f" }  },
      /* --- pixel bitmap for cmr118 char#78 N --- */
      {  78,14826,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\xcf\x20\x14\x42\x21\x24\x42\x26\x44\x42\x28\x84"
            "\x42\x30\x1f\x02" }  },
      /* --- pixel bitmap for cmr118 char#79 O --- */
      {  79,15645,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\x51\x51\x31\x71\x1f\x41\x91\x11\x71\x31\x51\x55"
            "\x31" }  },
      /* --- pixel bitmap for cmr118 char#80 P --- */
      {  80,16710,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x10\x44\x20\x81\x04\xf1\x43\x00\x01\x04\x10\xf0"
            "\x01" }  },
      /* --- pixel bitmap for cmr118 char#81 Q --- */
      {  81,17689,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 11,   14, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\x51\x51\x31\x71\x1f\x41\x91\x11\x23\x21\x31\x11"
            "\x31\x55\xa1\xd1\x82\x11" }  },
      /* --- pixel bitmap for cmr118 char#82 R --- */
      {  82,18934,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x40\x10\x04\x42\x20\x04\xc1\x0f\x84\x41\x10\x04"
            "\x41\x10\x1f\x0e" }  },
      /* --- pixel bitmap for cmr118 char#83 S --- */
      {  83,19935,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x60\x30\x60\xe0\x81\x81\xc1\xd0\x07" }  },
      /* --- pixel bitmap for cmr118 char#84 T --- */
      {  84,20971,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x0f\x21\x41\x31\xf5\x51\x40\x35\x22" }  },
      /* --- pixel bitmap for cmr118 char#85 U --- */
      {  85,21915,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x25\xf7\x21\x61\x20\x31\x41\x74\x42" }  },
      /* --- pixel bitmap for cmr118 char#86 V --- */
      {  86,22861,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x4f\x20\x04\x82\x10\x08\x01\x09\x90\x00\x09\x60"
            "\x00\x06\x60\x00" }  },
      /* --- pixel bitmap for cmr118 char#87 W --- */
      {  87,24218,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   11, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x34\x24\xf2\x21\x41\x11\x41\x20\xf2\x31\x21\x31"
            "\x21\x30\xf3\x42\x52\x43" }  },
      /* --- pixel bitmap for cmr118 char#88 X --- */
      {  88,25279,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x87\x10\x98\x00\x0d\x60\x00\x06\x70\x00\x09\x08"
            "\xc1\x10\x0f\x0f" }  },
      /* --- pixel bitmap for cmr118 char#89 Y --- */
      {  89,26379,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xcf\x20\x08\x01\x11\xa0\x00\x0e\x40\x00\x04\x40"
            "\x00\x04\xf0\x01" }  },
      /* --- pixel bitmap for cmr118 char#90 Z --- */
      {  90,27378,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x43\x61\x21\x10\x18\x88\x84\x86\xc2\xff" }  },
      /* --- pixel bitmap for cmr118 char#91 [ --- */
      {  91,96794,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  4,   16, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xd1\x34" }  },
      /* --- pixel bitmap for cmr118 char#92 (noname) --- */
      {  92,114689,                     /* character number, location */
         11, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\xa5\xbd\x01" }  },
      /* --- pixel bitmap for cmr118 char#93 ] --- */
      {  93,97474,                      /* character number, location */
         12, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  4,   16, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfd\x31\x04" }  },
      /* --- pixel bitmap for cmr118 char#94 \^ --- */
      {  94,103409,                     /* character number, location */
         11, 2,    9, 2,      /* topleft row,col, and botleft row,col */
          {  4,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96" }  },
      /* --- pixel bitmap for cmr118 char#95 (noname) --- */
      {  95,103872,                     /* character number, location */
         12, 2,   10, 2,      /* topleft row,col, and botleft row,col */
          {  1,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03" }  },
      /* --- pixel bitmap for cmr118 char#96 (noname) --- */
      {  96,98074,                      /* character number, location */
         11, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd6\x03" }  },
      /* --- pixel bitmap for cmr118 char#97 a --- */
      {  97,28480,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x08\x47\x12\x89\xfa\x00" }  },
      /* --- pixel bitmap for cmr118 char#98 b --- */
      {  98,29442,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x81\x40\xe0\x11\x09\x85\x42\x93\x07" }  },
      /* --- pixel bitmap for cmr118 char#99 c --- */
      {  99,30173,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x10\x04\x81\xc8\x01" }  },
      /* --- pixel bitmap for cmr118 char#100 d --- */
      { 100,31130,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x10\x08\xc4\x13\x85\x42\x21\x19\x1b" }  },
      /* --- pixel bitmap for cmr118 char#101 e --- */
      { 101,31848,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xfe\x10\xa4\x03" }  },
      /* --- pixel bitmap for cmr118 char#102 f --- */
      { 102,32659,                      /* character number, location */
         11,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x04\x02\xf1\x43\x20\x10\x08\x04\x0f" }  },
      /* --- pixel bitmap for cmr118 char#103 g --- */
      { 103,33856,                      /* character number, location */
          7, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x22\x22\x22\x1e\x02\x7e\x81\x81\xc3\x3c" }  },
      /* --- pixel bitmap for cmr118 char#104 h --- */
      { 104,34789,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x81\x40\xe0\x11\x89\x44\x22\xd1\x19" }  },
      /* --- pixel bitmap for cmr118 char#105 i --- */
      { 105,35488,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1b\x80\x49\x92\x0e" }  },
      /* --- pixel bitmap for cmr118 char#106 j --- */
      { 106,36250,                      /* character number, location */
         12,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\x00\xc0\x88\x88\x88\x88\x07" }  },
      /* --- pixel bitmap for cmr118 char#107 k --- */
      { 107,37330,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x02\x02\x02\xf2\x12\x0a\x1e\x12\x22\xe7" }  },
      /* --- pixel bitmap for cmr118 char#108 l --- */
      { 108,37935,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\x24\x49\xd2\x01" }  },
      /* --- pixel bitmap for cmr118 char#109 m --- */
      { 109,39236,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\xc7\x18\x09\x21\x21\x24\x84\x84\xd0\x39\x07" }  },
      /* --- pixel bitmap for cmr118 char#110 n --- */
      { 110,40177,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x91\x48\x24\x12\x9d\x01" }  },
      /* --- pixel bitmap for cmr118 char#111 o --- */
      { 111,40834,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x14\x86\xa1\xe4\x01" }  },
      /* --- pixel bitmap for cmr118 char#112 p --- */
      { 112,41862,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x91\x50\x28\x34\x79\x04\x82\x03" }  },
      /* --- pixel bitmap for cmr118 char#113 q --- */
      { 113,42848,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x51\x28\x14\x92\xb1\x40\x20\x38" }  },
      /* --- pixel bitmap for cmr118 char#114 r --- */
      { 114,43665,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5f\x08\x21\xc4\x01" }  },
      /* --- pixel bitmap for cmr118 char#115 s --- */
      { 115,44562,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x61\x99\x07" }  },
      /* --- pixel bitmap for cmr118 char#116 t --- */
      { 116,45349,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x98\x4f\x08\xa1\x14\x01" }  },
      /* --- pixel bitmap for cmr118 char#117 u --- */
      { 117,46236,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\x91\x48\x24\x12\xf1\x01" }  },
      /* --- pixel bitmap for cmr118 char#118 v --- */
      { 118,47088,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xef\x89\x10\x41\x81\x02\x05\x04" }  },
      /* --- pixel bitmap for cmr118 char#119 w --- */
      { 119,48303,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x4e\x26\x94\x42\x29\x94\x82\x19\x08\x01" }  },
      /* --- pixel bitmap for cmr118 char#120 x --- */
      { 120,49260,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\xc9\xa0\x80\x80\x82\xc8\x71" }  },
      /* --- pixel bitmap for cmr118 char#121 y --- */
      { 121,50315,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xef\x89\x10\x41\x81\x02\x05\x04\x08\x08\x0e\x00" }  },
      /* --- pixel bitmap for cmr118 char#122 z --- */
      { 122,51236,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\xa4\xb0\xa4\xf8\x03" }  },
      /* --- pixel bitmap for cmr118 char#123 (noname) --- */
      { 123,115267,                     /* character number, location */
          5, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  8,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff" }  },
      /* --- pixel bitmap for cmr118 char#124 (noname) --- */
      { 124,116061,                     /* character number, location */
          5, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          { 16,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff" }  },
      /* --- pixel bitmap for cmr118 char#125 (noname) --- */
      { 125,104523,                     /* character number, location */
         11, 2,    8, 2,      /* topleft row,col, and botleft row,col */
          {  5,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\x25" }  },
      /* --- pixel bitmap for cmr118 char#126 \~ --- */
      { 126,105177,                     /* character number, location */
         11, 1,    9, 1,      /* topleft row,col, and botleft row,col */
          {  6,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x06" }  },
      /* --- pixel bitmap for cmr118 char#127 (noname) --- */
      { 127,105830,                     /* character number, location */
         12, 1,   10, 1,      /* topleft row,col, and botleft row,col */
          {  5,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x02" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=3 for .131gf ---
 * mf '\mode=preview; mag=magstep(-16.39322518098640003469); input cmr10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmr131 --- */
static	chardef  cmr131[] =
   {
      /* --- pixel bitmap for cmr131 char#0 \Gamma --- */
      {   0,53384,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   12, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x22\x42\xf2\x22\x51\xf5\x22\x66\x41" }  },
      /* --- pixel bitmap for cmr131 char#1 \Delta --- */
      {   1,54283,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x1c\x80\x03\xc8\x00\x19\x10\x06\xc2\x20\x30"
            "\x04\x46\x80\xf9\xbf\xff\x0f" }  },
      /* --- pixel bitmap for cmr131 char#2 \Theta --- */
      {   2,55402,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc0\x30\x06\x26\x40\x93\x3c\xcf\xf3\x3c\xc9\x02"
            "\x64\x60\x0c\x03\x0f" }  },
      /* --- pixel bitmap for cmr131 char#3 \Lambda --- */
      {   3,56346,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x80\x03\x1c\xe0\x80\x0f\x64\x20\x83\x39\x84\x21"
            "\x8c\xe1\x9e\x0f" }  },
      /* --- pixel bitmap for cmr131 char#4 \Xi --- */
      {   4,57705,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\x1f\x60\x80\x84\xf0\xc3\x0f\x21\x01\x06\xf8"
            "\xff\xff" }  },
      /* --- pixel bitmap for cmr131 char#5 \Pi --- */
      {   5,58858,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xf9\x22\x62\x26\x26" }  },
      /* --- pixel bitmap for cmr131 char#6 \Sigma --- */
      {   6,59973,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3f\xb0\x03\x39\x88\x41\x18\xc0\x00\x82\x08\x64"
            "\xa0\x81\xff\x0f" }  },
      /* --- pixel bitmap for cmr131 char#7 \Upsilon --- */
      {   7,61063,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x13\x43\x12\x12\x22\x12\x44\x40\xf7\x52\x50\x36\x31" }  },
      /* --- pixel bitmap for cmr131 char#8 \Phi --- */
      {   8,62085,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x03\x18\xf8\x63\xb6\x31\x8f\xd9\x6c\xfc\x01"
            "\x03\x18\xf0\x03" }  },
      /* --- pixel bitmap for cmr131 char#9 \Psi --- */
      {   9,63188,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x06\x67\x6e\x66\x66\x66\x66\x66\xc6\x36\xf8"
            "\x01\x06\x60\x80\x1f" }  },
      /* --- pixel bitmap for cmr131 char#10 \Omega --- */
      {  10,64337,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x30\xd8\x80\x07\x3c\xe0\x01\x0b\xc8\x60\x05\x6d"
            "\xac\xe3\x1c\x07" }  },
      /* --- pixel bitmap for cmr131 char#11 \ff --- */
      {  11,109874,                     /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   13, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x31\x31\x40\xf2\x21\x41\x4b\x10\xf5\x21\x41\x40"
            "\x12\x43\x21" }  },
      /* --- pixel bitmap for cmr131 char#12 \fi --- */
      {  12,111034,                     /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x10\x11\x20\x40\xe0\x1f\x31\x42\x84\x08\x11\x22"
            "\x64\x18" }  },
      /* --- pixel bitmap for cmr131 char#13 \fl --- */
      {  13,112188,                     /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x10\x11\x22\x44\xe8\x1f\x21\x42\x84\x08\x11\x22"
            "\xe4\x1c" }  },
      /* --- pixel bitmap for cmr131 char#14 \ffi --- */
      {  14,113793,                     /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   13, 3,44, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x14\x41\x32\x31\x10\xf2\x21\x41\x6d\x31\x41\x32"
            "\x10\xf4\x21\x41\x41\x10\x12\x41\x42" }  },
      /* --- pixel bitmap for cmr131 char#15 \ffl --- */
      {  15,115416,                     /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   13, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x14\x41\x41\x31\x10\xf2\x21\x41\x41\x1d\x10\xf5"
            "\x21\x41\x41\x10\x13\x23\x23" }  },
      /* --- pixel bitmap for cmr131 char#16 \imath --- */
      {  16,78056,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\x24\xe9" }  },
      /* --- pixel bitmap for cmr131 char#17 \jmath --- */
      {  17,78724,                      /* character number, location */
          8,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          {  5,   12, 3, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\xf9\x41\x03\x23" }  },
      /* --- pixel bitmap for cmr131 char#18 \gravesym --- */
      {  18,101143,                     /* character number, location */
         13, 2,   10, 2,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x01" }  },
      /* --- pixel bitmap for cmr131 char#19 \acutesym --- */
      {  19,101712,                     /* character number, location */
         13, 3,   10, 3,      /* topleft row,col, and botleft row,col */
          {  4,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x02" }  },
      /* --- pixel bitmap for cmr131 char#20 \checksym --- */
      {  20,102337,                     /* character number, location */
         11, 2,    9, 2,      /* topleft row,col, and botleft row,col */
          {  5,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9b\x00" }  },
      /* --- pixel bitmap for cmr131 char#21 \brevesym --- */
      {  21,102953,                     /* character number, location */
         13, 2,    9, 2,      /* topleft row,col, and botleft row,col */
          {  5,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\x6e\x07" }  },
      /* --- pixel bitmap for cmr131 char#22 (noname) --- */
      {  22,103537,                     /* character number, location */
         10, 1,    9, 1,      /* topleft row,col, and botleft row,col */
          {  7,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f" }  },
      /* --- pixel bitmap for cmr131 char#23 (noname) --- */
      {  23,104314,                     /* character number, location */
         13, 5,   10, 5,      /* topleft row,col, and botleft row,col */
          {  4,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x06" }  },
      /* --- pixel bitmap for cmr131 char#24 (noname) --- */
      {  24,105002,                     /* character number, location */
          0, 3,   -3, 3,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe6\x01" }  },
      /* --- pixel bitmap for cmr131 char#25 \ss --- */
      {  25,79801,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x42\x42\x42\x22\x1b\x62\x42\x82\x82\x82\x92\x63" }  },
      /* --- pixel bitmap for cmr131 char#26 \ae --- */
      {  26,81136,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x07\x46\x20\xc8\xff\x22\x10\x02\x61\xe8\x79" }  },
      /* --- pixel bitmap for cmr131 char#27 \oe --- */
      {  27,82242,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x4f\x14\x05\xc1\xe0\x1f\x04\x82\x80\x28\xe4\x78" }  },
      /* --- pixel bitmap for cmr131 char#28 (noname) --- */
      {  28,83050,                      /* character number, location */
         10, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x10\x4f\x16\x4d\x26\x8b\x26\x8f\x20\x00" }  },
      /* --- pixel bitmap for cmr131 char#29 \AE --- */
      {  29,84818,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x3f\x68\x18\x34\x08\x1b\x84\x8c\x42\x46\xe0\x3f"
            "\x88\x91\xc4\x48\x62\x90\x30\xec\xfc\x07" }  },
      /* --- pixel bitmap for cmr131 char#30 \OE --- */
      {  30,86500,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xff\x18\x86\x19\x0c\x12\x18\x35\x30\x6a\xe0\xc7"
            "\xc0\x88\x81\x91\x06\x03\x0d\x06\x31\x0c\x83\xff\x07" }  },
      /* --- pixel bitmap for cmr131 char#31 (noname) --- */
      {  31,87464,                      /* character number, location */
         13, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x2f\x0c\x63\x78\x82\x34\xc4\x43\x3c\xc2\x23"
            "\x2c\x41\x1e\xc6\x30\xf4\x40\x00" }  },
      /* --- pixel bitmap for cmr131 char#32 (noname) --- */
      {  32,105498,                     /* character number, location */
          7, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  5,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x00" }  },
      /* --- pixel bitmap for cmr131 char#33 ! --- */
      {  33,88101,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\xc0\x03" }  },
      /* --- pixel bitmap for cmr131 char#34 " --- */
      {  34,116353,                     /* character number, location */
         13, 1,    7, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x2c\x8a\x62\x04" }  },
      /* --- pixel bitmap for cmr131 char#35 # --- */
      {  35,89551,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x61\x31\x20\xf2\x51\x31\x3d\xf2\x41\x31\x4d\xf2"
            "\x31\x31\x50\xf2\x21\x31\x61" }  },
      /* --- pixel bitmap for cmr131 char#36 $ --- */
      {  36,74366,                      /* character number, location */
         14, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x8e\x2a\x99\x5c\x38\x78\x78\x64\x32\xa9\xe2\x20"
            "\x00" }  },
      /* --- pixel bitmap for cmr131 char#37 % --- */
      {  37,90780,                      /* character number, location */
         14, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x48\x83\xc4\x9f\x08\x11\x11\x22\x82\x22\x70\x72"
            "\x40\x0a\x24\x82\x44\x88\x88\x10\x11\x14\x81\x03" }  },
      /* --- pixel bitmap for cmr131 char#38 & --- */
      {  38,75624,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x40\x04\x44\x40\x04\x24\x40\xf1\x08\xc2\x10\x12"
            "\x11\x0a\x61\x30\x8e\x1e\x07" }  },
      /* --- pixel bitmap for cmr131 char#39 ' --- */
      {  39,91424,                      /* character number, location */
         13, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          {  2,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaf\x06" }  },
      /* --- pixel bitmap for cmr131 char#40 ( --- */
      {  40,91998,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x11\x21\x44\x08\x21\x84\x10\x84\x10\x04\x41" }  },
      /* --- pixel bitmap for cmr131 char#41 ) --- */
      {  41,92599,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x10\x84\x10\x84\x10\x42\x08\x11\x42\x44\x04" }  },
      /* --- pixel bitmap for cmr131 char#42 * --- */
      {  42,93224,                      /* character number, location */
         14, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xc4\x9a\xc3\x59\x23\x10" }  },
      /* --- pixel bitmap for cmr131 char#43 + --- */
      {  43,93904,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x61\x5c\xf5\x61\x51" }  },
      /* --- pixel bitmap for cmr131 char#44 (noname) --- */
      {  44,94485,                      /* character number, location */
          2, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  2,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaf\x06" }  },
      /* --- pixel bitmap for cmr131 char#45 (noname) --- */
      {  45,116856,                     /* character number, location */
          5, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  5,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for cmr131 char#46 (noname) --- */
      {  46,94950,                      /* character number, location */
          2, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr131 char#47 / --- */
      {  47,95456,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  7,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x08\x04\x82\x40\x20\x08\x04\x82\x40\x20\x08"
            "\x04\x82\x40\x00" }  },
      /* --- pixel bitmap for cmr131 char#48 0 --- */
      {  48,65049,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x31\x31\x1f\x71\x51\x11\x31\x33\x22" }  },
      /* --- pixel bitmap for cmr131 char#49 1 --- */
      {  49,65815,                      /* character number, location */
         12, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  5,   12, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x23\x20\xf8\x21\x25" }  },
      /* --- pixel bitmap for cmr131 char#50 2 --- */
      {  50,66780,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xd1\x78\x08\x06\x83\x20\x08\xa2\xf0\x0f" }  },
      /* --- pixel bitmap for cmr131 char#51 3 --- */
      {  51,67804,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x70\x18\x0c\xe2\xc0\xc0\xe0\x71\xcc\x03" }  },
      /* --- pixel bitmap for cmr131 char#52 4 --- */
      {  52,68714,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x30\x28\x2c\x24\x22\x23\xff\x20\x20\x20\xf8" }  },
      /* --- pixel bitmap for cmr131 char#53 5 --- */
      {  53,69738,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x8f\x43\x20\xf0\x88\xc0\xe0\x70\xcc\x03" }  },
      /* --- pixel bitmap for cmr131 char#54 6 --- */
      {  54,70616,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xa2\x20\xd0\x19\x05\x83\x41\xa1\x88\x03" }  },
      /* --- pixel bitmap for cmr131 char#55 7 --- */
      {  55,71504,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xfe\x82\x41\x20\x10\x10\x10\x08\x08\x08\x08\x08" }  },
      /* --- pixel bitmap for cmr131 char#56 8 --- */
      {  56,72414,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x70\x70\xe8\xe2\xe8\xc2\xc1\xa0\x88\x03" }  },
      /* --- pixel bitmap for cmr131 char#57 9 --- */
      {  57,73300,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x28\x18\x14\x73\x81\x40\x50\xc4\x01" }  },
      /* --- pixel bitmap for cmr131 char#58 : --- */
      {  58,96040,                      /* character number, location */
          8, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xf0" }  },
      /* --- pixel bitmap for cmr131 char#59 ; --- */
      {  59,96703,                      /* character number, location */
          8, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xf0\x6a" }  },
      /* --- pixel bitmap for cmr131 char#60 (noname) --- */
      {  60,88709,                      /* character number, location */
          9, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  2,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xfc\xff\x03" }  },
      /* --- pixel bitmap for cmr131 char#61 = --- */
      {  61,97379,                      /* character number, location */
          7, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 12,    5, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xf2\xcc" }  },
      /* --- pixel bitmap for cmr131 char#62 (noname) --- */
      {  62,77455,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x06\x00\x00\x60\x10\x08\x04\x41\x30\xe8\x03" }  },
      /* --- pixel bitmap for cmr131 char#63 ? --- */
      {  63,76549,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\x60\x10\x04\x41\x20\x18\x00\x00\x80\xc1\x00" }  },
      /* --- pixel bitmap for cmr131 char#64 @ --- */
      {  64,98549,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc0\x30\xf2\xa4\x50\x05\x5a\xa0\x05\x5a\xa0\x05"
            "\xaa\xb0\xf2\xc6\xc0\xf0\x03" }  },
      /* --- pixel bitmap for cmr131 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x00\x06\x60\x00\x0d\xd0\x80\x1d\x88\x81\x18\xfc"
            "\x43\x30\x04\xf3\xf8" }  },
      /* --- pixel bitmap for cmr131 char#66 B --- */
      {  66, 2314,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xc1\x30\x0c\xc6\x60\x0c\xc6\x3f\x0c\xc6\xc0\x0c"
            "\xcc\xc0\x0c\xf6\x3f" }  },
      /* --- pixel bitmap for cmr131 char#67 C --- */
      {  67, 3227,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x65\xb0\x01\x05\x38\x80\x01\x0c\x60\x00\x02\x34"
            "\x20\x83\xe0\x03" }  },
      /* --- pixel bitmap for cmr131 char#68 D --- */
      {  68, 4295,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x52\x52\x42\x62\x32\x71\x10\xf4\x22\x72\x22\x62"
            "\x32\x52\x2a\x31" }  },
      /* --- pixel bitmap for cmr131 char#69 E --- */
      {  69, 5676,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xc7\x60\x0c\xc4\x48\x8c\xc4\x0f\x8c\xc0\x88\x0c"
            "\xc8\x40\x0c\xf6\x7f" }  },
      /* --- pixel bitmap for cmr131 char#70 F --- */
      {  70, 6893,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x63\x18\x83\x18\xc9\x48\x7e\x30\x82\x11\x0c\x60"
            "\x00\x03\x7e\x00" }  },
      /* --- pixel bitmap for cmr131 char#71 G --- */
      {  71, 8050,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc5\x60\x06\x24\x40\x03\x30\x00\x83\x3f\x60\x02"
            "\x66\x60\x0c\x06\x5f" }  },
      /* --- pixel bitmap for cmr131 char#72 H --- */
      {  72, 9205,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x26\xf3\x22\x62\x20\x2a\x20\xf4\x22\x62\x26\x26" }  },
      /* --- pixel bitmap for cmr131 char#73 I --- */
      {  73, 9864,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   12, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xf9\x22\x26" }  },
      /* --- pixel bitmap for cmr131 char#74 J --- */
      {  74,10656,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\xf7\x42\x1f\x12\x22\x10\x14\x24" }  },
      /* --- pixel bitmap for cmr131 char#75 K --- */
      {  75,11795,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x9f\x41\x30\x04\x46\xc0\x04\xd8\x01\x37\x60\x0c"
            "\x8c\x83\x61\x30\x98\x9f\x0f" }  },
      /* --- pixel bitmap for cmr131 char#76 L --- */
      {  76,12728,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   12, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x40\xf5\x22\x60\xf2\x22\x51\x22\x4c" }  },
      /* --- pixel bitmap for cmr131 char#77 M --- */
      {  77,13994,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\xf0\x39\xe0\xd0\xa0\xa1\x41\x43\x83\x86\x8c\x0c"
            "\x19\x19\x62\x31\xc4\x62\x88\xc5\x10\x86\xf9\xcc\x0f" }  },
      /* --- pixel bitmap for cmr131 char#78 N --- */
      {  78,15108,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x3e\x07\x42\x83\x90\x21\xe4\x08\x31\x42\x98\x10"
            "\x2c\x04\x0f\x81\x43\xc0\x7c\x20" }  },
      /* --- pixel bitmap for cmr131 char#79 O --- */
      {  79,15955,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc0\x30\x06\x26\x40\x03\x3c\xc0\x03\x3c\xc0\x02"
            "\x64\x60\x0c\x03\x0f" }  },
      /* --- pixel bitmap for cmr131 char#80 P --- */
      {  80,17050,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   12, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x42\x42\x10\xf2\x22\x52\x22\x42\x37\x20\xf3\x22"
            "\x76\x52" }  },
      /* --- pixel bitmap for cmr131 char#81 Q --- */
      {  81,18059,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc0\x30\x06\x26\x40\x03\x3c\xc0\x03\x3c\xc0\x02"
            "\x64\x67\x9c\x03\x0f\x00\x00\x90\x00\x0f\x60" }  },
      /* --- pixel bitmap for cmr131 char#82 R --- */
      {  82,19336,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x81\x61\x30\x18\x06\xc3\x30\xf8\x03\x63\x60\x18"
            "\x0c\x83\x61\x30\xcc\x1f\x0f" }  },
      /* --- pixel bitmap for cmr131 char#83 S --- */
      {  83,20369,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\xc2\x83\x03\x07\x3e\x78\xc0\xc0\xc1\x41\x3f" }  },
      /* --- pixel bitmap for cmr131 char#84 T --- */
      {  84,21435,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x32\x22\x0f\x21\x42\x31\xf5\x52\x40\x28\x11" }  },
      /* --- pixel bitmap for cmr131 char#85 U --- */
      {  85,22411,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x35\xf8\x22\x71\x20\x32\x51\x85\x40" }  },
      /* --- pixel bitmap for cmr131 char#86 V --- */
      {  86,23387,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x3e\x03\x82\x41\x60\x10\x30\x02\x8c\x00\x23\x80"
            "\x05\x60\x01\x78\x00\x0c\x00\x03" }  },
      /* --- pixel bitmap for cmr131 char#87 W --- */
      {  87,24789,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\xcf\x67\x30\x08\x87\x61\x30\x1e\x81\xd1\x08\x9c"
            "\x66\xc0\x76\x01\x16\x0b\xf0\x78\x00\xc7\x01\x18\x0c"
            "\xc0\x60\x00" }  },
      /* --- pixel bitmap for cmr131 char#88 X --- */
      {  88,25878,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x1f\x86\x00\x33\xc0\x05\xe0\x00\x30\x00\x1c\x80"
            "\x06\x30\x03\xc4\x81\x60\x7c\xfc" }  },
      /* --- pixel bitmap for cmr131 char#89 Y --- */
      {  89,27008,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x35\x23\x52\x52\x51\x72\x31\x83\x12\x92\x11\x50"
            "\xf4\x62\x60\x46\x41" }  },
      /* --- pixel bitmap for cmr131 char#90 Z --- */
      {  90,28037,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x87\x05\x0b\x13\x07\x06\x06\x8e\x0c\x0d\x1a\xfe"
            "\x0f" }  },
      /* --- pixel bitmap for cmr131 char#91 [ --- */
      {  91,99276,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  4,   19, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x3f\x11\x34" }  },
      /* --- pixel bitmap for cmr131 char#92 (noname) --- */
      {  92,117723,                     /* character number, location */
         13, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\x14\x45\xf3\x0c" }  },
      /* --- pixel bitmap for cmr131 char#93 ] --- */
      {  93,99962,                      /* character number, location */
         14, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  4,   19, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x31\xf1\x31\x04" }  },
      /* --- pixel bitmap for cmr131 char#94 \^ --- */
      {  94,106123,                     /* character number, location */
         13, 2,   10, 2,      /* topleft row,col, and botleft row,col */
          {  5,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x45" }  },
      /* --- pixel bitmap for cmr131 char#95 (noname) --- */
      {  95,106590,                     /* character number, location */
         13, 2,   11, 2,      /* topleft row,col, and botleft row,col */
          {  1,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03" }  },
      /* --- pixel bitmap for cmr131 char#96 (noname) --- */
      {  96,100568,                     /* character number, location */
         13, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          {  2,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x0f" }  },
      /* --- pixel bitmap for cmr131 char#97 a --- */
      {  97,29169,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x20\x20\x3e\x21\xa1\xa1\x7e" }  },
      /* --- pixel bitmap for cmr131 char#98 b --- */
      {  98,30161,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x02\x02\x02\x02\x3a\x46\x82\x82\x82\x82\x46\x3a" }  },
      /* --- pixel bitmap for cmr131 char#99 c --- */
      {  99,30928,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x41\x20\x10\x08\x08\x79" }  },
      /* --- pixel bitmap for cmr131 char#100 d --- */
      { 100,31913,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x40\x40\x40\x40\x5c\x62\x41\x41\x41\x41\x62\xdc" }  },
      /* --- pixel bitmap for cmr131 char#101 e --- */
      { 101,32665,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x18\xfe\x41\x20\x72" }  },
      /* --- pixel bitmap for cmr131 char#102 f --- */
      { 102,33480,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\xf3\x21\x46\x10\xf5\x21\x45\x21" }  },
      /* --- pixel bitmap for cmr131 char#103 g --- */
      { 103,34707,                      /* character number, location */
          8, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xcd\x08\x11\x42\x42\x83\x00\x3f\x81\x02\x06\x14"
            "\xc4\x07" }  },
      /* --- pixel bitmap for cmr131 char#104 h --- */
      { 104,35676,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x02\x02\x02\x02\x3a\x46\x42\x42\x42\x42\x42\xe7" }  },
      /* --- pixel bitmap for cmr131 char#105 i --- */
      { 105,36383,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1b\x80\x49\x92\x74" }  },
      /* --- pixel bitmap for cmr131 char#106 j --- */
      { 106,37147,                      /* character number, location */
         13,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          {  5,   17, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x32\xf2\x50\x23\xf9\x41\x03\x23" }  },
      /* --- pixel bitmap for cmr131 char#107 k --- */
      { 107,38231,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x04\x08\x10\x20\x40\x9e\x0c\x0d\x1e\x2c\x88\x10"
            "\x72\x1e" }  },
      /* --- pixel bitmap for cmr131 char#108 l --- */
      { 108,38842,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\x24\x49\x92\x74" }  },
      /* --- pixel bitmap for cmr131 char#109 m --- */
      { 109,40147,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\xc7\x18\x09\x21\x21\x24\x84\x84\x90\x10\x3a\xe7" }  },
      /* --- pixel bitmap for cmr131 char#110 n --- */
      { 110,41120,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x46\x42\x42\x42\x42\x42\xe7" }  },
      /* --- pixel bitmap for cmr131 char#111 o --- */
      { 111,41809,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x0c\x8a\x38" }  },
      /* --- pixel bitmap for cmr131 char#112 p --- */
      { 112,42867,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x46\x82\x82\x82\x82\x46\x3a\x02\x02\x02\x07" }  },
      /* --- pixel bitmap for cmr131 char#113 q --- */
      { 113,43863,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x08\x13\x48\x20\x81\x04\x22\x0c\x2f\x80\x00\x02"
            "\x08\xf8" }  },
      /* --- pixel bitmap for cmr131 char#114 r --- */
      { 114,44714,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9b\x2d\x08\x82\x20\x3c" }  },
      /* --- pixel bitmap for cmr131 char#115 s --- */
      { 115,45643,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x46\x83\x63\x7c" }  },
      /* --- pixel bitmap for cmr131 char#116 t --- */
      { 116,46460,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x61\xfc\x04\x41\x10\x24\x89\x01" }  },
      /* --- pixel bitmap for cmr131 char#117 u --- */
      { 117,47375,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x42\x42\x42\x42\x42\x62\xdc" }  },
      /* --- pixel bitmap for cmr131 char#118 v --- */
      { 118,48233,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x13\x42\x08\x12\x48\xc0\x00\x03\x0c" }  },
      /* --- pixel bitmap for cmr131 char#119 w --- */
      { 119,49489,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x9e\x88\x90\x12\x52\x82\x2a\x50\x05\xc6\x80\x08" }  },
      /* --- pixel bitmap for cmr131 char#120 x --- */
      { 120,50454,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x13\x81\x04\x0c\x30\x20\x41\xc8\xf3" }  },
      /* --- pixel bitmap for cmr131 char#121 y --- */
      { 121,51511,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x13\x42\x08\x12\x48\xe0\x01\x03\x0c\x10\x40\x90"
            "\xc0\x03" }  },
      /* --- pixel bitmap for cmr131 char#122 z --- */
      { 122,52462,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x94\x25\xa4\x29\xfe" }  },
      /* --- pixel bitmap for cmr131 char#123 (noname) --- */
      { 123,118331,                     /* character number, location */
          5, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  9,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09" }  },
      /* --- pixel bitmap for cmr131 char#124 (noname) --- */
      { 124,119151,                     /* character number, location */
          5, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          { 18,    1, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x04" }  },
      /* --- pixel bitmap for cmr131 char#125 (noname) --- */
      { 125,107267,                     /* character number, location */
         13, 2,   10, 2,      /* topleft row,col, and botleft row,col */
          {  6,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\xb4\x01" }  },
      /* --- pixel bitmap for cmr131 char#126 \~ --- */
      { 126,107947,                     /* character number, location */
         12, 2,   10, 2,      /* topleft row,col, and botleft row,col */
          {  5,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb6\x01" }  },
      /* --- pixel bitmap for cmr131 char#127 (noname) --- */
      { 127,108626,                     /* character number, location */
         13, 2,   11, 2,      /* topleft row,col, and botleft row,col */
          {  5,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7b\x03" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=4 for .160gf ---
 * mf '\mode=preview; mag=magstep(-15.29639112828755784636); input cmr10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmr160 --- */
static	chardef  cmr160[] =
   {
      /* --- pixel bitmap for cmr160 char#0 \Gamma --- */
      {   0,53842,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x32\x52\x32\x61\x10\xf1\x22\x71\xf8\x22\x87\x51" }  },
      /* --- pixel bitmap for cmr160 char#1 \Delta --- */
      {   1,54747,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x72\x70\xf1\x61\x12\x60\xf1\x51\x32\x50\xf1\x41"
            "\x52\x40\xf1\x31\x72\x30\xf1\x21\x92\x20\x11\xb2\x2e"
            "\x1e\x02" }  },
      /* --- pixel bitmap for cmr160 char#2 \Theta --- */
      {   2,55880,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x03\xc6\x00\x66\x00\x9b\x20\xcf\x9f"
            "\xe7\xcf\x13\xe4\x01\xb0\x01\xcc\x00\xc6\x80\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for cmr160 char#3 \Lambda --- */
      {   3,56836,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x61\x60\xf2\x53\x50\xf2\x41\x22\x40\xf2\x31\x42"
            "\x30\xf2\x21\x62\x25\x26" }  },
      /* --- pixel bitmap for cmr160 char#4 \Xi --- */
      {   4,58207,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0d\x0f\x11\xb1\xe0\x11\x71\x20\xf1\x29\x20\x21"
            "\x71\x20\xf1\xdf\x11\xb1\x0f\x1d" }  },
      /* --- pixel bitmap for cmr160 char#5 \Pi --- */
      {   5,59364,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\xfc\x22\x72\x26\x36" }  },
      /* --- pixel bitmap for cmr160 char#6 \Sigma --- */
      {   6,60491,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x13\x82\x23\x81\x32\x91\x32\x81\x33\xc3\x70\xf1"
            "\x52\x70\x51\xc1\x81\x31\x91\x21\x91\x22\x82\x1d\x10" }  },
      /* --- pixel bitmap for cmr160 char#7 \Upsilon --- */
      {   7,61587,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x14\x54\x16\x37\x51\x21\x41\x63\x60\xf9\x72\x60\x48"
            "\x32" }  },
      /* --- pixel bitmap for cmr160 char#8 \Phi --- */
      {   8,62617,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x07\x30\x00\x0c\xc0\x0f\xcc\x8c\x31\x36\x0c\x0f"
            "\xc3\xc3\xb0\x31\xc6\xcc\xc0\x0f\xc0\x00\x30\x80\x7f"
            "\x00" }  },
      /* --- pixel bitmap for cmr160 char#9 \Psi --- */
      {   9,63738,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x30\xf1\x72\x63\x42\x33\x13\x32\x23\x10\xf3\x22"
            "\x32\x22\x20\x32\x22\x12\x72\x15\x85\x50\xf1\x72\x60"
            "\x48\x38" }  },
      /* --- pixel bitmap for cmr160 char#10 \Omega --- */
      {  10,64899,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x03\x03\x63\x80\x0d\xc0\x03\xf0\x00\x3c\x00\x0b"
            "\x40\x06\x18\x01\xc2\xc0\x24\x90\x19\xa6\x87\xe7\xe1"
            "\x01" }  },
      /* --- pixel bitmap for cmr160 char#11 \ff --- */
      {  11,110754,                     /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x14\x42\x33\x22\xf2\x22\x42\x5d\x20\xf7\x22\x42"
            "\x54\x44\x31" }  },
      /* --- pixel bitmap for cmr160 char#12 \fi --- */
      {  12,111926,                     /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x41\x42\x51\x20\xf1\x22\x8a\x42\x24\x20\xf6"
            "\x22\x42\x24\x44" }  },
      /* --- pixel bitmap for cmr160 char#13 \fl --- */
      {  13,113090,                     /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x52\x32\x20\xf2\x22\x42\x2a\x20\xf7\x22\x42\x25"
            "\x25" }  },
      /* --- pixel bitmap for cmr160 char#14 \ffi --- */
      {  14,114703,                     /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x15\x62\x42\x41\x42\x42\x51\x20\xf1\x22\x42\x8e"
            "\x02\x42\x42\x24\x20\xf6\x22\x42\x42\x24\x42\x44" }  },
      /* --- pixel bitmap for cmr160 char#15 \ffl --- */
      {  15,116340,                     /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\x52\x33\x32\x20\xf2\x22\x42\x42\x2e\x02\x20\xf7"
            "\x22\x42\x42\x25\x24\x25" }  },
      /* --- pixel bitmap for cmr160 char#16 \imath --- */
      {  16,78730,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x20\xf7\x22\x26" }  },
      /* --- pixel bitmap for cmr160 char#17 \jmath --- */
      {  17,79402,                      /* character number, location */
         10,-2,   -4,-2,      /* topleft row,col, and botleft row,col */
          {  7,   14, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\xfa\x52\x02\x28\x22" }  },
      /* --- pixel bitmap for cmr160 char#18 \gravesym --- */
      {  18,102013,                     /* character number, location */
         15, 2,   12, 2,      /* topleft row,col, and botleft row,col */
          {  4,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x0c" }  },
      /* --- pixel bitmap for cmr160 char#19 \acutesym --- */
      {  19,102582,                     /* character number, location */
         15, 4,   12, 4,      /* topleft row,col, and botleft row,col */
          {  5,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\x1b" }  },
      /* --- pixel bitmap for cmr160 char#20 \checksym --- */
      {  20,103207,                     /* character number, location */
         14, 3,   12, 3,      /* topleft row,col, and botleft row,col */
          {  5,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdb\x01" }  },
      /* --- pixel bitmap for cmr160 char#21 \brevesym --- */
      {  21,103823,                     /* character number, location */
         15, 2,   11, 2,      /* topleft row,col, and botleft row,col */
          {  7,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xa0\x88\x03" }  },
      /* --- pixel bitmap for cmr160 char#22 (noname) --- */
      {  22,104407,                     /* character number, location */
         13, 2,   12, 2,      /* topleft row,col, and botleft row,col */
          {  7,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f" }  },
      /* --- pixel bitmap for cmr160 char#23 (noname) --- */
      {  23,105184,                     /* character number, location */
         15, 6,   12, 6,      /* topleft row,col, and botleft row,col */
          {  5,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x3a" }  },
      /* --- pixel bitmap for cmr160 char#24 (noname) --- */
      {  24,105872,                     /* character number, location */
          0, 3,   -4, 3,      /* topleft row,col, and botleft row,col */
          {  5,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xe3\x0f" }  },
      /* --- pixel bitmap for cmr160 char#25 \ss --- */
      {  25,80485,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x20\xc4\x30\xc3\x8c\xbd\xc3\x08\x63\x0c\x33\xcc"
            "\x30\xc3\x4c\x33\xf7\x0c" }  },
      /* --- pixel bitmap for cmr160 char#26 \ae --- */
      {  26,81828,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x8f\x79\x06\x0c\x03\xc3\xf8\xbf\x31\x30\x0c\x0c"
            "\x03\xc3\x21\x8f\x07" }  },
      /* --- pixel bitmap for cmr160 char#27 \oe --- */
      {  27,82944,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x1e\xe3\x99\x60\x78\x30\x3c\xf8\x1f\x0c\x0c\x06"
            "\x04\x03\xc6\x43\x1c\x1e" }  },
      /* --- pixel bitmap for cmr160 char#28 (noname) --- */
      {  28,83758,                      /* character number, location */
         12, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\xe1\x31\x26\x6a\xf4\xe4\xc9\x8b\x15\x19\xe3"
            "\x21\x40\x00" }  },
      /* --- pixel bitmap for cmr160 char#29 \AE --- */
      {  29,85538,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xff\x01\x0d\x06\x32\x10\xc8\x80\x20\x43\xc2\x0c"
            "\x01\x31\x06\xfc\x1f\x10\x63\x20\x0c\x89\x30\x24\xc2"
            "\xc0\x04\x03\x11\x0c\xf6\xfd\x1f" }  },
      /* --- pixel bitmap for cmr160 char#30 \OE --- */
      {  30,87238,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xff\x87\xe1\x60\x0c\x0c\x64\xc0\x80\x06\x0c\x39"
            "\xc0\x10\x03\x8c\x31\xc0\x1f\x03\x8c\x31\xc0\x90\x06"
            "\x0c\x69\xc0\xc0\x0c\x0c\x84\xe1\x60\xe0\xff\x07" }  },
      /* --- pixel bitmap for cmr160 char#31 (noname) --- */
      {  31,88220,                      /* character number, location */
         16, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x10\xf0\x0d\x06\x83\x81\x63\x60\x13\x10\x0d\x84"
            "\x07\xc2\x83\xe0\x21\xf0\x10\x58\x04\x64\x03\xe3\xc0"
            "\x60\x30\xd8\x07\x04\x00" }  },
      /* --- pixel bitmap for cmr160 char#32 (noname) --- */
      {  32,106370,                     /* character number, location */
          9, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          {  6,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb0\x13\x00" }  },
      /* --- pixel bitmap for cmr160 char#33 ! --- */
      {  33,88875,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\x03\x3c" }  },
      /* --- pixel bitmap for cmr160 char#34 " --- */
      {  34,117287,                     /* character number, location */
         15, 1,    9, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x2c\x8a\x51\x04" }  },
      /* --- pixel bitmap for cmr160 char#35 # --- */
      {  35,90329,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 16,   19, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x71\x41\x30\xf2\x61\x41\x4e\x02\xf4\x51\x41\x5e"
            "\x02\xf2\x41\x41\x60\xf2\x31\x41\x72" }  },
      /* --- pixel bitmap for cmr160 char#36 $ --- */
      {  36,75008,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x20\xf0\x91\x14\x31\x72\xe4\x09\x3e\xf8\x40\x83"
            "\x3c\x71\x62\x44\x49\x3c\x20\x00" }  },
      /* --- pixel bitmap for cmr160 char#37 % --- */
      {  37,91566,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x20\x16\x10\x63\x1c\xa3\x0b\x23\x04\x23\x04\x23"
            "\x02\x23\x01\x16\x01\x8c\x30\x80\x48\x40\x8c\x20\x8c"
            "\x20\x8c\x10\x8c\x08\x8c\x08\x48\x04\x30" }  },
      /* --- pixel bitmap for cmr160 char#38 & --- */
      {  38,76282,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x00\x44\x00\x23\x80\x11\xc0\x04\x60\xe3\xf3\x60"
            "\x30\x10\x3c\x04\x1b\xc2\x98\x60\x5c\x30\x1c\x34\x1e"
            "\xf3\xf8\x00" }  },
      /* --- pixel bitmap for cmr160 char#39 ' --- */
      {  39,92232,                      /* character number, location */
         15, 2,    9, 2,      /* topleft row,col, and botleft row,col */
          {  2,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaf\x05" }  },
      /* --- pixel bitmap for cmr160 char#40 ( --- */
      {  40,92806,                      /* character number, location */
         17, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  6,   23, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x41\x41\x42\x41\x42\x41\x4f\x82\x40\x11\x52\x51"
            "\x52\x51\x61\x61" }  },
      /* --- pixel bitmap for cmr160 char#41 ) --- */
      {  41,93415,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x40\x30\x08\x06\xc1\x30\x0c\xc3\x30\x0c\xc3\x10"
            "\x86\x30\x84\x10\x00" }  },
      /* --- pixel bitmap for cmr160 char#42 * --- */
      {  42,94048,                      /* character number, location */
         17, 1,    7, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x20\x48\xba\xce\x87\xcf\x75\x49\x10\x20\x00" }  },
      /* --- pixel bitmap for cmr160 char#43 + --- */
      {  43,94740,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x71\x7e\x01\xf6\x71\x73" }  },
      /* --- pixel bitmap for cmr160 char#44 (noname) --- */
      {  44,95325,                      /* character number, location */
          2, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  2,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaf\x05" }  },
      /* --- pixel bitmap for cmr160 char#45 (noname) --- */
      {  45,117790,                     /* character number, location */
          6, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  6,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f" }  },
      /* --- pixel bitmap for cmr160 char#46 (noname) --- */
      {  46,95790,                      /* character number, location */
          2, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr160 char#47 / --- */
      {  47,96296,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  9,   23, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\xf2\x71\x10\xf1\x61\x20\xf2\x51\x30\xf2\x41"
            "\x40\xf2\x31\x50\xf1\x21\x60\xf2\x11\x7f\x11\x81" }  },
      /* --- pixel bitmap for cmr160 char#48 0 --- */
      {  48,65623,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\x42\x32\x21\x51\x1f\x72\x52\x11\x51\x22\x32\x35"
            "\x21" }  },
      /* --- pixel bitmap for cmr160 char#49 1 --- */
      {  49,66397,                      /* character number, location */
         14, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  7,   14, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x25\x20\xfa\x32\x27" }  },
      /* --- pixel bitmap for cmr160 char#50 2 --- */
      {  50,67366,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x84\x05\x1e\x0c\x18\x30\x30\x20\x20\x20\x20\x24"
            "\xe8\xef\x1f" }  },
      /* --- pixel bitmap for cmr160 char#51 3 --- */
      {  51,68394,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x84\x18\x03\x06\x0c\x0c\x1e\x60\x80\x01\x0f\x1e"
            "\x2c\x8c\x0f" }  },
      /* --- pixel bitmap for cmr160 char#52 4 --- */
      {  52,69310,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\xc0\xc0\x41\x83\x86\x8c\x98\x31\xff\xc1\x80\x01"
            "\x03\x06\x3f" }  },
      /* --- pixel bitmap for cmr160 char#53 5 --- */
      {  53,70338,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\xfc\xe8\x10\x20\x40\x8f\x31\xc1\x80\x01\x0f\x1e"
            "\x24\x8c\x07" }  },
      /* --- pixel bitmap for cmr160 char#54 6 --- */
      {  54,71228,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x18\x1b\x36\x30\x60\xcf\xb1\xc1\x83\x07\x0f\x16"
            "\x44\x0c\x07" }  },
      /* --- pixel bitmap for cmr160 char#55 7 --- */
      {  55,72124,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xf8\xef\x7f\x40\x81\x00\x01\x02\x08\x30\x40\x00"
            "\x01\x06\x18\x60\x80\x01" }  },
      /* --- pixel bitmap for cmr160 char#56 8 --- */
      {  56,73038,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x88\x18\x33\x66\x8c\x0f\x0e\x7a\xc2\x07\x0f\x1e"
            "\x6c\x8c\x0f" }  },
      /* --- pixel bitmap for cmr160 char#57 9 --- */
      {  57,73932,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x08\x1a\x3c\x78\xf0\x60\xe3\xbc\x01\x03\x1a"
            "\x36\xc6\x03" }  },
      /* --- pixel bitmap for cmr160 char#58 : --- */
      {  58,96888,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x00\x0f" }  },
      /* --- pixel bitmap for cmr160 char#59 ; --- */
      {  59,97551,                      /* character number, location */
         10, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  2,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x00\xaf\x05" }  },
      /* --- pixel bitmap for cmr160 char#60 (noname) --- */
      {  60,89485,                      /* character number, location */
         11, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  2,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xf0\xff\x3f" }  },
      /* --- pixel bitmap for cmr160 char#61 = --- */
      {  61,98227,                      /* character number, location */
          9, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 15,    7, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\xf4\xe0\x1e\x01" }  },
      /* --- pixel bitmap for cmr160 char#62 (noname) --- */
      {  62,78127,                      /* character number, location */
         11, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x18\x00\x00\x00\x00\x18\x08\x08\x0c\x06\x03\xc3"
            "\xc3\x3c" }  },
      /* --- pixel bitmap for cmr160 char#63 ? --- */
      {  63,77219,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xc3\xc3\xc0\x60\x30\x10\x10\x18\x00\x00\x00\x00"
            "\x18\x18" }  },
      /* --- pixel bitmap for cmr160 char#64 @ --- */
      {  64,99397,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x44\x38\x24\x23\x8a\x60\x66\x30"
            "\x33\x98\x19\xcc\x08\xa6\x8c\x4b\x38\x47\x00\xc0\x80"
            "\x83\x3f\x00" }  },
      /* --- pixel bitmap for cmr160 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x70\xf2\x63\x60\xf2\x51\x22\x50\xf1\x41\x42\x40"
            "\x47\x40\xf1\x31\x62\x30\x22\x63\x41\x82\x25\x46" }  },
      /* --- pixel bitmap for cmr160 char#66 B --- */
      {  66, 2324,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x62\x62\x20\xf2\x22\x72\x10\x22\x63\x32\x53\x4a"
            "\x42\x72\x10\xf2\x22\x82\x22\x73\x22\x63\x1b\x36" }  },
      /* --- pixel bitmap for cmr160 char#67 C --- */
      {  67, 3249,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x21\x32\x63\x22\x82\xf1\x12\xa1\x0f\x42\xc0\xf1"
            "\x12\xa1\x22\x81\x42\x61\x76\x33" }  },
      /* --- pixel bitmap for cmr160 char#68 D --- */
      {  68, 4327,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x72\x62\x52\x72\x42\x82\x32\x91\x10\xf4\x22\x92"
            "\x22\x91\x32\x82\x32\x72\x42\x62\x3a\x53" }  },
      /* --- pixel bitmap for cmr160 char#69 E --- */
      {  69, 5720,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x8f\x81\x31\x20\x06\xc8\x10\x19\x02\x63\xe0\x0f"
            "\x8c\x81\x21\x32\x44\x06\xcc\x80\x18\xd8\xff\x03" }  },
      /* --- pixel bitmap for cmr160 char#70 F --- */
      {  70, 6949,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xc7\x60\x0c\xc4\x80\x0c\xc9\x10\x8c\xc1\x1f\x8c"
            "\xc1\x10\x0c\xc1\x00\x0c\xc0\x00\x7f\x00" }  },
      /* --- pixel bitmap for cmr160 char#71 G --- */
      {  71, 8116,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x21\x52\x63\x42\x82\x20\xf1\x12\xa1\x2f\x22\xe2"
            "\x79\xa2\x20\xf1\x12\x92\x20\x22\x82\x52\x63\x76\x21"
            "\x22" }  },
      /* --- pixel bitmap for cmr160 char#72 H --- */
      {  72, 9281,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x36\xf5\x22\x72\x20\x2b\x20\xf5\x22\x72\x26\x36" }  },
      /* --- pixel bitmap for cmr160 char#73 I --- */
      {  73, 9952,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   15, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xfc\x32\x38" }  },
      /* --- pixel bitmap for cmr160 char#74 J --- */
      {  74,10750,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\xfa\x62\x22\x42\x22\x32\x45\x45" }  },
      /* --- pixel bitmap for cmr160 char#75 K --- */
      {  75,11895,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x3e\x06\x06\x83\x81\x61\xc0\x18\x60\x04\x30\x03"
            "\x58\x03\x1c\x03\x86\x01\x83\x81\x81\xc1\xc0\x60\xc0"
            "\xfc\xf8\x01" }  },
      /* --- pixel bitmap for cmr160 char#76 L --- */
      {  76,12842,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x50\xf7\x22\x80\xf1\x22\x71\x22\x62\x22\x61\x32"
            "\x52\x1b\x11" }  },
      /* --- pixel bitmap for cmr160 char#77 M --- */
      {  77,14116,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x85\xf1\x23\x83\x20\xf1\x21\x12\x61\x12\x20\xf2"
            "\x21\x22\x41\x22\x20\xf2\x21\x32\x21\x32\x20\xf2\x21"
            "\x43\x42\x25\x31\x36" }  },
      /* --- pixel bitmap for cmr160 char#78 N --- */
      {  78,15246,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x7c\x0e\x08\x0d\x84\x0e\x42\x06\x21\x86\x10\x47"
            "\x08\x23\x04\x13\x82\x0b\x81\x85\x80\x43\xc0\x21\xc0"
            "\x7c\x40\x00" }  },
      /* --- pixel bitmap for cmr160 char#79 O --- */
      {  79,16111,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x52\x72\x32\x92\x21\xb1\x1f\x42\xb2\xf1"
            "\x12\x92\x10\x22\x72\x52\x52\x85\x51" }  },
      /* --- pixel bitmap for cmr160 char#80 P --- */
      {  80,17218,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x52\x62\x10\xf3\x22\x72\x22\x62\x38\x30\xf5\x22"
            "\x96\x72" }  },
      /* --- pixel bitmap for cmr160 char#81 Q --- */
      {  81,18235,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x52\x72\x20\xf1\x12\x92\x1f\x42\xb2\xf1"
            "\x12\x92\x10\x22\x23\x22\x53\x33\x85\xe0\x11\xe1\x31"
            "\xb4\xb3\x11" }  },
      /* --- pixel bitmap for cmr160 char#82 R --- */
      {  82,19524,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x82\x52\x40\xf3\x22\x62\x30\x22\x52\x67\x82\x42"
            "\x50\xf3\x22\x52\x40\x22\x52\x37\x44\x10" }  },
      /* --- pixel bitmap for cmr160 char#83 S --- */
      {  83,20569,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x19\x36\xd0\x40\x03\x1c\xe0\x07\x3f\xc0\x01\x0c"
            "\x70\xc0\x01\x0f\xd6\x0f" }  },
      /* --- pixel bitmap for cmr160 char#84 T --- */
      {  84,21647,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x42\x42\x0f\x21\x52\x51\xf8\x62\x60\x38\x30" }  },
      /* --- pixel bitmap for cmr160 char#85 U --- */
      {  85,22629,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x45\xfa\x22\x81\x20\x32\x61\x72\x41\x95\x58" }  },
      /* --- pixel bitmap for cmr160 char#86 V --- */
      {  86,23617,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x46\xf1\x32\x81\x30\x33\x62\x30\xf1\x42\x61\x40"
            "\xf1\x52\x41\x50\x53\x22\x50\xf1\x62\x21\x60\xf2\x73"
            "\x70\x81\x81" }  },
      /* --- pixel bitmap for cmr160 char#87 W --- */
      {  87,25014,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   15, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x36\x26\x22\x72\x62\x20\xf2\x32\x51\x12\x51\x30"
            "\xf2\x42\x31\x32\x31\x40\xf3\x52\x11\x52\x11\x50\xf2"
            "\x62\x72\x61" }  },
      /* --- pixel bitmap for cmr160 char#88 X --- */
      {  88,26135,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x16\x36\x43\x52\x82\x51\xa2\x31\xc2\x12\xc2\x11\xe2"
            "\x80\xf1\x73\x70\x61\x22\xb2\x32\xa1\x42\x91\x62\x72"
            "\x72\x36\x47" }  },
      /* --- pixel bitmap for cmr160 char#89 Y --- */
      {  89,27277,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x46\x32\x81\x72\x62\x73\x51\x92\x42\xa2\x31\xb3"
            "\x11\xd2\x11\x60\xf5\x82\x70\x66\x51" }  },
      /* --- pixel bitmap for cmr160 char#90 Z --- */
      {  90,28316,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xef\x60\x06\x27\x30\x82\x01\x1c\xc0\x00\x06\x30"
            "\x80\x83\x18\xc8\x80\x0e\x6c\xe0\xff\x0f" }  },
      /* --- pixel bitmap for cmr160 char#91 [ --- */
      {  91,100130,                     /* character number, location */
         17, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  4,   23, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x3f\x51\x34" }  },
      /* --- pixel bitmap for cmr160 char#92 (noname) --- */
      {  92,118659,                     /* character number, location */
         15, 4,    9, 4,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\x18\x45\xf3\x0c" }  },
      /* --- pixel bitmap for cmr160 char#93 ] --- */
      {  93,100824,                     /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  5,   23, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xf5\x41\x05" }  },
      /* --- pixel bitmap for cmr160 char#94 \^ --- */
      {  94,106997,                     /* character number, location */
         15, 3,   12, 3,      /* topleft row,col, and botleft row,col */
          {  5,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x45" }  },
      /* --- pixel bitmap for cmr160 char#95 (noname) --- */
      {  95,107464,                     /* character number, location */
         16, 2,   14, 2,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmr160 char#96 (noname) --- */
      {  96,101438,                     /* character number, location */
         15, 2,    9, 2,      /* topleft row,col, and botleft row,col */
          {  2,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x0f" }  },
      /* --- pixel bitmap for cmr160 char#97 a --- */
      {  97,29456,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x98\x01\x0c\x30\xfc\x18\x33\xcc\xb0\xe3\x72\x07" }  },
      /* --- pixel bitmap for cmr160 char#98 b --- */
      {  98,30458,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x60\x00\x03\x18\xc0\x00\x76\x70\x8c\x41\x0c\x66"
            "\x30\x83\x19\xcc\x20\x8e\x90\x03" }  },
      /* --- pixel bitmap for cmr160 char#99 c --- */
      {  99,31233,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xc4\x02\x03\x03\x03\x03\x02\x84\x78" }  },
      /* --- pixel bitmap for cmr160 char#100 d --- */
      { 100,32224,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\x0c\x60\x00\x03\x18\xdc\x10\x47\x30\x83\x19"
            "\xcc\x60\x06\x23\x18\xe3\xe0\x1e" }  },
      /* --- pixel bitmap for cmr160 char#101 e --- */
      { 101,32984,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x66\xc2\xc3\xff\x03\x03\x02\x86\x78" }  },
      /* --- pixel bitmap for cmr160 char#102 f --- */
      { 102,33805,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   15, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x42\x22\xf2\x22\x57\x20\xf7\x22\x56\x32" }  },
      /* --- pixel bitmap for cmr160 char#103 g --- */
      { 103,35038,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x9b\x39\xcc\x30\xc3\x98\xe1\xc3\x00\x7e\xf8\x33"
            "\xd8\x60\x83\x19\xc3\x07" }  },
      /* --- pixel bitmap for cmr160 char#104 h --- */
      { 104,36015,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x80\xf3\x22\x80\x22\x14\x53\x32\x20\xf6\x22\x42"
            "\x26\x15" }  },
      /* --- pixel bitmap for cmr160 char#105 i --- */
      { 105,36730,                      /* character number, location */
         16, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   16, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x22\x20\xf3\x64\x20\xf7\x22\x26" }  },
      /* --- pixel bitmap for cmr160 char#106 j --- */
      { 106,37498,                      /* character number, location */
         16,-2,   -4,-2,      /* topleft row,col, and botleft row,col */
          {  7,   20, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x52\xf3\x70\x34\xfa\x52\x02\x28\x20" }  },
      /* --- pixel bitmap for cmr160 char#107 k --- */
      { 107,38588,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xc0\x00\x0c\xc0\x00\x0c\xc0\x7c\x8c\xc1\x04\x6c"
            "\xc0\x07\xcc\xc0\x1c\x8c\xc1\x30\x9f\x0f" }  },
      /* --- pixel bitmap for cmr160 char#108 l --- */
      { 108,39207,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   15, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x20\xfc\x22\x26" }  },
      /* --- pixel bitmap for cmr160 char#109 m --- */
      { 109,40516,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   10, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x14\x24\x53\x33\x32\x20\xf6\x22\x42\x42\x26\x15"
            "\x15" }  },
      /* --- pixel bitmap for cmr160 char#110 n --- */
      { 110,41501,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   10, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x14\x53\x32\x20\xf6\x22\x42\x26\x15" }  },
      /* --- pixel bitmap for cmr160 char#111 o --- */
      { 111,42198,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x09\x1a\x3c\x78\xf0\x60\x41\xc6\x70\x00" }  },
      /* --- pixel bitmap for cmr160 char#112 p --- */
      { 112,43264,                      /* character number, location */
         10, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xef\xe0\x18\x83\x18\xcc\x60\x06\x33\x98\x61\x1c\x61"
            "\x07\x03\x18\xc0\x80\x1f\x00" }  },
      /* --- pixel bitmap for cmr160 char#113 q --- */
      { 113,44268,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x42\x38\x06\x33\x30\x03\x33\x30\x03\x63\x30\x84"
            "\x83\x37\x00\x03\x30\x00\x03\xfc" }  },
      /* --- pixel bitmap for cmr160 char#114 r --- */
      { 114,45127,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x13\x33\x22\x23\x40\xf5\x22\x56\x30" }  },
      /* --- pixel bitmap for cmr160 char#115 s --- */
      { 115,46060,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xe1\xf0\xe0\xe3\x87\xc3\xa3\x0e" }  },
      /* --- pixel bitmap for cmr160 char#116 t --- */
      { 116,46885,                      /* character number, location */
         14, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x08\x0c\x0c\x7f\x0c\x0c\x0c\x0c\x0c\x8c\x8c\x8c"
            "\x78" }  },
      /* --- pixel bitmap for cmr160 char#117 u --- */
      { 117,47808,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   10, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x24\x20\xf6\x22\x42\x20\x22\x33\x54\x14" }  },
      /* --- pixel bitmap for cmr160 char#118 v --- */
      { 118,48674,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\xcf\x20\x18\x81\x11\x18\x01\x0b\xb0\x00\x06\x60"
            "\x00\x06" }  },
      /* --- pixel bitmap for cmr160 char#119 w --- */
      { 119,49923,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\xf3\x8c\x23\x8c\x23\xd8\x13\x58\x16\x58\x16\x78"
            "\x1e\x30\x0c\x30\x0c\x30\x0c" }  },
      /* --- pixel bitmap for cmr160 char#120 x --- */
      { 120,50892,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x8f\x11\x98\x00\x0f\x60\x00\x06\xd0\x80\x19\x88"
            "\xf3\xf9" }  },
      /* --- pixel bitmap for cmr160 char#121 y --- */
      { 121,51955,                      /* character number, location */
         10, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\xcf\x20\x18\x81\x11\x18\x01\x0b\xb0\x00\x06\x60"
            "\x00\x06\x20\x00\x02\x13\xe0\x00" }  },
      /* --- pixel bitmap for cmr160 char#122 z --- */
      { 122,52914,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x63\x61\x31\x18\x98\x8c\x86\xc6\xff" }  },
      /* --- pixel bitmap for cmr160 char#123 (noname) --- */
      { 123,119267,                     /* character number, location */
          7, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          { 11,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b" }  },
      /* --- pixel bitmap for cmr160 char#124 (noname) --- */
      { 124,120087,                     /* character number, location */
          7, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          { 22,    1, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x08" }  },
      /* --- pixel bitmap for cmr160 char#125 (noname) --- */
      { 125,108141,                     /* character number, location */
         15, 3,   11, 3,      /* topleft row,col, and botleft row,col */
          {  6,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x1c\x45" }  },
      /* --- pixel bitmap for cmr160 char#126 \~ --- */
      { 126,108825,                     /* character number, location */
         15, 2,   12, 2,      /* topleft row,col, and botleft row,col */
          {  7,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x5f\x04" }  },
      /* --- pixel bitmap for cmr160 char#127 (noname) --- */
      { 127,109506,                     /* character number, location */
         16, 2,   14, 2,      /* topleft row,col, and botleft row,col */
          {  7,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe3\x31" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=5 for .180gf ---
 * mf '\mode=preview; mag=magstep(-14.65037297372839890542); input cmr10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmr180 --- */
static	chardef  cmr180[] =
   {
      /* --- pixel bitmap for cmr180 char#0 \Gamma --- */
      {   0,54233,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x42\x72\x42\x81\x42\x82\xf1\x32\x91\xf9\x32\xa8"
            "\x71" }  },
      /* --- pixel bitmap for cmr180 char#1 \Delta --- */
      {   1,55144,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x90\xf1\x83\x80\xf1\x71\x22\x70\xf1\x61\x42\x60"
            "\xf1\x51\x62\x50\xf1\x41\x82\x40\xf1\x31\xa2\x30\x21"
            "\xb3\x41\xc2\x31\xd3\x2e\x03\x1e\x05" }  },
      /* --- pixel bitmap for cmr180 char#2 \Theta --- */
      {   2,56287,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\xa2\x52\x72\x72\x52\x92\x20\xf1\x12\xb2\x12\xd4"
            "\x21\x71\x22\x0f\x12\x29\x22\x02\x21\x71\x22\x0f\x12"
            "\xd2\xf1\x12\xb2\x10\x22\x92\x52\x72\x72\x52\xa5\x60" }  },
      /* --- pixel bitmap for cmr180 char#3 \Lambda --- */
      {   3,57259,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x71\x70\xf2\x63\x60\xf2\x51\x22\x50\x41\x33\x40"
            "\xf2\x41\x42\x40\xf2\x31\x62\x30\x21\x82\x42\x72\x25"
            "\x46" }  },
      /* --- pixel bitmap for cmr180 char#4 \Xi --- */
      {   4,58642,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x01\x0f\x11\xd1\xf1\xe0\x10\x31\x71\x30\xf1"
            "\x39\x30\x31\x71\x30\xf2\xe0\x1f\x11\xd1\x0f\x1e\x01" }  },
      /* --- pixel bitmap for cmr180 char#5 \Pi --- */
      {   5,59799,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   17, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x05\xfe\x32\x92\x38\x38" }  },
      /* --- pixel bitmap for cmr180 char#6 \Sigma --- */
      {   6,60934,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\x22\x93\x23\xa1\x32\xa2\x32\xa1\x33\x91\x42"
            "\xe0\x12\xe0\x12\xe1\xe1\xe1\xa1\x31\xb1\x31\xa2\x21"
            "\xb1\x21\xa3\x1e\x01\x12" }  },
      /* --- pixel bitmap for cmr180 char#7 \Upsilon --- */
      {   7,62038,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   18, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x54\x36\x36\x12\x42\x21\x43\x61\x12\x52\x63\x61"
            "\xfb\x82\x70\x58\x41" }  },
      /* --- pixel bitmap for cmr180 char#8 \Phi --- */
      {   8,63084,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x40\xf2\x72\x70\x48\x62\x32\x32\x32\x42\x42\x1f"
            "\x22\x52\x52\x12\x42\x42\x32\x32\x32\x68\x40\xf2\x72"
            "\x70\x48\x43" }  },
      /* --- pixel bitmap for cmr180 char#9 \Psi --- */
      {   9,64209,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x40\xf1\x82\x73\x52\x43\xf4\x22\x42\x32\x20\x31"
            "\x42\x32\x52\x32\x22\x72\x22\x12\xa6\x50\xf2\x82\x70"
            "\x58\x48" }  },
      /* --- pixel bitmap for cmr180 char#10 \Omega --- */
      {  10,65380,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   18, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x82\x62\x52\x82\x32\xa2\x1f\x42\xc2\xf1\x12\xa2"
            "\x10\x22\x82\x51\x81\x71\x61\x41\x31\x61\x32\x41\x41"
            "\x41\xf1\x15\x45\x11" }  },
      /* --- pixel bitmap for cmr180 char#11 \ff --- */
      {  11,111599,                     /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x13\x52\x43\x12\xf3\x32\x52\x4e\x01\x10\xf8\x32"
            "\x52\x40\x15\x35\x21" }  },
      /* --- pixel bitmap for cmr180 char#12 \fi --- */
      {  12,112779,                     /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   17, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x72\x32\x52\x42\x20\xf2\x32\x8b\x20\xf8\x32\x42"
            "\x20\x15\x25" }  },
      /* --- pixel bitmap for cmr180 char#13 \fl --- */
      {  13,113949,                     /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   17, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x62\x32\x20\xf3\x32\x42\x2b\x20\xf8\x32\x42\x20"
            "\x15\x25" }  },
      /* --- pixel bitmap for cmr180 char#14 \ffi --- */
      {  14,115570,                     /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 20,   17, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x15\x72\x43\x32\x52\x52\x42\x20\xf2\x32\x52\x8e"
            "\x04\x20\xf8\x32\x52\x42\x20\x15\x34\x25" }  },
      /* --- pixel bitmap for cmr180 char#15 \ffl --- */
      {  15,117217,                     /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 20,   17, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x16\x62\x43\x32\x20\xf3\x32\x52\x42\x2e\x04\x20"
            "\xf8\x32\x52\x42\x20\x16\x1c" }  },
      /* --- pixel bitmap for cmr180 char#16 \imath --- */
      {  16,79369,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   11, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x20\xf8\x22\x26" }  },
      /* --- pixel bitmap for cmr180 char#17 \jmath --- */
      {  17,80043,                      /* character number, location */
         11,-1,   -5,-1,      /* topleft row,col, and botleft row,col */
          {  6,   16, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\xfc\x42\x02\x21\x23\x23" }  },
      /* --- pixel bitmap for cmr180 char#18 \gravesym --- */
      {  18,102844,                     /* character number, location */
         17, 3,   13, 3,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\xc6" }  },
      /* --- pixel bitmap for cmr180 char#19 \acutesym --- */
      {  19,103415,                     /* character number, location */
         17, 5,   13, 5,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xec\x36" }  },
      /* --- pixel bitmap for cmr180 char#20 \checksym --- */
      {  20,104042,                     /* character number, location */
         16, 3,   14, 3,      /* topleft row,col, and botleft row,col */
          {  6,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb3\x07" }  },
      /* --- pixel bitmap for cmr180 char#21 \brevesym --- */
      {  21,104658,                     /* character number, location */
         17, 2,   14, 2,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\xc3\x3c" }  },
      /* --- pixel bitmap for cmr180 char#22 (noname) --- */
      {  22,105238,                     /* character number, location */
         15, 2,   14, 2,      /* topleft row,col, and botleft row,col */
          {  8,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff" }  },
      /* --- pixel bitmap for cmr180 char#23 (noname) --- */
      {  23,106015,                     /* character number, location */
         18, 7,   14, 7,      /* topleft row,col, and botleft row,col */
          {  5,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x46\x07" }  },
      /* --- pixel bitmap for cmr180 char#24 (noname) --- */
      {  24,106707,                     /* character number, location */
         -1, 3,   -6, 3,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x0c\xfb\x01" }  },
      /* --- pixel bitmap for cmr180 char#25 \ss --- */
      {  25,81130,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc1\x18\x83\x19\xcc\x60\x86\xbd\x83\x31\x0c\x63"
            "\x18\x83\x19\xcc\x60\x06\x33\x99\x79\x8f\x01" }  },
      /* --- pixel bitmap for cmr180 char#26 \ae --- */
      {  26,82481,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x3c\xc6\x62\x80\xc3\x80\xc1\xf0\xff\x8c\x01\x82"
            "\x01\x83\x01\x83\x83\xc6\x46\x7c\x3c" }  },
      /* --- pixel bitmap for cmr180 char#27 \oe --- */
      {  27,83607,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x78\x08\x89\x19\x1e\x1e\x18\x3c\xf0\x7f\x60\xc0"
            "\xc0\x80\x81\x01\x86\x07\x09\x19\xe1\xe1\x01" }  },
      /* --- pixel bitmap for cmr180 char#28 (noname) --- */
      {  28,84431,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x84\x0f\x21\x42\x8d\x3d\xf2\xcc\x13\x2f\xac"
            "\x10\x21\x7c\x08\x20\x00" }  },
      /* --- pixel bitmap for cmr180 char#29 \AE --- */
      {  29,86217,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xff\x07\x68\x60\x80\x06\x04\x64\xc0\x40\x06\x08"
            "\x64\x88\x20\x86\x00\x62\x0c\xe0\xff\x00\x61\x0c\x10"
            "\x86\x08\x61\x88\x08\x06\x88\x60\x40\x08\x06\xc4\x60"
            "\x60\x9f\xff\x07" }  },
      /* --- pixel bitmap for cmr180 char#30 \OE --- */
      {  30,87929,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 23,   19, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x65\xe0\x22\x5b\x42\x63\x62\x32\x73\x71\x22\x83\x72"
            "\x12\x83\x83\x93\x51\x23\xa2\x51\x32\xa2\x42\x32\xa8"
            "\x32\xa2\x42\x32\xa2\x51\x23\x93\x51\x21\x12\x83\x81"
            "\x12\x83\x71\x32\x73\x71\x42\x63\x62\x53\x4b\x75\xc1" }  },
      /* --- pixel bitmap for cmr180 char#31 (noname) --- */
      {  31,88931,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x47\x60\xf0\x20\x80\x60\x80\x63\x80\xcd\x00\xd9"
            "\x00\xe1\x01\xc1\x03\x82\x07\x02\x0f\x02\x1e\x04\x3c"
            "\x04\xd8\x04\x98\x0d\x30\x0e\x30\x08\x20\x78\x30\x10"
            "\x1f\x00" }  },
      /* --- pixel bitmap for cmr180 char#32 (noname) --- */
      {  32,107207,                     /* character number, location */
         10, 0,    7, 0,      /* topleft row,col, and botleft row,col */
          {  6,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x27\x00" }  },
      /* --- pixel bitmap for cmr180 char#33 ! --- */
      {  33,89602,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  3,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\xff\x5b\x92\x04\x40\x17" }  },
      /* --- pixel bitmap for cmr180 char#34 " --- */
      {  34,118176,                     /* character number, location */
         17, 1,    9, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\xe7\xc6\x84\x84\x84\x42\x21" }  },
      /* --- pixel bitmap for cmr180 char#35 # --- */
      {  35,91072,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x91\x51\x30\xf2\x81\x51\x4e\x05\xf1\x71\x51\x50"
            "\xf2\x61\x51\x6e\x05\xf1\x51\x51\x70\xf3\x41\x51\x80"
            "\xf1\x31\x51\x91" }  },
      /* --- pixel bitmap for cmr180 char#36 $ --- */
      {  36,75631,                      /* character number, location */
         19, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x80\x80\x87\x69\x20\x86\x18\x72\x08\x26\xf8\x80"
            "\x0f\x78\x20\x83\x38\x62\x88\x22\x99\x82\x07\x08" }  },
      /* --- pixel bitmap for cmr180 char#37 % --- */
      {  37,92321,                      /* character number, location */
         19, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x80\x30\x01\x82\x38\x18\x86\x7e\x30\x04\x81\x21"
            "\x08\x0c\x21\x60\x08\x01\x22\x04\x30\x11\x00\x87\x70"
            "\x00\xc2\x04\x08\x42\x40\x18\x02\xc1\x10\x08\x86\x20"
            "\x30\x84\x00\x21\x04\x98\x10\x80\x03" }  },
      /* --- pixel bitmap for cmr180 char#38 & --- */
      {  38,76909,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x00\x20\x02\x60\x04\xc0\x08\x80\x11\x00\x13\x00"
            "\x26\x00\x2c\xfc\x30\x60\x60\x40\xe0\x41\x20\x83\x20"
            "\x8e\x60\x18\xc1\x60\x81\x81\x81\x03\x07\x0d\x19\xf1"
            "\xe1\x01" }  },
      /* --- pixel bitmap for cmr180 char#39 ' --- */
      {  39,92997,                      /* character number, location */
         17, 2,    9, 2,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x49\x29" }  },
      /* --- pixel bitmap for cmr180 char#40 ( --- */
      {  40,93575,                      /* character number, location */
         19, 3,   -6, 3,      /* topleft row,col, and botleft row,col */
          {  6,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x84\x30\x84\x61\x08\xc3\x30\x0c\xc3\x30\x0c\x83"
            "\x60\x18\x04\x83\x40\x20" }  },
      /* --- pixel bitmap for cmr180 char#41 ) --- */
      {  41,94188,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x40\x30\x08\x86\x41\x30\x0c\xc3\x30\x0c\xc3\x30"
            "\x84\x61\x08\x43\x08\x01" }  },
      /* --- pixel bitmap for cmr180 char#42 * --- */
      {  42,94825,                      /* character number, location */
         19, 1,    8, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x60\xc8\xb4\xcd\x0f\x06\x3f\xdb\x32\x61\xc0\x00" }  },
      /* --- pixel bitmap for cmr180 char#43 + --- */
      {  43,95519,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x81\x8e\x03\xf7\x81\x82" }  },
      /* --- pixel bitmap for cmr180 char#44 (noname) --- */
      {  44,96108,                      /* character number, location */
          3, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x49\x29" }  },
      /* --- pixel bitmap for cmr180 char#45 (noname) --- */
      {  45,118687,                     /* character number, location */
          6, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  7,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3f" }  },
      /* --- pixel bitmap for cmr180 char#46 (noname) --- */
      {  46,96577,                      /* character number, location */
          3, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00" }  },
      /* --- pixel bitmap for cmr180 char#47 / --- */
      {  47,97085,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 10,   25, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x91\xf2\x81\x10\xf1\x71\x20\xf2\x61\x30\xf1\x51"
            "\x40\xf2\x41\x50\xf2\x31\x60\xf1\x21\x70\xf2\x11\x8f"
            "\x11\x91" }  },
      /* --- pixel bitmap for cmr180 char#48 0 --- */
      {  48,66116,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x52\x22\x32\x42\x21\x61\x1f\x92\x62\x11\x61\x22"
            "\x42\x32\x22\x54\x31" }  },
      /* --- pixel bitmap for cmr180 char#49 1 --- */
      {  49,66906,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  8,   17, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\x44\x31\x22\x30\xfc\x32\x38" }  },
      /* --- pixel bitmap for cmr180 char#50 2 --- */
      {  50,67883,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x22\x58\xc0\x01\x0f\x0c\x30\xc0\x80\x01\x02"
            "\x04\x08\x10\x20\x48\xa0\x7f\xff\x01" }  },
      /* --- pixel bitmap for cmr180 char#51 3 --- */
      {  51,68921,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x23\x98\x61\x86\x01\x06\x08\x10\x78\x00\x02"
            "\x18\xc0\x03\x0f\x1c\xb0\x60\x84\xe0\x01" }  },
      /* --- pixel bitmap for cmr180 char#52 4 --- */
      {  52,69853,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x03\x0e\x38\xd0\x60\x83\x0c\x31\xc4\x08\x13"
            "\xcc\xff\xc0\x00\x03\x0c\x30\xf0\x03" }  },
      /* --- pixel bitmap for cmr180 char#53 5 --- */
      {  53,70891,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xf9\xa3\x83\x00\x02\x08\x20\x87\x22\x86\x09\x0c"
            "\x30\xc0\x00\x0f\x1c\x90\x60\xc6\xe0\x01" }  },
      /* --- pixel bitmap for cmr180 char#54 6 --- */
      {  54,71795,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x60\xc4\x98\x61\x06\x08\xb0\xc7\x21\x87\x0d\x3c"
            "\xf0\xc0\x03\x0f\x2c\xb0\x61\x8c\xe0\x01" }  },
      /* --- pixel bitmap for cmr180 char#55 7 --- */
      {  55,72707,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   18, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xaa\x19\x11\x81\x11\x71\x20\xf1\x71\x30\x61\x92"
            "\x91\x50\xf1\x42\x50\x41\x60\xf4\x32\x62" }  },
      /* --- pixel bitmap for cmr180 char#56 8 --- */
      {  56,73627,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\x63\x98\x61\x86\x19\xc6\x0c\x17\x70\xb0\x63"
            "\xd8\xe0\x03\x0f\x3c\xb0\x41\x84\xe0\x01" }  },
      /* --- pixel bitmap for cmr180 char#57 9 --- */
      {  57,74539,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x62\xd8\x40\x03\x0f\x3c\xf0\xc0\x03\x1b\x4e"
            "\x38\xde\x00\x03\x66\x98\x21\x42\xf0\x00" }  },
      /* --- pixel bitmap for cmr180 char#58 : --- */
      {  58,97681,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  3,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00\x00\xba\x00" }  },
      /* --- pixel bitmap for cmr180 char#59 ; --- */
      {  59,98348,                      /* character number, location */
         11, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  3,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00\x00\xba\x49\x29" }  },
      /* --- pixel bitmap for cmr180 char#60 (noname) --- */
      {  60,90220,                      /* character number, location */
         12, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  3,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00\x48\x92\xfc\xff\x17" }  },
      /* --- pixel bitmap for cmr180 char#61 = --- */
      {  61,99030,                      /* character number, location */
         10, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 17,    7, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\xf4\xe0\x3e\x03" }  },
      /* --- pixel bitmap for cmr180 char#62 (noname) --- */
      {  62,78784,                      /* character number, location */
         12, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 10,   17, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x83\x81\x50\xf2\xa0\xf3\x41\x50\x31\x81\x81\x8f"
            "\x12\x62\x11\x61\x36\x21" }  },
      /* --- pixel bitmap for cmr180 char#63 ? --- */
      {  63,77868,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   17, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x26\x31\x52\x1f\x12\x62\x72\x72\x71\x82\x40\xf2\x41"
            "\x50\xf2\xa0\x41\x83\x81\x54" }  },
      /* --- pixel bitmap for cmr180 char#64 @ --- */
      {  64,100200,                     /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x20\x1c\x22\x44\x48\x0c\x53"
            "\x0c\xc6\x18\x8c\x31\x18\x63\x30\xc6\x60\x14\xc3\x28"
            "\xc4\x89\x70\x0e\x02\x00\x18\xe0\xc0\x3f\x00" }  },
      /* --- pixel bitmap for cmr180 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   18, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\xf2\x73\x70\x62\x12\x60\xf1\x61\x22\x60\xf2"
            "\x51\x42\x50\x41\x62\x89\x81\x62\x40\xf2\x31\x82\x30"
            "\x22\x83\x26\x47" }  },
      /* --- pixel bitmap for cmr180 char#66 B --- */
      {  66, 2336,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x72\x73\x52\x82\x20\xf2\x32\x92\x10\x32\x82\x52"
            "\x63\x6b\x62\x83\x42\x93\xf2\x32\xa2\x32\x92\x42\x82"
            "\x2e\x33" }  },
      /* --- pixel bitmap for cmr180 char#67 C --- */
      {  67, 3269,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   19, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x41\x42\x52\x12\x32\x83\x22\xa2\x12\xb2\x12\xc3"
            "\xd1\x0f\x42\xe2\xd1\xf1\x12\xc1\x22\xa1\x42\x81\x62"
            "\x61\x96\x46" }  },
      /* --- pixel bitmap for cmr180 char#68 D --- */
      {  68, 4365,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x82\x72\x72\x92\x52\xa1\x52\xa2\x42\xb1\x10\xf5"
            "\x32\xb2\x32\xa2\x42\xa1\x52\x92\x52\x73\x3d\x51" }  },
      /* --- pixel bitmap for cmr180 char#69 E --- */
      {  69, 5766,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x7f\x18\x60\x18\x40\x18\xc0\x18\x80\x18\x84\x18"
            "\x04\x18\x06\xf8\x07\x18\x06\x18\x84\x18\x84\x18\x80"
            "\x18\x40\x18\x40\x18\x70\xff\x7f" }  },
      /* --- pixel bitmap for cmr180 char#70 F --- */
      {  70, 7003,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x42\x72\x42\x81\x42\x82\x32\x91\x32\x51\x31\x32"
            "\x51\x72\x42\x78\x72\x42\x40\xf1\x32\x51\x40\xf3\x32"
            "\xa8\x71" }  },
      /* --- pixel bitmap for cmr180 char#71 G --- */
      {  71, 8176,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 18,   19, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x41\x62\x52\x12\x52\x83\x42\xa2\x32\xb2\x32\xc1"
            "\x22\xd1\x2f\x22\xe0\x22\x97\x0f\x12\xc2\x20\xf1\x12"
            "\xb2\x20\x22\xa2\x52\x92\x62\x62\x11\x86\x60" }  },
      /* --- pixel bitmap for cmr180 char#72 H --- */
      {  72, 9359,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   17, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x38\xf6\x32\x92\x30\x3d\x30\xf6\x32\x92\x38\x38" }  },
      /* --- pixel bitmap for cmr180 char#73 I --- */
      {  73,10038,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   17, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xfe\x32\x38" }  },
      /* --- pixel bitmap for cmr180 char#74 J --- */
      {  74,10840,                      /* character number, location */
         17, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 10,   18, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\xfb\x62\x2f\x12\x42\x21\x51\x41\x32\x54\x48" }  },
      /* --- pixel bitmap for cmr180 char#75 K --- */
      {  75,11995,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x46\x32\x82\x62\x81\x72\x71\x82\x61\x92\x51\xa2"
            "\x41\xb2\x32\xb2\x12\x11\xb3\x32\xa2\x52\x60\xf1\x32"
            "\x62\x50\x32\x72\x40\xf1\x32\x82\x38\x37" }  },
      /* --- pixel bitmap for cmr180 char#76 L --- */
      {  76,12950,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x70\xf8\x32\xa0\xf2\x32\x91\x32\x82\x32\x81\x42"
            "\x63\x1e\x12" }  },
      /* --- pixel bitmap for cmr180 char#77 M --- */
      {  77,14230,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   17, 3,82, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xb6\x33\xb3\x30\xf2\x31\x12\x91\x12\x30\xf1\x31"
            "\x22\x71\x22\x30\xf2\x31\x32\x51\x32\x30\xf1\x31\x42"
            "\x31\x42\x30\xf2\x31\x52\x11\x52\x30\x23\x52\x62\x37"
            "\x32\x38" }  },
      /* --- pixel bitmap for cmr180 char#78 N --- */
      {  78,15384,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\xf0\xc7\x01\x0e\x0e\x20\xd0\x00\x81\x0c\x08\xc4"
            "\x40\x20\x06\x02\x61\x10\x08\x86\x40\x60\x04\x02\x23"
            "\x10\x30\x81\x00\x0b\x04\x70\x20\x80\x83\x03\x18\x7f"
            "\x80\x00" }  },
      /* --- pixel bitmap for cmr180 char#79 O --- */
      {  79,16259,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\xa2\x52\x72\x72\x52\x92\x20\xf1\x12\xb2\x1f\x62"
            "\xd2\xf1\x12\xb2\x10\x22\x92\x52\x72\x72\x52\xa5\x61" }  },
      /* --- pixel bitmap for cmr180 char#80 P --- */
      {  80,17382,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x62\x72\x52\x82\x10\xf2\x32\x92\x32\x82\x42\x72"
            "\x5a\x30\xf6\x32\xb8\x82" }  },
      /* --- pixel bitmap for cmr180 char#81 Q --- */
      {  81,18405,                      /* character number, location */
         18, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 17,   23, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\xa2\x52\x72\x72\x52\x92\x20\xf1\x12\xb2\x1f\x62"
            "\xd2\x12\xb2\x22\x43\x42\x32\x21\x31\x22\x52\x11\x31"
            "\x12\x73\x42\x31\x66\x41\xb1\x41\xb2\x22\xb5\xd3\x21" }  },
      /* --- pixel bitmap for cmr180 char#82 R --- */
      {  82,19724,                      /* character number, location */
         17, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\xa2\x62\x82\x72\x40\xf2\x32\x82\x30\x32\x72\x72"
            "\x62\x88\xa2\x62\x50\xf3\x32\x72\x40\xf1\x32\x72\x31"
            "\x08\x51\x31\xe3\x16" }  },
      /* --- pixel bitmap for cmr180 char#83 S --- */
      {  83,20783,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   19, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\x21\x31\x51\x11\x21\x72\x1f\x22\x81\x13\xa3\xa6"
            "\x77\x94\xa2\xb2\x0f\x21\x92\x02\x72\x11\x12\x42\x21"
            "\x35\x31" }  },
      /* --- pixel bitmap for cmr180 char#84 T --- */
      {  84,21881,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x04\x52\x52\x0f\x31\x62\x61\xf9\x72\x70\x3a\x36" }  },
      /* --- pixel bitmap for cmr180 char#85 U --- */
      {  85,22871,                      /* character number, location */
         17, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x47\x32\x93\x20\xfb\x32\xa1\x30\x42\x81\x91\x71"
            "\xb2\x42\xc5\x72" }  },
      /* --- pixel bitmap for cmr180 char#86 V --- */
      {  86,23871,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   18, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x65\x22\x92\x42\xa1\x20\xf2\x32\x81\x30\xf1\x42"
            "\x61\x40\x43\x42\x40\xf1\x52\x41\x50\xf2\x62\x21\x60"
            "\xf2\x73\x70\x81\x86" }  },
      /* --- pixel bitmap for cmr180 char#87 W --- */
      {  87,25295,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 24,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\xfe\xf8\x0c\x18\x70\x0c\x38\x20\x0c\x38\x20\x18"
            "\x38\x10\x18\x38\x10\x18\x64\x10\x30\x64\x08\x30\x64"
            "\x08\x30\xc2\x08\x30\xc2\x08\x60\xc2\x04\x60\x81\x05"
            "\x60\x81\x05\xc0\x81\x03\xc0\x81\x03\xc0\x00\x03\x80"
            "\x00\x01" }  },
      /* --- pixel bitmap for cmr180 char#88 X --- */
      {  88,26428,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,66, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x36\x42\x63\x63\x52\x82\x51\xa2\x31\xc2\x12\xc2"
            "\x11\xe2\x80\xf1\x73\x70\x61\x22\xb2\x32\xa1\x43\x81"
            "\x62\x72\x72\x53\x73\x26\x47" }  },
      /* --- pixel bitmap for cmr180 char#89 Y --- */
      {  89,27578,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x66\x23\x82\x62\x81\x73\x71\x82\x61\xa2\x42\xa3"
            "\x31\xc3\x12\xd2\x11\x70\xf6\x82\x80\x58\x51" }  },
      /* --- pixel bitmap for cmr180 char#90 Z --- */
      {  90,28623,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xdf\x81\x19\x30\x01\x23\x30\x04\x06\x60\x00\x06"
            "\xe0\x00\x0c\xc0\x40\x0c\x88\x01\x19\xa0\x01\x36\xe0"
            "\xff\x1f" }  },
      /* --- pixel bitmap for cmr180 char#91 [ --- */
      {  91,100949,                     /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  5,   25, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\x71\x45" }  },
      /* --- pixel bitmap for cmr180 char#92 (noname) --- */
      {  92,119556,                     /* character number, location */
         17, 3,    9, 3,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x42\x21\x21\x21\x63\xe7\x42" }  },
      /* --- pixel bitmap for cmr180 char#93 ] --- */
      {  93,101647,                     /* character number, location */
         19, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  5,   25, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xf7\x41\x05" }  },
      /* --- pixel bitmap for cmr180 char#94 \^ --- */
      {  94,107834,                     /* character number, location */
         17, 3,   13, 3,      /* topleft row,col, and botleft row,col */
          {  6,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x37\x87" }  },
      /* --- pixel bitmap for cmr180 char#95 (noname) --- */
      {  95,108303,                     /* character number, location */
         18, 2,   15, 2,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00" }  },
      /* --- pixel bitmap for cmr180 char#96 (noname) --- */
      {  96,102265,                     /* character number, location */
         17, 2,    9, 2,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x94\x92\x5d" }  },
      /* --- pixel bitmap for cmr180 char#97 a --- */
      {  97,29771,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x30\x06\x60\x00\x03\x1f\xc6\x08\x66\xb0\x83\x35"
            "\x2e\xcf\x00" }  },
      /* --- pixel bitmap for cmr180 char#98 b --- */
      {  98,30779,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x80\xf4\x22\x80\x22\x14\x53\x32\x42\x52\x10\xf4"
            "\x22\x62\x22\x52\x33\x32\x41\x24\x32" }  },
      /* --- pixel bitmap for cmr180 char#99 c --- */
      {  99,31560,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x18\x1b\x18\x30\x60\xc0\x80\x01\x06\x19\xe1\x01" }  },
      /* --- pixel bitmap for cmr180 char#100 d --- */
      { 100,32555,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x20\xf4\x82\x20\x34\x12\x42\x33\x32\x52\x2f\x42"
            "\x62\x20\x12\x52\x42\x33\x54\x14" }  },
      /* --- pixel bitmap for cmr180 char#101 e --- */
      { 101,33321,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x08\x19\x1e\xfc\x7f\xc0\x80\x01\x06\x09\xe1\x01" }  },
      /* --- pixel bitmap for cmr180 char#102 f --- */
      { 102,34146,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   17, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\x52\x12\xf3\x32\x48\x10\xf8\x32\x40\x17\x11" }  },
      /* --- pixel bitmap for cmr180 char#103 g --- */
      { 103,35383,                      /* character number, location */
         12, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 11,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xe3\xa5\x19\x87\x31\x8c\x61\x98\xc1\x07\x01\x18"
            "\xc0\x3f\xfc\x23\xb8\x81\x0d\x6c\x60\x86\xc1\x03" }  },
      /* --- pixel bitmap for cmr180 char#104 h --- */
      { 104,36370,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x80\xf4\x22\x80\x22\x14\x53\x32\x20\xf7\x22\x42"
            "\x26\x24" }  },
      /* --- pixel bitmap for cmr180 char#105 i --- */
      { 105,37065,                      /* character number, location */
         18, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   18, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x43\x41\x30\xf3\x64\x20\xf8\x22\x26" }  },
      /* --- pixel bitmap for cmr180 char#106 j --- */
      { 106,37837,                      /* character number, location */
         18,-1,   -5,-1,      /* topleft row,col, and botleft row,col */
          {  6,   23, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x43\x41\x10\xf3\x60\x24\xfc\x42\x02\x21\x23\x22" }  },
      /* --- pixel bitmap for cmr180 char#107 k --- */
      { 107,38933,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xc0\x00\x0c\xc0\x00\x0c\xc0\x00\x8c\xcf\x30\x0c"
            "\xc1\x0c\x6c\xc0\x0f\xcc\xc0\x18\x8c\xc3\x30\xbf\x0f" }  },
      /* --- pixel bitmap for cmr180 char#108 l --- */
      { 108,39532,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   17, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x20\xfe\x22\x26" }  },
      /* --- pixel bitmap for cmr180 char#109 m --- */
      { 109,40845,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   11, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x24\x34\x54\x34\x32\x20\xf7\x22\x52\x52\x26\x25"
            "\x25" }  },
      /* --- pixel bitmap for cmr180 char#110 n --- */
      { 110,41836,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x14\x53\x32\x20\xf7\x22\x42\x26\x24" }  },
      /* --- pixel bitmap for cmr180 char#111 o --- */
      { 111,42537,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x22\xd0\xc0\x03\x0f\x3c\xf0\xc0\x02\x11\x82"
            "\x07" }  },
      /* --- pixel bitmap for cmr180 char#112 p --- */
      { 112,43607,                      /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x14\x53\x32\x42\x52\x10\xf4\x22\x62\x22\x52\x33"
            "\x32\x42\x14\x30\xf3\x22\x86\x62" }  },
      /* --- pixel bitmap for cmr180 char#113 q --- */
      { 113,44617,                      /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x21\x42\x33\x32\x52\x2f\x42\x62\x20\x12\x52\x42"
            "\x33\x54\x12\x20\xf3\x82\x20\x66" }  },
      /* --- pixel bitmap for cmr180 char#114 r --- */
      { 114,45482,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x13\x33\x22\x23\x40\xf6\x22\x56\x30" }  },
      /* --- pixel bitmap for cmr180 char#115 s --- */
      { 115,46417,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x82\x83\x03\x3e\x7c\xe0\xc1\xc1\x43\x3d" }  },
      /* --- pixel bitmap for cmr180 char#116 t --- */
      { 116,47244,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   15, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\x40\x32\x63\x48\x10\xf4\x32\x40\xf3\x32\x31"
            "\x44\x14" }  },
      /* --- pixel bitmap for cmr180 char#117 u --- */
      { 117,48171,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x24\x20\xf7\x22\x42\x20\x22\x33\x54\x14" }  },
      /* --- pixel bitmap for cmr180 char#118 v --- */
      { 118,49041,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x77\x18\x43\x18\xc2\x19\x4c\x60\x02\x0e\x70\x80"
            "\x03\x08\x00" }  },
      /* --- pixel bitmap for cmr180 char#119 w --- */
      { 119,50292,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\xf7\x86\x63\x8e\x63\x8c\x23\x4c\x22\x4c\x36\x58"
            "\x16\x38\x14\x38\x1c\x30\x0c\x10\x08" }  },
      /* --- pixel bitmap for cmr180 char#120 x --- */
      { 120,51271,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\x0f\x63\x60\x04\x58\x00\x0e\x80\x01\x38\x80\x0c"
            "\x18\x83\x61\x7c\x7e" }  },
      /* --- pixel bitmap for cmr180 char#121 y --- */
      { 121,52338,                      /* character number, location */
         11, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 12,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\xcf\x61\x18\x82\x21\x38\x03\x13\x30\x01\x0e\xe0"
            "\x00\x0e\x40\x00\x04\x20\x30\x02\x13\xe0\x00" }  },
      /* --- pixel bitmap for cmr180 char#122 z --- */
      { 122,53303,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x87\x05\x0b\x03\x03\x07\x46\x86\x06\x0d\xff\x07" }  },
      /* --- pixel bitmap for cmr180 char#123 (noname) --- */
      { 123,120172,                     /* character number, location */
          7, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          { 12,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c" }  },
      /* --- pixel bitmap for cmr180 char#124 (noname) --- */
      { 124,120992,                     /* character number, location */
          7, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          { 25,    1, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0b" }  },
      /* --- pixel bitmap for cmr180 char#125 (noname) --- */
      { 125,108982,                     /* character number, location */
         17, 3,   13, 3,      /* topleft row,col, and botleft row,col */
          {  7,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xf3\x2c\x02" }  },
      /* --- pixel bitmap for cmr180 char#126 \~ --- */
      { 126,109666,                     /* character number, location */
         17, 2,   14, 2,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x7e\x31" }  },
      /* --- pixel bitmap for cmr180 char#127 (noname) --- */
      { 127,110347,                     /* character number, location */
         18, 2,   15, 2,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xe7\x66" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=6 for .210gf ---
 * mf '\mode=preview; mag=magstep(-13.80488502080647873125); input cmr10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmr210 --- */
static	chardef  cmr210[] =
   {
      /* --- pixel bitmap for cmr210 char#0 \Gamma --- */
      {   0,54819,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x43\x73\x10\xf1\x33\x91\x10\xf2\x33\xa1\xfb"
            "\x33\xba\x71" }  },
      /* --- pixel bitmap for cmr210 char#1 \Delta --- */
      {   1,55738,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   21, 3,84, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xa2\xa0\xf1\x94\x90\x81\x14\xe0\x21\x23\xe0\x11"
            "\x34\xe1\x43\xd1\x54\xc1\x63\xb1\x74\xa1\x83\x91\x94"
            "\x81\xa3\x71\xb4\x61\xc3\x52\xc4\x41\xe3\x20\xf1\x1e"
            "\x06\x1e\x08" }  },
      /* --- pixel bitmap for cmr210 char#2 \Theta --- */
      {   2,56889,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\xc2\x52\x83\x73\x62\x92\x52\xb2\x20\xf1\x13\xb3"
            "\x10\x12\xd2\x13\x31\x51\x33\x0f\x23\x37\x33\x03\x31"
            "\x51\x33\x0f\x13\xd3\xf1\x13\xb3\x10\x22\xb2\x52\x92"
            "\x63\x73\x82\x52\xc5\x73" }  },
      /* --- pixel bitmap for cmr210 char#3 \Lambda --- */
      {   3,57875,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   21, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x82\x80\xf2\x74\x70\x66\x60\xf2\x61\x23\x60\xf2"
            "\x51\x43\x50\xf2\x41\x63\x40\x31\x74\x30\xf1\x31\x83"
            "\x30\x22\x84\x26\x48" }  },
      /* --- pixel bitmap for cmr210 char#4 \Xi --- */
      {   4,59266,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x03\x0f\x21\xe0\x11\xf2\xe0\x30\x31\x91\x30"
            "\xf1\x3b\x30\x31\x91\x30\xf2\xe0\x3f\x21\xe0\x11\x0f"
            "\x1e\x03" }  },
      /* --- pixel bitmap for cmr210 char#5 \Pi --- */
      {   5,60431,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x06\xfe\x33\x83\x30\xf2\x33\x83\x39\x29" }  },
      /* --- pixel bitmap for cmr210 char#6 \Sigma --- */
      {   6,61578,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x23\x93\x24\x92\x33\xa1\x43\xa1\x34\x91\x44"
            "\x81\x53\xe4\xe4\xe2\xe0\x11\xe0\x21\x81\x61\x91\x51"
            "\xa1\x41\xa2\x31\xb1\x31\xa3\x2e\x01\x1e\x02\x12" }  },
      /* --- pixel bitmap for cmr210 char#7 \Upsilon --- */
      {   7,62692,                      /* character number, location */
         21, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   21, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x74\x36\x56\x13\x23\x33\x24\x52\x32\x52\x62\x12"
            "\x61\x72\x12\xe0\x11\x11\x80\xfc\x83\x80\x4b\x41" }  },
      /* --- pixel bitmap for cmr210 char#8 \Phi --- */
      {   8,63750,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x30\xf2\x73\x70\x57\x83\x13\x13\x52\x33\x32\x32"
            "\x43\x42\x1f\x33\x43\x43\x12\x43\x42\x32\x33\x32\x53"
            "\x13\x13\x87\x50\xf2\x73\x70\x3b\x31" }  },
      /* --- pixel bitmap for cmr210 char#9 \Psi --- */
      {   9,64893,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4b\x40\xf2\x83\x83\x53\x53\xf5\x13\x43\x43\x10\x22"
            "\x43\x42\x43\x33\x33\x53\x23\x23\x73\x13\x13\xa7\x60"
            "\xf2\x83\x80\x4b\x42" }  },
      /* --- pixel bitmap for cmr210 char#10 \Omega --- */
      {  10,66078,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   21, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\xc2\x52\x83\x73\x30\xf1\x23\x93\x20\xf4\x13\xb3"
            "\x10\x22\xb2\x43\x93\x20\xf1\x32\x92\x30\x42\x72\x41"
            "\x32\x72\x32\x41\x71\x43\x32\x52\x32\xf2\x16\x56\x12" }  },
      /* --- pixel bitmap for cmr210 char#11 \ff --- */
      {  11,112755,                     /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x34\x62\x43\x23\x41\x53\x33\x32\x62\x41\x10\xf2"
            "\x32\x62\x6e\x02\x30\xfa\x32\x62\x60\x16\x27\x32" }  },
      /* --- pixel bitmap for cmr210 char#12 \fi --- */
      {  12,113951,                     /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x92\x41\x71\x53\x52\x53\x20\xf2\x32\xad\x20\xfa"
            "\x32\x62\x20\x16\x26" }  },
      /* --- pixel bitmap for cmr210 char#13 \fl --- */
      {  13,115133,                     /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\x63\x33\x61\x53\x20\xf3\x32\x62\x2d\x20\xfa\x32"
            "\x62\x20\x16\x26" }  },
      /* --- pixel bitmap for cmr210 char#14 \ffi --- */
      {  14,116766,                     /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x35\x83\x41\x12\x41\x71\x53\x53\x52\x53\x53\x20"
            "\xf2\x32\x62\xae\x07\x20\xfa\x32\x62\x62\x20\x16\x26"
            "\x26" }  },
      /* --- pixel bitmap for cmr210 char#15 \ffl --- */
      {  15,118433,                     /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x37\x63\x44\x33\x61\x53\x53\x52\x53\x62\x20\xf2"
            "\x32\x62\x62\x2e\x07\x20\xfa\x32\x62\x62\x20\x16\x26"
            "\x26" }  },
      /* --- pixel bitmap for cmr210 char#16 \imath --- */
      {  16,80265,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x20\xfa\x22\x26" }  },
      /* --- pixel bitmap for cmr210 char#17 \jmath --- */
      {  17,80943,                      /* character number, location */
         13,-2,   -6,-2,      /* topleft row,col, and botleft row,col */
          {  8,   19, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\xfd\x62\x11\x45\x31\x13\x22\x25\x22" }  },
      /* --- pixel bitmap for cmr210 char#18 \gravesym --- */
      {  18,103978,                     /* character number, location */
         20, 3,   15, 3,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc3\xe1\x60\x20" }  },
      /* --- pixel bitmap for cmr210 char#19 \acutesym --- */
      {  19,104551,                     /* character number, location */
         20, 6,   15, 6,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\xce\x19\x01" }  },
      /* --- pixel bitmap for cmr210 char#20 \checksym --- */
      {  20,105180,                     /* character number, location */
         18, 4,   15, 4,      /* topleft row,col, and botleft row,col */
          {  7,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x1f\x02" }  },
      /* --- pixel bitmap for cmr210 char#21 \brevesym --- */
      {  21,105798,                     /* character number, location */
         20, 3,   16, 3,      /* topleft row,col, and botleft row,col */
          {  9,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x03\x1a\xe3\x03" }  },
      /* --- pixel bitmap for cmr210 char#22 (noname) --- */
      {  22,106382,                     /* character number, location */
         17, 2,   16, 2,      /* topleft row,col, and botleft row,col */
          { 11,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b" }  },
      /* --- pixel bitmap for cmr210 char#23 (noname) --- */
      {  23,107159,                     /* character number, location */
         21, 8,   16, 8,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\x1e" }  },
      /* --- pixel bitmap for cmr210 char#24 (noname) --- */
      {  24,107855,                     /* character number, location */
         -1, 4,   -6, 4,      /* topleft row,col, and botleft row,col */
          {  7,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x18\x18\xfc\x03" }  },
      /* --- pixel bitmap for cmr210 char#25 \ss --- */
      {  25,82040,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\xc3\x30\x30\x06\xc6\xc0\x18\x08\x83\x78\x0e"
            "\x0c\x83\xc1\x30\x30\x06\xc4\x80\x19\x30\x03\x66\xc0"
            "\x0c\x98\x99\x31\x93\xc7\x01" }  },
      /* --- pixel bitmap for cmr210 char#26 \ae --- */
      {  26,83405,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xf0\x70\xd8\x98\x83\x83\x08\x0c\x0c\x60\x60\xf0"
            "\xff\x73\x18\xc0\xc0\x00\x03\x06\x18\x70\xc0\x80\x03"
            "\x0d\x36\xc4\x0f\x1e" }  },
      /* --- pixel bitmap for cmr210 char#27 \oe --- */
      {  27,84543,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   13, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x64\x52\x42\x22\x42\x22\x64\x52\x21\x83\x64\x82"
            "\x74\x8b\x0f\x22\x82\x90\x12\x64\x92\x64\x71\x22\x42"
            "\x22\x51\x54\x65\x26" }  },
      /* --- pixel bitmap for cmr210 char#28 (noname) --- */
      {  28,85377,                      /* character number, location */
         15, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x80\xc1\x17\x06\x63\xe0\x04\xd2\x60\x1e\xc4"
            "\x43\x78\x08\x8f\x60\x19\x64\xc1\x18\x0c\x7e\x20\x00"
            "\x06\x40\x00\x00" }  },
      /* --- pixel bitmap for cmr210 char#29 \AE --- */
      {  29,87177,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 24,   20, 3,113, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x6e\x02\xb1\x13\x62\xa2\x13\x71\xa1\x23\x71\xa1\x23"
            "\x81\x10\xf1\x71\x33\x81\x10\x71\x33\x51\xa1\x43\x51"
            "\xa1\x43\x42\xae\x91\x53\x42\x40\xf1\x51\x53\x51\x31"
            "\x41\x63\x91\x41\x63\x82\x32\x63\x81\x41\x73\x81\x33"
            "\x63\x63\x16\x3e\x15" }  },
      /* --- pixel bitmap for cmr210 char#30 \OE --- */
      {  30,88905,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 26,   22, 3,119, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x75\xe0\x52\x4d\x53\x64\x62\x52\x74\x71\x42\x84\x71"
            "\x20\xf1\x13\x84\x81\x13\x94\x51\x21\x13\xa3\x51\x43"
            "\xa3\x42\x43\xa9\x43\xa3\x42\x43\xa3\x51\x43\xa3\x51"
            "\x34\x94\x91\x13\x84\x91\x13\x84\x82\xf1\x23\x74\x81"
            "\x10\x33\x64\x63\x62\x4e\x85\xe0" }  },
      /* --- pixel bitmap for cmr210 char#31 (noname) --- */
      {  31,89923,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x0f\x01\x83\x05\x0e\x38\x30\x80\xc1\x00\x1a\x07"
            "\xd8\x19\x40\xcc\x00\x61\x07\x0c\x3f\x20\xf8\x81\xc0"
            "\x0f\x04\x7e\x10\xf0\xc3\x80\x1f\x02\xdc\x08\x60\x6e"
            "\x80\x63\x01\x0c\x06\x30\x70\xc0\x81\x06\x03\xc2\x07"
            "\x00" }  },
      /* --- pixel bitmap for cmr210 char#32 (noname) --- */
      {  32,108355,                     /* character number, location */
         12, 1,    8, 1,      /* topleft row,col, and botleft row,col */
          {  6,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x7e\x04" }  },
      /* --- pixel bitmap for cmr210 char#33 ! --- */
      {  33,90616,                      /* character number, location */
         21, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          {  3,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\xff\xff\x92\x24\x01\x80\x2e" }  },
      /* --- pixel bitmap for cmr210 char#34 " --- */
      {  34,119412,                     /* character number, location */
         20, 1,   11, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\x8e\x1b\x26\x48\x90\xa0\x20\x41\x41\x00" }  },
      /* --- pixel bitmap for cmr210 char#35 # --- */
      {  35,92096,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 20,   26, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x92\x42\x30\x83\x33\x30\xf2\x82\x42\x40\x73\x33"
            "\xb2\x42\x5f\x1e\x06\xf3\x62\x42\x6f\x1e\x06\x52\x42"
            "\xb3\x33\x70\xf2\x42\x42\x80\x33\x33\x80\xf2\x32\x42"
            "\x92" }  },
      /* --- pixel bitmap for cmr210 char#36 $ --- */
      {  36,76445,                      /* character number, location */
         22, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 11,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x00\x01\x3e\x58\x62\xa2\x11\x8e\x7c\xe4\x27\x7a"
            "\x81\x1f\xf8\x83\x3f\xd0\x81\x5c\xc4\x27\x1e\x71\x88"
            "\x44\x46\x1a\x7c\x80\x00\x04" }  },
      /* --- pixel bitmap for cmr210 char#37 % --- */
      {  37,93357,                      /* character number, location */
         22, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 20,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x00\x43\x04\x38\xc6\xc0\x31\xf8\x1f\x83\xe0\x30"
            "\x08\x06\x83\x70\x30\x08\x03\x83\x38\x60\xc4\x01\x44"
            "\x0c\x80\xe3\x00\x00\x87\x03\x30\x44\x80\x63\x04\x1c"
            "\x83\xc0\x30\x08\x0e\x83\x60\x30\x08\x07\x83\x38\x30"
            "\x88\x01\x46\x1c\x40\xc4\x00\x38" }  },
      /* --- pixel bitmap for cmr210 char#38 & --- */
      {  38,77747,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 21,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x01\x00\x4c\x00\x80\x10\x00\x18\x02\x00\x43\x00"
            "\x60\x08\x00\x8c\x00\x80\x09\x00\xb0\xc0\x1f\x1c\xe0"
            "\x80\x01\x0c\x78\x80\x80\x0c\x08\x88\x03\x81\x61\x10"
            "\x10\x18\x01\x03\x27\x60\xc0\x02\x0d\x30\x20\x03\x0e"
            "\xc4\x30\x43\xf0\x81\x07" }  },
      /* --- pixel bitmap for cmr210 char#39 ' --- */
      {  39,94051,                      /* character number, location */
         20, 3,   11, 3,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x49\x4a\x01" }  },
      /* --- pixel bitmap for cmr210 char#40 ( --- */
      {  40,94631,                      /* character number, location */
         22, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  7,   30, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x51\x51\x52\x51\x52\x51\x52\x40\xf1\x11\x5f\x92"
            "\x50\xf1\x11\x50\x12\x61\x62\x61\x62\x61\x71\x71" }  },
      /* --- pixel bitmap for cmr210 char#41 ) --- */
      {  41,95254,                      /* character number, location */
         22, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  7,   30, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x71\x71\x62\x61\x62\x61\x62\x10\xf1\x51\x10\xf9"
            "\x52\xf1\x51\x10\x42\x51\x52\x51\x52\x51\x51\x51\x62" }  },
      /* --- pixel bitmap for cmr210 char#42 * --- */
      {  42,95901,                      /* character number, location */
         22, 2,    9, 2,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x00\x01\x08\x46\xfc\x7a\xfe\xc0\x81\x3f\xaf\x1f"
            "\x31\x08\x40\x00\x02" }  },
      /* --- pixel bitmap for cmr210 char#43 + --- */
      {  43,96599,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x92\x8f\x1e\x05\xf8\x92\x87" }  },
      /* --- pixel bitmap for cmr210 char#44 (noname) --- */
      {  44,97194,                      /* character number, location */
          3, 3,   -6, 3,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x49\x4a\x01" }  },
      /* --- pixel bitmap for cmr210 char#45 (noname) --- */
      {  45,119927,                     /* character number, location */
          7, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  8,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff" }  },
      /* --- pixel bitmap for cmr210 char#46 (noname) --- */
      {  46,97665,                      /* character number, location */
          3, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00" }  },
      /* --- pixel bitmap for cmr210 char#47 / --- */
      {  47,98173,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 11,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x30\xc0\x01\x06\x30\xc0\x01\x06\x30\xc0\x01"
            "\x06\x30\xc0\x01\x06\x30\xc0\x01\x06\x30\xc0\x01\x06"
            "\x30\xc0\x01\x06\x30\xc0\x01\x06\x30\xc0\x01\x06\x30"
            "\x00" }  },
      /* --- pixel bitmap for cmr210 char#48 0 --- */
      {  48,66830,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x72\x32\x51\x71\x32\x72\x21\x91\x1f\xa2\x92\x11"
            "\x91\x22\x72\x31\x71\x52\x32\x75\x42" }  },
      /* --- pixel bitmap for cmr210 char#49 1 --- */
      {  49,67632,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 10,   20, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x73\x43\x12\x40\xfe\x42\x40\x42\x4a" }  },
      /* --- pixel bitmap for cmr210 char#50 2 --- */
      {  50,68615,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   20, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x43\x31\x82\x13\x72\x14\x67\x72\x12\x82\xf1"
            "\xa3\xa2\xa2\xa2\xa2\xa2\xa2\xa2\x61\x31\x81\x21\x81"
            "\x2b\x1c\x12" }  },
      /* --- pixel bitmap for cmr210 char#51 3 --- */
      {  51,69663,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x71\x43\x41\x62\x20\xf2\x13\x53\x10\xf1\x92\x20"
            "\x82\x75\xc3\xb3\xb2\xb3\x12\x73\x0f\x14\x63\x03\x72"
            "\x21\x73\x32\x43\x65\x43" }  },
      /* --- pixel bitmap for cmr210 char#52 4 --- */
      {  52,70605,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   20, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x82\x30\x73\x94\x91\x12\x81\x22\x72\x22\x71\x32"
            "\x61\x42\x52\x42\x51\x52\x41\x62\x32\x62\x3d\xf4\x82"
            "\x30\x58" }  },
      /* --- pixel bitmap for cmr210 char#53 5 --- */
      {  53,71653,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x52\x48\x57\x61\x21\x70\xf2\x21\xa0\x21\x24\x61"
            "\x11\x42\x42\x52\x41\x72\x10\xf2\xa3\x0f\x23\x73\x11"
            "\x82\x21\x72\x42\x42\x75\x42" }  },
      /* --- pixel bitmap for cmr210 char#54 6 --- */
      {  54,72567,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x72\x41\x52\x43\x32\x53\x31\xb2\xb1\xb2\x34\x42"
            "\x12\x41\x33\x71\x23\x72\x1f\x32\x92\x11\x92\x12\x82"
            "\x12\x72\x31\x71\x52\x41\x75\x42" }  },
      /* --- pixel bitmap for cmr210 char#55 7 --- */
      {  55,73491,                      /* character number, location */
         20, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xcc\x1b\x21\x91\x11\x91\x21\x81\x30\xf1\x81\x40"
            "\x71\x50\xf1\x61\x60\xf1\x52\x60\xf2\x42\x70\xf3\x33"
            "\x70\x41\x81" }  },
      /* --- pixel bitmap for cmr210 char#56 8 --- */
      {  56,74419,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x61\x10\x18\x03\x66\xc0\x0c\x98\x03\xe3\x31"
            "\x7c\x03\x3f\xc0\x0f\xc6\x63\xf0\x04\xf8\x00\x1e\xc0"
            "\x03\x78\x00\x19\x30\x06\x03\x1f\x00" }  },
      /* --- pixel bitmap for cmr210 char#57 9 --- */
      {  57,75341,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x10\x03\x36\xc0\x06\xd0\x00\x1e\xc0"
            "\x03\x78\x00\x1b\x70\x02\x8e\xb0\xe1\x31\x00\x02\x60"
            "\x00\xcc\xc1\x38\x08\xc2\x80\x0f\x00" }  },
      /* --- pixel bitmap for cmr210 char#58 : --- */
      {  58,98777,                      /* character number, location */
         13, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00\x00\x80\x2e" }  },
      /* --- pixel bitmap for cmr210 char#59 ; --- */
      {  59,99444,                      /* character number, location */
         13, 3,   -6, 3,      /* topleft row,col, and botleft row,col */
          {  3,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00\x00\x80\x6e\x92\x52\x00" }  },
      /* --- pixel bitmap for cmr210 char#60 (noname) --- */
      {  60,91238,                      /* character number, location */
         15, 3,   -7, 3,      /* topleft row,col, and botleft row,col */
          {  3,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00\x40\x92\x24\xfd\xff\x7f\x01" }  },
      /* --- pixel bitmap for cmr210 char#61 = --- */
      {  61,100128,                     /* character number, location */
         11, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 19,    8, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x05\xf3\xe0\x5f\x1e\x05" }  },
      /* --- pixel bitmap for cmr210 char#62 (noname) --- */
      {  62,79646,                      /* character number, location */
         15, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 10,   21, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x83\x81\x50\xf3\xa0\xf3\x41\x50\x32\x81\x82\x72"
            "\x72\x8f\x12\x53\x02\x62\x12\x42\x35\x33" }  },
      /* --- pixel bitmap for cmr210 char#63 ? --- */
      {  63,78724,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 10,   20, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x26\x31\x52\x12\x62\x0f\x13\x52\x72\x72\x72\x81\x40"
            "\xf3\x41\x50\xf3\xa0\x41\x83\x81\x53" }  },
      /* --- pixel bitmap for cmr210 char#64 @ --- */
      {  64,101302,                     /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x0f\x00\x83\x01\x06\x30\x08\x00\x42\x78\x10\x61"
            "\x0c\x89\xc1\x29\x04\x8c\x31\x60\x8c\x01\x63\x0c\x18"
            "\x63\xc0\x18\x02\x46\x31\x38\x0a\xe3\x89\xf0\x38\x04"
            "\x00\xc0\x00\x00\x18\xe0\x01\xff\x01" }  },
      /* --- pixel bitmap for cmr210 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   21, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x92\x90\xf2\x84\x80\xf2\x71\x23\x70\xf2\x61\x43"
            "\x60\xf1\x51\x63\x50\x5a\x50\xf2\x41\x83\x40\x31\xa3"
            "\x53\x93\x37\x49" }  },
      /* --- pixel bitmap for cmr210 char#66 B --- */
      {  66, 2344,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   20, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x73\x72\x63\x73\x20\xf3\x33\x83\x10\x33\x73\x53"
            "\x63\x6b\x73\x73\x53\x83\x10\xf4\x33\x93\x33\x83\x43"
            "\x73\x2e\x47" }  },
      /* --- pixel bitmap for cmr210 char#67 C --- */
      {  67, 3289,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 17,   22, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x41\x52\x52\x12\x42\x83\x32\xa2\x22\xb2\xf1\x13"
            "\xc1\x12\xd1\x0f\x53\xe0\x12\xd1\xf1\x13\xc1\x22\xb1"
            "\x42\xa1\x52\x81\x72\x52\xa5\x50" }  },
      /* --- pixel bitmap for cmr210 char#68 D --- */
      {  68, 4395,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x93\x73\x73\x92\x63\xa2\x53\xa3\x10\xf1\x33\xb2"
            "\x10\xf6\x33\xb3\x33\xb2\x43\xa3\x43\xa2\x53\x92\x63"
            "\x73\x4e\x62" }  },
      /* --- pixel bitmap for cmr210 char#69 E --- */
      {  69, 5808,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\x53\x83\x20\xf1\x33\xa1\x20\xf1\x33\xb1\x10"
            "\x33\x61\x41\x43\x61\x93\x52\x9a\x93\x52\x93\x61\x93"
            "\x61\x51\xf1\x33\xc1\x33\xb2\x33\xb1\x43\xa2\x43\x93"
            "\x1e\x04\x10" }  },
      /* --- pixel bitmap for cmr210 char#70 F --- */
      {  70, 7055,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   20, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\x43\x83\x10\xf1\x33\xa1\x10\xf1\x33\xb1\x33"
            "\x61\x41\x33\x61\x83\x52\x8a\x83\x52\x50\xf1\x33\x61"
            "\x50\xf5\x33\xca\x81" }  },
      /* --- pixel bitmap for cmr210 char#71 G --- */
      {  71, 8236,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 20,   22, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\x41\x73\x52\x12\x62\x93\x52\xa3\x42\xc2\x20\xf1"
            "\x13\xd1\x20\x12\xe1\x2f\x33\xe0\x33\x8c\xc3\x32\xc3"
            "\x20\xf1\x13\xb3\x20\x22\xb3\x52\xa3\x62\x81\x12\x73"
            "\x51\x31\x96\x70" }  },
      /* --- pixel bitmap for cmr210 char#72 H --- */
      {  72, 9431,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x29\xf7\x33\x83\x30\x3e\x30\xf8\x33\x83\x39\x29" }  },
      /* --- pixel bitmap for cmr210 char#73 I --- */
      {  73,10122,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   20, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xfe\x33\x30\xf2\x33\x39" }  },
      /* --- pixel bitmap for cmr210 char#74 J --- */
      {  74,10930,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\xfd\x83\x20\x12\x53\x2f\x14\x43\x20\x12\x43\x42"
            "\x42\x74\x60" }  },
      /* --- pixel bitmap for cmr210 char#75 K --- */
      {  75,12093,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,82, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x47\x43\x93\x63\x91\x83\x81\x93\x71\xa3\x61\xb3"
            "\x51\xc3\x41\xd3\x33\xc3\x24\xc3\x11\x23\xb4\x34\xa3"
            "\x53\xa3\x63\x93\x64\x83\x73\x83\x83\x73\x84\x63\x94"
            "\x29\x48" }  },
      /* --- pixel bitmap for cmr210 char#76 L --- */
      {  76,13060,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x70\xfa\x33\xb0\xf2\x33\xa1\x33\x92\x33\x91\x43"
            "\x82\x43\x73\x1e\x02\x13" }  },
      /* --- pixel bitmap for cmr210 char#77 M --- */
      {  77,14348,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   20, 3,94, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xb7\xf1\x34\xb4\x30\xf1\x31\x13\x91\x13\x30\xf2"
            "\x31\x23\x71\x23\x30\xf2\x31\x33\x51\x33\x30\xf1\x31"
            "\x43\x31\x43\x30\xf2\x31\x53\x11\x53\x30\xf1\x31\x63"
            "\x63\x30\x23\x53\x63\x37\x41\x49" }  },
      /* --- pixel bitmap for cmr210 char#78 N --- */
      {  78,15518,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\xe0\x8f\x07\x38\x78\x00\x81\x0e\x10\xc8\x01\x81"
            "\x3c\x10\x88\x03\x81\x70\x10\x08\x0f\x81\xe0\x10\x08"
            "\x1c\x81\x80\x13\x08\x38\x81\x00\x17\x08\xe0\x81\x00"
            "\x1e\x08\xc0\x81\x00\x18\x1c\x80\xf1\x07\x10" }  },
      /* --- pixel bitmap for cmr210 char#79 O --- */
      {  79,16407,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\xc2\x52\x83\x73\x62\x92\x52\xb2\x33\xb3\x10\xf1"
            "\x12\xd2\x1f\x63\xd3\xf1\x13\xb3\x10\x22\xb2\x52\x92"
            "\x63\x73\x82\x52\xc5\x71" }  },
      /* --- pixel bitmap for cmr210 char#80 P --- */
      {  80,17542,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   20, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x73\x73\x53\x83\x10\xf4\x33\x93\x33\x83\x43\x73"
            "\x5b\x40\xf7\x33\xc9\x91" }  },
      /* --- pixel bitmap for cmr210 char#81 Q --- */
      {  81,18575,                      /* character number, location */
         21, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   27, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\xc2\x52\x83\x73\x62\x92\x52\xb2\x20\xf1\x13\xb3"
            "\x10\x12\xd2\x1f\x63\xd3\xf1\x13\xb3\x10\x22\x43\x42"
            "\x52\x21\x31\x22\x63\x11\x35\x83\x42\x41\x76\x51\xc2"
            "\x41\xc2\x32\xf1\xd5\x10\xe3\x21" }  },
      /* --- pixel bitmap for cmr210 char#82 R --- */
      {  82,19906,                      /* character number, location */
         20, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 21,   21, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\xb3\x63\x93\x73\x50\xf3\x33\x83\x40\x33\x73\x83"
            "\x63\x9a\xb3\x62\xa3\x63\x60\xf3\x33\x73\x50\xf1\x33"
            "\x73\x41\x33\x82\x4a\x53\x21\xe0\x33\x21" }  },
      /* --- pixel bitmap for cmr210 char#83 S --- */
      {  83,20979,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 12,   22, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\x31\x21\x51\x12\x12\x63\x11\x82\x0f\x22\x91\x03"
            "\xa3\x97\x68\x58\x84\xa3\xa2\x0f\x21\x92\x02\x81\x12"
            "\x72\x14\x42\x21\x35\x33" }  },
      /* --- pixel bitmap for cmr210 char#84 T --- */
      {  84,22085,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x03\x22\x53\x52\x10\xf1\x11\x63\x61\x1f\x21\x73"
            "\x71\xfb\x83\x80\x4b\x43" }  },
      /* --- pixel bitmap for cmr210 char#85 U --- */
      {  85,23085,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 20,   21, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x47\x33\x93\x20\xfd\x33\xa1\x30\x42\x91\x83\x81"
            "\x92\x71\xb3\x41\xe5\x73" }  },
      /* --- pixel bitmap for cmr210 char#86 V --- */
      {  86,24097,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 20,   21, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x66\x24\xa2\x20\xf1\x33\xa1\x30\x34\x91\x30\xf1"
            "\x43\x81\x40\xf2\x53\x61\x50\xf2\x63\x41\x60\xf1\x73"
            "\x21\x70\x76\x70\xf1\x84\x80\xf2\x92\x91" }  },
      /* --- pixel bitmap for cmr210 char#87 W --- */
      {  87,25529,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 28,   21, 3,119, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x08\x29\x36\x23\x83\x82\x43\x83\x91\x20\xf2\x33\x74"
            "\x71\x30\x43\x64\x61\x40\xf1\x43\x51\x23\x51\x40\x53"
            "\x41\x23\x41\x50\xf1\x53\x31\x43\x31\x50\x54\x21\x43"
            "\x31\x50\xf2\x63\x11\x63\x11\x60\x74\x64\x70\xf1\x73"
            "\x83\x70\x82\x82\xe0\x21\xa1\x80" }  },
      /* --- pixel bitmap for cmr210 char#88 X --- */
      {  88,26680,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,78, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x28\x44\x63\x83\x71\x94\x51\xb3\x42\xc3\x31\xd4"
            "\x11\xe0\x15\xe0\x23\x90\xf1\x84\x80\x85\xe1\x23\xd2"
            "\x33\xc1\x44\xa1\x63\xa1\x73\x81\x84\x63\x74\x37\x58" }  },
      /* --- pixel bitmap for cmr210 char#89 Y --- */
      {  89,27838,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x67\x34\xa2\x73\xa1\x93\x82\x94\x71\xb3\x62\xc3"
            "\x51\xd4\x31\xe0\x13\x31\xe0\x14\x11\xe0\x35\x80\xf7"
            "\xa3\x90\x79\x61" }  },
      /* --- pixel bitmap for cmr210 char#90 Z --- */
      {  90,28891,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,68, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x14\x64\x12\x83\x22\x73\x31\x83\x3f\x11\x73\x40"
            "\x73\x50\xf1\x63\x60\xf1\x53\x70\x43\x71\xf1\x33\x81"
            "\x23\x91\x23\x82\x13\x96\x7e\x05" }  },
      /* --- pixel bitmap for cmr210 char#91 [ --- */
      {  91,102065,                     /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  6,   29, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x06\x0f\xe2\x4f\x92\x4f\x16" }  },
      /* --- pixel bitmap for cmr210 char#92 (noname) --- */
      {  92,120796,                     /* character number, location */
         20, 5,   11, 5,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x05\x09\x0a\x12\x24\xc8\xb0\xe3\x82\x00" }  },
      /* --- pixel bitmap for cmr210 char#93 ] --- */
      {  93,102771,                     /* character number, location */
         22, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          {  6,   29, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x06\xfe\x42\xf9\x42\x0f\x16" }  },
      /* --- pixel bitmap for cmr210 char#94 \^ --- */
      {  94,108984,                     /* character number, location */
         20, 4,   16, 4,      /* topleft row,col, and botleft row,col */
          {  7,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x8a\x28\x08" }  },
      /* --- pixel bitmap for cmr210 char#95 (noname) --- */
      {  95,109455,                     /* character number, location */
         20, 2,   17, 2,      /* topleft row,col, and botleft row,col */
          {  4,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x06" }  },
      /* --- pixel bitmap for cmr210 char#96 (noname) --- */
      {  96,103397,                     /* character number, location */
         20, 3,   11, 3,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x94\x92\xec\x02" }  },
      /* --- pixel bitmap for cmr210 char#97 a --- */
      {  97,30049,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x80\xc3\xe0\x60\x10\x18\x00\x06\xf8\xc1\x61\x18"
            "\x18\x03\xc6\x80\x39\x60\x1a\x9c\xfc\x1c" }  },
      /* --- pixel bitmap for cmr210 char#98 b --- */
      {  98,31067,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   20, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xa0\xf5\x22\xa0\x22\x24\x64\x42\x43\x62\x32\x72"
            "\x10\xf4\x22\x82\x22\x72\x33\x61\x44\x41\x51\x34\x41" }  },
      /* --- pixel bitmap for cmr210 char#99 c --- */
      {  99,31858,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   13, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x32\x43\x12\x53\x12\x61\x1f\x42\x90\x12\x92\x71"
            "\x22\x51\x55\x22" }  },
      /* --- pixel bitmap for cmr210 char#100 d --- */
      { 100,32861,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   20, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x20\xf5\xa2\x20\x44\x22\x51\x44\x41\x72\x32\x72"
            "\x2f\x42\x82\x20\x12\x72\x32\x63\x42\x41\x12\x64\x24" }  },
      /* --- pixel bitmap for cmr210 char#101 e --- */
      { 101,33639,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x60\x88\x81\x04\x3c\xe0\xff\x0f\x60\x00\x03\x30"
            "\x80\x01\x19\x04\x1f" }  },
      /* --- pixel bitmap for cmr210 char#102 f --- */
      { 102,34470,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   20, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x52\x23\x32\x33\x32\x41\x10\xf2\x32\x68\x30\xfa"
            "\x32\x60\x17\x35" }  },
      /* --- pixel bitmap for cmr210 char#103 g --- */
      { 103,35717,                      /* character number, location */
         14, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 14,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x1c\x9c\xc8\x18\x13\x04\x06\x83\xc1\x60\x30\x10"
            "\x04\x8c\x01\x1d\x60\x00\x18\x00\xfc\x03\xff\x63\xc0"
            "\x0c\x60\x03\xd8\x00\x66\xc0\x30\x18\xf8\x03" }  },
      /* --- pixel bitmap for cmr210 char#104 h --- */
      { 104,36718,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   20, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xa0\xf5\x22\xa0\x22\x24\x62\x11\x32\x53\x52\x20"
            "\xf8\x22\x62\x26\x26" }  },
      /* --- pixel bitmap for cmr210 char#105 i --- */
      { 105,37451,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   20, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x43\x41\x30\xf3\x64\x20\xfa\x22\x26" }  },
      /* --- pixel bitmap for cmr210 char#106 j --- */
      { 106,38227,                      /* character number, location */
         20,-2,   -6,-2,      /* topleft row,col, and botleft row,col */
          {  8,   26, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x63\x61\x10\xf3\x80\x35\xfd\x62\x11\x45\x31\x13"
            "\x22\x25\x22" }  },
      /* --- pixel bitmap for cmr210 char#107 k --- */
      { 107,39333,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   20, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x90\xf5\x22\x90\x22\x45\x22\x52\x42\x51\x52\x41"
            "\x62\x22\x72\x12\x83\x12\x50\xf1\x22\x32\x40\x22\x42"
            "\x52\x43\x42\x53\x16\x25" }  },
      /* --- pixel bitmap for cmr210 char#108 l --- */
      { 108,39970,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   20, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x20\xfe\x22\x20\xf2\x22\x26" }  },
      /* --- pixel bitmap for cmr210 char#109 m --- */
      { 109,41289,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   13, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x24\x44\x62\x11\x32\x21\x32\x53\x53\x52\x20\xf8"
            "\x22\x62\x62\x26\x26\x26" }  },
      /* --- pixel bitmap for cmr210 char#110 n --- */
      { 110,42296,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x24\x62\x11\x32\x53\x52\x20\xf8\x22\x62\x26\x26" }  },
      /* --- pixel bitmap for cmr210 char#111 o --- */
      { 111,43007,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x52\x32\x72\x21\x91\x1f\x42\x92\xf1\x12\x72"
            "\x10\x22\x52\x65\x46" }  },
      /* --- pixel bitmap for cmr210 char#112 p --- */
      { 112,44085,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 14,   19, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x24\x64\x42\x43\x62\x32\x72\x10\xf4\x22\x82\x22"
            "\x72\x33\x61\x44\x32\x52\x24\x40\xf4\x22\xa6\x82" }  },
      /* --- pixel bitmap for cmr210 char#113 q --- */
      { 113,45105,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 14,   19, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x31\x52\x31\x12\x41\x63\x32\x72\x2f\x42\x82\x20"
            "\x12\x72\x32\x63\x42\x41\x12\x64\x22\x20\xf4\xa2\x20"
            "\x86" }  },
      /* --- pixel bitmap for cmr210 char#114 r --- */
      { 114,45984,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x14\x10\xf1\x23\x23\x22\x41\x10\xf7\x22\x67\x30" }  },
      /* --- pixel bitmap for cmr210 char#115 s --- */
      { 115,46927,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x84\x0d\x1a\x74\xc0\x07\x3f\xe0\x81\x03\x0f\x3e"
            "\x96\x07" }  },
      /* --- pixel bitmap for cmr210 char#116 t --- */
      { 116,47764,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   18, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x31\x40\x22\x53\x48\xf6\x22\x40\xf2\x22\x31\x31"
            "\x31\x43\x15" }  },
      /* --- pixel bitmap for cmr210 char#117 u --- */
      { 117,48697,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x44\x20\xf8\x22\x62\x20\x22\x53\x51\x44\x64\x24" }  },
      /* --- pixel bitmap for cmr210 char#118 v --- */
      { 118,49575,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x9e\x81\x31\x10\x06\x82\x21\x30\x04\x4c\x80\x09"
            "\x30\x01\x1c\x80\x03\x70\x00\x04\x00" }  },
      /* --- pixel bitmap for cmr210 char#119 w --- */
      { 119,50834,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x9f\x77\x30\x18\x43\x41\x18\x1a\xc2\xd0\x10\x4c"
            "\x44\x60\x62\x02\x13\x13\x70\x50\x80\x83\x03\x1c\x1c"
            "\xc0\x60\x00\x02\x02" }  },
      /* --- pixel bitmap for cmr210 char#120 x --- */
      { 120,51829,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   13, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x15\x35\x42\x52\x72\x41\x82\x31\xa2\x11\xc3\xd2\xc3"
            "\xb1\x22\x92\x32\x81\x43\x62\x52\x36\x36" }  },
      /* --- pixel bitmap for cmr210 char#121 y --- */
      { 121,52904,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x9e\x81\x31\x10\x06\x82\x21\x30\x04\x4c\x80\x09"
            "\x30\x01\x1c\x80\x03\x70\x00\x04\x80\x00\x08\x38\x01"
            "\x27\xe0\x02\x38\x00" }  },
      /* --- pixel bitmap for cmr210 char#122 z --- */
      { 122,53881,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f\x58\xe0\x02\x13\x0c\x30\xc0\x01\x86\x18\x64"
            "\xa0\x03\x0d\xfc\x7f" }  },
      /* --- pixel bitmap for cmr210 char#123 (noname) --- */
      { 123,121416,                     /* character number, location */
          9, 0,    8, 0,      /* topleft row,col, and botleft row,col */
          { 15,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x7f" }  },
      /* --- pixel bitmap for cmr210 char#124 (noname) --- */
      { 124,122236,                     /* character number, location */
          9, 0,    8, 0,      /* topleft row,col, and botleft row,col */
          { 29,    1, 2, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x1d" }  },
      /* --- pixel bitmap for cmr210 char#125 (noname) --- */
      { 125,110134,                     /* character number, location */
         20, 4,   15, 4,      /* topleft row,col, and botleft row,col */
          {  9,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x19\x1b\x1b\x13\x02" }  },
      /* --- pixel bitmap for cmr210 char#126 \~ --- */
      { 126,110822,                     /* character number, location */
         19, 2,   16, 2,      /* topleft row,col, and botleft row,col */
          { 11,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xf4\x5f\x70\x00" }  },
      /* --- pixel bitmap for cmr210 char#127 (noname) --- */
      { 127,111503,                     /* character number, location */
         20, 3,   17, 3,      /* topleft row,col, and botleft row,col */
          {  9,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\x8e\x0b\x02" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=7 for .250gf ---
 * mf '\mode=preview; mag=magstep(-12.84858895680446863032); input cmr10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmr250 --- */
static	chardef  cmr250[] =
   {
      /* --- pixel bitmap for cmr250 char#0 \Gamma --- */
      {   0,55643,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 21,   24, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x06\x53\xa3\x53\xb2\x53\xc1\x53\xc2\xf2\x43\xd1"
            "\xfe\x43\xec\x91" }  },
      /* --- pixel bitmap for cmr250 char#1 \Delta --- */
      {   1,56572,                      /* character number, location */
         25, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,114, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc1\xc0\xf1\xb3\xb0\xa5\xe0\x61\x13\xe0\x51\x24\xe0"
            "\x41\x33\xe0\x31\x44\xe0\x21\x53\xe0\x11\x64\xe1\x73"
            "\xd1\x84\xc1\x93\xb1\xa4\xa1\xb3\x91\xc4\x81\xd3\x71"
            "\xe4\x61\xe0\x13\x51\xe0\x24\x41\xe0\x33\x31\xe0\x44"
            "\x2e\x09\x1f\x1e\x0b" }  },
      /* --- pixel bitmap for cmr250 char#2 \Theta --- */
      {   2,57739,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   26, 3,113, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xe3\x53\xb3\x73\x93\x93\x73\xb3\x30\xf1\x23\xd3"
            "\x20\x14\xd4\x23\xe0\x13\x14\xe0\x18\x31\x71\x34\x0f"
            "\x24\x39\x34\x04\x31\x71\x34\x0f\x14\xe0\x14\x13\xe0"
            "\x13\x24\xd4\x10\xf1\x23\xd3\x20\x33\xb3\x73\x93\x93"
            "\x73\xb3\x53\xe7\x8b" }  },
      /* --- pixel bitmap for cmr250 char#3 \Lambda --- */
      {   3,58741,                      /* character number, location */
         25, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   25, 3,76, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xa2\xa0\xf2\x94\x90\x81\x14\x80\xf1\x81\x23\x80"
            "\x72\x24\x70\xf2\x71\x43\x70\xf2\x61\x63\x60\xf2\x51"
            "\x83\x50\xf2\x41\xa3\x40\x32\xa4\x54\x94\x37\x5a" }  },
      /* --- pixel bitmap for cmr250 char#4 \Xi --- */
      {   4,60150,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   24, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x1e\x05\x10\xf2\x11\xe0\x31\x10\xf3\xe0\x70\xf1"
            "\x41\xb1\x40\xf1\x4d\x40\xf1\x41\xb1\x40\xf3\xe0\x7f"
            "\x21\xe0\x51\x0f\x1e\x07" }  },
      /* --- pixel bitmap for cmr250 char#5 \Pi --- */
      {   5,61323,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0c\xfe\x43\xc3\x40\xf6\x43\xc3\x4b\x4b" }  },
      /* --- pixel bitmap for cmr250 char#6 \Sigma --- */
      {   6,62486,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 21,   24, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x06\x23\xc4\x24\xd2\x33\xe1\x43\xd2\x34\xd1\x43"
            "\xd1\x53\xc1\x54\xe0\x43\xe0\x53\xe0\x44\xe0\x43\xe0"
            "\x51\xe0\x51\xe0\x51\xc1\x61\xd1\x51\xe1\x41\xe2\x41"
            "\xe1\x41\xe2\x31\xd4\x2e\x05\x1e\x06\x13" }  },
      /* --- pixel bitmap for cmr250 char#7 \Upsilon --- */
      {   7,63612,                      /* character number, location */
         25, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   25, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x94\x47\x77\x28\x58\x12\x53\x33\x53\x72\x32\x72"
            "\x73\x13\x71\xf1\x92\x12\x90\xa1\x11\xa0\xfe\xa3\xa0"
            "\x6b\x60" }  },
      /* --- pixel bitmap for cmr250 char#8 \Phi --- */
      {   8,64682,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 21,   24, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5b\x50\xf3\x93\x90\x77\xb3\x23\x23\x64\x33\x34\x34"
            "\x43\x44\x23\x53\x53\x1f\x34\x53\x54\x13\x53\x53\x24"
            "\x43\x44\x34\x33\x34\x63\x23\x23\xb7\x70\xf3\x93\x90"
            "\x5b\x51" }  },
      /* --- pixel bitmap for cmr250 char#9 \Psi --- */
      {   9,65841,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6b\x60\xf2\xa3\xa4\x63\x64\xf7\x23\x53\x53\x20\x32"
            "\x53\x52\x63\x43\x43\x72\x43\x42\x92\x33\x32\xb3\x13"
            "\x13\xe7\x80\xf3\xa3\xa0\x6b\x63" }  },
      /* --- pixel bitmap for cmr250 char#10 \Omega --- */
      {  10,67046,                      /* character number, location */
         25, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 21,   25, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\xc3\x53\x83\x93\x30\xf1\x23\xb3\x20\x14\xb4\x1f"
            "\x54\xd4\x13\xd3\x24\xb4\x10\xf1\x23\xb3\x20\x32\xb2"
            "\x63\x93\x72\x92\x41\x41\x91\x42\x42\x72\x43\x32\x72"
            "\x32\xf2\x16\x76\x14" }  },
      /* --- pixel bitmap for cmr250 char#11 \ff --- */
      {  11,114273,                     /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 22,   24, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x85\x35\x72\x51\x12\x23\x52\x54\x33\x42\x63\x51\x10"
            "\xf4\x42\x72\x7e\x05\x30\xfc\x42\x72\x70\x17\x37\x4f" }  },
      /* --- pixel bitmap for cmr250 char#12 \fi --- */
      {  12,115487,                     /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   24, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x85\xb2\x51\x92\x53\x72\x63\x72\x71\x40\xf3\x42\xce"
            "\x01\x30\xfc\x42\x72\x30\x17\x37" }  },
      /* --- pixel bitmap for cmr250 char#13 \fl --- */
      {  13,116683,                     /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   24, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x92\x43\x82\x53\x30\xf5\x42\x72\x3e\x01\x30\xfc"
            "\x42\x72\x30\x18\x18" }  },
      /* --- pixel bitmap for cmr250 char#14 \ffi --- */
      {  14,118332,                     /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 28,   24, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x45\xb3\x51\x12\x51\x92\x64\x53\x72\x73\x63\x72"
            "\x82\x71\x40\xf3\x42\x82\xce\x0b\x30\xfc\x42\x82\x72"
            "\x30\x18\x28\x18" }  },
      /* --- pixel bitmap for cmr250 char#15 \ffl --- */
      {  15,120021,                     /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 28,   24, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x47\x93\x51\x12\x43\x82\x64\x53\x72\x73\x72\x30"
            "\xf4\x42\x82\x72\x3e\x0b\x30\xfc\x42\x82\x72\x30\x18"
            "\x28\x18" }  },
      /* --- pixel bitmap for cmr250 char#16 \imath --- */
      {  16,81399,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   15, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x30\xfc\x32\x38" }  },
      /* --- pixel bitmap for cmr250 char#17 \jmath --- */
      {  17,82107,                      /* character number, location */
         15,-2,   -7,-2,      /* topleft row,col, and botleft row,col */
          {  9,   22, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\xfe\x72\xf1\x72\x11\x55\x32\x13\x31\x35\x30" }  },
      /* --- pixel bitmap for cmr250 char#18 \gravesym --- */
      {  18,105464,                     /* character number, location */
         24, 4,   18, 4,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc3\x61\x30\x18\x0c" }  },
      /* --- pixel bitmap for cmr250 char#19 \acutesym --- */
      {  19,106039,                     /* character number, location */
         24, 7,   18, 7,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x8e\x31\xc6\x00" }  },
      /* --- pixel bitmap for cmr250 char#20 \checksym --- */
      {  20,106670,                     /* character number, location */
         22, 4,   18, 4,      /* topleft row,col, and botleft row,col */
          {  9,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x8d\xe1\x80\x00" }  },
      /* --- pixel bitmap for cmr250 char#21 \brevesym --- */
      {  21,107292,                     /* character number, location */
         24, 3,   19, 3,      /* topleft row,col, and botleft row,col */
          { 11,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x0c\xa0\x80\x08\x82\x0f" }  },
      /* --- pixel bitmap for cmr250 char#22 (noname) --- */
      {  22,107880,                     /* character number, location */
         21, 2,   20, 2,      /* topleft row,col, and botleft row,col */
          { 13,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d" }  },
      /* --- pixel bitmap for cmr250 char#23 (noname) --- */
      {  23,108657,                     /* character number, location */
         25,10,   19,10,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\xa1\x07" }  },
      /* --- pixel bitmap for cmr250 char#24 (noname) --- */
      {  24,109357,                     /* character number, location */
         -1, 5,   -7, 5,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0e\x18\x0c\xfe\x01" }  },
      /* --- pixel bitmap for cmr250 char#25 \ss --- */
      {  25,83210,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x92\x32\x72\x52\x20\xf3\x32\x72\x10\x32\x62\x52"
            "\x52\x35\x23\x82\x51\x72\x62\x52\x71\x52\x72\x42\x81"
            "\x10\xf4\x32\x82\x32\x81\x42\x22\x32\x42\x22\x22\x25"
            "\x34\x32" }  },
      /* --- pixel bitmap for cmr250 char#26 \ae --- */
      {  26,84591,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   15, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x27\x55\x43\x42\x32\x41\x33\x52\x11\x71\x31\x73\x81"
            "\xf1\xa2\x91\x6e\x02\x33\x42\xb3\x62\xb2\x72\xa2\x82"
            "\xa2\x83\x83\x81\x12\x71\x12\x52\x32\x42\x45\x74\x35" }  },
      /* --- pixel bitmap for cmr250 char#27 \oe --- */
      {  27,85743,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   15, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x85\x62\x42\x42\x51\x41\x81\x22\x71\x22\x84\x81"
            "\x21\xa2\xa3\xa2\xa3\xad\x0f\x22\xa2\xb0\x12\x84\xb2"
            "\x84\x91\x22\x62\x22\x81\x32\x42\x42\x52\x64\x85\x35" }  },
      /* --- pixel bitmap for cmr250 char#28 (noname) --- */
      {  28,86593,                      /* character number, location */
         18, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 15,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x20\x00\x18\x00\x04\x7c\x81\xc1\x60\xe0\x18\xd8"
            "\x04\x44\x03\xe1\x81\xf0\x20\x78\x08\x3c\x04\x16\x01"
            "\xd9\xc0\x38\x30\x18\x0c\xf4\x01\x01\xc0\x00\x20\x00"
            "\x00" }  },
      /* --- pixel bitmap for cmr250 char#29 \AE --- */
      {  29,88407,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 29,   24, 3,143, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x7e\x06\xd1\x13\x83\xc1\x23\x92\xc1\x23\xa1\xb2\x23"
            "\xa2\x10\xf1\x91\x33\xb1\x10\x82\x33\xb1\x10\xf1\x81"
            "\x43\x61\x60\x72\x43\x61\xd1\x53\x52\xde\x02\xc1\x63"
            "\x52\xc1\x63\x61\xc1\x63\x61\x51\x51\x73\x61\x51\x51"
            "\x73\xc1\x51\x73\xb2\xf1\x41\x83\xb1\x10\x41\x83\xa2"
            "\x34\x73\x93\x18\x2e\x04\x10" }  },
      /* --- pixel bitmap for cmr250 char#30 \OE --- */
      {  30,90159,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 32,   26, 3,143, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xe0\x93\x5e\x02\x73\x74\x83\x63\x84\x92\x53\x94"
            "\xa1\x44\x94\xa2\x33\xa4\xb1\x24\xa4\xb1\x23\xb4\x71"
            "\x31\x1f\x14\xc3\x71\x54\xc3\x62\x54\xcb\x54\xc3\x62"
            "\x5f\x14\xc3\x71\x54\xc3\x71\x41\xf1\x14\xa4\xc1\x23"
            "\xa4\xb2\x24\x94\xb1\x43\x94\xb1\x53\x84\xa2\x63\x74"
            "\x93\x73\x5e\x03\x97\xe0\x30" }  },
      /* --- pixel bitmap for cmr250 char#31 (noname) --- */
      {  31,91201,                      /* character number, location */
         25, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   27, 3,137, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\x51\x83\x53\x21\x82\x93\x82\xb2\x72\xc3\x30\xf1"
            "\x22\xc1\x22\x20\x13\xb1\x33\x22\xb1\x52\x13\xb1\x56"
            "\xa1\x63\x0f\x13\x91\x73\x03\x81\x83\x0f\x13\x71\x93"
            "\x03\x61\xa3\x12\x51\xb2\x23\x41\xa3\x32\x31\xb2\x42"
            "\x21\xc2\x52\x11\xb2\x72\xb2\x83\x92\x91\x13\x53\x91"
            "\x47\xa1\xe0\x63" }  },
      /* --- pixel bitmap for cmr250 char#32 (noname) --- */
      {  32,109859,                     /* character number, location */
         14, 1,   10, 1,      /* topleft row,col, and botleft row,col */
          {  8,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\xe0\x1c\x03" }  },
      /* --- pixel bitmap for cmr250 char#33 ! --- */
      {  33,91918,                      /* character number, location */
         25, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          {  4,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\xff\xff\x6f\x66\x66\x66\x66\x06\x00\x60\xff\x06" }  },
      /* --- pixel bitmap for cmr250 char#34 " --- */
      {  34,121026,                     /* character number, location */
         24, 1,   13, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x7b\xfc\xe3\x1d\x8e\x40\x04\x22\x90\x40\x04\x12"
            "\x88\x40\x00" }  },
      /* --- pixel bitmap for cmr250 char#35 # --- */
      {  35,93412,                      /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 25,   31, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xb2\x62\x40\xa3\x53\x40\xf3\xa2\x62\x50\x93\x53"
            "\xe2\x62\x6f\x1e\x0b\xf1\x82\x62\x70\x73\x53\x70\xf2"
            "\x72\x62\x8f\x1e\x0b\x62\x62\xe3\x53\x90\xf4\x52\x62"
            "\xa0\x43\x53\xa0\xf2\x42\x62\xb1" }  },
      /* --- pixel bitmap for cmr250 char#36 $ --- */
      {  36,77523,                      /* character number, location */
         26, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 13,   28, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x08\xc0\x07\x24\x43\x84\x84\xd0\x10\x1c\xe2"
            "\x43\x7c\x08\x1d\x01\x2f\xc0\x0f\xf0\x07\xfc\x01\x7a"
            "\x40\x0c\x88\x0b\xe1\x23\x3c\x84\x83\xb0\x10\x13\x22"
            "\x4c\x02\x3e\x00\x01\x20\x00" }  },
      /* --- pixel bitmap for cmr250 char#37 % --- */
      {  37,94693,                      /* character number, location */
         26, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 25,   28, 3,167, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x34\xd2\x52\x31\xb3\x42\x52\x83\x51\x61\x13\x26\x42"
            "\x71\x32\x23\x52\x71\x72\x62\x71\x63\x62\x71\x53\x72"
            "\x71\x52\x82\x71\x43\x91\x61\x43\xa2\x51\x42\xc2\x31"
            "\x43\xd4\x43\xe0\x82\x54\xd3\x42\x31\xc2\x42\x51\xa3"
            "\x41\x61\x93\x42\x71\x82\x52\x71\x73\x52\x71\x63\x62"
            "\x71\x62\x72\x71\x53\x72\x71\x43\x91\x61\x52\xa2\x51"
            "\x43\xb2\x31\x52\xd4\x30" }  },
      /* --- pixel bitmap for cmr250 char#38 & --- */
      {  38,78845,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 24,   26, 3,133, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x83\xe0\x61\x31\xe0\x41\x51\xb0\xf2\x52\x51\xb0\xf1"
            "\x52\x41\xc0\x52\x31\xe0\x42\x21\xe0\x63\x78\x62\xa4"
            "\x82\xb1\xa3\xa1\x91\x12\x91\x91\x32\x71\x91\x43\x61"
            "\x81\x62\x51\x81\x82\x41\x72\x82\x31\x82\x92\x11\x92"
            "\xa2\x93\xa3\x81\x12\x81\x22\x61\x32\x52\x42\x42\x55"
            "\x84\x30" }  },
      /* --- pixel bitmap for cmr250 char#39 ' --- */
      {  39,95417,                      /* character number, location */
         24, 3,   13, 3,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe6\x7d\x0b\x21\x44\x88\x08" }  },
      /* --- pixel bitmap for cmr250 char#40 ( --- */
      {  40,96003,                      /* character number, location */
         26, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          {  8,   34, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x61\x61\x61\x62\x61\x62\x61\x50\xf1\x12\x50\xf1"
            "\x11\x6f\x92\x60\xf1\x11\x60\xf1\x12\x50\x21\x72\x71"
            "\x72\x71\x81\x81\x81" }  },
      /* --- pixel bitmap for cmr250 char#41 ) --- */
      {  41,96634,                      /* character number, location */
         26, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  8,   34, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x81\x81\x72\x71\x72\x71\x20\xf1\x52\x10\xf1"
            "\x61\x10\xf9\x62\xf1\x61\x10\xf1\x52\x10\x51\x62\x61"
            "\x62\x61\x61\x61\x61\x71" }  },
      /* --- pixel bitmap for cmr250 char#42 * --- */
      {  42,97289,                      /* character number, location */
         26, 2,   11, 2,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x08\x00\x01\x21\x74\xc4\xbd\x1e\xfe\x00\x07"
            "\xf8\xc3\xeb\x1d\x71\x21\x04\x04\x80\x00\x10\x00" }  },
      /* --- pixel bitmap for cmr250 char#43 + --- */
      {  43,97999,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\xb2\xaf\x1e\x09\xf9\xb2\xa1" }  },
      /* --- pixel bitmap for cmr250 char#44 (noname) --- */
      {  44,98598,                      /* character number, location */
          4, 3,   -7, 3,      /* topleft row,col, and botleft row,col */
          {  4,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\xef\x88\x48\x24\x02" }  },
      /* --- pixel bitmap for cmr250 char#45 (noname) --- */
      {  45,121549,                     /* character number, location */
          8, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          { 10,    2, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0a" }  },
      /* --- pixel bitmap for cmr250 char#46 (noname) --- */
      {  46,99073,                      /* character number, location */
          4, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x6f" }  },
      /* --- pixel bitmap for cmr250 char#47 / --- */
      {  47,99583,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 13,   35, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xb2\xa3\xf1\xa2\x10\x93\x10\xf1\x92\x20\x83\x20"
            "\xf1\x82\x30\x73\x30\xf1\x72\x40\x63\x40\xf1\x62\x50"
            "\x53\x50\xf1\x52\x60\x43\x60\xf1\x42\x70\x33\x70\xf1"
            "\x32\x80\x23\x80\xf1\x22\x90\x13\x90\xf1\x12\xa3\xaf"
            "\x12\xb1" }  },
      /* --- pixel bitmap for cmr250 char#48 0 --- */
      {  48,67814,                      /* character number, location */
         23, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   24, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x72\x32\x52\x52\x20\xf1\x12\x72\x10\x11\x91\x1f"
            "\xb2\x92\x11\x91\x10\xf1\x12\x72\x10\x22\x52\x52\x32"
            "\x75\x43" }  },
      /* --- pixel bitmap for cmr250 char#49 1 --- */
      {  49,68628,                      /* character number, location */
         23, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 10,   23, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x73\x43\x12\x40\xfe\x42\x40\xf3\x42\x4a" }  },
      /* --- pixel bitmap for cmr250 char#50 2 --- */
      {  50,69617,                      /* character number, location */
         23, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   23, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x42\x41\x72\x31\x82\x13\x73\x0f\x14\x63\x12"
            "\x73\xf1\xa3\x93\xa2\xa3\xa2\xa2\xa2\xa2\xa2\xa2\x71"
            "\x31\x81\x21\x81\x2b\x1c\x11" }  },
      /* --- pixel bitmap for cmr250 char#51 3 --- */
      {  51,70673,                      /* character number, location */
         23, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x43\x51\x73\x20\xf2\x13\x73\x10\x21\x83\xc2"
            "\xc3\xc2\xc2\x95\xe3\xd3\xd3\xc4\x12\x84\x0f\x24\x74"
            "\x11\x93\x21\x83\x42\x53\x76\x52" }  },
      /* --- pixel bitmap for cmr250 char#52 4 --- */
      {  52,71625,                      /* character number, location */
         23, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   23, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x92\x40\xf1\x83\x40\x71\x12\x40\xf1\x61\x22\x40"
            "\x51\x32\x40\xf1\x41\x42\x40\x31\x52\x40\xf1\x21\x62"
            "\x40\x11\x72\x42\x72\x4e\x01\xf5\x92\x40\x68\x12" }  },
      /* --- pixel bitmap for cmr250 char#53 5 --- */
      {  53,72683,                      /* character number, location */
         23, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   24, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x12\x72\x2a\x39\x48\x40\xf3\x11\xb0\x11\x25\x51\x11"
            "\x42\x42\x62\x31\x73\xb2\x10\xf2\xa3\x0f\x23\x73\x01"
            "\x92\x21\x73\x21\x72\x42\x42\x74\x52" }  },
      /* --- pixel bitmap for cmr250 char#54 6 --- */
      {  54,73603,                      /* character number, location */
         23, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x82\x51\x62\x62\x42\x63\x32\x73\x32\xc3\xc2\xc3"
            "\x34\x53\x12\x42\x34\x72\x24\x73\x14\x82\x1f\x33\x93"
            "\xf1\x12\x93\x13\x82\x32\x73\x42\x62\x62\x42\x85\x52" }  },
      /* --- pixel bitmap for cmr250 char#55 7 --- */
      {  55,74539,                      /* character number, location */
         23, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xee\x1d\x21\xb1\x11\xb1\x21\xa1\x30\xf1\xa1\x40"
            "\x91\x50\xf1\x81\x60\xf1\x71\x70\xf1\x62\x70\xf2\x52"
            "\x80\xf4\x43\x80\x51\x92" }  },
      /* --- pixel bitmap for cmr250 char#56 8 --- */
      {  56,75473,                      /* character number, location */
         23, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x52\x72\x41\x92\x10\xf1\x12\x92\x10\x13"
            "\x82\x24\x62\x44\x52\x55\x21\x86\xa6\x81\x25\x52\x54"
            "\x32\x74\x22\x95\xa3\x0f\x22\xb2\x12\xa1\x31\x91\x52"
            "\x52\x85\x56" }  },
      /* --- pixel bitmap for cmr250 char#57 9 --- */
      {  57,76407,                      /* character number, location */
         23, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x51\x62\x71\x43\x72\x32\x83\x1f\x13\x92\x1f"
            "\x33\x93\x12\x84\x13\x74\x22\x74\x32\x42\x13\x54\x33"
            "\xc2\x10\xf1\xb3\x10\x13\x72\x33\x62\x42\x71\x61\x52"
            "\x86\x65" }  },
      /* --- pixel bitmap for cmr250 char#58 : --- */
      {  58,100199,                     /* character number, location */
         15, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x6f\x00\x00\x00\x60\xff\x06" }  },
      /* --- pixel bitmap for cmr250 char#59 ; --- */
      {  59,100870,                     /* character number, location */
         15, 3,   -7, 3,      /* topleft row,col, and botleft row,col */
          {  4,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x6f\x00\x00\x00\x60\xff\x8e\x88\x44\x22" }  },
      /* --- pixel bitmap for cmr250 char#60 (noname) --- */
      {  60,92548,                      /* character number, location */
         17, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          {  4,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x6f\x00\x00\x66\x66\x66\x66\x66\xff\xff\xff\x06" }  },
      /* --- pixel bitmap for cmr250 char#61 = --- */
      {  61,101560,                     /* character number, location */
         14, 2,    4, 2,      /* topleft row,col, and botleft row,col */
          { 23,   10, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x09\xf5\xe0\x9f\x1e\x09" }  },
      /* --- pixel bitmap for cmr250 char#62 (noname) --- */
      {  62,80772,                      /* character number, location */
         17, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 12,   24, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x50\xf1\x44\x40\x52\x50\xf3\xc0\xf1\x61\x50\xf3"
            "\x51\x60\x41\xa2\x92\x92\x92\x81\x1f\x12\x73\x11\x81"
            "\x22\x61\x56\x31" }  },
      /* --- pixel bitmap for cmr250 char#63 ? --- */
      {  63,79840,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   24, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x51\x62\x21\x81\x1f\x13\x72\x11\x82\x92\x92\x92"
            "\xa1\x40\xf5\x61\x50\xf3\xc0\x52\x50\xf1\x44\x40\x52"
            "\x52" }  },
      /* --- pixel bitmap for cmr250 char#64 @ --- */
      {  64,102734,                     /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x72\xb1\xb1\x91\xd1\x71\xe0\x11\x51\x65\x61"
            "\x31\x62\x41\x61\x21\x51\x71\x51\x21\x42\x82\x31\x1f"
            "\x51\x42\x92\x41\x11\x42\x82\x41\x11\x51\x73\x31\x21"
            "\x62\x41\x12\x31\x31\x65\x34\x51\xe0\x91\xe0\x91\xe3"
            "\x62\x94\xa9\x62" }  },
      /* --- pixel bitmap for cmr250 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         25, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 24,   25, 3,78, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xb2\xb0\xf2\xa4\xa0\xf2\x91\x23\x90\xf2\x81\x43"
            "\x80\xf2\x71\x63\x70\x61\x83\xcc\xc1\x83\x60\xf1\x51"
            "\xa3\x50\x42\xa4\x40\xf1\x41\xc3\x40\x33\xb4\x38\x6a" }  },
      /* --- pixel bitmap for cmr250 char#66 B --- */
      {  66, 2360,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 22,   24, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\xa3\x83\x83\x94\x63\xa3\x20\xf3\x43\xa4\x10"
            "\x43\xa3\x63\x94\x63\x84\x7d\x93\x93\x73\xa3\x63\xa4"
            "\x10\xf4\x43\xb4\x43\xa4\x53\xa3\x63\x84\x3e\x03\x5a" }  },
      /* --- pixel bitmap for cmr250 char#67 C --- */
      {  67, 3321,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 21,   26, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x51\x73\x52\x22\x53\x94\x43\xb3\x33\xc3\xf1\x23"
            "\xe2\x14\xe0\x11\x13\xe0\x25\xe0\x21\x0f\x54\xe0\x34"
            "\xe0\x21\x13\xe0\x21\x14\xe0\x11\x23\xe0\x11\x23\xe1"
            "\x43\xd1\x53\xb1\x73\x91\xa3\x52\xd6\x60" }  },
      /* --- pixel bitmap for cmr250 char#68 D --- */
      {  68, 4443,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 24,   24, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\xc3\x84\x93\xa3\x83\xb3\x30\xf1\x43\xc3\x20"
            "\x43\xc4\x53\xd3\x10\xf7\x43\xd4\xf1\x43\xd3\x10\xf1"
            "\x43\xc3\x20\x43\xb3\x73\xa3\x83\x84\x5e\x03\x73" }  },
      /* --- pixel bitmap for cmr250 char#69 E --- */
      {  69, 5872,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x0e\x07\x63\xb3\x63\xc2\x63\xd1\x63\xd2\x10\xf1\x43"
            "\xe1\x10\x43\x81\x51\x10\xf1\x43\x81\x70\x43\x72\xbc"
            "\xb3\x72\x70\xf1\x43\x81\x70\x43\x81\x61\xf1\x43\xe0"
            "\x11\x43\xe2\xf1\x43\xe1\x10\x43\xd2\x53\xb4\x1e\x08"
            "\x10" }  },
      /* --- pixel bitmap for cmr250 char#70 F --- */
      {  70, 7161,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 22,   24, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x07\x53\xb3\x53\xc2\x53\xd1\x53\xd2\xf1\x43\xe1"
            "\x43\x81\x51\xf1\x43\x81\x60\x43\x72\xac\xa3\x72\x60"
            "\xf2\x43\x81\x60\xf6\x43\xe0\x1c\xa1" }  },
      /* --- pixel bitmap for cmr250 char#71 G --- */
      {  71, 8356,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   26, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x96\x51\x93\x52\x22\x73\x94\x63\xb3\x53\xc3\x20\xf1"
            "\x23\xe2\x20\x14\xe0\x11\x33\xe0\x21\x24\xe0\x21\x2f"
            "\x34\xe0\x54\xa9\x0f\x14\xe3\x20\x13\xe3\x34\xd3\x20"
            "\xf1\x23\xd3\x20\x33\xc3\x63\xb3\x73\x91\x12\x93\x52"
            "\x31\xb6\x80" }  },
      /* --- pixel bitmap for cmr250 char#72 H --- */
      {  72, 9567,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x4b\xf9\x43\xc3\x40\x4e\x04\x40\xfa\x43\xc3\x4b"
            "\x4b" }  },
      /* --- pixel bitmap for cmr250 char#73 I --- */
      {  73,10274,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   24, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\xfe\x43\x40\xf6\x43\x4b" }  },
      /* --- pixel bitmap for cmr250 char#74 J --- */
      {  74,11090,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   25, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5b\xfe\xa3\x30\xf1\xa3\x30\x12\x73\x3f\x14\x63\x33"
            "\x72\x51\x72\x71\x52\x96\x73" }  },
      /* --- pixel bitmap for cmr250 char#75 K --- */
      {  75,12289,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 25,   24, 3,108, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x0b\x77\x43\xc4\x63\xc2\x83\xc1\x93\xb1\xa3\x92\xb3"
            "\x81\xd3\x71\xe3\x61\xe0\x13\x51\xe0\x23\x43\xe0\x13"
            "\x31\x13\xe3\x21\x23\xe3\x11\x43\xd4\x63\xc3\x73\xc3"
            "\x83\xb3\x93\xa3\x94\x93\xa3\x93\xb3\x83\xb4\x73\xb5"
            "\x2b\x59" }  },
      /* --- pixel bitmap for cmr250 char#76 L --- */
      {  76,13276,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 21,   24, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x90\xfd\x43\xe0\xf2\x43\xd1\xf1\x43\xc2\xf1\x43"
            "\xb2\x10\x43\x94\x1e\x06\x13" }  },
      /* --- pixel bitmap for cmr250 char#77 M --- */
      {  77,14574,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 32,   24, 3,120, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x08\xe0\x28\x44\xe0\x24\x40\xf2\x41\x13\xe1\x13\x40"
            "\xf1\x41\x23\xc1\x23\x40\xf2\x41\x33\xa1\x33\x40\xf1"
            "\x41\x43\x81\x43\x40\xf1\x41\x53\x61\x53\x40\xf2\x41"
            "\x63\x41\x63\x40\xf1\x41\x73\x21\x73\x40\xf2\x41\x84"
            "\x83\x40\x33\x82\x93\x49\x52\x5b" }  },
      /* --- pixel bitmap for cmr250 char#78 N --- */
      {  78,15778,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,131, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x07\xa9\x44\xc3\x75\xc1\x81\x13\xc1\x81\x23\xb1\x81"
            "\x33\xa1\x81\x34\x91\x81\x43\x91\x81\x53\x81\x81\x63"
            "\x71\x81\x64\x61\x81\x73\x61\x81\x83\x51\x40\xf1\x41"
            "\x93\x41\x40\x41\xa3\x31\x81\xb3\x21\x40\xf1\x41\xc3"
            "\x11\x40\x41\xd4\x81\xe3\x81\xe0\x12\x73\xe2\x49\xc1"
            "\x40" }  },
      /* --- pixel bitmap for cmr250 char#79 O --- */
      {  79,16693,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   26, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\xe3\x53\xb3\x73\x93\x93\x73\xb3\x30\xf1\x23\xd3"
            "\x20\x14\xd4\x23\xe0\x13\x1f\x74\xe0\x14\x13\xe0\x13"
            "\x24\xd4\x10\xf1\x23\xd3\x20\x33\xb3\x73\x93\x93\x73"
            "\xb3\x53\xe7\x81" }  },
      /* --- pixel bitmap for cmr250 char#80 P --- */
      {  80,17844,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 22,   24, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\x93\x84\x73\xa3\x63\xb3\x10\xf4\x43\xb4\x43"
            "\xb3\x53\xa3\x63\x84\x7d\x50\xf9\x43\xe0\x1b\xb0" }  },
      /* --- pixel bitmap for cmr250 char#81 Q --- */
      {  81,18889,                      /* character number, location */
         25, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 23,   32, 3,127, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xe3\x53\xb3\x73\x93\x93\x73\xb3\x30\xf1\x23\xd3"
            "\x20\x14\xd4\x23\xe0\x13\x1f\x74\xe0\x14\x13\xe0\x13"
            "\x24\xd4\x33\xd3\x43\x53\x53\x53\x31\x31\x33\x73\x21"
            "\x41\x13\x93\x11\x44\xb4\x43\x51\x88\x61\xe0\x12\x51"
            "\xe0\x12\x42\xe0\x18\xe0\x17\xe0\x36\xe0\x43\x39" }  },
      /* --- pixel bitmap for cmr250 char#82 R --- */
      {  82,20242,                      /* character number, location */
         24, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\xe3\x74\xb3\x93\xa3\xa3\x50\xf3\x43\xa4\x40"
            "\x43\xa3\x93\x93\xa3\x74\xbb\xe3\x72\xd3\x82\xc3\x92"
            "\x70\xf2\x43\x93\x60\xf1\x43\x94\x50\x43\x94\x41\x43"
            "\x95\x31\x43\xa4\x3c\x73\x21\xe0\x64\x21" }  },
      /* --- pixel bitmap for cmr250 char#83 S --- */
      {  83,21331,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   26, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x41\x41\x52\x12\x31\x83\x21\xa2\x12\xa2\x1f\x22"
            "\xb1\x13\xd3\xc5\xb8\x89\x88\xb5\xc3\xd3\xd2\x0f\x21"
            "\xc2\x02\xb1\x12\xa2\x13\x91\x22\x12\x61\x31\x46\x43" }  },
      /* --- pixel bitmap for cmr250 char#84 T --- */
      {  84,22451,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x07\x23\x63\x63\x10\xf1\x11\x83\x81\x12\x83\x82"
            "\x0f\x21\x93\x91\xfe\xa3\xa0\x5d\x53" }  },
      /* --- pixel bitmap for cmr250 char#85 U --- */
      {  85,23463,                      /* character number, location */
         24, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 26,   25, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x69\x43\xd3\x30\xfe\x43\xe1\x40\xf1\x43\xe1\x40"
            "\x52\xd1\xa3\xc1\xb2\xb1\xd2\x91\xe0\x13\x52\xe0\x46"
            "\xa2" }  },
      /* --- pixel bitmap for cmr250 char#86 V --- */
      {  86,24491,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 24,   25, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x87\x33\xd3\x53\xd2\x30\xf2\x43\xc1\x40\xf2\x53"
            "\xa1\x50\xf1\x63\x81\x60\xf2\x73\x61\x70\xf2\x83\x41"
            "\x80\xf1\x93\x21\x90\x96\x90\xf1\xa4\xa0\xf2\xb2\xb3" }  },
      /* --- pixel bitmap for cmr250 char#87 W --- */
      {  87,25924,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 34,   25, 3,123, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x09\x4a\x47\x24\xa4\x93\x20\xf2\x33\xa4\xa1\x30\xf2"
            "\x43\x81\x23\x81\x40\x53\x71\x23\x71\x50\xf1\x53\x61"
            "\x43\x61\x50\x63\x51\x43\x51\x60\xf2\x63\x41\x63\x41"
            "\x60\xf2\x73\x21\x83\x21\x70\x83\x11\x83\x11\x80\xf1"
            "\x84\xa4\x80\x93\xa3\x90\xf2\x92\xc2\x90" }  },
      /* --- pixel bitmap for cmr250 char#88 X --- */
      {  88,27107,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 24,   24, 3,108, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x0a\x49\x54\x84\x84\x91\xb3\x81\xd3\x71\xd4\x51\xe0"
            "\x13\x41\xe0\x33\x31\xe0\x34\x11\xe0\x54\xe0\x73\xb0"
            "\xf1\xa4\xa0\xa1\x13\xe0\x41\x24\xe0\x22\x33\xe0\x21"
            "\x53\xe1\x63\xd2\x73\xc1\x84\xa1\xa3\x92\xb3\x74\x95"
            "\x38\x6a" }  },
      /* --- pixel bitmap for cmr250 char#89 Y --- */
      {  89,28283,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   24, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x88\x34\xc3\x64\xc2\x84\xb1\xa3\xa2\xa4\x91\xc3"
            "\x81\xe3\x71\xe4\x51\xe0\x23\x51\xe0\x33\x31\xe0\x44"
            "\x12\xe0\x53\x11\xe0\x64\xb0\xf8\xb3\xb0\x7b\x70" }  },
      /* --- pixel bitmap for cmr250 char#90 Z --- */
      {  90,29350,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x07\x93\x13\xa3\x12\xa3\x21\xb3\x21\xa3\x3f\x11"
            "\x93\x40\x93\xd4\xd3\x60\xf1\x73\x70\x63\xd4\xd3\x81"
            "\xf1\x43\x91\x33\x92\xf1\x23\xa1\x10\x13\xa2\x23\x84"
            "\x1e\x02\x13" }  },
      /* --- pixel bitmap for cmr250 char#91 [ --- */
      {  91,103523,                     /* character number, location */
         26, 3,   -9, 3,      /* topleft row,col, and botleft row,col */
          {  7,   35, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x07\x0f\xe2\x5f\xe2\x52\x5f\x17" }  },
      /* --- pixel bitmap for cmr250 char#92 (noname) --- */
      {  92,122418,                     /* character number, location */
         24, 5,   13, 5,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x22\x90\x40\x04\x12\x88\x40\x04\xe2\x70\x8f\x7f"
            "\xbc\xc1\x00" }  },
      /* --- pixel bitmap for cmr250 char#93 ] --- */
      {  93,104241,                     /* character number, location */
         26, 0,   -9, 0,      /* topleft row,col, and botleft row,col */
          {  7,   35, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x07\xfe\x52\xfe\x52\x52\x0f\x17" }  },
      /* --- pixel bitmap for cmr250 char#94 \^ --- */
      {  94,110488,                     /* character number, location */
         24, 4,   19, 4,      /* topleft row,col, and botleft row,col */
          {  9,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x50\x10\x11\x14\x10" }  },
      /* --- pixel bitmap for cmr250 char#95 (noname) --- */
      {  95,110963,                     /* character number, location */
         24, 3,   20, 3,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x6f" }  },
      /* --- pixel bitmap for cmr250 char#96 (noname) --- */
      {  96,104879,                     /* character number, location */
         24, 3,   13, 3,      /* topleft row,col, and botleft row,col */
          {  4,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x22\x11\x71\xff\x06" }  },
      /* --- pixel bitmap for cmr250 char#97 a --- */
      {  97,30520,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x80\xc3\xc0\xc1\x40\xc0\x00\x60\x00\x30\xc0\x1f"
            "\x38\x0c\x06\x86\x01\xc3\x80\x71\xc0\x38\x70\x34\x7c"
            "\xe3\x71\x00" }  },
      /* --- pixel bitmap for cmr250 char#98 b --- */
      {  98,31546,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xb0\xf7\x32\xb0\x32\x25\x72\x11\x42\x63\x71\x52"
            "\x82\x42\x91\x10\xf4\x32\x92\x32\x91\x42\x82\x43\x62"
            "\x51\x21\x42\x61\x34\x51" }  },
      /* --- pixel bitmap for cmr250 char#99 c --- */
      {  99,32353,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x42\x43\x21\x63\x12\x71\x21\xaf\x42\xa0\x11\xb2"
            "\x81\x21\x81\x32\x42\x55\x32" }  },
      /* --- pixel bitmap for cmr250 char#100 d --- */
      { 100,33362,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x85\x30\xf7\xb2\x30\x54\x22\x62\x41\x12\x52\x63\x42"
            "\x82\x41\x92\x3f\x42\x92\x30\x11\x92\x42\x82\x51\x73"
            "\x62\x41\x12\x75\x25" }  },
      /* --- pixel bitmap for cmr250 char#101 e --- */
      { 101,34154,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x62\x42\x42\x71\x22\x81\x21\x94\xae\x0f\x22\xb0"
            "\x11\xc2\x91\x22\x71\x42\x52\x65\x32" }  },
      /* --- pixel bitmap for cmr250 char#102 f --- */
      { 102,35019,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   24, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x72\x23\x52\x33\x42\x51\x10\xf4\x42\x7a\x30\xfc"
            "\x42\x70\x19\x32" }  },
      /* --- pixel bitmap for cmr250 char#103 g --- */
      { 103,36274,                      /* character number, location */
         16, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc3\x55\x21\x31\x32\x33\x32\x22\x52\x50\xf3\x12\x72"
            "\x40\x22\x52\x73\x32\x81\x15\x70\xf2\x12\xd0\x2a\x7a"
            "\x42\x83\x2f\x32\xb2\x10\x12\x92\x43\x53\x77\x53" }  },
      /* --- pixel bitmap for cmr250 char#104 h --- */
      { 104,37285,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xc0\xf7\x32\xc0\x32\x25\x82\x11\x42\x73\x62\x30"
            "\xfa\x32\x72\x38\x27" }  },
      /* --- pixel bitmap for cmr250 char#105 i --- */
      { 105,38030,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   24, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x40\xf1\x14\x30\x22\x40\xf4\x85\x30\xfc\x32\x38" }  },
      /* --- pixel bitmap for cmr250 char#106 j --- */
      { 106,38838,                      /* character number, location */
         24,-2,   -7,-2,      /* topleft row,col, and botleft row,col */
          {  9,   31, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\x10\xf1\x54\x62\x10\xf4\x90\x45\xfe\x72\xf1\x72"
            "\x11\x55\x32\x13\x31\x35\x35" }  },
      /* --- pixel bitmap for cmr250 char#107 k --- */
      { 107,39952,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xc0\xf7\x32\xc0\x32\x47\x42\x54\x62\x52\x82\x51"
            "\x92\x41\xa2\x22\xb2\x13\xb3\x22\x70\xf1\x32\x42\x60"
            "\x32\x52\x82\x62\x72\x63\x62\x64\x28\x27" }  },
      /* --- pixel bitmap for cmr250 char#108 l --- */
      { 108,40601,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   24, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x30\xfe\x32\x30\xf6\x32\x38" }  },
      /* --- pixel bitmap for cmr250 char#109 m --- */
      { 109,41954,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 28,   15, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x35\x55\x82\x12\x42\x22\x42\x40\xf1\x33\x73\x72"
            "\x30\xf9\x32\x82\x82\x38\x28\x28" }  },
      /* --- pixel bitmap for cmr250 char#110 n --- */
      { 110,42973,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x25\x82\x11\x42\x73\x62\x30\xfa\x32\x72\x38\x27" }  },
      /* --- pixel bitmap for cmr250 char#111 o --- */
      { 111,43692,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x52\x72\x32\x92\x21\xb1\x1f\x42\xb2\x11"
            "\xb1\x22\x92\x32\x72\x52\x52\x85\x50" }  },
      /* --- pixel bitmap for cmr250 char#112 p --- */
      { 112,44778,                      /* character number, location */
         15, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x25\x72\x11\x42\x63\x62\x52\x82\x42\x91\x10\xf4"
            "\x32\x92\xf1\x32\x82\x10\x33\x62\x52\x11\x42\x62\x24"
            "\x50\xf5\x32\xb8\x82" }  },
      /* --- pixel bitmap for cmr250 char#113 q --- */
      { 113,45812,                      /* character number, location */
         15, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x31\x62\x41\x21\x52\x63\x30\xf1\x12\x82\x3f\x42"
            "\x92\x30\x11\x92\x42\x73\x52\x63\x62\x41\x12\x75\x22"
            "\x30\xf5\xb2\x30\x88" }  },
      /* --- pixel bitmap for cmr250 char#114 r --- */
      { 114,46701,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x34\x42\x12\x23\x33\x43\x33\x51\x10\xf9\x32\x88"
            "\x52" }  },
      /* --- pixel bitmap for cmr250 char#115 s --- */
      { 115,47650,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\x21\x22\x53\x1f\x22\x81\x10\x13\x97\x77\xa3\x11"
            "\x84\x94\x84\x81\x14\x52\x11\x35\x32" }  },
      /* --- pixel bitmap for cmr250 char#116 t --- */
      { 116,48495,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   21, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x41\x50\xf1\x32\x50\x23\x5a\xf7\x32\x50\xf3\x32"
            "\x41\x42\x21\x63\x24" }  },
      /* --- pixel bitmap for cmr250 char#117 u --- */
      { 117,49436,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x45\x30\xfa\x32\x72\x30\x32\x63\x72\x41\x12\x85"
            "\x25" }  },
      /* --- pixel bitmap for cmr250 char#118 v --- */
      { 118,50324,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\xf8\x0c\x70\x1c\x30\x18\x10\x18\x10\x30\x08\x30"
            "\x08\x70\x0c\x60\x04\x60\x04\xc0\x02\xc0\x02\xc0\x03"
            "\x80\x01\x80\x01" }  },
      /* --- pixel bitmap for cmr250 char#119 w --- */
      { 119,51608,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x7e\x7e\x06\x0c\x1c\x03\x06\x04\x83\x02\x81\x41"
            "\x83\xc0\xa0\x41\xc0\x88\x10\x60\xc4\x08\x30\x62\x04"
            "\xb0\x20\x01\x58\xb0\x00\x2c\x58\x00\x0c\x18\x00\x06"
            "\x0c\x00\x03\x06\x00" }  },
      /* --- pixel bitmap for cmr250 char#120 x --- */
      { 120,52623,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x46\x23\x63\x52\x61\x82\x42\x92\x22\xa3\x11\xc3"
            "\xe2\xd4\xb2\x22\xa1\x32\x91\x52\x72\x62\x53\x63\x25"
            "\x56" }  },
      /* --- pixel bitmap for cmr250 char#121 y --- */
      { 121,53706,                      /* character number, location */
         15, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\xf8\x0c\x70\x1c\x30\x18\x10\x18\x10\x30\x08\x30"
            "\x08\x70\x0c\x60\x04\x60\x04\xc0\x02\xc0\x02\xc0\x03"
            "\x80\x01\x80\x01\x80\x00\x80\x00\xc0\x00\x47\x00\x67"
            "\x00\x35\x00\x1e\x00" }  },
      /* --- pixel bitmap for cmr250 char#122 z --- */
      { 122,54697,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\x80\x0d\xb8\x00\x13\x30\x02\x03\x30\x00\x07"
            "\x60\x10\x06\x62\x40\x06\xe4\x80\x0c\xdc\xff\x03" }  },
      /* --- pixel bitmap for cmr250 char#123 (noname) --- */
      { 123,123046,                     /* character number, location */
         10, 0,    9, 0,      /* topleft row,col, and botleft row,col */
          { 17,    1, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03" }  },
      /* --- pixel bitmap for cmr250 char#124 (noname) --- */
      { 124,123866,                     /* character number, location */
         10, 0,    9, 0,      /* topleft row,col, and botleft row,col */
          { 35,    1, 2, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x23" }  },
      /* --- pixel bitmap for cmr250 char#125 (noname) --- */
      { 125,111644,                     /* character number, location */
         24, 4,   18, 4,      /* topleft row,col, and botleft row,col */
          { 10,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x33\x6c\x98\x61\x82\x0c\x03" }  },
      /* --- pixel bitmap for cmr250 char#126 \~ --- */
      { 126,112336,                     /* character number, location */
         23, 3,   20, 3,      /* topleft row,col, and botleft row,col */
          { 11,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xf4\x5f\x70\x00" }  },
      /* --- pixel bitmap for cmr250 char#127 (noname) --- */
      { 127,113017,                     /* character number, location */
         24, 3,   20, 3,      /* topleft row,col, and botleft row,col */
          { 11,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x7b\xfc\xe3\x0d\x06" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* ------------------------------------------------------------------------
font sizes 0-7 for cmmi10
------------------------------------------------------------------------ */

/* --- size=0 for .83gf ---
 * mf '\mode=eighthre;  input cmmi10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmi83 --- */
static	chardef  cmmi83[] =
   {
      /* --- pixel bitmap for cmmi83 char#0 \Gamma --- */
      {   0, 1597,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xc8\x44\x04\x04\x04\x02\x07" }  },
      /* --- pixel bitmap for cmmi83 char#1 \Delta --- */
      {   1, 1624,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x60\xd0\x90\x88\x84\x86\xfe" }  },
      /* --- pixel bitmap for cmmi83 char#2 \Theta --- */
      {   2, 1657,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x28\xb6\x61\x14\x39" }  },
      /* --- pixel bitmap for cmmi83 char#3 \Lambda --- */
      {   3, 1694,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x18\x0c\x85\x22\x91\xee" }  },
      /* --- pixel bitmap for cmmi83 char#4 \Xi --- */
      {   4, 1727,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x09\x12\xe1\x43\x04\x40\x90\x3f" }  },
      /* --- pixel bitmap for cmmi83 char#5 \Pi --- */
      {   5, 1758,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x23\x44\x08\x21\x84\x10\x22\xc4\x39" }  },
      /* --- pixel bitmap for cmmi83 char#6 \Sigma --- */
      {   6, 1795,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x32\x0b\x81\x20\x49\x3e" }  },
      /* --- pixel bitmap for cmmi83 char#7 \Upsilon --- */
      {   7, 1826,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x57\x4b\x10\x04\x21\x1c" }  },
      /* --- pixel bitmap for cmmi83 char#8 \Phi --- */
      {   8, 1855,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xf9\x5a\x9f\x38" }  },
      /* --- pixel bitmap for cmmi83 char#9 \Psi --- */
      {   9, 1886,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x94\xa6\xa9\x47\x38" }  },
      /* --- pixel bitmap for cmmi83 char#10 \Omega --- */
      {  10, 1921,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x24\x91\x48\x24\x95\xef" }  },
      /* --- pixel bitmap for cmmi83 char#11 \alpha --- */
      {  11, 1960,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\xa7\x7c\x01" }  },
      /* --- pixel bitmap for cmmi83 char#12 \beta --- */
      {  12, 1985,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x29\x39\x92\xb4\x1c\x41\x00" }  },
      /* --- pixel bitmap for cmmi83 char#13 \gamma --- */
      {  13, 2022,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb2\x32\x46\x08\x01" }  },
      /* --- pixel bitmap for cmmi83 char#14 \delta --- */
      {  14, 2049,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\x42\x56\x59\x03" }  },
      /* --- pixel bitmap for cmmi83 char#15 \epsilon --- */
      {  15, 2082,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\x73" }  },
      /* --- pixel bitmap for cmmi83 char#16 \zeta --- */
      {  16, 2099,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x13\x21\x44\x10\xc4\x00" }  },
      /* --- pixel bitmap for cmmi83 char#17 \eta --- */
      {  17, 2126,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xca\x94\x10\x02" }  },
      /* --- pixel bitmap for cmmi83 char#18 \theta --- */
      {  18, 2155,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xac\xfa\x5f\x35" }  },
      /* --- pixel bitmap for cmmi83 char#19 \iota --- */
      {  19, 2186,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xea\x03" }  },
      /* --- pixel bitmap for cmmi83 char#20 \kappa --- */
      {  20, 2203,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xda\xb8\x1c\x01" }  },
      /* --- pixel bitmap for cmmi83 char#21 \lambda --- */
      {  21, 2226,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x82\x40\x18\x25\x85" }  },
      /* --- pixel bitmap for cmmi83 char#22 \mu --- */
      {  22, 2255,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\xca\x7c\x43\x00" }  },
      /* --- pixel bitmap for cmmi83 char#23 \nu --- */
      {  23, 2286,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\xaa\x32\x00" }  },
      /* --- pixel bitmap for cmmi83 char#24 \xi --- */
      {  24, 2311,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x0b\xc1\x44\x08\xc6\x00" }  },
      /* --- pixel bitmap for cmmi83 char#25 \pi --- */
      {  25, 2338,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x18\x53\x00" }  },
      /* --- pixel bitmap for cmmi83 char#26 \rho --- */
      {  26, 2357,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\xca\x75\x42\x00" }  },
      /* --- pixel bitmap for cmmi83 char#27 \sigma --- */
      {  27, 2384,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x14\x25\x07" }  },
      /* --- pixel bitmap for cmmi83 char#28 \tau --- */
      {  28, 2407,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\x10\x21\x00" }  },
      /* --- pixel bitmap for cmmi83 char#29 \upsilon --- */
      {  29, 2426,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\xca\x64\x00" }  },
      /* --- pixel bitmap for cmmi83 char#30 \phi --- */
      {  30, 2451,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x82\x78\x65\x59\x39\x82\x00" }  },
      /* --- pixel bitmap for cmmi83 char#31 \chi --- */
      {  31, 2490,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x13\x05\xc1\x90\xc4\x00" }  },
      /* --- pixel bitmap for cmmi83 char#32 \psi --- */
      {  32, 2521,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x82\xac\xab\x59\x39\x84\x00" }  },
      /* --- pixel bitmap for cmmi83 char#33 \omega --- */
      {  33, 2562,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x9a\x76\x1b" }  },
      /* --- pixel bitmap for cmmi83 char#34 \varepsilon --- */
      {  34, 2593,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2c\x12\x06" }  },
      /* --- pixel bitmap for cmmi83 char#35 \vartheta --- */
      {  35, 2610,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\xd2\x3f\x55\x32" }  },
      /* --- pixel bitmap for cmmi83 char#36 \varpi --- */
      {  36, 2643,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x53\x52\x29\x36" }  },
      /* --- pixel bitmap for cmmi83 char#37 \varrho --- */
      {  37, 2674,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\xca\x75\xc2\x03" }  },
      /* --- pixel bitmap for cmmi83 char#38 \varsigma --- */
      {  38, 2701,                      /* character number, location */
          5, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\xa2\x01" }  },
      /* --- pixel bitmap for cmmi83 char#39 \varphi --- */
      {  39, 2720,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x59\x4e\x8e\x20\x00" }  },
      /* --- pixel bitmap for cmmi83 char#40 \leftharpoonup --- */
      {  40, 3136,                      /* character number, location */
          5, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x02\xff" }  },
      /* --- pixel bitmap for cmmi83 char#41 \leftharpoondown --- */
      {  41, 3149,                      /* character number, location */
          3, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x02\x04" }  },
      /* --- pixel bitmap for cmmi83 char#42 \rightharpoonup --- */
      {  42, 3162,                      /* character number, location */
          5, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x40\xff" }  },
      /* --- pixel bitmap for cmmi83 char#43 \rightharpoondown --- */
      {  43, 3175,                      /* character number, location */
          3, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x40\x20" }  },
      /* --- pixel bitmap for cmmi83 char#44 ` --- */
      {  44, 3188,                      /* character number, location */
          7, 0,    2, 0,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x02" }  },
      /* --- pixel bitmap for cmmi83 char#45 ' --- */
      {  45, 3205,                      /* character number, location */
          7, 0,    2, 0,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa9\x01" }  },
      /* --- pixel bitmap for cmmi83 char#46 \triangleright --- */
      {  46, 3222,                      /* character number, location */
          4, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x00" }  },
      /* --- pixel bitmap for cmmi83 char#47 \triangleleft --- */
      {  47, 3235,                      /* character number, location */
          4, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x01" }  },
      /* --- pixel bitmap for cmmi83 char#48 \0 --- */
      {  48, 2902,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc6\xe8\x00" }  },
      /* --- pixel bitmap for cmmi83 char#49 \1 --- */
      {  49, 2925,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\x74" }  },
      /* --- pixel bitmap for cmmi83 char#50 \2 --- */
      {  50, 2942,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x42\xfe\x01" }  },
      /* --- pixel bitmap for cmmi83 char#51 \3 --- */
      {  51, 2961,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x21\x06\xa3\x03" }  },
      /* --- pixel bitmap for cmmi83 char#52 \4 --- */
      {  52, 2986,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\xa9\xf5\x11\x07" }  },
      /* --- pixel bitmap for cmmi83 char#53 \5 --- */
      {  53, 3011,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x17\x71\x98\x06" }  },
      /* --- pixel bitmap for cmmi83 char#54 \6 --- */
      {  54, 3034,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\x84\x17\xa3\x03" }  },
      /* --- pixel bitmap for cmmi83 char#55 \7 --- */
      {  55, 3059,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x24\x22\x02" }  },
      /* --- pixel bitmap for cmmi83 char#56 \8 --- */
      {  56, 3082,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x29\x17\xa3\x03" }  },
      /* --- pixel bitmap for cmmi83 char#57 \9 --- */
      {  57, 3111,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x46\x0f\x91\x01" }  },
      /* --- pixel bitmap for cmmi83 char#58 . --- */
      {  58, 3248,                      /* character number, location */
          1, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  1,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01" }  },
      /* --- pixel bitmap for cmmi83 char#59 , --- */
      {  59, 3257,                      /* character number, location */
          1, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  1,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07" }  },
      /* --- pixel bitmap for cmmi83 char#60 < --- */
      {  60, 3270,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\xc4\x08\x81\xc0\x40\x20" }  },
      /* --- pixel bitmap for cmmi83 char#61 / --- */
      {  61, 3295,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x25\x49\x4a\x02" }  },
      /* --- pixel bitmap for cmmi83 char#62 > --- */
      {  62, 3326,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\xc0\x40\x20\xc4\x08\x01" }  },
      /* --- pixel bitmap for cmmi83 char#63 \star --- */
      {  63, 3351,                      /* character number, location */
          3,-1,    1,-1,      /* topleft row,col, and botleft row,col */
          {  6,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x06" }  },
      /* --- pixel bitmap for cmmi83 char#64 \partial --- */
      {  64, 2753,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x42\x1f\x53\x3a" }  },
      /* --- pixel bitmap for cmmi83 char#65 A --- */
      {  65,   35,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x60\x50\x50\x48\x78\x44\xe7" }  },
      /* --- pixel bitmap for cmmi83 char#66 B --- */
      {  66,   68,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\xc8\x44\x7c\x64\x44\x22\x1f" }  },
      /* --- pixel bitmap for cmmi83 char#67 C --- */
      {  67,  101,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x2c\x05\x41\x94\x18" }  },
      /* --- pixel bitmap for cmmi83 char#68 D --- */
      {  68,  132,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x88\x84\x84\x84\x04\x42\x3f" }  },
      /* --- pixel bitmap for cmmi83 char#69 E --- */
      {  69,  165,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xc8\x64\x3c\xa4\x84\x42\x7f" }  },
      /* --- pixel bitmap for cmmi83 char#70 F --- */
      {  70,  200,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xc8\x54\x1c\x14\x04\x02\x07" }  },
      /* --- pixel bitmap for cmmi83 char#71 G --- */
      {  71,  231,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\xb3\x28\x10\x0f\x45\x3c" }  },
      /* --- pixel bitmap for cmmi83 char#72 H --- */
      {  72,  266,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x23\x44\x08\x3f\x84\x10\x22\xc4\x39" }  },
      /* --- pixel bitmap for cmmi83 char#73 I --- */
      {  73,  303,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x11\x42\x88\x38" }  },
      /* --- pixel bitmap for cmmi83 char#74 J --- */
      {  74,  326,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x84\x20\x08\x52\x1c" }  },
      /* --- pixel bitmap for cmmi83 char#75 K --- */
      {  75,  351,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdc\x23\x41\x02\x05\x2c\x90\x20\xc2\x39" }  },
      /* --- pixel bitmap for cmmi83 char#76 L --- */
      {  76,  390,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x04\x81\x40\x24\x8a\x7e" }  },
      /* --- pixel bitmap for cmmi83 char#77 M --- */
      {  77,  419,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x8e\x61\x14\x43\x29\x94\x42\x25\x32\x71\x3b" }  },
      /* --- pixel bitmap for cmmi83 char#78 N --- */
      {  78,  476,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x63\x44\x09\x25\xa4\x90\x22\xc6\x11" }  },
      /* --- pixel bitmap for cmmi83 char#79 O --- */
      {  79,  523,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x28\x86\x61\x14\x39" }  },
      /* --- pixel bitmap for cmmi83 char#80 P --- */
      {  80,  558,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x24\x91\xc8\x23\x08\x0e" }  },
      /* --- pixel bitmap for cmmi83 char#81 Q --- */
      {  81,  587,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x28\x86\x61\x54\x39\x00\x02" }  },
      /* --- pixel bitmap for cmmi83 char#82 R --- */
      {  82,  628,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x88\x44\x3c\x44\x44\x22\x67" }  },
      /* --- pixel bitmap for cmmi83 char#83 S --- */
      {  83,  663,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x0a\x83\x60\x3a" }  },
      /* --- pixel bitmap for cmmi83 char#84 T --- */
      {  84,  690,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xd2\x49\x08\x08\x08\x04\x1e" }  },
      /* --- pixel bitmap for cmmi83 char#85 U --- */
      {  85,  721,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x42\x21\x21\x21\x21\x11\x0f" }  },
      /* --- pixel bitmap for cmmi83 char#86 V --- */
      {  86,  758,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x22\x22\x12\x0a\x0a\x06\x06" }  },
      /* --- pixel bitmap for cmmi83 char#87 W --- */
      {  87,  793,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x97\x89\x4c\x54\xa1\x0a\x33\x98\x41\x04" }  },
      /* --- pixel bitmap for cmmi83 char#88 X --- */
      {  88,  846,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdc\xa1\xc0\x81\x01\x03\x05\x89\x73" }  },
      /* --- pixel bitmap for cmmi83 char#89 Y --- */
      {  89,  879,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x26\x14\x14\x08\x08\x04\x0e" }  },
      /* --- pixel bitmap for cmmi83 char#90 Z --- */
      {  90,  910,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xa5\x21\xa4\x29\x7d" }  },
      /* --- pixel bitmap for cmmi83 char#91 \flat --- */
      {  91, 3362,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\xd2\x76\x03" }  },
      /* --- pixel bitmap for cmmi83 char#92 \natural --- */
      {  92, 3393,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\xdf\xb6\x27" }  },
      /* --- pixel bitmap for cmmi83 char#93 \sharp --- */
      {  93, 3430,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6d\xdf\xb6\x2f" }  },
      /* --- pixel bitmap for cmmi83 char#94 \smile --- */
      {  94, 3473,                      /* character number, location */
          5, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x42\x3c" }  },
      /* --- pixel bitmap for cmmi83 char#95 \frown --- */
      {  95, 3490,                      /* character number, location */
          5, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x42\x81" }  },
      /* --- pixel bitmap for cmmi83 char#96 \ell --- */
      {  96, 2784,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x33\x46\x8c\xe1" }  },
      /* --- pixel bitmap for cmmi83 char#97 a --- */
      {  97,  943,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\xd9\x0b" }  },
      /* --- pixel bitmap for cmmi83 char#98 b --- */
      {  98,  968,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x71\x99\x35" }  },
      /* --- pixel bitmap for cmmi83 char#99 c --- */
      {  99,  997,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x11\x07" }  },
      /* --- pixel bitmap for cmmi83 char#100 d --- */
      { 100, 1016,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x22\x97\x52\x5b" }  },
      /* --- pixel bitmap for cmmi83 char#101 e --- */
      { 101, 1047,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x17\x07" }  },
      /* --- pixel bitmap for cmmi83 char#102 f --- */
      { 102, 1066,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\x64\x22\x22\x11" }  },
      /* --- pixel bitmap for cmmi83 char#103 g --- */
      { 103, 1093,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x59\x47\x03" }  },
      /* --- pixel bitmap for cmmi83 char#104 h --- */
      { 104, 1120,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x08\x27\x65\xce" }  },
      /* --- pixel bitmap for cmmi83 char#105 i --- */
      { 105, 1151,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  2,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x55\x01" }  },
      /* --- pixel bitmap for cmmi83 char#106 j --- */
      { 106, 1172,                      /* character number, location */
          9, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x00\x66\x24\x22\x01" }  },
      /* --- pixel bitmap for cmmi83 char#107 k --- */
      { 107, 1197,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x08\x6d\x4d\x4b" }  },
      /* --- pixel bitmap for cmmi83 char#108 l --- */
      { 108, 1228,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa6\x24\x4d" }  },
      /* --- pixel bitmap for cmmi83 char#109 m --- */
      { 109, 1251,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\x93\x92\xc9\xc9" }  },
      /* --- pixel bitmap for cmmi83 char#110 n --- */
      { 110, 1286,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\xda\x0d" }  },
      /* --- pixel bitmap for cmmi83 char#111 o --- */
      { 111, 1311,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc6\x74\x00" }  },
      /* --- pixel bitmap for cmmi83 char#112 p --- */
      { 112, 1334,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x49\x5a\x8e\x30\x00" }  },
      /* --- pixel bitmap for cmmi83 char#113 q --- */
      { 113, 1361,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x59\x47\x06" }  },
      /* --- pixel bitmap for cmmi83 char#114 r --- */
      { 114, 1388,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\x12\x01" }  },
      /* --- pixel bitmap for cmmi83 char#115 s --- */
      { 115, 1407,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xac\x46\x06" }  },
      /* --- pixel bitmap for cmmi83 char#116 t --- */
      { 116, 1426,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd4\xa5\x09" }  },
      /* --- pixel bitmap for cmmi83 char#117 u --- */
      { 117, 1447,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbb\xda\x0e" }  },
      /* --- pixel bitmap for cmmi83 char#118 v --- */
      { 118, 1472,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbb\x5a\x06" }  },
      /* --- pixel bitmap for cmmi83 char#119 w --- */
      { 119, 1497,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcb\xa5\xb2\xe4\x01" }  },
      /* --- pixel bitmap for cmmi83 char#120 x --- */
      { 120, 1530,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\x92\xf5\x00" }  },
      /* --- pixel bitmap for cmmi83 char#121 y --- */
      { 121, 1551,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbb\x5a\x46\x03" }  },
      /* --- pixel bitmap for cmmi83 char#122 z --- */
      { 122, 1580,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x64\x07" }  },
      /* --- pixel bitmap for cmmi83 char#123 \imath --- */
      { 123, 2807,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  1,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for cmmi83 char#124 \jmath --- */
      { 124, 2824,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x25\x05" }  },
      /* --- pixel bitmap for cmmi83 char#125 \wp --- */
      { 125, 2845,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xa3\x50\xd4\x29\x08\x00" }  },
      /* --- pixel bitmap for cmmi83 char#126 \vec --- */
      { 126, 2876,                      /* character number, location */
          9, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  5,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe8\x23" }  },
      /* --- pixel bitmap for cmmi83 char#127 (noname) --- */
      { 127, 2889,                      /* character number, location */
          8, 3,    6, 3,      /* topleft row,col, and botleft row,col */
          {  3,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2b" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=1 for .100gf ---
 * mf '\mode=preview; mag=magstep(-17.87427405946994351363); input cmmi10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmi100 --- */
static	chardef  cmmi100[] =
   {
      /* --- pixel bitmap for cmmi100 char#0 \Gamma --- */
      {   0,52525,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x11\x23\x24\x44\x80\x00\x01\x01\x0f\x00" }  },
      /* --- pixel bitmap for cmmi100 char#1 \Delta --- */
      {   1,53390,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x00\x03\x1a\x44\x08\x11\x44\xa0\x80\xff\x03" }  },
      /* --- pixel bitmap for cmmi100 char#2 \Theta --- */
      {   2,54515,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x08\x0b\x1c\x98\x33\x60\x20\x21\x3c\x00" }  },
      /* --- pixel bitmap for cmmi100 char#3 \Lambda --- */
      {   3,55411,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\xc0\x40\x81\x82\x04\x09\x11\x21\xe7\x01" }  },
      /* --- pixel bitmap for cmmi100 char#4 \Xi --- */
      {   4,56816,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x09\x02\x20\xc2\x87\x08\x80\x20\x7f\x00" }  },
      /* --- pixel bitmap for cmmi100 char#5 \Pi --- */
      {   5,58037,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x47\x08\x42\x08\x41\x08\x42\x10\x42\x08\xe7\x01" }  },
      /* --- pixel bitmap for cmmi100 char#6 \Sigma --- */
      {   6,59192,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x33\x8c\x20\x44\x30\x60\xc4\x90\x21\xff\x00" }  },
      /* --- pixel bitmap for cmmi100 char#7 \Upsilon --- */
      {   7,60208,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\x12\x62\x40\x80\x00\x01\x02\x02\x1f\x00" }  },
      /* --- pixel bitmap for cmmi100 char#8 \Phi --- */
      {   8,61210,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x7c\x92\x91\xd1\x3e\x08\x3e" }  },
      /* --- pixel bitmap for cmmi100 char#9 \Psi --- */
      {   9,62239,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x20\x44\x4e\x92\x64\x85\x07\x02\x1f\x00" }  },
      /* --- pixel bitmap for cmmi100 char#10 \Omega --- */
      {  10,63426,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x30\x44\xa0\x40\x02\x11\x42\x44\x31\xe7\x00" }  },
      /* --- pixel bitmap for cmmi100 char#11 \alpha --- */
      {  11,64434,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x1c\x47\xd9\x09" }  },
      /* --- pixel bitmap for cmmi100 char#12 \beta --- */
      {  12,65455,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x90\x88\x48\x3c\x44\x44\x44\x26\x1e\x02\x02\x01" }  },
      /* --- pixel bitmap for cmmi100 char#13 \gamma --- */
      {  13,66316,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\x68\x0c\x06\x83\x40\x20\x08" }  },
      /* --- pixel bitmap for cmmi100 char#14 \delta --- */
      {  14,67225,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x08\x42\x56\x4a\x65\x00" }  },
      /* --- pixel bitmap for cmmi100 char#15 \epsilon --- */
      {  15,68065,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x17\x69" }  },
      /* --- pixel bitmap for cmmi100 char#16 \zeta --- */
      {  16,68937,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x13\x21\x42\x08\x61\x30\xe4\x00" }  },
      /* --- pixel bitmap for cmmi100 char#17 \eta --- */
      {  17,69770,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdb\x29\x8a\x51\x04\x41\x08" }  },
      /* --- pixel bitmap for cmmi100 char#18 \theta --- */
      {  18,70480,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x4a\xf9\x5e\x2a\x65\x00" }  },
      /* --- pixel bitmap for cmmi100 char#19 \iota --- */
      {  19,71073,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x54\x01" }  },
      /* --- pixel bitmap for cmmi100 char#20 \kappa --- */
      {  20,71967,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb2\x62\x28\x69\x0c" }  },
      /* --- pixel bitmap for cmmi100 char#21 \lambda --- */
      {  21,72778,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x82\x20\x10\x84\x91\x62\x08" }  },
      /* --- pixel bitmap for cmmi100 char#22 \mu --- */
      {  22,73728,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x22\x91\x68\xf6\x0a\x04\x01" }  },
      /* --- pixel bitmap for cmmi100 char#23 \nu --- */
      {  23,74469,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa3\x28\x49\xcd\x00" }  },
      /* --- pixel bitmap for cmmi100 char#24 \xi --- */
      {  24,75547,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x4e\x10\x04\x27\x08\x81\xc0\x40\x1c" }  },
      /* --- pixel bitmap for cmmi100 char#25 \pi --- */
      {  25,76403,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x15\x14\x14\x12\x22" }  },
      /* --- pixel bitmap for cmmi100 char#26 \rho --- */
      {  26,77185,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x49\x92\x96\x23\x08\x01" }  },
      /* --- pixel bitmap for cmmi100 char#27 \sigma --- */
      {  27,78037,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x49\x24\x92\x30\x00" }  },
      /* --- pixel bitmap for cmmi100 char#28 \tau --- */
      {  28,78742,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x04\x02\x41\x20\x00" }  },
      /* --- pixel bitmap for cmmi100 char#29 \upsilon --- */
      {  29,79565,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\xa1\x50\x28\xe2\x00" }  },
      /* --- pixel bitmap for cmmi100 char#30 \phi --- */
      {  30,80385,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x84\x20\x9c\x5a\x96\x95\x23\x08\x02" }  },
      /* --- pixel bitmap for cmmi100 char#31 \chi --- */
      {  31,81378,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x86\x48\x28\x10\x18\x24\x22\x41" }  },
      /* --- pixel bitmap for cmmi100 char#32 \psi --- */
      {  32,82387,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x20\x20\x10\x92\x93\x92\x4a\x6a\x1c\x08\x04\x04" }  },
      /* --- pixel bitmap for cmmi100 char#33 \omega --- */
      {  33,83452,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\x81\x91\x91\x59\x36" }  },
      /* --- pixel bitmap for cmmi100 char#34 \varepsilon --- */
      {  34,84381,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x30\x11\x1d" }  },
      /* --- pixel bitmap for cmmi100 char#35 \vartheta --- */
      {  35,85330,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x14\x12\x39\x1b\x8b\x24\x12\x07" }  },
      /* --- pixel bitmap for cmmi100 char#36 \varpi --- */
      {  36,86475,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x4f\x10\x89\x48\x44\x13\x66\x00" }  },
      /* --- pixel bitmap for cmmi100 char#37 \varrho --- */
      {  37,87318,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\x4a\xb9\x4e\x08\x07" }  },
      /* --- pixel bitmap for cmmi100 char#38 \varsigma --- */
      {  38,88091,                      /* character number, location */
          6, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x11\x86\x06" }  },
      /* --- pixel bitmap for cmmi100 char#39 \varphi --- */
      {  39,88970,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\x91\x89\x49\x65\x1e\x04\x04\x02" }  },
      /* --- pixel bitmap for cmmi100 char#40 \leftharpoonup --- */
      {  40,103866,                     /* character number, location */
          7, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 12,    4, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x21\x90\x12\x9c" }  },
      /* --- pixel bitmap for cmmi100 char#41 \leftharpoondown --- */
      {  41,104862,                     /* character number, location */
          4, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x6f\x00\x04\x40\x00" }  },
      /* --- pixel bitmap for cmmi100 char#42 \rightharpoonup --- */
      {  42,105856,                     /* character number, location */
          7, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 12,    4, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x91\x20\x92\x1c" }  },
      /* --- pixel bitmap for cmmi100 char#43 \rightharpoondown --- */
      {  43,106853,                     /* character number, location */
          4, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x60\x00\x02\x20" }  },
      /* --- pixel bitmap for cmmi100 char#44 ` --- */
      {  44,107242,                     /* character number, location */
          8, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x02" }  },
      /* --- pixel bitmap for cmmi100 char#45 ' --- */
      {  45,107634,                     /* character number, location */
          8, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa9\x01" }  },
      /* --- pixel bitmap for cmmi100 char#46 \triangleright --- */
      {  46,108143,                     /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\xb4\xd8\x46\x00" }  },
      /* --- pixel bitmap for cmmi100 char#47 \triangleleft --- */
      {  47,108661,                     /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x90\xcb\x28\x39\x04" }  },
      /* --- pixel bitmap for cmmi100 char#48 \0 --- */
      {  48,94905,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc6\x18\x1d" }  },
      /* --- pixel bitmap for cmmi100 char#49 \1 --- */
      {  49,95626,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa6\x10\x42\x3e" }  },
      /* --- pixel bitmap for cmmi100 char#50 \2 --- */
      {  50,96560,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x42\x64\x3f" }  },
      /* --- pixel bitmap for cmmi100 char#51 \3 --- */
      {  51,97545,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x42\xe8\x60\x8c\x0e" }  },
      /* --- pixel bitmap for cmmi100 char#52 \4 --- */
      {  52,98426,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x0c\x45\x32\xf9\x43\x20\x38" }  },
      /* --- pixel bitmap for cmmi100 char#53 \5 --- */
      {  53,99419,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x84\x17\x61\x8c\x0e" }  },
      /* --- pixel bitmap for cmmi100 char#54 \6 --- */
      {  54,100268,                     /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x84\x17\x63\x94\x0e" }  },
      /* --- pixel bitmap for cmmi100 char#55 \7 --- */
      {  55,101121,                     /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x08\x21\x08\x41\x10\x04" }  },
      /* --- pixel bitmap for cmmi100 char#56 \8 --- */
      {  56,102000,                     /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x46\xe5\x62\x8c\x0e" }  },
      /* --- pixel bitmap for cmmi100 char#57 \9 --- */
      {  57,102855,                     /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc5\x18\x3d\x44\x07" }  },
      /* --- pixel bitmap for cmmi100 char#58 . --- */
      {  58,109108,                     /* character number, location */
          1, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  1,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01" }  },
      /* --- pixel bitmap for cmmi100 char#59 , --- */
      {  59,109639,                     /* character number, location */
          1, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  1,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmmi100 char#60 < --- */
      {  60,110267,                     /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\x52\x52\x52\x61\x92\x92\x92\x92" }  },
      /* --- pixel bitmap for cmmi100 char#61 / --- */
      {  61,110761,                     /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x22\x84\x08\x21\x42\x88\x10\x00" }  },
      /* --- pixel bitmap for cmmi100 char#62 > --- */
      {  62,111410,                     /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x92\x92\x92\x91\x62\x52\x52\x52\x71" }  },
      /* --- pixel bitmap for cmmi100 char#63 \star --- */
      {  63,112079,                     /* character number, location */
          4, 0,    2, 0,      /* topleft row,col, and botleft row,col */
          {  6,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x06" }  },
      /* --- pixel bitmap for cmmi100 char#64 \partial --- */
      {  64,89878,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x08\x82\xbc\x18\x46\x91\x03" }  },
      /* --- pixel bitmap for cmmi100 char#65 A --- */
      {  65, 1000,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\xc0\x40\x81\x82\x04\x0f\x11\x21\xe7\x01" }  },
      /* --- pixel bitmap for cmmi100 char#66 B --- */
      {  66, 2304,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x21\x8c\x20\x61\xfc\x10\x44\x90\x20\x7f\x00" }  },
      /* --- pixel bitmap for cmmi100 char#67 C --- */
      {  67, 3245,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x09\x0b\x0c\x10\x20\x40\x20\x21\x3c\x00" }  },
      /* --- pixel bitmap for cmmi100 char#68 D --- */
      {  68, 4329,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x83\x30\x04\x11\x88\x40\x04\x22\x88\x20\xfe\x00" }  },
      /* --- pixel bitmap for cmmi100 char#69 E --- */
      {  69, 5750,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x11\x23\x25\xc5\x83\x24\x29\x61\x7f\x00" }  },
      /* --- pixel bitmap for cmmi100 char#70 F --- */
      {  70, 6983,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x11\x23\x25\xc5\x83\x04\x09\x01\x0f\x00" }  },
      /* --- pixel bitmap for cmmi100 char#71 G --- */
      {  71, 8120,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x09\x0b\x0c\x10\x3e\x50\x20\x21\x7c\x00" }  },
      /* --- pixel bitmap for cmmi100 char#72 H --- */
      {  72, 9341,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x47\x08\x42\x08\xc1\x0f\x42\x10\x42\x08\xe7\x01" }  },
      /* --- pixel bitmap for cmmi100 char#73 I --- */
      {  73,10040,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x82\x10\x04\x41\x08\x0f" }  },
      /* --- pixel bitmap for cmmi100 char#74 J --- */
      {  74,10878,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x08\x02\x81\x40\x12\x06" }  },
      /* --- pixel bitmap for cmmi100 char#75 K --- */
      {  75,12061,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x47\x04\x12\x48\xc0\x03\x36\x10\x41\x08\xcf\x01" }  },
      /* --- pixel bitmap for cmmi100 char#76 L --- */
      {  76,12954,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x20\x40\x40\x80\x00\x21\x42\x42\xfe\x00" }  },
      /* --- pixel bitmap for cmmi100 char#77 M --- */
      {  77,14212,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x3c\x06\x83\xa1\x50\x18\x14\x05\x29\x41\x4a\x88"
            "\x09\x2f\x0f" }  },
      /* --- pixel bitmap for cmmi100 char#78 N --- */
      {  78,15350,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\xc7\x08\x46\x28\x41\x0a\x52\x90\x42\x08\x4f\x00" }  },
      /* --- pixel bitmap for cmmi100 char#79 O --- */
      {  79,16195,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x08\x0b\x0c\x18\x30\x60\x20\x21\x3c\x00" }  },
      /* --- pixel bitmap for cmmi100 char#80 P --- */
      {  80,17278,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x10\x22\x24\xc4\x87\x00\x01\x01\x0f\x00" }  },
      /* --- pixel bitmap for cmmi100 char#81 Q --- */
      {  81,18265,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x08\x0b\x1c\x18\x30\x60\x20\x2d\x3c\x00\x00\x00"
            "\x03" }  },
      /* --- pixel bitmap for cmmi100 char#82 R --- */
      {  82,19576,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x10\x23\x24\xc4\x87\x08\x11\x11\xcf\x01" }  },
      /* --- pixel bitmap for cmmi100 char#83 S --- */
      {  83,20595,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x84\x04\x04\x38\x40\x40\x21\x1f" }  },
      /* --- pixel bitmap for cmmi100 char#84 T --- */
      {  84,21611,                      /* character number, location */
          9,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x17\xa2\x10\x43\x04\x02\x10\x80\x00\x02\x7c\x00" }  },
      /* --- pixel bitmap for cmmi100 char#85 U --- */
      {  85,22591,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xef\x85\x08\x09\x11\x22\x44\x88\x08\x0f\x00" }  },
      /* --- pixel bitmap for cmmi100 char#86 V --- */
      {  86,23491,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x13\x42\x04\x11\x24\x90\x40\x01\x03\x0c\x00" }  },
      /* --- pixel bitmap for cmmi100 char#87 W --- */
      {  87,24856,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\xb9\x30\x42\x8a\x90\x12\x94\x04\xa5\xc0\x28\x10"
            "\x06\x84\x01" }  },
      /* --- pixel bitmap for cmmi100 char#88 X --- */
      {  88,25983,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x87\x08\x28\xc0\x00\x06\x28\x60\x02\x11\xcf\x03" }  },
      /* --- pixel bitmap for cmmi100 char#89 Y --- */
      {  89,27039,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x13\x82\x04\x0a\x38\x40\x00\x01\x02\x3c\x00" }  },
      /* --- pixel bitmap for cmmi100 char#90 Z --- */
      {  90,28084,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x4c\x24\x32\x10\x48\x44\x22\x3f" }  },
      /* --- pixel bitmap for cmmi100 char#91 \flat --- */
      {  91,112714,                     /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\xd2\xf6\x0b" }  },
      /* --- pixel bitmap for cmmi100 char#92 \natural --- */
      {  92,113421,                     /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x84\x7c\x63\x8c\x31\x5f\x08\x01" }  },
      /* --- pixel bitmap for cmmi100 char#93 \sharp --- */
      {  93,114236,                     /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6d\xfb\xb6\xed\x5b" }  },
      /* --- pixel bitmap for cmmi100 char#94 \smile --- */
      {  94,115108,                     /* character number, location */
          6, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 12,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x28\x40\x04\x82\x1f" }  },
      /* --- pixel bitmap for cmmi100 char#95 \frown --- */
      {  95,115946,                     /* character number, location */
          6, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 12,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x20\x02\x14\x80" }  },
      /* --- pixel bitmap for cmmi100 char#96 \ell --- */
      {  96,90620,                      /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x28\x12\x45\xa2\x30\x08\x46\x1c" }  },
      /* --- pixel bitmap for cmmi100 char#97 a --- */
      {  97,28976,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\xc6\x98\x2d" }  },
      /* --- pixel bitmap for cmmi100 char#98 b --- */
      {  98,29788,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x22\x97\x99\x35" }  },
      /* --- pixel bitmap for cmmi100 char#99 c --- */
      {  99,30573,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x11\x79" }  },
      /* --- pixel bitmap for cmmi100 char#100 d --- */
      { 100,31499,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x08\x82\x9c\x14\x45\x99\x05" }  },
      /* --- pixel bitmap for cmmi100 char#101 e --- */
      { 101,32286,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x17\x69" }  },
      /* --- pixel bitmap for cmmi100 char#102 f --- */
      { 102,33416,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x08\x04\x82\x83\x20\x10\x08\x04\x82\x70\x00" }  },
      /* --- pixel bitmap for cmmi100 char#103 g --- */
      { 103,34363,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x49\x92\x14\x07\x41\x0f" }  },
      /* --- pixel bitmap for cmmi100 char#104 h --- */
      { 104,35264,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x41\x10\x9a\x29\x8a\x71\x08" }  },
      /* --- pixel bitmap for cmmi100 char#105 i --- */
      { 105,36040,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x00\x52\x22\x66" }  },
      /* --- pixel bitmap for cmmi100 char#106 j --- */
      { 106,36941,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x00\x00\x18\x05\x41\x08\x82\x10\x07" }  },
      /* --- pixel bitmap for cmmi100 char#107 k --- */
      { 107,37934,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x41\x10\xb2\x6a\x18\x55\x06" }  },
      /* --- pixel bitmap for cmmi100 char#108 l --- */
      { 108,38596,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x26\x29\x49\x13" }  },
      /* --- pixel bitmap for cmmi100 char#109 m --- */
      { 109,39737,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb6\x6b\x16\x91\x88\x24\x52\x11\x01" }  },
      /* --- pixel bitmap for cmmi100 char#110 n --- */
      { 110,40674,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\x16\x89\x24\x15\x01" }  },
      /* --- pixel bitmap for cmmi100 char#111 o --- */
      { 111,41374,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\xc6\x98\x0c" }  },
      /* --- pixel bitmap for cmmi100 char#112 p --- */
      { 112,42280,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x27\x91\x68\xd2\x08\x04\x07" }  },
      /* --- pixel bitmap for cmmi100 char#113 q --- */
      { 113,43157,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x99\x75\x44\x0f" }  },
      /* --- pixel bitmap for cmmi100 char#114 r --- */
      { 114,43958,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x4b\x10\x82\x00" }  },
      /* --- pixel bitmap for cmmi100 char#115 s --- */
      { 115,44854,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\x32\x18\x1d" }  },
      /* --- pixel bitmap for cmmi100 char#116 t --- */
      { 116,45560,                      /* character number, location */
          9,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  4,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\xf8\x44\xa4\x0c" }  },
      /* --- pixel bitmap for cmmi100 char#117 u --- */
      { 117,46548,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe2\x28\x8a\xb2\x0b" }  },
      /* --- pixel bitmap for cmmi100 char#118 v --- */
      { 118,47399,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe2\x28\x8a\x92\x03" }  },
      /* --- pixel bitmap for cmmi100 char#119 w --- */
      { 119,48543,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x47\x8a\x14\x29\xcb\x0d" }  },
      /* --- pixel bitmap for cmmi100 char#120 x --- */
      { 120,49745,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x25\x02\x51\xf2\x00" }  },
      /* --- pixel bitmap for cmmi100 char#121 y --- */
      { 121,50757,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x49\x92\x14\x07\x29\x06" }  },
      /* --- pixel bitmap for cmmi100 char#122 z --- */
      { 122,51611,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xac\x8c\x11\x52\x07" }  },
      /* --- pixel bitmap for cmmi100 char#123 \imath --- */
      { 123,91284,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x64\x03" }  },
      /* --- pixel bitmap for cmmi100 char#124 \jmath --- */
      { 124,92069,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\x42\x88\x10\x22\x07" }  },
      /* --- pixel bitmap for cmmi100 char#125 \wp --- */
      { 125,93174,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x5c\x71\xb8\x9a\x14\x0a\x03" }  },
      /* --- pixel bitmap for cmmi100 char#126 \vec --- */
      { 126,93748,                      /* character number, location */
         10, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          {  7,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa0\x3f\x08" }  },
      /* --- pixel bitmap for cmmi100 char#127 (noname) --- */
      { 127,94258,                      /* character number, location */
         10, 4,    7, 4,      /* topleft row,col, and botleft row,col */
          {  6,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x02" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=2 for .118gf ---
 * mf '\mode=preview; mag=magstep(-16.96645799324018499600); input cmmi10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmi118 --- */
static	chardef  cmmi118[] =
   {
      /* --- pixel bitmap for cmmi118 char#0 \Gamma --- */
      {   0,53147,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x39\xf2\x41\x51\x10\x41\x70\xf3\x31\x80\x21\x95\x71" }  },
      /* --- pixel bitmap for cmmi118 char#1 \Delta --- */
      {   1,54016,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x28\x40\x02\x26\x20\x06\x41\x08\xc4\x40\x04"
            "\x2c\x80\xff\x0f" }  },
      /* --- pixel bitmap for cmmi118 char#2 \Theta --- */
      {   2,55125,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x81\x61\x04\x24\x40\x12\x99\x4f\x89\x14\x60\x02"
            "\x62\x18\x7c\x00" }  },
      /* --- pixel bitmap for cmmi118 char#3 \Lambda --- */
      {   3,56037,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x00\x03\x0a\x28\x90\x40\x82\x08\x22\x84\x18\xf2"
            "\x3c" }  },
      /* --- pixel bitmap for cmmi118 char#4 \Xi --- */
      {   4,57424,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x4f\x40\x00\x00\x00\x08\xc2\x1f\x04\x01\x00\x02"
            "\x12\x10\xff\x01" }  },
      /* --- pixel bitmap for cmmi118 char#5 \Pi --- */
      {   5,58649,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   11, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\xf3\x41\x61\x20\xf3\x31\x61\x30\x21\x61\x45\x25"
            "\x21" }  },
      /* --- pixel bitmap for cmmi118 char#6 \Sigma --- */
      {   6,59786,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x1f\x01\x61\x20\x08\x04\x03\x40\x00\x04\x40\x20"
            "\x0c\xc6\x40\xfc\x0f" }  },
      /* --- pixel bitmap for cmmi118 char#7 \Upsilon --- */
      {   7,60806,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\x27\x08\x02\x04\x10\x20\x80\x00\x02\x08\x10\xf0"
            "\x01" }  },
      /* --- pixel bitmap for cmmi118 char#8 \Phi --- */
      {   8,61786,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x03\x01\x04\x7e\x42\x86\x28\x32\x3f\x20\x40\xc0"
            "\x07" }  },
      /* --- pixel bitmap for cmmi118 char#9 \Psi --- */
      {   9,62819,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\xc1\x88\x45\x24\x22\x89\x48\x82\x0f\x10\x40"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for cmmi118 char#10 \Omega --- */
      {  10,63988,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x61\x90\x00\x05\x28\x40\x01\x09\x44\x10\x45\x29"
            "\xca\x39\x00" }  },
      /* --- pixel bitmap for cmmi118 char#11 \alpha --- */
      {  11,64984,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xa2\xa1\xc1\x41\x71\xce" }  },
      /* --- pixel bitmap for cmmi118 char#12 \beta --- */
      {  12,65987,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x20\x22\x44\x8c\x87\x10\x41\x82\x04\x8d\xe9\x10"
            "\x20\x20\x00" }  },
      /* --- pixel bitmap for cmmi118 char#13 \gamma --- */
      {  13,66854,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x25\x85\x02\x03\x06\x0c\x08\x10\x20\x20\x00" }  },
      /* --- pixel bitmap for cmmi118 char#14 \delta --- */
      {  14,67767,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x41\x10\x8c\x14\x45\x51\x62\x00" }  },
      /* --- pixel bitmap for cmmi118 char#15 \epsilon --- */
      {  15,68611,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x84\x17\xa2\x03" }  },
      /* --- pixel bitmap for cmmi118 char#16 \zeta --- */
      {  16,69485,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x8c\x10\x42\x10\x04\x41\x60\x60\x10\x03" }  },
      /* --- pixel bitmap for cmmi118 char#17 \eta --- */
      {  17,70360,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x66\x91\x48\x14\x89\x40\x20\x08" }  },
      /* --- pixel bitmap for cmmi118 char#18 \theta --- */
      {  18,71104,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x49\x8a\xe2\x17\x45\x49\x62\x00" }  },
      /* --- pixel bitmap for cmmi118 char#19 \iota --- */
      {  19,71729,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x22\x91\x06" }  },
      /* --- pixel bitmap for cmmi118 char#20 \kappa --- */
      {  20,72625,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe4\x12\x0e\x1e\x22\x51\x61" }  },
      /* --- pixel bitmap for cmmi118 char#21 \lambda --- */
      {  21,73438,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x08\x10\x10\x20\x20\x30\x48\x44\x82\x81" }  },
      /* --- pixel bitmap for cmmi118 char#22 \mu --- */
      {  22,74418,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x44\x44\x44\x64\xa6\xde\x02\x02\x01" }  },
      /* --- pixel bitmap for cmmi118 char#23 \nu --- */
      {  23,75165,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x42\x42\x22\x12\x0d\x03" }  },
      /* --- pixel bitmap for cmmi118 char#24 \xi --- */
      {  24,76247,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x6e\x08\x02\x27\x04\x41\x30\x30\x10\x03" }  },
      /* --- pixel bitmap for cmmi118 char#25 \pi --- */
      {  25,77145,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x55\xa4\x20\x41\x82\x84\x08" }  },
      /* --- pixel bitmap for cmmi118 char#26 \rho --- */
      {  26,77933,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x24\x91\x48\x34\x69\x04\x82\x00" }  },
      /* --- pixel bitmap for cmmi118 char#27 \sigma --- */
      {  27,78791,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x22\x21\x21\x11\x11\x0e" }  },
      /* --- pixel bitmap for cmmi118 char#28 \tau --- */
      {  28,79514,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x0a\x09\x08\x08\x04\x04" }  },
      /* --- pixel bitmap for cmmi118 char#29 \upsilon --- */
      {  29,80407,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x89\x85\x84\x44\x64\x18" }  },
      /* --- pixel bitmap for cmmi118 char#30 \phi --- */
      {  30,81261,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x20\x20\x10\x38\x56\x91\x89\x49\x69\x1e\x04\x04"
            "\x04" }  },
      /* --- pixel bitmap for cmmi118 char#31 \chi --- */
      {  31,82234,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x09\x21\x41\x01\x01\x02\x0a\x12\x42\x02\x01" }  },
      /* --- pixel bitmap for cmmi118 char#32 \psi --- */
      {  32,83287,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x01\x04\x10\x46\xa6\x58\x22\x89\x24\x51\x82"
            "\x07\x04\x10\x20\x00" }  },
      /* --- pixel bitmap for cmmi118 char#33 \omega --- */
      {  33,84336,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x0a\x18\x62\x88\x31\xe7\xe4\x0c" }  },
      /* --- pixel bitmap for cmmi118 char#34 \varepsilon --- */
      {  34,85297,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x8c\x17\xe2\x03" }  },
      /* --- pixel bitmap for cmmi118 char#35 \vartheta --- */
      {  35,86288,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x88\x88\x88\xb6\xc5\x45\x44\x24\x24\x1c" }  },
      /* --- pixel bitmap for cmmi118 char#36 \varpi --- */
      {  36,87483,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x5f\x01\x15\x21\x22\x44\x46\xc8\x08\xe7\x00" }  },
      /* --- pixel bitmap for cmmi118 char#37 \varrho --- */
      {  37,88334,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x29\x8a\xe2\xd4\x04\x81\x03" }  },
      /* --- pixel bitmap for cmmi118 char#38 \varsigma --- */
      {  38,89113,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x84\x10\x0c\x42\x0c" }  },
      /* --- pixel bitmap for cmmi118 char#39 \varphi --- */
      {  39,90036,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\x89\x18\x61\x84\x11\x29\xc2\x07\x02\x08\x10\x00" }  },
      /* --- pixel bitmap for cmmi118 char#40 \leftharpoonup --- */
      {  40,105132,                     /* character number, location */
          8, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 14,    4, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\xc1\xc2\xbe" }  },
      /* --- pixel bitmap for cmmi118 char#41 \leftharpoondown --- */
      {  41,106128,                     /* character number, location */
          5, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 14,    4, 3, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x12\xd1\xe1\xa1" }  },
      /* --- pixel bitmap for cmmi118 char#42 \rightharpoonup --- */
      {  42,107122,                     /* character number, location */
          8, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 14,    4, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\xe1\xd2\x1e" }  },
      /* --- pixel bitmap for cmmi118 char#43 \rightharpoondown --- */
      {  43,108119,                     /* character number, location */
          5, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 14,    4, 3, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xb2\xc1\xc1\x31" }  },
      /* --- pixel bitmap for cmmi118 char#44 ` --- */
      {  44,108534,                     /* character number, location */
          9, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x62" }  },
      /* --- pixel bitmap for cmmi118 char#45 ' --- */
      {  45,108952,                     /* character number, location */
          9, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x39" }  },
      /* --- pixel bitmap for cmmi118 char#46 \triangleright --- */
      {  46,109461,                     /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x91\x85\xd9\x11\x00" }  },
      /* --- pixel bitmap for cmmi118 char#47 \triangleleft --- */
      {  47,109979,                     /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x6e\x86\x26\x0e\x02" }  },
      /* --- pixel bitmap for cmmi118 char#48 \0 --- */
      {  48,96123,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\x61\xe8\x01" }  },
      /* --- pixel bitmap for cmmi118 char#49 \1 --- */
      {  49,96848,                      /* character number, location */
          7, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe4\x10\x42\xc8\x07" }  },
      /* --- pixel bitmap for cmmi118 char#50 \2 --- */
      {  50,97782,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x08\xc2\x88\xf9\x03" }  },
      /* --- pixel bitmap for cmmi118 char#51 \3 --- */
      {  51,98769,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x82\x1c\x04\x86\x91\x03" }  },
      /* --- pixel bitmap for cmmi118 char#52 \4 --- */
      {  52,99654,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x30\x28\x24\x22\x23\xff\x20\x20\xf8" }  },
      /* --- pixel bitmap for cmmi118 char#53 \5 --- */
      {  53,100651,                     /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\x17\x04\xdd\x08\x86\x91\x03" }  },
      /* --- pixel bitmap for cmmi118 char#54 \6 --- */
      {  54,101506,                     /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x28\x04\xcd\x14\x86\xa1\xc4\x00" }  },
      /* --- pixel bitmap for cmmi118 char#55 \7 --- */
      {  55,102369,                     /* character number, location */
          8, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x7f\x30\x04\x41\x20\x08\x04\x02\x01" }  },
      /* --- pixel bitmap for cmmi118 char#56 \8 --- */
      {  56,103254,                     /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\x9e\x33\x85\x61\xe8\x01" }  },
      /* --- pixel bitmap for cmmi118 char#57 \9 --- */
      {  57,104115,                     /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x14\x86\xb1\x0b\x42\x91\x03" }  },
      /* --- pixel bitmap for cmmi118 char#58 . --- */
      {  58,110452,                     /* character number, location */
          2, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmmi118 char#59 , --- */
      {  59,111011,                     /* character number, location */
          2, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaf\x01" }  },
      /* --- pixel bitmap for cmmi118 char#60 < --- */
      {  60,111641,                     /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x72\x72\x72\x72\x81\xb2\xb2\xb2\xb2\xb2" }  },
      /* --- pixel bitmap for cmmi118 char#61 / --- */
      {  61,112139,                     /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x41\x10\x82\x20\x04\x41\x08\x82\x10\x04" }  },
      /* --- pixel bitmap for cmmi118 char#62 > --- */
      {  62,112794,                     /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xb2\xb2\xb2\xb2\xb1\x82\x72\x72\x72\x72\x92" }  },
      /* --- pixel bitmap for cmmi118 char#63 \star --- */
      {  63,113467,                     /* character number, location */
          5,-1,    3,-1,      /* topleft row,col, and botleft row,col */
          {  7,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x18" }  },
      /* --- pixel bitmap for cmmi118 char#64 \partial --- */
      {  64,91002,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x42\x40\x80\xbc\x42\x41\x41\x21\x11\x0e" }  },
      /* --- pixel bitmap for cmmi118 char#65 A --- */
      {  65, 1000,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x06\x30\x40\x02\x12\x88\x20\x04\x3f\x04\x21"
            "\xc8\xe3\x01" }  },
      /* --- pixel bitmap for cmmi118 char#66 B --- */
      {  66, 2310,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x0f\x02\x43\x40\x08\x08\xc1\xf0\x0f\x02\x43\x40"
            "\x08\x88\xc0\xfc\x07" }  },
      /* --- pixel bitmap for cmmi118 char#67 C --- */
      {  67, 3233,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x89\x61\x04\x24\x40\x02\x10\x00\x01\x10\x20\x02"
            "\x61\x18\x78\x00" }  },
      /* --- pixel bitmap for cmmi118 char#68 D --- */
      {  68, 4377,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x07\x82\x41\x20\x08\x08\x01\x11\x10\x02\x42\x40"
            "\x08\x84\x60\xfc\x03" }  },
      /* --- pixel bitmap for cmmi118 char#69 E --- */
      {  69, 5780,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x1f\x02\x41\x20\x88\x04\x19\xf0\x01\x22\x42\x44"
            "\x08\x84\xc0\xfc\x0f" }  },
      /* --- pixel bitmap for cmmi118 char#70 F --- */
      {  70, 6993,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x1f\x02\x41\x20\x08\x05\x31\xf0\x03\x42\x40\x08"
            "\x08\x80\x00\x7c\x00" }  },
      /* --- pixel bitmap for cmmi118 char#71 G --- */
      {  71, 8134,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x89\x61\x04\x24\x40\x02\x10\x00\x81\x17\x20\x02"
            "\x62\x10\xf8\x01" }  },
      /* --- pixel bitmap for cmmi118 char#72 H --- */
      {  72, 9361,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   11, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x34\xf3\x41\x61\x20\x38\x30\xf2\x31\x61\x30\x21"
            "\x61\x45\x25\x22" }  },
      /* --- pixel bitmap for cmmi118 char#73 I --- */
      {  73,10068,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\xf3\x41\x30\xf3\x31\x40\x21\x55\x31" }  },
      /* --- pixel bitmap for cmmi118 char#74 J --- */
      {  74,10910,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\xf3\x61\x20\xf3\x51\x31\x31\x53\x51" }  },
      /* --- pixel bitmap for cmmi118 char#75 K --- */
      {  75,12097,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x7c\x08\x06\x84\x00\x22\x00\x0d\x40\x07\x60\x04"
            "\x10\x02\x08\x02\x02\xc1\xc7\x03" }  },
      /* --- pixel bitmap for cmmi118 char#76 L --- */
      {  76,13052,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x40\x00\x01\x04\x10\x20\x80\x20\x82\x08\x13\xf6"
            "\x1f" }  },
      /* --- pixel bitmap for cmmi118 char#77 M --- */
      {  77,14368,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xc0\x61\xc0\x40\x81\x81\x82\x02\x85\x04\x09\x05"
            "\x12\x09\x24\x11\x88\x22\x08\x23\x7c\xf2\x01" }  },
      /* --- pixel bitmap for cmmi118 char#78 N --- */
      {  78,15498,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x3c\x0c\x02\x85\x40\x21\xd0\x08\x22\x81\x48\x20"
            "\x14\x08\x05\xc1\xf0\x21\x00" }  },
      /* --- pixel bitmap for cmmi118 char#79 O --- */
      {  79,16331,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x81\x61\x04\x24\x00\x02\x18\x40\x01\x14\x60\x02"
            "\x62\x18\x7c\x00" }  },
      /* --- pixel bitmap for cmmi118 char#80 P --- */
      {  80,17394,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x10\xf2\x41\x61\x41\x51\x47\x20\xf2\x31\x80\x21"
            "\x95\x71" }  },
      /* --- pixel bitmap for cmmi118 char#81 Q --- */
      {  81,18387,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x81\x61\x04\x24\x40\x02\x18\x40\x01\x14\x60\x32"
            "\xe2\x18\x7c\x00\x04\x40\x00\x1c" }  },
      /* --- pixel bitmap for cmmi118 char#82 R --- */
      {  82,19656,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x07\x81\x10\x08\x81\x10\x84\x1f\x08\x83\x20\x08"
            "\x42\x10\x1f\x0e" }  },
      /* --- pixel bitmap for cmmi118 char#83 S --- */
      {  83,20735,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x22\x44\x10\x01\x0c\xc0\x01\x08\x20\x82\x0c\xd1"
            "\x03" }  },
      /* --- pixel bitmap for cmmi118 char#84 T --- */
      {  84,21763,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x1f\x51\x88\x42\x04\x02\x08\x40\x00\x02\x10\x40"
            "\x80\x1f\x00" }  },
      /* --- pixel bitmap for cmmi118 char#85 U --- */
      {  85,22721,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x34\xf3\x11\x61\x2f\x21\x61\x31\x51\x41\x42\x54"
            "\x61" }  },
      /* --- pixel bitmap for cmmi118 char#86 V --- */
      {  86,23629,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8f\x17\x08\x41\x08\x41\x04\x22\x90\x80\x04\x14\x60"
            "\x00\x03\x00" }  },
      /* --- pixel bitmap for cmmi118 char#87 W --- */
      {  87,24950,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8f\xf7\x42\x41\x42\x21\x22\x11\x22\x11\x12\x09\x12"
            "\x09\x0a\x05\x0a\x05\x06\x02\x06\x02" }  },
      /* --- pixel bitmap for cmmi118 char#88 X --- */
      {  88,26123,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x3c\x08\x01\x24\x00\x05\xc0\x00\x30\x00\x0c\x80"
            "\x04\x10\x01\x82\xf0\xf0\x00" }  },
      /* --- pixel bitmap for cmmi118 char#89 Y --- */
      {  89,27159,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8f\x4f\x10\x84\x80\x0c\x48\x00\x03\x10\x00\x01\x10"
            "\x80\x00\x3e\x00" }  },
      /* --- pixel bitmap for cmmi118 char#90 Z --- */
      {  90,28236,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x67\x10\x41\x08\x01\x04\x10\x40\x04\x21\x84\x11"
            "\xc6\x3f\x00" }  },
      /* --- pixel bitmap for cmmi118 char#91 \flat --- */
      {  91,114102,                     /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x11\xd1\x99\x59\x37" }  },
      /* --- pixel bitmap for cmmi118 char#92 \natural --- */
      {  92,114817,                     /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xd1\x9b\x99\x99\xbd\x88" }  },
      /* --- pixel bitmap for cmmi118 char#93 \sharp --- */
      {  93,115636,                     /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\xd9\x9b\x99\x99\xbd\x19" }  },
      /* --- pixel bitmap for cmmi118 char#94 \smile --- */
      {  94,116512,                     /* character number, location */
          7, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 14,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xa0\x00\x44\x80\x20\x10\xf0\x03" }  },
      /* --- pixel bitmap for cmmi118 char#95 \frown --- */
      {  95,117354,                     /* character number, location */
          7, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 14,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x03\x02\x41\x80\x08\x40\x01\x20" }  },
      /* --- pixel bitmap for cmmi118 char#96 \ell --- */
      {  96,91776,                      /* character number, location */
         11,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x28\x14\x89\xa2\x30\x08\x86\x22\x0e" }  },
      /* --- pixel bitmap for cmmi118 char#97 a --- */
      {  97,29160,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xac\x14\x45\x51\x6a\x03" }  },
      /* --- pixel bitmap for cmmi118 char#98 b --- */
      {  98,29980,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x08\xe1\x66\x8c\x31\x19" }  },
      /* --- pixel bitmap for cmmi118 char#99 c --- */
      {  99,30769,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x86\x10\xa2\x03" }  },
      /* --- pixel bitmap for cmmi118 char#100 d --- */
      { 100,31697,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x10\x08\xc4\x92\x44\x22\x91\x94\x0d" }  },
      /* --- pixel bitmap for cmmi118 char#101 e --- */
      { 101,32518,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\xe6\x13\xa2\x03" }  },
      /* --- pixel bitmap for cmmi118 char#102 f --- */
      { 102,33652,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\xf2\x51\x30\x34\x20\xf4\x41\x40\xf2\x31\x53\x61" }  },
      /* --- pixel bitmap for cmmi118 char#103 g --- */
      { 103,34601,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb0\x48\x44\x44\x44\x24\x38\x20\x20\x1f" }  },
      /* --- pixel bitmap for cmmi118 char#104 h --- */
      { 104,35508,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x81\xc0\x33\x89\x44\x92\x68\x08" }  },
      /* --- pixel bitmap for cmmi118 char#105 i --- */
      { 105,36328,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x00\x60\x59\x24\xca" }  },
      /* --- pixel bitmap for cmmi118 char#106 j --- */
      { 106,37235,                      /* character number, location */
         12, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x00\x00\xc0\xa1\x48\x20\x10\x04\x02\x41\x1c"
            "\x00" }  },
      /* --- pixel bitmap for cmmi118 char#107 k --- */
      { 107,38232,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x81\x40\xd6\x1a\x1c\x92\x54\x0c" }  },
      /* --- pixel bitmap for cmmi118 char#108 l --- */
      { 108,38898,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x44\x24\x22\x52\x06" }  },
      /* --- pixel bitmap for cmmi118 char#109 m --- */
      { 109,40057,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xae\x33\x35\x22\x42\x44\x48\x84\xa8\x10\x02" }  },
      /* --- pixel bitmap for cmmi118 char#110 n --- */
      { 110,41068,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\x4d\x45\x44\x24\xa2\x42" }  },
      /* --- pixel bitmap for cmmi118 char#111 o --- */
      { 111,41776,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x18\x86\x51\xe4\x00" }  },
      /* --- pixel bitmap for cmmi118 char#112 p --- */
      { 112,42686,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6c\x9a\x8a\x88\x88\x4c\x34\x04\x04\x0f" }  },
      /* --- pixel bitmap for cmmi118 char#113 q --- */
      { 113,43571,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xac\x14\x45\x51\xe2\x20\x88\x07" }  },
      /* --- pixel bitmap for cmmi118 char#114 r --- */
      { 114,44392,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x66\x81\x40\x10\x08\x00" }  },
      /* --- pixel bitmap for cmmi118 char#115 s --- */
      { 115,45346,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x12\x01\x07\x0c\x79\x00" }  },
      /* --- pixel bitmap for cmmi118 char#116 t --- */
      { 116,46054,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x90\x2f\x84\x10\xc9\x00" }  },
      /* --- pixel bitmap for cmmi118 char#117 u --- */
      { 117,47032,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x49\x45\x44\x64\xa4\xdc" }  },
      /* --- pixel bitmap for cmmi118 char#118 v --- */
      { 118,47907,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\x64\x91\x48\x22\x71\x00" }  },
      /* --- pixel bitmap for cmmi118 char#119 w --- */
      { 119,49073,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x4c\x62\x11\x89\x48\x24\x32\x61\x07" }  },
      /* --- pixel bitmap for cmmi118 char#120 x --- */
      { 120,50285,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x94\x12\x10\x10\x59\x36" }  },
      /* --- pixel bitmap for cmmi118 char#121 y --- */
      { 121,51317,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x49\x45\x44\x64\x24\x3c\x20\x12\x0e" }  },
      /* --- pixel bitmap for cmmi118 char#122 z --- */
      { 122,52229,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x62\x20\x18\x44\x26\x19" }  },
      /* --- pixel bitmap for cmmi118 char#123 \imath --- */
      { 123,92484,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x45\xa2\x0c" }  },
      /* --- pixel bitmap for cmmi118 char#124 \jmath --- */
      { 124,93275,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x4a\x82\x20\x04\x41\xc8\x01" }  },
      /* --- pixel bitmap for cmmi118 char#125 \wp --- */
      { 125,94358,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xc4\x65\x2c\x38\x50\x52\x99\x04\x09\x0c\x00" }  },
      /* --- pixel bitmap for cmmi118 char#126 \vec --- */
      { 126,94940,                      /* character number, location */
         11, 2,    8, 2,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\xff\x40" }  },
      /* --- pixel bitmap for cmmi118 char#127 (noname) --- */
      { 127,95476,                      /* character number, location */
         11, 4,    8, 4,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x82\x81" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=3 for .131gf ---
 * mf '\mode=preview; mag=magstep(-16.39322518098640003469); input cmmi10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmi131 --- */
static	chardef  cmmi131[] =
   {
      /* --- pixel bitmap for cmmi131 char#0 \Gamma --- */
      {   0,53970,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3a\x52\x42\xf2\x42\x51\x10\x42\x70\xf3\x32\x80\x22"
            "\x96\x71" }  },
      /* --- pixel bitmap for cmmi131 char#1 \Delta --- */
      {   1,54869,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\xb2\xa4\x81\x22\x72\x22\x71\x33\x51\x52\x41\x62"
            "\x32\x62\x31\x73\x1e\x0b" }  },
      /* --- pixel bitmap for cmmi131 char#2 \Theta --- */
      {   2,56028,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x86\x21\x30\x06\x6c\x92\xcd\xf3\x3c\x9b\x64"
            "\x03\xc6\xc0\x18\x06\x7c\x00" }  },
      /* --- pixel bitmap for cmmi131 char#3 \Lambda --- */
      {   3,56972,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x18\x80\x01\x1c\xa0\x01\x1a\x90\x03\x31\x08"
            "\x43\x30\x04\xf3\xfc" }  },
      /* --- pixel bitmap for cmmi131 char#4 \Xi --- */
      {   4,58385,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x3a\xf1\x21\x81\x10\x41\x41\x76\x66\x71\x41\x40"
            "\xf1\x11\x81\x2f\x1a\x31" }  },
      /* --- pixel bitmap for cmmi131 char#5 \Pi --- */
      {   5,59564,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   12, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x52\x62\x20\xf3\x42\x62\x30\xf3\x32\x62\x40\x22"
            "\x62\x56\x26\x3f" }  },
      /* --- pixel bitmap for cmmi131 char#6 \Sigma --- */
      {   6,60731,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x3f\x0e\x0c\x03\xc1\x41\x60\x10\x38\x00\x0c\x80"
            "\x20\x10\x08\x02\x43\x60\xf8\x1f" }  },
      /* --- pixel bitmap for cmmi131 char#7 \Upsilon --- */
      {   7,61783,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x13\x48\x24\x41\x11\x40\xf2\x42\x50\xf3\x32\x60\x22"
            "\x76\x51" }  },
      /* --- pixel bitmap for cmmi131 char#8 \Phi --- */
      {   8,62791,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x07\x18\xc0\x00\x3f\xcc\x66\xcc\x63\x66\x36\xfc"
            "\x00\x06\x30\xc0\x0f" }  },
      /* --- pixel bitmap for cmmi131 char#9 \Psi --- */
      {   9,63856,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x03\x0c\x67\x6c\x66\x66\x66\x66\x36\x63\x1b\xfc"
            "\x00\x03\x18\xe0\x07" }  },
      /* --- pixel bitmap for cmmi131 char#10 \Omega --- */
      {  10,65057,                      /* character number, location */
         12, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x83\x61\x0c\x6c\xc0\x06\x6c\x60\x06\x66\x30\x05"
            "\x55\x28\x87\x73\x1c" }  },
      /* --- pixel bitmap for cmmi131 char#11 \alpha --- */
      {  11,66083,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x10\x29\x54\x50\xc1\x04\x11\x8a\x67" }  },
      /* --- pixel bitmap for cmmi131 char#12 \beta --- */
      {  12,67094,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 11,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x01\x11\x04\x21\x84\x30\x74\x20\x84\x40\x04\x22"
            "\x10\x41\x0c\xa1\x07\x01\x08\x20\x00\x01\x00" }  },
      /* --- pixel bitmap for cmmi131 char#13 \gamma --- */
      {  13,67999,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x9a\x14\x14\x50\xc0\x00\x03\x0c\x10\x40\x00\x01"
            "\x02\x08" }  },
      /* --- pixel bitmap for cmmi131 char#14 \delta --- */
      {  14,68918,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x34\x81\x80\x40\x60\x28\xa2\x50\x28\x14\x71\x00" }  },
      /* --- pixel bitmap for cmmi131 char#15 \epsilon --- */
      {  15,69746,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb8\x21\x7c\x41\x20\x72" }  },
      /* --- pixel bitmap for cmmi131 char#16 \zeta --- */
      {  16,70648,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x20\xe0\x18\x04\x04\x02\x01\x01\x01\x01\x01\x06"
            "\x18\x20\x20\x1c" }  },
      /* --- pixel bitmap for cmmi131 char#17 \eta --- */
      {  17,71529,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe6\x9a\x8d\x84\x84\x84\x42\x42\x40\x40\x20\x20" }  },
      /* --- pixel bitmap for cmmi131 char#18 \theta --- */
      {  18,72279,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x24\x91\x28\x14\xfa\x43\xa1\x50\x24\x61\x00" }  },
      /* --- pixel bitmap for cmmi131 char#19 \iota --- */
      {  19,72912,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x08\x21\x62\x32" }  },
      /* --- pixel bitmap for cmmi131 char#20 \kappa --- */
      {  20,73812,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\xc9\x48\xf0\x20\x42\x68\xa8\x60" }  },
      /* --- pixel bitmap for cmmi131 char#21 \lambda --- */
      {  21,74633,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x20\x40\x00\x01\x02\x04\x10\x30\x50\x10\x11\x12"
            "\x14\x10" }  },
      /* --- pixel bitmap for cmmi131 char#22 \mu --- */
      {  22,75619,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x21\x44\x08\x21\x84\x10\x6b\x94\x6e\x02\x08\x10"
            "\x40\x00" }  },
      /* --- pixel bitmap for cmmi131 char#23 \nu --- */
      {  23,76376,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x09\x0a\x12\x22\x44\x46\x83\x01" }  },
      /* --- pixel bitmap for cmmi131 char#24 \xi --- */
      {  24,77488,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x10\xf8\x04\x02\x02\x7c\x06\x02\x01\x01\x01\x03"
            "\x0c\x30\x20\x1c" }  },
      /* --- pixel bitmap for cmmi131 char#25 \pi --- */
      {  25,78392,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x4b\x91\x04\x12\x48\x10\x41\x04\x11" }  },
      /* --- pixel bitmap for cmmi131 char#26 \rho --- */
      {  26,79184,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x88\x88\x84\x84\x44\x46\x3a\x02\x02\x01\x01" }  },
      /* --- pixel bitmap for cmmi131 char#27 \sigma --- */
      {  27,80048,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x89\x08\x09\x12\x24\x44\x04\x07" }  },
      /* --- pixel bitmap for cmmi131 char#28 \tau --- */
      {  28,80801,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x45\x44\x80\x00\x01\x02\x02\x04" }  },
      /* --- pixel bitmap for cmmi131 char#29 \upsilon --- */
      {  29,81696,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x15\x26\x24\x48\x90\x10\x11\x1c" }  },
      /* --- pixel bitmap for cmmi131 char#30 \phi --- */
      {  30,82554,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x80\x00\x01\x01\x02\x0f\x29\x89\x11\x23\x46\x52"
            "\xc2\x03\x01\x02\x02\x04\x00" }  },
      /* --- pixel bitmap for cmmi131 char#31 \chi --- */
      {  31,83563,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x1a\x84\x10\x22\x50\xc0\x00\x03\x0a\x44\x08\x21"
            "\x58\x60" }  },
      /* --- pixel bitmap for cmmi131 char#32 \psi --- */
      {  32,84624,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 11,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x04\x20\x00\x01\x08\x23\x2a\x31\x89\x44\x24"
            "\x21\x89\x48\x82\x0f\x08\x40\x00\x02\x10\x00" }  },
      /* --- pixel bitmap for cmmi131 char#33 \omega --- */
      {  33,85683,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0a\x38\x61\x84\x11\x66\x94\x99\x39" }  },
      /* --- pixel bitmap for cmmi131 char#34 \varepsilon --- */
      {  34,86624,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x10\x78\x43\x10\x7a" }  },
      /* --- pixel bitmap for cmmi131 char#35 \vartheta --- */
      {  35,87617,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x40\x82\x04\x09\xd2\xa8\xe2\x42\x84\x08\x11\x21"
            "\x81\x01" }  },
      /* --- pixel bitmap for cmmi131 char#36 \varpi --- */
      {  36,88820,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x7f\x05\x48\x02\x84\x10\x42\x08\x21\x46\x90\x22"
            "\x30\x0e" }  },
      /* --- pixel bitmap for cmmi131 char#37 \varrho --- */
      {  37,89677,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x22\x51\x28\x14\x8d\x3a\x81\x40\xc0\x03" }  },
      /* --- pixel bitmap for cmmi131 char#38 \varsigma --- */
      {  38,90488,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb8\x21\x04\x81\xc0\x40\x10\x07" }  },
      /* --- pixel bitmap for cmmi131 char#39 \varphi --- */
      {  39,91413,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x89\x19\x62\x84\x11\x46\xa4\x0c\x0f\x08\x20\x40"
            "\x00\x01" }  },
      /* --- pixel bitmap for cmmi131 char#40 \leftharpoonup --- */
      {  40,106945,                     /* character number, location */
          9, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 16,    5, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x31\xc0\x21\xe2\xde\x02" }  },
      /* --- pixel bitmap for cmmi131 char#41 \leftharpoondown --- */
      {  41,107969,                     /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,    5, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x12\xe0\x11\xd0\xf1\x31\xc1" }  },
      /* --- pixel bitmap for cmmi131 char#42 \rightharpoonup --- */
      {  42,108991,                     /* character number, location */
          9, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 16,    5, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xc1\x30\xd1\xe0\x12\x1e\x02" }  },
      /* --- pixel bitmap for cmmi131 char#43 \rightharpoondown --- */
      {  43,110016,                     /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,    5, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\xd2\xe1\x20\xf1\xc1\x32" }  },
      /* --- pixel bitmap for cmmi131 char#44 ` --- */
      {  44,110433,                     /* character number, location */
          9, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x62" }  },
      /* --- pixel bitmap for cmmi131 char#45 ' --- */
      {  45,110851,                     /* character number, location */
          9, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x39" }  },
      /* --- pixel bitmap for cmmi131 char#46 \triangleright --- */
      {  46,111386,                     /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x43\x22\x16\x8c\x25\x0e\x01" }  },
      /* --- pixel bitmap for cmmi131 char#47 \triangleleft --- */
      {  47,111938,                     /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x38\xd2\x18\x34\x22\xe1\x40" }  },
      /* --- pixel bitmap for cmmi131 char#48 \0 --- */
      {  48,97636,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x0c\x8a\x7c" }  },
      /* --- pixel bitmap for cmmi131 char#49 \1 --- */
      {  49,98391,                      /* character number, location */
          8, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe4\x10\x42\x08\xf9" }  },
      /* --- pixel bitmap for cmmi131 char#50 \2 --- */
      {  50,99353,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\x70\x10\x0c\xc3\xfa\xff" }  },
      /* --- pixel bitmap for cmmi131 char#51 \3 --- */
      {  51,100370,                     /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x70\x18\x0c\xe2\xc0\xc0\xe0\x71\xcc\x03" }  },
      /* --- pixel bitmap for cmmi131 char#52 \4 --- */
      {  52,101285,                     /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x30\x28\x2c\x24\x22\x23\xff\x20\x20\x20\xf8" }  },
      /* --- pixel bitmap for cmmi131 char#53 \5 --- */
      {  53,102314,                     /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x8f\x43\x20\xf0\x88\xc0\xe0\x70\xcc\x03" }  },
      /* --- pixel bitmap for cmmi131 char#54 \6 --- */
      {  54,103197,                     /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xa2\x20\xd0\x19\x05\x83\x41\xa1\x88\x03" }  },
      /* --- pixel bitmap for cmmi131 char#55 \7 --- */
      {  55,104090,                     /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xfe\x82\x41\x20\x10\x10\x10\x08\x08\x08\x08\x08" }  },
      /* --- pixel bitmap for cmmi131 char#56 \8 --- */
      {  56,105005,                     /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x70\x70\xe8\xe2\xe8\xc2\xc1\xa0\x88\x03" }  },
      /* --- pixel bitmap for cmmi131 char#57 \9 --- */
      {  57,105896,                     /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x28\x18\x14\x73\x81\x40\x50\xc4\x01" }  },
      /* --- pixel bitmap for cmmi131 char#58 . --- */
      {  58,112419,                     /* character number, location */
          2, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmmi131 char#59 , --- */
      {  59,112978,                     /* character number, location */
          2, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  2,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaf\x06" }  },
      /* --- pixel bitmap for cmmi131 char#60 < --- */
      {  60,113636,                     /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x72\x62\x62\x62\x71\xa2\xa2\xa2\xa2\xa1" }  },
      /* --- pixel bitmap for cmmi131 char#61 / --- */
      {  61,114160,                     /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  7,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x08\x04\x82\x40\x20\x08\x04\x82\x40\x20\x08"
            "\x04\x82\x40\x00" }  },
      /* --- pixel bitmap for cmmi131 char#62 > --- */
      {  62,114847,                     /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xc2\xc2\xc2\xc2\xc2\x82\x82\x82\x82\x82\xa2" }  },
      /* --- pixel bitmap for cmmi131 char#63 \star --- */
      {  63,115546,                     /* character number, location */
          5, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          {  7,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x18" }  },
      /* --- pixel bitmap for cmmi131 char#64 \partial --- */
      {  64,92387,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x08\x01\x02\x08\x10\x2f\x61\x41\x81\x02\x05\x09"
            "\xe1\x01" }  },
      /* --- pixel bitmap for cmmi131 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x03\x60\x00\x0e\xa0\x01\x34\x40\x06\xcc\x80\x18"
            "\xf8\x03\xc1\x10\x98\xc7\x0f" }  },
      /* --- pixel bitmap for cmmi131 char#66 B --- */
      {  66, 2366,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x0f\x0c\xc3\x60\x18\x0c\xc3\xe1\x0f\x06\xc3\xc0"
            "\x18\x18\x83\x31\xb8\xff\x01" }  },
      /* --- pixel bitmap for cmmi131 char#67 C --- */
      {  67, 3319,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x13\x86\x23\x20\x06\x64\x00\x0c\xc0\x00\x18\x00"
            "\x02\xc4\x40\x10\x04\x7c\x00" }  },
      /* --- pixel bitmap for cmmi131 char#68 D --- */
      {  68, 4439,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x39\x82\x52\x52\x71\x10\xf2\x42\x72\xf1\x32\x72\x10"
            "\x32\x71\x52\x62\x42\x52\x4a\x55" }  },
      /* --- pixel bitmap for cmmi131 char#69 E --- */
      {  69, 5872,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x3f\x18\x0c\x03\xc1\x48\x30\x12\xfc\x80\x11\x60"
            "\x44\x18\x10\x06\xc2\xc0\xfc\x1f" }  },
      /* --- pixel bitmap for cmmi131 char#70 F --- */
      {  70, 7115,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x1f\x0c\xc3\x40\x18\x09\x23\xe1\x07\x46\xc0\x08"
            "\x18\x00\x03\x30\x80\x3f\x00" }  },
      /* --- pixel bitmap for cmmi131 char#71 G --- */
      {  71, 8286,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x13\x86\x23\x20\x06\x64\x00\x0c\xc0\xe0\x1f\x30"
            "\x02\xc6\xc0\x10\x0c\x7c\x01" }  },
      /* --- pixel bitmap for cmmi131 char#72 H --- */
      {  72, 9467,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   12, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x26\x52\x62\x20\xf2\x42\x62\x30\x4a\x30\xf3\x32"
            "\x62\x40\x22\x62\x56\x26\x32" }  },
      /* --- pixel bitmap for cmmi131 char#73 I --- */
      {  73,10178,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x52\x20\xf3\x42\x30\xf3\x32\x40\x22\x56\x33" }  },
      /* --- pixel bitmap for cmmi131 char#74 J --- */
      {  74,11022,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x03\x06\x0c\x30\xc0\x00\x03\x06\x18\x60\x98\x31"
            "\x83\x07" }  },
      /* --- pixel bitmap for cmmi131 char#75 K --- */
      {  75,12213,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xf9\x60\x10\x30\x0c\x30\x06\x30\x01\xf0\x01\x78"
            "\x03\x18\x03\x18\x07\x18\x06\x0c\x06\x3f\x1f" }  },
      /* --- pixel bitmap for cmmi131 char#76 L --- */
      {  76,13170,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x03\x0c\x60\x00\x03\x18\x60\x00\x83\x18\xc4"
            "\x30\xc3\xfe\x07" }  },
      /* --- pixel bitmap for cmmi131 char#77 M --- */
      {  77,14488,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 20,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x80\x0f\x0e\x30\xd0\xc0\x01\x0d\x1a\xd0\x80\x01"
            "\x0d\x19\x88\xc9\x80\x18\x0c\x88\xc5\x80\x38\x0c\x84"
            "\x61\xf0\x99\x1f" }  },
      /* --- pixel bitmap for cmmi131 char#78 N --- */
      {  78,15620,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xf0\xc1\x81\x40\x87\x80\x0c\x01\x39\x02\x62\x04"
            "\xc2\x05\x04\x0b\x08\x1e\x10\x38\x10\x30\xf8\x40\x00" }  },
      /* --- pixel bitmap for cmmi131 char#79 O --- */
      {  79,16507,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x86\x21\x30\x06\x6c\x80\x0d\xf0\x00\x1b\x60"
            "\x03\xc6\xc0\x38\x06\x7c\x00" }  },
      /* --- pixel bitmap for cmmi131 char#80 P --- */
      {  80,17628,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x39\x62\x42\xf2\x42\x52\x42\x42\x47\x30\xf2\x32\x80"
            "\x22\x96\x72" }  },
      /* --- pixel bitmap for cmmi131 char#81 Q --- */
      {  81,18651,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 13,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x86\x21\x30\x06\x6c\x80\x0d\xf0\x00\x1b\x60"
            "\x03\xc6\xce\x38\x06\x7c\x00\x00\x00\x09\xe0\x00\x0c" }  },
      /* --- pixel bitmap for cmmi131 char#82 R --- */
      {  82,19980,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x39\x62\x42\xf1\x42\x52\x42\x42\x56\x30\xf3\x32\x42"
            "\x20\x22\x43\x17\x34" }  },
      /* --- pixel bitmap for cmmi131 char#83 S --- */
      {  83,21065,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xc5\x30\x82\x18\xc0\x01\x7c\xc0\x07\x30\x80\x11"
            "\xc4\x30\x7a\x00" }  },
      /* --- pixel bitmap for cmmi131 char#84 T --- */
      {  84,22121,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x2f\xcc\x63\x14\x46\x61\x04\x06\x30\x00\x03\x30"
            "\x00\x03\x18\xe0\x0f" }  },
      /* --- pixel bitmap for cmmi131 char#85 U --- */
      {  85,23111,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x35\x22\x71\x20\xf3\x12\x71\x3f\x22\x71\x42\x61"
            "\x61\x51\x85\x72" }  },
      /* --- pixel bitmap for cmmi131 char#86 V --- */
      {  86,24049,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x3e\x03\xc1\x40\x30\x08\x0c\x01\x46\x80\x09\x60"
            "\x01\x58\x00\x0e\x80\x01\x60\x00" }  },
      /* --- pixel bitmap for cmmi131 char#87 W --- */
      {  87,25439,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\xcf\x67\x18\x04\xc3\x21\x18\x8e\xc0\x68\x04\x26"
            "\x13\x30\x99\x80\xc5\x02\x2c\x0e\xe0\x70\x00\x86\x01"
            "\x10\x0c\x00" }  },
      /* --- pixel bitmap for cmmi131 char#88 X --- */
      {  88,26556,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   12, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x25\x62\x41\x92\x31\xa3\x11\x50\xf2\x73\x60\x61"
            "\x12\xb1\x32\x91\x42\x82\x43\x46\x26\x20" }  },
      /* --- pixel bitmap for cmmi131 char#89 Y --- */
      {  89,27648,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x35\x22\x61\x53\x41\x72\x31\x82\x22\x94\xa3\x70"
            "\xf2\x42\x80\x32\xa6\x72" }  },
      /* --- pixel bitmap for cmmi131 char#90 Z --- */
      {  90,28727,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x8f\x61\x0c\x43\x18\xc4\x00\x0e\x70\x00\x23\x18"
            "\xc2\x30\x86\xf1\x1f" }  },
      /* --- pixel bitmap for cmmi131 char#91 \flat --- */
      {  91,116207,                     /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x84\x10\xc2\x8e\x31\xa6\x54\x06" }  },
      /* --- pixel bitmap for cmmi131 char#92 \natural --- */
      {  92,116956,                     /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  5,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x84\x90\x6f\x8c\x31\xc6\x98\x2f\x84\x10" }  },
      /* --- pixel bitmap for cmmi131 char#93 \sharp --- */
      {  93,117809,                     /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  5,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4a\x29\xa5\x9f\x52\x4a\x29\xa5\x9f\x52\x0a" }  },
      /* --- pixel bitmap for cmmi131 char#94 \smile --- */
      {  94,118723,                     /* character number, location */
          7, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 16,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x80\x02\x40\x0c\x30\xf0\x0f" }  },
      /* --- pixel bitmap for cmmi131 char#95 \frown --- */
      {  95,119587,                     /* character number, location */
          7, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 16,    4, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x62\x82\x31\xc1\x11\xe1" }  },
      /* --- pixel bitmap for cmmi131 char#96 \ell --- */
      {  96,93167,                      /* character number, location */
         13,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x40\x42\x84\x84\x08\x09\x0a\x0a\x0c\x08\x18\x40"
            "\x04\x07" }  },
      /* --- pixel bitmap for cmmi131 char#97 a --- */
      {  97,29655,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x62\x22\x21\x21\xb1\x51\x6e" }  },
      /* --- pixel bitmap for cmmi131 char#98 b --- */
      {  98,30481,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x41\x08\x82\x27\x8e\x61\x18\x45\x0e" }  },
      /* --- pixel bitmap for cmmi131 char#99 c --- */
      {  99,31276,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xa2\x20\x10\x08\x84\x3c" }  },
      /* --- pixel bitmap for cmmi131 char#100 d --- */
      { 100,32206,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x80\x80\x40\x40\x5c\x62\x22\x21\x21\xb1\x51\x6e" }  },
      /* --- pixel bitmap for cmmi131 char#101 e --- */
      { 101,33009,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xa3\xe8\x13\x08\x84\x3c" }  },
      /* --- pixel bitmap for cmmi131 char#102 f --- */
      { 102,34171,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   17, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\x71\x11\xf2\x51\x30\x43\x71\x30\xf4\x41\x40\xf2"
            "\x31\x51\x21\x62\x62" }  },
      /* --- pixel bitmap for cmmi131 char#103 g --- */
      { 103,35130,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb8\xc4\x44\x42\x42\x62\x22\x3c\x20\x20\x10\x0f" }  },
      /* --- pixel bitmap for cmmi131 char#104 h --- */
      { 104,36043,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x10\x20\x20\x40\x80\x0e\x13\x23\x42\x84\x88\x0c"
            "\x15\x0c" }  },
      /* --- pixel bitmap for cmmi131 char#105 i --- */
      { 105,36873,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x00\x00\x8c\x4a\x84\x48\xc5\x00" }  },
      /* --- pixel bitmap for cmmi131 char#106 j --- */
      { 106,37784,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  8,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x00\x00\x00\x30\x48\x24\x20\x20\x20\x10\x10"
            "\x10\x10\x08\x07" }  },
      /* --- pixel bitmap for cmmi131 char#107 k --- */
      { 107,38785,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x10\x20\x20\x40\x80\x1c\x45\x05\x0e\x24\x88\x8a"
            "\x12\x06" }  },
      /* --- pixel bitmap for cmmi131 char#108 l --- */
      { 108,39475,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x48\x44\x24\x22\x5a\x06" }  },
      /* --- pixel bitmap for cmmi131 char#109 m --- */
      { 109,40692,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe6\x1c\x4d\x49\x63\x84\x10\x42\x08\x21\x44\x0a\xa1"
            "\x84\x60" }  },
      /* --- pixel bitmap for cmmi131 char#110 n --- */
      { 110,41713,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe6\x68\xd2\x08\x21\x84\x10\x29\x94\x60" }  },
      /* --- pixel bitmap for cmmi131 char#111 o --- */
      { 111,42427,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xa2\x30\x18\x0c\x45\x1c" }  },
      /* --- pixel bitmap for cmmi131 char#112 p --- */
      { 112,43381,                      /* character number, location */
          8,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xec\x28\x6a\x44\x88\x10\x11\x23\x3a\x04\x08\x08\x78"
            "\x00" }  },
      /* --- pixel bitmap for cmmi131 char#113 q --- */
      { 113,44272,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\xb1\x28\x14\x8a\x45\x3c\x10\x08\x82\x07" }  },
      /* --- pixel bitmap for cmmi131 char#114 r --- */
      { 114,45125,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\x8a\x0d\x04\x04\x04\x02\x02" }  },
      /* --- pixel bitmap for cmmi131 char#115 s --- */
      { 115,46055,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xa2\x80\x03\x02\x86\x3c" }  },
      /* --- pixel bitmap for cmmi131 char#116 t --- */
      { 116,46791,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x82\xfc\x08\x41\x10\xa4\xc4\x00" }  },
      /* --- pixel bitmap for cmmi131 char#117 u --- */
      { 117,47799,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x29\x94\x08\x21\x84\x10\x4b\x14\x6e" }  },
      /* --- pixel bitmap for cmmi131 char#118 v --- */
      { 118,48680,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x8a\x89\x84\x84\x44\x44\x38" }  },
      /* --- pixel bitmap for cmmi131 char#119 w --- */
      { 119,49850,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xa8\x88\x49\x48\x84\x44\x48\x44\x64\x84\x39" }  },
      /* --- pixel bitmap for cmmi131 char#120 x --- */
      { 120,51068,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd8\xd1\x28\x01\x04\x10\x40\x94\x89\x1d" }  },
      /* --- pixel bitmap for cmmi131 char#121 y --- */
      { 121,52132,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x15\x26\x22\x44\x88\x18\x11\x3c\x40\x40\x44\x70"
            "\x00" }  },
      /* --- pixel bitmap for cmmi131 char#122 z --- */
      { 122,53024,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x64\x20\x10\x08\x44\x26\x19" }  },
      /* --- pixel bitmap for cmmi131 char#123 \imath --- */
      { 123,93907,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x25\x42\xa4\x62" }  },
      /* --- pixel bitmap for cmmi131 char#124 \jmath --- */
      { 124,94676,                      /* character number, location */
          8,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x90\x48\x40\x40\x40\x20\x20\x20\x20\x10\x0f" }  },
      /* --- pixel bitmap for cmmi131 char#125 \wp --- */
      { 125,95815,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x90\x27\xa1\x82\x06\x0a\x24\x51\x39\x09\x24\x50"
            "\x80\x00" }  },
      /* --- pixel bitmap for cmmi131 char#126 \vec --- */
      { 126,96431,                      /* character number, location */
         13, 4,   10, 4,      /* topleft row,col, and botleft row,col */
          {  7,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa0\x3f\x08" }  },
      /* --- pixel bitmap for cmmi131 char#127 (noname) --- */
      { 127,96967,                      /* character number, location */
         12, 5,   10, 5,      /* topleft row,col, and botleft row,col */
          {  8,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x81" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=4 for .160gf ---
 * mf '\mode=preview; mag=magstep(-15.29639112828755784636); input cmmi10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmi160 --- */
static	chardef  cmmi160[] =
   {
      /* --- pixel bitmap for cmmi160 char#0 \Gamma --- */
      {   0,54633,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xf1\x52\x62\xf1\x52\x71\xf3\x42\x90\xf3\x32\xa0"
            "\x22\xb7\x81" }  },
      /* --- pixel bitmap for cmmi160 char#1 \Delta --- */
      {   1,55538,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x00\x1c\x00\x1a\x00\x1a\x00\x19\x80\x38\x40"
            "\x30\x40\x30\x20\x30\x10\x70\x08\x60\x08\x60\x04\x60"
            "\xfe\xff\xff\xff" }  },
      /* --- pixel bitmap for cmmi160 char#2 \Theta --- */
      {   2,56711,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\x38\x0c\x06\x8c\x01\x6c\x00\xb6\x20\xcf\x9f"
            "\xe7\xcf\x13\xe4\x01\xd8\x00\x6c\x00\x23\xc0\x70\x18"
            "\xe0\x03\x00" }  },
      /* --- pixel bitmap for cmmi160 char#3 \Lambda --- */
      {   3,57667,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x80\x01\x70\x00\x1c\x80\x06\xa0\x01\x64\x80"
            "\x19\x20\x06\x84\x01\x61\x20\x38\x08\x0e\x01\xf3\xf9"
            "\x03" }  },
      /* --- pixel bitmap for cmmi160 char#4 \Xi --- */
      {   4,59092,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4d\x3d\x10\xf1\x31\xb1\x10\xe0\x71\x71\x40\xf1\x49"
            "\x40\x41\x71\x40\xf1\xe0\x30\xf1\x11\xb1\x3f\x1d\x41" }  },
      /* --- pixel bitmap for cmmi160 char#5 \Pi --- */
      {   5,60275,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   15, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x02\xf3\x52\x72\x30\xf3\x42\x72\x40\xf3\x32\x72"
            "\x50\x22\x72\x67\x27\x30" }  },
      /* --- pixel bitmap for cmmi160 char#6 \Sigma --- */
      {   6,61428,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4d\x42\x83\x43\x82\x52\x82\x53\x81\x62\xe0\x13\xe0"
            "\x12\xe0\x11\xe0\x11\xe0\x11\x81\x61\x82\x51\x91\x51"
            "\x83\x4c\x47" }  },
      /* --- pixel bitmap for cmmi160 char#7 \Upsilon --- */
      {   7,62486,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x53\x26\x27\x51\x21\x41\xf1\x61\x11\x60\xf3\x62"
            "\x70\xf3\x52\x80\x42\xa8\x61" }  },
      /* --- pixel bitmap for cmmi160 char#8 \Phi --- */
      {   8,63508,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x0f\x60\x00\x18\x80\x1f\x9c\x99\x31\x3c\x0c\x0f"
            "\xc3\xc3\xd8\x18\x66\x66\xe0\x07\x60\x00\x0c\xe0\x1f"
            "\x00" }  },
      /* --- pixel bitmap for cmmi160 char#9 \Psi --- */
      {   9,64591,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x0f\xc0\x00\x60\xe0\x30\x6e\x98\x31\x66\x18\x33"
            "\x8c\x19\xc6\x06\x33\x03\xdb\x00\x1f\x00\x06\x80\x01"
            "\xf8\x07\x00" }  },
      /* --- pixel bitmap for cmmi160 char#10 \Omega --- */
      {  10,65780,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x1f\x70\x30\x18\x60\x0c\xc0\x0c\xc0\x06\x60\x06"
            "\x60\x06\x30\x04\x30\x0c\x18\x0c\x0c\x09\x24\x09\x12"
            "\x0f\x1e\x0f\x0f" }  },
      /* --- pixel bitmap for cmmi160 char#11 \alpha --- */
      {  11,66818,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x00\x21\x12\x44\x01\x15\xa0\x02\x4c\x80\x08\x18"
            "\xc2\x8a\x87\x01" }  },
      /* --- pixel bitmap for cmmi160 char#12 \beta --- */
      {  12,67867,                      /* character number, location */
         15, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 13,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x07\x08\x83\x40\x08\x08\xc1\xd0\x07\x02\x41\x40"
            "\x08\x88\x00\x11\x20\x02\x44\x40\x14\x86\x3c\x10\x00"
            "\x02\x20\x00\x04\x00" }  },
      /* --- pixel bitmap for cmmi160 char#13 \gamma --- */
      {  13,68808,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x34\x63\x10\x03\x05\x28\xc0\x00\x06\x30\x80\x00"
            "\x04\x20\x00\x01\x04\x20\x00" }  },
      /* --- pixel bitmap for cmmi160 char#14 \delta --- */
      {  14,69761,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x11\x40\x80\x00\x02\x0e\x12\x42\x82\x02\x05\x0a"
            "\x14\x44\x0c\x07" }  },
      /* --- pixel bitmap for cmmi160 char#15 \epsilon --- */
      {  15,70619,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x0c\x02\x02\x7f\x01\x01\x02\x42\x3c" }  },
      /* --- pixel bitmap for cmmi160 char#16 \zeta --- */
      {  16,71551,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x01\x3c\x0c\x08\x10\x40\x80\x00\x02\x04\x10"
            "\x40\x00\x01\x08\xc0\x01\x18\x40\x00\x01\x07" }  },
      /* --- pixel bitmap for cmmi160 char#17 \eta --- */
      {  17,72436,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\xe5\x98\x61\x82\x0c\x11\x44\x10\x41\x82\x08\x02"
            "\x08\x20\x40\x00\x01" }  },
      /* --- pixel bitmap for cmmi160 char#18 \theta --- */
      {  18,73196,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x20\x22\x24\x48\x90\xa0\x40\xff\x02\x05\x05\x0a"
            "\x22\x44\x04\x07" }  },
      /* --- pixel bitmap for cmmi160 char#19 \iota --- */
      {  19,73837,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x41\x10\x82\x20\x86\x91\x03" }  },
      /* --- pixel bitmap for cmmi160 char#20 \kappa --- */
      {  20,74743,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x23\x04\x19\x28\xe0\x03\x21\x08\x52\x90\x81\x0a"
            "\x1c" }  },
      /* --- pixel bitmap for cmmi160 char#21 \lambda --- */
      {  21,75574,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x00\x01\x08\x80\x00\x04\x20\x00\x02\x10\xc0\x00"
            "\x09\x44\x10\x42\x20\x01\x05\x10" }  },
      /* --- pixel bitmap for cmmi160 char#22 \mu --- */
      {  22,76554,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x82\x20\x08\x82\x20\x04\x41\x10\x04\x49\x98\x46"
            "\xa5\x33\x02\x20\x00\x01\x10\x00" }  },
      /* --- pixel bitmap for cmmi160 char#23 \nu --- */
      {  23,77349,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x12\x48\x20\x41\x82\x08\x22\x84\x0c\x0d\x0c\x00" }  },
      /* --- pixel bitmap for cmmi160 char#24 \xi --- */
      {  24,78495,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x80\xc0\x47\x40\x40\x00\x01\x7c\x0c\x04\x04\x08"
            "\x10\x20\x80\x01\x1c\x40\x80\xe0\x01" }  },
      /* --- pixel bitmap for cmmi160 char#25 \pi --- */
      {  25,79429,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x97\x44\x24\x90\x80\x04\x24\x10\x81\x08\x44\x10"
            "\x04" }  },
      /* --- pixel bitmap for cmmi160 char#26 \rho --- */
      {  26,80243,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\xc1\x88\x20\x82\x04\x12\x48\x20\x41\x8a\xc8\x21"
            "\x80\x00\x01\x04\x00" }  },
      /* --- pixel bitmap for cmmi160 char#27 \sigma --- */
      {  27,81143,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x8f\x10\x04\x21\x10\x01\x11\x10\x01\x11\x08\x42"
            "\xc0\x03" }  },
      /* --- pixel bitmap for cmmi160 char#28 \tau --- */
      {  28,81930,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x4b\x10\x01\x04\x08\x20\x80\x00\x02\x04\x10\x00" }  },
      /* --- pixel bitmap for cmmi160 char#29 \upsilon --- */
      {  29,82829,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x26\x98\x60\x82\x04\x11\x44\x10\x21\x44\xe0\x00" }  },
      /* --- pixel bitmap for cmmi160 char#30 \phi --- */
      {  30,83697,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x10\x00\x01\x08\x80\x00\x3e\x98\x44\x84\x42"
            "\x18\x84\x41\x18\x82\x22\x64\x32\xf8\x00\x01\x10\x00"
            "\x01\x10\x00" }  },
      /* --- pixel bitmap for cmmi160 char#31 \chi --- */
      {  31,84718,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x50\x01\x41\x10\x08\x02\x22\x40\x02\x30\x00\x06"
            "\xa0\x00\x22\x20\x04\x02\x21\xa0\x02\x18" }  },
      /* --- pixel bitmap for cmmi160 char#32 \psi --- */
      {  32,85791,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x40\x00\x04\x80\x00\x10\x1c\x62\x22\x4c\x84"
            "\x89\x90\x10\x11\x21\x22\x42\x44\x90\x06\x3c\x00\x01"
            "\x20\x00\x04\x40\x00" }  },
      /* --- pixel bitmap for cmmi160 char#33 \omega --- */
      {  33,86890,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x90\x00\x0a\x40\x41\x18\x84\x82\x50\x10\x0a\x23"
            "\xd3\xc6\x71\x00" }  },
      /* --- pixel bitmap for cmmi160 char#34 \varepsilon --- */
      {  34,87869,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x08\x0a\x10\xc0\x43\x40\x80\x00\x41\x7c\x00" }  },
      /* --- pixel bitmap for cmmi160 char#35 \vartheta --- */
      {  35,88868,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x01\x11\x84\x20\x04\x21\x13\x25\x2f\xc1\x09\x22"
            "\x08\x41\x08\x41\x08\x22\xe0\x00" }  },
      /* --- pixel bitmap for cmmi160 char#36 \varpi --- */
      {  36,90081,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xff\x15\x80\x24\x00\x21\x00\x24\x10\x44\x20\x88"
            "\x60\x10\xc1\x10\x62\x11\x38\x1c\x00" }  },
      /* --- pixel bitmap for cmmi160 char#37 \varrho --- */
      {  37,90962,                      /* character number, location */
         10, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x30\x12\x24\x28\x50\xa0\x40\x41\x45\x72\x04\x08"
            "\x10\xc0\x0f" }  },
      /* --- pixel bitmap for cmmi160 char#38 \varsigma --- */
      {  38,91783,                      /* character number, location */
         10, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x19\x08\x10\x10\x40\x00\x01\x0c\x20\x80\x00\x81"
            "\x01" }  },
      /* --- pixel bitmap for cmmi160 char#39 \varphi --- */
      {  39,92712,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x87\x10\x09\x21\x21\x18\x82\x42\x50\x08\x12\x21"
            "\x14\x03\x1f\x40\x00\x08\x80\x00\x10\x00" }  },
      /* --- pixel bitmap for cmmi160 char#40 \leftharpoonup --- */
      {  40,108370,                     /* character number, location */
         11, 1,    5, 1,      /* topleft row,col, and botleft row,col */
          { 20,    6, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\xe0\x10\x31\xe0\x42\xe0\x32\xe0\x3e\x06" }  },
      /* --- pixel bitmap for cmmi160 char#41 \leftharpoondown --- */
      {  41,109396,                     /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,    6, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x06\x12\xe0\x52\xe0\x51\xe0\x20\xf1\x41\xe0\x14" }  },
      /* --- pixel bitmap for cmmi160 char#42 \rightharpoonup --- */
      {  42,110420,                     /* character number, location */
         11, 1,    5, 1,      /* topleft row,col, and botleft row,col */
          { 20,    6, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x11\x40\xe0\x21\xe0\x52\xe0\x52\x1e\x06" }  },
      /* --- pixel bitmap for cmmi160 char#43 \rightharpoondown --- */
      {  43,111447,                     /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,    6, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x06\xe0\x32\xe0\x32\xe0\x41\x30\xf1\xe0\x11\x44" }  },
      /* --- pixel bitmap for cmmi160 char#44 ` --- */
      {  44,111866,                     /* character number, location */
         12, 1,    5, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2c\x11\x21\x0c" }  },
      /* --- pixel bitmap for cmmi160 char#45 ' --- */
      {  45,112288,                     /* character number, location */
         12, 1,    5, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x88\x48\x03" }  },
      /* --- pixel bitmap for cmmi160 char#46 \triangleright --- */
      {  46,112827,                     /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x38\x40\x06\xc2\x10\x98\x00\x07\x2c\x18\x31\x28"
            "\x40\x00\x00" }  },
      /* --- pixel bitmap for cmmi160 char#47 \triangleleft --- */
      {  47,113389,                     /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x04\x38\x30\x61\x48\xc0\x00\x1a\x10\x83\x60\x04"
            "\x2c\x80\x01" }  },
      /* --- pixel bitmap for cmmi160 char#48 \0 --- */
      {  48,98993,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\x31\x51\x1f\x51\x71\x11\x51\x35\x21" }  },
      /* --- pixel bitmap for cmmi160 char#49 \1 --- */
      {  49,99756,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  7,   10, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\x34\x30\xf6\x31\x37" }  },
      /* --- pixel bitmap for cmmi160 char#50 \2 --- */
      {  50,100722,                     /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x05\x04\x08\x18\x18\x0c\x8c\xfe\xfe\x01" }  },
      /* --- pixel bitmap for cmmi160 char#51 \3 --- */
      {  51,101743,                     /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x08\x03\x06\x0c\x08\x1e\x60\x80\x01\x0f\x1e"
            "\x2c\x8c\x0f" }  },
      /* --- pixel bitmap for cmmi160 char#52 \4 --- */
      {  52,102664,                     /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\xc0\x40\x81\x82\x84\x08\x11\x21\x43\xfe\x03\x01"
            "\x02\x04\x3e" }  },
      /* --- pixel bitmap for cmmi160 char#53 \5 --- */
      {  53,103701,                     /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\xfc\xe8\x10\x20\x40\x8f\x31\xc1\x80\x01\x07\x0e"
            "\x24\x8c\x07" }  },
      /* --- pixel bitmap for cmmi160 char#54 \6 --- */
      {  54,104596,                     /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x18\x0a\x10\x10\x20\xcf\xa1\x81\x01\x03\x06\x14"
            "\x44\x0c\x07" }  },
      /* --- pixel bitmap for cmmi160 char#55 \7 --- */
      {  55,105495,                     /* character number, location */
         11, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x99\x11\x72\x71\x81\x20\xf1\x61\x30\x51\x40\xf2"
            "\x41\x50\xf3\x31\x61" }  },
      /* --- pixel bitmap for cmmi160 char#56 \8 --- */
      {  56,106414,                     /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x88\x08\x12\x64\x88\x0f\x0e\x7a\xc2\x03\x06\x0c"
            "\x28\x88\x0f" }  },
      /* --- pixel bitmap for cmmi160 char#57 \9 --- */
      {  57,107313,                     /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x08\x0a\x18\x30\x60\x60\xe1\x3c\x01\x02\x02"
            "\x14\xc6\x03" }  },
      /* --- pixel bitmap for cmmi160 char#58 . --- */
      {  58,113880,                     /* character number, location */
          2, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmmi160 char#59 , --- */
      {  59,114439,                     /* character number, location */
          2, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  2,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaf\x05" }  },
      /* --- pixel bitmap for cmmi160 char#60 < --- */
      {  60,115097,                     /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb2\x92\x92\x92\x92\x92\xa1\xd2\xd2\xd2\xd2\xd2\xd2" }  },
      /* --- pixel bitmap for cmmi160 char#61 / --- */
      {  61,115625,                     /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  9,   23, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\xf2\x71\x10\xf1\x61\x20\xf2\x51\x30\xf2\x41"
            "\x40\xf2\x31\x50\xf1\x21\x60\xf2\x11\x7f\x11\x81" }  },
      /* --- pixel bitmap for cmmi160 char#62 > --- */
      {  62,116320,                     /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xd2\xd2\xd2\xd2\xd2\xd1\xa2\x92\x92\x92\x92\x92"
            "\xb0" }  },
      /* --- pixel bitmap for cmmi160 char#63 \star --- */
      {  63,117023,                     /* character number, location */
          7, 0,    1, 0,      /* topleft row,col, and botleft row,col */
          { 11,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xc4\x0f\x18\x00\x00\x09\x84\x00" }  },
      /* --- pixel bitmap for cmmi160 char#64 \partial --- */
      {  64,93724,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x40\x18\x81\x00\x08\x40\x00\xc2\x93\xa1\x02\x0e"
            "\x50\x80\x02\x12\x10\x61\xf0\x00" }  },
      /* --- pixel bitmap for cmmi160 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x0c\x00\x06\x80\x03\xc0\x01\xd0\x00\x64\x00\x32"
            "\x80\x30\x40\x18\xf0\x0f\x04\x06\x02\x83\x80\x61\xc0"
            "\x7c\xf8\x01" }  },
      /* --- pixel bitmap for cmmi160 char#66 B --- */
      {  66, 2376,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x72\x62\x10\xf2\x52\x72\x42\x72\x52\x53\x6a\x62"
            "\x63\x10\xf2\x32\x82\x10\x32\x72\x42\x72\x3b\x52" }  },
      /* --- pixel bitmap for cmmi160 char#67 C --- */
      {  67, 3341,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x31\x52\x51\x11\x42\x82\x32\xa1\x22\xb1\x22\xdf"
            "\x32\xef\x12\xa1\x30\x11\x91\x62\x52\x86\x7b" }  },
      /* --- pixel bitmap for cmmi160 char#68 D --- */
      {  68, 4473,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x82\x62\x72\x72\x10\xf1\x52\x82\xf3\x42\x92\xf1"
            "\x32\x92\x10\x32\x82\x52\x72\x52\x63\x4b\x6b" }  },
      /* --- pixel bitmap for cmmi160 char#69 E --- */
      {  69, 5918,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xff\x60\xc0\x60\xc0\x60\x80\x60\x88\x30\x04\x30"
            "\x04\xf0\x07\x30\x06\x18\x22\x18\x22\x18\x10\x18\x10"
            "\x0c\x1c\xff\x0f" }  },
      /* --- pixel bitmap for cmmi160 char#70 F --- */
      {  70, 7173,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xf1\x52\x62\x52\x71\x52\x41\x21\xf1\x42\x41\x40"
            "\x47\x82\x32\x40\xf1\x32\x41\x50\xf1\x32\xa0\x22\xb7"
            "\x82" }  },
      /* --- pixel bitmap for cmmi160 char#71 G --- */
      {  71, 8354,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x31\x52\x51\x11\x42\x82\x32\xa1\x22\xb1\x22\xdf"
            "\x12\xe2\x76\x1f\x22\x92\x30\x11\x92\x52\x62\x77\x11"
            "\x42" }  },
      /* --- pixel bitmap for cmmi160 char#72 H --- */
      {  72, 9547,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   15, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\x27\xf3\x52\x72\x30\xf1\x42\x72\x40\x4b\x82\x72"
            "\x40\xf3\x32\x72\x50\x22\x72\x67\x27\x32" }  },
      /* --- pixel bitmap for cmmi160 char#73 I --- */
      {  73,10270,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\xf3\x52\x30\xf3\x42\x40\xf3\x32\x50\x22\x67\x32" }  },
      /* --- pixel bitmap for cmmi160 char#74 J --- */
      {  74,11094,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xf3\x82\x20\xf3\x72\x30\xf2\x62\x42\x42\x41\x42"
            "\x64\x73" }  },
      /* --- pixel bitmap for cmmi160 char#75 K --- */
      {  75,12317,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\x26\x52\x62\x82\x52\x92\x42\xa2\x31\xb2\x31\xc2"
            "\x23\xb2\x11\x12\xb3\x22\xa3\x42\x92\x52\x92\x53\x82"
            "\x62\x72\x72\x56\x46\x20" }  },
      /* --- pixel bitmap for cmmi160 char#76 L --- */
      {  76,13290,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x20\xf3\x52\x60\xf3\x42\x70\xf1\x32\x71\xf1\x32"
            "\x61\x10\x22\x53\x1b\x22" }  },
      /* --- pixel bitmap for cmmi160 char#77 M --- */
      {  77,14616,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x00\x3e\x38\xc0\x01\x1a\x70\x80\x06\x1a\xa0\x41"
            "\x06\x64\xd0\x00\x19\x32\x40\x86\x0c\x90\x11\x03\x62"
            "\x62\x80\x98\x18\x20\x1c\x06\x08\x87\x01\xc3\x30\xf0"
            "\x11\x3f\x00" }  },
      /* --- pixel bitmap for cmmi160 char#78 N --- */
      {  78,15774,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xe0\x07\x0f\x0c\x68\x20\x40\x03\x01\x32\x08\x88"
            "\x21\x40\x1c\x01\xc2\x08\x10\x46\x40\x60\x01\x02\x0b"
            "\x10\x70\x80\x80\x03\x06\x0c\xfc\x40\x00" }  },
      /* --- pixel bitmap for cmmi160 char#79 O --- */
      {  79,16679,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x73\x42\x52\x72\x32\x92\xf1\x12\xa2\x0f\x22\xb2"
            "\x0f\x12\xa2\x12\x92\x32\x72\x43\x42\x85\x71" }  },
      /* --- pixel bitmap for cmmi160 char#80 P --- */
      {  80,17786,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x72\x62\x10\xf2\x52\x72\x42\x72\x52\x62\x68\x82"
            "\xa0\xf3\x32\xb0\x22\xc6\xa2" }  },
      /* --- pixel bitmap for cmmi160 char#81 Q --- */
      {  81,18843,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x73\x42\x52\x72\x32\x92\xf1\x12\xa2\x0f\x22\xb2"
            "\x0f\x12\xa2\x12\x92\x31\x23\x32\x43\x33\x85\xe0\xe0"
            "\x21\xe4\xb3\x40" }  },
      /* --- pixel bitmap for cmmi160 char#82 R --- */
      {  82,20156,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3a\x72\x52\x10\xf2\x52\x62\x42\x62\x52\x52\x67\x82"
            "\x42\x30\xf3\x32\x52\x30\x22\x62\x27\x44\x15" }  },
      /* --- pixel bitmap for cmmi160 char#83 S --- */
      {  83,21253,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x13\x86\x41\x20\x0c\x84\x01\x30\x00\x7e\x80\x1f"
            "\x80\x07\xc0\x00\x18\x01\x23\x30\x06\x43\x3f\x00" }  },
      /* --- pixel bitmap for cmmi160 char#84 T --- */
      {  84,22319,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x02\x42\x51\x1f\x21\x52\x51\x10\xf3\x52\x80\xf3"
            "\x42\x90\x32\xa8\x72" }  },
      /* --- pixel bitmap for cmmi160 char#85 U --- */
      {  85,23289,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x36\x22\x82\x20\xf2\x22\x81\x30\xf3\x12\x81\x4f"
            "\x22\x81\x52\x71\x72\x42\x95\x92" }  },
      /* --- pixel bitmap for cmmi160 char#86 V --- */
      {  86,24213,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x55\x22\x82\x42\x81\x52\x71\x72\x61\x72\x51\x50"
            "\xf1\x32\x41\x60\x32\x31\xa2\x22\xa2\x21\xb4\xd3\xd2"
            "\xe1\xb4" }  },
      /* --- pixel bitmap for cmmi160 char#87 W --- */
      {  87,25598,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x7e\x3e\x03\x07\xc2\xa0\x41\x30\x68\x10\x0c\x19"
            "\x02\x43\x86\xc0\x88\x11\x30\x62\x04\x4c\x98\x00\x1b"
            "\x36\xc0\x82\x05\x70\xe0\x00\x1c\x38\x00\x03\x06\xc0"
            "\x80\x01\x00" }  },
      /* --- pixel bitmap for cmmi160 char#88 X --- */
      {  88,26741,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   15, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x26\x72\x61\xa3\x41\xc2\x31\xd2\x21\xe0\x13\xe0"
            "\x22\xe0\x33\xe0\x14\xe2\x13\xd1\x32\xc1\x42\xb1\x62"
            "\x91\x72\x56\x47\x22" }  },
      /* --- pixel bitmap for cmmi160 char#89 Y --- */
      {  89,27817,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x56\x23\x72\x62\x71\x72\x61\x92\x41\xa2\x31\xb3"
            "\x12\xc4\xd3\x90\xf3\x52\xa0\x42\xd6\x91" }  },
      /* --- pixel bitmap for cmmi160 char#90 Z --- */
      {  90,28906,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5b\x43\x53\x52\x53\x61\x62\x71\x52\xd2\xd2\xd2\xd2"
            "\xd2\x51\x72\x61\x62\x71\x52\x72\x42\x72\x4c\x41" }  },
      /* --- pixel bitmap for cmmi160 char#91 \flat --- */
      {  91,117698,                     /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x40\x20\x10\x08\x04\x6e\xc1\x60\x30\x18\x8a\x64"
            "\x0a\x03" }  },
      /* --- pixel bitmap for cmmi160 char#92 \natural --- */
      {  92,118457,                     /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   19, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x01\x61\x37\x21\x0f\x71\x51\x01\x37\x21\xf2\x61" }  },
      /* --- pixel bitmap for cmmi160 char#93 \sharp --- */
      {  93,119318,                     /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x91\x48\x24\x7f\x89\x44\x22\x91\x48\x24\x12\xc9"
            "\x5f\x22\x91\x08" }  },
      /* --- pixel bitmap for cmmi160 char#94 \smile --- */
      {  94,120244,                     /* character number, location */
          9, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 20,    6, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x41\x11\xe0\x21\x31\xe1\x51\xc1\x73\x63\xb6"
            "\x77" }  },
      /* --- pixel bitmap for cmmi160 char#95 \frown --- */
      {  95,121116,                     /* character number, location */
          9, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 20,    6, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\xb3\x63\x71\xc1\x51\xe1\x31\xe0\x21\x11\xe0\x41" }  },
      /* --- pixel bitmap for cmmi160 char#96 \ell --- */
      {  96,94488,                      /* character number, location */
         15,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x81\x02\x05\x09\x0a\x12\x14\x28\x30\x30\x20\x60"
            "\xa0\x00\x22\x3c" }  },
      /* --- pixel bitmap for cmmi160 char#97 a --- */
      {  97,29842,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb8\x10\x23\x8c\x30\x41\x04\x11\x64\x98\x51\x39\x03" }  },
      /* --- pixel bitmap for cmmi160 char#98 b --- */
      {  98,30706,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x04\x04\x04\x04\x72\x8e\x82\x82\x81\x81\x81\x41"
            "\x22\x1c" }  },
      /* --- pixel bitmap for cmmi160 char#99 c --- */
      {  99,31537,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x10\x12\x14\x10\x20\x40\x80\x80\xc2\x78\x00" }  },
      /* --- pixel bitmap for cmmi160 char#100 d --- */
      { 100,32501,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x03\x04\x10\x40\x00\xe1\x42\x8c\x30\xc2\x04\x11"
            "\x44\x90\x61\x46\xe5\x0c" }  },
      /* --- pixel bitmap for cmmi160 char#101 e --- */
      { 101,33342,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x18\x0a\x14\xf4\x27\x40\x80\x80\xc2\x78\x00" }  },
      /* --- pixel bitmap for cmmi160 char#102 f --- */
      { 102,34486,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   19, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x61\x21\xf2\x61\x30\x44\x20\xf5\x51\x40\xf3\x41"
            "\x50\x31\x61\x21\x72\x72" }  },
      /* --- pixel bitmap for cmmi160 char#103 g --- */
      { 103,35449,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x62\x4c\x30\xc1\x02\x09\x24\x90\x60\xc4\xe0\x02"
            "\x08\x20\x40\xfc\x00" }  },
      /* --- pixel bitmap for cmmi160 char#104 h --- */
      { 104,36372,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x40\x00\x02\x10\x80\x00\x72\x70\x84\x21\x04\x31"
            "\x84\x20\x04\x29\xc4\x20\x05\x06" }  },
      /* --- pixel bitmap for cmmi160 char#105 i --- */
      { 105,37238,                      /* character number, location */
         16, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x00\x00\x80\x49\xa9\x10\x22\xa5\x32" }  },
      /* --- pixel bitmap for cmmi160 char#106 j --- */
      { 106,38157,                      /* character number, location */
         16,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          { 10,   20, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\xf4\xa0\x62\x71\x21\x10\xf1\x41\x31\x10\xf3\x71"
            "\x20\xf3\x61\x30\x51\x45\x51" }  },
      /* --- pixel bitmap for cmmi160 char#107 k --- */
      { 107,39164,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x20\x80\x00\x02\x08\x10\x4e\x24\x09\x14\x78\x20"
            "\x82\x90\x42\x06\x15\x1c" }  },
      /* --- pixel bitmap for cmmi160 char#108 l --- */
      { 108,39890,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x44\x24\x22\x12\x91\x59\x03" }  },
      /* --- pixel bitmap for cmmi160 char#109 m --- */
      { 109,41113,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\x71\x72\x1c\x65\x18\x4a\x10\xc4\x30\x84\x20\x08"
            "\x41\x50\x82\x90\x82\xa0\x04\x81\x01" }  },
      /* --- pixel bitmap for cmmi160 char#110 n --- */
      { 110,42148,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\xc9\x51\x86\x12\xc4\x10\x82\x10\x94\x90\x82\x12"
            "\x18" }  },
      /* --- pixel bitmap for cmmi160 char#111 o --- */
      { 111,42874,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x10\x12\x14\x18\x30\x60\xc0\x40\x42\x78\x00" }  },
      /* --- pixel bitmap for cmmi160 char#112 p --- */
      { 112,43836,                      /* character number, location */
         10, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\xc9\x28\xa1\x84\x08\x22\x88\x20\x42\x8c\xd0\x41"
            "\x00\x01\x02\x3c\x00" }  },
      /* --- pixel bitmap for cmmi160 char#113 q --- */
      { 113,44763,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x18\x0b\x16\x1c\x28\x50\xa0\x60\x62\xb8\x00\x01"
            "\x02\x02\x1f" }  },
      /* --- pixel bitmap for cmmi160 char#114 r --- */
      { 114,45650,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe6\x99\x09\x09\x0c\x04\x04\x04\x02\x02" }  },
      /* --- pixel bitmap for cmmi160 char#115 s --- */
      { 115,46586,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x86\x82\x02\x1c\x20\x40\x41\x21\x1e" }  },
      /* --- pixel bitmap for cmmi160 char#116 t --- */
      { 116,47330,                      /* character number, location */
         14, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x08\x04\xf2\x47\x20\x10\x04\x02\x91\x44\xe2\x00" }  },
      /* --- pixel bitmap for cmmi160 char#117 u --- */
      { 117,48372,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x49\x48\x42\x12\x42\x08\x42\x10\x92\x98\xc4\xc2"
            "\x0d" }  },
      /* --- pixel bitmap for cmmi160 char#118 v --- */
      { 118,49265,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x13\x26\x4c\x48\x88\x10\x21\x22\x44\x70\x00" }  },
      /* --- pixel bitmap for cmmi160 char#119 w --- */
      { 119,50445,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x61\x42\x98\x10\x26\x84\x84\x10\x21\x44\x08\x11"
            "\x23\xc4\x08\xce\x01" }  },
      /* --- pixel bitmap for cmmi160 char#120 x --- */
      { 120,51677,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x8f\x8c\x44\x40\x04\x20\x00\x02\x20\x04\x42\x31"
            "\xe2\x1c" }  },
      /* --- pixel bitmap for cmmi160 char#121 y --- */
      { 121,52775,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0b\x16\x2c\x28\x48\x90\x20\x61\x62\xb8\x00\x01"
            "\x11\xc1\x01" }  },
      /* --- pixel bitmap for cmmi160 char#122 z --- */
      { 122,53679,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x89\x13\x02\x02\x02\x02\x42\x82\x8e\xe2\x00" }  },
      /* --- pixel bitmap for cmmi160 char#123 \imath --- */
      { 123,95234,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x26\xa5\x42\x88\x94\xca\x00" }  },
      /* --- pixel bitmap for cmmi160 char#124 \jmath --- */
      { 124,96037,                      /* character number, location */
         10,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\x61\x21\xf1\x41\x31\xf3\x71\x10\xf3\x61\x20\x51"
            "\x35\x41" }  },
      /* --- pixel bitmap for cmmi160 char#125 \wp --- */
      { 125,97156,                      /* character number, location */
         10, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x40\x78\x62\x28\x81\x09\x58\x80\x03\x28\x40\x15"
            "\x92\x1e\x09\x10\x01\x09\x60\x00" }  },
      /* --- pixel bitmap for cmmi160 char#126 \vec --- */
      { 126,97786,                      /* character number, location */
         15, 4,   11, 4,      /* topleft row,col, and botleft row,col */
          {  9,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\xfe\x03\x03\x02" }  },
      /* --- pixel bitmap for cmmi160 char#127 (noname) --- */
      { 127,98324,                      /* character number, location */
         14, 6,   12, 6,      /* topleft row,col, and botleft row,col */
          {  8,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x81" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=5 for .180gf ---
 * mf '\mode=preview; mag=magstep(-14.65037297372839890542); input cmmi10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmi180 --- */
static	chardef  cmmi180[] =
   {
      /* --- pixel bitmap for cmmi180 char#0 \Gamma --- */
      {   0,55074,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x72\x72\x72\x81\xf2\x62\x91\x62\xa0\xf3\x52\xb0"
            "\xf3\x42\xc0\x32\xd8\xa2" }  },
      /* --- pixel bitmap for cmmi180 char#1 \Delta --- */
      {   1,55985,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\x40\xf1\xc3\x40\xb1\x12\xe1\x23\x30\xf1\x91\x42"
            "\x30\x81\x52\xa1\x63\x20\xf1\x61\x82\x20\x51\x92\x61"
            "\xa3\x42\xb2\x41\xc2\x31\xd2\x2e\x0e\x09" }  },
      /* --- pixel bitmap for cmmi180 char#2 \Theta --- */
      {   2,57168,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x92\x52\x72\x72\x51\xa2\x31\xb2\x22\xb2\x12\xd1"
            "\x12\xc2\x0f\x22\x29\x22\x0f\x12\xc2\x1f\x12\xb2\x20"
            "\x11\xa2\x42\x82\x62\x52\xa5\x8e" }  },
      /* --- pixel bitmap for cmmi180 char#3 \Lambda --- */
      {   3,58134,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x18\x00\x0c\x00\x07\x80\x03\xa0\x01\xc8\x00\x64"
            "\x00\x31\x80\x18\x20\x0c\x10\x06\x04\x03\x82\x81\xc0"
            "\x60\x60\x10\x30\x0c\x98\x0f\x3f" }  },
      /* --- pixel bitmap for cmmi180 char#4 \Xi --- */
      {   4,59545,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   17, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x4e\x01\x41\xd1\x31\xd1\x10\xf1\xe0\x50\x61\x71"
            "\x40\xf1\x59\x50\x51\x71\x50\xf2\xe0\x50\xf1\x11\xd1"
            "\x3f\x1e\x01\x41" }  },
      /* --- pixel bitmap for cmmi180 char#5 \Pi --- */
      {   5,60754,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   17, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x05\xf1\x72\x92\x30\xf3\x62\x92\x40\xf3\x52\x92"
            "\x50\xf3\x42\x92\x60\x32\x92\x78\x38\x40" }  },
      /* --- pixel bitmap for cmmi180 char#6 \Sigma --- */
      {   6,61941,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   17, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x01\x52\xa2\x52\xb1\x53\xa1\x62\xa1\x63\x91\xf1"
            "\x72\xa0\x82\xe0\x31\xe0\x31\xe0\x31\x91\x62\xa1\x51"
            "\xb1\x51\xc1\x41\xb3\x3e\x01\x45" }  },
      /* --- pixel bitmap for cmmi180 char#7 \Upsilon --- */
      {   7,63033,                      /* character number, location */
         18, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x63\x46\x42\x12\x22\x42\x21\x42\x11\x52\x11\x53"
            "\x71\x11\x51\x10\xf2\x82\x80\xf3\x72\x90\xf3\x62\xa0"
            "\x52\xd8\x81" }  },
      /* --- pixel bitmap for cmmi180 char#8 \Phi --- */
      {   8,64071,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x3f\x00\x06\x00\x06\x00\x03\xe0\x1f\x18\x73\x06"
            "\xc3\x86\xc1\x83\xc1\x83\xc1\x83\x61\xce\x18\xf8\x07"
            "\xc0\x00\xc0\x00\x60\x00\xfc\x03" }  },
      /* --- pixel bitmap for cmmi180 char#9 \Psi --- */
      {   9,65184,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x3f\x00\x0c\x00\x18\x38\x18\xcc\x30\x8c\x61\x0c"
            "\xc3\x18\xc3\x18\x86\x31\x0c\x33\x30\x66\xc0\x76\x00"
            "\x3f\x00\x18\x00\x30\x00\x30\x00\xfc\x03\x00" }  },
      /* --- pixel bitmap for cmmi180 char#10 \Omega --- */
      {  10,66407,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xa3\x52\x72\x82\x52\xa2\x32\xb2\xf2\x22\xc2\x22"
            "\xb2\x10\xf1\x22\xa2\x20\x31\x92\x62\x72\x81\x62\x51"
            "\x31\x61\x31\x21\x31\x51\x31\x35\x46\x35\x45\x42" }  },
      /* --- pixel bitmap for cmmi180 char#11 \alpha --- */
      {  11,67457,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\xc6\xc8\x60\x1a\x98\x06\xd6\x80\x35\xe0\x0c"
            "\x18\x02\x86\x61\xc5\xc7\x01" }  },
      /* --- pixel bitmap for cmmi180 char#12 \beta --- */
      {  12,68512,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 13,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x07\x18\x83\x40\x10\x08\x81\x21\x10\xf4\x41\x3e"
            "\x08\x0c\x81\x21\x30\x02\x46\xc0\x08\x18\x81\x51\x1c"
            "\xf2\x40\x00\x08\x80\x00\x10\x00\x02\x00" }  },
      /* --- pixel bitmap for cmmi180 char#13 \gamma --- */
      {  13,69437,                      /* character number, location */
         11, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 14,   17, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\x71\x16\x51\x22\x32\x41\x11\x61\x31\xa1\x21\x20"
            "\xf1\x81\x11\x30\xf2\x82\x40\xf2\x81\x50\xf3\x71\x61" }  },
      /* --- pixel bitmap for cmmi180 char#14 \delta --- */
      {  14,70398,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x80\x0f\x21\x04\x30\x80\x01\x06\x38\xd8\x31\x66"
            "\x98\x61\x83\x0d\x36\x98\x20\x46\xf0\x00" }  },
      /* --- pixel bitmap for cmmi180 char#15 \epsilon --- */
      {  15,71266,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x31\x30\x30\xe0\x67\xc0\x80\x01\x06\x08\xe1\x01" }  },
      /* --- pixel bitmap for cmmi180 char#16 \zeta --- */
      {  16,72200,                      /* character number, location */
         17, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 10,   22, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x71\x20\x73\x55\x42\x72\x81\x82\x60\xf2\x12\x7f"
            "\x22\x80\x12\x83\x85\x74\x83\x82\x81\x63\x31" }  },
      /* --- pixel bitmap for cmmi180 char#17 \eta --- */
      {  17,73117,                      /* character number, location */
         11, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 11,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\x6b\x71\x87\x1b\xcc\x60\x83\x19\xcc\x60\x06\x1b"
            "\xcc\x60\x00\x03\x18\x60\x00\x03\x18\x40\x00" }  },
      /* --- pixel bitmap for cmmi180 char#18 \theta --- */
      {  18,73887,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x40\x86\x11\xc3\x04\x1b\x6c\xf0\x60\xff\x0d\x36"
            "\xd8\x30\xc1\x84\x31\xc2\x04\x0e\x00" }  },
      /* --- pixel bitmap for cmmi180 char#19 \iota --- */
      {  19,74536,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x06\x83\xc1\x30\x18\x8c\xa3\x99\x03" }  },
      /* --- pixel bitmap for cmmi180 char#20 \kappa --- */
      {  20,75444,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xc6\x58\x4c\xc0\x02\x1c\xe0\x0f\x86\x61\x98\x86"
            "\x39\x58\x03\x03" }  },
      /* --- pixel bitmap for cmmi180 char#21 \lambda --- */
      {  21,76279,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x00\x0c\x80\x03\x60\x00\x0c\x80\x03\x60\x00\x0c"
            "\x00\x03\x70\x00\x1d\x10\x03\x63\x30\x1c\x03\x33\x60"
            "\x02\x18" }  },
      /* --- pixel bitmap for cmmi180 char#22 \mu --- */
      {  22,77291,                      /* character number, location */
         11, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x08\x83\x61\x30\x0c\x86\xc1\x18\x0c\x83\x61\xb0"
            "\x0c\xd7\xf1\xd9\x31\x03\x60\x00\x06\xc0\x00\x18\x00"
            "\x01\x00" }  },
      /* --- pixel bitmap for cmmi180 char#23 \nu --- */
      {  23,78064,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\xc8\xc0\x0c\xcc\xc0\x0c\x66\x30\x86\x61\x0c\x66"
            "\xb0\x01\x07\x00" }  },
      /* --- pixel bitmap for cmmi180 char#24 \xi --- */
      {  24,79214,                      /* character number, location */
         17, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 10,   22, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x61\x30\x55\x42\x13\x32\x50\xf2\x22\x60\xf1\x36"
            "\x10\x21\x82\x7f\x22\x83\x84\x75\x74\x92\x41\x31\x63"
            "\x32" }  },
      /* --- pixel bitmap for cmmi180 char#25 \pi --- */
      {  25,80132,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xdf\xff\xcf\x84\x88\x00\x11\x30\x03\x62\x40\x0c"
            "\x8c\x81\x71\x10\x04" }  },
      /* --- pixel bitmap for cmmi180 char#26 \rho --- */
      {  26,80974,                      /* character number, location */
         11, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x03\x66\x30\x84\xc1\x18\xcc\x60\x0c\xc6\x60\x0c"
            "\xe3\x18\x76\x60\x00\x06\x30\x00\x03\x30\x00\x01\x00" }  },
      /* --- pixel bitmap for cmmi180 char#27 \sigma --- */
      {  27,81880,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x3a\x22\x42\x42\x52\x42\x61\x3f\x22\x62\x32\x52"
            "\x52\x32\x74\x72" }  },
      /* --- pixel bitmap for cmmi180 char#28 \tau --- */
      {  28,82669,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x29\x1c\x31\x51\x32\x50\xf1\x41\x60\xf2\x32\x60\xf1"
            "\x22\x72" }  },
      /* --- pixel bitmap for cmmi180 char#29 \upsilon --- */
      {  29,83570,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x54\x70\x03\x1b\xc8\x40\x03\x19\xc8\x40\x06\x21"
            "\x04\x1e\x00" }  },
      /* --- pixel bitmap for cmmi180 char#30 \phi --- */
      {  30,84442,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 14,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x80\x00\x20\x00\x04\x00\x01\x40\x00\x7e\xe0"
            "\x32\x8c\x98\x21\x64\x08\x0f\x61\x43\xd8\x10\x62\x44"
            "\x90\x0c\xf8\x00\x08\x00\x02\x40\x00\x10\x00\x04\x00" }  },
      /* --- pixel bitmap for cmmi180 char#31 \chi --- */
      {  31,85513,                      /* character number, location */
         11, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 14,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xa0\x0c\x08\x03\x81\x21\x60\x04\xb8\x00\x1c\x00"
            "\x03\xc0\x00\x68\x00\x1a\x40\x0e\x08\x03\xc1\x20\x60"
            "\x05\x30" }  },
      /* --- pixel bitmap for cmmi180 char#32 \psi --- */
      {  32,86592,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 14,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x04\x00\x01\x20\x00\x08\x00\x02\x80\xe0\x10\x2a"
            "\xc4\x0d\x61\x43\xc8\x08\x1a\x42\x86\x90\x21\x62\x44"
            "\x30\x09\xf0\x01\x10\x00\x02\x80\x00\x20\x00\x08\x00" }  },
      /* --- pixel bitmap for cmmi180 char#33 \omega --- */
      {  33,87675,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x20\x01\x6c\x00\x0a\x86\x82\x61\x30\x14\x0c\x0d"
            "\x63\xf7\x8c\xef\xc3\x31\x00" }  },
      /* --- pixel bitmap for cmmi180 char#34 \varepsilon --- */
      {  34,88656,                      /* character number, location */
         12, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x47\x22\x51\xf1\x11\x80\x25\x46\x3f\x21\x91\x61"
            "\x36\x54\x42" }  },
      /* --- pixel bitmap for cmmi180 char#35 \vartheta --- */
      {  35,89687,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x03\x64\x40\x04\xc2\x20\x0c\xc4\x86\xdc\x70\x0d"
            "\xde\x60\x0c\x66\x30\x06\x63\x18\x86\x60\x04\x3c\x00" }  },
      /* --- pixel bitmap for cmmi180 char#36 \varpi --- */
      {  36,90934,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xff\xf7\xff\xff\x04\x80\x12\x00\x84\x40\x20\x02"
            "\x81\x10\x08\x84\xe0\x30\x84\xc7\xe0\xe7\x03\x0e\x0f"
            "\x00" }  },
      /* --- pixel bitmap for cmmi180 char#37 \varrho --- */
      {  37,91841,                      /* character number, location */
         11, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 11,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x81\x19\x86\x18\xcc\x60\x83\x19\xcc\x60\x86\x29"
            "\x46\x0e\x02\x10\x80\x3f\xf8\x03\x10" }  },
      /* --- pixel bitmap for cmmi180 char#38 \varsigma --- */
      {  38,92668,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x19\x18\x18\x30\x60\xc0\x01\x07\x3c\xe0\x00\x01"
            "\x82\x03" }  },
      /* --- pixel bitmap for cmmi180 char#39 \varphi --- */
      {  39,93599,                      /* character number, location */
         11, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x0e\xc1\x27\x18\x0b\x82\x42\x60\x10\x14\x04\x89"
            "\x20\x26\x06\xff\x00\x1f\xc0\x00\x10\x00\x04\x80\x01"
            "\x60\x00\x08\x00" }  },
      /* --- pixel bitmap for cmmi180 char#40 \leftharpoonup --- */
      {  40,109405,                     /* character number, location */
         13, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\xe0\x71\xe0\x30\xf1\x41\xe0\x40\x31\xe0\x62\xe0"
            "\x6e\x09" }  },
      /* --- pixel bitmap for cmmi180 char#41 \leftharpoondown --- */
      {  41,110433,                     /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x09\x12\xe0\x91\xe0\x50\xf1\x41\xe0\x40\x51\xe0"
            "\x91\xe0\x22" }  },
      /* --- pixel bitmap for cmmi180 char#42 \rightharpoonup --- */
      {  42,111459,                     /* character number, location */
         13, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x21\xe0\x91\x50\xf1\xe0\x41\x40\xe0\x51\xe0\x92"
            "\x1e\x09" }  },
      /* --- pixel bitmap for cmmi180 char#43 \rightharpoondown --- */
      {  43,112488,                     /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x09\xe0\x62\xe0\x61\x30\xf1\xe0\x41\x40\xe0\x31"
            "\xe0\x71\x62" }  },
      /* --- pixel bitmap for cmmi180 char#44 ` --- */
      {  44,112909,                     /* character number, location */
         13, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x84\x10\x04\x07" }  },
      /* --- pixel bitmap for cmmi180 char#45 ' --- */
      {  45,113331,                     /* character number, location */
         13, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x41\x08\xd1\x01" }  },
      /* --- pixel bitmap for cmmi180 char#46 \triangleright --- */
      {  46,113870,                     /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x70\x00\x19\x10\x06\x81\x11\x60\x01\x18\x60\x81"
            "\x11\x06\x19\x70\x00\x01\x00" }  },
      /* --- pixel bitmap for cmmi180 char#47 \triangleleft --- */
      {  47,114438,                     /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\xe0\x80\x09\x86\x18\x68\x80\x01\x68\x80\x18"
            "\x08\x86\x80\x09\xe0\x00\x08" }  },
      /* --- pixel bitmap for cmmi180 char#48 \0 --- */
      {  48,99908,                      /* character number, location */
         12, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x42\x42\x21\x61\x1f\x62\x62\x11\x61\x22\x42\x44"
            "\x32" }  },
      /* --- pixel bitmap for cmmi180 char#49 \1 --- */
      {  49,100683,                     /* character number, location */
         12, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  8,   12, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x35\x30\xf8\x32\x38" }  },
      /* --- pixel bitmap for cmmi180 char#50 \2 --- */
      {  50,101653,                     /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x08\x16\xf0\xc0\x00\x03\x0c\x18\x30\x30\x22\xe8"
            "\xdf\x7f" }  },
      /* --- pixel bitmap for cmmi180 char#51 \3 --- */
      {  51,102682,                     /* character number, location */
         12, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x23\x98\x61\x86\x01\x06\x08\x10\x78\x00\x02"
            "\x18\xc0\x03\x0f\x1c\xb0\x60\x84\xe0\x01" }  },
      /* --- pixel bitmap for cmmi180 char#52 \4 --- */
      {  52,103619,                     /* character number, location */
         12, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 10,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x03\x0e\x38\xd0\x60\x83\x0c\x31\xc4\x08\x13"
            "\xcc\xff\xc0\x00\x03\x0c\x30\xf0\x03" }  },
      /* --- pixel bitmap for cmmi180 char#53 \5 --- */
      {  53,104662,                     /* character number, location */
         12, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xf9\xa3\x83\x00\x02\x08\x20\x87\x22\x86\x09\x0c"
            "\x30\xc0\x00\x0f\x1c\x90\x60\xc6\xe0\x01" }  },
      /* --- pixel bitmap for cmmi180 char#54 \6 --- */
      {  54,105571,                     /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x60\xc4\x98\x61\x06\x08\xb0\xc7\x21\x87\x0d\x3c"
            "\xf0\xc0\x03\x0f\x2c\xb0\x61\x8c\xe0\x01" }  },
      /* --- pixel bitmap for cmmi180 char#55 \7 --- */
      {  55,106488,                     /* character number, location */
         12, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 11,   18, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xaa\x19\x11\x81\x11\x71\x20\xf1\x71\x30\x61\x92"
            "\x91\x50\xf1\x42\x50\x41\x60\xf4\x32\x62" }  },
      /* --- pixel bitmap for cmmi180 char#56 \8 --- */
      {  56,107413,                     /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\x63\x98\x61\x86\x19\xc6\x0c\x17\x70\xb0\x63"
            "\xd8\xe0\x03\x0f\x3c\xb0\x41\x84\xe0\x01" }  },
      /* --- pixel bitmap for cmmi180 char#57 \9 --- */
      {  57,108330,                     /* character number, location */
         12, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x62\xd8\x40\x03\x0f\x3c\xf0\xc0\x03\x1b\x4e"
            "\x38\xde\x00\x03\x66\x98\x21\x42\xf0\x00" }  },
      /* --- pixel bitmap for cmmi180 char#58 . --- */
      {  58,114935,                     /* character number, location */
          3, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00" }  },
      /* --- pixel bitmap for cmmi180 char#59 , --- */
      {  59,115496,                     /* character number, location */
          3, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x49\x29" }  },
      /* --- pixel bitmap for cmmi180 char#60 < --- */
      {  60,116158,                     /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,44, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\xb2\xb2\xb2\xb2\xb2\xb2\xc1\xe0\x12\xe0\x12\xe0"
            "\x12\xe0\x12\xe0\x12\xe0\x12\xe0\x12" }  },
      /* --- pixel bitmap for cmmi180 char#61 / --- */
      {  61,116690,                     /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 10,   25, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x91\xf2\x81\x10\xf1\x71\x20\xf2\x61\x30\xf1\x51"
            "\x40\xf2\x41\x50\xf2\x31\x60\xf1\x21\x70\xf2\x11\x8f"
            "\x11\x94" }  },
      /* --- pixel bitmap for cmmi180 char#62 > --- */
      {  62,117389,                     /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x22\xe0\x12\xe0\x12\xe0\x12\xe0\x12\xe0\x12"
            "\xe0\x11\xc2\xb2\xb2\xb2\xb2\xb2\xb2\xd0" }  },
      /* --- pixel bitmap for cmmi180 char#63 \star --- */
      {  63,118096,                     /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x61\x64\x21\x24\x29\x73\xa1\x11\x92\x12\x72\x32"
            "\x61\x51\x51\x71\x22" }  },
      /* --- pixel bitmap for cmmi180 char#64 \partial --- */
      {  64,94589,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x03\x84\x40\x20\x08\x0c\x01\x01\x20\xf8\x84\xa1"
            "\x08\x9c\x01\x1b\x60\x03\x3c\xc0\x06\xd8\x80\x19\x30"
            "\x02\x83\x30\xe0\x01" }  },
      /* --- pixel bitmap for cmmi180 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   18, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xc2\x30\xb3\x30\xf1\xa1\x12\x30\xf1\x91\x22\x30"
            "\x81\x32\xa2\x32\xa1\x42\x91\x52\x99\x20\xf1\x51\x72"
            "\x20\x41\x82\x51\x92\x42\x92\x26\x47" }  },
      /* --- pixel bitmap for cmmi180 char#66 B --- */
      {  66, 2390,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   17, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4d\x92\x72\x82\x82\xf2\x62\x92\x62\x82\x62\x64\x7c"
            "\x72\x83\x62\x92\x10\xf2\x42\xa2\x10\x42\x92\x52\x83"
            "\x3e\x51" }  },
      /* --- pixel bitmap for cmmi180 char#67 C --- */
      {  67, 3363,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 18,   19, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x31\x63\x51\x21\x52\x83\x41\xb2\x32\xb1\x32\xc1"
            "\x22\xd1\x22\xe0\x1f\x32\xe0\x2f\x22\xc1\x30\x11\xb1"
            "\x61\x91\x81\x62\xa6\x82" }  },
      /* --- pixel bitmap for cmmi180 char#68 D --- */
      {  68, 4537,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   17, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\x92\x72\x82\x82\x10\xf1\x52\xa2\xf1\x52\xb1\xf2"
            "\x42\xb2\x42\xb1\x42\xb2\x42\xa2\x52\xa1\x62\x82\x62"
            "\x73\x5c\x71" }  },
      /* --- pixel bitmap for cmmi180 char#69 E --- */
      {  69, 5964,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x62\x82\x62\x91\xf1\x52\xa1\x52\x51\x41\x52\x51"
            "\x92\x51\xa8\xa2\x51\xa2\x51\x41\x42\x51\x41\x52\xa1"
            "\x20\xf1\x32\x91\x30\x22\x83\x3e\x47" }  },
      /* --- pixel bitmap for cmmi180 char#70 F --- */
      {  70, 7227,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4d\x62\x72\x62\x81\xf1\x52\x91\x52\x51\x31\x52\x51"
            "\x82\x51\x98\x50\xf1\x42\x51\x50\x32\x51\x60\xf2\x32"
            "\xc0\x22\xd7\xa1" }  },
      /* --- pixel bitmap for cmmi180 char#71 G --- */
      {  71, 8414,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 18,   19, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x31\x63\x51\x21\x52\x83\x41\xb2\x32\xb1\x32\xc1"
            "\x22\xd1\x22\xe0\x1f\x12\xe0\x22\x99\xc2\x2f\x22\xb2"
            "\x30\x11\xb2\x51\x92\x71\x62\x11\x86\x80" }  },
      /* --- pixel bitmap for cmmi180 char#72 H --- */
      {  72, 9649,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   17, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x38\xf1\x72\x92\x30\xf3\x62\x92\x40\x52\x92\xad"
            "\x50\xf1\x52\x92\x50\xf3\x42\x92\x60\x32\x92\x78\x38"
            "\x40" }  },
      /* --- pixel bitmap for cmmi180 char#73 I --- */
      {  73,10380,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\xf1\x72\x30\xf3\x62\x40\xf3\x52\x50\xf3\x42\x60"
            "\x32\x78\x42" }  },
      /* --- pixel bitmap for cmmi180 char#74 J --- */
      {  74,11208,                      /* character number, location */
         17, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xf1\x92\x20\xf3\x82\x30\xf3\x72\x40\xf1\x62\x51"
            "\x52\x52\x41\x61\x42\x61\x32\x84\x80" }  },
      /* --- pixel bitmap for cmmi180 char#75 K --- */
      {  75,12441,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   17, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x46\x62\x82\x92\x72\x92\x71\xb2\x61\xc2\x51\xd2"
            "\x31\xe2\x32\xe2\x21\x12\xd3\x32\xd2\x51\x90\xf1\x32"
            "\x62\x80\xf1\x32\x72\x70\x22\x92\x67\x46\x40" }  },
      /* --- pixel bitmap for cmmi180 char#76 L --- */
      {  76,13422,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x40\xf1\x72\x70\xf3\x62\x80\xf3\x52\x90\xf1\x42"
            "\x91\x42\x81\x52\x72\x42\x73\x1e\x22" }  },
      /* --- pixel bitmap for cmmi180 char#77 M --- */
      {  77,14726,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 27,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x03\xe0\x07\x1c\x00\x07\xe0\x00\x34\x80\x06\xd0"
            "\x00\x34\x80\x06\x20\x03\x32\x00\x19\x88\x01\xc4\x40"
            "\x06\x20\x06\x31\x00\x31\x84\x01\x88\x21\x0c\x20\x98"
            "\x30\x00\xc1\x82\x01\x08\x16\x0c\x40\x70\x60\x00\x83"
            "\x81\x01\x7f\x8c\x7f\x00" }  },
      /* --- pixel bitmap for cmmi180 char#78 N --- */
      {  78,15928,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   17, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x77\xf1\x73\x91\x30\xf1\x61\x22\x71\x40\xf1\x61"
            "\x32\x61\x40\xf1\x51\x52\x41\x50\xf1\x51\x62\x31\x50"
            "\xf1\x41\x82\x11\x60\xf1\x41\x93\x60\x32\xa1\x77\x81"
            "\x71" }  },
      /* --- pixel bitmap for cmmi180 char#79 O --- */
      {  79,16843,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x92\x52\x71\x82\x51\xa2\x31\xb2\x22\xc1\xf1\x12"
            "\xd1\x0f\x22\xd2\x0f\x12\xc2\x1f\x12\xb2\x20\x11\xa2"
            "\x42\x82\x62\x52\xa5\x81" }  },
      /* --- pixel bitmap for cmmi180 char#80 P --- */
      {  80,17966,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\x82\x72\x72\x82\xf2\x52\x92\x52\x82\x52\x73\x6a"
            "\x40\xf1\x42\xc0\xf3\x32\xd0\x22\xe7\xb2" }  },
      /* --- pixel bitmap for cmmi180 char#81 Q --- */
      {  81,19029,                      /* character number, location */
         18, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 17,   23, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x92\x52\x72\x72\x51\xa2\x31\xb2\x22\xb2\x12\xd1"
            "\x12\xc2\x0f\x22\xd2\x0f\x12\xc2\x12\xb2\x22\x43\x42"
            "\x31\x31\x21\x32\x42\x11\x41\x12\x63\x42\x31\x66\x41"
            "\xa2\x32\xa2\x31\xc4\xd3\x51" }  },
      /* --- pixel bitmap for cmmi180 char#82 R --- */
      {  82,20400,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4b\x92\x62\x82\x72\x10\xf2\x52\x82\x10\x52\x72\x62"
            "\x63\x79\x50\xf1\x42\x62\x40\xf2\x32\x72\x40\x32\x72"
            "\x31\x22\x81\x31\x17\x52\x21\xe3\x23" }  },
      /* --- pixel bitmap for cmmi180 char#83 S --- */
      {  83,21485,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x21\x62\x41\x11\x51\x72\x42\x72\xf1\x32\x81\x10"
            "\x32\xd3\xd6\xa7\xc4\x20\xf1\xb2\x20\xf1\x11\x92\x20"
            "\x11\x82\x32\x81\x44\x42\x51\x35\x63" }  },
      /* --- pixel bitmap for cmmi180 char#84 T --- */
      {  84,22569,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x02\x12\x52\x52\x11\x62\x52\x0f\x21\x62\x61\x10"
            "\x72\x80\xf3\x62\x90\xf3\x52\xa0\x42\xc9\x71" }  },
      /* --- pixel bitmap for cmmi180 char#85 U --- */
      {  85,23573,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x47\xf1\x32\xa1\x30\xf3\x22\xa1\x40\xf3\x12\xa1"
            "\x5f\x22\xa1\x60\x11\x91\x82\x71\xa2\x42\xc5\xb2" }  },
      /* --- pixel bitmap for cmmi180 char#86 V --- */
      {  86,24509,                      /* character number, location */
         17, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x66\x22\x92\x30\xf1\x22\x91\x40\x22\x81\x50\xf1"
            "\x22\x71\x60\xf1\x32\x51\x70\x32\x41\x80\xf1\x32\x31"
            "\x90\x32\x21\xd2\x12\xd2\x11\xe3\xe0\x22\xe0\x21\xd1" }  },
      /* --- pixel bitmap for cmmi180 char#87 W --- */
      {  87,25897,                      /* character number, location */
         17, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\xfe\xf8\x19\x30\x40\x30\x60\x80\x60\xc0\x80\xc0"
            "\xc0\x81\x81\x41\x03\x01\x83\x06\x01\x86\x0c\x02\x0c"
            "\x19\x02\x18\x71\x04\x30\xc2\x04\x60\x82\x09\xc0\x04"
            "\x0b\x80\x05\x1e\x00\x07\x1c\x00\x0e\x18\x00\x0c\x30"
            "\x00\x18\x20\x00\x00" }  },
      /* --- pixel bitmap for cmmi180 char#88 X --- */
      {  88,27082,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x36\x72\x63\x92\x61\xc2\x41\xd2\x31\xe3\x11\xe0"
            "\x24\x70\xf2\x93\x80\x81\x22\xe1\x32\xd1\x43\xb1\x62"
            "\xa1\x73\x82\x82\x56\x56\x33" }  },
      /* --- pixel bitmap for cmmi180 char#89 Y --- */
      {  89,28166,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x66\x22\x92\x53\x81\x72\x71\x83\x51\xa2\x42\xa2"
            "\x41\xc2\x21\xd2\x11\xe3\xe0\x22\xa0\xf3\x52\xb0\x42"
            "\xd8\x93" }  },
      /* --- pixel bitmap for cmmi180 char#90 Z --- */
      {  90,29263,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x53\x62\x61\x72\x62\x62\x71\x62\x81\x53\xd3\xe2"
            "\xe2\xe2\xe2\x61\x72\x61\x72\x71\x62\x81\x52\x82\x42"
            "\x82\x4d\x42" }  },
      /* --- pixel bitmap for cmmi180 char#91 \flat --- */
      {  91,118793,                     /* character number, location */
         19, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  8,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x01\x01\x01\x01\x01\x01\x3d\x63\xc1\xc1\xc1\xc1"
            "\x61\x61\x31\x19\x0d\x07\x01" }  },
      /* --- pixel bitmap for cmmi180 char#92 \natural --- */
      {  92,119562,                     /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  6,   25, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x01\x51\x33\x18\x13\x31\x0f\x61\x41\x01\x33\x18"
            "\x13\x31\xf3\x51" }  },
      /* --- pixel bitmap for cmmi180 char#93 \sharp --- */
      {  93,120441,                     /* character number, location */
         18, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  8,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x42\x42\x42\x42\xc2\xfe\x7f\x43\x42\x42\x42\x42"
            "\x42\x42\x42\xc2\xfe\x7f\x43\x42\x42\x42\x02" }  },
      /* --- pixel bitmap for cmmi180 char#94 \smile --- */
      {  94,121375,                     /* character number, location */
         10, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 23,    6, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x71\x11\xe0\x51\x32\xe0\x12\x54\x94\x8d\xd7"
            "\x81" }  },
      /* --- pixel bitmap for cmmi180 char#95 \frown --- */
      {  95,122245,                     /* character number, location */
         11, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\xe0\x3b\xae\x01\x72\xd2\x51\xe0\x31\x31\xe0\x51"
            "\x11\xe0\x71" }  },
      /* --- pixel bitmap for cmmi180 char#96 \ell --- */
      {  96,95373,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x01\x0b\x26\x58\x30\xc1\x04\x0b\x16\x58\xe0\x80"
            "\x01\x02\x0c\x28\x90\x00\x66\x70\x00" }  },
      /* --- pixel bitmap for cmmi180 char#97 a --- */
      {  97,30207,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc2\x1c\xc3\x0c\x66\xb0\xc1\x0c\x66\xb0\xc3\x15"
            "\x1f\xc7\x00" }  },
      /* --- pixel bitmap for cmmi180 char#98 b --- */
      {  98,31071,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x60\x80\x01\x03\x0c\x30\xc0\x8f\x63\x06\x19\x6c"
            "\xf0\x60\x83\x0d\x36\x8c\x18\x1c\x00" }  },
      /* --- pixel bitmap for cmmi180 char#99 c --- */
      {  99,31906,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x61\xc8\xb0\x01\x06\x0c\x30\xc0\x00\x02\x1a\xc6"
            "\x07" }  },
      /* --- pixel bitmap for cmmi180 char#100 d --- */
      { 100,32872,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x0f\xc0\x00\x0c\x60\x00\x06\x60\xf0\x86\x39\x0c"
            "\x63\x30\x06\x33\x18\x83\x31\x58\xc3\x25\x3e\x1c\x03" }  },
      /* --- pixel bitmap for cmmi180 char#101 e --- */
      { 101,33715,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x60\xc4\x90\x41\xfe\x0c\x30\xc0\x00\x02\x1a\xc6"
            "\x07" }  },
      /* --- pixel bitmap for cmmi180 char#102 f --- */
      { 102,34861,                      /* character number, location */
         17, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 12,   22, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x82\x12\x72\x11\x10\xf2\x62\x40\x38\x72\x40\xf5"
            "\x52\x50\xf3\x42\x60\x41\x81\x12\x72\x11\x92\x91" }  },
      /* --- pixel bitmap for cmmi180 char#103 g --- */
      { 103,35834,                      /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x85\x39\x86\x19\xcc\x60\x83\x19\xcc\x60\x86\x23"
            "\x0e\x6e\x00\x03\x18\x61\x8c\xc1\x07" }  },
      /* --- pixel bitmap for cmmi180 char#104 h --- */
      { 104,36767,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x00\x03\x30\x80\x01\x18\x80\x01\xd8\xc3\x62\x1c"
            "\xc6\x60\x0c\x66\x30\x06\x63\xb0\x86\x39\x58\x03\x03" }  },
      /* --- pixel bitmap for cmmi180 char#105 i --- */
      { 105,37641,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x0c\x00\x00\xc0\x68\x59\xc6\x30\x86\x69\x5a\x0c" }  },
      /* --- pixel bitmap for cmmi180 char#106 j --- */
      { 106,38564,                      /* character number, location */
         17,-1,   -5,-1,      /* topleft row,col, and botleft row,col */
          { 11,   22, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\x92\xf3\xb0\x63\x71\x22\x10\xf1\x41\x32\x10\x82"
            "\x10\xf3\x72\x20\xf3\x62\x30\x11\x32\x42\x22\x64\x62" }  },
      /* --- pixel bitmap for cmmi180 char#107 k --- */
      { 107,39581,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x80\x01\x0c\x30\x80\x01\x0c\x60\x9c\x91\x4c\x66"
            "\x01\x07\xfc\x60\x0c\x63\x1a\x73\x58\x83\x01" }  },
      /* --- pixel bitmap for cmmi180 char#108 l --- */
      { 108,40287,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x63\xc6\x18\x33\xc6\x98\x31\xe6\x5c\x06" }  },
      /* --- pixel bitmap for cmmi180 char#109 m --- */
      { 109,41514,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\xe7\xa1\xc5\x31\x39\x0c\x93\xc1\x30\x18\x0c\xc3"
            "\x60\x18\x0c\x86\xc1\x60\x98\x0c\xc6\x64\x30\x4c\x06"
            "\x83\x03" }  },
      /* --- pixel bitmap for cmmi180 char#110 n --- */
      { 110,42557,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\x43\xc7\x64\x98\x0c\x83\x61\x18\x06\xc3\x60\x98"
            "\x8c\xc9\x30\x19\x1c" }  },
      /* --- pixel bitmap for cmmi180 char#111 o --- */
      { 111,43313,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xc0\x18\x83\x0c\x6c\xe0\x81\x0d\x6c\x60\x82\x31"
            "\x06\x0f\x00" }  },
      /* --- pixel bitmap for cmmi180 char#112 p --- */
      { 112,44305,                      /* character number, location */
         11,-2,   -5,-2,      /* topleft row,col, and botleft row,col */
          { 14,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x0f\x3a\x86\x06\xa1\xc1\x60\x30\x0c\x06\x83\xc1"
            "\x60\x30\x0c\x8e\x81\x1d\x60\x00\x18\x00\x03\xc0\x00"
            "\xfc\x00" }  },
      /* --- pixel bitmap for cmmi180 char#113 q --- */
      { 113,45238,                      /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc4\x14\xc3\x0c\x66\xb0\xc1\x0c\x66\x30\xc3\x11"
            "\x07\x37\x80\x01\x0c\x30\x80\x01\x3f" }  },
      /* --- pixel bitmap for cmmi180 char#114 r --- */
      { 114,46109,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\x7b\x76\x6e\xc0\xc0\x80\x01\x03\x06\x06\x0c\x00" }  },
      /* --- pixel bitmap for cmmi180 char#115 s --- */
      { 115,47049,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x18\x1a\x36\xe0\x83\x0f\xb8\x60\x43\xc2\x78\x00" }  },
      /* --- pixel bitmap for cmmi180 char#116 t --- */
      { 116,47797,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x18\x18\x18\xff\x0c\x0c\x0c\x0c\x06\x06\x46\x26"
            "\x26\x1c" }  },
      /* --- pixel bitmap for cmmi180 char#117 u --- */
      { 117,48841,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xa4\x60\x0d\xd6\x60\x0c\x66\x30\x06\x63\xb0\x86"
            "\x6b\x7c\x38\x06" }  },
      /* --- pixel bitmap for cmmi180 char#118 v --- */
      { 118,49736,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x2b\xdc\x60\x83\x0c\x1a\x64\x90\x41\x86\x10\x81"
            "\x03" }  },
      /* --- pixel bitmap for cmmi180 char#119 w --- */
      { 119,50920,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xc4\x12\xc6\x11\x86\x19\x86\x18\x86\x0c\x43\x0c"
            "\x43\x0c\x43\x0c\x23\x88\x23\x70\x1e" }  },
      /* --- pixel bitmap for cmmi180 char#120 x --- */
      { 120,52158,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x0e\x39\x12\x63\x62\x00\x0c\xc0\x00\x18\x00\x43"
            "\x62\x64\xce\x38\x07" }  },
      /* --- pixel bitmap for cmmi180 char#121 y --- */
      { 121,53236,                      /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x94\x70\x84\x33\x8c\x61\x86\x31\x8c\x61\x0c\x63"
            "\x0c\x7e\x00\x23\x8c\x61\x84\xc1\x03" }  },
      /* --- pixel bitmap for cmmi180 char#122 z --- */
      { 122,54148,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\xc4\x1f\x41\x00\x01\x04\x10\x40\x00\x41\x04\xf1"
            "\x4f\x38\x00" }  },
      /* --- pixel bitmap for cmmi180 char#123 \imath --- */
      { 123,96127,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x96\x65\x0c\x63\x98\xa6\xc5\x00" }  },
      /* --- pixel bitmap for cmmi180 char#124 \jmath --- */
      { 124,96932,                      /* character number, location */
         11,-1,   -5,-1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x61\x22\xf1\x41\x32\x82\xf3\x72\x10\xf3\x62\x20"
            "\x11\x32\x32\x22\x54\x50" }  },
      /* --- pixel bitmap for cmmi180 char#125 \wp --- */
      { 125,98059,                      /* character number, location */
         12, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 15,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x00\x0c\x0f\x66\x8c\x09\xc4\x02\xe6\x00\x3b\xc0"
            "\x1c\x60\x06\x30\x47\x8c\x27\x43\xf3\x20\x03\x90\x01"
            "\x64\x00\x32\x00\x09\x00\x03\x00" }  },
      /* --- pixel bitmap for cmmi180 char#126 \vec --- */
      { 126,98703,                      /* character number, location */
         17, 5,   14, 5,      /* topleft row,col, and botleft row,col */
          { 10,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xfd\x0f\x08" }  },
      /* --- pixel bitmap for cmmi180 char#127 (noname) --- */
      { 127,99239,                      /* character number, location */
         16, 6,   14, 6,      /* topleft row,col, and botleft row,col */
          { 10,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x19\x08" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=6 for .210gf ---
 * mf '\mode=preview; mag=magstep(-13.80488502080647873125); input cmmi10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmi210 --- */
static	chardef  cmmi210[] =
   {
      /* --- pixel bitmap for cmmi210 char#0 \Gamma --- */
      {   0,55957,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x01\x82\x82\xf2\x72\x92\x72\x91\x72\xa1\x10\xf2"
            "\x62\xc0\xf3\x52\xd0\xf3\x42\xe0\x32\xe0\x19\xb3" }  },
      /* --- pixel bitmap for cmmi210 char#1 \Delta --- */
      {   1,56876,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   21, 3,90, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x12\x50\xe3\xe0\x41\x13\x40\xf1\xc1\x32\x40"
            "\xb1\x42\xe1\x53\xc2\x62\xc1\x72\xb1\x82\xa1\x93\x82"
            "\xa2\x81\xb2\x71\xc2\x61\xd2\x61\xe2\x41\xe0\x12\x31"
            "\xe0\x22\x2e\x06\x2e\x07" }  },
      /* --- pixel bitmap for cmmi210 char#2 \Theta --- */
      {   2,58071,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 20,   22, 3,95, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\xd2\x52\x92\x82\x72\xa2\x52\xb2\x42\xd2\xf1\x22"
            "\xe2\x12\xe0\x12\x12\x31\x71\x32\x12\x39\x34\x39\x32"
            "\x12\x31\x71\x32\x12\xe0\x12\x1f\x12\xe2\x22\xd2\x42"
            "\xb2\x52\xa2\x72\x82\x92\x52\xd5\xa0" }  },
      /* --- pixel bitmap for cmmi210 char#3 \Lambda --- */
      {   3,59055,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   21, 3,84, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xd2\x30\xf1\xc3\x30\xf1\xb1\x12\x30\xf1\xa1\x22"
            "\x30\x91\x32\x30\xf1\x81\x42\x30\x71\x52\xa1\x53\x81"
            "\x63\x81\x72\x20\xf1\x51\x82\x20\x41\x92\x51\xa2\x42"
            "\xa2\x26\x57" }  },
      /* --- pixel bitmap for cmmi210 char#4 \Xi --- */
      {   4,60530,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x5e\x03\xf2\x41\xe0\x11\x10\xf2\xe0\x80\x61\x91"
            "\xbb\xab\xb1\x91\x60\xf2\xe0\x80\xf2\x11\xe0\x11\x4f"
            "\x1e\x03\x52" }  },
      /* --- pixel bitmap for cmmi210 char#5 \Pi --- */
      {   5,61747,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   20, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x06\x82\xa2\x30\xf3\x72\xa2\x40\xf3\x62\xa2\x50"
            "\xf3\x52\xa2\x60\xf3\x42\xa2\x70\x32\xa2\x88\x48\x5f" }  },
      /* --- pixel bitmap for cmmi210 char#6 \Sigma --- */
      {   6,62946,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x02\x53\xa3\xf1\x62\xb2\x72\xa2\x72\xa1\x83\x91"
            "\x92\xe0\x53\xa0\xf1\x92\xa0\x91\xe0\x42\xe0\x41\xb1"
            "\x71\xb1\x71\xc1\x61\xc1\x61\xc2\x51\xb4\x4e\x02\x52" }  },
      /* --- pixel bitmap for cmmi210 char#7 \Upsilon --- */
      {   7,63996,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   21, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x74\x36\x56\x12\x42\x31\x51\x11\x61\x21\x62\x71"
            "\x21\x61\xf1\x81\x11\x80\xf3\x82\x90\xf3\x72\xa0\xf3"
            "\x62\xb0\x52\xda\x81" }  },
      /* --- pixel bitmap for cmmi210 char#8 \Phi --- */
      {   8,65068,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   20, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7a\xc2\x50\xf1\xa2\x60\x77\x92\x32\x13\x52\x42\x42"
            "\x32\x52\x42\x10\xf1\x12\x62\x52\x0f\x12\x62\x52\x10"
            "\x12\x52\x42\x32\x52\x32\x53\x22\x22\x97\x70\xf1\x72"
            "\x90\x62\xca\x62" }  },
      /* --- pixel bitmap for cmmi210 char#9 \Psi --- */
      {   9,66173,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6a\xd2\x70\xf1\x92\x82\x72\x53\x12\x62\x42\x32\x52"
            "\x52\x20\xf2\x12\x52\x42\x30\xf1\x12\x42\x42\x40\x12"
            "\x42\x32\x71\x42\x22\x83\x12\x22\xb6\x90\xf1\x62\xb0"
            "\x52\xda\x8a" }  },
      /* --- pixel bitmap for cmmi210 char#10 \Omega --- */
      {  10,67410,                      /* character number, location */
         21, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 21,   21, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb5\xd3\x52\xa2\x91\x82\xa2\x62\xb2\x52\xd1\x52\xd2"
            "\xf2\x32\xd2\x10\x32\xc2\x52\xc1\x71\xb2\x72\x92\x82"
            "\x82\xa1\x81\x61\x41\x71\x41\x21\x41\x62\x41\x21\x41"
            "\x61\x41\x36\x57\x36\x56\x42" }  },
      /* --- pixel bitmap for cmmi210 char#11 \alpha --- */
      {  11,68476,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x18\x62\x60\x64\xc0\x64\x80\xc9\x00\x8f"
            "\x01\x9c\x01\x18\x03\x30\x04\x70\x18\xd0\x60\x98\x85"
            "\x0f\x0e" }  },
      /* --- pixel bitmap for cmmi210 char#12 \beta --- */
      {  12,69539,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 15,   26, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x94\xa1\x41\x81\x52\x61\x62\x51\x72\x51\x71\x51\x72"
            "\x51\x26\x61\x25\x71\x62\x20\xf3\x31\x82\x10\xf1\x21"
            "\x82\x20\x21\x72\x52\x61\x51\x11\x42\x61\x25\x60\xf1"
            "\x11\xdf\x31\xe7" }  },
      /* --- pixel bitmap for cmmi210 char#13 \gamma --- */
      {  13,70504,                      /* character number, location */
         13, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x61\x27\x51\x13\x33\x31\x21\x71\x31\x11\x81\x31"
            "\x10\xf2\xa1\x11\x20\xf2\xa2\x30\xf3\xa1\x40\xf3\x91"
            "\x50\x81\x61" }  },
      /* --- pixel bitmap for cmmi210 char#14 \delta --- */
      {  14,71475,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x01\xfc\x20\x0c\x02\x60\x00\x04\xc0\x00\x18\xc0"
            "\x03\x33\x18\xc7\x60\x06\x66\x60\x06\x36\x30\x03\x23"
            "\x30\x86\xc1\x08\x78\x00" }  },
      /* --- pixel bitmap for cmmi210 char#15 \epsilon --- */
      {  15,72353,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 10,   13, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x32\x72\x72\x72\x88\x2f\x42\x80\x12\x51\x45\x22" }  },
      /* --- pixel bitmap for cmmi210 char#16 \zeta --- */
      {  16,73265,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 12,   26, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x71\x40\x75\x66\x51\xa1\xa2\x92\xa1\xa2\xa1\xaf"
            "\x62\xa0\x13\xa5\x85\xa3\x30\xf1\x81\x30\x31\x32\x74"
            "\x42" }  },
      /* --- pixel bitmap for cmmi210 char#17 \eta --- */
      {  17,74166,                      /* character number, location */
         13, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 14,   20, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x45\x21\x12\x21\x42\x11\x23\x53\x23\x63\x22\x72"
            "\xf1\x32\x72\xf3\x22\x72\x10\xf1\x12\x72\x20\xf1\xa2"
            "\x20\xf3\x92\x30\x91\x41" }  },
      /* --- pixel bitmap for cmmi210 char#18 \theta --- */
      {  18,74948,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x03\x46\x30\x84\xc1\x08\xcc\xc0\x0c\x6c\xc0\x06"
            "\xec\xff\xff\x37\x60\x03\x36\x30\x03\x33\x10\x83\x21"
            "\x0c\x62\xc0\x01" }  },
      /* --- pixel bitmap for cmmi210 char#19 \iota --- */
      {  19,75607,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x18\x18\x0c\x0c\x0c\x0c\x06\x86\x86\x43\x23\x1e" }  },
      /* --- pixel bitmap for cmmi210 char#20 \kappa --- */
      {  20,76521,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x70\x0c\x3e\xc6\x8c\x11\xc0\x04\xe0\x01\xf0\x0f"
            "\x0c\x0c\x06\x46\x03\xa3\x81\x71\xc0\x34\xc0\x01" }  },
      /* --- pixel bitmap for cmmi210 char#21 \lambda --- */
      {  21,77366,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x00\x18\x00\x06\x00\x03\xc0\x00\x70\x00\x18\x00"
            "\x06\x80\x03\xc0\x00\x30\x00\x1e\x40\x06\x98\x01\xc3"
            "\x60\x30\x0c\x8c\x01\x36\x80\x05\xc0" }  },
      /* --- pixel bitmap for cmmi210 char#22 \mu --- */
      {  22,78386,                      /* character number, location */
         13, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x52\x72\x10\xf3\x42\x72\x20\x32\x72\x30\xf1\x32"
            "\x72\x21\x32\x63\x21\x24\x41\x12\x11\x32\x15\x33\x10"
            "\xf1\x22\xd0\xf3\x12\xe0\x11\xe0\x12" }  },
      /* --- pixel bitmap for cmmi210 char#23 \nu --- */
      {  23,79175,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x60\x0c\x30\x06\x98\x01\xc6\x00\x63\xc0\x30\x30"
            "\x0c\x0c\x06\x03\xc3\x80\x19\x60\x07\x70\x00\x00" }  },
      /* --- pixel bitmap for cmmi210 char#24 \xi --- */
      {  24,80307,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 12,   26, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x71\x40\x75\x52\x14\x42\x92\x70\xf2\x22\x80\x31"
            "\x80\xf1\x37\x20\x22\x80\xf1\x12\x9f\x22\xa3\xa4\x96"
            "\x94\xa3\xa2\x61\x32\x74\x31" }  },
      /* --- pixel bitmap for cmmi210 char#25 \pi --- */
      {  25,81259,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x7f\xfe\xbf\x11\x41\xc4\x00\x22\x00\x11\xc0\x08"
            "\x20\x04\x10\x02\x0c\x03\x86\x81\xc1\xc0\x60\x00" }  },
      /* --- pixel bitmap for cmmi210 char#26 \rho --- */
      {  26,82109,                      /* character number, location */
         13, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\xa2\x32\x72\x51\x62\x62\xf2\x42\x72\xf1\x32\x72"
            "\x10\x32\x62\x52\x61\x52\x11\x32\x62\x24\x50\xf1\x22"
            "\xb0\xf3\x12\xc0\x11\xd4" }  },
      /* --- pixel bitmap for cmmi210 char#27 \sigma --- */
      {  27,83027,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   13, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6a\x4c\x33\x42\x62\x72\x30\xf2\x12\x82\x3f\x12\x82"
            "\x40\x11\x72\x62\x61\x81\x42\xa4\x92" }  },
      /* --- pixel bitmap for cmmi210 char#28 \tau --- */
      {  28,83798,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x2c\x12\x41\x71\x51\x60\xf1\x62\x60\xf1\x61\x70"
            "\xf2\x52\x70\xf1\x42\x81" }  },
      /* --- pixel bitmap for cmmi210 char#29 \upsilon --- */
      {  29,84703,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x20\x19\xb8\x0c\x28\x06\x94\x01\xc2\x00\x61\x80"
            "\x18\x20\x0c\x10\x06\x04\x03\x01\x43\x00\x1e\x00" }  },
      /* --- pixel bitmap for cmmi210 char#30 \phi --- */
      {  30,85585,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 17,   26, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\xb1\x50\xf2\xa1\x60\x76\x92\x21\x32\x52\x41\x42"
            "\x32\x51\x51\x31\x61\x52\xf1\x12\x51\x62\x02\x61\x52"
            "\x21\x61\x52\x22\x41\x52\x41\x41\x42\x62\x21\x22\x96"
            "\x70\xf3\x61\xa0\xf1\x51\xb2" }  },
      /* --- pixel bitmap for cmmi210 char#31 \chi --- */
      {  31,86646,                      /* character number, location */
         13, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 17,   19, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\xa1\x21\x22\x81\x62\x81\x63\x61\x82\x51\x93\x31"
            "\xb2\x21\xc2\x11\xd3\xe0\x12\xe3\xe4\xc1\x22\xb1\x32"
            "\xa1\x52\x81\x62\x71\x73\x21\x21\x92\x21\x11\xb3\x26" }  },
      /* --- pixel bitmap for cmmi210 char#32 \psi --- */
      {  32,87737,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 18,   26, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\xc1\x50\xf3\xb1\x60\x23\x51\x51\x21\x22\x41\x52"
            "\x11\x22\x41\x51\x11\x32\x41\x51\x11\x22\x41\x61\x10"
            "\xf1\x32\x41\x61\x10\x22\x51\x51\x42\x41\x61\x42\x41"
            "\x51\x62\x31\x41\x82\x21\x22\xa6\x70\xf2\x71\xa0\xf2"
            "\x61\xb0" }  },
      /* --- pixel bitmap for cmmi210 char#33 \omega --- */
      {  33,88838,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   13, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\xb1\x41\xc2\xf1\x21\xd1\x10\xf2\x11\x62\x61\x1f"
            "\x12\x52\x61\x22\x52\x51\x42\x26\x13\x46\x16\x63\x44"
            "\x51" }  },
      /* --- pixel bitmap for cmmi210 char#34 \varepsilon --- */
      {  34,89829,                      /* character number, location */
         14, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x58\x22\x52\x21\x80\xf1\x11\x90\xf1\x25\x40\x11"
            "\x9f\x21\xa2\x61\x37\x55\x42" }  },
      /* --- pixel bitmap for cmmi210 char#35 \vartheta --- */
      {  35,90838,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x1c\x80\x11\x40\x08\x10\x0c\x08\x06\x04\x03\x82"
            "\x19\xc2\x1a\x66\x19\x7c\x06\x2c\x03\x86\x01\xc3\xc0"
            "\x30\x60\x18\x10\x0c\x0c\x06\x03\xc6\x00\x1e\x00" }  },
      /* --- pixel bitmap for cmmi210 char#36 \varpi --- */
      {  36,92101,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xff\x3f\xff\xff\x6f\x02\x00\x49\x00\x40\x10\x08"
            "\x10\x02\x02\x84\xc0\x00\x11\x30\x20\x04\x0e\x08\x81"
            "\x02\xc1\x98\x31\xe0\xe3\x07\x78\xf0\x00" }  },
      /* --- pixel bitmap for cmmi210 char#37 \varrho --- */
      {  37,93024,                      /* character number, location */
         13, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x82\x32\x52\x51\x42\x62\xf2\x22\x72\xf1\x12\x72"
            "\x10\x12\x62\x33\x51\x31\x21\x32\x41\x34\x5f\x21\xc8"
            "\x77\xc1\x41" }  },
      /* --- pixel bitmap for cmmi210 char#38 \varsigma --- */
      {  38,93861,                      /* character number, location */
         13, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x32\x41\x21\x82\x7f\x32\x83\x84\x74\x84\x20\xf1"
            "\x62\x20\x61\x63\x41" }  },
      /* --- pixel bitmap for cmmi210 char#39 \varphi --- */
      {  39,94800,                      /* character number, location */
         13, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 16,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x38\x04\x7e\x02\xc3\x02\x81\x81\x80\x81\x80\x41"
            "\x80\x41\x40\x41\x60\x23\x30\x2e\x1c\xfc\x0f\xf0\x03"
            "\x30\x00\x10\x00\x10\x00\x18\x00\x18\x00\x18\x00\x08"
            "\x00" }  },
      /* --- pixel bitmap for cmmi210 char#40 \leftharpoonup --- */
      {  40,110784,                     /* character number, location */
         15, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          { 25,    9, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x62\xe0\x30\xf1\x52\xe0\x40\x42\xe0\x83\xe0\x73"
            "\xe0\x7e\x0e\x0e\x07" }  },
      /* --- pixel bitmap for cmmi210 char#41 \leftharpoondown --- */
      {  41,111816,                     /* character number, location */
          8, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,    9, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0b\x1e\x0a\x23\xe0\x93\xe0\x92\xe0\x50\xf1\x52"
            "\xe0\x40\xf1\x62\xe0\x31" }  },
      /* --- pixel bitmap for cmmi210 char#42 \rightharpoonup --- */
      {  42,112846,                     /* character number, location */
         15, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          { 25,    9, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x32\x60\xf1\xe0\x42\x50\xe0\x52\xe0\x93\xe0"
            "\x93\x2f\x1e\x0b" }  },
      /* --- pixel bitmap for cmmi210 char#43 \rightharpoondown --- */
      {  43,113879,                     /* character number, location */
          8, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,    9, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0b\xe0\x63\xe0\x73\xe0\x82\x40\xf1\xe0\x42"
            "\x50\xf1\xe0\x32\x60" }  },
      /* --- pixel bitmap for cmmi210 char#44 ` --- */
      {  44,114304,                     /* character number, location */
         14, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x33\x33\xef" }  },
      /* --- pixel bitmap for cmmi210 char#45 ' --- */
      {  45,114728,                     /* character number, location */
         14, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\xcc\xcc\x7f" }  },
      /* --- pixel bitmap for cmmi210 char#46 \triangleright --- */
      {  46,115269,                     /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xb4\x96\x72\x23\x62\x34\x42\x54\x2f\x12\x74\x02"
            "\x54\x22\x34\x42\x23\x66\x74\x92\xb4" }  },
      /* --- pixel bitmap for cmmi210 char#47 \triangleleft --- */
      {  47,115837,                     /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb2\x94\x76\x54\x22\x43\x42\x24\x52\x0f\x14\x72\x24"
            "\x52\x43\x42\x54\x22\x76\x94\xb2" }  },
      /* --- pixel bitmap for cmmi210 char#48 \0 --- */
      {  48,101197,                     /* character number, location */
         14, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x52\x32\x72\x21\x91\x1f\x62\x92\x11\x91\x22"
            "\x72\x32\x52\x65\x41" }  },
      /* --- pixel bitmap for cmmi210 char#49 \1 --- */
      {  49,101980,                     /* character number, location */
         14, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x46\x40\xfa\x42\x4a" }  },
      /* --- pixel bitmap for cmmi210 char#50 \2 --- */
      {  50,102954,                     /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x52\x32\x72\x10\xf1\x13\x72\xb2\xb1\xb2\x92"
            "\x93\x92\x51\x32\x71\x1b\x1c\x13" }  },
      /* --- pixel bitmap for cmmi210 char#51 \3 --- */
      {  51,103989,                     /* character number, location */
         14, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x71\x52\x41\x71\x20\xf1\x13\x62\x10\x21\x72\xb1"
            "\xb2\xa2\x75\xd2\xc2\xc1\xc2\x11\x92\x0f\x13\x82\x01"
            "\xa1\x21\x82\x32\x52\x65\x41" }  },
      /* --- pixel bitmap for cmmi210 char#52 \4 --- */
      {  52,104936,                     /* character number, location */
         14, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   20, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x82\x30\x73\x94\x91\x12\x81\x22\x72\x22\x71\x32"
            "\x61\x42\x52\x42\x51\x52\x41\x62\x32\x62\x3d\xf4\x82"
            "\x30\x58" }  },
      /* --- pixel bitmap for cmmi210 char#53 \5 --- */
      {  53,105989,                     /* character number, location */
         14, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x52\x48\x51\x14\x50\xf3\x21\xa0\x21\x24\x61\x11"
            "\x42\x42\x62\x31\x72\x10\xf2\xb2\x0f\x13\x82\x02\x92"
            "\x11\x82\x21\x81\x42\x42\x75\x42" }  },
      /* --- pixel bitmap for cmmi210 char#54 \6 --- */
      {  54,106908,                     /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x72\x41\x52\x43\x32\x53\x31\xb2\xb1\xb2\x34\x42"
            "\x12\x41\x33\x71\x23\x72\x1f\x32\x92\x11\x92\x12\x82"
            "\x12\x72\x31\x71\x52\x41\x75\x42" }  },
      /* --- pixel bitmap for cmmi210 char#55 \7 --- */
      {  55,107837,                     /* character number, location */
         14, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xcc\x1b\x21\x91\x11\x91\x21\x81\x30\xf1\x81\x40"
            "\x71\x50\xf1\x61\x60\xf1\x52\x60\xf2\x42\x70\xf3\x33"
            "\x70\x41\x81" }  },
      /* --- pixel bitmap for cmmi210 char#56 \8 --- */
      {  56,108770,                     /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x72\x32\x52\x52\x20\xf2\x12\x72\x10\x13\x62\x33"
            "\x42\x53\x22\x74\x95\x62\x43\x32\x63\x21\x83\x0f\x32"
            "\x92\x12\x72\x32\x52\x65\x45" }  },
      /* --- pixel bitmap for cmmi210 char#57 \9 --- */
      {  57,109697,                     /* character number, location */
         14, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x10\x03\x36\xc0\x06\xd0\x00\x1e\xc0"
            "\x03\x78\x00\x1b\x70\x02\x8e\xb0\xe1\x31\x00\x02\x60"
            "\x00\xcc\xc1\x38\x08\xc2\x80\x0f\x00" }  },
      /* --- pixel bitmap for cmmi210 char#58 . --- */
      {  58,116334,                     /* character number, location */
          3, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00" }  },
      /* --- pixel bitmap for cmmi210 char#59 , --- */
      {  59,116895,                     /* character number, location */
          3, 3,   -6, 3,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x49\x4a\x01" }  },
      /* --- pixel bitmap for cmmi210 char#60 < --- */
      {  60,117559,                     /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x32\xe0\x14\xd4\xd4\xc5\xc5\xc4\xd4\xdf\x14\xe0"
            "\x10\x24\xe0\x34\xe0\x35\xe0\x25\xe0\x34\xe0\x34\xe0"
            "\x34\xe0\x32" }  },
      /* --- pixel bitmap for cmmi210 char#61 / --- */
      {  61,118097,                     /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 11,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x30\xc0\x01\x06\x30\xc0\x01\x06\x30\xc0\x01"
            "\x06\x30\xc0\x01\x06\x30\xc0\x01\x06\x30\xc0\x01\x06"
            "\x30\xc0\x01\x06\x30\xc0\x01\x06\x30\xc0\x01\x06\x30"
            "\x00" }  },
      /* --- pixel bitmap for cmmi210 char#62 > --- */
      {  62,118804,                     /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x34\xe0\x34\xe0\x34\xe0\x35\xe0\x25\xe0\x34"
            "\xe0\x34\x20\xf1\xe0\x14\xd4\xd4\xc5\xc5\xc4\xd4\xd4"
            "\xe0\x12\xe0\x32" }  },
      /* --- pixel bitmap for cmmi210 char#63 \star --- */
      {  63,119517,                     /* character number, location */
         15,-1,   -1,-1,      /* topleft row,col, and botleft row,col */
          { 17,   16, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x81\x84\x41\x44\x3b\x87\xc3\xd2\x12\xc1\x31\xb2"
            "\x32\x92\x52\x81\x71\x71\x91\x34" }  },
      /* --- pixel bitmap for cmmi210 char#64 \partial --- */
      {  64,95804,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x0f\x40\x10\x20\x20\x70\x60\x70\x40\x00\xc0\x00"
            "\xc0\x80\xc7\x60\xd8\x10\xd0\x08\xe0\x0c\x60\x06\x60"
            "\x06\x60\x06\x20\x03\x30\x03\x10\x03\x18\x02\x0c\x06"
            "\x04\x0c\x03\xf8\x00" }  },
      /* --- pixel bitmap for cmmi210 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   21, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe2\x40\xf1\xd3\x40\xc1\x12\xe0\x12\x12\xe0\x11"
            "\x22\xe1\x32\xe1\x42\x30\xf1\x91\x52\x30\x81\x62\xa1"
            "\x72\xaa\x30\xf1\x61\x82\x30\x51\x92\x30\xf1\x41\xa2"
            "\x30\x32\xa3\x27\x58" }  },
      /* --- pixel bitmap for cmmi210 char#66 B --- */
      {  66, 2400,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5d\xb2\x73\x10\xf3\x72\xa2\x62\xa2\x72\x92\x82\x82"
            "\x9b\x92\x92\x30\xf1\x52\xa2\x20\x52\xb2\x10\xf1\x42"
            "\xb2\x20\x42\xa2\x72\x93\x62\x92\x5e\x70" }  },
      /* --- pixel bitmap for cmmi210 char#67 C --- */
      {  67, 3385,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 20,   22, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\x41\x82\x51\x22\x62\x81\x12\x52\xa2\x52\xb2\x42"
            "\xc2\x32\xd2\x32\xd1\x20\xf2\x12\xe0\x3f\x22\xe0\x42"
            "\xe1\x3f\x12\xd1\x40\x11\xc1\x62\xa1\x82\x81\xa2\x52"
            "\xd5\xa2" }  },
      /* --- pixel bitmap for cmmi210 char#68 D --- */
      {  68, 4571,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5d\xc2\x73\x92\xa1\x92\xa2\x82\xb1\x82\xb2\xf3\x62"
            "\xc2\xf2\x52\xc2\x10\x52\xb2\x62\xc2\x62\xb2\x72\xa2"
            "\x82\x92\x82\x82\x7d\x91" }  },
      /* --- pixel bitmap for cmmi210 char#69 E --- */
      {  69, 6036,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x02\x82\x83\xf2\x72\xa2\x72\xa1\x72\x61\x41\x10"
            "\xf1\x62\x61\x60\x69\x60\xf1\x52\x61\x70\x52\x61\x51"
            "\x62\xb1\x20\xf1\x42\xc1\x20\x42\xb1\x72\xa2\x62\xa3"
            "\x3e\x03\x43" }  },
      /* --- pixel bitmap for cmmi210 char#70 F --- */
      {  70, 7309,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x02\x82\x83\xf2\x72\xa2\x72\xa1\x72\x61\x41\x10"
            "\xf1\x62\x61\x60\x69\x60\xf2\x52\x61\x70\x52\xe0\xf3"
            "\x42\xe0\x10\x32\xe0\x29\xc0" }  },
      /* --- pixel bitmap for cmmi210 char#71 G --- */
      {  71, 8504,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa6\x41\x82\x61\x22\x62\x91\x12\x52\xb2\x52\xc2\x42"
            "\xd2\x41\xe2\x32\xe1\x20\xf2\x12\xe0\x42\xe0\x52\xa8"
            "\x1f\x12\xe2\x32\xd2\x51\xd2\x52\xc2\x52\xb3\x62\xa2"
            "\x82\x63\x11\xa6\xa8" }  },
      /* --- pixel bitmap for cmmi210 char#72 H --- */
      {  72, 9751,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   20, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x48\x82\xa2\x30\xf3\x72\xa2\x40\xf2\x62\xa2\x50"
            "\x6e\x50\xf3\x52\xa2\x60\xf3\x42\xa2\x70\x32\xa2\x88"
            "\x48\x52" }  },
      /* --- pixel bitmap for cmmi210 char#73 I --- */
      {  73,10520,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   20, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x82\x30\xf3\x72\x40\xf3\x62\x50\xf3\x52\x60\xf3"
            "\x42\x70\x32\x88\x52" }  },
      /* --- pixel bitmap for cmmi210 char#74 J --- */
      {  74,11380,                      /* character number, location */
         20, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 16,   21, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\xc2\x20\xf3\xb2\x30\xf3\xa2\x40\xf3\x92\x50\x82"
            "\x71\x62\x63\x52\x62\x52\x71\x62\x81\x32\xb4\xa2" }  },
      /* --- pixel bitmap for cmmi210 char#75 K --- */
      {  75,12621,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   20, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x58\x57\x82\xa2\xa2\xa2\xb2\x91\xd2\x81\xe2\x61\xe0"
            "\x12\x61\xe0\x22\x51\xe0\x32\x33\xe0\x32\x21\x12\xe0"
            "\x22\x21\x32\xe0\x12\x11\x42\xa0\xf1\x52\x72\x90\xf1"
            "\x42\x92\x80\xf1\x42\xa2\x70\x32\xb3\x68\x67\x40" }  },
      /* --- pixel bitmap for cmmi210 char#76 L --- */
      {  76,13618,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   20, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x59\xc2\x80\xf3\x72\x90\xf3\x62\xa0\xf2\x52\xb0\x52"
            "\xa1\xf1\x42\xa1\x10\x42\x91\x62\x82\x52\x74\x2e\x01"
            "\x32" }  },
      /* --- pixel bitmap for cmmi210 char#77 M --- */
      {  77,14956,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 30,   20, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x56\xd6\x83\xd3\xa1\x12\xc3\x40\xf1\x71\x12\xb1\x12"
            "\x40\x71\x12\xa1\x22\xa1\x22\x91\x22\xb1\x32\x81\x22"
            "\xb1\x32\x71\x32\xb1\x32\x61\x42\xa1\x42\x61\x32\xb1"
            "\x42\x51\x42\xb1\x42\x41\x52\xb1\x52\x31\x52\xa1\x62"
            "\x21\x52\x70\xf1\x41\x62\x11\x62\x70\x41\x63\x72\xa2"
            "\x62\x72\x87\x42\x48\x50" }  },
      /* --- pixel bitmap for cmmi210 char#78 N --- */
      {  78,16182,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   20, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x55\x87\x82\xa2\x30\xf1\x71\x12\x91\x40\xf1\x71\x22"
            "\x81\x40\x61\x32\x71\x50\xf1\x61\x42\x61\x50\x61\x52"
            "\x51\xa1\x62\x41\x60\xf1\x51\x72\x31\x60\x51\x81\x31"
            "\x60\xf1\x41\x92\x11\x70\xf1\x41\xa3\x70\x32\xb1\x87"
            "\x91\x82" }  },
      /* --- pixel bitmap for cmmi210 char#79 O --- */
      {  79,17117,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 20,   22, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\xd2\x52\x92\x82\x72\xa2\x52\xc1\x42\xd2\xf1\x22"
            "\xe2\xf2\x12\xe0\x12\x0f\x22\xe0\x12\x1f\x12\xe2\x22"
            "\xd2\x42\xb2\x52\xa2\x72\x82\x92\x52\xd5\xa1" }  },
      /* --- pixel bitmap for cmmi210 char#80 P --- */
      {  80,18252,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5d\xb2\x73\x82\x92\x10\xf2\x72\xa2\xf1\x62\xa2\x10"
            "\x62\x92\x82\x73\x8a\x60\xf2\x52\xe0\xf3\x42\xe0\x10"
            "\x32\xe0\x28\xd2" }  },
      /* --- pixel bitmap for cmmi210 char#81 Q --- */
      {  81,19299,                      /* character number, location */
         21, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 20,   27, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xa5\xd2\x52\x92\x82\x72\xa2\x52\xb2\x42\xd2\xf1\x22"
            "\xe2\xf2\x12\xe0\x12\x0f\x22\xe0\x12\x1f\x12\xe2\x22"
            "\xd2\x42\x43\x42\x52\x31\x31\x22\x72\x11\x41\x12\x93"
            "\x42\x41\x86\x51\xd1\x42\xd1\x41\xe1\x32\xe5\xe0\x23"
            "\x61" }  },
      /* --- pixel bitmap for cmmi210 char#82 R --- */
      {  82,20686,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 21,   21, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\xc2\x63\x92\x82\x20\xf2\x72\x92\x10\x62\x92\x82"
            "\x82\x92\x63\xa9\xb2\x72\xa2\x81\x50\xf1\x52\x82\x40"
            "\xf2\x42\x82\x50\x42\x82\x41\x32\x92\x31\x18\x62\x21"
            "\xe0\x33\x36" }  },
      /* --- pixel bitmap for cmmi210 char#83 S --- */
      {  83,21809,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 17,   22, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x85\x31\x72\x41\x21\x61\x73\x52\x72\x10\xf2\x42\x91"
            "\x10\xf1\x42\xb0\x45\xd7\xd5\x40\xf2\xb2\x40\xf2\x11"
            "\x92\x40\x11\x82\x53\x71\x61\x21\x42\x71\x35\x82" }  },
      /* --- pixel bitmap for cmmi210 char#84 T --- */
      {  84,22905,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x03\x23\x62\x52\x21\x72\x62\x21\x72\x71\x11\x82"
            "\x71\x11\x82\x61\x11\x82\x71\x10\xf2\x92\x90\xf3\x82"
            "\xa0\xf3\x72\xb0\x62\xea\x81" }  },
      /* --- pixel bitmap for cmmi210 char#85 U --- */
      {  85,23919,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 21,   21, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x57\x42\xa2\x30\xf3\x32\xb1\x40\xf3\x22\xb1\x50"
            "\xf3\x12\xb1\x6f\x12\xb1\x70\x11\xa1\x92\x81\xa2\x71"
            "\xc2\x51\xe0\x15\xc2" }  },
      /* --- pixel bitmap for cmmi210 char#86 V --- */
      {  86,24867,                      /* character number, location */
         20, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 20,   21, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x76\x22\xc2\x42\xc1\x52\xb1\x40\xf1\x22\xa1\x50"
            "\xf1\x32\x81\x60\x32\x71\x70\xf1\x32\x61\x80\x32\x51"
            "\xc2\x42\xc2\x41\xd3\x21\xe0\x12\x21\xe0\x12\x11\xc0"
            "\xf1\x43\xd0\xf1\x42\xe2" }  },
      /* --- pixel bitmap for cmmi210 char#87 W --- */
      {  87,26276,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 29,   21, 3,139, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x08\x47\x46\x32\x93\x82\x52\x83\x91\x62\x81\x12\x81"
            "\x62\x71\x22\x71\x72\x71\x22\x61\x82\x61\x32\x61\x82"
            "\x61\x32\x51\x92\x51\x42\x51\x92\x42\x42\x41\xa2\x41"
            "\x52\x41\x70\xf1\x32\x31\x62\x31\x80\xf1\x32\x21\x72"
            "\x21\x90\xf1\x32\x11\x82\x11\xa0\xf1\x33\x93\xb0\x32"
            "\xa2\xe0\x12\xa1\xd8" }  },
      /* --- pixel bitmap for cmmi210 char#88 X --- */
      {  88,27491,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 24,   20, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x47\x82\x83\xb3\x71\xe2\x62\xe2\x52\xe0\x22\x32"
            "\xe0\x32\x31\xe0\x43\x11\x90\xf2\xb3\xa0\xa1\x12\xe0"
            "\x51\x32\xe0\x31\x42\xe0\x21\x62\xe1\x72\xd1\x83\xb2"
            "\x92\xa2\xa3\x67\x67\x41" }  },
      /* --- pixel bitmap for cmmi210 char#89 Y --- */
      {  89,28589,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x76\x32\xc2\x53\xa1\x82\x91\x92\x82\xa2\x71\xb2"
            "\x61\xc3\x41\xe2\x31\xe0\x12\x21\xe0\x24\xb0\xf2\x72"
            "\xc0\xf3\x62\xd0\x52\xe0\x28\xb2" }  },
      /* --- pixel bitmap for cmmi210 char#90 Z --- */
      {  90,29694,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x53\x82\x52\x92\x62\x82\x71\x82\x81\x73\x71\x82"
            "\xe0\x22\xe0\x22\xe0\x22\xe0\x22\xe0\x22\xe0\x22\x81"
            "\x72\x91\x63\x81\x72\x91\x62\x92\x52\xa2\x42\x93\x4e"
            "\x01\x42" }  },
      /* --- pixel bitmap for cmmi210 char#91 \flat --- */
      {  91,120222,                     /* character number, location */
         22, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          {  7,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x40\x20\x10\x08\x04\x02\x9d\x59\x38\x1c\x0e\x87"
            "\x63\xb1\x48\xa6\x51\x18\x04\x00" }  },
      /* --- pixel bitmap for cmmi210 char#92 \natural --- */
      {  92,121001,                     /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x01\x61\x43\x1a\x13\x41\x0f\x81\x51\x01\x43\x1a"
            "\x13\x41\xf4\x61" }  },
      /* --- pixel bitmap for cmmi210 char#93 \sharp --- */
      {  93,121892,                     /* character number, location */
         21, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  7,   28, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x91\x48\x24\x12\x89\xfd\xbf\x91\x48\x24\x12\x89"
            "\x44\x22\x91\x48\xec\xff\x8d\x44\x22\x91\x48\x00" }  },
      /* --- pixel bitmap for cmmi210 char#94 \smile --- */
      {  94,122842,                     /* character number, location */
         11, 2,    4, 2,      /* topleft row,col, and botleft row,col */
          { 25,    7, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x91\x11\xe0\x71\x31\xe0\x51\x52\xe0\x12\x74"
            "\x94\xad\xe0\x17\x92" }  },
      /* --- pixel bitmap for cmmi210 char#95 \frown --- */
      {  95,123716,                     /* character number, location */
         12, 2,    4, 2,      /* topleft row,col, and botleft row,col */
          { 25,    8, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xe0\x5b\xce\x01\x92\xd2\x71\xe0\x31\x51\xe0\x51"
            "\x31\xe0\x71\x11\xe0\x91" }  },
      /* --- pixel bitmap for cmmi210 char#96 \ell --- */
      {  96,96600,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x98\x80\x08\x8c\x40\x08\x46\x20\x04\x23\x30"
            "\x01\x13\x98\x80\x05\x38\x80\x01\x18\xc0\x01\x1a\x90"
            "\x81\x10\x06\x1e" }  },
      /* --- pixel bitmap for cmmi210 char#97 a --- */
      {  97,30648,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x19\x8c\x86\xc1\x31\x30\x06\x8c\x01\x63\xc0\x0c"
            "\x18\x03\xa6\x80\x69\x70\x12\x5a\x78\x1c" }  },
      /* --- pixel bitmap for cmmi210 char#98 b --- */
      {  98,31502,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   20, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x15\xa2\x60\xf3\x32\x70\x22\xa2\x23\x54\x32\x32\x61"
            "\x10\xf3\x12\x72\x0f\x12\x72\x10\x11\x62\x32\x51\x51"
            "\x32\x74\x54" }  },
      /* --- pixel bitmap for cmmi210 char#99 c --- */
      {  99,32349,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x03\x43\x18\xce\x70\x06\x60\x00\x06\x30\x00\x03"
            "\x20\x80\x06\xc4\x30\xf8\x00" }  },
      /* --- pixel bitmap for cmmi210 char#100 d --- */
      { 100,33323,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\xd2\xf3\xc2\x10\xb2\x83\x22\x62\x31\x12\x52\x53"
            "\x42\x62\x30\xf2\x12\x72\x32\x72\x42\x72\x21\x21\x72"
            "\x21\x22\x53\x21\x31\x41\x12\x11\x54\x33\x22" }  },
      /* --- pixel bitmap for cmmi210 char#101 e --- */
      { 101,34184,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xc1\x10\x03\x0d\x34\xa0\xff\x0c\x20\x00\x01\x18"
            "\xe0\x80\x0c\xc3\x07" }  },
      /* --- pixel bitmap for cmmi210 char#102 f --- */
      { 102,35338,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 14,   26, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb2\xa2\x12\x95\x92\x12\xf2\x82\x40\x58\x92\x40\xf4"
            "\x72\x50\xf4\x62\x60\x61\x70\xf1\x52\x70\x12\x22\x73"
            "\x21\x82\x21\xa3\xa1" }  },
      /* --- pixel bitmap for cmmi210 char#103 g --- */
      { 103,36321,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 14,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x33\x18\x0d\x83\x63\x60\x0c\x18\x03\xc6\x80\x19"
            "\x30\x06\x0c\x01\xc3\xe0\x20\x1c\xf0\x06\x80\x01\x60"
            "\x18\x0c\x07\xc3\x70\xe0\x07\x00" }  },
      /* --- pixel bitmap for cmmi210 char#104 h --- */
      { 104,37268,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x00\x30\x00\x0c\x00\x06\x00\x03\x80\x01\x60\x00"
            "\x30\x1f\x58\x18\x1c\x0c\x07\x86\x01\xc3\x80\x61\xc0"
            "\x18\x30\x0c\x98\x06\x46\x03\xd3\x80\x69\x80\x03" }  },
      /* --- pixel bitmap for cmmi210 char#105 i --- */
      { 105,38154,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\xe0\x60\x00\x00\x00\x00\x1c\x32\x32\x31\x19\x18"
            "\x18\x0c\x4c\x4c\x26\x26\x1c" }  },
      /* --- pixel bitmap for cmmi210 char#106 j --- */
      { 106,39113,                      /* character number, location */
         20,-1,   -6,-1,      /* topleft row,col, and botleft row,col */
          { 13,   26, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\xb3\xa2\x10\xf3\xd0\x73\x91\x22\x71\x42\x61\x32"
            "\x61\x42\x20\xf1\x92\x20\xf3\x82\x30\xf3\x72\x40\x12"
            "\x32\x53\x32\x52\x32\x74\x82" }  },
      /* --- pixel bitmap for cmmi210 char#107 k --- */
      { 107,40142,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x00\x18\x00\x03\xc0\x00\x30\x00\x0c\x80\x01\x60"
            "\x70\x18\x3a\x46\xce\x88\xb1\x01\x1c\x00\x7f\x60\x38"
            "\x18\x4c\x06\x93\xc1\x34\xb0\x0c\x18" }  },
      /* --- pixel bitmap for cmmi210 char#108 l --- */
      { 108,40888,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x8c\x61\x18\xc6\x30\x0c\x63\x18\x86\x31\x4c\xd3"
            "\xb4\x18" }  },
      /* --- pixel bitmap for cmmi210 char#109 m --- */
      { 109,42149,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0f\x0f\x6d\x6c\x8c\x0c\x0e\x26\x07\x07\x93\x81"
            "\x81\xc1\xc0\xc0\x60\x60\x60\x18\x18\x18\x0c\x0c\x4c"
            "\x06\x06\x26\x03\x83\xc9\xc0\xc0\x64\x60\xc0\x01" }  },
      /* --- pixel bitmap for cmmi210 char#110 n --- */
      { 110,43210,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0f\x6d\x8c\x0c\x26\x07\x93\x81\xc1\xc0\x60\x60"
            "\x18\x18\x0c\x4c\x06\x26\x83\xc9\xc0\x64\xc0\x01" }  },
      /* --- pixel bitmap for cmmi210 char#111 o --- */
      { 111,43954,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x72\x51\x52\x62\x32\x82\xf2\x12\x92\x0f\x12\x92"
            "\x10\x11\x82\x32\x62\x52\x42\x75\x62" }  },
      /* --- pixel bitmap for cmmi210 char#112 p --- */
      { 112,44954,                      /* character number, location */
         13,-1,   -6,-1,      /* topleft row,col, and botleft row,col */
          { 16,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x1c\x68\x63\xc8\x40\x64\xc0\x64\xc0\x60\xc0\x60"
            "\xc0\x30\x60\x30\x60\x30\x30\x30\x10\x58\x0c\x98\x07"
            "\x18\x00\x18\x00\x0c\x00\x0c\x00\x0c\x00\x3f\x00" }  },
      /* --- pixel bitmap for cmmi210 char#113 q --- */
      { 113,45903,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x11\x46\x63\x70\x06\x66\xc0\x0c\x98\x01\x1b\x30"
            "\x03\x46\xc0\x18\x1c\xc2\x81\x37\x00\x06\xc0\x00\x0c"
            "\x80\x01\x30\xc0\x1f" }  },
      /* --- pixel bitmap for cmmi210 char#114 r --- */
      { 114,46784,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\xa7\xe5\x32\x9e\x63\x19\x80\x01\x18\xc0\x00\x0c"
            "\xc0\x00\x0c\x60\x00\x06\x00" }  },
      /* --- pixel bitmap for cmmi210 char#115 s --- */
      { 115,47760,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x60\x84\x39\x63\x1c\xe0\x81\x0f\x70\x82\x1d\x36"
            "\x48\x10\x3e\x00" }  },
      /* --- pixel bitmap for cmmi210 char#116 t --- */
      { 116,48516,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x60\xc0\x80\x81\xe1\x3f\x06\x0c\x0c\x18\x30\x60"
            "\x60\xc0\x90\x21\x23\x26\x38\x00" }  },
      /* --- pixel bitmap for cmmi210 char#117 u --- */
      { 117,49568,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x98\x0c\x26\x83\xc5\x30\x19\x0c\x06\x83\xc1\x30"
            "\x18\x0c\x26\x83\xc9\x70\x22\x5e\x70\x0c" }  },
      /* --- pixel bitmap for cmmi210 char#118 v --- */
      { 118,50477,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x48\x06\xcb\xa0\x18\x94\x81\x30\x10\x06\x62\x20"
            "\x0c\x84\x41\x30\x08\x8c\x00\x0f\x00" }  },
      /* --- pixel bitmap for cmmi210 char#119 w --- */
      { 119,51697,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x18\x92\xc1\xb0\x0c\x86\x63\x18\x94\xc1\x20\x0c"
            "\x06\x61\x30\x88\xc1\x20\x0c\x06\x61\x30\x08\x83\x21"
            "\x30\x8a\x00\x8f\x03" }  },
      /* --- pixel bitmap for cmmi210 char#120 x --- */
      { 120,52951,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x3c\xe4\x39\x71\x5c\x18\x26\x0c\x00\x06\x00\x03"
            "\xc0\x00\x60\x90\x31\xc8\x19\x62\x8a\xe0\x38\x00" }  },
      /* --- pixel bitmap for cmmi210 char#121 y --- */
      { 121,54043,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 14,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xb0\x0c\x2c\x03\xc7\x60\x19\x18\x06\x86\x81\x31"
            "\x30\x0c\x0c\x03\xc3\xe0\x60\x1c\xf0\x06\x80\x01\x30"
            "\x1c\x0c\x87\x81\x30\xc0\x03\x00" }  },
      /* --- pixel bitmap for cmmi210 char#122 z --- */
      { 122,54995,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x88\x5f\x08\x07\x20\x00\x01\x08\x40\x00\x03\x08"
            "\x44\x40\x1c\x22\x3f\xc1\x00" }  },
      /* --- pixel bitmap for cmmi210 char#123 \imath --- */
      { 123,97368,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x99\x2c\x96\xc1\x60\x18\x4c\xa6\xc9\xc4\x01" }  },
      /* --- pixel bitmap for cmmi210 char#124 \jmath --- */
      { 124,98181,                      /* character number, location */
         13,-1,   -6,-1,      /* topleft row,col, and botleft row,col */
          { 12,   19, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x81\x22\x61\x42\x51\x32\x51\x42\x10\xf1\x92\x10"
            "\xf3\x82\x20\xf3\x72\x30\x12\x32\x43\x32\x42\x32\x64"
            "\x71" }  },
      /* --- pixel bitmap for cmmi210 char#125 \wp --- */
      { 125,99318,                      /* character number, location */
         14, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 17,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x00\x30\x78\x30\x0c\x63\x04\x64\x04\xd8\x04\xb0"
            "\x05\x60\x0b\xc0\x0e\xc0\x1c\x80\x19\x82\x71\x04\xe1"
            "\x89\x41\xe3\x81\x0c\x00\x19\x00\x31\x00\x62\x00\xc4"
            "\x00\xc8\x00\xe0\x00\x00" }  },
      /* --- pixel bitmap for cmmi210 char#126 \vec --- */
      { 126,99982,                      /* character number, location */
         21, 6,   15, 6,      /* topleft row,col, and botleft row,col */
          { 13,    6, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\xb3\x2f\x1d\x73\xa2\x42" }  },
      /* --- pixel bitmap for cmmi210 char#127 (noname) --- */
      { 127,100524,                     /* character number, location */
         19, 8,   16, 8,      /* topleft row,col, and botleft row,col */
          { 11,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x31\x50\x00\x01" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=7 for .250gf ---
 * mf '\mode=preview; mag=magstep(-12.84858895680446863032); input cmmi10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmi250 --- */
static	chardef  cmmi250[] =
   {
      /* --- pixel bitmap for cmmi250 char#0 \Gamma --- */
      {   0,56859,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x06\xa3\xa3\xf1\x93\xc2\xf1\x93\xc1\x10\xf1\x83"
            "\xd1\x10\xf1\x83\xe0\x10\xf3\x73\xe0\x20\xf3\x63\xe0"
            "\x30\xf3\x53\xe0\x40\x44\xe0\x4c\xe2" }  },
      /* --- pixel bitmap for cmmi250 char#1 \Delta --- */
      {   1,57788,                      /* character number, location */
         25, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,120, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x41\xe0\x93\x50\xf1\xe0\x24\x50\xe0\x11\x13\xe0"
            "\x51\x24\x40\xf1\xd1\x43\x40\xc1\x53\xe0\x11\x64\x30"
            "\xf1\xa1\x83\x30\x91\x93\xb1\xa4\x20\xf1\x71\xc3\x20"
            "\x61\xd3\x71\xe4\x10\xf1\x41\xe0\x23\x10\x31\xe0\x33"
            "\x31\xe0\x44\xf1\x1e\x0a\x0e\x0b" }  },
      /* --- pixel bitmap for cmmi250 char#2 \Theta --- */
      {   2,58995,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   26, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb7\xe3\x53\xa3\x83\x82\xb3\x62\xd2\x53\xd3\x33\xe3"
            "\xf1\x23\xe0\x22\x13\xe0\x32\x13\xe0\x23\x0f\x33\x3b"
            "\x33\x03\xe0\x23\x12\xe0\x33\x1f\x12\xe0\x23\x23\xe3"
            "\x33\xd3\x52\xd2\x63\xb2\x83\x83\xa3\x53\xe7\xb0" }  },
      /* --- pixel bitmap for cmmi250 char#3 \Lambda --- */
      {   3,59991,                      /* character number, location */
         25, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   25, 3,106, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x22\x40\xf1\xe0\x13\x40\xf1\xe4\x40\xd1\x13"
            "\xe0\x22\x13\xe0\x21\x23\x40\xf1\xb1\x33\x40\xf1\xa1"
            "\x44\x30\xf1\x91\x63\x30\x81\x73\x30\xf1\x71\x83\x30"
            "\xf1\x61\x93\x30\xf1\x51\xa3\x30\x41\xb3\x62\xb3\x38"
            "\x59" }  },
      /* --- pixel bitmap for cmmi250 char#4 \Xi --- */
      {   4,61478,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x7e\x05\xf2\x61\xe0\x31\x10\xf4\xe0\xc0\x71\xb1"
            "\x60\xf1\x7d\x60\x71\xb1\x60\xf4\xe0\xc0\xf2\x11\xe0"
            "\x51\x4f\x1e\x07\x53" }  },
      /* --- pixel bitmap for cmmi250 char#5 \Pi --- */
      {   5,62721,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 32,   24, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x0c\xa3\xc3\x40\xf3\x93\xc3\x50\xf3\x83\xc3\x60"
            "\xf3\x73\xc3\x70\xf3\x63\xc3\x80\xf3\x53\xc3\x90\x43"
            "\xc3\xab\x4b\x67" }  },
      /* --- pixel bitmap for cmmi250 char#6 \Sigma --- */
      {   6,63936,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,95, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x06\x64\xc4\x73\xe2\x74\xd2\xf1\x83\xd1\x10\x84"
            "\xc1\xa3\xc1\xa4\xd0\xf1\xa3\xd0\xa4\xe0\x93\xe0\x91"
            "\xe0\xa1\xe0\xa1\xc1\xb1\xd1\xa1\xd1\xa1\xe1\x91\xe2"
            "\x72\xe2\x71\xe4\x6e\x05\x6e\x06\x61" }  },
      /* --- pixel bitmap for cmmi250 char#7 \Upsilon --- */
      {   7,64998,                      /* character number, location */
         25, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   25, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x95\x37\x76\x23\x33\x44\x23\x11\x62\x42\x62\x72"
            "\x32\x72\x82\x12\x81\x92\x11\xe0\x54\xa0\xf2\x93\xb0"
            "\xf3\x83\xc0\xf3\x73\xd0\xf3\x63\xe0\x54\xe0\x1c\xa2" }  },
      /* --- pixel bitmap for cmmi250 char#8 \Phi --- */
      {   8,66056,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   24, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\xd4\x60\xf2\xb3\x70\x88\xa3\x23\x23\x72\x43\x43"
            "\x33\x53\x52\x23\x63\x53\x13\x53\x63\x0f\x13\x63\x63"
            "\x03\x63\x53\x13\x53\x63\x22\x53\x53\x33\x43\x42\x73"
            "\x23\x23\xa8\x80\xf2\x73\xb0\x64\xdc\x73" }  },
      /* --- pixel bitmap for cmmi250 char#9 \Psi --- */
      {   9,67177,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,95, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6c\xe0\x14\x90\xf1\xa3\xa3\x73\x64\x13\x63\x53\x33"
            "\x53\x63\x20\xf2\x13\x53\x53\x3f\x23\x53\x53\x43\x53"
            "\x43\x53\x43\x52\x72\x43\x42\x92\x33\x32\xb2\x23\x13"
            "\xd8\xb0\xf2\x63\xe0\x54\xe0\x1c\xac" }  },
      /* --- pixel bitmap for cmmi250 char#10 \Omega --- */
      {  10,68434,                      /* character number, location */
         25, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 24,   25, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc7\xe0\x13\x53\xb3\x92\x92\xc2\x72\xd3\x53\xd3\x43"
            "\xe3\x42\xe0\x13\xf1\x33\xe0\x13\x33\xe0\x12\x43\xe3"
            "\x43\xe2\x53\xd3\x53\xc3\x72\xc2\x82\xb2\x92\xb1\xb1"
            "\xa2\x61\x41\x92\x31\x31\x41\x91\x41\x31\x42\x71\x41"
            "\x46\x86\x46\x77\x46\x76\x5e" }  },
      /* --- pixel bitmap for cmmi250 char#11 \alpha --- */
      {  11,69516,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 18,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x03\xc0\x30\x88\x81\x21\x03\x86\x06\x30\x19\xc0"
            "\x34\x00\xcb\x00\x2c\x03\x70\x0c\xc0\x30\x00\xc3\x00"
            "\x0e\x03\x34\x18\x8c\x84\x0f\x0c" }  },
      /* --- pixel bitmap for cmmi250 char#12 \beta --- */
      {  12,70619,                      /* character number, location */
         24, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 20,   31, 3,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc5\xd2\x51\xb1\x81\x10\xf1\x81\x92\x71\xa2\x71\x92"
            "\x71\xa2\x71\x92\x81\x37\x81\x46\x91\x92\x81\xa1\x81"
            "\xa2\x20\xf3\x41\xb2\x20\xf1\x32\xa2\x30\x32\x92\x72"
            "\x82\x71\x21\x53\x81\x36\x80\xf1\x21\xe0\x30\xf3\x11"
            "\xe0\x41\xe0\x57" }  },
      /* --- pixel bitmap for cmmi250 char#13 \gamma --- */
      {  13,71602,                      /* character number, location */
         15, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 19,   23, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x91\x37\x71\x34\x14\x61\x22\x72\x41\x31\x91\x41"
            "\x21\xa1\x31\x30\xf1\xc1\x21\x30\xf2\xc1\x11\x40\xf2"
            "\xc2\x50\xf2\xc1\x60\xf3\xb1\x70\xf1\xa1\x82" }  },
      /* --- pixel bitmap for cmmi250 char#14 \delta --- */
      {  14,72561,                      /* character number, location */
         25, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   25, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x97\x51\x43\xf2\x51\x70\xf1\x52\x60\x62\x50\xf1"
            "\x63\x40\x42\x13\x62\x32\x52\x43\x20\xf1\x12\x62\x2f"
            "\x22\x72\x22\x71\x32\x62\x32\x61\x42\x52\x52\x32\x74"
            "\x72" }  },
      /* --- pixel bitmap for cmmi250 char#15 \epsilon --- */
      {  15,73451,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x42\x71\x81\x82\x72\x89\x1f\x42\x80\x11\xa1\x52"
            "\x35\x20" }  },
      /* --- pixel bitmap for cmmi250 char#16 \zeta --- */
      {  16,74367,                      /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 14,   31, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x91\x40\x95\x81\x14\x62\xb2\xb2\xc1\xc2\xb2\xc1"
            "\xb0\xf1\x12\xbf\x62\xc0\x12\xc4\xb6\xa6\xb4\x30\xf2"
            "\x92\x30\x42\x31\xa3\x52" }  },
      /* --- pixel bitmap for cmmi250 char#17 \eta --- */
      {  17,75306,                      /* character number, location */
         15, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\x54\x41\x21\x22\x32\x10\xf1\x11\x33\x62\x11\x32"
            "\x72\xf3\x42\x72\x10\xf3\x32\x72\x20\xf1\x22\x72\x30"
            "\xf1\xb2\x30\xf3\xa2\x40\xf1\x92\x52" }  },
      /* --- pixel bitmap for cmmi250 char#18 \theta --- */
      {  18,76072,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x07\x20\x02\x04\x81\x40\x30\x30\x04\x8c\x01\x23"
            "\xc0\x0c\x30\x03\x6c\x80\xf9\x7f\xfe\x9f\x01\x36\xc0"
            "\x0c\x30\x03\xc4\x80\x31\x20\x0c\x0c\x02\x81\x20\x40"
            "\x04\xe0\x00" }  },
      /* --- pixel bitmap for cmmi250 char#19 \iota --- */
      {  19,76747,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x30\x60\xc0\x80\x81\x01\x03\x06\x06\x0c\x18\x1c"
            "\x38\x48\x0c\x07" }  },
      /* --- pixel bitmap for cmmi250 char#20 \kappa --- */
      {  20,77691,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x70\x18\x7c\x18\x62\x18\x01\x98\x00\x6c\x00\xfc"
            "\x00\x8c\x07\x0c\x0c\x06\x0c\x06\x8c\x06\x8c\x06\x8c"
            "\x03\x4c\x03\x38" }  },
      /* --- pixel bitmap for cmmi250 char#21 \lambda --- */
      {  21,78546,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,78, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\xe0\x22\xe0\x13\x80\xf1\x72\x80\xf2\x82\x70\xf2"
            "\x92\x60\xf1\xa2\x50\x94\xc2\x12\xb2\x22\xa2\x33\x82"
            "\x52\x72\x62\x62\x82\x42\x92\x33\x92\x23\xb2\x12\xc3" }  },
      /* --- pixel bitmap for cmmi250 char#22 \mu --- */
      {  22,79604,                      /* character number, location */
         15, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          { 18,   23, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x81\x20\xf3\x52\x72\x20\xf3\x42\x72\x30\x32\x72"
            "\x40\xf1\x32\x72\x31\x32\x63\x31\x24\x41\x12\x21\x32"
            "\x15\x33\x20\xf1\x22\xe0\xf3\x12\xe0\x1f\x12\xe0\x23" }  },
      /* --- pixel bitmap for cmmi250 char#23 \nu --- */
      {  23,80429,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x15\x81\xf2\x32\x82\x32\x72\x32\x82\x32\x72\x42\x71"
            "\x52\x62\x42\x62\x52\x52\x62\x41\x82\x22\x82\x12\xa3"
            "\xc5" }  },
      /* --- pixel bitmap for cmmi250 char#24 \xi --- */
      {  24,81569,                      /* character number, location */
         24, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 14,   31, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x91\x40\x86\x63\x14\x52\xb2\x80\xf4\x32\x90\xf1"
            "\x47\x30\x32\xb2\xa0\xf1\x12\xbf\x22\xc3\xc3\xc4\xb5"
            "\xb6\xb4\x20\xf1\xa2\x20\x51\x41\x94\x4f" }  },
      /* --- pixel bitmap for cmmi250 char#25 \pi --- */
      {  25,82531,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xff\xf9\xff\x1b\x21\x08\x42\x10\x84\x00\x8c\x01"
            "\x08\x01\x10\x02\x30\x04\x20\x08\x40\x30\xc0\x60\x80"
            "\xc1\x80\x81\x01\x03\x02" }  },
      /* --- pixel bitmap for cmmi250 char#26 \rho --- */
      {  26,83391,                      /* character number, location */
         15, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x95\xa2\x32\x81\x61\x72\x62\xf1\x52\x72\xf2\x42\x82"
            "\xf1\x32\x82\x10\x32\x72\x53\x52\x52\x11\x42\x62\x24"
            "\x60\xf1\x22\xc0\xf3\x12\xdf\x12\xe4" }  },
      /* --- pixel bitmap for cmmi250 char#27 \sigma --- */
      {  27,84293,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6b\x4d\x33\x42\x72\x72\x40\xf1\x12\x82\x4f\x22\x92"
            "\x42\x82\x51\x92\x52\x72\x62\x62\x82\x42\xa5\xa2" }  },
      /* --- pixel bitmap for cmmi250 char#28 \tau --- */
      {  28,85072,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x2d\x11\x61\x6f\x11\x61\x70\x71\x70\xf1\x62\x70"
            "\xf1\x61\x80\xf2\x52\x80\xf1\x42\x92" }  },
      /* --- pixel bitmap for cmmi250 char#29 \upsilon --- */
      {  29,86009,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x80\x88\x00\x0b\x01\x16\x03\x2c\x06\x18\x0c\x10"
            "\x0c\x20\x18\x40\x30\x40\x30\x80\x60\x80\xc0\x00\x01"
            "\x03\x01\x06\x01\xf0\x01" }  },
      /* --- pixel bitmap for cmmi250 char#30 \phi --- */
      {  30,86899,                      /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 17,   31, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xc1\x40\xf3\xb1\x50\xf2\xa1\x60\x76\x92\x21\x32"
            "\x52\x41\x42\x32\x51\x51\x22\x61\x52\x12\x51\x62\x0f"
            "\x22\x61\x62\x02\x51\x62\x12\x51\x61\x22\x51\x51\x42"
            "\x41\x32\x62\x21\x23\x96\x70\xf1\x61\xa0\xf3\x51\xb0"
            "\x41\xc1" }  },
      /* --- pixel bitmap for cmmi250 char#31 \chi --- */
      {  31,88004,                      /* character number, location */
         15, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\xd1\x21\x13\xa1\x21\x32\xa1\x63\x81\x82\x71\x92"
            "\x61\xb2\x41\xc2\x31\xd3\x11\xe0\x13\xe0\x22\xe0\x42"
            "\xe0\x23\xe0\x11\x13\xd1\x32\xc1\x42\xb1\x62\x91\x72"
            "\x81\x83\x61\xa2\x31\x21\xa3\x11\x21\xd3\x23" }  },
      /* --- pixel bitmap for cmmi250 char#32 \psi --- */
      {  32,89135,                      /* character number, location */
         24, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 21,   31, 3,125, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x11\x50\xf3\xe1\x60\xf2\xd1\x70\x33\x71\x51"
            "\x31\x31\x51\x62\x11\x41\x51\x62\xf1\x11\x32\x51\x62"
            "\x52\x41\x71\x10\xf1\x42\x51\x71\x10\x42\x51\x61\x52"
            "\x51\x71\x52\x51\x61\x71\x51\x51\x82\x41\x41\xa2\x21"
            "\x32\xd6\x80\xf1\x91\xb0\xf3\x81\xc0\x71\xd3" }  },
      /* --- pixel bitmap for cmmi250 char#33 \omega --- */
      {  33,90280,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   15, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\xe1\x32\xe2\x21\xe0\x12\xf1\x11\xe0\x22\x01\x91"
            "\x71\x1f\x11\x82\x71\x11\x82\x62\x11\x81\x71\x21\x72"
            "\x62\x22\x54\x51\x38\x18\x46\x36\x64\x53\x61" }  },
      /* --- pixel bitmap for cmmi250 char#34 \varepsilon --- */
      {  34,91279,                      /* character number, location */
         16, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x69\x33\x52\x22\x90\xf2\x21\xa0\x36\x62\x13\x50"
            "\xf1\x11\xbf\x11\xc1\xa1\x22\x62\x39\x65\x51" }  },
      /* --- pixel bitmap for cmmi250 char#35 \vartheta --- */
      {  35,92296,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   24, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc3\xe1\x22\xc1\x41\xb1\x51\x20\xf4\x91\x52\x10\x32"
            "\x51\x42\x31\x21\x52\x12\x31\x32\x63\x31\x32\x74\x11"
            "\x32\x72\x20\xf1\x42\x72\x30\x42\x71\x82\x62\x72\x72"
            "\x72\x62\x82\x61\x92\x51\xb2\x32\xc4\x91" }  },
      /* --- pixel bitmap for cmmi250 char#36 \varpi --- */
      {  36,93575,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 26,   15, 3,95, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x09\x2e\x0a\x12\x31\xe0\x21\x21\x41\xe0\x31\x21"
            "\x31\xe0\x41\x61\x81\x91\x20\xf1\x31\x91\x91\x20\x31"
            "\x82\x81\x51\x92\x81\x51\x81\x11\x72\x52\x61\x21\x62"
            "\x71\x42\x32\x42\x86\x56\xa4\x74\x74" }  },
      /* --- pixel bitmap for cmmi250 char#37 \varrho --- */
      {  37,94512,                      /* character number, location */
         15, 3,   -7, 3,      /* topleft row,col, and botleft row,col */
          { 14,   22, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x82\x32\x61\x61\x52\x62\xf1\x32\x72\xf2\x22\x82"
            "\x13\x72\x22\x82\x23\x62\x33\x52\x32\x12\x32\x41\x34"
            "\x6f\x21\xd2\xd9\x68\xd1\x41" }  },
      /* --- pixel bitmap for cmmi250 char#38 \varsigma --- */
      {  38,95385,                      /* character number, location */
         15, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 12,   18, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x42\x51\x31\xa1\xa2\x9f\x22\xa3\xa3\xa3\xa4\xa4"
            "\xa3\x20\xf1\x82\x20\x81\x83\x42" }  },
      /* --- pixel bitmap for cmmi250 char#39 \varphi --- */
      {  39,96354,                      /* character number, location */
         15, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 19,   23, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\xa3\x41\x96\x31\x82\x42\x11\x82\x61\x11\x81\x71"
            "\x0f\x11\x81\x81\x01\xe0\x31\x0f\x11\x71\x81\x12\x61"
            "\x71\x32\x41\x62\x53\x21\x43\x7b\xa7\xd2\xb0\xf1\x61"
            "\xc0\xf2\x52\xc0\xf1\x42\xd4" }  },
      /* --- pixel bitmap for cmmi250 char#40 \leftharpoonup --- */
      {  40,112528,                     /* character number, location */
         18, 2,    8, 2,      /* topleft row,col, and botleft row,col */
          { 31,   10, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x72\xe0\x80\xf1\x62\xe0\x90\x52\xe0\xe3\xe0\xd3"
            "\xe0\xd3\xe0\xde\x0e\x0e\x0e\x05" }  },
      /* --- pixel bitmap for cmmi250 char#41 \leftharpoondown --- */
      {  41,113562,                     /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 31,   10, 2,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x1f\x01\x1e\x02\x03\x1d\x03\x1d\x03\x1d\x02\x18"
            "\x00\xff\x01\x06\x02\x17\x00\xff\x01\x07\x02\x16" }  },
      /* --- pixel bitmap for cmmi250 char#42 \rightharpoonup --- */
      {  42,114594,                     /* character number, location */
         18, 2,    8, 2,      /* topleft row,col, and botleft row,col */
          { 31,   10, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x82\x70\xf1\xe0\x92\x60\xe0\xa2\xe0\xe0\x13"
            "\xe0\xe0\x13\xe0\xe0\x13\x2f\x1e\x0e\x03" }  },
      /* --- pixel bitmap for cmmi250 char#43 \rightharpoondown --- */
      {  43,115629,                     /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 31,   10, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0e\x0e\x0e\x05\xe0\xd3\xe0\xd3\xe0\xd3\xe0\xe2"
            "\x50\xf1\xe0\x92\x60\xf1\xe0\x82\x7e" }  },
      /* --- pixel bitmap for cmmi250 char#44 ` --- */
      {  44,116056,                     /* character number, location */
         18, 2,    8, 2,      /* topleft row,col, and botleft row,col */
          {  6,   10, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\x18\x3f\x32\x43\x45\x33" }  },
      /* --- pixel bitmap for cmmi250 char#45 ' --- */
      {  45,116484,                     /* character number, location */
         18, 2,    8, 2,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc7\x87\xc3\x30\x0c\xe3\xdf\x01" }  },
      /* --- pixel bitmap for cmmi250 char#46 \triangleright --- */
      {  46,117029,                     /* character number, location */
         17, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   16, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xd4\xb6\x92\x24\x72\x43\x62\x54\x42\x74\x2f\x12"
            "\x94\x02\x74\x22\x54\x42\x43\x62\x24\x76\x94\xb2\xd1" }  },
      /* --- pixel bitmap for cmmi250 char#47 \triangleleft --- */
      {  47,117605,                     /* character number, location */
         17, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   16, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\xb4\x96\x74\x22\x63\x42\x44\x52\x24\x72\x0f\x14"
            "\x92\x24\x72\x44\x52\x63\x42\x74\x22\x96\xb4\xd2" }  },
      /* --- pixel bitmap for cmmi250 char#48 \0 --- */
      {  48,102853,                     /* character number, location */
         16, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   17, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x52\x20\xf1\x12\x72\x1f\x82\x92\xf1\x12\x72"
            "\x10\x22\x52\x65\x41" }  },
      /* --- pixel bitmap for cmmi250 char#49 \1 --- */
      {  49,103644,                     /* character number, location */
         16, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x46\x40\xfc\x42\x4a" }  },
      /* --- pixel bitmap for cmmi250 char#50 \2 --- */
      {  50,104622,                     /* character number, location */
         16, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   16, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x61\x53\x31\x82\x12\x86\x82\x11\x92\xa3\xa2\xa2"
            "\xa2\xa2\x92\x51\x42\x61\x39\x2b\x1c\x11" }  },
      /* --- pixel bitmap for cmmi250 char#51 \3 --- */
      {  51,105663,                     /* character number, location */
         16, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x51\x82\x20\xf2\x13\x73\x10\x21\x83\x10"
            "\xf1\xb2\x20\xa2\xc2\x95\xe0\x12\xe2\xd3\xd3\x12\x93"
            "\x0f\x24\x83\x11\x93\x21\x92\x42\x62\x76\x51" }  },
      /* --- pixel bitmap for cmmi250 char#52 \4 --- */
      {  52,106620,                     /* character number, location */
         16, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 15,   23, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x92\x40\xf1\x83\x40\x71\x12\x40\xf1\x61\x22\x40"
            "\x51\x32\x40\xf1\x41\x42\x40\x31\x52\x40\xf1\x21\x62"
            "\x40\x11\x72\x42\x72\x4e\x01\xf5\x92\x40\x68\x13" }  },
      /* --- pixel bitmap for cmmi250 char#53 \5 --- */
      {  53,107683,                     /* character number, location */
         16, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 13,   24, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x12\x72\x2a\x39\x41\x31\x70\xf3\x11\xb0\x11\x25\x51"
            "\x11\x42\x42\x62\x31\x73\xb2\x10\xf2\xa3\x0f\x23\x73"
            "\x01\x92\x21\x73\x21\x72\x42\x42\x74\x50" }  },
      /* --- pixel bitmap for cmmi250 char#54 \6 --- */
      {  54,108610,                     /* character number, location */
         23, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x04\x61\x60\x04\x4e\xc0\x0d\x80\x01\x10\x00"
            "\xe3\x61\x43\x1c\x90\x03\x36\x80\x06\xf0\x00\x1e\xc0"
            "\x03\x78\x00\x0b\x60\x03\x44\xc0\x18\x08\x86\x80\x0f" }  },
      /* --- pixel bitmap for cmmi250 char#55 \7 --- */
      {  55,109551,                     /* character number, location */
         16, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xee\x1d\x21\xb1\x11\xb1\x21\xa1\x30\xf1\xa1\x40"
            "\x91\x50\xf1\x81\x60\xf1\x71\x70\xf1\x62\x70\xf2\x52"
            "\x80\xf4\x43\x80\x51\x91" }  },
      /* --- pixel bitmap for cmmi250 char#56 \8 --- */
      {  56,110490,                     /* character number, location */
         23, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x52\x72\x41\x92\x10\xf1\x12\x92\x10\x13"
            "\x82\x24\x62\x44\x52\x55\x21\x86\xa6\x81\x25\x52\x54"
            "\x32\x74\x22\x95\xa3\x0f\x22\xb2\x12\xa1\x31\x91\x52"
            "\x52\x85\x52" }  },
      /* --- pixel bitmap for cmmi250 char#57 \9 --- */
      {  57,111429,                     /* character number, location */
         16, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 13,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x63\x10\x18\x03\x22\xc0\x06\xd0\x00\x1e\xc0"
            "\x03\x78\x00\x0f\x60\x01\x6c\xc0\x09\x38\xc2\x86\xc7"
            "\x00\x08\x80\x01\xb0\x03\x72\x60\x06\x86\x60\xe0\x03" }  },
      /* --- pixel bitmap for cmmi250 char#58 . --- */
      {  58,118110,                     /* character number, location */
          4, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x6f" }  },
      /* --- pixel bitmap for cmmi250 char#59 , --- */
      {  59,118673,                     /* character number, location */
          4, 3,   -7, 3,      /* topleft row,col, and botleft row,col */
          {  4,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\xef\x88\x48\x24\x02" }  },
      /* --- pixel bitmap for cmmi250 char#60 < --- */
      {  60,119341,                     /* character number, location */
         20, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x52\xe0\x34\xe0\x14\xe0\x14\xe0\x14\xe0\x14\xe0"
            "\x23\xe0\x24\xe0\x14\xe0\x14\xe0\x1f\x14\xe0\x30\x24"
            "\xe0\x54\xe0\x54\xe0\x53\xe0\x54\xe0\x54\xe0\x54\xe0"
            "\x54\xe0\x54\xe0\x52" }  },
      /* --- pixel bitmap for cmmi250 char#61 / --- */
      {  61,119887,                     /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 13,   35, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xb2\xa3\xf1\xa2\x10\x93\x10\xf1\x92\x20\x83\x20"
            "\xf1\x82\x30\x73\x30\xf1\x72\x40\x63\x40\xf1\x62\x50"
            "\x53\x50\xf1\x52\x60\x43\x60\xf1\x42\x70\x33\x70\xf1"
            "\x32\x80\x23\x80\xf1\x22\x90\x13\x90\xf1\x12\xa3\xaf"
            "\x12\xb1" }  },
      /* --- pixel bitmap for cmmi250 char#62 > --- */
      {  62,120606,                     /* character number, location */
         20, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x54\xe0\x54\xe0\x54\xe0\x54\xe0\x54\xe0\x53"
            "\xe0\x54\xe0\x54\xe0\x54\x20\xf1\xe0\x34\xe0\x14\xe0"
            "\x14\xe0\x14\xe0\x23\xe0\x24\xe0\x14\xe0\x14\xe0\x14"
            "\xe0\x14\xe0\x32\xe0\x52" }  },
      /* --- pixel bitmap for cmmi250 char#63 \star --- */
      {  63,121327,                     /* character number, location */
         18,-1,    1,-1,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x91\x80\x14\x41\x44\x35\x11\x15\x87\xd3\xe2\x12"
            "\xd1\x31\xc2\x32\xa2\x52\x91\x71\x81\x91\x30" }  },
      /* --- pixel bitmap for cmmi250 char#64 \partial --- */
      {  64,97370,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 17,   26, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x75\xa2\x52\x71\x82\x61\x91\x20\xf1\x33\x82\x10\xf1"
            "\xe0\x11\x10\xe0\x12\x74\x42\x52\x42\x21\x51\x71\x12"
            "\x41\x93\x31\xa3\x22\xa3\x21\xb2\x2f\x12\xb2\x22\xa2"
            "\x31\xb2\x31\xa2\x41\xa1\x52\x82\x61\x72\x81\x52\xa5"
            "\x92" }  },
      /* --- pixel bitmap for cmmi250 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         25, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 24,   25, 3,110, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x32\x50\xf1\xe0\x23\x50\xe0\x14\xe0\x55\xe0"
            "\x51\x13\xe0\x41\x23\xe0\x41\x24\x40\xf1\xc1\x43\x40"
            "\xb1\x53\x40\xf1\xa1\x63\x40\xf1\x91\x73\x40\x8c\x40"
            "\xf1\x71\x93\x40\x61\xa4\x91\xb3\x81\xc3\x72\xc3\x63"
            "\xc3\x38\x6a" }  },
      /* --- pixel bitmap for cmmi250 char#66 B --- */
      {  66, 2438,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   24, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x02\xd3\x83\xa3\xa3\x93\xb2\x10\xf1\x83\xb3\x73"
            "\xc2\x83\xb3\x83\xa3\x93\x93\x93\x84\xae\xb3\x93\xa3"
            "\xa3\x30\xf3\x53\xc3\x20\xf1\x43\xc3\x30\x43\xb3\x83"
            "\xa3\x83\x94\x6e\x02\x94" }  },
      /* --- pixel bitmap for cmmi250 char#67 C --- */
      {  67, 3465,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 24,   26, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc6\x51\x93\x61\x32\x82\x91\x22\x63\xb3\x62\xd3\x53"
            "\xe2\x43\xe0\x12\x42\xe0\x21\x43\xe0\x21\x33\xe0\x31"
            "\x33\xe0\x6f\x43\xe0\x7f\x12\xe0\x31\x42\xe0\x21\x53"
            "\xe0\x11\x53\xe1\x72\xd1\x92\xb1\xb2\x91\xd2\x62\xe0"
            "\x26\xc8" }  },
      /* --- pixel bitmap for cmmi250 char#68 D --- */
      {  68, 4667,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x02\xe3\x83\xb3\xb2\xa3\xc2\x10\xf1\x83\xc3\xf3"
            "\x73\xe2\xf3\x63\xe3\xf1\x53\xe3\x10\x53\xe2\x73\xd3"
            "\x63\xd3\x73\xc3\x83\xb3\x93\xa3\x93\x93\x8e\x02\xa3" }  },
      /* --- pixel bitmap for cmmi250 char#69 E --- */
      {  69, 6148,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 27,   24, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x6e\x07\xa3\xb3\xf1\x93\xd2\xf1\x93\xd1\x10\x83\xe1"
            "\x93\x81\x51\x93\x81\xe0\x13\x72\xe3\x81\xe0\x1c\x80"
            "\xf1\x73\x72\x80\x63\x81\xe0\x13\x81\x61\x83\xe0\x11"
            "\x83\xe1\x83\xe0\x11\x83\xe2\x83\xe1\x93\xd2\x83\xc3"
            "\x5e\x08\x5a" }  },
      /* --- pixel bitmap for cmmi250 char#70 F --- */
      {  70, 7437,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 27,   24, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x07\xa3\xb3\xf1\x93\xd2\xf1\x93\xd1\x10\x83\xe1"
            "\x93\x81\x51\x93\x81\xe0\x13\x72\xe3\x81\xe0\x1c\x80"
            "\xf1\x73\x72\x80\xf1\x63\x81\x90\xf1\x63\xe0\x40\xf3"
            "\x53\xe0\x50\x44\xe0\x5c\xe0\x13" }  },
      /* --- pixel bitmap for cmmi250 char#71 G --- */
      {  71, 8672,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 24,   26, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc6\x51\x93\x61\x32\x82\x91\x22\x63\xb3\x62\xd3\x53"
            "\xe2\x43\xe0\x12\x42\xe0\x21\x43\xe0\x21\x33\xe0\x31"
            "\x33\xe0\x6f\x23\xe0\x73\xaa\x13\xe3\x4f\x22\xe0\x13"
            "\x4f\x13\xd3\x50\x12\xd3\x72\xb4\x82\x91\x12\xa2\x62"
            "\x31\xc6\xca" }  },
      /* --- pixel bitmap for cmmi250 char#72 H --- */
      {  72, 9963,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 32,   24, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6b\x4b\xa3\xc3\x40\xf3\x93\xc3\x50\xf3\x83\xc3\x60"
            "\x73\xc3\xee\x04\x70\xf1\x73\xc3\x70\xf3\x63\xc3\x80"
            "\xf3\x53\xc3\x90\x43\xc3\xab\x4b\x63" }  },
      /* --- pixel bitmap for cmmi250 char#73 I --- */
      {  73,10748,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6b\xa3\x40\xf3\x93\x50\xf3\x83\x60\xf3\x73\x70\xf3"
            "\x63\x80\xf3\x53\x90\x43\xab\x63" }  },
      /* --- pixel bitmap for cmmi250 char#74 J --- */
      {  74,11616,                      /* character number, location */
         24, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 21,   25, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xab\xe4\x30\xf3\xe3\x40\xf3\xd3\x50\xf3\xc3\x60\xf3"
            "\xb3\x70\x12\x73\x8f\x14\x63\x83\x63\x91\x73\xb1\x53"
            "\xd6\xd3" }  },
      /* --- pixel bitmap for cmmi250 char#75 K --- */
      {  75,12867,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 31,   24, 3,127, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x6b\x68\xa3\xc3\xc3\xd2\xd3\xc1\xe0\x13\xa2\xe0\x23"
            "\x91\xe0\x33\x91\xe0\x43\x71\xe0\x63\x61\xe0\x73\x51"
            "\xe0\x73\x43\xe0\x73\x31\x13\xe0\x63\x21\x23\xe0\x64"
            "\x53\xe0\x44\x63\xe0\x43\x74\xb0\xf1\x63\x83\xb0\xf1"
            "\x53\xa3\xa0\xf1\x53\xb3\x90\x43\xc4\x8b\x59\x60" }  },
      /* --- pixel bitmap for cmmi250 char#76 L --- */
      {  76,13878,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6c\xe0\x13\xa0\xf3\x93\xb0\xf3\x83\xc0\xf3\x73\xd0"
            "\x63\xe0\xf1\x63\xd1\x63\xc1\x63\xd1\x63\xc2\x63\xc1"
            "\x73\xa3\x63\x95\x2e\x06\x33" }  },
      /* --- pixel bitmap for cmmi250 char#77 M --- */
      {  77,15228,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 38,   24, 3,173, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x68\xe0\x28\xa4\xe0\x11\x13\xd1\x13\xe0\x14\xe1\x13"
            "\xe1\x13\x50\xf1\x91\x13\xd1\x23\x50\x81\x33\xb1\x23"
            "\x60\xf1\x81\x33\xa1\x33\x60\x81\x33\x91\x43\x60\xf1"
            "\x71\x43\x81\x43\x70\x71\x53\x61\x53\xe1\x53\x51\x63"
            "\xd1\x63\x51\x53\xe1\x63\x41\x63\x80\xf1\x61\x63\x31"
            "\x73\x80\x51\x83\x11\x73\x90\xf1\x51\x84\x83\x90\x51"
            "\x83\x93\xc3\x82\x93\xa9\x52\x5b\x60" }  },
      /* --- pixel bitmap for cmmi250 char#78 N --- */
      {  78,16484,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 32,   24, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x67\xa9\xa3\xd3\x30\xf1\x91\x13\xc1\x50\xf1\x91\x23"
            "\xb1\x50\xf1\x81\x43\x91\x60\xf1\x81\x53\x81\x60\xf1"
            "\x71\x73\x61\x70\xf1\x71\x83\x51\x70\xf1\x61\xa3\x31"
            "\x80\xf1\x61\xb3\x21\x80\xf1\x51\xd4\x90\xf1\x51\xe3"
            "\x90\x33\xe0\x11\xa9\xc1\xa1" }  },
      /* --- pixel bitmap for cmmi250 char#79 O --- */
      {  79,17439,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   26, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb7\xe3\x53\xa3\x83\x82\xb3\x62\xd2\x52\xe3\x33\xe0"
            "\x12\xf1\x23\xe0\x22\xf1\x13\xe0\x32\x0f\x33\xe0\x33"
            "\x03\xe0\x23\x12\xe0\x33\x1f\x12\xe0\x23\x23\xe3\x33"
            "\xd3\x52\xd2\x63\xa3\x83\x83\xa3\x53\xe7\xb1" }  },
      /* --- pixel bitmap for cmmi250 char#80 P --- */
      {  80,18590,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 27,   24, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x03\xe3\x93\x20\xf1\x93\xb3\x10\x93\xc2\xa3\xc3"
            "\xf1\x83\xc3\x10\x83\xc2\xa3\xb3\x93\xb3\xa3\x93\xcd"
            "\xe3\xe0\x30\xf3\x63\xe0\x40\xf3\x53\xe0\x50\x43\xe0"
            "\x6b\xe0\x22" }  },
      /* --- pixel bitmap for cmmi250 char#81 Q --- */
      {  81,19675,                      /* character number, location */
         25, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 23,   32, 3,145, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb7\xe3\x53\xa3\x83\x82\xb3\x62\xd2\x53\xd3\x33\xe3"
            "\xf1\x23\xe0\x22\x13\xe0\x32\x13\xe0\x23\x0f\x33\xe0"
            "\x33\x03\xe0\x23\x12\xe0\x33\x1f\x12\xe0\x23\x23\xe3"
            "\x33\x53\x53\x52\x41\x31\x42\x63\x31\x31\x32\x83\x11"
            "\x54\xa3\x11\x33\x51\x88\x61\xe2\x52\xe2\x51\xe0\x12"
            "\x42\xe0\x17\xe0\x35\xe0\x53\x71" }  },
      /* --- pixel bitmap for cmmi250 char#82 R --- */
      {  82,21058,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x01\xe3\x73\xb3\xa3\x93\xb2\x10\xf1\x83\xb3\xf1"
            "\x73\xb3\x10\x73\xa3\x93\x93\x93\x83\xbb\xe3\x73\xc3"
            "\x92\x50\xf3\x53\xa3\x40\xf1\x43\xa3\x50\xf1\x43\xa3"
            "\x41\x33\xb3\x31\x1a\x82\x21\xe0\x73\x31" }  },
      /* --- pixel bitmap for cmmi250 char#83 S --- */
      {  83,22199,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 20,   26, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xa5\x41\x82\x52\x12\x72\x83\x62\x92\x71\xa2\x10\xf1"
            "\x52\xa2\x10\x43\xa1\x20\xf1\x43\xd0\x55\xe0\x18\xd9"
            "\xd8\xe0\x15\x40\xf2\xe3\x30\x21\xb3\x30\xf1\x11\xc2"
            "\x40\x11\xc1\x62\xa2\x53\x92\x62\x12\x61\x81\x46\x91" }  },
      /* --- pixel bitmap for cmmi250 char#84 T --- */
      {  84,23281,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 24,   24, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x07\x23\x73\x63\x22\x73\x82\x21\x83\x82\xf1\x11"
            "\x93\x81\x10\x11\x83\x91\x11\x93\x91\x10\xf1\xa3\xb0"
            "\xf3\x93\xc0\xf3\x83\xd0\xf3\x73\xe0\x64\xe0\x1d\xa2" }  },
      /* --- pixel bitmap for cmmi250 char#85 U --- */
      {  85,24307,                      /* character number, location */
         24, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 26,   25, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x69\x43\xd3\x30\xf3\x33\xe1\x50\xf3\x23\xe1\x60"
            "\xf3\x13\xe1\x7f\x23\xe1\x83\xd2\x83\xd1\x9f\x13\xc1"
            "\xa0\x12\xb1\xd2\x82\xe0\x12\x52\xe0\x46\xe0\x2d" }  },
      /* --- pixel bitmap for cmmi250 char#86 V --- */
      {  86,25271,                      /* character number, location */
         24, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 24,   25, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x09\x87\x24\xd3\x53\xd1\x73\xc2\x73\xc1\x50\xf1\x33"
            "\xb1\x60\x33\xa1\x70\xf1\x33\x91\x80\xf1\x43\x71\x90"
            "\x43\x61\xa0\xf1\x43\x51\xb0\x43\x41\xe0\x23\x32\xe0"
            "\x23\x31\xe0\x34\x11\xe0\x53\x11\xe0\x54\xe0\x10\xf1"
            "\x53\xe0\x20\xf1\x52\xe0\x31" }  },
      /* --- pixel bitmap for cmmi250 char#87 W --- */
      {  87,26694,                      /* character number, location */
         24, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 34,   25, 3,169, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x09\x4a\x47\x24\xa3\xa3\x43\xb3\xa2\x53\xa4\xa1\x63"
            "\xa4\x91\x73\x91\x13\x91\x73\x91\x13\x81\x84\x71\x23"
            "\x81\x60\xf1\x33\x61\x33\x71\x70\xf1\x33\x51\x43\x61"
            "\x80\x33\x41\x54\x41\xc3\x41\x63\x31\xd3\x31\x73\x31"
            "\xd3\x31\x73\x21\xe3\x21\x83\x21\xe3\x12\x83\x11\xe0"
            "\x13\x11\x93\x11\xc0\xf1\x34\xa4\xd0\xf1\x33\xb3\xe0"
            "\x32\xc2\xe0\x42\xc1\xe0\x22" }  },
      /* --- pixel bitmap for cmmi250 char#88 X --- */
      {  88,27955,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 28,   24, 3,119, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x6a\x48\x94\x93\xd3\x92\xe4\x72\xe0\x23\x62\xe0\x33"
            "\x61\xe0\x44\x41\xe0\x63\x31\xe0\x74\x11\xe0\x94\xe0"
            "\xa3\xc0\xf1\xd4\xb0\xc1\x14\xe0\x72\x23\xe0\x62\x33"
            "\xe0\x61\x44\xe0\x41\x63\xe0\x31\x74\xe0\x11\x93\xe1"
            "\xa3\xd1\xb4\xa4\xa4\x78\x79\x41" }  },
      /* --- pixel bitmap for cmmi250 char#89 Y --- */
      {  89,29093,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   24, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x87\x34\xd3\x63\xd1\x84\xb1\xa3\xa1\xb3\x92\xb4"
            "\x81\xd3\x71\xe4\x51\xe0\x23\x41\xe0\x33\x32\xe0\x34"
            "\x21\xe0\x53\x11\xe0\x64\xd0\xf3\x83\xe0\xf3\x73\xe0"
            "\x10\x63\xe0\x4b\xc1" }  },
      /* --- pixel bitmap for cmmi250 char#90 Z --- */
      {  90,30238,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x03\x64\x93\x63\xa3\x72\xa3\x81\xa4\x81\xa3\x81"
            "\xa3\x91\x93\xe0\x53\xe0\x53\xe0\x53\x90\xf1\xa3\xa0"
            "\x93\xe0\x53\xe0\x53\x81\xa3\x91\x93\x91\x93\xa1\x84"
            "\x92\x83\xa1\x83\xa2\x73\x93\x7e\x02\x70" }  },
      /* --- pixel bitmap for cmmi250 char#91 \flat --- */
      {  91,122038,                     /* character number, location */
         26, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          {  9,   27, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x01\x81\x15\x22\x42\x11\x61\x1f\x41\x62\x0f\x11"
            "\x52\x11\x42\x21\x41\x31\x32\x31\x22\x41\x12\x52\x71"
            "\x84" }  },
      /* --- pixel bitmap for cmmi250 char#92 \natural --- */
      {  92,122829,                     /* character number, location */
         26, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  9,   34, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x81\x54\x1e\x14\x51\x0f\xa1\x71\x01\x54\x1e"
            "\x14\x51\xf5\x81" }  },
      /* --- pixel bitmap for cmmi250 char#93 \sharp --- */
      {  93,123734,                     /* character number, location */
         25, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  9,   33, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x10\xf6\x11\x51\x10\x11\x43\x1e\x02\x13\x41\x10"
            "\xfa\x11\x51\x10\x11\x43\x1e\x02\x13\x41\x10\xf4\x11"
            "\x51\x10\x11\x70" }  },
      /* --- pixel bitmap for cmmi250 char#94 \smile --- */
      {  94,124704,                     /* character number, location */
         13, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          { 31,    8, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\xe0\x11\x11\xe0\xd1\x31\xe0\xb1\x52\xe0\x72"
            "\x73\xe0\x33\xa4\xb4\xee\x01\xe0\x59\xb1" }  },
      /* --- pixel bitmap for cmmi250 char#95 \frown --- */
      {  95,125582,                     /* character number, location */
         14, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          { 31,    9, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x11\xe0\xad\xe0\x2e\x03\xc3\xe0\x13\x92\xe0\x52"
            "\x71\xe0\x91\x51\xe0\xb1\x31\xe0\xd1\x11\xe0\xe0\x11" }  },
      /* --- pixel bitmap for cmmi250 char#96 \ell --- */
      {  96,98180,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x1c\x80\x09\x30\x02\x84\x80\x21\x30\x08\x0c\x81"
            "\x41\x60\x08\x18\x02\x43\xc0\x08\x30\x01\x2c\x00\x05"
            "\x60\x01\x38\x00\x06\xc0\x01\x48\x00\x11\x00\x0c\x04"
            "\xc2\x00\x0f" }  },
      /* --- pixel bitmap for cmmi250 char#97 a --- */
      {  97,31204,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x09\x84\x83\xe0\x10\x30\x06\x8c\x80\x31\x60\x0c"
            "\x18\x03\x46\xc0\x10\x30\x06\x8c\x83\xa3\xd8\xc4\xe1"
            "\x00" }  },
      /* --- pixel bitmap for cmmi250 char#98 b --- */
      {  98,32064,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 11,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x80\x01\x06\x30\x80\x01\x0c\x30\x80\x01\x0c\x60"
            "\x8f\x85\x1c\x6c\x60\x03\x0f\x78\xc0\x03\x1e\x70\xc0"
            "\x02\x16\x98\x41\x88\x81\x07" }  },
      /* --- pixel bitmap for cmmi250 char#99 c --- */
      {  99,32899,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x62\x41\x42\x43\x22\x53\x12\x62\x22\x9f\x42\xa2"
            "\x93\x81\x22\x52\x46\x42" }  },
      /* --- pixel bitmap for cmmi250 char#100 d --- */
      { 100,33879,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\xd2\xf3\xc2\x10\xf2\xb2\x20\x54\x22\x61\x43\x61"
            "\x53\x51\x72\x42\x72\x41\x72\x4f\x22\x72\x41\x72\x5f"
            "\x11\x72\x31\x12\x53\x31\x21\x32\x12\x21\x43\x43\x34" }  },
      /* --- pixel bitmap for cmmi250 char#101 e --- */
      { 101,34750,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x62\x41\x41\x71\x21\x81\x12\x71\x12\x72\x19\x3f"
            "\x32\xa2\x91\x11\x81\x22\x52\x55\x42" }  },
      /* --- pixel bitmap for cmmi250 char#102 f --- */
      { 102,35936,                      /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 18,   31, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd4\xd1\x32\xb2\x23\xb1\x42\xf3\xa2\x60\x92\xd9\x30"
            "\xf2\x92\x70\xf5\x82\x80\xf4\x72\x90\xf2\x62\xa0\x12"
            "\x31\xb3\x22\xb2\x31\xd4\xd1" }  },
      /* --- pixel bitmap for cmmi250 char#103 g --- */
      { 103,36945,                      /* character number, location */
         15, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x21\x71\x43\x61\x53\x51\x72\x42\x72\x41\x72\x10"
            "\xf2\x32\x72\x10\xf2\x31\x72\x20\x32\x53\x61\x34\x83"
            "\x22\x30\xf1\xa2\x30\x92\x52\x62\x43\x52\x52\x52\x76"
            "\x82" }  },
      /* --- pixel bitmap for cmmi250 char#104 h --- */
      { 104,37926,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\xe2\x80\xf3\x52\x90\xf2\x42\xa0\x42\x24\x72\x12"
            "\x32\x30\xf1\x33\x62\x20\x32\x72\x20\xf2\x22\x72\x30"
            "\x22\x62\x52\x72\x52\x72\x31\x12\x62\x41\x12\x62\x31"
            "\x12\x81\x22\x12\x92\x33" }  },
      /* --- pixel bitmap for cmmi250 char#105 i --- */
      { 105,38824,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x81\x03\x06\x00\x00\x00\x00\x00\x00\x70\x90\x11"
            "\x26\x46\x0c\x18\x18\x30\x30\x60\xc0\xc8\x90\x11\x22"
            "\x38" }  },
      /* --- pixel bitmap for cmmi250 char#106 j --- */
      { 106,39787,                      /* character number, location */
         24, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 14,   31, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\xb3\xc2\xf5\xe0\x83\xa1\x31\x81\x42\x10\xf1\x51"
            "\x52\x10\xf3\xa2\x20\xf3\x92\x30\xf3\x82\x40\x72\x62"
            "\x42\x53\x32\x62\x32\x84\x91" }  },
      /* --- pixel bitmap for cmmi250 char#107 k --- */
      { 107,40848,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\xd2\x70\xf3\x52\x80\xf2\x42\x90\x42\x53\x42\x51"
            "\x22\x32\x41\x23\x32\x31\x32\x42\x21\x92\x12\xa4\xb2"
            "\x23\x82\x42\x62\x52\x50\xf2\x12\x52\x31\x12\x62\x21"
            "\x22\x73\x32" }  },
      /* --- pixel bitmap for cmmi250 char#108 l --- */
      { 108,41608,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  7,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x30\x0c\x06\x83\x61\x30\x18\x0c\x83\xc1\x60\x18"
            "\x0c\x06\xc3\x60\x34\x1a\x4d\x1c" }  },
      /* --- pixel bitmap for cmmi250 char#109 m --- */
      { 109,42851,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 28,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x7c\xf0\x40\x22\xcc\x18\x62\x81\x02\x23\x0e\x38"
            "\x30\x62\x80\x01\x03\x07\x0c\x18\x30\xc0\x80\x01\x03"
            "\x0c\x18\x30\xc0\xc0\x80\x01\x06\x0c\x18\x60\xc0\x88"
            "\x01\x06\x86\x18\x60\x60\xc4\x00\x03\x44\x0c\x30\x80"
            "\x03" }  },
      /* --- pixel bitmap for cmmi250 char#110 n --- */
      { 110,43954,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x3c\x90\x8c\x21\x0e\x8c\x38\x30\x62\xc0\xc0\x80"
            "\x01\x03\x06\x0c\x18\x30\x30\x60\xc0\x80\x01\x23\x06"
            "\x86\x18\x18\x31\x40\xc6\x00\x06" }  },
      /* --- pixel bitmap for cmmi250 char#111 o --- */
      { 111,44706,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x72\x41\x52\x61\x32\x72\xf1\x12\x82\x0f\x22\x92"
            "\x0f\x12\x82\x12\x72\x22\x62\x42\x42\x74\x62" }  },
      /* --- pixel bitmap for cmmi250 char#112 p --- */
      { 112,45714,                      /* character number, location */
         15,-1,   -7,-1,      /* topleft row,col, and botleft row,col */
          { 17,   22, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x44\x61\x21\x21\x41\x41\x33\x52\xf1\x31\x32\x62"
            "\xf3\x62\x72\xf1\x52\x72\x10\x52\x62\x72\x61\x72\x11"
            "\x32\x82\x24\x50\xf1\x42\xb0\xf3\x32\xc7\xa2" }  },
      /* --- pixel bitmap for cmmi250 char#113 q --- */
      { 113,46647,                      /* character number, location */
         15, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 13,   22, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x31\x41\x41\x11\x41\x53\x31\x72\x22\x72\x21\x72"
            "\x2f\x22\x72\x2f\x21\x72\x32\x53\x41\x34\x63\x22\x40"
            "\xf1\x72\x40\xf3\x62\x50\x37\x33" }  },
      /* --- pixel bitmap for cmmi250 char#114 r --- */
      { 114,47564,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\x44\x31\x21\x21\x32\x11\x33\x33\x11\x32\x42\x21"
            "\x32\x70\xf3\x42\x80\xf3\x32\x90\xf1\x22\xa3" }  },
      /* --- pixel bitmap for cmmi250 char#115 s --- */
      { 115,48544,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x62\x42\xf1\x32\x43\x32\x42\x43\x96\x85\xa3\xa2"
            "\x1f\x13\x62\x12\x62\x31\x52\x56\x41" }  },
      /* --- pixel bitmap for cmmi250 char#116 t --- */
      { 116,49306,                      /* character number, location */
         21, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 11,   21, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x52\x40\xf2\x42\x5b\xf3\x32\x60\xf3\x22\x70\x12"
            "\x80\xf1\x12\x51\x20\x12\x41\x42\x31\x64\x53" }  },
      /* --- pixel bitmap for cmmi250 char#117 u --- */
      { 117,50364,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x40\x88\xc0\x08\x81\x11\x03\x23\x06\x06\x0c\x06"
            "\x0c\x0c\x18\x18\x30\x30\x30\x30\x60\x60\xc4\xc0\x88"
            "\xc1\x11\x46\x13\x78\x1c" }  },
      /* --- pixel bitmap for cmmi250 char#118 v --- */
      { 118,51309,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x20\x22\xb0\x10\x58\x0c\x2c\x06\x06\x03\xc1\x80"
            "\x60\x40\x30\x20\x0c\x08\x06\x04\x03\x01\x41\x80\x31"
            "\x80\x07\x00" }  },
      /* --- pixel bitmap for cmmi250 char#119 w --- */
      { 119,52537,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   15, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\x81\x61\x31\x31\x62\x62\x11\x41\x62\x62\xf1\x11"
            "\x32\x62\x62\x52\x52\x71\x10\xf2\x42\x62\x71\x10\xf1"
            "\x32\x62\x71\x20\x32\x62\x61\x71\x62\x61\x72\x41\x12"
            "\x41\xa4\x35\x52" }  },
      /* --- pixel bitmap for cmmi250 char#120 x --- */
      { 120,53803,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xe1\x41\x6c\x8c\x60\x38\x81\x61\x04\x06\x00\x0c"
            "\x00\x30\x00\xc0\x00\x00\x03\x00\x06\x00\x18\xc8\x60"
            "\x20\xc7\x41\x8c\x85\xe0\xe1\x01" }  },
      /* --- pixel bitmap for cmmi250 char#121 y --- */
      { 121,54927,                      /* character number, location */
         15, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\x81\x21\x31\x62\x11\x41\x62\xf1\x11\x32\x62\x52"
            "\x52\x10\xf2\x42\x62\x10\xf2\x32\x62\x20\x32\x53\x62"
            "\x33\x84\x12\xd2\xd1\x62\x52\x53\x42\x62\x51\x81\x32"
            "\xa4\x84" }  },
      /* --- pixel bitmap for cmmi250 char#122 z --- */
      { 122,55891,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x51\x46\x31\x42\x44\x51\x71\xd1\xd1\xd1\xd1\xd1"
            "\xc2\xc1\x81\x41\x91\x45\x32\x41\x45\x41\x63\x53" }  },
      /* --- pixel bitmap for cmmi250 char#123 \imath --- */
      { 123,98964,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xc8\x08\x13\x23\x06\x0c\x0c\x18\x18\x30\x60\x64"
            "\xc8\x08\x11\x1c" }  },
      /* --- pixel bitmap for cmmi250 char#124 \jmath --- */
      { 124,99807,                      /* character number, location */
         15, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 13,   22, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x91\x31\x71\x42\xf1\x51\x52\xf3\xa2\x10\xf3\x92"
            "\x20\xf3\x82\x30\x72\x52\x42\x43\x32\x52\x32\x75\x71" }  },
      /* --- pixel bitmap for cmmi250 char#125 \wp --- */
      { 125,100950,                     /* character number, location */
         16, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x00\x80\x81\x0f\x06\xc3\x10\x04\xcc\x18\x60\x26"
            "\x00\x1b\x01\xd8\x04\xc0\x16\x00\xb6\x00\xb0\x03\xc0"
            "\x1c\x00\xc6\x20\x18\x0e\x41\xe8\x88\x41\x86\x07\x62"
            "\x00\x10\x03\x40\x18\x00\xc2\x00\x10\x06\x80\x18\x00"
            "\x4c\x00\xc0\x01\x00" }  },
      /* --- pixel bitmap for cmmi250 char#126 \vec --- */
      { 126,101632,                     /* character number, location */
         24, 6,   17, 6,      /* topleft row,col, and botleft row,col */
          { 15,    7, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb2\xd3\x1f\x1e\x01\xa3\xc2\xd1\x41" }  },
      /* --- pixel bitmap for cmmi250 char#127 (noname) --- */
      { 127,102176,                     /* character number, location */
         23,10,   19,10,      /* topleft row,col, and botleft row,col */
          { 13,    4, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x52\x62\x21\xa2\xb1" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* ------------------------------------------------------------------------
font sizes 0-7 for cmmib10
------------------------------------------------------------------------ */

/* --- size=0 for .83gf ---
 * mf '\mode=eighthre;  input cmmib10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmib83 --- */
static	chardef  cmmib83[] =
   {
      /* --- pixel bitmap for cmmib83 char#0 \Gamma --- */
      {   0, 1593,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x31\x33\x62\xc0\x80\x81\x81\x0f" }  },
      /* --- pixel bitmap for cmmib83 char#1 \Delta --- */
      {   1, 1620,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\xc0\x81\x83\x86\x9c\x30\x7f\xff" }  },
      /* --- pixel bitmap for cmmib83 char#2 \Theta --- */
      {   2, 1649,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xb3\xf8\xff\x1f\xcd\x1c" }  },
      /* --- pixel bitmap for cmmib83 char#3 \Lambda --- */
      {   3, 1680,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x60\x70\x70\x68\x6c\x64\xf7" }  },
      /* --- pixel bitmap for cmmib83 char#4 \Xi --- */
      {   4, 1711,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xf1\x13\xc2\x83\x47\xe0\xbf\x7f" }  },
      /* --- pixel bitmap for cmmib83 char#5 \Pi --- */
      {   5, 1738,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xc7\x18\x63\x18\xc3\x18\xc6\x18\xe3\x3d" }  },
      /* --- pixel bitmap for cmmib83 char#6 \Sigma --- */
      {   6, 1775,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x39\x63\xc2\x01\x03\x13\x11\x3f" }  },
      /* --- pixel bitmap for cmmib83 char#7 \Upsilon --- */
      {   7, 1806,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb7\x3b\x83\xc1\x60\x18\x1e" }  },
      /* --- pixel bitmap for cmmib83 char#8 \Phi --- */
      {   8, 1833,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x98\x6f\xbf\xf7\x31\x7c" }  },
      /* --- pixel bitmap for cmmib83 char#9 \Psi --- */
      {   9, 1860,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xd8\x7e\xbf\xf7\x31\x3c" }  },
      /* --- pixel bitmap for cmmib83 char#10 \Omega --- */
      {  10, 1889,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xcc\xc6\xc6\x46\xe6\x67\x77" }  },
      /* --- pixel bitmap for cmmib83 char#11 \alpha --- */
      {  11, 1926,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x1c\x65\x27" }  },
      /* --- pixel bitmap for cmmib83 char#12 \beta --- */
      {  12, 1953,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xa2\xc8\x23\x12\x4d\x1e\x81\x00" }  },
      /* --- pixel bitmap for cmmib83 char#13 \gamma --- */
      {  13, 1990,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x63\x84\x10\x02" }  },
      /* --- pixel bitmap for cmmib83 char#14 \delta --- */
      {  14, 2015,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x10\x93\x52\x39" }  },
      /* --- pixel bitmap for cmmib83 char#15 \epsilon --- */
      {  15, 2044,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x17\x0e" }  },
      /* --- pixel bitmap for cmmib83 char#16 \zeta --- */
      {  16, 2061,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x8b\x10\x42\x18\xc4\x00" }  },
      /* --- pixel bitmap for cmmib83 char#17 \eta --- */
      {  17, 2088,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdb\x29\x46\x11\x04\x01" }  },
      /* --- pixel bitmap for cmmib83 char#18 \theta --- */
      {  18, 2119,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\xca\xff\x53\x32" }  },
      /* --- pixel bitmap for cmmib83 char#19 \iota --- */
      {  19, 2150,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x7a" }  },
      /* --- pixel bitmap for cmmib83 char#20 \kappa --- */
      {  20, 2169,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb2\xe3\xc5\x21" }  },
      /* --- pixel bitmap for cmmib83 char#21 \lambda --- */
      {  21, 2192,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x20\x84\xa8\x8c" }  },
      /* --- pixel bitmap for cmmib83 char#22 \mu --- */
      {  22, 2221,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\x28\xc6\x6f\x10\x00" }  },
      /* --- pixel bitmap for cmmib83 char#23 \nu --- */
      {  23, 2252,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa3\x28\x35\x03" }  },
      /* --- pixel bitmap for cmmib83 char#24 \xi --- */
      {  24, 2277,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x0b\xc1\x44\x10\xcc\x01" }  },
      /* --- pixel bitmap for cmmib83 char#25 \pi --- */
      {  25, 2304,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xa2\x28\x09" }  },
      /* --- pixel bitmap for cmmib83 char#26 \rho --- */
      {  26, 2329,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x28\x4e\x4f\x10\x00" }  },
      /* --- pixel bitmap for cmmib83 char#27 \sigma --- */
      {  27, 2356,                      /* character number, location */
          5, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x92\x14\x03" }  },
      /* --- pixel bitmap for cmmib83 char#28 \tau --- */
      {  28, 2379,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x41\x08\x02" }  },
      /* --- pixel bitmap for cmmib83 char#29 \upsilon --- */
      {  29, 2398,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd3\x28\x46\x0e" }  },
      /* --- pixel bitmap for cmmib83 char#30 \phi --- */
      {  30, 2423,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x08\xc2\x97\x4c\x96\x3c\x04\x02" }  },
      /* --- pixel bitmap for cmmib83 char#31 \chi --- */
      {  31, 2462,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x13\x06\x41\x11\x85\x01" }  },
      /* --- pixel bitmap for cmmib83 char#32 \psi --- */
      {  32, 2493,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x08\x64\xb5\x54\xaa\x3c\x04\x02" }  },
      /* --- pixel bitmap for cmmib83 char#33 \omega --- */
      {  33, 2536,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\x64\xb2\xb5\x01" }  },
      /* --- pixel bitmap for cmmib83 char#34 \varepsilon --- */
      {  34, 2569,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2c\x12\x0e" }  },
      /* --- pixel bitmap for cmmib83 char#35 \vartheta --- */
      {  35, 2586,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x8a\xee\xa3\x14\x39" }  },
      /* --- pixel bitmap for cmmib83 char#36 \varpi --- */
      {  36, 2621,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x8f\x24\x52\x2c\x6e\x00" }  },
      /* --- pixel bitmap for cmmib83 char#37 \varrho --- */
      {  37, 2652,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x28\x4e\x4f\xe0\x00" }  },
      /* --- pixel bitmap for cmmib83 char#38 \varsigma --- */
      {  38, 2679,                      /* character number, location */
          5, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x46\x01" }  },
      /* --- pixel bitmap for cmmib83 char#39 \varphi --- */
      {  39, 2698,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb2\x64\xb2\xe4\x21\x10\x00" }  },
      /* --- pixel bitmap for cmmib83 char#40 \bfleftharpoonup --- */
      {  40, 3124,                      /* character number, location */
          5, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 10,    3, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x82\x7a" }  },
      /* --- pixel bitmap for cmmib83 char#41 \bfleftharpoondown --- */
      {  41, 3137,                      /* character number, location */
          3, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1b\x40\x00" }  },
      /* --- pixel bitmap for cmmib83 char#42 \bfrightharpoonup --- */
      {  42, 3150,                      /* character number, location */
          5, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 10,    3, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x92\x1a" }  },
      /* --- pixel bitmap for cmmib83 char#43 \bfrightharpoondown --- */
      {  43, 3163,                      /* character number, location */
          3, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03\x06\x08" }  },
      /* --- pixel bitmap for cmmib83 char#44 ` --- */
      {  44, 3176,                      /* character number, location */
          7, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  1,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for cmmib83 char#45 ' --- */
      {  45, 3193,                      /* character number, location */
          7, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  1,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for cmmib83 char#46 \triangleright --- */
      {  46, 3210,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x79\x01" }  },
      /* --- pixel bitmap for cmmib83 char#47 \triangleleft --- */
      {  47, 3229,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe8\xe9\x08" }  },
      /* --- pixel bitmap for cmmib83 char#48 \0 --- */
      {  48, 2892,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\x1e" }  },
      /* --- pixel bitmap for cmmib83 char#49 \1 --- */
      {  49, 2915,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\x74" }  },
      /* --- pixel bitmap for cmmib83 char#50 \2 --- */
      {  50, 2932,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x97\xe8\x0f" }  },
      /* --- pixel bitmap for cmmib83 char#51 \3 --- */
      {  51, 2951,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa6\x31\x87\xb7\x03" }  },
      /* --- pixel bitmap for cmmib83 char#52 \4 --- */
      {  52, 2976,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x67\x4d\x3f\x84\x03" }  },
      /* --- pixel bitmap for cmmib83 char#53 \5 --- */
      {  53, 3001,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x71\xdc\x06" }  },
      /* --- pixel bitmap for cmmib83 char#54 \6 --- */
      {  54, 3024,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x71\x99\x06" }  },
      /* --- pixel bitmap for cmmib83 char#55 \7 --- */
      {  55, 3049,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x22\x22\x84\x00" }  },
      /* --- pixel bitmap for cmmib83 char#56 \8 --- */
      {  56, 3072,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\xef\x9d\x06" }  },
      /* --- pixel bitmap for cmmib83 char#57 \9 --- */
      {  57, 3099,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\xe9\x88\x07" }  },
      /* --- pixel bitmap for cmmib83 char#58 . --- */
      {  58, 3248,                      /* character number, location */
          2, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmmib83 char#59 , --- */
      {  59, 3259,                      /* character number, location */
          2, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  2,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f" }  },
      /* --- pixel bitmap for cmmib83 char#60 < --- */
      {  60, 3274,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x18\xc2\x10\x30\x20\x60\x40" }  },
      /* --- pixel bitmap for cmmib83 char#61 / --- */
      {  61, 3299,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x44\x44\x22\x22\x11" }  },
      /* --- pixel bitmap for cmmib83 char#62 > --- */
      {  62, 3330,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x03\x02\x06\x84\x21\x0c\x01" }  },
      /* --- pixel bitmap for cmmib83 char#63 \star --- */
      {  63, 3355,                      /* character number, location */
          3,-1,    1,-1,      /* topleft row,col, and botleft row,col */
          {  6,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x06" }  },
      /* --- pixel bitmap for cmmib83 char#64 \partial --- */
      {  64, 2733,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x09\xfa\x61\x14\x3d" }  },
      /* --- pixel bitmap for cmmib83 char#65 A --- */
      {  65,   35,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\xc0\x80\x81\x83\x06\x1f\xb1\xf3" }  },
      /* --- pixel bitmap for cmmib83 char#66 B --- */
      {  66,   64,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x30\x33\xe3\xc7\x8c\x99\x99\x1f" }  },
      /* --- pixel bitmap for cmmib83 char#67 C --- */
      {  67,   97,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xc4\x46\x03\x03\x43\x23\x1e" }  },
      /* --- pixel bitmap for cmmib83 char#68 D --- */
      {  68,  128,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x30\x33\x66\xcc\x98\x91\xb1\x3f" }  },
      /* --- pixel bitmap for cmmib83 char#69 E --- */
      {  69,  163,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x31\xb3\xe2\xc1\x92\xa1\xa1\x7f" }  },
      /* --- pixel bitmap for cmmib83 char#70 F --- */
      {  70,  200,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x31\xb3\xe2\xc1\x82\x81\x81\x07" }  },
      /* --- pixel bitmap for cmmib83 char#71 G --- */
      {  71,  231,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xc4\x46\x03\xfb\x63\x33\x3e" }  },
      /* --- pixel bitmap for cmmib83 char#72 H --- */
      {  72,  264,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\xc7\x18\x63\xf8\xc3\x18\xc6\x18\xe3\x3d" }  },
      /* --- pixel bitmap for cmmib83 char#73 I --- */
      {  73,  301,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xc6\x30\x0c\x63\x3c" }  },
      /* --- pixel bitmap for cmmib83 char#74 J --- */
      {  74,  324,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x60\x30\x30\x30\x30\x1b\x0e" }  },
      /* --- pixel bitmap for cmmib83 char#75 K --- */
      {  75,  349,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\xc7\x04\x1b\x78\xc0\x06\x36\x98\xe1\x39" }  },
      /* --- pixel bitmap for cmmib83 char#76 L --- */
      {  76,  386,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x18\x0c\x0c\x8c\x8c\x46\x7f" }  },
      /* --- pixel bitmap for cmmib83 char#77 M --- */
      {  77,  415,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x3c\x8e\x46\xe3\xd0\x34\xb4\x0c\x39\x23\x66\x9c"
            "\x3c" }  },
      /* --- pixel bitmap for cmmib83 char#78 N --- */
      {  78,  472,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xc7\x11\x5d\xc8\x42\x1e\xe2\x08\xe3\x10" }  },
      /* --- pixel bitmap for cmmib83 char#79 O --- */
      {  79,  515,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xb3\x78\x3c\x1e\xcd\x1c" }  },
      /* --- pixel bitmap for cmmib83 char#80 P --- */
      {  80,  550,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x98\xcc\xcc\x7c\x0c\x06\x0f" }  },
      /* --- pixel bitmap for cmmib83 char#81 Q --- */
      {  81,  579,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xb3\x78\x3c\x1e\xfd\x1c\x30\x08" }  },
      /* --- pixel bitmap for cmmib83 char#82 R --- */
      {  82,  616,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x30\x33\xe3\xc3\x8c\x99\x99\xe7" }  },
      /* --- pixel bitmap for cmmib83 char#83 S --- */
      {  83,  651,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x6b\x38\x1c\xd6\x1c" }  },
      /* --- pixel bitmap for cmmib83 char#84 T --- */
      {  84,  678,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x65\x67\xc2\x80\x01\x03\x03\x1f" }  },
      /* --- pixel bitmap for cmmib83 char#85 U --- */
      {  85,  709,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x0d\x0d\x19\x32\x64\xc8\x08\x0f" }  },
      /* --- pixel bitmap for cmmib83 char#86 V --- */
      {  86,  746,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x8d\x98\x70\xc1\x81\x03\x03\x02" }  },
      /* --- pixel bitmap for cmmib83 char#87 W --- */
      {  87,  777,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xef\xdd\x9c\x98\x1b\x6b\x61\x1d\x9c\x83\x31\x20\x06" }  },
      /* --- pixel bitmap for cmmib83 char#88 X --- */
      {  88,  828,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\xc3\x02\x07\x1c\x70\xe0\x81\xc6\x7b" }  },
      /* --- pixel bitmap for cmmib83 char#89 Y --- */
      {  89,  859,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x99\xb0\xe0\x81\x01\x03\x03\x0f" }  },
      /* --- pixel bitmap for cmmib83 char#90 Z --- */
      {  90,  888,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x9a\x0e\xc3\x72\x59\x3e" }  },
      /* --- pixel bitmap for cmmib83 char#91 \flat --- */
      {  91, 3366,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  2,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\xff\x01" }  },
      /* --- pixel bitmap for cmmib83 char#92 \natural --- */
      {  92, 3391,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xbd\x99\xd9\x8b" }  },
      /* --- pixel bitmap for cmmib83 char#93 \sharp --- */
      {  93, 3432,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  2,   10, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x02" }  },
      /* --- pixel bitmap for cmmib83 char#94 \smile --- */
      {  94, 3459,                      /* character number, location */
          5, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 10,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x0a\xc4\x0f" }  },
      /* --- pixel bitmap for cmmib83 char#95 \frown --- */
      {  95, 3476,                      /* character number, location */
          5, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 10,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x08\x14\x20" }  },
      /* --- pixel bitmap for cmmib83 char#96 \ell --- */
      {  96, 2764,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x4a\x51\x0c\x61\xe0" }  },
      /* --- pixel bitmap for cmmib83 char#97 a --- */
      {  97,  921,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\xc6\x7c\x01" }  },
      /* --- pixel bitmap for cmmib83 char#98 b --- */
      {  98,  946,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x84\x17\x63\x3a" }  },
      /* --- pixel bitmap for cmmib83 char#99 c --- */
      {  99,  975,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x11\x0f" }  },
      /* --- pixel bitmap for cmmib83 char#100 d --- */
      { 100,  994,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x08\x79\x51\x94\x5d" }  },
      /* --- pixel bitmap for cmmib83 char#101 e --- */
      { 101, 1025,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xbe\xf0\x00" }  },
      /* --- pixel bitmap for cmmib83 char#102 f --- */
      { 102, 1044,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\x10\x47\x88\x10\x22\x00" }  },
      /* --- pixel bitmap for cmmib83 char#103 g --- */
      { 103, 1071,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\xc6\xf4\xd0\x01" }  },
      /* --- pixel bitmap for cmmib83 char#104 h --- */
      { 104, 1098,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x21\x68\xa6\x18\xc7" }  },
      /* --- pixel bitmap for cmmib83 char#105 i --- */
      { 105, 1131,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xb0\x69\x03" }  },
      /* --- pixel bitmap for cmmib83 char#106 j --- */
      { 106, 1152,                      /* character number, location */
          9, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x00\xc0\x14\x22\x84\x0c" }  },
      /* --- pixel bitmap for cmmib83 char#107 k --- */
      { 107, 1179,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x21\xc8\xae\x93\x45" }  },
      /* --- pixel bitmap for cmmib83 char#108 l --- */
      { 108, 1210,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa6\x24\x4d" }  },
      /* --- pixel bitmap for cmmib83 char#109 m --- */
      { 109, 1233,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdb\x4e\x8a\x8c\x1c\x19" }  },
      /* --- pixel bitmap for cmmib83 char#110 n --- */
      { 110, 1270,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xca\x9c\x01" }  },
      /* --- pixel bitmap for cmmib83 char#111 o --- */
      { 111, 1295,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x46\x0f" }  },
      /* --- pixel bitmap for cmmib83 char#112 p --- */
      { 112, 1318,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x23\xd1\xe4\x11\x0c\x00" }  },
      /* --- pixel bitmap for cmmib83 char#113 q --- */
      { 113, 1345,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\xc6\xf4\x10\x03" }  },
      /* --- pixel bitmap for cmmib83 char#114 r --- */
      { 114, 1372,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\x12\x01" }  },
      /* --- pixel bitmap for cmmib83 char#115 s --- */
      { 115, 1391,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\x8c\x0e" }  },
      /* --- pixel bitmap for cmmib83 char#116 t --- */
      { 116, 1408,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd4\xa5\x09" }  },
      /* --- pixel bitmap for cmmib83 char#117 u --- */
      { 117, 1429,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\xca\x6c\x01" }  },
      /* --- pixel bitmap for cmmib83 char#118 v --- */
      { 118, 1456,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\xca\x64\x00" }  },
      /* --- pixel bitmap for cmmib83 char#119 w --- */
      { 119, 1481,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\x93\x92\x49\x36" }  },
      /* --- pixel bitmap for cmmib83 char#120 x --- */
      { 120, 1516,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x94\x8a\x54\x1e" }  },
      /* --- pixel bitmap for cmmib83 char#121 y --- */
      { 121, 1543,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\xca\xe4\xd0\x01" }  },
      /* --- pixel bitmap for cmmib83 char#122 z --- */
      { 122, 1572,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x11\xf5\x00" }  },
      /* --- pixel bitmap for cmmib83 char#123 \imath --- */
      { 123, 2793,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xef\x03" }  },
      /* --- pixel bitmap for cmmib83 char#124 \jmath --- */
      { 124, 2810,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x25\x05" }  },
      /* --- pixel bitmap for cmmib83 char#125 \wp --- */
      { 125, 2831,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x74\x8e\x82\x42\x35\x05\x02" }  },
      /* --- pixel bitmap for cmmib83 char#126 \bfvec --- */
      { 126, 2866,                      /* character number, location */
          9, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  6,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd0\x0f\x01" }  },
      /* --- pixel bitmap for cmmib83 char#127 (noname) --- */
      { 127, 2879,                      /* character number, location */
          8, 3,    6, 3,      /* topleft row,col, and botleft row,col */
          {  5,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x02" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=1 for .100gf ---
 * mf '\mode=preview; mag=magstep(-17.87427405946994351363); input cmmib10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmib100 --- */
static	chardef  cmmib100[] =
   {
      /* --- pixel bitmap for cmmib100 char#0 \Gamma --- */
      {   0,52539,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x63\x8c\x21\x43\x0c\x30\xc0\x80\x01\x1f\x00" }  },
      /* --- pixel bitmap for cmmib100 char#1 \Delta --- */
      {   1,53404,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x0e\x68\x20\x87\x31\x84\x11\xdc\xff\xff\x07" }  },
      /* --- pixel bitmap for cmmib100 char#2 \Theta --- */
      {   2,54527,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x31\x6c\xf0\xcc\x33\x0f\x3c\xd8\x31\x7c\x00" }  },
      /* --- pixel bitmap for cmmib100 char#3 \Lambda --- */
      {   3,55425,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x80\x01\x0e\x34\xc8\x20\x43\x8c\x31\xe7\x03" }  },
      /* --- pixel bitmap for cmmib100 char#4 \Xi --- */
      {   4,56802,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x29\x21\x71\xf1\x27\x20\xc1\x71\x1f\x19\x22" }  },
      /* --- pixel bitmap for cmmib100 char#5 \Pi --- */
      {   5,58019,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,    9, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2b\xf1\x32\x42\x20\xf3\x22\x42\x30\x12\x42\x44\x25"
            "\x22" }  },
      /* --- pixel bitmap for cmmib100 char#6 \Sigma --- */
      {   6,59174,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xe7\x30\x8e\xe1\x04\x06\x10\x61\x8c\x20\xfe\x01" }  },
      /* --- pixel bitmap for cmmib100 char#7 \Upsilon --- */
      {   7,60190,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\xbd\x8f\x03\x06\x18\x60\x80\x01\x03\x3f\x00" }  },
      /* --- pixel bitmap for cmmib100 char#8 \Phi --- */
      {   8,61216,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xc1\xf0\xb3\x3d\x7b\xb6\x1f\x0c\x7e\x00" }  },
      /* --- pixel bitmap for cmmib100 char#9 \Psi --- */
      {   9,62271,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xc0\x30\xfb\x36\xdb\xec\xe1\x03\x03\x3f\x00" }  },
      /* --- pixel bitmap for cmmib100 char#10 \Omega --- */
      {  10,63456,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x61\x18\x83\x0d\x66\x30\x82\x18\xea\x30\xc7\x01" }  },
      /* --- pixel bitmap for cmmib100 char#11 \alpha --- */
      {  11,64424,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xcc\x0f\x1f\x36\xce\x33" }  },
      /* --- pixel bitmap for cmmib100 char#12 \beta --- */
      {  12,65445,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x20\x23\x46\x4c\x8f\x1e\x31\x62\x66\x74\x08\x10"
            "\x10\x00" }  },
      /* --- pixel bitmap for cmmib100 char#13 \gamma --- */
      {  13,66310,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\x9f\x71\x60\x60\x20\x20\x20\x10" }  },
      /* --- pixel bitmap for cmmib100 char#14 \delta --- */
      {  14,67177,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x4e\x32\x18\x67\xcf\xf3\xe6\x00" }  },
      /* --- pixel bitmap for cmmib100 char#15 \epsilon --- */
      {  15,67981,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\xf0\x0d\xa3\x07" }  },
      /* --- pixel bitmap for cmmib100 char#16 \zeta --- */
      {  16,68853,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xce\x1b\xc2\x30\x0c\xc3\xe3\x41\x1c" }  },
      /* --- pixel bitmap for cmmib100 char#17 \eta --- */
      {  17,69686,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\xcf\xc6\xc6\x63\x63\x60\x60\x20" }  },
      /* --- pixel bitmap for cmmib100 char#18 \theta --- */
      {  18,70422,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xa6\xd1\xf8\xff\x8f\x67\x13\x07" }  },
      /* --- pixel bitmap for cmmib100 char#19 \iota --- */
      {  19,71067,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x66\x6b" }  },
      /* --- pixel bitmap for cmmib100 char#20 \kappa --- */
      {  20,71961,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc4\xf6\x3e\x66\xe3\xc3" }  },
      /* --- pixel bitmap for cmmib100 char#21 \lambda --- */
      {  21,72770,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x70\xc0\x80\x01\x06\x0c\x1c\x66\xc6\x84\x03" }  },
      /* --- pixel bitmap for cmmib100 char#22 \mu --- */
      {  22,73786,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x19\x33\x66\xec\xdc\xb7\x01\x03\x02\x00" }  },
      /* --- pixel bitmap for cmmib100 char#23 \nu --- */
      {  23,74527,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0d\x1b\x36\xb7\xe3\x00" }  },
      /* --- pixel bitmap for cmmib100 char#24 \xi --- */
      {  24,75605,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x38\x9b\x61\xe0\xf1\x0c\x83\x87\x0f\x86\x03" }  },
      /* --- pixel bitmap for cmmib100 char#25 \pi --- */
      {  25,76463,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xff\xb3\x20\x61\xc6\x0c" }  },
      /* --- pixel bitmap for cmmib100 char#26 \rho --- */
      {  26,77281,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x10\x33\x66\x6c\xcc\x8f\x01\x03\x02\x00" }  },
      /* --- pixel bitmap for cmmib100 char#27 \sigma --- */
      {  27,78119,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xfd\x8f\x19\x33\xc3\x03" }  },
      /* --- pixel bitmap for cmmib100 char#28 \tau --- */
      {  28,78822,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xff\x18\x08\x0c\x0c" }  },
      /* --- pixel bitmap for cmmib100 char#29 \upsilon --- */
      {  29,79695,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\xc7\x86\x46\x46\x3c" }  },
      /* --- pixel bitmap for cmmib100 char#30 \phi --- */
      {  30,80501,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x01\x02\x08\xfc\x98\x34\xf1\xc4\x93\xf9\x81"
            "\x00\x02\x08\x00" }  },
      /* --- pixel bitmap for cmmib100 char#31 \chi --- */
      {  31,81468,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x1b\x61\xc1\x81\x01\x07\x0d\x31\xe1\x00" }  },
      /* --- pixel bitmap for cmmib100 char#32 \psi --- */
      {  32,82451,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x01\x04\x10\x26\x9d\x6c\xa2\x49\x96\xf1\x01"
            "\x01\x04\x08\x00" }  },
      /* --- pixel bitmap for cmmib100 char#33 \omega --- */
      {  33,83490,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x05\x1c\x63\xcc\xff\xb9\x03" }  },
      /* --- pixel bitmap for cmmib100 char#34 \varepsilon --- */
      {  34,84415,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xbf\xf3\x1f" }  },
      /* --- pixel bitmap for cmmib100 char#35 \vartheta --- */
      {  35,85388,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x88\x88\x88\xf7\xc7\xc6\x66\x22\x1e" }  },
      /* --- pixel bitmap for cmmib100 char#36 \varpi --- */
      {  36,86533,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xff\xff\x13\x21\x32\xc6\x7f\x38\x07" }  },
      /* --- pixel bitmap for cmmib100 char#37 \varrho --- */
      {  37,87408,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xc4\xc6\xc6\x67\x3d\x01\x1f\x1e" }  },
      /* --- pixel bitmap for cmmib100 char#38 \varsigma --- */
      {  38,88183,                      /* character number, location */
          6, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x8c\xe3\x38\x03" }  },
      /* --- pixel bitmap for cmmib100 char#39 \varphi --- */
      {  39,89036,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\x85\x1f\x62\x44\xff\xf1\x81\x01\x06\x08\x00" }  },
      /* --- pixel bitmap for cmmib100 char#40 \bfleftharpoonup --- */
      {  40,103938,                     /* character number, location */
          7, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 14,    4, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\xc1\xc2\xbe" }  },
      /* --- pixel bitmap for cmmib100 char#41 \bfleftharpoondown --- */
      {  41,104934,                     /* character number, location */
          4, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,    4, 3, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x12\xd1\xe1\xa2" }  },
      /* --- pixel bitmap for cmmib100 char#42 \bfrightharpoonup --- */
      {  42,105928,                     /* character number, location */
          7, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 14,    4, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\xe1\xd2\x1e" }  },
      /* --- pixel bitmap for cmmib100 char#43 \bfrightharpoondown --- */
      {  43,106925,                     /* character number, location */
          4, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,    4, 3, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xb2\xc1\xc1\x32" }  },
      /* --- pixel bitmap for cmmib100 char#44 ` --- */
      {  44,107314,                     /* character number, location */
          8, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x02" }  },
      /* --- pixel bitmap for cmmib100 char#45 ' --- */
      {  45,107706,                     /* character number, location */
          8, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa9\x01" }  },
      /* --- pixel bitmap for cmmib100 char#46 \triangleright --- */
      {  46,108215,                     /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x91\x85\xd9\x11\x00" }  },
      /* --- pixel bitmap for cmmib100 char#47 \triangleleft --- */
      {  47,108733,                     /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x6e\x86\x26\x0e\x02" }  },
      /* --- pixel bitmap for cmmib100 char#48 \0 --- */
      {  48,94975,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xde\x3c\xcf\xb3\x07" }  },
      /* --- pixel bitmap for cmmib100 char#49 \1 --- */
      {  49,95696,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\xc3\x30\xcc\x0f" }  },
      /* --- pixel bitmap for cmmib100 char#50 \2 --- */
      {  50,96628,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\x0c\xe3\xfe\x0f" }  },
      /* --- pixel bitmap for cmmib100 char#51 \3 --- */
      {  51,97611,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xde\x3c\xc3\x1c\x3c\xcf\x1e" }  },
      /* --- pixel bitmap for cmmib100 char#52 \4 --- */
      {  52,98494,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x38\x3c\x36\x33\xff\x30\x30\xfc" }  },
      /* --- pixel bitmap for cmmib100 char#53 \5 --- */
      {  53,99485,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x13\x7c\x33\x3c\x4f\x0e" }  },
      /* --- pixel bitmap for cmmib100 char#54 \6 --- */
      {  54,100334,                     /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x3d\x7f\xf3\x3c\xcb\x1c" }  },
      /* --- pixel bitmap for cmmib100 char#55 \7 --- */
      {  55,101191,                     /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x7f\x08\x82\x60\x30\x18\x0c" }  },
      /* --- pixel bitmap for cmmib100 char#56 \8 --- */
      {  56,102070,                     /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xde\x3c\x7b\xde\x3c\xcf\x1e" }  },
      /* --- pixel bitmap for cmmib100 char#57 \9 --- */
      {  57,102923,                     /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\x34\xcf\xb3\x3f\x6f\x0e" }  },
      /* --- pixel bitmap for cmmib100 char#58 . --- */
      {  58,109180,                     /* character number, location */
          2, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmmib100 char#59 , --- */
      {  59,109713,                     /* character number, location */
          2, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaf\x01" }  },
      /* --- pixel bitmap for cmmib100 char#60 < --- */
      {  60,110343,                     /* character number, location */
          9, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x72\x62\x62\x62\x71\xa2\xa2\xa2\xa2\xa1" }  },
      /* --- pixel bitmap for cmmib100 char#61 / --- */
      {  61,110841,                     /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x41\x08\x42\x10\x84\x20\x04\x01" }  },
      /* --- pixel bitmap for cmmib100 char#62 > --- */
      {  62,111490,                     /* character number, location */
          9, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xa2\xa2\xa2\xa2\xa1\x72\x62\x62\x62\x71\x91" }  },
      /* --- pixel bitmap for cmmib100 char#63 \star --- */
      {  63,112163,                     /* character number, location */
          5, 0,    1, 0,      /* topleft row,col, and botleft row,col */
          {  6,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x8f\x91" }  },
      /* --- pixel bitmap for cmmib100 char#64 \partial --- */
      {  64,89950,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xb3\x11\xc8\x17\x8f\x67\x33\x07" }  },
      /* --- pixel bitmap for cmmib100 char#65 A --- */
      {  65, 1000,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x00\x06\x38\xa0\x01\x1d\xc4\xf0\x87\x30\xc7\x07" }  },
      /* --- pixel bitmap for cmmib100 char#66 B --- */
      {  66, 2328,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xc3\x30\x86\x19\xc6\x1f\x86\x31\xcc\x30\xff\x00" }  },
      /* --- pixel bitmap for cmmib100 char#67 C --- */
      {  67, 3269,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x32\x6c\xe0\x00\x03\x0c\x30\x90\x20\x7c\x00" }  },
      /* --- pixel bitmap for cmmib100 char#68 D --- */
      {  68, 4379,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x07\xc3\x30\x8c\xc1\x18\x8c\xc1\x18\xc6\x30\xfe"
            "\x01" }  },
      /* --- pixel bitmap for cmmib100 char#69 E --- */
      {  69, 5774,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x63\x8c\x29\x53\x7c\x30\xc9\x94\x61\xff\x00" }  },
      /* --- pixel bitmap for cmmib100 char#70 F --- */
      {  70, 6981,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x63\x8c\x29\x53\x7c\x30\xc1\x84\x01\x1f\x00" }  },
      /* --- pixel bitmap for cmmib100 char#71 G --- */
      {  71, 8092,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x65\xb0\x01\x05\x30\xfc\x81\x0d\xcc\x30\xfc\x01" }  },
      /* --- pixel bitmap for cmmib100 char#72 H --- */
      {  72, 9313,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x1f\xc3\x60\x18\x86\xc1\x3f\x18\x06\xc3\x30\x0c"
            "\xcf\x07" }  },
      /* --- pixel bitmap for cmmib100 char#73 I --- */
      {  73,10012,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x30\x30\x18\x18\x18\x18\x0c\x3f" }  },
      /* --- pixel bitmap for cmmib100 char#74 J --- */
      {  74,10850,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\xf1\x62\x10\xf3\x52\x22\x22\x44\x40" }  },
      /* --- pixel bitmap for cmmib100 char#75 K --- */
      {  75,12033,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x8f\x11\x98\xc0\x06\x7c\xc0\x0e\xcc\x60\x0c\xdf"
            "\x03" }  },
      /* --- pixel bitmap for cmmib100 char#76 L --- */
      {  76,12926,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xc0\x00\x03\x06\x18\x60\x88\x31\x43\xfe\x01" }  },
      /* --- pixel bitmap for cmmib100 char#77 M --- */
      {  77,14236,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xf8\x38\x38\x38\x34\x34\x1a\x64\x1a\x64\x19\xe4"
            "\x18\xe2\x0c\x6f\x3e" }  },
      /* --- pixel bitmap for cmmib100 char#78 N --- */
      {  78,15374,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x1e\x87\xa0\x11\x32\x41\x2c\x88\x05\xe1\x10\x0c"
            "\x0f\x01" }  },
      /* --- pixel bitmap for cmmib100 char#79 O --- */
      {  79,16219,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x31\x6c\xf0\xc0\x03\x0f\x3c\xd8\x31\x7c\x00" }  },
      /* --- pixel bitmap for cmmib100 char#80 P --- */
      {  80,17276,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xc3\x30\x86\x19\xc6\x1f\x06\x30\xc0\x00\x1f\x00" }  },
      /* --- pixel bitmap for cmmib100 char#81 Q --- */
      {  81,18263,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x31\x6c\xf0\xc0\x03\x0f\x3c\xd8\x37\x7c\x80\x00"
            "\x0e\x30" }  },
      /* --- pixel bitmap for cmmib100 char#82 R --- */
      {  82,19548,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xc3\x30\x86\x19\xc6\x1f\xc6\x30\xc6\x18\x9f\x07" }  },
      /* --- pixel bitmap for cmmib100 char#83 S --- */
      {  83,20593,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x19\x32\xe0\xc1\x07\x1c\xb0\x30\x3f\x00" }  },
      /* --- pixel bitmap for cmmib100 char#84 T --- */
      {  84,21609,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x8b\x2d\x66\x4c\x30\xc0\x00\x03\x06\x7e\x00" }  },
      /* --- pixel bitmap for cmmib100 char#85 U --- */
      {  85,22589,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x24\xf1\x12\x51\x2f\x32\x51\x32\x41\x55\x52" }  },
      /* --- pixel bitmap for cmmib100 char#86 V --- */
      {  86,23463,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\xcf\x20\x0c\xc1\x08\x98\x80\x05\x38\x80\x03\x18"
            "\x00" }  },
      /* --- pixel bitmap for cmmib100 char#87 W --- */
      {  87,24826,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\xf7\x8c\x23\x4c\x33\x6c\x13\x2c\x0b\x1c\x0b\x1c"
            "\x07\x0c\x06\x0c\x02" }  },
      /* --- pixel bitmap for cmmib100 char#88 X --- */
      {  88,25923,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x1e\x4c\x80\x05\x60\x00\x0c\x40\x03\x64\x40\x18"
            "\x9f\x0f" }  },
      /* --- pixel bitmap for cmmib100 char#89 Y --- */
      {  89,26953,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\xcf\x30\x98\x81\x0d\x78\x00\x03\x30\x80\x01\x7c"
            "\x00" }  },
      /* --- pixel bitmap for cmmib100 char#90 Z --- */
      {  90,28024,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x33\x46\x8c\x18\x30\x60\xc4\x98\x21\xff\x00" }  },
      /* --- pixel bitmap for cmmib100 char#91 \flat --- */
      {  91,112804,                     /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x51\xdf\x7d\x37" }  },
      /* --- pixel bitmap for cmmib100 char#92 \natural --- */
      {  92,113511,                     /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xf9\x9f\x99\xf9\x9f\x08" }  },
      /* --- pixel bitmap for cmmib100 char#93 \sharp --- */
      {  93,114322,                     /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\xf9\x9f\x99\xf9\x9f\x01" }  },
      /* --- pixel bitmap for cmmib100 char#94 \smile --- */
      {  94,115186,                     /* character number, location */
          6, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 14,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xa0\x01\xc6\xff\xc0\x0f" }  },
      /* --- pixel bitmap for cmmib100 char#95 \frown --- */
      {  95,116022,                     /* character number, location */
          6, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 14,    4, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x5a\x31\xa1\x11\xc1" }  },
      /* --- pixel bitmap for cmmib100 char#96 \ell --- */
      {  96,90694,                      /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\xb0\x98\x58\x2c\x1c\x0c\x0c\x8e\x78" }  },
      /* --- pixel bitmap for cmmib100 char#97 a --- */
      {  97,28928,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\xf1\x78\x3c\x77\x03" }  },
      /* --- pixel bitmap for cmmib100 char#98 b --- */
      {  98,29702,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x83\xc1\xf0\x1b\x8f\xc7\x33\x0f" }  },
      /* --- pixel bitmap for cmmib100 char#99 c --- */
      {  99,30447,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x3d\x0c\xa3\x07" }  },
      /* --- pixel bitmap for cmmib100 char#100 d --- */
      { 100,31333,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xc0\xc0\xc0\x7c\x62\x63\x63\x73\x6e" }  },
      /* --- pixel bitmap for cmmib100 char#101 e --- */
      { 101,32132,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\xf8\x0d\xa3\x07" }  },
      /* --- pixel bitmap for cmmib100 char#102 f --- */
      { 102,33262,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xf0\x30\x30\xfc\x30\x18\x18\x18\x18\x18\x0a\x06" }  },
      /* --- pixel bitmap for cmmib100 char#103 g --- */
      { 103,34211,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb8\xc4\xc6\xc6\x66\x7c\x60\x62\x1e" }  },
      /* --- pixel bitmap for cmmib100 char#104 h --- */
      { 104,35116,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0c\x0c\x0c\x76\xce\xc6\xc6\xe3\xc3" }  },
      /* --- pixel bitmap for cmmib100 char#105 i --- */
      { 105,35944,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\x00\x60\x67\x76\x06" }  },
      /* --- pixel bitmap for cmmib100 char#106 j --- */
      { 106,36897,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x30\x00\x00\xc0\xd1\x60\x30\x0c\x06\xe3\x30\x00" }  },
      /* --- pixel bitmap for cmmib100 char#107 k --- */
      { 107,37892,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0c\x0c\x0c\xe6\xd6\xde\x36\x73\x63" }  },
      /* --- pixel bitmap for cmmib100 char#108 l --- */
      { 108,38556,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\xcc\x66\x66\x67" }  },
      /* --- pixel bitmap for cmmib100 char#109 m --- */
      { 109,39723,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\xf7\xcc\xc6\x6c\xcc\x63\x3e\xc6" }  },
      /* --- pixel bitmap for cmmib100 char#110 n --- */
      { 110,40682,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\xcf\xc6\xc6\xe3\xc3" }  },
      /* --- pixel bitmap for cmmib100 char#111 o --- */
      { 111,41340,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\xc6\xc3\xc3\x63\x3e" }  },
      /* --- pixel bitmap for cmmib100 char#112 p --- */
      { 112,42246,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x1c\x33\x66\x6c\xcc\x8f\x01\x03\x07\x00" }  },
      /* --- pixel bitmap for cmmib100 char#113 q --- */
      { 113,43131,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\xf1\x78\x3c\xf3\xc1\x60\x3c" }  },
      /* --- pixel bitmap for cmmib100 char#114 r --- */
      { 114,43960,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xde\x6d\x1b\xc3\x00" }  },
      /* --- pixel bitmap for cmmib100 char#115 s --- */
      { 115,44882,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x1a\x4f\x3f\xf2\x00" }  },
      /* --- pixel bitmap for cmmib100 char#116 t --- */
      { 116,45576,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\xe3\xcf\x18\xb3\x0c" }  },
      /* --- pixel bitmap for cmmib100 char#117 u --- */
      { 117,46564,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\xb3\xd9\x6c\x77\x03" }  },
      /* --- pixel bitmap for cmmib100 char#118 v --- */
      { 118,47415,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa6\xb3\xd1\x68\xf2\x00" }  },
      /* --- pixel bitmap for cmmib100 char#119 w --- */
      { 119,48533,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x3a\xb3\x19\xcd\x68\x26\xee\x00" }  },
      /* --- pixel bitmap for cmmib100 char#120 x --- */
      { 120,49735,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6c\xda\xd8\x1a\x4f\x3e" }  },
      /* --- pixel bitmap for cmmib100 char#121 y --- */
      { 121,50751,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xc7\xc6\xc6\x66\x7c\x60\x36\x1e" }  },
      /* --- pixel bitmap for cmmib100 char#122 z --- */
      { 122,51655,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x1f\x84\xe1\xdb\x00" }  },
      /* --- pixel bitmap for cmmib100 char#123 \imath --- */
      { 123,91382,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\x7d\x03" }  },
      /* --- pixel bitmap for cmmib100 char#124 \jmath --- */
      { 124,92165,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x0d\xc3\x18\x86\x29\x06" }  },
      /* --- pixel bitmap for cmmib100 char#125 \wp --- */
      { 125,93246,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xcc\xf7\xf0\xc0\xb3\x9d\xd3\x40\x03\x06\x00" }  },
      /* --- pixel bitmap for cmmib100 char#126 \bfvec --- */
      { 126,93818,                      /* character number, location */
         10, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\xff\x40" }  },
      /* --- pixel bitmap for cmmib100 char#127 (noname) --- */
      { 127,94328,                      /* character number, location */
         10, 4,    7, 4,      /* topleft row,col, and botleft row,col */
          {  6,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x02" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=2 for .118gf ---
 * mf '\mode=preview; mag=magstep(-16.96645799324018499600); input cmmib10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmib118 --- */
static	chardef  cmmib118[] =
   {
      /* --- pixel bitmap for cmmib118 char#0 \Gamma --- */
      {   0,53816,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x39\x42\x42\xf1\x42\x51\x42\x60\xf3\x32\x70\x22\x86"
            "\x62" }  },
      /* --- pixel bitmap for cmmib118 char#1 \Delta --- */
      {   1,54711,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\xb3\xa1\x12\x91\x23\x72\x32\x62\x42\x61\x53\x41"
            "\x72\x31\x82\x2e\x0d" }  },
      /* --- pixel bitmap for cmmib118 char#2 \Theta --- */
      {   2,55868,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x07\x06\xc7\x80\x19\x40\xe6\xf3\x7c\x36\x9f\x4d"
            "\x64\x03\x8c\xc1\x81\x1f\x00" }  },
      /* --- pixel bitmap for cmmib118 char#3 \Lambda --- */
      {   3,56806,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x01\x0c\x70\x80\x03\x1a\xc8\x40\x0e\x61\x04\x23"
            "\xd8\xf3\x01" }  },
      /* --- pixel bitmap for cmmib118 char#4 \Xi --- */
      {   4,58215,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x2b\x31\x91\xe0\x57\x67\xe0\x40\xf1\x11\x91\x2f"
            "\x1b\x30" }  },
      /* --- pixel bitmap for cmmib118 char#5 \Pi --- */
      {   5,59412,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   11, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x01\xf3\x42\x72\x30\xf3\x32\x72\x40\x22\x72\x56"
            "\x36\x30" }  },
      /* --- pixel bitmap for cmmib118 char#6 \Sigma --- */
      {   6,60549,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x33\x62\x42\x71\x43\x61\x52\xd2\xb2\xb1\x71\x41"
            "\x71\x32\x72\x2b\x32" }  },
      /* --- pixel bitmap for cmmib118 char#7 \Upsilon --- */
      {   7,61595,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x44\x15\x22\x13\x44\x31\x53\xb2\x50\xf3\x52\x60"
            "\x42\x96\x52" }  },
      /* --- pixel bitmap for cmmib118 char#8 \Phi --- */
      {   8,62605,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x07\x0c\xc0\x80\x7f\xc6\x3c\xc6\x66\xcc\x3f\x60"
            "\x00\x03\xfc\x00" }  },
      /* --- pixel bitmap for cmmib118 char#9 \Psi --- */
      {   9,63690,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x07\x18\x0c\x63\x63\x66\xcc\xcc\x8c\xd9\xe0\x0f"
            "\x60\x00\x06\xf0\x03" }  },
      /* --- pixel bitmap for cmmib118 char#10 \Omega --- */
      {  10,64859,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x87\x83\x19\x60\x03\x6c\x80\x0d\x98\x81\x29\x50"
            "\x05\xe5\xf0\x1c\x0e" }  },
      /* --- pixel bitmap for cmmib118 char#11 \alpha --- */
      {  11,65855,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xcc\x0e\x1f\x36\x6c\x9c\x67" }  },
      /* --- pixel bitmap for cmmib118 char#12 \beta --- */
      {  12,66882,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\xc1\x8c\x30\xc2\xe8\x91\x47\x30\xc1\x04\x1b\xa6"
            "\x87\x00\x02\x04\x00" }  },
      /* --- pixel bitmap for cmmib118 char#13 \gamma --- */
      {  13,67803,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xfa\x14\x12\x30\xc0\x00\x03\x04\x10\x40\x80\x00" }  },
      /* --- pixel bitmap for cmmib118 char#14 \delta --- */
      {  14,68740,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x3c\x12\x83\xc1\x99\xc7\xe3\xf1\xcc\x03" }  },
      /* --- pixel bitmap for cmmib118 char#15 \epsilon --- */
      {  15,69588,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x31\x7c\xc3\xe8\x01" }  },
      /* --- pixel bitmap for cmmib118 char#16 \zeta --- */
      {  16,70488,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x38\x9e\x61\x10\x0c\x06\x83\x81\x87\x07\xe3\x00" }  },
      /* --- pixel bitmap for cmmib118 char#17 \eta --- */
      {  17,71375,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\x3a\x37\x66\xcc\xd8\x98\x31\x60\xc0\x80\x00" }  },
      /* --- pixel bitmap for cmmib118 char#18 \theta --- */
      {  18,72119,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x4c\xc4\xc6\xc6\x7f\x63\x63\x33\x13\x0e" }  },
      /* --- pixel bitmap for cmmib118 char#19 \iota --- */
      {  19,72770,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x66\xb3\x06" }  },
      /* --- pixel bitmap for cmmib118 char#20 \kappa --- */
      {  20,73692,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc4\xa6\x1e\x3e\x66\xb3\xe3" }  },
      /* --- pixel bitmap for cmmib118 char#21 \lambda --- */
      {  21,74507,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x30\xc0\x80\x01\x07\x0c\x3c\x6c\xce\x06\x07\x06" }  },
      /* --- pixel bitmap for cmmib118 char#22 \mu --- */
      {  22,75527,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x19\x33\x66\xcc\xd8\xb9\x6f\x03\x06\x04\x00" }  },
      /* --- pixel bitmap for cmmib118 char#23 \nu --- */
      {  23,76272,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8f\xc6\xc6\x66\x36\x1b\x07" }  },
      /* --- pixel bitmap for cmmib118 char#24 \xi --- */
      {  24,77380,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\xf0\xf8\x0c\x0c\x7c\x7c\x06\x06\x07\x1e\x7c\x70"
            "\x38" }  },
      /* --- pixel bitmap for cmmib118 char#25 \pi --- */
      {  25,78290,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xfb\x9f\x04\x1a\x6c\x90\x63\x04" }  },
      /* --- pixel bitmap for cmmib118 char#26 \rho --- */
      {  26,79088,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x30\x33\x66\xcc\xc8\x98\x1f\x03\x06\x04\x00" }  },
      /* --- pixel bitmap for cmmib118 char#27 \sigma --- */
      {  27,79970,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xfb\x3f\xc6\x18\x63\xcc\xe0\x01" }  },
      /* --- pixel bitmap for cmmib118 char#28 \tau --- */
      {  28,80729,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xfd\x67\xc0\x80\x80\x01\x03" }  },
      /* --- pixel bitmap for cmmib118 char#29 \upsilon --- */
      {  29,81606,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\x34\x37\x64\xc8\x88\x09\x0e" }  },
      /* --- pixel bitmap for cmmib118 char#30 \phi --- */
      {  30,82486,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x40\x80\x00\x81\xc7\xf2\xe4\xc9\x93\x96\xf9\x40"
            "\x80\x80\x00" }  },
      /* --- pixel bitmap for cmmib118 char#31 \chi --- */
      {  31,83511,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x72\x84\x09\x1e\x30\xc0\x80\x07\x19\xe2\x04\x07" }  },
      /* --- pixel bitmap for cmmib118 char#32 \psi --- */
      {  32,84546,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x04\x20\x80\xe0\x24\x2d\x37\x91\x85\x2c\x62"
            "\x09\x3e\x20\x00\x01\x08\x00" }  },
      /* --- pixel bitmap for cmmib118 char#33 \omega --- */
      {  33,85621,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x09\x1c\x63\x8c\x11\xfd\xe7\x0e" }  },
      /* --- pixel bitmap for cmmib118 char#34 \varepsilon --- */
      {  34,86578,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\xff\x7d\xc1\xef\x01" }  },
      /* --- pixel bitmap for cmmib118 char#35 \vartheta --- */
      {  35,87553,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x40\x04\x31\xc4\x6e\x37\xd6\x18\x63\xcc\x30\xc1"
            "\x03" }  },
      /* --- pixel bitmap for cmmib118 char#36 \varpi --- */
      {  36,88734,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x7f\xff\x7f\x21\x84\x10\x42\x8c\xe0\x7d\x60\x1c"
            "\x00" }  },
      /* --- pixel bitmap for cmmib118 char#37 \varrho --- */
      {  37,89593,                      /* character number, location */
          7, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xcc\xc6\xc6\x46\x67\x3d\x01\x3f\x3e" }  },
      /* --- pixel bitmap for cmmib118 char#38 \varsigma --- */
      {  38,90398,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x31\x0c\x87\xc7\xc3\x1c" }  },
      /* --- pixel bitmap for cmmib118 char#39 \varphi --- */
      {  39,91321,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\x89\x1f\x61\x80\x09\xf9\xc3\x07\x03\x0c\x10\x00" }  },
      /* --- pixel bitmap for cmmib118 char#40 \bfleftharpoonup --- */
      {  40,106721,                     /* character number, location */
          9, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 17,    5, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\xc0\x31\xe2\xee\x03" }  },
      /* --- pixel bitmap for cmmib118 char#41 \bfleftharpoondown --- */
      {  41,107745,                     /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,    5, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\x12\xe0\x31\xd0\xf1\x41\xc1" }  },
      /* --- pixel bitmap for cmmib118 char#42 \bfrightharpoonup --- */
      {  42,108767,                     /* character number, location */
          9, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 17,    5, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xc1\x40\xd1\xe0\x32\x1e\x03" }  },
      /* --- pixel bitmap for cmmib118 char#43 \bfrightharpoondown --- */
      {  43,109792,                     /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,    5, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\xe2\xe1\x30\xf1\xc1\x43" }  },
      /* --- pixel bitmap for cmmib118 char#44 ` --- */
      {  44,110209,                     /* character number, location */
          9, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x62" }  },
      /* --- pixel bitmap for cmmib118 char#45 ' --- */
      {  45,110627,                     /* character number, location */
          9, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x39" }  },
      /* --- pixel bitmap for cmmib118 char#46 \triangleright --- */
      {  46,111162,                     /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x43\x22\x16\x8c\x25\x0e\x01" }  },
      /* --- pixel bitmap for cmmib118 char#47 \triangleleft --- */
      {  47,111714,                     /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x38\xd2\x18\x34\x22\xe1\x40" }  },
      /* --- pixel bitmap for cmmib118 char#48 \0 --- */
      {  48,97456,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x15\x1f\x42\x32\x15\x12" }  },
      /* --- pixel bitmap for cmmib118 char#49 \1 --- */
      {  49,98207,                      /* character number, location */
          7, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\xc3\x30\x0c\xf3\x03" }  },
      /* --- pixel bitmap for cmmib118 char#50 \2 --- */
      {  50,99167,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\x31\x18\x84\xf5\xff\x01" }  },
      /* --- pixel bitmap for cmmib118 char#51 \3 --- */
      {  51,100180,                     /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\xf1\x18\xc4\x01\x81\xc7\x23\x0f" }  },
      /* --- pixel bitmap for cmmib118 char#52 \4 --- */
      {  52,101091,                     /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x30\x38\x34\x32\x33\xff\x30\x30\xfc" }  },
      /* --- pixel bitmap for cmmib118 char#53 \5 --- */
      {  53,102112,                     /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x8f\x43\xe0\x11\x83\xc7\x21\x0f" }  },
      /* --- pixel bitmap for cmmib118 char#54 \6 --- */
      {  54,102991,                     /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xb3\x78\xf0\x19\x8d\xc7\x63\x11\x07" }  },
      /* --- pixel bitmap for cmmib118 char#55 \7 --- */
      {  55,103880,                     /* character number, location */
          8, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xff\x7f\x21\x11\x18\x08\x0c\x0c\x0c\x0c" }  },
      /* --- pixel bitmap for cmmib118 char#56 \8 --- */
      {  56,104791,                     /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\xf1\xf8\xec\xe3\xc9\xc7\xe3\x11\x07" }  },
      /* --- pixel bitmap for cmmib118 char#57 \9 --- */
      {  57,105678,                     /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xd1\x78\x3c\xe6\x83\x47\x33\x0f" }  },
      /* --- pixel bitmap for cmmib118 char#58 . --- */
      {  58,112195,                     /* character number, location */
          3, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00" }  },
      /* --- pixel bitmap for cmmib118 char#59 , --- */
      {  59,112756,                     /* character number, location */
          3, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x29\x01" }  },
      /* --- pixel bitmap for cmmib118 char#60 < --- */
      {  60,113414,                     /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x72\x72\x72\x72\x81\xb2\xb2\xb2\xb2\xb2" }  },
      /* --- pixel bitmap for cmmib118 char#61 / --- */
      {  61,113938,                     /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x08\x04\x81\x40\x10\x08\x02\x81\x20\x10\x04"
            "\x02" }  },
      /* --- pixel bitmap for cmmib118 char#62 > --- */
      {  62,114619,                     /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xb2\xb2\xb2\xb2\xb1\x82\x72\x72\x72\x72\x92" }  },
      /* --- pixel bitmap for cmmib118 char#63 \star --- */
      {  63,115318,                     /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x20\x40\x98\xec\x0f\x07\x0a\x22\x82\x00" }  },
      /* --- pixel bitmap for cmmib118 char#64 \partial --- */
      {  64,92279,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x88\x19\x32\xcc\xdb\xd8\xb0\x61\x63\x46\x78\x00" }  },
      /* --- pixel bitmap for cmmib118 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x38\x80\x03\x34\x20\x03\x32\x10\x83\x3f\x08"
            "\x46\x60\x8f\x0f" }  },
      /* --- pixel bitmap for cmmib118 char#66 B --- */
      {  66, 2362,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x39\x10\xf2\x42\x52\x42\x42\x49\x10\xf2\x32\x62\x22"
            "\x62\x1a\x31" }  },
      /* --- pixel bitmap for cmmib118 char#67 C --- */
      {  67, 3311,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x12\x33\x52\x32\x81\x22\x91\x22\xbf\x12\xc2\x91"
            "\x31\x81\x51\x61\x76\x52" }  },
      /* --- pixel bitmap for cmmib118 char#68 D --- */
      {  68, 4429,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   11, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x39\x30\xf1\x42\x62\x10\xf1\x42\x72\xf2\x32\x72\x10"
            "\x32\x62\x42\x62\x3a\x52" }  },
      /* --- pixel bitmap for cmmib118 char#69 E --- */
      {  69, 5832,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x3f\x0c\x04\x03\xc1\x48\x30\x02\x7e\x80\x91\x60"
            "\x24\x18\x04\x83\xf1\x3f\x00" }  },
      /* --- pixel bitmap for cmmib118 char#70 F --- */
      {  70, 7045,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x1f\x06\xc3\x40\x18\x09\x23\xf0\x03\x46\xc0\x08"
            "\x18\x80\x01\xfc\x00" }  },
      /* --- pixel bitmap for cmmib118 char#71 G --- */
      {  71, 8212,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x37\x0e\xc6\x00\x19\x40\x06\xc0\xc0\x3f\xc0\x0c"
            "\x30\x02\x0c\x81\x81\x5f\x00" }  },
      /* --- pixel bitmap for cmmib118 char#72 H --- */
      {  72, 9417,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   11, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x36\xf3\x42\x72\x30\x3b\x40\xf2\x32\x72\x40\x22"
            "\x72\x56\x36\x32" }  },
      /* --- pixel bitmap for cmmib118 char#73 I --- */
      {  73,10124,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\xf3\x42\x30\xf3\x32\x40\x22\x56\x32" }  },
      /* --- pixel bitmap for cmmib118 char#74 J --- */
      {  74,10940,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\xf3\x72\x20\xf2\x62\x30\x11\x42\x32\x32\x55\x52" }  },
      /* --- pixel bitmap for cmmib118 char#75 K --- */
      {  75,12129,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   11, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x35\x42\x71\x72\x52\x82\x41\xa2\x21\xb2\x14\xa3"
            "\x32\x92\x42\x92\x52\x72\x62\x56\x35\x30" }  },
      /* --- pixel bitmap for cmmib118 char#76 L --- */
      {  76,13058,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x81\x01\x0c\x60\x00\x03\x0c\x60\x10\x83\x18\x62"
            "\xd8\x7f\x00" }  },
      /* --- pixel bitmap for cmmib118 char#77 M --- */
      {  77,14374,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 20,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x00\x0f\x0d\x38\xd0\x40\x03\x0d\x34\xd0\x20\x83"
            "\x18\x19\x88\x89\x81\x98\x18\x88\x85\x41\x30\x0c\x1f"
            "\xf1\x03" }  },
      /* --- pixel bitmap for cmmib118 char#78 N --- */
      {  78,15534,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xe0\xc3\x01\x01\x0d\x04\x64\x10\x10\x43\x20\x8c"
            "\x80\x60\x02\x02\x0b\x08\x38\x10\x60\xf0\x01\x01" }  },
      /* --- pixel bitmap for cmmib118 char#79 O --- */
      {  79,16417,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x83\x31\x30\x03\x6c\x80\x07\xd8\x00\x1b\x60"
            "\x03\xc6\x70\xf0\x03" }  },
      /* --- pixel bitmap for cmmib118 char#80 P --- */
      {  80,17508,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   11, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3a\x10\xf2\x42\x62\x42\x52\x49\x20\xf2\x32\x90\x22"
            "\xa6\x82" }  },
      /* --- pixel bitmap for cmmib118 char#81 Q --- */
      {  81,18527,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\xc3\x31\x30\x03\x6c\x80\x07\xd8\x00\x1b\x60"
            "\x73\xc6\x69\xf0\x13\x60\x02\x3c\x00\x03" }  },
      /* --- pixel bitmap for cmmib118 char#82 R --- */
      {  82,19828,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   11, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x39\x20\xf2\x42\x62\x42\x52\x48\x30\xf2\x32\x52\x20"
            "\x22\x61\x27\x43\x12" }  },
      /* --- pixel bitmap for cmmib118 char#83 S --- */
      {  83,20909,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc7\x10\x83\x18\xc0\x07\x7c\x00\x07\x30\x82\x19"
            "\x46\x1f\x00" }  },
      /* --- pixel bitmap for cmmib118 char#84 T --- */
      {  84,21935,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1d\x32\x31\x1f\x11\x42\x31\x10\x52\x50\xf3\x42\x60"
            "\x32\x87\x45" }  },
      /* --- pixel bitmap for cmmib118 char#85 U --- */
      {  85,22945,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x44\xf3\x12\x71\x2f\x22\x71\x32\x61\x42\x51\x75"
            "\x62" }  },
      /* --- pixel bitmap for cmmib118 char#86 V --- */
      {  86,23879,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x9e\x81\x30\x08\x06\xc1\x10\x38\x01\x26\xc0\x02"
            "\x38\x00\x07\x60\x00" }  },
      /* --- pixel bitmap for cmmib118 char#87 W --- */
      {  87,25265,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\xcf\x1b\x0c\xc2\x30\x08\xa3\x11\x8c\x26\x30\x99"
            "\xc0\x62\x01\x8b\x05\x1c\x0e\x70\x18\xc0\x60\x00" }  },
      /* --- pixel bitmap for cmmib118 char#88 X --- */
      {  88,26378,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x3e\x1c\x03\x66\x80\x0f\xc0\x01\x70\x00\x1e\xc0"
            "\x0e\x18\x03\xc3\xf1\xf8\x00" }  },
      /* --- pixel bitmap for cmmib118 char#89 Y --- */
      {  89,27464,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x9e\x81\x70\x08\x8c\x80\x09\xe0\x00\x0c\x80\x01"
            "\x30\x00\x03\xf8\x01" }  },
      /* --- pixel bitmap for cmmib118 char#90 Z --- */
      {  90,28567,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xcf\x60\x04\x43\x18\xc0\x00\x06\x30\x82\x21\x0c"
            "\x63\x18\xff\x01" }  },
      /* --- pixel bitmap for cmmib118 char#91 \flat --- */
      {  91,116003,                     /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x84\x10\x5e\xce\xb9\x9d\x00" }  },
      /* --- pixel bitmap for cmmib118 char#92 \natural --- */
      {  92,116742,                     /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x84\xfc\xff\x8c\x31\xe6\xff\x27\x04" }  },
      /* --- pixel bitmap for cmmib118 char#93 \sharp --- */
      {  93,117585,                     /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x69\xff\x96\x52\x4a\xfb\xb7\x04" }  },
      /* --- pixel bitmap for cmmib118 char#94 \smile --- */
      {  94,118479,                     /* character number, location */
          7, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 17,    5, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x11\x11\xd1\x32\x92\x5b\x87\x52" }  },
      /* --- pixel bitmap for cmmib118 char#95 \frown --- */
      {  95,119345,                     /* character number, location */
          8, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 17,    6, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\xc9\x7b\x51\xb1\x31\xd1\x11\xe0\x11" }  },
      /* --- pixel bitmap for cmmib118 char#96 \ell --- */
      {  96,93031,                      /* character number, location */
         11,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\xc0\xc1\x82\x05\x07\x07\x06\x0c\x1c\x36\xc2\x03" }  },
      /* --- pixel bitmap for cmmib118 char#97 a --- */
      {  97,29491,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\xf3\x78\x3c\x9e\xbb\x01" }  },
      /* --- pixel bitmap for cmmib118 char#98 b --- */
      {  98,30335,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x83\xc1\xe0\x3b\x8f\xc7\xa3\x99\x07" }  },
      /* --- pixel bitmap for cmmib118 char#99 c --- */
      {  99,31124,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x3d\x0e\xc3\xe8\x01" }  },
      /* --- pixel bitmap for cmmib118 char#100 d --- */
      { 100,32080,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x81\x01\x03\xc6\xcd\xcc\x98\x31\x63\xe6\xb8\x01" }  },
      /* --- pixel bitmap for cmmib118 char#101 e --- */
      { 101,32899,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x39\x3f\xc3\xe8\x01" }  },
      /* --- pixel bitmap for cmmib118 char#102 f --- */
      { 102,34007,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\xc1\x82\x01\xc3\x1f\x06\x0c\x18\x30\x60\x60\xc0"
            "\xa0\xc1\x01" }  },
      /* --- pixel bitmap for cmmib118 char#103 g --- */
      { 103,34974,                      /* character number, location */
          7,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x31\x33\x66\xcc\x98\x19\x3e\x60\xc2\x7c\x00" }  },
      /* --- pixel bitmap for cmmib118 char#104 h --- */
      { 104,35909,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x0c\x0c\x0c\x7c\xce\xc6\xc6\x66\xe3\xc3" }  },
      /* --- pixel bitmap for cmmib118 char#105 i --- */
      { 105,36739,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x01\x00\x5c\x6b\xc6\x38\x07" }  },
      /* --- pixel bitmap for cmmib118 char#106 j --- */
      { 106,37672,                      /* character number, location */
         12, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\xc0\x00\x00\x00\x70\x68\x64\x60\x60\x30\x30\x30"
            "\x1a\x0e" }  },
      /* --- pixel bitmap for cmmib118 char#107 k --- */
      { 107,38699,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x0c\x0c\x0c\xec\x96\xce\x1e\x36\x5b\x73" }  },
      /* --- pixel bitmap for cmmib118 char#108 l --- */
      { 108,39407,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x31\xc6\x8c\x31\xe6\x18" }  },
      /* --- pixel bitmap for cmmib118 char#109 m --- */
      { 109,40602,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\x9c\xce\x59\x63\x8c\x31\xc6\x98\x31\xc6\x1a\xc3"
            "\x00" }  },
      /* --- pixel bitmap for cmmib118 char#110 n --- */
      { 110,41625,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\x3a\x37\x66\xcc\xcc\xb8\x61" }  },
      /* --- pixel bitmap for cmmib118 char#111 o --- */
      { 111,42357,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xf3\x78\x3c\x9a\x79\x00" }  },
      /* --- pixel bitmap for cmmib118 char#112 p --- */
      { 112,43319,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdc\xe9\xac\x31\xc6\x18\x31\xc6\x0f\x03\x0c\x7c\x00" }  },
      /* --- pixel bitmap for cmmib118 char#113 q --- */
      { 113,44228,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdc\x66\x63\x63\x63\x33\x3e\x30\x30\x7c" }  },
      /* --- pixel bitmap for cmmib118 char#114 r --- */
      { 114,45061,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\x6e\x9b\xc1\x30\x18\x00" }  },
      /* --- pixel bitmap for cmmib118 char#115 s --- */
      { 115,46017,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x64\x1c\x78\xc2\x43\x3e" }  },
      /* --- pixel bitmap for cmmib118 char#116 t --- */
      { 116,46753,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xc3\xfc\x86\x61\x18\x93\x03" }  },
      /* --- pixel bitmap for cmmib118 char#117 u --- */
      { 117,47743,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\xb4\x35\x63\xc6\x8c\x2d\x76" }  },
      /* --- pixel bitmap for cmmib118 char#118 v --- */
      { 118,48604,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\xda\x8d\x8c\x4c\x4c\x38" }  },
      /* --- pixel bitmap for cmmib118 char#119 w --- */
      { 119,49756,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\xa8\x8d\xcd\xc8\x8c\xcc\xc8\x4c\xb8\x03" }  },
      /* --- pixel bitmap for cmmib118 char#120 x --- */
      { 120,50968,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd8\xd1\x28\x33\x0c\x32\x6c\xe4\x0f" }  },
      /* --- pixel bitmap for cmmib118 char#121 y --- */
      { 121,52016,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\xda\xcd\xcc\xcc\x6c\x78\x60\x36\x1e" }  },
      /* --- pixel bitmap for cmmib118 char#122 z --- */
      { 122,52902,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x7e\x20\x18\x84\x7e\x39" }  },
      /* --- pixel bitmap for cmmib118 char#123 \imath --- */
      { 123,93745,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xde\x6d\xe6\x0e" }  },
      /* --- pixel bitmap for cmmib118 char#124 \jmath --- */
      { 124,94508,                      /* character number, location */
          7,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xd0\xc8\xc0\xc0\x60\x60\x60\x32\x1e" }  },
      /* --- pixel bitmap for cmmib118 char#125 \wp --- */
      { 125,95645,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x20\x9f\x87\x0d\x2c\x60\x8b\xbd\xa7\x01\x0d\x30"
            "\x00" }  },
      /* --- pixel bitmap for cmmib118 char#126 \bfvec --- */
      { 126,96247,                      /* character number, location */
         11, 3,    8, 3,      /* topleft row,col, and botleft row,col */
          {  7,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x3f\x08" }  },
      /* --- pixel bitmap for cmmib118 char#127 (noname) --- */
      { 127,96783,                      /* character number, location */
         11, 4,    8, 4,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x82\x81" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=3 for .131gf ---
 * mf '\mode=preview; mag=magstep(-16.39322518098640003469); input cmmib10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmib131 --- */
static	chardef  cmmib131[] =
   {
      /* --- pixel bitmap for cmmib131 char#0 \Gamma --- */
      {   0,53849,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x53\x42\xf2\x43\x61\x43\x70\xf3\x33\x80\x23\x98"
            "\x62" }  },
      /* --- pixel bitmap for cmmib131 char#1 \Delta --- */
      {   1,54748,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   12, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\xd3\xb4\xa1\x13\x91\x24\x71\x34\x62\x43\x61\x54"
            "\x41\x64\x3c\x2e\x0e\x01" }  },
      /* --- pixel bitmap for cmmib131 char#2 \Theta --- */
      {   2,55905,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\x38\x1c\x06\x8c\x49\xee\x3c\x77\x9e\x9f\xe7"
            "\xce\x73\x27\x19\x03\x8e\xc3\x01\x3f\x00" }  },
      /* --- pixel bitmap for cmmib131 char#3 \Lambda --- */
      {   3,56853,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x60\x00\x0e\xc0\x03\x7c\x40\x0e\xc8\x81\x38"
            "\x08\x07\xe1\x11\xbc\xef\x0f" }  },
      /* --- pixel bitmap for cmmib131 char#4 \Xi --- */
      {   4,58264,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   12, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x3c\xf1\x21\xa1\x10\xe0\x58\x68\xe0\x50\xf1\x11"
            "\xa1\x2f\x1c\x31" }  },
      /* --- pixel bitmap for cmmib131 char#5 \Pi --- */
      {   5,59491,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   12, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x02\x53\x63\x20\xf3\x43\x63\x30\xf3\x33\x63\x40"
            "\x23\x63\x57\x27\x34" }  },
      /* --- pixel bitmap for cmmib131 char#6 \Sigma --- */
      {   6,60632,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   12, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x34\x62\x44\x61\x53\x61\x54\x51\x63\xc3\x41\x72"
            "\x51\x61\x61\x52\x62\x3c\x2c\x32" }  },
      /* --- pixel bitmap for cmmib131 char#7 \Upsilon --- */
      {   7,61684,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x44\x16\x26\x33\x13\x21\x52\x12\x40\xf1\x63\x50"
            "\xf3\x53\x60\x43\x98\x4c" }  },
      /* --- pixel bitmap for cmmib131 char#8 \Phi --- */
      {   8,62698,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x93\xa3\x98\x42\x23\x13\x23\x23\x26\x23\x23\x23"
            "\x13\x22\x48\x93\xa3\x98\x4c" }  },
      /* --- pixel bitmap for cmmib131 char#9 \Psi --- */
      {   9,63789,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x93\x44\x23\x23\xf2\x13\x23\x13\x10\x13\x13\x13"
            "\x42\x16\x67\x93\xa3\x98\x4c" }  },
      /* --- pixel bitmap for cmmib131 char#10 \Omega --- */
      {  10,64962,                      /* character number, location */
         12, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x0f\x0e\xc6\x81\x3b\xe0\x0e\xb8\x03\xe7\xc0\x34"
            "\x58\x09\xd2\xc3\xf3\xf8\x3c\x1e" }  },
      /* --- pixel bitmap for cmmib131 char#11 \alpha --- */
      {  11,65962,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x40\x88\x86\x35\x58\x83\x33\x18\xc3\xe3\x63" }  },
      /* --- pixel bitmap for cmmib131 char#12 \beta --- */
      {  12,66997,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 11,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x03\x21\x04\x21\x88\x60\xf4\xa1\x8f\xc0\x04\x26"
            "\x30\xc1\x0c\xa3\x0f\x01\x08\x20\x00\x01\x00" }  },
      /* --- pixel bitmap for cmmib131 char#13 \gamma --- */
      {  13,67928,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xe8\x47\xc3\x04\x48\x00\x03\x30\x00\x03\x10\x00"
            "\x01\x10\x80\x00\x08" }  },
      /* --- pixel bitmap for cmmib131 char#14 \delta --- */
      {  14,68871,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\xf8\x48\x08\x18\x18\x38\x74\x66\x63\x63\x23\x33"
            "\x1e" }  },
      /* --- pixel bitmap for cmmib131 char#15 \epsilon --- */
      {  15,69751,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x83\xe0\x37\x18\x08\x78" }  },
      /* --- pixel bitmap for cmmib131 char#16 \zeta --- */
      {  16,70677,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x20\xe0\xf0\x08\x04\x06\x03\x03\x03\x03\x07\x3e"
            "\x7c\x60\x60\x38" }  },
      /* --- pixel bitmap for cmmib131 char#17 \eta --- */
      {  17,71544,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\x35\x37\x66\xcc\x98\xb1\x31\x63\xc0\x80\x81\x01"
            "\x03" }  },
      /* --- pixel bitmap for cmmib131 char#18 \theta --- */
      {  18,72294,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x30\x31\x66\x6c\xd8\xb0\xff\x61\xc3\x86\x8d\x91"
            "\xc1\x01" }  },
      /* --- pixel bitmap for cmmib131 char#19 \iota --- */
      {  19,72901,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x63\x18\xc6\x38\x39" }  },
      /* --- pixel bitmap for cmmib131 char#20 \kappa --- */
      {  20,73801,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\xb1\x62\x81\x0f\x66\x18\x3b\xd4\x70" }  },
      /* --- pixel bitmap for cmmib131 char#21 \lambda --- */
      {  21,74624,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xc0\x00\x03\x1c\x60\x80\x01\x0c\x38\xf0\x61\xc6"
            "\xd8\xc1\x03\x03" }  },
      /* --- pixel bitmap for cmmib131 char#22 \mu --- */
      {  22,75622,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\xc3\x18\x63\x18\xc3\x18\xc6\x3a\xcb\x77\x06\x30"
            "\xc0\x00\x06\x00" }  },
      /* --- pixel bitmap for cmmib131 char#23 \nu --- */
      {  23,76377,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x33\x6c\x98\x61\xc6\x98\xb1\xc1\x01" }  },
      /* --- pixel bitmap for cmmib131 char#24 \xi --- */
      {  24,77515,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x08\x9e\x6f\x30\xf8\x78\x82\xc1\x60\xf0\xf0\xe1"
            "\xc1\x38" }  },
      /* --- pixel bitmap for cmmib131 char#25 \pi --- */
      {  25,78405,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xef\xff\x91\x00\x09\x98\x80\x18\x8c\x41\x18" }  },
      /* --- pixel bitmap for cmmib131 char#26 \rho --- */
      {  26,79207,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x41\x8c\x31\xc3\x0c\x33\xe6\x88\x1d\x06\x18\x30"
            "\xc0\x00" }  },
      /* --- pixel bitmap for cmmib131 char#27 \sigma --- */
      {  27,80097,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xe7\xbf\x31\x86\x31\x8c\x21\x8c\xc1\x03" }  },
      /* --- pixel bitmap for cmmib131 char#28 \tau --- */
      {  28,80834,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xfb\x1f\x01\x06\x18\x60\xc0\x00\x03" }  },
      /* --- pixel bitmap for cmmib131 char#29 \upsilon --- */
      {  29,81687,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x69\x9c\x11\x43\x0c\x31\xc2\x08\x1e" }  },
      /* --- pixel bitmap for cmmib131 char#30 \phi --- */
      {  30,82571,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 11,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x04\x20\x80\x00\x04\xfc\x30\xc9\xc4\x23\x1e"
            "\xf1\xc8\x24\xc3\x0f\x08\x40\x00\x01\x08\x00" }  },
      /* --- pixel bitmap for cmmib131 char#31 \chi --- */
      {  31,83580,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xa8\x41\x38\x02\x13\xf0\x00\x06\x60\x00\x0f\xc8"
            "\x40\x1c\x82\x15\x70" }  },
      /* --- pixel bitmap for cmmib131 char#32 \psi --- */
      {  32,84627,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x20\x00\x04\x80\x00\x10\x18\x91\x26\xce\x44"
            "\x8c\x88\x09\x31\x11\x26\x01\x1f\x40\x00\x08\x00\x01"
            "\x20\x00" }  },
      /* --- pixel bitmap for cmmib131 char#33 \omega --- */
      {  33,85712,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x24\xc0\x43\x14\x46\x61\x34\x27\xff\xe3\x1c" }  },
      /* --- pixel bitmap for cmmib131 char#34 \varepsilon --- */
      {  34,86675,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\xfe\x41\x1e\x0d\x01\x3f\x1e" }  },
      /* --- pixel bitmap for cmmib131 char#35 \vartheta --- */
      {  35,87656,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x81\x0c\x32\xc8\x20\x3b\xad\x79\x63\x8c\x31\xc6"
            "\x0c\x13\x38\x00" }  },
      /* --- pixel bitmap for cmmib131 char#36 \varpi --- */
      {  36,88845,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xff\xfd\xff\x27\x00\x21\x08\x42\x10\x84\x78\x04"
            "\x9f\x0f\x1c\x07" }  },
      /* --- pixel bitmap for cmmib131 char#37 \varrho --- */
      {  37,89708,                      /* character number, location */
          8, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x10\x33\x36\x6c\xd8\xd8\x91\x1e\x01\x02\xfc\xf1"
            "\x03" }  },
      /* --- pixel bitmap for cmmib131 char#38 \varsigma --- */
      {  38,90545,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x0c\x02\x03\x03\x0e\x3c\x70\x20\x18" }  },
      /* --- pixel bitmap for cmmib131 char#39 \varphi --- */
      {  39,91470,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x13\x7e\x18\x43\x18\xc1\x89\xf9\x87\x1f\x18\x40"
            "\x00\x03\x18\x00" }  },
      /* --- pixel bitmap for cmmib131 char#40 \bfleftharpoonup --- */
      {  40,106960,                     /* character number, location */
         10, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 19,    6, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x42\xd0\x32\xe0\x22\xe0\x2e\x0e\x09" }  },
      /* --- pixel bitmap for cmmib131 char#41 \bfleftharpoondown --- */
      {  41,107986,                     /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,    6, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x05\x1e\x04\x22\xe0\x42\xe0\xf1\x42\xd3" }  },
      /* --- pixel bitmap for cmmib131 char#42 \bfrightharpoonup --- */
      {  42,109010,                     /* character number, location */
         10, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 19,    6, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xd2\x40\xe2\xe0\x42\x2f\x1e\x05" }  },
      /* --- pixel bitmap for cmmib131 char#43 \bfrightharpoondown --- */
      {  43,110037,                     /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,    6, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x05\xe0\x12\xe0\x22\x30\xf1\xd2\x43" }  },
      /* --- pixel bitmap for cmmib131 char#44 ` --- */
      {  44,110456,                     /* character number, location */
         12, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x33\x33\xef" }  },
      /* --- pixel bitmap for cmmib131 char#45 ' --- */
      {  45,110880,                     /* character number, location */
         12, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\xcc\xcc\x7f" }  },
      /* --- pixel bitmap for cmmib131 char#46 \triangleright --- */
      {  46,111421,                     /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x07\x1f\x3b\xf3\xf3\x3b\x1f\x07\x03" }  },
      /* --- pixel bitmap for cmmib131 char#47 \triangleleft --- */
      {  47,111973,                     /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\xf0\xf8\xde\xc7\xc7\xde\xf8\xf0\xc0" }  },
      /* --- pixel bitmap for cmmib131 char#48 \0 --- */
      {  48,97647,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x42\xc3\xc3\xc3\xc3\x42\x3c" }  },
      /* --- pixel bitmap for cmmib131 char#49 \1 --- */
      {  49,98402,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\x44\x30\xf4\x32\x30\x17" }  },
      /* --- pixel bitmap for cmmib131 char#50 \2 --- */
      {  50,99364,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\xe3\xc0\xc0\xb0\xf8\x7e\x7f" }  },
      /* --- pixel bitmap for cmmib131 char#51 \3 --- */
      {  51,100379,                     /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\xe3\xe3\xe2\x60\x3c\x60\xe0\xe7\xe7\x63\x3c" }  },
      /* --- pixel bitmap for cmmib131 char#52 \4 --- */
      {  52,101298,                     /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x70\x70\x68\x64\x66\x63\xff\x60\x60\x60\xf8" }  },
      /* --- pixel bitmap for cmmib131 char#53 \5 --- */
      {  53,102325,                     /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x3e\x3e\x02\x02\x3e\x62\xe0\xe3\xe3\x63\x3c" }  },
      /* --- pixel bitmap for cmmib131 char#54 \6 --- */
      {  54,103210,                     /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xc4\xc6\x03\x3b\x47\xc3\xc3\xc3\xc2\x66\x3c" }  },
      /* --- pixel bitmap for cmmib131 char#55 \7 --- */
      {  55,104105,                     /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xfc\xfb\x0b\x12\x04\x04\x04\x0c\x08\x18\x30\x60"
            "\xc0\x00" }  },
      /* --- pixel bitmap for cmmib131 char#56 \8 --- */
      {  56,105020,                     /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\xc2\xc3\xc7\x7f\x7e\x7e\xe3\xc3\xc3\x42\x3c" }  },
      /* --- pixel bitmap for cmmib131 char#57 \9 --- */
      {  57,105909,                     /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x62\x43\xc3\xc3\xe2\xdc\xc0\xc0\x63\x23\x1e" }  },
      /* --- pixel bitmap for cmmib131 char#58 . --- */
      {  58,112454,                     /* character number, location */
          3, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00" }  },
      /* --- pixel bitmap for cmmib131 char#59 , --- */
      {  59,113015,                     /* character number, location */
          3, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x49\x05" }  },
      /* --- pixel bitmap for cmmib131 char#60 < --- */
      {  60,113675,                     /* character number, location */
         12, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 12,   14, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\x84\x73\x74\x64\x73\x7f\x14\x80\x23\xa4\xa4\xa3"
            "\xa4\xa2" }  },
      /* --- pixel bitmap for cmmib131 char#61 / --- */
      {  61,114205,                     /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  8,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\xc0\xe0\x60\x60\x70\x30\x30\x38\x18\x1c\x0c\x0c"
            "\x0e\x06\x06\x07\x03\x03" }  },
      /* --- pixel bitmap for cmmib131 char#62 > --- */
      {  62,114892,                     /* character number, location */
         12, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 12,   14, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xa4\xa3\xa4\xa4\xa3\x20\xf1\x84\x73\x74\x64\x73"
            "\x74\x82\xa1" }  },
      /* --- pixel bitmap for cmmib131 char#63 \star --- */
      {  63,115597,                     /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x80\x00\x02\x08\xfe\xe3\x03\x07\x36\x88\x10\x04" }  },
      /* --- pixel bitmap for cmmib131 char#64 \partial --- */
      {  64,92438,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x60\x18\x81\x08\x0c\x60\x7c\x33\xdc\x60\x03\x1b"
            "\xc8\x60\x84\xc1\x03" }  },
      /* --- pixel bitmap for cmmib131 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\xc0\x01\x70\x00\x1e\x40\x07\xd0\x03\xe2\x40"
            "\x38\xf0\x0f\x82\x43\xe0\x7c\xfe" }  },
      /* --- pixel bitmap for cmmib131 char#66 B --- */
      {  66, 2364,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x63\x43\x43\x62\xf1\x43\x53\x49\x53\x53\x10\xf1"
            "\x33\x63\x33\x62\x33\x63\x1c\x37" }  },
      /* --- pixel bitmap for cmmib131 char#67 C --- */
      {  67, 3317,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x12\x43\x53\x32\x81\x32\x91\x10\xf1\x13\xbf\x13"
            "\xc0\x12\x91\x32\x81\x52\x61\x86\x50" }  },
      /* --- pixel bitmap for cmmib131 char#68 D --- */
      {  68, 4437,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   12, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x83\x53\x53\x72\x10\xf2\x43\x73\xf1\x33\x73\x10"
            "\x33\x72\x53\x63\x43\x62\x4b\x66" }  },
      /* --- pixel bitmap for cmmib131 char#69 E --- */
      {  69, 5844,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x7f\x70\x30\x1c\x10\x8e\x08\x47\x84\x3f\xe0\x08"
            "\x70\x44\x38\x20\x1c\x08\x07\xe6\xff\x01" }  },
      /* --- pixel bitmap for cmmib131 char#70 F --- */
      {  70, 7061,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x3f\x38\x0c\x07\xc2\x91\x70\x24\xfc\x81\x23\xe0"
            "\x08\x38\x00\x0e\xc0\x01\xfc\x03" }  },
      /* --- pixel bitmap for cmmib131 char#71 G --- */
      {  71, 8232,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x6f\x38\x38\x06\x88\x01\xe4\x00\x70\x00\x1c\xfc"
            "\x0f\x38\x06\x1c\x03\x0e\x83\x03\x3e\x01" }  },
      /* --- pixel bitmap for cmmib131 char#72 H --- */
      {  72, 9465,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   12, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\x27\x53\x63\x20\xf2\x43\x63\x30\x4c\x30\xf3\x33"
            "\x63\x40\x23\x63\x57\x27\x32" }  },
      /* --- pixel bitmap for cmmib131 char#73 I --- */
      {  73,10176,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\x53\x20\xf3\x43\x30\xf3\x33\x40\x23\x57\x33" }  },
      /* --- pixel bitmap for cmmib131 char#74 J --- */
      {  74,10994,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\x93\x10\xf3\x83\x20\xf2\x73\x30\x13\x33\x33\x33"
            "\x56\x60" }  },
      /* --- pixel bitmap for cmmib131 char#75 K --- */
      {  75,12211,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   12, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\x35\x53\x62\x63\x61\x83\x41\xa3\x22\xb3\x13\xa8"
            "\x70\xf1\x33\x33\x60\x33\x43\x73\x54\x47\x26\x30" }  },
      /* --- pixel bitmap for cmmib131 char#76 L --- */
      {  76,13142,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\x83\x50\xf3\x43\x60\x33\x70\xf1\x33\x61\x33\x51"
            "\x33\x43\x1b\x23" }  },
      /* --- pixel bitmap for cmmib131 char#77 M --- */
      {  77,14460,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x7e\xf0\x80\x0e\x74\xc0\x03\x3a\xd0\x01\x39"
            "\xe4\x80\x1c\x71\x20\x8e\x1c\x10\x27\x0e\x08\x0f\x07"
            "\x84\x83\x03\xc1\xe1\xe0\x63\xfc\x01" }  },
      /* --- pixel bitmap for cmmib131 char#78 N --- */
      {  78,15622,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xc0\x07\x0f\x08\xf4\x20\x20\x0f\x01\x71\x08\x08"
            "\x47\x20\x78\x01\x81\x0f\x08\x78\x40\x80\x03\x01\x0c"
            "\x3e\x40\x00" }  },
      /* --- pixel bitmap for cmmib131 char#79 O --- */
      {  79,16481,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x73\x43\x42\x72\x32\x83\xf1\x13\x83\x0f\x13\x83"
            "\x13\x82\x32\x73\x33\x43\x76\x65" }  },
      /* --- pixel bitmap for cmmib131 char#80 P --- */
      {  80,17576,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x63\x43\xf2\x43\x53\x43\x43\x49\x30\xf2\x33\x90"
            "\x23\xa7\x82" }  },
      /* --- pixel bitmap for cmmib131 char#81 Q --- */
      {  81,18599,                      /* character number, location */
         12, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 15,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\x38\x1c\x06\x8c\x01\xee\x00\x77\x80\x1f\xe0"
            "\x0e\x70\x07\x18\x73\x8e\xe7\x01\x3f\x02\x10\x01\x78"
            "\x00\x3c\x00\x0e" }  },
      /* --- pixel bitmap for cmmib131 char#82 R --- */
      {  82,19904,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   12, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3b\x73\x43\x10\xf1\x43\x53\x10\x43\x43\x68\x40\xf3"
            "\x33\x43\x30\x23\x53\x28\x44\x16" }  },
      /* --- pixel bitmap for cmmib131 char#83 S --- */
      {  83,20963,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x57\x32\x52\x31\x61\x32\xa6\x77\x67\x84\xa2\x21\x71"
            "\x22\x61\x38\x43" }  },
      /* --- pixel bitmap for cmmib131 char#84 T --- */
      {  84,22015,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x11\x43\x22\x0f\x21\x43\x31\x10\x53\x50\xf3\x43"
            "\x60\x33\x79\x43" }  },
      /* --- pixel bitmap for cmmib131 char#85 U --- */
      {  85,23031,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   12, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x45\x23\x81\x20\xf3\x13\x81\x3f\x23\x81\x43\x71"
            "\x62\x61\x87\x73" }  },
      /* --- pixel bitmap for cmmib131 char#86 V --- */
      {  86,23943,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x78\x0e\x08\x0f\x02\x07\x81\x43\xc0\x11\xe0\x04"
            "\xf0\x02\xf0\x00\x38\x00\x1c\x00\x06\x00" }  },
      /* --- pixel bitmap for cmmib131 char#87 W --- */
      {  87,25316,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x7e\x9e\x83\x83\x70\xf8\x10\x0e\x1d\xc1\x91\x13"
            "\x78\x71\x02\x2e\x2e\xc0\xc3\x07\x78\x78\x00\x07\x07"
            "\x60\xe0\x00\x0c\x08\x00" }  },
      /* --- pixel bitmap for cmmib131 char#88 X --- */
      {  88,26455,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   12, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x25\x53\x41\x84\x21\xa3\x11\xb4\xd3\xd4\xb1\x13"
            "\xa1\x24\x81\x43\x71\x53\x45\x27\x23" }  },
      /* --- pixel bitmap for cmmib131 char#89 Y --- */
      {  89,27521,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x44\x24\x61\x53\x51\x64\x31\x83\x21\x96\xa4\x60"
            "\xf2\x53\x70\x43\xa7\x63" }  },
      /* --- pixel bitmap for cmmib131 char#90 Z --- */
      {  90,28600,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x3f\x06\xc7\xe0\x10\x1c\x84\x03\x70\x00\x0e\xc0"
            "\x21\x38\x08\x07\xe3\x60\xfc\x1f" }  },
      /* --- pixel bitmap for cmmib131 char#91 \flat --- */
      {  91,116280,                     /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x10\x04\x41\xf0\xc5\x71\x9c\x35\x47\x00" }  },
      /* --- pixel bitmap for cmmib131 char#92 \natural --- */
      {  92,117025,                     /* character number, location */
         14, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x10\x04\x71\xff\x8e\x61\x18\x86\x71\xff\x8e\x20"
            "\x08" }  },
      /* --- pixel bitmap for cmmib131 char#93 \sharp --- */
      {  93,117884,                     /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x90\x24\xc9\xfe\x37\x49\x92\x24\xc9\xfe\x37\x49\x02" }  },
      /* --- pixel bitmap for cmmib131 char#94 \smile --- */
      {  94,118790,                     /* character number, location */
          8, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 19,    5, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x31\x11\xe0\x11\x33\x93\x6b\xa7\x61" }  },
      /* --- pixel bitmap for cmmib131 char#95 \frown --- */
      {  95,119656,                     /* character number, location */
          9, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 19,    6, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\xe9\x8d\x52\xb2\x31\xe0\x11\x11\xe0\x31" }  },
      /* --- pixel bitmap for cmmib131 char#96 \ell --- */
      {  96,93222,                      /* character number, location */
         13,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x80\x82\x05\x05\x0b\x0e\x0c\x0c\x18\x38\x68\x80"
            "\x08\x0f" }  },
      /* --- pixel bitmap for cmmib131 char#97 a --- */
      {  97,29528,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xcc\x89\x19\x33\x66\xec\x2c\x77" }  },
      /* --- pixel bitmap for cmmib131 char#98 b --- */
      {  98,30378,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x06\xc3\x60\xf0\x99\xc7\xe3\xf1\x68\xe6\x00" }  },
      /* --- pixel bitmap for cmmib131 char#99 c --- */
      {  99,31199,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xc4\x46\x03\x03\x03\x43\x3e" }  },
      /* --- pixel bitmap for cmmib131 char#100 d --- */
      { 100,32157,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x01\x03\x06\x06\x0c\x9f\x39\x31\x63\xc6\x8c\x9d"
            "\xe5\x0e" }  },
      /* --- pixel bitmap for cmmib131 char#101 e --- */
      { 101,32984,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xa3\xf0\x37\x18\x0c\x7d" }  },
      /* --- pixel bitmap for cmmib131 char#102 f --- */
      { 102,34120,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x01\x0d\x16\x18\x60\xf0\x07\x03\x0c\x30\xc0\x00"
            "\x03\x0c\x18\x60\xa0\xc1\x02\x06\x00" }  },
      /* --- pixel bitmap for cmmib131 char#103 g --- */
      { 103,35097,                      /* character number, location */
          8,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x63\x8e\x18\x63\x8c\x31\xc6\x0c\x3e\xc0\x00\x23"
            "\x86\x0f" }  },
      /* --- pixel bitmap for cmmib131 char#104 h --- */
      { 104,36010,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x60\x80\x01\x03\x0c\xf0\xc3\x8c\x31\xc6\x18\x63"
            "\xe6\x58\xc3\x00" }  },
      /* --- pixel bitmap for cmmib131 char#105 i --- */
      { 105,36798,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x04\x00\x00\xc0\x68\x19\xc3\x98\x16\x03" }  },
      /* --- pixel bitmap for cmmib131 char#106 j --- */
      { 106,37711,                      /* character number, location */
         14,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          {  9,   18, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\xf3\x90\x53\x51\x22\x31\x22\x10\xf2\x62\x10"
            "\xf3\x52\x20\x11\x22\x44\x42" }  },
      /* --- pixel bitmap for cmmib131 char#107 k --- */
      { 107,38716,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x30\x60\x60\xc0\x80\x19\x6b\x4b\x1e\x6c\x98\x1d"
            "\x35\x0e" }  },
      /* --- pixel bitmap for cmmib131 char#108 l --- */
      { 108,39408,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x63\xc6\x18\x33\xc6\xd8\xe5\x00" }  },
      /* --- pixel bitmap for cmmib131 char#109 m --- */
      { 109,40611,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\x79\x74\xce\x74\x8c\x61\x18\xc3\x30\x86\x61\xa6"
            "\x61\x2c\xc3\x30" }  },
      /* --- pixel bitmap for cmmib131 char#110 n --- */
      { 110,41590,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\xa1\x33\x1d\xc3\x30\x0c\xc3\x98\x86\x65\x30" }  },
      /* --- pixel bitmap for cmmib131 char#111 o --- */
      { 111,42330,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xc4\xc6\xc3\xc3\x63\x23\x1e" }  },
      /* --- pixel bitmap for cmmib131 char#112 p --- */
      { 112,43270,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdc\xd1\xac\x31\xc6\x18\x63\xc4\x19\x1f\x0c\x30\x60"
            "\xc0\x03" }  },
      /* --- pixel bitmap for cmmib131 char#113 q --- */
      { 113,44185,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb8\xe6\x62\x63\x63\x63\x33\x3e\x30\x30\x18\x3c" }  },
      /* --- pixel bitmap for cmmib131 char#114 r --- */
      { 114,45050,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xda\x4d\x0c\x0c\x0c\x06\x06" }  },
      /* --- pixel bitmap for cmmib131 char#115 s --- */
      { 115,45982,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xc4\x46\x3c\x78\x42\x23\x1e" }  },
      /* --- pixel bitmap for cmmib131 char#116 t --- */
      { 116,46748,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\xc6\x30\x3f\x63\x18\x86\x39\x39" }  },
      /* --- pixel bitmap for cmmib131 char#117 u --- */
      { 117,47744,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xd3\x58\x66\x18\xc3\x18\xc6\x32\x0b\x77" }  },
      /* --- pixel bitmap for cmmib131 char#118 v --- */
      { 118,48611,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x34\x67\x62\xc4\x88\x09\x13\x1c" }  },
      /* --- pixel bitmap for cmmib131 char#119 w --- */
      { 119,49767,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x93\xc6\x9c\x19\x31\x46\x8c\x11\x63\xc4\x9c\xe0"
            "\x1c" }  },
      /* --- pixel bitmap for cmmib131 char#120 x --- */
      { 120,50985,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x47\xce\x62\x04\x06\x60\x20\x46\x73\xe2\x1c" }  },
      /* --- pixel bitmap for cmmib131 char#121 y --- */
      { 121,52039,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x6b\x9c\x19\x63\x8c\x31\xc6\x0c\x3e\xc0\x88\x31"
            "\x82\x07" }  },
      /* --- pixel bitmap for cmmib131 char#122 z --- */
      { 122,52959,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\x7c\x20\x10\x08\x84\x7e\x39" }  },
      /* --- pixel bitmap for cmmib131 char#123 \imath --- */
      { 123,93918,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x96\x31\x8c\x69\x31" }  },
      /* --- pixel bitmap for cmmib131 char#124 \jmath --- */
      { 124,94713,                      /* character number, location */
          8,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x20\x23\x03\x06\x0c\x18\x18\x30\x60\xc0\xc8\xf0"
            "\x00" }  },
      /* --- pixel bitmap for cmmib131 char#125 \wp --- */
      { 125,95828,                      /* character number, location */
          8, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x30\xde\x8c\x17\x7c\xe0\x01\x4d\xec\x1c\x0d\x68"
            "\xc0\x01\x06\x00" }  },
      /* --- pixel bitmap for cmmib131 char#126 \bfvec --- */
      { 126,96440,                      /* character number, location */
         13, 4,    9, 4,      /* topleft row,col, and botleft row,col */
          {  8,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\xff\xff\x38" }  },
      /* --- pixel bitmap for cmmib131 char#127 (noname) --- */
      { 127,96978,                      /* character number, location */
         12, 6,   10, 6,      /* topleft row,col, and botleft row,col */
          {  8,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x81" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=4 for .160gf ---
 * mf '\mode=preview; mag=magstep(-15.29639112828755784636); input cmmib10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmib160 --- */
static	chardef  cmmib160[] =
   {
      /* --- pixel bitmap for cmmib160 char#0 \Gamma --- */
      {   0,54473,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3d\xf1\x53\x62\xf1\x53\x71\xf3\x43\x90\xf3\x33\xa0"
            "\x23\xb8\x86" }  },
      /* --- pixel bitmap for cmmib160 char#1 \Delta --- */
      {   1,55378,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   15, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\xe0\x23\xe0\x24\xe1\x13\xd1\x23\xc1\x34\xa1\x53"
            "\x92\x53\x91\x64\x71\x83\x61\x93\x51\xa4\x3e\x02\x2e"
            "\x03\x1e\x05" }  },
      /* --- pixel bitmap for cmmib160 char#2 \Theta --- */
      {   2,56521,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x93\x53\x53\x83\x33\xa3\x13\xb3\x13\x11\x61\x23"
            "\x0f\x23\x28\x23\x03\x11\x61\x23\x13\xb3\x13\xa3\x32"
            "\x93\x53\x53\x88\x72" }  },
      /* --- pixel bitmap for cmmib160 char#3 \Lambda --- */
      {   3,57479,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\x40\xf1\xa3\x30\x94\x30\xf1\x81\x13\x30\x71\x23"
            "\x91\x33\x91\x34\x71\x44\x62\x53\x61\x63\x51\x73\x42"
            "\x73\x25\x47" }  },
      /* --- pixel bitmap for cmmib160 char#4 \Xi --- */
      {   4,58904,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   15, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x01\x3e\x01\x10\xf1\x31\xd1\x10\xe0\xa1\x71\x50"
            "\xf1\x59\x50\x51\x71\x50\xf1\xe0\x50\xf1\x11\xd1\x3f"
            "\x1e\x01\x47" }  },
      /* --- pixel bitmap for cmmib160 char#5 \Pi --- */
      {   5,60139,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   15, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x05\xf3\x53\x83\x30\xf3\x43\x83\x40\xf3\x33\x83"
            "\x50\x23\x83\x68\x38\x30" }  },
      /* --- pixel bitmap for cmmib160 char#6 \Sigma --- */
      {   6,61318,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   15, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x01\x44\x83\x53\x92\x54\x91\x63\x91\x64\xe0\x23"
            "\xe0\x24\xe0\x22\xe0\x21\x81\x81\x91\x62\x91\x61\x93"
            "\x4e\x01\x3e\x01\x42" }  },
      /* --- pixel bitmap for cmmib160 char#7 \Upsilon --- */
      {   7,62376,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\x64\x27\x38\x43\x32\x41\x63\x12\x60\xf1\x74\x70"
            "\xf2\x73\x80\xf3\x63\x90\x53\xc9\x71" }  },
      /* --- pixel bitmap for cmmib160 char#8 \Phi --- */
      {   8,63396,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x7f\x00\x07\x00\x07\xe0\x1f\x1c\x77\x8e\xe3\x87"
            "\xe3\x87\xe3\x87\x63\xc7\x71\xce\x1d\xf8\x07\xc0\x01"
            "\xe0\x00\xfc\x07" }  },
      /* --- pixel bitmap for cmmib160 char#9 \Psi --- */
      {   9,64505,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x69\x30\xf1\x83\x73\x53\x34\x13\x43\x23\x20\xf2\x13"
            "\x33\x23\x30\x13\x33\x13\x62\x23\x22\x73\x16\xa7\xd3"
            "\xe3\xc9\x79" }  },
      /* --- pixel bitmap for cmmib160 char#10 \Omega --- */
      {  10,65718,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 18,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x3f\xc0\x83\x83\x03\x1c\x07\xe0\x1c\x80\x3b\x00"
            "\xe7\x00\x1c\x03\x38\x1c\x60\x60\xc0\x90\x81\x49\x04"
            "\x22\x1f\x7c\x7c\xf8\xf1\xe1\x03" }  },
      /* --- pixel bitmap for cmmib160 char#11 \alpha --- */
      {  11,66730,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x0c\x21\x81\xd1\x80\x35\xc0\x1a\xe0\x0c\x30"
            "\x06\x18\x06\x0f\x7e\x1c" }  },
      /* --- pixel bitmap for cmmib160 char#12 \beta --- */
      {  12,67801,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x07\x08\x81\x60\x08\x0c\x81\x90\x1f\xf2\x41\x60"
            "\x08\x8c\x80\x11\x30\x02\x46\x60\x14\x86\x3c\x10\x00"
            "\x02\x20\x00\x04\x00" }  },
      /* --- pixel bitmap for cmmib160 char#13 \gamma --- */
      {  13,68742,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xd0\x0f\x0e\xa3\xc0\x04\x50\x00\x0a\xc0\x00\x18"
            "\x00\x03\x20\x00\x04\x80\x00\x08\x00\x01" }  },
      /* --- pixel bitmap for cmmib160 char#14 \delta --- */
      {  14,69695,                      /* character number, location */
         16, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\xc0\x0f\x11\x04\x30\x80\x01\x0f\x76\x84\x19\x36"
            "\xd8\x60\x83\x0d\x62\x04\x0f" }  },
      /* --- pixel bitmap for cmmib160 char#15 \epsilon --- */
      {  15,70557,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x0c\x06\x06\x7f\x03\x03\x03\x86\x7c" }  },
      /* --- pixel bitmap for cmmib160 char#16 \zeta --- */
      {  16,71463,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 11,   19, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x91\xb4\x56\x41\x91\x92\x70\xf1\x12\x8f\x22\x93"
            "\x93\x96\x75\x92\xa1\x73\x32" }  },
      /* --- pixel bitmap for cmmib160 char#17 \eta --- */
      {  17,72334,                      /* character number, location */
         10, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\x97\xc7\x19\x9c\xc1\x0c\xc6\x60\x0c\xc6\x60\x06"
            "\x63\x30\x00\x03\x30\x80\x01\x18" }  },
      /* --- pixel bitmap for cmmib160 char#18 \theta --- */
      {  18,73094,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x81\x11\x86\x11\xcc\x60\x02\x1b\xd8\xff\x06\x16"
            "\xd8\xc0\x04\x23\x08\x23\xf0\x00" }  },
      /* --- pixel bitmap for cmmib160 char#19 \iota --- */
      {  19,73735,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x06\x83\x61\x30\x18\x47\x33\x07" }  },
      /* --- pixel bitmap for cmmib160 char#20 \kappa --- */
      {  20,74641,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x8e\xa1\x31\x03\x16\xe0\x07\x8c\x83\xc1\x34\x98"
            "\x03\x6b\xc0\x00" }  },
      /* --- pixel bitmap for cmmib160 char#21 \lambda --- */
      {  21,75474,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x00\x0c\x80\x01\x60\x00\x0c\x80\x03\x60\x00\x1c"
            "\x80\x03\x6c\xc0\x18\x0c\xc3\xc0\x0c\x98\x00\x06" }  },
      /* --- pixel bitmap for cmmib160 char#22 \mu --- */
      {  22,76480,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 14,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x08\x06\x83\xc1\x60\x30\x0c\x06\x83\xc1\x60\x32"
            "\x9c\x8e\x97\x1f\x63\x00\x18\x00\x03\xc0\x00\x00" }  },
      /* --- pixel bitmap for cmmib160 char#23 \nu --- */
      {  23,77271,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xc8\xc0\x0c\xcc\x60\x06\x62\x30\x86\x61\x06\x3b"
            "\x70\x00" }  },
      /* --- pixel bitmap for cmmib160 char#24 \xi --- */
      {  24,78391,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   19, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x81\x95\x32\x14\x22\x60\xf1\x12\x70\xf1\x26\x20"
            "\x12\x7f\x22\x83\x85\x76\x73\x91\x54\x20" }  },
      /* --- pixel bitmap for cmmib160 char#25 \pi --- */
      {  25,79287,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xdf\xff\x47\x04\x88\x00\x19\x30\x03\x62\x60\x0c"
            "\x8c\x83\x20\x00" }  },
      /* --- pixel bitmap for cmmib160 char#26 \rho --- */
      {  26,80123,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\xc3\x10\x8c\x81\x0c\xcc\xc0\x0c\xcc\x60\x0e"
            "\x63\x1f\x06\x60\x00\x03\x30\x00" }  },
      /* --- pixel bitmap for cmmib160 char#27 \sigma --- */
      {  27,81021,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   10, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\x3a\x22\x42\x42\x52\x3f\x22\x62\x32\x52\x51\x42"
            "\x75\x62" }  },
      /* --- pixel bitmap for cmmib160 char#28 \tau --- */
      {  28,81766,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   10, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2a\x1c\x41\x60\xf1\x51\x60\xf2\x42\x60\xf1\x32\x72" }  },
      /* --- pixel bitmap for cmmib160 char#29 \upsilon --- */
      {  29,82649,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xac\xc1\x19\x9c\x81\x0c\xc4\x40\x0c\xc4\x20\x0c"
            "\x01\x0f" }  },
      /* --- pixel bitmap for cmmib160 char#30 \phi --- */
      {  30,83543,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 14,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x80\x00\x20\x00\x04\x00\x01\xf8\x83\x91\x31"
            "\xc2\x86\xf0\x20\x3c\x08\x0f\xc1\x42\x98\x91\x83\x3f"
            "\x80\x00\x20\x00\x08\x00\x02\x00" }  },
      /* --- pixel bitmap for cmmib160 char#31 \chi --- */
      {  31,84604,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 14,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x60\x06\x84\x83\xc0\x10\x70\x02\x58\x00\x0e\x00"
            "\x03\xe0\x01\x64\x80\x38\x10\x0c\x02\x57\x00\x07" }  },
      /* --- pixel bitmap for cmmib160 char#32 \psi --- */
      {  32,85661,                      /* character number, location */
         15, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 15,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x04\x00\x02\x80\x00\x40\x00\x20\x60\x10\x6b\x84"
            "\x33\xc2\x19\x41\x86\x10\x23\x88\x11\xc2\x88\xc0\x24"
            "\xc0\x0f\x80\x00\x40\x00\x20\x00\x08\x00" }  },
      /* --- pixel bitmap for cmmib160 char#33 \omega --- */
      {  33,86760,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x60\x02\xb0\x00\x58\x10\x1c\x0c\x0a\x06\x05\xc3"
            "\xc6\x33\xbe\x0f\x8e\x03" }  },
      /* --- pixel bitmap for cmmib160 char#34 \varepsilon --- */
      {  34,87735,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xf1\x6f\x90\x00\x7e\xe8\x11\x40\x40\xff\xf0\x01" }  },
      /* --- pixel bitmap for cmmib160 char#35 \vartheta --- */
      {  35,88696,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x07\x88\x81\x30\x10\x04\xc2\x9c\x58\xe6\xcb\xe0"
            "\x19\x8c\xc1\x30\x18\x06\xc1\x30\x18\x03\x1e\x00" }  },
      /* --- pixel bitmap for cmmib160 char#36 \varpi --- */
      {  36,89895,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 20,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xff\xef\xff\xff\x11\x00\x82\x00\x20\x08\x02\x42"
            "\x20\x20\x04\x07\x43\x58\x18\xfc\xfc\x80\x83\x07" }  },
      /* --- pixel bitmap for cmmib160 char#37 \varrho --- */
      {  37,90796,                      /* character number, location */
         10, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xc3\x30\x82\x19\x68\x60\x03\x1b\xd8\x60\x85\xc9"
            "\x47\x00\x02\xf0\x1f\xff\x00" }  },
      /* --- pixel bitmap for cmmib160 char#38 \varsigma --- */
      {  38,91617,                      /* character number, location */
         10, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x73\x68\x80\x01\x07\x18\xe0\x01\x1f\xf0\x00\x03"
            "\x0c\x1c" }  },
      /* --- pixel bitmap for cmmib160 char#39 \varphi --- */
      {  39,92548,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 14,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x1c\xc1\x2f\x18\x0a\x82\x41\x60\x10\x18\x02\x99"
            "\x70\xfc\x07\xfc\x00\x03\xc0\x00\x18\x00\x06\x00" }  },
      /* --- pixel bitmap for cmmib160 char#40 \bfleftharpoonup --- */
      {  40,108166,                     /* character number, location */
         12, 1,    5, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x52\xe0\x20\x42\xe0\x63\xe0\x53\xe0\x5e\x0e\x0e"
            "\x03" }  },
      /* --- pixel bitmap for cmmib160 char#41 \bfleftharpoondown --- */
      {  41,109194,                     /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x09\x1e\x08\x23\xe0\x73\xe0\x72\xe0\x30\xf1\x52"
            "\xe0\x22" }  },
      /* --- pixel bitmap for cmmib160 char#42 \bfrightharpoonup --- */
      {  42,110220,                     /* character number, location */
         12, 1,    5, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x22\x50\xe0\x32\xe0\x73\xe0\x73\x2f\x1e\x09" }  },
      /* --- pixel bitmap for cmmib160 char#43 \bfrightharpoondown --- */
      {  43,111249,                     /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x09\xe0\x43\xe0\x53\xe0\x62\x40\xf1\xe0\x22"
            "\x50" }  },
      /* --- pixel bitmap for cmmib160 char#44 ` --- */
      {  44,111670,                     /* character number, location */
         13, 1,    5, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd8\x9f\x31\x8e\xc7" }  },
      /* --- pixel bitmap for cmmib160 char#45 ' --- */
      {  45,112094,                     /* character number, location */
         13, 1,    5, 1,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe3\x71\x8c\xf9\x1b" }  },
      /* --- pixel bitmap for cmmib160 char#46 \triangleright --- */
      {  46,112635,                     /* character number, location */
         13, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 13,   14, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xb4\x96\x72\x23\x62\x34\x42\x54\x2f\x12\x74\x02"
            "\x54\x22\x34\x42\x23\x66\x74\x92\xb6" }  },
      /* --- pixel bitmap for cmmib160 char#47 \triangleleft --- */
      {  47,113203,                     /* character number, location */
         13, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 13,   14, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb2\x94\x76\x54\x22\x43\x42\x24\x52\x0f\x14\x72\x24"
            "\x52\x43\x42\x54\x22\x76\x94\xb2" }  },
      /* --- pixel bitmap for cmmib160 char#48 \0 --- */
      {  48,98787,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   10, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x27\x32\x52\x1f\x52\x72\x12\x52\x37\x21" }  },
      /* --- pixel bitmap for cmmib160 char#49 \1 --- */
      {  49,99550,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  8,   10, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x35\x30\xf6\x32\x38" }  },
      /* --- pixel bitmap for cmmib160 char#50 \2 --- */
      {  50,100516,                     /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x09\xd8\x80\x01\x0c\x30\xc0\x80\x11\xff\xfe\xfb"
            "\x1f" }  },
      /* --- pixel bitmap for cmmib160 char#51 \3 --- */
      {  51,101537,                     /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x30\x8c\xe1\x08\x07\x38\xe0\xe0\x03\x70\x00\x07"
            "\xf8\xc1\x0f\x2e\x38\x7e\x00" }  },
      /* --- pixel bitmap for cmmib160 char#52 \4 --- */
      {  52,102460,                     /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x01\x0e\x70\x40\x03\x19\xc4\x10\xc6\x30\x83\xf9"
            "\x3f\x60\x00\x03\x18\xf8\x03" }  },
      /* --- pixel bitmap for cmmib160 char#53 \5 --- */
      {  53,103495,                     /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xe3\x0f\x3f\x28\x40\x00\x7a\x30\x8e\x60\x00\x07"
            "\xf8\xc0\x07\x26\x18\x7e\x00" }  },
      /* --- pixel bitmap for cmmib160 char#54 \6 --- */
      {  54,104390,                     /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc1\x18\xc1\x0c\x30\x80\x79\x3c\x6c\x40\x03\x1e"
            "\xb0\x80\x0d\xc4\x30\x7c\x00" }  },
      /* --- pixel bitmap for cmmib160 char#55 \7 --- */
      {  55,105291,                     /* character number, location */
         11, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xbb\x1a\x11\x81\x21\x71\xa1\xa2\xa1\xa2\xa1\x60"
            "\xf4\x42\x62" }  },
      /* --- pixel bitmap for cmmib160 char#56 \8 --- */
      {  56,106210,                     /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x8c\xc1\x0c\xe6\x31\xfe\xe0\x87\x7f\xc6\x1f"
            "\xf8\x80\x07\x6c\x30\x7e\x00" }  },
      /* --- pixel bitmap for cmmib160 char#57 \9 --- */
      {  57,107107,                     /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x30\x88\xc0\x06\x3c\xe0\x01\x0b\xd8\xf0\x78\x06"
            "\x30\xc0\x0c\x66\x18\x3e\x00" }  },
      /* --- pixel bitmap for cmmib160 char#58 . --- */
      {  58,113700,                     /* character number, location */
          3, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00" }  },
      /* --- pixel bitmap for cmmib160 char#59 , --- */
      {  59,114261,                     /* character number, location */
          3, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x49\x05" }  },
      /* --- pixel bitmap for cmmib160 char#60 < --- */
      {  60,114921,                     /* character number, location */
         14, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe2\xc4\xa4\xa4\xa4\xa4\xa4\xaf\x14\xc0\x24\xe4\xe4"
            "\xe4\xe4\xe4\xe2" }  },
      /* --- pixel bitmap for cmmib160 char#61 / --- */
      {  61,115455,                     /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 11,   23, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x92\x83\x82\x83\x82\x83\x20\xf1\x62\x30\x53\x82"
            "\x83\x82\x83\x50\xf1\x32\x60\x23\x82\x83\x82\x83\x8f"
            "\x12\x92" }  },
      /* --- pixel bitmap for cmmib160 char#62 > --- */
      {  62,116150,                     /* character number, location */
         14, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe4\xe4\xe4\xe4\xe4\xe4\x20\xf1\xc4\xa4\xa4\xa4"
            "\xa4\xa4\xa4\xc2\xe1" }  },
      /* --- pixel bitmap for cmmib160 char#63 \star --- */
      {  63,116859,                     /* character number, location */
         12, 0,    1, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x61\x62\x41\x42\x29\x65\x93\x92\x12\x81\x31\x71"
            "\x51\x34" }  },
      /* --- pixel bitmap for cmmib160 char#64 \partial --- */
      {  64,93528,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x82\x60\x20\x0c\x0c\x80\x01\x30\x7c\x66\xd0"
            "\x06\x7c\x80\x0d\xb0\x01\x33\x20\x0c\x03\x3f\x00" }  },
      /* --- pixel bitmap for cmmib160 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xb2\x40\xa3\xd4\xd5\xb1\x23\x30\xf1\x71\x33\x30"
            "\x61\x43\x81\x53\x8a\x61\x73\x20\xf1\x31\x83\x26\x47" }  },
      /* --- pixel bitmap for cmmib160 char#66 B --- */
      {  66, 2374,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3d\x73\x63\x10\xf2\x53\x73\x43\x73\x53\x54\x6c\x63"
            "\x73\x10\xf2\x33\x83\x10\x33\x73\x43\x73\x3d\x56" }  },
      /* --- pixel bitmap for cmmib160 char#67 C --- */
      {  67, 3339,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x22\x53\x63\x43\x92\x33\xb1\x23\xc1\x23\xef\x33"
            "\xe0\x1f\x13\xb1\x30\x12\xa1\x63\x62\x97\x7d" }  },
      /* --- pixel bitmap for cmmib160 char#68 D --- */
      {  68, 4469,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3d\x93\x73\x73\x92\x10\xf1\x53\x93\xf3\x43\xa3\xf1"
            "\x33\xa3\x10\x33\x93\x53\x83\x53\x73\x5d\x7d" }  },
      /* --- pixel bitmap for cmmib160 char#69 E --- */
      {  69, 5888,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x01\xf1\x53\x82\x53\x91\x53\x41\x41\xf1\x43\x41"
            "\x60\x48\xa3\x32\x60\xf1\x33\x41\x41\x20\xf1\x33\x81"
            "\x30\x23\x73\x3e\x40" }  },
      /* --- pixel bitmap for cmmib160 char#70 F --- */
      {  70, 7117,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\xf1\x53\x72\x53\x81\x53\x41\x31\xf1\x43\x41\x50"
            "\x48\x93\x32\x50\xf1\x33\x41\x60\xf1\x33\xb0\x23\xc8"
            "\x90" }  },
      /* --- pixel bitmap for cmmib160 char#71 G --- */
      {  71, 8298,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x22\x53\x63\x43\x92\x33\xb1\x23\xc1\x23\xef\x13"
            "\xe0\x13\x68\x1f\x23\x93\x30\x12\x93\x53\x63\x87\x21"
            "\x40" }  },
      /* --- pixel bitmap for cmmib160 char#72 H --- */
      {  72, 9541,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   15, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x38\xf3\x53\x83\x30\xf1\x43\x83\x40\x4e\x83\x83"
            "\x40\xf3\x33\x83\x50\x23\x83\x68\x38\x33" }  },
      /* --- pixel bitmap for cmmib160 char#73 I --- */
      {  73,10264,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\xf3\x63\x40\xf3\x53\x50\xf3\x43\x60\x33\x79\x43" }  },
      /* --- pixel bitmap for cmmib160 char#74 J --- */
      {  74,11114,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\xf3\x83\x20\xf3\x73\x30\xf1\x63\x42\x43\x43\x33"
            "\x42\x33\x65\x73" }  },
      /* --- pixel bitmap for cmmib160 char#75 K --- */
      {  75,12313,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   15, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x55\x53\x91\x83\x72\x93\x61\xb3\x42\xb3\x41\xd3"
            "\x23\xd3\x14\xd4\x23\xb3\x43\xb3\x53\xa3\x54\x93\x63"
            "\x83\x83\x58\x37\x30" }  },
      /* --- pixel bitmap for cmmib160 char#76 L --- */
      {  76,13284,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x39\x20\xf3\x53\x60\xf3\x43\x70\xf1\x33\x71\xf1\x33"
            "\x61\x10\x23\x53\x1c\x23" }  },
      /* --- pixel bitmap for cmmib160 char#77 M --- */
      {  77,14610,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 26,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\xf0\x83\x0e\xe0\x01\x3a\x40\x07\xe8\x00\x1d"
            "\xa0\x03\x72\x40\x0e\xe4\x00\x71\x90\x03\xc4\x21\x0e"
            "\x10\x47\x38\x20\x9c\x70\x80\xe0\xc2\x01\x82\x07\x07"
            "\x08\x0e\x1c\x10\x38\x38\xf0\x63\xf8\x07" }  },
      /* --- pixel bitmap for cmmib160 char#78 N --- */
      {  78,15798,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   15, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x76\x55\x81\x81\x13\x81\x81\x23\x71\x81\x24\x61"
            "\x71\x43\x51\x81\x53\x41\x81\x54\x31\x81\x63\x31\x71"
            "\x83\x11\x81\x85\x81\x94\x81\xa3\x71\xb2\x66\x91\x61" }  },
      /* --- pixel bitmap for cmmib160 char#79 O --- */
      {  79,16701,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x73\x53\x53\x82\x33\x93\x13\xa3\x12\xb3\x0f\x23"
            "\xb3\x0f\x13\xa3\x13\x93\x23\x83\x43\x53\x87\x71" }  },
      /* --- pixel bitmap for cmmib160 char#80 P --- */
      {  80,17808,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3d\x73\x63\x10\xf2\x53\x73\x43\x73\x53\x63\x6a\x83"
            "\xb0\xf3\x33\xc0\x23\xd8\xa3" }  },
      /* --- pixel bitmap for cmmib160 char#81 Q --- */
      {  81,18839,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x73\x53\x53\x82\x33\x93\xf1\x13\xa3\x0f\x23\xb3"
            "\x0f\x13\xa3\x13\x93\x23\x23\x33\x44\x34\x87\x41\xb1"
            "\x41\x20\xf1\x95\x30\xa2\x51" }  },
      /* --- pixel bitmap for cmmib160 char#82 R --- */
      {  82,20156,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x83\x63\x10\xf2\x53\x73\x43\x73\x53\x63\x6a\x83"
            "\x53\x30\xf3\x33\x63\x30\x23\x73\x29\x54\x17" }  },
      /* --- pixel bitmap for cmmib160 char#83 S --- */
      {  83,21227,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x12\x51\x62\x51\x81\x42\x81\x42\xd5\xa8\x88\xa6"
            "\xc3\xd2\x31\x92\x31\x82\x32\x72\x41\x17\x67" }  },
      /* --- pixel bitmap for cmmib160 char#84 T --- */
      {  84,22267,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x04\x53\x51\x1f\x21\x63\x51\x10\xf3\x63\x80\xf3"
            "\x53\x90\x43\xba\x61" }  },
      /* --- pixel bitmap for cmmib160 char#85 U --- */
      {  85,23289,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   15, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x56\xf3\x23\xa1\x30\xf3\x13\xa1\x4f\x23\xa1\x50"
            "\x12\x91\x82\x62\xa7\x92" }  },
      /* --- pixel bitmap for cmmib160 char#86 V --- */
      {  86,24213,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x55\x23\x91\x54\x81\x63\x71\x40\xf1\x33\x61\x50"
            "\x33\x51\x94\x31\xb3\x22\xb3\x21\xc3\x11\x90\xf1\x44"
            "\xa0\x52\xe0\x21\xc0" }  },
      /* --- pixel bitmap for cmmib160 char#87 W --- */
      {  87,25598,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\xfc\xf1\x39\xe0\x80\x70\xe0\x81\xe0\xc0\x83\xc1"
            "\x41\x07\x81\xc7\x0e\x01\x8e\x1c\x02\x9c\x78\x02\x38"
            "\xe1\x02\x70\xc1\x05\xe0\x81\x07\xc0\x03\x0f\x80\x03"
            "\x0e\x00\x07\x0c\x00\x04\x18\x00" }  },
      /* --- pixel bitmap for cmmib160 char#88 X --- */
      {  88,26759,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   15, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x27\x63\x62\xa3\x41\xc3\x31\xd4\x11\x70\xf1\x84"
            "\x80\x93\xe0\x25\xe1\x23\xd1\x34\xb1\x53\xa1\x64\x81"
            "\x83\x56\x47\x31" }  },
      /* --- pixel bitmap for cmmib160 char#89 Y --- */
      {  89,27835,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x55\x24\x81\x63\x71\x74\x52\x83\x42\x93\x32\xa4"
            "\x21\xc3\x11\xd4\x90\xf3\x53\xa0\x43\xd7\x91" }  },
      /* --- pixel bitmap for cmmib160 char#90 Z --- */
      {  90,28926,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5d\x43\x64\x52\x64\x61\x64\x71\x54\xd4\xd4\xd4\xd3"
            "\xe3\x61\x73\x71\x63\x81\x53\x82\x43\x82\x4e\x44" }  },
      /* --- pixel bitmap for cmmib160 char#91 \flat --- */
      {  91,117548,                     /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x01\x01\x01\x01\x01\x01\x7f\xc3\xc1\xc1\xc1\x61"
            "\x31\x19\x07\x01" }  },
      /* --- pixel bitmap for cmmib160 char#92 \natural --- */
      {  92,118303,                     /* character number, location */
         16, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  6,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x10\x04\x71\xff\x8e\x61\x18\x86\x61\x18\xf7\xef"
            "\x08\x82" }  },
      /* --- pixel bitmap for cmmib160 char#93 \sharp --- */
      {  93,119170,                     /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x42\x42\xc2\xfe\x7f\x43\x42\x42\x42\x42\x42\x42"
            "\xc2\xfe\x7f\x43\x42\x02" }  },
      /* --- pixel bitmap for cmmib160 char#94 \smile --- */
      {  94,120084,                     /* character number, location */
          9, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 23,    6, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x71\x11\xe0\x51\x32\xe0\x12\x54\x94\x8d\xd7"
            "\x81" }  },
      /* --- pixel bitmap for cmmib160 char#95 \frown --- */
      {  95,120954,                     /* character number, location */
         10, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\xe0\x3b\xae\x01\x72\xd2\x51\xe0\x31\x31\xe0\x51"
            "\x11\xe0\x71" }  },
      /* --- pixel bitmap for cmmib160 char#96 \ell --- */
      {  96,94294,                      /* character number, location */
         15,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x03\x24\x30\xc1\x08\x26\x18\xc1\x04\x16\x70\xc0"
            "\x01\x06\x38\x20\x01\x18\x83\x07" }  },
      /* --- pixel bitmap for cmmib160 char#97 a --- */
      {  97,29862,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\xc2\x38\x06\x63\x30\x83\x31\x18\x83\x39\x98\xe2"
            "\xc5\x31" }  },
      /* --- pixel bitmap for cmmib160 char#98 b --- */
      {  98,30724,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x18\x30\x60\xc0\xc0\x9e\x63\x83\x06\x07\x0f\x1e"
            "\x3c\x4c\x0c\x0f" }  },
      /* --- pixel bitmap for cmmib160 char#99 c --- */
      {  99,31529,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x61\x48\xb0\x01\x03\x0c\x30\xc0\x80\x86\xf1\x01" }  },
      /* --- pixel bitmap for cmmib160 char#100 d --- */
      { 100,32493,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x0f\x60\x00\x06\x60\x00\x06\x37\x8c\x63\x30\x06"
            "\x33\x18\x83\x31\x98\x83\x29\x5e\x1c\x03" }  },
      /* --- pixel bitmap for cmmib160 char#101 e --- */
      { 101,33332,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x30\x64\x90\x21\x7f\x0c\x30\xc0\x80\x86\xf1\x01" }  },
      /* --- pixel bitmap for cmmib160 char#102 f --- */
      { 102,34476,                      /* character number, location */
         15, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\x92\x21\x82\x12\xf1\x72\x40\x48\x10\xf2\x72\x40"
            "\xf4\x62\x50\xf1\x52\x60\x11\x32\x62\x31\x84\x84" }  },
      /* --- pixel bitmap for cmmib160 char#103 g --- */
      { 103,35457,                      /* character number, location */
         10, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xc4\x38\x83\x19\x6c\x30\x83\x19\xcc\x60\xc4\xc1"
            "\x0d\x60\x00\x23\x0c\x3f\x00" }  },
      /* --- pixel bitmap for cmmib160 char#104 h --- */
      { 104,36382,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x00\x03\x60\x00\x0c\x80\x01\x98\x07\x8f\x61\x30"
            "\x0c\xc6\x60\x18\x0c\x83\x69\x18\x07\xd3\xc0\x01" }  },
      /* --- pixel bitmap for cmmib160 char#105 i --- */
      { 105,37208,                      /* character number, location */
         16, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  6,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x04\x00\x00\xe0\x64\x59\xc3\x30\xa6\x69\x31" }  },
      /* --- pixel bitmap for cmmib160 char#106 j --- */
      { 106,38129,                      /* character number, location */
         16,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          { 11,   20, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x92\xf3\xb0\x63\x71\x22\x10\xf1\x41\x32\x10\xf3"
            "\x72\x20\xf3\x62\x30\x11\x32\x54\x62" }  },
      /* --- pixel bitmap for cmmib160 char#107 k --- */
      { 107,39140,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xc0\x00\x06\x30\x80\x01\x86\x33\x9a\xc9\x3c\xf0"
            "\x80\x1d\x8c\x69\xcc\x61\x0d\x06" }  },
      /* --- pixel bitmap for cmmib160 char#108 l --- */
      { 108,39866,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x31\xc6\x8c\x31\x66\x8c\x39\x97\x01" }  },
      /* --- pixel bitmap for cmmib160 char#109 m --- */
      { 109,41075,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 20,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\xe7\x91\xc7\x31\x19\x0c\x93\xc1\x30\x0c\x86\xc1"
            "\x60\x18\x0c\x86\xc9\x60\x8c\x06\xc3\x64\x30\x38" }  },
      /* --- pixel bitmap for cmmib160 char#110 n --- */
      { 110,42096,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\x23\xc7\x64\x98\x0c\xc3\x30\x18\x06\xc3\x64\x8c"
            "\x86\xc9\xe0\x00" }  },
      /* --- pixel bitmap for cmmib160 char#111 o --- */
      { 111,42848,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc1\x10\x81\x0d\x3c\xe0\x01\x0f\x78\x60\x86\xe1"
            "\x03" }  },
      /* --- pixel bitmap for cmmib160 char#112 p --- */
      { 112,43796,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x27\xc7\x32\x28\x83\x18\x8c\xc1\x18\x8c\x61\x1c"
            "\xc3\x1e\x0c\xc0\x00\x06\xf0\x01" }  },
      /* --- pixel bitmap for cmmib160 char#113 q --- */
      { 113,44723,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x32\x6e\xb0\xc1\x83\x0d\x36\xd8\x60\xe2\x70\x03"
            "\x0c\x30\x60\xc0\x07" }  },
      /* --- pixel bitmap for cmmib160 char#114 r --- */
      { 114,45598,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe6\x3a\x37\x6e\x60\xc0\x80\x01\x03\x03\x06\x00" }  },
      /* --- pixel bitmap for cmmib160 char#115 s --- */
      { 115,46536,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x08\x0a\x36\xc0\x07\x1e\xa0\x41\x41\x7c\x00" }  },
      /* --- pixel bitmap for cmmib160 char#116 t --- */
      { 116,47280,                      /* character number, location */
         14, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x30\x30\x30\xff\x18\x18\x18\x0c\x0c\x8c\x4c\x4c"
            "\x38" }  },
      /* --- pixel bitmap for cmmib160 char#117 u --- */
      { 117,48308,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xd4\x60\x0d\xd6\x60\x06\x63\x30\x06\x6b\xb8\xc6"
            "\xc7\x63" }  },
      /* --- pixel bitmap for cmmib160 char#118 v --- */
      { 118,49185,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x37\xdc\x70\x83\x06\x19\x64\x90\x21\x46\xf0\x00" }  },
      /* --- pixel bitmap for cmmib160 char#119 w --- */
      { 119,50351,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xc4\x1a\xc6\x19\xc6\x19\x86\x0c\x43\x0c\x43\x0c"
            "\x43\x0c\x23\x8c\x23\x78\x1e" }  },
      /* --- pixel bitmap for cmmib160 char#120 x --- */
      { 120,51583,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x1c\xe2\x4c\x18\x13\x06\xc0\x00\x30\x00\x0c\x09"
            "\x43\xe3\x88\xe7\x01" }  },
      /* --- pixel bitmap for cmmib160 char#121 y --- */
      { 121,52645,                      /* character number, location */
         10, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xd4\x70\x86\x33\xcc\x30\x86\x31\x8c\x61\x8c\xc1"
            "\x0f\x60\x84\x31\x06\x1f\x00" }  },
      /* --- pixel bitmap for cmmib160 char#122 z --- */
      { 122,53549,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xf2\x4f\x10\x20\x60\x40\x80\x20\x41\xfe\x85\x03" }  },
      /* --- pixel bitmap for cmmib160 char#123 \imath --- */
      { 123,95026,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x96\x35\x0c\x63\x9a\x16\x03" }  },
      /* --- pixel bitmap for cmmib160 char#124 \jmath --- */
      { 124,95829,                      /* character number, location */
         10,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x61\x22\xf1\x41\x32\xf3\x72\x10\xf3\x62\x20\x11"
            "\x32\x44\x52" }  },
      /* --- pixel bitmap for cmmib160 char#125 \wp --- */
      { 125,96950,                      /* character number, location */
         10, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 14,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x00\xc1\x63\x0c\xdb\xc0\x0b\xf0\x01\x7c\x00\x1b"
            "\x61\x4d\x4c\xe6\x91\x03\xc4\x00\x19\x80\x03\x00" }  },
      /* --- pixel bitmap for cmmib160 char#126 \bfvec --- */
      { 126,97580,                      /* character number, location */
         15, 4,   11, 4,      /* topleft row,col, and botleft row,col */
          { 11,    4, 3, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\x1f\x1b\x72\x22" }  },
      /* --- pixel bitmap for cmmib160 char#127 (noname) --- */
      { 127,98118,                      /* character number, location */
         14, 6,   12, 6,      /* topleft row,col, and botleft row,col */
          { 10,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x05\x08" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=5 for .180gf ---
 * mf '\mode=preview; mag=magstep(-14.65037297372839890542); input cmmib10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmib180 --- */
static	chardef  cmmib180[] =
   {
      /* --- pixel bitmap for cmmib180 char#0 \Gamma --- */
      {   0,55047,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   17, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x01\x73\x72\x73\x81\xf2\x63\x91\x63\xa0\xf3\x53"
            "\xb0\xf3\x43\xc0\x33\xda\x92" }  },
      /* --- pixel bitmap for cmmib180 char#1 \Delta --- */
      {   1,55958,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 21,   17, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\xe0\x43\xe0\x44\xe0\x21\x13\xe0\x11\x23\xe1\x34"
            "\xc1\x53\xb1\x63\xa2\x64\x91\x83\x81\x94\x61\xa4\x51"
            "\xc3\x41\xd4\x2e\x05\x1e\x06\x1e\x07" }  },
      /* --- pixel bitmap for cmmib180 char#2 \Theta --- */
      {   2,57135,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x93\x53\x63\x82\x43\x93\x23\xa3\x13\xc2\x13\x31"
            "\x41\x23\x0f\x23\x36\x33\x03\x31\x41\x32\x13\xb3\x13"
            "\xb2\x23\xa2\x43\x82\x63\x53\x97\x77" }  },
      /* --- pixel bitmap for cmmib180 char#3 \Lambda --- */
      {   3,58101,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,66, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xc2\x40\xb3\x40\xf1\xa4\x40\xf1\x91\x14\x30\x81"
            "\x33\x30\xf1\x71\x43\x30\x61\x53\x81\x63\x81\x64\x61"
            "\x74\x20\xf1\x31\x93\x26\x48" }  },
      /* --- pixel bitmap for cmmib180 char#4 \Xi --- */
      {   4,59532,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x4e\x03\x41\xe0\x11\x31\xe0\x11\x10\xf1\xe0\x70"
            "\x61\x91\x40\xf1\x5b\x50\x51\x91\x50\xf2\xe0\x70\xf1"
            "\x11\xe0\x11\x3f\x1e\x03\x48" }  },
      /* --- pixel bitmap for cmmib180 char#5 \Pi --- */
      {   5,60767,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 26,   17, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x08\xf1\x73\xa3\x30\xf3\x63\xa3\x40\xf3\x53\xa3"
            "\x50\xf3\x43\xa3\x60\x33\xa3\x79\x49\x42" }  },
      /* --- pixel bitmap for cmmib180 char#6 \Sigma --- */
      {   6,61954,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 20,   17, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x02\x53\x93\x54\x92\x63\xa1\x64\x91\x73\x91\x74"
            "\xe0\x34\xe0\x33\xe0\x32\xe0\x32\x81\x81\x91\x72\xa1"
            "\x61\xb1\x61\xa3\x4e\x02\x3e\x02\x47" }  },
      /* --- pixel bitmap for cmmib180 char#7 \Upsilon --- */
      {   7,63020,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x64\x27\x46\x11\x43\x23\x32\x62\x12\x51\x72\x12"
            "\x60\xf1\x74\x70\xf3\x73\x80\xf3\x63\x90\x53\xc9\x71" }  },
      /* --- pixel bitmap for cmmib180 char#8 \Phi --- */
      {   8,64076,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6a\x10\xf1\x93\x50\x83\xb9\x63\x23\x23\x23\x43\x33"
            "\x12\x43\x43\x0f\x13\x43\x43\x03\x43\x33\x23\x23\x24"
            "\x59\x50\xf1\x63\x80\x53\xba\x52" }  },
      /* --- pixel bitmap for cmmib180 char#9 \Psi --- */
      {   9,65189,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x69\x30\xf1\x93\x64\x43\x43\xf2\x13\x43\x33\x1f\x13"
            "\x43\x33\x20\x12\x43\x23\x43\x33\x22\x63\x13\x13\x97"
            "\x70\xf1\x63\x90\x53\xc9\x7a" }  },
      /* --- pixel bitmap for cmmib180 char#10 \Omega --- */
      {  10,66412,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 20,   17, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x97\xa4\x53\x73\x92\x53\xa3\xf2\x33\xb3\x33\xa3\x43"
            "\xa2\x53\x93\x62\x83\x72\x82\x41\x41\x72\x31\x11\x41"
            "\x62\x41\x16\x66\x26\x57\x26\x56\x37" }  },
      /* --- pixel bitmap for cmmib180 char#11 \alpha --- */
      {  11,67458,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x1c\x27\x07\xd3\x81\xeb\xc0\x3b\xe0\x1d\x70"
            "\x0e\x38\x06\x1c\x83\x2d\x3e\x1c" }  },
      /* --- pixel bitmap for cmmib180 char#12 \beta --- */
      {  12,68509,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 14,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x0f\x20\x0c\x04\x83\xc0\x10\x30\x04\x0e\xf9\x21"
            "\x31\x88\x1f\x02\x86\x80\x11\x70\x04\x1c\x01\x47\xe0"
            "\x28\x1c\xf2\x81\x00\x20\x00\x04\x00\x01\x40\x00\x00" }  },
      /* --- pixel bitmap for cmmib180 char#13 \gamma --- */
      {  13,69436,                      /* character number, location */
         11, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 15,   16, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x71\x26\x51\x28\x41\x12\x53\x21\xb1\x21\x20\xf1"
            "\xa2\x30\xf2\xa1\x40\xf2\x92\x40\xf2\x82\x52" }  },
      /* --- pixel bitmap for cmmib180 char#14 \delta --- */
      {  14,70389,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x00\x7e\x30\x0e\x03\x60\x00\x0e\xc0\x01\x3e\xb8"
            "\xc3\x79\x8e\xe7\x70\x07\x73\x38\x87\x63\x18\xce\x80"
            "\x07" }  },
      /* --- pixel bitmap for cmmib180 char#15 \epsilon --- */
      {  15,71257,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xe3\xc0\x81\x03\x0e\xfc\x77\xc0\x01\x06\x30\x88"
            "\x1f" }  },
      /* --- pixel bitmap for cmmib180 char#16 \zeta --- */
      {  16,72165,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   22, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x61\x40\x65\x52\x31\x42\x14\x32\x91\x92\x70\xf2"
            "\x12\x8f\x12\x9f\x13\x80\x15\x67\x57\x75\x83\x51\x22"
            "\x73\x34" }  },
      /* --- pixel bitmap for cmmib180 char#17 \eta --- */
      {  17,73048,                      /* character number, location */
         11, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\xa7\x8b\xf5\xf0\x0e\xce\xc1\x1d\x9c\x83\x73\x70"
            "\x0e\xee\xe0\x18\x1c\x80\x03\x70\x00\x07\xe0\x00\x0c" }  },
      /* --- pixel bitmap for cmmib180 char#18 \theta --- */
      {  18,73816,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x01\x23\x18\xc6\x61\x0c\xee\xe0\x0e\x7e\x70\xff"
            "\x77\x70\x07\x37\x38\x83\x33\x1c\xc3\x60\x06\x3c\x00" }  },
      /* --- pixel bitmap for cmmib180 char#19 \iota --- */
      {  19,74465,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x1c\x1c\x1c\x1c\x0e\x0e\x8e\x47\x67\x1e" }  },
      /* --- pixel bitmap for cmmib180 char#20 \kappa --- */
      {  20,75399,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x1c\x87\xc7\x99\x71\x01\x3c\x80\xff\xe0\x70\x38"
            "\x9c\x0e\xe7\xc1\x65\xe0\x00" }  },
      /* --- pixel bitmap for cmmib180 char#21 \lambda --- */
      {  21,76234,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\xd3\xc4\xc3\xc4\x50\xf1\x73\x50\x74\xc3\xc4\x92"
            "\x13\x82\x24\x62\x43\x43\x54\x23\x73\x14\x74\x12\x93" }  },
      /* --- pixel bitmap for cmmib180 char#22 \mu --- */
      {  22,77272,                      /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 15,   16, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x62\x10\xf3\x33\x53\x10\xf1\x23\x53\x20\xf1\x23"
            "\x53\x11\x14\x36\x27\x33\x10\xf1\x13\xbf\x13\xc2\xd3" }  },
      /* --- pixel bitmap for cmmib180 char#23 \nu --- */
      {  23,78041,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x15\x62\xf2\x23\x63\x23\x53\x23\x53\x33\x52\x43\x33"
            "\x53\x23\x53\x13\x74\xa3" }  },
      /* --- pixel bitmap for cmmib180 char#24 \xi --- */
      {  24,79165,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 10,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x01\x3c\x9c\xb8\x73\xc0\x01\x03\xfc\x60\x44"
            "\x8f\x01\x03\x0c\x30\xc0\x03\x3f\xf8\x87\x3f\xf0\x80"
            "\xc1\x03" }  },
      /* --- pixel bitmap for cmmib180 char#25 \pi --- */
      {  25,80113,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x7f\xff\xbf\xff\x3f\x44\x00\x23\x80\x11\xe0\x1c"
            "\x30\x0e\x1c\x0f\x0e\x07\x83\x01" }  },
      /* --- pixel bitmap for cmmib180 char#26 \rho --- */
      {  26,80951,                      /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 14,   16, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x74\x82\x33\x52\x52\x10\xf1\x33\x53\xf2\x23\x53\x10"
            "\x23\x43\x34\x33\x43\x14\x50\xf1\x13\xaf\x13\xb2\xc2" }  },
      /* --- pixel bitmap for cmmib180 char#27 \sigma --- */
      {  27,81855,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   11, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x4d\x2d\x23\x43\x63\x52\x5f\x23\x53\x53\x43\x72"
            "\x33\x95\x94" }  },
      /* --- pixel bitmap for cmmib180 char#28 \tau --- */
      {  28,82642,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2b\x2d\x1c\x11\x51\x70\xf1\x52\x70\xf2\x43\x70\x33"
            "\xc2\x85" }  },
      /* --- pixel bitmap for cmmib180 char#29 \upsilon --- */
      {  29,83527,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x48\x83\xe7\xf0\x0e\xcc\x01\x1d\x90\x03\x72\x20"
            "\x0e\x84\x61\xe0\x03" }  },
      /* --- pixel bitmap for cmmib180 char#30 \phi --- */
      {  30,84425,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xa1\x50\xf2\x91\x60\x66\x73\x21\x32\x43\x31\x33"
            "\x23\x41\x42\x23\x41\x43\x0f\x13\x41\x43\x13\x41\x42"
            "\x32\x41\x32\x52\x21\x23\x77\x60\xf1\x61\x90\xf2\x51"
            "\xa2" }  },
      /* --- pixel bitmap for cmmib180 char#31 \chi --- */
      {  31,85496,                      /* character number, location */
         11, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 16,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x80\xf2\x40\xe0\x20\xe0\x11\xc0\x09\xc0\x05\xc0"
            "\x03\x80\x03\x80\x03\xc0\x03\xa0\x07\x10\x07\x08\x07"
            "\x04\x0f\x02\x5e\x01\x3c" }  },
      /* --- pixel bitmap for cmmib180 char#32 \psi --- */
      {  32,86559,                      /* character number, location */
         17, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xb1\x40\xf3\xa1\x50\x13\x51\x41\x21\x12\x41\x34"
            "\x23\x31\x34\x13\x41\x42\x23\x31\x61\xf1\x13\x41\x51"
            "\x10\x13\x41\x41\x33\x31\x41\x53\x21\x22\x86\xd1\x80"
            "\xf3\x61\x91" }  },
      /* --- pixel bitmap for cmmib180 char#33 \omega --- */
      {  33,87668,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x40\x04\xe0\x06\xe0\x02\xc0\x82\x81\x81\x41\x83"
            "\x41\xe7\x73\xff\x3f\x3e\x1f\x1c\x0e" }  },
      /* --- pixel bitmap for cmmib180 char#34 \varepsilon --- */
      {  34,88617,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xf1\x6f\xa0\x00\x7e\x18\x91\x43\x00\x01\xfb\xc7"
            "\x07" }  },
      /* --- pixel bitmap for cmmib180 char#35 \vartheta --- */
      {  35,89608,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x07\x20\x02\x88\x01\x61\x40\x38\x20\xee\x90\x77"
            "\x78\x1d\x7c\x07\xc7\xc1\x39\x38\x0e\x8e\xc3\xe1\x30"
            "\x38\x06\xf8\x00" }  },
      /* --- pixel bitmap for cmmib180 char#36 \varpi --- */
      {  36,90855,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   11, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x06\xf1\x1e\x07\x01\x21\xe0\x21\x41\x71\x81\x31"
            "\x72\x71\x41\x63\x71\x41\x55\x42\x57\x28\x56\x37\x74"
            "\x54\x60" }  },
      /* --- pixel bitmap for cmmib180 char#37 \varrho --- */
      {  37,91756,                      /* character number, location */
         11, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   16, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x72\x33\x42\x52\x10\xf1\x23\x53\xf2\x13\x53\x10"
            "\x13\x43\x24\x33\x31\x25\x51\xc8\x59\x58\xc1\x47" }  },
      /* --- pixel bitmap for cmmib180 char#38 \varsigma --- */
      {  38,92581,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x32\x41\x21\x70\xf1\x12\x73\x84\x66\x57\x55\x73"
            "\x82\x63\x24" }  },
      /* --- pixel bitmap for cmmib180 char#39 \varphi --- */
      {  39,93540,                      /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\x64\x41\x66\x21\x67\x21\x62\x42\x11\x51\x72\x61"
            "\x61\x11\x51\x71\x22\x31\x52\x3c\x5a\x86\x60\xf2\x42"
            "\xa0\xf1\x33\xa3" }  },
      /* --- pixel bitmap for cmmib180 char#40 \bfleftharpoonup --- */
      {  40,109260,                     /* character number, location */
         13, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          { 25,    8, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x62\xe0\x30\x52\xe0\x83\xe0\x73\xe0\x73\xe0\x7e"
            "\x0e\x0e\x07" }  },
      /* --- pixel bitmap for cmmib180 char#41 \bfleftharpoondown --- */
      {  41,110290,                     /* character number, location */
          7, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,    8, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0b\x1e\x0a\x23\xe0\x93\xe0\x93\xe0\x92\xe0\x40"
            "\xf1\x62\xe0\x33" }  },
      /* --- pixel bitmap for cmmib180 char#42 \bfrightharpoonup --- */
      {  42,111318,                     /* character number, location */
         13, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          { 25,    8, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x32\x60\xe0\x42\xe0\x93\xe0\x93\xe0\x93\x2f"
            "\x1e\x0b" }  },
      /* --- pixel bitmap for cmmib180 char#43 \bfrightharpoondown --- */
      {  43,112349,                     /* character number, location */
          7, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,    8, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0b\xe0\x63\xe0\x73\xe0\x73\xe0\x82\x50\xf1"
            "\xe0\x32\x60" }  },
      /* --- pixel bitmap for cmmib180 char#44 ` --- */
      {  44,112772,                     /* character number, location */
         13, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x33\x33\xef" }  },
      /* --- pixel bitmap for cmmib180 char#45 ' --- */
      {  45,113196,                     /* character number, location */
         13, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\xcc\xcc\x7f" }  },
      /* --- pixel bitmap for cmmib180 char#46 \triangleright --- */
      {  46,113737,                     /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xf0\x00\x3f\x30\x0f\xc3\x33\xf0\x03\x3f\x3c\xf3"
            "\xf0\x03\x0f\x30\x00" }  },
      /* --- pixel bitmap for cmmib180 char#47 \triangleleft --- */
      {  47,114297,                     /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\x84\x66\x44\x22\x24\x42\x0f\x14\x62\x24\x42\x44"
            "\x22\x66\x84\xa2" }  },
      /* --- pixel bitmap for cmmib180 char#48 \0 --- */
      {  48,99821,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x43\x43\x22\x62\x1f\x43\x63\x12\x62\x23\x43\x46"
            "\x36" }  },
      /* --- pixel bitmap for cmmib180 char#49 \1 --- */
      {  49,100588,                     /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x37\x30\xf7\x43\x30\x19" }  },
      /* --- pixel bitmap for cmmib180 char#50 \2 --- */
      {  50,101556,                     /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xe3\x70\x0e\x4e\xe0\x00\x0e\x70\xc0\x09\x86\xf8"
            "\xe7\x7f\xff\x07" }  },
      /* --- pixel bitmap for cmmib180 char#51 \3 --- */
      {  51,102583,                     /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x30\x0e\xe7\x70\x04\x07\x30\x80\x01\x1f\x00"
            "\x03\x60\x00\x2e\xe0\x07\x7e\x60\x02\xc3\x1f" }  },
      /* --- pixel bitmap for cmmib180 char#52 \4 --- */
      {  52,103514,                     /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\x20\xf1\x73\x20\x64\x71\x13\x61\x23\x51\x33\x41"
            "\x43\x32\x43\x22\x53\x2c\xf3\x73\x20\x48" }  },
      /* --- pixel bitmap for cmmib180 char#53 \5 --- */
      {  53,104553,                     /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xc6\x3f\xfc\x41\x02\x04\x40\x00\xf4\xc1\x30\x04"
            "\x06\xe0\x00\x7e\xe0\x07\x3e\x60\x06\x83\x1f" }  },
      /* --- pixel bitmap for cmmib180 char#54 \6 --- */
      {  54,105454,                     /* character number, location */
         16, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x81\x61\x0c\xe7\x70\x06\x70\x00\xf7\xf1\x30\x0f"
            "\x76\xe0\x07\x7e\xe0\x06\xee\x60\x0c\x03\x1f" }  },
      /* --- pixel bitmap for cmmib180 char#55 \7 --- */
      {  55,106363,                     /* character number, location */
         12, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xbb\x1a\x29\x21\x71\x31\x61\xb1\xa1\xa2\xa1\x60"
            "\xf1\x42\x60\xf3\x33\x60\x41\x73" }  },
      /* --- pixel bitmap for cmmib180 char#56 \8 --- */
      {  56,107286,                     /* character number, location */
         16, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xc1\x30\x06\x66\x60\x0e\xe6\x33\xfc\x81\x1f\xec"
            "\x63\x78\x03\x3e\xc0\x03\x3c\x40\x06\x86\x1f" }  },
      /* --- pixel bitmap for cmmib180 char#57 \9 --- */
      {  57,108193,                     /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xc0\x30\x06\x77\x60\x07\x7e\xe0\x07\x6e\xf0\x0c"
            "\x8f\xef\x00\x0e\x60\x0e\xe7\x30\x84\x81\x07" }  },
      /* --- pixel bitmap for cmmib180 char#58 . --- */
      {  58,114786,                     /* character number, location */
          4, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x6f" }  },
      /* --- pixel bitmap for cmmib180 char#59 , --- */
      {  59,115349,                     /* character number, location */
          4, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  4,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\xef\x88\x44\x02" }  },
      /* --- pixel bitmap for cmmib180 char#60 < --- */
      {  60,116013,                     /* character number, location */
         15, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x22\xe4\xc4\xc4\xc4\xc4\xc4\xc4\xcf\x14\xe0\x24"
            "\xe0\x24\xe0\x24\xe0\x24\xe0\x24\xe0\x24\xe0\x24\xe0"
            "\x22" }  },
      /* --- pixel bitmap for cmmib180 char#61 / --- */
      {  61,116551,                     /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 10,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x03\x0c\x38\x60\x80\x01\x07\x0c\x30\xe0\x80\x01"
            "\x06\x1c\x30\xe0\x80\x01\x06\x1c\x30\xc0\x80\x03\x06"
            "\x18\x70\xc0\x00\x03\x00" }  },
      /* --- pixel bitmap for cmmib180 char#62 > --- */
      {  62,117250,                     /* character number, location */
         15, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x24\xe0\x24\xe0\x24\xe0\x24\xe0\x24\xe0\x24"
            "\xe0\x24\x20\xf1\xe4\xc4\xc4\xc4\xc4\xc4\xc4\xc4\xe2"
            "\xe0\x20" }  },
      /* --- pixel bitmap for cmmib180 char#63 \star --- */
      {  63,117963,                     /* character number, location */
         13, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 15,   14, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x71\x70\x63\x64\x23\x24\x2b\x67\x40\xf1\x55\x50"
            "\x43\x13\x82\x32\x72\x52\x61\x71\x34" }  },
      /* --- pixel bitmap for cmmib180 char#64 \partial --- */
      {  64,94522,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x81\x52\x61\x72\x10\xf1\x33\x72\xd2\x55\x32\x33"
            "\x45\x23\x64\xf1\x13\x83\x0f\x13\x83\x13\x73\x32\x72"
            "\x52\x43\x76\x63" }  },
      /* --- pixel bitmap for cmmib180 char#65 A --- */
      {  65, 1026,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   17, 3,66, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xd2\x50\xc3\xe0\x24\xe0\x25\xe1\x23\x40\xf1\x91"
            "\x33\x40\x81\x43\xb1\x54\xa1\x63\x9b\x30\xf1\x51\x83"
            "\x30\x41\x93\x61\xa4\x26\x68" }  },
      /* --- pixel bitmap for cmmib180 char#66 B --- */
      {  66, 2408,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 21,   17, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x01\x93\x73\x83\x83\x63\xa2\xf1\x63\x93\x63\x83"
            "\x63\x65\x7d\x30\xf1\x53\x83\x20\xf2\x43\x93\x20\x43"
            "\x83\x63\x83\x4e\x01\x66" }  },
      /* --- pixel bitmap for cmmib180 char#67 C --- */
      {  67, 3381,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   17, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x31\x63\x61\x12\x43\x93\x33\xb1\x33\xc1\x23\xd1"
            "\x23\xe0\x1f\x33\xe0\x2f\x13\xc1\x30\x12\xb1\x53\x91"
            "\x73\x62\xa7\x8e" }  },
      /* --- pixel bitmap for cmmib180 char#68 D --- */
      {  68, 4521,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 22,   17, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x01\xa3\x73\x93\x92\x73\xa3\xf2\x63\xb2\xf2\x53"
            "\xb3\x53\xb2\x53\xb3\x53\xb2\x63\xa3\x63\x93\x63\x83"
            "\x5e\x01\x77" }  },
      /* --- pixel bitmap for cmmib180 char#69 E --- */
      {  69, 5948,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 20,   17, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x02\x73\x82\x73\x91\xf1\x63\xa1\x63\x51\x41\x63"
            "\x51\xa3\x51\xb9\xb3\x42\xb3\x51\x51\x43\x51\x51\x53"
            "\xb1\x53\xa1\x63\x92\x53\x93\x2e\x03\x30" }  },
      /* --- pixel bitmap for cmmib180 char#70 F --- */
      {  70, 7185,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 20,   17, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x02\x73\x82\x73\x91\xf1\x63\xa1\x63\x51\x41\x63"
            "\x51\xa3\x51\xb9\xb3\x42\xb3\x51\xa3\x51\x70\xf2\x43"
            "\xd0\x33\xea\xa3" }  },
      /* --- pixel bitmap for cmmib180 char#71 G --- */
      {  71, 8372,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 20,   17, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x41\x63\x62\x12\x43\xa3\x33\xc1\x33\xd1\x23\xe1"
            "\x23\xe0\x2f\x13\xe0\x33\x8c\xc3\x2f\x13\xb3\x30\x12"
            "\xb3\x52\xa3\x62\x74\x97\x31\x4e" }  },
      /* --- pixel bitmap for cmmib180 char#72 H --- */
      {  72, 9625,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 26,   17, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\x49\xf1\x73\xa3\x30\xf3\x63\xa3\x40\x53\xa3\xae"
            "\x02\x50\xf1\x53\xa3\x50\xf3\x43\xa3\x60\x33\xa3\x79"
            "\x49\x42" }  },
      /* --- pixel bitmap for cmmib180 char#73 I --- */
      {  73,10356,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\xf1\x73\x30\xf3\x63\x40\xf3\x53\x50\xf3\x43\x60"
            "\x33\x79\x41" }  },
      /* --- pixel bitmap for cmmib180 char#74 J --- */
      {  74,11210,                      /* character number, location */
         17, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x69\xf1\xa3\x20\xf3\x93\x30\xf3\x83\x40\xf1\x73\x53"
            "\x43\x53\x33\x62\x42\x86\x83" }  },
      /* --- pixel bitmap for cmmib180 char#75 K --- */
      {  75,12439,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 25,   17, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\x66\x73\xa2\xa3\x91\xb3\x82\xc3\x71\xe3\x52\xe0"
            "\x13\x41\xe0\x23\x33\xe0\x23\x21\x13\xe0\x14\x33\xe0"
            "\x13\x53\xd3\x63\x90\xf1\x43\x73\x80\x43\x83\xa3\xa3"
            "\x69\x48\x40" }  },
      /* --- pixel bitmap for cmmib180 char#76 L --- */
      {  76,13420,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4a\x30\xf1\x73\x70\xf3\x63\x80\xf3\x53\x90\xf1\x43"
            "\x91\x43\x81\x53\x72\x43\x64\x1e\x01\x20" }  },
      /* --- pixel bitmap for cmmib180 char#77 M --- */
      {  77,14750,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 31,   17, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x46\xe7\x73\xe4\xa3\xd1\x13\x91\x22\xb1\x13\x40\xf1"
            "\x61\x22\xa1\x23\x40\x61\x22\x91\x33\x91\x42\x71\x33"
            "\x50\xf1\x51\x42\x61\x43\x50\x51\x42\x51\x53\x91\x62"
            "\x31\x53\x60\xf1\x41\x62\x21\x63\x60\x41\x62\x11\x73"
            "\x91\x82\x73\x77\x51\x59\x40" }  },
      /* --- pixel bitmap for cmmib180 char#78 N --- */
      {  78,15980,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 26,   17, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x97\x74\xb1\xa5\xa1\x91\x23\x91\xa1\x33\x81\x40"
            "\xf1\x61\x43\x71\x40\x51\x63\x51\x50\xf1\x51\x73\x41"
            "\x50\x51\x83\x31\x91\xa3\x11\xa1\xa5\xa1\xb4\xa1\xc3"
            "\x91\xd2\x77\xb1\x71" }  },
      /* --- pixel bitmap for cmmib180 char#79 O --- */
      {  79,16867,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x93\x53\x63\x82\x42\xa3\x23\xb2\xf1\x13\xc2\x0f"
            "\x23\xc3\x0f\x13\xb3\x13\xa3\x23\xa2\x43\x82\x63\x53"
            "\x97\x71" }  },
      /* --- pixel bitmap for cmmib180 char#80 P --- */
      {  80,17982,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 21,   17, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x01\x93\x73\x83\x83\xf2\x63\x93\x63\x83\x63\x83"
            "\x7c\x40\xf1\x53\xd0\xf3\x43\xe0\x33\xe0\x19\xc3" }  },
      /* --- pixel bitmap for cmmib180 char#81 Q --- */
      {  81,19019,                      /* character number, location */
         17, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 18,   22, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x93\x53\x63\x82\x43\x93\x23\xa3\x13\xc2\x13\xb3"
            "\x0f\x23\xc3\x03\xc2\x13\xb3\x13\xb2\x23\x33\x42\x43"
            "\x11\x31\x22\x63\x44\x97\x41\xb2\x41\xb2\x31\xc6\xc5"
            "\xe3\x52" }  },
      /* --- pixel bitmap for cmmib180 char#82 R --- */
      {  82,20378,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 22,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\xb3\x63\xa3\x73\x20\xf2\x63\x83\x20\x63\x73\x83"
            "\x73\x9b\x60\xf1\x53\x63\x50\xf2\x43\x73\x50\x43\x73"
            "\x41\x33\x83\x31\x19\x65\x21" }  },
      /* --- pixel bitmap for cmmib180 char#83 S --- */
      {  83,21459,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\x21\x52\x63\x42\x82\x41\x91\x42\x91\x43\xd5\xc7"
            "\xa8\xa6\x30\xf1\xb2\x30\xf1\x11\x92\x30\x11\x82\x43"
            "\x62\x51\x26\x71" }  },
      /* --- pixel bitmap for cmmib180 char#84 T --- */
      {  84,22533,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x02\x22\x53\x42\x11\x73\x51\x11\x63\x61\x0f\x11"
            "\x73\x61\x83\x70\xf3\x73\x80\xf3\x63\x90\x53\xbb\x63" }  },
      /* --- pixel bitmap for cmmib180 char#85 U --- */
      {  85,23563,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   17, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x67\xf1\x33\xc1\x30\xf3\x23\xc1\x40\xf3\x13\xc1"
            "\x5f\x13\xc1\x63\xb1\x83\x91\xa3\x62\xd7\xb3" }  },
      /* --- pixel bitmap for cmmib180 char#86 V --- */
      {  86,24521,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 20,   17, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x66\x23\xc1\x44\xa1\x63\x91\x40\xf1\x33\x81\x50"
            "\x33\x71\x94\x51\xb3\x51\xb3\x41\xc3\x31\xd3\x21\xe4"
            "\x11\xe0\x14\xb0\xf1\x53\xc0\x52\xd1" }  },
      /* --- pixel bitmap for cmmib180 char#87 W --- */
      {  87,25914,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 28,   17, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x08\x38\x36\x23\x83\x91\x43\x83\x81\x53\x74\x81\x53"
            "\x74\x71\x63\x61\x23\x51\x83\x51\x23\x51\x83\x41\x33"
            "\x41\x60\xf1\x33\x31\x43\x31\x70\x33\x21\x53\x21\xb3"
            "\x11\x63\x21\xb3\x11\x65\xc4\x83\xe3\x83\xe2\x92\xe0"
            "\x11\xa1\xc3" }  },
      /* --- pixel bitmap for cmmib180 char#88 X --- */
      {  88,27091,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   17, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\x37\x73\x82\xb3\x61\xd3\x51\xe0\x13\x31\xe0\x24"
            "\x11\x80\xf1\xa4\x90\xb3\xe0\x55\xe0\x31\x23\xe0\x21"
            "\x34\xe1\x53\xd1\x64\xb1\x83\x92\x94\x57\x58\x31" }  },
      /* --- pixel bitmap for cmmib180 char#89 Y --- */
      {  89,28201,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 21,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x76\x24\xa2\x63\x92\x74\x81\x93\x71\xa4\x51\xc3"
            "\x41\xd4\x21\xe0\x13\x11\xe0\x24\xe0\x42\xc0\xf2\x63"
            "\xc0\x62\xe0\x43\xe0\x19\xa3" }  },
      /* --- pixel bitmap for cmmib180 char#90 Z --- */
      {  90,29298,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4d\x43\x63\x51\x73\x52\x64\x51\x73\x61\x63\xd3\xd3"
            "\xd3\xd3\xd3\x71\x54\x61\x63\x71\x53\x81\x43\x82\x33"
            "\x73\x3e\x30" }  },
      /* --- pixel bitmap for cmmib180 char#91 \flat --- */
      {  91,118660,                     /* character number, location */
         19, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  7,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x40\x20\x10\x08\x04\x02\xbf\x79\x3c\x1e\xcf\xe5"
            "\x3a\x8d\x43\x00" }  },
      /* --- pixel bitmap for cmmib180 char#92 \natural --- */
      {  92,119421,                     /* character number, location */
         18, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  7,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x40\x20\x10\xce\xff\xff\xcf\x61\x30\x18\x0c\x06"
            "\xc3\xf9\xff\xff\x39\x04\x02\x01" }  },
      /* --- pixel bitmap for cmmib180 char#93 \sharp --- */
      {  93,120292,                     /* character number, location */
         17, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  7,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x90\x48\xac\xf7\xff\x5e\x23\x91\x48\x24\x12\x89"
            "\xf5\xfe\xdf\x6b\x24\x10\x00" }  },
      /* --- pixel bitmap for cmmib180 char#94 \smile --- */
      {  94,121214,                     /* character number, location */
         10, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 25,    7, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x91\x11\xe0\x71\x31\xe0\x51\x52\xe0\x12\x74"
            "\x94\xad\xe0\x17\x91" }  },
      /* --- pixel bitmap for cmmib180 char#95 \frown --- */
      {  95,122088,                     /* character number, location */
         11, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 25,    8, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xe0\x5b\xce\x01\x92\xd2\x71\xe0\x31\x51\xe0\x51"
            "\x31\xe0\x71\x11\xe0\x91" }  },
      /* --- pixel bitmap for cmmib180 char#96 \ell --- */
      {  96,95296,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x03\x48\xc0\x08\x46\x70\x04\x27\x70\x82\x13\xb8"
            "\x80\x07\x38\x80\x01\x1c\xa0\x01\x19\x00\x61\xe0\x01" }  },
      /* --- pixel bitmap for cmmib180 char#97 a --- */
      {  97,30268,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x0d\xc3\x31\x38\x07\xe7\xe0\x0e\xce\xc1\x39\xb8"
            "\x07\xd7\xf0\xf1\x39" }  },
      /* --- pixel bitmap for cmmib180 char#98 b --- */
      {  98,31132,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x80\x03\x38\xc0\x01\x1c\xc0\x01\xfc\xe1\x71\x0e"
            "\xe6\xe0\x0e\x7e\x70\x07\x77\x70\x87\x63\x1c\x7c\x00" }  },
      /* --- pixel bitmap for cmmib180 char#99 c --- */
      {  99,31967,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x83\x63\x1c\xe7\x30\x0e\x70\x00\x07\x70\x00\x06"
            "\xe8\x60\xf8\x01" }  },
      /* --- pixel bitmap for cmmib180 char#100 d --- */
      { 100,32935,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   17, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x95\xf1\xb3\xf2\xa3\x10\x54\x13\x42\x43\x42\x53\x20"
            "\xf1\x13\x53\x2f\x13\x53\x3f\x13\x53\x11\x10\x12\x45"
            "\x45\x23\x20" }  },
      /* --- pixel bitmap for cmmib180 char#101 e --- */
      { 101,33778,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x83\x43\x1c\xe4\x40\x8e\xf3\x07\x07\x70\x00\x06"
            "\xc8\x60\xf8\x01" }  },
      /* --- pixel bitmap for cmmib180 char#102 f --- */
      { 102,34900,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\xa2\x13\x83\x13\x83\x12\x93\xb3\x9a\x10\xf3\x73"
            "\x50\xf4\x63\x60\x62\xc3\x82\x23\x73\x22\x83\x21\xa4"
            "\xa5" }  },
      /* --- pixel bitmap for cmmib180 char#103 g --- */
      { 103,35891,                      /* character number, location */
         11, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 13,   16, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x12\x42\x43\x32\x53\xf1\x23\x53\xf3\x13\x53\x10"
            "\x22\x43\x58\xa3\x32\x53\x23\x43\x33\x33\x66\x51" }  },
      /* --- pixel bitmap for cmmib180 char#104 h --- */
      { 104,36850,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x00\x1c\x00\x07\xe0\x00\x38\x00\x0e\x80\x7b\x70"
            "\x31\x3c\x1c\x07\xc7\xc1\x39\x38\x0e\x8e\x83\xeb\x70"
            "\x1e\x5c\x06\x0e" }  },
      /* --- pixel bitmap for cmmib180 char#105 i --- */
      { 105,37684,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  7,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x38\x0c\x00\x00\x00\x38\xba\x5c\x8e\xc3\x71\x38"
            "\x9d\x26\x0e" }  },
      /* --- pixel bitmap for cmmib180 char#106 j --- */
      { 106,38635,                      /* character number, location */
         18,-1,   -5,-1,      /* topleft row,col, and botleft row,col */
          { 12,   23, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\x93\xa1\x10\xf3\xc0\x64\x71\x23\x10\xf1\x41\x33"
            "\x10\x83\x10\xf3\x73\x20\xf2\x63\x30\x12\x33\x33\x23"
            "\x43\x13\x64\x74" }  },
      /* --- pixel bitmap for cmmib180 char#107 k --- */
      { 107,39656,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x00\x0e\xc0\x01\x1c\x80\x03\x70\x00\x0e\xe3\xd8"
            "\x9c\x9c\x8b\xf1\x00\xff\xe0\x38\x1c\xa7\xe3\x3c\x5c"
            "\x06\x07" }  },
      /* --- pixel bitmap for cmmib180 char#108 l --- */
      { 108,40390,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x8e\x73\x1c\xc7\x39\x8e\xe3\x1c\xc7\x75\x3d\x0e" }  },
      /* --- pixel bitmap for cmmib180 char#109 m --- */
      { 109,41601,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x8f\x0f\x5d\x2c\x4e\x1e\x0e\x27\x07\x87\x83\x83"
            "\xc3\xe1\xe0\x70\x70\x70\x38\x38\x38\x9c\x1c\x1c\x27"
            "\x07\x87\x13\x03\x83\x07" }  },
      /* --- pixel bitmap for cmmib180 char#110 n --- */
      { 110,42632,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x0f\x3d\x4e\x0e\x27\x87\x83\xc3\xe1\x70\x70\x38"
            "\x38\x9c\x1c\x27\x87\x13\x83\x07" }  },
      /* --- pixel bitmap for cmmib180 char#111 o --- */
      { 111,43388,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\xc7\x70\x30\x07\xe6\xc0\x0f\xdc\x81\x3b\x30"
            "\x06\xc7\x70\xe0\x03" }  },
      /* --- pixel bitmap for cmmib180 char#112 p --- */
      { 112,44340,                      /* character number, location */
         11, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 15,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x0f\x7a\x1c\x1d\x8c\x0e\x0e\x07\xc7\xc1\xe1\xe0"
            "\x70\x70\x38\x1c\x1e\x07\xf7\x80\x03\xc0\x01\x70\x00"
            "\x38\x00\x7e\x00" }  },
      /* --- pixel bitmap for cmmib180 char#113 q --- */
      { 113,45273,                      /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 13,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x19\xc3\x31\x38\x07\xe7\xe0\x0e\xce\xc1\x39\x38"
            "\x07\xc7\x70\xf0\x0f\xc0\x01\x38\x80\x03\x70\x80\x3f" }  },
      /* --- pixel bitmap for cmmib180 char#114 r --- */
      { 114,46126,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\xd3\x73\xce\x73\x86\x03\x0e\x70\x80\x03\x1c\x70"
            "\x00\x03\x00" }  },
      /* --- pixel bitmap for cmmib180 char#115 s --- */
      { 115,47068,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x30\x33\x67\xc4\x07\x3f\xf8\xc3\x87\x86\xf9\x00" }  },
      /* --- pixel bitmap for cmmib180 char#116 t --- */
      { 116,47818,                      /* character number, location */
         16, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\xe0\xe0\xc0\x81\xe3\x3f\x07\x0e\x1c\x38\x38\x70"
            "\xe0\xc8\x89\x13\x1e" }  },
      /* --- pixel bitmap for cmmib180 char#117 u --- */
      { 117,48850,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x98\x06\x97\xc3\x75\x70\x1c\x9c\x83\xe3\xe0\x38"
            "\xb8\x0e\x2e\xe3\x87\xc7\x01" }  },
      /* --- pixel bitmap for cmmib180 char#118 v --- */
      { 118,49731,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x26\xe3\x71\x9e\xc3\x38\xc8\x41\x1c\xc4\x21\x1c"
            "\x82\x11\xf0\x00" }  },
      /* --- pixel bitmap for cmmib180 char#119 w --- */
      { 119,50901,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 18,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0c\x69\x38\x9e\xe3\x78\x87\xc3\x1c\x0e\x3a\x1c"
            "\xe4\x70\x90\xc3\x41\x0e\x87\x30\x1e\x81\xc7\x03" }  },
      /* --- pixel bitmap for cmmib180 char#120 x --- */
      { 120,52139,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x1c\xb1\x2c\x9c\x0b\x67\xc0\x01\x38\x00\x0e\x8c"
            "\x43\xe7\xc8\x3c\xe3\x3c\x00" }  },
      /* --- pixel bitmap for cmmib180 char#121 y --- */
      { 121,53209,                      /* character number, location */
         11, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x58\x86\xc7\xf1\x1c\x8e\xc3\x39\x1c\x87\xe3\x70"
            "\x1c\x0e\xe3\xc0\x1f\x80\x63\x38\x0e\xc3\x31\xf0\x03" }  },
      /* --- pixel bitmap for cmmib180 char#122 z --- */
      { 122,54121,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x51\x39\x37\x11\xb1\xa2\xa1\xa2\xa1\x71\x31\x26"
            "\x3a\x21\x53\x43" }  },
      /* --- pixel bitmap for cmmib180 char#123 \imath --- */
      { 123,96036,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x5d\x2e\xc7\xe1\x38\x9c\x4e\x13\x07" }  },
      /* --- pixel bitmap for cmmib180 char#124 \jmath --- */
      { 124,96841,                      /* character number, location */
         11,-1,   -5,-1,      /* topleft row,col, and botleft row,col */
          { 11,   16, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x61\x23\xf1\x41\x33\x83\xf3\x73\x10\xf2\x63\x20"
            "\x12\x33\x23\x23\x33\x22\x55\x52" }  },
      /* --- pixel bitmap for cmmib180 char#125 \wp --- */
      { 125,97970,                      /* character number, location */
         11, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 15,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x00\x86\x8f\x31\xdc\x04\x6c\x01\x5e\x80\x1f\xc0"
            "\x0f\xe1\x8f\xb8\x4f\x4c\xcf\x21\x07\x90\x03\xc8\x00"
            "\x64\x00\x1c\x00" }  },
      /* --- pixel bitmap for cmmib180 char#126 \bfvec --- */
      { 126,98610,                      /* character number, location */
         18, 5,   12, 5,      /* topleft row,col, and botleft row,col */
          { 12,    6, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\xa3\x2f\x1c\x63\xa1\x42" }  },
      /* --- pixel bitmap for cmmib180 char#127 (noname) --- */
      { 127,99152,                      /* character number, location */
         16, 7,   14, 7,      /* topleft row,col, and botleft row,col */
          { 11,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x33\x20" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=6 for .210gf ---
 * mf '\mode=preview; mag=magstep(-13.80488502080647873125); input cmmib10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmib210 --- */
static	chardef  cmmib210[] =
   {
      /* --- pixel bitmap for cmmib210 char#0 \Gamma --- */
      {   0,56674,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x02\x84\x63\xf2\x74\x82\x74\x81\x74\x91\x10\xf2"
            "\x64\xb0\xf3\x54\xc0\xf3\x44\xd0\x34\xeb\xa2" }  },
      /* --- pixel bitmap for cmmib210 char#1 \Delta --- */
      {   1,57593,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 24,   20, 3,84, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x22\xe0\x73\xe0\x64\x60\xf1\xd6\x50\xc1\x25\xe0"
            "\x11\x35\xe1\x54\xd1\x65\xb2\x65\xa2\x84\xa1\x95\x81"
            "\xa5\x71\xc4\x61\xd5\x41\xe5\x32\xe0\x14\x3e\x08\x1e"
            "\x0e\x0e\x05" }  },
      /* --- pixel bitmap for cmmib210 char#2 \Theta --- */
      {   2,58752,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa8\xc4\x54\x93\x93\x64\xa4\x44\xc3\x43\xd4\x24\xd4"
            "\x14\x31\x61\x34\xf1\x14\x38\x34\x0f\x14\x38\x34\x14"
            "\x31\x61\x34\x14\xd4\x24\xd3\x43\xc4\x44\xa4\x63\x93"
            "\x94\x54\xc8\xa3" }  },
      /* --- pixel bitmap for cmmib210 char#3 \Lambda --- */
      {   3,59798,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,86, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x11\xe0\x52\xe0\x43\xe0\x44\xe0\x25\x40\xf1\xb1"
            "\x14\x40\xa1\x24\xd2\x24\xd1\x34\xc1\x45\xa2\x45\xa1"
            "\x64\x30\xf1\x61\x74\x30\x51\x84\x30\xf1\x41\x95\x20"
            "\x31\xb4\x26\x69" }  },
      /* --- pixel bitmap for cmmib210 char#4 \Xi --- */
      {   4,61241,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 24,   20, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x6e\x04\x5e\x04\x10\xf2\x51\xe0\x21\x10\xe0\xe0"
            "\x31\xa1\x50\xf1\x7c\x50\x6c\xc1\xa1\x60\xf1\xe0\xa0"
            "\xf2\x11\xe0\x41\x30\x1e\x06\x3f\x1e\x06\x41" }  },
      /* --- pixel bitmap for cmmib210 char#5 \Pi --- */
      {   5,62556,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 27,   20, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x08\x84\x84\x30\xf3\x74\x84\x40\xf3\x64\x84\x50"
            "\xf3\x54\x84\x60\xf3\x44\x84\x70\x34\x84\x8a\x2a\x50" }  },
      /* --- pixel bitmap for cmmib210 char#6 \Sigma --- */
      {   6,63755,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 24,   20, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x05\x55\xa4\xf1\x65\xb2\x75\xa2\x84\xa1\x95\x91"
            "\xa4\xe0\x65\xa0\xf1\xa4\xa0\xb2\xe0\x71\xa1\xa2\xa1"
            "\xa1\xc1\x91\xc2\x72\xc2\x71\xc4\x5e\x05\x4e\x05\x50" }  },
      /* --- pixel bitmap for cmmib210 char#7 \Upsilon --- */
      {   7,64831,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x95\x37\x67\x18\x4a\x54\x24\x51\x73\x23\xe0\x12"
            "\x13\xe0\x25\x90\xf2\x84\xa0\xf3\x74\xb0\xf3\x64\xc0"
            "\x54\xec\x91" }  },
      /* --- pixel bitmap for cmmib210 char#8 \Phi --- */
      {   8,65865,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\xd4\x60\xf1\xa4\x70\x79\xa3\x24\x14\x53\x34\x34"
            "\x34\x34\x43\x10\xf1\x14\x44\x44\x0f\x14\x44\x44\x10"
            "\x13\x44\x34\x34\x34\x33\x54\x14\x23\xa9\x70\xf1\x74"
            "\xa0\x64\xdc\x79" }  },
      /* --- pixel bitmap for cmmib210 char#9 \Psi --- */
      {   9,66996,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6c\xe4\x80\xf1\x94\x94\x54\x45\x14\x44\x34\x34\x34"
            "\x44\x20\xf2\x14\x34\x34\x30\x14\x24\x34\x54\x24\x33"
            "\x64\x24\x24\x73\x24\x14\x97\x13\xc8\xa0\xf1\x64\xc0"
            "\x54\xec\x9c" }  },
      /* --- pixel bitmap for cmmib210 char#10 \Omega --- */
      {  10,68231,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb8\xc4\x63\x84\x93\x64\xa4\xf1\x44\xc3\xf2\x34\xc4"
            "\x34\xb4\x53\xb3\x63\xa3\x73\xa2\x92\x92\x51\x42\x82"
            "\x41\x11\x51\x81\x51\x11\x51\x72\x41\x27\x77\x27\x68"
            "\x27\x67\x3c" }  },
      /* --- pixel bitmap for cmmib210 char#11 \alpha --- */
      {  11,69293,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\x80\xc3\x20\x0e\x0c\x79\xe0\xe4\x01\x27\x0f"
            "\xb8\x78\xc0\xe5\x01\x1e\x0f\xf0\x70\x00\x87\x03\x3e"
            "\x38\xcc\x85\x1f\x18" }  },
      /* --- pixel bitmap for cmmib210 char#12 \beta --- */
      {  12,70358,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 18,   26, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\xb2\x52\x81\x73\x61\x83\xf1\x51\x93\x41\xa2\x51"
            "\x44\x12\x61\x31\x42\x71\x35\x12\x51\xa2\x20\xf2\x31"
            "\xa3\x10\xf1\x21\xa3\x20\x21\xa2\x52\x82\x51\x21\x53"
            "\x61\x36\x70\xf1\x11\xe0\x2f\x31\xe0\x33" }  },
      /* --- pixel bitmap for cmmib210 char#13 \gamma --- */
      {  13,71303,                      /* character number, location */
         13, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 18,   19, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x81\x37\x71\x1a\x51\x23\x44\x31\x21\xa1\x31\xd1"
            "\x21\xe0\x11\x11\x30\xf1\xc2\x40\xf2\xc1\x50\xf2\xb2"
            "\x50\xf2\xa2\x60\xa1\x70" }  },
      /* --- pixel bitmap for cmmib210 char#14 \delta --- */
      {  14,72242,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   21, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x98\x61\x43\x61\xd2\xc3\xc3\xb4\x96\x63\x14\x53"
            "\x34\x33\x44\x10\xf2\x13\x63\x13\x72\x23\x63\x32\x63"
            "\x33\x52\x52\x42\x84\x60" }  },
      /* --- pixel bitmap for cmmib210 char#15 \epsilon --- */
      {  15,73120,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 11,   13, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x33\x73\x74\x6f\x14\x79\x2f\x33\x80\x13\x52\x36"
            "\x24" }  },
      /* --- pixel bitmap for cmmib210 char#16 \zeta --- */
      {  16,74032,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 13,   26, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\x40\x85\x72\x31\x52\x23\x52\xa2\xa2\xb1\xb2"
            "\xb1\xbf\x52\xb4\xa5\x88\x78\x85\x20\xf1\x92\x20\x42"
            "\x31\x93\x42" }  },
      /* --- pixel bitmap for cmmib210 char#17 \eta --- */
      {  17,74963,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 16,   19, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x45\x31\x13\x21\x43\x11\x24\x54\x24\x64\x23\x73"
            "\xf1\x33\x73\xf3\x23\x73\x10\x13\x73\x42\x73\x20\xf1"
            "\xb3\x20\xf2\xa3\x30\xa2\x41" }  },
      /* --- pixel bitmap for cmmib210 char#18 \theta --- */
      {  18,75743,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x07\x30\x07\x87\xc1\xe1\x38\x38\x0f\xcf\xc1\x7b"
            "\xf0\x1e\xbc\xff\xff\xff\x3d\x78\x0f\xde\x83\xf3\xf0"
            "\x1c\x1c\x87\x83\xe1\xe0\x0c\xe0\x01" }  },
      /* --- pixel bitmap for cmmib210 char#19 \iota --- */
      {  19,76428,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x70\xe0\xe0\xc0\x81\x83\x03\x07\x0e\x0f\x1e\x32"
            "\xc2\x03" }  },
      /* --- pixel bitmap for cmmib210 char#20 \kappa --- */
      {  20,77342,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   13, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x64\x43\x51\x13\x43\x32\x22\x43\x31\xa3\x21\xb5"
            "\xc9\x73\x53\x50\xf2\x13\x63\x31\x03\x73\x21\x22\x93"
            "\x23" }  },
      /* --- pixel bitmap for cmmib210 char#21 \lambda --- */
      {  21,78189,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x90\xf1\x63\x80\x64\xe3\xe4\xe3\xe4\xe3\xe4\xe3"
            "\xd4\xb2\x14\x92\x33\x82\x44\x63\x53\x53\x64\x24\x83"
            "\x23\x93\x22\xb3" }  },
      /* --- pixel bitmap for cmmib210 char#22 \mu --- */
      {  22,79235,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 18,   19, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x82\x10\xf1\x43\x73\x10\xf3\x33\x73\x20\x23\x73"
            "\x30\xf1\x23\x73\x21\x23\x64\x21\x15\x41\x13\x11\x23"
            "\x15\x33\x20\xf1\x13\xef\x23\xe0\x12\xe0\x21" }  },
      /* --- pixel bitmap for cmmib210 char#23 \nu --- */
      {  23,80048,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   13, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x15\x92\xf1\x33\x83\xf1\x23\x83\x10\x23\x73\x43\x63"
            "\x43\x63\x53\x53\x63\x43\x73\x23\x83\x13\xa4\xd1" }  },
      /* --- pixel bitmap for cmmib210 char#24 \xi --- */
      {  24,81180,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   26, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\x40\x76\x54\x31\x44\x13\x44\x60\xf3\x24\x70"
            "\x38\x62\x41\x42\x15\x42\xb1\xbf\x12\xb3\xa5\x97\x79"
            "\x68\x85\xb2\x61\x41\x84\x33" }  },
      /* --- pixel bitmap for cmmib210 char#25 \pi --- */
      {  25,82138,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   13, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x01\x3e\x03\x1e\x03\x21\x42\x31\x70\xf1\x61\x41"
            "\x70\x52\x41\xc2\x42\xa3\x33\xa2\x43\x60\xf1\x33\x53"
            "\x50\x32\x71\x61" }  },
      /* --- pixel bitmap for cmmib210 char#26 \rho --- */
      {  26,82984,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 16,   19, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x85\x92\x42\x72\x53\x53\x54\xf2\x33\x64\xf1\x23\x64"
            "\x10\x23\x63\x43\x53\x44\x43\x53\x15\x60\xf1\x13\xcf"
            "\x23\xd2\xe1" }  },
      /* --- pixel bitmap for cmmib210 char#27 \sigma --- */
      {  27,83898,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   13, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6c\x5e\x01\x3e\x01\x34\x44\x50\xf2\x13\x73\x5f\x13"
            "\x73\x63\x72\x82\x62\xa2\x42\xc6\xa5" }  },
      /* --- pixel bitmap for cmmib210 char#28 \tau --- */
      {  28,84667,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   13, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3d\x3e\x01\x1e\x01\x21\x52\xe0\x11\x90\xf2\x62\x90"
            "\xf2\x53\x90\x43\xe0\x12\xa2" }  },
      /* --- pixel bitmap for cmmib210 char#29 \upsilon --- */
      {  29,85570,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x60\x72\xf0\x72\xf0\x71\xf0\x39\xc0\x38\x80\x38"
            "\x80\x1c\x40\x1c\x40\x1c\x20\x18\x10\x38\x08\xe0\x07" }  },
      /* --- pixel bitmap for cmmib210 char#30 \phi --- */
      {  30,86478,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 19,   26, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\xc1\x60\xf2\xb1\x70\x78\x93\x21\x33\x53\x41\x43"
            "\x33\x51\x52\x32\x61\x53\xf1\x13\x51\x63\x03\x61\x53"
            "\x22\x61\x53\x22\x51\x53\x33\x41\x43\x62\x31\x23\x98"
            "\x70\xf3\x71\xb0\xf1\x61\xcf" }  },
      /* --- pixel bitmap for cmmib210 char#31 \chi --- */
      {  31,87565,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 18,   19, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\xb1\x11\x23\x91\x54\x71\x74\x51\x93\x41\xa3\x31"
            "\xb4\x11\xd4\x70\xf1\x73\x80\x74\x70\xf1\x61\x13\x70"
            "\x51\x24\xa1\x43\x91\x54\x71\x73\x31\x21\x84\x21\x11"
            "\xb4\x23" }  },
      /* --- pixel bitmap for cmmib210 char#32 \psi --- */
      {  32,88682,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 19,   26, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\xd1\x50\xf2\xc1\x60\x24\x61\x32\x10\xf1\x11\x23"
            "\x41\x34\x01\x33\x41\x44\x23\x51\x52\xf1\x33\x41\x71"
            "\x23\x51\x61\x33\x51\x51\x43\x41\x61\x52\x41\x42\x73"
            "\x21\x22\xb6\x70\xf3\x81\xa0\xf1\x71\xb3" }  },
      /* --- pixel bitmap for cmmib210 char#33 \omega --- */
      {  33,89809,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x00\x43\x00\x3c\x01\xe0\x09\x00\x2e\x40\x60\x01"
            "\x03\x0a\x18\x70\xc0\x40\x03\x06\x73\x7e\x8e\xff\x7f"
            "\xfc\xf9\x81\x83\x07" }  },
      /* --- pixel bitmap for cmmib210 char#34 \varepsilon --- */
      {  34,90770,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x5a\x22\x71\x10\xf1\x11\xb0\x11\x16\x53\x32\x51"
            "\x23\x6f\x11\xc2\x81\x39\x57\x42" }  },
      /* --- pixel bitmap for cmmib210 char#35 \vartheta --- */
      {  35,91781,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\xc1\x32\xb1\x42\x10\xf1\x81\x53\xf1\x81\x44\x23"
            "\x41\x34\x11\x13\x47\x11\x22\x74\x0f\x11\x23\x64\x10"
            "\x33\x64\x43\x63\x43\x64\x43\x63\x53\x53\x63\x52\x82"
            "\x42\xa6\x76" }  },
      /* --- pixel bitmap for cmmib210 char#36 \varpi --- */
      {  36,93042,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 27,   13, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x09\x3e\x0b\x1e\x0b\x21\x31\xe0\x31\x81\x71\x91"
            "\x71\x81\x91\x71\x72\x91\x61\x82\x81\x71\x73\x72\x72"
            "\x43\x12\x52\x88\x28\xa6\x46\xc3\x74\x83" }  },
      /* --- pixel bitmap for cmmib210 char#37 \varrho --- */
      {  37,93957,                      /* character number, location */
         13, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x82\x42\x62\x53\x43\x54\xf2\x23\x64\xf1\x13\x64"
            "\x10\x13\x63\x33\x53\x32\x12\x33\x41\x35\x61\xe2\xda"
            "\x5b\x69\xe1\x48" }  },
      /* --- pixel bitmap for cmmib210 char#38 \varsigma --- */
      {  38,94794,                      /* character number, location */
         13, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x57\x32\x52\x22\x92\x9f\x22\xa3\x95\x86\x77\x76\x84"
            "\x93\x92\x83\x43" }  },
      /* --- pixel bitmap for cmmib210 char#39 \varphi --- */
      {  39,95759,                      /* character number, location */
         13, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 18,   19, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x94\x41\x86\x21\x88\x11\x73\x43\x81\x71\x0f\x11"
            "\x71\x81\x01\xe0\x11\x11\x61\x72\x13\x41\x53\x3e\x5b"
            "\x97\x70\xf2\x52\xb0\xf1\x43\xb0\x42\xc3" }  },
      /* --- pixel bitmap for cmmib210 char#40 \bfleftharpoonup --- */
      {  40,111727,                     /* character number, location */
         15, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          { 29,    9, 2,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x07\x02\x14\x00\x06\x02\x1a\x03\x1a\x02\x1a"
            "\x02\x19\x03\x19\x39" }  },
      /* --- pixel bitmap for cmmib210 char#41 \bfleftharpoondown --- */
      {  41,112759,                     /* character number, location */
          8, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 29,    9, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0e\x01\x1e\x0e\x23\xe0\xe2\xe0\xe2\xe0\xd3\xe0"
            "\xd2\xe0\x70\xf1\x72\xe0\x65" }  },
      /* --- pixel bitmap for cmmib210 char#42 \bfrightharpoonup --- */
      {  42,113789,                     /* character number, location */
         15, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          { 29,    9, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x62\x70\xe0\x72\xe0\xd3\xe0\xd2\xe0\xe2\xe0"
            "\xe3\x2f\x1e\x0e\x01" }  },
      /* --- pixel bitmap for cmmib210 char#43 \bfrightharpoondown --- */
      {  43,114822,                     /* character number, location */
          8, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 29,    9, 2,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x39\x19\x03\x19\x02\x1a\x02\x1a\x03\x1a\x02\x06"
            "\x00\xff\x01\x14\x02\x07" }  },
      /* --- pixel bitmap for cmmib210 char#44 ` --- */
      {  44,115247,                     /* character number, location */
         16, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdc\x9f\x31\xc6\x38\x9e\x03" }  },
      /* --- pixel bitmap for cmmib210 char#45 ' --- */
      {  45,115675,                     /* character number, location */
         16, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x71\x8c\x31\xe6\xef\x00" }  },
      /* --- pixel bitmap for cmmib210 char#46 \triangleright --- */
      {  46,116220,                     /* character number, location */
         15, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   16, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xd4\xb6\x92\x24\x72\x43\x62\x54\x42\x74\x2f\x12"
            "\x94\x02\x74\x22\x54\x42\x43\x62\x24\x76\x94\xb2\xd3" }  },
      /* --- pixel bitmap for cmmib210 char#47 \triangleleft --- */
      {  47,116796,                     /* character number, location */
         15, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   16, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\xb4\x96\x74\x22\x63\x42\x44\x52\x24\x72\x0f\x14"
            "\x92\x24\x72\x44\x52\x63\x42\x74\x22\x96\xb4\xd2" }  },
      /* --- pixel bitmap for cmmib210 char#48 \0 --- */
      {  48,102206,                     /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   13, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x63\x53\x20\xf1\x13\x73\x1f\x54\x74\x13\x73\x33"
            "\x53\x67\x43" }  },
      /* --- pixel bitmap for cmmib210 char#49 \1 --- */
      {  49,102981,                     /* character number, location */
         13, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 11,   13, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x47\x40\xf9\x43\x4b" }  },
      /* --- pixel bitmap for cmmib210 char#50 \2 --- */
      {  50,103953,                     /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x28\x41\x64\x1f\x13\x64\x94\x93\x93\x93\x82\x51\x42"
            "\x61\x39\x2b\x1c\x11" }  },
      /* --- pixel bitmap for cmmib210 char#51 \3 --- */
      {  51,104984,                     /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x62\x54\x20\xf2\x13\x64\x10\xa4\xa4\xb3\x86\xd4"
            "\xc4\x10\xf1\xb4\x12\x84\x0f\x14\x74\x03\x74\x22\x64"
            "\x58\x41" }  },
      /* --- pixel bitmap for cmmib210 char#52 \4 --- */
      {  52,105923,                     /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\xc3\x30\xf1\x84\x30\x71\x13\x91\x23\x81\x33\x71"
            "\x43\x61\x53\x52\x53\x42\x63\x32\x73\x3e\x01\xf4\x93"
            "\x30\x69" }  },
      /* --- pixel bitmap for cmmib210 char#53 \5 --- */
      {  53,106972,                     /* character number, location */
         13, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x12\x72\x2a\x39\x48\x40\xf2\x11\xb0\x11\x25\x53\x43"
            "\x31\x73\xa3\x10\xf1\x94\x0f\x13\x64\x03\x63\x21\x64"
            "\x31\x53\x56\x45" }  },
      /* --- pixel bitmap for cmmib210 char#54 \6 --- */
      {  54,107879,                     /* character number, location */
         19, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x73\x51\x53\x53\x33\x63\x10\xf1\x13\xb4\xb4\x25"
            "\x44\x11\x43\x25\x63\x14\x73\x1f\x24\x74\x13\x74\x13"
            "\x73\x33\x63\x43\x43\x76\x41" }  },
      /* --- pixel bitmap for cmmib210 char#55 \7 --- */
      {  55,108800,                     /* character number, location */
         14, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xee\x1d\x2c\x22\x91\x3f\x11\x91\x40\x91\xd1\xd1"
            "\x70\xf1\x62\x70\xf2\x52\x80\xf3\x43\x80\x51\x94" }  },
      /* --- pixel bitmap for cmmib210 char#56 \8 --- */
      {  56,109731,                     /* character number, location */
         19, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x71\x63\x41\x92\x22\x92\x23\x82\x25\x62\x26\x42"
            "\x4a\x68\x89\x42\x37\x22\x56\x12\x87\xa3\x0f\x12\xb2"
            "\x12\xa1\x32\x72\x58\x46" }  },
      /* --- pixel bitmap for cmmib210 char#57 \9 --- */
      {  57,110648,                     /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x73\x43\x43\x63\x33\x73\x14\x73\x1f\x24\x74\x13"
            "\x74\x13\x65\x23\x41\x14\x45\x24\xb4\xf1\xb3\x10\x13"
            "\x63\x33\x62\x51\x53\x76\x61" }  },
      /* --- pixel bitmap for cmmib210 char#58 . --- */
      {  58,117301,                     /* character number, location */
          5, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\xff\xef\x00" }  },
      /* --- pixel bitmap for cmmib210 char#59 , --- */
      {  59,117866,                     /* character number, location */
          5, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\xff\xef\x21\x44\x88\x08" }  },
      /* --- pixel bitmap for cmmib210 char#60 < --- */
      {  60,118534,                     /* character number, location */
         17, 3,   -3, 3,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x42\xe0\x24\xe4\xe4\xe4\xe4\xe4\xe4\xe4\xef\x14"
            "\xe0\x20\x24\xe0\x44\xe0\x44\xe0\x44\xe0\x44\xe0\x44"
            "\xe0\x44\xe0\x44\xe0\x42" }  },
      /* --- pixel bitmap for cmmib210 char#61 / --- */
      {  61,119076,                     /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 13,   29, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xb2\xa3\xa2\xa3\x10\xf1\x92\x20\x83\xa2\xa3\x30"
            "\xf1\x72\x40\x63\xa2\xa3\xa2\xa3\x60\xf1\x42\x70\x33"
            "\xa2\xa3\x80\xf1\x22\x90\x13\xa2\xa3\xaf\x12\xb1" }  },
      /* --- pixel bitmap for cmmib210 char#62 > --- */
      {  62,119783,                     /* character number, location */
         17, 3,   -3, 3,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x44\xe0\x44\xe0\x44\xe0\x44\xe0\x44\xe0\x44"
            "\xe0\x44\xe0\x44\x20\xf1\xe0\x24\xe4\xe4\xe4\xe4\xe4"
            "\xe4\xe4\xe4\xe0\x22\xe0\x43" }  },
      /* --- pixel bitmap for cmmib210 char#63 \star --- */
      {  63,120500,                     /* character number, location */
         15, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 17,   16, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x81\x80\xf2\x73\x7e\x03\x2d\x69\x40\xf1\x65\x60"
            "\x53\x13\xa2\x32\x92\x52\x81\x71\x71\x91\x34" }  },
      /* --- pixel bitmap for cmmib210 char#64 \partial --- */
      {  64,96753,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\xb1\x63\x81\x83\x20\xf1\x43\x83\x10\xf1\xe0\x14"
            "\x75\x34\x53\x42\x14\x33\x71\x14\x24\x84\x10\xf1\x14"
            "\x94\x10\x14\x93\x24\x94\x24\x93\x43\x83\x53\x82\x73"
            "\x53\xa7\x86" }  },
      /* --- pixel bitmap for cmmib210 char#65 A --- */
      {  65, 1066,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,82, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x21\xe0\x72\x60\xf1\xe4\x50\xd5\x50\xf1\xc1\x14"
            "\x50\xb1\x24\xe0\x11\x35\xd2\x44\xd1\x54\xc1\x64\xb2"
            "\x64\xbd\x91\x94\x30\xf1\x51\xa4\x30\x41\xb4\x61\xc4"
            "\x37\x6a" }  },
      /* --- pixel bitmap for cmmib210 char#66 B --- */
      {  66, 2474,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x01\xb4\x64\x10\xf3\x74\x84\x64\x84\x74\x83\x84"
            "\x64\x9d\x94\x83\x84\x84\x74\x93\x74\x94\x54\xa3\x64"
            "\x94\x64\x93\x74\x84\x64\x83\x5e\x02\x71" }  },
      /* --- pixel bitmap for cmmib210 char#67 C --- */
      {  67, 3459,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa7\x51\x83\x62\x13\x63\xa3\x63\xc2\x53\xd2\x43\xe2"
            "\x34\xe1\x20\xf2\x14\xe0\x4f\x24\xe0\x54\xe0\x11\x34"
            "\xe1\x53\xe1\x53\xd1\x73\xa2\xa3\x62\xe7\xa4" }  },
      /* --- pixel bitmap for cmmib210 char#68 D --- */
      {  68, 4649,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 25,   20, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x01\xd4\x73\xa4\x93\x20\xf1\x74\xa3\x10\x74\xa4"
            "\xf3\x64\xb4\x54\xc3\x10\xf1\x54\xb4\x10\x54\xb3\x64"
            "\xb4\x64\xa4\x74\xa3\x84\x84\x84\x74\x7e\x02\x91" }  },
      /* --- pixel bitmap for cmmib210 char#69 E --- */
      {  69, 6154,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x03\x84\x73\xf2\x74\x92\x74\x91\x74\x41\x51\x74"
            "\x41\xd4\x32\xd9\x70\xf1\x54\x41\x80\x54\x41\x61\x64"
            "\xa1\x20\xf1\x44\xb1\x20\x44\xa1\x74\x92\x64\x84\x3e"
            "\x04\x4a" }  },
      /* --- pixel bitmap for cmmib210 char#70 F --- */
      {  70, 7441,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x03\x84\x73\xf2\x74\x92\x74\x91\x74\x41\x51\x74"
            "\x41\xd4\x32\xd9\x70\xf2\x54\x41\x80\x54\xd0\xf3\x44"
            "\xe0\x34\xe0\x1b\xb1" }  },
      /* --- pixel bitmap for cmmib210 char#71 G --- */
      {  71, 8636,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa7\x51\x83\x62\x13\x63\xa3\x63\xc2\x53\xd2\x43\xe2"
            "\x34\xe1\x20\xf2\x14\xe0\x44\xe0\x54\x8a\x1f\x14\xc4"
            "\x34\xb4\x40\xf1\x13\xb4\x40\x23\x95\x83\x62\x12\xb7"
            "\x41\x5a" }  },
      /* --- pixel bitmap for cmmib210 char#72 H --- */
      {  72, 9967,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 27,   20, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x2a\x84\x84\x30\xf3\x74\x84\x40\xf2\x64\x84\x50"
            "\x6e\x02\x50\xf3\x54\x84\x60\xf3\x44\x84\x70\x34\x84"
            "\x8a\x2a\x50" }  },
      /* --- pixel bitmap for cmmib210 char#73 I --- */
      {  73,10776,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x84\x30\xf3\x74\x40\xf3\x64\x50\xf3\x54\x60\xf3"
            "\x44\x70\x34\x8a\x54" }  },
      /* --- pixel bitmap for cmmib210 char#74 J --- */
      {  74,11636,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7a\xb4\x20\xf3\xa4\x30\xf3\x94\x40\xf3\x84\x50\x74"
            "\x73\x34\x64\x34\x63\x34\x72\x34\x96\xa4" }  },
      /* --- pixel bitmap for cmmib210 char#75 K --- */
      {  75,12913,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 27,   20, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x57\x84\xa2\xa4\xa1\xc4\x91\xd4\x71\xe0\x14\x61"
            "\xe0\x14\x61\xe0\x24\x41\xe0\x44\x33\xe0\x34\x15\xe0"
            "\x24\x11\x24\xe0\x15\x34\xa0\xf1\x54\x54\x90\xf1\x44"
            "\x74\x80\xf1\x44\x84\x70\x34\x95\x6a\x49\x40" }  },
      /* --- pixel bitmap for cmmib210 char#76 L --- */
      {  76,13946,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5b\xb4\x70\xf3\x74\x80\xf3\x64\x90\xf2\x54\xa0\x54"
            "\x91\xf1\x44\x91\x10\x44\x81\x64\x72\x54\x64\x2e\x02"
            "\x34" }  },
      /* --- pixel bitmap for cmmib210 char#77 M --- */
      {  77,15350,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 33,   20, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x57\xd8\x84\xc1\x14\xa1\x13\xc5\xb1\x13\xb1\x14\x40"
            "\xf1\x71\x13\xa1\x24\x40\x61\x33\x81\x24\x50\xf1\x61"
            "\x33\x71\x34\x50\x61\x33\x61\x44\xa1\x43\x51\x44\xb1"
            "\x53\x41\x44\xb1\x53\x31\x54\xb1\x53\x21\x64\xa1\x63"
            "\x21\x54\xb1\x63\x11\x64\xb1\x64\x74\xb1\x73\x74\xa1"
            "\x82\x74\x87\x51\x5a\x50" }  },
      /* --- pixel bitmap for cmmib210 char#78 N --- */
      {  78,16642,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 27,   20, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x57\x87\x85\xa1\xa1\x14\x91\xb1\x15\x81\xb1\x24\x81"
            "\xb1\x34\x71\xa1\x44\x61\x50\xf1\x61\x54\x51\x50\x61"
            "\x64\x41\xa1\x74\x31\xb1\x84\x21\xb1\x85\x11\xb1\x94"
            "\x11\xa1\xa5\xb1\xb4\x70\xf1\x41\xc3\x70\x31\xe1\x87"
            "\xb1\x84" }  },
      /* --- pixel bitmap for cmmib210 char#79 O --- */
      {  79,17547,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa7\xc4\x53\x93\x83\x64\xa3\x44\xb3\x43\xc4\x24\xc4"
            "\xf2\x14\xd4\x0f\x24\xd4\x14\xc4\x24\xc3\x43\xb4\x43"
            "\xa4\x63\x84\x83\x54\xc7\xa4" }  },
      /* --- pixel bitmap for cmmib210 char#80 P --- */
      {  80,18714,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x01\xb4\x64\x84\x83\x10\xf2\x74\x84\xf1\x64\x84"
            "\x10\x64\x74\x84\x64\x8c\x60\xf2\x54\xe0\xf3\x44\xe0"
            "\x10\x34\xe0\x2a\xd4" }  },
      /* --- pixel bitmap for cmmib210 char#81 Q --- */
      {  81,19761,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 22,   26, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa7\xc4\x53\x93\x83\x64\xa3\x44\xb3\x43\xc4\x24\xc4"
            "\xf2\x14\xd4\x0f\x24\xd4\x14\xc4\x24\xc3\x43\xb4\x43"
            "\x43\x34\x63\x21\x31\x14\x84\x44\xc8\x51\xe2\x51\xe2"
            "\x42\xe7\x40\xf1\xb6\x50\xc3\x71" }  },
      /* --- pixel bitmap for cmmib210 char#82 R --- */
      {  82,21148,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 24,   20, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\xd4\x63\xa4\x83\x20\xf2\x74\x84\x10\x64\x84\x84"
            "\x83\x94\x64\xab\xc4\x64\xa4\x73\x50\xf1\x54\x74\x40"
            "\xf2\x44\x74\x50\x44\x74\x41\x34\x84\x31\x1a\x75\x22" }  },
      /* --- pixel bitmap for cmmib210 char#83 S --- */
      {  83,22267,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x31\x72\x64\x53\x82\x62\xa1\x10\xf1\x43\xa1\x10"
            "\x34\xe0\x26\xda\xaa\xaa\xc8\xe5\xe0\x14\x20\xf1\x11"
            "\xb3\x30\x11\xb2\x52\x92\x54\x72\x61\x37\x8a" }  },
      /* --- pixel bitmap for cmmib210 char#84 T --- */
      {  84,23325,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x05\x23\x64\x52\x22\x64\x62\x21\x74\x62\x11\x84"
            "\x62\x11\x84\x61\x11\x84\x71\x10\xf2\x94\x90\xf3\x84"
            "\xa0\xf3\x74\xb0\x64\xed\x74" }  },
      /* --- pixel bitmap for cmmib210 char#85 U --- */
      {  85,24365,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1a\x57\x44\xb1\x30\xf3\x34\xb1\x40\xf3\x24\xb1\x50"
            "\xf3\x14\xb1\x64\xb1\x83\xb1\x83\xa1\x94\x81\xc3\x52"
            "\xe7\xc3" }  },
      /* --- pixel bitmap for cmmib210 char#86 V --- */
      {  86,25361,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x86\x24\xd1\x54\xc2\x55\xb1\x74\xa1\x50\xf1\x34"
            "\x91\x60\x35\x71\xb4\x61\xc4\x52\xc4\x51\xd4\x41\xe5"
            "\x21\xe0\x24\x21\xe0\x24\x11\xc0\xf1\x55\xd0\x54\xe0"
            "\x62\xe0\x71\xe0\x26" }  },
      /* --- pixel bitmap for cmmib210 char#87 W --- */
      {  87,26805,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 33,   20, 3,133, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x09\x3a\x56\xf1\x24\x94\xa1\x30\x24\x94\x91\x64\x94"
            "\x81\x75\x75\x81\x84\x61\x14\x71\x94\x61\x15\x51\xa4"
            "\x51\x34\x51\xa4\x42\x34\x41\xb4\x41\x44\x32\xb5\x21"
            "\x54\x31\xd4\x21\x54\x21\xe4\x11\x64\x21\xe5\x76\xe0"
            "\x15\x84\xe0\x24\x94\xe0\x23\xa3\xe0\x33\xa2\xe0\x51"
            "\xb2\xe4" }  },
      /* --- pixel bitmap for cmmib210 char#88 X --- */
      {  88,28064,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 27,   20, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x48\x84\x92\xc5\x72\xe4\x62\xe0\x15\x42\xe0\x34"
            "\x32\xe0\x45\x12\xe0\x66\xe0\x75\xe0\x94\xe0\x95\xe0"
            "\x71\x14\xe0\x61\x25\xe0\x41\x44\xe0\x31\x55\xe0\x11"
            "\x74\xe1\x85\xc1\xa4\xb1\xb5\x68\x69\x41" }  },
      /* --- pixel bitmap for cmmib210 char#89 Y --- */
      {  89,29212,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 24,   20, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x86\x35\xc1\x74\xb1\x85\x92\x85\x82\xa5\x62\xb5"
            "\x61\xd5\x41\xe5\x31\xe0\x25\x11\xe0\x36\xb0\xf1\x84"
            "\xc0\x83\xd0\xf2\x74\xd0\x73\xe0\x64\xe0\x3a\xb0" }  },
      /* --- pixel bitmap for cmmib210 char#90 Z --- */
      {  90,30317,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x02\x53\x84\x53\x84\x62\x84\x71\x84\x81\x75\x71"
            "\x75\xe0\x24\xe0\x24\xe0\x24\xe0\x24\xe0\x24\xe0\x24"
            "\x71\x85\x61\x85\x71\x84\x72\x74\x81\x74\x82\x64\x74"
            "\x5e\x01\x65" }  },
      /* --- pixel bitmap for cmmib210 char#91 \flat --- */
      {  91,121199,                     /* character number, location */
         22, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  9,   22, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x81\x15\x23\x23\x1f\x31\x44\x01\x34\x11\x33"
            "\x21\x24\x21\x23\x31\x12\x53\x61\x81" }  },
      /* --- pixel bitmap for cmmib210 char#92 \natural --- */
      {  92,121972,                     /* character number, location */
         21, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  9,   27, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x01\x81\x63\x45\x26\x0f\x19\x06\x25\x43\x61\x0f"
            "\x41\x71\x01\x63\x45\x26\x0f\x19\x06\x25\x43\x61\xf1"
            "\x81" }  },
      /* --- pixel bitmap for cmmib210 char#93 \sharp --- */
      {  93,122859,                     /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  9,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x01\x12\x2c\x5e\xbf\xff\x7f\xbf\x1e\x0d\x12"
            "\x24\x48\x90\x20\x41\x82\xc5\xeb\xf7\xff\xef\xd7\xa3"
            "\x01\x02\x04\x00" }  },
      /* --- pixel bitmap for cmmib210 char#94 \smile --- */
      {  94,123793,                     /* character number, location */
         11, 2,    4, 2,      /* topleft row,col, and botleft row,col */
          { 29,    7, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\xd1\x11\xe0\xb1\x31\xe0\x91\x52\xe0\x52\x84"
            "\xb4\xce\x01\xe0\x39\xa4" }  },
      /* --- pixel bitmap for cmmib210 char#95 \frown --- */
      {  95,124667,                     /* character number, location */
         12, 2,    4, 2,      /* topleft row,col, and botleft row,col */
          { 29,    8, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\xe0\x8d\xee\x03\xa3\xe0\x13\x72\xe0\x52\x51\xe0"
            "\x91\x31\xe0\xb1\x11\xe0\xd1" }  },
      /* --- pixel bitmap for cmmib210 char#96 \ell --- */
      {  96,97541,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x0e\xc0\x04\x18\x01\x47\xc0\x10\x38\x02\x86\xc0"
            "\x11\x70\x02\x5c\x80\x13\xe0\x02\x78\x00\x0e\x80\x03"
            "\xf0\x00\x3a\x40\x0c\x0c\xc3\x00\x0f" }  },
      /* --- pixel bitmap for cmmib210 char#97 a --- */
      {  97,31271,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x67\x70\x78\x38\x70\x3c\x38\x1e\x38\x1e\x38\x1e"
            "\x38\x0f\x1c\x0f\x9c\x0e\x9c\x0e\x9c\x0c\x5f\xf8\x38" }  },
      /* --- pixel bitmap for cmmib210 char#98 b --- */
      {  98,32121,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   20, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\xb3\x70\xf3\x33\x80\x23\xb3\x15\x54\x42\x43\x53"
            "\x10\xf3\x13\x64\x0f\x13\x64\x10\x12\x63\x32\x53\x52"
            "\x33\x75\x61" }  },
      /* --- pixel bitmap for cmmib210 char#99 c --- */
      {  99,32942,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x64\x41\x43\x53\x24\x43\x24\x61\x20\xf1\x14\x9f"
            "\x14\xa0\x13\xb3\x91\x23\x62\x57\x32" }  },
      /* --- pixel bitmap for cmmib210 char#100 d --- */
      { 100,33916,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc5\xe3\xf3\xd3\x10\xc3\x85\x13\x63\x44\x53\x63\x44"
            "\x53\x30\xf2\x14\x63\x34\x63\x44\x63\x21\x10\xf1\x13"
            "\x63\x21\x10\x22\x45\x11\x55\x33\x31" }  },
      /* --- pixel bitmap for cmmib210 char#101 e --- */
      { 101,34773,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x63\x51\x43\x61\x34\x61\x24\x71\x24\x43\x38\x50"
            "\xf2\x13\xa0\x13\x91\x23\x62\x57\x33" }  },
      /* --- pixel bitmap for cmmib210 char#102 f --- */
      { 102,35953,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 16,   26, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb4\xb2\x22\x93\x13\x93\x22\xf1\x93\x40\x83\xaa\x10"
            "\xf3\x83\x50\xf4\x73\x60\xf3\x63\x70\x62\x92\x32\x83"
            "\x22\x92\x31\xb4\xb5" }  },
      /* --- pixel bitmap for cmmib210 char#103 g --- */
      { 103,36952,                      /* character number, location */
         13, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 16,   19, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x22\x53\x44\x43\x63\x34\x53\x10\xf2\x24\x63\x10"
            "\xf1\x14\x63\x20\xf1\x23\x63\x20\x32\x44\x75\x13\x30"
            "\xf1\xa3\x30\x12\x63\x43\x63\x42\x54\x68\x72" }  },
      /* --- pixel bitmap for cmmib210 char#104 h --- */
      { 104,37897,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\xe3\x90\xf3\x43\xa0\x33\xe3\x25\x73\x11\x43\x54"
            "\x53\x44\x63\x20\xf2\x23\x73\x20\x13\x73\x43\x73\x21"
            "\x13\x63\x31\x13\x63\x21\x13\x82\x21\x22\x93\x24" }  },
      /* --- pixel bitmap for cmmib210 char#105 i --- */
      { 105,38783,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\xe0\x40\x00\x00\x00\x00\x00\x3c\x72\x72\x71\x39"
            "\x38\x38\x1c\x9c\x8e\x4e\x4c\x38" }  },
      /* --- pixel bitmap for cmmib210 char#106 j --- */
      { 106,39742,                      /* character number, location */
         21,-1,   -6,-1,      /* topleft row,col, and botleft row,col */
          { 14,   27, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xc3\xb2\x10\xf4\xe0\x74\x91\x32\x71\x43\x61\x33"
            "\x61\x43\x20\xf1\x93\x20\xf3\x83\x30\xf3\x73\x40\x12"
            "\x33\x53\x32\x62\x32\x85\x83" }  },
      /* --- pixel bitmap for cmmib210 char#107 k --- */
      { 107,40797,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   20, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\xd3\x80\xf3\x43\x90\x33\xd3\x54\x43\x41\x23\x33"
            "\x31\x33\x23\x31\x42\x33\x12\xa4\xc7\x83\x33\x60\xf2"
            "\x13\x43\x31\x13\x53\x21\x32\x73\x31" }  },
      /* --- pixel bitmap for cmmib210 char#108 l --- */
      { 108,41543,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x38\x0e\x87\xc3\x71\x38\x1c\x8e\xc3\xe1\x70\x1c"
            "\x4e\xa7\xd3\xc5\x01" }  },
      /* --- pixel bitmap for cmmib210 char#109 m --- */
      { 109,42804,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 27,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x3e\xf8\x90\x09\x37\x8e\x3c\x78\x70\xf2\xc0\x83"
            "\x93\x03\x0e\x1c\x1c\x70\xe0\xe0\x80\x03\x87\x03\x0e"
            "\x1c\x1c\x70\xe0\xe4\x80\x83\x23\x07\x1c\x9c\x1c\x70"
            "\xc0\xc4\x00\x03\x1c" }  },
      /* --- pixel bitmap for cmmib210 char#110 n --- */
      { 110,43891,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x3e\xe8\x84\x23\x0b\x4e\x1e\x38\x39\xe0\xe0\x80"
            "\x83\x03\x0e\x07\x1c\x1c\x70\x72\xe0\xc8\x81\x93\x03"
            "\x4c\x0c\xe0\x00" }  },
      /* --- pixel bitmap for cmmib210 char#111 o --- */
      { 111,44663,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   13, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\x74\x33\x53\x63\x34\x64\xf2\x14\x74\x0f\x14\x74"
            "\x10\x13\x73\x33\x63\x53\x43\x86\x63" }  },
      /* --- pixel bitmap for cmmib210 char#112 p --- */
      { 112,45663,                      /* character number, location */
         13,-1,   -6,-1,      /* topleft row,col, and botleft row,col */
          { 18,   19, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x35\x61\x13\x11\x42\x51\x23\x53\x10\xf1\x21\x23"
            "\x64\xf1\x53\x64\xf1\x43\x64\x10\x43\x63\x63\x53\x64"
            "\x43\x73\x15\x60\xf1\x33\xc0\xf2\x23\xd7\xb3" }  },
      /* --- pixel bitmap for cmmib210 char#113 q --- */
      { 113,46610,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x31\x43\x44\x33\x63\x24\x53\x10\xf2\x14\x63\x1f"
            "\x14\x63\x20\xf1\x13\x63\x20\x22\x44\x65\x13\x30\xf1"
            "\x93\x30\xf2\x83\x40\x58\x20" }  },
      /* --- pixel bitmap for cmmib210 char#114 r --- */
      { 114,47489,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x9e\x6e\x2e\x87\xe7\x61\x39\x00\x0e\x80\x03\x70"
            "\x00\x1c\x00\x07\xc0\x01\x38\x00\x0c\x00" }  },
      /* --- pixel bitmap for cmmib210 char#115 s --- */
      { 115,48439,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x41\x18\xce\x61\x3c\x80\x1f\xf0\x03\x78\x02"
            "\x76\x60\x03\x32\x18\xfc\x00" }  },
      /* --- pixel bitmap for cmmib210 char#116 t --- */
      { 116,49195,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\xc0\x01\x07\x1c\x38\xfc\x8f\x03\x0e\x1c\x70\xc0"
            "\x01\x07\x0e\x38\xe4\x90\x23\x4e\xf0\x00" }  },
      /* --- pixel bitmap for cmmib210 char#117 u --- */
      { 117,50247,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xc0\xe4\xc0\xc9\x81\x8b\x83\x93\x03\x07\x07\x0e"
            "\x0e\x1c\x0e\x1c\x1c\x38\x39\x70\x72\xf0\xc4\xd0\x05"
            "\x1f\x07" }  },
      /* --- pixel bitmap for cmmib210 char#118 v --- */
      { 118,51158,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x98\x1c\x2f\xc7\xc7\xf1\x39\x30\x0e\x88\x03\x72"
            "\x40\x1c\x10\x07\xc2\x41\xe0\x18\xf0\x01" }  },
      /* --- pixel bitmap for cmmib210 char#119 w --- */
      { 119,52378,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x60\x4c\x0e\xce\xcb\xc1\xf9\x38\x1c\x9f\x83\x83"
            "\x71\x70\x20\x0e\x0e\xe4\xe0\x40\x1c\x1c\x88\x83\x83"
            "\x70\x70\x10\x1c\x0d\x01\x1f\x1f\x00" }  },
      /* --- pixel bitmap for cmmib210 char#120 x --- */
      { 120,53632,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xf0\x10\x9f\x13\x1c\x17\x1c\x26\x38\x00\x70\x00"
            "\xe0\x00\xe0\x00\xc0\x41\x86\x83\x1c\x87\x18\x8d\xe0"
            "\xf1\x00" }  },
      /* --- pixel bitmap for cmmib210 char#121 y --- */
      { 121,54750,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 16,   19, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x82\xf1\x11\x23\x63\x01\x33\x53\x11\x23\x63\x10"
            "\xf1\x33\x63\x10\xf2\x23\x63\x20\x23\x54\x52\x44\x75"
            "\x13\xd3\xc3\x53\x53\x53\x43\x71\x42\xa4\x93" }  },
      /* --- pixel bitmap for cmmib210 char#122 z --- */
      { 122,55702,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\x51\x46\x21\x4a\xb2\xb1\xc1\xb2\xb1\xc1\x71\x41"
            "\x72\x3a\x32\x26\x31\x63\x43" }  },
      /* --- pixel bitmap for cmmib210 char#123 \imath --- */
      { 123,98335,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x72\x72\x71\x39\x38\x38\x1c\x9c\x8e\x4e\x4c\x38" }  },
      /* --- pixel bitmap for cmmib210 char#124 \jmath --- */
      { 124,99174,                      /* character number, location */
         13,-1,   -6,-1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x74\x81\x32\x61\x43\x51\x33\x51\x43\x10\xf1\x93\x10"
            "\xf3\x83\x20\xf3\x73\x30\x12\x33\x43\x33\x42\x32\x75"
            "\x73" }  },
      /* --- pixel bitmap for cmmib210 char#125 \wp --- */
      { 125,100337,                     /* character number, location */
         13, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x00\xc0\xc0\x07\x83\x61\x08\x03\x66\x04\x70\x13"
            "\x80\x5b\x00\xfc\x01\x70\x0f\x80\x73\x08\x8c\x47\x70"
            "\x7c\xc2\xa0\xe7\x03\x39\x00\x88\x03\x40\x0c\x00\x62"
            "\x00\x10\x01\x00\x07\x00\x00" }  },
      /* --- pixel bitmap for cmmib210 char#126 \bfvec --- */
      { 126,100991,                     /* character number, location */
         21, 6,   15, 6,      /* topleft row,col, and botleft row,col */
          { 15,    6, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\xd3\x2f\x1e\x01\x93\xc2\x41" }  },
      /* --- pixel bitmap for cmmib210 char#127 (noname) --- */
      { 127,101533,                     /* character number, location */
         19, 8,   16, 8,      /* topleft row,col, and botleft row,col */
          { 13,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xc7\x00\x05\x40" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=7 for .250gf ---
 * mf '\mode=preview; mag=magstep(-12.84858895680446863032); input cmmib10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmmib250 --- */
static	chardef  cmmib250[] =
   {
      /* --- pixel bitmap for cmmib250 char#0 \Gamma --- */
      {   0,57268,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x6e\x06\x95\x84\xf2\x95\x92\x10\xf2\x85\xa2\x10"
            "\x85\xd0\xf3\x75\xe0\xf3\x65\xe0\x10\xf3\x55\xe0\x20"
            "\x1d\xce\xc4" }  },
      /* --- pixel bitmap for cmmib250 char#1 \Delta --- */
      {   1,58197,                      /* character number, location */
         25, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 29,   25, 3,120, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x53\xe0\xb4\xe0\xb5\xe0\x96\xe0\x87\xe0\x72\x16"
            "\xe0\x53\x16\xe0\x52\x26\xe0\x42\x45\xe0\x32\x56\xe0"
            "\x13\x56\xe3\x75\xe2\x86\xc2\x96\xb2\xb5\xa3\xb6\x83"
            "\xc6\x82\xd6\x72\xe0\x15\x62\xe0\x26\x43\xe0\x26\x3e"
            "\x0c\x3e\x0d\x1e\x0e\x0e\x0e\x01" }  },
      /* --- pixel bitmap for cmmib250 char#2 \Theta --- */
      {   2,59400,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 28,   26, 3,125, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd9\xe0\x34\x54\xd3\xa4\x94\xc4\x74\xd4\x64\xe0\x14"
            "\x45\xe0\x14\x35\xe0\x24\x34\xe0\x34\x25\xe0\x34\x25"
            "\x32\x72\x34\xf3\x15\x3b\x35\x14\x32\x72\x35\x15\xe0"
            "\x35\x24\xe0\x34\x34\xe0\x25\x34\xe0\x15\x44\xe0\x14"
            "\x64\xd4\x74\xc4\x94\xa3\xd4\x55\xe0\x29\xc2" }  },
      /* --- pixel bitmap for cmmib250 char#3 \Lambda --- */
      {   3,60444,                      /* character number, location */
         25, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 26,   25, 3,108, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x42\xe0\x93\xe0\x94\xe0\x75\x50\xf1\xe0\x16\x50"
            "\xf1\xe7\x50\xd2\x15\xe0\x32\x25\xe0\x32\x26\xe0\x12"
            "\x36\xe3\x36\xe2\x55\x40\xf1\x92\x65\x40\x82\x75\xb2"
            "\x85\xb2\x86\x92\x96\x83\x96\x82\xb5\x72\xc5\x48\x6e"
            "\x06\x5c" }  },
      /* --- pixel bitmap for cmmib250 char#4 \Xi --- */
      {   4,61901,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 29,   24, 3,95, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x6e\x09\xf1\x5e\x09\x10\xf1\x52\xe0\x52\x10\x42"
            "\xe0\x52\xe0\xe0\x30\xf1\x82\xb2\x60\xf3\x7e\x01\x70"
            "\xf1\x62\xb2\x80\xe0\xe0\x32\xe0\x52\x40\xf1\x12\xe0"
            "\x52\x50\xf1\x1e\x09\x5f\x1e\x09\x65" }  },
      /* --- pixel bitmap for cmmib250 char#5 \Pi --- */
      {   5,63204,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 35,   24, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x0e\x01\x6e\x0e\x10\xf3\x95\xb5\x50\xf3\x85\xb5"
            "\x60\xf3\x75\xb5\x70\xf3\x65\xb5\x80\xf3\x55\xb5\x90"
            "\x1c\x4c\x6d\x3d\x60" }  },
      /* --- pixel bitmap for cmmib250 char#6 \Sigma --- */
      {   6,64417,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 30,   24, 3,95, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x6e\x0a\x66\xc6\x76\xd3\x87\xd2\x96\xd2\x10\xf1"
            "\x96\xc2\x10\xa6\xb2\xb7\xe0\xa6\xd0\xf1\xc6\xc0\xd3"
            "\xe0\xc3\xa2\xe3\xb2\xc3\xd2\xb3\xd2\xb3\xd3\x93\xe4"
            "\x83\xd5\x8e\x08\x6e\x09\x6e\x0a\x65" }  },
      /* --- pixel bitmap for cmmib250 char#7 \Upsilon --- */
      {   7,65505,                      /* character number, location */
         25, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 27,   25, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\xb5\x58\x78\x39\x6a\x1b\x4e\x54\x34\x55\x73\x24"
            "\x72\x94\x13\xe0\x57\xe0\x76\xe0\x75\xe0\x76\xc0\xf3"
            "\x95\xd0\xf3\x85\xe0\xf3\x75\xe0\x10\x2e\xce\x01\xb4" }  },
      /* --- pixel bitmap for cmmib250 char#8 \Phi --- */
      {   8,66581,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   24, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\x01\xae\x30\xf3\xc5\x80\x8c\xa4\x25\x24\x64\x45"
            "\x44\x34\x55\x45\x15\x45\x55\x0f\x15\x55\x55\x05\x55"
            "\x45\x15\x45\x54\x34\x45\x44\x64\x25\x24\xac\x80\xf3"
            "\x85\xc0\x3e\xae\x01\x89" }  },
      /* --- pixel bitmap for cmmib250 char#9 \Psi --- */
      {   9,67720,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 27,   24, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x01\xce\x60\xf2\xb5\xb5\x65\x56\x15\x45\x55\x20"
            "\xf2\x15\x45\x45\x3f\x15\x45\x45\x45\x45\x44\x64\x45"
            "\x35\x64\x35\x35\x84\x25\x25\xa4\x1a\xea\xc0\xf3\x75"
            "\xe0\x10\x2e\xce\x01\xb9" }  },
      /* --- pixel bitmap for cmmib250 char#10 \Omega --- */
      {  10,68967,                      /* character number, location */
         25, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 28,   25, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd9\xe0\x24\x74\xb4\xa4\x94\xc4\x74\xd5\x54\xe5\x45"
            "\xe5\x44\xe0\x15\xf1\x35\xe0\x15\x35\xe0\x14\x45\xe5"
            "\x45\xe4\x55\xd4\x74\xc4\x84\xc3\xa3\xb3\xc2\xb2\x82"
            "\x32\xa2\x42\x32\x41\x92\x42\x33\x41\x91\x52\x39\x78"
            "\x48\x88\x48\x79\x48\x78\x54" }  },
      /* --- pixel bitmap for cmmib250 char#11 \alpha --- */
      {  11,70023,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   15, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\xd3\x43\x52\x33\x73\x42\x23\x84\x32\x14\x94\x12"
            "\x23\xa4\x12\x1f\x14\xa6\x24\xa5\x3f\x23\xb4\x40\x13"
            "\x82\x13\x31\x23\x53\x24\x12\x46\x74\x13" }  },
      /* --- pixel bitmap for cmmib250 char#12 \beta --- */
      {  12,71098,                      /* character number, location */
         24,-1,   -7,-1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe6\xe0\x12\x52\xc2\x73\xa2\x84\x82\x94\x72\xa4\x72"
            "\xa3\x72\xa4\x72\xa3\x82\x39\x82\x32\x44\x82\x46\x13"
            "\x72\xb3\x72\xb4\x10\xf3\x42\xc4\x10\xf1\x33\xb4\x20"
            "\x33\xa4\x64\x93\x62\x22\x63\x82\x47\x80\xf1\x22\xe0"
            "\x50\xf3\x12\xe0\x62\xe0\x74" }  },
      /* --- pixel bitmap for cmmib250 char#13 \gamma --- */
      {  13,72085,                      /* character number, location */
         15, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 22,   23, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x92\x48\x72\x3b\x52\x36\x16\x42\x32\x93\x22\x32"
            "\xb2\x22\xe0\x22\x12\x40\xf1\xe4\x40\xf1\xe3\x50\xf2"
            "\xe2\x60\xf2\xd3\x60\xf3\xc3\x70\xc2\xe0\x61\x94" }  },
      /* --- pixel bitmap for cmmib250 char#14 \delta --- */
      {  14,73060,                      /* character number, location */
         25, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   25, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x93\xb9\x71\x44\x62\x52\x72\xe3\xd4\xd4\xc5\xc5\xa7"
            "\x73\x15\x53\x36\x33\x55\x24\x55\x23\x74\x1f\x24\x74"
            "\x13\x83\x23\x74\x23\x73\x43\x62\x63\x42\x96\x64" }  },
      /* --- pixel bitmap for cmmib250 char#15 \epsilon --- */
      {  15,73952,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   15, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x4a\x34\x94\x94\xa3\xaf\x1c\x2f\x24\xa0\x13\xb3"
            "\x81\x43\x43\x66\x33" }  },
      /* --- pixel bitmap for cmmib250 char#16 \zeta --- */
      {  16,74896,                      /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 17,   31, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xa2\x50\xa6\xa3\x32\x72\x25\x72\xe2\xe2\xe3\xe2"
            "\xe2\xd0\xf1\x13\xdf\x43\xe4\xd5\xc7\xb9\x9b\x7b\x98"
            "\xc5\x30\xf1\xb3\x30\x62\x32\xc4\x53" }  },
      /* --- pixel bitmap for cmmib250 char#17 \eta --- */
      {  17,75837,                      /* character number, location */
         15, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 21,   23, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x55\x61\x23\x22\x43\x31\x35\x63\x10\xf1\x12\x34"
            "\x74\xf3\x54\x74\x10\xf3\x44\x74\x20\x34\x74\x72\x84"
            "\x30\xf1\xe4\x30\xf3\xd4\x40\xc4\xe0\x42\x66" }  },
      /* --- pixel bitmap for cmmib250 char#18 \theta --- */
      {  18,76655,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   24, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x95\xb3\x33\x83\x52\x73\x63\x54\x63\x53\x74\x34\x74"
            "\x33\x84\xf1\x24\x84\x14\x84\x10\xf1\x1e\x02\x10\x14"
            "\x84\x1f\x14\x84\x24\x83\x34\x74\x34\x73\x53\x64\x53"
            "\x63\x72\x53\x83\x33\xb5\x93" }  },
      /* --- pixel bitmap for cmmib250 char#19 \iota --- */
      {  19,77330,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x50\xf3\x34\x50\xf2\x24\x60\x14\x84\x61\x14\x56"
            "\x66\x52\x23\x33\x45\x54" }  },
      /* --- pixel bitmap for cmmib250 char#20 \kappa --- */
      {  20,78250,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   15, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x84\x54\x66\x54\x51\x24\x54\x32\x42\x64\x21\xd4"
            "\x12\xe8\xd4\x26\x94\x63\x74\x74\x41\xf1\x14\x74\x32"
            "\x14\x74\x22\x14\x93\x21\x32\xb4\x34" }  },
      /* --- pixel bitmap for cmmib250 char#21 \lambda --- */
      {  21,79135,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 20,   24, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\xe0\x25\xe0\x24\xe0\x25\xe0\x24\xe0\x25\xe0\x24"
            "\x80\xf1\x85\x70\xf1\x95\x60\xa4\x60\xf1\xa5\x50\x97"
            "\xb4\x14\xa4\x25\x84\x44\x65\x55\x45\x65\x35\x85\x15"
            "\x95\x14\xb4\x13\xc5" }  },
      /* --- pixel bitmap for cmmib250 char#22 \mu --- */
      {  22,80165,                      /* character number, location */
         15, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 23,   23, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x83\x30\xf3\x54\x74\x30\xf3\x44\x74\x40\x34\x74"
            "\x41\xf1\x34\x74\x32\x34\x65\x22\x36\x42\x13\x21\x4a"
            "\x44\x30\xf1\x24\xe0\x30\xf3\x14\xe0\x44\xe0\x62\xe0"
            "\x65" }  },
      /* --- pixel bitmap for cmmib250 char#23 \nu --- */
      {  23,80990,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   15, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x17\x93\x16\x94\xf1\x34\x94\x34\x84\x34\x94\x34\x84"
            "\x44\x74\x54\x73\x54\x73\x64\x54\x74\x43\x94\x23\xa8"
            "\xc4\xe0\x21" }  },
      /* --- pixel bitmap for cmmib250 char#24 \xi --- */
      {  24,82154,                      /* character number, location */
         24, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 16,   31, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xa2\x40\xa1\xe6\x84\x32\x54\x24\x54\x80\xf4\x34"
            "\x90\x49\x83\x42\x62\x16\x62\xd2\xd3\xcf\x13\xd4\xc5"
            "\xb8\x9a\x7c\x6b\x88\xb5\xd3\x81\x42\xa5\x30" }  },
      /* --- pixel bitmap for cmmib250 char#25 \pi --- */
      {  25,83122,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   15, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x03\x3e\x06\x1e\x06\x22\x43\x32\x72\x52\x42\xe2"
            "\x42\x70\xf1\x63\x33\x70\x53\x43\xc3\x44\xa4\x44\xa4"
            "\x45\x84\x55\x84\x64\x92\x82\x61" }  },
      /* --- pixel bitmap for cmmib250 char#26 \rho --- */
      {  26,83978,                      /* character number, location */
         15, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 20,   23, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa7\xb3\x52\x93\x63\x73\x74\x54\x74\x53\x84\xf2\x44"
            "\x84\xf1\x34\x84\x10\x34\x74\x54\x73\x56\x43\x74\x25"
            "\x70\xf1\x24\xe0\xf3\x14\xe0\x14\xe0\x32\xe0\x32" }  },
      /* --- pixel bitmap for cmmib250 char#27 \sigma --- */
      {  27,84904,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   15, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x5e\x04\x3e\x04\x34\x64\x60\xf1\x14\x74\x6f\x24"
            "\x84\x6f\x13\x84\x73\x83\x83\x73\xa3\x44\xd6\xd4" }  },
      /* --- pixel bitmap for cmmib250 char#28 \tau --- */
      {  28,85707,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x01\x4e\x03\x1e\x04\x22\x62\x92\x63\x90\xf1\x83"
            "\x90\xf2\x73\xa0\xf2\x64\xa0\x54\xe0\x33\xb6" }  },
      /* --- pixel bitmap for cmmib250 char#29 \upsilon --- */
      {  29,86616,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 21,   15, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x82\x52\x23\x64\x32\x34\x55\x12\x34\x74\x12\x34"
            "\x83\x64\x82\x10\xf1\x54\x92\x10\x54\x82\x64\x92\x64"
            "\x82\x74\x81\x93\x71\xb3\x42\xe6\x70" }  },
      /* --- pixel bitmap for cmmib250 char#30 \phi --- */
      {  30,87532,                      /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 22,   31, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe2\x60\xf3\xd2\x70\xf2\xc2\x80\x89\xa4\x22\x33"
            "\x73\x42\x43\x44\x52\x53\x24\x62\x54\x14\x52\x64\x0f"
            "\x24\x62\x64\x04\x52\x64\x14\x52\x63\x24\x52\x53\x43"
            "\x52\x43\x73\x22\x33\xb9\x80\xf1\x82\xc0\xf3\x72\xd0"
            "\x62\xe3" }  },
      /* --- pixel bitmap for cmmib250 char#31 \chi --- */
      {  31,88637,                      /* character number, location */
         15, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x26\xd1\x12\x25\x95\x44\x83\x75\x63\x94\x53\xa5\x33"
            "\xc4\x23\xd4\x13\xe7\xe0\x25\x80\xf1\x94\x90\x85\xe0"
            "\x27\xe3\x14\xd3\x24\xc3\x35\xa3\x54\x93\x65\x73\x84"
            "\x45\x95\x22\x11\xd6\x29" }  },
      /* --- pixel bitmap for cmmib250 char#32 \psi --- */
      {  32,89738,                      /* character number, location */
         24, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 25,   31, 3,137, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x32\x60\xf3\xe0\x22\x70\xf2\xe0\x12\x80\x44"
            "\x72\x43\x41\x23\x52\x44\x31\x34\x42\x45\x12\x24\x52"
            "\x54\x12\x24\x52\x63\x54\x42\x72\x10\xf1\x44\x52\x72"
            "\x10\x44\x52\x62\x54\x52\x72\x54\x52\x62\x73\x52\x52"
            "\x84\x42\x42\xb4\x12\x32\xe0\x18\x90\xf1\xb2\xc0\xf3"
            "\xa2\xd0\x92\xe7" }  },
      /* --- pixel bitmap for cmmib250 char#33 \omega --- */
      {  33,90883,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   15, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\xe3\x33\xd4\x32\xe5\x13\xe0\x14\x12\xe0\x35\x82"
            "\x82\x1f\x12\x74\x72\x12\x73\x73\x12\x73\x72\x23\x54"
            "\x63\x25\x18\x15\x4e\x04\x58\x27\x84\x54\x74" }  },
      /* --- pixel bitmap for cmmib250 char#34 \varepsilon --- */
      {  34,91880,                      /* character number, location */
         16, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x7b\x34\x63\x23\xb0\xf1\x22\xc0\x22\x24\x94\x22"
            "\x79\x62\xdf\x22\xe2\xc1\x23\x82\x4b\x68\x52" }  },
      /* --- pixel bitmap for cmmib250 char#35 \vartheta --- */
      {  35,92899,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 22,   24, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe4\xe0\x22\x42\xd2\x53\x10\xf1\xa2\x63\x10\xf2\xa2"
            "\x64\xb2\x54\x44\x33\x44\x31\x23\x43\x14\x31\x34\x56"
            "\x22\x34\x75\x12\x34\x74\x10\xf1\x54\x74\x20\x54\x73"
            "\x84\x64\x30\xf1\x44\x73\x40\x44\x63\xa3\x53\xb4\x33"
            "\xe6\x92" }  },
      /* --- pixel bitmap for cmmib250 char#36 \varpi --- */
      {  36,94178,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 32,   15, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x0d\x3e\x0e\x02\x1e\x0e\x02\x22\x32\xe0\x52\x32"
            "\x32\xe0\x62\x82\x92\x92\x30\xf1\x42\xa2\x92\x30\x42"
            "\x93\x82\x73\x84\x82\x73\x75\x72\x92\x54\x13\x44\x9a"
            "\x2a\xb7\x57\xe4\x85\x93" }  },
      /* --- pixel bitmap for cmmib250 char#37 \varrho --- */
      {  37,95105,                      /* character number, location */
         15, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 18,   22, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x93\x52\x73\x63\x53\x74\x34\x74\x33\x84\xf2\x24"
            "\x84\xf1\x14\x84\x10\x14\x74\x35\x63\x33\x12\x43\x52"
            "\x36\x7f\x12\xe0\x23\xe0\x1d\x6d\x6c\xe0\x12\x54" }  },
      /* --- pixel bitmap for cmmib250 char#38 \varsigma --- */
      {  38,95952,                      /* character number, location */
         15, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x53\x52\x32\xc2\xc3\xbf\x13\xc4\xb5\xa8\x89\x7a"
            "\x79\x87\xa5\x20\xf1\xa2\x30\x74\x43" }  },
      /* --- pixel bitmap for cmmib250 char#39 \varphi --- */
      {  39,96895,                      /* character number, location */
         15, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 22,   23, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\xa4\x52\xa7\x32\x8a\x12\x93\x43\x12\x82\x72\x0f"
            "\x12\x82\x82\x02\x72\x94\x72\x82\x12\x62\x83\x13\x52"
            "\x73\x35\x22\x45\x5e\x02\x7d\xc8\x80\xf2\x63\xd0\xf2"
            "\x54\xd0\x44\xe0\x53\xe3" }  },
      /* --- pixel bitmap for cmmib250 char#40 \bfleftharpoonup --- */
      {  40,113069,                     /* character number, location */
         18, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          { 36,   11, 2,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x08\x03\x19\x00\xff\x01\x07\x03\x1a\x00\x06"
            "\x03\x20\x04\x1f\x04\x1f\x04\x1e\x22\x01\x47\x01" }  },
      /* --- pixel bitmap for cmmib250 char#41 \bfleftharpoondown --- */
      {  41,114105,                     /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 36,   11, 2,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x23\x01\x24\x01\x22\x04\x04\x21\x04\x21\x04\x21"
            "\x03\x1b\x00\xff\x01\x07\x03\x1a\x00\xff\x01\x08\x03"
            "\x19" }  },
      /* --- pixel bitmap for cmmib250 char#42 \bfrightharpoonup --- */
      {  42,115139,                     /* character number, location */
         18, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          { 36,   11, 2,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x19\x03\x08\x00\xff\x01\x1a\x03\x07\x00\x1b"
            "\x03\x21\x04\x21\x04\x21\x04\x04\x22\x01\x24\x01\x23" }  },
      /* --- pixel bitmap for cmmib250 char#43 \bfrightharpoondown --- */
      {  43,116176,                     /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 36,   11, 2,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x47\x01\x22\x1e\x04\x1f\x04\x1f\x04\x20\x03\x06"
            "\x00\xff\x01\x1a\x03\x07\x00\xff\x01\x19\x03\x08" }  },
      /* --- pixel bitmap for cmmib250 char#44 ` --- */
      {  44,116605,                     /* character number, location */
         18, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          {  7,   11, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x25\x1a\x3f\x23\x44\x46\x25\x34" }  },
      /* --- pixel bitmap for cmmib250 char#45 ' --- */
      {  45,117035,                     /* character number, location */
         18, 2,    7, 2,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8f\xcf\x0f\x0f\x87\xc3\xf1\xbf\xcf\x03" }  },
      /* --- pixel bitmap for cmmib250 char#46 \triangleright --- */
      {  46,117582,                     /* character number, location */
         19, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 18,   21, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x12\xe0\x15\xd6\xc8\xa3\x16\x83\x26\x73\x46\x53\x66"
            "\x33\x76\x23\x99\xb7\x99\x76\x23\x66\x33\x46\x53\x26"
            "\x73\x16\x88\xa6\xc5\xe2\xe0\x13" }  },
      /* --- pixel bitmap for cmmib250 char#47 \triangleleft --- */
      {  47,118174,                     /* character number, location */
         19, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 18,   21, 3,66, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x13\xe4\xc6\xa8\x99\x76\x23\x56\x43\x46\x53\x26"
            "\x73\x15\x98\xa3\x15\x93\x26\x73\x46\x53\x56\x43\x76"
            "\x23\x99\xa8\xc6\xe4\xe0\x13" }  },
      /* --- pixel bitmap for cmmib250 char#48 \0 --- */
      {  48,103418,                     /* character number, location */
         16, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x73\x43\x53\x63\x20\xf1\x13\x83\x1f\x64\x84\xf1"
            "\x13\x83\x10\x23\x63\x53\x43\x78\x44" }  },
      /* --- pixel bitmap for cmmib250 char#49 \1 --- */
      {  49,104209,                     /* character number, location */
         16, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 14,   16, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\x5f\x19\x50\xfa\x54\x5f\x1e" }  },
      /* --- pixel bitmap for cmmib250 char#50 \2 --- */
      {  50,105187,                     /* character number, location */
         16, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x39\x5d\x23\x66\x14\x79\x84\x12\x94\xb5\xb4\xb4\xa4"
            "\xb2\x52\x52\x72\x3d\x1e\x1f\x1e\x01\x12" }  },
      /* --- pixel bitmap for cmmib250 char#51 \3 --- */
      {  51,106226,                     /* character number, location */
         16, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x8a\x53\x54\x33\x64\x20\xf2\x14\x64\x10\x22\x65"
            "\xb4\xc3\xc3\x96\xe4\xd4\xd4\xc5\x13\x75\x0f\x15\x65"
            "\x05\x64\x23\x65\x24\x45\x4b\x77\x52" }  },
      /* --- pixel bitmap for cmmib250 char#52 \4 --- */
      {  52,107181,                     /* character number, location */
         16, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 18,   23, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\xe0\x13\xe4\xd5\xc6\xb2\x14\xb1\x24\xa1\x34\x92"
            "\x34\x82\x44\x72\x54\x62\x64\x52\x74\x42\x84\x4f\x1e"
            "\x04\xf4\xa4\x40\xf1\x6c" }  },
      /* --- pixel bitmap for cmmib250 char#53 \5 --- */
      {  53,108240,                     /* character number, location */
         16, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x82\x4b\x5a\x69\x77\x70\xf2\x22\xc0\x22\x16\x73"
            "\x53\x52\x64\x41\x84\xc4\x10\xf1\xb5\x12\x85\x0f\x24"
            "\x75\x03\x84\x22\x74\x43\x45\x59\x86\x64" }  },
      /* --- pixel bitmap for cmmib250 char#54 \6 --- */
      {  54,109163,                     /* character number, location */
         23, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\x89\x64\x43\x43\x54\x33\x64\x24\x72\x20\xf1\x13"
            "\xc4\x25\x54\x11\x43\x35\x63\x25\x73\x14\x83\x1f\x34"
            "\x84\xf1\x13\x84\x14\x73\x33\x64\x43\x44\x69\x86\x53" }  },
      /* --- pixel bitmap for cmmib250 char#55 \7 --- */
      {  55,110102,                     /* character number, location */
         16, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x12\xe0\xf1\x1e\x02\x1e\x01\x2e\x2f\x12\xa2\x32\x92"
            "\xe2\x50\xf1\x92\x60\x82\x70\xf1\x73\x70\xf3\x63\x80"
            "\xf4\x54\x80\x62\x94" }  },
      /* --- pixel bitmap for cmmib250 char#56 \8 --- */
      {  56,111041,                     /* character number, location */
         23, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x8a\x53\x54\x42\x74\x10\xf1\x13\x83\x10\x14\x73"
            "\x25\x63\x27\x33\x4b\x69\x89\x6b\x43\x28\x23\x5a\x88"
            "\x94\x0f\x13\xa3\x03\xa2\x23\x83\x33\x63\x5a\x86\x53" }  },
      /* --- pixel bitmap for cmmib250 char#57 \9 --- */
      {  57,111972,                     /* character number, location */
         16, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x89\x64\x43\x44\x63\x33\x83\x1f\x14\x83\x1f\x34"
            "\x84\x13\x84\x13\x75\x23\x65\x33\x41\x14\x55\x24\xf1"
            "\xc3\x10\x22\x74\x24\x63\x34\x53\x43\x53\x69\x86\x73" }  },
      /* --- pixel bitmap for cmmib250 char#58 . --- */
      {  58,118691,                     /* character number, location */
          5, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\xff\xef\x00" }  },
      /* --- pixel bitmap for cmmib250 char#59 , --- */
      {  59,119256,                     /* character number, location */
          5, 3,   -7, 3,      /* topleft row,col, and botleft row,col */
          {  5,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\xfd\xef\x21\x44\x88\x10\x01" }  },
      /* --- pixel bitmap for cmmib250 char#60 < --- */
      {  60,119926,                     /* character number, location */
         21, 3,   -4, 3,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,100, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x83\xe0\x65\xe0\x47\xe0\x27\xe0\x27\xe0\x27\xe0"
            "\x27\xe0\x27\xe0\x27\xe0\x27\xe0\x27\xe0\x27\xe0\x45"
            "\xe0\x67\xe0\x67\xe0\x67\xe0\x67\xe0\x67\xe0\x67\xe0"
            "\x67\xe0\x67\xe0\x67\xe0\x67\xe0\x65\xe0\x83" }  },
      /* --- pixel bitmap for cmmib250 char#61 / --- */
      {  61,120478,                     /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 16,   35, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe2\xd3\xc4\xf1\xc3\x10\xb4\xc3\xc4\x20\xf1\xa3\x30"
            "\x94\xc3\xc4\x40\xf1\x83\x50\x74\xc3\xc4\xc3\xc4\x70"
            "\xf1\x53\x80\x44\xc3\xc4\x90\xf1\x33\xa0\x24\xc3\xc4"
            "\xb0\xf1\x13\xc4\xcf\x13\xd7" }  },
      /* --- pixel bitmap for cmmib250 char#62 > --- */
      {  62,121197,                     /* character number, location */
         21, 3,   -4, 3,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x03\xe0\x85\xe0\x67\xe0\x67\xe0\x67\xe0\x67\xe0\x67"
            "\xe0\x67\xe0\x67\xe0\x67\xe0\x67\xe0\x67\xe0\x65\xe0"
            "\x47\xe0\x27\xe0\x27\xe0\x27\xe0\x27\xe0\x27\xe0\x27"
            "\xe0\x27\xe0\x27\xe0\x27\xe0\x45\xe0\x63\xe0\x80" }  },
      /* --- pixel bitmap for cmmib250 char#63 \star --- */
      {  63,121924,                     /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   19, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x91\x90\xf2\x83\x84\x43\x44\x2e\x01\x6b\xa7\xd5"
            "\xd7\xc3\x13\xb3\x33\xa2\x52\x92\x72\x81\x91\x71\xb1"
            "\x37" }  },
      /* --- pixel bitmap for cmmib250 char#64 \partial --- */
      {  64,97907,                      /* character number, location */
         25, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 20,   26, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xd9\xa2\x54\x82\x83\x63\x84\x10\xf1\x44\x83\x10"
            "\x43\x94\xe0\x24\x76\x34\x53\x51\x23\x53\x75\x43\x85"
            "\x33\x95\x24\x95\x23\xa4\x2f\x14\xa4\x24\x94\x33\xa4"
            "\x33\xa3\x43\x93\x54\x73\x73\x54\x9a\xc6\xa3" }  },
      /* --- pixel bitmap for cmmib250 char#65 A --- */
      {  65, 1066,                      /* character number, location */
         25, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 28,   25, 3,122, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x52\x70\xf1\xe0\x44\x60\xe0\x35\x60\xf1\xe0\x26"
            "\x60\xe0\x17\xe0\x62\x15\xe0\x62\x16\xe0\x42\x35\xe0"
            "\x33\x35\xe0\x32\x45\xe0\x22\x55\xe0\x13\x55\xe0\x12"
            "\x65\xe2\x76\x40\xf1\x8e\x02\x40\xf1\x72\xa5\x40\x62"
            "\xb5\x92\xc5\x92\xc6\x48\x7e\x07\x7c" }  },
      /* --- pixel bitmap for cmmib250 char#66 B --- */
      {  66, 2488,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 29,   24, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x05\xae\x07\xb5\x95\xa5\xa4\x10\xf1\x95\xa5\x85"
            "\xb4\x95\xa5\x95\xa4\xa5\x94\xa5\x85\xbe\x02\xd5\x94"
            "\xb5\xa4\x30\xf3\x65\xb5\x20\xf1\x55\xb5\x30\x55\xa5"
            "\x95\x86\x6e\x07\x7e\x06\x92" }  },
      /* --- pixel bitmap for cmmib250 char#67 C --- */
      {  67, 3485,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 28,   26, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd8\x61\xac\x33\x86\x77\x66\xa5\x65\xd4\x55\xe0\x13"
            "\x45\xe0\x23\x44\xe0\x32\x45\xe0\x32\x35\xe0\x42\x35"
            "\xe0\x8f\x45\xe0\x9f\x14\xe0\x42\x44\xe0\x32\x55\xe0"
            "\x22\x55\xe0\x12\x74\xe2\x95\xb2\xb6\x64\xdd\xe0\x48"
            "\xd5" }  },
      /* --- pixel bitmap for cmmib250 char#68 D --- */
      {  68, 4695,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 31,   24, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x05\xce\x08\xc5\x96\xb5\xb5\xa5\xc5\x95\xd4\xf3"
            "\x85\xe4\x75\xe0\x14\xf2\x75\xe5\xf1\x65\xe5\x10\x65"
            "\xe4\x85\xd5\x75\xd5\x85\xc5\x95\xb5\xa5\x95\x8e\x08"
            "\x8e\x06\xb0" }  },
      /* --- pixel bitmap for cmmib250 char#69 E --- */
      {  69, 6186,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 28,   24, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x6e\x08\x95\x95\xf2\x95\xb2\x10\x85\xc2\x10\xf1"
            "\x85\x52\x52\x10\x85\x43\xe0\x15\x52\x90\xf1\x7c\x90"
            "\x75\x43\x90\xf1\x65\x52\x62\x20\x65\x52\x52\x95\xc2"
            "\x85\xc2\x95\xb3\x95\xa4\x95\x85\x6e\x08\x5e\x08\x68" }  },
      /* --- pixel bitmap for cmmib250 char#70 F --- */
      {  70, 7515,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 27,   24, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x6e\x07\x95\x85\xf2\x95\xa2\x10\x85\xb2\x10\xf1"
            "\x85\x52\x42\x10\x85\x43\xe5\x52\x80\xf1\x7c\x80\x75"
            "\x43\x80\xf2\x65\x52\x90\x65\xe0\x20\xf3\x55\xe0\x30"
            "\x1d\xde\xd5" }  },
      /* --- pixel bitmap for cmmib250 char#71 G --- */
      {  71, 8724,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 28,   26, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd8\x61\xac\x33\x86\x77\x66\xa5\x65\xd4\x55\xe0\x13"
            "\x45\xe0\x23\x44\xe0\x32\x45\xe0\x32\x35\xe0\x42\x35"
            "\xe0\x8f\x35\xe0\x95\x9d\x14\xad\x1f\x14\xe0\x15\x4f"
            "\x15\xd5\x50\x14\xd5\x75\xa6\x86\x63\x13\xad\x41\xd8"
            "\xd5" }  },
      /* --- pixel bitmap for cmmib250 char#72 H --- */
      {  72,10047,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 35,   24, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6d\x3d\x6c\x4c\x10\xf3\x95\xb5\x50\xf3\x85\xb5\x60"
            "\x75\xb5\x70\xf1\x7e\x07\x70\x75\xb5\x70\xf3\x65\xb5"
            "\x80\xf3\x55\xb5\x90\x1c\x4c\x6d\x3d\x64" }  },
      /* --- pixel bitmap for cmmib250 char#73 I --- */
      {  73,10870,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6d\x6c\x10\xf3\x95\x50\xf3\x85\x60\xf3\x75\x70\xf3"
            "\x65\x80\xf3\x55\x90\x1c\x6d\x65" }  },
      /* --- pixel bitmap for cmmib250 char#74 J --- */
      {  74,11738,                      /* character number, location */
         24, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   25, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xad\xac\x10\xf3\xe5\x40\xf3\xd5\x50\xf3\xc5\x60\xf3"
            "\xb5\x70\x14\x55\x8f\x15\x55\x84\x55\x92\x74\xb2\x45"
            "\xe6\xe3" }  },
      /* --- pixel bitmap for cmmib250 char#75 K --- */
      {  75,13029,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 34,   24, 3,131, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x6d\x69\x6c\x79\x95\xc3\xe5\xb3\xe0\x15\xa2\xe0\x35"
            "\x83\xe0\x35\x82\xe0\x55\x63\xe0\x65\x53\xe0\x75\x33"
            "\xe0\x85\x35\xe0\x75\x26\xe0\x78\x15\xe0\x66\x35\xe0"
            "\x56\x55\xe0\x45\x65\xe0\x45\x66\xe0\x35\x75\xe0\x25"
            "\x86\xe0\x15\x95\xe0\x15\x96\xe5\xa5\xac\x4c\x5d\x4b"
            "\x60" }  },
      /* --- pixel bitmap for cmmib250 char#76 L --- */
      {  76,14050,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x9d\x40\xf3\x95\x90\xf3\x85\xa0\xf3\x75\xb0\xf2"
            "\x65\xa2\x65\x92\x65\xa2\x65\x93\x65\x83\x75\x65\x3e"
            "\x05\x3e\x06\x30" }  },
      /* --- pixel bitmap for cmmib250 char#77 M --- */
      {  77,15440,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 40,   24, 3,171, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x69\xe0\x29\x69\xe0\x19\xa6\xe6\xe2\x14\xd6\xe2\x14"
            "\xc2\x14\xe2\x14\xb2\x24\xd2\x24\xb2\x14\xe2\x24\xa2"
            "\x24\xe2\x24\x92\x34\xe2\x34\x82\x34\xd2\x44\x72\x34"
            "\x70\xf1\x72\x44\x62\x44\x70\x72\x44\x52\x54\xd2\x54"
            "\x42\x54\xe2\x64\x32\x54\xe2\x64\x22\x64\xe2\x64\x12"
            "\x74\xd2\x74\x12\x64\xe2\x76\x74\xe2\x75\x84\xe2\x84"
            "\x84\xa9\x53\x5b\x6a\x52\x5c\x60" }  },
      /* --- pixel bitmap for cmmib250 char#78 N --- */
      {  78,16756,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 35,   24, 3,127, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x69\xaa\x6a\x99\xa7\xc2\xe2\x15\xb2\xe2\x16\xa2\xe2"
            "\x25\xa2\xd2\x36\x82\xe2\x45\x82\xe2\x46\x72\xe2\x56"
            "\x62\xd2\x75\x52\xe2\x76\x42\xe2\x85\x42\xe2\x86\x32"
            "\xd2\xa5\x22\xe2\xb5\x12\xe2\xb8\xe2\xc7\xd2\xd6\x90"
            "\xf1\x52\xe5\x90\x52\xe0\x14\xa9\xd2\xaa\xd2\xa4" }  },
      /* --- pixel bitmap for cmmib250 char#79 O --- */
      {  79,17679,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 27,   26, 3,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd8\xe0\x24\x63\xc4\x94\x94\xb4\x74\xc4\x64\xe4\x44"
            "\xe0\x14\x35\xe0\x14\x34\xe0\x24\xf1\x25\xe0\x24\xf3"
            "\x15\xe0\x25\x14\xe0\x25\x15\xe0\x25\x15\xe0\x24\x34"
            "\xe0\x15\x34\xe5\x44\xe4\x64\xc4\x74\xb4\x94\x94\xb5"
            "\x54\xe0\x28\xc0" }  },
      /* --- pixel bitmap for cmmib250 char#80 P --- */
      {  80,18870,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 28,   24, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x04\xae\x06\xb5\x86\x95\x95\xf1\x95\xa4\xf2\x85"
            "\xa5\x85\x95\x85\xa4\x95\x85\xae\x02\xc5\xe0\x20\xf3"
            "\x65\xe0\x30\xf3\x55\xe0\x40\x1c\xe0\x1d\xe0\x14" }  },
      /* --- pixel bitmap for cmmib250 char#81 Q --- */
      {  81,19927,                      /* character number, location */
         25, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 27,   32, 3,155, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd8\xe0\x24\x63\xc4\x94\x94\xb4\x74\xc4\x64\xe4\x44"
            "\xe0\x14\x35\xe0\x14\x34\xe0\x24\xf1\x25\xe0\x24\xf3"
            "\x15\xe0\x25\x14\xe0\x25\x15\xe0\x25\x15\xe0\x24\x34"
            "\xe0\x15\x34\xe0\x14\x44\x54\x54\x64\x32\x31\x34\x74"
            "\x31\x41\x24\x94\x11\x56\xb4\x11\x44\x51\xaa\x61\xe0"
            "\x33\x52\x30\xf1\xe9\x40\xe0\x17\xe0\x66\xe0\x84\x74" }  },
      /* --- pixel bitmap for cmmib250 char#82 R --- */
      {  82,21346,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 30,   25, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x6e\x04\xce\x06\xd5\x85\xc5\x95\xb5\xa4\xb5\xa5\x10"
            "\xf1\x85\xa5\x20\x85\xa4\xb5\x94\xb5\x84\xde\x01\xe0"
            "\x15\x74\xe5\x84\x60\xf3\x65\x95\x50\xf1\x55\x95\x60"
            "\xf1\x55\x95\x42\x1c\x65\x32\x1d\x74\x31\xe0\xa5\x34" }  },
      /* --- pixel bitmap for cmmib250 char#83 S --- */
      {  83,22485,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   26, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb6\x51\x9a\x22\x74\x66\x64\x93\x73\xa3\x10\xf1\x54"
            "\xa3\x10\x45\xa2\x65\xe0\x47\xe0\x2b\xdc\xcc\xcc\xdb"
            "\xe0\x27\x30\xf1\xe0\x15\x30\x22\xb5\x30\xf1\x12\xc4"
            "\x40\x13\xb3\x63\xa3\x66\x64\x72\x2b\x81\x57\xa5" }  },
      /* --- pixel bitmap for cmmib250 char#84 T --- */
      {  84,23589,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 27,   24, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x3e\x0a\x24\x65\x64\x22\x85\x72\x23\x85\x72\x22"
            "\x95\x72\x22\x85\x82\x1f\x12\x95\x82\x10\xb5\xb0\xf3"
            "\xa5\xc0\xf3\x95\xd0\xf3\x85\xe0\x2e\x02\xbe\x01\xa4" }  },
      /* --- pixel bitmap for cmmib250 char#85 U --- */
      {  85,24667,                      /* character number, location */
         24, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 29,   25, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x6e\x08\x79\x10\xf3\x35\xe2\x50\xf3\x25\xe2\x60"
            "\xf3\x15\xe2\x7f\x35\xe2\x85\xd2\x9f\x15\xc2\xa0\x14"
            "\xa3\xd4\x74\xe0\x1c\xe0\x58\xe0\x2e" }  },
      /* --- pixel bitmap for cmmib250 char#86 V --- */
      {  86,25655,                      /* character number, location */
         24, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 29,   25, 3,119, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1b\x9e\x06\x89\x45\xe2\x40\xf1\x45\xd2\x50\x45\xc2"
            "\xa6\xa2\xc5\x93\xc5\x92\xd5\x82\xe5\x73\xe6\x62\xe0"
            "\x16\x52\xe0\x35\x43\xe0\x35\x42\xe0\x45\x32\xe0\x55"
            "\x23\xe0\x56\x12\xe0\xf1\x77\xe0\x10\x76\xe0\x20\xf1"
            "\x75\xe0\x30\x74\xe0\xc2\xe0\x51" }  },
      /* --- pixel bitmap for cmmib250 char#87 W --- */
      {  87,27115,                      /* character number, location */
         24, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 40,   25, 3,177, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1b\x3c\x4e\x07\x3b\x59\xf1\x36\x95\xb2\x40\x45\x95"
            "\xa2\x95\x95\x93\x95\x87\x82\xa5\x87\x72\xb5\x72\x15"
            "\x72\xb5\x62\x25\x62\xc5\x62\x25\x52\xd5\x52\x35\x52"
            "\xd6\x33\x35\x42\xe0\x15\x32\x45\x42\xe0\x15\x22\x55"
            "\x32\xe0\x25\x22\x56\x12\xe0\x35\x12\x75\x12\xe0\x38"
            "\x77\xe0\x47\x87\xe0\x46\x96\xe0\x56\x95\xe0\x65\xa5"
            "\xe0\x74\xa4\xe0\x83\xb4\xe0\x82\xc3\xe0\x30" }  },
      /* --- pixel bitmap for cmmib250 char#88 X --- */
      {  88,28402,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 32,   24, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x6c\x4a\xa6\x83\xe0\x16\x73\xe0\x36\x53\xe0\x46"
            "\x43\xe0\x66\x23\xe0\x76\x13\xe0\x98\xe0\xa7\xe0\xc5"
            "\xd0\xf1\xe6\xc0\xd8\xe0\x93\x15\xe0\x83\x26\xe0\x63"
            "\x45\xe0\x53\x56\xe0\x33\x66\xe0\x23\x86\xe3\x96\xd3"
            "\xb6\x7a\x7b\x4a\x6c\x42" }  },
      /* --- pixel bitmap for cmmib250 char#89 Y --- */
      {  89,29562,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 29,   24, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x9e\x06\x89\x46\xc3\x86\xc2\xa6\xa2\xb6\x92\xd6"
            "\x72\xe6\x62\xe0\x26\x43\xe0\x26\x33\xe0\x46\x13\xe0"
            "\x59\xe0\x77\xe0\x86\xe0\xf2\x95\xe0\x10\x94\xe0\x20"
            "\xf2\x85\xe0\x20\x84\xe0\x7c\xe0\x2d\xd6" }  },
      /* --- pixel bitmap for cmmib250 char#90 Z --- */
      {  90,30677,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,95, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x7e\x05\x66\x76\x74\x86\x83\x86\x92\x86\x93\x76"
            "\xa2\x85\xb2\x75\xe0\x65\xe0\x65\xe0\x65\xe0\x65\xe0"
            "\x65\xe0\x65\x72\xb5\x82\xa5\x92\x96\x82\x96\x92\x86"
            "\x93\x76\x93\x76\x76\x6f\x1e\x05\x7d" }  },
      /* --- pixel bitmap for cmmib250 char#91 \flat --- */
      {  91,122635,                     /* character number, location */
         26, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   27, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x02\x92\x23\x49\x2a\x12\x53\x1f\x42\x54\x0f\x12"
            "\x44\x12\x34\x22\x33\x32\x23\x42\x13\x55\x64\x72\x91" }  },
      /* --- pixel bitmap for cmmib250 char#92 \natural --- */
      {  92,123422,                     /* character number, location */
         26, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 11,   34, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x02\x92\x74\x56\x27\x0f\x1b\x07\x26\x52\x0f\x82"
            "\x72\x02\x56\x27\x0f\x1b\x07\x26\x54\x72\xf3\x92" }  },
      /* --- pixel bitmap for cmmib250 char#93 \sharp --- */
      {  93,124327,                     /* character number, location */
         25, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 11,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x03\x18\xc1\x0c\x66\x30\x83\x19\xdc\xf0\xf6\xf7"
            "\xff\xff\xfe\xf6\xb0\x83\x19\xcc\x60\x06\x33\x98\xc1"
            "\x0c\x66\x30\x83\x1b\xde\xfe\xfe\xff\xdf\xdf\x1e\x76"
            "\x30\x83\x19\xc4\x00\x06\x00" }  },
      /* --- pixel bitmap for cmmib250 char#94 \smile --- */
      {  94,125293,                     /* character number, location */
         13, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          { 36,    8, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\xe0\x45\xe0\xe0\x23\x14\xe0\xc4\x44\xe0\x84"
            "\x77\xe7\xae\x0a\xee\x06\xe0\x6c\xc2" }  },
      /* --- pixel bitmap for cmmib250 char#95 \frown --- */
      {  95,126169,                     /* character number, location */
         14, 2,    4, 2,      /* topleft row,col, and botleft row,col */
          { 36,   10, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xda\xe0\x9e\x02\xe0\x3e\x08\xd6\xc6\xa5\xe0\x45\x74"
            "\xe0\x84\x53\xe0\xc3\x33\xe0\xe3\x13\xe0\xe0\x25\xe0"
            "\xe0\x42" }  },
      /* --- pixel bitmap for cmmib250 char#96 \ell --- */
      {  96,98715,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb3\xc2\x21\xa2\x32\x83\x32\x73\x42\x64\x42\x63\x42"
            "\x64\x42\x64\x32\x74\x22\x74\x32\x74\x22\x84\x12\x96"
            "\x96\xa5\x80\xf1\x34\x90\x25\xa6\x92\x23\x81\x43\x63"
            "\x52\x44\x86\x33" }  },
      /* --- pixel bitmap for cmmib250 char#97 a --- */
      {  97,31643,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   15, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x23\x73\x45\x63\x64\x53\x74\x44\x74\x43\x74\x4f"
            "\x24\x74\x43\x74\x41\x0f\x13\x74\x32\x03\x65\x22\x23"
            "\x42\x13\x21\x55\x44\x32" }  },
      /* --- pixel bitmap for cmmib250 char#98 b --- */
      {  98,32531,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x17\x80\xf3\x34\x90\xf2\x24\xa0\x24\x16\x46\x52"
            "\x35\x63\x10\xf1\x14\x74\x0f\x34\x84\x0f\x13\x84\x13"
            "\x74\x33\x63\x52\x43\x86\x75" }  },
      /* --- pixel bitmap for cmmib250 char#99 c --- */
      {  99,33390,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x73\x52\x43\x64\x23\x74\x14\x73\x23\xcf\x24\xcf"
            "\x13\xd3\xb1\x23\x92\x33\x63\x68\x44" }  },
      /* --- pixel bitmap for cmmib250 char#100 d --- */
      { 100,34370,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xc7\xf3\xe4\x10\xf2\xd4\x20\x65\x24\x63\x45\x63"
            "\x64\x53\x74\x44\x74\x43\x74\x4f\x24\x74\x43\x74\x41"
            "\x0f\x13\x74\x32\x03\x65\x22\x23\x42\x13\x21\x55\x44"
            "\x33" }  },
      /* --- pixel bitmap for cmmib250 char#101 e --- */
      { 101,35243,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x64\x52\x43\x82\x23\x92\x14\x82\x23\x83\x1d\x3f"
            "\x24\xc3\xd4\xa1\x23\x92\x33\x63\x68\x44" }  },
      /* --- pixel bitmap for cmmib250 char#102 f --- */
      { 102,36403,                      /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 20,   31, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd6\xd3\x23\xf1\xb3\x24\xa4\x32\x10\xf2\xa4\x60\x94"
            "\x70\xf1\x5d\x20\xf1\x94\x70\xf5\x84\x80\xf4\x74\x90"
            "\xf1\x64\xa0\x12\x34\xa4\x23\xb4\x22\xc3\x22\xe5\xe4" }  },
      /* --- pixel bitmap for cmmib250 char#103 g --- */
      { 103,37416,                      /* character number, location */
         15, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 18,   22, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\x23\x53\x55\x43\x74\x33\x84\x24\x84\x23\x84\x10"
            "\xf2\x14\x84\x10\xf2\x13\x84\x20\x23\x65\x52\x46\x76"
            "\x14\x30\xf1\xb4\x30\x12\x74\x44\x64\x44\x54\x53\x54"
            "\x88\x86" }  },
      /* --- pixel bitmap for cmmib250 char#104 h --- */
      { 104,38373,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   24, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x37\xb0\xf3\x54\xc0\xf2\x44\xd0\x44\x25\x94\x12"
            "\x43\x75\x63\x40\xf1\x34\x74\x30\xf2\x24\x74\x40\x24"
            "\x64\x64\x74\x41\x14\x74\x32\x14\x64\x42\x14\x64\x32"
            "\x14\x83\x22\x32\xa4\x4f" }  },
      /* --- pixel bitmap for cmmib250 char#105 i --- */
      { 105,39273,                      /* character number, location */
         25, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   25, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x83\x10\x74\x92\x20\xf5\xc0\x44\x71\x23\x52\x24"
            "\x20\xf1\x12\x34\x20\xf1\x54\x30\xf1\x44\x40\x44\x31"
            "\xf1\x34\x32\x33\x32\x43\x22\x74\x34" }  },
      /* --- pixel bitmap for cmmib250 char#106 j --- */
      { 106,40214,                      /* character number, location */
         25, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 16,   32, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe2\xd3\xc4\xd2\x10\xf5\xe0\x20\x85\x92\x33\x72\x44"
            "\x10\xf1\x42\x54\x10\xf3\xa4\x20\xf3\x94\x30\xf3\x84"
            "\x40\x12\x44\x54\x34\x54\x24\x63\x24\x85\xa4" }  },
      /* --- pixel bitmap for cmmib250 char#107 k --- */
      { 107,41253,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x37\x90\xf3\x54\xa0\xf2\x44\xb0\x44\x64\x44\x52"
            "\x23\x34\x41\x34\x34\x31\x44\x34\x12\x62\x34\x11\xd7"
            "\xcb\x84\x35\x64\x54\x41\xf1\x14\x54\x32\x14\x54\x22"
            "\x14\x73\x21\x32\x94\x3f" }  },
      /* --- pixel bitmap for cmmib250 char#108 l --- */
      { 108,42015,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   24, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x27\xf3\x44\x10\xf3\x34\x20\xf3\x24\x30\xf3\x14"
            "\x44\x41\x0f\x14\x32\x04\x22\x23\x21\x44\x34" }  },
      /* --- pixel bitmap for cmmib250 char#109 m --- */
      { 109,43286,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 34,   15, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x44\x55\x55\x91\x23\x22\x43\x21\x43\x61\x35\x63\x11"
            "\x53\x40\xf1\x12\x34\x74\x64\x30\xf2\x54\x74\x64\x40"
            "\x54\x74\x54\x94\x74\x64\x41\x44\x74\x64\x32\x44\x74"
            "\x54\x42\x44\x74\x54\x32\x44\x74\x73\x22\x62\x92\x94"
            "\x46" }  },
      /* --- pixel bitmap for cmmib250 char#110 n --- */
      { 110,44389,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   15, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x45\x91\x23\x21\x43\x61\x35\x53\x40\xf1\x12\x34"
            "\x64\x30\xf2\x54\x64\x40\x54\x54\x94\x64\x41\x44\x64"
            "\x32\x44\x54\x42\x44\x54\x32\x44\x73\x22\x62\x94\x44" }  },
      /* --- pixel bitmap for cmmib250 char#111 o --- */
      { 111,45143,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x93\x53\x53\x83\x33\x94\x14\x94\x13\xa4\x0f\x24"
            "\xa4\x03\xa4\x13\xa3\x23\x94\x33\x74\x53\x53\x97\x74" }  },
      /* --- pixel bitmap for cmmib250 char#112 p --- */
      { 112,46151,                      /* character number, location */
         15,-1,   -7,-1,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x45\x71\x23\x12\x42\x51\x34\x63\x32\x34\x73\x22"
            "\x34\x64\xf3\x64\x74\xf1\x54\x74\x10\x54\x73\x74\x63"
            "\x76\x43\x84\x16\x60\xf1\x44\xd0\xf2\x34\xe0\x18\xc9"
            "\xc4" }  },
      /* --- pixel bitmap for cmmib250 char#113 q --- */
      { 113,47108,                      /* character number, location */
         15, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 18,   22, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x33\x43\x55\x43\x74\x33\x84\x24\x84\x23\x84\x2f"
            "\x24\x84\x2f\x23\x84\x30\x13\x65\x52\x46\x76\x14\x40"
            "\xf1\xa4\x40\xf2\x94\x50\xf1\x69\x32" }  },
      /* --- pixel bitmap for cmmib250 char#114 r --- */
      { 114,48023,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x45\x32\x13\x21\x33\x12\x25\x34\x12\x24\x44\x12"
            "\x24\x52\x10\xf3\x44\x90\xf3\x34\xa0\x24\xe2\xc4" }  },
      /* --- pixel bitmap for cmmib250 char#115 s --- */
      { 115,48979,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\x71\x62\x51\x64\x32\x64\x33\x53\x47\x8a\x6a\x78"
            "\x22\x83\x1f\x14\x82\x13\x82\x32\x72\x58\x52" }  },
      /* --- pixel bitmap for cmmib250 char#116 t --- */
      { 116,49743,                      /* character number, location */
         22, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   22, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\x40\xf2\x64\x30\xf2\x54\x40\x1e\x0a\x10\xf2\x44"
            "\x50\xf3\x34\x60\x24\x61\x24\x52\xf1\x24\x42\x10\x33"
            "\x22\x75\x40" }  },
      /* --- pixel bitmap for cmmib250 char#117 u --- */
      { 117,50805,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 22,   15, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x73\x62\x23\x54\x52\x34\x44\x30\xf1\x12\x34\x54"
            "\x30\x64\x44\x40\xf2\x54\x54\x40\x44\x54\x41\xf1\x44"
            "\x54\x32\x53\x54\x22\x63\x32\x13\x21\x95\x34\x38" }  },
      /* --- pixel bitmap for cmmib250 char#118 v --- */
      { 118,51726,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   15, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x52\x23\x44\x32\x34\x35\x12\x34\x54\x12\x34"
            "\x63\x64\x62\x10\xf1\x54\x72\x10\x54\x71\x64\x72\x64"
            "\x71\x74\x62\x83\x52\xa3\x32\xc5\x71" }  },
      /* --- pixel bitmap for cmmib250 char#119 w --- */
      { 119,52928,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 28,   15, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x73\x52\x52\x23\x54\x44\x32\x34\x44\x45\x12\x34"
            "\x54\x54\x12\x34\x54\x63\x64\x44\x72\x10\xf2\x54\x54"
            "\x72\x10\xf1\x44\x54\x72\x20\x44\x54\x62\x83\x54\x61"
            "\xa3\x32\x13\x41\xc6\x36\x64" }  },
      /* --- pixel bitmap for cmmib250 char#120 x --- */
      { 120,54220,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xe3\xc3\xb0\x39\x83\xe7\x0d\x3c\x6f\xe0\x31\x80"
            "\x07\x00\x3c\x00\xe0\x01\x00\x0f\x00\x3c\x20\xe3\x81"
            "\x3d\x0f\xec\x7d\x30\xe7\xc3\xf0\xf0\x01" }  },
      /* --- pixel bitmap for cmmib250 char#121 y --- */
      { 121,55322,                      /* character number, location */
         15, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 20,   22, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x83\x32\x23\x64\x22\x34\x54\xf1\x12\x34\x64\x64"
            "\x54\x10\xf2\x54\x64\x10\xf2\x44\x64\x20\x53\x55\x83"
            "\x35\xa5\x14\xe0\x24\x71\x74\x73\x64\x64\x54\x74\x53"
            "\x92\x43\xc6\xa1" }  },
      /* --- pixel bitmap for cmmib250 char#122 z --- */
      { 122,56288,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x62\x48\x32\x4d\x58\x22\xe0\x12\xe3\xe2\xe0\x12"
            "\xe3\xe2\x91\x52\x92\x42\x39\x3e\x32\x48\x32\x74\x53" }  },
      /* --- pixel bitmap for cmmib250 char#123 \imath --- */
      { 123,99519,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x1c\xcc\x63\x3c\xc6\x03\x1e\xe0\x01\x0f\xf0"
            "\x00\x8f\x78\x8c\xc7\x38\x86\x33\xe0\x01" }  },
      /* --- pixel bitmap for cmmib250 char#124 \jmath --- */
      { 124,100338,                     /* character number, location */
         15, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x85\x82\x33\x62\x44\xf1\x42\x54\xf3\xa4\x10\xf3\x94"
            "\x20\xf3\x84\x30\x12\x44\x44\x34\x44\x24\x53\x24\x76"
            "\x86" }  },
      /* --- pixel bitmap for cmmib250 char#125 \wp --- */
      { 125,101509,                     /* character number, location */
         16, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 23,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x00\x00\x18\xe0\x07\x06\x0e\x06\x81\x01\xc7\x30"
            "\x80\x67\x0c\xc0\x1b\x03\xe0\xcd\x00\xf0\x26\x00\x78"
            "\x1b\x00\xbc\x07\x00\xcf\x83\x81\xe7\xc1\xe0\xe1\x61"
            "\x70\xf8\x31\x1e\xec\xe1\x01\xe6\x00\x00\x63\x00\x80"
            "\x30\x00\x60\x18\x00\x20\x0c\x00\x10\x02\x00\x88\x00"
            "\x00\x38\x00\x00" }  },
      /* --- pixel bitmap for cmmib250 char#126 \bfvec --- */
      { 126,102191,                     /* character number, location */
         26, 6,   17, 6,      /* topleft row,col, and botleft row,col */
          { 18,    9, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd1\xe0\x23\xe0\x14\x3e\x0e\x07\x1e\x03\xb5\xd3\xe0"
            "\x12\x52" }  },
      /* --- pixel bitmap for cmmib250 char#127 (noname) --- */
      { 127,102739,                     /* character number, location */
         23,10,   18,10,      /* topleft row,col, and botleft row,col */
          { 16,    5, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\x5d\x23\x86\xc3\xd1\x1e" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* ------------------------------------------------------------------------
font sizes 0-7 for cmsy10
------------------------------------------------------------------------ */

/* --- size=0 for .83gf ---
 * mf '\mode=eighthre;  input cmsy10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmsy83 --- */
static	chardef  cmsy83[] =
   {
      /* --- pixel bitmap for cmsy83 char#0 - --- */
      {   0,  943,                      /* character number, location */
          3, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f" }  },
      /* --- pixel bitmap for cmsy83 char#1 \cdot --- */
      {   1, 1591,                      /* character number, location */
          3, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  1,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01" }  },
      /* --- pixel bitmap for cmsy83 char#2 \times --- */
      {   2, 1745,                      /* character number, location */
          6, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\xc4\x10\x8c\x14\x02" }  },
      /* --- pixel bitmap for cmsy83 char#3 \ast --- */
      {   3, 1774,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x2e" }  },
      /* --- pixel bitmap for cmsy83 char#4 \div --- */
      {   4, 1791,                      /* character number, location */
          6, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x80\x0f\x00\x01" }  },
      /* --- pixel bitmap for cmsy83 char#5 \diamond --- */
      {   5, 1600,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x45\x45\x00" }  },
      /* --- pixel bitmap for cmsy83 char#6 \pm --- */
      {   6,  952,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x31\x26\xf2\x31\x26" }  },
      /* --- pixel bitmap for cmsy83 char#7 \mp --- */
      {   7, 1808,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x82\x20\x3f\x82\x20\x08" }  },
      /* --- pixel bitmap for cmsy83 char#8 \oplus --- */
      {   8,  977,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x96\xa6\x7f\x9a\x6a\x0c" }  },
      /* --- pixel bitmap for cmsy83 char#9 \ominus --- */
      {   9, 1833,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x14\x86\x7f\x18\x4a\x0c" }  },
      /* --- pixel bitmap for cmsy83 char#10 \otimes --- */
      {  10, 1022,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x34\xb7\x65\x3b\x4b\x0c" }  },
      /* --- pixel bitmap for cmsy83 char#11 \oslash --- */
      {  11, 1870,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x14\xa7\x65\x39\x4a\x0c" }  },
      /* --- pixel bitmap for cmsy83 char#12 \odot --- */
      {  12, 1915,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x14\x86\x6d\x18\x4a\x0c" }  },
      /* --- pixel bitmap for cmsy83 char#13 \bigcirc --- */
      {  13, 1956,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x42\x81\x81\x81\x81\x81\x81\x42\x3c" }  },
      /* --- pixel bitmap for cmsy83 char#14 \circ --- */
      {  14, 1999,                      /* character number, location */
          5, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x00" }  },
      /* --- pixel bitmap for cmsy83 char#15 \bullet --- */
      {  15, 2014,                      /* character number, location */
          5, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00" }  },
      /* --- pixel bitmap for cmsy83 char#16 \asymp --- */
      {  16, 2027,                      /* character number, location */
          6, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\xc4\x00\x8c\x14\x02" }  },
      /* --- pixel bitmap for cmsy83 char#17 \equiv --- */
      {  17, 1512,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xf2\x66\xf2\x66" }  },
      /* --- pixel bitmap for cmsy83 char#18 \subseteq --- */
      {  18, 2056,                      /* character number, location */
          7, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x11\x4f\x41\x50\x11\x64\xf2\x66" }  },
      /* --- pixel bitmap for cmsy83 char#19 \supseteq --- */
      {  19, 2085,                      /* character number, location */
          7, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x04\x82\x20\x08\x42\x0f\x00\x00\x3f" }  },
      /* --- pixel bitmap for cmsy83 char#20 \leq --- */
      {  20, 1454,                      /* character number, location */
          7, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\xc4\x08\x81\xc0\x40\x20\x00\x00\x3f" }  },
      /* --- pixel bitmap for cmsy83 char#21 \geq --- */
      {  21, 1483,                      /* character number, location */
          7, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\xc0\x40\x20\xc4\x08\x01\x00\x00\x3f" }  },
      /* --- pixel bitmap for cmsy83 char#22 \preceq --- */
      {  22, 2114,                      /* character number, location */
          7, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x21\x07\x02\x81\x20\x00\x00\x3f" }  },
      /* --- pixel bitmap for cmsy83 char#23 \succeq --- */
      {  23, 2143,                      /* character number, location */
          7, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x20\x10\x38\x21\x04\x01\x00\x00\x3f" }  },
      /* --- pixel bitmap for cmsy83 char#24 \sim --- */
      {  24, 2172,                      /* character number, location */
          4, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\x0e" }  },
      /* --- pixel bitmap for cmsy83 char#25 \approx --- */
      {  25, 2187,                      /* character number, location */
          6, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xd9\xe6\x67\xd9\xe6" }  },
      /* --- pixel bitmap for cmsy83 char#26 \subset --- */
      {  26, 1308,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x10\x04\x41\x10\x08\x3c" }  },
      /* --- pixel bitmap for cmsy83 char#27 \supset --- */
      {  27, 1333,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x04\x82\x20\x08\x42\x0f" }  },
      /* --- pixel bitmap for cmsy83 char#28 \ll --- */
      {  28, 2234,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x90\x48\x24\x12\x09\x12\x24\x48\x90" }  },
      /* --- pixel bitmap for cmsy83 char#29 \gg --- */
      {  29, 2277,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x12\x24\x48\x90\x48\x24\x12\x09" }  },
      /* --- pixel bitmap for cmsy83 char#30 \prec --- */
      {  30, 2320,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x21\x07\x02\x81\x20" }  },
      /* --- pixel bitmap for cmsy83 char#31 \succ --- */
      {  31, 2345,                      /* character number, location */
          6, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x20\x10\x38\x21\x04\x01" }  },
      /* --- pixel bitmap for cmsy83 char#32 \leftarrow --- */
      {  32, 1249,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x02\xff\x02\x06" }  },
      /* --- pixel bitmap for cmsy83 char#33 \rightarrow --- */
      {  33, 1266,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x40\xff\x40\x60" }  },
      /* --- pixel bitmap for cmsy83 char#34 \uparrow --- */
      {  34, 1222,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,   10, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x21\x25\xf6\x21\x21" }  },
      /* --- pixel bitmap for cmsy83 char#35 \downarrow --- */
      {  35, 1195,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,   10, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x21\x25\xf1\x21\x21" }  },
      /* --- pixel bitmap for cmsy83 char#36 \leftrightarrow --- */
      {  36, 1283,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x42\xff\x42\x66" }  },
      /* --- pixel bitmap for cmsy83 char#37 \nearrow --- */
      {  37, 2370,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x81\x85\x09\x01\x01\x03\x03\x02\x02\x00" }  },
      /* --- pixel bitmap for cmsy83 char#38 \searrow --- */
      {  38, 2401,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x04\x18\x20\x80\x00\x02\x48\xb0\xc0\xe0\x01" }  },
      /* --- pixel bitmap for cmsy83 char#39 \simeq --- */
      {  39, 2432,                      /* character number, location */
          5, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\x9b\x03\x00\xf0\x03" }  },
      /* --- pixel bitmap for cmsy83 char#40 \Leftarrow --- */
      {  40, 2457,                      /* character number, location */
          6, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfc\x02\x02\x02\xfc\x0c" }  },
      /* --- pixel bitmap for cmsy83 char#41 \Rightarrow --- */
      {  41, 2478,                      /* character number, location */
          6, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa0\x1f\x10\x08\xfc\xc1\x00" }  },
      /* --- pixel bitmap for cmsy83 char#42 \Uparrow --- */
      {  42, 2499,                      /* character number, location */
          7,-1,   -2,-1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x24\xc3\x42\x42\x42\x42\x42\x42" }  },
      /* --- pixel bitmap for cmsy83 char#43 \Downarrow --- */
      {  43, 2540,                      /* character number, location */
          8,-1,   -1,-1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x42\x42\x42\x42\x42\xc3\x24\x18" }  },
      /* --- pixel bitmap for cmsy83 char#44 \Leftrightarrow --- */
      {  44, 2581,                      /* character number, location */
          6, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x7e\x42\xc3\x42\x3c\x24" }  },
      /* --- pixel bitmap for cmsy83 char#45 \nwarrow --- */
      {  45, 2612,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x0c\x34\x48\x00\x01\x04\x10\x60\x80\x00\x02" }  },
      /* --- pixel bitmap for cmsy83 char#46 \swarrow --- */
      {  46, 2643,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x01\x03\x03\x02\x42\x86\x06\x06\x3c\x00" }  },
      /* --- pixel bitmap for cmsy83 char#47 \propto --- */
      {  47, 2674,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe6\x4c\x26\x63\x06" }  },
      /* --- pixel bitmap for cmsy83 char#48 \prime --- */
      {  48, 2701,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  2,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6a\x05" }  },
      /* --- pixel bitmap for cmsy83 char#49 \infty --- */
      {  49, 1685,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x99\x99\x99\x66" }  },
      /* --- pixel bitmap for cmsy83 char#50 \in --- */
      {  50, 1358,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x84\xf0\x43\x10\x1c" }  },
      /* --- pixel bitmap for cmsy83 char#51 \ni --- */
      {  51, 2720,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x41\xf8\x21\x44\x07" }  },
      /* --- pixel bitmap for cmsy83 char#52 \triangle --- */
      {  52, 2745,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x85\x22\x12\x05\xff" }  },
      /* --- pixel bitmap for cmsy83 char#53 \bigtriangledown --- */
      {  53, 2778,                      /* character number, location */
          6, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xa0\x48\x44\xa1\x20\x10" }  },
      /* --- pixel bitmap for cmsy83 char#54 \boldslash --- */
      {  54, 2811,                      /* character number, location */
          8, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x04\x21\x08\x41\x10\x82\x10\x00" }  },
      /* --- pixel bitmap for cmsy83 char#55 \' --- */
      {  55, 2840,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  1,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for cmsy83 char#56 \forall --- */
      {  56, 1383,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\x3a\xa5\x14\x21" }  },
      /* --- pixel bitmap for cmsy83 char#57 \exists --- */
      {  57, 1416,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x27\x4d\xf2" }  },
      /* --- pixel bitmap for cmsy83 char#58 \neg --- */
      {  58, 1439,                      /* character number, location */
          4, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x42\x08" }  },
      /* --- pixel bitmap for cmsy83 char#59 \emptyset --- */
      {  59, 2857,                      /* character number, location */
          9, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc8\xe5\x5a\x6b\x9d\x4e\x00" }  },
      /* --- pixel bitmap for cmsy83 char#60 \Re --- */
      {  60, 2904,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\xb5\x52\xa7\xc1\x64\xcc" }  },
      /* --- pixel bitmap for cmsy83 char#61 \Im --- */
      {  61, 2945,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x1c\xc4\x72\x24\x31" }  },
      /* --- pixel bitmap for cmsy83 char#62 \top --- */
      {  62, 2978,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xf5\x31\x31" }  },
      /* --- pixel bitmap for cmsy83 char#63 \bot --- */
      {  63, 2999,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x31\x37" }  },
      /* --- pixel bitmap for cmsy83 char#64 \aleph --- */
      {  64, 3020,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x99\xbb\xdd\x9a" }  },
      /* --- pixel bitmap for cmsy83 char#65 \calA --- */
      {  65,   35,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x18\x0c\x85\xe2\x89\x82" }  },
      /* --- pixel bitmap for cmsy83 char#66 \calB --- */
      {  66,   66,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x49\x6b\xa2\x28\x37" }  },
      /* --- pixel bitmap for cmsy83 char#67 \calC --- */
      {  67,  103,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x8a\x10\x42\x32" }  },
      /* --- pixel bitmap for cmsy83 char#68 \calD --- */
      {  68,  130,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\x64\x92\x48\x24\x51\x1c" }  },
      /* --- pixel bitmap for cmsy83 char#69 \calE --- */
      {  69,  169,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\x12\x26\x42\x32" }  },
      /* --- pixel bitmap for cmsy83 char#70 \calF --- */
      {  70,  196,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x29\x40\x80\x80\x07\x01\x81\x03" }  },
      /* --- pixel bitmap for cmsy83 char#71 \calG --- */
      {  71,  221,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\xc6\x10\xb3\x43\x07" }  },
      /* --- pixel bitmap for cmsy83 char#72 \calH --- */
      {  72,  254,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\x24\x12\xe9\x23\x91\xc4" }  },
      /* --- pixel bitmap for cmsy83 char#73 \calI --- */
      {  73,  293,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x09\x02\x81\x20\x10\x3e" }  },
      /* --- pixel bitmap for cmsy83 char#74 \calJ --- */
      {  74,  318,                      /* character number, location */
          8, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x48\x24\x20\x10\x10\x10\x09\x06" }  },
      /* --- pixel bitmap for cmsy83 char#75 \calK --- */
      {  75,  349,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x0a\xc3\x60\x50\x28\x63" }  },
      /* --- pixel bitmap for cmsy83 char#76 \calL --- */
      {  76,  384,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x4a\x10\x84\xe0\xe6" }  },
      /* --- pixel bitmap for cmsy83 char#77 \calM --- */
      {  77,  413,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xc4\x20\x86\x31\x4a\x31\x52\x91\x69\xc0" }  },
      /* --- pixel bitmap for cmsy83 char#78 \calN --- */
      {  78,  462,                      /* character number, location */
          9,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x46\x08\x46\x30\x82\x09\x4a\x90\x82\x0c\x43\x00" }  },
      /* --- pixel bitmap for cmsy83 char#79 \calO --- */
      {  79,  507,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\xa5\x31\x18\x0c\x45\x1c" }  },
      /* --- pixel bitmap for cmsy83 char#80 \calP --- */
      {  80,  546,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x9a\x92\x14\x43\x08\x02" }  },
      /* --- pixel bitmap for cmsy83 char#81 \calQ --- */
      {  81,  583,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xa3\x30\x18\x0c\x79\x0e\x78" }  },
      /* --- pixel bitmap for cmsy83 char#82 \calR --- */
      {  82,  618,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x49\x49\x24\x1c\x14\x24\xe2" }  },
      /* --- pixel bitmap for cmsy83 char#83 \calS --- */
      {  83,  657,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x49\x20\xb0\x18\x3b" }  },
      /* --- pixel bitmap for cmsy83 char#84 \calT --- */
      {  84,  686,                      /* character number, location */
          8, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x12\x10\x08\x08\x08\x08\x04\x04" }  },
      /* --- pixel bitmap for cmsy83 char#85 \calU --- */
      {  85,  713,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x22\x49\x24\xcb\x64\x6e" }  },
      /* --- pixel bitmap for cmsy83 char#86 \calV --- */
      {  86,  752,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x22\x91\x44\xa2\x28\x0c" }  },
      /* --- pixel bitmap for cmsy83 char#87 \calW --- */
      {  87,  789,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x22\x23\x19\xa9\x44\x25\xa6\x18\x43\x18" }  },
      /* --- pixel bitmap for cmsy83 char#88 \calX --- */
      {  88,  844,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc8\x90\x70\x10\x18\x16\x11\x33" }  },
      /* --- pixel bitmap for cmsy83 char#89 \calY --- */
      {  89,  877,                      /* character number, location */
          8, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x26\x24\x12\x85\xc2\x20\x0a\x03" }  },
      /* --- pixel bitmap for cmsy83 char#90 \calZ --- */
      {  90,  914,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x44\x20\x38\x08\x44\x42\x3f" }  },
      /* --- pixel bitmap for cmsy83 char#91 \cup --- */
      {  91, 1067,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\xc6\x18\xa3\x03" }  },
      /* --- pixel bitmap for cmsy83 char#92 \cap --- */
      {  92, 1100,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x13\x1f\x51\x31" }  },
      /* --- pixel bitmap for cmsy83 char#93 \uplus --- */
      {  93, 3059,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\xc6\x1a\xa3\x03" }  },
      /* --- pixel bitmap for cmsy83 char#94 \wedge --- */
      {  94, 1133,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x28\xa5\x62\x04" }  },
      /* --- pixel bitmap for cmsy83 char#95 \vee --- */
      {  95, 1164,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\x2a\xa5\x08\x01" }  },
      /* --- pixel bitmap for cmsy83 char#96 \vdash --- */
      {  96, 3094,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\xf1\x11\x11" }  },
      /* --- pixel bitmap for cmsy83 char#97 \dashv --- */
      {  97, 3117,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\xe8\x88\x88" }  },
      /* --- pixel bitmap for cmsy83 char#98 \lfloor --- */
      {  98, 3140,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x01\x23" }  },
      /* --- pixel bitmap for cmsy83 char#99 \rfloor --- */
      {  99, 3173,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  3,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x21\x03" }  },
      /* --- pixel bitmap for cmsy83 char#100 \lceil --- */
      { 100, 3206,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x0f\xb1\x23" }  },
      /* --- pixel bitmap for cmsy83 char#101 \rceil --- */
      { 101, 3239,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  3,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xfb\x21" }  },
      /* --- pixel bitmap for cmsy83 char#102 \lbrace --- */
      { 102, 1623,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\x10\x42\xce\x21\x84\x10\x0c" }  },
      /* --- pixel bitmap for cmsy83 char#103 \rbrace --- */
      { 103, 1654,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x10\x42\x38\x27\x84\x90\x01" }  },
      /* --- pixel bitmap for cmsy83 char#104 \langle --- */
      { 104, 3272,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\xa4\x24\x92\x48" }  },
      /* --- pixel bitmap for cmsy83 char#105 \rangle --- */
      { 105, 3305,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x89\x24\x92\x92\x12" }  },
      /* --- pixel bitmap for cmsy83 char#106 \mid --- */
      { 106, 1560,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  1,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f" }  },
      /* --- pixel bitmap for cmsy83 char#107 \parallel --- */
      { 107, 3338,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  5,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x01\x31" }  },
      /* --- pixel bitmap for cmsy83 char#108 \updownarrow --- */
      { 108, 3397,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x7c\x42\x08\x21\xe4\x13\x02" }  },
      /* --- pixel bitmap for cmsy83 char#109 \Updownarrow --- */
      { 109, 3428,                      /* character number, location */
          8,-1,   -2,-1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x66\xc3\x42\x42\x42\x42\xc3\x66\x18" }  },
      /* --- pixel bitmap for cmsy83 char#110 \setminus --- */
      { 110, 1529,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\x24\x49\x22\x09" }  },
      /* --- pixel bitmap for cmsy83 char#111 \wr --- */
      { 111, 3471,                      /* character number, location */
          7, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  2,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xab\x57\x03" }  },
      /* --- pixel bitmap for cmsy83 char#112 \surd --- */
      { 112, 3496,                      /* character number, location */
          1, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x02\x02\x04\x04\x88\x88\x11\x14\x28\x30\x40"
            "\x00" }  },
      /* --- pixel bitmap for cmsy83 char#113 \amalg --- */
      { 113, 3535,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x23\xf5\x11\x41\x18" }  },
      /* --- pixel bitmap for cmsy83 char#114 \nabla --- */
      { 114, 3572,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x82\x44\x44\x6c\x28\x28\x10" }  },
      /* --- pixel bitmap for cmsy83 char#115 \smallint --- */
      { 115, 1718,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb4\x24\x49\x0b" }  },
      /* --- pixel bitmap for cmsy83 char#116 \sqcup --- */
      { 116, 3607,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x01\x31\x05" }  },
      /* --- pixel bitmap for cmsy83 char#117 \sqcap --- */
      { 117, 3640,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\x51\x31" }  },
      /* --- pixel bitmap for cmsy83 char#118 \sqsubseteq --- */
      { 118, 3673,                      /* character number, location */
          7, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\x61\x67\xf2\x76\x10" }  },
      /* --- pixel bitmap for cmsy83 char#119 \sqsupseteq --- */
      { 119, 3702,                      /* character number, location */
          7, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xf6\x61\x16\xf2\x70\x16" }  },
      /* --- pixel bitmap for cmsy83 char#120 \S --- */
      { 120, 3731,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  2,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\xbf\x0f" }  },
      /* --- pixel bitmap for cmsy83 char#121 \dag --- */
      { 121, 3758,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x2e\x49\x12" }  },
      /* --- pixel bitmap for cmsy83 char#122 \ddag --- */
      { 122, 3785,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\x25\xc8\x17" }  },
      /* --- pixel bitmap for cmsy83 char#123 \P --- */
      { 123, 3812,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\xad\xb5\x94\x52\x4a\x01" }  },
      /* --- pixel bitmap for cmsy83 char#124 \clubsuit --- */
      { 124, 3857,                      /* character number, location */
          8, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xf8\xf0\xc1\xe1\xef\xff\x7f\x6b\x10\x00" }  },
      /* --- pixel bitmap for cmsy83 char#125 \Diamond --- */
      { 125, 3886,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x0a\x45\x14\x14\x51\x28\x08" }  },
      /* --- pixel bitmap for cmsy83 char#126 \Heart --- */
      { 126, 3925,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x64\x30\x18\x14\x51\x10" }  },
      /* --- pixel bitmap for cmsy83 char#127 \spadesuit --- */
      { 127, 3964,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\xc7\xf7\xff\xff\xd7\x08" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=1 for .100gf ---
 * mf '\mode=preview; mag=magstep(-17.87427405946994351363); input cmsy10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmsy100 --- */
static	chardef  cmsy100[] =
   {
      /* --- pixel bitmap for cmsy100 char#0 - --- */
      {   0,20118,                      /* character number, location */
          4, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          {  9,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09" }  },
      /* --- pixel bitmap for cmsy100 char#1 \cdot --- */
      {   1,36924,                      /* character number, location */
          4, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          {  1,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01" }  },
      /* --- pixel bitmap for cmsy100 char#2 \times --- */
      {   2,41722,                      /* character number, location */
          7, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x11\x05\x41\x11\x05\x01" }  },
      /* --- pixel bitmap for cmsy100 char#3 \ast --- */
      {   3,42321,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\x3a\x57\x09" }  },
      /* --- pixel bitmap for cmsy100 char#4 \div --- */
      {   4,43148,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x00\x00\xf8\x0f\x00\x00\x04" }  },
      /* --- pixel bitmap for cmsy100 char#5 \diamond --- */
      {   5,37433,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x8a\x28\x28\xa2\x20\x00" }  },
      /* --- pixel bitmap for cmsy100 char#6 \pm --- */
      {   6,20789,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x41\x49\xf2\x41\x49" }  },
      /* --- pixel bitmap for cmsy100 char#7 \mp --- */
      {   7,43827,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xf2\x41\x49\xf3\x41\x41" }  },
      /* --- pixel bitmap for cmsy100 char#8 \oplus --- */
      {   8,21508,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x24\x45\x8c\xf8\x3f\x62\x44\x49\x7c\x00" }  },
      /* --- pixel bitmap for cmsy100 char#9 \ominus --- */
      {   9,44547,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x05\x0c\xf8\x3f\x60\x40\x41\x7c\x00" }  },
      /* --- pixel bitmap for cmsy100 char#10 \otimes --- */
      {  10,22252,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x15\x4d\x19\x31\x65\x51\x41\x7c\x00" }  },
      /* --- pixel bitmap for cmsy100 char#11 \oslash --- */
      {  11,45280,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x05\x0d\x19\x31\x61\x41\x41\x7c\x00" }  },
      /* --- pixel bitmap for cmsy100 char#12 \odot --- */
      {  12,46022,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x05\x0c\x18\x31\x60\x40\x41\x7c\x00" }  },
      /* --- pixel bitmap for cmsy100 char#13 \bigcirc --- */
      {  13,46867,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x51\x61\x20\xf1\x11\x81\x1f\x41\xa1\xf1\x11\x81"
            "\x10\x21\x61\x56\x31" }  },
      /* --- pixel bitmap for cmsy100 char#14 \circ --- */
      {  14,47481,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc6\xe8\x00" }  },
      /* --- pixel bitmap for cmsy100 char#15 \bullet --- */
      {  15,48054,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\xff\xef\x00" }  },
      /* --- pixel bitmap for cmsy100 char#16 \asymp --- */
      {  16,48720,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x05\xf1\x01\xc0\x47\x50\x40" }  },
      /* --- pixel bitmap for cmsy100 char#17 \equiv --- */
      {  17,35557,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xf2\x99\xf2\x99" }  },
      /* --- pixel bitmap for cmsy100 char#18 \subseteq --- */
      {  18,49431,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x27\x11\x7f\x41\x80\x11\x97\xf2\x99" }  },
      /* --- pixel bitmap for cmsy100 char#19 \supseteq --- */
      {  19,50144,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x91\x10\xf4\x81\x71\x17\x20\xf2\x99" }  },
      /* --- pixel bitmap for cmsy100 char#20 \leq --- */
      {  20,34167,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x62\x52\x52\x52\x82\x92\x92\x92\xf2\x99" }  },
      /* --- pixel bitmap for cmsy100 char#21 \geq --- */
      {  21,34854,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x92\x92\x92\x92\x62\x52\x52\x52\x70\xf2\x99" }  },
      /* --- pixel bitmap for cmsy100 char#22 \preceq --- */
      {  22,50825,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\x71\x62\x25\x92\x91\x10\xf1\x81\xf2\x99" }  },
      /* --- pixel bitmap for cmsy100 char#23 \succeq --- */
      {  23,51505,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\x80\x11\x92\x95\x22\x61\x7f\x11\x80\xf2\x99" }  },
      /* --- pixel bitmap for cmsy100 char#24 \sim --- */
      {  24,52163,                      /* character number, location */
          5, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  9,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x77\x87\x03" }  },
      /* --- pixel bitmap for cmsy100 char#25 \approx --- */
      {  25,52883,                      /* character number, location */
          7, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x37\xc6\x0e\xe7\x70\x63\xec\x70" }  },
      /* --- pixel bitmap for cmsy100 char#26 \subset --- */
      {  26,30405,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x27\x11\x7f\x41\x80\x11\x97" }  },
      /* --- pixel bitmap for cmsy100 char#27 \supset --- */
      {  27,31079,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x91\x10\xf4\x81\x71\x17\x22" }  },
      /* --- pixel bitmap for cmsy100 char#28 \ll --- */
      {  28,53692,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0c\x33\x88\x60\x06\x11\x60\x06\x88\x00\x33\xc0"
            "\x0c" }  },
      /* --- pixel bitmap for cmsy100 char#29 \gg --- */
      {  29,54500,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\xc0\x0c\x10\x01\x66\x80\x08\x66\x10\xc1\x0c\x33"
            "\x00" }  },
      /* --- pixel bitmap for cmsy100 char#30 \prec --- */
      {  30,55155,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\x71\x62\x25\x92\x91\x10\xf1\x81" }  },
      /* --- pixel bitmap for cmsy100 char#31 \succ --- */
      {  31,55791,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x02\x08\x60\x00\x9f\x81\x80\x00\x01\x00" }  },
      /* --- pixel bitmap for cmsy100 char#32 \leftarrow --- */
      {  32,27376,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    7, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x21\x90\x12\x9c\x12\x90\xf1\x21\x91" }  },
      /* --- pixel bitmap for cmsy100 char#33 \rightarrow --- */
      {  33,28382,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    7, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x91\x20\x92\x1c\x92\x10\xf1\x91\x21" }  },
      /* --- pixel bitmap for cmsy100 char#34 \uparrow --- */
      {  34,26355,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x31\x30\x23\x22\x11\x12\xf8\x31\x31" }  },
      /* --- pixel bitmap for cmsy100 char#35 \downarrow --- */
      {  35,25570,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x31\x32\x11\x12\x23\x20\xf1\x31\x31" }  },
      /* --- pixel bitmap for cmsy100 char#36 \leftrightarrow --- */
      {  36,29725,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x42\x20\x06\xf6\xff\x06\x46\x20\x04\x02" }  },
      /* --- pixel bitmap for cmsy100 char#37 \nearrow --- */
      {  37,56801,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\xd4\xb2\xa1\x11\x91\x21\x81\x41\x61\xb1\xb1\xb1"
            "\xb1\xb1\xb1\xc2" }  },
      /* --- pixel bitmap for cmsy100 char#38 \searrow --- */
      {  38,57825,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xd1\xd1\xd1\xd1\xd1\xd1\xd1\x41\x81\x21\xa1\x11"
            "\xb2\x94\x81\x52" }  },
      /* --- pixel bitmap for cmsy100 char#39 \simeq --- */
      {  39,58529,                      /* character number, location */
          6, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x77\x87\x03\x00\x00\xc0\x7f" }  },
      /* --- pixel bitmap for cmsy100 char#40 \Leftarrow --- */
      {  40,59511,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,    9, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\xa1\xaa\x12\xa1\xc1\xc9\x32\xb1\x71" }  },
      /* --- pixel bitmap for cmsy100 char#41 \Rightarrow --- */
      {  41,60494,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\xb1\x2a\xa2\xa1\x91\x19\x92\x91\x31" }  },
      /* --- pixel bitmap for cmsy100 char#42 \Uparrow --- */
      {  42,61292,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   12, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\x54\x32\x22\x12\x42\xf7\x11\x41\x11" }  },
      /* --- pixel bitmap for cmsy100 char#43 \Downarrow --- */
      {  43,62118,                      /* character number, location */
         10, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  8,   12, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x11\x41\x12\x42\x12\x22\x34\x52\x31" }  },
      /* --- pixel bitmap for cmsy100 char#44 \Leftrightarrow --- */
      {  44,63364,                      /* character number, location */
          8, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x10\xe2\x5f\x80\x01\x0a\xe4\x1f\x21\x84\x00" }  },
      /* --- pixel bitmap for cmsy100 char#45 \nwarrow --- */
      {  45,64388,                      /* character number, location */
         11, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x84\x92\xb1\x11\xa1\x21\x81\x41\xd1\xd1\xd1\xd1"
            "\xd1\xd1\xd1" }  },
      /* --- pixel bitmap for cmsy100 char#46 \swarrow --- */
      {  46,65412,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xb1\xb1\xb1\xb1\xb1\xb1\x61\x41\x81\x21\x91\x11"
            "\xa2\xb4\xd1\x72" }  },
      /* --- pixel bitmap for cmsy100 char#47 \propto --- */
      {  47,66448,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\xa3\x84\x08\x11\xc5\x31" }  },
      /* --- pixel bitmap for cmsy100 char#48 \prime --- */
      {  48,66940,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x44\x22\x11" }  },
      /* --- pixel bitmap for cmsy100 char#49 \infty --- */
      {  49,40158,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x17\x89\x61\x18\x86\x91\xe8\x70" }  },
      /* --- pixel bitmap for cmsy100 char#50 \in --- */
      {  50,31708,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x41\x20\xf0\x0f\x04\x04\x7c" }  },
      /* --- pixel bitmap for cmsy100 char#51 \ni --- */
      {  51,67569,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x10\x10\xf8\x07\x02\x41\x1f" }  },
      /* --- pixel bitmap for cmsy100 char#52 \triangle --- */
      {  52,68311,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x80\x02\x14\x10\x81\x08\x82\x10\x44\x40\x02\xfa"
            "\x3f" }  },
      /* --- pixel bitmap for cmsy100 char#53 \bigtriangledown --- */
      {  53,69080,                      /* character number, location */
          7, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x17\x90\x80\x08\x42\x10\x44\x20\x02\x0a\x50\x00"
            "\x01" }  },
      /* --- pixel bitmap for cmsy100 char#54 \boldslash --- */
      {  54,69432,                      /* character number, location */
         10, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x10\x08\x02\x41\x20\x10\x04\x82\x40\x10\x00" }  },
      /* --- pixel bitmap for cmsy100 char#55 \' --- */
      {  55,69783,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  1,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for cmsy100 char#56 \forall --- */
      {  56,32304,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x03\x0a\xf2\x47\x84\x08\x0a\x14\x10\x20\x00" }  },
      /* --- pixel bitmap for cmsy100 char#57 \exists --- */
      {  57,32907,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xf2\x51\x15\xf3\x51\x06" }  },
      /* --- pixel bitmap for cmsy100 char#58 \neg --- */
      {  58,33497,                      /* character number, location */
          5, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    4, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xf2\x61" }  },
      /* --- pixel bitmap for cmsy100 char#59 \emptyset --- */
      {  59,70458,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xe5\x5a\x6b\xad\xc2\x09" }  },
      /* --- pixel bitmap for cmsy100 char#60 \Re --- */
      {  60,72229,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xec\x68\x24\x11\x85\xf4\x59\x01\x09\x24\x93\x38\x0e" }  },
      /* --- pixel bitmap for cmsy100 char#61 \Im --- */
      {  61,73456,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x84\x06\x0e\x10\xd8\x30\xa0\x41\x84\xf0\x00" }  },
      /* --- pixel bitmap for cmsy100 char#62 \top --- */
      {  62,74122,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xf7\x41\x42" }  },
      /* --- pixel bitmap for cmsy100 char#63 \bot --- */
      {  63,74797,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x41\x49" }  },
      /* --- pixel bitmap for cmsy100 char#64 \aleph --- */
      {  64,75990,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x24\xd7\x55\x96\x49\xd2\x08" }  },
      /* --- pixel bitmap for cmsy100 char#65 \calA --- */
      {  65,  722,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x0a\x50\x40\x02\x12\x88\xe0\x8f\x40\x03\x06" }  },
      /* --- pixel bitmap for cmsy100 char#66 \calB --- */
      {  66, 1412,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe4\x28\x32\x26\x63\x4d\xa0\x40\x41\x7d\x00" }  },
      /* --- pixel bitmap for cmsy100 char#67 \calC --- */
      {  67, 2053,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xa2\x28\x10\x08\x04\x44\x1c" }  },
      /* --- pixel bitmap for cmsy100 char#68 \calD --- */
      {  68, 2823,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x24\x94\x20\x82\x08\x12\x44\x10\x31\x3e\x00" }  },
      /* --- pixel bitmap for cmsy100 char#69 \calE --- */
      {  69, 3450,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xa2\x40\xc0\x11\x04\x42\x1e" }  },
      /* --- pixel bitmap for cmsy100 char#70 \calF --- */
      {  70, 4166,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x8f\x04\x48\x00\x02\xe0\x03\x02\x10\x00\x01\x0e"
            "\x00" }  },
      /* --- pixel bitmap for cmsy100 char#71 \calG --- */
      {  71, 4845,                      /* character number, location */
          9, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xa2\x30\x10\x0c\x86\x7d\x90\x07" }  },
      /* --- pixel bitmap for cmsy100 char#72 \calH --- */
      {  72, 5703,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x26\x98\x10\x42\xfe\x11\x42\x08\x21\x84\x03" }  },
      /* --- pixel bitmap for cmsy100 char#73 \calI --- */
      {  73, 6424,                      /* character number, location */
          9,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x45\x80\x80\x00\x01\x02\x02\x44\x7f\x00" }  },
      /* --- pixel bitmap for cmsy100 char#74 \calJ --- */
      {  74, 7070,                      /* character number, location */
          9, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x87\x09\x44\x00\x01\x08\x40\x00\x01\x08\x21\xf0"
            "\x00" }  },
      /* --- pixel bitmap for cmsy100 char#75 \calK --- */
      {  75, 7843,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\xc9\x50\x60\xa0\x40\x82\x84\x90\xc1\x00" }  },
      /* --- pixel bitmap for cmsy100 char#76 \calL --- */
      {  76, 8559,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x90\x08\x08\x04\x04\x04\x9e\x71" }  },
      /* --- pixel bitmap for cmsy100 char#77 \calM --- */
      {  77, 9626,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x40\x08\x30\x0c\x18\x05\x8a\x82\x42\x22\x11\x89"
            "\x08\x43\x03\x60" }  },
      /* --- pixel bitmap for cmsy100 char#78 \calN --- */
      {  78,10545,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x0c\x21\x10\x82\x21\x28\x81\x12\x28\x41\x14\xc4"
            "\x30\x08" }  },
      /* --- pixel bitmap for cmsy100 char#79 \calO --- */
      {  79,11282,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x50\x24\x61\x80\x01\x06\x14\x90\x30\x3c\x00" }  },
      /* --- pixel bitmap for cmsy100 char#80 \calP --- */
      {  80,12023,                      /* character number, location */
          9, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x24\x9c\x20\x82\x88\xd1\x41\x00\x01\x02\x08\x00" }  },
      /* --- pixel bitmap for cmsy100 char#81 \calQ --- */
      {  81,12808,                      /* character number, location */
          9, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x08\x09\x0c\x18\x30\x50\x10\x1f\x0e\xe0\x03" }  },
      /* --- pixel bitmap for cmsy100 char#82 \calR --- */
      {  82,13601,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x49\x50\x82\x10\x82\x0f\x22\x10\x81\x90\x02\x03" }  },
      /* --- pixel bitmap for cmsy100 char#83 \calS --- */
      {  83,14271,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x84\x04\x08\x70\x81\x81\x43\x3c" }  },
      /* --- pixel bitmap for cmsy100 char#84 \calT --- */
      {  84,14939,                      /* character number, location */
          9, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1a\x41\x40\xf3\x41\x50\xf2\x31\x60\x21\x71" }  },
      /* --- pixel bitmap for cmsy100 char#85 \calU --- */
      {  85,15655,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x09\x12\x12\x24\x2c\x4c\x94\x24\xc6\x00" }  },
      /* --- pixel bitmap for cmsy100 char#86 \calV --- */
      {  86,16296,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x04\x12\x24\x44\x88\x08\x09\x0a\x0c\x00" }  },
      /* --- pixel bitmap for cmsy100 char#87 \calW --- */
      {  87,17273,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x90\x30\x48\x0c\x92\x44\x24\x11\x45\xc2\x90\x18"
            "\x14\x06\x03" }  },
      /* --- pixel bitmap for cmsy100 char#88 \calX --- */
      {  88,18026,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x06\x21\xc8\xc0\x01\x02\x2c\x18\x21\x08\x83\x01" }  },
      /* --- pixel bitmap for cmsy100 char#89 \calY --- */
      {  89,18711,                      /* character number, location */
          9, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x21\x08\x21\x44\x10\x41\x02\x05\x08\x11\x38\x00" }  },
      /* --- pixel bitmap for cmsy100 char#90 \calZ --- */
      {  90,19491,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x13\x44\x08\x10\xf0\x40\x80\x90\x41\xff\x00" }  },
      /* --- pixel bitmap for cmsy100 char#91 \cup --- */
      {  91,22900,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x01\x51\x11\x31\x33\x22" }  },
      /* --- pixel bitmap for cmsy100 char#92 \cap --- */
      {  92,23539,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x31\x31\x1f\x61\x51" }  },
      /* --- pixel bitmap for cmsy100 char#93 \uplus --- */
      {  93,76697,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x60\x30\xd9\x4d\x06\x45\x1c" }  },
      /* --- pixel bitmap for cmsy100 char#94 \wedge --- */
      {  94,24161,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x85\x22\x12\x89\x82\x41" }  },
      /* --- pixel bitmap for cmsy100 char#95 \vee --- */
      {  95,24781,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xa0\x48\x24\xa2\x50\x10\x08" }  },
      /* --- pixel bitmap for cmsy100 char#96 \vdash --- */
      {  96,77294,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x01\x56\x0f\x41\x52" }  },
      /* --- pixel bitmap for cmsy100 char#97 \dashv --- */
      {  97,77872,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x51\x15\xf4\x51" }  },
      /* --- pixel bitmap for cmsy100 char#98 \lfloor --- */
      {  98,78360,                      /* character number, location */
         10, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  4,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x01\x34" }  },
      /* --- pixel bitmap for cmsy100 char#99 \rfloor --- */
      {  99,78855,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  4,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x31\x04" }  },
      /* --- pixel bitmap for cmsy100 char#100 \lceil --- */
      { 100,79351,                      /* character number, location */
         10, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  4,   13, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xb1\x34" }  },
      /* --- pixel bitmap for cmsy100 char#101 \rceil --- */
      { 101,79848,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  4,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfb\x31" }  },
      /* --- pixel bitmap for cmsy100 char#102 \lbrace --- */
      { 102,38233,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\x10\x42\xc8\x20\x84\x10\x82\x01" }  },
      /* --- pixel bitmap for cmsy100 char#103 \rbrace --- */
      { 103,39036,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x10\x42\x08\x26\x84\x10\x32\x00" }  },
      /* --- pixel bitmap for cmsy100 char#104 \langle --- */
      { 104,80316,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x24\x12\x11\x22\x84\x08" }  },
      /* --- pixel bitmap for cmsy100 char#105 \rangle --- */
      { 105,80785,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x42\x84\x88\x44\x12\x01" }  },
      /* --- pixel bitmap for cmsy100 char#106 \mid --- */
      { 106,36449,                      /* character number, location */
         10, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  1,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f" }  },
      /* --- pixel bitmap for cmsy100 char#107 \parallel --- */
      { 107,81344,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x01\x31" }  },
      /* --- pixel bitmap for cmsy100 char#108 \updownarrow --- */
      { 108,82488,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x67\x8d\x40\x20\x10\x88\x35\x07\x81\x00" }  },
      /* --- pixel bitmap for cmsy100 char#109 \Updownarrow --- */
      { 109,83523,                      /* character number, location */
          9, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x24\xc3\x42\x42\x42\x42\x42\xc3\x24\x18" }  },
      /* --- pixel bitmap for cmsy100 char#110 \setminus --- */
      { 110,36053,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x08\x21\x08\x21\x08\x21\x08\x01" }  },
      /* --- pixel bitmap for cmsy100 char#111 \wr --- */
      { 111,83964,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  2,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xab\x57\x03" }  },
      /* --- pixel bitmap for cmsy100 char#112 \surd --- */
      { 112,84782,                      /* character number, location */
          1, 1,  -13, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x40\x00\x04\x20\x00\x02\x10\x00\x21\x08\x87"
            "\x40\x04\x48\x80\x02\x28\x00\x01" }  },
      /* --- pixel bitmap for cmsy100 char#113 \amalg --- */
      { 113,85934,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x23\xf6\x11\x41\x18" }  },
      /* --- pixel bitmap for cmsy100 char#114 \nabla --- */
      { 114,86826,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x2c\x90\x61\x84\x20\x81\x04\x0c\x30\x00" }  },
      /* --- pixel bitmap for cmsy100 char#115 \smallint --- */
      { 115,41061,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x23\x42\x08\x21\x84\x88\x31\x00" }  },
      /* --- pixel bitmap for cmsy100 char#116 \sqcup --- */
      { 116,87458,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x01\x51\x07" }  },
      /* --- pixel bitmap for cmsy100 char#117 \sqcap --- */
      { 117,88101,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\x71\x51" }  },
      /* --- pixel bitmap for cmsy100 char#118 \sqsubseteq --- */
      { 118,88816,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x0f\x61\x9a\xf2\xa9\x11" }  },
      /* --- pixel bitmap for cmsy100 char#119 \sqsupseteq --- */
      { 119,89521,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 10,   13, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\xf6\x91\x19\xf2\xa0\x19" }  },
      /* --- pixel bitmap for cmsy100 char#120 \S --- */
      { 120,90480,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x11\x96\x99\x86\x98\x06" }  },
      /* --- pixel bitmap for cmsy100 char#121 \dag --- */
      { 121,91266,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x21\x25\xf7\x21\x20" }  },
      /* --- pixel bitmap for cmsy100 char#122 \ddag --- */
      { 122,92237,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x7c\x42\x08\x20\xc4\x7f\x42\x00" }  },
      /* --- pixel bitmap for cmsy100 char#123 \P --- */
      { 123,92895,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\xd7\xeb\xf5\x72\xb1\x50\x28\x14\x0a\x85\x02" }  },
      /* --- pixel bitmap for cmsy100 char#124 \clubsuit --- */
      { 124,93797,                      /* character number, location */
         10, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\xc0\x07\x3e\xf0\x01\x07\xff\xfd\xff\xff\xaf\x37"
            "\x19\x08\x40\x00" }  },
      /* --- pixel bitmap for cmsy100 char#125 \Diamond --- */
      { 125,94462,                      /* character number, location */
         10, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x50\xa0\x20\x22\x48\xb0\x20\x41\x44\x50\xa0\x80"
            "\x00" }  },
      /* --- pixel bitmap for cmsy100 char#126 \Heart --- */
      { 126,95227,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\x22\x46\x0c\x18\x50\x10\x11\x14\x10\x20\x00" }  },
      /* --- pixel bitmap for cmsy100 char#127 \spadesuit --- */
      { 127,96054,                      /* character number, location */
         10, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x20\xe0\xe0\xe3\xef\xff\xff\xff\xd7\x25\x41\x80"
            "\x00" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=2 for .118gf ---
 * mf '\mode=preview; mag=magstep(-16.96645799324018499600); input cmsy10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmsy118 --- */
static	chardef  cmsy118[] =
   {
      /* --- pixel bitmap for cmsy118 char#0 - --- */
      {   0,20576,                      /* character number, location */
          5, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 11,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b" }  },
      /* --- pixel bitmap for cmsy118 char#1 \cdot --- */
      {   1,37492,                      /* character number, location */
          6, 2,    4, 2,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmsy118 char#2 \times --- */
      {   2,42368,                      /* character number, location */
          9, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x05\x11\x41\x01\x01\x05\x11\x41\x01\x01" }  },
      /* --- pixel bitmap for cmsy118 char#3 \ast --- */
      {   3,42975,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xb2\x33\x3b\x82\x00" }  },
      /* --- pixel bitmap for cmsy118 char#4 \div --- */
      {   4,43774,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    9, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x42\x40\xf1\xaa\xf1\xa0\xf1\x42\x41" }  },
      /* --- pixel bitmap for cmsy118 char#5 \diamond --- */
      {   5,38055,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x8a\x28\x28\xa2\x20\x00" }  },
      /* --- pixel bitmap for cmsy118 char#6 \pm --- */
      {   6,21247,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x51\x5b\xf3\x51\x5b" }  },
      /* --- pixel bitmap for cmsy118 char#7 \mp --- */
      {   7,44457,                      /* character number, location */
          9, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\xf3\x51\x5b\xf4\x51\x50" }  },
      /* --- pixel bitmap for cmsy118 char#8 \oplus --- */
      {   8,21970,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x89\x88\x42\x18\xc2\xff\x87\x30\x84\x22\x22"
            "\x09\x3e\x00" }  },
      /* --- pixel bitmap for cmsy118 char#9 \ominus --- */
      {   9,45181,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x80\x02\x18\xc0\xff\x07\x30\x80\x02\x22"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for cmsy118 char#10 \otimes --- */
      {  10,22726,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\xc1\x12\x19\xc5\x10\x46\x31\x91\x06\x23"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for cmsy118 char#11 \oslash --- */
      {  11,45922,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\xc0\x02\x19\xc4\x10\x46\x30\x81\x06\x22"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for cmsy118 char#12 \odot --- */
      {  12,46672,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x80\x02\x18\xc7\x38\xc6\x31\x80\x02\x22"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for cmsy118 char#13 \bigcirc --- */
      {  13,47529,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 14,   14, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x82\x42\x51\x81\x20\xf1\x11\xa1\x1f\x31\xc1\xf1"
            "\x11\xa1\x10\x21\x81\x52\x42\x84\x52" }  },
      /* --- pixel bitmap for cmsy118 char#14 \circ --- */
      {  14,48147,                      /* character number, location */
          7, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\xa1\x07" }  },
      /* --- pixel bitmap for cmsy118 char#15 \bullet --- */
      {  15,48724,                      /* character number, location */
          7, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xde\xff\xff\xbf\x07" }  },
      /* --- pixel bitmap for cmsy118 char#16 \asymp --- */
      {  16,49392,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x34\x18\x3e\x00\x00\x00\x00\xe0\xc3\x60\x01\x04" }  },
      /* --- pixel bitmap for cmsy118 char#17 \equiv --- */
      {  17,36061,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    9, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\xf2\xbb\xf2\xbb" }  },
      /* --- pixel bitmap for cmsy118 char#18 \subseteq --- */
      {  18,50103,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x21\x91\x9f\x41\xa0\x11\xb1\xb8\xf2\xbb" }  },
      /* --- pixel bitmap for cmsy118 char#19 \supseteq --- */
      {  19,50820,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xb1\xb1\x10\xf4\xa1\x91\x91\x28\x30\xf2\xbb" }  },
      /* --- pixel bitmap for cmsy118 char#20 \leq --- */
      {  20,34663,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\x82\x72\x72\x72\x72\xa2\xb2\xb2\xb2\xb2\xf2\xbb" }  },
      /* --- pixel bitmap for cmsy118 char#21 \geq --- */
      {  21,35354,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xb2\xb2\xb2\xb2\xb2\x82\x72\x72\x72\x72\x90\xf2"
            "\xbb" }  },
      /* --- pixel bitmap for cmsy118 char#22 \preceq --- */
      {  22,51505,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xa1\x91\x91\x73\x35\xb3\xb1\xb1\x10\xf1\xa1\xf2"
            "\xbb" }  },
      /* --- pixel bitmap for cmsy118 char#23 \succeq --- */
      {  23,52189,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xa0\x11\xb1\xb3\xb5\x33\x71\x91\x9f\x11\xa0"
            "\xf2\xbb" }  },
      /* --- pixel bitmap for cmsy118 char#24 \sim --- */
      {  24,52851,                      /* character number, location */
          6, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 11,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x9c\x61\x98\x83\x07" }  },
      /* --- pixel bitmap for cmsy118 char#25 \approx --- */
      {  25,53577,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x9c\x61\x98\x83\xe7\xc1\x19\x86\x39\x78" }  },
      /* --- pixel bitmap for cmsy118 char#26 \subset --- */
      {  26,30907,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x21\x91\x9f\x41\xa0\x11\xb1\xb8" }  },
      /* --- pixel bitmap for cmsy118 char#27 \supset --- */
      {  27,31585,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xb1\xb1\x10\xf4\xa1\x91\x91\x28\x31" }  },
      /* --- pixel bitmap for cmsy118 char#28 \ll --- */
      {  28,54386,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x21\x20\x04\x42\x40\x08\x8c\x81\x10\x10\x02\x08"
            "\x01\x8c\x01\x84\x00\xc6\x00\x63\x00\x21" }  },
      /* --- pixel bitmap for cmsy118 char#29 \gg --- */
      {  29,55210,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x80\x10\xc0\x18\x40\x08\x60\x0c\x30\x06\x10\x02"
            "\x42\x20\x04\x84\xc0\x18\x08\x01\x21\x00" }  },
      /* --- pixel bitmap for cmsy118 char#30 \prec --- */
      {  30,55881,                      /* character number, location */
          9, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xa1\x91\x91\x73\x35\xb3\xb1\xb1\x10\xf1\xa1" }  },
      /* --- pixel bitmap for cmsy118 char#31 \succ --- */
      {  31,56521,                      /* character number, location */
          9, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xa0\x11\xb1\xb3\xb5\x33\x71\x91\x9f\x11\xa1" }  },
      /* --- pixel bitmap for cmsy118 char#32 \leftarrow --- */
      {  32,27878,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 14,    7, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\xc1\xc2\xbe\x12\xd1\xe1\xa9" }  },
      /* --- pixel bitmap for cmsy118 char#33 \rightarrow --- */
      {  33,28884,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 14,    7, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\xe1\xd2\x1e\xb2\xc1\xc1\x39" }  },
      /* --- pixel bitmap for cmsy118 char#34 \uparrow --- */
      {  34,26855,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   14, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x31\x30\x23\x22\x11\x12\xf9\x31\x31" }  },
      /* --- pixel bitmap for cmsy118 char#35 \downarrow --- */
      {  35,26068,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   14, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x31\x32\x11\x12\x23\x20\xf1\x31\x31" }  },
      /* --- pixel bitmap for cmsy118 char#36 \leftrightarrow --- */
      {  36,30227,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 14,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x01\x62\x80\xfd\xff\x06\x18\x01\x82\x40\x00" }  },
      /* --- pixel bitmap for cmsy118 char#37 \nearrow --- */
      {  37,57535,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 14,   14, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x95\xc2\xb1\x11\xa1\x21\x91\x31\x81\xc1\xc1\xc1\xc1"
            "\xc1\xc1\xc1\xc1\xd1" }  },
      /* --- pixel bitmap for cmsy118 char#38 \searrow --- */
      {  38,58561,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 14,   14, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\xe1\x31\xa1\x21"
            "\xb1\x11\xc2\x95" }  },
      /* --- pixel bitmap for cmsy118 char#39 \simeq --- */
      {  39,59267,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    8, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x14\x53\x22\x42\x42\x23\x54\x10\xf2\xbb" }  },
      /* --- pixel bitmap for cmsy118 char#40 \Leftarrow --- */
      {  40,60255,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,    9, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\xc1\xcb\x12\xc1\xe1\xeb\x41\xe1\x8b" }  },
      /* --- pixel bitmap for cmsy118 char#41 \Rightarrow --- */
      {  41,61238,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,    9, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\xd1\x3b\xd2\xc1\xb1\x1b\xb1\xb1\x4b" }  },
      /* --- pixel bitmap for cmsy118 char#42 \Uparrow --- */
      {  42,62036,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 10,   13, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x74\x52\x22\x32\x42\x11\x11\x41\x11\xf7\x21\x41"
            "\x21" }  },
      /* --- pixel bitmap for cmsy118 char#43 \Downarrow --- */
      {  43,62870,                      /* character number, location */
         11, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 10,   13, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x21\x41\x21\x11\x41\x11\x12\x42\x32\x22\x54\x72"
            "\x41" }  },
      /* --- pixel bitmap for cmsy118 char#44 \Leftrightarrow --- */
      {  44,64124,                      /* character number, location */
          9, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x41\x20\xfe\x17\x80\x01\x28\x40\xfc\x43\x20\x08"
            "\x01" }  },
      /* --- pixel bitmap for cmsy118 char#45 \nwarrow --- */
      {  45,65148,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 15,   14, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x15\xa2\xd1\x11\xc1\x21\xb1\x31\xe0\x11\xe0\x11\xe0"
            "\x11\xe0\x11\xe0\x11\xe0\x11\xe0\x11\xe0\x11\xe0\x11" }  },
      /* --- pixel bitmap for cmsy118 char#46 \swarrow --- */
      {  46,66174,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 15,   14, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\xd1\x91\x31\xa1\x21"
            "\xb1\x11\xc2\xd5\x91" }  },
      /* --- pixel bitmap for cmsy118 char#47 \propto --- */
      {  47,67238,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x97\x45\x18\x82\x10\x0c\xd1\x70\x18" }  },
      /* --- pixel bitmap for cmsy118 char#48 \prime --- */
      {  48,67734,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\x64\x26\x13\x01" }  },
      /* --- pixel bitmap for cmsy118 char#49 \infty --- */
      {  49,40792,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x8e\x48\x14\x0c\x06\x83\xc1\xa0\x48\xc4\xe1\x00" }  },
      /* --- pixel bitmap for cmsy118 char#50 \in --- */
      {  50,32218,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x21\x71\x7f\x11\x89\x0f\x11\x80\x11\x91\x96" }  },
      /* --- pixel bitmap for cmsy118 char#51 \ni --- */
      {  51,68365,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x80\x00\x02\x08\xf0\x3f\x40\x80\x80\x80\xfc\x00" }  },
      /* --- pixel bitmap for cmsy118 char#52 \triangle --- */
      {  52,69059,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x14\x80\x02\x88\x00\x11\x10\x04\x01\x21\x20"
            "\x02\x48\x00\xfd\x7f" }  },
      /* --- pixel bitmap for cmsy118 char#53 \bigtriangledown --- */
      {  53,69780,                      /* character number, location */
          8, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x5f\x00\x09\x20\x02\x42\x40\x10\x04\x44\x80\x08"
            "\xa0\x00\x14\x00\x01" }  },
      /* --- pixel bitmap for cmsy118 char#54 \boldslash --- */
      {  54,70136,                      /* character number, location */
         11, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x01\x02\x02\x02\x04\x04\x04\x08\x08\x08\x10"
            "\x10\x00" }  },
      /* --- pixel bitmap for cmsy118 char#55 \' --- */
      {  55,70487,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  1,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f" }  },
      /* --- pixel bitmap for cmsy118 char#56 \forall --- */
      {  56,32792,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x03\x0a\xf2\x47\x84\x08\x11\x14\x28\x20\x40\x00" }  },
      /* --- pixel bitmap for cmsy118 char#57 \exists --- */
      {  57,33399,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xf3\x61\x07\xf3\x61\x07" }  },
      /* --- pixel bitmap for cmsy118 char#58 \neg --- */
      {  58,33991,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    5, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xf3\x81" }  },
      /* --- pixel bitmap for cmsy118 char#59 \emptyset --- */
      {  59,71166,                      /* character number, location */
         12, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x27\xa5\x69\x5a\x96\x65\x29\x39\x02" }  },
      /* --- pixel bitmap for cmsy118 char#60 \Re --- */
      {  60,72951,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\xc8\x49\x84\x24\x28\xa1\xf9\x4c\x02\x12\x90\x48"
            "\x84\xc1\x01" }  },
      /* --- pixel bitmap for cmsy118 char#61 \Im --- */
      {  61,74184,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x10\x6c\x80\x03\x20\x60\x86\x02\x04\x20\x03\x61"
            "\x08\x3c\x00" }  },
      /* --- pixel bitmap for cmsy118 char#62 \top --- */
      {  62,74854,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\xf9\x51\x52" }  },
      /* --- pixel bitmap for cmsy118 char#63 \bot --- */
      {  63,75533,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x51\x5b" }  },
      /* --- pixel bitmap for cmsy118 char#64 \aleph --- */
      {  64,76730,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x42\x42\xc6\x49\x59\x31\x21\x42\x42\x83" }  },
      /* --- pixel bitmap for cmsy118 char#65 \calA --- */
      {  65,  748,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x30\x80\x02\x28\x40\x02\x22\x20\x02\x3f\x08"
            "\x92\x40\x06\x0c" }  },
      /* --- pixel bitmap for cmsy118 char#66 \calB --- */
      {  66, 1498,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\x91\x48\x21\x43\xe4\x10\x46\xa0\x80\x02\x0a\xd6"
            "\x07" }  },
      /* --- pixel bitmap for cmsy118 char#67 \calC --- */
      {  67, 2147,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x10\x12\x14\x24\x20\x40\x80\x00\x01\x84\xf1\x00" }  },
      /* --- pixel bitmap for cmsy118 char#68 \calD --- */
      {  68, 2949,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xc3\x84\x49\x40\x08\x08\x01\x21\x20\x04\x42\x40"
            "\x08\x04\x71\xf0\x01" }  },
      /* --- pixel bitmap for cmsy118 char#69 \calE --- */
      {  69, 3610,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x84\x82\x02\x3c\x04\x02\x01\x01\x61\x1e" }  },
      /* --- pixel bitmap for cmsy118 char#70 \calF --- */
      {  70, 4358,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x1f\x12\x20\x02\x20\x00\x04\x80\x0f\x08\x00\x01"
            "\x10\x00\x02\x38\x00" }  },
      /* --- pixel bitmap for cmsy118 char#71 \calG --- */
      {  71, 5041,                      /* character number, location */
         11, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x21\x48\x90\x40\x01\x04\x14\x50\x60\xc2\xf0\x02"
            "\x08\x10\x3e\x00" }  },
      /* --- pixel bitmap for cmsy118 char#72 \calH --- */
      {  72, 5911,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xd0\x04\x89\x20\x10\x04\x42\x20\x08\xfe\x81\x10"
            "\x08\x02\x41\x20\x78" }  },
      /* --- pixel bitmap for cmsy118 char#73 \calI --- */
      {  73, 6588,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x0b\x01\x02\x08\x20\x40\x00\x01\x04\x08\x20\xf4"
            "\x0f" }  },
      /* --- pixel bitmap for cmsy118 char#74 \calJ --- */
      {  74, 7238,                      /* character number, location */
         11, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 14,   13, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x61\x41\x71\x41\x71\x41\x40\xf1\x91\x40\xf2\x81"
            "\x51\x71\x51\x61\x71\x41\x94\x81" }  },
      /* --- pixel bitmap for cmsy118 char#75 \calK --- */
      {  75, 7997,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x47\x06\x09\x28\xc0\x00\x06\x50\x40\x02\x22\x10"
            "\x62\xe0\x00" }  },
      /* --- pixel bitmap for cmsy118 char#76 \calL --- */
      {  76, 8667,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x01\x19\x04\x20\x80\x00\x04\x20\x80\x00\x04\xf4"
            "\x51\x78\x00" }  },
      /* --- pixel bitmap for cmsy118 char#77 \calM --- */
      {  77, 9766,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x00\x82\x00\x04\x06\x18\x18\x50\x50\x20\x41\x82"
            "\x02\x09\x09\x22\x22\x08\x85\x10\x0c\x32\x00\x18" }  },
      /* --- pixel bitmap for cmsy118 char#78 \calN --- */
      {  78,10699,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xe0\x10\x10\x10\x10\x30\x08\x30\x08\x48\x08\x48"
            "\x04\x48\x04\x88\x04\x84\x04\x04\x03\x03\x02" }  },
      /* --- pixel bitmap for cmsy118 char#79 \calO --- */
      {  79,11472,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x90\x83\x44\x24\x28\x81\x01\x18\x80\x01\x14\x40\x01"
            "\x22\x18\x7c\x00" }  },
      /* --- pixel bitmap for cmsy118 char#80 \calP --- */
      {  80,12225,                      /* character number, location */
         11, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x63\x42\x12\x08\x81\x10\x08\x41\x10\x83\x0e\x08"
            "\x80\x00\x04\x40\x00" }  },
      /* --- pixel bitmap for cmsy118 char#81 \calQ --- */
      {  81,13044,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x41\x10\x01\x05\x18\xc0\x00\x06\x48\x40\xbc\x01"
            "\x83\x07\x60\x04\x1c" }  },
      /* --- pixel bitmap for cmsy118 char#82 \calR --- */
      {  82,13875,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xc7\x04\x49\x20\x08\x04\x41\x20\x04\x74\x40\x04"
            "\x08\x01\x41\x12\x38" }  },
      /* --- pixel bitmap for cmsy118 char#83 \calS --- */
      {  83,14581,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x21\x48\x00\x01\x18\x80\x03\xd0\x40\x01\x0d\xc2"
            "\x07" }  },
      /* --- pixel bitmap for cmsy118 char#84 \calT --- */
      {  84,15253,                      /* character number, location */
         11, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   12, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2a\x11\x41\x51\x41\x60\xf2\x51\x60\xf3\x41\x70\xf1"
            "\x31\x81" }  },
      /* --- pixel bitmap for cmsy118 char#85 \calU --- */
      {  85,15949,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x88\x40\x08\x44\x60\x04\x22\x30\x82\x12\x14\x21"
            "\x11\x11\x0e\x03" }  },
      /* --- pixel bitmap for cmsy118 char#86 \calV --- */
      {  86,16654,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x11\x88\x20\x82\x08\x21\x84\x08\x12\x28\x50\xc0"
            "\x00" }  },
      /* --- pixel bitmap for cmsy118 char#87 \calW --- */
      {  87,17639,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x41\x04\x83\x84\x82\x84\x82\x44\x42\x44\x44\x24"
            "\x24\x14\x24\x14\x14\x0c\x0c\x04\x04" }  },
      /* --- pixel bitmap for cmsy118 char#88 \calX --- */
      {  88,18436,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x08\x84\x40\x04\x24\xc0\x01\x06\x58\x40\x08\x82"
            "\x10\x08\x03\x03" }  },
      /* --- pixel bitmap for cmsy118 char#89 \calY --- */
      {  89,19129,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x42\x20\x04\x21\x08\x22\x10\x81\x04\x14\xa0\x00"
            "\x43\x08\x32\x60\x00" }  },
      /* --- pixel bitmap for cmsy118 char#90 \calZ --- */
      {  90,19947,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x31\x61\xa1\xa1\x83\xa3\x81\xa1\x92\x61\x21\x71"
            "\x29\x31" }  },
      /* --- pixel bitmap for cmsy118 char#91 \cup --- */
      {  91,23382,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x01\x71\x11\x51\x35\x21" }  },
      /* --- pixel bitmap for cmsy118 char#92 \cap --- */
      {  92,24025,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\x31\x51\x1f\x71\x71" }  },
      /* --- pixel bitmap for cmsy118 char#93 \uplus --- */
      {  93,77441,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x03\x46\x8c\xd8\x37\x62\xc4\x80\x82\xf8\x00" }  },
      /* --- pixel bitmap for cmsy118 char#94 \wedge --- */
      {  94,24651,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x20\xa0\x40\x41\x84\x88\x20\x41\x01\x03\x02" }  },
      /* --- pixel bitmap for cmsy118 char#95 \vee --- */
      {  95,25275,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x03\x0a\x12\x44\x84\x08\x0a\x14\x10\x20\x00" }  },
      /* --- pixel bitmap for cmsy118 char#96 \vdash --- */
      {  96,78046,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x01\x78\x0f\x41\x71" }  },
      /* --- pixel bitmap for cmsy118 char#97 \dashv --- */
      {  97,78626,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x71\x08\xf4\x71" }  },
      /* --- pixel bitmap for cmsy118 char#98 \lfloor --- */
      {  98,79116,                      /* character number, location */
         12, 3,   -3, 3,      /* topleft row,col, and botleft row,col */
          {  4,   15, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x01\x34" }  },
      /* --- pixel bitmap for cmsy118 char#99 \rfloor --- */
      {  99,79615,                      /* character number, location */
         12, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  4,   15, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x31\x04" }  },
      /* --- pixel bitmap for cmsy118 char#100 \lceil --- */
      { 100,80115,                      /* character number, location */
         12, 3,   -3, 3,      /* topleft row,col, and botleft row,col */
          {  4,   15, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xd1\x34" }  },
      /* --- pixel bitmap for cmsy118 char#101 \rceil --- */
      { 101,80616,                      /* character number, location */
         12, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  4,   15, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfd\x31" }  },
      /* --- pixel bitmap for cmsy118 char#102 \lbrace --- */
      { 102,38855,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   16, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\xf5\x31\x2f\x13\x30\xf5\x31\x20\x42" }  },
      /* --- pixel bitmap for cmsy118 char#103 \rbrace --- */
      { 103,39664,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   16, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x30\xf5\x31\x20\xf1\x42\xf5\x31\x23\x31" }  },
      /* --- pixel bitmap for cmsy118 char#104 \langle --- */
      { 104,81088,                      /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x44\x22\x11\x21\x42\x84\x08" }  },
      /* --- pixel bitmap for cmsy118 char#105 \rangle --- */
      { 105,81561,                      /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x22\x44\x88\x48\x24\x12\x01" }  },
      /* --- pixel bitmap for cmsy118 char#106 \mid --- */
      { 106,36985,                      /* character number, location */
         12, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  1,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff" }  },
      /* --- pixel bitmap for cmsy118 char#107 \parallel --- */
      { 107,82124,                      /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   15, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x41" }  },
      /* --- pixel bitmap for cmsy118 char#108 \updownarrow --- */
      { 108,83276,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x67\x8d\x40\x20\x10\x08\x04\x02\xb1\xe6\x20"
            "\x10" }  },
      /* --- pixel bitmap for cmsy118 char#109 \Updownarrow --- */
      { 109,84317,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x20\x61\x58\xa1\x84\x10\x42\x08\x21\x84\x10\x52"
            "\xa8\x61\x48\xc0\x00" }  },
      /* --- pixel bitmap for cmsy118 char#110 \setminus --- */
      { 110,36557,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x20\x08\x02\x41\x10\x08\x82\x40\x10\x04\x82" }  },
      /* --- pixel bitmap for cmsy118 char#111 \wr --- */
      { 111,84804,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\xad\x65\x06" }  },
      /* --- pixel bitmap for cmsy118 char#112 \surd --- */
      { 112,85622,                      /* character number, location */
          1, 2,  -16, 2,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x10\x00\x01\x20\x00\x02\x40\x00\x04\x80\x00\x08"
            "\x00\x61\x10\x08\x02\x22\x40\x04\x50\x00\x0a\xc0\x00"
            "\x10\x00" }  },
      /* --- pixel bitmap for cmsy118 char#113 \amalg --- */
      { 113,86780,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x25\xf8\x21\x61\x2c" }  },
      /* --- pixel bitmap for cmsy118 char#114 \nabla --- */
      { 114,87680,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3f\xc0\x02\x44\x20\x04\x82\x10\x08\x01\x09\x90"
            "\x00\x06\x60\x00" }  },
      /* --- pixel bitmap for cmsy118 char#115 \smallint --- */
      { 115,41701,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x28\x04\x82\x40\x20\x10\x08\x04\x81\x50\x18\x00" }  },
      /* --- pixel bitmap for cmsy118 char#116 \sqcup --- */
      { 116,88320,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x71\x09" }  },
      /* --- pixel bitmap for cmsy118 char#117 \sqcap --- */
      { 117,88967,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\x81\x71" }  },
      /* --- pixel bitmap for cmsy118 char#118 \sqsubseteq --- */
      { 118,89686,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0f\x81\xbc\xf2\xcb\x11" }  },
      /* --- pixel bitmap for cmsy118 char#119 \sqsupseteq --- */
      { 119,90395,                      /* character number, location */
         10, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xf8\xb1\x1b\xf2\xc0\x1b" }  },
      /* --- pixel bitmap for cmsy118 char#120 \S --- */
      { 120,91358,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc6\x60\x54\x8c\x8a\xc1\x18\x1d" }  },
      /* --- pixel bitmap for cmsy118 char#121 \dag --- */
      { 121,92100,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   14, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x21\x25\xf8\x21\x22" }  },
      /* --- pixel bitmap for cmsy118 char#122 \ddag --- */
      { 122,93021,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x90\x4f\x08\x01\x84\xf8\x4f\x08" }  },
      /* --- pixel bitmap for cmsy118 char#123 \P --- */
      { 123,93681,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x3d\x7d\xfa\xf4\xe9\x93\x27\x4e\x90\x20\x41\x82"
            "\x04\x09\x12" }  },
      /* --- pixel bitmap for cmsy118 char#124 \clubsuit --- */
      { 124,94587,                      /* character number, location */
         11, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\x95\x40\xf1\x37\x30\x45\x5b\x1f\x2d\x05\x11\x15"
            "\x13\x21\x23\x10\xf1\x61\x61" }  },
      /* --- pixel bitmap for cmsy118 char#125 \Diamond --- */
      { 125,95254,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x80\x02\x14\x10\x41\x10\x01\x05\x50\x40\x04\x41"
            "\x04\x14\xa0\x00\x02" }  },
      /* --- pixel bitmap for cmsy118 char#126 \Heart --- */
      { 126,96023,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xde\x0b\x61\x08\x03\x18\x40\x01\x09\x88\x20\xd8\x80"
            "\x02\x08\x00" }  },
      /* --- pixel bitmap for cmsy118 char#127 \spadesuit --- */
      { 127,96856,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x00\x01\x1c\xf0\xc1\x1f\xff\xfd\xff\xff\xff\x7f"
            "\xbd\xc9\x40\x00\x02" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=3 for .131gf ---
 * mf '\mode=preview; mag=magstep(-16.39322518098640003469); input cmsy10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmsy131 --- */
static	chardef  cmsy131[] =
   {
      /* --- pixel bitmap for cmsy131 char#0 - --- */
      {   0,20854,                      /* character number, location */
          5, 2,    4, 2,      /* topleft row,col, and botleft row,col */
          { 10,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a" }  },
      /* --- pixel bitmap for cmsy131 char#1 \cdot --- */
      {   1,38460,                      /* character number, location */
          6, 2,    4, 2,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmsy131 char#2 \times --- */
      {   2,43450,                      /* character number, location */
          9, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x42\x24\x18\x08\x18\x24\x42\x81" }  },
      /* --- pixel bitmap for cmsy131 char#3 \ast --- */
      {   3,44079,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xc4\x9a\xc3\x59\x23\x10" }  },
      /* --- pixel bitmap for cmsy131 char#4 \div --- */
      {   4,44936,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x52\x50\xf2\xcc\xf2\xc0\xf1\x52\x52" }  },
      /* --- pixel bitmap for cmsy131 char#5 \diamond --- */
      {   5,38997,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x50\x10\x11\x14\x50\x10\x11\x14\x10\x00" }  },
      /* --- pixel bitmap for cmsy131 char#6 \pm --- */
      {   6,21551,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x61\x5c\xf4\x61\x5c" }  },
      /* --- pixel bitmap for cmsy131 char#7 \mp --- */
      {   7,45645,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xf4\x61\x5c\xf5\x61\x50" }  },
      /* --- pixel bitmap for cmsy131 char#8 \oplus --- */
      {   8,22304,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x24\x42\x24\x44\x41\x18\x84\xff\x1f\x84\x41"
            "\x28\x44\x42\x44\x24\xf8\x01" }  },
      /* --- pixel bitmap for cmsy131 char#9 \ominus --- */
      {   9,46399,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x20\x02\x24\x40\x01\x18\x80\xff\x1f\x80\x01"
            "\x28\x40\x02\x44\x20\xf8\x01" }  },
      /* --- pixel bitmap for cmsy131 char#10 \otimes --- */
      {  10,23098,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x20\x06\xa6\x50\x91\x18\x86\x21\x18\x86\x91"
            "\xa8\x50\x06\x46\x20\xf8\x01" }  },
      /* --- pixel bitmap for cmsy131 char#11 \oslash --- */
      {  11,47174,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x20\x02\x26\x50\x81\x18\x84\x21\x18\x82\x11"
            "\xa8\x40\x06\x44\x20\xf8\x01" }  },
      /* --- pixel bitmap for cmsy131 char#12 \odot --- */
      {  12,47962,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x20\x02\x24\x40\x01\x18\x86\x61\x18\x86\x01"
            "\x28\x40\x02\x44\x20\xf8\x01" }  },
      /* --- pixel bitmap for cmsy131 char#13 \bigcirc --- */
      {  13,48853,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\xa2\x42\x71\x81\x51\xa1\x20\xf1\x11\xc1\x1f\x41"
            "\xe1\xf1\x11\xc1\x10\x21\xa1\x51\x81\x72\x42\xa4\x61" }  },
      /* --- pixel bitmap for cmsy131 char#14 \circ --- */
      {  14,49509,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\x71\x00" }  },
      /* --- pixel bitmap for cmsy131 char#15 \bullet --- */
      {  15,50116,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xdf\xff\xff\xf7\x71\x00" }  },
      /* --- pixel bitmap for cmsy131 char#16 \asymp --- */
      {  16,50812,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    9, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xa1\x12\x62\x46\x30\xf2\xc0\x36\x42\x62\x11\xa1" }  },
      /* --- pixel bitmap for cmsy131 char#17 \equiv --- */
      {  17,36991,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    9, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xf2\xcc\xf2\xcc" }  },
      /* --- pixel bitmap for cmsy131 char#18 \subseteq --- */
      {  18,51549,                      /* character number, location */
         12, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\x21\x81\x8f\x41\x90\x11\xa1\xa7\xf2\xaa" }  },
      /* --- pixel bitmap for cmsy131 char#19 \supseteq --- */
      {  19,52292,                      /* character number, location */
         12, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xa1\xa1\x10\xf4\x91\x81\x81\x27\x30\xf2\xaa" }  },
      /* --- pixel bitmap for cmsy131 char#20 \leq --- */
      {  20,35541,                      /* character number, location */
         12, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x72\x62\x62\x62\x71\xa2\xa2\xa2\xa2\xa1\xf2\xaa" }  },
      /* --- pixel bitmap for cmsy131 char#21 \geq --- */
      {  21,36258,                      /* character number, location */
         12, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xa2\xa2\xa2\xa2\xa1\x72\x62\x62\x62\x71\x90\xf2"
            "\xaa" }  },
      /* --- pixel bitmap for cmsy131 char#22 \preceq --- */
      {  22,53003,                      /* character number, location */
         12, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x91\x81\x81\x63\x34\xa3\xa1\xa1\x10\xf1\x91\xf2"
            "\xaa" }  },
      /* --- pixel bitmap for cmsy131 char#23 \succeq --- */
      {  23,53713,                      /* character number, location */
         12, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\x90\x11\xa1\xa3\xa4\x33\x61\x81\x8f\x11\x90"
            "\xf2\xaa" }  },
      /* --- pixel bitmap for cmsy131 char#24 \sim --- */
      {  24,54401,                      /* character number, location */
          7, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 12,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x38\x83\x61\x18\xcc\x81\x07" }  },
      /* --- pixel bitmap for cmsy131 char#25 \approx --- */
      {  25,55159,                      /* character number, location */
          9, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x38\x83\xe1\x1c\x78\x00\x00\x00\x1e\x38\x83\xe1"
            "\x1c\x78" }  },
      /* --- pixel bitmap for cmsy131 char#26 \subset --- */
      {  26,31591,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\x21\x81\x8f\x41\x90\x11\xa1\xa7" }  },
      /* --- pixel bitmap for cmsy131 char#27 \supset --- */
      {  27,32295,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xa1\xa1\x10\xf4\x91\x81\x81\x27\x32" }  },
      /* --- pixel bitmap for cmsy131 char#28 \ll --- */
      {  28,55996,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 16,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x84\x00\x63\xc0\x18\x20\x04\x18\x03\xc6\x00\x21"
            "\x00\xc6\x00\x18\x03\x20\x04\xc0\x18\x00\x63\x00\x84" }  },
      /* --- pixel bitmap for cmsy131 char#29 \gg --- */
      {  29,56846,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 16,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x00\xc6\x00\x18\x03\x20\x04\xc0\x18\x00\x63\x00"
            "\x84\x00\x63\xc0\x18\x20\x04\x18\x03\xc6\x00\x21\x00" }  },
      /* --- pixel bitmap for cmsy131 char#30 \prec --- */
      {  30,57543,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x91\x81\x81\x63\x34\xa3\xa1\xa1\x10\xf1\x91" }  },
      /* --- pixel bitmap for cmsy131 char#31 \succ --- */
      {  31,58209,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\x90\x11\xa1\xa3\xa4\x33\x61\x81\x8f\x11\x91" }  },
      /* --- pixel bitmap for cmsy131 char#32 \leftarrow --- */
      {  32,28468,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,    9, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x31\xc0\x22\xd2\xde\x02\x12\xe0\x12\xc0\xf1\x31"
            "\xc1" }  },
      /* --- pixel bitmap for cmsy131 char#33 \rightarrow --- */
      {  33,29504,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,    9, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xc1\x30\xc2\xe0\x12\x1e\x02\xd2\xd2\x20\xf1\xc1"
            "\x31" }  },
      /* --- pixel bitmap for cmsy131 char#34 \uparrow --- */
      {  34,27413,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  9,   17, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\x40\x33\x55\x22\x21\x22\xfb\x41\x40" }  },
      /* --- pixel bitmap for cmsy131 char#35 \downarrow --- */
      {  35,26594,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  9,   17, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x41\x42\x21\x22\x25\x53\x30\xf1\x41\x40" }  },
      /* --- pixel bitmap for cmsy131 char#36 \leftrightarrow --- */
      {  36,30877,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x10\x08\x10\x0c\x30\x06\x60\xff\xff\x06\x60\x0c"
            "\x30\x08\x10\x08\x10" }  },
      /* --- pixel bitmap for cmsy131 char#37 \nearrow --- */
      {  37,59249,                      /* character number, location */
         14, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\xe0\x35\xe0\x12\xe1\x11\xd1\x21\xc1\x31\xb1\x51"
            "\x91\xe0\x11\xe0\x11\xe0\x11\xe0\x11\xe0\x11\xe0\x11"
            "\xe0\x11\xe0\x11\xe0\x11\xe0\x23" }  },
      /* --- pixel bitmap for cmsy131 char#38 \searrow --- */
      {  38,60309,                      /* character number, location */
         12, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x31\xe0\x31\xe0\x31\xe0\x31\xe0\x31\xe0\x31"
            "\xe0\x31\xe0\x31\xe0\x31\xe0\x31\x51\xb1\x31\xd1\x21"
            "\xe1\x11\xe0\x12\xc5\xb1\x60" }  },
      /* --- pixel bitmap for cmsy131 char#39 \simeq --- */
      {  39,61049,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x14\x63\x23\x42\x52\x23\x64\x10\xf2\xcc" }  },
      /* --- pixel bitmap for cmsy131 char#40 \Leftarrow --- */
      {  40,62063,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   11, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x51\xa0\x41\xed\xf1\x12\xd0\x22\xe0\x1d\x41\xb0"
            "\xf1\x51\xa0" }  },
      /* --- pixel bitmap for cmsy131 char#41 \Rightarrow --- */
      {  41,63076,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xa1\x40\xb1\x3d\x20\xf1\xd2\xc2\x1d\xd1\x30\xf1"
            "\xa1\x41" }  },
      /* --- pixel bitmap for cmsy131 char#42 \Uparrow --- */
      {  42,63904,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x42\x40\x31\x21\x51\x41\x23\x43\xfa\x21\x41\x21" }  },
      /* --- pixel bitmap for cmsy131 char#43 \Downarrow --- */
      {  43,64772,                      /* character number, location */
         13, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x21\x41\x23\x43\x21\x41\x51\x21\x30\xf1\x42\x41" }  },
      /* --- pixel bitmap for cmsy131 char#44 \Leftrightarrow --- */
      {  44,66060,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x02\x41\x80\xf8\x7f\x03\x70\x00\x28\x00\xf1"
            "\x3f\x0c\x0c\x02\x81\x40\x00" }  },
      /* --- pixel bitmap for cmsy131 char#45 \nwarrow --- */
      {  45,67118,                      /* character number, location */
         14, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\xb5\xc2\xe0\x11\x11\xe1\x21\xd1\x31\xb1\x51\xe0"
            "\x31\xe0\x31\xe0\x31\xe0\x31\xe0\x31\xe0\x31\xe0\x31"
            "\xe0\x31\xe0\x31\xe0\x31" }  },
      /* --- pixel bitmap for cmsy131 char#46 \swarrow --- */
      {  46,68178,                      /* character number, location */
         12, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x21\xe0\x11\xe0\x11\xe0\x11\xe0\x11\xe0\x11\xe0"
            "\x11\xe0\x11\xe0\x11\xe0\x11\x91\x51\xb1\x31\xc1\x21"
            "\xd1\x11\xe2\xe0\x15\xe0\x31\xa3" }  },
      /* --- pixel bitmap for cmsy131 char#47 \propto --- */
      {  47,69224,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x2c\x22\x41\x11\x08\x81\x10\x14\x22\xc2\xc1" }  },
      /* --- pixel bitmap for cmsy131 char#48 \prime --- */
      {  48,69728,                      /* character number, location */
         10, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  4,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\x64\x26\x32\x01" }  },
      /* --- pixel bitmap for cmsy131 char#49 \infty --- */
      {  49,41832,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x38\x22\x46\x41\x81\x81\x81\x81\x81\x81\x82\x62"
            "\x44\x1c\x38" }  },
      /* --- pixel bitmap for cmsy131 char#50 \in --- */
      {  50,32954,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x04\x02\x01\x01\xff\x01\x01\x02\x04\xf8" }  },
      /* --- pixel bitmap for cmsy131 char#51 \ni --- */
      {  51,70385,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x20\x40\x80\x80\xff\x80\x80\x40\x20\x1f" }  },
      /* --- pixel bitmap for cmsy131 char#52 \triangle --- */
      {  52,71131,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x14\x80\x02\x88\x00\x11\x10\x04\x82\x20\x20"
            "\x04\x44\x00\x09\xa0\x00\xf8\xff\x01" }  },
      /* --- pixel bitmap for cmsy131 char#53 \bigtriangledown --- */
      {  53,71912,                      /* character number, location */
          9, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3f\x00\x0a\x20\x01\x44\x40\x08\x08\x82\x40\x10"
            "\x10\x01\x22\x80\x02\x50\x00\x04\x00" }  },
      /* --- pixel bitmap for cmsy131 char#54 \boldslash --- */
      {  54,72276,                      /* character number, location */
         13, 3,   -4, 3,      /* topleft row,col, and botleft row,col */
          {  9,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x01\x02\x02\x04\x04\x08\x08\x10\x20\x20\x40"
            "\x40\x80\x80\x00\x01\x01\x00" }  },
      /* --- pixel bitmap for cmsy131 char#55 \' --- */
      {  55,72635,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  2,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd5\x15" }  },
      /* --- pixel bitmap for cmsy131 char#56 \forall --- */
      {  56,33580,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x0c\xa0\x80\x04\xc4\x1f\x82\x10\x04\x11\x88\x80"
            "\x02\x14\x40\x00\x02" }  },
      /* --- pixel bitmap for cmsy131 char#57 \exists --- */
      {  57,34221,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xf4\x71\x08\xf4\x71\x08" }  },
      /* --- pixel bitmap for cmsy131 char#58 \neg --- */
      {  58,34843,                      /* character number, location */
          7, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 10,    5, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\xf3\x91" }  },
      /* --- pixel bitmap for cmsy131 char#59 \emptyset --- */
      {  59,73340,                      /* character number, location */
         14, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x9e\x0c\x12\x8d\x26\x93\xc9\x62\xb1\x68\xf2\x08"
            "\x00" }  },
      /* --- pixel bitmap for cmsy131 char#60 \Re --- */
      {  60,75159,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\x93\x72\x19\xa6\xe1\x1c\xcc\x63\xfd\xb1\x1b\x98"
            "\x81\x19\x99\x91\x99\x0e\x07" }  },
      /* --- pixel bitmap for cmsy131 char#61 \Im --- */
      {  61,76430,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x20\x0c\x81\x19\x70\x01\x20\x70\x9c\x09\x98\x00"
            "\x73\x30\x0c\x87\x31\xf0\x01" }  },
      /* --- pixel bitmap for cmsy131 char#62 \top --- */
      {  62,77162,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\xfb\x61\x61" }  },
      /* --- pixel bitmap for cmsy131 char#63 \bot --- */
      {  63,77897,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x61\x6d" }  },
      /* --- pixel bitmap for cmsy131 char#64 \aleph --- */
      {  64,79124,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x86\x0d\x32\xcc\x98\x93\x24\x39\x62\x84\x19\x66"
            "\x7c\x10" }  },
      /* --- pixel bitmap for cmsy131 char#65 \calA --- */
      {  65,  748,                      /* character number, location */
         13, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x0c\x00\x03\xe0\x00\x38\x00\x0d\x40\x03\xc8\x00"
            "\x33\x40\x0c\xf8\x07\x83\x6d\x60\x0f\xb8\x01\x00" }  },
      /* --- pixel bitmap for cmsy131 char#66 \calB --- */
      {  66, 1492,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd8\xf7\x33\x8e\x39\xc6\x19\xf6\x31\x9c\xc1\x06\x36"
            "\xb0\xc7\xf6\x01" }  },
      /* --- pixel bitmap for cmsy131 char#67 \calC --- */
      {  67, 2167,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x31\x33\x36\x66\x60\xc0\x80\x01\x03\x06\x1f\xf3"
            "\x01" }  },
      /* --- pixel bitmap for cmsy131 char#68 \calD --- */
      {  68, 2947,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x8f\x19\x37\x86\x87\xc1\x30\x30\x0c\x0c\x03\xc3"
            "\x60\x18\x0c\x86\x81\x39\xf8\x01" }  },
      /* --- pixel bitmap for cmsy131 char#69 \calE --- */
      {  69, 3614,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x61\xce\x18\x03\x1c\xe0\xc1\x80\x01\x03\x0c\x76"
            "\x8c\x0f" }  },
      /* --- pixel bitmap for cmsy131 char#70 \calF --- */
      {  70, 4366,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x3f\x36\xc4\x0c\x10\x03\x60\x00\x18\x00\x7e\xc0"
            "\x00\x30\x00\x06\xb0\x01\x3c\x00" }  },
      /* --- pixel bitmap for cmsy131 char#71 \calG --- */
      {  71, 5083,                      /* character number, location */
         12, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x63\xcc\xb0\x61\x06\x0c\x38\xd8\x60\xc3\x9d\xe7"
            "\x0f\x30\x64\xf8\x00" }  },
      /* --- pixel bitmap for cmsy131 char#72 \calH --- */
      {  72, 5957,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xb0\x19\x36\x86\x85\x61\x60\x0c\x0c\xc3\xff\xc0"
            "\x30\x30\x06\x86\x81\x61\x62\x78\x0c\x00" }  },
      /* --- pixel bitmap for cmsy131 char#73 \calI --- */
      {  73, 6670,                      /* character number, location */
         12,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\x22\x32\x52\x42\x40\xf2\x62\x50\xf2\x52\x60\x42"
            "\xb2\x32\x2a\x32" }  },
      /* --- pixel bitmap for cmsy131 char#74 \calJ --- */
      {  74, 7338,                      /* character number, location */
         12, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   14, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x62\x32\x72\x32\x72\x32\x40\xf1\x92\x40\xf2\x82"
            "\x50\x21\x52\x52\x52\x63\x42\x72\x32\x85\x92" }  },
      /* --- pixel bitmap for cmsy131 char#75 \calK --- */
      {  75, 8141,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\xcc\x63\x60\x03\x1c\xc0\x01\x38\x00\x07\x60\x01"
            "\x26\xc0\x08\x1a\xa2\x81\x03" }  },
      /* --- pixel bitmap for cmsy131 char#76 \calL --- */
      {  76, 8827,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x03\x76\x30\x02\x03\x18\x80\x01\x18\xc0\x00\x0c"
            "\xc0\xc0\x7e\x36\x3e" }  },
      /* --- pixel bitmap for cmsy131 char#77 \calM --- */
      {  77, 9930,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 20,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x00\x08\x0c\xc0\xc0\x00\x06\x1e\x70\xa0\x81\x07"
            "\x1a\x6c\xa0\x63\x06\x31\x63\x10\x1b\x06\xf1\x60\x0b"
            "\x06\xf6\x00\xe0\x06\x00\x00" }  },
      /* --- pixel bitmap for cmsy131 char#78 \calN --- */
      {  78,10869,                      /* character number, location */
         14,-1,   -1,-1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x00\x03\x00\x0e\x0e\x0c\x38\x10\xe0\x40\x80\x83"
            "\x00\x1e\x02\x68\x08\x90\x13\x40\x4c\x00\x31\x01\xc2"
            "\x05\x0b\x0e\x3c\x38\x60\x00\x00" }  },
      /* --- pixel bitmap for cmsy131 char#79 \calO --- */
      {  79,11626,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x1f\x36\xc6\x86\x9b\xc1\x06\xf0\x00\x3c\x00\x0f"
            "\x60\x03\xcc\x81\xe1\x30\xf0\x03" }  },
      /* --- pixel bitmap for cmsy131 char#80 \calP --- */
      {  80,12383,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xcf\x8c\x8f\xe1\x30\x0c\x83\x61\x18\x8c\x81\x0f"
            "\x18\x00\x03\x60\x00\x06\x40\x00\x00" }  },
      /* --- pixel bitmap for cmsy131 char#81 \calQ --- */
      {  81,13192,                      /* character number, location */
         12, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 13,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x07\xc3\x31\x70\x03\x6c\x80\x07\xf0\x00\x1e\x60"
            "\x87\xc6\x6f\x00\x06\x3f\x88\x8f\x81\x0f" }  },
      /* --- pixel bitmap for cmsy131 char#82 \calR --- */
      {  82,13979,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x0f\x33\xce\x18\x26\x0c\x03\xc3\x80\x31\xc0\x07"
            "\x60\x07\x18\x03\x8c\x03\x86\x9b\x81\x03" }  },
      /* --- pixel bitmap for cmsy131 char#83 \calS --- */
      {  83,14689,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x87\x31\x86\x31\x80\x03\x78\x00\xcf\x60\x03\x1b"
            "\xd8\x61\xfc\x00" }  },
      /* --- pixel bitmap for cmsy131 char#84 \calT --- */
      {  84,15367,                      /* character number, location */
         13, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 16,   14, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x11\x3c\x22\x42\x72\x52\x70\xf3\x62\x80\xf3\x52"
            "\x90\xf1\x42\xa6" }  },
      /* --- pixel bitmap for cmsy131 char#85 \calU --- */
      {  85,16067,                      /* character number, location */
         12,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x58\x03\x63\x30\x06\xc6\x60\x0c\x8e\xc1\x31\x3c"
            "\xc3\x63\x6c\xcc\x8c\x87\x03" }  },
      /* --- pixel bitmap for cmsy131 char#86 \calV --- */
      {  86,16774,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x76\x30\x07\x31\x88\x41\x0c\x61\x0c\x33\xd8\xc0"
            "\x03\x0e\x30\x80\x00" }  },
      /* --- pixel bitmap for cmsy131 char#87 \calW --- */
      {  87,17761,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 18,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x06\x3b\x38\xcc\xe1\x20\x46\x83\x18\x1d\x62\x62"
            "\x84\x8d\x19\x1e\x26\x38\x58\x60\xe0\xc1\x81\x03\x03"
            "\x04\x04\x10\x00" }  },
      /* --- pixel bitmap for cmsy131 char#88 \calX --- */
      {  88,18600,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x38\x34\x0c\x8c\x01\x33\xc0\x06\x70\x00\x0e\x60"
            "\x07\x8c\x81\x61\x30\x58\x1c\x0e" }  },
      /* --- pixel bitmap for cmsy131 char#89 \calY --- */
      {  89,19327,                      /* character number, location */
         12, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\xb4\x83\x30\x08\x87\x60\x04\x46\x60\x02\x26\x60"
            "\x01\x0e\x60\x10\x02\x11\xe0\x00" }  },
      /* --- pixel bitmap for cmsy131 char#90 \calZ --- */
      {  90,20189,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x1b\xe3\x61\x18\x80\x01\x18\xc0\x07\x30\x80\x01"
            "\x18\x88\x81\xf9\x99\xf1\x01" }  },
      /* --- pixel bitmap for cmsy131 char#91 \cup --- */
      {  91,23792,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x81\x11\x61\x36\x21" }  },
      /* --- pixel bitmap for cmsy131 char#92 \cap --- */
      {  92,24465,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x26\x31\x61\x1f\x81\x81" }  },
      /* --- pixel bitmap for cmsy131 char#93 \uplus --- */
      {  93,79867,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x06\x18\x62\x88\x21\xf6\x1b\x62\x88\x01\x0a\xc4"
            "\x0f" }  },
      /* --- pixel bitmap for cmsy131 char#94 \wedge --- */
      {  94,25121,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\xc0\x00\x03\x12\x48\x10\x42\x88\x40\x02\x05\x18"
            "\x20" }  },
      /* --- pixel bitmap for cmsy131 char#95 \vee --- */
      {  95,25773,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x06\x28\x90\x40\x84\x10\x82\x04\x12\x30\xc0\x00"
            "\x03" }  },
      /* --- pixel bitmap for cmsy131 char#96 \vdash --- */
      {  96,80504,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x01\x89\x0f\x51\x81" }  },
      /* --- pixel bitmap for cmsy131 char#97 \dashv --- */
      {  97,81114,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x81\x09\xf5\x81" }  },
      /* --- pixel bitmap for cmsy131 char#98 \lfloor --- */
      {  98,81634,                      /* character number, location */
         14, 3,   -5, 3,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x4f\x21\x45" }  },
      /* --- pixel bitmap for cmsy131 char#99 \rfloor --- */
      {  99,82167,                      /* character number, location */
         14, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x41\xf2\x41\x05" }  },
      /* --- pixel bitmap for cmsy131 char#100 \lceil --- */
      { 100,82701,                      /* character number, location */
         14, 3,   -5, 3,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\x21\x41" }  },
      /* --- pixel bitmap for cmsy131 char#101 \rceil --- */
      { 101,83236,                      /* character number, location */
         14, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xf2\x41" }  },
      /* --- pixel bitmap for cmsy131 char#102 \lbrace --- */
      { 102,39831,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  7,   19, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x32\x20\xf5\x31\x30\x22\x32\x72\x30\xf5\x31\x30"
            "\x32\x72" }  },
      /* --- pixel bitmap for cmsy131 char#103 \rbrace --- */
      { 103,40672,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  7,   19, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x72\x30\xf5\x31\x30\x32\x72\x32\x20\xf5\x31\x30"
            "\x22\x32\x51" }  },
      /* --- pixel bitmap for cmsy131 char#104 \langle --- */
      { 104,83742,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x22\x44\x88\x10\x21\x04\x21\x08\x41\x08\x42" }  },
      /* --- pixel bitmap for cmsy131 char#105 \rangle --- */
      { 105,84249,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x08\x41\x08\x42\x10\x42\x84\x08\x11\x22\x04" }  },
      /* --- pixel bitmap for cmsy131 char#106 \mid --- */
      { 106,37947,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  1,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\x07" }  },
      /* --- pixel bitmap for cmsy131 char#107 \parallel --- */
      { 107,84846,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x31\x0f\x31\x31" }  },
      /* --- pixel bitmap for cmsy131 char#108 \updownarrow --- */
      { 108,86040,                      /* character number, location */
         14, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  9,   19, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\x40\x33\x55\x22\x21\x22\xf8\x41\x42\x21\x22"
            "\x25\x53\x30\xf1\x41\x41" }  },
      /* --- pixel bitmap for cmsy131 char#109 \Updownarrow --- */
      { 109,87113,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   17, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x71\x21\x51\x41\x23\x43\xf8\x21\x41\x23\x43\x21"
            "\x41\x51\x21\x72\x41" }  },
      /* --- pixel bitmap for cmsy131 char#110 \setminus --- */
      { 110,37513,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  7,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\x40\x20\x20\x10\x08\x08\x04\x02\x02\x81\x80"
            "\x40\x20\x20\x10" }  },
      /* --- pixel bitmap for cmsy131 char#111 \wr --- */
      { 111,87604,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\x49\x6b\x49\x66" }  },
      /* --- pixel bitmap for cmsy131 char#112 \surd --- */
      { 112,88456,                      /* character number, location */
          1, 1,  -17, 1,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\xf1\xd1\x10\xf1\xc1\x20\xf1\xb1\x30\xf1\xa1\x40"
            "\x11\x71\x53\x61\x71\x51\x91\x41\x60\xf1\x31\x31\x70"
            "\xf1\x41\x11\x80\x51\x91" }  },
      /* --- pixel bitmap for cmsy131 char#113 \amalg --- */
      { 113,89646,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x45\xf9\x22\x62\x2e" }  },
      /* --- pixel bitmap for cmsy131 char#114 \nabla --- */
      { 114,90576,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xdf\xff\x19\x20\x06\xc2\x40\x30\x04\x86\x80\x09"
            "\x30\x01\x1c\x80\x03\x20\x00" }  },
      /* --- pixel bitmap for cmsy131 char#115 \smallint --- */
      { 115,42751,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   17, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x61\x11\xf2\x51\x20\xf6\x41\x30\xf2\x31\x41\x21"
            "\x52\x51" }  },
      /* --- pixel bitmap for cmsy131 char#116 \sqcup --- */
      { 116,91242,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x01\x81\x0a" }  },
      /* --- pixel bitmap for cmsy131 char#117 \sqcap --- */
      { 117,91919,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x0f\x91\x81" }  },
      /* --- pixel bitmap for cmsy131 char#118 \sqsubseteq --- */
      { 118,92668,                      /* character number, location */
         12, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0f\x81\xbc\xf2\xcb\x12" }  },
      /* --- pixel bitmap for cmsy131 char#119 \sqsupseteq --- */
      { 119,93403,                      /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\xf8\xa1\x1a\xf2\xb0\x1a" }  },
      /* --- pixel bitmap for cmsy131 char#120 \S --- */
      { 120,94392,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x18\x06\x02\xa1\x85\x61\x68\x21\x10\x18\x46\x0e" }  },
      /* --- pixel bitmap for cmsy131 char#121 \dag --- */
      { 121,95194,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   17, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x31\x37\xfa\x31\x31" }  },
      /* --- pixel bitmap for cmsy131 char#122 \ddag --- */
      { 122,96173,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   17, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x31\x37\xf3\x31\x30\x70\xf2\x31\x30\x1d\xf2\x31"
            "\x31" }  },
      /* --- pixel bitmap for cmsy131 char#123 \P --- */
      { 123,96865,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   17, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x28\x15\x21\x1f\x36\x21\x10\x15\x21\x34\x21\x43\x21"
            "\x10\xf7\x51\x21\x11" }  },
      /* --- pixel bitmap for cmsy131 char#124 \clubsuit --- */
      { 124,97835,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\x95\x40\xf2\x37\x30\x45\x5b\x1f\x3d\x14\x11\x14"
            "\x32\x21\x22\x20\xf1\x61\x60" }  },
      /* --- pixel bitmap for cmsy131 char#125 \Diamond --- */
      { 125,98558,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x14\x80\x02\x88\x80\x20\x08\x88\x00\x0a\x80"
            "\x02\x88\x80\x20\x08\x88\x00\x0a\x40\x01\x10\x00" }  },
      /* --- pixel bitmap for cmsy131 char#126 \Heart --- */
      { 126,99387,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x47\x14\x05\xc1\x00\x18\x00\x03\xa0\x00\x22\x20"
            "\x04\x04\x63\x80\x02\x50\x00\x04\x00" }  },
      /* --- pixel bitmap for cmsy131 char#127 \spadesuit --- */
      { 127,100282,                     /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x61\x60\x53\x95\x77\x59\x3b\x1f\x3d\x05\x11\x15"
            "\x13\x21\x23\x10\xf1\x61\x62" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=4 for .160gf ---
 * mf '\mode=preview; mag=magstep(-15.29639112828755784636); input cmsy10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmsy160 --- */
static	chardef  cmsy160[] =
   {
      /* --- pixel bitmap for cmsy160 char#0 - --- */
      {   0,21432,                      /* character number, location */
          6, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          { 13,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d" }  },
      /* --- pixel bitmap for cmsy160 char#1 \cdot --- */
      {   1,39198,                      /* character number, location */
          7, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for cmsy160 char#2 \times --- */
      {   2,44232,                      /* character number, location */
         11, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x14\x10\x41\x10\x01\x05\x10\x40\x01\x11\x04\x11"
            "\x50\x00\x01" }  },
      /* --- pixel bitmap for cmsy160 char#3 \ast --- */
      {   3,44873,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x10\x10\xd6\x38\x38\xd6\x10\x10\x10" }  },
      /* --- pixel bitmap for cmsy160 char#4 \div --- */
      {   4,45708,                      /* character number, location */
         12, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x62\x60\xf3\xee\xf3\xe0\xf1\x62\x62" }  },
      /* --- pixel bitmap for cmsy160 char#5 \diamond --- */
      {   5,39735,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x80\x02\x22\x08\x22\xa0\x00\x0a\x88\x20\x88\x80"
            "\x02\x08\x00" }  },
      /* --- pixel bitmap for cmsy160 char#6 \pm --- */
      {   6,22129,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x71\x7e\x01\xf5\x71\x7e\x01" }  },
      /* --- pixel bitmap for cmsy160 char#7 \mp --- */
      {   7,46417,                      /* character number, location */
         11, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\xf5\x71\x7e\x01\xf6\x71\x72" }  },
      /* --- pixel bitmap for cmsy160 char#8 \oplus --- */
      {   8,22886,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x4c\x06\x21\x44\x10\x24\x08\x0a\x04\x06\x02"
            "\xff\xff\x81\xc0\x40\xa0\x20\x48\x10\x44\x08\xc1\x64"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for cmsy160 char#9 \ominus --- */
      {   9,47175,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x51\x91\x20\xf1\x11\xb1\x1f\x11\xd1\x0e"
            "\x01\x0f\x11\xd1\xf1\x11\xb1\x10\x21\x91\x52\x52\x85"
            "\x52" }  },
      /* --- pixel bitmap for cmsy160 char#10 \otimes --- */
      {  10,23692,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x44\x01\x25\x41\x0a\x11\x06\x05"
            "\x03\x81\x41\xc1\x10\xa1\x04\x49\x01\x45\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for cmsy160 char#11 \oslash --- */
      {  11,47958,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x44\x00\x25\x40\x0a\x10\x06\x04"
            "\x03\x81\x41\xc0\x10\xa0\x04\x48\x01\x44\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for cmsy160 char#12 \odot --- */
      {  12,48758,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x51\x91\x20\xf1\x11\xb1\x11\xd1\x0f\x21"
            "\x53\x51\x01\xd1\xf1\x11\xb1\x10\x21\x91\x52\x52\x85"
            "\x51" }  },
      /* --- pixel bitmap for cmsy160 char#13 \bigcirc --- */
      {  13,49657,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 20,   19, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\xb3\x63\x71\xc1\x51\xe1\x20\xf1\x11\xe0\x21\x1f"
            "\x61\xe0\x41\xf1\x11\xe0\x21\x10\x21\xe1\x51\xc1\x73"
            "\x63\xb6\x71" }  },
      /* --- pixel bitmap for cmsy160 char#14 \circ --- */
      {  14,50321,                      /* character number, location */
         10, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\x31\x51\x1f\x41\x71\x11\x51\x35\x21" }  },
      /* --- pixel bitmap for cmsy160 char#15 \bullet --- */
      {  15,50936,                      /* character number, location */
         10, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\x37\x1f\x49\x17\x35\x21" }  },
      /* --- pixel bitmap for cmsy160 char#16 \asymp --- */
      {  16,51636,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xd1\x12\x92\x42\x52\x85\x50\xf2\xe0\x10\x55\x82"
            "\x52\x42\x92\x11\xd1" }  },
      /* --- pixel bitmap for cmsy160 char#17 \equiv --- */
      {  17,37713,                      /* character number, location */
         12, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   13, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\xf4\xe0\x1e\x01\xf4\xe0\x1e\x01" }  },
      /* --- pixel bitmap for cmsy160 char#18 \subseteq --- */
      {  18,52381,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x32\xa1\xa0\xf1\x11\xbf\x21\xc0\xf1\x11\xb0\x21"
            "\xd2\xd8\xf4\xdd" }  },
      /* --- pixel bitmap for cmsy160 char#19 \supseteq --- */
      {  19,53128,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xd2\xd1\x20\xf1\xb1\x10\xf2\xc1\xf1\xb1\x10\xa1"
            "\xa2\x38\x50\xf4\xdd" }  },
      /* --- pixel bitmap for cmsy160 char#20 \leq --- */
      {  20,36255,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xa2\x92\x92\x92\x92\x92\xc2\xd2\xd2\xd2\xd2\xd2"
            "\xf4\xdd" }  },
      /* --- pixel bitmap for cmsy160 char#21 \geq --- */
      {  21,36976,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xd2\xd2\xd2\xd2\xd2\xd2\xa2\x92\x92\x92\x92\x92"
            "\xb0\xf4\xdd" }  },
      /* --- pixel bitmap for cmsy160 char#22 \preceq --- */
      {  22,53843,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xc1\xb1\xa2\x83\x46\xd3\xd2\xd1\x10\xf2\xc1\xf4"
            "\xdd" }  },
      /* --- pixel bitmap for cmsy160 char#23 \succeq --- */
      {  23,54557,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x01\xc0\x11\xd2\xd3\xd6\x43\x82\xa1\xbf\x21\xc0"
            "\xf4\xdd" }  },
      /* --- pixel bitmap for cmsy160 char#24 \sim --- */
      {  24,55249,                      /* character number, location */
          8, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 15,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x40\x33\xe0\x70\x38\x60\x16\xe0\x01" }  },
      /* --- pixel bitmap for cmsy160 char#25 \approx --- */
      {  25,56007,                      /* character number, location */
         11, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x40\x33\xe0\x30\x30\x30\x1c\x30\x0b\xf0\xf0\x00"
            "\xcd\x80\xc3\xc0\xc0\x70\xc0\x2c\xc0\x03" }  },
      /* --- pixel bitmap for cmsy160 char#26 \subset --- */
      {  26,32277,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x32\xa1\xa0\xf1\x11\xbf\x21\xc0\xf1\x11\xb0\x21"
            "\xd2\xd8" }  },
      /* --- pixel bitmap for cmsy160 char#27 \supset --- */
      {  27,32985,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xd2\xd1\x20\xf1\xb1\x10\xf2\xc1\xf1\xb1\x10\xa1"
            "\xa2\x38\x51" }  },
      /* --- pixel bitmap for cmsy160 char#28 \ll --- */
      {  28,56866,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 20,   15, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x61\xa2\x52\x92\x52\xa1\x61\xa2\x52\x92\x52\x92"
            "\x52\xa1\x61\xd2\x52\xd2\x52\xd1\x61\xd2\x52\xd2\x52"
            "\xd2\x52\xd1\x61" }  },
      /* --- pixel bitmap for cmsy160 char#29 \gg --- */
      {  29,57724,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 20,   15, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x61\xd2\x52\xd2\x52\xd1\x61\xd2\x52\xd2\x52\xd2"
            "\x52\xd1\x61\xa2\x52\x92\x52\xa1\x61\xa2\x52\x92\x52"
            "\x92\x52\xa1\x61\xc2" }  },
      /* --- pixel bitmap for cmsy160 char#30 \prec --- */
      {  30,58429,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xc1\xb1\xa2\x83\x46\xd3\xd2\xd1\x10\xf2\xc1" }  },
      /* --- pixel bitmap for cmsy160 char#31 \succ --- */
      {  31,59099,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x01\xc0\x11\xd2\xd3\xd6\x43\x82\xa1\xbf\x21\xc2" }  },
      /* --- pixel bitmap for cmsy160 char#32 \leftarrow --- */
      {  32,29138,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   11, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\xe0\x10\x32\xe0\x41\xe0\x41\xe0\x3e\x06\x21"
            "\xe0\x61\xe0\x52\xe0\x10\xf1\x41\xe0\x10" }  },
      /* --- pixel bitmap for cmsy160 char#33 \rightarrow --- */
      {  33,30178,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   11, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x11\x40\xe0\x12\xe0\x51\xe0\x61\x2e\x06\xe0"
            "\x31\xe0\x41\xe0\x42\x30\xf1\xe0\x11\x40" }  },
      /* --- pixel bitmap for cmsy160 char#34 \uparrow --- */
      {  34,28075,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   19, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\x40\x33\x55\x32\x11\x12\x11\x31\x31\xfc\x41"
            "\x41" }  },
      /* --- pixel bitmap for cmsy160 char#35 \downarrow --- */
      {  35,27248,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   19, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x41\x41\x31\x31\x12\x11\x12\x35\x53\x30\xf1\x41"
            "\x41" }  },
      /* --- pixel bitmap for cmsy160 char#36 \leftrightarrow --- */
      {  36,31555,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   11, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\xa1\x40\x32\xa2\x61\xc1\x51\xe1\x2e\x06\x21"
            "\xe1\x51\xc1\x62\xa2\x30\xf1\x41\xa1\x40" }  },
      /* --- pixel bitmap for cmsy160 char#37 \nearrow --- */
      {  37,60143,                      /* character number, location */
         15, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd3\x22\xe0\x42\xe0\x31\xe0\x41\xe0\x41\x31\xe1\x41"
            "\xd1\x51\xc1\xe0\x41\xe0\x41\xe0\x41\xe0\x41\xe0\x41"
            "\xe0\x41\xe0\x41\xe0\x41\xe0\x41\xe0\x41\xe0\x41\xe0"
            "\x41\xe0\x53" }  },
      /* --- pixel bitmap for cmsy160 char#38 \searrow --- */
      {  38,61209,                      /* character number, location */
         16, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,82, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x61\xe0\x61\xe0\x61\xe0\x61\xe0\x61\xe0\x61"
            "\xe0\x61\xe0\x61\xe0\x61\xe0\x61\xe0\x61\xe0\x61\xe0"
            "\x61\x51\xe1\x41\xe0\x11\x31\xe0\x21\xe0\x61\xe0\x62"
            "\xd3\x22" }  },
      /* --- pixel bitmap for cmsy160 char#39 \simeq --- */
      {  39,61955,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x81\x12\x22\x73\x43\x43\x72\x22\x11\x84\x20\xf4"
            "\xe0\x1e\x01" }  },
      /* --- pixel bitmap for cmsy160 char#40 \Leftarrow --- */
      {  40,62975,                      /* character number, location */
         12, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 20,   13, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\xe0\x41\xe0\x41\xe0\x4e\x02\x31\xe0\x20\xf1\x12"
            "\xe0\x30\x31\xe0\x61\xe0\x6e\x01\x51\xe0\x61\xe0\x61"
            "\xc1" }  },
      /* --- pixel bitmap for cmsy160 char#41 \Rightarrow --- */
      {  41,63992,                      /* character number, location */
         12, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   13, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xe0\x51\xe0\x51\x4e\x02\xe0\x51\x20\xf1\xe0\x32"
            "\xe0\x21\xe0\x31\x3e\x01\xe0\x41\xe0\x31\xe0\x31\x61" }  },
      /* --- pixel bitmap for cmsy160 char#42 \Uparrow --- */
      {  42,64824,                      /* character number, location */
         14, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 14,   18, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x62\x60\x51\x21\x91\x41\x62\x62\x33\x63\x11\x21"
            "\x61\x21\xfa\x31\x61\x31" }  },
      /* --- pixel bitmap for cmsy160 char#43 \Downarrow --- */
      {  43,65704,                      /* character number, location */
         15, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 14,   18, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x31\x61\x31\x21\x61\x21\x13\x63\x32\x62\x61\x41"
            "\x91\x21\x50\xf1\x62\x61" }  },
      /* --- pixel bitmap for cmsy160 char#44 \Leftrightarrow --- */
      {  44,67004,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 18,   13, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\x81\x40\x31\xa1\x5e\x32\xc2\x12\xe3\xe0\x21"
            "\x11\xe1\x31\xc1\x5c\x61\xa1\x30\xf1\x41\x81\x41" }  },
      /* --- pixel bitmap for cmsy160 char#45 \nwarrow --- */
      {  45,68070,                      /* character number, location */
         15, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,84, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x12\x23\xe2\xe0\x71\xe0\x71\xe0\x31\x31\xe0\x21\x41"
            "\xe0\x11\x51\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x71"
            "\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0"
            "\x71\xe0\x71" }  },
      /* --- pixel bitmap for cmsy160 char#46 \swarrow --- */
      {  46,69136,                      /* character number, location */
         16, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x61\xe0\x51\xe0\x51\xe0\x51\xe0\x51\xe0\x51\xe0"
            "\x51\xe0\x51\xe0\x51\xe0\x51\xe0\x51\xe0\x51\xe0\x51"
            "\xd1\x51\xe1\x41\xe0\x11\x31\xe0\x51\xe0\x51\xe0\x42"
            "\xe0\x52\x23\xd3" }  },
      /* --- pixel bitmap for cmsy160 char#47 \propto --- */
      {  47,70214,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x70\x21\x84\x20\x21\x60\x10\x30\x08\x18\x04\x0c"
            "\x04\x09\x42\x08\x1e\x38" }  },
      /* --- pixel bitmap for cmsy160 char#48 \prime --- */
      {  48,70752,                      /* character number, location */
         12, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x23\xc6\x88\x11\x62\x04" }  },
      /* --- pixel bitmap for cmsy160 char#49 \infty --- */
      {  49,42594,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xc0\x61\x0c\x63\x02\x09\x14\x50\x80\x01\x06\x18"
            "\x60\x80\x01\x0a\x28\x90\x40\xc6\x30\x86\x03\x1c" }  },
      /* --- pixel bitmap for cmsy160 char#50 \in --- */
      {  50,33648,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   13, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x32\x81\x80\xf1\x11\x91\xac\xa0\xf1\x11\x90\x21"
            "\xb2\xb6" }  },
      /* --- pixel bitmap for cmsy160 char#51 \ni --- */
      {  51,71413,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   13, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xb2\xb1\x20\xf1\x91\x10\xac\xa1\xf1\x91\x10\x81"
            "\x82\x36\x51" }  },
      /* --- pixel bitmap for cmsy160 char#52 \triangle --- */
      {  52,72163,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\xf1\x71\x11\x70\xf1\x61\x31\x60\xf1\x51\x51"
            "\x50\x41\x71\x40\xf1\x31\x91\x30\xf1\x21\xb1\x20\xf1"
            "\x11\xd1\x1e\x03" }  },
      /* --- pixel bitmap for cmsy160 char#53 \bigtriangledown --- */
      {  53,72952,                      /* character number, location */
         11, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\xf1\x11\xd1\x10\xf1\x21\xb1\x20\xf1\x31\x91"
            "\x30\x41\x71\x40\xf1\x51\x51\x50\xf1\x61\x31\x60\xf1"
            "\x71\x11\x70\x81\x80" }  },
      /* --- pixel bitmap for cmsy160 char#54 \boldslash --- */
      {  54,73324,                      /* character number, location */
         15, 3,   -4, 3,      /* topleft row,col, and botleft row,col */
          { 11,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x04\x10\x80\x00\x02\x10\x40\x00\x02\x08\x40\x00"
            "\x01\x04\x20\x80\x00\x04\x10\x80\x00\x02\x10\x40\x00"
            "\x00" }  },
      /* --- pixel bitmap for cmsy160 char#55 \' --- */
      {  55,73687,                      /* character number, location */
         10, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  2,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x57\x01" }  },
      /* --- pixel bitmap for cmsy160 char#56 \forall --- */
      {  56,34278,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x30\x00\x0a\x20\x01\xc4\x7f\x08\x08\x82\x40\x10"
            "\x08\x02\x22\x40\x04\x50\x00\x0a\x80\x00\x10\x00" }  },
      /* --- pixel bitmap for cmsy160 char#57 \exists --- */
      {  57,34927,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\xf5\x91\x0a\xf5\x91\x0a" }  },
      /* --- pixel bitmap for cmsy160 char#58 \neg --- */
      {  58,35553,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 13,    7, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\xf5\xc1" }  },
      /* --- pixel bitmap for cmsy160 char#59 \emptyset --- */
      {  59,74396,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\xe1\x31\x26\x2c\x64\xc8\x90\x11\x23\x26\x4c"
            "\x98\xb0\xa0\x21\x63\x3a\x04\x00" }  },
      /* --- pixel bitmap for cmsy160 char#60 \Re --- */
      {  60,76231,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x8f\x68\x4e\x0c\x26\x06\x26\x03\xa3\x03\xd3\xc1"
            "\xea\x1f\x75\x06\x39\x03\x8c\x01\xc6\x30\x63\x90\x60"
            "\x3b\x60\x00" }  },
      /* --- pixel bitmap for cmsy160 char#61 \Im --- */
      {  61,77522,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x80\xe1\x10\x70\x06\x70\x01\x40\x00\x67\x60\xe2"
            "\x98\x00\x06\x00\x03\xc0\x1c\x60\x1c\x18\x1c\x03\x7c"
            "\x00" }  },
      /* --- pixel bitmap for cmsy160 char#62 \top --- */
      {  62,78234,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\xfd\x71\x73" }  },
      /* --- pixel bitmap for cmsy160 char#63 \bot --- */
      {  63,78947,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x71\x7e\x01" }  },
      /* --- pixel bitmap for cmsy160 char#64 \aleph --- */
      {  64,80178,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x31\x30\x02\x66\xe0\x0c\xca\x21\x34\x22\x26\xc2"
            "\x22\x38\x02\x43\x60\x0c\xc4\xc0\x0f\x08" }  },
      /* --- pixel bitmap for cmsy160 char#65 \calA --- */
      {  65,  774,                      /* character number, location */
         16, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\x20\xf1\xc3\x20\xf1\xb1\x12\x20\xf1\xa1\x22\x20"
            "\x91\x32\xa2\x32\xa1\x42\x91\x52\x8a\x71\x72\x61\x82"
            "\x12\x22\x82\x15\x93\x13\xd0" }  },
      /* --- pixel bitmap for cmsy160 char#66 \calB --- */
      {  66, 1558,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x1f\x67\x8e\x07\xe3\xc1\x38\x18\x86\x81\x7d\x70"
            "\x38\x0c\x1c\x03\xc6\x80\x19\x60\x06\x8c\x87\xb1\x1f"
            "\x00" }  },
      /* --- pixel bitmap for cmsy160 char#67 \calC --- */
      {  67, 2247,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x42\x32\x32\x42\x22\x52\x12\x52\x10\xf1\x12\x8f"
            "\x42\x93\x52\x23\x32\x45\x41" }  },
      /* --- pixel bitmap for cmsy160 char#68 \calD --- */
      {  68, 3035,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\x52\x22\x34\x12\x32\x62\x12\x32\x63\xf2\x52\x72"
            "\x42\x82\xf1\x42\x72\x10\x42\x62\x52\x62\x62\x52\x72"
            "\x32\x77\x82" }  },
      /* --- pixel bitmap for cmsy160 char#69 \calE --- */
      {  69, 3740,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x87\x31\x86\x19\xc0\x00\x0e\xe0\x03\x03\x0c\x30"
            "\xc0\x00\x06\x30\x98\x63\xf8\x00" }  },
      /* --- pixel bitmap for cmsy160 char#70 \calF --- */
      {  70, 4498,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   15, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7b\x52\x22\x52\x42\x32\xa2\x32\x80\xf2\x82\x80\x78"
            "\xa2\x90\xf1\x62\xa0\xf1\x52\xb3\x12\xd4\xd2" }  },
      /* --- pixel bitmap for cmsy160 char#71 \calG --- */
      {  71, 5221,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x1f\x06\x63\x60\x06\x66\x60\x0c\xc0\x00\x18\x60"
            "\x03\x6c\xc0\x0c\x98\x83\xe3\x38\xf8\x06\x60\x10\x06"
            "\x7f\x00" }  },
      /* --- pixel bitmap for cmsy160 char#72 \calH --- */
      {  72, 6107,                      /* character number, location */
         15, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x80\x99\x81\x19\x03\x1b\x06\x06\x0c\x06\x0c\x0c"
            "\x18\x18\x30\x18\xf8\x3f\x60\x60\xc0\xc0\x80\xc1\x00"
            "\x83\x01\x03\x23\x06\x66\x04\x3c" }  },
      /* --- pixel bitmap for cmsy160 char#73 \calI --- */
      {  73, 6836,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   15, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4a\x22\x42\x52\x52\x40\xf2\x72\x50\xf2\x62\x60\xf2"
            "\x52\x70\x42\x51\x62\x42\x2a\x4b" }  },
      /* --- pixel bitmap for cmsy160 char#74 \calJ --- */
      {  74, 7538,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa8\x82\x32\xa2\x42\x92\x42\x92\x52\x40\xf1\xb2\x50"
            "\xf3\xa2\x60\x92\x91\x62\x72\x72\x73\x52\x93\x32\xb5"
            "\xb1" }  },
      /* --- pixel bitmap for cmsy160 char#75 \calK --- */
      {  75, 8323,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x60\x3c\x9c\x18\x02\x98\x01\x58\x00\x38\x00\x38"
            "\x00\x2c\x00\x4c\x00\x4c\x00\x8c\x00\x86\x00\x06\x81"
            "\x06\x42\x03\x3c" }  },
      /* --- pixel bitmap for cmsy160 char#76 \calL --- */
      {  76, 9053,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x92\x13\x72\x32\x10\xf1\x52\x70\xf2\x42\x80\xf2"
            "\x32\x90\x22\xc2\x82\x17\x32\x12\x45\x32" }  },
      /* --- pixel bitmap for cmsy160 char#77 \calM --- */
      {  77,10188,                      /* character number, location */
         15, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 23,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x01\x40\xc0\x00\x30\x60\x00\x18\x38\x00\x0e\x3c"
            "\x80\x07\x1a\xe0\x01\x0d\xd8\x40\x06\x66\x20\x87\x31"
            "\x10\x63\x18\x84\x19\x0c\xc2\x07\x06\xc1\x01\x4b\x60"
            "\x80\x3d\x00\xc0\x0f\x00\x00" }  },
      /* --- pixel bitmap for cmsy160 char#78 \calN --- */
      {  78,11119,                      /* character number, location */
         17,-2,   -1,-2,      /* topleft row,col, and botleft row,col */
          { 24,   18, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x64\xe0\x55\x72\xa1\xb3\x91\x40\xf1\x73\x81\x50"
            "\x74\x71\xb1\x22\x61\xc1\x23\x51\xc1\x32\x51\xc1\x33"
            "\x41\x60\xf1\x51\x52\x31\x70\x51\x53\x21\xb1\x73\x11"
            "\x72\x21\x83\x84\x93\x93\xe0\x60" }  },
      /* --- pixel bitmap for cmsy160 char#79 \calO --- */
      {  79,11986,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x1e\xd8\x1c\x36\x9c\x0d\x6c\x06\x36\x00\x0f\x80"
            "\x07\xc0\x03\xb0\x01\xd8\x00\xe6\x00\x63\xc0\xf0\x18"
            "\xe0\x03\x00" }  },
      /* --- pixel bitmap for cmsy160 char#80 \calP --- */
      {  80,12731,                      /* character number, location */
         15, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4a\x42\x22\x43\x12\x32\x65\x32\x72\xf1\x52\x72\x52"
            "\x62\x52\x62\x62\x42\x86\xa2\xa0\xf2\x32\xb0\x22\xe1"
            "\xd2" }  },
      /* --- pixel bitmap for cmsy160 char#81 \calQ --- */
      {  81,13550,                      /* character number, location */
         15, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x92\x34\x52\x72\x42\x83\x10\xf1\x12\xa2\x1f\x12"
            "\xb2\x1f\x12\xa2\x23\x82\x43\x32\x12\x65\x22\xc2\x77"
            "\x81\x45\x42\x87\x25" }  },
      /* --- pixel bitmap for cmsy160 char#82 \calR --- */
      {  82,14401,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x1f\x30\xe3\x31\x06\xc6\x18\x18\x60\x60\x80\xc1"
            "\x00\x06\x03\x0c\x03\xb0\x03\xc0\x1c\x00\x63\x00\x86"
            "\x03\x18\x0c\x63\x70\xc6\x80\x07" }  },
      /* --- pixel bitmap for cmsy160 char#83 \calS --- */
      {  83,15167,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   15, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\x62\x43\x42\x62\xf1\x42\x80\x43\xc4\xc4\xc3\x32"
            "\x72\x2f\x12\x82\x23\x62\x43\x42\x66\x62" }  },
      /* --- pixel bitmap for cmsy160 char#84 \calT --- */
      {  84,15853,                      /* character number, location */
         16, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x22\x3e\x22\x52\x82\x62\x82\x52\x90\xf2\x72\x90"
            "\xf3\x62\xa0\xf2\x52\xb0\xf1\x42\xc0\x41\xd2" }  },
      /* --- pixel bitmap for cmsy160 char#85 \calU --- */
      {  85,16563,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\xc0\x1b\x60\x18\x60\x18\x70\x0c\x30\x0c\x38\x06"
            "\x38\x06\x1c\x06\x1e\x03\x1e\x03\x1b\x83\x0d\xc3\x0c"
            "\x67\x0c\x1e\x1c" }  },
      /* --- pixel bitmap for cmsy160 char#86 \calV --- */
      {  86,17312,                      /* character number, location */
         15, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 14,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x98\x03\xce\x01\x63\x80\x18\x20\x0e\x04\x03\xc1"
            "\x20\x30\x0c\x8c\x01\x33\xc0\x06\xd8\x00\x1e\x80\x03"
            "\x20\x00" }  },
      /* --- pixel bitmap for cmsy160 char#87 \calW --- */
      {  87,18313,                      /* character number, location */
         15, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 22,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x18\xb0\x03\x0e\xce\x81\x03\x62\xd0\x80\x18\x34"
            "\x20\x86\x1c\x84\x31\x06\x61\x84\x21\x98\x60\x08\x36"
            "\x18\x81\x05\x6e\xe0\x00\x0f\x3c\xc0\x01\x07\x30\xc0"
            "\x00\x0c\x10\x00\x01" }  },
      /* --- pixel bitmap for cmsy160 char#88 \calX --- */
      {  88,19150,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x53\x55\x52\x82\x52\x82\x42\x92\x22\xb2\x12\xc3"
            "\xe2\xd5\xa2\x32\x92\x42\x72\x62\x62\x72\x62\x72\x12"
            "\x33\x64\x42" }  },
      /* --- pixel bitmap for cmsy160 char#89 \calY --- */
      {  89,19911,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x30\x39\x20\x38\x10\x18\x08\x0c\x04\x0e\x01\x86"
            "\x00\x23\x80\x11\xc0\x04\x60\x01\x70\x00\x18\x00\x04"
            "\x04\x01\x44\x00\x1c\x00" }  },
      /* --- pixel bitmap for cmsy160 char#90 \calZ --- */
      {  90,20757,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x32\x52\x36\x52\x72\x61\x72\xe2\xe2\xb6\xd2\x21"
            "\xb2\xe2\xe2\xe2\x72\x42\x92\x37\x42\x32\x47\x42" }  },
      /* --- pixel bitmap for cmsy160 char#91 \cup --- */
      {  91,24406,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x01\xb1\x11\x91\x32\x52\x65\x41" }  },
      /* --- pixel bitmap for cmsy160 char#92 \cap --- */
      {  92,25087,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x52\x31\x91\x1f\x91\xb1" }  },
      /* --- pixel bitmap for cmsy160 char#93 \uplus --- */
      {  93,80935,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xb1\x0f\x31\x51\x51\x01\x19\x11\x0f\x21\x51"
            "\x51\x11\x41\x41\x32\x52\x65\x42" }  },
      /* --- pixel bitmap for cmsy160 char#94 \wedge --- */
      {  94,25751,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x14\x80\x02\x88\x00\x11\x10\x04\x82\x20\x20"
            "\x04\x44\x00\x09\xa0\x00\x18\x00\x01" }  },
      /* --- pixel bitmap for cmsy160 char#95 \vee --- */
      {  95,26415,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x30\x00\x0a\x20\x01\x44\x40\x08\x08\x82\x40\x10"
            "\x10\x01\x22\x80\x02\x50\x00\x04\x00" }  },
      /* --- pixel bitmap for cmsy160 char#96 \vdash --- */
      {  96,81586,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x01\xbc\x0f\x61\xb1" }  },
      /* --- pixel bitmap for cmsy160 char#97 \dashv --- */
      {  97,82200,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\xb1\x0c\xf6\xb1" }  },
      /* --- pixel bitmap for cmsy160 char#98 \lfloor --- */
      {  98,82724,                      /* character number, location */
         17, 4,   -6, 4,      /* topleft row,col, and botleft row,col */
          {  6,   23, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x5f\x61\x56" }  },
      /* --- pixel bitmap for cmsy160 char#99 \rfloor --- */
      {  99,83265,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  6,   23, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x51\xf6\x51\x06" }  },
      /* --- pixel bitmap for cmsy160 char#100 \lceil --- */
      { 100,83807,                      /* character number, location */
         17, 4,   -6, 4,      /* topleft row,col, and botleft row,col */
          {  6,   23, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x5f\x61\x51" }  },
      /* --- pixel bitmap for cmsy160 char#101 \rceil --- */
      { 101,84350,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  6,   23, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x51\xf6\x51" }  },
      /* --- pixel bitmap for cmsy160 char#102 \lbrace --- */
      { 102,40577,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  9,   23, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x51\x30\xf7\x41\x40\x31\x53\x91\x50\xf7\x41\x40"
            "\x51\x93" }  },
      /* --- pixel bitmap for cmsy160 char#103 \rbrace --- */
      { 103,41426,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  9,   23, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x91\x50\xf7\x41\x40\x51\x93\x51\x30\xf7\x41\x40"
            "\x31\x53\x61" }  },
      /* --- pixel bitmap for cmsy160 char#104 \langle --- */
      { 104,84864,                      /* character number, location */
         17, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  6,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x41\x08\x42\x10\x82\x10\x04\x81\x20\x10\x04"
            "\x82\x40\x10\x08\x02" }  },
      /* --- pixel bitmap for cmsy160 char#105 \rangle --- */
      { 105,85379,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x20\x08\x04\x81\x20\x10\x04\x82\x20\x04\x21\x08"
            "\x41\x08\x42\x10\x00" }  },
      /* --- pixel bitmap for cmsy160 char#106 \mid --- */
      { 106,38677,                      /* character number, location */
         17, 3,   -6, 3,      /* topleft row,col, and botleft row,col */
          {  1,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\x7f" }  },
      /* --- pixel bitmap for cmsy160 char#107 \parallel --- */
      { 107,85984,                      /* character number, location */
         17, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  7,   23, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x51\x0f\x71\x51" }  },
      /* --- pixel bitmap for cmsy160 char#108 \updownarrow --- */
      { 108,87194,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  9,   23, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\x40\x33\x55\x32\x11\x12\x11\x31\x31\xfa\x41"
            "\x41\x31\x31\x12\x11\x12\x35\x53\x30\xf1\x41\x41" }  },
      /* --- pixel bitmap for cmsy160 char#109 \Updownarrow --- */
      { 109,88283,                      /* character number, location */
         16, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 14,   21, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\xb1\x21\x91\x41\x62\x62\x22\x11\x61\x12\xfa\x31"
            "\x61\x32\x11\x61\x12\x22\x62\x61\x41\x91\x21\xb2\x60" }  },
      /* --- pixel bitmap for cmsy160 char#110 \setminus --- */
      { 110,38235,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  9,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x02\x08\x10\x20\x80\x00\x01\x04\x08\x10\x40\x80"
            "\x00\x01\x04\x08\x10\x40\x80\x00\x02\x04\x08\x20\x40" }  },
      /* --- pixel bitmap for cmsy160 char#111 \wr --- */
      { 111,88798,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x8c\xc8\x64\x32\x11\x23\x0e" }  },
      /* --- pixel bitmap for cmsy160 char#112 \surd --- */
      { 112,89654,                      /* character number, location */
          1, 2,  -21, 2,      /* topleft row,col, and botleft row,col */
          { 17,   22, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x21\xf1\xe0\x11\x10\xf1\xe1\x20\xf1\xd1\x30"
            "\xf1\xc1\x40\xb1\x71\x81\x53\x71\x91\x61\x60\xf1\x31"
            "\x51\x70\xf1\x41\x31\x80\xf1\x51\x11\x90\x52\xe0\x21"
            "\xa1" }  },
      /* --- pixel bitmap for cmsy160 char#113 \amalg --- */
      { 113,90854,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x36\xfc\x22\x72\x2e\x01" }  },
      /* --- pixel bitmap for cmsy160 char#114 \nabla --- */
      { 114,91796,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x1e\x22\xb1\x10\xf1\x22\x91\x20\xf1\x32\x71"
            "\x30\xf1\x42\x51\x40\xf1\x52\x31\x50\xf1\x62\x11\x60"
            "\xf1\x72\x71" }  },
      /* --- pixel bitmap for cmsy160 char#115 \smallint --- */
      { 115,43529,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   19, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\x71\x21\xf3\x61\x30\xf6\x51\x40\xf3\x41\x51\x21"
            "\x72\x7f" }  },
      /* --- pixel bitmap for cmsy160 char#116 \sqcup --- */
      { 116,92476,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x01\xb1\x0d" }  },
      /* --- pixel bitmap for cmsy160 char#117 \sqcap --- */
      { 117,93161,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xb1\xb1" }  },
      /* --- pixel bitmap for cmsy160 char#118 \sqsubseteq --- */
      { 118,93918,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 14,   19, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0f\xa1\xde\xf4\xed\x11" }  },
      /* --- pixel bitmap for cmsy160 char#119 \sqsupseteq --- */
      { 119,94657,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 14,   19, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xfa\xd1\x1d\xf4\xe0\x1d" }  },
      /* --- pixel bitmap for cmsy160 char#120 \S --- */
      { 120,95650,                      /* character number, location */
         15, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  6,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x18\x06\x81\xc0\x48\x61\x18\x4a\x0c\x04\x82\x61"
            "\xe4\x00" }  },
      /* --- pixel bitmap for cmsy160 char#121 \dag --- */
      { 121,96456,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   19, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x41\x49\xfc\x41\x41" }  },
      /* --- pixel bitmap for cmsy160 char#122 \ddag --- */
      { 122,97439,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   19, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x41\x49\xf3\x41\x40\x90\xf3\x41\x49\xf3\x41\x41" }  },
      /* --- pixel bitmap for cmsy160 char#123 \P --- */
      { 123,98135,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   19, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x25\x21\x36\x21\x2f\x37\x21\x20\x16\x21\x45\x21"
            "\x63\x21\x20\xf8\x61\x21\x21" }  },
      /* --- pixel bitmap for cmsy160 char#124 \clubsuit --- */
      { 124,99087,                      /* character number, location */
         15, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\xb5\x50\xf3\x47\x40\x55\x72\x15\x12\x3d\x1f\x3e"
            "\x01\x15\x11\x15\x33\x21\x23\x91\x70\xf1\x63\x63" }  },
      /* --- pixel bitmap for cmsy160 char#125 \Diamond --- */
      { 125,99794,                      /* character number, location */
         15, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 15,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\xa0\x00\x50\x00\x44\x00\x41\x80\x20\x20\x20"
            "\x08\x20\x02\x60\x01\x10\x01\x04\x01\x01\x41\x80\x20"
            "\x80\x08\x80\x02\x40\x01\x40\x00" }  },
      /* --- pixel bitmap for cmsy160 char#126 \Heart --- */
      { 126,100609,                     /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x1e\xa1\x50\x20\x30\x10\x18\x00\x0c\x00\x0a\x80"
            "\x04\x40\x04\x10\x04\x04\x04\x01\x44\x00\x14\x00\x04"
            "\x00\x02\x00" }  },
      /* --- pixel bitmap for cmsy160 char#127 \spadesuit --- */
      { 127,101486,                     /* character number, location */
         15, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x70\xf1\x63\x60\x55\x97\x79\x5b\x20\xf1\x1d\x1f"
            "\x3e\x01\x15\x11\x15\x33\x21\x23\x91\x70\xf1\x63\x61" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=5 for .180gf ---
 * mf '\mode=preview; mag=magstep(-14.65037297372839890542); input cmsy10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmsy180 --- */
static	chardef  cmsy180[] =
   {
      /* --- pixel bitmap for cmsy180 char#0 - --- */
      {   0,21798,                      /* character number, location */
          7, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          { 15,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x7f" }  },
      /* --- pixel bitmap for cmsy180 char#1 \cdot --- */
      {   1,39702,                      /* character number, location */
          8, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00" }  },
      /* --- pixel bitmap for cmsy180 char#2 \times --- */
      {   2,44792,                      /* character number, location */
         13, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x14\x10\x41\x08\x81\x08\x28\x80\x00\x0a\x88\x20"
            "\x04\x41\x04\x14\x40" }  },
      /* --- pixel bitmap for cmsy180 char#3 \ast --- */
      {   3,45441,                      /* character number, location */
         12, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x60\xc8\xb4\xcd\x0f\x06\x3f\xdb\x32\x61\xc0\x00" }  },
      /* --- pixel bitmap for cmsy180 char#4 \div --- */
      {   4,46312,                      /* character number, location */
         14, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\xe0\x13\xe0\x11\x80\xf3\xe0\x3e\x03\xf3\xe0\x30"
            "\x81\xe0\x13\xe0\x11\x81" }  },
      /* --- pixel bitmap for cmsy180 char#5 \diamond --- */
      {   5,40267,                      /* character number, location */
         12, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x80\x02\x22\x08\x22\xa0\x00\x0a\x88\x20\x88\x80"
            "\x02\x08\x00" }  },
      /* --- pixel bitmap for cmsy180 char#6 \pm --- */
      {   6,22495,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x81\x8e\x03\xf6\x81\x8e\x03" }  },
      /* --- pixel bitmap for cmsy180 char#7 \mp --- */
      {   7,47025,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\xf6\x81\x8e\x03\xf7\x81\x8e" }  },
      /* --- pixel bitmap for cmsy180 char#8 \oplus --- */
      {   8,23256,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x32\x20\x84\x20\x08\x22\x10\x48\x20\x50"
            "\x40\xc0\x80\x80\xff\xff\x03\x02\x06\x04\x14\x08\x24"
            "\x10\x88\x20\x08\x42\x08\x98\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for cmsy180 char#9 \ominus --- */
      {   9,47787,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\xa2\x52\x71\x91\x51\xb1\x20\xf1\x11\xd1\x1f\x11"
            "\xe0\x11\x0e\x03\x0f\x11\xe0\x11\xf1\x11\xd1\x10\x21"
            "\xb1\x51\x91\x72\x52\xa5\x61" }  },
      /* --- pixel bitmap for cmsy180 char#10 \otimes --- */
      {  10,24074,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x60\x00\x23\x01\x49\x04\x51"
            "\x10\xc1\x40\x81\x01\x01\x03\x05\x06\x11\x14\x41\x24"
            "\x01\x89\x01\x0c\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for cmsy180 char#11 \oslash --- */
      {  11,48578,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x20\x00\x23\x00\x49\x00\x51"
            "\x00\xc1\x00\x81\x01\x01\x03\x01\x06\x01\x14\x01\x24"
            "\x01\x88\x01\x08\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for cmsy180 char#12 \odot --- */
      {  12,49386,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\xa2\x52\x71\x91\x51\xb1\x20\xf1\x11\xd1\x11\xe0"
            "\x11\x0f\x21\x63\x61\x01\xe0\x11\xf1\x11\xd1\x10\x21"
            "\xb1\x51\x91\x72\x52\xa5\x61" }  },
      /* --- pixel bitmap for cmsy180 char#13 \bigcirc --- */
      {  13,50293,                      /* character number, location */
         18, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x95\xe0\x13\x53\xb1\xb1\x91\xd1\x71\xe0\x11\x30\xf1"
            "\x21\xe0\x31\x20\xf1\x11\xe0\x51\x1f\x51\xe0\x71\xf1"
            "\x11\xe0\x51\x10\xf1\x21\xe0\x31\x20\x31\xe0\x11\x71"
            "\xd1\x91\xb1\xb3\x53\xe0\x15\x92" }  },
      /* --- pixel bitmap for cmsy180 char#14 \circ --- */
      {  14,50977,                      /* character number, location */
         11, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x22\x50\x80\x01\x06\x18\xa0\x40\x84\xe0\x01" }  },
      /* --- pixel bitmap for cmsy180 char#15 \bullet --- */
      {  15,51596,                      /* character number, location */
         11, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x56\x38\x1f\x3a\x18\x36\x54\x31" }  },
      /* --- pixel bitmap for cmsy180 char#16 \asymp --- */
      {  16,52298,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   13, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x11\x11\xd1\x32\x92\x62\x52\xa5\x60\xf2\xe0"
            "\x30\x65\xa2\x52\x62\x92\x31\xd1\x11\xe0\x11" }  },
      /* --- pixel bitmap for cmsy180 char#17 \equiv --- */
      {  17,38209,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   13, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\xf4\xe0\x3e\x03\xf4\xe0\x3e\x03" }  },
      /* --- pixel bitmap for cmsy180 char#18 \subseteq --- */
      {  18,53051,                      /* character number, location */
         16, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 15,   21, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x32\xc1\xc0\xf1\x11\xdf\x41\xe0\xf1\x11\xd0\x21"
            "\xe0\x12\xe0\x1a\xf4\xe0\x1e\x01" }  },
      /* --- pixel bitmap for cmsy180 char#19 \supseteq --- */
      {  19,53802,                      /* character number, location */
         16, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 15,   21, 3,44, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\xe0\x12\xe0\x11\x20\xf1\xd1\x10\xf4\xe1\xf1\xd1"
            "\x10\xc1\xc2\x3a\x50\xf4\xe0\x1e\x01" }  },
      /* --- pixel bitmap for cmsy180 char#20 \leq --- */
      {  20,36743,                      /* character number, location */
         16, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 15,   21, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\xc2\xb2\xb2\xb2\xb2\xb2\xb2\xe2\xe0\x12\xe0\x12"
            "\xe0\x12\xe0\x12\xe0\x12\xe0\x12\xf4\xe0\x1e\x01" }  },
      /* --- pixel bitmap for cmsy180 char#21 \geq --- */
      {  21,37468,                      /* character number, location */
         16, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 15,   21, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x12\xe0\x12\xe0\x12\xe0\x12\xe0\x12\xe0\x12"
            "\xe0\x12\xc2\xb2\xb2\xb2\xb2\xb2\xb2\xd0\xf4\xe0\x1e"
            "\x01" }  },
      /* --- pixel bitmap for cmsy180 char#22 \preceq --- */
      {  22,54521,                      /* character number, location */
         16, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 15,   21, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe1\xf1\xd1\x10\xc1\xc2\xa3\x57\xe0\x13\xe0\x12"
            "\xe0\x11\x20\xf1\xd1\x10\xf1\xe1\xf4\xe0\x1e\x01" }  },
      /* --- pixel bitmap for cmsy180 char#23 \succeq --- */
      {  23,55239,                      /* character number, location */
         16, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 15,   21, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xe0\xf1\x11\xd0\x21\xe0\x12\xe0\x13\xe0\x17"
            "\x53\xa2\xc1\xc0\xf1\x11\xdf\x11\xe0\xf4\xe0\x1e\x01" }  },
      /* --- pixel bitmap for cmsy180 char#24 \sim --- */
      {  24,55935,                      /* character number, location */
          9, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 17,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x00\x8d\x01\x0a\x06\x1e\x18\x14\x60\x2c\x80\x0f" }  },
      /* --- pixel bitmap for cmsy180 char#25 \approx --- */
      {  25,56699,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x00\x8d\x01\x0a\x06\x1e\x18\x14\x60\x2c\x80\x0f"
            "\x1f\x40\x63\x80\x82\x81\x07\x06\x05\x18\x0b\xe0\x03" }  },
      /* --- pixel bitmap for cmsy180 char#26 \subset --- */
      {  26,32763,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x32\xc1\xc0\xf1\x11\xdf\x41\xe0\xf1\x11\xd0\x21"
            "\xe0\x12\xe0\x1a" }  },
      /* --- pixel bitmap for cmsy180 char#27 \supset --- */
      {  27,33475,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\xe0\x12\xe0\x11\x20\xf1\xd1\x10\xf4\xe1\xf1\xd1"
            "\x10\xc1\xc2\x3a\x51" }  },
      /* --- pixel bitmap for cmsy180 char#28 \ll --- */
      {  28,57558,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 23,   17, 3,84, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\x71\xc2\x62\xb2\x62\xb2\x62\xc1\x71\xc2\x62\xb2"
            "\x62\xb2\x62\xc1\x71\xe0\x12\x62\xe0\x12\x62\xe0\x12"
            "\x62\xe0\x11\x71\xe0\x12\x62\xe0\x12\x62\xe0\x12\x62"
            "\xe0\x11\x71" }  },
      /* --- pixel bitmap for cmsy180 char#29 \gg --- */
      {  29,58424,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 23,   17, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x71\xe0\x12\x62\xe0\x12\x62\xe0\x12\x62\xe0\x11"
            "\x71\xe0\x12\x62\xe0\x12\x62\xe0\x12\x62\xe0\x11\x71"
            "\xc2\x62\xb2\x62\xb2\x62\xc1\x71\xc2\x62\xb2\x62\xb2"
            "\x62\xc1\x71\xe3" }  },
      /* --- pixel bitmap for cmsy180 char#30 \prec --- */
      {  30,59137,                      /* character number, location */
         13, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe1\xf1\xd1\x10\xc1\xc2\xa3\x57\xe0\x13\xe0\x12"
            "\xe0\x11\x20\xf1\xd1\x10\xf1\xe1" }  },
      /* --- pixel bitmap for cmsy180 char#31 \succ --- */
      {  31,59811,                      /* character number, location */
         13, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xe0\xf1\x11\xd0\x21\xe0\x12\xe0\x13\xe0\x17"
            "\x53\xa2\xc1\xc0\xf1\x11\xdf\x11\xe2" }  },
      /* --- pixel bitmap for cmsy180 char#32 \leftarrow --- */
      {  32,29608,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   13, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\xe0\x20\xf1\x51\xe0\x30\x41\xe0\x71\xe0\x71\xe0"
            "\x6e\x09\x21\xe0\x91\xe0\x91\xe0\x40\xf1\x51\xe0\x30"
            "\x61\xe0\x21" }  },
      /* --- pixel bitmap for cmsy180 char#33 \rightarrow --- */
      {  33,30652,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   13, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x21\x60\xf1\xe0\x31\x50\xe0\x41\xe0\x91\xe0\x91"
            "\x2e\x09\xe0\x61\xe0\x71\xe0\x71\x40\xf1\xe0\x31\x50"
            "\xe0\x21\x61" }  },
      /* --- pixel bitmap for cmsy180 char#34 \uparrow --- */
      {  34,28535,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   22, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x51\x50\x43\x71\x11\x11\x51\x21\x21\x22\x31\x32"
            "\xfe\x51\x51" }  },
      /* --- pixel bitmap for cmsy180 char#35 \downarrow --- */
      {  35,27698,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   22, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x51\x52\x31\x32\x21\x21\x21\x51\x11\x11\x73\x40"
            "\xf2\x51\x51" }  },
      /* --- pixel bitmap for cmsy180 char#36 \leftrightarrow --- */
      {  36,32033,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   13, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x91\x60\xf1\x51\xb1\x50\x41\xd1\x71\xe0\x11\x51"
            "\xe0\x31\x2e\x09\x21\xe0\x31\x51\xe0\x11\x71\xd1\x40"
            "\xf1\x51\xb1\x50\x61\x91\x61" }  },
      /* --- pixel bitmap for cmsy180 char#37 \nearrow --- */
      {  37,60859,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 23,   23, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe2\x52\xe0\x27\xe0\x62\xe0\x61\x11\xe0\x51\x21\xe0"
            "\x41\x31\xe0\x31\x41\xe0\x21\x61\xe1\x71\xd1\xe0\x71"
            "\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0"
            "\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x80" }  },
      /* --- pixel bitmap for cmsy180 char#38 \searrow --- */
      {  38,61937,                      /* character number, location */
         18, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 23,   23, 3,102, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x91\xe0\x91\xe0\x91\xe0\x91\xe0\x91\xe0\x91"
            "\xe0\x91\xe0\x91\xe0\x91\xe0\x91\xe0\x91\xe0\x91\xe0"
            "\x91\xe0\x91\x71\xe0\x11\x61\xe0\x21\x41\xe0\x41\x31"
            "\xe0\x51\x21\xe0\x61\x11\xe0\x72\xe0\x37\xe2\x52" }  },
      /* --- pixel bitmap for cmsy180 char#39 \simeq --- */
      {  39,62695,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   12, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\x91\x12\x32\x81\x11\x52\x64\x62\x51\x11\x82\x32"
            "\x11\x95\x20\xf4\xe0\x3e\x03" }  },
      /* --- pixel bitmap for cmsy180 char#40 \Leftarrow --- */
      {  40,63721,                      /* character number, location */
         14, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 23,   15, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\xe0\x71\xe0\x71\xe0\x7e\x04\x41\xe0\x62\xe0"
            "\x52\xe0\x92\xe0\x91\xe0\x9e\x04\x61\xe0\x91\xe0\x10"
            "\xf1\x81\xe1" }  },
      /* --- pixel bitmap for cmsy180 char#41 \Rightarrow --- */
      {  41,64742,                      /* character number, location */
         14, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 23,   15, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe1\x80\xe0\x11\xe0\x91\x6e\x04\xe0\x91\xe0\x92"
            "\xe0\x92\xe0\x52\xe0\x61\x4e\x04\xe0\x71\xe0\x71\x70"
            "\xf1\xe1\x81" }  },
      /* --- pixel bitmap for cmsy180 char#42 \Uparrow --- */
      {  42,65578,                      /* character number, location */
         17, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x71\x70\xf1\x61\x11\x60\x51\x31\x91\x51\x72\x52"
            "\x51\x11\x51\x11\x22\x21\x51\x22\xfc\x41\x51\x41" }  },
      /* --- pixel bitmap for cmsy180 char#43 \Downarrow --- */
      {  43,66478,                      /* character number, location */
         17, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x41\x51\x42\x21\x51\x22\x21\x11\x51\x11\x52\x52"
            "\x71\x51\x91\x31\x50\xf1\x61\x11\x60\xf1\x71\x71" }  },
      /* --- pixel bitmap for cmsy180 char#44 \Leftrightarrow --- */
      {  44,67798,                      /* character number, location */
         14, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 25,   15, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x91\x70\xf1\x61\xb1\x60\x51\xd1\x9e\x03\x71\xe0"
            "\x31\x51\xe0\x51\x22\xe0\x72\x21\xe0\x51\x51\xe0\x31"
            "\x7e\x03\x91\xd1\x50\xf1\x61\xb1\x60\x71\x91\x71" }  },
      /* --- pixel bitmap for cmsy180 char#45 \nwarrow --- */
      {  45,68872,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 23,   23, 3,102, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\x52\xe7\xe0\x32\xe0\x71\x11\xe0\x61\x21\xe0\x51"
            "\x31\xe0\x41\x41\xe0\x21\x61\xe0\x11\x71\xe0\x91\xe0"
            "\x91\xe0\x91\xe0\x91\xe0\x91\xe0\x91\xe0\x91\xe0\x91"
            "\xe0\x91\xe0\x91\xe0\x91\xe0\x91\xe0\x91\xe0\x91" }  },
      /* --- pixel bitmap for cmsy180 char#46 \swarrow --- */
      {  46,69950,                      /* character number, location */
         18, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 23,   23, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x81\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0"
            "\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x71\xe0\x71"
            "\xe0\x71\xd1\x71\xe1\x61\xe0\x21\x41\xe0\x31\x31\xe0"
            "\x41\x21\xe0\x51\x11\xe0\x62\xe0\x67\xe0\x22\x52\xe0" }  },
      /* --- pixel bitmap for cmsy180 char#47 \propto --- */
      {  47,71040,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xe0\xec\x30\x82\x09\x01\x0f\x01\x07\x01\x06\x01"
            "\x0e\x01\x0f\x02\x19\xc6\x70\x78\xe0" }  },
      /* --- pixel bitmap for cmsy180 char#48 \prime --- */
      {  48,71582,                      /* character number, location */
         14, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x8e\x73\x1c\xc7\x38\x8e\x61\x0c\x03" }  },
      /* --- pixel bitmap for cmsy180 char#49 \infty --- */
      {  49,43134,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 23,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x00\x0f\xf6\x60\x88\xc0\x08\x28\xc0\x02\x18\xc0"
            "\x01\x0c\xe0\x00\x06\x70\x00\x03\x68\x80\x02\x62\x20"
            "\xc2\xe0\x0d\x1e\xc0\x03" }  },
      /* --- pixel bitmap for cmsy180 char#50 \in --- */
      {  50,34142,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x32\xa1\xa0\xf1\x11\xbf\x11\xcd\x0f\x11\xc0\xf1"
            "\x11\xb0\x21\xd2\xd8" }  },
      /* --- pixel bitmap for cmsy180 char#51 \ni --- */
      {  51,72247,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xd2\xd1\x20\xf1\xb1\x10\xf1\xc1\x0d\xf1\xc1\xf1"
            "\xb1\x10\xa1\xa2\x38\x51" }  },
      /* --- pixel bitmap for cmsy180 char#52 \triangle --- */
      {  52,73001,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x90\xf1\x81\x11\x80\xf1\x71\x31\x70\xf1\x61\x51"
            "\x60\xf1\x51\x71\x50\xf1\x41\x91\x40\xf1\x31\xb1\x30"
            "\xf1\x21\xd1\x20\xf1\x11\xe0\x11\x1e\x05" }  },
      /* --- pixel bitmap for cmsy180 char#53 \bigtriangledown --- */
      {  53,73802,                      /* character number, location */
         12, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x05\xf1\x11\xe0\x11\x10\xf1\x21\xd1\x20\xf1\x31"
            "\xb1\x30\xf1\x41\x91\x40\xf1\x51\x71\x50\xf1\x61\x51"
            "\x60\xf1\x71\x31\x70\xf1\x81\x11\x80\x91\x91" }  },
      /* --- pixel bitmap for cmsy180 char#54 \boldslash --- */
      {  54,74186,                      /* character number, location */
         18, 3,   -5, 3,      /* topleft row,col, and botleft row,col */
          { 13,   23, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xf1\xb1\x10\xf1\xa1\x20\xf1\x91\x30\xf1\x81\x40"
            "\xf1\x71\x50\x61\x60\xf1\x51\x70\xf1\x41\x80\xf1\x31"
            "\x90\xf1\x21\xa0\xf1\x11\xb1\xc1" }  },
      /* --- pixel bitmap for cmsy180 char#55 \' --- */
      {  55,74557,                      /* character number, location */
         11, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          {  2,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x57\x01" }  },
      /* --- pixel bitmap for cmsy180 char#56 \forall --- */
      {  56,34750,                      /* character number, location */
         17, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xd1\xf1\x11\xb1\x10\x21\x91\x4b\x41\x91\x20"
            "\xf1\x31\x71\x30\xf1\x41\x51\x40\xf2\x51\x31\x50\xf1"
            "\x61\x11\x60\xf1\x71\x71" }  },
      /* --- pixel bitmap for cmsy180 char#57 \exists --- */
      {  57,35411,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xf6\xb1\x0c\xf6\xb1\x0c" }  },
      /* --- pixel bitmap for cmsy180 char#58 \neg --- */
      {  58,36041,                      /* character number, location */
          9, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 15,    7, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\xf5\xe1" }  },
      /* --- pixel bitmap for cmsy180 char#59 \emptyset --- */
      {  59,75266,                      /* character number, location */
         20, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 10,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x82\x0f\x33\xc6\x09\x35\xf4\xc8\x23\x8f\x3c"
            "\xf2\xc4\x13\x4f\x3c\xf1\xc2\x0b\x2b\xe4\x18\x33\x7c"
            "\x10\x00" }  },
      /* --- pixel bitmap for cmsy180 char#60 \Re --- */
      {  60,77123,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x1c\x38\x76\xc8\xc2\x08\x03\x13\x06\x46\x0c\x18"
            "\x19\x30\x74\xc0\xe8\xc0\xd0\x7f\xb4\x63\x30\xc7\x00"
            "\x86\x01\x0c\x03\x18\x86\x31\x0c\x62\x18\x49\xb0\x61"
            "\xc0\x00" }  },
      /* --- pixel bitmap for cmsy180 char#61 \Im --- */
      {  61,78434,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x91\x53\x61\x83\x22\xb3\x1f\x11\xe0\x10\x11\xa3"
            "\x31\x82\x21\x33\x52\x21\xf1\xb2\x30\xc2\x23\x92\x43"
            "\x82\x52\x62\x73\x33\x95\x43" }  },
      /* --- pixel bitmap for cmsy180 char#62 \top --- */
      {  62,79152,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\xfe\x81\x80\x81\x83" }  },
      /* --- pixel bitmap for cmsy180 char#63 \bot --- */
      {  63,79869,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x81\x80\x81\x8e\x03" }  },
      /* --- pixel bitmap for cmsy180 char#64 \aleph --- */
      {  64,81104,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x62\xc0\x08\x18\x03\xc6\xc0\x31\x38\x0e\x25\x23"
            "\x44\xc4\x98\x18\x16\x83\x63\x60\x18\x18\x06\xc2\xc0"
            "\x0f\x10" }  },
      /* --- pixel bitmap for cmsy180 char#65 \calA --- */
      {  65,  774,                      /* character number, location */
         18, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x11\xe0\x32\x30\xf1\xd3\x30\xf1\xc1\x12\x30\xf1"
            "\xb1\x22\x30\xf1\xa1\x32\x30\x91\x42\xb2\x42\xb1\x52"
            "\xaa\x82\x72\x81\x82\x21\x41\x92\x22\x22\x92\x25\xa4"
            "\x13\xe0\x10" }  },
      /* --- pixel bitmap for cmsy180 char#66 \calB --- */
      {  66, 1544,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x7c\x38\xe3\xb0\xc1\xf0\xc0\x70\xc0\x70\x60\x38"
            "\x30\x38\x0c\x98\x1f\x18\x38\x18\x70\x0c\x60\x0c\x60"
            "\x0c\x60\x0c\x60\x06\x30\x1e\x18\x3b\x0c\xf3\x03" }  },
      /* --- pixel bitmap for cmsy180 char#67 \calC --- */
      {  67, 2253,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x85\x62\x32\x42\x52\x32\x62\x32\x52\x32\x62\x22\x62"
            "\x20\xf1\x12\xaf\x42\xb2\x82\x13\x62\x32\x62\x33\x32"
            "\x65\x62" }  },
      /* --- pixel bitmap for cmsy180 char#68 \calD --- */
      {  68, 3083,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\x62\x22\x34\x22\x42\x53\x12\x42\x63\x62\x72\xf3"
            "\x52\x82\x52\x72\x52\x82\x52\x72\x62\x62\x62\x62\x72"
            "\x52\x82\x32\x87\x92" }  },
      /* --- pixel bitmap for cmsy180 char#69 \calE --- */
      {  69, 3770,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 14,   19, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x85\x72\x33\x42\x62\x42\x52\x10\xf1\x32\x90\x33\xc3"
            "\xc4\x92\xb2\xb2\xb2\xb2\xc2\x82\x22\x72\x33\x52\x53"
            "\x32\x75\x72" }  },
      /* --- pixel bitmap for cmsy180 char#70 \calF --- */
      {  70, 4568,                      /* character number, location */
         17, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 20,   18, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7d\x62\x22\x62\xf1\x42\x42\x80\xf2\x92\x90\xf1\x82"
            "\xa0\x88\x40\xf2\x72\xb0\xf1\x62\xc2\x32\xd3\x22\xe4"
            "\xe0\x15" }  },
      /* --- pixel bitmap for cmsy180 char#71 \calG --- */
      {  71, 5299,                      /* character number, location */
         18, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 14,   21, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\x62\x43\x42\x62\x32\x72\x22\x72\x22\x81\x32\xbf"
            "\x12\xcf\x12\x92\x12\x83\x12\x82\x23\x63\x33\x32\x12"
            "\x45\x22\xc2\xb2\x51\x62\x44\x32\x75\x72" }  },
      /* --- pixel bitmap for cmsy180 char#72 \calH --- */
      {  72, 6199,                      /* character number, location */
         17, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 18,   19, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x72\x22\x32\x72\x12\x42\x62\x12\x52\x62\x82\x62"
            "\x10\xf3\x62\x62\x20\x3c\x30\xf1\x52\x62\x30\x42\x72"
            "\x30\xf1\x42\x62\x40\x32\x72\x40\xf1\x32\x72\x22\xc4"
            "\x23" }  },
      /* --- pixel bitmap for cmsy180 char#73 \calI --- */
      {  73, 6938,                      /* character number, location */
         17,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x32\x52\x72\x52\x72\x62\x60\xf3\x82\x70\xf3\x72"
            "\x80\xf1\x62\x90\xf1\x52\x52\x3c\x52" }  },
      /* --- pixel bitmap for cmsy180 char#74 \calJ --- */
      {  74, 7646,                      /* character number, location */
         17, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb9\x92\x52\xa2\x52\xa2\x52\xa2\x62\xa2\x52\x50\xf1"
            "\xd2\x50\xf2\xc2\x60\xf2\xb2\x70\x21\x82\x72\x82\x83"
            "\x62\xa2\x62\xa3\x32\xd6\xc2" }  },
      /* --- pixel bitmap for cmsy180 char#75 \calK --- */
      {  75, 8467,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x83\x33\x62\x12\x42\x42\x32\x42\x32\xa2\x22\xb2"
            "\x12\xc4\x90\xf2\x34\xa0\x35\x90\xf1\x22\x22\x90\x22"
            "\x23\x92\x42\x92\x43\x52\x12\x53\x44\x73\x22\x12\x84"
            "\x33" }  },
      /* --- pixel bitmap for cmsy180 char#76 \calL --- */
      {  76, 9211,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   19, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\xa2\x23\x10\xf1\x72\x42\x10\x62\x51\x82\x80\xf1"
            "\x52\x90\xf3\x42\xa0\xf2\x32\xb0\x22\xa2\x16\x62\x13"
            "\x25\x22\x22\x65\x33" }  },
      /* --- pixel bitmap for cmsy180 char#77 \calM --- */
      {  77,10310,                      /* character number, location */
         18, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 28,   20, 3,133, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x92\xe0\x21\x92\xe0\x11\x93\xe2\x93\xd3\x94\xb4\x91"
            "\x12\xb3\xa1\x12\xa1\x12\x91\x22\x92\x12\x91\x22\x82"
            "\x22\x91\x23\x62\x32\x81\x42\x52\x42\x81\x42\x51\x42"
            "\x91\x42\x41\x52\x81\x53\x22\x52\x81\x62\x12\x62\x81"
            "\x64\x72\x71\x82\x82\x32\x12\xe0\x42\x34\xe0\x54\x22"
            "\xe0\xb0" }  },
      /* --- pixel bitmap for cmsy180 char#78 \calN --- */
      {  78,11297,                      /* character number, location */
         19,-1,   -2,-1,      /* topleft row,col, and botleft row,col */
          { 26,   21, 3,113, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x84\x82\xb5\x82\xa2\xc3\x91\xc1\x12\x91\xc1\x12"
            "\x81\xd1\x13\x71\x60\xf1\x71\x22\x71\x60\x61\x33\x51"
            "\x70\xf1\x61\x42\x51\x70\x61\x43\x41\xc1\x62\x31\xd1"
            "\x63\x21\xd1\x72\x21\xc1\x83\x11\xc1\x93\x91\x21\xa3"
            "\x94\xe0\x83\xe0\x92" }  },
      /* --- pixel bitmap for cmsy180 char#79 \calO --- */
      {  79,12160,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 18,   19, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\x35\x72\x22\x33\x52\x22\x53\x32\x22\x72\xf1\x22"
            "\x22\x82\x12\x31\x92\x12\xd2\x0f\x12\xe2\x0f\x12\xd2"
            "\x1f\x12\xc2\x23\xa2\x42\x92\x53\x72\x73\x42\xa6\x91" }  },
      /* --- pixel bitmap for cmsy180 char#80 \calP --- */
      {  80,12951,                      /* character number, location */
         17, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4a\x52\x22\x44\x12\x42\x65\x42\x72\x62\x72\xf1\x52"
            "\x82\x52\x72\x62\x62\x72\x52\x72\x43\x86\xb2\xb0\xf2"
            "\x32\xc0\xf1\x22\xd0\x21\xe2" }  },
      /* --- pixel bitmap for cmsy180 char#81 \calQ --- */
      {  81,13806,                      /* character number, location */
         18, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\x92\x44\x62\x72\x52\x83\x32\xa2\x10\xf1\x12\xb2"
            "\x1f\x22\xc2\x1f\x12\xb2\x23\x92\x43\x42\x12\x66\x32"
            "\xd2\xe2\x87\x81\x46\x42\x97\x23" }  },
      /* --- pixel bitmap for cmsy180 char#82 \calR --- */
      {  82,14667,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 20,   18, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4b\x72\x22\x53\x42\x42\x63\x32\x42\x72\x92\x72\x82"
            "\x82\x82\x72\x92\x62\xa2\x43\xb2\x13\xd2\x33\x80\xf1"
            "\x42\x42\x80\x32\x53\xa2\x62\x52\x32\x63\x32\x32\x82"
            "\x22\x42\x84\x42" }  },
      /* --- pixel bitmap for cmsy180 char#83 \calS --- */
      {  83,15447,                      /* character number, location */
         18, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 16,   19, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x82\x44\x52\x72\x42\x82\x42\x81\x52\xe3\xe3\xe4"
            "\xe4\xe3\xe3\x33\x82\x2f\x12\xa2\x22\x92\x33\x72\x53"
            "\x52\x77\x70" }  },
      /* --- pixel bitmap for cmsy180 char#84 \calT --- */
      {  84,16147,                      /* character number, location */
         18, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x51\x3e\x02\x32\x62\x92\x62\x9f\x12\x72\x90\x92"
            "\x90\xf3\x82\xa0\xf3\x72\xb0\xf1\x62\xc0\xf1\x52\xd0"
            "\x51\xe7" }  },
      /* --- pixel bitmap for cmsy180 char#85 \calU --- */
      {  85,16889,                      /* character number, location */
         17, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 17,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x80\x67\x00\xc3\x00\x83\x01\x86\x01\x0c\x03\x1c"
            "\x03\x18\x06\x38\x0c\x78\x0c\x70\x18\xf0\x30\xb0\x31"
            "\x60\x63\x60\xc3\x60\x86\x61\x0c\x67\x18\x3c\x70\x00" }  },
      /* --- pixel bitmap for cmsy180 char#86 \calV --- */
      {  86,17628,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   18, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x92\x33\x83\x33\x82\x42\x91\x43\x81\x52\x81\x52"
            "\x71\x62\x62\x62\x61\x72\x51\x82\x42\x82\x32\x92\x22"
            "\xa2\x12\xa2\x12\xb4\xc3\xd1\xb2" }  },
      /* --- pixel bitmap for cmsy180 char#87 \calW --- */
      {  87,18637,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 25,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x60\x80\x39\xc0\x81\x63\x80\x03\xc4\x81\x06\x08"
            "\x03\x1d\x10\x06\x31\x20\x0c\x63\x20\x18\xc2\x40\x30"
            "\x82\x41\x60\x06\xc7\xc0\x04\x8c\x80\x05\x98\x00\x0f"
            "\xb0\x01\x0e\x60\x01\x0e\xc0\x01\x1c\x80\x03\x18\x00"
            "\x03\x10\x00\x02\x00" }  },
      /* --- pixel bitmap for cmsy180 char#88 \calX --- */
      {  88,19490,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   17, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x73\x42\x13\x72\x82\x72\x82\x62\x92\x52\xa3\x32"
            "\xc2\x12\xe3\xe0\x13\xe0\x14\xd2\x22\xb2\x42\xa2\x52"
            "\x92\x62\x82\x73\x72\x82\x12\x43\x74\x53" }  },
      /* --- pixel bitmap for cmsy180 char#89 \calY --- */
      {  89,20261,                      /* character number, location */
         17, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x72\x22\x23\x63\x63\x62\xf1\x72\x71\x73\x61\xf1"
            "\x82\x51\x10\x82\x41\xa2\x32\xa2\x31\xb2\x21\xc2\x12"
            "\xc4\xd3\xe2\x81\x52\x83\x23\xa6\xc3\xc3" }  },
      /* --- pixel bitmap for cmsy180 char#90 \calZ --- */
      {  90,21117,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   17, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x22\x52\x55\x62\x72\x62\x82\xe0\x12\xe0\x12\xe0"
            "\x12\xb8\xd2\x12\xc2\xe0\x12\xe0\x12\xe0\x12\x81\x62"
            "\x82\x42\xa2\x38\x42\x32\x56\x56" }  },
      /* --- pixel bitmap for cmsy180 char#91 \cup --- */
      {  91,24796,                      /* character number, location */
         16, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x01\xd1\x11\xb1\x32\x72\x67\x41" }  },
      /* --- pixel bitmap for cmsy180 char#92 \cap --- */
      {  92,25493,                      /* character number, location */
         16, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x62\x72\x31\xb1\x1f\xd1\xd1" }  },
      /* --- pixel bitmap for cmsy180 char#93 \uplus --- */
      {  93,81871,                      /* character number, location */
         16, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x01\xd1\x0f\x41\x61\x61\x01\x1b\x11\x0f\x41\x61"
            "\x61\x11\xb1\x32\x72\x67\x41" }  },
      /* --- pixel bitmap for cmsy180 char#94 \wedge --- */
      {  94,26173,                      /* character number, location */
         16, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x71\x70\xf1\x61\x11\x60\xf1\x51\x31\x50\xf1\x41"
            "\x51\x40\xf2\x31\x71\x30\xf1\x21\x91\x20\xf1\x11\xb1"
            "\x1f\x11\xd1" }  },
      /* --- pixel bitmap for cmsy180 char#95 \vee --- */
      {  95,26851,                      /* character number, location */
         16, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xd1\xf1\x11\xb1\x10\xf1\x21\x91\x20\xf2\x31"
            "\x71\x30\xf1\x41\x51\x40\xf1\x51\x31\x50\xf1\x61\x11"
            "\x60\xf1\x71\x71" }  },
      /* --- pixel bitmap for cmsy180 char#96 \vdash --- */
      {  96,82542,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x01\xcd\x0f\x71\xc1" }  },
      /* --- pixel bitmap for cmsy180 char#97 \dashv --- */
      {  97,83160,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\xc1\x0d\xf7\xc1" }  },
      /* --- pixel bitmap for cmsy180 char#98 \lfloor --- */
      {  98,83688,                      /* character number, location */
         19, 4,   -6, 4,      /* topleft row,col, and botleft row,col */
          {  6,   25, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x5f\x81\x56" }  },
      /* --- pixel bitmap for cmsy180 char#99 \rfloor --- */
      {  99,84233,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   25, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x51\xf8\x51\x06" }  },
      /* --- pixel bitmap for cmsy180 char#100 \lceil --- */
      { 100,84779,                      /* character number, location */
         19, 4,   -6, 4,      /* topleft row,col, and botleft row,col */
          {  6,   25, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x5f\x81\x51" }  },
      /* --- pixel bitmap for cmsy180 char#101 \rceil --- */
      { 101,85326,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   25, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x51\xf8\x51" }  },
      /* --- pixel bitmap for cmsy180 char#102 \lbrace --- */
      { 102,41109,                      /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  8,   25, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\x42\x20\xf8\x32\x30\x22\x43\x72\x40\xf8\x32\x30"
            "\x42\x73" }  },
      /* --- pixel bitmap for cmsy180 char#103 \rbrace --- */
      { 103,41962,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 10,   25, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xa2\x50\xf8\x42\x40\x52\xa3\x52\x30\xf8\x42\x40"
            "\x32\x53\x71" }  },
      /* --- pixel bitmap for cmsy180 char#104 \langle --- */
      { 104,85844,                      /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  7,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x08\x04\x41\x20\x08\x04\x81\x20\x10\x08\x08"
            "\x04\x04\x02\x02\x01\x01\x81\x80\x40" }  },
      /* --- pixel bitmap for cmsy180 char#105 \rangle --- */
      { 105,86363,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  7,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\x40\x40\x40\x20\x20\x10\x10\x08\x08\x04\x82"
            "\x40\x10\x08\x02\x41\x10\x08\x02\x01" }  },
      /* --- pixel bitmap for cmsy180 char#106 \mid --- */
      { 106,39177,                      /* character number, location */
         19, 3,   -6, 3,      /* topleft row,col, and botleft row,col */
          {  1,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\xff\x01" }  },
      /* --- pixel bitmap for cmsy180 char#107 \parallel --- */
      { 107,86972,                      /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  8,   25, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x61\x0f\x91\x61" }  },
      /* --- pixel bitmap for cmsy180 char#108 \updownarrow --- */
      { 108,88190,                      /* character number, location */
         20, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 11,   27, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x51\x50\x43\x75\x57\x2f\x1b\x19\x37\x20\xf1\x35"
            "\x30\x43\x91\x93\x40\xf1\x35\x30\x27\x39\x1f\x1b\x27"
            "\x55\x73\x40\xf2\x51\x51" }  },
      /* --- pixel bitmap for cmsy180 char#109 \Updownarrow --- */
      { 109,89271,                      /* character number, location */
         20, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 15,   27, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x71\x70\x63\xb5\x97\x79\x4d\x1e\x01\xfa\x41\x51"
            "\x4e\x01\x1d\x49\x77\x95\xb3\x60\xf1\x71\x7f" }  },
      /* --- pixel bitmap for cmsy180 char#110 \setminus --- */
      { 110,38731,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 10,   25, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\x90\xf2\x11\x80\xf1\x21\x70\xf2\x31\x60\xf2"
            "\x41\x50\xf1\x51\x40\xf2\x61\x30\xf1\x71\x20\xf2\x81"
            "\x10\xf1\x91" }  },
      /* --- pixel bitmap for cmsy180 char#111 \wr --- */
      { 111,89774,                      /* character number, location */
         14, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  5,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x61\x08\x31\x23\x66\x84\x30\x0c\x07" }  },
      /* --- pixel bitmap for cmsy180 char#112 \surd --- */
      { 112,90630,                      /* character number, location */
          1, 2,  -24, 2,      /* topleft row,col, and botleft row,col */
          { 20,   25, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x51\xf1\xe0\x41\x10\xf1\xe0\x31\x20\xf1\xe0"
            "\x21\x30\xf1\xe0\x11\x40\xf1\xe1\x50\x21\xa1\x64\x91"
            "\x82\x81\x93\x71\xa2\x61\xb3\x51\xc2\x41\xd3\x31\xe2"
            "\x21\xe0\x13\x11\xa0\xf1\x63\xb0\x71\xc2" }  },
      /* --- pixel bitmap for cmsy180 char#113 \amalg --- */
      { 113,91838,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   17, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x38\xfe\x32\x92\x3e\x05" }  },
      /* --- pixel bitmap for cmsy180 char#114 \nabla --- */
      { 114,92788,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x05\x1e\x03\x23\xd1\x32\xc1\x43\xb1\x20\xf1\x32"
            "\xa1\x30\xf1\x42\x81\x40\xf1\x52\x61\x50\xf1\x62\x41"
            "\x60\xf1\x72\x21\x70\xf1\x83\x80\x91\x91" }  },
      /* --- pixel bitmap for cmsy180 char#115 \smallint --- */
      { 115,44075,                      /* character number, location */
         18, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 11,   24, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\x10\xf1\x71\x12\xf4\x62\x30\x61\x40\xf5\x52\x40"
            "\x51\x50\xf4\x42\x52\x21\x62\x12\x73\x71" }  },
      /* --- pixel bitmap for cmsy180 char#116 \sqcup --- */
      { 116,93478,                      /* character number, location */
         16, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   16, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\xb1\x0d" }  },
      /* --- pixel bitmap for cmsy180 char#117 \sqcap --- */
      { 117,94175,                      /* character number, location */
         16, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   16, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xe1\xb1" }  },
      /* --- pixel bitmap for cmsy180 char#118 \sqsubseteq --- */
      { 118,94944,                      /* character number, location */
         16, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 16,   21, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x0f\xc1\xe0\x1e\x02\xf4\xe0\x2e\x01\x11" }  },
      /* --- pixel bitmap for cmsy180 char#119 \sqsupseteq --- */
      { 119,95687,                      /* character number, location */
         16, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 16,   21, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\xfc\xe0\x11\x1e\x01\xf4\xe0\x20\x1e\x01" }  },
      /* --- pixel bitmap for cmsy180 char#120 \S --- */
      { 120,96684,                      /* character number, location */
         17, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  7,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\xd1\x78\x3c\x10\x18\x18\xb2\xd1\x78\x2c\x36\x61"
            "\x60\x20\xf0\x78\x2c\xe2\x00" }  },
      /* --- pixel bitmap for cmsy180 char#121 \dag --- */
      { 121,97502,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 10,   23, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x42\x4f\x1a\xfe\x42\x40\x42\x42" }  },
      /* --- pixel bitmap for cmsy180 char#122 \ddag --- */
      { 122,98493,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 10,   22, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x42\x4a\xf4\x42\x40\xa0\xf3\x42\x4f\x1a\xf3\x42"
            "\x41" }  },
      /* --- pixel bitmap for cmsy180 char#123 \P --- */
      { 123,99195,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 13,   22, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x49\x26\x21\x37\x21\x2f\x48\x21\x20\x17\x21\x46\x21"
            "\x55\x21\x73\x21\x20\xf9\x71\x21\x22" }  },
      /* --- pixel bitmap for cmsy180 char#124 \clubsuit --- */
      { 124,100159,                     /* character number, location */
         18, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 17,   21, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\xb7\x50\xf5\x49\x40\x57\x73\x15\x13\x3e\x01\x1f"
            "\x4e\x03\x07\x11\x17\x16\x11\x16\x34\x21\x24\x20\xf1"
            "\x73\x72" }  },
      /* --- pixel bitmap for cmsy180 char#125 \Diamond --- */
      { 125,100876,                     /* character number, location */
         18, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 17,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x00\x05\x00\x0a\x00\x22\x00\x44\x00\x04\x01"
            "\x04\x04\x04\x10\x08\x20\x08\x80\x08\x00\x16\x00\x44"
            "\x00\x04\x01\x04\x02\x08\x08\x08\x20\x08\x80\x08\x00"
            "\x11\x00\x14\x00\x28\x00\x20\x00" }  },
      /* --- pixel bitmap for cmsy180 char#126 \Heart --- */
      { 126,101707,                     /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x54\x31\x41\x31\x41\x11\x61\x11\x61\x0f\x11\x71"
            "\x71\x0f\x31\xe0\x11\xf1\x11\xd1\x10\x21\xb1\x51\x91"
            "\x71\x71\x91\x51\xb1\x31\x60\xf1\x71\x11\x70\x81\x81" }  },
      /* --- pixel bitmap for cmsy180 char#127 \spadesuit --- */
      { 127,102606,                     /* character number, location */
         18, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 17,   21, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\x80\xf1\x73\x70\x65\xb7\x99\x7b\x5d\x20\xf1"
            "\x1e\x01\x1f\x4e\x03\xf1\x16\x11\x16\x10\x24\x21\x24"
            "\x20\xf1\x73\x71" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=6 for .210gf ---
 * mf '\mode=preview; mag=magstep(-13.80488502080647873125); input cmsy10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmsy210 --- */
static	chardef  cmsy210[] =
   {
      /* --- pixel bitmap for cmsy210 char#0 - --- */
      {   0,22190,                      /* character number, location */
          8, 2,    6, 2,      /* topleft row,col, and botleft row,col */
          { 19,    2, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x05" }  },
      /* --- pixel bitmap for cmsy210 char#1 \cdot --- */
      {   1,40268,                      /* character number, location */
          9, 3,    6, 3,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x00" }  },
      /* --- pixel bitmap for cmsy210 char#2 \times --- */
      {   2,45406,                      /* character number, location */
         14, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 15,   14, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xb5\x93\x13\x73\x33\x53\x53\x33\x73\x13\x40\xf1"
            "\x55\x50\x43\x13\x73\x33\x53\x53\x33\x73\x13\x95\xb2" }  },
      /* --- pixel bitmap for cmsy210 char#3 \ast --- */
      {   3,46057,                      /* character number, location */
         14, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x00\x01\x08\x46\xfc\x7a\xfe\xc0\x81\x3f\xaf\x1f"
            "\x31\x08\x40\x00\x02" }  },
      /* --- pixel bitmap for cmsy210 char#4 \div --- */
      {   4,46906,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\x80\xf1\x74\x70\x82\x80\xf3\xe0\x4f\x1e\x04\xf3"
            "\xe0\x40\x82\x80\xf1\x74\x70\x82\x83" }  },
      /* --- pixel bitmap for cmsy210 char#5 \diamond --- */
      {   5,40833,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   14, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\xb4\x96\x73\x23\x53\x43\x33\x63\x1f\x13\x83\x13"
            "\x63\x33\x43\x53\x23\x76\x94\xb2\x60" }  },
      /* --- pixel bitmap for cmsy210 char#6 \pm --- */
      {   6,22889,                      /* character number, location */
         19, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x92\x8f\x1e\x05\xf6\x92\x8f\x1e\x05" }  },
      /* --- pixel bitmap for cmsy210 char#7 \mp --- */
      {   7,47625,                      /* character number, location */
         15, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x05\xf6\x92\x8f\x1e\x05\xf8\x92\x8e" }  },
      /* --- pixel bitmap for cmsy210 char#8 \oplus --- */
      {   8,23656,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xa2\x31\x32\x71\x51\x51\x51\x61\x61\x20\xf2\x11"
            "\x71\x71\x1f\x11\x81\x81\x0e\x05\x0f\x21\x81\x81\xf2"
            "\x11\x71\x71\x10\x21\x61\x61\x51\x51\x51\x72\x31\x32"
            "\xa7\x62" }  },
      /* --- pixel bitmap for cmsy210 char#9 \ominus --- */
      {   9,48393,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xa2\x72\x71\xb1\x51\xd1\x20\xf2\x11\xe0\x11\x1f"
            "\x11\xe0\x31\x0e\x05\x0f\x21\xe0\x31\xf2\x11\xe0\x11"
            "\x10\x21\xd1\x51\xb1\x72\x72\xa7\x62" }  },
      /* --- pixel bitmap for cmsy210 char#10 \otimes --- */
      {  10,24492,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x1f\x80\x01\x03\x02\x20\x18\x00\x23\x01\x24\x11"
            "\x10\x09\x41\x28\x10\x81\x01\x05\x0c\x10\x60\x80\x00"
            "\x03\x0a\x18\x88\x40\x21\x08\x89\x80\x48\x02\x48\x0c"
            "\x80\x41\x00\x04\x0c\x18\x80\x3f\x00" }  },
      /* --- pixel bitmap for cmsy210 char#11 \oslash --- */
      {  11,49196,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xa2\x72\x71\xb1\x51\xc2\x31\xc1\x21\x21\xb1\x31"
            "\x21\xa1\x41\x11\xa1\x62\x91\x71\x0f\x11\x81\x81\x01"
            "\x71\x92\x61\xa1\x11\x41\xa1\x21\x31\xb1\x21\x21\xc1"
            "\x32\xc1\x51\xb1\x72\x72\xa7\x61" }  },
      /* --- pixel bitmap for cmsy210 char#12 \odot --- */
      {  12,50022,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xa2\x72\x71\xb1\x51\xd1\x20\xf2\x11\xe0\x11\x11"
            "\xe0\x31\x0f\x31\x73\x71\x01\xe0\x31\xf2\x11\xe0\x11"
            "\x10\x21\xd1\x51\xb1\x72\x72\xa7\x61" }  },
      /* --- pixel bitmap for cmsy210 char#13 \bigcirc --- */
      {  13,50943,                      /* character number, location */
         21, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 25,   28, 3,113, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x97\xe0\x2b\xc4\x74\x93\xb3\x73\xd3\x53\xe0\x13\x42"
            "\xe0\x32\x33\xe0\x33\x10\xf1\x12\xe0\x52\x13\xe0\x53"
            "\x0f\x52\xe0\x72\x03\xe0\x53\xf1\x12\xe0\x52\x10\x13"
            "\xe0\x33\x32\xe0\x32\x43\xe0\x13\x53\xd3\x73\xb3\x94"
            "\x74\xcb\xe0\x27\x92" }  },
      /* --- pixel bitmap for cmsy210 char#14 \circ --- */
      {  14,51639,                      /* character number, location */
         13, 2,    2, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\xe0\x8f\xe3\x0e\x3e\xe0\x01\x0f\xf8\xe0\x8e\xe3"
            "\x0f\x1c\x00" }  },
      /* --- pixel bitmap for cmsy210 char#15 \bullet --- */
      {  15,52258,                      /* character number, location */
         13, 2,    2, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x67\x39\x1f\x4b\x19\x37\x63\x42" }  },
      /* --- pixel bitmap for cmsy210 char#16 \asymp --- */
      {  16,52962,                      /* character number, location */
         14, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   14, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x15\xd3\x13\xb3\x35\x55\x6b\xb5\x70\xf1\xe0"
            "\x50\x75\xbb\x65\x55\x33\xb3\x13\xd5\xe0\x12" }  },
      /* --- pixel bitmap for cmsy210 char#17 \equiv --- */
      {  17,38753,                      /* character number, location */
         14, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   14, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x05\xf3\xe0\x5f\x1e\x05\xf3\xe0\x5f\x1e\x05" }  },
      /* --- pixel bitmap for cmsy210 char#18 \subseteq --- */
      {  18,53719,                      /* character number, location */
         18, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x5e\x34\xe3\xe0\x13\xe0\x22\xe0\x23\xe0\x2f\x32"
            "\xe0\x33\xe0\x32\xe0\x33\xe0\x33\xe0\x34\xe0\x3e\x7c"
            "\xf3\xe0\x50\xf1\x1e\x04" }  },
      /* --- pixel bitmap for cmsy210 char#19 \supseteq --- */
      {  19,54478,                      /* character number, location */
         18, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x7e\xe0\x34\xe0\x33\xe0\x33\xe0\x32\xe0\x33\xf3"
            "\xe0\x32\xe0\x23\xe0\x22\xe0\x23\xe0\x13\xe4\x3e\x5c"
            "\x70\xf3\xe0\x5f\x1e\x04\x13" }  },
      /* --- pixel bitmap for cmsy210 char#20 \leq --- */
      {  20,37271,                      /* character number, location */
         18, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,68, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x32\xe0\x14\xd4\xd4\xc5\xc5\xc4\xd4\xdf\x14\xe0"
            "\x10\x24\xe0\x34\xe0\x35\xe0\x25\xe0\x34\xe0\x34\xe0"
            "\x34\xe0\x32\xf3\xe0\x5f\x1e\x05" }  },
      /* --- pixel bitmap for cmsy210 char#21 \geq --- */
      {  21,38004,                      /* character number, location */
         18, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x34\xe0\x34\xe0\x34\xe0\x35\xe0\x25\xe0\x34"
            "\xe0\x34\x20\xf1\xe0\x14\xd4\xd4\xc5\xc5\xc4\xd4\xd4"
            "\xe0\x12\xe0\x30\xf3\xe0\x5f\x1e\x05" }  },
      /* --- pixel bitmap for cmsy210 char#22 \preceq --- */
      {  22,55205,                      /* character number, location */
         18, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x32\xe0\x23\xe0\x22\xe0\x23\xe0\x13\xe4\xb6"
            "\x5f\x1c\x70\x86\xe0\x34\xe0\x33\xe0\x33\xe0\x32\xe0"
            "\x33\xf1\xe0\x32\xf3\xe0\x5f\x1e\x05" }  },
      /* --- pixel bitmap for cmsy210 char#23 \succeq --- */
      {  23,55931,                      /* character number, location */
         18, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x33\xe0\x32\xe0\x33\xe0\x33\xe0\x34\xe0"
            "\x36\x80\xf1\x7c\x56\xb4\xe3\xe0\x13\xe0\x22\xe0\x23"
            "\xe0\x2f\x12\xe0\x30\xf3\xe0\x5f\x1e\x05" }  },
      /* --- pixel bitmap for cmsy210 char#24 \sim --- */
      {  24,56635,                      /* character number, location */
         11, 2,    4, 2,      /* topleft row,col, and botleft row,col */
          { 19,    7, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\xb1\x18\x91\x19\x75\x45\x45\x79\x11\x98\x11\xb4"
            "\x36" }  },
      /* --- pixel bitmap for cmsy210 char#25 \approx --- */
      {  25,57397,                      /* character number, location */
         14, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   14, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\xb1\x18\x9d\x54\x5d\x89\x11\xb5\x20\xf1\xe0\x50"
            "\x25\xb1\x18\x9d\x54\x5d\x89\x11\xb5\x20" }  },
      /* --- pixel bitmap for cmsy210 char#26 \subset --- */
      {  26,33261,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x5e\x34\xe3\xe0\x13\xe0\x22\xe0\x23\xe0\x2f\x32"
            "\xe0\x33\xe0\x32\xe0\x33\xe0\x33\xe0\x34\xe0\x3e\x7c" }  },
      /* --- pixel bitmap for cmsy210 char#27 \supset --- */
      {  27,33979,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x7e\xe0\x34\xe0\x33\xe0\x33\xe0\x32\xe0\x33\xf3"
            "\xe0\x32\xe0\x23\xe0\x22\xe0\x23\xe0\x13\xe4\x3e\x5c"
            "\x70" }  },
      /* --- pixel bitmap for cmsy210 char#28 \ll --- */
      {  28,58242,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 25,   20, 3,80, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe2\x72\xc4\x54\xb3\x63\xb4\x54\xb3\x63\xb4\x54\xb3"
            "\x63\xb4\x54\xb3\x63\xbf\x14\x54\xc0\x23\x63\xe4\x54"
            "\xe3\x63\xe4\x54\xe3\x63\xe4\x54\xe3\x63\xe4\x54\xe2"
            "\x72" }  },
      /* --- pixel bitmap for cmsy210 char#29 \gg --- */
      {  29,59120,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 25,   20, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x72\xe4\x54\xe3\x63\xe4\x54\xe3\x63\xe4\x54\xe3"
            "\x63\xe4\x54\xe3\x63\x20\xf1\xc4\x54\xb3\x63\xb4\x54"
            "\xb3\x63\xb4\x54\xb3\x63\xb4\x54\xb3\x63\xb4\x54\xc2"
            "\x72\xe3" }  },
      /* --- pixel bitmap for cmsy210 char#30 \prec --- */
      {  30,59845,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x32\xe0\x23\xe0\x22\xe0\x23\xe0\x13\xe4\xb6"
            "\x5f\x1c\x70\x86\xe0\x34\xe0\x33\xe0\x33\xe0\x32\xe0"
            "\x33\xf1\xe0\x32" }  },
      /* --- pixel bitmap for cmsy210 char#31 \succ --- */
      {  31,60525,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x33\xe0\x32\xe0\x33\xe0\x33\xe0\x34\xe0"
            "\x36\x80\xf1\x7c\x56\xb4\xe3\xe0\x13\xe0\x22\xe0\x23"
            "\xe0\x2f\x12\xe0\x33" }  },
      /* --- pixel bitmap for cmsy210 char#32 \leftarrow --- */
      {  32,30084,                      /* character number, location */
         15, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,   16, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x62\xe0\x30\xf1\x52\xe0\x40\x43\xe0\x82\xe0\x73"
            "\xe0\x60\xf1\x1e\x0a\x23\xe0\xa2\xe0\x93\xe0\x40\xf1"
            "\x52\xe0\x40\xf1\x62\xe0\x35" }  },
      /* --- pixel bitmap for cmsy210 char#33 \rightarrow --- */
      {  33,31134,                      /* character number, location */
         15, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,   16, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x32\x60\xf1\xe0\x42\x50\xe0\x43\xe0\x92\xe0"
            "\xa3\x2f\x1e\x0b\xe0\x63\xe0\x72\xe0\x83\x40\xf1\xe0"
            "\x42\x50\xf1\xe0\x32\x60" }  },
      /* --- pixel bitmap for cmsy210 char#34 \uparrow --- */
      {  34,29003,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 14,   26, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x60\xf1\x62\x60\x54\x96\x78\x44\x12\x14\x13\x32"
            "\x34\x52\x51\xfe\x62\x60\xf1\x62\x63" }  },
      /* --- pixel bitmap for cmsy210 char#35 \downarrow --- */
      {  35,28158,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 14,   26, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x62\x60\xf1\x62\x61\x52\x54\x32\x33\x14\x12\x14"
            "\x48\x76\x94\x50\xf1\x62\x60\x71\x63" }  },
      /* --- pixel bitmap for cmsy210 char#36 \leftrightarrow --- */
      {  36,32521,                      /* character number, location */
         15, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,   16, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x62\x92\x60\xf1\x52\xb2\x50\x43\xb3\x82\xd2\x63"
            "\xe0\x13\x20\xf1\x1e\x0a\x23\xe0\x13\x62\xd2\x83\xb3"
            "\x40\xf1\x52\xb2\x50\xf1\x62\x92\x62" }  },
      /* --- pixel bitmap for cmsy210 char#37 \nearrow --- */
      {  37,61579,                      /* character number, location */
         21, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 26,   26, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x11\xe0\xa4\x52\xe0\x39\xe0\x56\xe0\x84\xe0\x75"
            "\xe0\x63\x12\xe0\x53\x22\xe0\x43\x42\xe0\x23\x52\xe0"
            "\x13\x72\xd3\x81\xd3\xe0\x83\xe0\x83\xe0\x83\xe0\x83"
            "\xe0\x83\xe0\x83\xe0\x83\xe0\x83\xe0\x83\xe0\x83\xe0"
            "\x83\xe0\x83\xe0\x92\xe0\xa2" }  },
      /* --- pixel bitmap for cmsy210 char#38 \searrow --- */
      {  38,62663,                      /* character number, location */
         19, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 26,   26, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe0\xa3\xe0\xa3\xe0\xa3\xe0\xa3\xe0\xa3\xe0\xa3"
            "\xe0\xa3\xe0\xa3\xe0\xa3\xe0\xa3\xe0\xa3\xe0\xa3\xe0"
            "\xa3\xe0\xa3\x81\xe0\x13\x72\xe0\x13\x52\xe0\x33\x42"
            "\xe0\x43\x22\xe0\x63\x12\xe0\x75\xe0\x84\xe0\x66\xe0"
            "\x49\xe0\x14\x52\xe0\x21\xa2" }  },
      /* --- pixel bitmap for cmsy210 char#39 \simeq --- */
      {  39,63427,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   13, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\xb1\x19\x8d\x54\x5d\x98\x11\xb5\x20\xf4\xe0\x5f"
            "\x1e\x05" }  },
      /* --- pixel bitmap for cmsy210 char#40 \Leftarrow --- */
      {  40,64447,                      /* character number, location */
         15, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,   16, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\xe0\xf1\x82\xe0\x10\x72\xe0\x8e\x05\x4e\x07\x24"
            "\xe0\x54\xe0\x93\xe0\xa2\xe0\xae\x06\x6e\x05\x72\xe0"
            "\x20\xf1\x82\xe0\x10\x92\xe2" }  },
      /* --- pixel bitmap for cmsy210 char#41 \Rightarrow --- */
      {  41,65470,                      /* character number, location */
         15, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,   16, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe2\x90\xf1\xe0\x12\x80\xe0\x22\x7e\x05\x6e\x07\xe0"
            "\x94\xe0\x94\xe0\x63\xe0\x72\x4e\x06\x5e\x05\xe0\x82"
            "\x70\xf1\xe0\x12\x80\xe2\x92" }  },
      /* --- pixel bitmap for cmsy210 char#42 \Uparrow --- */
      {  42,66308,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 17,   26, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\x80\xf1\x73\x70\x62\x12\xb2\x32\x93\x33\x73"
            "\x53\x54\x54\x23\x12\x52\x15\x22\x52\x22\xfe\x42\x52"
            "\x40" }  },
      /* --- pixel bitmap for cmsy210 char#43 \Downarrow --- */
      {  43,67220,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 17,   26, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x42\x52\x42\x22\x52\x25\x12\x52\x13\x24\x54\x53"
            "\x53\x73\x33\x92\x32\xb2\x12\x60\xf1\x73\x70\xf1\x81"
            "\x80" }  },
      /* --- pixel bitmap for cmsy210 char#44 \Leftrightarrow --- */
      {  44,68552,                      /* character number, location */
         15, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 27,   16, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x72\x92\x70\xf1\x62\xb2\x60\x5e\x03\x8e\x07\x53"
            "\xe0\x33\x23\xe0\x73\x13\xe0\x53\x42\xe0\x32\x7e\x05"
            "\x9e\x03\x50\xf1\x62\xb2\x60\xf1\x72\x92\x70" }  },
      /* --- pixel bitmap for cmsy210 char#45 \nwarrow --- */
      {  45,69626,                      /* character number, location */
         21, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 26,   26, 3,116, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xa1\xe0\x22\x54\xe0\x19\xe0\x46\xe0\x64\xe0\x85\xe0"
            "\x72\x13\xe0\x62\x23\xe0\x42\x43\xe0\x32\x53\xe0\x12"
            "\x73\xe0\x11\x83\xe0\xa3\xe0\xa3\xe0\xa3\xe0\xa3\xe0"
            "\xa3\xe0\xa3\xe0\xa3\xe0\xa3\xe0\xa3\xe0\xa3\xe0\xa3"
            "\xe0\xa3\xe0\xa3\xe0\xa2" }  },
      /* --- pixel bitmap for cmsy210 char#46 \swarrow --- */
      {  46,70710,                      /* character number, location */
         19, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 26,   26, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xa2\xe0\x93\xe0\x83\xe0\x83\xe0\x83\xe0\x83\xe0"
            "\x83\xe0\x83\xe0\x83\xe0\x83\xe0\x83\xe0\x83\xe0\x83"
            "\xe0\x83\xd1\x83\xd2\x73\xe0\x12\x53\xe0\x22\x43\xe0"
            "\x42\x23\xe0\x52\x13\xe0\x65\xe0\x74\xe0\x86\xe0\x59"
            "\xe0\x32\x54\xe0\xa1\xe0\x12" }  },
      /* --- pixel bitmap for cmsy210 char#47 \propto --- */
      {  47,71806,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x00\x67\x0f\x86\xc0\x18\x04\x6e\x10\x60\x81\x00"
            "\x0e\x04\x70\x20\x80\x03\x01\x34\x10\xb0\x83\xc0\x18"
            "\x08\x83\x87\x07\x70" }  },
      /* --- pixel bitmap for cmsy210 char#48 \prime --- */
      {  48,72364,                      /* character number, location */
         16, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  7,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x38\x1c\x87\xc3\x71\x38\x0c\x87\xc3\x60\x18\x0c"
            "\x00" }  },
      /* --- pixel bitmap for cmsy210 char#49 \infty --- */
      {  49,43720,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 25,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x00\x3e\xb8\x03\xc6\x08\x0c\x02\x12\x30\x02\x14"
            "\xc0\x02\x30\x00\x07\x60\x00\x0e\xc0\x00\x1c\x80\x01"
            "\x68\x00\x05\x88\x01\x09\x08\x06\x62\x0c\xb8\x83\x0f"
            "\xe0\x03" }  },
      /* --- pixel bitmap for cmsy210 char#50 \in --- */
      {  50,34652,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x4b\x34\xa3\xb3\xc2\xc3\xc2\xdf\x1e\x01\x02\xd3"
            "\xd2\xd3\xd3\xd4\xcb\x78" }  },
      /* --- pixel bitmap for cmsy210 char#51 \ni --- */
      {  51,73033,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x7b\xc4\xd3\xd3\xd2\xd3\xd2\x0f\x1e\x01\xd2\xc3"
            "\xc2\xc3\xb3\xa4\x3b\x48\x72" }  },
      /* --- pixel bitmap for cmsy210 char#52 \triangle --- */
      {  52,73767,                      /* character number, location */
         21, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   21, 3,84, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\xa0\xf1\x94\x90\x86\xe0\x22\x22\xe0\x13\x23\xe2"
            "\x42\xd3\x43\xc2\x62\xb3\x63\xa2\x82\x93\x83\x82\xa2"
            "\x73\xa3\x62\xc2\x53\xc3\x42\xe2\x33\xe3\x22\xe0\x22"
            "\x1f\x1e\x08" }  },
      /* --- pixel bitmap for cmsy210 char#53 \bigtriangledown --- */
      {  53,74546,                      /* character number, location */
         14, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 22,   21, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x08\x12\xe0\x22\x23\xe3\x32\xe2\x43\xc3\x52"
            "\xc2\x63\xa3\x72\xa2\x83\x83\x92\x82\xa3\x63\xb2\x62"
            "\xc3\x43\xd2\x42\xe3\x23\xe0\x12\x22\xe0\x26\x80\xf1"
            "\x94\x90\xa2\xa2" }  },
      /* --- pixel bitmap for cmsy210 char#54 \boldslash --- */
      {  54,74934,                      /* character number, location */
         21, 4,   -7, 4,      /* topleft row,col, and botleft row,col */
          { 15,   28, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\xc3\xc2\xc3\xc2\xc3\xc2\xc3\xc2\xc3\xc2\xc3\x50"
            "\xf1\x72\x60\x63\xc2\xc3\xc2\xc3\xc2\xc3\xc2\xc3\xc2"
            "\xc3\xc2\xc3\xc2\xd3" }  },
      /* --- pixel bitmap for cmsy210 char#55 \' --- */
      {  55,75315,                      /* character number, location */
         13, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdb\xb6\x7f\xdb\x06" }  },
      /* --- pixel bitmap for cmsy210 char#56 \forall --- */
      {  56,35266,                      /* character number, location */
         20, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 16,   21, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xc2\x03\xa3\xf1\x12\xa2\x10\x13\x83\x10\xf1"
            "\x2c\x20\xf1\x32\x62\x30\x33\x43\x30\xf1\x42\x42\x40"
            "\x43\x23\x92\x22\xa6\x50\xf2\x64\x60\xf1\x72\x71" }  },
      /* --- pixel bitmap for cmsy210 char#57 \exists --- */
      {  57,35929,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   20, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0c\xf6\xa2\x0f\x1c\xf6\xa2\x0f\x1c" }  },
      /* --- pixel bitmap for cmsy210 char#58 \neg --- */
      {  58,36565,                      /* character number, location */
         11, 2,    2, 2,      /* topleft row,col, and botleft row,col */
          { 15,    9, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x01\xf6\xd2" }  },
      /* --- pixel bitmap for cmsy210 char#59 \emptyset --- */
      {  59,76030,                      /* character number, location */
         23, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 13,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\xc0\xc0\x1f\x8c\x41\x70\x0c\x9e\xe0\x12\x4c"
            "\x83\x79\x38\x0f\xe3\x61\x3c\x8e\xc7\xf0\x18\x1e\xc3"
            "\x73\x78\x06\xcb\x20\x1f\xe6\xc1\x38\x08\xc6\xe0\x0f"
            "\x0c\x80\x01\x00" }  },
      /* --- pixel bitmap for cmsy210 char#60 \Re --- */
      {  60,77901,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 20,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x70\x80\xc3\x0e\x64\xc2\x20\x2c\x18\x82\x81\x23"
            "\x18\x30\x84\x01\x86\x18\x60\x90\x03\x0c\x39\x60\x90"
            "\xff\x21\x39\x06\x92\x63\xc0\x38\x06\x80\x61\x00\x18"
            "\x06\x80\x61\x20\x18\x06\x83\x61\x20\x08\x86\x44\x60"
            "\x86\x03\x1c" }  },
      /* --- pixel bitmap for cmsy210 char#61 \Im --- */
      {  61,79234,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 18,   20, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\xa2\x53\x71\x92\x51\xb2\x32\xd3\x1f\x11\xe0\x31"
            "\xd3\x21\xb1\x31\x22\x82\x31\x43\x52\x31\xc2\x40\xf1"
            "\xd2\x33\xb2\x43\x92\x62\x82\x72\x62\x93\x33\xb5\x50" }  },
      /* --- pixel bitmap for cmsy210 char#62 \top --- */
      {  62,79992,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\xfe\x92\x90\xf2\x92\x93" }  },
      /* --- pixel bitmap for cmsy210 char#63 \bot --- */
      {  63,80741,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x92\x90\xf2\x92\x9f\x1e\x06" }  },
      /* --- pixel bitmap for cmsy210 char#64 \aleph --- */
      {  64,81982,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xc2\x80\x31\x40\x18\x30\x0c\x18\x02\xce\x81\xd3"
            "\xa0\x62\x88\x30\x31\x4c\x0c\x16\x03\xc7\x80\x61\x40"
            "\x18\x30\x0c\x18\x03\xcc\x00\x1f\x80" }  },
      /* --- pixel bitmap for cmsy210 char#65 \calA --- */
      {  65,  774,                      /* character number, location */
         21, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 22,   23, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x31\x40\xf1\xe0\x22\x40\xf1\xe0\x13\x40\xe1\x12"
            "\xe0\x41\x13\x30\xf1\xd1\x32\x30\xf1\xc1\x42\x30\xb1"
            "\x52\xd2\x52\xd1\x62\xc1\x72\xca\xb1\x82\xa2\x82\x92"
            "\x92\x41\x41\xa3\x23\x21\xc2\x35\xc4\x23\xe0\x30" }  },
      /* --- pixel bitmap for cmsy210 char#66 \calB --- */
      {  66, 1580,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x56\x53\x32\x43\x52\x12\x72\xf1\x54\x82\x44\x82"
            "\x53\x92\x53\x72\x72\x62\x92\x34\x93\x54\x72\x83\x62"
            "\x93\x52\xa2\x20\xf2\x22\xb2\x20\x22\xa2\x44\x92\x44"
            "\x82\x42\x13\x52\x62\x27\x82" }  },
      /* --- pixel bitmap for cmsy210 char#67 \calC --- */
      {  67, 2301,                      /* character number, location */
         21, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x72\x42\x52\x62\x42\x72\xf1\x32\x72\x10\x22\x82"
            "\x32\x71\x30\xf2\x12\xcf\x52\xd2\xa2\x13\x82\x33\x62"
            "\x53\x42\x76\x60" }  },
      /* --- pixel bitmap for cmsy210 char#68 \calD --- */
      {  68, 3087,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x92\x32\x55\x52\x42\x83\x32\x52\x93\x12\x52\xb3"
            "\xf3\x72\xc2\x62\xd2\xf2\x62\xc2\x10\x52\xc2\x72\xb2"
            "\x82\xa2\x82\xa2\x92\x82\xb2\x53\xb9\xc2" }  },
      /* --- pixel bitmap for cmsy210 char#69 \calE --- */
      {  69, 3788,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x82\x43\x62\x62\x52\x72\xf2\x42\xa0\x43\xe3\xe5"
            "\xa2\xd2\xa0\xf1\x22\xc0\xf1\x12\xd2\xe2\xa2\x22\x92"
            "\x33\x72\x53\x43\x76\x82" }  },
      /* --- pixel bitmap for cmsy210 char#70 \calF --- */
      {  70, 4566,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 24,   21, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x82\x32\x73\x62\x32\x82\x62\x42\xe0\x12\x52\xb0"
            "\xf1\xb2\xb0\xf2\xa2\xc0\x9a\xe2\xd0\xf2\x82\xe0\xf1"
            "\x72\xe0\x10\x11\x42\xe0\x22\x42\xe0\x23\x22\xe0\x45"
            "\xe0\x42" }  },
      /* --- pixel bitmap for cmsy210 char#71 \calG --- */
      {  71, 5309,                      /* character number, location */
         21, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 17,   25, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x97\x82\x53\x52\x82\x42\x92\x32\x92\x32\x92\x42\xd0"
            "\xf1\x12\xe2\xe0\x12\xd1\x1f\x12\xb2\x2f\x12\xa3\x23"
            "\x83\x42\x74\x44\x42\x12\x66\x22\xe0\x12\x40\xf1\xa2"
            "\x50\x12\x62\x74\x32\xa5\x92" }  },
      /* --- pixel bitmap for cmsy210 char#72 \calH --- */
      {  72, 6195,                      /* character number, location */
         20, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\xa2\x32\x42\xa2\x22\x52\x92\x22\x62\x92\x12\x72"
            "\x92\xa2\x82\x20\xf1\x82\x92\x20\xf1\x82\x82\x30\x72"
            "\x92\x7e\x02\xa2\x82\x40\xf2\x62\x92\x40\xf2\x52\x92"
            "\x50\xf1\x42\xa2\x32\xe0\x25\x25" }  },
      /* --- pixel bitmap for cmsy210 char#73 \calI --- */
      {  73, 6974,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   20, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5d\x32\x62\x72\x62\x72\x72\x60\xf2\x92\x70\xf3\x82"
            "\x80\xf3\x72\x90\xf1\x62\xa0\x52\x62\x72\x72\x3d\x52" }  },
      /* --- pixel bitmap for cmsy210 char#74 \calJ --- */
      {  74, 7714,                      /* character number, location */
         20, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xda\xa3\x52\xc2\x62\xc2\x72\xb2\x72\xc2\x62\xc2\x72"
            "\xe0\x72\x60\xf2\xe2\x70\xf3\xd2\x80\xc2\xa1\xa2\x92"
            "\xa2\x9f\x12\x92\xa2\x82\xb3\x62\xd3\x42\xe0\x16\xe0"
            "\x10" }  },
      /* --- pixel bitmap for cmsy210 char#75 \calK --- */
      {  75, 8549,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x52\xa4\x43\x82\x22\x52\x62\x42\x52\x42\x61\x62\x32"
            "\xe2\x22\xe2\x22\xe0\x12\x12\xc0\xf1\x44\xd0\x32\x12"
            "\xe0\x22\x13\xc0\xf1\x32\x22\xc0\x22\x33\xd2\x42\xd2"
            "\x43\xb2\x62\xb2\x63\x62\x22\x73\x52\x12\x93\x32\x22"
            "\xa5\x40" }  },
      /* --- pixel bitmap for cmsy210 char#76 \calL --- */
      {  76, 9339,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 18,   22, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb5\xc2\x23\xa2\x42\x92\x52\x82\x62\x82\x90\xf2\x62"
            "\xa0\xf3\x52\xb0\xf2\x42\xc0\xf1\x32\xd0\x22\xc2\x17"
            "\x72\x22\x35\x32\x22\x76\x32" }  },
      /* --- pixel bitmap for cmsy210 char#77 \calM --- */
      {  77,10470,                      /* character number, location */
         21, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 32,   23, 3,155, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb2\xe0\x41\xf1\xa3\xe0\x32\xa3\xe0\x22\xb3\xe0\x13"
            "\xb4\xd4\xb1\x12\xc2\x12\xa1\x22\xc1\x22\xa1\x22\xb1"
            "\x22\xb1\x22\xa2\x22\xa1\x33\x82\x32\xa1\x42\x72\x42"
            "\xa1\x42\x71\x52\x91\x52\x61\x52\xa1\x53\x42\x52\xa1"
            "\x62\x32\x62\x91\x72\x22\x72\x91\x75\x82\x81\x93\x92"
            "\x81\x92\xa2\x32\x22\xe0\x72\x35\xe0\x84\x23\xe0\xe0" }  },
      /* --- pixel bitmap for cmsy210 char#78 \calN --- */
      {  78,11477,                      /* character number, location */
         22,-1,   -2,-1,      /* topleft row,col, and botleft row,col */
          { 30,   24, 3,145, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xc4\xa2\xd5\xa2\xc2\xd3\xc1\xe4\xa1\x60\xf1\x91"
            "\x12\xa1\x60\x91\x13\x91\xe0\x11\x22\x81\xe0\x11\x32"
            "\x81\xe0\x11\x33\x71\xe0\x11\x42\x71\xe0\x11\x43\x51"
            "\x80\xf1\x71\x62\x51\x80\x71\x63\x31\xe0\x11\x82\x31"
            "\xe0\x11\x83\x21\xe0\x11\x92\x21\xe1\xa3\x11\xe1\xb3"
            "\xa2\x21\xc3\xa5\xe0\xc3\xe0\xc5" }  },
      /* --- pixel bitmap for cmsy210 char#79 \calO --- */
      {  79,12356,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\x35\xa2\x22\x34\x62\x32\x62\x52\x32\x73\xf1\x32"
            "\x32\x92\x22\x32\xa2\x12\x41\xb2\xf1\x12\xe0\x22\x02"
            "\xe0\x32\x0f\x22\xe0\x22\x12\xe0\x12\x22\xe2\x33\xd2"
            "\x42\xc2\x53\xa2\x72\x92\x84\x52\xc7\xa0" }  },
      /* --- pixel bitmap for cmsy210 char#80 \calP --- */
      {  80,13135,                      /* character number, location */
         20, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5d\x72\x32\x64\x42\x42\x83\x22\x52\x95\x52\xb2\xf1"
            "\x72\xb2\xf1\x72\xa2\x10\x62\xa2\x82\x92\x92\x82\xa2"
            "\x53\xb2\x24\x90\xf1\x52\xe0\x10\xf2\x42\xe0\x20\xf1"
            "\x32\xe0\x30\x31\xe0\x42" }  },
      /* --- pixel bitmap for cmsy210 char#81 \calQ --- */
      {  81,14004,                      /* character number, location */
         21, 4,   -3, 4,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\xb2\x44\x72\x83\x52\xa2\x42\xb3\xf1\x22\xd2\xf1"
            "\x12\xe2\x0f\x12\xe0\x12\x0f\x12\xe2\x12\xd2\x23\xc2"
            "\x32\x71\x32\x44\x32\x32\x75\x42\xe0\x22\xe0\x12\x89"
            "\x91\x45\x82\x75\x42\xb6\x34" }  },
      /* --- pixel bitmap for cmsy210 char#82 \calR --- */
      {  82,14857,                      /* character number, location */
         20, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 25,   21, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x5e\x92\x32\x74\x62\x42\x93\x42\x52\xa2\x32\x52\xb2"
            "\xa2\xb2\x30\xf1\x72\xa2\x40\x72\x92\xb2\x92\xc2\x72"
            "\xe2\x25\xe0\x22\x42\xe0\x22\x53\xe0\x12\x62\xe0\x12"
            "\x63\xd2\x82\xd2\x83\x62\x42\x92\x52\x42\xa3\x32\x52"
            "\xb5\x41" }  },
      /* --- pixel bitmap for cmsy210 char#83 \calS --- */
      {  83,15677,                      /* character number, location */
         21, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 18,   22, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa6\xa2\x44\x72\x72\x62\x82\x52\x92\xf1\x52\xb0\x53"
            "\xe0\x23\xe0\x24\xe0\x24\xe0\x23\xe0\x23\x52\x93\x32"
            "\xb2\x2f\x12\xc2\x22\xb2\x33\xa2\x43\x82\x63\x52\x97"
            "\x83" }  },
      /* --- pixel bitmap for cmsy210 char#84 \calT --- */
      {  84,16413,                      /* character number, location */
         21, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 23,   23, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x72\x4e\x04\x32\x72\xb2\x82\xaf\x12\x82\xb0\xf1"
            "\xa2\xb0\xf3\x92\xc0\xf3\x82\xd0\xf2\x72\xe0\xf2\x62"
            "\xe0\x10\x52\xe0\x22" }  },
      /* --- pixel bitmap for cmsy210 char#85 \calU --- */
      {  85,17135,                      /* character number, location */
         20, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 21,   21, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x34\xc2\x12\x22\xc2\xf1\x52\xb2\x10\x42\xb3\x52\xb2"
            "\x62\xa3\x52\xb3\x52\xa3\x52\xb3\x52\xa4\x42\xa2\x12"
            "\x42\xa4\x52\x92\x12\x42\x92\x22\x42\x82\x32\x42\x72"
            "\x32\x52\x62\x42\x52\x52\x52\x53\x32\x62\x65\x83\x42" }  },
      /* --- pixel bitmap for cmsy210 char#86 \calV --- */
      {  86,17916,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 18,   21, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xa3\x33\x94\x33\xa2\xf1\x42\xb1\x43\xa1\xf1\x52"
            "\x91\x10\x52\x81\x72\x72\x72\x71\x82\x61\x92\x52\x92"
            "\x42\xa2\x32\xb2\x22\xc2\x12\xc2\x12\xd4\xe3\xe0\x11"
            "\xd2" }  },
      /* --- pixel bitmap for cmsy210 char#87 \calW --- */
      {  87,18963,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 29,   21, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x04\xb2\x92\x33\xa2\x93\x32\xa3\x92\x32\x91\x12\xa1"
            "\x33\x72\x12\xa1\x42\x71\x23\x91\xf1\x42\x61\x42\x81"
            "\x10\x42\x51\x52\x71\x62\x42\x52\x71\x62\x41\x63\x51"
            "\x72\x31\x82\x51\x72\x22\x82\x41\x82\x21\x92\x32\x82"
            "\x11\xa2\x31\x94\xa2\x21\x92\x11\xb2\x12\x93\xc4\xa3"
            "\xc3\xb2\xd2\xc1\xe1\xa3" }  },
      /* --- pixel bitmap for cmsy210 char#88 \calX --- */
      {  88,19868,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 21,   20, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x74\x73\x52\x22\x82\x51\x32\x82\x93\x72\xa2\x62\xb2"
            "\x42\xd2\x32\xe2\x12\xe0\x24\xe0\x32\xe0\x43\xe0\x22"
            "\x12\xe0\x12\x23\xc2\x52\xb2\x62\x92\x82\x82\x92\x82"
            "\x92\x32\x32\x93\x12\x43\x94\x51" }  },
      /* --- pixel bitmap for cmsy210 char#89 \calY --- */
      {  89,20629,                      /* character number, location */
         20, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 20,   24, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\x93\x22\x23\x84\x63\x92\x72\xa1\x73\x91\x82\x91"
            "\xf1\x82\x81\x10\x83\x71\xa2\x61\xb2\x52\xb2\x51\xc2"
            "\x41\xd2\x32\xd2\x22\xe2\x21\xe0\x12\x11\xe0\x24\xe0"
            "\x23\x81\x73\x91\x62\xb2\x33\xc7\xe4\xe0\x12" }  },
      /* --- pixel bitmap for cmsy210 char#90 \calZ --- */
      {  90,21503,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x97\x42\x72\x57\x72\xa2\x72\xa2\xe0\x52\xe0\x52\xe0"
            "\x52\xe0\x52\xe0\x52\xe0\x29\xe0\x12\x31\xe0\x12\xe0"
            "\x52\xe0\x52\xe0\x52\xe0\x52\xb2\x62\xb2\x52\xd2\x49"
            "\x62\x42\x68\x61" }  },
      /* --- pixel bitmap for cmsy210 char#91 \cup --- */
      {  91,25236,                      /* character number, location */
         18, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x02\xb2\x03\x93\x13\x73\x33\x53\x59\x85\x51" }  },
      /* --- pixel bitmap for cmsy210 char#92 \cap --- */
      {  92,25939,                      /* character number, location */
         18, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x89\x53\x53\x33\x73\x13\x93\x0f\xd2\xb2" }  },
      /* --- pixel bitmap for cmsy210 char#93 \uplus --- */
      {  93,82763,                      /* character number, location */
         18, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x02\xb2\x0f\x12\x52\x42\x0f\x12\x27\x22\x0f\x12"
            "\x52\x42\x0f\x12\xb2\x03\x93\x13\x73\x33\x53\x59\x85"
            "\x51" }  },
      /* --- pixel bitmap for cmsy210 char#94 \wedge --- */
      {  94,26625,                      /* character number, location */
         18, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x01\xe0\x00\x70\x00\x7c\x00\x36\x00\x1b\xc0\x1d"
            "\x60\x0c\x38\x0e\x0c\x06\x06\x83\x83\xc3\x80\x61\xc0"
            "\x38\xe0\x0c\x60\x07\xf0\x01\xf0\x00\x18" }  },
      /* --- pixel bitmap for cmsy210 char#95 \vee --- */
      {  95,27307,                      /* character number, location */
         18, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xe0\x01\xf0\x01\xdc\x00\xe6\x80\x63\xc0\x30\x60"
            "\x38\x38\x18\x0c\x0c\x06\x8e\x03\xc6\x00\x77\x00\x1b"
            "\x80\x0d\xc0\x07\xc0\x01\xe0\x00\x70\x00" }  },
      /* --- pixel bitmap for cmsy210 char#96 \vdash --- */
      {  96,83430,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   20, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x02\xcf\x1e\x0f\x82\xc2" }  },
      /* --- pixel bitmap for cmsy210 char#97 \dashv --- */
      {  97,84054,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   20, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xc2\x0f\x1e\xf8\xc2" }  },
      /* --- pixel bitmap for cmsy210 char#98 \lfloor --- */
      {  98,84588,                      /* character number, location */
         22, 5,   -8, 5,      /* topleft row,col, and botleft row,col */
          {  8,   30, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x6f\xc2\x6f\x18" }  },
      /* --- pixel bitmap for cmsy210 char#99 \rfloor --- */
      {  99,85143,                      /* character number, location */
         22, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          {  8,   30, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x62\xfc\x62\x0f\x18" }  },
      /* --- pixel bitmap for cmsy210 char#100 \lceil --- */
      { 100,85699,                      /* character number, location */
         22, 5,   -8, 5,      /* topleft row,col, and botleft row,col */
          {  8,   30, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x08\x0f\xe2\x6f\xc2\x62" }  },
      /* --- pixel bitmap for cmsy210 char#101 \rceil --- */
      { 101,86256,                      /* character number, location */
         22, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          {  8,   30, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x08\xfe\x62\xfc\x62" }  },
      /* --- pixel bitmap for cmsy210 char#102 \lbrace --- */
      { 102,41679,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 11,   29, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x62\x30\xfa\x52\x40\x33\x54\xa3\x50\xfa\x52\x40"
            "\x62\xb3" }  },
      /* --- pixel bitmap for cmsy210 char#103 \rbrace --- */
      { 103,42540,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 11,   29, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xa3\x50\xfa\x52\x40\x62\xb3\x62\x30\xfa\x52\x40"
            "\x33\x54\x73" }  },
      /* --- pixel bitmap for cmsy210 char#104 \langle --- */
      { 104,86784,                      /* character number, location */
         22, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  7,   30, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x30\x1c\x06\xc3\x61\x38\x0c\x86\xc3\x60\x38\x0c"
            "\x06\x07\x83\xc1\xc1\x60\x70\x30\x38\x18\x0c\x0e\x06"
            "\x03" }  },
      /* --- pixel bitmap for cmsy210 char#105 \rangle --- */
      { 105,87313,                      /* character number, location */
         22, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  7,   30, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\xc1\xc1\x60\x70\x30\x38\x18\x0c\x0e\x06\x83\x83"
            "\xc1\x70\x18\x0c\x87\xc1\x70\x18\x0e\x83\xe1\x30\x18"
            "\x00" }  },
      /* --- pixel bitmap for cmsy210 char#106 \mid --- */
      { 106,39735,                      /* character number, location */
         22, 3,   -7, 3,      /* topleft row,col, and botleft row,col */
          {  2,   29, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\xd2" }  },
      /* --- pixel bitmap for cmsy210 char#107 \parallel --- */
      { 107,87932,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          {  9,   30, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x52\x0f\xe2\x52" }  },
      /* --- pixel bitmap for cmsy210 char#108 \updownarrow --- */
      { 108,89170,                      /* character number, location */
         23, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          { 14,   31, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x60\xf1\x62\x60\x54\x96\x78\x44\x12\x14\x13\x32"
            "\x34\x52\x51\xfc\x62\x61\x52\x54\x32\x33\x14\x12\x14"
            "\x48\x76\x94\x50\xf1\x62\x60\x71\x60" }  },
      /* --- pixel bitmap for cmsy210 char#109 \Updownarrow --- */
      { 109,90283,                      /* character number, location */
         23, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          { 17,   31, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\x80\x73\xd2\x12\xb2\x32\x93\x33\x73\x53\x45"
            "\x55\x13\x12\x52\x13\xfc\x42\x52\x43\x12\x52\x13\x15"
            "\x55\x43\x53\x73\x33\x92\x32\xb2\x12\xd3\x70\xf1\x81"
            "\x82" }  },
      /* --- pixel bitmap for cmsy210 char#110 \setminus --- */
      { 110,39281,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 11,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x18\xc0\x01\x0c\x60\x00\x07\x30\x80\x01\x1c\xc0"
            "\x00\x06\x70\x00\x03\x18\xc0\x01\x0c\x60\x00\x07\x30"
            "\x80\x01\x1c\xc0\x00\x06\x70\x00\x03\x18\xc0\x01\x0c"
            "\x60" }  },
      /* --- pixel bitmap for cmsy210 char#111 \wr --- */
      { 111,90830,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          {  4,   20, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x10\xf8\x13\x0f\x83\x10\x13" }  },
      /* --- pixel bitmap for cmsy210 char#112 \surd --- */
      { 112,91696,                      /* character number, location */
          2, 2,  -28, 2,      /* topleft row,col, and botleft row,col */
          { 24,   30, 3,125, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x82\xe0\x73\xe0\x72\xe0\x73\xe0\x72\xe0\x73\xe0"
            "\x72\xe0\x73\xe0\x72\xe0\x73\xe0\x72\xe0\x73\xe0\x72"
            "\xe0\x73\xe0\x72\x92\xa3\x74\xa2\xb2\x83\xb2\x82\xd2"
            "\x63\xd2\x62\xe2\x53\xe0\x12\x42\xe0\x22\x33\xe0\x32"
            "\x22\xe0\x42\x13\xc0\xf1\x74\xd0\xf1\x82\xe3" }  },
      /* --- pixel bitmap for cmsy210 char#113 \amalg --- */
      { 113,92916,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x48\xfe\x32\xa2\x30\xf2\x32\xa2\x3e\x06" }  },
      /* --- pixel bitmap for cmsy210 char#114 \nabla --- */
      { 114,93878,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 22,   21, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x08\x1e\x06\x23\xe0\x12\x32\xe0\x11\x43\xd2\x52"
            "\xd1\x63\xc1\x72\xb1\x83\xa1\x92\x91\xa3\x81\xb2\x71"
            "\xc3\x61\x60\xf1\x72\x51\x70\xf1\x82\x31\x80\xf1\x92"
            "\x11\x90\xf1\xa2\xa3" }  },
      /* --- pixel bitmap for cmsy210 char#115 \smallint --- */
      { 115,44677,                      /* character number, location */
         21, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 11,   28, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\x82\x11\xf1\x71\x12\xf5\x62\x30\xf7\x52\x40\xf5"
            "\x42\x5f\x12\x21\x61\x21\x82\x83" }  },
      /* --- pixel bitmap for cmsy210 char#116 \sqcup --- */
      { 116,94582,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\xb2\x02\xb2\x0f\x1e\x01" }  },
      /* --- pixel bitmap for cmsy210 char#117 \sqcap --- */
      { 117,95285,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x01\x0f\xe2\xb2\x02\xb2" }  },
      /* --- pixel bitmap for cmsy210 char#118 \sqsubseteq --- */
      { 118,96060,                      /* character number, location */
         18, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 20,   24, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\x0f\xd2\xe0\x4f\x1e\x06\xf3\xe0\x6f\x1e"
            "\x06" }  },
      /* --- pixel bitmap for cmsy210 char#119 \sqsupseteq --- */
      { 119,96811,                      /* character number, location */
         18, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 20,   24, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\xfd\xe0\x42\x0f\x1e\x06\xf3\xe0\x6f\x1e"
            "\x06" }  },
      /* --- pixel bitmap for cmsy210 char#120 \S --- */
      { 120,97816,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  9,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x0c\x09\x1c\x3c\x60\x80\x00\x02\x18\xd8\x18\x1b"
            "\x3c\x78\xf0\x60\x63\x6c\x60\x00\x01\x04\x18\xf0\xe0"
            "\x40\xc2\x78\x00" }  },
      /* --- pixel bitmap for cmsy210 char#121 \dag --- */
      { 121,98646,                      /* character number, location */
         20, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 10,   27, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x42\x4f\x1a\xfe\x42\x40\xf3\x42\x41" }  },
      /* --- pixel bitmap for cmsy210 char#122 \ddag --- */
      { 122,99645,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 10,   26, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x42\x4a\xf5\x42\x40\xa0\xf4\x42\x4f\x1a\xf4\x42"
            "\x42" }  },
      /* --- pixel bitmap for cmsy210 char#123 \P --- */
      { 123,100355,                     /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 15,   26, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x3c\x26\x32\x20\xf1\x17\x32\x2f\x38\x32\x20\xf1"
            "\x17\x32\x20\x26\x32\x55\x32\x73\x32\x20\xfb\x62\x32"
            "\x20" }  },
      /* --- pixel bitmap for cmsy210 char#124 \clubsuit --- */
      { 124,101359,                     /* character number, location */
         21, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 22,   25, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x94\xe0\x28\xda\x60\xf5\x5c\x50\x6a\x8e\x04\x3e\x06"
            "\x1f\x5e\x08\x09\x12\x19\x18\x12\x18\x37\x12\x17\x63"
            "\x32\x33\x40\xf2\x94\x91" }  },
      /* --- pixel bitmap for cmsy210 char#125 \Diamond --- */
      { 125,102110,                     /* character number, location */
         21, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 20,   26, 3,95, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x90\xf1\x84\x80\x76\xe2\x22\xd3\x23\xb3\x43\xa2"
            "\x62\x93\x63\x73\x83\x53\xa3\x33\xc3\x1f\x13\xe3\x13"
            "\xc3\x33\xa3\x53\x83\x73\x63\x92\x62\xa3\x43\xb3\x23"
            "\xd2\x22\xe6\x70\xf1\x84\x80\x92\x90" }  },
      /* --- pixel bitmap for cmsy210 char#126 \Heart --- */
      { 126,102971,                     /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 20,   22, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x25\x65\x38\x28\x22\x46\x42\x13\x54\x55\x64\x62\x0f"
            "\x12\x72\x72\x0f\x12\xe0\x22\x03\xe3\x12\xe2\x23\xc3"
            "\x32\xc2\x43\xa3\x53\x83\x73\x63\x93\x43\xb3\x23\xd6"
            "\x70\xf1\x84\x80\x92\x94" }  },
      /* --- pixel bitmap for cmsy210 char#127 \spadesuit --- */
      { 127,103900,                     /* character number, location */
         21, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 20,   25, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x92\x90\x84\x80\xf1\x76\x70\x68\xba\x9c\x7e\x5e"
            "\x02\x20\xf1\x1e\x04\x1f\x5e\x06\x08\x12\x18\xf1\x17"
            "\x12\x17\x10\x24\x32\x34\x20\xf2\x84\x83" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=7 for .250gf ---
 * mf '\mode=preview; mag=magstep(-12.84858895680446863032); input cmsy10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmsy250 --- */
static	chardef  cmsy250[] =
   {
      /* --- pixel bitmap for cmsy250 char#0 - --- */
      {   0,22600,                      /* character number, location */
         10, 3,    8, 3,      /* topleft row,col, and botleft row,col */
          { 21,    2, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x07" }  },
      /* --- pixel bitmap for cmsy250 char#1 \cdot --- */
      {   1,40920,                      /* character number, location */
         11, 3,    7, 3,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x6f" }  },
      /* --- pixel bitmap for cmsy250 char#2 \times --- */
      {   2,46118,                      /* character number, location */
         17, 5,    1, 5,      /* topleft row,col, and botleft row,col */
          { 17,   16, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xd5\xb3\x13\x93\x33\x73\x53\x53\x73\x33\x93\x13"
            "\x50\xf1\x65\x60\x53\x13\x93\x33\x73\x53\x53\x73\x33"
            "\x93\x13\xb5\xd2" }  },
      /* --- pixel bitmap for cmsy250 char#3 \ast --- */
      {   3,46777,                      /* character number, location */
         16, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x08\x00\x01\x21\x74\xc4\xbd\x1e\xfe\x00\x07"
            "\xf8\xc3\xeb\x1d\x71\x21\x04\x04\x80\x00\x10\x00" }  },
      /* --- pixel bitmap for cmsy250 char#4 \div --- */
      {   4,47664,                      /* character number, location */
         19, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa3\xa0\xf2\x95\x90\xa3\xa0\xf3\xe0\x9f\x1e\x09\xf3"
            "\xe0\x90\xa3\xa0\xf2\x95\x90\xa3\xa1" }  },
      /* --- pixel bitmap for cmsy250 char#5 \diamond --- */
      {   5,41487,                      /* character number, location */
         17, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\xd4\xb6\x93\x23\x73\x43\x53\x63\x33\x83\x1f\x13"
            "\xa3\x13\x83\x33\x63\x53\x43\x73\x23\x96\xb4\xd2\x72" }  },
      /* --- pixel bitmap for cmsy250 char#6 \pm --- */
      {   6,23299,                      /* character number, location */
         23, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\xb2\xaf\x1e\x09\xf7\xb2\xaf\x1e\x09" }  },
      /* --- pixel bitmap for cmsy250 char#7 \mp --- */
      {   7,48387,                      /* character number, location */
         17, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x09\xf7\xb2\xaf\x1e\x09\xf9\xb2\xae" }  },
      /* --- pixel bitmap for cmsy250 char#8 \oplus --- */
      {   8,24070,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x31\x32\xa2\x51\x52\x71\x71\x71\x51\x81\x81"
            "\x20\xf2\x11\x91\x91\x1f\x11\xa1\xa1\x0e\x09\x0f\x21"
            "\xa1\xa1\xf2\x11\x91\x91\x10\x21\x81\x81\x51\x71\x71"
            "\x72\x51\x52\xa2\x31\x32\xe7\x8e" }  },
      /* --- pixel bitmap for cmsy250 char#9 \ominus --- */
      {   9,49159,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x72\xa2\xb2\x71\xe0\x11\x51\xe0\x31\x20\xf2"
            "\x11\xe0\x51\x1f\x11\xe0\x71\x0e\x09\x0f\x21\xe0\x71"
            "\xf2\x11\xe0\x51\x10\x21\xe0\x31\x51\xe0\x11\x72\xb2"
            "\xa2\x72\xe7\x82" }  },
      /* --- pixel bitmap for cmsy250 char#10 \otimes --- */
      {  10,24918,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x7f\x00\x60\xc0\x00\x0c\x80\x01\x01\x00\x41\x01"
            "\x40\x11\x01\x10\x09\x01\x84\x04\x01\x41\x01\x41\xc0"
            "\x00\x11\x60\x00\x07\x30\x80\x03\x18\x20\x02\x0c\x08"
            "\x02\x0a\x02\x82\x84\x00\x42\x22\x00\x22\x0a\x00\x0a"
            "\x02\x00\x02\x06\xc0\x00\x0c\x18\x00\xf8\x03\x00" }  },
      /* --- pixel bitmap for cmsy250 char#11 \oslash --- */
      {  11,49970,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x72\xa2\xb2\x71\xe0\x11\x51\xe0\x11\x11\x31"
            "\xe0\x11\x31\x21\xe1\x41\x21\xd1\x51\x11\xd1\x72\xc1"
            "\x82\xa2\x92\x91\xb2\x81\xc2\x71\xd1\x11\x51\xd1\x21"
            "\x41\xe1\x21\x31\xe0\x11\x31\x11\xe0\x11\x51\xe0\x11"
            "\x72\xb2\xa2\x72\xe7\x81" }  },
      /* --- pixel bitmap for cmsy250 char#12 \odot --- */
      {  12,50808,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x72\xa2\xb2\x71\xe0\x11\x51\xe0\x31\x20\xf2"
            "\x11\xe0\x51\x11\x93\x91\x0f\x31\x85\x81\x01\x93\x91"
            "\xf2\x11\xe0\x51\x10\x21\xe0\x31\x51\xe0\x11\x72\xb2"
            "\xa2\x72\xe7\x81" }  },
      /* --- pixel bitmap for cmsy250 char#13 \bigcirc --- */
      {  13,51741,                      /* character number, location */
         25, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 31,   33, 3,145, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc7\xe0\x8b\xe0\x44\x74\xe4\xb4\xb3\xe0\x13\x93\xe0"
            "\x33\x73\xe0\x53\x62\xe0\x72\x53\xe0\x73\x33\xe0\x93"
            "\x10\xf1\x12\xe0\xb2\x13\xe0\xb3\x0f\x62\xe0\xd2\x03"
            "\xe0\xb3\xf1\x12\xe0\xb2\x10\x13\xe0\x93\x33\xe0\x73"
            "\x52\xe0\x72\x63\xe0\x53\x73\xe0\x33\x93\xe0\x13\xb4"
            "\xb4\xe4\x74\xe0\x4b\xe0\x87\xc4" }  },
      /* --- pixel bitmap for cmsy250 char#14 \circ --- */
      {  14,52457,                      /* character number, location */
         15, 2,    2, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x69\x33\x53\x13\x73\x0f\x42\x92\x03\x73\x13\x53"
            "\x39\x65\x40" }  },
      /* --- pixel bitmap for cmsy250 char#15 \bullet --- */
      {  15,53084,                      /* character number, location */
         15, 2,    2, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x69\x3b\x1f\x6d\x1b\x39\x65\x42" }  },
      /* --- pixel bitmap for cmsy250 char#16 \asymp --- */
      {  16,53792,                      /* character number, location */
         17, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   16, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x55\xe0\x33\x14\xd4\x45\x75\x8d\xd7\x80\xf3"
            "\xe0\x90\x87\xdd\x85\x75\x44\xd4\x13\xe0\x35\xe0\x52" }  },
      /* --- pixel bitmap for cmsy250 char#17 \equiv --- */
      {  17,39381,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   18, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x09\xf5\xe0\x9f\x1e\x09\xf5\xe0\x9f\x1e\x09" }  },
      /* --- pixel bitmap for cmsy250 char#18 \subseteq --- */
      {  18,54549,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 21,   30, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8d\x6e\x01\x44\xe0\x23\xe0\x33\xe0\x33\xe0\x30\xf1"
            "\x12\xe0\x43\xe0\x4f\x32\xe0\x53\xe0\x40\xf1\x12\xe0"
            "\x40\x13\xe0\x53\xe0\x53\xe0\x54\xe0\x5e\x01\x8d\xf5"
            "\xe0\x70\xf1\x1e\x06" }  },
      /* --- pixel bitmap for cmsy250 char#19 \supseteq --- */
      {  19,55316,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 21,   30, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x8e\x01\xe0\x54\xe0\x53\xe0\x53\xe0\x53\x10\xf1"
            "\xe0\x42\x10\xe0\x43\xf3\xe0\x52\xe0\x43\xf1\xe0\x42"
            "\x10\xe0\x33\xe0\x33\xe0\x33\xe0\x24\x4e\x01\x6d\x80"
            "\xf5\xe0\x7f\x1e\x06\x12" }  },
      /* --- pixel bitmap for cmsy250 char#20 \leq --- */
      {  20,37883,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 21,   30, 3,98, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x52\xe0\x34\xe0\x14\xe0\x14\xe0\x14\xe0\x23\xe0"
            "\x24\xe0\x14\xe0\x14\xe0\x14\xe0\x1f\x14\xe0\x30\x24"
            "\xe0\x54\xe0\x54\xe0\x53\xe0\x54\xe0\x54\xe0\x54\xe0"
            "\x54\xe0\x54\xe0\x52\xf5\xe0\x7f\x1e\x07" }  },
      /* --- pixel bitmap for cmsy250 char#21 \geq --- */
      {  21,38624,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 21,   30, 3,100, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x54\xe0\x54\xe0\x54\xe0\x54\xe0\x53\xe0\x54"
            "\xe0\x54\xe0\x54\xe0\x54\x20\xf1\xe0\x34\xe0\x14\xe0"
            "\x14\xe0\x14\xe0\x23\xe0\x24\xe0\x14\xe0\x14\xe0\x14"
            "\xe0\x14\xe0\x32\xe0\x50\xf5\xe0\x7f\x1e\x07" }  },
      /* --- pixel bitmap for cmsy250 char#22 \preceq --- */
      {  22,56051,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 21,   30, 3,80, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\x52\xe0\x43\xe0\x42\xe0\x43\xe0\x33\xe0\x33"
            "\xe0\x15\xc7\x6f\x1c\x90\x87\xe0\x45\xe0\x53\xe0\x53"
            "\xe0\x53\xe0\x52\xe0\x53\xf2\xe0\x52\xf5\xe0\x7f\x1e"
            "\x07" }  },
      /* --- pixel bitmap for cmsy250 char#23 \succeq --- */
      {  23,56785,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 21,   30, 3,82, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x02\xe0\x53\xe0\x52\xe0\x53\xe0\x53\xe0\x53\xe0"
            "\x55\xe0\x47\x80\xf1\x9c\x67\xc5\xe0\x13\xe0\x33\xe0"
            "\x33\xe0\x42\xe0\x43\xe0\x4f\x22\xe0\x50\xf5\xe0\x7f"
            "\x1e\x07" }  },
      /* --- pixel bitmap for cmsy250 char#24 \sim --- */
      {  24,57497,                      /* character number, location */
         13, 2,    5, 2,      /* topleft row,col, and botleft row,col */
          { 23,    8, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\xe1\x28\xc1\x1b\xa4\x55\x84\x85\x54\xba\x11\xc8"
            "\x21\xe5\x37" }  },
      /* --- pixel bitmap for cmsy250 char#25 \approx --- */
      {  25,58265,                      /* character number, location */
         17, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   18, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\xe1\x28\xc1\x1a\xb4\x55\x84\x85\x54\xab\x11\xc8"
            "\x21\xe5\x30\xf1\xe0\x90\x35\xe1\x28\xc1\x1a\xb4\x55"
            "\x84\x85\x54\xab\x11\xc8\x21\xe5\x30" }  },
      /* --- pixel bitmap for cmsy250 char#26 \subset --- */
      {  26,33795,                      /* character number, location */
         20, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,76, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8d\x6e\x01\x44\xe0\x23\xe0\x33\xe0\x33\xe0\x30\xf1"
            "\x12\xe0\x43\xe0\x4f\x32\xe0\x53\xe0\x40\xf1\x12\xe0"
            "\x40\x13\xe0\x53\xe0\x53\xe0\x54\xe0\x5e\x01\x8d" }  },
      /* --- pixel bitmap for cmsy250 char#27 \supset --- */
      {  27,34521,                      /* character number, location */
         20, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x8e\x01\xe0\x54\xe0\x53\xe0\x53\xe0\x53\x10\xf1"
            "\xe0\x42\x10\xe0\x43\xf3\xe0\x52\xe0\x43\xf1\xe0\x42"
            "\x10\xe0\x33\xe0\x33\xe0\x33\xe0\x24\x4e\x01\x6d\x82" }  },
      /* --- pixel bitmap for cmsy250 char#28 \ll --- */
      {  28,59134,                      /* character number, location */
         21, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 31,   24, 3,140, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x33\x83\xe0\x23\x83\xe0\x14\x74\xe0\x13\x83\xe0"
            "\x14\x74\xe4\x74\xe0\x13\x83\xe0\x14\x74\xe0\x13\x83"
            "\xe0\x14\x74\xe0\x13\x83\xe0\x1f\x14\x74\xe0\x20\x23"
            "\x83\xe0\x44\x74\xe0\x43\x83\xe0\x44\x74\xe0\x43\x83"
            "\xe0\x44\x74\xe0\x44\x74\xe0\x43\x83\xe0\x44\x74\xe0"
            "\x43\x83\xe0\x43\x83" }  },
      /* --- pixel bitmap for cmsy250 char#29 \gg --- */
      {  29,60028,                      /* character number, location */
         21, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 31,   24, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x03\x83\xe0\x43\x83\xe0\x44\x74\xe0\x43\x83\xe0\x44"
            "\x74\xe0\x44\x74\xe0\x43\x83\xe0\x44\x74\xe0\x43\x83"
            "\xe0\x44\x74\xe0\x43\x83\x20\xf1\xe0\x24\x74\xe0\x13"
            "\x83\xe0\x14\x74\xe0\x13\x83\xe0\x14\x74\xe0\x13\x83"
            "\xe0\x14\x74\xe4\x74\xe0\x13\x83\xe0\x14\x74\xe0\x13"
            "\x83\xe0\x23\x83\xe0\x30" }  },
      /* --- pixel bitmap for cmsy250 char#30 \prec --- */
      {  30,60769,                      /* character number, location */
         19, 3,   -3, 3,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\x52\xe0\x43\xe0\x42\xe0\x43\xe0\x33\xe0\x33"
            "\xe0\x15\xc7\x6f\x1c\x90\x87\xe0\x45\xe0\x53\xe0\x53"
            "\xe0\x53\xe0\x52\xe0\x53\xf2\xe0\x52" }  },
      /* --- pixel bitmap for cmsy250 char#31 \succ --- */
      {  31,61457,                      /* character number, location */
         19, 3,   -3, 3,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x02\xe0\x53\xe0\x52\xe0\x53\xe0\x53\xe0\x53\xe0"
            "\x55\xe0\x47\x80\xf1\x9c\x67\xc5\xe0\x13\xe0\x33\xe0"
            "\x33\xe0\x42\xe0\x43\xe0\x4f\x22\xe0\x54" }  },
      /* --- pixel bitmap for cmsy250 char#32 \leftarrow --- */
      {  32,30602,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 31,   18, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x72\xe0\x80\xf1\x62\xe0\x90\x52\xe0\xe2\xe0\xe2"
            "\xe0\xc0\xf1\x1e\x0e\x02\x32\xe0\xe0\x22\xe0\xe0\x22"
            "\xe0\xa0\xf1\x62\xe0\x90\xf2\x72\xe0\x83" }  },
      /* --- pixel bitmap for cmsy250 char#33 \rightarrow --- */
      {  33,31656,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 31,   18, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\x82\x70\xf1\xe0\x92\x60\xe0\xa2\xe0\xe0\x22"
            "\xe0\xe0\x22\x3f\x1e\x0e\x03\xe0\xc2\xe0\xe2\xe0\xe2"
            "\x50\xf1\xe0\x92\x60\xf2\xe0\x82\x70" }  },
      /* --- pixel bitmap for cmsy250 char#34 \uparrow --- */
      {  34,29507,                      /* character number, location */
         24, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 16,   31, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x70\xf2\x72\x70\x64\xb6\x92\x12\x12\x63\x22\x23"
            "\x24\x32\x36\x52\x52\xfe\x72\x70\xf5\x72\x73" }  },
      /* --- pixel bitmap for cmsy250 char#35 \downarrow --- */
      {  35,28648,                      /* character number, location */
         24, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 16,   31, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x72\x70\xf5\x72\x72\x52\x56\x32\x34\x23\x22\x23"
            "\x62\x12\x12\x96\xb4\x60\xf2\x72\x70\x81\x73" }  },
      /* --- pixel bitmap for cmsy250 char#36 \leftrightarrow --- */
      {  36,33047,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 31,   18, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x72\xd2\x70\xf1\x62\xe0\x12\x60\x52\xe0\x32\x92"
            "\xe0\x52\x72\xe0\x72\x30\xf1\x1e\x0e\x02\x32\xe0\x72"
            "\x72\xe0\x52\x92\xe0\x32\x50\xf1\x62\xe0\x12\x60\xf2"
            "\x72\xd2\x73" }  },
      /* --- pixel bitmap for cmsy250 char#37 \nearrow --- */
      {  37,62519,                      /* character number, location */
         25, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 32,   32, 3,155, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x51\xe0\xe0\x24\x72\xe0\x7b\xe0\x98\xe0\xe4\xe0"
            "\xd5\xe0\xc3\x12\xe0\xb3\x22\xe0\xa3\x32\xe0\x93\x42"
            "\xe0\x83\x62\xe0\x63\x72\xe0\x53\x92\xe0\x33\xa1\xe0"
            "\x33\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3"
            "\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0"
            "\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe0\x12\xe0\xe0\x23" }  },
      /* --- pixel bitmap for cmsy250 char#38 \searrow --- */
      {  38,63619,                      /* character number, location */
         24, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 32,   32, 2,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x1e"
            "\x03\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x1e\x03"
            "\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x0a"
            "\x01\x13\x03\x09\x02\x13\x03\x07\x02\x15\x03\x06\x02"
            "\x16\x03\x04\x02\x18\x03\x03\x02\x19\x03\x02\x02\x1a"
            "\x03\x01\x02\x1b\x05\x1c\x04\x18\x08\x16\x0b\x13\x04"
            "\x07\x02\x14\x01\x0c" }  },
      /* --- pixel bitmap for cmsy250 char#39 \simeq --- */
      {  39,64399,                      /* character number, location */
         16, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   16, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x35\xe1\x29\xb1\x1b\x95\x57\x55\x9b\x11\xb9\x21\xe5"
            "\x30\xf6\xe0\x9f\x1e\x09" }  },
      /* --- pixel bitmap for cmsy250 char#40 \Leftarrow --- */
      {  40,65425,                      /* character number, location */
         19, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 31,   20, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xb2\xe0\x40\xa2\xe0\xe2\xe0\xe2\xe0\xee\x0a\x6e"
            "\x0b\x43\xe0\xc4\xe0\xb4\xe0\xe0\x13\xe0\xe0\x23\xe0"
            "\xe0\x13\xe0\xe0\x2e\x0a\x8e\x09\xf1\x92\xe0\x60\xa2"
            "\xe0\x50\xf1\xb2\xe0\x40" }  },
      /* --- pixel bitmap for cmsy250 char#41 \Rightarrow --- */
      {  41,66456,                      /* character number, location */
         19, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 31,   20, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x42\xb0\xe0\x52\xe0\xe0\x22\xe0\xe0\x22\x8e"
            "\x0a\x7e\x0b\xe0\xe0\x23\xe0\xe0\x14\xe0\xe0\x14\xe0"
            "\xc3\xe0\xc3\xe0\xd3\x5e\x0a\x7e\x09\x80\xf1\xe0\x62"
            "\x90\xe0\x52\xa0\xf1\xe0\x42\xb0" }  },
      /* --- pixel bitmap for cmsy250 char#42 \Uparrow --- */
      {  42,67302,                      /* character number, location */
         24, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 21,   31, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xa1\xa0\xf1\x93\x90\xf1\x82\x12\x80\x72\x32\xd2"
            "\x52\xb2\x72\x84\x74\x55\x75\x24\x12\x72\x16\x32\x72"
            "\x32\xfe\x52\x72\x50\xf2\x52\x72\x59" }  },
      /* --- pixel bitmap for cmsy250 char#43 \Downarrow --- */
      {  43,68234,                      /* character number, location */
         24, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 21,   31, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x52\x72\x50\xf2\x52\x72\x52\x32\x72\x36\x12\x72"
            "\x14\x25\x75\x54\x74\x82\x72\xb2\x52\xd2\x32\x70\xf1"
            "\x82\x12\x80\xf1\x93\x90\xf1\xa1\xa9" }  },
      /* --- pixel bitmap for cmsy250 char#44 \Leftrightarrow --- */
      {  44,69586,                      /* character number, location */
         19, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 33,   20, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x92\xb2\x90\xf1\x82\xd2\x80\x72\xe0\x12\xde\x07"
            "\xbe\x09\x83\xe0\x73\x53\xe0\x93\x23\xe0\xd3\x13\xe0"
            "\xb3\x43\xe0\x73\x73\xe0\x53\x9e\x09\xbe\x07\xd2\xe0"
            "\x12\x70\xf1\x82\xd2\x80\xf1\x92\xb2\x93" }  },
      /* --- pixel bitmap for cmsy250 char#45 \nwarrow --- */
      {  45,70676,                      /* character number, location */
         25, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 32,   32, 2,82, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x01\x14\x02\x07\x04\x13\x0b\x16\x08\x18\x04\x1c"
            "\x05\x1b\x02\x01\x03\x1a\x02\x02\x03\x19\x02\x03\x03"
            "\x18\x02\x04\x03\x16\x02\x06\x03\x15\x02\x07\x03\x13"
            "\x02\x09\x03\x13\x01\x0a\x03\x1e\x03\x1e\x03\x1e\x03"
            "\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x1e"
            "\x03\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x1e\x03\x1e\x03"
            "\x1e\x03\x1e\x02" }  },
      /* --- pixel bitmap for cmsy250 char#46 \swarrow --- */
      {  46,71776,                      /* character number, location */
         24, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          { 32,   32, 3,155, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x22\xe0\xe0\x13\xe0\xe3\xe0\xe3\xe0\xe3\xe0"
            "\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3"
            "\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0\xe3\xe0"
            "\x31\xa3\xe0\x32\x93\xe0\x52\x73\xe0\x62\x63\xe0\x82"
            "\x43\xe0\x92\x33\xe0\xa2\x23\xe0\xb2\x13\xe0\xc5\xe0"
            "\xd4\xe0\xe8\xe0\x9b\xe0\x72\x74\xe0\xe0\x21\xe0\x53" }  },
      /* --- pixel bitmap for cmsy250 char#47 \propto --- */
      {  47,72888,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   15, 3,76, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\xa4\x32\x23\x82\x51\x62\x61\x61\x82\x41\x71\x92"
            "\x21\x71\xb4\x71\xb3\x81\xc2\x81\xc3\x71\xb4\x81\xa1"
            "\x22\x71\x91\x42\x71\x71\x62\x71\x42\x83\x65\xa4" }  },
      /* --- pixel bitmap for cmsy250 char#48 \prime --- */
      {  48,73454,                      /* character number, location */
         19, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  8,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\xf0\xf0\xf0\x78\x78\x38\x3c\x1c\x1c\x1c\x0e\x0e"
            "\x06\x06\x07\x03\x02" }  },
      /* --- pixel bitmap for cmsy250 char#49 \infty --- */
      {  49,44406,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 31,   15, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\xd5\x73\x14\x92\x42\x51\x72\x71\x81\x31\x92\x51"
            "\xa1\x21\xa2\x31\xb1\x11\xc2\x11\xd1\x0f\x21\xd3\xd1"
            "\x01\xd1\x12\xc1\x11\xb1\x32\xa1\x21\xa1\x52\x91\x31"
            "\x81\x72\x71\x52\x42\x94\x13\x75\xd5\x40" }  },
      /* --- pixel bitmap for cmsy250 char#50 \in --- */
      {  50,35202,                      /* character number, location */
         20, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 17,   22, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x89\x6b\x44\xc3\xd3\xd3\xd0\xf1\x12\xe3\xe2\xe0\x1f"
            "\x1e\x03\x02\xe0\x13\xe0\xf1\x12\xe0\x13\xe0\x13\xe0"
            "\x13\xe0\x14\xe0\x1b\x89" }  },
      /* --- pixel bitmap for cmsy250 char#51 \ni --- */
      {  51,74129,                      /* character number, location */
         20, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 17,   22, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x8b\xe0\x14\xe0\x13\xe0\x13\xe0\x13\x10\xf1\xe2"
            "\x10\xe3\xe0\x12\x0f\x1e\x03\xe0\x12\xe3\xf1\xe2\x10"
            "\xd3\xd3\xd3\xc4\x4b\x69\x82" }  },
      /* --- pixel bitmap for cmsy250 char#52 \triangle --- */
      {  52,74897,                      /* character number, location */
         25, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 26,   25, 3,116, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc2\xc0\xf1\xb4\xb0\xa6\xe0\x62\x22\xe0\x53\x23\xe0"
            "\x42\x42\xe0\x33\x43\xe0\x22\x62\xe0\x13\x63\xe2\x82"
            "\xd3\x83\xc2\xa2\xb3\xa3\xa2\xc2\x93\xc3\x82\xe2\x73"
            "\xe3\x62\xe0\x22\x53\xe0\x23\x42\xe0\x42\x33\xe0\x43"
            "\x22\xe0\x62\x1f\x1e\x0c" }  },
      /* --- pixel bitmap for cmsy250 char#53 \bigtriangledown --- */
      {  53,75718,                      /* character number, location */
         17, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 26,   25, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0c\x12\xe0\x62\x23\xe0\x43\x32\xe0\x42\x43"
            "\xe0\x23\x52\xe0\x22\x63\xe3\x72\xe2\x83\xc3\x92\xc2"
            "\xa3\xa3\xb2\xa2\xc3\x83\xd2\x82\xe3\x63\xe0\x12\x62"
            "\xe0\x23\x43\xe0\x32\x42\xe0\x43\x23\xe0\x52\x22\xe0"
            "\x66\xa0\xf1\xb4\xb0\xc2\xc3" }  },
      /* --- pixel bitmap for cmsy250 char#54 \boldslash --- */
      {  54,76122,                      /* character number, location */
         25, 5,   -7, 5,      /* topleft row,col, and botleft row,col */
          { 17,   32, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x12\xe3\xe2\xe3\xe2\xe3\xe2\xe3\xe2\xe3\xe2\xe3"
            "\xe2\xe3\xe2\xe3\x70\xf1\x72\x80\x63\xe2\xe3\xe2\xe3"
            "\xe2\xe3\xe2\xe3\xe2\xe3\xe2\xe3\xe2\xe0\x10" }  },
      /* --- pixel bitmap for cmsy250 char#55 \' --- */
      {  55,76511,                      /* character number, location */
         16, 2,    2, 2,      /* topleft row,col, and botleft row,col */
          {  3,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdb\xb6\xfd\xdb\xb6\x01" }  },
      /* --- pixel bitmap for cmsy250 char#56 \forall --- */
      {  56,35850,                      /* character number, location */
         24, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 20,   25, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x22\x03\xe3\x12\xe2\x23\xc3\x10\xf1\x22"
            "\xc2\x20\x23\xa3\x20\xf1\x3e\x30\xf1\x42\x82\x40\x43"
            "\x63\x40\xf1\x52\x62\x50\x53\x43\xb2\x42\xc3\x23\x60"
            "\xf1\x72\x22\x70\x76\x70\xf1\x84\x80\xf1\x92\x91" }  },
      /* --- pixel bitmap for cmsy250 char#57 \exists --- */
      {  57,36531,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x01\xf8\xd2\x0f\x1e\x01\xf8\xd2\x0f\x1e\x01" }  },
      /* --- pixel bitmap for cmsy250 char#58 \neg --- */
      {  58,37175,                      /* character number, location */
         13, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   10, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x05\xf7\xe0\x32" }  },
      /* --- pixel bitmap for cmsy250 char#59 \emptyset --- */
      {  59,77230,                      /* character number, location */
         27, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 13,   30, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\xc0\xc0\x1f\x8c\xc3\x70\x08\x8e\xc1\x13\x5c"
            "\x82\x69\x30\x0f\xe6\xe1\x3c\x8c\x87\xf1\x38\x1e\xc3"
            "\x63\x78\x0c\xcf\xe1\x19\x3c\x83\x65\x90\x0e\xf2\x60"
            "\x1c\x84\xc3\x70\x0c\xfe\xc0\x00\x18\x00" }  },
      /* --- pixel bitmap for cmsy250 char#60 \Re --- */
      {  60,79123,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xc0\x03\x1e\xd8\x83\x18\xc3\x21\x58\xe0\x11\x3c"
            "\xe0\x08\x0c\xf0\x0c\x0e\x70\x0c\x07\x70\x8c\x03\x38"
            "\xc4\x01\x38\xe4\x00\x0c\x72\x80\x01\xf9\x3f\x88\x1c"
            "\x0e\x44\x0e\x07\x12\x87\x03\x86\xc3\x01\xc0\xe1\x00"
            "\xe0\x70\x00\x70\x38\x10\x18\x1c\x18\x0c\x0e\x08\x06"
            "\x07\x85\x81\x63\x44\x80\x0b\x1c\x80\x03" }  },
      /* --- pixel bitmap for cmsy250 char#61 \Im --- */
      {  61,80484,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   24, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\xe2\x53\xb1\x84\x81\xa4\x61\xc4\x42\xd3\x42\xe0"
            "\x15\x1f\x11\xe0\x70\x11\xe4\x41\xc2\x31\x42\x93\x41"
            "\x53\x63\x41\xf1\xe3\x50\xf1\xe0\x13\x45\xb3\x63\xb3"
            "\x63\xa3\x74\x73\xa3\x63\xb3\x34\xd7\x63" }  },
      /* --- pixel bitmap for cmsy250 char#62 \top --- */
      {  62,81232,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 24,   24, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0a\xfe\xb2\xb0\xf6\xb2\xb4" }  },
      /* --- pixel bitmap for cmsy250 char#63 \bot --- */
      {  63,81963,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 24,   24, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xb2\xb0\xf6\xb2\xbf\x1e\x0a" }  },
      /* --- pixel bitmap for cmsy250 char#64 \aleph --- */
      {  64,83212,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x10\x06\x30\x0c\xe0\x38\xc0\xe1\x00\x87\x01\x1c"
            "\x06\x78\x1c\xd0\x78\xa0\xd1\x41\x31\x87\x20\x0c\x41"
            "\x30\xc2\xe0\x82\x81\x07\x03\x0e\x06\x38\x1c\x60\x30"
            "\x80\xe1\x00\x87\x03\x1c\x07\x30\x0e\xe0\x0f\x40" }  },
      /* --- pixel bitmap for cmsy250 char#65 \calA --- */
      {  65,  774,                      /* character number, location */
         25, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 25,   27, 3,125, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x62\xe0\x83\x30\xf1\xe0\x44\x30\xe0\x35\xe0\x61"
            "\x13\xe0\x52\x13\xe0\x51\x23\xe0\x42\x23\xe0\x41\x33"
            "\xe0\x32\x33\x30\xf1\xd2\x43\x30\xc2\x53\xe0\x11\x63"
            "\xe2\x63\xd2\x73\xdc\xcd\xb2\x93\xa3\x93\xa2\xa4\x21"
            "\x52\xb4\x22\x32\xd3\x27\xdb\xe4\x24\xe0\x60" }  },
      /* --- pixel bitmap for cmsy250 char#66 \calB --- */
      {  66, 1594,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 22,   26, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x72\x65\x83\x48\x55\x22\x45\x62\x22\x64\x62\x12\x83"
            "\x55\x92\x64\xa2\x64\x92\x73\x92\x83\x73\x93\x53\xa3"
            "\x38\x83\x39\x73\x85\x62\xa5\x52\xb4\x10\xf1\x33\xc3"
            "\x10\x32\xd3\x42\xd2\x43\xd2\x42\xd2\x55\x92\x52\x15"
            "\x53\x62\x1b\x72\x46\xa7" }  },
      /* --- pixel bitmap for cmsy250 char#67 \calC --- */
      {  67, 2307,                      /* character number, location */
         25, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 19,   26, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd5\xb9\x83\x44\x72\x73\x62\x82\x62\x92\x52\x92\x52"
            "\xa2\x52\x92\x30\xf1\x22\xe0\x10\x13\xe0\x10\xf1\x12"
            "\xe0\x2f\x43\xe0\x23\xd1\x24\xb2\x24\xa2\x44\x82\x56"
            "\x52\x7a\xb6\x92" }  },
      /* --- pixel bitmap for cmsy250 char#68 \calD --- */
      {  68, 3155,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 25,   24, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\xbe\x03\x62\x43\x47\x42\x52\x85\x22\x62\x94\x13"
            "\x53\xa5\x73\xa4\xf1\x83\xb3\xf1\x82\xc3\xf1\x73\xc2"
            "\x10\x72\xc3\x82\xc2\x83\xc2\x82\xc2\x92\xb2\x93\xa2"
            "\xa2\xa2\xb2\x82\xc2\x63\xe9\xe8\xe0\x15" }  },
      /* --- pixel bitmap for cmsy250 char#69 \calE --- */
      {  69, 3896,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   26, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\xb9\x82\x54\xf1\x62\x82\x10\x52\x81\x82\xe0\x23"
            "\xc0\xf1\x44\xb0\x55\xe8\xd5\xd2\xe0\x12\xe0\x22\xe0"
            "\xf1\x22\xe0\x10\x12\xe0\x32\xc1\x33\xb2\x33\xa2\x44"
            "\x82\x56\x52\x7a\xb6\xa3" }  },
      /* --- pixel bitmap for cmsy250 char#70 \calF --- */
      {  70, 4712,                      /* character number, location */
         24, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 28,   25, 3,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xce\x02\xae\x04\x82\x43\x83\x72\x53\xb0\xf1\x62\x62"
            "\xc0\x51\x73\xe0\xb3\xc0\xf1\xd2\xd0\xc3\xe0\xb2\xe0"
            "\xcb\xe0\x2a\xe0\x42\xe0\xb3\xe0\x10\xf1\xa2\xe0\x20"
            "\xf1\x92\xe0\x30\x82\xe0\x53\x42\xe0\x45\x22\xe0\x67"
            "\xe0\x84\xe0\x82" }  },
      /* --- pixel bitmap for cmsy250 char#71 \calG --- */
      {  71, 5461,                      /* character number, location */
         25, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 19,   29, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb7\xaa\x72\x64\x62\x83\x52\x92\x52\xa2\x42\xa2\x42"
            "\xa2\x52\xe0\x23\xe0\x10\xf1\x12\xe0\x23\xe1\x13\xc3"
            "\x1f\x13\xc2\x23\xb3\x24\x94\x24\x93\x44\x74\x45\x42"
            "\x12\x69\x22\x76\x33\xe0\x22\x50\xf1\xb2\x60\x14\x52"
            "\x7a\xb6\xb0" }  },
      /* --- pixel bitmap for cmsy250 char#72 \calH --- */
      {  72, 6385,                      /* character number, location */
         24, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 26,   26, 3,121, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x75\xd1\x58\xa2\x42\x44\xa2\x32\x63\x93\x10\xf1\x12"
            "\x73\x92\x21\x92\x93\xc2\x92\xc3\x92\xc3\x83\x30\xf1"
            "\x92\x92\x40\x6e\x02\x8e\x04\xc2\x92\xc3\x92\x50\xf1"
            "\x72\x93\x50\x63\x92\xc2\xa2\xc2\x93\xb3\x93\xb2\xa3"
            "\x42\x52\xa3\x32\x52\xb7\xe0\x55\x44" }  },
      /* --- pixel bitmap for cmsy250 char#73 \calI --- */
      {  73, 7154,                      /* character number, location */
         24,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\x01\x6e\x02\x52\x82\xa2\x82\xa2\x92\xa1\x92\xe0"
            "\x72\x90\xf1\xb3\x90\xf1\xb2\xa0\xf1\xa3\xa0\xf1\xa2"
            "\xb0\x93\xb0\xf1\x92\xc0\x83\xe0\x62\x91\x30\xf1\x72"
            "\x82\x40\x2e\x01\x6e\x01\x82" }  },
      /* --- pixel bitmap for cmsy250 char#74 \calJ --- */
      {  74, 7906,                      /* character number, location */
         24, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 27,   28, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x2b\xec\xd2\x72\xe0\x12\x72\xe0\x12\x72\xe0\x12"
            "\x82\x60\xf1\x82\x82\x70\x71\x92\xe0\xb2\xe0\xa3\x80"
            "\xf1\xe0\x22\x90\xf1\xe0\x13\x90\xf1\xe0\x12\xa0\xf1"
            "\xe3\xa0\xe2\xc2\xb2\xbf\x13\xa2\xc3\x92\xd4\x72\xe5"
            "\x52\xe0\x29\xe0\x56\xe0\x50" }  },
      /* --- pixel bitmap for cmsy250 char#75 \calK --- */
      {  75, 8749,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 24,   26, 3,127, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x72\xb4\x63\x92\x22\x45\x72\x42\x63\x52\x62\x63\x32"
            "\xe0\x22\x32\xe0\x32\x22\xe0\x33\x12\xe0\x45\xe0\xf2"
            "\x54\xe0\x10\x45\xe0\x56\xe0\xf1\x42\x22\xe0\x33\x23"
            "\xe0\x22\x42\xe0\x22\x43\xe3\x52\xe2\x63\xd2\x72\x92"
            "\x13\x73\x72\x22\x93\x62\x22\xa3\x32\x32\xc5\x50" }  },
      /* --- pixel bitmap for cmsy250 char#76 \calL --- */
      {  76, 9549,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 22,   26, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x15\xe0\x17\xd2\x44\xb3\x44\xb2\x63\xa2\x72\xa3"
            "\x71\xb2\xc0\xf1\x73\xc0\x72\xd0\xf1\x63\xd0\x62\xe0"
            "\xf2\x53\xe0\x52\xe0\x10\xf1\x43\xe0\x10\x42\xe0\x11"
            "\x32\xe3\x28\x92\x3c\x42\x32\x4c\x32\x96\x52" }  },
      /* --- pixel bitmap for cmsy250 char#77 \calM --- */
      {  77,10692,                      /* character number, location */
         25, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 37,   27, 3,191, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd2\xe0\x71\xc3\xe0\x71\xc3\xe0\x62\xc3\xe0\x53\xc4"
            "\xe0\x34\xb5\xe0\x25\xb1\x13\xe0\x15\xc1\x13\xe0\x12"
            "\x12\xc1\x13\xe2\x13\xc1\x14\xc2\x23\xb1\x24\xb3\x23"
            "\xb1\x33\xa3\x33\xb1\x33\x93\x43\xa1\x44\x73\x53\xa1"
            "\x44\x63\x62\xb1\x53\x62\x72\xa1\x63\x52\x73\xa1\x64"
            "\x32\x83\x92\x64\x23\x83\x91\x87\x93\x91\x86\xa3\x81"
            "\xa4\xb3\x72\xa3\xc3\x22\x32\xb1\xd3\x26\xe0\xca\xe0"
            "\xd4\x24\xe0\xe0\x40" }  },
      /* --- pixel bitmap for cmsy250 char#78 \calN --- */
      {  78,11725,                      /* character number, location */
         27, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          { 34,   29, 3,171, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x24\xe0\xe6\xc1\xe7\xa4\xd3\xe4\xd1\x60\xf1"
            "\xa4\xc1\x70\xa5\xb1\xe0\x35\xa1\xe0\x41\x13\xa1\x80"
            "\xf1\x91\x24\x91\x80\x91\x33\x81\xe0\x41\x34\x71\xe0"
            "\x31\x44\x71\xe0\x31\x53\x71\x90\xf1\x81\x54\x51\xa0"
            "\x71\x73\x51\xe0\x31\x74\x41\xe0\x31\x74\x31\xb0\xf1"
            "\x61\x94\x21\xb0\x52\xa4\x11\xe0\x21\xb5\xc2\x22\xc4"
            "\xc5\xd4\xc5\xe2\xe3\xe0\xe0\x21" }  },
      /* --- pixel bitmap for cmsy250 char#79 \calO --- */
      {  79,12624,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,   26, 3,129, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xa1\x56\xb2\x49\x92\x42\x45\x72\x32\x74\x62\x42\x84"
            "\x42\x42\x94\xf1\x32\x42\xb3\x22\x42\xc3\x22\x41\xd3"
            "\x13\xe0\x43\x12\xe0\x53\x12\xe0\x52\x13\xe0\x52\x13"
            "\xe0\x43\x1f\x13\xe0\x42\x23\xe0\x32\x3f\x14\xe0\x12"
            "\x40\x13\xe2\x64\xc2\x75\x92\xa6\x53\xcb\xe0\x26\xe1" }  },
      /* --- pixel bitmap for cmsy250 char#80 \calP --- */
      {  80,13471,                      /* character number, location */
         24, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 24,   26, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x7d\x9e\x03\x52\x42\x66\x32\x52\x85\x12\x53\x97\x53"
            "\xa4\x73\xa3\x83\xa3\x83\xa2\x92\xb2\x92\xa2\x93\x92"
            "\xa3\x82\xb2\x82\xc2\x63\xc3\x25\xe2\x23\xe0\x32\xe0"
            "\x73\xe0\x20\xf1\x52\xe0\x30\x43\xe0\x30\xf1\x42\xe0"
            "\x40\x33\xe0\x71\xe0\x65" }  },
      /* --- pixel bitmap for cmsy250 char#81 \calQ --- */
      {  81,14354,                      /* character number, location */
         25, 4,   -4, 4,      /* topleft row,col, and botleft row,col */
          { 23,   29, 3,123, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc6\xea\xb3\x55\x92\x85\x72\xa4\x62\xc4\x42\xd4\x10"
            "\xf1\x22\xe0\x13\x10\x13\xe0\x13\x10\xf1\x12\xe0\x23"
            "\x1f\x13\xe0\x22\x23\xe0\x13\x23\xe0\x12\x34\xe2\x35"
            "\xc2\x55\x52\x32\x7a\x42\x86\x62\xe0\x62\xe0\x52\xe0"
            "\x52\xd8\xb2\x1a\x92\x5a\x52\xac\xe7\x5b" }  },
      /* --- pixel bitmap for cmsy250 char#82 \calR --- */
      {  82,15245,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 28,   25, 3,127, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x7e\xce\x04\x82\x42\x76\x62\x52\x94\x52\x53\xa3\x43"
            "\x53\xa3\x41\x73\xa2\xd3\xa2\xd3\x92\xe2\xa2\xe2\x92"
            "\xe3\x72\xe0\x23\x34\xe0\x42\x25\xe0\x52\x44\xe0\x33"
            "\x44\xb0\xf1\x62\x64\xa0\x53\x74\xe2\x84\x81\x52\x93"
            "\x62\x53\x94\x52\x52\xa5\x32\x62\xb7\x72\xd4\x66" }  },
      /* --- pixel bitmap for cmsy250 char#83 \calS --- */
      {  83,16057,                      /* character number, location */
         25, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 22,   26, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd7\xda\xa2\x65\x82\x84\x72\xa3\x72\xa2\x73\xa1\x83"
            "\xe0\x54\xe0\x45\xe0\x46\xe0\x37\xe0\x37\xe0\x36\xe0"
            "\x45\xe0\x45\x61\xb4\x42\xd3\x32\xe3\x2f\x13\xe2\x34"
            "\xc2\x45\xa2\x66\x62\x9b\xd7\xb4" }  },
      /* --- pixel bitmap for cmsy250 char#84 \calT --- */
      {  84,16777,                      /* character number, location */
         25, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 28,   27, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xc2\x7e\x06\x6e\x06\x62\x83\xe2\x93\xd3\x92\xe3"
            "\x83\xd2\xa3\xe0\xb3\xe0\xb2\xe0\xf2\xb3\xe0\xb2\xe0"
            "\x10\xf2\xa3\xe0\x10\xa2\xe0\x20\xf2\x93\xe0\x20\x92"
            "\xe0\x30\xf1\x83\xe0\x30\x82\xe0\xb3\xe0\xb2\xe0\x53" }  },
      /* --- pixel bitmap for cmsy250 char#85 \calU --- */
      {  85,17535,                      /* character number, location */
         24,-1,   -1,-1,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,125, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x54\xe2\x36\xd2\x31\x33\xd2\x73\xc3\x10\xf1\x62\xd2"
            "\x20\x52\xd3\x72\xd2\x73\xc3\x72\xc4\x72\xc3\x40\xf1"
            "\x32\xc4\x40\x22\xc5\x62\xb2\x12\x63\xa2\x22\x62\xb2"
            "\x13\x62\xa2\x23\x53\x92\x32\x63\x82\x42\x63\x72\x43"
            "\x63\x62\x53\x64\x42\x63\x68\x85\x55\xa3\x64" }  },
      /* --- pixel bitmap for cmsy250 char#86 \calV --- */
      {  86,18308,                      /* character number, location */
         24, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 22,   25, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x14\xd2\x26\xb4\x35\xa5\x34\xc3\x44\xc2\x44\xd1\x53"
            "\xd1\xf1\x54\xb1\x10\x63\xa2\x10\xf1\x63\x92\x20\x63"
            "\x82\x93\x72\xa3\x63\xa3\x53\xb3\x43\xc3\x33\xd3\x23"
            "\xe2\x23\xe0\x16\xe0\x16\xe0\x25\xe0\x33\xe0\x52\xe0"
            "\x13" }  },
      /* --- pixel bitmap for cmsy250 char#87 \calW --- */
      {  87,19341,                      /* character number, location */
         24, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 35,   25, 3,175, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x13\xe0\x12\xa3\x16\xc3\xa4\x15\xc3\xa4\x34\xa5\xb2"
            "\x34\x96\xc1\x44\x82\x13\xc1\x44\x72\x24\xb1\x53\x71"
            "\x34\xa1\x63\x62\x43\xa1\x63\x61\x53\x92\x63\x52\x54"
            "\x81\x73\x42\x64\x72\x73\x42\x73\x71\x83\x32\x83\x62"
            "\x83\x22\x93\x52\x93\x22\x94\x33\x93\x12\xa4\x32\xa5"
            "\xc3\x22\xb5\xc3\x12\xc4\xd6\xb4\xe5\xc3\xe0\x14\xd3"
            "\xe0\x13\xe2\xe0\x22\xe0\x11\xe0\x32\xb6" }  },
      /* --- pixel bitmap for cmsy250 char#88 \calX --- */
      {  88,20238,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x95\x93\x77\x84\x72\x23\x93\x61\x44\x82\xc4\x82\xd3"
            "\x72\xe3\x62\xe0\x13\x42\xe0\x33\x32\xe0\x43\x12\xe0"
            "\x64\xe0\x83\xe0\x85\xe0\x66\xe0\x42\x33\xe0\x22\x53"
            "\xe0\x12\x63\xd2\x83\xc2\x93\xb2\xa3\xb2\xa4\x41\x43"
            "\xa4\x22\x54\xa6\x63\xb4\x84" }  },
      /* --- pixel bitmap for cmsy250 char#89 \calY --- */
      {  89,21013,                      /* character number, location */
         24, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 25,   28, 3,127, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x54\xc2\x57\xa4\x32\x25\xb3\x75\xb2\x84\xc1\xf1\x94"
            "\xb1\xf1\xa3\xa1\x10\xf1\xa4\x81\x20\xb3\x72\xd3\x71"
            "\xe3\x61\xe0\x13\x52\xe0\x13\x51\xe0\x23\x41\xe0\x33"
            "\x32\xe0\x33\x22\xe0\x43\x12\xe0\x55\xe0\x64\xe0\x73"
            "\xc1\x83\xc2\x73\xe3\x33\xe0\x28\xe0\x54\xe0\x42" }  },
      /* --- pixel bitmap for cmsy250 char#90 \calZ --- */
      {  90,21901,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc7\x52\xae\x01\x92\x68\x92\xc2\x93\xb2\xa1\xc2\xe0"
            "\x92\xe0\x92\xe0\x92\xe0\x92\xe0\x4a\xe0\x62\x23\xe0"
            "\x42\xe0\x92\xe0\x92\xe0\x92\xe0\x92\xe0\x92\xd1\x92"
            "\xc3\x82\xd3\x72\xe2\x7a\x62\x6e\x05\x62\x88\x80" }  },
      /* --- pixel bitmap for cmsy250 char#91 \cup --- */
      {  91,25678,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\xe0\x12\x02\xe0\x15\xe2\x12\xd3\x13\xb3\x34"
            "\x74\x6b\xa7\x61" }  },
      /* --- pixel bitmap for cmsy250 char#92 \cap --- */
      {  92,26393,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xab\x64\x74\x33\xb3\x13\xd2\x12\xe3\x0f\xe2\xe0"
            "\x12\x02\xe0\x12" }  },
      /* --- pixel bitmap for cmsy250 char#93 \uplus --- */
      {  93,84013,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x02\xe0\x12\x0f\x32\x72\x62\x0f\x12\x2b\x22\x0f"
            "\x42\x72\x62\x03\xe2\x12\xd3\x13\xb3\x34\x74\x6b\xa7"
            "\x61" }  },
      /* --- pixel bitmap for cmsy250 char#94 \wedge --- */
      {  94,27091,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,84, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x83\x80\x75\xe2\x12\xd3\x13\x60\xf1\x62\x32\x60"
            "\x53\x33\xa2\x52\x93\x53\x82\x72\x73\x73\x30\xf1\x32"
            "\x92\x30\x23\x93\x42\xb2\x33\xb3\x22\xd2\x13\xd3\x0f"
            "\x12\xe0\x12" }  },
      /* --- pixel bitmap for cmsy250 char#95 \vee --- */
      {  95,27785,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x12\x03\xd3\x12\xd2\x23\xb3\x32\xb2\x43"
            "\x93\x20\xf1\x32\x92\x30\x33\x73\x72\x72\x83\x53\x92"
            "\x52\xa3\x33\x50\xf1\x62\x32\x60\x63\x13\xd2\x12\xe5"
            "\x70\xf2\x83\x81" }  },
      /* --- pixel bitmap for cmsy250 char#96 \vdash --- */
      {  96,84702,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x02\xe0\x1f\x1e\x03\x0f\xa2\xe0\x12" }  },
      /* --- pixel bitmap for cmsy250 char#97 \dashv --- */
      {  97,85334,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\xe0\x12\x0f\x1e\x03\xfa\xe0\x12" }  },
      /* --- pixel bitmap for cmsy250 char#98 \lfloor --- */
      {  98,85876,                      /* character number, location */
         26, 6,   -8, 6,      /* topleft row,col, and botleft row,col */
          {  9,   34, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x7f\xe2\x7f\x12\x7f\x19" }  },
      /* --- pixel bitmap for cmsy250 char#99 \rfloor --- */
      {  99,86439,                      /* character number, location */
         26, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          {  9,   34, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x72\xfe\x72\xf1\x72\x0f\x19" }  },
      /* --- pixel bitmap for cmsy250 char#100 \lceil --- */
      { 100,87003,                      /* character number, location */
         26, 6,   -8, 6,      /* topleft row,col, and botleft row,col */
          {  9,   34, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x09\x0f\xe2\x7f\xe2\x7f\x12\x72" }  },
      /* --- pixel bitmap for cmsy250 char#101 \rceil --- */
      { 101,87568,                      /* character number, location */
         26, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          {  9,   34, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x09\xfe\x72\xfe\x72\xf1\x72" }  },
      /* --- pixel bitmap for cmsy250 char#102 \lbrace --- */
      { 102,42341,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 13,   35, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa3\x82\xa2\x40\xfb\x62\x50\x52\x93\x74\xc3\xc2\x60"
            "\xfb\x62\x50\x72\xc2\xd3" }  },
      /* --- pixel bitmap for cmsy250 char#103 \rbrace --- */
      { 103,43214,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 13,   35, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xc3\xc2\x60\xfb\x62\x50\x72\xc2\xd3\x82\xa2\x40"
            "\xfb\x62\x50\x52\x93\x74\x93" }  },
      /* --- pixel bitmap for cmsy250 char#104 \langle --- */
      { 104,88104,                      /* character number, location */
         26, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          {  8,   34, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\xc0\xe0\x60\x60\x70\x30\x38\x18\x18\x1c\x0c\x0e"
            "\x06\x06\x07\x03\x03\x07\x06\x06\x0e\x0c\x1c\x18\x18"
            "\x38\x30\x70\x60\x60\xe0\xc0\xc0" }  },
      /* --- pixel bitmap for cmsy250 char#105 \rangle --- */
      { 105,88641,                      /* character number, location */
         26, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  8,   34, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x03\x07\x06\x06\x0e\x0c\x1c\x18\x18\x38\x30\x70"
            "\x60\x60\xe0\xc0\xc0\xe0\x60\x60\x70\x30\x38\x18\x18"
            "\x1c\x0c\x0e\x06\x06\x07\x03\x03" }  },
      /* --- pixel bitmap for cmsy250 char#106 \mid --- */
      { 106,40375,                      /* character number, location */
         26, 4,   -9, 4,      /* topleft row,col, and botleft row,col */
          {  2,   35, 2, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x22\x00\x02" }  },
      /* --- pixel bitmap for cmsy250 char#107 \parallel --- */
      { 107,89268,                      /* character number, location */
         26, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 11,   34, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x21\x00\x02\x07\x02" }  },
      /* --- pixel bitmap for cmsy250 char#108 \updownarrow --- */
      { 108,90522,                      /* character number, location */
         27, 1,  -10, 1,      /* topleft row,col, and botleft row,col */
          { 16,   37, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x70\xf2\x72\x70\x64\xb6\x92\x12\x12\x63\x22\x23"
            "\x24\x32\x36\x52\x52\xfe\x72\x70\xf1\x72\x72\x52\x56"
            "\x32\x34\x23\x22\x23\x62\x12\x12\x96\xb4\x60\xf2\x72"
            "\x70\x81\x73" }  },
      /* --- pixel bitmap for cmsy250 char#109 \Updownarrow --- */
      { 109,91655,                      /* character number, location */
         27, 0,  -10, 0,      /* topleft row,col, and botleft row,col */
          { 21,   37, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xa1\xa0\x93\xe0\x32\x12\xe0\x13\x13\xe2\x32\xc3"
            "\x53\x93\x73\x65\x75\x24\x12\x72\x16\x32\x72\x32\xfe"
            "\x52\x72\x52\x32\x72\x36\x12\x72\x14\x25\x75\x63\x73"
            "\x93\x53\xc2\x32\xe3\x13\xe0\x12\x12\xe0\x33\x90\xf1"
            "\xa1\xa5" }  },
      /* --- pixel bitmap for cmsy250 char#110 \setminus --- */
      { 110,39909,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 13,   35, 3,110, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xb3\xa0\xf1\x12\xa0\x13\x90\xf1\x22\x90\x23"
            "\x80\xf1\x32\x80\x33\x70\xf1\x42\x70\x43\x60\xf1\x52"
            "\x60\x53\x50\xf1\x62\x50\x63\x40\xf1\x72\x40\x73\x30"
            "\xf1\x82\x30\x83\x20\xf1\x92\x20\x93\x10\xf1\xa2\x10"
            "\xa3\xf1\xb2" }  },
      /* --- pixel bitmap for cmsy250 char#111 \wr --- */
      { 111,92234,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          {  6,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xc7\xe1\x38\x8e\xe3\x38\xc7\x39\xce\x71\x1c\xc7"
            "\x71\x38\x0e\x0f" }  },
      /* --- pixel bitmap for cmsy250 char#112 \surd --- */
      { 112,93104,                      /* character number, location */
          2, 2,  -33, 2,      /* topleft row,col, and botleft row,col */
          { 29,   35, 3,161, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xd2\xe0\xc3\xe0\xc2\xe0\xc3\xe0\xc2\xe0\xc3\xe0"
            "\xc2\xe0\xc3\xe0\xc2\xe0\xc3\xe0\xc2\xe0\xc3\xe0\xc2"
            "\xe0\xc3\xe0\xc2\xe0\xc3\xe0\xc2\xb1\xe3\x93\xe2\x91"
            "\x22\xc3\xc2\xc2\xe2\xa3\xe2\xa2\xe0\x22\x83\xe0\x22"
            "\x82\xe0\x42\x63\xe0\x42\x62\xe0\x62\x43\xe0\x62\x42"
            "\xe0\x82\x23\xe0\x82\x22\xe0\xa5\xe0\xa4\xe0\xc3\xe0"
            "\xc2\xe0\x33" }  },
      /* --- pixel bitmap for cmsy250 char#113 \amalg --- */
      { 113,94342,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x4b\xfe\x43\xc3\x40\xf6\x43\xc3\x4e\x0c" }  },
      /* --- pixel bitmap for cmsy250 char#114 \nabla --- */
      { 114,95320,                      /* character number, location */
         24, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0b\x1e\x09\x24\xe0\x41\x33\xe0\x31\x44\xe0"
            "\x21\x53\xe0\x11\x64\xe1\x73\xd1\x84\xc1\x93\xb1\xa4"
            "\xa1\xb3\x91\xc4\x81\xd3\x71\xe4\x61\xe0\x13\x51\xe0"
            "\x24\x41\xe0\x33\x31\xe0\x44\x21\xe0\x53\x11\xe0\x65"
            "\xa0\xf1\xb3\xb0\xc1\xc2" }  },
      /* --- pixel bitmap for cmsy250 char#115 \smallint --- */
      { 115,45379,                      /* character number, location */
         25, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 14,   33, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa3\xa1\x31\xf1\x82\x22\xf2\x81\x50\xf4\x72\x50\x71"
            "\x60\xf6\x62\x60\x61\x70\xf4\x52\x70\xf2\x51\x8f\x12"
            "\x22\x81\x31\xa3\xa1" }  },
      /* --- pixel bitmap for cmsy250 char#116 \sqcup --- */
      { 116,96034,                      /* character number, location */
         21, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   21, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x12\x00\x02\x0f\x02\x00\xff\x01\x13" }  },
      /* --- pixel bitmap for cmsy250 char#117 \sqcap --- */
      { 117,96749,                      /* character number, location */
         21, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   21, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x13\x00\xff\x12\x02\x0f\x02" }  },
      /* --- pixel bitmap for cmsy250 char#118 \sqsubseteq --- */
      { 118,97536,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 22,   30, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x08\x0f\xe2\xe0\x6f\x22\xe0\x6f\x1e\x08\xf5"
            "\xe0\x8f\x1e\x08" }  },
      /* --- pixel bitmap for cmsy250 char#119 \sqsupseteq --- */
      { 119,98295,                      /* character number, location */
         22, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 22,   30, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x08\xfe\xe0\x62\xf2\xe0\x62\x0f\x1e\x08\xf5"
            "\xe0\x8f\x1e\x08" }  },
      /* --- pixel bitmap for cmsy250 char#120 \S --- */
      { 120,99308,                      /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 11,   31, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x60\x8c\x81\x06\x34\xb0\x01\x0c\xc0\x00\x04\x40"
            "\x00\x1e\x18\x61\x90\x81\x0d\x78\xc0\x03\x36\x30\xc1"
            "\x10\x03\x0f\x40\x00\x04\x60\x00\x06\xb0\x81\x05\x2c"
            "\x30\xc6\xc0\x03" }  },
      /* --- pixel bitmap for cmsy250 char#121 \dag --- */
      { 121,100154,                     /* character number, location */
         24, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 12,   32, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x52\x5f\x1c\xfe\x52\x50\xf6\x52\x5f" }  },
      /* --- pixel bitmap for cmsy250 char#122 \ddag --- */
      { 122,101163,                     /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 12,   31, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x52\x5c\xf6\x52\x50\xc0\xf6\x52\x5c\xf6\x52\x52" }  },
      /* --- pixel bitmap for cmsy250 char#123 \P --- */
      { 123,101883,                     /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 18,   31, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5d\x3e\x01\x28\x32\x30\xf1\x19\x32\x3f\x5a\x32\x30"
            "\xf1\x19\x32\x30\x28\x32\x67\x32\x76\x32\xa3\x32\x30"
            "\xfd\x82\x32\x31" }  },
      /* --- pixel bitmap for cmsy250 char#124 \clubsuit --- */
      { 124,102881,                     /* character number, location */
         25, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 26,   29, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb4\xe0\x68\xe0\x3a\x80\xf1\x7c\x70\xf3\x6e\x60\xf1"
            "\x7c\x70\x8a\xc2\x38\x32\x6e\x08\x20\xf1\x1e\x0a\x1f"
            "\x5e\x0c\xf1\x19\x22\x29\x10\x28\x22\x28\x64\x42\x44"
            "\x40\xf2\xb4\xb1" }  },
      /* --- pixel bitmap for cmsy250 char#125 \Diamond --- */
      { 125,103618,                     /* character number, location */
         25, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 24,   30, 3,129, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb2\xb0\xf1\xa4\xa0\x96\xe0\x42\x22\xe0\x33\x23\xe0"
            "\x13\x43\xd3\x63\xc2\x82\xb3\x83\x93\xa3\x73\xc3\x53"
            "\xe3\x33\xe0\x23\x1f\x13\xe0\x43\x13\xe0\x23\x33\xe3"
            "\x53\xc3\x73\xa3\x93\x83\xb2\x82\xc3\x63\xd3\x43\xe0"
            "\x13\x23\xe0\x32\x22\xe0\x46\x90\xf1\xa4\xa0\xb2\xb2" }  },
      /* --- pixel bitmap for cmsy250 char#126 \Heart --- */
      { 126,104469,                     /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 24,   26, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x44\x84\x68\x48\x33\x43\x23\x43\x22\x66\x62\x13\x74"
            "\x75\x84\x82\x0f\x12\x92\x92\x0f\x22\xe0\x62\x03\xe0"
            "\x43\x12\xe0\x42\x23\xe0\x23\x33\xe3\x52\xe2\x63\xc3"
            "\x73\xa3\x94\x64\xc3\x43\xe0\x13\x23\xe0\x32\x22\xe0"
            "\x46\xe0\x54\xa0\xf1\xb2\xb6" }  },
      /* --- pixel bitmap for cmsy250 char#127 \spadesuit --- */
      { 127,105392,                     /* character number, location */
         25, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 24,   29, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xb2\xb0\xf1\xa4\xa0\x96\x90\xf1\x88\x80\x7a\xce"
            "\x9e\x02\x7e\x04\x30\xf1\x2e\x06\x20\xf1\x1e\x08\x1f"
            "\x6e\x0a\x09\x22\x29\xf1\x18\x22\x28\x10\x25\x42\x45"
            "\x20\xf2\xa4\xa4" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* ------------------------------------------------------------------------
font sizes 0-7 for cmex10
------------------------------------------------------------------------ */

/* --- size=0 for .83gf ---
 * mf '\mode=eighthre;  input cmex10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmex83 --- */
static	chardef  cmex83[] =
   {
      /* --- pixel bitmap for cmex83 char#0 \big( --- */
      {   0,   35,                      /* character number, location */
          0, 2,  -12, 2,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x55\xa5" }  },
      /* --- pixel bitmap for cmex83 char#1 \big) --- */
      {   1,  457,                      /* character number, location */
          0, 0,  -12, 0,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\xaa\x5a" }  },
      /* --- pixel bitmap for cmex83 char#2 \big[ --- */
      {   2,  879,                      /* character number, location */
          0, 2,  -12, 2,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x57\x55\xd5" }  },
      /* --- pixel bitmap for cmex83 char#3 \big] --- */
      {   3, 1316,                      /* character number, location */
          0, 0,  -12, 0,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xab\xaa\xea" }  },
      /* --- pixel bitmap for cmex83 char#4 (noname) --- */
      {   4, 1753,                      /* character number, location */
          0, 2,  -12, 2,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x55\xd5" }  },
      /* --- pixel bitmap for cmex83 char#5 (noname) --- */
      {   5, 2037,                      /* character number, location */
          0, 0,  -12, 0,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xaa\xea" }  },
      /* --- pixel bitmap for cmex83 char#6 (noname) --- */
      {   6, 2321,                      /* character number, location */
          0, 2,  -12, 2,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x57\x55\x55" }  },
      /* --- pixel bitmap for cmex83 char#7 (noname) --- */
      {   7, 2605,                      /* character number, location */
          0, 0,  -12, 0,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xab\xaa\xaa" }  },
      /* --- pixel bitmap for cmex83 char#8 \big{ --- */
      {   8, 2889,                      /* character number, location */
          0, 0,  -12, 0,      /* topleft row,col, and botleft row,col */
          {  6,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x82\x20\x88\x61\x20\x08\x82\xc0" }  },
      /* --- pixel bitmap for cmex83 char#9 \big} --- */
      {   9, 3316,                      /* character number, location */
          0, 0,  -12, 0,      /* topleft row,col, and botleft row,col */
          {  6,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x82\x20\x08\x8e\x23\x08\x82\x1c" }  },
      /* --- pixel bitmap for cmex83 char#10 \big< --- */
      {  10, 3786,                      /* character number, location */
          0, 1,  -13, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\xa4\x24\x92\x48" }  },
      /* --- pixel bitmap for cmex83 char#11 \big> --- */
      {  11, 4074,                      /* character number, location */
          0, 0,  -13, 0,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x89\x24\x92\x92\x12" }  },
      /* --- pixel bitmap for cmex83 char#12 (noname) --- */
      {  12, 4930,                      /* character number, location */
          1, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01" }  },
      /* --- pixel bitmap for cmex83 char#13 (noname) --- */
      {  13, 4955,                      /* character number, location */
          1, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          {  3,    9, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x11" }  },
      /* --- pixel bitmap for cmex83 char#14 (noname) --- */
      {  14, 4362,                      /* character number, location */
          0, 1,  -12, 1,      /* topleft row,col, and botleft row,col */
          {  4,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x44\x44\x22\x22\x11" }  },
      /* --- pixel bitmap for cmex83 char#15 (noname) --- */
      {  15, 4646,                      /* character number, location */
          0, 1,  -12, 1,      /* topleft row,col, and botleft row,col */
          {  4,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x22\x22\x44\x44\x88" }  },
      /* --- pixel bitmap for cmex83 char#16 \Big( --- */
      {  16,   85,                      /* character number, location */
          0, 2,  -19, 2,      /* topleft row,col, and botleft row,col */
          {  4,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x24\x12\x11\x11\x11\x11\x22\x44\x08" }  },
      /* --- pixel bitmap for cmex83 char#17 \Big) --- */
      {  17,  507,                      /* character number, location */
          0, 0,  -19, 0,      /* topleft row,col, and botleft row,col */
          {  4,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x42\x84\x88\x88\x88\x88\x44\x22\x01" }  },
      /* --- pixel bitmap for cmex83 char#18 \bigg( --- */
      {  18,  149,                      /* character number, location */
          0, 3,  -26, 3,      /* topleft row,col, and botleft row,col */
          {  4,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x24\x22\x12\x11\x11\x11\x11\x11\x21\x22\x42\x84" }  },
      /* --- pixel bitmap for cmex83 char#19 \bigg) --- */
      {  19,  571,                      /* character number, location */
          0, 0,  -26, 0,      /* topleft row,col, and botleft row,col */
          {  4,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x42\x44\x84\x88\x88\x88\x88\x88\x48\x44\x24\x12" }  },
      /* --- pixel bitmap for cmex83 char#20 \bigg[ --- */
      {  20,  993,                      /* character number, location */
          0, 3,  -26, 3,      /* topleft row,col, and botleft row,col */
          {  2,   26, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x0f\xe1\x1f\x81\x12" }  },
      /* --- pixel bitmap for cmex83 char#21 \bigg] --- */
      {  21, 1430,                      /* character number, location */
          0, 0,  -26, 0,      /* topleft row,col, and botleft row,col */
          {  2,   26, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xfe\x11\xf8\x11\x02" }  },
      /* --- pixel bitmap for cmex83 char#22 (noname) --- */
      {  22, 1867,                      /* character number, location */
          0, 3,  -26, 3,      /* topleft row,col, and botleft row,col */
          {  3,   26, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x2f\x91\x23" }  },
      /* --- pixel bitmap for cmex83 char#23 (noname) --- */
      {  23, 2151,                      /* character number, location */
          0, 0,  -26, 0,      /* topleft row,col, and botleft row,col */
          {  3,   26, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x21\xf9\x21\x03" }  },
      /* --- pixel bitmap for cmex83 char#24 (noname) --- */
      {  24, 2435,                      /* character number, location */
          0, 3,  -26, 3,      /* topleft row,col, and botleft row,col */
          {  3,   26, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x0f\xe1\x2f\x91\x21" }  },
      /* --- pixel bitmap for cmex83 char#25 (noname) --- */
      {  25, 2719,                      /* character number, location */
          0, 0,  -26, 0,      /* topleft row,col, and botleft row,col */
          {  3,   26, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xfe\x21\xf9\x21" }  },
      /* --- pixel bitmap for cmex83 char#26 \bigg{ --- */
      {  26, 3003,                      /* character number, location */
          0, 1,  -26, 1,      /* topleft row,col, and botleft row,col */
          {  6,   26, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x41\x10\xf8\x31\x20\x21\x30\xf1\x11\x40\x21\x30"
            "\xf8\x31\x20\x41\x61" }  },
      /* --- pixel bitmap for cmex83 char#27 \bigg} --- */
      {  27, 3430,                      /* character number, location */
          0, 1,  -26, 1,      /* topleft row,col, and botleft row,col */
          {  6,   26, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x61\x30\xf9\x31\x20\x42\x41\x10\xf9\x31\x20\x21"
            "\x32\x41" }  },
      /* --- pixel bitmap for cmex83 char#28 \bigg< --- */
      {  28, 3902,                      /* character number, location */
          0, 2,  -27, 2,      /* topleft row,col, and botleft row,col */
          {  5,   27, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x22\x84\x08\x21\x44\x08\x11\x42\x10\x42\x10\x42"
            "\x08\x42\x08\x42" }  },
      /* --- pixel bitmap for cmex83 char#29 \bigg> --- */
      {  29, 4190,                      /* character number, location */
          0, 1,  -27, 1,      /* topleft row,col, and botleft row,col */
          {  5,   27, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x08\x21\x08\x21\x04\x21\x04\x21\x44\x08\x11\x42"
            "\x88\x10\x22\x04" }  },
      /* --- pixel bitmap for cmex83 char#30 (noname) --- */
      {  30, 4476,                      /* character number, location */
          0, 1,  -26, 1,      /* topleft row,col, and botleft row,col */
          {  9,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x02\x06\x04\x08\x18\x10\x20\x60\x40\x80\x80"
            "\x01\x01\x02\x06\x04\x08\x18\x10\x20\x60\x40\x80\x80"
            "\x01\x01\x02\x00" }  },
      /* --- pixel bitmap for cmex83 char#31 (noname) --- */
      {  31, 4760,                      /* character number, location */
          0, 1,  -26, 1,      /* topleft row,col, and botleft row,col */
          {  9,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x02\x0c\x10\x20\xc0\x00\x01\x02\x0c\x10\x20\xc0"
            "\x00\x01\x02\x0c\x10\x20\xc0\x00\x01\x02\x0c\x10\x20"
            "\xc0\x00\x01\x02" }  },
      /* --- pixel bitmap for cmex83 char#32 \Bigg( --- */
      {  32,  227,                      /* character number, location */
          0, 3,  -33, 3,      /* topleft row,col, and botleft row,col */
          {  5,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x21\x42\x84\x10\x22\x84\x10\x42\x08\x21\x84\x10"
            "\x42\x08\x42\x08\x41\x08\x42\x10" }  },
      /* --- pixel bitmap for cmex83 char#33 \Bigg) --- */
      {  33,  649,                      /* character number, location */
          0, 0,  -33, 0,      /* topleft row,col, and botleft row,col */
          {  5,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x08\x42\x10\x42\x08\x42\x08\x21\x84\x10\x42\x08"
            "\x21\x84\x08\x21\x44\x88\x10\x01" }  },
      /* --- pixel bitmap for cmex83 char#34 \Bigg[ --- */
      {  34, 1071,                      /* character number, location */
          0, 3,  -33, 3,      /* topleft row,col, and botleft row,col */
          {  3,   33, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x0f\xe1\x2f\xe1\x21\x23" }  },
      /* --- pixel bitmap for cmex83 char#35 \Bigg] --- */
      {  35, 1508,                      /* character number, location */
          0, 0,  -33, 0,      /* topleft row,col, and botleft row,col */
          {  3,   33, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xfe\x21\xfe\x21\x24" }  },
      /* --- pixel bitmap for cmex83 char#36 (noname) --- */
      {  36, 1945,                      /* character number, location */
          0, 3,  -33, 3,      /* topleft row,col, and botleft row,col */
          {  3,   33, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f\x00\x01\x02\x03" }  },
      /* --- pixel bitmap for cmex83 char#37 (noname) --- */
      {  37, 2229,                      /* character number, location */
          0, 0,  -33, 0,      /* topleft row,col, and botleft row,col */
          {  3,   33, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f\x02\x01\x00\x03" }  },
      /* --- pixel bitmap for cmex83 char#38 (noname) --- */
      {  38, 2513,                      /* character number, location */
          0, 3,  -33, 3,      /* topleft row,col, and botleft row,col */
          {  3,   33, 2, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x03\x00\xff\x1f\x01\x02" }  },
      /* --- pixel bitmap for cmex83 char#39 (noname) --- */
      {  39, 2797,                      /* character number, location */
          0, 0,  -33, 0,      /* topleft row,col, and botleft row,col */
          {  3,   33, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x03\xff\x1f\x02\x01" }  },
      /* --- pixel bitmap for cmex83 char#40 \Bigg{ --- */
      {  40, 3081,                      /* character number, location */
          0, 1,  -33, 1,      /* topleft row,col, and botleft row,col */
          {  6,   33, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x32\x41\x20\xfb\x21\x30\x11\x41\x61\x40\xfb\x21"
            "\x30\x31\x52\x61" }  },
      /* --- pixel bitmap for cmex83 char#41 \Bigg} --- */
      {  41, 3508,                      /* character number, location */
          0, 1,  -33, 1,      /* topleft row,col, and botleft row,col */
          {  6,   33, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x61\x40\xfb\x21\x30\x31\x52\x61\x32\x41\x20\xfb"
            "\x21\x30\x11\x41\x51" }  },
      /* --- pixel bitmap for cmex83 char#42 \Bigg< --- */
      {  42, 3982,                      /* character number, location */
          0, 2,  -33, 2,      /* topleft row,col, and botleft row,col */
          {  5,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x42\x84\x10\x22\x84\x08\x21\x44\x08\x21\x04\x21"
            "\x84\x20\x84\x20\x84\x10\x84\x10" }  },
      /* --- pixel bitmap for cmex83 char#43 \Bigg> --- */
      {  43, 4270,                      /* character number, location */
          0, 1,  -33, 1,      /* topleft row,col, and botleft row,col */
          {  5,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x04\x21\x84\x20\x84\x20\x84\x10\x84\x10\x42\x84"
            "\x10\x22\x84\x08\x21\x44\x08\x01" }  },
      /* --- pixel bitmap for cmex83 char#44 / --- */
      {  44, 4554,                      /* character number, location */
          0, 1,  -33, 1,      /* topleft row,col, and botleft row,col */
          { 12,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\xc0\x00\x04\x40\x00\x06\x20\x00\x02\x30\x00"
            "\x01\x10\x80\x01\x08\x80\x00\x0c\x40\x00\x04\x60\x00"
            "\x02\x20\x00\x03\x10\x00\x01\x18\x80\x00\x08\xc0\x00"
            "\x04\x40\x00\x06\x20\x00\x02\x30\x00\x01\x00" }  },
      /* --- pixel bitmap for cmex83 char#45 \ --- */
      {  45, 4838,                      /* character number, location */
          0, 1,  -33, 1,      /* topleft row,col, and botleft row,col */
          { 12,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x30\x00\x02\x20\x00\x06\x40\x00\x04\xc0\x00\x08"
            "\x80\x00\x18\x00\x01\x10\x00\x03\x20\x00\x02\x60\x00"
            "\x04\x40\x00\x0c\x80\x00\x08\x80\x01\x10\x00\x01\x30"
            "\x00\x02\x20\x00\x06\x40\x00\x04\xc0\x00\x08" }  },
      /* --- pixel bitmap for cmex83 char#46 / --- */
      {  46, 4412,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          {  6,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x43\x10\x86\x20\x08\x43\x10\x84\x21\x08\x43"
            "\x10\x00" }  },
      /* --- pixel bitmap for cmex83 char#47 \ --- */
      {  47, 4696,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          {  6,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x30\x08\x82\x41\x10\x04\x83\x20\x08\x06\x41\x30"
            "\x08\x02" }  },
      /* --- pixel bitmap for cmex83 char#48 \leftparentop --- */
      {  48,  319,                      /* character number, location */
         -1, 4,  -21, 4,      /* topleft row,col, and botleft row,col */
          {  5,   20, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\xf1\x31\x10\xf2\x21\x20\xf3\x11\x3f\x91\x40" }  },
      /* --- pixel bitmap for cmex83 char#49 \rightparentop --- */
      {  49,  741,                      /* character number, location */
         -1, 0,  -21, 0,      /* topleft row,col, and botleft row,col */
          {  5,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x08\x42\x08\x42\x08\x41\x08\x21\x84\x10\x42\x08" }  },
      /* --- pixel bitmap for cmex83 char#50 (noname) --- */
      {  50, 1163,                      /* character number, location */
         -1, 4,  -20, 4,      /* topleft row,col, and botleft row,col */
          {  3,   19, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x0f\xe1\x2f\x21\x21" }  },
      /* --- pixel bitmap for cmex83 char#51 (noname) --- */
      {  51, 1600,                      /* character number, location */
         -1, 0,  -20, 0,      /* topleft row,col, and botleft row,col */
          {  3,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xfe\x21\xf2\x21" }  },
      /* --- pixel bitmap for cmex83 char#52 (noname) --- */
      {  52, 1227,                      /* character number, location */
          0, 4,  -19, 4,      /* topleft row,col, and botleft row,col */
          {  3,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x2f\x21\x23" }  },
      /* --- pixel bitmap for cmex83 char#53 (noname) --- */
      {  53, 1664,                      /* character number, location */
          0, 0,  -19, 0,      /* topleft row,col, and botleft row,col */
          {  3,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x21\xf2\x21\x03" }  },
      /* --- pixel bitmap for cmex83 char#54 (noname) --- */
      {  54, 1291,                      /* character number, location */
          1, 4,   -8, 4,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01" }  },
      /* --- pixel bitmap for cmex83 char#55 (noname) --- */
      {  55, 1728,                      /* character number, location */
          1, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01" }  },
      /* --- pixel bitmap for cmex83 char#56 \leftbracetop --- */
      {  56, 3173,                      /* character number, location */
         -1, 4,  -11, 4,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x32\x33\x33\x33" }  },
      /* --- pixel bitmap for cmex83 char#57 \rightbracetop --- */
      {  57, 3600,                      /* character number, location */
         -1, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  5,   10, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x42\x42\x10\xf6\x32" }  },
      /* --- pixel bitmap for cmex83 char#58 \leftbracebot --- */
      {  58, 3219,                      /* character number, location */
          1, 4,   -9, 4,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\x33\x33\x23\x84" }  },
      /* --- pixel bitmap for cmex83 char#59 \rightbracebot --- */
      {  59, 3646,                      /* character number, location */
          1, 1,   -9, 1,      /* topleft row,col, and botleft row,col */
          {  5,   10, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x32\x22\x22\x22\x32" }  },
      /* --- pixel bitmap for cmex83 char#60 \leftbracemid --- */
      {  60, 3246,                      /* character number, location */
          1, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          {  5,   23, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x32\x31\x32\x22\x21\x52\x42\x41\x10\xf7\x32" }  },
      /* --- pixel bitmap for cmex83 char#61 \rightbracemid --- */
      {  61, 3673,                      /* character number, location */
          1, 4,  -22, 4,      /* topleft row,col, and botleft row,col */
          {  4,   23, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x02\x20\x12\x31\x41\x21\x22\x1f\x82\x21" }  },
      /* --- pixel bitmap for cmex83 char#62 \leftbracebar --- */
      {  62, 3299,                      /* character number, location */
          1, 4,   -4, 4,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03" }  },
      /* --- pixel bitmap for cmex83 char#63 (noname) --- */
      {  63, 5086,                      /* character number, location */
          1, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01" }  },
      /* --- pixel bitmap for cmex83 char#64 \leftparenbot --- */
      {  64,  385,                      /* character number, location */
          1, 4,  -19, 4,      /* topleft row,col, and botleft row,col */
          {  5,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x84\x10\x42\x08\x21\x08\x21\x04\x21\x04\x21\x08" }  },
      /* --- pixel bitmap for cmex83 char#65 \rightparenbot --- */
      {  65,  807,                      /* character number, location */
          1, 0,  -19, 0,      /* topleft row,col, and botleft row,col */
          {  5,   20, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x41\xf3\x31\x10\xf2\x21\x20\xf1\x11\x31\x49" }  },
      /* --- pixel bitmap for cmex83 char#66 \leftparenbar --- */
      {  66,  432,                      /* character number, location */
          1, 4,   -8, 4,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01" }  },
      /* --- pixel bitmap for cmex83 char#67 \rightparenbar --- */
      {  67,  854,                      /* character number, location */
          1, 4,   -8, 4,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01" }  },
      /* --- pixel bitmap for cmex83 char#68 \Big< --- */
      {  68, 3838,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          {  4,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x44\x24\x22\x11\x21\x22\x44\x84\x08" }  },
      /* --- pixel bitmap for cmex83 char#69 \Big> --- */
      {  69, 4126,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          {  4,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x22\x42\x44\x88\x48\x44\x22\x12\x01" }  },
      /* --- pixel bitmap for cmex83 char#70 \bigsqcup --- */
      {  70, 5675,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x01\x51\x07" }  },
      /* --- pixel bitmap for cmex83 char#71 \Bigsqcup --- */
      {  71, 5743,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x81\x0a" }  },
      /* --- pixel bitmap for cmex83 char#72 \oint --- */
      {  72, 6951,                      /* character number, location */
          0, 0,  -13, 0,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x8a\x20\x18\xcb\x62\x08\x82\x14\x06" }  },
      /* --- pixel bitmap for cmex83 char#73 \Bigoint --- */
      {  73, 7011,                      /* character number, location */
          0, 1,  -26, 1,      /* topleft row,col, and botleft row,col */
          {  8,   26, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x62\xf2\x61\x10\xf4\x51\x20\x34\x10\xf3\x21\x11"
            "\x21\x34\x10\xf4\x31\x40\xf2\x21\x51\x11\x52\x61" }  },
      /* --- pixel bitmap for cmex83 char#74 \bigodot --- */
      {  74, 5831,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x22\x50\x80\x01\xc6\x18\x60\x80\x02\x11\x82"
            "\x07" }  },
      /* --- pixel bitmap for cmex83 char#75 \Bigodot --- */
      {  75, 5899,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 14,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\x86\x41\x80\x08\x40\x02\x50\x00\x18\x00\x06"
            "\x83\xc1\x60\x00\x18\x00\x0a\x40\x02\x10\x01\x82\x61"
            "\x80\x07" }  },
      /* --- pixel bitmap for cmex83 char#76 \bigoplus --- */
      {  76, 5989,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x90\x22\x52\x88\x21\xfe\x1f\x62\x88\x22\x91\x82"
            "\x07" }  },
      /* --- pixel bitmap for cmex83 char#77 \Bigoplus --- */
      {  77, 6069,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 14,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\xa6\x41\x88\x08\x42\x82\x50\x20\x18\x08\xfe"
            "\xff\x81\x60\x20\x18\x08\x0a\x42\x82\x10\x21\x82\x69"
            "\x80\x07" }  },
      /* --- pixel bitmap for cmex83 char#78 \bigotimes --- */
      {  78, 6179,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x62\x58\x92\x31\x46\x18\x63\x92\x86\x11\x82"
            "\x07" }  },
      /* --- pixel bitmap for cmex83 char#79 \Bigotimes --- */
      {  79, 6259,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 14,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\x86\x41\x80\x28\x50\x0a\x54\x84\x18\x12\x06"
            "\x83\xc1\x60\x48\x18\x21\x2a\x50\x0a\x14\x01\x82\x61"
            "\x80\x07" }  },
      /* --- pixel bitmap for cmex83 char#80 \sum --- */
      {  80, 6381,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x06\x09\x24\x80\x00\x02\x02\x06\x04\x05\xfd\x03" }  },
      /* --- pixel bitmap for cmex83 char#81 \prod --- */
      {  81, 6507,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xf8\x11\x41\x13\x23" }  },
      /* --- pixel bitmap for cmex83 char#82 \int --- */
      {  82, 6815,                      /* character number, location */
          0, 0,  -13, 0,      /* topleft row,col, and botleft row,col */
          {  6,   13, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x41\x11\xf8\x31\x21\x11\x42\x33" }  },
      /* --- pixel bitmap for cmex83 char#83 \bigcup --- */
      {  83, 7107,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x51\x11\x31\x33\x21" }  },
      /* --- pixel bitmap for cmex83 char#84 \bigcap --- */
      {  84, 7263,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x31\x31\x1f\x81\x51" }  },
      /* --- pixel bitmap for cmex83 char#85 \biguplus --- */
      {  85, 7419,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x60\x30\x98\xec\x26\x83\x41\x11\x07" }  },
      /* --- pixel bitmap for cmex83 char#86 \bigwedge --- */
      {  86, 7591,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x85\x42\x11\x89\x44\xa2\x60\x10" }  },
      /* --- pixel bitmap for cmex83 char#87 \bigvee --- */
      {  87, 7739,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xa0\x48\x24\x12\x51\x28\x14\x04\x02" }  },
      /* --- pixel bitmap for cmex83 char#88 \Bigsum --- */
      {  88, 6437,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 14,   16, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x12\x92\x22\x92\x22\x91\x32\xc3\xc2\xd2\xd1\xc1"
            "\xc2\xb2\xc1\x91\x21\x92\x12\x82\x1d\x11" }  },
      /* --- pixel bitmap for cmex83 char#89 \Bigprod --- */
      {  89, 6575,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xfd\x22\x42\x2c" }  },
      /* --- pixel bitmap for cmex83 char#90 \Bigint --- */
      {  90, 6871,                      /* character number, location */
          0, 1,  -26, 1,      /* topleft row,col, and botleft row,col */
          {  8,   26, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x62\xf2\x61\x10\xf4\x51\x20\xf5\x41\x30\xf4\x31"
            "\x40\xf2\x21\x51\x11\x52\x62" }  },
      /* --- pixel bitmap for cmex83 char#91 \Bigcup --- */
      {  91, 7175,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x01\x81\x11\x61\x31\x41\x54\x34" }  },
      /* --- pixel bitmap for cmex83 char#92 \Bigcap --- */
      {  92, 7331,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x51\x41\x31\x61\x1f\xc1\x81" }  },
      /* --- pixel bitmap for cmex83 char#93 \Biguplus --- */
      {  93, 7493,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x06\x18\x60\x80\x01\x86\x18\x62\xbf\x21\x86\x18"
            "\x60\x80\x01\x0a\x44\x08\x1e" }  },
      /* --- pixel bitmap for cmex83 char#94 \Bigwedge --- */
      {  94, 7657,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x40\xf2\x42\x40\xf2\x31\x21\x30\xf2\x21\x41\x20"
            "\xf3\x11\x61\x1f\x11\x81" }  },
      /* --- pixel bitmap for cmex83 char#95 \Bigvee --- */
      {  95, 7805,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x06\x28\x90\x40\x02\x09\x44\x08\x21\x84\x20\x81"
            "\x04\x12\x30\xc0\x00\x03\x08" }  },
      /* --- pixel bitmap for cmex83 char#96 \coprod --- */
      {  96, 6661,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x23\xf8\x11\x41\x18" }  },
      /* --- pixel bitmap for cmex83 char#97 \Bigcoprod --- */
      {  97, 6729,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xfd\x22\x42\x2c" }  },
      /* --- pixel bitmap for cmex83 char#98 ^ --- */
      {  98, 7887,                      /* character number, location */
          8, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          {  5,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x03" }  },
      /* --- pixel bitmap for cmex83 char#99 ^ --- */
      {  99, 7900,                      /* character number, location */
          9, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          { 10,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x38\x17\x20" }  },
      /* --- pixel bitmap for cmex83 char#100 ^ --- */
      { 100, 7917,                      /* character number, location */
          9, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          { 16,    3, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x75\x45\x11\xe1" }  },
      /* --- pixel bitmap for cmex83 char#101 ~ --- */
      { 101, 7934,                      /* character number, location */
          8, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          {  5,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb6\x01" }  },
      /* --- pixel bitmap for cmex83 char#102 ~ --- */
      { 102, 7949,                      /* character number, location */
          9, 0,    7, 0,      /* topleft row,col, and botleft row,col */
          { 10,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\xcf\x07" }  },
      /* --- pixel bitmap for cmex83 char#103 ~ --- */
      { 103, 7964,                      /* character number, location */
          9, 0,    7, 0,      /* topleft row,col, and botleft row,col */
          { 16,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xc1\x83\x7f" }  },
      /* --- pixel bitmap for cmex83 char#104 \Big[ --- */
      { 104,  929,                      /* character number, location */
          0, 2,  -19, 2,      /* topleft row,col, and botleft row,col */
          {  2,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x57\x55\x55\x55\x35" }  },
      /* --- pixel bitmap for cmex83 char#105 \Big] --- */
      { 105, 1366,                      /* character number, location */
          0, 0,  -19, 0,      /* topleft row,col, and botleft row,col */
          {  2,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xab\xaa\xaa\xaa\x3a" }  },
      /* --- pixel bitmap for cmex83 char#106 (noname) --- */
      { 106, 1803,                      /* character number, location */
          0, 2,  -19, 2,      /* topleft row,col, and botleft row,col */
          {  3,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x2f\x21\x23" }  },
      /* --- pixel bitmap for cmex83 char#107 (noname) --- */
      { 107, 2087,                      /* character number, location */
          0, 0,  -19, 0,      /* topleft row,col, and botleft row,col */
          {  3,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x21\xf2\x21\x03" }  },
      /* --- pixel bitmap for cmex83 char#108 (noname) --- */
      { 108, 2371,                      /* character number, location */
          0, 2,  -19, 2,      /* topleft row,col, and botleft row,col */
          {  3,   19, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x0f\xe1\x2f\x21\x21" }  },
      /* --- pixel bitmap for cmex83 char#109 (noname) --- */
      { 109, 2655,                      /* character number, location */
          0, 0,  -19, 0,      /* topleft row,col, and botleft row,col */
          {  3,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xfe\x21\xf2\x21" }  },
      /* --- pixel bitmap for cmex83 char#110 \Big{ --- */
      { 110, 2939,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x90\x11\x42\x08\x21\x26\x18\x42\x08\x21\x84\x41" }  },
      /* --- pixel bitmap for cmex83 char#111 \Big} --- */
      { 111, 3366,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x10\x42\x08\x21\x0c\x32\x42\x08\x21\xc4\x04" }  },
      /* --- pixel bitmap for cmex83 char#112 (noname) --- */
      { 112, 5250,                      /* character number, location */
          1, 1,  -13, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x08\x10\x40\x80\x00\x02\x84\x10\x23\x88\x40"
            "\x01\x05\x0c\x20\x00" }  },
      /* --- pixel bitmap for cmex83 char#113 (noname) --- */
      { 113, 5295,                      /* character number, location */
          1, 1,  -20, 1,      /* topleft row,col, and botleft row,col */
          { 10,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x08\x10\x40\x00\x01\x02\x08\x20\x80\x00\x01"
            "\x84\x10\x23\x88\x20\x02\x05\x14\x50\x40\x01\x02\x08"
            "\x00" }  },
      /* --- pixel bitmap for cmex83 char#114 (noname) --- */
      { 114, 5360,                      /* character number, location */
          1, 1,  -27, 1,      /* topleft row,col, and botleft row,col */
          { 10,   28, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x91\xf3\x81\x10\xf4\x71\x20\xf1\x61\x30\xf1\x11"
            "\x41\x32\x31\x40\xf2\x11\x31\x40\x21\x21\x40\xf3\x21"
            "\x11\x50\xf2\x31\x60" }  },
      /* --- pixel bitmap for cmex83 char#115 (noname) --- */
      { 115, 5445,                      /* character number, location */
          1, 1,  -34, 1,      /* topleft row,col, and botleft row,col */
          { 10,   35, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x91\xf5\x81\x10\xf5\x71\x20\xf2\x61\x30\xf1\x11"
            "\x41\x32\x31\x40\xf3\x11\x31\x40\x21\x21\x40\xf5\x21"
            "\x11\x50\xf2\x31\x60" }  },
      /* --- pixel bitmap for cmex83 char#116 (noname) --- */
      { 116, 5550,                      /* character number, location */
          1, 1,  -21, 1,      /* topleft row,col, and botleft row,col */
          {  7,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x10\x28\x34\x1a\x8b\x44\x24\x12\x09\x85\x42"
            "\xa1\x60\x30\x18\x0c\x04\x02" }  },
      /* --- pixel bitmap for cmex83 char#117 (noname) --- */
      { 117, 5627,                      /* character number, location */
          1, 7,   -8, 7,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01" }  },
      /* --- pixel bitmap for cmex83 char#118 (noname) --- */
      { 118, 5652,                      /* character number, location */
          1, 7,   -7, 7,      /* topleft row,col, and botleft row,col */
          {  5,    8, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\x61\x41" }  },
      /* --- pixel bitmap for cmex83 char#119 (noname) --- */
      { 119, 5207,                      /* character number, location */
          1, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  4,    9, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x21" }  },
      /* --- pixel bitmap for cmex83 char#120 (noname) --- */
      { 120, 4998,                      /* character number, location */
          0, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc4\x55\x42\x08\x01" }  },
      /* --- pixel bitmap for cmex83 char#121 (noname) --- */
      { 121, 5042,                      /* character number, location */
          0, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x10\x52\x1d\x01" }  },
      /* --- pixel bitmap for cmex83 char#122 (noname) --- */
      { 122, 3726,                      /* character number, location */
          2,-1,   -2,-1,      /* topleft row,col, and botleft row,col */
          {  7,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\xbe\x21\x00" }  },
      /* --- pixel bitmap for cmex83 char#123 (noname) --- */
      { 123, 3741,                      /* character number, location */
          2,-1,   -2,-1,      /* topleft row,col, and botleft row,col */
          {  7,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x0f\x0c\x08" }  },
      /* --- pixel bitmap for cmex83 char#124 (noname) --- */
      { 124, 3756,                      /* character number, location */
          4,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  7,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x03\x1f\x0e" }  },
      /* --- pixel bitmap for cmex83 char#125 (noname) --- */
      { 125, 3771,                      /* character number, location */
          4,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  7,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\xd8\xe7\x00" }  },
      /* --- pixel bitmap for cmex83 char#126 (noname) --- */
      { 126, 5111,                      /* character number, location */
         -1, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x24\xe7\x24\x24\x24" }  },
      /* --- pixel bitmap for cmex83 char#127 (noname) --- */
      { 127, 5159,                      /* character number, location */
          0, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x24\x24\xe7\x24\x18" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=1 for .100gf ---
 * mf '\mode=preview; mag=magstep(-17.87427405946994351363); input cmex10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmex100 --- */
static	chardef  cmex100[] =
   {
      /* --- pixel bitmap for cmex100 char#0 \big( --- */
      {   0,  635,                      /* character number, location */
          1, 2,  -15, 2,      /* topleft row,col, and botleft row,col */
          {  4,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x22\x11\x11\x11\x11\x22\x84" }  },
      /* --- pixel bitmap for cmex100 char#1 \big) --- */
      {   1, 6116,                      /* character number, location */
          1, 0,  -15, 0,      /* topleft row,col, and botleft row,col */
          {  4,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x44\x88\x88\x88\x88\x44\x12" }  },
      /* --- pixel bitmap for cmex100 char#2 \big[ --- */
      {   2,11565,                      /* character number, location */
          1, 3,  -15, 3,      /* topleft row,col, and botleft row,col */
          {  3,   16, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x0f\xd1\x23" }  },
      /* --- pixel bitmap for cmex100 char#3 \big] --- */
      {   3,17191,                      /* character number, location */
          1, 0,  -15, 0,      /* topleft row,col, and botleft row,col */
          {  3,   16, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xfd\x21\x03" }  },
      /* --- pixel bitmap for cmex100 char#4 (noname) --- */
      {   4,22654,                      /* character number, location */
          1, 3,  -15, 3,      /* topleft row,col, and botleft row,col */
          {  4,   16, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x34" }  },
      /* --- pixel bitmap for cmex100 char#5 (noname) --- */
      {   5,26001,                      /* character number, location */
          1, 0,  -15, 0,      /* topleft row,col, and botleft row,col */
          {  4,   16, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x31\x04" }  },
      /* --- pixel bitmap for cmex100 char#6 (noname) --- */
      {   6,29324,                      /* character number, location */
          1, 3,  -15, 3,      /* topleft row,col, and botleft row,col */
          {  4,   16, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x31" }  },
      /* --- pixel bitmap for cmex100 char#7 (noname) --- */
      {   7,32679,                      /* character number, location */
          1, 0,  -15, 0,      /* topleft row,col, and botleft row,col */
          {  4,   16, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x31" }  },
      /* --- pixel bitmap for cmex100 char#8 \big{ --- */
      {   8,36129,                      /* character number, location */
          1, 2,  -15, 2,      /* topleft row,col, and botleft row,col */
          {  4,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x44\x44\x24\x42\x44\x44\x84" }  },
      /* --- pixel bitmap for cmex100 char#9 \big} --- */
      {   9,43640,                      /* character number, location */
          1, 2,  -15, 2,      /* topleft row,col, and botleft row,col */
          {  4,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x44\x44\xc4\x44\x44\x44\x34" }  },
      /* --- pixel bitmap for cmex100 char#10 \big< --- */
      {  10,52198,                      /* character number, location */
          1, 2,  -16, 2,      /* topleft row,col, and botleft row,col */
          {  4,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x44\x22\x12\x11\x22\x42\x84\x08" }  },
      /* --- pixel bitmap for cmex100 char#11 \big> --- */
      {  11,54875,                      /* character number, location */
          1, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          {  4,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x22\x44\x84\x88\x44\x24\x12\x01" }  },
      /* --- pixel bitmap for cmex100 char#12 (noname) --- */
      {  12,63349,                      /* character number, location */
          1, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          {  1,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03" }  },
      /* --- pixel bitmap for cmex100 char#13 (noname) --- */
      {  13,63936,                      /* character number, location */
          1, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          {  4,   10, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x01\x21" }  },
      /* --- pixel bitmap for cmex100 char#14 (noname) --- */
      {  14,57538,                      /* character number, location */
          1, 1,  -15, 1,      /* topleft row,col, and botleft row,col */
          {  6,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x41\x10\x82\x20\x04\x41\x08\x82\x10\x04" }  },
      /* --- pixel bitmap for cmex100 char#15 (noname) --- */
      {  15,60488,                      /* character number, location */
          1, 1,  -15, 1,      /* topleft row,col, and botleft row,col */
          {  6,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x20\x08\x02\x41\x10\x08\x82\x40\x10\x04\x82" }  },
      /* --- pixel bitmap for cmex100 char#16 \Big( --- */
      {  16, 1352,                      /* character number, location */
          1, 3,  -23, 3,      /* topleft row,col, and botleft row,col */
          {  5,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x11\x22\x84\x08\x21\x84\x10\x42\x08\x41\x08\x41"
            "\x08\x82" }  },
      /* --- pixel bitmap for cmex100 char#17 \Big) --- */
      {  17, 6820,                      /* character number, location */
          1, 0,  -23, 0,      /* topleft row,col, and botleft row,col */
          {  5,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x10\x82\x10\x82\x10\x42\x08\x21\x84\x10\x21\x44"
            "\x88\x08" }  },
      /* --- pixel bitmap for cmex100 char#18 \bigg( --- */
      {  18, 2138,                      /* character number, location */
          1, 3,  -32, 3,      /* topleft row,col, and botleft row,col */
          {  7,   33, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x51\x51\x20\xf1\x31\x30\xf1\x21\x40\xf3\x11\x5f"
            "\xa1\x60\xf3\x11\x50\xf1\x21\x40\xf1\x31\x30\x41\x71"
            "\x71" }  },
      /* --- pixel bitmap for cmex100 char#19 \bigg) --- */
      {  19, 7593,                      /* character number, location */
          1, 0,  -32, 0,      /* topleft row,col, and botleft row,col */
          {  7,   33, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x71\x71\x40\xf1\x31\x30\xf1\x41\x20\xf3\x51\x10"
            "\xfa\x61\xf3\x51\x10\xf1\x41\x20\xf1\x31\x30\x21\x51"
            "\x51\x61" }  },
      /* --- pixel bitmap for cmex100 char#20 \bigg[ --- */
      {  20,13186,                      /* character number, location */
          1, 3,  -32, 3,      /* topleft row,col, and botleft row,col */
          {  4,   33, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x3f\xe1\x31\x34" }  },
      /* --- pixel bitmap for cmex100 char#21 \bigg] --- */
      {  21,18760,                      /* character number, location */
          1, 0,  -32, 0,      /* topleft row,col, and botleft row,col */
          {  4,   33, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x31\xfe\x31\x35" }  },
      /* --- pixel bitmap for cmex100 char#22 (noname) --- */
      {  22,24313,                      /* character number, location */
          1, 3,  -32, 3,      /* topleft row,col, and botleft row,col */
          {  5,   33, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f\x00\x01\x04\x05" }  },
      /* --- pixel bitmap for cmex100 char#23 (noname) --- */
      {  23,27634,                      /* character number, location */
          1, 0,  -32, 0,      /* topleft row,col, and botleft row,col */
          {  5,   33, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f\x04\x01\x00\x05" }  },
      /* --- pixel bitmap for cmex100 char#24 (noname) --- */
      {  24,30987,                      /* character number, location */
          1, 3,  -32, 3,      /* topleft row,col, and botleft row,col */
          {  5,   33, 2, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x05\x00\xff\x1f\x01\x04" }  },
      /* --- pixel bitmap for cmex100 char#25 (noname) --- */
      {  25,34316,                      /* character number, location */
          1, 0,  -32, 0,      /* topleft row,col, and botleft row,col */
          {  5,   33, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x05\xff\x1f\x04\x01" }  },
      /* --- pixel bitmap for cmex100 char#26 \bigg{ --- */
      {  26,38060,                      /* character number, location */
          1, 2,  -32, 2,      /* topleft row,col, and botleft row,col */
          {  6,   33, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x32\x41\x20\xfb\x21\x30\x11\x41\x61\x40\xfb\x21"
            "\x30\x31\x52\x61" }  },
      /* --- pixel bitmap for cmex100 char#27 \bigg} --- */
      {  27,45573,                      /* character number, location */
          1, 2,  -32, 2,      /* topleft row,col, and botleft row,col */
          {  6,   33, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x61\x40\xfb\x21\x30\x31\x52\x61\x32\x41\x20\xfb"
            "\x21\x30\x11\x41\x51" }  },
      /* --- pixel bitmap for cmex100 char#28 \bigg< --- */
      {  28,53517,                      /* character number, location */
          1, 2,  -32, 2,      /* topleft row,col, and botleft row,col */
          {  7,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x08\x04\x82\x40\x10\x08\x04\x81\x20\x10\x08"
            "\x02\x81\x80\x40\x20\x20\x10\x10\x08\x04\x04\x02\x02"
            "\x81\x80\x40" }  },
      /* --- pixel bitmap for cmex100 char#29 \bigg> --- */
      {  29,56196,                      /* character number, location */
          1, 1,  -32, 1,      /* topleft row,col, and botleft row,col */
          {  7,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\x40\x20\x20\x10\x10\x08\x04\x04\x02\x02\x81"
            "\x80\x40\x20\x08\x04\x82\x40\x10\x08\x04\x81\x20\x10"
            "\x08\x02\x01" }  },
      /* --- pixel bitmap for cmex100 char#30 (noname) --- */
      {  30,58977,                      /* character number, location */
          1, 1,  -32, 1,      /* topleft row,col, and botleft row,col */
          { 12,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\xc0\x00\x04\x40\x00\x06\x20\x00\x02\x30\x00"
            "\x01\x10\x80\x01\x08\x80\x00\x0c\x40\x00\x04\x60\x00"
            "\x02\x20\x00\x03\x10\x00\x01\x18\x80\x00\x08\xc0\x00"
            "\x04\x40\x00\x06\x20\x00\x02\x30\x00\x01\x00" }  },
      /* --- pixel bitmap for cmex100 char#31 (noname) --- */
      {  31,61935,                      /* character number, location */
          1, 1,  -32, 1,      /* topleft row,col, and botleft row,col */
          { 12,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x30\x00\x02\x20\x00\x06\x40\x00\x04\xc0\x00\x08"
            "\x80\x00\x18\x00\x01\x10\x00\x03\x20\x00\x02\x60\x00"
            "\x04\x40\x00\x0c\x80\x00\x08\x80\x01\x10\x00\x01\x30"
            "\x00\x02\x20\x00\x06\x40\x00\x04\xc0\x00\x08" }  },
      /* --- pixel bitmap for cmex100 char#32 \Bigg( --- */
      {  32, 2968,                      /* character number, location */
          1, 3,  -40, 3,      /* topleft row,col, and botleft row,col */
          {  8,   41, 3,66, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x61\x61\x20\xf1\x41\x30\xf1\x31\x40\xf2\x21\x50"
            "\xf3\x11\x6f\xc1\x70\xf3\x11\x60\xf2\x21\x50\xf1\x31"
            "\x40\xf1\x41\x30\x51\x81\x81" }  },
      /* --- pixel bitmap for cmex100 char#33 \Bigg) --- */
      {  33, 8384,                      /* character number, location */
          1, 0,  -40, 0,      /* topleft row,col, and botleft row,col */
          {  8,   41, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x81\x50\xf1\x31\x40\xf1\x41\x30\xf2\x51\x20"
            "\xf3\x61\x10\xfc\x71\xf3\x61\x10\xf2\x51\x20\xf1\x41"
            "\x30\xf1\x31\x40\x21\x61\x61\x70" }  },
      /* --- pixel bitmap for cmex100 char#34 \Bigg[ --- */
      {  34,14049,                      /* character number, location */
          1, 4,  -40, 4,      /* topleft row,col, and botleft row,col */
          {  4,   41, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x3f\xe1\x3f\x81\x34" }  },
      /* --- pixel bitmap for cmex100 char#35 \Bigg] --- */
      {  35,19584,                      /* character number, location */
          1, 0,  -40, 0,      /* topleft row,col, and botleft row,col */
          {  4,   41, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x31\xfe\x31\xf8\x31\x04" }  },
      /* --- pixel bitmap for cmex100 char#36 (noname) --- */
      {  36,25208,                      /* character number, location */
          1, 4,  -40, 4,      /* topleft row,col, and botleft row,col */
          {  5,   41, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x27\x00\x01\x04\x05" }  },
      /* --- pixel bitmap for cmex100 char#37 (noname) --- */
      {  37,28490,                      /* character number, location */
          1, 0,  -40, 0,      /* topleft row,col, and botleft row,col */
          {  5,   41, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x27\x04\x01\x00\x05" }  },
      /* --- pixel bitmap for cmex100 char#38 (noname) --- */
      {  38,31884,                      /* character number, location */
          1, 4,  -40, 4,      /* topleft row,col, and botleft row,col */
          {  5,   41, 2, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x05\x00\xff\x27\x01\x04" }  },
      /* --- pixel bitmap for cmex100 char#39 (noname) --- */
      {  39,35174,                      /* character number, location */
          1, 0,  -40, 0,      /* topleft row,col, and botleft row,col */
          {  5,   41, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x05\xff\x27\x04\x01" }  },
      /* --- pixel bitmap for cmex100 char#40 \Bigg{ --- */
      {  40,39078,                      /* character number, location */
          1, 2,  -40, 2,      /* topleft row,col, and botleft row,col */
          {  7,   41, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x51\x51\x20\xfe\x31\x30\x21\x51\x51\x71\x71\x40"
            "\xfe\x31\x30\x41\x71\x71" }  },
      /* --- pixel bitmap for cmex100 char#41 \Bigg} --- */
      {  41,46592,                      /* character number, location */
          1, 2,  -40, 2,      /* topleft row,col, and botleft row,col */
          {  7,   41, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x71\x71\x40\xfe\x31\x30\x41\x71\x71\x51\x51\x20"
            "\xfe\x31\x30\x21\x51\x51\x61" }  },
      /* --- pixel bitmap for cmex100 char#42 \Bigg< --- */
      {  42,54253,                      /* character number, location */
          1, 2,  -40, 2,      /* topleft row,col, and botleft row,col */
          {  8,   41, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x80\x40\x40\x40\x20\x20\x20\x10\x10\x08\x08\x08"
            "\x04\x04\x04\x02\x02\x02\x01\x01\x01\x02\x02\x02\x04"
            "\x04\x04\x08\x08\x08\x10\x10\x20\x20\x20\x40\x40\x40"
            "\x80\x80" }  },
      /* --- pixel bitmap for cmex100 char#43 \Bigg> --- */
      {  43,56933,                      /* character number, location */
          1, 1,  -40, 1,      /* topleft row,col, and botleft row,col */
          {  8,   41, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x01\x02\x02\x02\x04\x04\x04\x08\x08\x10\x10\x10"
            "\x20\x20\x20\x40\x40\x40\x80\x80\x80\x40\x40\x40\x20"
            "\x20\x20\x10\x10\x10\x08\x08\x04\x04\x04\x02\x02\x02"
            "\x01\x01" }  },
      /* --- pixel bitmap for cmex100 char#44 / --- */
      {  44,59879,                      /* character number, location */
          1, 1,  -40, 1,      /* topleft row,col, and botleft row,col */
          { 16,   41, 3,123, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x11\xe2\xf1\xe1\x10\xd2\x10\xf1\xd1\x20\xc2\xe1"
            "\xe2\x30\xf1\xb1\x40\xa2\x40\xf1\xa1\x50\x92\xe1\xe2"
            "\x60\xf1\x81\x70\x72\x70\xf1\x71\x80\x62\xe1\xe2\x90"
            "\xf1\x51\xa0\x42\xa0\xf1\x41\xb0\x32\xe1\xe2\xc0\xf1"
            "\x21\xd0\x12\xd0\xf1\x11\xe2\xe1\xe0\x10" }  },
      /* --- pixel bitmap for cmex100 char#45 \ --- */
      {  45,62841,                      /* character number, location */
          1, 1,  -40, 1,      /* topleft row,col, and botleft row,col */
          { 16,   41, 3,142, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x12\xe0\xf1\x11\xe0\x12\xd0\xf1\x21\xd0\x22"
            "\xe0\x11\xe0\x12\xb0\xf1\x41\xb0\x42\xa0\xf1\x51\xa0"
            "\x52\xe0\x11\xe0\x12\x80\xf1\x71\x80\x72\x70\xf1\x81"
            "\x70\x82\xe0\x11\xe0\x12\x50\xf1\xa1\x50\xa2\x40\xf1"
            "\xb1\x40\xb2\xe0\x11\xe0\x12\x20\xf1\xd1\x20\xd2\x10"
            "\xf1\xe1\x10\xe2\xe0\x11" }  },
      /* --- pixel bitmap for cmex100 char#46 / --- */
      {  46,58197,                      /* character number, location */
          1, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          {  9,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x03\x02\x04\x0c\x08\x10\x30\x20\x40\xc0\x80"
            "\x00\x01\x03\x02\x04\x0c\x08\x10\x30\x20\x40\xc0\x80"
            "\x00" }  },
      /* --- pixel bitmap for cmex100 char#47 \ --- */
      {  47,61151,                      /* character number, location */
          1, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          {  9,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x06\x08\x10\x60\x80\x00\x01\x06\x08\x10\x60\x80"
            "\x00\x01\x06\x08\x10\x60\x80\x00\x01\x06\x08\x10\x60"
            "\x80" }  },
      /* --- pixel bitmap for cmex100 char#48 \leftparentop --- */
      {  48, 3830,                      /* character number, location */
          0, 4,  -25, 4,      /* topleft row,col, and botleft row,col */
          {  8,   25, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x61\x62\x61\x62\x61\x62\x61\x40\xf1\x22\x40\x21"
            "\x50\xf3\x12\x50\x11\x6f\x82\x60" }  },
      /* --- pixel bitmap for cmex100 char#49 \rightparentop --- */
      {  49, 9207,                      /* character number, location */
          0, 0,  -25, 0,      /* topleft row,col, and botleft row,col */
          {  8,   25, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x72\x71\x72\x71\x72\x71\x30\xf1\x42\x20\x51"
            "\x20\xf3\x52\x10\x61\x10\xf8\x62" }  },
      /* --- pixel bitmap for cmex100 char#50 (noname) --- */
      {  50,14897,                      /* character number, location */
          0, 4,  -24, 4,      /* topleft row,col, and botleft row,col */
          {  5,   24, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\x71\x4f" }  },
      /* --- pixel bitmap for cmex100 char#51 (noname) --- */
      {  51,20393,                      /* character number, location */
          0, 0,  -24, 0,      /* topleft row,col, and botleft row,col */
          {  5,   24, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xf7\x41" }  },
      /* --- pixel bitmap for cmex100 char#52 (noname) --- */
      {  52,15733,                      /* character number, location */
          1, 4,  -23, 4,      /* topleft row,col, and botleft row,col */
          {  5,   24, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x4f\x71\x45" }  },
      /* --- pixel bitmap for cmex100 char#53 (noname) --- */
      {  53,21190,                      /* character number, location */
          1, 0,  -23, 0,      /* topleft row,col, and botleft row,col */
          {  5,   24, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x41\xf7\x41\x05" }  },
      /* --- pixel bitmap for cmex100 char#54 (noname) --- */
      {  54,16466,                      /* character number, location */
          1, 4,   -9, 4,      /* topleft row,col, and botleft row,col */
          {  1,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03" }  },
      /* --- pixel bitmap for cmex100 char#55 (noname) --- */
      {  55,21884,                      /* character number, location */
          1, 4,   -9, 4,      /* topleft row,col, and botleft row,col */
          {  1,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03" }  },
      /* --- pixel bitmap for cmex100 char#56 \leftbracetop --- */
      {  56,40013,                      /* character number, location */
         -1, 5,  -13, 5,      /* topleft row,col, and botleft row,col */
          {  4,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x36\x33\x33\x33\x33" }  },
      /* --- pixel bitmap for cmex100 char#57 \rightbracetop --- */
      {  57,47528,                      /* character number, location */
         -1, 3,  -13, 3,      /* topleft row,col, and botleft row,col */
          {  4,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\xc6\xcc\xcc\xcc\xcc" }  },
      /* --- pixel bitmap for cmex100 char#58 \leftbracebot --- */
      {  58,40912,                      /* character number, location */
          1, 5,  -11, 5,      /* topleft row,col, and botleft row,col */
          {  4,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\x33\x33\x33\x63\x84" }  },
      /* --- pixel bitmap for cmex100 char#59 \rightbracebot --- */
      {  59,48428,                      /* character number, location */
          1, 3,  -11, 3,      /* topleft row,col, and botleft row,col */
          {  4,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\xcc\xcc\xcc\x6c\x12" }  },
      /* --- pixel bitmap for cmex100 char#60 \leftbracemid --- */
      {  60,41886,                      /* character number, location */
          1, 3,  -26, 3,      /* topleft row,col, and botleft row,col */
          {  4,   27, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x22\x21\x22\x21\x21\x41\x32\x31\x10\xf9\x22" }  },
      /* --- pixel bitmap for cmex100 char#61 \rightbracemid --- */
      {  61,49403,                      /* character number, location */
          1, 5,  -26, 5,      /* topleft row,col, and botleft row,col */
          {  4,   27, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x02\x20\x11\x32\x31\x41\x21\x22\x21\x2f\x92\x20" }  },
      /* --- pixel bitmap for cmex100 char#62 \leftbracebar --- */
      {  62,42754,                      /* character number, location */
          1, 5,   -5, 5,      /* topleft row,col, and botleft row,col */
          {  2,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f" }  },
      /* --- pixel bitmap for cmex100 char#63 (noname) --- */
      {  63,66405,                      /* character number, location */
          1, 4,   -9, 4,      /* topleft row,col, and botleft row,col */
          {  1,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03" }  },
      /* --- pixel bitmap for cmex100 char#64 \leftparenbot --- */
      {  64, 4682,                      /* character number, location */
          2, 4,  -23, 4,      /* topleft row,col, and botleft row,col */
          {  8,   25, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x02\x60\x11\x60\xf3\x12\x50\x21\x50\xf1\x22\x40"
            "\x31\x72\x71\x72\x71\x72\x71\x81" }  },
      /* --- pixel bitmap for cmex100 char#65 \rightparenbot --- */
      {  65,10020,                      /* character number, location */
          2, 0,  -23, 0,      /* topleft row,col, and botleft row,col */
          {  8,   25, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x62\x61\x10\xf3\x52\x10\x51\x20\xf1\x42\x20\x41"
            "\x62\x61\x62\x61\x62\x61\x61\x72" }  },
      /* --- pixel bitmap for cmex100 char#66 \leftparenbar --- */
      {  66, 5528,                      /* character number, location */
          1, 4,   -9, 4,      /* topleft row,col, and botleft row,col */
          {  2,   10, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x02" }  },
      /* --- pixel bitmap for cmex100 char#67 \rightparenbar --- */
      {  67,10827,                      /* character number, location */
          1, 6,   -9, 6,      /* topleft row,col, and botleft row,col */
          {  2,   10, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x02" }  },
      /* --- pixel bitmap for cmex100 char#68 \Big< --- */
      {  68,52823,                      /* character number, location */
          1, 2,  -24, 2,      /* topleft row,col, and botleft row,col */
          {  5,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x22\x84\x08\x21\x42\x88\x10\x82\x10\x82\x10\x82"
            "\x10\x82\x10" }  },
      /* --- pixel bitmap for cmex100 char#69 \Big> --- */
      {  69,55501,                      /* character number, location */
          1, 1,  -24, 1,      /* topleft row,col, and botleft row,col */
          {  5,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x08\x21\x08\x21\x08\x21\x08\x21\x42\x88\x10\x22"
            "\x84\x08\x01" }  },
      /* --- pixel bitmap for cmex100 char#70 \bigsqcup --- */
      {  70,76500,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x01\x81\x0a" }  },
      /* --- pixel bitmap for cmex100 char#71 \Bigsqcup --- */
      {  71,77385,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\xb1\x0f\x21\xb1\x0d" }  },
      /* --- pixel bitmap for cmex100 char#72 \oint --- */
      {  72,95543,                      /* character number, location */
          0, 1,  -15, 1,      /* topleft row,col, and botleft row,col */
          {  8,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\xa0\x20\x10\x78\x94\x94\x94\x94\x78\x10\x10\x08"
            "\x09\x06" }  },
      /* --- pixel bitmap for cmex100 char#73 \Bigoint --- */
      {  73,96579,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 12,   31, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\xa1\x11\xc0\xf2\x81\x30\xf2\x71\x40\xf1\x62\x40"
            "\x44\x71\x23\x30\xf3\x21\x22\x21\x20\x31\x12\x11\x74"
            "\x40\xf2\x42\x60\xf2\x41\x70\xf2\x31\x80\xc1\x11\xa1"
            "\xa1" }  },
      /* --- pixel bitmap for cmex100 char#74 \bigodot --- */
      {  74,78345,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x10\x01\x14\x00\x03\x60\x10\x0c\x82"
            "\x01\x30\x00\x0a\x20\x02\x82\x20\xe0\x03" }  },
      /* --- pixel bitmap for cmex100 char#75 \Bigodot --- */
      {  75,79472,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 19,   19, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\xc2\x52\x82\x92\x30\xf1\x21\xd1\x20\xf1\x11\xe0"
            "\x11\x11\xe0\x32\x81\x82\x73\x72\x81\x82\xe0\x31\xf1"
            "\x11\xe0\x11\x10\xf1\x21\xd1\x20\x32\x92\x82\x52\xc5"
            "\x72" }  },
      /* --- pixel bitmap for cmex100 char#76 \bigoplus --- */
      {  76,80437,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x49\x10\x11\x21\x14\x04\x83\xe0\xff\x0f\x82"
            "\x41\x30\x08\x0a\x21\x22\x82\x24\xe0\x03" }  },
      /* --- pixel bitmap for cmex100 char#77 \Bigoplus --- */
      {  77,81581,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 19,   19, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\xc2\x21\x22\x82\x41\x42\x30\xf1\x21\x61\x61\x20"
            "\xf1\x11\x71\x71\x1f\x11\x81\x81\x0e\x05\x0f\x11\x81"
            "\x81\xf1\x11\x71\x71\x10\xf1\x21\x61\x61\x20\x32\x41"
            "\x42\x82\x21\x22\xc5\x72" }  },
      /* --- pixel bitmap for cmex100 char#78 \bigotimes --- */
      {  78,82571,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x10\x05\x15\x11\x43\x61\x10\x0c\x82"
            "\xa1\x30\x22\x2a\x28\x02\x82\x20\xe0\x03" }  },
      /* --- pixel bitmap for cmex100 char#79 \Bigotimes --- */
      {  79,83724,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 19,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x0f\x00\x83\x01\x06\x30\x18\x00\x43\x01\x14\x11"
            "\x10\x09\x41\x28\x10\x81\x01\x05\x0c\x10\x60\x40\x01"
            "\x03\x11\x28\x04\x21\x11\x10\x51\x00\x85\x01\x30\x18"
            "\xc0\x00\x83\x01\xe0\x03\x00" }  },
      /* --- pixel bitmap for cmex100 char#80 \sum --- */
      {  80,85060,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x12\x82\x22\x82\x21\x91\x31\xd1\xc2\xc1\xb1\xb1"
            "\xb2\x81\x21\x82\x11\x82\x1c\x11" }  },
      /* --- pixel bitmap for cmex100 char#81 \prod --- */
      {  81,87926,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 11,   14, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\xfb\x11\x71\x13\x53" }  },
      /* --- pixel bitmap for cmex100 char#82 \int --- */
      {  82,93534,                      /* character number, location */
          0, 1,  -15, 1,      /* topleft row,col, and botleft row,col */
          {  8,   15, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x61\x11\x51\x20\xf8\x41\x30\x31\x41\x21\x52\x53" }  },
      /* --- pixel bitmap for cmex100 char#83 \bigcup --- */
      {  83,97373,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x01\x81\x11\x61\x31\x41\x54\x31" }  },
      /* --- pixel bitmap for cmex100 char#84 \bigcap --- */
      {  84,99053,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x51\x41\x31\x61\x1f\xa1\x81" }  },
      /* --- pixel bitmap for cmex100 char#85 \biguplus --- */
      {  85,100798,                     /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x06\x18\x60\x80\x21\x86\xd8\x6f\x88\x21\x06\x18"
            "\xa0\x40\x84\xe0\x01" }  },
      /* --- pixel bitmap for cmex100 char#86 \bigwedge --- */
      {  86,102540,                     /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\xc0\x00\x03\x12\x48\x20\x41\x08\x21\x84\x08\x24"
            "\x90\x40\x01\x06\x08" }  },
      /* --- pixel bitmap for cmex100 char#87 \bigvee --- */
      {  87,104160,                     /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x06\x28\x90\x40\x02\x11\x42\x08\x21\x48\x20\x81"
            "\x04\x0c\x30\x80\x00" }  },
      /* --- pixel bitmap for cmex100 char#88 \Bigsum --- */
      {  88,86507,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 18,   19, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x23\xb3\x23\xc1\x32\xd1\x32\xe0\x32\xe0\x23"
            "\xe0\x23\xe0\x22\xe0\x32\xe0\x21\xe0\x22\xe0\x12\xe0"
            "\x12\xe0\x21\xe0\x21\xd1\x22\xc1\x22\xb3\x1e\x02\x21" }  },
      /* --- pixel bitmap for cmex100 char#89 \Bigprod --- */
      {  89,89508,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 16,   19, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\xfe\x22\x82\x20\xf1\x22\x82\x26\x46" }  },
      /* --- pixel bitmap for cmex100 char#90 \Bigint --- */
      {  90,94546,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 12,   31, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\xa1\x11\xc0\xf2\x81\x30\xf2\x71\x40\xf3\x62\x40"
            "\xf4\x52\x50\xf3\x42\x60\xf2\x41\x70\xf2\x31\x80\xc1"
            "\x11\xa1\xa1" }  },
      /* --- pixel bitmap for cmex100 char#91 \Bigcup --- */
      {  91,98266,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\xb1\x11\x91\x31\x71\x51\x51\x75\x41" }  },
      /* --- pixel bitmap for cmex100 char#92 \Bigcap --- */
      {  92,99953,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x71\x51\x51\x71\x31\x91\x1f\xe1\xb1" }  },
      /* --- pixel bitmap for cmex100 char#93 \Biguplus --- */
      {  93,101766,                     /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x01\xb1\x0f\x31\x51\x51\x01\x19\x11\x0f\x31\x51"
            "\x51\x0f\x11\xb1\x11\x91\x31\x71\x51\x51\x75\x41" }  },
      /* --- pixel bitmap for cmex100 char#94 \Bigwedge --- */
      {  94,103405,                     /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x61\x60\xf2\x51\x11\x50\xf2\x41\x31\x40\xf2\x31"
            "\x51\x30\xf2\x21\x71\x20\xf2\x11\x91\x1f\x11\xb1" }  },
      /* --- pixel bitmap for cmex100 char#95 \Bigvee --- */
      {  95,105026,                     /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xb1\xf2\x11\x91\x10\xf2\x21\x71\x20\xf2\x31"
            "\x51\x30\xf2\x41\x31\x40\xf2\x51\x11\x50\xf1\x61\x64" }  },
      /* --- pixel bitmap for cmex100 char#96 \coprod --- */
      {  96,90953,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 11,   14, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x53\xfb\x11\x71\x1b" }  },
      /* --- pixel bitmap for cmex100 char#97 \Bigcoprod --- */
      {  97,92537,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 16,   19, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x46\xfe\x22\x82\x20\xf1\x22\x82\x2e\x02" }  },
      /* --- pixel bitmap for cmex100 char#98 ^ --- */
      {  98,105743,                     /* character number, location */
         10, 0,    7, 0,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\xe7\x81" }  },
      /* --- pixel bitmap for cmex100 char#99 ^ --- */
      {  99,106588,                     /* character number, location */
         10, 0,    7, 0,      /* topleft row,col, and botleft row,col */
          { 14,    3, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x64\x44\x11\xc1" }  },
      /* --- pixel bitmap for cmex100 char#100 ^ --- */
      { 100,107642,                     /* character number, location */
         10, 0,    7, 0,      /* topleft row,col, and botleft row,col */
          { 20,    3, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\x86\x66\x11\xe0\x41" }  },
      /* --- pixel bitmap for cmex100 char#101 ~ --- */
      { 101,108325,                     /* character number, location */
         10, 0,    8, 0,      /* topleft row,col, and botleft row,col */
          {  8,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xde\x7b" }  },
      /* --- pixel bitmap for cmex100 char#102 ~ --- */
      { 102,109215,                     /* character number, location */
         10, 0,    8, 0,      /* topleft row,col, and botleft row,col */
          { 14,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\xf0\xf0\x07" }  },
      /* --- pixel bitmap for cmex100 char#103 ~ --- */
      { 103,110314,                     /* character number, location */
         10, 0,    8, 0,      /* topleft row,col, and botleft row,col */
          { 20,    2, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x29\x74\x79\x21" }  },
      /* --- pixel bitmap for cmex100 char#104 \Big[ --- */
      { 104,12367,                      /* character number, location */
          1, 3,  -23, 3,      /* topleft row,col, and botleft row,col */
          {  4,   24, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x3f\x61\x34" }  },
      /* --- pixel bitmap for cmex100 char#105 \Big] --- */
      { 105,17954,                      /* character number, location */
          1, 0,  -23, 0,      /* topleft row,col, and botleft row,col */
          {  4,   24, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x31\xf6\x31\x04" }  },
      /* --- pixel bitmap for cmex100 char#106 (noname) --- */
      { 106,23462,                      /* character number, location */
          1, 3,  -23, 3,      /* topleft row,col, and botleft row,col */
          {  4,   24, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x3f\x71\x34" }  },
      /* --- pixel bitmap for cmex100 char#107 (noname) --- */
      { 107,26796,                      /* character number, location */
          1, 0,  -23, 0,      /* topleft row,col, and botleft row,col */
          {  4,   24, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x31\xf7\x31\x04" }  },
      /* --- pixel bitmap for cmex100 char#108 (noname) --- */
      { 108,30134,                      /* character number, location */
          1, 3,  -23, 3,      /* topleft row,col, and botleft row,col */
          {  4,   24, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x3f\x71\x31" }  },
      /* --- pixel bitmap for cmex100 char#109 (noname) --- */
      { 109,33476,                      /* character number, location */
          1, 0,  -23, 0,      /* topleft row,col, and botleft row,col */
          {  4,   24, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x31\xf7\x31" }  },
      /* --- pixel bitmap for cmex100 char#110 \Big{ --- */
      { 110,37086,                      /* character number, location */
          1, 2,  -23, 2,      /* topleft row,col, and botleft row,col */
          {  5,   24, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x31\x10\xf8\x21\x20\xf1\x11\x30\xf8\x21\x20\x31"
            "\x51" }  },
      /* --- pixel bitmap for cmex100 char#111 \Big} --- */
      { 111,44598,                      /* character number, location */
          1, 2,  -23, 2,      /* topleft row,col, and botleft row,col */
          {  5,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x10\x42\x08\x21\x84\x10\x8c\x08\x21\x84\x10\x42"
            "\x88\x08" }  },
      /* --- pixel bitmap for cmex100 char#112 (noname) --- */
      { 112,70256,                      /* character number, location */
          1, 2,  -16, 2,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x10\x00\x01\x20\x00\x02\x40\x00\x04\x80\x00\x08"
            "\x00\x61\x10\x08\x02\x22\x40\x04\x50\x00\x0a\xc0\x00"
            "\x10\x00" }  },
      /* --- pixel bitmap for cmex100 char#113 (noname) --- */
      { 113,71185,                      /* character number, location */
          1, 2,  -24, 2,      /* topleft row,col, and botleft row,col */
          { 13,   25, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xc1\xf2\xb1\x10\xf2\xa1\x20\xf2\x91\x30\xf1\x81"
            "\x40\x11\x61\x42\x51\x61\x51\x71\x41\x50\xf2\x21\x31"
            "\x60\xf2\x31\x11\x70\xf1\x41\x81" }  },
      /* --- pixel bitmap for cmex100 char#114 (noname) --- */
      { 114,72139,                      /* character number, location */
          1, 2,  -33, 2,      /* topleft row,col, and botleft row,col */
          { 13,   34, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xc1\xf3\xb1\x10\xf3\xa1\x20\xf3\x91\x30\xf1\x81"
            "\x40\x11\x61\x42\x61\x42\x51\x50\xf1\x11\x51\x50\x21"
            "\x41\x50\xf3\x21\x31\x60\xf3\x31\x11\x70\x32\x80\xf1"
            "\x41\x82" }  },
      /* --- pixel bitmap for cmex100 char#115 (noname) --- */
      { 115,73119,                      /* character number, location */
          1, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 13,   42, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xc1\xf4\xb1\x10\xf4\xa1\x20\xf4\x91\x30\xf2\x81"
            "\x40\xf1\x11\x61\x42\x61\x40\xf2\x11\x51\x50\xf1\x21"
            "\x41\x50\xf3\x21\x31\x60\x31\x21\x60\xf4\x31\x11\x70"
            "\xf2\x41\x80" }  },
      /* --- pixel bitmap for cmex100 char#116 (noname) --- */
      { 116,74163,                      /* character number, location */
          1, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 10,   26, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x91\x11\x71\x12\x62\x11\x61\x21\x61\xf1\x31\x51"
            "\xf2\x41\x41\xf2\x51\x31\xf2\x61\x21\xf2\x71\x11\xf2"
            "\x82\x91" }  },
      /* --- pixel bitmap for cmex100 char#117 (noname) --- */
      { 117,75016,                      /* character number, location */
          1,10,   -9,10,      /* topleft row,col, and botleft row,col */
          {  1,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03" }  },
      /* --- pixel bitmap for cmex100 char#118 (noname) --- */
      { 118,75801,                      /* character number, location */
          1,10,   -9,10,      /* topleft row,col, and botleft row,col */
          {  6,   10, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\x81\x51" }  },
      /* --- pixel bitmap for cmex100 char#119 (noname) --- */
      { 119,69333,                      /* character number, location */
          1, 4,   -9, 4,      /* topleft row,col, and botleft row,col */
          {  4,   10, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x01\x21" }  },
      /* --- pixel bitmap for cmex100 char#120 (noname) --- */
      { 120,64827,                      /* character number, location */
          0, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xce\x1a\x81\x40\x20\x10" }  },
      /* --- pixel bitmap for cmex100 char#121 (noname) --- */
      { 121,65720,                      /* character number, location */
          0, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x02\x81\x58\x73\x10" }  },
      /* --- pixel bitmap for cmex100 char#122 (noname) --- */
      { 122,49998,                      /* character number, location */
          2,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xf8\x0c\x02\x01" }  },
      /* --- pixel bitmap for cmex100 char#123 (noname) --- */
      { 123,50550,                      /* character number, location */
          2,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x1f\x30\x40\x80" }  },
      /* --- pixel bitmap for cmex100 char#124 (noname) --- */
      { 124,51099,                      /* character number, location */
          5,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x02\x0c\xf8\xe0" }  },
      /* --- pixel bitmap for cmex100 char#125 (noname) --- */
      { 125,51649,                      /* character number, location */
          5,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  8,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x40\x30\x1f\x07" }  },
      /* --- pixel bitmap for cmex100 char#126 (noname) --- */
      { 126,67429,                      /* character number, location */
         -1, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          { 10,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x20\xc1\xcc\xd2\x48\x20\x81\x04" }  },
      /* --- pixel bitmap for cmex100 char#127 (noname) --- */
      { 127,68485,                      /* character number, location */
          0, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 10,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x20\x81\xc4\xd2\xcc\x20\x01\x03" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=2 for .118gf ---
 * mf '\mode=preview; mag=magstep(-16.96645799324018499600); input cmex10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmex118 --- */
static	chardef  cmex118[] =
   {
      /* --- pixel bitmap for cmex118 char#0 \big( --- */
      {   0,  635,                      /* character number, location */
          1, 2,  -18, 2,      /* topleft row,col, and botleft row,col */
          {  4,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x24\x12\x11\x11\x11\x11\x22\x44\x08" }  },
      /* --- pixel bitmap for cmex118 char#1 \big) --- */
      {   1, 6234,                      /* character number, location */
          1, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          {  4,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x42\x84\x88\x88\x88\x88\x44\x22\x01" }  },
      /* --- pixel bitmap for cmex118 char#2 \big[ --- */
      {   2,11853,                      /* character number, location */
          1, 3,  -18, 3,      /* topleft row,col, and botleft row,col */
          {  4,   19, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x3f\x11\x34" }  },
      /* --- pixel bitmap for cmex118 char#3 \big] --- */
      {   3,17571,                      /* character number, location */
          1, 0,  -18, 0,      /* topleft row,col, and botleft row,col */
          {  4,   19, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x31\xf1\x31\x04" }  },
      /* --- pixel bitmap for cmex118 char#4 (noname) --- */
      {   4,23204,                      /* character number, location */
          1, 3,  -18, 3,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x4f\x21\x45" }  },
      /* --- pixel bitmap for cmex118 char#5 (noname) --- */
      {   5,26671,                      /* character number, location */
          1, 0,  -18, 0,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x41\xf2\x41\x05" }  },
      /* --- pixel bitmap for cmex118 char#6 (noname) --- */
      {   6,30062,                      /* character number, location */
          1, 3,  -18, 3,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\x21\x41" }  },
      /* --- pixel bitmap for cmex118 char#7 (noname) --- */
      {   7,33537,                      /* character number, location */
          1, 0,  -18, 0,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xf2\x41" }  },
      /* --- pixel bitmap for cmex118 char#8 \big{ --- */
      {   8,37081,                      /* character number, location */
          1, 2,  -18, 2,      /* topleft row,col, and botleft row,col */
          {  6,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x86\x20\x08\x82\x20\xc4\x40\x20\x08\x82\x20\x08"
            "\x06\x02" }  },
      /* --- pixel bitmap for cmex118 char#9 \big} --- */
      {   9,44708,                      /* character number, location */
          1, 2,  -18, 2,      /* topleft row,col, and botleft row,col */
          {  6,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x81\x20\x08\x82\x20\x18\x88\x21\x08\x82\x20\x08"
            "\x31\x00" }  },
      /* --- pixel bitmap for cmex118 char#10 \big< --- */
      {  10,53380,                      /* character number, location */
          1, 2,  -18, 2,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x22\x44\x88\x10\x21\x04\x21\x08\x41\x08\x42" }  },
      /* --- pixel bitmap for cmex118 char#11 \big> --- */
      {  11,56175,                      /* character number, location */
          1, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x08\x41\x08\x42\x10\x42\x84\x08\x11\x22\x04" }  },
      /* --- pixel bitmap for cmex118 char#12 (noname) --- */
      {  12,64825,                      /* character number, location */
          1, 2,  -11, 2,      /* topleft row,col, and botleft row,col */
          {  1,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f" }  },
      /* --- pixel bitmap for cmex118 char#13 (noname) --- */
      {  13,65416,                      /* character number, location */
          1, 2,  -11, 2,      /* topleft row,col, and botleft row,col */
          {  5,   12, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x01\x31" }  },
      /* --- pixel bitmap for cmex118 char#14 (noname) --- */
      {  14,58930,                      /* character number, location */
          1, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          {  7,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x08\x04\x82\x40\x20\x08\x04\x82\x40\x20\x08"
            "\x04\x82\x40\x00" }  },
      /* --- pixel bitmap for cmex118 char#15 (noname) --- */
      {  15,61922,                      /* character number, location */
          1, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          {  7,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\x40\x20\x20\x10\x08\x08\x04\x02\x02\x81\x80"
            "\x40\x20\x20\x10" }  },
      /* --- pixel bitmap for cmex118 char#16 \Big( --- */
      {  16, 1358,                      /* character number, location */
          1, 3,  -28, 3,      /* topleft row,col, and botleft row,col */
          {  6,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x84\x20\x04\x21\x08\x42\x10\x04\x41\x10\x04\x41"
            "\x10\x04\x82\x20\x10\x04\x82\x40\x20" }  },
      /* --- pixel bitmap for cmex118 char#17 \Big) --- */
      {  17, 6944,                      /* character number, location */
          1, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          {  6,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x40\x10\x08\x02\x41\x10\x08\x82\x20\x08\x82\x20"
            "\x08\x82\x10\x04\x21\x08\x41\x08\x01" }  },
      /* --- pixel bitmap for cmex118 char#18 \bigg( --- */
      {  18, 2154,                      /* character number, location */
          1, 3,  -38, 3,      /* topleft row,col, and botleft row,col */
          {  8,   39, 3,66, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x61\x61\x20\xf1\x41\x30\xf1\x31\x40\xf1\x21\x50"
            "\xf3\x11\x6f\xc1\x70\xf3\x11\x60\xf1\x21\x50\xf1\x31"
            "\x40\xf1\x41\x30\x51\x81\x81" }  },
      /* --- pixel bitmap for cmex118 char#19 \bigg) --- */
      {  19, 7727,                      /* character number, location */
          1, 1,  -38, 1,      /* topleft row,col, and botleft row,col */
          {  8,   39, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x81\x50\xf1\x31\x40\xf1\x41\x30\xf1\x51\x20"
            "\xf3\x61\x10\xfc\x71\xf3\x61\x10\xf1\x51\x20\xf1\x41"
            "\x30\xf1\x31\x40\x21\x61\x61\x71" }  },
      /* --- pixel bitmap for cmex118 char#20 \bigg[ --- */
      {  20,13490,                      /* character number, location */
          1, 4,  -38, 4,      /* topleft row,col, and botleft row,col */
          {  5,   39, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\xe1\x4f\x61\x45" }  },
      /* --- pixel bitmap for cmex118 char#21 \bigg] --- */
      {  21,19156,                      /* character number, location */
          1, 0,  -38, 0,      /* topleft row,col, and botleft row,col */
          {  5,   39, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xfe\x41\xf6\x41\x05" }  },
      /* --- pixel bitmap for cmex118 char#22 (noname) --- */
      {  22,24905,                      /* character number, location */
          1, 4,  -38, 4,      /* topleft row,col, and botleft row,col */
          {  6,   39, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x25\x00\x01\x05\x06" }  },
      /* --- pixel bitmap for cmex118 char#23 (noname) --- */
      {  23,28320,                      /* character number, location */
          1, 0,  -38, 0,      /* topleft row,col, and botleft row,col */
          {  6,   39, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x25\x05\x01\x00\x06" }  },
      /* --- pixel bitmap for cmex118 char#24 (noname) --- */
      {  24,31767,                      /* character number, location */
          1, 4,  -38, 4,      /* topleft row,col, and botleft row,col */
          {  6,   39, 2, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x00\xff\x25\x01\x05" }  },
      /* --- pixel bitmap for cmex118 char#25 (noname) --- */
      {  25,35190,                      /* character number, location */
          1, 0,  -38, 0,      /* topleft row,col, and botleft row,col */
          {  6,   39, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\xff\x25\x05\x01" }  },
      /* --- pixel bitmap for cmex118 char#26 \bigg{ --- */
      {  26,39054,                      /* character number, location */
          1, 2,  -38, 2,      /* topleft row,col, and botleft row,col */
          {  8,   39, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\x51\x61\x30\xfd\x31\x40\x21\x61\x61\x81\x81\x50"
            "\xfd\x31\x40\x41\x81\x82" }  },
      /* --- pixel bitmap for cmex118 char#27 \bigg} --- */
      {  27,46683,                      /* character number, location */
          1, 2,  -38, 2,      /* topleft row,col, and botleft row,col */
          {  8,   39, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x81\x50\xfd\x31\x40\x41\x81\x82\x51\x61\x30"
            "\xfd\x31\x40\x21\x61\x61\x72" }  },
      /* --- pixel bitmap for cmex118 char#28 \bigg< --- */
      {  28,54763,                      /* character number, location */
          1, 2,  -38, 2,      /* topleft row,col, and botleft row,col */
          {  9,   39, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x02\x02\x04\x04\x08\x08\x10\x20\x20\x40\x40"
            "\x80\x00\x01\x01\x02\x02\x04\x04\x08\x10\x40\x80\x00"
            "\x02\x04\x10\x20\x40\x00\x01\x02\x08\x10\x20\x80\x00"
            "\x01\x04\x08\x20\x40" }  },
      /* --- pixel bitmap for cmex118 char#29 \bigg> --- */
      {  29,57560,                      /* character number, location */
          1, 1,  -38, 1,      /* topleft row,col, and botleft row,col */
          {  9,   39, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x02\x08\x10\x40\x80\x00\x02\x04\x08\x20\x40\x00"
            "\x01\x02\x04\x10\x20\x80\x00\x01\x04\x08\x10\x10\x20"
            "\x20\x40\x40\x80\x00\x01\x01\x02\x02\x04\x08\x08\x10"
            "\x10\x20\x20\x40\x00" }  },
      /* --- pixel bitmap for cmex118 char#30 (noname) --- */
      {  30,60385,                      /* character number, location */
          1, 1,  -38, 1,      /* topleft row,col, and botleft row,col */
          { 15,   39, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe1\xd2\xf1\xd1\x10\xc2\x10\xf1\xc1\x20\xb2\xd1\xd2"
            "\x30\xf1\xa1\x40\x92\x40\xf1\x91\x50\x82\x50\xf1\x81"
            "\x60\x72\xd1\xd2\x70\xf1\x61\x80\x52\x80\xf1\x51\x90"
            "\x42\x90\xf1\x41\xa0\x32\xd1\xd2\xb0\xf1\x21\xc0\x12"
            "\xc0\xf1\x11\xd2\xd1\xe0" }  },
      /* --- pixel bitmap for cmex118 char#31 (noname) --- */
      {  31,63385,                      /* character number, location */
          1, 1,  -38, 1,      /* topleft row,col, and botleft row,col */
          { 15,   39, 3,118, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xe2\xd0\xf1\x11\xd0\x12\xc0\xf1\x21\xc0\x22\xe1"
            "\xe2\xa0\xf1\x41\xa0\x42\x90\xf1\x51\x90\x52\x80\xf1"
            "\x61\x80\x62\xe1\xe2\x60\xf1\x81\x60\x82\x50\xf1\x91"
            "\x50\x92\x40\xf1\xa1\x40\xa2\xe1\xe2\x20\xf1\xc1\x20"
            "\xc2\x10\xf1\xd1\x10\xd2\xe1" }  },
      /* --- pixel bitmap for cmex118 char#32 \Bigg( --- */
      {  32, 3022,                      /* character number, location */
          1, 4,  -47, 4,      /* topleft row,col, and botleft row,col */
          {  8,   48, 3,78, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x61\x62\x61\x62\x61\x62\x61\x40\xf1\x22\x40\x21"
            "\x50\xf3\x12\x50\x11\x6f\xe2\x62\x71\x60\xf3\x12\x50"
            "\x21\x50\xf1\x22\x40\x31\x72\x71\x72\x71\x72\x71\x81" }  },
      /* --- pixel bitmap for cmex118 char#33 \Bigg) --- */
      {  33, 8556,                      /* character number, location */
          1, 1,  -47, 1,      /* topleft row,col, and botleft row,col */
          {  8,   48, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x72\x71\x72\x71\x72\x71\x30\xf1\x42\x20\x51"
            "\x20\xf3\x52\x10\x61\x10\xfe\x62\x62\x61\x10\xf3\x52"
            "\x10\x51\x20\xf1\x42\x20\x41\x62\x61\x62\x61\x62\x61"
            "\x61\x70" }  },
      /* --- pixel bitmap for cmex118 char#34 \Bigg[ --- */
      {  34,14391,                      /* character number, location */
          1, 5,  -47, 5,      /* topleft row,col, and botleft row,col */
          {  5,   48, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x05\x00\xff\x2d\x01\x04\x05" }  },
      /* --- pixel bitmap for cmex118 char#35 \Bigg] --- */
      {  35,20018,                      /* character number, location */
          1, 0,  -47, 0,      /* topleft row,col, and botleft row,col */
          {  5,   48, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xfe\x41\xfe\x41\x46" }  },
      /* --- pixel bitmap for cmex118 char#36 (noname) --- */
      {  36,25838,                      /* character number, location */
          1, 5,  -47, 5,      /* topleft row,col, and botleft row,col */
          {  5,   48, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x2e\x00\x01\x04\x05" }  },
      /* --- pixel bitmap for cmex118 char#37 (noname) --- */
      {  37,29214,                      /* character number, location */
          1, 0,  -47, 0,      /* topleft row,col, and botleft row,col */
          {  5,   48, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x2e\x04\x01\x00\x05" }  },
      /* --- pixel bitmap for cmex118 char#38 (noname) --- */
      {  38,32702,                      /* character number, location */
          1, 5,  -47, 5,      /* topleft row,col, and botleft row,col */
          {  5,   48, 2, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x05\x00\xff\x2e\x01\x04" }  },
      /* --- pixel bitmap for cmex118 char#39 (noname) --- */
      {  39,36086,                      /* character number, location */
          1, 0,  -47, 0,      /* topleft row,col, and botleft row,col */
          {  5,   48, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x05\xff\x2e\x04\x01" }  },
      /* --- pixel bitmap for cmex118 char#40 \Bigg{ --- */
      {  40,40084,                      /* character number, location */
          1, 2,  -47, 2,      /* topleft row,col, and botleft row,col */
          {  9,   48, 3,68, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x62\x10\xf1\x52\x20\xfe\x42\x30\x42\x30\xf1\x32"
            "\x40\x22\x50\xf1\x11\x70\x22\x50\xf1\x32\x40\xfe\x42"
            "\x30\x42\x30\xf1\x52\x20\x62\x91" }  },
      /* --- pixel bitmap for cmex118 char#41 \Bigg} --- */
      {  41,47714,                      /* character number, location */
          1, 2,  -47, 2,      /* topleft row,col, and botleft row,col */
          {  9,   48, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x82\x91\x82\x40\xfe\x42\x30\x42\x81\x82\x81\x92"
            "\x71\x71\x72\x71\x30\xfe\x42\x30\x42\x62\x71\x62\x62"
            "\x70" }  },
      /* --- pixel bitmap for cmex118 char#42 \Bigg< --- */
      {  42,55511,                      /* character number, location */
          1, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 10,   49, 3,108, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x91\xf2\x81\x10\xf1\x71\x20\xf2\x61\x30\xf1\x51"
            "\x40\xf2\x41\x50\xf2\x31\x60\xf1\x21\x70\xf2\x11\x8f"
            "\x21\x90\xf2\x11\x80\xf1\x21\x70\xf2\x31\x60\xf2\x41"
            "\x50\xf1\x51\x40\xf2\x61\x30\xf1\x71\x20\xf2\x81\x10"
            "\xf1\x91" }  },
      /* --- pixel bitmap for cmex118 char#43 \Bigg> --- */
      {  43,58309,                      /* character number, location */
          1, 1,  -48, 1,      /* topleft row,col, and botleft row,col */
          { 10,   49, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x01\x90\xf2\x11\x80\xf1\x21\x70\xf2\x31\x60\xf1"
            "\x41\x50\xf2\x51\x40\xf2\x61\x30\xf1\x71\x20\xf2\x81"
            "\x10\xf2\x91\xf2\x81\x10\xf1\x71\x20\xf2\x61\x30\xf2"
            "\x51\x40\xf1\x41\x50\xf2\x31\x60\xf1\x21\x70\xf2\x11"
            "\x8f\x11\x90" }  },
      /* --- pixel bitmap for cmex118 char#44 / --- */
      {  44,61299,                      /* character number, location */
          1, 1,  -47, 1,      /* topleft row,col, and botleft row,col */
          { 19,   48, 3,185, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x41\xe0\x32\xf1\xe0\x31\x10\xe0\x22\x10\xf1\xe0"
            "\x21\x20\xe0\x12\xe0\x31\xe0\x32\x30\xf1\xe1\x40\xd2"
            "\xe0\x31\xe0\x32\x50\xf1\xc1\x60\xb2\x60\xf1\xb1\x70"
            "\xa2\xe0\x31\xe0\x32\x80\xf1\x91\x90\x82\xe0\x31\xe0"
            "\x32\xa0\xf1\x71\xb0\x62\xb0\xf1\x61\xc0\x52\xe0\x31"
            "\xe0\x32\xd0\xf1\x41\xe0\x32\xe0\x31\xe0\x32\xe0\x10"
            "\xf1\x21\xe0\x20\x12\xe0\x20\xf1\x11\xe0\x32\xe0\x31"
            "\xe0\x40" }  },
      /* --- pixel bitmap for cmex118 char#45 \ --- */
      {  45,64303,                      /* character number, location */
          1, 1,  -47, 1,      /* topleft row,col, and botleft row,col */
          { 19,   48, 3,184, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x42\xe0\x30\xf1\x11\xe0\x30\x12\xe0\x20\xf1"
            "\x21\xe0\x20\x22\xe0\x41\xe0\x42\xe0\xf1\x41\xe0\x42"
            "\xe0\x41\xe0\x42\xc0\xf1\x61\xc0\x62\xb0\xf1\x71\xb0"
            "\x72\xe0\x41\xe0\x42\x90\xf1\x91\x90\x92\xe0\x41\xe0"
            "\x42\x70\xf1\xb1\x70\xb2\x60\xf1\xc1\x60\xc2\xe0\x41"
            "\xe0\x42\x40\xf1\xe1\x40\xe2\xe0\x41\xe0\x42\x20\xf1"
            "\xe0\x21\x20\xe0\x22\x10\xf1\xe0\x31\x10\xe0\x32\xe0"
            "\x41" }  },
      /* --- pixel bitmap for cmex118 char#46 / --- */
      {  46,59595,                      /* character number, location */
          1, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          { 11,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x04\x30\x80\x00\x04\x30\x80\x00\x04\x30\x80\x00"
            "\x04\x30\x80\x00\x04\x30\x80\x00\x06\x10\x80\x00\x06"
            "\x10\x80\x00\x06\x10\x80\x00\x06\x10\x80\x00\x06\x10"
            "\x00" }  },
      /* --- pixel bitmap for cmex118 char#47 \ --- */
      {  47,62591,                      /* character number, location */
          1, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          { 11,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x18\x80\x00\x04\x60\x00\x02\x10\x80\x01\x08\x40"
            "\x00\x06\x20\x00\x01\x18\x80\x00\x0c\x40\x00\x02\x30"
            "\x00\x01\x08\xc0\x00\x04\x20\x00\x03\x10\x80\x00\x0c"
            "\x40" }  },
      /* --- pixel bitmap for cmex118 char#48 \leftparentop --- */
      {  48, 3898,                      /* character number, location */
          0, 5,  -30, 5,      /* topleft row,col, and botleft row,col */
          {  9,   30, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x71\x72\x71\x72\x71\x72\x71\x72\x40\xf1\x31\x50"
            "\xf1\x22\x50\x21\x60\xf4\x12\x60\x11\x7f\x92\x72" }  },
      /* --- pixel bitmap for cmex118 char#49 \rightparentop --- */
      {  49, 9419,                      /* character number, location */
          0, 0,  -30, 0,      /* topleft row,col, and botleft row,col */
          {  9,   30, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x91\x82\x81\x82\x81\x82\x81\x82\x30\xf1\x51\x30"
            "\xf1\x52\x20\x61\x20\xf4\x62\x10\x71\x10\xf9\x72" }  },
      /* --- pixel bitmap for cmex118 char#50 (noname) --- */
      {  50,15253,                      /* character number, location */
          0, 6,  -29, 6,      /* topleft row,col, and botleft row,col */
          {  5,   29, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\xc1\x4f" }  },
      /* --- pixel bitmap for cmex118 char#51 (noname) --- */
      {  51,20867,                      /* character number, location */
          0, 0,  -29, 0,      /* topleft row,col, and botleft row,col */
          {  5,   29, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xfc\x41" }  },
      /* --- pixel bitmap for cmex118 char#52 (noname) --- */
      {  52,16099,                      /* character number, location */
          1, 6,  -28, 6,      /* topleft row,col, and botleft row,col */
          {  5,   29, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x4f\xc1\x45" }  },
      /* --- pixel bitmap for cmex118 char#53 (noname) --- */
      {  53,21700,                      /* character number, location */
          1, 0,  -28, 0,      /* topleft row,col, and botleft row,col */
          {  5,   29, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x41\xfc\x41\x05" }  },
      /* --- pixel bitmap for cmex118 char#54 (noname) --- */
      {  54,16842,                      /* character number, location */
          1, 6,  -11, 6,      /* topleft row,col, and botleft row,col */
          {  1,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f" }  },
      /* --- pixel bitmap for cmex118 char#55 (noname) --- */
      {  55,22430,                      /* character number, location */
          1, 4,  -11, 4,      /* topleft row,col, and botleft row,col */
          {  1,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f" }  },
      /* --- pixel bitmap for cmex118 char#56 \leftbracetop --- */
      {  56,41033,                      /* character number, location */
         -1, 7,  -16, 7,      /* topleft row,col, and botleft row,col */
          {  5,   15, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x31\x31\x32\x31\x3f\x92\x32" }  },
      /* --- pixel bitmap for cmex118 char#57 \rightbracetop --- */
      {  57,48664,                      /* character number, location */
         -1, 3,  -16, 3,      /* topleft row,col, and botleft row,col */
          {  6,   15, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x62\x52\x20\xf1\x32\x10\xf9\x42" }  },
      /* --- pixel bitmap for cmex118 char#58 \leftbracebot --- */
      {  58,41938,                      /* character number, location */
          1, 7,  -14, 7,      /* topleft row,col, and botleft row,col */
          {  5,   15, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x02\x30\x11\x42\x41\x51\x51" }  },
      /* --- pixel bitmap for cmex118 char#59 \rightbracebot --- */
      {  59,49570,                      /* character number, location */
          1, 3,  -14, 3,      /* topleft row,col, and botleft row,col */
          {  6,   15, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x42\xf1\x32\x10\x22\x32\x31\x52" }  },
      /* --- pixel bitmap for cmex118 char#60 \leftbracemid --- */
      {  60,42918,                      /* character number, location */
          1, 3,  -30, 3,      /* topleft row,col, and botleft row,col */
          {  6,   31, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x42\xf1\x32\x10\x22\x32\x31\x62\x52\x20\xf1\x32"
            "\x10\xfa\x42" }  },
      /* --- pixel bitmap for cmex118 char#61 \rightbracemid --- */
      {  61,50551,                      /* character number, location */
          1, 7,  -30, 7,      /* topleft row,col, and botleft row,col */
          {  5,   31, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x02\x30\x11\x42\x41\x51\x51\x31\x31\x32\x31\x3f"
            "\xa2\x31" }  },
      /* --- pixel bitmap for cmex118 char#62 \leftbracebar --- */
      {  62,43794,                      /* character number, location */
          1, 7,   -6, 7,      /* topleft row,col, and botleft row,col */
          {  2,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3f" }  },
      /* --- pixel bitmap for cmex118 char#63 (noname) --- */
      {  63,67901,                      /* character number, location */
          1, 5,  -11, 5,      /* topleft row,col, and botleft row,col */
          {  1,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f" }  },
      /* --- pixel bitmap for cmex118 char#64 \leftparenbot --- */
      {  64, 4760,                      /* character number, location */
          2, 5,  -28, 5,      /* topleft row,col, and botleft row,col */
          {  9,   30, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x02\x70\x11\x70\xf4\x12\x60\x21\x60\xf1\x22\x50"
            "\xf1\x31\x50\x32\x81\x82\x81\x82\x81\x82\x81\x91" }  },
      /* --- pixel bitmap for cmex118 char#65 \rightparenbot --- */
      {  65,10268,                      /* character number, location */
          2, 0,  -28, 0,      /* topleft row,col, and botleft row,col */
          {  9,   30, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x72\x71\x10\xf4\x62\x10\x61\x20\xf1\x52\x20\xf1"
            "\x51\x30\x42\x71\x72\x71\x72\x71\x72\x71\x71\x82" }  },
      /* --- pixel bitmap for cmex118 char#66 \leftparenbar --- */
      {  66, 5616,                      /* character number, location */
          1, 5,  -11, 5,      /* topleft row,col, and botleft row,col */
          {  2,   12, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x02" }  },
      /* --- pixel bitmap for cmex118 char#67 \rightparenbar --- */
      {  67,11111,                      /* character number, location */
          1, 7,  -11, 7,      /* topleft row,col, and botleft row,col */
          {  2,   12, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x02" }  },
      /* --- pixel bitmap for cmex118 char#68 \Big< --- */
      {  68,54035,                      /* character number, location */
          1, 2,  -28, 2,      /* topleft row,col, and botleft row,col */
          {  7,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x08\x04\x81\x20\x10\x08\x02\x41\x20\x08\x04"
            "\x02\x02\x01\x81\x80\x40\x20\x20\x10\x10\x08\x08\x04" }  },
      /* --- pixel bitmap for cmex118 char#69 \Big> --- */
      {  69,56831,                      /* character number, location */
          1, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          {  7,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\x40\x40\x20\x20\x10\x08\x08\x04\x04\x02\x02"
            "\x81\x20\x10\x04\x82\x40\x20\x08\x04\x81\x20\x10\x00" }  },
      /* --- pixel bitmap for cmex118 char#70 \bigsqcup --- */
      {  70,78108,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\xa1\x0c" }  },
      /* --- pixel bitmap for cmex118 char#71 \Bigsqcup --- */
      {  71,79001,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\xe1\x0f\x61\xe1\x0e\x02" }  },
      /* --- pixel bitmap for cmex118 char#72 \oint --- */
      {  72,97441,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          {  9,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x40\x82\x00\x01\x01\x02\x0e\x2a\x92\x24\x51\xc1"
            "\x01\x01\x02\x02\x04\x09\x0c\x00" }  },
      /* --- pixel bitmap for cmex118 char#73 \Bigoint --- */
      {  73,98483,                      /* character number, location */
          0, 1,  -36, 1,      /* topleft row,col, and botleft row,col */
          { 14,   36, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb2\xc1\x11\xf1\xa1\x12\xf2\x91\x40\xf1\x82\x40\xf1"
            "\x81\x50\xf1\x72\x50\x55\x81\x22\x11\x61\x31\x31\x20"
            "\xf3\x31\x22\x31\x20\x41\x11\x31\x85\x40\xf2\x52\x70"
            "\xf1\x51\x80\xf1\x42\x80\xf2\x41\x9f\x12\x11\xa1\x11"
            "\xc2\xb1" }  },
      /* --- pixel bitmap for cmex118 char#74 \bigodot --- */
      {  74,79977,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x82\x62\x51\xa1\x20\xf1\x11\xc1\x1f\x11\xe1\x0f"
            "\x11\x62\x61\x0f\x11\xe1\xf1\x11\xc1\x10\x21\xa1\x52"
            "\x62\x86\x51" }  },
      /* --- pixel bitmap for cmex118 char#75 \Bigodot --- */
      {  75,81138,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 23,   23, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x72\xb1\xb1\x82\xd2\x61\xe0\x11\x51\xe0\x31"
            "\x20\xf1\x11\xe0\x51\x1f\x11\xe0\x71\x01\xa1\xa2\x93"
            "\x92\xa1\xa1\x0f\x11\xe0\x71\xf1\x11\xe0\x51\x10\x21"
            "\xe0\x31\x51\xe0\x11\x62\xd2\x81\xb1\xb2\x72\xe7\x80" }  },
      /* --- pixel bitmap for cmex118 char#76 \bigoplus --- */
      {  76,82119,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 16,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x07\x18\x19\x04\x21\x02\x41\x02\x41\x01\x81\x01"
            "\x81\xff\xff\x01\x81\x01\x81\x01\x81\x02\x41\x02\x41"
            "\x04\x21\x18\x19\xe0\x07" }  },
      /* --- pixel bitmap for cmex118 char#77 \Bigoplus --- */
      {  77,83301,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 23,   23, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x31\x32\xb1\x51\x51\x82\x61\x62\x61\x71\x71"
            "\x51\x81\x81\x20\xf1\x11\x91\x91\x1f\x21\xa1\xa1\x0e"
            "\x09\x0f\x21\xa1\xa1\xf1\x11\x91\x91\x10\x21\x81\x81"
            "\x51\x71\x71\x62\x61\x62\x81\x51\x51\xb2\x31\x32\xe7"
            "\x82" }  },
      /* --- pixel bitmap for cmex118 char#78 \bigotimes --- */
      {  78,84315,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 16,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x07\x18\x18\x04\x20\x0a\x50\x12\x48\x21\x84\x41"
            "\x82\x81\x81\x81\x81\x41\x82\x21\x84\x12\x48\x0a\x50"
            "\x04\x20\x18\x18\xe0\x07" }  },
      /* --- pixel bitmap for cmex118 char#79 \Bigotimes --- */
      {  79,85510,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 23,   23, 3,131, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x72\xb1\xb1\x50\xf1\x32\xd2\x30\x21\x21\xb1"
            "\x21\x31\x41\x91\x41\x21\x51\x71\x51\x11\x71\x51\x72"
            "\x81\x31\x82\x91\x11\x92\xa1\xa2\x91\x11\x92\x81\x31"
            "\x82\x71\x51\x71\x11\x51\x71\x51\x21\x41\x91\x41\x31"
            "\x21\xb1\x21\x20\xf1\x32\xd2\x30\x51\xb1\xb2\x72\xe7"
            "\x80" }  },
      /* --- pixel bitmap for cmex118 char#80 \sum --- */
      {  80,86870,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 15,   16, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x12\xa2\x21\xb2\x21\xb1\x31\xe0\x11\xe2\x90\xf2"
            "\x51\x90\x41\xd1\xd2\xa1\x21\xa2\x11\xa2\x1e\x11" }  },
      /* --- pixel bitmap for cmex118 char#81 \prod --- */
      {  81,89752,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 13,   16, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\xfd\x22\x52\x26\x16" }  },
      /* --- pixel bitmap for cmex118 char#82 \int --- */
      {  82,95408,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          {  9,   18, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\x61\x21\xf1\x51\x30\xf9\x41\x40\xf1\x31\x51\x21"
            "\x62\x63" }  },
      /* --- pixel bitmap for cmex118 char#83 \bigcup --- */
      {  83,99301,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x01\xa1\x11\x81\x32\x42\x64\x40" }  },
      /* --- pixel bitmap for cmex118 char#84 \bigcap --- */
      {  84,101005,                     /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x62\x42\x31\x81\x1f\xc1\xa1" }  },
      /* --- pixel bitmap for cmex118 char#85 \biguplus --- */
      {  85,102774,                     /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x01\xa1\x0f\x21\x51\x41\x01\x18\x11\x0f\x21\x51"
            "\x41\x0f\x11\xa1\x11\x81\x32\x42\x64\x41" }  },
      /* --- pixel bitmap for cmex118 char#86 \bigwedge --- */
      {  86,104548,                     /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x50\xf1\x52\x50\xf2\x41\x21\x40\xf2\x31\x41\x30"
            "\xf1\x21\x61\x20\xf2\x11\x81\x1f\x11\xa1" }  },
      /* --- pixel bitmap for cmex118 char#87 \bigvee --- */
      {  87,106190,                     /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x18\x80\x02\x24\x40\x02\x44\x20\x04\x82\x10\x08"
            "\x81\x10\x90\x00\x09\x90\x00\x06\x60\x00\x04" }  },
      /* --- pixel bitmap for cmex118 char#88 \Bigsum --- */
      {  88,88321,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 22,   23, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x0e\x06\x23\xe4\x23\xe0\x12\x33\xe0\x11\x43\xe0\x11"
            "\x33\xe0\x63\xe0\x63\xe0\x63\xe0\x62\xe0\x63\xe0\x63"
            "\xe0\x61\xe0\x61\xe0\x61\xe0\x62\xe0\x52\xe0\x52\xe0"
            "\x11\x41\xe0\x11\x41\xe0\x12\x32\xd4\x2e\x05\x2e\x06"
            "\x21" }  },
      /* --- pixel bitmap for cmex118 char#89 \Bigprod --- */
      {  89,91342,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 19,   23, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x05\x23\x93\x20\xfe\x32\x92\x30\xf3\x32\x92\x30"
            "\x24\x74\x28\x38" }  },
      /* --- pixel bitmap for cmex118 char#90 \Bigint --- */
      {  90,96426,                      /* character number, location */
          0, 1,  -36, 1,      /* topleft row,col, and botleft row,col */
          { 14,   36, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb2\xc1\x11\xf1\xa1\x12\xf2\x91\x40\xf1\x82\x40\xf1"
            "\x81\x50\xf3\x72\x50\x71\x60\xf3\x62\x60\x61\x70\xf3"
            "\x52\x70\xf1\x51\x80\xf1\x42\x80\xf2\x41\x9f\x12\x11"
            "\xa1\x11\xc2\xb1" }  },
      /* --- pixel bitmap for cmex118 char#91 \Bigcup --- */
      {  91,100202,                     /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\xe1\x0f\x21\xe1\xf1\x11\xc1\x10\x21\xa1\x52"
            "\x62\x86\x51" }  },
      /* --- pixel bitmap for cmex118 char#92 \Bigcap --- */
      {  92,101913,                     /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x82\x62\x51\xa1\x20\xf1\x11\xc1\x1f\xe1\xe1\x0f"
            "\x21\xe1" }  },
      /* --- pixel bitmap for cmex118 char#93 \Biguplus --- */
      {  93,103754,                     /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x01\xe1\x0f\x41\x71\x61\x01\x1c\x11\x0f\x41\x71"
            "\x61\x0f\x11\xe1\xf1\x11\xc1\x10\x21\xa1\x52\x62\x86"
            "\x53" }  },
      /* --- pixel bitmap for cmex118 char#94 \Bigwedge --- */
      {  94,105421,                     /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x70\xf1\x72\x70\xf2\x61\x21\x60\xf2\x51\x41\x50"
            "\xf2\x41\x61\x40\xf2\x31\x81\x30\xf2\x21\xa1\x20\xf2"
            "\x11\xc1\x1f\x11\xe1" }  },
      /* --- pixel bitmap for cmex118 char#95 \Bigvee --- */
      {  95,107064,                     /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xe1\xf2\x11\xc1\x10\xf2\x21\xa1\x20\xf2\x31"
            "\x81\x30\xf2\x41\x61\x40\xf2\x51\x41\x50\xf2\x61\x21"
            "\x60\xf1\x72\x70\x81\x71" }  },
      /* --- pixel bitmap for cmex118 char#96 \coprod --- */
      {  96,92803,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 13,   16, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x16\xfd\x22\x52\x2d" }  },
      /* --- pixel bitmap for cmex118 char#97 \Bigcoprod --- */
      {  97,94395,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 19,   23, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x38\x24\x74\x20\xfe\x32\x92\x30\xf3\x32\x92\x30"
            "\x23\x93\x2e\x05" }  },
      /* --- pixel bitmap for cmex118 char#98 ^ --- */
      {  98,107795,                     /* character number, location */
         12, 0,    9, 0,      /* topleft row,col, and botleft row,col */
          {  9,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xdc\x0d\x06" }  },
      /* --- pixel bitmap for cmex118 char#99 ^ --- */
      {  99,108640,                     /* character number, location */
         12, 0,    9, 0,      /* topleft row,col, and botleft row,col */
          { 16,    3, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x93\x43\x33\xa3" }  },
      /* --- pixel bitmap for cmex118 char#100 ^ --- */
      { 100,109694,                     /* character number, location */
         12, 0,    9, 0,      /* topleft row,col, and botleft row,col */
          { 24,    3, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\xd5\x65\x44\xe0\x24" }  },
      /* --- pixel bitmap for cmex118 char#101 ~ --- */
      { 101,110377,                     /* character number, location */
         12, 0,   10, 0,      /* topleft row,col, and botleft row,col */
          {  9,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\xf7\x01" }  },
      /* --- pixel bitmap for cmex118 char#102 ~ --- */
      { 102,111267,                     /* character number, location */
         12, 0,    9, 0,      /* topleft row,col, and botleft row,col */
          { 16,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x8e\x71\x01\x0f" }  },
      /* --- pixel bitmap for cmex118 char#103 ~ --- */
      { 103,112372,                     /* character number, location */
         12, 0,    9, 0,      /* topleft row,col, and botleft row,col */
          { 24,    3, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x57\xa2\x24\x44\x44\x22\xa7\x52" }  },
      /* --- pixel bitmap for cmex118 char#104 \Big[ --- */
      { 104,12661,                      /* character number, location */
          1, 4,  -28, 4,      /* topleft row,col, and botleft row,col */
          {  4,   29, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x3f\xb1\x34" }  },
      /* --- pixel bitmap for cmex118 char#105 \Big] --- */
      { 105,18340,                      /* character number, location */
          1, 0,  -28, 0,      /* topleft row,col, and botleft row,col */
          {  4,   29, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x31\xfb\x31\x04" }  },
      /* --- pixel bitmap for cmex118 char#106 (noname) --- */
      { 106,24044,                      /* character number, location */
          1, 4,  -28, 4,      /* topleft row,col, and botleft row,col */
          {  5,   29, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x4f\xc1\x45" }  },
      /* --- pixel bitmap for cmex118 char#107 (noname) --- */
      { 107,27472,                      /* character number, location */
          1, 0,  -28, 0,      /* topleft row,col, and botleft row,col */
          {  5,   29, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x41\xfc\x41\x05" }  },
      /* --- pixel bitmap for cmex118 char#108 (noname) --- */
      { 108,30904,                      /* character number, location */
          1, 4,  -28, 4,      /* topleft row,col, and botleft row,col */
          {  5,   29, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\xc1\x41" }  },
      /* --- pixel bitmap for cmex118 char#109 (noname) --- */
      { 109,34340,                      /* character number, location */
          1, 0,  -28, 0,      /* topleft row,col, and botleft row,col */
          {  5,   29, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xfc\x41" }  },
      /* --- pixel bitmap for cmex118 char#110 \Big{ --- */
      { 110,38044,                      /* character number, location */
          1, 2,  -28, 2,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x41\x20\xfa\x31\x30\x21\x42\x71\x40\xfa\x31\x30"
            "\x41\x72" }  },
      /* --- pixel bitmap for cmex118 char#111 \Big} --- */
      { 111,45672,                      /* character number, location */
          1, 2,  -28, 2,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x71\x40\xfa\x31\x30\x41\x72\x41\x20\xfa\x31\x30"
            "\x21\x42\x52" }  },
      /* --- pixel bitmap for cmex118 char#112 (noname) --- */
      { 112,71780,                      /* character number, location */
          1, 2,  -19, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe1\xf1\xd1\x10\xf1\xc1\x20\xf1\xb1\x30\xf1\xa1"
            "\x40\x11\x71\x53\x61\x50\xf1\x21\x51\x60\xf1\x31\x31"
            "\x70\xf1\x41\x11\x80\x42\xe1\x90" }  },
      /* --- pixel bitmap for cmex118 char#113 (noname) --- */
      { 113,72719,                      /* character number, location */
          1, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 15,   30, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe1\xf2\xd1\x10\xf3\xc1\x20\xf2\xb1\x30\xf2\xa1"
            "\x40\x91\x61\x71\x51\x11\x61\x50\xf2\x21\x51\x60\xf2"
            "\x31\x31\x70\x41\x21\x70\xf2\x41\x11\x80\xf1\x51\x90" }  },
      /* --- pixel bitmap for cmex118 char#114 (noname) --- */
      { 114,73689,                      /* character number, location */
          1, 2,  -39, 2,      /* topleft row,col, and botleft row,col */
          { 15,   40, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xe1\xf3\xd1\x10\xf3\xc1\x20\xf4\xb1\x30\xf3\xa1"
            "\x40\x91\x61\x71\x52\x71\x51\x11\x61\x50\xf3\x21\x51"
            "\x60\x31\x41\x60\xf3\x31\x31\x70\xf3\x41\x11\x80\x42"
            "\x90\xf1\x51\x90" }  },
      /* --- pixel bitmap for cmex118 char#115 (noname) --- */
      { 115,74687,                      /* character number, location */
          1, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 15,   49, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xe1\xf5\xd1\x10\xf4\xc1\x20\xf4\xb1\x30\xf5\xa1"
            "\x40\xf1\x11\x71\x52\x71\x51\x11\x61\x71\x61\x50\xf3"
            "\x21\x51\x60\x31\x41\x60\xf4\x31\x31\x70\x41\x21\x70"
            "\xf4\x41\x11\x80\xf2\x51\x91" }  },
      /* --- pixel bitmap for cmex118 char#116 (noname) --- */
      { 116,75753,                      /* character number, location */
          1, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 10,   30, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x91\xf1\x12\x61\x01\x11\x61\x21\x61\xf2\x31\x51"
            "\xf2\x41\x41\xf3\x51\x31\xf2\x61\x21\xf2\x71\x11\xf2"
            "\x82\xf1\x91" }  },
      /* --- pixel bitmap for cmex118 char#117 (noname) --- */
      { 117,76618,                      /* character number, location */
          1,11,  -11,11,      /* topleft row,col, and botleft row,col */
          {  1,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f" }  },
      /* --- pixel bitmap for cmex118 char#118 (noname) --- */
      { 118,77407,                      /* character number, location */
          1,11,  -10,11,      /* topleft row,col, and botleft row,col */
          {  7,   11, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\x91\x62" }  },
      /* --- pixel bitmap for cmex118 char#119 (noname) --- */
      { 119,70849,                      /* character number, location */
          1, 5,  -11, 5,      /* topleft row,col, and botleft row,col */
          {  4,   12, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x01\x21" }  },
      /* --- pixel bitmap for cmex118 char#120 (noname) --- */
      { 120,66315,                      /* character number, location */
          0, 2,  -10, 2,      /* topleft row,col, and botleft row,col */
          {  7,   10, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\x53\x22\x11\x12\xf6\x31\x30" }  },
      /* --- pixel bitmap for cmex118 char#121 (noname) --- */
      { 121,67212,                      /* character number, location */
          0, 2,  -10, 2,      /* topleft row,col, and botleft row,col */
          {  7,   10, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x31\x32\x11\x12\x23\x51\x30" }  },
      /* --- pixel bitmap for cmex118 char#122 (noname) --- */
      { 122,51154,                      /* character number, location */
          2,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  9,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xf1\x33\x10\x10\x00" }  },
      /* --- pixel bitmap for cmex118 char#123 (noname) --- */
      { 123,51706,                      /* character number, location */
          2,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  9,    5, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x56\x82\x91\x91" }  },
      /* --- pixel bitmap for cmex118 char#124 (noname) --- */
      { 124,52255,                      /* character number, location */
          5,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  9,    5, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x91\x93\x76\x54" }  },
      /* --- pixel bitmap for cmex118 char#125 (noname) --- */
      { 125,52805,                      /* character number, location */
          5,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          {  9,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\xc1\xf9\xf1\x00" }  },
      /* --- pixel bitmap for cmex118 char#126 (noname) --- */
      { 126,68929,                      /* character number, location */
         -1, 2,  -10, 2,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x20\xc1\xcc\xd2\x48\x20\x81\x04\x12\x48\x00" }  },
      /* --- pixel bitmap for cmex118 char#127 (noname) --- */
      { 127,69993,                      /* character number, location */
          0, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 10,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x20\x81\x04\x12\x48\x2c\xcd\x0c\x12\x30\x00" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=3 for .131gf ---
 * mf '\mode=preview; mag=magstep(-16.39322518098640003469); input cmex10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmex131 --- */
static	chardef  cmex131[] =
   {
      /* --- pixel bitmap for cmex131 char#0 \big( --- */
      {   0,  661,                      /* character number, location */
          1, 3,  -20, 3,      /* topleft row,col, and botleft row,col */
          {  4,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x24\x22\x11\x11\x11\x11\x21\x22\x44\x08" }  },
      /* --- pixel bitmap for cmex131 char#1 \big) --- */
      {   1, 6356,                      /* character number, location */
          1, 1,  -20, 1,      /* topleft row,col, and botleft row,col */
          {  4,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x42\x44\x88\x88\x88\x88\x48\x44\x22\x01" }  },
      /* --- pixel bitmap for cmex131 char#2 \big[ --- */
      {   2,12071,                      /* character number, location */
          1, 4,  -20, 4,      /* topleft row,col, and botleft row,col */
          {  4,   21, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x3f\x31\x34" }  },
      /* --- pixel bitmap for cmex131 char#3 \big] --- */
      {   3,17833,                      /* character number, location */
          1, 0,  -20, 0,      /* topleft row,col, and botleft row,col */
          {  4,   21, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x31\xf3\x31\x04" }  },
      /* --- pixel bitmap for cmex131 char#4 (noname) --- */
      {   4,23562,                      /* character number, location */
          1, 4,  -20, 4,      /* topleft row,col, and botleft row,col */
          {  5,   21, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x4f\x41\x45" }  },
      /* --- pixel bitmap for cmex131 char#5 (noname) --- */
      {   5,27059,                      /* character number, location */
          1, 0,  -20, 0,      /* topleft row,col, and botleft row,col */
          {  5,   21, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x41\xf4\x41\x05" }  },
      /* --- pixel bitmap for cmex131 char#6 (noname) --- */
      {   6,30532,                      /* character number, location */
          1, 4,  -20, 4,      /* topleft row,col, and botleft row,col */
          {  5,   21, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\x41\x41" }  },
      /* --- pixel bitmap for cmex131 char#7 (noname) --- */
      {   7,34037,                      /* character number, location */
          1, 0,  -20, 0,      /* topleft row,col, and botleft row,col */
          {  5,   21, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xf4\x41" }  },
      /* --- pixel bitmap for cmex131 char#8 \big{ --- */
      {   8,37611,                      /* character number, location */
          1, 2,  -20, 2,      /* topleft row,col, and botleft row,col */
          {  7,   21, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x41\x20\xf6\x31\x30\x21\x42\x71\x40\xf6\x31\x30"
            "\x41\x72" }  },
      /* --- pixel bitmap for cmex131 char#9 \big} --- */
      {   9,45124,                      /* character number, location */
          1, 2,  -20, 2,      /* topleft row,col, and botleft row,col */
          {  7,   21, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x71\x40\xf6\x31\x30\x41\x72\x41\x20\xf6\x31\x30"
            "\x21\x42\x53" }  },
      /* --- pixel bitmap for cmex131 char#10 \big< --- */
      {  10,53820,                      /* character number, location */
          1, 2,  -20, 2,      /* topleft row,col, and botleft row,col */
          {  6,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x41\x08\x41\x08\x42\x10\x04\x82\x40\x10\x08"
            "\x04\x81\x20" }  },
      /* --- pixel bitmap for cmex131 char#11 \big> --- */
      {  11,56595,                      /* character number, location */
          1, 2,  -20, 2,      /* topleft row,col, and botleft row,col */
          {  5,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x08\x41\x08\x41\x08\x42\x88\x10\x21\x44\x88\x10"
            "\x00" }  },
      /* --- pixel bitmap for cmex131 char#12 (noname) --- */
      {  12,65389,                      /* character number, location */
          1, 3,  -12, 3,      /* topleft row,col, and botleft row,col */
          {  1,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f" }  },
      /* --- pixel bitmap for cmex131 char#13 (noname) --- */
      {  13,66008,                      /* character number, location */
          1, 3,  -12, 3,      /* topleft row,col, and botleft row,col */
          {  4,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x01\x21" }  },
      /* --- pixel bitmap for cmex131 char#14 (noname) --- */
      {  14,59356,                      /* character number, location */
          1, 1,  -20, 1,      /* topleft row,col, and botleft row,col */
          {  8,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x80\x40\x40\x40\x20\x20\x20\x10\x10\x08\x08\x08"
            "\x04\x04\x04\x02\x02\x02\x01\x01" }  },
      /* --- pixel bitmap for cmex131 char#15 (noname) --- */
      {  15,62404,                      /* character number, location */
          1, 1,  -20, 1,      /* topleft row,col, and botleft row,col */
          {  8,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x01\x02\x02\x02\x04\x04\x04\x08\x08\x08\x10\x10"
            "\x20\x20\x20\x40\x40\x40\x80\x80" }  },
      /* --- pixel bitmap for cmex131 char#16 \Big( --- */
      {  16, 1388,                      /* character number, location */
          1, 3,  -31, 3,      /* topleft row,col, and botleft row,col */
          {  7,   32, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x51\x51\x20\xf1\x31\x30\xf1\x21\x40\xf3\x11\x5f"
            "\x91\x60\xf3\x11\x50\xf1\x21\x40\xf1\x31\x30\x41\x71"
            "\x71" }  },
      /* --- pixel bitmap for cmex131 char#17 \Big) --- */
      {  17, 7070,                      /* character number, location */
          1, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          {  7,   32, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x01\x01\x81\x80\x40\x40\x20\x10\x08\x08\x04\x02"
            "\x81\x40\x20\x10\x08\x04\x81\x40\x20\x08\x04\x81\x20"
            "\x08\x02" }  },
      /* --- pixel bitmap for cmex131 char#18 \bigg( --- */
      {  18, 2216,                      /* character number, location */
          1, 4,  -42, 4,      /* topleft row,col, and botleft row,col */
          {  8,   43, 3,82, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x61\x10\xf1\x51\x20\x41\x62\x61\x40\xf1\x22\x40"
            "\x21\x50\xf3\x12\x50\x11\x6f\xc2\x60\x11\x60\xf3\x12"
            "\x50\x21\x50\xf1\x22\x40\x31\x72\x71\x30\xf1\x51\x20"
            "\x61\x81" }  },
      /* --- pixel bitmap for cmex131 char#19 \bigg) --- */
      {  19, 7885,                      /* character number, location */
          1, 1,  -42, 1,      /* topleft row,col, and botleft row,col */
          {  8,   43, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x60\xf1\x21\x50\x31\x72\x71\x30\xf1\x42\x20"
            "\x51\x20\xf3\x52\x10\x61\x10\xfc\x62\x61\x10\xf3\x52"
            "\x10\x51\x20\xf1\x42\x20\x41\x62\x61\x40\xf1\x21\x50"
            "\x11\x61\x72" }  },
      /* --- pixel bitmap for cmex131 char#20 \bigg[ --- */
      {  20,13718,                      /* character number, location */
          1, 5,  -42, 5,      /* topleft row,col, and botleft row,col */
          {  5,   43, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\xe1\x4f\xa1\x45" }  },
      /* --- pixel bitmap for cmex131 char#21 \bigg] --- */
      {  21,19454,                      /* character number, location */
          1, 0,  -42, 0,      /* topleft row,col, and botleft row,col */
          {  5,   43, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xfe\x41\xfa\x41\x05" }  },
      /* --- pixel bitmap for cmex131 char#22 (noname) --- */
      {  22,25273,                      /* character number, location */
          1, 5,  -42, 5,      /* topleft row,col, and botleft row,col */
          {  6,   43, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x29\x00\x01\x05\x06" }  },
      /* --- pixel bitmap for cmex131 char#23 (noname) --- */
      {  23,28744,                      /* character number, location */
          1, 0,  -42, 0,      /* topleft row,col, and botleft row,col */
          {  6,   43, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x29\x05\x01\x00\x06" }  },
      /* --- pixel bitmap for cmex131 char#24 (noname) --- */
      {  24,32247,                      /* character number, location */
          1, 5,  -42, 5,      /* topleft row,col, and botleft row,col */
          {  6,   43, 2, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x00\xff\x29\x01\x05" }  },
      /* --- pixel bitmap for cmex131 char#25 (noname) --- */
      {  25,35726,                      /* character number, location */
          1, 0,  -42, 0,      /* topleft row,col, and botleft row,col */
          {  6,   43, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\xff\x29\x05\x01" }  },
      /* --- pixel bitmap for cmex131 char#26 \bigg{ --- */
      {  26,39516,                      /* character number, location */
          1, 2,  -42, 2,      /* topleft row,col, and botleft row,col */
          { 10,   43, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\x72\x71\x82\x30\xfd\x42\x40\x32\x81\x72\x72\x92"
            "\xa1\x92\x50\xfd\x42\x40\x52\x91\xa2\x92" }  },
      /* --- pixel bitmap for cmex131 char#27 \bigg} --- */
      {  27,47031,                      /* character number, location */
          1, 2,  -42, 2,      /* topleft row,col, and botleft row,col */
          { 10,   43, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x92\xa1\x92\x50\xfd\x42\x40\x52\x91\xa2\x92\x72"
            "\x71\x82\x30\xfd\x42\x40\x32\x81\x72\x72\x82" }  },
      /* --- pixel bitmap for cmex131 char#28 \bigg< --- */
      {  28,55137,                      /* character number, location */
          1, 2,  -42, 2,      /* topleft row,col, and botleft row,col */
          { 10,   43, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x08\x10\x40\x80\x00\x02\x04\x10\x40\x80\x00"
            "\x02\x04\x10\x20\x80\x00\x02\x04\x10\x20\x80\x00\x01"
            "\x04\x10\x80\x00\x02\x10\x40\x00\x02\x08\x20\x00\x01"
            "\x04\x20\x80\x00\x04\x10\x40\x00\x02\x08\x40\x00\x01"
            "\x08\x20" }  },
      /* --- pixel bitmap for cmex131 char#29 \bigg> --- */
      {  29,57914,                      /* character number, location */
          1, 2,  -42, 2,      /* topleft row,col, and botleft row,col */
          { 10,   43, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x04\x20\x80\x00\x04\x10\x80\x00\x02\x08\x40\x00"
            "\x01\x08\x20\x00\x01\x04\x10\x80\x00\x02\x10\x40\x00"
            "\x02\x08\x20\x40\x00\x01\x02\x08\x10\x40\x00\x01\x02"
            "\x08\x10\x40\x80\x00\x02\x08\x10\x40\x80\x00\x02\x04"
            "\x10\x00" }  },
      /* --- pixel bitmap for cmex131 char#30 (noname) --- */
      {  30,60821,                      /* character number, location */
          1, 1,  -42, 1,      /* topleft row,col, and botleft row,col */
          { 17,   43, 3,155, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x21\xe0\x12\xf1\xe0\x11\x10\xe2\x10\xf1\xe1\x20"
            "\xd2\xe0\x11\xe0\x12\x30\xf1\xc1\x40\xb2\xe0\x11\xe0"
            "\x12\x50\xf1\xa1\x60\x92\x60\xf1\x91\x70\x82\xe0\x11"
            "\xe0\x12\x80\xf1\x71\x90\x62\x90\xf1\x61\xa0\x52\xe0"
            "\x11\xe0\x12\xb0\xf1\x41\xc0\x32\xe0\x11\xe0\x12\xd0"
            "\xf1\x21\xe0\x12\xe0\xf1\x11\xe0\x12\xe0\x11\xe0\x20" }  },
      /* --- pixel bitmap for cmex131 char#31 (noname) --- */
      {  31,63877,                      /* character number, location */
          1, 1,  -42, 1,      /* topleft row,col, and botleft row,col */
          { 17,   43, 3,158, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x22\xe0\x10\xf1\x11\xe0\x10\x12\xe0\xf1\x21"
            "\xe0\x22\xe0\x21\xe0\x22\xc0\xf1\x41\xc0\x42\xe0\x21"
            "\xe0\x22\xa0\xf1\x61\xa0\x62\x90\xf1\x71\x90\x72\xe0"
            "\x21\xe0\x22\x70\xf1\x91\x70\x92\x60\xf1\xa1\x60\xa2"
            "\xe0\x21\xe0\x22\x40\xf1\xc1\x40\xc2\xe0\x21\xe0\x22"
            "\x20\xf1\xe1\x20\xe2\x10\xf1\xe0\x11\x10\xe0\x12\xe0"
            "\x21" }  },
      /* --- pixel bitmap for cmex131 char#32 \Bigg( --- */
      {  32, 3092,                      /* character number, location */
          1, 4,  -53, 4,      /* topleft row,col, and botleft row,col */
          {  9,   54, 3,94, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x71\x72\x71\x71\x72\x71\x40\xf1\x32\x40\x31\x50"
            "\xf1\x22\x50\x21\x60\xf4\x12\x60\x11\x7f\xe2\x72\x81"
            "\x70\xf4\x12\x60\x21\x60\xf1\x22\x50\x31\x50\xf1\x32"
            "\x40\x41\x82\x81\x91\x82\x81\x91" }  },
      /* --- pixel bitmap for cmex131 char#33 \Bigg) --- */
      {  33, 8722,                      /* character number, location */
          1, 1,  -53, 1,      /* topleft row,col, and botleft row,col */
          {  9,   54, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x91\x82\x81\x91\x82\x81\x40\xf1\x42\x30\x51\x30"
            "\xf1\x52\x20\x61\x20\xf4\x62\x10\x71\x10\xfe\x72\x72"
            "\x71\x10\xf4\x62\x10\x61\x20\xf1\x52\x20\x51\x30\xf1"
            "\x42\x30\x41\x72\x71\x71\x72\x71\x71\x80" }  },
      /* --- pixel bitmap for cmex131 char#34 \Bigg[ --- */
      {  34,14601,                      /* character number, location */
          1, 5,  -53, 5,      /* topleft row,col, and botleft row,col */
          {  6,   54, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x00\xff\x33\x01\x05\x06" }  },
      /* --- pixel bitmap for cmex131 char#35 \Bigg] --- */
      {  35,20324,                      /* character number, location */
          1, 0,  -53, 0,      /* topleft row,col, and botleft row,col */
          {  6,   54, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\xff\x33\x05\x01\x00\x06" }  },
      /* --- pixel bitmap for cmex131 char#36 (noname) --- */
      {  36,26188,                      /* character number, location */
          1, 5,  -53, 5,      /* topleft row,col, and botleft row,col */
          {  7,   54, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x34\x00\x01\x06\x07" }  },
      /* --- pixel bitmap for cmex131 char#37 (noname) --- */
      {  37,29646,                      /* character number, location */
          1, 0,  -53, 0,      /* topleft row,col, and botleft row,col */
          {  7,   54, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x34\x06\x01\x00\x07" }  },
      /* --- pixel bitmap for cmex131 char#38 (noname) --- */
      {  38,33164,                      /* character number, location */
          1, 5,  -53, 5,      /* topleft row,col, and botleft row,col */
          {  7,   54, 2, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x07\x00\xff\x34\x01\x06" }  },
      /* --- pixel bitmap for cmex131 char#39 (noname) --- */
      {  39,36630,                      /* character number, location */
          1, 0,  -53, 0,      /* topleft row,col, and botleft row,col */
          {  7,   54, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x07\xff\x34\x06\x01" }  },
      /* --- pixel bitmap for cmex131 char#40 \Bigg{ --- */
      {  40,40606,                      /* character number, location */
          1, 3,  -53, 3,      /* topleft row,col, and botleft row,col */
          {  9,   54, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x71\x71\x72\x20\xfe\x42\x30\xf3\x42\x30\x32\x71"
            "\x71\x60\xf1\x11\x70\x21\x91\x82\x40\xfe\x42\x30\xf3"
            "\x42\x30\x52\x81\x91\x91" }  },
      /* --- pixel bitmap for cmex131 char#41 \Bigg} --- */
      {  41,48122,                      /* character number, location */
          1, 3,  -53, 3,      /* topleft row,col, and botleft row,col */
          {  9,   54, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x92\x82\x82\x81\x40\xfe\x42\x30\xf2\x42\x30\xf1"
            "\x52\x20\x62\x10\xf1\x72\x62\x10\xf1\x52\x20\xfe\x42"
            "\x30\xf2\x42\x30\x41\x72\x62\x62\x61\x80" }  },
      /* --- pixel bitmap for cmex131 char#42 \Bigg< --- */
      {  42,55945,                      /* character number, location */
          1, 3,  -54, 3,      /* topleft row,col, and botleft row,col */
          { 10,   55, 3,108, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x91\xf2\x81\x10\xf2\x71\x20\xf2\x61\x30\xf2\x51"
            "\x40\xf2\x41\x50\xf2\x31\x60\xf2\x21\x70\xf2\x11\x8f"
            "\x21\x90\xf2\x11\x80\xf2\x21\x70\xf2\x31\x60\xf2\x41"
            "\x50\xf2\x51\x40\xf2\x61\x30\xf2\x71\x20\xf2\x81\x10"
            "\xf1\x91" }  },
      /* --- pixel bitmap for cmex131 char#43 \Bigg> --- */
      {  43,58723,                      /* character number, location */
          1, 2,  -54, 2,      /* topleft row,col, and botleft row,col */
          { 10,   55, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x01\x90\xf2\x11\x80\xf2\x21\x70\xf2\x31\x60\xf2"
            "\x41\x50\xf2\x51\x40\xf2\x61\x30\xf2\x71\x20\xf2\x81"
            "\x10\xf2\x91\xf2\x81\x10\xf2\x71\x20\xf2\x61\x30\xf2"
            "\x51\x40\xf2\x41\x50\xf2\x31\x60\xf2\x21\x70\xf2\x11"
            "\x8f\x11\x90" }  },
      /* --- pixel bitmap for cmex131 char#44 / --- */
      {  44,61769,                      /* character number, location */
          1, 1,  -53, 1,      /* topleft row,col, and botleft row,col */
          { 21,   54, 3,217, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x61\xe0\x52\xf1\xe0\x51\x10\xe0\x42\x10\xf1\xe0"
            "\x41\x20\xe0\x32\xe0\x51\xe0\x52\x30\xf1\xe0\x21\x40"
            "\xe0\x12\x40\xf1\xe0\x11\x50\xe2\xe0\x51\xe0\x52\x60"
            "\xf1\xd1\x70\xc2\x70\xf1\xc1\x80\xb2\xe0\x51\xe0\x52"
            "\x90\xf1\xa1\xa0\x92\xe0\x51\xe0\x52\xb0\xf1\x81\xc0"
            "\x72\xc0\xf1\x71\xd0\x62\xe0\x51\xe0\x52\xe0\xf1\x51"
            "\xe0\x10\x42\xe0\x10\xf1\x41\xe0\x20\x32\xe0\x51\xe0"
            "\x52\xe0\x30\xf1\x21\xe0\x40\x12\xe0\x40\xf1\x11\xe0"
            "\x52\xe0\x51\xe0\x60" }  },
      /* --- pixel bitmap for cmex131 char#45 \ --- */
      {  45,64829,                      /* character number, location */
          1, 1,  -53, 1,      /* topleft row,col, and botleft row,col */
          { 21,   54, 3,220, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x62\xe0\x50\xf1\x11\xe0\x50\x12\xe0\x40\xf1"
            "\x21\xe0\x40\x22\xe0\x61\xe0\x62\xe0\x20\xf1\x41\xe0"
            "\x20\x42\xe0\x10\xf1\x51\xe0\x10\x52\xe0\x61\xe0\x62"
            "\xd0\xf1\x71\xd0\x72\xc0\xf1\x81\xc0\x82\xe0\x61\xe0"
            "\x62\xa0\xf1\xa1\xa0\xa2\xe0\x61\xe0\x62\x80\xf1\xc1"
            "\x80\xc2\x70\xf1\xd1\x70\xd2\xe0\x61\xe0\x62\x50\xf1"
            "\xe0\x11\x50\xe0\x12\x40\xf1\xe0\x21\x40\xe0\x22\xe0"
            "\x61\xe0\x62\x20\xf1\xe0\x41\x20\xe0\x42\x10\xf1\xe0"
            "\x51\x10\xe0\x52\xe0\x61" }  },
      /* --- pixel bitmap for cmex131 char#46 / --- */
      {  46,60025,                      /* character number, location */
          1, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 13,   32, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xb2\xf1\xb1\x10\xa2\xb1\xb2\x20\xf1\x91\x30\x82"
            "\x30\xf1\x81\x40\x72\xb1\xb2\x50\xf1\x61\x60\x52\xb1"
            "\xb2\x70\xf1\x41\x80\x32\x80\xf1\x31\x90\x22\xb1\xb2"
            "\xa0\xf1\x11\xb2\xb1\xc2" }  },
      /* --- pixel bitmap for cmex131 char#47 \ --- */
      {  47,63077,                      /* character number, location */
          1, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 13,   32, 3,92, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xc2\xb0\xf1\x11\xb0\x12\xc1\xc2\x90\xf1\x31\x90"
            "\x32\x80\xf1\x41\x80\x42\xc1\xc2\x60\xf1\x61\x60\x62"
            "\xc1\xc2\x40\xf1\x81\x40\x82\x30\xf1\x91\x30\x92\xc1"
            "\xc2\x10\xf1\xb1\x10\xb2\xc1" }  },
      /* --- pixel bitmap for cmex131 char#48 \leftparentop --- */
      {  48, 3980,                      /* character number, location */
          0, 5,  -33, 5,      /* topleft row,col, and botleft row,col */
          { 10,   33, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x81\x82\x81\x20\xf1\x61\x30\x51\x40\xf1\x42\x40"
            "\x41\x82\x50\xf1\x31\x60\xf1\x22\x60\x21\x70\xf5\x12"
            "\x7f\xa2\x82" }  },
      /* --- pixel bitmap for cmex131 char#49 \rightparentop --- */
      {  49, 9597,                      /* character number, location */
          0, 1,  -33, 1,      /* topleft row,col, and botleft row,col */
          { 10,   33, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xa1\x92\x91\x70\xf1\x31\x60\x41\x50\xf1\x42\x40"
            "\x51\x92\x30\xf1\x61\x30\xf1\x62\x20\x71\x20\xf5\x72"
            "\x10\xfa\x82" }  },
      /* --- pixel bitmap for cmex131 char#50 (noname) --- */
      {  50,15475,                      /* character number, location */
          0, 6,  -32, 6,      /* topleft row,col, and botleft row,col */
          {  6,   32, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x5f\xe1\x51\x51" }  },
      /* --- pixel bitmap for cmex131 char#51 (noname) --- */
      {  51,21185,                      /* character number, location */
          0, 0,  -32, 0,      /* topleft row,col, and botleft row,col */
          {  6,   32, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x51\xfe\x51\x51" }  },
      /* --- pixel bitmap for cmex131 char#52 (noname) --- */
      {  52,16327,                      /* character number, location */
          1, 6,  -31, 6,      /* topleft row,col, and botleft row,col */
          {  6,   32, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x5f\xe1\x51\x56" }  },
      /* --- pixel bitmap for cmex131 char#53 (noname) --- */
      {  53,22024,                      /* character number, location */
          1, 0,  -31, 0,      /* topleft row,col, and botleft row,col */
          {  6,   32, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x51\xfe\x51\x57" }  },
      /* --- pixel bitmap for cmex131 char#54 (noname) --- */
      {  54,17076,                      /* character number, location */
          1, 6,  -12, 6,      /* topleft row,col, and botleft row,col */
          {  1,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f" }  },
      /* --- pixel bitmap for cmex131 char#55 (noname) --- */
      {  55,22760,                      /* character number, location */
          1, 5,  -12, 5,      /* topleft row,col, and botleft row,col */
          {  1,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f" }  },
      /* --- pixel bitmap for cmex131 char#56 \leftbracetop --- */
      {  56,41541,                      /* character number, location */
         -1, 7,  -17, 7,      /* topleft row,col, and botleft row,col */
          {  6,   16, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x32\x32\x33\x32\x3f\xa3\x30" }  },
      /* --- pixel bitmap for cmex131 char#57 \rightbracetop --- */
      {  57,49058,                      /* character number, location */
         -1, 3,  -17, 3,      /* topleft row,col, and botleft row,col */
          {  7,   16, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x62\x62\x62\x53\x10\xfa\x43" }  },
      /* --- pixel bitmap for cmex131 char#58 \leftbracebot --- */
      {  58,42422,                      /* character number, location */
          1, 7,  -15, 7,      /* topleft row,col, and botleft row,col */
          {  6,   16, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x03\x30\x12\x43\x42\x52\x61" }  },
      /* --- pixel bitmap for cmex131 char#59 \rightbracebot --- */
      {  59,49940,                      /* character number, location */
          1, 3,  -15, 3,      /* topleft row,col, and botleft row,col */
          {  7,   16, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x43\x33\x42\x42\x42\x42\x53" }  },
      /* --- pixel bitmap for cmex131 char#60 \leftbracemid --- */
      {  60,43378,                      /* character number, location */
          1, 3,  -34, 3,      /* topleft row,col, and botleft row,col */
          {  7,   35, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x43\x42\x43\x42\x42\x42\x41\x72\x62\x62\x53\x52"
            "\x10\xfb\x43" }  },
      /* --- pixel bitmap for cmex131 char#61 \rightbracemid --- */
      {  61,50897,                      /* character number, location */
          1, 7,  -34, 7,      /* topleft row,col, and botleft row,col */
          {  6,   35, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x03\x30\x12\x43\x20\xf1\x22\x20\x32\x61\x32\x10"
            "\xf1\x22\x20\x13\x32\x3f\xb3\x30" }  },
      /* --- pixel bitmap for cmex131 char#62 \leftbracebar --- */
      {  62,44236,                      /* character number, location */
          1, 7,   -6, 7,      /* topleft row,col, and botleft row,col */
          {  3,    7, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x03" }  },
      /* --- pixel bitmap for cmex131 char#63 (noname) --- */
      {  63,68579,                      /* character number, location */
          1, 6,  -12, 6,      /* topleft row,col, and botleft row,col */
          {  1,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f" }  },
      /* --- pixel bitmap for cmex131 char#64 \leftparenbot --- */
      {  64, 4848,                      /* character number, location */
          2, 5,  -31, 5,      /* topleft row,col, and botleft row,col */
          { 10,   33, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x02\x80\xf5\x12\x70\x21\x70\xf1\x22\x60\xf1\x31"
            "\x60\x32\x91\x50\xf1\x42\x40\x51\x40\xf1\x61\x30\x71"
            "\x92\x91\xa1" }  },
      /* --- pixel bitmap for cmex131 char#65 \rightparenbot --- */
      {  65,10452,                      /* character number, location */
          2, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 10,   33, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x82\xf5\x72\x10\x71\x20\xf1\x62\x20\xf1\x61\x30"
            "\x52\x81\x40\xf1\x42\x40\x41\x50\xf1\x31\x60\x21\x82"
            "\x81\x81\x92" }  },
      /* --- pixel bitmap for cmex131 char#66 \leftparenbar --- */
      {  66, 5710,                      /* character number, location */
          1, 5,  -12, 5,      /* topleft row,col, and botleft row,col */
          {  2,   13, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x02" }  },
      /* --- pixel bitmap for cmex131 char#67 \rightparenbar --- */
      {  67,11301,                      /* character number, location */
          1, 9,  -12, 9,      /* topleft row,col, and botleft row,col */
          {  2,   13, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x02" }  },
      /* --- pixel bitmap for cmex131 char#68 \Big< --- */
      {  68,54453,                      /* character number, location */
          1, 2,  -32, 2,      /* topleft row,col, and botleft row,col */
          {  8,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x80\x40\x40\x20\x20\x10\x10\x08\x08\x08\x04\x04"
            "\x02\x02\x01\x01\x01\x02\x02\x04\x04\x08\x08\x08\x10"
            "\x10\x20\x20\x40\x40\x80\x80" }  },
      /* --- pixel bitmap for cmex131 char#69 \Big> --- */
      {  69,57229,                      /* character number, location */
          1, 2,  -32, 2,      /* topleft row,col, and botleft row,col */
          {  7,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\x40\x20\x20\x10\x10\x08\x04\x04\x02\x02\x81"
            "\x80\x40\x20\x08\x04\x82\x40\x10\x08\x04\x81\x20\x10"
            "\x08\x02\x01" }  },
      /* --- pixel bitmap for cmex131 char#70 \bigsqcup --- */
      {  70,79158,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\xb1\x0f\x11\xb1\x0d" }  },
      /* --- pixel bitmap for cmex131 char#71 \Bigsqcup --- */
      {  71,80085,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x17\x00\x01\x10\x01\x00\x12" }  },
      /* --- pixel bitmap for cmex131 char#72 \oint --- */
      {  72,98887,                      /* character number, location */
          0, 1,  -20, 1,      /* topleft row,col, and botleft row,col */
          { 11,   20, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x81\x21\xf3\x61\x40\x43\x71\x11\x11\x30\xf3\x21"
            "\x21\x21\x20\x31\x11\x11\x73\x40\xf3\x41\x61\x21\x83"
            "\x72" }  },
      /* --- pixel bitmap for cmex131 char#73 \Bigoint --- */
      {  73,99941,                      /* character number, location */
          0, 1,  -40, 1,      /* topleft row,col, and botleft row,col */
          { 16,   40, 3,129, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd2\xd1\x21\xb2\x12\xb1\x22\xb1\x40\xf1\xa2\x40\xf1"
            "\xa1\x50\xf2\x92\x50\x91\x60\xf1\x82\x60\x64\xb1\x23"
            "\x91\x31\x21\x40\xf3\x31\x32\x31\x30\x41\x21\x31\x93"
            "\x21\xb4\x60\xf1\x62\x80\x61\x90\xf2\x52\x90\xf1\x51"
            "\xa0\xf1\x42\xa0\x41\xb2\x21\xb2\x12\xb1\x21\xd2\xd1" }  },
      /* --- pixel bitmap for cmex131 char#74 \bigodot --- */
      {  74,81095,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xa2\x62\x71\xa1\x51\xc1\x20\xf1\x11\xe1\x1f\x11"
            "\xe0\x21\x0f\x11\x72\x71\x0f\x11\xe0\x21\xf1\x11\xe1"
            "\x10\x21\xc1\x51\xa1\x72\x62\xa6\x61" }  },
      /* --- pixel bitmap for cmex131 char#75 \Bigodot --- */
      {  75,82264,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,113, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x97\xe0\x22\x72\xc2\xb2\x91\xe0\x11\x71\xe0\x31\x30"
            "\xf1\x21\xe0\x51\x20\xf1\x11\xe0\x71\x1f\x11\xe0\x91"
            "\x0f\x21\xa3\xa1\x0f\x11\xe0\x91\xf1\x11\xe0\x71\x10"
            "\xf1\x21\xe0\x51\x20\x31\xe0\x31\x71\xe0\x11\x92\xb2"
            "\xc2\x72\xe0\x27\x90" }  },
      /* --- pixel bitmap for cmex131 char#76 \bigoplus --- */
      {  76,83279,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 18,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\xc0\xc8\x80\x20\x04\x81\x20\x02\x02\x09\x08"
            "\x14\x20\x60\x80\x80\xff\xff\x07\x08\x18\x20\x60\x80"
            "\x80\x02\x02\x09\x08\x44\x20\x08\x82\x10\x30\x32\x00"
            "\x3f\x00" }  },
      /* --- pixel bitmap for cmex131 char#77 \Bigoplus --- */
      {  77,84473,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x97\xe0\x22\x31\x32\xc2\x51\x52\x91\x71\x71\x71\x81"
            "\x81\x30\xf1\x21\x91\x91\x20\xf1\x11\xa1\xa1\x1f\x21"
            "\xb1\xb1\x0e\x0b\x0f\x21\xb1\xb1\xf1\x11\xa1\xa1\x10"
            "\xf1\x21\x91\x91\x20\x31\x81\x81\x71\x71\x71\x92\x51"
            "\x52\xc2\x31\x32\xe0\x27\x90" }  },
      /* --- pixel bitmap for cmex131 char#78 \bigotimes --- */
      {  78,85525,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 18,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\xc0\xc0\x80\x00\x04\x03\x30\x12\x20\x89\x40"
            "\x14\x84\x60\x20\x81\x01\x03\x06\x0c\x18\x48\x60\x10"
            "\x82\x22\x10\x49\x80\xc4\x00\x0c\x02\x10\x30\x30\x00"
            "\x3f\x00" }  },
      /* --- pixel bitmap for cmex131 char#79 \Bigotimes --- */
      {  79,86728,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,155, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x97\xe0\x22\x72\xc2\xb2\x91\xe0\x11\x72\xe0\x12\x51"
            "\x21\xd1\x21\x41\x31\xb1\x31\x31\x51\x91\x51\x21\x61"
            "\x71\x61\x11\x81\x51\x82\x91\x31\x92\xa1\x11\xa2\xb1"
            "\xb2\xa1\x11\xa2\x91\x31\x92\x81\x51\x81\x11\x61\x71"
            "\x61\x21\x51\x91\x51\x31\x31\xb1\x31\x41\x21\xd1\x21"
            "\x52\xe0\x12\x71\xe0\x11\x92\xb2\xc2\x72\xe0\x27\x91" }  },
      /* --- pixel bitmap for cmex131 char#80 \sum --- */
      {  80,88130,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 17,   18, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\x22\xa4\x21\xc2\x31\xc1\x41\xc1\x32\xe0\x22"
            "\xe0\x21\xb0\xf1\x61\xa0\x51\xe0\x12\xe0\x11\xe0\x11"
            "\xc1\x22\xb1\x31\xb2\x21\xa4\x1e\x01\x21" }  },
      /* --- pixel bitmap for cmex131 char#81 \prod --- */
      {  81,91076,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\xfe\x22\x72\x20\x22\x72\x26\x36" }  },
      /* --- pixel bitmap for cmex131 char#82 \int --- */
      {  82,96842,                      /* character number, location */
          0, 1,  -20, 1,      /* topleft row,col, and botleft row,col */
          { 11,   20, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x81\x21\xf3\x61\x40\xf7\x51\x50\xf3\x41\x61\x21"
            "\x83\x74" }  },
      /* --- pixel bitmap for cmex131 char#83 \bigcup --- */
      {  83,100793,                     /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x01\xb1\xf1\x11\x91\x10\x22\x52\x65\x42" }  },
      /* --- pixel bitmap for cmex131 char#84 \bigcap --- */
      {  84,102565,                     /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x52\x20\xf1\x11\x91\x1f\xd1\xb1" }  },
      /* --- pixel bitmap for cmex131 char#85 \biguplus --- */
      {  85,104402,                     /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x01\xb1\x0f\x31\x51\x51\x01\x19\x11\x0f\x31\x51"
            "\x51\x01\xb1\xf1\x11\x91\x10\x22\x52\x65\x44" }  },
      /* --- pixel bitmap for cmex131 char#86 \bigwedge --- */
      {  86,106252,                     /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x61\x60\xf2\x51\x11\x50\xf2\x41\x31\x40\xf1\x31"
            "\x51\x30\xf2\x21\x71\x20\xf2\x11\x91\x1f\x11\xb1" }  },
      /* --- pixel bitmap for cmex131 char#87 \bigvee --- */
      {  87,107964,                     /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xb1\xf2\x11\x91\x10\xf2\x21\x71\x20\xf1\x31"
            "\x51\x30\xf2\x41\x31\x40\xf2\x51\x11\x50\xf1\x61\x62" }  },
      /* --- pixel bitmap for cmex131 char#88 \Bigsum --- */
      {  88,89615,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 24,   25, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x0e\x08\x24\xe5\x23\xe0\x32\x33\xe0\x31\x43\xe0\x31"
            "\x34\xe0\x73\xe0\x83\xe0\x83\xe0\x74\xe0\x73\xe0\x83"
            "\xe0\x83\xe0\x72\xe0\x81\xe0\x81\xe0\x82\xe0\x72\xe0"
            "\x72\xe0\x81\xe0\x31\x41\xe0\x31\x41\xe0\x32\x32\xe0"
            "\x14\x2e\x07\x2e\x08\x21" }  },
      /* --- pixel bitmap for cmex131 char#89 \Bigprod --- */
      {  89,92700,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 21,   25, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x07\x24\x94\x20\xfe\x33\x93\x30\xf5\x33\x93\x30"
            "\x25\x75\x29\x39" }  },
      /* --- pixel bitmap for cmex131 char#90 \Bigint --- */
      {  90,97864,                      /* character number, location */
          0, 1,  -40, 1,      /* topleft row,col, and botleft row,col */
          { 16,   40, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd2\xd1\x21\xb2\x12\xb1\x22\xb1\x40\xf1\xa2\x40\xf1"
            "\xa1\x50\xf2\x92\x50\x91\x60\xf3\x82\x60\x81\x70\xf3"
            "\x72\x70\x71\x80\xf3\x62\x80\x61\x90\xf2\x52\x90\xf1"
            "\x51\xa0\xf1\x42\xa0\x41\xb2\x21\xb2\x12\xb1\x21\xd2"
            "\xd4" }  },
      /* --- pixel bitmap for cmex131 char#91 \Bigcup --- */
      {  91,101728,                     /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\xe0\x21\x0f\x31\xe0\x21\xf1\x11\xe1\x10\x21"
            "\xc1\x51\xa1\x72\x62\xa6\x60" }  },
      /* --- pixel bitmap for cmex131 char#92 \Bigcap --- */
      {  92,103507,                     /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xa2\x62\x71\xa1\x51\xc1\x20\xf1\x11\xe1\x1f\xe1"
            "\xe0\x21\x0f\x31\xe0\x21" }  },
      /* --- pixel bitmap for cmex131 char#93 \Biguplus --- */
      {  93,105420,                     /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x01\xe0\x21\x0f\x51\x81\x71\x01\x1e\x11\x0f\x51"
            "\x81\x71\x01\xe0\x21\xf1\x11\xe1\x10\x21\xc1\x51\xa1"
            "\x72\x62\xa6\x60" }  },
      /* --- pixel bitmap for cmex131 char#94 \Bigwedge --- */
      {  94,107161,                     /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x80\xf1\x82\x80\xf2\x71\x21\x70\xf2\x61\x41\x60"
            "\xf2\x51\x61\x50\xf2\x41\x81\x40\xf1\x31\xa1\x30\xf2"
            "\x21\xc1\x20\xf2\x11\xe1\x1f\x11\xe0\x21" }  },
      /* --- pixel bitmap for cmex131 char#95 \Bigvee --- */
      {  95,108874,                     /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xe0\x21\xf2\x11\xe1\x10\xf2\x21\xc1\x20\xf1"
            "\x31\xa1\x30\xf2\x41\x81\x40\xf2\x51\x61\x50\xf2\x61"
            "\x41\x60\xf2\x71\x21\x70\xf1\x82\x80\x91\x81" }  },
      /* --- pixel bitmap for cmex131 char#96 \coprod --- */
      {  96,94195,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x36\xfe\x22\x72\x20\x22\x72\x2e\x01" }  },
      /* --- pixel bitmap for cmex131 char#97 \Bigcoprod --- */
      {  97,95821,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 21,   25, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x39\x25\x75\x20\xfe\x33\x93\x30\xf5\x33\x93\x30"
            "\x24\x94\x2e\x07" }  },
      /* --- pixel bitmap for cmex131 char#98 ^ --- */
      {  98,109639,                     /* character number, location */
         13, 0,   10, 0,      /* topleft row,col, and botleft row,col */
          { 10,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x30\x33\x30" }  },
      /* --- pixel bitmap for cmex131 char#99 ^ --- */
      {  99,110510,                     /* character number, location */
         14, 0,   10, 0,      /* topleft row,col, and botleft row,col */
          { 18,    4, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x74\xb3\x43\x53\xa3\x11\xe0\x21" }  },
      /* --- pixel bitmap for cmex131 char#100 ^ --- */
      { 100,111594,                     /* character number, location */
         14, 0,   10, 0,      /* topleft row,col, and botleft row,col */
          { 26,    4, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb4\xe0\x35\x45\x75\xe5\x11\xe0\xa1" }  },
      /* --- pixel bitmap for cmex131 char#101 ~ --- */
      { 101,112307,                     /* character number, location */
         13, 0,   11, 0,      /* topleft row,col, and botleft row,col */
          { 10,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\xcf\x07" }  },
      /* --- pixel bitmap for cmex131 char#102 ~ --- */
      { 102,113223,                     /* character number, location */
         14, 0,   11, 0,      /* topleft row,col, and botleft row,col */
          { 18,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x00\x3a\x1e\x17\xc0\x07" }  },
      /* --- pixel bitmap for cmex131 char#103 ~ --- */
      { 103,114354,                     /* character number, location */
         14, 0,   11, 0,      /* topleft row,col, and botleft row,col */
          { 26,    3, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x57\xc2\x24\x46\x44\x22\xc7\x50" }  },
      /* --- pixel bitmap for cmex131 char#104 \Big[ --- */
      { 104,12857,                      /* character number, location */
          1, 4,  -31, 4,      /* topleft row,col, and botleft row,col */
          {  5,   32, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\xe1\x45" }  },
      /* --- pixel bitmap for cmex131 char#105 \Big] --- */
      { 105,18606,                      /* character number, location */
          1, 0,  -31, 0,      /* topleft row,col, and botleft row,col */
          {  5,   32, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xfe\x41\x05" }  },
      /* --- pixel bitmap for cmex131 char#106 (noname) --- */
      { 106,24380,                      /* character number, location */
          1, 4,  -31, 4,      /* topleft row,col, and botleft row,col */
          {  6,   32, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x5f\xe1\x51\x56" }  },
      /* --- pixel bitmap for cmex131 char#107 (noname) --- */
      { 107,27864,                      /* character number, location */
          1, 0,  -31, 0,      /* topleft row,col, and botleft row,col */
          {  6,   32, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x51\xfe\x51\x57" }  },
      /* --- pixel bitmap for cmex131 char#108 (noname) --- */
      { 108,31352,                      /* character number, location */
          1, 4,  -31, 4,      /* topleft row,col, and botleft row,col */
          {  6,   32, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x5f\xe1\x51\x57" }  },
      /* --- pixel bitmap for cmex131 char#109 (noname) --- */
      { 109,34844,                      /* character number, location */
          1, 0,  -31, 0,      /* topleft row,col, and botleft row,col */
          {  6,   32, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x51\xfe\x51\x51" }  },
      /* --- pixel bitmap for cmex131 char#110 \Big{ --- */
      { 110,38552,                      /* character number, location */
          1, 2,  -31, 2,      /* topleft row,col, and botleft row,col */
          {  8,   32, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\x51\x61\x30\xfa\x31\x40\x21\x50\xf1\x11\x60\x21"
            "\x50\xfa\x31\x40\x41\x81\x82" }  },
      /* --- pixel bitmap for cmex131 char#111 \Big} --- */
      { 111,46066,                      /* character number, location */
          1, 2,  -31, 2,      /* topleft row,col, and botleft row,col */
          {  8,   32, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x82\x71\x50\xfa\x31\x40\x41\x30\xf1\x53\x41\x30"
            "\xfa\x31\x40\x21\x62\x51\x71" }  },
      /* --- pixel bitmap for cmex131 char#112 (noname) --- */
      { 112,72584,                      /* character number, location */
          1, 3,  -21, 3,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x11\xf1\xe1\x10\xf1\xd1\x20\xf1\xc1\x30\xf1"
            "\xb1\x40\xa1\x61\x81\x52\x71\x81\x61\x60\xf1\x21\x51"
            "\x70\xf1\x31\x31\x80\xf1\x41\x11\x90\x42\xe0\x11\xa2" }  },
      /* --- pixel bitmap for cmex131 char#113 (noname) --- */
      { 113,73555,                      /* character number, location */
          1, 3,  -32, 3,      /* topleft row,col, and botleft row,col */
          { 16,   33, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x11\xf2\xe1\x10\xf2\xd1\x20\xf3\xc1\x30\xf2"
            "\xb1\x40\xf1\xa1\x50\x11\x81\x52\x71\x71\x71\x81\x61"
            "\x60\xf2\x21\x51\x70\xf3\x31\x31\x80\xf2\x41\x11\x90"
            "\xf1\x51\xa1" }  },
      /* --- pixel bitmap for cmex131 char#114 (noname) --- */
      { 114,74559,                      /* character number, location */
          1, 3,  -43, 3,      /* topleft row,col, and botleft row,col */
          { 16,   44, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\x11\xf3\xe1\x10\xf3\xd1\x20\xf4\xc1\x30\xf3"
            "\xb1\x40\xf1\xa1\x50\xf1\x11\x81\x52\x71\x60\xf1\x11"
            "\x71\x60\x21\x61\x60\xf3\x21\x51\x70\x31\x41\x70\xf3"
            "\x31\x31\x80\xf3\x41\x11\x90\x42\xa0\xf1\x51\xa1" }  },
      /* --- pixel bitmap for cmex131 char#115 (noname) --- */
      { 115,75595,                      /* character number, location */
          1, 3,  -54, 3,      /* topleft row,col, and botleft row,col */
          { 16,   55, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\x11\xf5\xe1\x10\xf4\xd1\x20\xf4\xc1\x30\xf5"
            "\xb1\x40\xf2\xa1\x50\x11\x81\x52\x81\x52\x71\x60\xf2"
            "\x11\x71\x60\xf1\x21\x61\x60\xf3\x21\x51\x70\x31\x41"
            "\x70\xf4\x31\x31\x80\xf5\x41\x11\x90\xf2\x51\xa1" }  },
      /* --- pixel bitmap for cmex131 char#116 (noname) --- */
      { 116,76703,                      /* character number, location */
          1, 2,  -33, 2,      /* topleft row,col, and botleft row,col */
          { 12,   34, 3,68, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\xb1\x11\x91\x12\x82\x11\x81\x21\x81\xf2\x31\x71"
            "\xf2\x41\x61\xf2\x51\x51\xf2\x61\x41\xf2\x71\x31\xf2"
            "\x81\x21\xf2\x91\x11\xf2\xa2\xb1" }  },
      /* --- pixel bitmap for cmex131 char#117 (noname) --- */
      { 117,77612,                      /* character number, location */
          1,13,  -12,13,      /* topleft row,col, and botleft row,col */
          {  1,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f" }  },
      /* --- pixel bitmap for cmex131 char#118 (noname) --- */
      { 118,78429,                      /* character number, location */
          1,13,  -11,13,      /* topleft row,col, and botleft row,col */
          {  7,   12, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\xa1\x61" }  },
      /* --- pixel bitmap for cmex131 char#119 (noname) --- */
      { 119,71623,                      /* character number, location */
          1, 4,  -12, 4,      /* topleft row,col, and botleft row,col */
          {  6,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x01\x41" }  },
      /* --- pixel bitmap for cmex131 char#120 (noname) --- */
      { 120,66937,                      /* character number, location */
          0, 2,  -11, 2,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x73\x55\x22\x21\x22\xf6\x41\x40" }  },
      /* --- pixel bitmap for cmex131 char#121 (noname) --- */
      { 121,67862,                      /* character number, location */
          0, 2,  -11, 2,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x41\x42\x21\x22\x25\x53\x71\x40" }  },
      /* --- pixel bitmap for cmex131 char#122 (noname) --- */
      { 122,51534,                      /* character number, location */
          3,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          { 10,    6, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x46\x37\x23\x61\x81\x91" }  },
      /* --- pixel bitmap for cmex131 char#123 (noname) --- */
      { 123,52114,                      /* character number, location */
          3,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          { 10,    6, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x66\x47\x83\xa1\xa1" }  },
      /* --- pixel bitmap for cmex131 char#124 (noname) --- */
      { 124,52691,                      /* character number, location */
          6,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 10,    6, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xa1\xa3\x87\x46\x64" }  },
      /* --- pixel bitmap for cmex131 char#125 (noname) --- */
      { 125,53269,                      /* character number, location */
          6,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 10,    6, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x81\x63\x27\x36\x44\x61" }  },
      /* --- pixel bitmap for cmex131 char#126 (noname) --- */
      { 126,69635,                      /* character number, location */
         -1, 0,  -11, 0,      /* topleft row,col, and botleft row,col */
          { 14,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x00\x48\x00\x33\x60\x18\x16\x5a\x84\x08\x21\x40"
            "\x08\x10\x02\x84\x00" }  },
      /* --- pixel bitmap for cmex131 char#127 (noname) --- */
      { 127,70733,                      /* character number, location */
          0, 0,  -10, 0,      /* topleft row,col, and botleft row,col */
          { 14,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x02\x84\x00\x21\x40\x08\x11\xa2\x85\x86\x61\xc0"
            "\x0c\x20\x01\x30\x00" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=4 for .160gf ---
 * mf '\mode=preview; mag=magstep(-15.29639112828755784636); input cmex10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmex160 --- */
static	chardef  cmex160[] =
   {
      /* --- pixel bitmap for cmex160 char#0 \big( --- */
      {   0,  661,                      /* character number, location */
          1, 3,  -25, 3,      /* topleft row,col, and botleft row,col */
          {  6,   26, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x41\x41\x42\x41\x30\xf2\x12\x3f\x92\x40\xf2\x12"
            "\x30\x21\x52\x51\x61\x61" }  },
      /* --- pixel bitmap for cmex160 char#1 \big) --- */
      {   1, 6506,                      /* character number, location */
          1, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          {  6,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x40\x30\x08\x86\x61\x30\x0c\xc3\x30\x0c\xc3\x30"
            "\x8c\x61\x18\xc2\x10\x42\x00" }  },
      /* --- pixel bitmap for cmex160 char#2 \big[ --- */
      {   2,12267,                      /* character number, location */
          1, 4,  -25, 4,      /* topleft row,col, and botleft row,col */
          {  5,   26, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\x81\x45" }  },
      /* --- pixel bitmap for cmex160 char#3 \big] --- */
      {   3,18127,                      /* character number, location */
          1, 0,  -25, 0,      /* topleft row,col, and botleft row,col */
          {  5,   26, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xf8\x41\x05" }  },
      /* --- pixel bitmap for cmex160 char#4 (noname) --- */
      {   4,23954,                      /* character number, location */
          1, 4,  -25, 4,      /* topleft row,col, and botleft row,col */
          {  6,   26, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x5f\x91\x56" }  },
      /* --- pixel bitmap for cmex160 char#5 (noname) --- */
      {   5,27517,                      /* character number, location */
          1, 0,  -25, 0,      /* topleft row,col, and botleft row,col */
          {  6,   26, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x51\xf9\x51\x06" }  },
      /* --- pixel bitmap for cmex160 char#6 (noname) --- */
      {   6,31056,                      /* character number, location */
          1, 4,  -25, 4,      /* topleft row,col, and botleft row,col */
          {  6,   26, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x5f\x91\x52" }  },
      /* --- pixel bitmap for cmex160 char#7 (noname) --- */
      {   7,34627,                      /* character number, location */
          1, 0,  -25, 0,      /* topleft row,col, and botleft row,col */
          {  6,   26, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x51\xf9\x51" }  },
      /* --- pixel bitmap for cmex160 char#8 \big{ --- */
      {   8,38241,                      /* character number, location */
          1, 2,  -25, 2,      /* topleft row,col, and botleft row,col */
          {  9,   26, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\x52\x20\xf8\x42\x30\x32\x40\xf1\x13\x50\x32\x40"
            "\xf8\x42\x30\x52\x92" }  },
      /* --- pixel bitmap for cmex160 char#9 \big} --- */
      {   9,45750,                      /* character number, location */
          1, 2,  -25, 2,      /* topleft row,col, and botleft row,col */
          {  9,   26, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x83\x40\xf8\x42\x30\x52\x20\xf1\x63\x52\x20\xf8"
            "\x42\x30\x23\x43\x60" }  },
      /* --- pixel bitmap for cmex160 char#10 \big< --- */
      {  10,54506,                      /* character number, location */
          1, 2,  -26, 2,      /* topleft row,col, and botleft row,col */
          {  6,   27, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x41\x08\x82\x10\x04\x21\x08\x41\x10\x08\x02"
            "\x41\x10\x08\x82\x40\x10\x08\x02" }  },
      /* --- pixel bitmap for cmex160 char#11 \big> --- */
      {  11,57371,                      /* character number, location */
          1, 2,  -26, 2,      /* topleft row,col, and botleft row,col */
          {  6,   27, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x20\x08\x04\x41\x20\x08\x02\x41\x20\x08\x42\x10"
            "\x82\x20\x04\x41\x08\x42\x10\x00" }  },
      /* --- pixel bitmap for cmex160 char#12 (noname) --- */
      {  12,66387,                      /* character number, location */
          1, 3,  -14, 3,      /* topleft row,col, and botleft row,col */
          {  1,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x7f" }  },
      /* --- pixel bitmap for cmex160 char#13 (noname) --- */
      {  13,67010,                      /* character number, location */
          1, 3,  -14, 3,      /* topleft row,col, and botleft row,col */
          {  6,   15, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x41" }  },
      /* --- pixel bitmap for cmex160 char#14 (noname) --- */
      {  14,60222,                      /* character number, location */
          1, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 11,   26, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\x92\xf1\x91\x10\x82\x91\x92\x20\xf1\x71\x30\x62"
            "\x91\x92\x40\xf1\x51\x50\x42\x91\x92\x60\xf1\x31\x70"
            "\x22\x91\x92\x80\xf1\x11\x92\x91\xa2" }  },
      /* --- pixel bitmap for cmex160 char#15 (noname) --- */
      {  15,63336,                      /* character number, location */
          1, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 11,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x18\x80\x00\x04\x60\x00\x02\x30\x00\x01\x08\xc0"
            "\x00\x04\x60\x00\x02\x10\x80\x01\x08\xc0\x00\x04\x20"
            "\x00\x03\x10\x80\x01\x08\x40\x00\x06\x20" }  },
      /* --- pixel bitmap for cmex160 char#16 \Big( --- */
      {  16, 1398,                      /* character number, location */
          1, 4,  -38, 4,      /* topleft row,col, and botleft row,col */
          {  8,   39, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x61\x61\x62\x61\x62\x61\x62\x61\x50\xf3\x12\x5f"
            "\xc2\x60\xf3\x12\x50\x21\x72\x71\x72\x71\x72\x71\x81"
            "\x81" }  },
      /* --- pixel bitmap for cmex160 char#17 \Big) --- */
      {  17, 7204,                      /* character number, location */
          1, 1,  -38, 1,      /* topleft row,col, and botleft row,col */
          {  8,   39, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x81\x72\x71\x72\x71\x72\x71\x20\xf3\x52\x10"
            "\xfc\x62\xf3\x52\x10\x51\x62\x61\x62\x61\x62\x61\x61"
            "\x61\x71" }  },
      /* --- pixel bitmap for cmex160 char#18 \bigg( --- */
      {  18, 2240,                      /* character number, location */
          1, 4,  -51, 4,      /* topleft row,col, and botleft row,col */
          { 11,   52, 3,78, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\x91\x91\x91\x92\x91\x91\x92\x91\x60\xf1\x32\x60"
            "\xf2\x22\x70\xf4\x12\x8f\xd2\x90\xf4\x12\x80\xf2\x22"
            "\x70\xf1\x32\x60\x41\xa2\xa1\xb1\xa2\xa1\xb1\xb1\xb1" }  },
      /* --- pixel bitmap for cmex160 char#19 \bigg) --- */
      {  19, 8007,                      /* character number, location */
          1, 1,  -51, 1,      /* topleft row,col, and botleft row,col */
          { 11,   52, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xb1\xb1\xb1\xa2\xa1\xb1\xa2\xa1\x40\xf1\x62\x30"
            "\xf2\x72\x20\xf4\x82\x10\xfd\x92\xf4\x82\x10\xf2\x72"
            "\x20\xf1\x62\x30\x61\x92\x91\x91\x92\x91\x91\x91\x91"
            "\xa0" }  },
      /* --- pixel bitmap for cmex160 char#20 \bigg[ --- */
      {  20,13938,                      /* character number, location */
          1, 5,  -51, 5,      /* topleft row,col, and botleft row,col */
          {  7,   52, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x07\x0f\xe2\x5f\xe2\x5f\xe2\x5f\x22\x5f\x17" }  },
      /* --- pixel bitmap for cmex160 char#21 \bigg] --- */
      {  21,19746,                      /* character number, location */
          1, 0,  -51, 0,      /* topleft row,col, and botleft row,col */
          {  7,   52, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x07\xfe\x52\xfe\x52\xfe\x52\xf2\x52\x0f\x17" }  },
      /* --- pixel bitmap for cmex160 char#22 (noname) --- */
      {  22,25689,                      /* character number, location */
          1, 5,  -51, 5,      /* topleft row,col, and botleft row,col */
          {  8,   52, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x31\x00\x02\x06\xff\x01\x08" }  },
      /* --- pixel bitmap for cmex160 char#23 (noname) --- */
      {  23,29200,                      /* character number, location */
          1, 0,  -51, 0,      /* topleft row,col, and botleft row,col */
          {  8,   52, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x31\x06\x02\x00\xff\x01\x08" }  },
      /* --- pixel bitmap for cmex160 char#24 (noname) --- */
      {  24,32795,                      /* character number, location */
          1, 5,  -51, 5,      /* topleft row,col, and botleft row,col */
          {  8,   52, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x08\x00\xff\x31\x02\x06" }  },
      /* --- pixel bitmap for cmex160 char#25 (noname) --- */
      {  25,36314,                      /* character number, location */
          1, 0,  -51, 0,      /* topleft row,col, and botleft row,col */
          {  8,   52, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x08\xff\x31\x06\x02" }  },
      /* --- pixel bitmap for cmex160 char#26 \bigg{ --- */
      {  26,40222,                      /* character number, location */
          1, 3,  -51, 3,      /* topleft row,col, and botleft row,col */
          { 11,   52, 3,68, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x82\x82\x82\x91\x40\xfe\x52\x40\xf1\x52\x40\x42"
            "\x91\x82\x70\xf1\x12\x80\x22\xb1\xa2\x50\xfe\x52\x40"
            "\xf1\x52\x40\x61\xa2\xa2\xa2\xa2" }  },
      /* --- pixel bitmap for cmex160 char#27 \bigg} --- */
      {  27,47733,                      /* character number, location */
          1, 3,  -51, 3,      /* topleft row,col, and botleft row,col */
          { 11,   52, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xb2\xa2\x60\xf1\x42\x50\xfe\x52\x40\xf1\x52\x40"
            "\xf1\x62\x30\x72\x20\xf1\x92\x72\x20\xf1\x62\x30\xfe"
            "\x52\x40\xf1\x52\x40\xf1\x42\x50\x32\x82\x72\x91" }  },
      /* --- pixel bitmap for cmex160 char#28 \bigg< --- */
      {  28,55899,                      /* character number, location */
          1, 3,  -51, 3,      /* topleft row,col, and botleft row,col */
          { 12,   52, 3,120, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb1\xa2\xf2\x92\x10\xf1\x82\x20\xf2\x72\x30\xf1\x62"
            "\x40\xf2\x52\x50\xf1\x42\x60\xf2\x32\x70\xf1\x22\x80"
            "\xf2\x12\x9f\x12\xa0\xf2\x12\x90\xf1\x22\x80\xf2\x32"
            "\x70\xf1\x42\x60\xf2\x52\x50\xf1\x62\x40\xf2\x72\x30"
            "\xf1\x82\x20\xf2\x92\x10\xa2\xb1" }  },
      /* --- pixel bitmap for cmex160 char#29 \bigg> --- */
      {  29,58766,                      /* character number, location */
          1, 2,  -51, 2,      /* topleft row,col, and botleft row,col */
          { 12,   52, 3,121, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xa0\xf2\x12\x90\xf1\x22\x80\xf2\x32\x70\xf1"
            "\x42\x60\xf2\x52\x50\xf1\x62\x40\xf2\x72\x30\xf1\x82"
            "\x20\xf2\x92\x10\xf1\xa2\xf2\x92\x10\xf1\x82\x20\xf2"
            "\x72\x30\xf1\x62\x40\xf2\x52\x50\xf1\x42\x60\xf2\x32"
            "\x70\xf1\x22\x80\xf2\x12\x9f\x12\xa0" }  },
      /* --- pixel bitmap for cmex160 char#30 (noname) --- */
      {  30,61711,                      /* character number, location */
          1, 1,  -51, 1,      /* topleft row,col, and botleft row,col */
          { 21,   52, 3,205, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x61\xe0\x52\xf1\xe0\x51\x10\xe0\x42\xe0\x51\xe0"
            "\x52\x20\xf1\xe0\x31\x30\xe0\x22\xe0\x51\xe0\x52\x40"
            "\xf1\xe0\x11\x50\xe2\x50\xf1\xe1\x60\xd2\xe0\x51\xe0"
            "\x52\x70\xf1\xc1\x80\xb2\xe0\x51\xe0\x52\x90\xf1\xa1"
            "\xa0\x92\xe0\x51\xe0\x52\xb0\xf1\x81\xc0\x72\xe0\x51"
            "\xe0\x52\xd0\xf1\x61\xe0\x52\xe0\xf1\x51\xe0\x10\x42"
            "\xe0\x51\xe0\x52\xe0\x20\xf1\x31\xe0\x30\x22\xe0\x51"
            "\xe0\x52\xe0\x40\xf1\x11\xe0\x52\xe0\x51\xe0\x60" }  },
      /* --- pixel bitmap for cmex160 char#31 (noname) --- */
      {  31,64833,                      /* character number, location */
          1, 1,  -51, 1,      /* topleft row,col, and botleft row,col */
          { 21,   52, 3,208, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x62\xe0\x50\xf1\x11\xe0\x50\x12\xe0\x61\xe0"
            "\x62\xe0\x30\xf1\x31\xe0\x30\x32\xe0\x61\xe0\x62\xe0"
            "\x10\xf1\x51\xe0\x10\x52\xe0\xf1\x61\xe0\x62\xe0\x61"
            "\xe0\x62\xc0\xf1\x81\xc0\x82\xe0\x61\xe0\x62\xa0\xf1"
            "\xa1\xa0\xa2\xe0\x61\xe0\x62\x80\xf1\xc1\x80\xc2\xe0"
            "\x61\xe0\x62\x60\xf1\xe1\x60\xe2\x50\xf1\xe0\x11\x50"
            "\xe0\x12\xe0\x61\xe0\x62\x30\xf1\xe0\x31\x30\xe0\x32"
            "\xe0\x61\xe0\x62\x10\xf1\xe0\x51\x10\xe0\x52\xe0\x61" }  },
      /* --- pixel bitmap for cmex160 char#32 \Bigg( --- */
      {  32, 3134,                      /* character number, location */
          1, 6,  -65, 6,      /* topleft row,col, and botleft row,col */
          { 11,   66, 3,122, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xa1\x91\x10\xf1\x81\x20\x71\x92\x91\x92\x91\x92\x91"
            "\x60\xf1\x32\x60\x31\x70\xf2\x22\x70\x21\x80\xf4\x12"
            "\x80\x11\x9f\xe2\x9f\x22\x90\x11\x90\xf4\x12\x80\x21"
            "\x80\xf2\x22\x70\x31\x70\xf1\x32\x60\x41\xa2\xa1\xa2"
            "\xa1\xa2\xa1\x30\xf1\x81\x20\x91\xb1" }  },
      /* --- pixel bitmap for cmex160 char#33 \Bigg) --- */
      {  33, 8862,                      /* character number, location */
          1, 1,  -65, 1,      /* topleft row,col, and botleft row,col */
          { 11,   66, 3,123, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xb1\x90\xf1\x21\x80\x31\xa2\xa1\xa2\xa1\xa2\xa1"
            "\x40\xf1\x62\x30\x71\x30\xf2\x72\x20\x81\x20\xf4\x82"
            "\x10\x91\x10\xfe\x92\xf2\x92\x91\x10\xf4\x82\x10\x81"
            "\x20\xf2\x72\x20\x71\x30\xf1\x62\x30\x61\x92\x91\x92"
            "\x91\x92\x91\x70\xf1\x21\x80\x11\x91\xa0" }  },
      /* --- pixel bitmap for cmex160 char#34 \Bigg[ --- */
      {  34,14865,                      /* character number, location */
          1, 6,  -65, 6,      /* topleft row,col, and botleft row,col */
          {  7,   66, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x07\x00\xff\x3d\x02\x05\xff\x01\x07" }  },
      /* --- pixel bitmap for cmex160 char#35 \Bigg] --- */
      {  35,20660,                      /* character number, location */
          1, 0,  -65, 0,      /* topleft row,col, and botleft row,col */
          {  7,   66, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x07\xff\x3d\x05\x02\x00\xff\x01\x07" }  },
      /* --- pixel bitmap for cmex160 char#36 (noname) --- */
      {  36,26648,                      /* character number, location */
          1, 6,  -65, 6,      /* topleft row,col, and botleft row,col */
          {  8,   66, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3f\x00\x02\x06\xff\x01\x08" }  },
      /* --- pixel bitmap for cmex160 char#37 (noname) --- */
      {  37,30146,                      /* character number, location */
          1, 0,  -65, 0,      /* topleft row,col, and botleft row,col */
          {  8,   66, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3f\x06\x02\x00\xff\x01\x08" }  },
      /* --- pixel bitmap for cmex160 char#38 (noname) --- */
      {  38,33756,                      /* character number, location */
          1, 6,  -65, 6,      /* topleft row,col, and botleft row,col */
          {  8,   66, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x08\x00\xff\x3f\x02\x06" }  },
      /* --- pixel bitmap for cmex160 char#39 (noname) --- */
      {  39,37262,                      /* character number, location */
          1, 0,  -65, 0,      /* topleft row,col, and botleft row,col */
          {  8,   66, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x08\xff\x3f\x06\x02" }  },
      /* --- pixel bitmap for cmex160 char#40 \Bigg{ --- */
      {  40,41304,                      /* character number, location */
          1, 3,  -65, 3,      /* topleft row,col, and botleft row,col */
          { 12,   66, 3,80, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\x92\x91\xa2\x30\xf1\x62\x40\xfe\x52\x50\xf6\x52"
            "\x50\x42\xa1\xa2\x92\x80\xf1\x11\xa0\x22\xb2\xb1\xb2"
            "\x60\xfe\x52\x50\xf6\x52\x50\xf1\x62\x40\x72\xb1\xc2"
            "\xc1" }  },
      /* --- pixel bitmap for cmex160 char#41 \Bigg} --- */
      {  41,48816,                      /* character number, location */
          1, 3,  -65, 3,      /* topleft row,col, and botleft row,col */
          { 12,   66, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xc2\xc1\xb2\x70\xf1\x42\x60\xfe\x52\x50\xf6\x52"
            "\x50\x62\xb1\xb2\xb2\x20\xf1\xa2\x82\x92\xa1\xa2\x40"
            "\xfe\x52\x50\xf6\x52\x50\xf1\x42\x60\x32\xa1\x92\x91"
            "\xb1" }  },
      /* --- pixel bitmap for cmex160 char#42 \Bigg< --- */
      {  42,56699,                      /* character number, location */
          1, 3,  -65, 3,      /* topleft row,col, and botleft row,col */
          { 13,   66, 3,132, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc1\xb2\xf2\xa2\x10\xf2\x92\x20\xf2\x82\x30\xf2\x72"
            "\x40\xf2\x62\x50\xf2\x52\x60\xf2\x42\x70\xf2\x32\x80"
            "\xf2\x22\x90\xf2\x12\xaf\x12\xb0\xf2\x12\xa0\xf2\x22"
            "\x90\xf2\x32\x80\xf2\x42\x70\xf2\x52\x60\xf2\x62\x50"
            "\xf2\x72\x40\xf2\x82\x30\xf2\x92\x20\xf2\xa2\x10\xb2"
            "\xc1" }  },
      /* --- pixel bitmap for cmex160 char#43 \Bigg> --- */
      {  43,59567,                      /* character number, location */
          1, 2,  -65, 2,      /* topleft row,col, and botleft row,col */
          { 13,   66, 3,133, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xb0\xf2\x12\xa0\xf2\x22\x90\xf2\x32\x80\xf2"
            "\x42\x70\xf2\x52\x60\xf2\x62\x50\xf2\x72\x40\xf2\x82"
            "\x30\xf2\x92\x20\xf2\xa2\x10\xf1\xb2\xf2\xa2\x10\xf2"
            "\x92\x20\xf2\x82\x30\xf2\x72\x40\xf2\x62\x50\xf2\x52"
            "\x60\xf2\x42\x70\xf2\x32\x80\xf2\x22\x90\xf2\x12\xaf"
            "\x12\xb0" }  },
      /* --- pixel bitmap for cmex160 char#44 / --- */
      {  44,62677,                      /* character number, location */
          1, 1,  -65, 1,      /* topleft row,col, and botleft row,col */
          { 26,   66, 3,281, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xb1\xe0\xa2\xf1\xe0\xa1\x10\xe0\x92\xe0\xa1\xe0"
            "\xa2\x20\xf1\xe0\x81\x30\xe0\x72\x30\xf1\xe0\x71\x40"
            "\xe0\x62\xe0\xa1\xe0\xa2\x50\xf1\xe0\x51\x60\xe0\x42"
            "\xe0\xa1\xe0\xa2\x70\xf1\xe0\x31\x80\xe0\x22\x80\xf1"
            "\xe0\x21\x90\xe0\x12\xe0\xa1\xe0\xa2\xa0\xf1\xe1\xb0"
            "\xd2\xe0\xa1\xe0\xa2\xc0\xf1\xc1\xd0\xb2\xd0\xf1\xb1"
            "\xe0\xa2\xe0\xa1\xe0\xa2\xe0\x10\xf1\x91\xe0\x20\x82"
            "\xe0\x20\xf1\x81\xe0\x30\x72\xe0\xa1\xe0\xa2\xe0\x40"
            "\xf1\x61\xe0\x50\x52\xe0\xa1\xe0\xa2\xe0\x60\xf1\x41"
            "\xe0\x70\x32\xe0\x70\xf1\x31\xe0\x80\x22\xe0\xa1\xe0"
            "\xa2\xe0\x90\xf1\x11\xe0\xa2\xe0\xa1\xe0\xb0" }  },
      /* --- pixel bitmap for cmex160 char#45 \ --- */
      {  45,65803,                      /* character number, location */
          1, 1,  -65, 1,      /* topleft row,col, and botleft row,col */
          { 26,   66, 3,280, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xe0\xb2\xe0\xa0\xf1\x11\xe0\xa0\x12\xe0\xb1\xe0"
            "\xb2\xe0\x80\xf1\x31\xe0\x80\x32\xe0\x70\xf1\x41\xe0"
            "\x70\x42\xe0\xb1\xe0\xb2\xe0\x50\xf1\x61\xe0\x50\x62"
            "\xe0\xb1\xe0\xb2\xe0\x30\xf1\x81\xe0\x30\x82\xe0\x20"
            "\xf1\x91\xe0\x20\x92\xe0\xb1\xe0\xb2\xe0\xf1\xb1\xe0"
            "\xb2\xd0\xf1\xc1\xd0\xc2\xe0\xb1\xe0\xb2\xb0\xf1\xe1"
            "\xb0\xe2\xe0\xb1\xe0\xb2\x90\xf1\xe0\x21\x90\xe0\x22"
            "\x80\xf1\xe0\x31\x80\xe0\x32\xe0\xb1\xe0\xb2\x60\xf1"
            "\xe0\x51\x60\xe0\x52\xe0\xb1\xe0\xb2\x40\xf1\xe0\x71"
            "\x40\xe0\x72\x30\xf1\xe0\x81\x30\xe0\x82\xe0\xb1\xe0"
            "\xb2\x10\xf1\xe0\xa1\x10\xe0\xa2\xe0\xb1" }  },
      /* --- pixel bitmap for cmex160 char#46 / --- */
      {  46,60901,                      /* character number, location */
          1, 1,  -38, 1,      /* topleft row,col, and botleft row,col */
          { 16,   39, 3,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x11\xe2\xf1\xe1\x10\xd2\xe1\xe2\x20\xf1\xc1\x30"
            "\xb2\xe1\xe2\x40\xf1\xa1\x50\x92\xe1\xe2\x60\xf1\x81"
            "\x70\x72\x70\xf1\x71\x80\x62\xe1\xe2\x90\xf1\x51\xa0"
            "\x42\xe1\xe2\xb0\xf1\x31\xc0\x22\xe1\xe2\xd0\xf1\x11"
            "\xe2\xe1\xe0\x10" }  },
      /* --- pixel bitmap for cmex160 char#47 \ --- */
      {  47,64019,                      /* character number, location */
          1, 1,  -38, 1,      /* topleft row,col, and botleft row,col */
          { 16,   39, 3,138, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x12\xe0\xf1\x11\xe0\x12\xe0\x11\xe0\x12\xc0"
            "\xf1\x31\xc0\x32\xe0\x11\xe0\x12\xa0\xf1\x51\xa0\x52"
            "\xe0\x11\xe0\x12\x80\xf1\x71\x80\x72\x70\xf1\x81\x70"
            "\x82\xe0\x11\xe0\x12\x50\xf1\xa1\x50\xa2\xe0\x11\xe0"
            "\x12\x30\xf1\xc1\x30\xc2\xe0\x11\xe0\x12\x10\xf1\xe1"
            "\x10\xe2\xe0\x11" }  },
      /* --- pixel bitmap for cmex160 char#48 \leftparentop --- */
      {  48, 4072,                      /* character number, location */
          0, 6,  -40, 6,      /* topleft row,col, and botleft row,col */
          { 12,   40, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\xa1\xa2\xa1\xa1\xa2\xa1\xa2\xa1\xa2\xa1\x60\xf1"
            "\x42\x60\x41\x70\xf1\x32\x70\x31\x80\xf2\x22\x80\x21"
            "\x90\xf5\x12\x90\x11\xaf\xb2\xa1" }  },
      /* --- pixel bitmap for cmex160 char#49 \rightparentop --- */
      {  49, 9761,                      /* character number, location */
          0, 1,  -40, 1,      /* topleft row,col, and botleft row,col */
          { 12,   40, 3,68, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xc1\xb2\xb1\xc1\xb2\xb1\xb2\xb1\xb2\xb1\x50\xf1"
            "\x62\x40\x71\x40\xf1\x72\x30\x81\x30\xf2\x82\x20\x91"
            "\x20\xf5\x92\x10\xa1\x10\xfb\xa2" }  },
      /* --- pixel bitmap for cmex160 char#50 (noname) --- */
      {  50,15763,                      /* character number, location */
          0, 7,  -39, 7,      /* topleft row,col, and botleft row,col */
          {  8,   39, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x08\x0f\xe2\x6f\xe2\x6f\x62\x6f" }  },
      /* --- pixel bitmap for cmex160 char#51 (noname) --- */
      {  51,21545,                      /* character number, location */
          0, 0,  -39, 0,      /* topleft row,col, and botleft row,col */
          {  8,   39, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x08\xfe\x62\xfe\x62\xf6\x62" }  },
      /* --- pixel bitmap for cmex160 char#52 (noname) --- */
      {  52,16629,                      /* character number, location */
          1, 7,  -38, 7,      /* topleft row,col, and botleft row,col */
          {  8,   39, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x6f\xe2\x6f\x62\x6f\x18" }  },
      /* --- pixel bitmap for cmex160 char#53 (noname) --- */
      {  53,22398,                      /* character number, location */
          1, 0,  -38, 0,      /* topleft row,col, and botleft row,col */
          {  8,   39, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x62\xfe\x62\xf6\x62\x0f\x18" }  },
      /* --- pixel bitmap for cmex160 char#54 (noname) --- */
      {  54,17392,                      /* character number, location */
          1, 7,  -14, 7,      /* topleft row,col, and botleft row,col */
          {  2,   15, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02" }  },
      /* --- pixel bitmap for cmex160 char#55 (noname) --- */
      {  55,23148,                      /* character number, location */
          1, 6,  -14, 6,      /* topleft row,col, and botleft row,col */
          {  2,   15, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02" }  },
      /* --- pixel bitmap for cmex160 char#56 \leftbracetop --- */
      {  56,42237,                      /* character number, location */
         -1, 9,  -21, 9,      /* topleft row,col, and botleft row,col */
          {  8,   20, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\x52\x52\x52\x52\x53\x52\x5f\xc3\x52" }  },
      /* --- pixel bitmap for cmex160 char#57 \rightbracetop --- */
      {  57,49750,                      /* character number, location */
         -1, 4,  -21, 4,      /* topleft row,col, and botleft row,col */
          {  8,   20, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x72\x72\x72\x72\x63\x62\x10\xfc\x53" }  },
      /* --- pixel bitmap for cmex160 char#58 \leftbracebot --- */
      {  58,43100,                      /* character number, location */
          1, 9,  -19, 9,      /* topleft row,col, and botleft row,col */
          {  8,   20, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x03\x50\x12\x63\x62\x72\x72\x72\x72" }  },
      /* --- pixel bitmap for cmex160 char#59 \rightbracebot --- */
      {  59,50614,                      /* character number, location */
          1, 4,  -19, 4,      /* topleft row,col, and botleft row,col */
          {  8,   20, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x53\x52\x53\x52\x52\x52\x52\x52\x63" }  },
      /* --- pixel bitmap for cmex160 char#60 \leftbracemid --- */
      {  60,44038,                      /* character number, location */
          1, 4,  -41, 4,      /* topleft row,col, and botleft row,col */
          {  8,   42, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x53\x52\x53\x52\x53\x52\x52\x4f\x12\x60\x22\x72"
            "\x63\x62\x63\x62\x10\xfd\x53" }  },
      /* --- pixel bitmap for cmex160 char#61 \rightbracemid --- */
      {  61,51553,                      /* character number, location */
          1, 9,  -41, 9,      /* topleft row,col, and botleft row,col */
          {  8,   42, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x03\x50\x12\x63\x62\x63\x62\x72\x20\xf1\x62\x42"
            "\x52\x53\x52\x53\x52\x5f\xd3\x52" }  },
      /* --- pixel bitmap for cmex160 char#62 \leftbracebar --- */
      {  62,44884,                      /* character number, location */
          1, 9,   -8, 9,      /* topleft row,col, and botleft row,col */
          {  3,    9, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x03" }  },
      /* --- pixel bitmap for cmex160 char#63 (noname) --- */
      {  63,69605,                      /* character number, location */
          1, 7,  -14, 7,      /* topleft row,col, and botleft row,col */
          {  1,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x7f" }  },
      /* --- pixel bitmap for cmex160 char#64 \leftparenbot --- */
      {  64, 4980,                      /* character number, location */
          2, 6,  -38, 6,      /* topleft row,col, and botleft row,col */
          { 12,   40, 3,68, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x02\xa0\x11\xa0\xf5\x12\x90\x21\x90\xf2\x22\x80"
            "\x31\x80\xf1\x32\x70\x41\x70\xf1\x42\x60\x51\xb2\xb1"
            "\xb2\xb1\xb2\xb1\xc1\xb2\xb1\xc1" }  },
      /* --- pixel bitmap for cmex160 char#65 \rightparenbot --- */
      {  65,10630,                      /* character number, location */
          2, 1,  -38, 1,      /* topleft row,col, and botleft row,col */
          { 12,   40, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\xa2\xa1\x10\xf5\x92\x10\x91\x20\xf2\x82\x20\x81"
            "\x30\xf1\x72\x30\x71\x40\xf1\x62\x40\x61\xa2\xa1\xa2"
            "\xa1\xa2\xa1\xa1\xa2\xa1\xa1\xb2" }  },
      /* --- pixel bitmap for cmex160 char#66 \leftparenbar --- */
      {  66, 5882,                      /* character number, location */
          1, 6,  -14, 6,      /* topleft row,col, and botleft row,col */
          {  2,   15, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02" }  },
      /* --- pixel bitmap for cmex160 char#67 \rightparenbar --- */
      {  67,11493,                      /* character number, location */
          1,11,  -14,11,      /* topleft row,col, and botleft row,col */
          {  2,   15, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02" }  },
      /* --- pixel bitmap for cmex160 char#68 \Big< --- */
      {  68,55151,                      /* character number, location */
          1, 2,  -38, 2,      /* topleft row,col, and botleft row,col */
          { 10,   39, 3,86, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x82\x81\x82\x81\x82\x81\x82\x81\x82\x40\xf1\x41"
            "\x50\x32\x81\x82\x81\x82\x81\x82\x81\x92\x91\x92\x91"
            "\x92\x91\x92\x50\xf1\x41\x50\x42\x91\x92\x91\x92\x91"
            "\x92\x91\x92\x91" }  },
      /* --- pixel bitmap for cmex160 char#69 \Big> --- */
      {  69,58017,                      /* character number, location */
          1, 2,  -38, 2,      /* topleft row,col, and botleft row,col */
          { 10,   39, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x92\x91\x92\x91\x92\x91\x92\x91\x92\x40\xf1\x51"
            "\x40\x52\x91\x92\x91\x92\x91\x92\x91\x82\x81\x82\x81"
            "\x82\x81\x82\x30\xf1\x51\x40\x42\x81\x82\x81\x82\x81"
            "\x82\x81\x82\x81\x92" }  },
      /* --- pixel bitmap for cmex160 char#70 \bigsqcup --- */
      {  70,80314,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\xc2\x0f\x42\xc2\x0f\x1e\x02" }  },
      /* --- pixel bitmap for cmex160 char#71 \Bigsqcup --- */
      {  71,81255,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1c\x00\x02\x13\x02\x00\xff\x01\x17" }  },
      /* --- pixel bitmap for cmex160 char#72 \oint --- */
      {  72,100301,                     /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 12,   25, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x82\x21\xf1\x62\x22\xf2\x62\x40\x52\x94\x71\x12"
            "\x11\x30\xf3\x21\x22\x21\x20\x31\x12\x11\x74\x40\xf1"
            "\x52\x50\xf2\x42\x6f\x12\x22\x61\x22\x83\x81" }  },
      /* --- pixel bitmap for cmex160 char#73 \Bigoint --- */
      {  73,101347,                     /* character number, location */
          0, 1,  -49, 1,      /* topleft row,col, and botleft row,col */
          { 20,   49, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x23\xe0\x21\x31\xf1\xe2\x22\xe1\x50\xf1\xd2\x50"
            "\xd1\x60\xf3\xc2\x60\xf4\xb2\x70\xa2\xe0\x16\xd1\x32"
            "\x11\xb1\x42\x21\x91\x52\x31\x40\xf4\x41\x42\x41\x40"
            "\x51\x22\x41\xb1\x12\x31\xd6\x70\xf1\x82\xa0\xf4\x72"
            "\xb0\xf3\x62\xc0\x61\xd0\xf1\x52\xd0\x51\xef\x12\x22"
            "\xe1\x31\xe0\x23\xe0\x2e" }  },
      /* --- pixel bitmap for cmex160 char#74 \bigodot --- */
      {  74,82287,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\xeb\xa4\x74\x73\xb3\x53\xd3\x33\xe0\x13\x22\xe0"
            "\x32\x13\xe0\x35\xe0\x54\x91\x92\x0f\x12\x83\x82\x02"
            "\x91\x94\xe0\x55\xe0\x33\x12\xe0\x32\x23\xe0\x13\x33"
            "\xd3\x53\xb3\x74\x74\xab\xe7\x81" }  },
      /* --- pixel bitmap for cmex160 char#75 \Bigodot --- */
      {  75,83472,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 31,   31, 3,153, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc7\xe0\x7d\xe0\x25\x75\xd3\xd3\xa4\xe0\x14\x82\xe0"
            "\x52\x73\xe0\x53\x53\xe0\x73\x42\xe0\x92\x33\xe0\x93"
            "\x22\xe0\xb2\x13\xe0\xb3\x0f\x12\xe0\xd2\x0f\x22\xc3"
            "\xc2\x0f\x12\xe0\xd2\x03\xe0\xb3\x12\xe0\xb2\x23\xe0"
            "\x93\x32\xe0\x92\x43\xe0\x73\x53\xe0\x53\x72\xe0\x52"
            "\x84\xe0\x14\xa3\xd3\xd5\x75\xe0\x2d\xe0\x77\xc1" }  },
      /* --- pixel bitmap for cmex160 char#76 \bigoplus --- */
      {  76,84507,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xeb\xa4\x32\x24\x73\x52\x43\x53\x62\x53\x33\x72"
            "\x63\x22\x82\x72\x13\x82\x73\x0f\x12\x92\x82\x0f\x1e"
            "\x09\x0f\x12\x92\x82\x03\x82\x73\x12\x82\x72\x23\x72"
            "\x63\x33\x62\x53\x53\x52\x43\x74\x32\x24\xab\xe7\x80" }  },
      /* --- pixel bitmap for cmex160 char#77 \Bigoplus --- */
      {  77,85713,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 31,   31, 3,161, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc7\xe0\x7d\xe0\x25\x32\x25\xd3\x62\x53\xa4\x72\x64"
            "\x82\x92\x82\x73\x92\x83\x53\xa2\x93\x42\xb2\xa2\x33"
            "\xb2\xa3\x22\xc2\xb2\x13\xc2\xb3\x0f\x12\xd2\xc2\x0f"
            "\x1e\x0e\x03\x0f\x22\xd2\xc2\x03\xc2\xb3\x12\xc2\xb2"
            "\x23\xb2\xa3\x32\xb2\xa2\x43\xa2\x93\x53\x92\x83\x72"
            "\x92\x82\x84\x72\x64\xa3\x62\x53\xd5\x32\x25\xe0\x2d"
            "\xe0\x77\xc0" }  },
      /* --- pixel bitmap for cmex160 char#78 \bigotimes --- */
      {  78,86789,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xeb\xa4\x74\x73\xb3\x54\xb4\x36\x96\x22\x23\x73"
            "\x22\x13\x33\x53\x35\x53\x33\x54\x63\x13\x62\x0f\x12"
            "\x75\x72\x02\x63\x13\x64\x53\x33\x55\x33\x53\x33\x12"
            "\x23\x73\x22\x26\x96\x34\xb4\x53\xb3\x74\x74\xab\xe7"
            "\x83" }  },
      /* --- pixel bitmap for cmex160 char#79 \Bigotimes --- */
      {  79,88004,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 31,   31, 3,183, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc7\xe0\x7d\xe0\x25\x75\xd3\xd3\xa4\xe0\x14\x83\xe0"
            "\x33\x75\xe0\x15\x53\x13\xd3\x13\x42\x33\xb3\x32\x33"
            "\x43\x93\x43\x22\x63\x73\x62\x13\x73\x53\x75\x93\x33"
            "\x94\xa3\x13\xa4\xb5\xb4\xc3\xc4\xb5\xb4\xa3\x13\xa4"
            "\x93\x33\x95\x73\x53\x73\x12\x63\x73\x62\x23\x43\x93"
            "\x43\x32\x33\xb3\x32\x43\x13\xd3\x13\x55\xe0\x15\x73"
            "\xe0\x33\x84\xe0\x14\xa3\xd3\xd5\x75\xe0\x2d\xe0\x77"
            "\xc0" }  },
      /* --- pixel bitmap for cmex160 char#80 \sum --- */
      {  80,89430,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x05\x23\xd4\x23\xe2\x32\xe0\x11\x42\xe0\x11\x33"
            "\xe0\x53\xe0\x52\xe0\x62\xe0\x53\xe0\x53\xe0\x52\xe0"
            "\x51\xe0\x51\xe0\x51\xe0\x51\xe0\x52\xe0\x51\xe0\x11"
            "\x31\xe0\x11\x31\xe0\x12\x21\xe4\x1e\x05\x23" }  },
      /* --- pixel bitmap for cmex160 char#81 \prod --- */
      {  81,92400,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x05\xfe\x22\xb2\x20\xf4\x22\xb2\x26\x76" }  },
      /* --- pixel bitmap for cmex160 char#82 \int --- */
      {  82,98246,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 12,   25, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x82\x21\xf1\x62\x22\xf2\x62\x40\xfa\x52\x50\xf2"
            "\x42\x6f\x12\x22\x61\x22\x83\x80" }  },
      /* --- pixel bitmap for cmex160 char#83 \bigcup --- */
      {  83,102229,                     /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\xc2\x02\xc5\xa3\x12\xa2\x23\x83\x33\x63\x5a"
            "\x86\x50" }  },
      /* --- pixel bitmap for cmex160 char#84 \bigcap --- */
      {  84,104037,                     /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x8a\x53\x63\x33\x83\x22\xa2\x13\xa3\x0f\xe2\xc2"
            "\x02\xc2" }  },
      /* --- pixel bitmap for cmex160 char#85 \biguplus --- */
      {  85,105910,                     /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x02\xc2\x0f\x12\x52\x52\x02\x36\x34\x28\x22\x0f"
            "\x22\x52\x52\x0f\x12\xc2\x03\xa3\x12\xa2\x23\x83\x33"
            "\x63\x5a\x86\x51" }  },
      /* --- pixel bitmap for cmex160 char#86 \bigwedge --- */
      {  86,107796,                     /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,82, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x72\x70\xf2\x64\x60\x56\x50\xf1\x52\x22\x50\x43"
            "\x23\x82\x42\x73\x43\x30\xf1\x32\x62\x30\x23\x63\x20"
            "\xf1\x22\x82\x20\x13\x83\x10\xf1\x12\xa2\x13\xa3\x0f"
            "\x12\xc2" }  },
      /* --- pixel bitmap for cmex160 char#87 \bigvee --- */
      {  87,109538,                     /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xc2\x03\xa3\xf1\x12\xa2\x10\x13\x83\x10\xf1"
            "\x22\x82\x20\x23\x63\x20\xf1\x32\x62\x30\x33\x43\x72"
            "\x42\x83\x23\x40\xf1\x52\x22\x50\x56\x50\xf2\x64\x60"
            "\xf1\x72\x72" }  },
      /* --- pixel bitmap for cmex160 char#88 \Bigsum --- */
      {  88,90923,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 30,   31, 3,145, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x0e\x0d\x34\xe0\x46\x34\xe0\x63\x44\xe0\x72\x43\xe0"
            "\x81\x44\xe0\x81\x44\xe0\xd4\xe0\xd3\xe0\xd4\xe0\xd4"
            "\xe0\xd4\xe0\xd3\xe0\xd4\xe0\xd4\xe0\xd4\xe0\xc3\xe0"
            "\xd2\xe0\xd2\xe0\xe1\xe0\xe1\xe0\xe2\xe0\xd2\xe0\xd2"
            "\xe0\xd2\xe0\x81\x51\xe0\x81\x51\xe0\x82\x42\xe0\x63"
            "\x42\xe0\x46\x3e\x0d\x2e\x0d\x33" }  },
      /* --- pixel bitmap for cmex160 char#89 \Bigprod --- */
      {  89,94040,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 26,   31, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0c\x34\xc4\x30\xfe\x43\xc3\x40\xfb\x43\xc3\x40"
            "\x35\xa5\x3b\x4b" }  },
      /* --- pixel bitmap for cmex160 char#90 \Bigint --- */
      {  90,99260,                      /* character number, location */
          0, 1,  -49, 1,      /* topleft row,col, and botleft row,col */
          { 20,   49, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x23\xe0\x21\x31\xf1\xe2\x22\xe1\x50\xf1\xd2\x50"
            "\xd1\x60\xf3\xc2\x60\xf4\xb2\x70\xf4\xa2\x80\xf4\x92"
            "\x90\xf4\x82\xa0\xf4\x72\xb0\xf3\x62\xc0\x61\xd0\xf1"
            "\x52\xd0\x51\xef\x12\x22\xe1\x31\xe0\x23\xe0\x20" }  },
      /* --- pixel bitmap for cmex160 char#91 \Bigcup --- */
      {  91,103178,                     /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\xe0\x52\x0f\x72\xe0\x52\x03\xe0\x33\x12\xe0"
            "\x32\x23\xe0\x13\x33\xd3\x53\xb3\x74\x74\xab\xe7\x82" }  },
      /* --- pixel bitmap for cmex160 char#92 \Bigcap --- */
      {  92,104993,                     /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\xeb\xa4\x74\x73\xb3\x53\xd3\x33\xe0\x13\x22\xe0"
            "\x32\x13\xe0\x33\x0f\xe2\xe0\x52\x0f\x72\xe0\x52" }  },
      /* --- pixel bitmap for cmex160 char#93 \Biguplus --- */
      {  93,106938,                     /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x02\xe0\x52\x02\x91\x92\x0f\x52\x92\x82\x02\x2e"
            "\x01\x24\x3d\x32\x0f\x52\x92\x82\x02\xe0\x55\xe0\x33"
            "\x12\xe0\x32\x23\xe0\x13\x33\xd3\x53\xb3\x74\x74\xab"
            "\xe7\x82" }  },
      /* --- pixel bitmap for cmex160 char#94 \Bigwedge --- */
      {  94,108713,                     /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,140, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb2\xa0\xf1\xa3\xa0\x95\x90\xf1\x92\x12\x90\x83\x13"
            "\x80\xf1\x82\x32\x80\x73\x33\x70\xf1\x72\x52\x70\x63"
            "\x53\xc2\x72\xb3\x73\x50\xf1\x52\x92\x50\x43\x93\x40"
            "\xf1\x42\xb2\x40\x33\xb3\x30\xf1\x32\xd2\x30\x23\xd3"
            "\x42\xe0\x12\x33\xe0\x13\x10\xf1\x12\xe0\x32\x13\xe0"
            "\x33\x0f\x12\xe0\x52" }  },
      /* --- pixel bitmap for cmex160 char#95 \Bigvee --- */
      {  95,110456,                     /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x52\x03\xe0\x33\xf1\x12\xe0\x32\x10\x13"
            "\xe0\x13\x32\xe0\x12\x43\xd3\x20\xf1\x32\xd2\x30\x33"
            "\xb3\x30\xf1\x42\xb2\x40\x43\x93\x40\xf1\x52\x92\x50"
            "\x53\x73\xb2\x72\xc3\x53\x60\xf1\x72\x52\x70\x73\x33"
            "\x70\xf1\x82\x32\x80\x83\x13\x80\xf1\x92\x12\x90\x95"
            "\x90\xf1\xa3\xa0\xb2\xae" }  },
      /* --- pixel bitmap for cmex160 char#96 \coprod --- */
      {  96,95559,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x76\xfe\x22\xb2\x20\xf4\x22\xb2\x2e\x05" }  },
      /* --- pixel bitmap for cmex160 char#97 \Bigcoprod --- */
      {  97,97201,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 26,   31, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x4b\x35\xa5\x30\xfe\x43\xc3\x40\xfb\x43\xc3\x40"
            "\x34\xc4\x3e\x0c" }  },
      /* --- pixel bitmap for cmex160 char#98 ^ --- */
      {  98,111243,                     /* character number, location */
         16, 0,   12, 0,      /* topleft row,col, and botleft row,col */
          { 12,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x80\x1f\x0e\x17\x80" }  },
      /* --- pixel bitmap for cmex160 char#99 ^ --- */
      {  99,112116,                     /* character number, location */
         17, 0,   13, 0,      /* topleft row,col, and botleft row,col */
          { 22,    4, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x94\xe0\x1a\x94\x84\x34\xe4" }  },
      /* --- pixel bitmap for cmex160 char#100 ^ --- */
      { 100,113198,                     /* character number, location */
         17, 0,   13, 0,      /* topleft row,col, and botleft row,col */
          { 32,    4, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe4\xe0\x9e\xd7\xa7\x45\xe0\x85" }  },
      /* --- pixel bitmap for cmex160 char#101 ~ --- */
      { 101,113909,                     /* character number, location */
         16, 0,   13, 0,      /* topleft row,col, and botleft row,col */
          { 12,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\xe8\x7f\xc1\x03" }  },
      /* --- pixel bitmap for cmex160 char#102 ~ --- */
      { 102,114827,                     /* character number, location */
         17, 0,   14, 0,      /* topleft row,col, and botleft row,col */
          { 22,    3, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\xa2\x1e\x06\x12\xa6\x40" }  },
      /* --- pixel bitmap for cmex160 char#103 ~ --- */
      { 103,115954,                     /* character number, location */
         17, 0,   14, 0,      /* topleft row,col, and botleft row,col */
          { 32,    3, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\xe0\x12\x25\x4a\x45\x22\xe0\x1a\x50" }  },
      /* --- pixel bitmap for cmex160 char#104 \Big[ --- */
      { 104,13063,                      /* character number, location */
          1, 5,  -38, 5,      /* topleft row,col, and botleft row,col */
          {  5,   39, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\xe1\x4f\x61\x45" }  },
      /* --- pixel bitmap for cmex160 char#105 \Big] --- */
      { 105,18910,                      /* character number, location */
          1, 0,  -38, 0,      /* topleft row,col, and botleft row,col */
          {  5,   39, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xfe\x41\xf6\x41\x05" }  },
      /* --- pixel bitmap for cmex160 char#106 (noname) --- */
      { 106,24782,                      /* character number, location */
          1, 5,  -38, 5,      /* topleft row,col, and botleft row,col */
          {  7,   39, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x25\x00\x01\x06\x07" }  },
      /* --- pixel bitmap for cmex160 char#107 (noname) --- */
      { 107,28332,                      /* character number, location */
          1, 1,  -38, 1,      /* topleft row,col, and botleft row,col */
          {  6,   39, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x25\x05\x01\x00\x06" }  },
      /* --- pixel bitmap for cmex160 char#108 (noname) --- */
      { 108,31886,                      /* character number, location */
          1, 5,  -38, 5,      /* topleft row,col, and botleft row,col */
          {  7,   39, 2, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x07\x00\xff\x25\x01\x06" }  },
      /* --- pixel bitmap for cmex160 char#109 (noname) --- */
      { 109,35444,                      /* character number, location */
          1, 1,  -38, 1,      /* topleft row,col, and botleft row,col */
          {  6,   39, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\xff\x25\x05\x01" }  },
      /* --- pixel bitmap for cmex160 char#110 \Big{ --- */
      { 110,39192,                      /* character number, location */
          1, 2,  -38, 2,      /* topleft row,col, and botleft row,col */
          { 11,   39, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x72\x82\x30\xfd\x52\x40\x42\x72\x72\xb2\xb2\x50"
            "\xfd\x52\x40\x62\xa2\xb2" }  },
      /* --- pixel bitmap for cmex160 char#111 \Big} --- */
      { 111,46702,                      /* character number, location */
          1, 2,  -38, 2,      /* topleft row,col, and botleft row,col */
          { 11,   39, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xb2\xb2\x50\xfd\x52\x40\x62\xa2\xb2\x72\x82\x30"
            "\xfd\x52\x40\x42\x72\x72\x93" }  },
      /* --- pixel bitmap for cmex160 char#112 (noname) --- */
      { 112,73634,                      /* character number, location */
          1, 2,  -26, 2,      /* topleft row,col, and botleft row,col */
          { 21,   27, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x61\xf1\xe0\x51\x10\xf1\xe0\x41\x20\xf1\xe0\x31"
            "\x30\xf1\xe0\x21\x40\xf1\xe0\x11\x50\xf1\xe1\x60\xd1"
            "\x91\xa1\x74\x81\xa2\x81\x80\xf1\x32\x61\x90\xf1\x42"
            "\x41\xa0\xf1\x52\x21\xb0\x52\x11\xe0\x43\xe0\x42\xe0"
            "\x61\xd1" }  },
      /* --- pixel bitmap for cmex160 char#113 (noname) --- */
      { 113,74617,                      /* character number, location */
          1, 2,  -39, 2,      /* topleft row,col, and botleft row,col */
          { 21,   40, 3,119, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x61\xf2\xe0\x51\x10\xf2\xe0\x41\x20\xf2\xe0"
            "\x31\x30\xf2\xe0\x21\x40\xf2\xe0\x11\x50\xf2\xe1\x60"
            "\xd1\x91\xa1\x83\x91\x71\x12\x81\xa2\x81\xb2\x71\x80"
            "\xf1\x32\x61\x90\x42\x51\x90\xf2\x42\x41\xa0\xf2\x52"
            "\x21\xb0\xf2\x63\xc0\xf1\x71\xd0" }  },
      /* --- pixel bitmap for cmex160 char#114 (noname) --- */
      { 114,75637,                      /* character number, location */
          1, 2,  -52, 2,      /* topleft row,col, and botleft row,col */
          { 21,   53, 3,129, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x61\xf3\xe0\x51\x10\xf3\xe0\x41\x20\xf3\xe0"
            "\x31\x30\xf3\xe0\x21\x40\xf3\xe0\x11\x50\xf3\xe1\x60"
            "\xd1\x70\xf1\x21\xa1\x70\x13\x91\x71\x12\x81\x80\xf1"
            "\x22\x81\x80\x32\x71\x80\xf3\x32\x61\x90\xf3\x42\x41"
            "\xa0\xf3\x52\x21\xb0\xf3\x63\xc0\x62\xd0\xf1\x71\xd0" }  },
      /* --- pixel bitmap for cmex160 char#115 (noname) --- */
      { 115,76693,                      /* character number, location */
          1, 2,  -66, 2,      /* topleft row,col, and botleft row,col */
          { 21,   67, 3,149, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\x61\xf4\xe0\x51\x10\xf4\xe0\x41\x20\xf4\xe0"
            "\x31\x30\xf4\xe0\x21\x40\xf4\xe0\x11\x50\xf4\xe1\x60"
            "\xd1\x70\xf1\x21\xa1\x70\xf1\x13\x91\x71\x12\x91\x71"
            "\x12\x81\x80\xf1\x22\x81\x80\xf1\x32\x71\x80\xf2\x32"
            "\x61\x90\xf1\x42\x51\x90\xf3\x42\x41\xa0\x52\x31\xa0"
            "\xf4\x52\x21\xb0\xf4\x63\xc0\xf2\x71\xd2" }  },
      /* --- pixel bitmap for cmex160 char#116 (noname) --- */
      { 116,77831,                      /* character number, location */
          1, 3,  -40, 3,      /* topleft row,col, and botleft row,col */
          { 13,   41, 3,76, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\xc1\xf1\x22\x81\xf1\x13\x81\x0f\x11\x22\x71\x32"
            "\x71\xf2\x42\x61\xf3\x52\x51\xf2\x62\x41\xf2\x72\x31"
            "\xf2\x82\x21\xf3\x92\x11\xf2\xa3\xf2\xb2\xf1\xc1" }  },
      /* --- pixel bitmap for cmex160 char#117 (noname) --- */
      { 117,78760,                      /* character number, location */
          1,15,  -14,15,      /* topleft row,col, and botleft row,col */
          {  1,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x7f" }  },
      /* --- pixel bitmap for cmex160 char#118 (noname) --- */
      { 118,79581,                      /* character number, location */
          1,15,  -13,15,      /* topleft row,col, and botleft row,col */
          {  9,   14, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\xc1\x82" }  },
      /* --- pixel bitmap for cmex160 char#119 (noname) --- */
      { 119,72665,                      /* character number, location */
          1, 7,  -14, 7,      /* topleft row,col, and botleft row,col */
          {  4,   15, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x21" }  },
      /* --- pixel bitmap for cmex160 char#120 (noname) --- */
      { 120,67947,                      /* character number, location */
          0, 2,  -13, 2,      /* topleft row,col, and botleft row,col */
          { 11,   13, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x93\x75\x42\x21\x22\x11\x41\x41\xf7\x51\x51" }  },
      /* --- pixel bitmap for cmex160 char#121 (noname) --- */
      { 121,68880,                      /* character number, location */
          0, 2,  -13, 2,      /* topleft row,col, and botleft row,col */
          { 11,   13, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x51\x51\x41\x41\x12\x21\x22\x45\x73\x91\x51" }  },
      /* --- pixel bitmap for cmex160 char#122 (noname) --- */
      { 122,52204,                      /* character number, location */
          3,-1,   -5,-1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x66\x48\x34\x73\x91\xa1\xa1\xb2" }  },
      /* --- pixel bitmap for cmex160 char#123 (noname) --- */
      { 123,52788,                      /* character number, location */
          3,-1,   -5,-1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x86\x68\x94\xa3\xb1\xc1\xc1" }  },
      /* --- pixel bitmap for cmex160 char#124 (noname) --- */
      { 124,53369,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xc1\xc1\xb3\xa4\x98\x66\x84" }  },
      /* --- pixel bitmap for cmex160 char#125 (noname) --- */
      { 125,53951,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\xa1\xa1\x93\x74\x38\x46\x64\x82" }  },
      /* --- pixel bitmap for cmex160 char#126 (noname) --- */
      { 126,70665,                      /* character number, location */
         -1, 3,  -13, 3,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x00\x06\x90\x80\x19\x94\x32\xc9\x90\x00\x09\x90"
            "\x00\x09\x90\x00\x09" }  },
      /* --- pixel bitmap for cmex160 char#127 (noname) --- */
      { 127,71769,                      /* character number, location */
          0, 3,  -12, 3,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x90\x00\x09\x90\x00\x09\x90\x00\x09\x93\x4c\x29\x98"
            "\x01\x09\x60\x00\x06" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=5 for .180gf ---
 * mf '\mode=preview; mag=magstep(-14.65037297372839890542); input cmex10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmex180 --- */
static	chardef  cmex180[] =
   {
      /* --- pixel bitmap for cmex180 char#0 \big( --- */
      {   0,  661,                      /* character number, location */
          1, 4,  -28, 4,      /* topleft row,col, and botleft row,col */
          {  6,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x84\x21\x0c\x61\x18\xc2\x30\x0c\xc3\x30\x0c\xc3"
            "\x30\x0c\x82\x61\x10\x0c\x82\x41\x20" }  },
      /* --- pixel bitmap for cmex180 char#1 \big) --- */
      {   1, 6576,                      /* character number, location */
          1, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          {  6,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x60\x10\x0c\x82\x61\x10\x0c\xc3\x30\x0c\xc3\x30"
            "\x0c\xc3\x10\x86\x21\x0c\x61\x08\x01" }  },
      /* --- pixel bitmap for cmex180 char#2 \big[ --- */
      {   2,12433,                      /* character number, location */
          1, 5,  -28, 5,      /* topleft row,col, and botleft row,col */
          {  5,   29, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\xb1\x45" }  },
      /* --- pixel bitmap for cmex180 char#3 \big] --- */
      {   3,18441,                      /* character number, location */
          1, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          {  4,   29, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x31\xfb\x31\x04" }  },
      /* --- pixel bitmap for cmex180 char#4 (noname) --- */
      {   4,24312,                      /* character number, location */
          1, 5,  -28, 5,      /* topleft row,col, and botleft row,col */
          {  6,   29, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x5f\xc1\x56" }  },
      /* --- pixel bitmap for cmex180 char#5 (noname) --- */
      {   5,27921,                      /* character number, location */
          1, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          {  6,   29, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x51\xfc\x51\x06" }  },
      /* --- pixel bitmap for cmex180 char#6 (noname) --- */
      {   6,31506,                      /* character number, location */
          1, 5,  -28, 5,      /* topleft row,col, and botleft row,col */
          {  6,   29, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x5f\xc1\x52" }  },
      /* --- pixel bitmap for cmex180 char#7 (noname) --- */
      {   7,35123,                      /* character number, location */
          1, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          {  6,   29, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x51\xfc\x51" }  },
      /* --- pixel bitmap for cmex180 char#8 \big{ --- */
      {   8,38783,                      /* character number, location */
          1, 3,  -28, 3,      /* topleft row,col, and botleft row,col */
          {  9,   29, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\x52\x20\xf9\x42\x30\x41\x62\x52\x92\x91\x40\xf9"
            "\x42\x30\x52\x92" }  },
      /* --- pixel bitmap for cmex180 char#9 \big} --- */
      {   9,46564,                      /* character number, location */
          1, 3,  -28, 3,      /* topleft row,col, and botleft row,col */
          {  9,   29, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x92\x91\x40\xf9\x42\x30\x52\x92\x52\x20\xf9\x42"
            "\x30\x41\x62\x52\x70" }  },
      /* --- pixel bitmap for cmex180 char#10 \big< --- */
      {  10,55514,                      /* character number, location */
          1, 2,  -28, 2,      /* topleft row,col, and botleft row,col */
          {  8,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x80\x40\x40\x20\x10\x10\x08\x08\x04\x04\x02\x02"
            "\x01\x01\x01\x02\x02\x04\x04\x08\x08\x10\x10\x20\x40"
            "\x40\x80\x80" }  },
      /* --- pixel bitmap for cmex180 char#11 \big> --- */
      {  11,58375,                      /* character number, location */
          1, 2,  -28, 2,      /* topleft row,col, and botleft row,col */
          {  8,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x01\x02\x02\x04\x08\x08\x10\x10\x20\x20\x40\x40"
            "\x80\x80\x80\x40\x40\x20\x20\x10\x10\x08\x08\x04\x02"
            "\x02\x01\x01" }  },
      /* --- pixel bitmap for cmex180 char#12 (noname) --- */
      {  12,67557,                      /* character number, location */
          1, 4,  -16, 4,      /* topleft row,col, and botleft row,col */
          {  1,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\x01" }  },
      /* --- pixel bitmap for cmex180 char#13 (noname) --- */
      {  13,68184,                      /* character number, location */
          1, 4,  -16, 4,      /* topleft row,col, and botleft row,col */
          {  6,   17, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x41\x0f\x11\x41" }  },
      /* --- pixel bitmap for cmex180 char#14 (noname) --- */
      {  14,61248,                      /* character number, location */
          1, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          { 12,   29, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\xa2\xf1\xa1\x10\x92\xa1\xa2\x20\xf1\x81\x30\x72"
            "\xa1\xa2\x40\xf1\x61\x50\x52\x50\xf1\x51\x60\x42\xa1"
            "\xa2\x70\xf1\x31\x80\x22\xa1\xa2\x90\xf1\x11\xa2\xa1"
            "\xb1" }  },
      /* --- pixel bitmap for cmex180 char#15 (noname) --- */
      {  15,64434,                      /* character number, location */
          1, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          { 12,   29, 3,82, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xb2\xa0\xf1\x11\xa0\x12\xb1\xb2\x80\xf1\x31\x80"
            "\x32\xb1\xb2\x60\xf1\x51\x60\x52\x50\xf1\x61\x50\x62"
            "\xb1\xb2\x30\xf1\x81\x30\x82\xb1\xb2\x10\xf1\xa1\x10"
            "\xa2\xb1" }  },
      /* --- pixel bitmap for cmex180 char#16 \Big( --- */
      {  16, 1430,                      /* character number, location */
          1, 5,  -43, 5,      /* topleft row,col, and botleft row,col */
          {  9,   44, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x71\x71\x72\x71\x71\x72\x71\x50\xf1\x22\x50\x21"
            "\x60\xf3\x12\x6f\xd2\x70\xf3\x12\x60\x21\x60\xf1\x22"
            "\x50\x31\x82\x81\x91\x82\x81\x91\x91" }  },
      /* --- pixel bitmap for cmex180 char#17 \Big) --- */
      {  17, 7306,                      /* character number, location */
          1, 1,  -43, 1,      /* topleft row,col, and botleft row,col */
          {  9,   44, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x91\x91\x82\x81\x91\x82\x81\x30\xf1\x52\x20\x61"
            "\x20\xf3\x62\x10\xfd\x72\xf3\x62\x10\x61\x20\xf1\x52"
            "\x20\x51\x72\x71\x71\x72\x71\x71\x71\x81" }  },
      /* --- pixel bitmap for cmex180 char#18 \bigg( --- */
      {  18, 2282,                      /* character number, location */
          1, 5,  -58, 5,      /* topleft row,col, and botleft row,col */
          { 12,   59, 3,102, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb1\xa1\xa1\xa1\xa2\xa1\xa1\xa2\xa1\xa2\xa1\x70\xf1"
            "\x32\x70\xf2\x22\x80\x21\x90\xf3\x12\x90\x11\xaf\xe2"
            "\xa0\x11\xa0\xf3\x12\x90\x21\x90\xf2\x22\x80\xf1\x32"
            "\x70\x41\xb2\xb1\xb2\xb1\xc1\xb2\xb1\xc1\xc1\xc1" }  },
      /* --- pixel bitmap for cmex180 char#19 \bigg) --- */
      {  19, 8119,                      /* character number, location */
          1, 1,  -58, 1,      /* topleft row,col, and botleft row,col */
          { 12,   59, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xc1\xc1\xc1\xb2\xb1\xc1\xb2\xb1\xb2\xb1\x40\xf1"
            "\x72\x30\xf2\x82\x20\x91\x20\xf3\x92\x10\xa1\x10\xfe"
            "\xa2\xa1\x10\xf3\x92\x10\x91\x20\xf2\x82\x20\xf1\x72"
            "\x30\x71\xa2\xa1\xa2\xa1\xa1\xa2\xa1\xa1\xa1\xa1\xb1" }  },
      /* --- pixel bitmap for cmex180 char#20 \bigg[ --- */
      {  20,14146,                      /* character number, location */
          1, 6,  -58, 6,      /* topleft row,col, and botleft row,col */
          {  7,   59, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x07\x0f\xe2\x5f\xe2\x5f\xe2\x5f\x92\x5f\x17" }  },
      /* --- pixel bitmap for cmex180 char#21 \bigg] --- */
      {  21,20076,                      /* character number, location */
          1, 0,  -58, 0,      /* topleft row,col, and botleft row,col */
          {  7,   59, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x07\xfe\x52\xfe\x52\xfe\x52\xf9\x52\x0f\x17" }  },
      /* --- pixel bitmap for cmex180 char#22 (noname) --- */
      {  22,26089,                      /* character number, location */
          1, 6,  -58, 6,      /* topleft row,col, and botleft row,col */
          {  9,   59, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x38\x00\x02\x07\xff\x01\x09" }  },
      /* --- pixel bitmap for cmex180 char#23 (noname) --- */
      {  23,29646,                      /* character number, location */
          1, 0,  -58, 0,      /* topleft row,col, and botleft row,col */
          {  9,   59, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x38\x07\x02\x00\xff\x01\x09" }  },
      /* --- pixel bitmap for cmex180 char#24 (noname) --- */
      {  24,33287,                      /* character number, location */
          1, 6,  -58, 6,      /* topleft row,col, and botleft row,col */
          {  9,   59, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x09\x00\xff\x38\x02\x07" }  },
      /* --- pixel bitmap for cmex180 char#25 (noname) --- */
      {  25,36852,                      /* character number, location */
          1, 0,  -58, 0,      /* topleft row,col, and botleft row,col */
          {  9,   59, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x09\xff\x38\x07\x02" }  },
      /* --- pixel bitmap for cmex180 char#26 \bigg{ --- */
      {  26,40780,                      /* character number, location */
          1, 4,  -58, 4,      /* topleft row,col, and botleft row,col */
          { 11,   59, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x82\x81\x91\x92\x40\xfe\x42\x50\xf4\x42\x50\xf1"
            "\x32\x60\x22\x82\x81\xb2\xa2\x70\xf1\x32\x60\xfe\x42"
            "\x50\xf4\x42\x50\x52\xa1\xb1\xb2\xa2" }  },
      /* --- pixel bitmap for cmex180 char#27 \bigg} --- */
      {  27,48563,                      /* character number, location */
          1, 4,  -58, 4,      /* topleft row,col, and botleft row,col */
          { 11,   59, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xb2\xa2\x70\xf1\x32\x60\xfe\x42\x50\xf4\x42\x50"
            "\x52\xa1\xb1\xb2\xa2\x82\x81\x91\x92\x40\xfe\x42\x50"
            "\xf4\x42\x50\xf1\x32\x60\x22\x82\x81\xa2" }  },
      /* --- pixel bitmap for cmex180 char#28 \bigg< --- */
      {  28,56897,                      /* character number, location */
          1, 3,  -59, 3,      /* topleft row,col, and botleft row,col */
          { 14,   60, 3,144, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd1\xc2\xf2\xb2\x10\xf1\xa2\x20\xf1\x92\x30\xf2\x82"
            "\x40\xf1\x72\x50\xf2\x62\x60\xf1\x52\x70\xf2\x42\x80"
            "\xf1\x32\x90\xf1\x22\xa0\xf2\x12\xbf\x12\xc0\xf2\x12"
            "\xb0\xf1\x22\xa0\xf1\x32\x90\xf2\x42\x80\xf1\x52\x70"
            "\xf2\x62\x60\xf1\x72\x50\xf2\x82\x40\xf1\x92\x30\xf1"
            "\xa2\x20\xf2\xb2\x10\xc2\xd1" }  },
      /* --- pixel bitmap for cmex180 char#29 \bigg> --- */
      {  29,59760,                      /* character number, location */
          1, 2,  -59, 2,      /* topleft row,col, and botleft row,col */
          { 14,   60, 3,145, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xc0\xf2\x12\xb0\xf1\x22\xa0\xf1\x32\x90\xf2"
            "\x42\x80\xf1\x52\x70\xf2\x62\x60\xf1\x72\x50\xf2\x82"
            "\x40\xf1\x92\x30\xf1\xa2\x20\xf2\xb2\x10\xf1\xc2\xf2"
            "\xb2\x10\xf1\xa2\x20\xf1\x92\x30\xf2\x82\x40\xf1\x72"
            "\x50\xf2\x62\x60\xf1\x52\x70\xf2\x42\x80\xf1\x32\x90"
            "\xf1\x22\xa0\xf2\x12\xbf\x12\xc0" }  },
      /* --- pixel bitmap for cmex180 char#30 (noname) --- */
      {  30,62779,                      /* character number, location */
          1, 1,  -58, 1,      /* topleft row,col, and botleft row,col */
          { 24,   59, 3,243, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x91\xe0\x82\xf1\xe0\x81\x10\xe0\x72\xe0\x81\xe0"
            "\x82\x20\xf1\xe0\x61\x30\xe0\x52\xe0\x81\xe0\x82\x40"
            "\xf1\xe0\x41\x50\xe0\x32\xe0\x81\xe0\x82\x60\xf1\xe0"
            "\x21\x70\xe0\x12\xe0\x81\xe0\x82\x80\xf1\xe1\x90\xd2"
            "\xe0\x81\xe0\x82\xa0\xf1\xc1\xb0\xb2\xb0\xf1\xb1\xc0"
            "\xa2\xe0\x81\xe0\x82\xd0\xf1\x91\xe0\x82\xe0\x81\xe0"
            "\x82\xe0\x10\xf1\x71\xe0\x20\x62\xe0\x81\xe0\x82\xe0"
            "\x30\xf1\x51\xe0\x40\x42\xe0\x81\xe0\x82\xe0\x50\xf1"
            "\x31\xe0\x60\x22\xe0\x81\xe0\x82\xe0\x70\xf1\x11\xe0"
            "\x82\xe0\x81\xe0\x90" }  },
      /* --- pixel bitmap for cmex180 char#31 (noname) --- */
      {  31,65973,                      /* character number, location */
          1, 1,  -58, 1,      /* topleft row,col, and botleft row,col */
          { 24,   59, 3,242, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x92\xe0\x80\xf1\x11\xe0\x80\x12\xe0\x91\xe0"
            "\x92\xe0\x60\xf1\x31\xe0\x60\x32\xe0\x91\xe0\x92\xe0"
            "\x40\xf1\x51\xe0\x40\x52\xe0\x91\xe0\x92\xe0\x20\xf1"
            "\x71\xe0\x20\x72\xe0\x91\xe0\x92\xe0\xf1\x91\xe0\x92"
            "\xe0\x91\xe0\x92\xc0\xf1\xb1\xc0\xb2\xb0\xf1\xc1\xb0"
            "\xc2\xe0\x91\xe0\x92\x90\xf1\xe1\x90\xe2\xe0\x91\xe0"
            "\x92\x70\xf1\xe0\x21\x70\xe0\x22\xe0\x91\xe0\x92\x50"
            "\xf1\xe0\x41\x50\xe0\x42\xe0\x91\xe0\x92\x30\xf1\xe0"
            "\x61\x30\xe0\x62\xe0\x91\xe0\x92\x10\xf1\xe0\x81\x10"
            "\xe0\x82\xe0\x91" }  },
      /* --- pixel bitmap for cmex180 char#32 \Bigg( --- */
      {  32, 3164,                      /* character number, location */
          1, 6,  -73, 6,      /* topleft row,col, and botleft row,col */
          { 13,   74, 3,126, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc1\xb1\xb1\xb2\xb1\xb1\xb2\xb1\xb2\xb1\xb2\xb1\xb2"
            "\xb1\x80\xf1\x32\x80\x31\x90\xf2\x22\x90\x21\xa0\xf5"
            "\x12\xa0\x11\xbf\xe2\xbf\x22\xb0\x11\xb0\xf5\x12\xa0"
            "\x21\xa0\xf2\x22\x90\x31\x90\xf1\x32\x80\x41\xc2\xc1"
            "\xc2\xc1\xc2\xc1\xc2\xc1\xd1\xc2\xc1\xd1\xd1" }  },
      /* --- pixel bitmap for cmex180 char#33 \Bigg) --- */
      {  33, 8988,                      /* character number, location */
          1, 1,  -73, 1,      /* topleft row,col, and botleft row,col */
          { 13,   74, 3,127, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xd1\xd1\xc2\xc1\xd1\xc2\xc1\xc2\xc1\xc2\xc1\xc2"
            "\xc1\x40\xf1\x82\x30\x91\x30\xf2\x92\x20\xa1\x20\xf5"
            "\xa2\x10\xb1\x10\xfe\xb2\xf2\xb2\xb1\x10\xf5\xa2\x10"
            "\xa1\x20\xf2\x92\x20\x91\x30\xf1\x82\x30\x81\xb2\xb1"
            "\xb2\xb1\xb2\xb1\xb2\xb1\xb1\xb2\xb1\xb1\xb1\xc0" }  },
      /* --- pixel bitmap for cmex180 char#34 \Bigg[ --- */
      {  34,15061,                      /* character number, location */
          1, 7,  -73, 7,      /* topleft row,col, and botleft row,col */
          {  8,   74, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x08\x00\xff\x45\x02\x06\xff\x01\x08" }  },
      /* --- pixel bitmap for cmex180 char#35 \Bigg] --- */
      {  35,20978,                      /* character number, location */
          1, 0,  -73, 0,      /* topleft row,col, and botleft row,col */
          {  8,   74, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x08\xff\x45\x06\x02\x00\xff\x01\x08" }  },
      /* --- pixel bitmap for cmex180 char#36 (noname) --- */
      {  36,27036,                      /* character number, location */
          1, 7,  -73, 7,      /* topleft row,col, and botleft row,col */
          {  9,   74, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x47\x00\x02\x07\xff\x01\x09" }  },
      /* --- pixel bitmap for cmex180 char#37 (noname) --- */
      {  37,30580,                      /* character number, location */
          1, 0,  -73, 0,      /* topleft row,col, and botleft row,col */
          {  9,   74, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x47\x07\x02\x00\xff\x01\x09" }  },
      /* --- pixel bitmap for cmex180 char#38 (noname) --- */
      {  38,34236,                      /* character number, location */
          1, 7,  -73, 7,      /* topleft row,col, and botleft row,col */
          {  9,   74, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x09\x00\xff\x47\x02\x07" }  },
      /* --- pixel bitmap for cmex180 char#39 (noname) --- */
      {  39,37788,                      /* character number, location */
          1, 0,  -73, 0,      /* topleft row,col, and botleft row,col */
          {  9,   74, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x09\xff\x47\x07\x02" }  },
      /* --- pixel bitmap for cmex180 char#40 \Bigg{ --- */
      {  40,41876,                      /* character number, location */
          1, 4,  -73, 4,      /* topleft row,col, and botleft row,col */
          { 12,   74, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\x92\x92\x92\xa1\xa2\xa1\x50\xfe\x52\x50\xf8\x52"
            "\x50\xf1\x42\x60\x32\xa1\xa1\x90\xf1\x11\xa0\x21\xc1"
            "\xb2\x70\xf1\x42\x60\xfe\x52\x50\xf8\x52\x50\x61\xb2"
            "\xb1\xb2\xb2\xb2\xc1" }  },
      /* --- pixel bitmap for cmex180 char#41 \Bigg} --- */
      {  41,49660,                      /* character number, location */
          1, 4,  -73, 4,      /* topleft row,col, and botleft row,col */
          { 12,   74, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xc2\xb2\xb2\xb1\xb2\xb1\x60\xfe\x52\x50\xf8\x52"
            "\x50\xf1\x62\x40\x72\xb1\xc1\xc2\xa1\xa1\xa1\xa2\x30"
            "\xf1\x62\x40\xfe\x52\x50\xf8\x52\x50\x51\xa2\xa1\xa2"
            "\x92\x92\x91\xb2" }  },
      /* --- pixel bitmap for cmex180 char#42 \Bigg< --- */
      {  42,57713,                      /* character number, location */
          1, 3,  -73, 3,      /* topleft row,col, and botleft row,col */
          { 15,   74, 3,156, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe1\xd2\xf2\xc2\x10\xf2\xb2\x20\xf2\xa2\x30\xf1\x92"
            "\x40\xf2\x82\x50\xf2\x72\x60\xf2\x62\x70\xf2\x52\x80"
            "\xf1\x42\x90\xf2\x32\xa0\xf2\x22\xb0\xf2\x12\xcf\x12"
            "\xd0\xf2\x12\xc0\xf2\x22\xb0\xf2\x32\xa0\xf1\x42\x90"
            "\xf2\x52\x80\xf2\x62\x70\xf2\x72\x60\xf2\x82\x50\xf1"
            "\x92\x40\xf2\xa2\x30\xf2\xb2\x20\xf2\xc2\x10\xd2\xe1" }  },
      /* --- pixel bitmap for cmex180 char#43 \Bigg> --- */
      {  43,60577,                      /* character number, location */
          1, 2,  -73, 2,      /* topleft row,col, and botleft row,col */
          { 15,   74, 3,157, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xd0\xf2\x12\xc0\xf2\x22\xb0\xf2\x32\xa0\xf1"
            "\x42\x90\xf2\x52\x80\xf2\x62\x70\xf2\x72\x60\xf2\x82"
            "\x50\xf1\x92\x40\xf2\xa2\x30\xf2\xb2\x20\xf2\xc2\x10"
            "\xf1\xd2\xf2\xc2\x10\xf2\xb2\x20\xf2\xa2\x30\xf1\x92"
            "\x40\xf2\x82\x50\xf2\x72\x60\xf2\x62\x70\xf2\x52\x80"
            "\xf1\x42\x90\xf2\x32\xa0\xf2\x22\xb0\xf2\x12\xcf\x12"
            "\xd0" }  },
      /* --- pixel bitmap for cmex180 char#44 / --- */
      {  44,63759,                      /* character number, location */
          1, 1,  -73, 1,      /* topleft row,col, and botleft row,col */
          { 30,   74, 3,225, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\xe2\xf2\xe0\xd2\x10\xf1\xe0\xc2\x20\xf2\xe0"
            "\xb2\x30\xf2\xe0\xa2\x40\xf1\xe0\x92\x50\xf2\xe0\x82"
            "\x60\xf1\xe0\x72\x70\xf2\xe0\x62\x80\xf1\xe0\x52\x90"
            "\xf2\xe0\x42\xa0\xf2\xe0\x32\xb0\xf1\xe0\x22\xc0\xf2"
            "\xe0\x12\xd0\xf1\xe2\xe0\xf2\xd2\xe0\x10\xf1\xc2\xe0"
            "\x20\xf2\xb2\xe0\x30\xf2\xa2\xe0\x40\xf1\x92\xe0\x50"
            "\xf2\x82\xe0\x60\xf1\x72\xe0\x70\xf2\x62\xe0\x80\xf1"
            "\x52\xe0\x90\xf2\x42\xe0\xa0\xf2\x32\xe0\xb0\xf1\x22"
            "\xe0\xc0\xf2\x12\xe0\xdf\x12\xe0\xe0" }  },
      /* --- pixel bitmap for cmex180 char#45 \ --- */
      {  45,66957,                      /* character number, location */
          1, 1,  -73, 1,      /* topleft row,col, and botleft row,col */
          { 30,   74, 3,228, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\xe0\xf2\x12\xe0\xd0\xf1\x22\xe0\xc0\xf2"
            "\x32\xe0\xb0\xf2\x42\xe0\xa0\xf1\x52\xe0\x90\xf2\x62"
            "\xe0\x80\xf1\x72\xe0\x70\xf2\x82\xe0\x60\xf1\x92\xe0"
            "\x50\xf2\xa2\xe0\x40\xf2\xb2\xe0\x30\xf1\xc2\xe0\x20"
            "\xf2\xd2\xe0\x10\xf1\xe2\xe0\xf2\xe0\x12\xd0\xf1\xe0"
            "\x22\xc0\xf2\xe0\x32\xb0\xf2\xe0\x42\xa0\xf1\xe0\x52"
            "\x90\xf2\xe0\x62\x80\xf1\xe0\x72\x70\xf2\xe0\x82\x60"
            "\xf1\xe0\x92\x50\xf2\xe0\xa2\x40\xf2\xe0\xb2\x30\xf1"
            "\xe0\xc2\x20\xf2\xe0\xd2\x10\xf1\xe0\xe2" }  },
      /* --- pixel bitmap for cmex180 char#46 / --- */
      {  46,61933,                      /* character number, location */
          1, 1,  -43, 1,      /* topleft row,col, and botleft row,col */
          { 18,   44, 3,165, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x31\xe0\x22\xf1\xe0\x21\x10\xe0\x12\xe0\x21\xe0"
            "\x22\x20\xf1\xe1\x30\xd2\xe0\x21\xe0\x22\x40\xf1\xc1"
            "\x50\xb2\xe0\x21\xe0\x22\x60\xf1\xa1\x70\x92\xe0\x21"
            "\xe0\x22\x80\xf1\x81\x90\x72\x90\xf1\x71\xa0\x62\xe0"
            "\x21\xe0\x22\xb0\xf1\x51\xc0\x42\xe0\x21\xe0\x22\xd0"
            "\xf1\x31\xe0\x22\xe0\x21\xe0\x22\xe0\x10\xf1\x11\xe0"
            "\x22\xe0\x21\xe0\x30" }  },
      /* --- pixel bitmap for cmex180 char#47 \ --- */
      {  47,65123,                      /* character number, location */
          1, 1,  -43, 1,      /* topleft row,col, and botleft row,col */
          { 18,   44, 3,164, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x32\xe0\x20\xf1\x11\xe0\x20\x12\xe0\x31\xe0"
            "\x32\xe0\xf1\x31\xe0\x32\xe0\x31\xe0\x32\xc0\xf1\x51"
            "\xc0\x52\xe0\x31\xe0\x32\xa0\xf1\x71\xa0\x72\x90\xf1"
            "\x81\x90\x82\xe0\x31\xe0\x32\x70\xf1\xa1\x70\xa2\xe0"
            "\x31\xe0\x32\x50\xf1\xc1\x50\xc2\xe0\x31\xe0\x32\x30"
            "\xf1\xe1\x30\xe2\xe0\x31\xe0\x32\x10\xf1\xe0\x21\x10"
            "\xe0\x22\xe0\x31" }  },
      /* --- pixel bitmap for cmex180 char#48 \leftparentop --- */
      {  48, 4118,                      /* character number, location */
          0, 8,  -45, 8,      /* topleft row,col, and botleft row,col */
          { 13,   45, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xb1\xb2\xb1\xb2\x20\xf1\x82\x30\xf1\x72\x40\xf1"
            "\x62\x50\xf2\x52\x60\xf2\x42\x70\x33\x70\xf1\x32\x80"
            "\xf2\x23\x80\xf1\x22\x90\xf5\x13\x90\x12\xaf\xc3\xa0" }  },
      /* --- pixel bitmap for cmex180 char#49 \rightparentop --- */
      {  49, 9903,                      /* character number, location */
          0, 1,  -45, 1,      /* topleft row,col, and botleft row,col */
          { 13,   45, 3,78, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xd1\xc2\xc1\xc2\x90\xf1\x32\x80\xf1\x42\x70\xf1"
            "\x52\x60\xf2\x62\x50\xf2\x72\x40\x73\x30\xf1\x82\x30"
            "\xf2\x83\x20\xf1\x92\x20\xf5\x93\x10\xa2\x10\xfc\xa3" }  },
      /* --- pixel bitmap for cmex180 char#50 (noname) --- */
      {  50,16001,                      /* character number, location */
          0, 8,  -44, 8,      /* topleft row,col, and botleft row,col */
          {  9,   44, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x09\x0f\xe2\x7f\xe2\x7f\xb2\x7f" }  },
      /* --- pixel bitmap for cmex180 char#51 (noname) --- */
      {  51,21879,                      /* character number, location */
          0, 0,  -44, 0,      /* topleft row,col, and botleft row,col */
          {  9,   44, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x09\xfe\x72\xfe\x72\xfb\x72" }  },
      /* --- pixel bitmap for cmex180 char#52 (noname) --- */
      {  52,16903,                      /* character number, location */
          1, 8,  -43, 8,      /* topleft row,col, and botleft row,col */
          {  9,   44, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x7f\xe2\x7f\xb2\x7f\x19" }  },
      /* --- pixel bitmap for cmex180 char#53 (noname) --- */
      {  53,22742,                      /* character number, location */
          1, 0,  -43, 0,      /* topleft row,col, and botleft row,col */
          {  9,   44, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x72\xfe\x72\xfb\x72\x0f\x19" }  },
      /* --- pixel bitmap for cmex180 char#54 (noname) --- */
      {  54,17702,                      /* character number, location */
          1, 8,  -16, 8,      /* topleft row,col, and botleft row,col */
          {  2,   17, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x12" }  },
      /* --- pixel bitmap for cmex180 char#55 (noname) --- */
      {  55,23502,                      /* character number, location */
          1, 7,  -16, 7,      /* topleft row,col, and botleft row,col */
          {  2,   17, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x12" }  },
      /* --- pixel bitmap for cmex180 char#56 \leftbracetop --- */
      {  56,42877,                      /* character number, location */
         -1,10,  -23,10,      /* topleft row,col, and botleft row,col */
          {  8,   22, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x52\x52\x52\x52\x40\xf1\x13\x40\x12\x5f\xd3\x52" }  },
      /* --- pixel bitmap for cmex180 char#57 \rightbracetop --- */
      {  57,50662,                      /* character number, location */
         -1, 5,  -23, 5,      /* topleft row,col, and botleft row,col */
          {  8,   22, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x82\x72\x72\x72\x20\xf1\x43\x10\x52\x10\xfd\x53" }  },
      /* --- pixel bitmap for cmex180 char#58 \leftbracebot --- */
      {  58,43796,                      /* character number, location */
          1,10,  -21,10,      /* topleft row,col, and botleft row,col */
          {  8,   22, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x03\x50\x12\x50\xf1\x13\x40\x22\x72\x72\x72\x81" }  },
      /* --- pixel bitmap for cmex180 char#59 \rightbracebot --- */
      {  59,51582,                      /* character number, location */
          1, 5,  -21, 5,      /* topleft row,col, and botleft row,col */
          {  8,   22, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x53\x52\x10\xf1\x43\x10\x42\x52\x52\x52\x51\x73" }  },
      /* --- pixel bitmap for cmex180 char#60 \leftbracemid --- */
      {  60,44790,                      /* character number, location */
          1, 5,  -46, 5,      /* topleft row,col, and botleft row,col */
          {  8,   47, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x53\x53\xf1\x43\x10\x42\x53\x52\x52\x52\x51\x82"
            "\x72\x72\x63\x62\x20\xf1\x43\x10\xfe\x53\x53" }  },
      /* --- pixel bitmap for cmex180 char#61 \rightbracemid --- */
      {  61,52577,                      /* character number, location */
          1,10,  -46,10,      /* topleft row,col, and botleft row,col */
          {  8,   47, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x03\x53\x50\xf1\x13\x40\x22\x63\x62\x72\x72\x81"
            "\x52\x52\x52\x53\x52\x40\xf1\x13\x4f\xe3\x53\x52" }  },
      /* --- pixel bitmap for cmex180 char#62 \leftbracebar --- */
      {  62,45698,                      /* character number, location */
          1,10,   -8,10,      /* topleft row,col, and botleft row,col */
          {  3,    9, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x03" }  },
      /* --- pixel bitmap for cmex180 char#63 (noname) --- */
      {  63,70795,                      /* character number, location */
          1, 8,  -16, 8,      /* topleft row,col, and botleft row,col */
          {  1,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\x01" }  },
      /* --- pixel bitmap for cmex180 char#64 \leftparenbot --- */
      {  64, 5036,                      /* character number, location */
          2, 8,  -43, 8,      /* topleft row,col, and botleft row,col */
          { 13,   45, 3,78, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x03\xa0\x12\xa0\xf5\x13\x90\xf1\x22\x90\xf2\x23"
            "\x80\xf1\x32\x80\x33\x70\xf2\x42\x70\xf2\x52\x60\xf1"
            "\x62\x50\xf1\x72\x40\xf1\x82\x30\x92\xc1\xc2\xc1\xd1" }  },
      /* --- pixel bitmap for cmex180 char#65 \rightparenbot --- */
      {  65,10782,                      /* character number, location */
          2, 1,  -43, 1,      /* topleft row,col, and botleft row,col */
          { 13,   45, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\xa3\xa2\x10\xf5\x93\x10\xf1\x92\x20\xf2\x83\x20"
            "\xf1\x82\x30\x73\x30\xf2\x72\x40\xf2\x62\x50\xf1\x52"
            "\x60\xf1\x42\x70\xf1\x32\x80\x22\xb1\xb2\xb1\xb1\xc3" }  },
      /* --- pixel bitmap for cmex180 char#66 \leftparenbar --- */
      {  66, 5948,                      /* character number, location */
          1, 8,  -16, 8,      /* topleft row,col, and botleft row,col */
          {  3,   17, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x03\x0f\x13" }  },
      /* --- pixel bitmap for cmex180 char#67 \rightparenbar --- */
      {  67,11655,                      /* character number, location */
          1,11,  -16,11,      /* topleft row,col, and botleft row,col */
          {  3,   17, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x03\x0f\x13" }  },
      /* --- pixel bitmap for cmex180 char#68 \Big< --- */
      {  68,56137,                      /* character number, location */
          1, 2,  -44, 2,      /* topleft row,col, and botleft row,col */
          { 11,   45, 3,106, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xa1\x92\x91\x92\x10\xf1\x81\x20\x72\x91\x92\x91\x92"
            "\x91\x92\x91\x92\x91\x92\x70\xf1\x21\x80\x12\x91\x92"
            "\x91\xa2\xa1\xa2\x80\xf1\x21\x80\x22\xa1\xa2\xa1\xa2"
            "\xa1\xa2\xa1\xa2\xa1\xa2\x20\xf1\x81\x20\x82\xa1\xa2"
            "\xa1" }  },
      /* --- pixel bitmap for cmex180 char#69 \Big> --- */
      {  69,58999,                      /* character number, location */
          1, 2,  -44, 2,      /* topleft row,col, and botleft row,col */
          { 11,   45, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x01\xa2\xa1\xa2\x80\xf1\x21\x80\x22\xa1\xa2\xa1\xa2"
            "\xa1\xa2\xa1\xa2\xa1\xa2\x20\xf1\x81\x20\x82\xa1\xa2"
            "\xa1\x92\x91\x92\x10\xf1\x81\x20\x72\x91\x92\x91\x92"
            "\x91\x92\x91\x92\x91\x92\x70\xf1\x21\x80\x12\x91\x92"
            "\x91\xa2" }  },
      /* --- pixel bitmap for cmex180 char#70 \bigsqcup --- */
      {  70,81634,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x16\x00\x02\x0f\x02\x00\xff\x01\x13" }  },
      /* --- pixel bitmap for cmex180 char#71 \Bigsqcup --- */
      {  71,82587,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x20\x00\x02\x16\x02\x00\xff\x01\x1a" }  },
      /* --- pixel bitmap for cmex180 char#72 \oint --- */
      {  72,101889,                     /* character number, location */
          0, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          { 15,   28, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa3\xb2\x21\xa1\x32\x82\x32\xf4\x82\x50\x64\xa1\x12"
            "\x11\x81\x22\x21\x30\xf3\x31\x32\x31\x20\x41\x22\x21"
            "\x81\x12\x11\xa4\x50\xf4\x62\x72\x42\x72\x32\x91\x31"
            "\xb3\xa0" }  },
      /* --- pixel bitmap for cmex180 char#73 \Bigoint --- */
      {  73,102975,                     /* character number, location */
          0, 1,  -55, 1,      /* topleft row,col, and botleft row,col */
          { 23,   55, 3,209, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x52\xe0\x61\x21\xe0\x41\x32\xe0\x22\x32\xe0\x21"
            "\x60\xf2\xe0\x12\x60\xe0\x11\x70\xf2\xe2\x70\xd3\x70"
            "\xf2\xd2\x80\xf2\xc3\x80\xf1\xc2\x90\xa4\xe0\x32\x14"
            "\xe0\x11\x33\x11\xd1\x43\x21\xc1\x33\x31\x60\xf2\x51"
            "\x43\x41\x50\x61\x33\x31\xc1\x23\x41\xd1\x13\x31\xe0"
            "\x14\x12\xe0\x34\xa0\xf1\x92\xc0\xf2\x83\xc0\xf2\x82"
            "\xd0\x73\xd0\xf2\x72\xe0\x71\xe0\x10\xf2\x62\xe0\x10"
            "\x61\xe0\x22\x32\xe0\x22\x31\xe0\x41\x21\xe0\x62\xe0"
            "\x55" }  },
      /* --- pixel bitmap for cmex180 char#74 \bigodot --- */
      {  74,83635,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 26,   25, 3,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x98\xe0\x2c\xc4\x84\x93\xc3\x73\xe3\x53\xe0\x23\x33"
            "\xe0\x43\x10\xf1\x12\xe0\x62\x13\xe0\x65\xe0\x84\xa2"
            "\xa4\x94\x94\xa2\xa4\xe0\x85\xe0\x63\xf1\x12\xe0\x62"
            "\x10\x13\xe0\x43\x33\xe0\x23\x53\xe3\x73\xc3\x94\x84"
            "\xcc\xe0\x28\x92" }  },
      /* --- pixel bitmap for cmex180 char#75 \Bigodot --- */
      {  75,84830,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 36,   35, 3,197, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe8\xe0\xbe\xe0\x65\x85\xe0\x24\xe4\xd3\xe0\x43\xb3"
            "\xe0\x63\x93\xe0\x83\x73\xe0\xa3\x53\xe0\xc3\x42\xe0"
            "\xe2\x33\xe0\xe3\x10\xf1\x12\xe0\xe0\x22\x13\xe0\xe0"
            "\x25\xe0\xe0\x44\xe0\x12\xe0\x12\x0f\x22\xe4\xe2\x02"
            "\xe0\x12\xe0\x14\xe0\xe0\x45\xe0\xe0\x23\xf1\x12\xe0"
            "\xe0\x22\x10\x13\xe0\xe3\x32\xe0\xe2\x43\xe0\xc3\x53"
            "\xe0\xa3\x73\xe0\x83\x93\xe0\x63\xb3\xe0\x43\xd4\xe4"
            "\xe0\x25\x85\xe0\x6e\xe0\xb8\xe0" }  },
      /* --- pixel bitmap for cmex180 char#76 \bigoplus --- */
      {  76,85885,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 26,   25, 3,123, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x98\xe0\x2c\xc4\x32\x34\x93\x52\x53\x73\x62\x63\x53"
            "\x72\x73\x33\x82\x83\x10\xf1\x12\x92\x92\x13\x92\x95"
            "\xa2\xa2\x0f\x1e\x0c\x0f\x12\xa2\xa2\x03\x92\x93\xf1"
            "\x12\x92\x92\x10\x13\x82\x83\x33\x72\x73\x53\x62\x63"
            "\x73\x52\x53\x94\x32\x34\xcc\xe0\x28\x93" }  },
      /* --- pixel bitmap for cmex180 char#77 \Bigoplus --- */
      {  77,87109,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 36,   35, 3,193, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe8\xe0\xbe\xe0\x65\x32\x35\xe0\x24\x62\x64\xd3\x82"
            "\x83\xb3\x92\x93\x93\xa2\xa3\x73\xb2\xb3\x53\xc2\xc3"
            "\x42\xd2\xd2\x33\xd2\xd3\x10\xf1\x12\xe2\xe2\x13\xe2"
            "\xe3\x0f\x12\xe0\x12\xe0\x12\x0f\x1e\x0e\x08\x0f\x22"
            "\xe0\x12\xe0\x12\x03\xe2\xe3\xf1\x12\xe2\xe2\x10\x13"
            "\xd2\xd3\x32\xd2\xd2\x43\xc2\xc3\x53\xb2\xb3\x73\xa2"
            "\xa3\x93\x92\x93\xb3\x82\x83\xd4\x62\x64\xe0\x25\x32"
            "\x35\xe0\x6e\xe0\xb8\xe0" }  },
      /* --- pixel bitmap for cmex180 char#78 \bigotimes --- */
      {  78,88209,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 26,   25, 3,131, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x98\xe0\x2c\xc4\x84\x93\xc3\x73\xe3\x55\xc5\x33\x13"
            "\xa3\x13\x22\x33\x83\x32\x22\x43\x63\x42\x13\x53\x43"
            "\x55\x73\x23\x74\x86\x84\x94\x94\x86\x84\x73\x23\x75"
            "\x53\x43\x53\x12\x43\x63\x42\x22\x33\x83\x32\x23\x13"
            "\xa3\x13\x35\xc5\x53\xe3\x73\xc3\x94\x84\xcc\xe0\x28"
            "\x92" }  },
      /* --- pixel bitmap for cmex180 char#79 \Bigotimes --- */
      {  79,89446,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 36,   35, 3,219, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe8\xe0\xbe\xe0\x65\x85\xe0\x24\xe4\xd3\xe0\x43\xb3"
            "\xe0\x63\x94\xe0\x64\x76\xe0\x46\x53\x23\xe0\x23\x23"
            "\x42\x43\xe3\x42\x33\x53\xc3\x53\x22\x73\xa3\x72\x22"
            "\x83\x83\x82\x13\x93\x63\x95\xb3\x43\xb4\xc3\x23\xc4"
            "\xd6\xd4\xe4\xe4\xd6\xd4\xc3\x23\xc4\xb3\x43\xb5\x93"
            "\x63\x93\x12\x83\x83\x82\x22\x73\xa3\x72\x23\x53\xc3"
            "\x53\x32\x43\xe3\x42\x43\x23\xe0\x23\x23\x56\xe0\x46"
            "\x74\xe0\x64\x93\xe0\x63\xb3\xe0\x43\xd4\xe4\xe0\x25"
            "\x85\xe0\x6e\xe0\xb8\xe2" }  },
      /* --- pixel bitmap for cmex180 char#80 \sum --- */
      {  80,90896,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 24,   25, 3,123, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x0e\x08\x32\xe0\x14\x33\xe0\x23\x32\xe0\x32\x42\xe0"
            "\x31\x52\xe0\x31\x42\xe0\x92\xe0\x92\xe0\x83\xe0\x82"
            "\xe0\x92\xe0\x83\xe0\x81\xe0\x81\xe0\x81\xe0\x20\xf1"
            "\x61\xe0\x30\x51\xe0\x81\xe0\x41\x31\xe0\x41\x31\xe0"
            "\x42\x31\xe0\x33\x21\xe0\x24\x2e\x08\x23" }  },
      /* --- pixel bitmap for cmex180 char#81 \prod --- */
      {  81,93888,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 22,   25, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x08\x23\xc3\x20\xfe\x32\xc2\x30\xf5\x32\xc2\x30"
            "\x24\xa4\x28\x68" }  },
      /* --- pixel bitmap for cmex180 char#82 \int --- */
      {  82,99790,                      /* character number, location */
          0, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          { 15,   28, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa3\xb2\x21\xa1\x32\x82\x32\xf4\x82\x50\xf9\x72\x60"
            "\xf4\x62\x72\x42\x72\x32\x91\x31\xb3\xa0" }  },
      /* --- pixel bitmap for cmex180 char#83 \bigcup --- */
      {  83,103869,                     /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\xe0\x12\x0f\x22\xe0\x12\x03\xd3\x12\xd2\x23"
            "\xb3\x33\x93\x53\x73\x7b\xa7\x60" }  },
      /* --- pixel bitmap for cmex180 char#84 \bigcap --- */
      {  84,105705,                     /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xab\x73\x73\x53\x93\x33\xb3\x22\xd2\x13\xd3\x0f"
            "\xe2\xe0\x12\x0f\x22\xe0\x12" }  },
      /* --- pixel bitmap for cmex180 char#85 \biguplus --- */
      {  85,107606,                     /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x02\xe0\x12\x02\x71\x72\x0f\x32\x72\x62\x0f\x12"
            "\x2b\x22\x0f\x32\x72\x62\x02\xe0\x15\xd3\x12\xd2\x23"
            "\xb3\x33\x93\x53\x73\x7b\xa7\x62" }  },
      /* --- pixel bitmap for cmex180 char#86 \bigwedge --- */
      {  86,109532,                     /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,104, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x92\x80\xf1\x83\x80\x75\x70\xf1\x72\x12\x70\x63\x13"
            "\x60\xf1\x62\x32\x60\x53\x33\xa2\x52\x93\x53\x40\xf1"
            "\x42\x72\x40\x33\x73\x30\xf1\x32\x92\x30\x23\x93\x42"
            "\xb2\x33\xb3\x10\xf1\x12\xd2\x13\xd3\x0f\x12\xe0\x12" }  },
      /* --- pixel bitmap for cmex180 char#87 \bigvee --- */
      {  87,111302,                     /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x12\x03\xd3\xf1\x12\xd2\x10\x13\xb3\x32"
            "\xb2\x43\x93\x20\xf1\x32\x92\x30\x33\x73\x30\xf1\x42"
            "\x72\x40\x43\x53\x92\x52\xa3\x33\x50\xf1\x62\x32\x60"
            "\x63\x13\x60\xf1\x72\x12\x70\x75\x70\xf1\x83\x80\x92"
            "\x80" }  },
      /* --- pixel bitmap for cmex180 char#88 \Bigsum --- */
      {  88,92399,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 34,   35, 3,199, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x0e\x0e\x03\x44\xe0\x67\x34\xe0\x94\x44\xe0\xa2\x54"
            "\xe0\xa2\x54\xe0\xa1\x54\xe0\xb1\x54\xe0\xb0\xf1\x64"
            "\xe0\xa0\x74\xe0\xe0\x34\xe0\x80\xf1\x94\xe0\x70\xa4"
            "\xe0\x60\xf1\xb4\xe0\x50\xc4\xe0\xe0\x32\xe0\xe0\x41"
            "\xe0\xe0\x42\xe0\xe0\x32\xe0\xe0\x32\xe0\xe0\x32\xe0"
            "\xe0\x41\xe0\xe0\x41\xe0\xe0\x41\xe0\xe0\x41\xe0\xc1"
            "\x52\xe0\xb1\x52\xe0\xb2\x42\xe0\xb3\x41\xe0\xa4\x41"
            "\xe0\x87\x3e\x0e\x03\x2e\x0e\x03\x33" }  },
      /* --- pixel bitmap for cmex180 char#89 \Bigprod --- */
      {  89,95540,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 30,   35, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0e\x02\x35\xe5\x30\xfe\x44\xe4\x40\xfe\x44\xe4"
            "\x40\x44\xe4\x76\xc6\x3c\x6c" }  },
      /* --- pixel bitmap for cmex180 char#90 \Bigint --- */
      {  90,100836,                     /* character number, location */
          0, 1,  -55, 1,      /* topleft row,col, and botleft row,col */
          { 23,   55, 3,157, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x52\xe0\x61\x21\xe0\x41\x32\xe0\x22\x32\xe0\x21"
            "\x60\xf2\xe0\x12\x60\xe0\x11\x70\xf2\xe2\x70\xd3\x70"
            "\xf2\xd2\x80\xf2\xc3\x80\xf1\xc2\x90\xf3\xb3\x90\xf4"
            "\xa3\xa0\xf3\x93\xb0\xf1\x92\xc0\xf2\x83\xc0\xf2\x82"
            "\xd0\x73\xd0\xf2\x72\xe0\x71\xe0\x10\xf2\x62\xe0\x10"
            "\x61\xe0\x22\x32\xe0\x22\x31\xe0\x41\x21\xe0\x62\xe0"
            "\x52" }  },
      /* --- pixel bitmap for cmex180 char#91 \Bigcup --- */
      {  91,104830,                     /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\xe0\x82\x0f\xa2\xe0\x82\x03\xe0\x63\x12\xe0"
            "\x62\x23\xe0\x43\x33\xe0\x23\x53\xe3\x73\xc3\x94\x84"
            "\xcc\xe0\x28\x92" }  },
      /* --- pixel bitmap for cmex180 char#92 \Bigcap --- */
      {  92,106673,                     /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\xe0\x2c\xc4\x84\x93\xc3\x73\xe3\x53\xe0\x23\x33"
            "\xe0\x43\x22\xe0\x62\x13\xe0\x63\x0f\xe2\xe0\x82\x0f"
            "\xa2\xe0\x82" }  },
      /* --- pixel bitmap for cmex180 char#93 \Biguplus --- */
      {  93,108654,                     /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x02\xe0\x82\x0f\x72\xa2\xa2\x02\x2e\x04\x24\x3e"
            "\x02\x32\x0f\x62\xa2\xa2\x02\xe0\x85\xe0\x63\x12\xe0"
            "\x62\x23\xe0\x43\x33\xe0\x23\x53\xe3\x73\xc3\x94\x84"
            "\xcc\xe0\x28\x91" }  },
      /* --- pixel bitmap for cmex180 char#94 \Bigwedge --- */
      {  94,110465,                     /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 3,158, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xc2\xc0\xf2\xb4\xb0\xa6\xe0\x62\x22\xe0\x53\x23"
            "\x90\xf1\x92\x42\x90\x83\x43\x80\xf1\x82\x62\x80\x73"
            "\x63\x70\xf1\x72\x82\x70\x63\x83\xc2\xa2\xb3\xa3\x50"
            "\xf1\x52\xc2\x50\x43\xc3\x40\xf1\x42\xe2\x40\x33\xe3"
            "\x30\xf1\x32\xe0\x22\x30\x23\xe0\x23\x42\xe0\x42\x33"
            "\xe0\x43\x10\xf1\x12\xe0\x62\x13\xe0\x63\x0f\x12\xe0"
            "\x82" }  },
      /* --- pixel bitmap for cmex180 char#95 \Bigvee --- */
      {  95,112236,                     /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 3,159, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x82\x03\xe0\x63\xf1\x12\xe0\x62\x10\x13"
            "\xe0\x43\x32\xe0\x42\x43\xe0\x23\x20\xf1\x32\xe0\x22"
            "\x30\x33\xe3\x30\xf1\x42\xe2\x40\x43\xc3\x40\xf1\x52"
            "\xc2\x50\x53\xa3\xb2\xa2\xc3\x83\x60\xf1\x72\x82\x70"
            "\x73\x63\x70\xf1\x82\x62\x80\x83\x43\x80\xf1\x92\x42"
            "\x90\x93\x23\xe0\x52\x22\xe0\x66\xa0\xf2\xb4\xb0\xf1"
            "\xc2\xc3" }  },
      /* --- pixel bitmap for cmex180 char#96 \coprod --- */
      {  96,97075,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 22,   25, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x68\x24\xa4\x20\xfe\x32\xc2\x30\xf5\x32\xc2\x30"
            "\x23\xc3\x2e\x08" }  },
      /* --- pixel bitmap for cmex180 char#97 \Bigcoprod --- */
      {  97,98729,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 30,   35, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x6c\x36\xc6\x30\xfe\x44\xe4\x40\xfe\x44\xe4\x40"
            "\x44\xe4\x75\xe5\x3e\x0e\x02" }  },
      /* --- pixel bitmap for cmex180 char#98 ^ --- */
      {  98,113035,                     /* character number, location */
         19, 0,   14, 0,      /* topleft row,col, and botleft row,col */
          { 14,    5, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\xa6\x63\x43\x32\x82\x11\xc1" }  },
      /* --- pixel bitmap for cmex180 char#99 ^ --- */
      {  99,113912,                     /* character number, location */
         20, 0,   15, 0,      /* topleft row,col, and botleft row,col */
          { 25,    5, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb3\xe0\x59\xd5\x55\x74\xd4\x23\xe0\x53" }  },
      /* --- pixel bitmap for cmex180 char#100 ^ --- */
      { 100,114998,                     /* character number, location */
         20, 0,   15, 0,      /* topleft row,col, and botleft row,col */
          { 36,    5, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x24\xe0\xec\xe0\x66\x86\xc5\xe0\x45\x44\xe0\xe4" }  },
      /* --- pixel bitmap for cmex180 char#101 ~ --- */
      { 101,115713,                     /* character number, location */
         18, 0,   15, 0,      /* topleft row,col, and botleft row,col */
          { 14,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\xa0\xff\x17\xf8\x00" }  },
      /* --- pixel bitmap for cmex180 char#102 ~ --- */
      { 102,116631,                     /* character number, location */
         19, 0,   15, 0,      /* topleft row,col, and botleft row,col */
          { 25,    4, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xc1\x3a\x83\x23\x8a\x31\xc6\x60" }  },
      /* --- pixel bitmap for cmex180 char#103 ~ --- */
      { 103,117764,                     /* character number, location */
         19, 0,   15, 0,      /* topleft row,col, and botleft row,col */
          { 36,    4, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\xe0\x32\x55\x45\xc3\x43\xc5\x45\x52\xe0\x38\x94" }  },
      /* --- pixel bitmap for cmex180 char#104 \Big[ --- */
      { 104,13261,                      /* character number, location */
          1, 6,  -43, 6,      /* topleft row,col, and botleft row,col */
          {  5,   44, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x4f\xe1\x4f\xb1\x45" }  },
      /* --- pixel bitmap for cmex180 char#105 \Big] --- */
      { 105,19230,                      /* character number, location */
          1, 1,  -43, 1,      /* topleft row,col, and botleft row,col */
          {  5,   44, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x41\xfe\x41\xfb\x41\x05" }  },
      /* --- pixel bitmap for cmex180 char#106 (noname) --- */
      { 106,25172,                      /* character number, location */
          1, 6,  -43, 6,      /* topleft row,col, and botleft row,col */
          {  7,   44, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x2a\x00\x01\x06\x07" }  },
      /* --- pixel bitmap for cmex180 char#107 (noname) --- */
      { 107,28768,                      /* character number, location */
          1, 1,  -43, 1,      /* topleft row,col, and botleft row,col */
          {  6,   44, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x2a\x05\x01\x00\x06" }  },
      /* --- pixel bitmap for cmex180 char#108 (noname) --- */
      { 108,32368,                      /* character number, location */
          1, 6,  -43, 6,      /* topleft row,col, and botleft row,col */
          {  7,   44, 2, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x07\x00\xff\x2a\x01\x06" }  },
      /* --- pixel bitmap for cmex180 char#109 (noname) --- */
      { 109,35972,                      /* character number, location */
          1, 1,  -43, 1,      /* topleft row,col, and botleft row,col */
          {  6,   44, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\xff\x2a\x05\x01" }  },
      /* --- pixel bitmap for cmex180 char#110 \Big{ --- */
      { 110,39740,                      /* character number, location */
          1, 3,  -43, 3,      /* topleft row,col, and botleft row,col */
          { 11,   44, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x72\x82\x82\x40\xfe\x42\x50\x32\x82\x70\xf1\x12"
            "\x80\x22\xa2\x60\xfe\x42\x50\x52\xa2\xa2\xb2" }  },
      /* --- pixel bitmap for cmex180 char#111 \Big} --- */
      { 111,47522,                      /* character number, location */
          1, 3,  -43, 3,      /* topleft row,col, and botleft row,col */
          { 11,   44, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xa2\xb1\xa2\x60\xfe\x42\x50\x52\xa2\x30\xf1\x83"
            "\x62\x82\x40\xfe\x42\x50\x32\x91\x82\x82\x93" }  },
      /* --- pixel bitmap for cmex180 char#112 (noname) --- */
      { 112,74852,                      /* character number, location */
          1, 3,  -29, 3,      /* topleft row,col, and botleft row,col */
          { 23,   30, 3,123, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x81\xf1\xe0\x71\x10\xf1\xe0\x61\x20\xf1\xe0"
            "\x51\x30\xf1\xe0\x41\x40\xf1\xe0\x31\x50\xf1\xe0\x21"
            "\x60\xe0\x11\xa1\xb1\x92\xa1\x82\x12\x91\x80\xf1\x32"
            "\x81\x90\xf1\x42\x61\xa0\xf1\x52\x41\xb0\xf1\x62\x21"
            "\xc0\x62\x11\xe0\x63\xe0\x62\xe0\x81\xe2" }  },
      /* --- pixel bitmap for cmex180 char#113 (noname) --- */
      { 113,75847,                      /* character number, location */
          1, 3,  -44, 3,      /* topleft row,col, and botleft row,col */
          { 23,   45, 3,137, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x81\xf2\xe0\x71\x10\xf2\xe0\x61\x20\xf2\xe0"
            "\x51\x30\xf3\xe0\x41\x40\xf2\xe0\x31\x50\xf2\xe0\x21"
            "\x60\xf1\xe0\x11\x70\x31\xb1\x92\xa1\x93\xa1\x81\x22"
            "\x91\x80\xf1\x32\x81\x90\x42\x71\x90\xf2\x42\x61\xa0"
            "\xf2\x52\x41\xb0\x62\x31\xb0\xf2\x62\x21\xc0\xf2\x73"
            "\xd0\xf1\x81\xe0" }  },
      /* --- pixel bitmap for cmex180 char#114 (noname) --- */
      { 114,76883,                      /* character number, location */
          1, 3,  -59, 3,      /* topleft row,col, and botleft row,col */
          { 23,   60, 3,157, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\x81\xf3\xe0\x71\x10\xf3\xe0\x61\x20\xf3\xe0"
            "\x51\x30\xf3\xe0\x41\x40\xf4\xe0\x31\x50\xf3\xe0\x21"
            "\x60\xf1\xe0\x11\x70\xf1\x31\xb1\x70\x22\xa1\x80\xf1"
            "\x13\xa1\x81\x22\x91\x80\xf2\x32\x81\x90\xf1\x42\x71"
            "\x90\xf2\x42\x61\xa0\x52\x51\xa0\xf2\x52\x41\xb0\x62"
            "\x31\xb0\xf3\x62\x21\xc0\xf3\x73\xd0\x72\xe0\xf1\x81"
            "\xe0" }  },
      /* --- pixel bitmap for cmex180 char#115 (noname) --- */
      { 115,77961,                      /* character number, location */
          1, 3,  -74, 3,      /* topleft row,col, and botleft row,col */
          { 23,   75, 3,155, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\x81\xf4\xe0\x71\x10\xf5\xe0\x61\x20\xf4\xe0"
            "\x51\x30\xf4\xe0\x41\x40\xf5\xe0\x31\x50\xf4\xe0\x21"
            "\x60\xf2\xe0\x11\x70\x31\xb1\x92\xb1\x92\xa1\x80\xf1"
            "\x13\xa1\x8f\x11\x22\x91\x80\xf3\x32\x81\x90\xf1\x42"
            "\x71\x90\xf3\x42\x61\xa0\x52\x51\xa0\xf4\x52\x41\xb0"
            "\xf4\x62\x21\xc0\x72\x11\xc0\xf4\x73\xd0\xf2\x81\xe1" }  },
      /* --- pixel bitmap for cmex180 char#116 (noname) --- */
      { 116,79123,                      /* character number, location */
          1, 3,  -45, 3,      /* topleft row,col, and botleft row,col */
          { 15,   46, 3,92, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\xe1\x21\xb1\x22\xa1\xf1\x13\xa1\x02\x12\x92\x22"
            "\x91\x32\x91\xf2\x42\x81\xf2\x52\x71\xf3\x62\x61\xf2"
            "\x72\x51\xf2\x82\x41\xf2\x92\x31\xf2\xa2\x21\xf2\xb2"
            "\x11\xf2\xc3\xf2\xd2\xf1\xe1" }  },
      /* --- pixel bitmap for cmex180 char#117 (noname) --- */
      { 117,80072,                      /* character number, location */
          1,17,  -16,17,      /* topleft row,col, and botleft row,col */
          {  1,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\x01" }  },
      /* --- pixel bitmap for cmex180 char#118 (noname) --- */
      { 118,80897,                      /* character number, location */
          1,17,  -15,17,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x0f\xe1\x91" }  },
      /* --- pixel bitmap for cmex180 char#119 (noname) --- */
      { 119,73875,                      /* character number, location */
          1, 7,  -16, 7,      /* topleft row,col, and botleft row,col */
          {  6,   17, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x41\x0f\x11\x41" }  },
      /* --- pixel bitmap for cmex180 char#120 (noname) --- */
      { 120,69129,                      /* character number, location */
          0, 3,  -15, 3,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x93\x75\x52\x11\x12\x22\x31\x32\xf9\x51\x50" }  },
      /* --- pixel bitmap for cmex180 char#121 (noname) --- */
      { 121,70066,                      /* character number, location */
          0, 3,  -15, 3,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x51\x52\x31\x32\x22\x11\x12\x55\x73\x91\x50" }  },
      /* --- pixel bitmap for cmex180 char#122 (noname) --- */
      { 122,53238,                      /* character number, location */
          3,-1,   -5,-1,      /* topleft row,col, and botleft row,col */
          { 13,    8, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x94\x67\x58\x44\x82\xa1\xb1\xb1\xc3" }  },
      /* --- pixel bitmap for cmex180 char#123 (noname) --- */
      { 123,53822,                      /* character number, location */
          3,-1,   -5,-1,      /* topleft row,col, and botleft row,col */
          { 13,    8, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x97\x68\xa4\xc2\xd1\xd1\xd1" }  },
      /* --- pixel bitmap for cmex180 char#124 (noname) --- */
      { 124,54403,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 13,    8, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xd1\xd1\xd2\xc4\xa8\x67\x94" }  },
      /* --- pixel bitmap for cmex180 char#125 (noname) --- */
      { 125,54985,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 13,    8, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xb1\xb1\xa2\x84\x48\x57\x64\x93" }  },
      /* --- pixel bitmap for cmex180 char#126 (noname) --- */
      { 126,71859,                      /* character number, location */
         -1, 2,  -15, 2,      /* topleft row,col, and botleft row,col */
          { 16,   14, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x72\x70\x61\x21\xb1\x41\x92\x42\x62\x11\x41\x12"
            "\x22\x31\x41\x32\xf6\x51\x41\x51" }  },
      /* --- pixel bitmap for cmex180 char#127 (noname) --- */
      { 127,72971,                      /* character number, location */
          0, 2,  -14, 2,      /* topleft row,col, and botleft row,col */
          { 16,   14, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x51\x41\x52\x31\x41\x32\x22\x11\x41\x12\x62\x42"
            "\x91\x41\xb1\x21\x60\xf1\x72\x71" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=6 for .210gf ---
 * mf '\mode=preview; mag=magstep(-13.80488502080647873125); input cmex10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmex210 --- */
static	chardef  cmex210[] =
   {
      /* --- pixel bitmap for cmex210 char#0 \big( --- */
      {   0,  661,                      /* character number, location */
          1, 4,  -33, 4,      /* topleft row,col, and botleft row,col */
          {  8,   34, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x61\x61\x61\x62\x61\x62\x61\x50\xf2\x12\x50\x11"
            "\x6f\x92\x60\x11\x60\xf2\x12\x50\x21\x72\x71\x72\x71"
            "\x81\x81\x81" }  },
      /* --- pixel bitmap for cmex210 char#1 \big) --- */
      {   1, 6598,                      /* character number, location */
          1, 1,  -33, 1,      /* topleft row,col, and botleft row,col */
          {  8,   34, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x81\x81\x72\x71\x72\x71\x20\xf2\x52\x10\x61"
            "\x10\xf9\x62\x61\x10\xf2\x52\x10\x51\x62\x61\x62\x61"
            "\x61\x61\x61\x73" }  },
      /* --- pixel bitmap for cmex210 char#2 \big[ --- */
      {   2,12581,                      /* character number, location */
          1, 5,  -33, 5,      /* topleft row,col, and botleft row,col */
          {  7,   34, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x07\x0f\xe2\x5f\xe2\x5f\x17" }  },
      /* --- pixel bitmap for cmex210 char#3 \big] --- */
      {   3,18611,                      /* character number, location */
          1, 0,  -33, 0,      /* topleft row,col, and botleft row,col */
          {  7,   34, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x07\xfe\x52\xfe\x52\x0f\x17" }  },
      /* --- pixel bitmap for cmex210 char#4 (noname) --- */
      {   4,24608,                      /* character number, location */
          1, 5,  -33, 5,      /* topleft row,col, and botleft row,col */
          {  9,   34, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x7f\xe2\x7f\x12\x7f\x19" }  },
      /* --- pixel bitmap for cmex210 char#5 (noname) --- */
      {   5,28285,                      /* character number, location */
          1, 0,  -33, 0,      /* topleft row,col, and botleft row,col */
          {  9,   34, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x72\xfe\x72\xf1\x72\x0f\x19" }  },
      /* --- pixel bitmap for cmex210 char#6 (noname) --- */
      {   6,31912,                      /* character number, location */
          1, 5,  -33, 5,      /* topleft row,col, and botleft row,col */
          {  9,   34, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x09\x0f\xe2\x7f\xe2\x7f\x12\x7e" }  },
      /* --- pixel bitmap for cmex210 char#7 (noname) --- */
      {   7,35597,                      /* character number, location */
          1, 0,  -33, 0,      /* topleft row,col, and botleft row,col */
          {  9,   34, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x09\xfe\x72\xfe\x72\xf1\x72" }  },
      /* --- pixel bitmap for cmex210 char#8 \big{ --- */
      {   8,39325,                      /* character number, location */
          1, 3,  -33, 3,      /* topleft row,col, and botleft row,col */
          { 11,   34, 3,44, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x72\x82\x30\xfa\x52\x40\x51\x83\x50\xf1\x13\x70"
            "\x33\xa1\x50\xfa\x52\x40\x62\xa2\xb2" }  },
      /* --- pixel bitmap for cmex210 char#9 \big} --- */
      {   9,47156,                      /* character number, location */
          1, 3,  -33, 3,      /* topleft row,col, and botleft row,col */
          { 11,   34, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xb3\xa2\x50\xfb\x52\x40\x62\x30\xf1\x83\x62\x30"
            "\xfb\x52\x40\x42\x73\x62\x94" }  },
      /* --- pixel bitmap for cmex210 char#10 \big< --- */
      {  10,56168,                      /* character number, location */
          1, 3,  -33, 3,      /* topleft row,col, and botleft row,col */
          {  9,   34, 3,76, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x72\x63\x62\x63\x62\x63\x62\x63\x30\xf1\x32\x40"
            "\x23\x62\x63\x62\x63\x6f\x12\x73\x72\x73\x72\x73\x40"
            "\xf1\x32\x40\x33\x72\x73\x72\x73\x72\x73\xf1\x72" }  },
      /* --- pixel bitmap for cmex210 char#11 \big> --- */
      {  11,59149,                      /* character number, location */
          1, 2,  -33, 2,      /* topleft row,col, and botleft row,col */
          {  9,   34, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x06\x1c\x30\xe0\x80\x01\x07\x0c\x38\x60\xc0\x80"
            "\x03\x06\x1c\x30\xe0\x80\x01\x03\x07\x06\x0e\x0c\x1c"
            "\x18\x30\x70\x60\xe0\xc0\xc0\x81\x81\x03\x03\x06\x00" }  },
      /* --- pixel bitmap for cmex210 char#12 (noname) --- */
      {  12,68587,                      /* character number, location */
          1, 4,  -18, 4,      /* topleft row,col, and botleft row,col */
          {  2,   19, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x32" }  },
      /* --- pixel bitmap for cmex210 char#13 (noname) --- */
      {  13,69218,                      /* character number, location */
          1, 4,  -18, 4,      /* topleft row,col, and botleft row,col */
          {  8,   19, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x42\x0f\x32\x42" }  },
      /* --- pixel bitmap for cmex210 char#14 (noname) --- */
      {  14,62142,                      /* character number, location */
          1, 2,  -33, 2,      /* topleft row,col, and botleft row,col */
          { 13,   34, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xb2\xa3\xf1\xa2\x10\x93\x10\xf1\x92\x20\x83\x20"
            "\xf1\x82\x30\x73\x30\xf1\x72\x40\x63\xa2\xa3\x50\xf1"
            "\x52\x60\x43\x60\xf1\x42\x70\x33\x70\xf1\x32\x80\x23"
            "\x80\xf1\x22\x90\x13\x90\xf1\x12\xa3\xaf\x12\xb2" }  },
      /* --- pixel bitmap for cmex210 char#15 (noname) --- */
      {  15,65396,                      /* character number, location */
          1, 2,  -33, 2,      /* topleft row,col, and botleft row,col */
          { 13,   34, 3,104, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xb3\xa0\xf1\x12\xa0\x13\x90\xf1\x22\x90\x23"
            "\x80\xf1\x32\x80\x33\x70\xf1\x42\x70\x43\x60\xf1\x52"
            "\x60\x53\xb2\xb3\x40\xf1\x72\x40\x73\x30\xf1\x82\x30"
            "\x83\x20\xf1\x92\x20\x93\x10\xf1\xa2\x10\xa3\xf1\xb2" }  },
      /* --- pixel bitmap for cmex210 char#16 \Big( --- */
      {  16, 1414,                      /* character number, location */
          1, 5,  -50, 5,      /* topleft row,col, and botleft row,col */
          { 11,   51, 3,86, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x82\x82\x20\xf1\x62\x30\x52\x40\xf1\x42\x50\xf1"
            "\x32\x60\xf2\x22\x70\xf4\x12\x8f\xe2\x90\xf4\x12\x80"
            "\xf2\x22\x70\xf1\x32\x60\xf1\x42\x50\x52\x40\xf1\x62"
            "\x30\x72\xa2\xa2" }  },
      /* --- pixel bitmap for cmex210 char#17 \Big) --- */
      {  17, 7338,                      /* character number, location */
          1, 1,  -50, 1,      /* topleft row,col, and botleft row,col */
          { 11,   51, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xa2\xa2\x70\xf1\x32\x60\x42\x50\xf1\x52\x40\xf1"
            "\x62\x30\xf2\x72\x20\xf4\x82\x10\xfe\x92\xf4\x82\x10"
            "\xf2\x72\x20\xf1\x62\x30\xf1\x52\x40\x42\x50\xf1\x32"
            "\x60\x22\x82\x82\x92" }  },
      /* --- pixel bitmap for cmex210 char#18 \bigg( --- */
      {  18, 2280,                      /* character number, location */
          1, 6,  -68, 6,      /* topleft row,col, and botleft row,col */
          { 14,   69, 3,118, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc2\xb2\xb2\xb2\x30\xf1\x82\x40\x72\x50\xf1\x62\x60"
            "\xf1\x52\x70\xf1\x42\x80\xf2\x32\x90\xf3\x22\xa0\xf5"
            "\x12\xbf\xe2\xcf\x12\xc0\xf5\x12\xb0\xf3\x22\xa0\xf2"
            "\x32\x90\xf1\x42\x80\xf1\x52\x70\xf1\x62\x60\x72\x50"
            "\xf1\x82\x40\x92\xd2\xd2\xd2" }  },
      /* --- pixel bitmap for cmex210 char#19 \bigg) --- */
      {  19, 8165,                      /* character number, location */
          1, 1,  -68, 1,      /* topleft row,col, and botleft row,col */
          { 14,   69, 3,119, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xd2\xd2\xd2\x90\xf1\x42\x80\x52\x70\xf1\x62\x60"
            "\xf1\x72\x50\xf1\x82\x40\xf2\x92\x30\xf3\xa2\x20\xf5"
            "\xb2\x10\xfe\xc2\xf1\xc2\xf5\xb2\x10\xf3\xa2\x20\xf2"
            "\x92\x30\xf1\x82\x40\xf1\x72\x50\xf1\x62\x60\x52\x70"
            "\xf1\x42\x80\x32\xb2\xb2\xb2\xc2" }  },
      /* --- pixel bitmap for cmex210 char#20 \bigg[ --- */
      {  20,14292,                      /* character number, location */
          1, 7,  -68, 7,      /* topleft row,col, and botleft row,col */
          {  8,   69, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x08\x00\xff\x40\x02\x06\xff\x01\x08" }  },
      /* --- pixel bitmap for cmex210 char#21 \bigg] --- */
      {  21,20270,                      /* character number, location */
          1, 0,  -68, 0,      /* topleft row,col, and botleft row,col */
          {  8,   69, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x08\xff\x40\x06\x02\x00\xff\x01\x08" }  },
      /* --- pixel bitmap for cmex210 char#22 (noname) --- */
      {  22,26383,                      /* character number, location */
          1, 7,  -68, 7,      /* topleft row,col, and botleft row,col */
          { 10,   69, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x42\x00\x02\x08\xff\x01\x0a" }  },
      /* --- pixel bitmap for cmex210 char#23 (noname) --- */
      {  23,30008,                      /* character number, location */
          1, 0,  -68, 0,      /* topleft row,col, and botleft row,col */
          { 10,   69, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x42\x08\x02\x00\xff\x01\x0a" }  },
      /* --- pixel bitmap for cmex210 char#24 (noname) --- */
      {  24,33691,                      /* character number, location */
          1, 7,  -68, 7,      /* topleft row,col, and botleft row,col */
          { 10,   69, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0a\x00\xff\x42\x02\x08" }  },
      /* --- pixel bitmap for cmex210 char#25 (noname) --- */
      {  25,37324,                      /* character number, location */
          1, 0,  -68, 0,      /* topleft row,col, and botleft row,col */
          { 10,   69, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0a\xff\x42\x08\x02" }  },
      /* --- pixel bitmap for cmex210 char#26 \bigg{ --- */
      {  26,41372,                      /* character number, location */
          1, 3,  -68, 3,      /* topleft row,col, and botleft row,col */
          { 16,   69, 3,92, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd3\xc4\xa4\xb3\xc3\xd2\xd3\x60\xfe\x72\x70\xf5\x72"
            "\x70\xf1\x62\x80\x52\xd2\xd2\xc3\xc3\xe3\xe0\x12\xe0"
            "\x12\xe0\x12\x90\xf1\x62\x80\xfe\x72\x70\xf5\x72\x70"
            "\x73\xe2\xe3\xe3\xe4\xe4\xd3" }  },
      /* --- pixel bitmap for cmex210 char#27 \bigg} --- */
      {  27,49205,                      /* character number, location */
          1, 3,  -68, 3,      /* topleft row,col, and botleft row,col */
          { 16,   69, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xd4\xe4\xe3\xe3\xe2\xe3\x70\xfe\x72\x70\xf5\x72"
            "\x70\xf1\x82\x60\x92\xe0\x12\xe0\x12\xe0\x14\xd3\xc4"
            "\xb2\xd2\xd2\x50\xf1\x82\x60\xfe\x72\x70\xf5\x72\x70"
            "\x63\xd2\xd3\xc3\xb4\xa4\xc3\xd1" }  },
      /* --- pixel bitmap for cmex210 char#28 \bigg< --- */
      {  28,57627,                      /* character number, location */
          1, 4,  -69, 4,      /* topleft row,col, and botleft row,col */
          { 15,   70, 3,196, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xd2\xc3\xc2\xc3\x10\xf1\xb2\x20\xa3\x20\xf1\xa2"
            "\x30\x93\xc2\xc3\x40\xf1\x82\x50\x73\xc2\xc3\x60\xf1"
            "\x62\x70\x53\x70\xf1\x52\x80\x43\xc2\xc3\x90\xf1\x32"
            "\xa0\x23\xa0\xf1\x22\xb0\x13\xc2\xc3\xcf\x12\xd3\xd2"
            "\xd3\xb0\xf1\x22\xb0\x23\xa0\xf1\x32\xa0\x33\xd2\xd3"
            "\x80\xf1\x52\x80\x53\x70\xf1\x62\x70\x63\xd2\xd3\x50"
            "\xf1\x82\x50\x83\xd2\xd3\x30\xf1\xa2\x30\xa3\x20\xf1"
            "\xb2\x20\xb3\xd2\xd3\xf1\xd2" }  },
      /* --- pixel bitmap for cmex210 char#29 \bigg> --- */
      {  29,60610,                      /* character number, location */
          1, 3,  -69, 3,      /* topleft row,col, and botleft row,col */
          { 15,   70, 3,197, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xd3\xd2\xd3\xb0\xf1\x22\xb0\x23\xa0\xf1\x32"
            "\xa0\x33\xd2\xd3\x80\xf1\x52\x80\x53\xd2\xd3\x60\xf1"
            "\x72\x60\x73\x50\xf1\x82\x50\x83\xd2\xd3\x30\xf1\xa2"
            "\x30\xa3\x20\xf1\xb2\x20\xb3\xd2\xd3\xf1\xd2\xc3\xc2"
            "\xc3\x10\xf1\xb2\x20\xa3\x20\xf1\xa2\x30\x93\xc2\xc3"
            "\x40\xf1\x82\x50\x73\x50\xf1\x72\x60\x63\xc2\xc3\x70"
            "\xf1\x52\x80\x43\xc2\xc3\x90\xf1\x32\xa0\x23\xa0\xf1"
            "\x22\xb0\x13\xc2\xc3\xcf\x12\xd3" }  },
      /* --- pixel bitmap for cmex210 char#30 (noname) --- */
      {  30,63697,                      /* character number, location */
          1, 2,  -68, 2,      /* topleft row,col, and botleft row,col */
          { 26,   69, 3,287, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\xa2\xe0\x93\xf1\xe0\x92\x10\xe0\x83\xe0\x92"
            "\xe0\x93\x20\xf1\xe0\x72\x30\xe0\x63\x30\xf1\xe0\x62"
            "\x40\xe0\x53\x40\xf1\xe0\x52\x50\xe0\x43\x50\xf1\xe0"
            "\x42\x60\xe0\x33\xe0\x92\xe0\x93\x70\xf1\xe0\x22\x80"
            "\xe0\x13\x80\xf1\xe0\x12\x90\xe3\x90\xf1\xe2\xa0\xd3"
            "\xa0\xf1\xd2\xb0\xc3\xe0\x92\xe0\x93\xc0\xf1\xb2\xd0"
            "\xa3\xd0\xf1\xa2\xe0\x93\xe0\xf1\x92\xe0\x10\x83\xe0"
            "\x10\xf1\x82\xe0\x20\x73\xe0\x92\xe0\x93\xe0\x30\xf1"
            "\x62\xe0\x40\x53\xe0\x40\xf1\x52\xe0\x50\x43\xe0\x50"
            "\xf1\x42\xe0\x60\x33\xe0\x60\xf1\x32\xe0\x70\x23\xe0"
            "\x92\xe0\x93\xe0\x80\xf1\x12\xe0\x93\xe0\x9f\x12\xe0"
            "\xa0" }  },
      /* --- pixel bitmap for cmex210 char#31 (noname) --- */
      {  31,66959,                      /* character number, location */
          1, 2,  -68, 2,      /* topleft row,col, and botleft row,col */
          { 26,   69, 3,290, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\xa3\xe0\x90\xf1\x12\xe0\x90\x13\xe0\xa2"
            "\xe0\xa3\xe0\x70\xf1\x32\xe0\x70\x33\xe0\x60\xf1\x42"
            "\xe0\x60\x43\xe0\x50\xf1\x52\xe0\x50\x53\xe0\x40\xf1"
            "\x62\xe0\x40\x63\xe0\xa2\xe0\xa3\xe0\x20\xf1\x82\xe0"
            "\x20\x83\xe0\x10\xf1\x92\xe0\x10\x93\xe0\xf1\xa2\xe0"
            "\xa3\xd0\xf1\xb2\xd0\xb3\xe0\xa2\xe0\xa3\xb0\xf1\xd2"
            "\xb0\xd3\xa0\xf1\xe2\xa0\xe3\x90\xf1\xe0\x12\x90\xe0"
            "\x13\x80\xf1\xe0\x22\x80\xe0\x23\xe0\xa2\xe0\xa3\x60"
            "\xf1\xe0\x42\x60\xe0\x43\x50\xf1\xe0\x52\x50\xe0\x53"
            "\x40\xf1\xe0\x62\x40\xe0\x63\x30\xf1\xe0\x72\x30\xe0"
            "\x73\xe0\xa2\xe0\xa3\x10\xf1\xe0\x92\x10\xe0\x93\xf1"
            "\xe0\xa2" }  },
      /* --- pixel bitmap for cmex210 char#32 \Bigg( --- */
      {  32, 3208,                      /* character number, location */
          1, 7,  -85, 7,      /* topleft row,col, and botleft row,col */
          { 15,   86, 3,146, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd2\xc2\x10\xf1\xb2\x20\xa2\xc2\xc3\xc2\xc3\xc2\xc3"
            "\xc2\xc3\xc2\x80\xf1\x43\x80\x42\x90\xf2\x33\x90\x32"
            "\xa0\xf2\x23\xa0\x22\xb0\xf6\x13\xbf\xe3\xcf\x63\xc0"
            "\xf6\x13\xb0\x22\xb0\xf2\x23\xa0\x32\xa0\xf2\x33\x90"
            "\x42\x90\xf1\x43\x80\x52\xd3\xd2\xd3\xd2\xd3\xd2\xd3"
            "\xd2\xe2\x30\xf1\xb2\x20\xc2\xe2" }  },
      /* --- pixel bitmap for cmex210 char#33 \Bigg) --- */
      {  33, 9080,                      /* character number, location */
          1, 1,  -85, 1,      /* topleft row,col, and botleft row,col */
          { 15,   86, 3,147, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe2\xc0\xf1\x22\xb0\x32\xe2\xd3\xd2\xd3\xd2\xd3"
            "\xd2\xd3\xd2\x50\xf1\x83\x40\x92\x40\xf2\x93\x30\xa2"
            "\x30\xf2\xa3\x20\xb2\x20\xf6\xb3\x10\xfe\xc3\xf6\xc3"
            "\xf6\xb3\x10\xb2\x20\xf2\xa3\x20\xa2\x30\xf2\x93\x30"
            "\x92\x40\xf1\x83\x40\x82\xc3\xc2\xc3\xc2\xc3\xc2\xc3"
            "\xc2\xc2\xa0\xf1\x22\xb0\x12\xc2\xd0" }  },
      /* --- pixel bitmap for cmex210 char#34 \Bigg[ --- */
      {  34,15253,                      /* character number, location */
          1, 8,  -85, 8,      /* topleft row,col, and botleft row,col */
          {  9,   86, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x09\x00\xff\x51\x02\x07\xff\x01\x09" }  },
      /* --- pixel bitmap for cmex210 char#35 \Bigg] --- */
      {  35,21218,                      /* character number, location */
          1, 0,  -85, 0,      /* topleft row,col, and botleft row,col */
          {  9,   86, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x09\xff\x51\x07\x02\x00\xff\x01\x09" }  },
      /* --- pixel bitmap for cmex210 char#36 (noname) --- */
      {  36,27376,                      /* character number, location */
          1, 8,  -85, 8,      /* topleft row,col, and botleft row,col */
          { 11,   86, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x53\x00\x02\x09\xff\x01\x0b" }  },
      /* --- pixel bitmap for cmex210 char#37 (noname) --- */
      {  37,30962,                      /* character number, location */
          1, 0,  -85, 0,      /* topleft row,col, and botleft row,col */
          { 11,   86, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x53\x09\x02\x00\xff\x01\x0b" }  },
      /* --- pixel bitmap for cmex210 char#38 (noname) --- */
      {  38,34686,                      /* character number, location */
          1, 8,  -85, 8,      /* topleft row,col, and botleft row,col */
          { 11,   86, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0b\x00\xff\x53\x02\x09" }  },
      /* --- pixel bitmap for cmex210 char#39 (noname) --- */
      {  39,38280,                      /* character number, location */
          1, 0,  -85, 0,      /* topleft row,col, and botleft row,col */
          { 11,   86, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0b\xff\x53\x09\x02" }  },
      /* --- pixel bitmap for cmex210 char#40 \Bigg{ --- */
      {  40,42488,                      /* character number, location */
          1, 3,  -85, 3,      /* topleft row,col, and botleft row,col */
          { 17,   86, 3,112, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe3\xd4\xb4\xc4\xc4\xd3\x50\xf1\x83\x60\xfe\x73\x70"
            "\xfb\x73\x70\xf1\x63\x80\xf1\x53\x90\x43\xd3\xc4\xcf"
            "\x13\xe0\x14\xe0\x13\xe0\x13\xa0\xf1\x53\x90\xf1\x63"
            "\x80\xfe\x73\x70\xfb\x73\x70\xf1\x83\x60\x93\xe4\xe4"
            "\xe4\xe0\x14\xe3" }  },
      /* --- pixel bitmap for cmex210 char#41 \Bigg} --- */
      {  41,50322,                      /* character number, location */
          1, 3,  -85, 3,      /* topleft row,col, and botleft row,col */
          { 17,   86, 3,113, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x03\xe4\xe0\x14\xe4\xe4\xe3\x90\xf1\x63\x80\xfe\x73"
            "\x70\xfb\x73\x70\xf1\x83\x60\xf1\x93\x50\xa3\xe0\x13"
            "\xe0\x14\x10\xf1\xe3\xc4\xc3\xd3\x40\xf1\x93\x50\xf1"
            "\x83\x60\xfe\x73\x70\xfb\x73\x70\xf1\x63\x80\x53\xd4"
            "\xc4\xc4\xb4\xd3\xe0" }  },
      /* --- pixel bitmap for cmex210 char#42 \Bigg< --- */
      {  42,58463,                      /* character number, location */
          1, 4,  -85, 4,      /* topleft row,col, and botleft row,col */
          { 16,   86, 3,272, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe2\xd3\xf1\xd2\x10\xc3\x10\xf1\xc2\x20\xb3\x20"
            "\xf1\xb2\x30\xa3\x30\xf1\xa2\x40\x93\x40\xf1\x92\x50"
            "\x83\x50\xf1\x82\x60\x73\x60\xf1\x72\x70\x63\x70\xf1"
            "\x62\x80\x53\x80\xf1\x52\x90\x43\x90\xf1\x42\xa0\x33"
            "\xa0\xf1\x32\xb0\x23\xb0\xf1\x22\xc0\x13\xc0\xf1\x12"
            "\xd3\xdf\x12\xe3\xd0\xf1\x12\xd0\x13\xc0\xf1\x22\xc0"
            "\x23\xb0\xf1\x32\xb0\x33\xa0\xf1\x42\xa0\x43\x90\xf1"
            "\x52\x90\x53\x80\xf1\x62\x80\x63\x70\xf1\x72\x70\x73"
            "\x60\xf1\x82\x60\x83\x50\xf1\x92\x50\x93\x40\xf1\xa2"
            "\x40\xa3\x30\xf1\xb2\x30\xb3\x20\xf1\xc2\x20\xc3\x10"
            "\xf1\xd2\x10\xd3\xf1\xe2" }  },
      /* --- pixel bitmap for cmex210 char#43 \Bigg> --- */
      {  43,61447,                      /* character number, location */
          1, 3,  -85, 3,      /* topleft row,col, and botleft row,col */
          { 16,   86, 3,273, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe3\xd0\xf1\x12\xd0\x13\xc0\xf1\x22\xc0\x23"
            "\xb0\xf1\x32\xb0\x33\xa0\xf1\x42\xa0\x43\x90\xf1\x52"
            "\x90\x53\x80\xf1\x62\x80\x63\x70\xf1\x72\x70\x73\x60"
            "\xf1\x82\x60\x83\x50\xf1\x92\x50\x93\x40\xf1\xa2\x40"
            "\xa3\x30\xf1\xb2\x30\xb3\x20\xf1\xc2\x20\xc3\x10\xf1"
            "\xd2\x10\xd3\xf1\xe2\xd3\xf1\xd2\x10\xc3\x10\xf1\xc2"
            "\x20\xb3\x20\xf1\xb2\x30\xa3\x30\xf1\xa2\x40\x93\x40"
            "\xf1\x92\x50\x83\x50\xf1\x82\x60\x73\x60\xf1\x72\x70"
            "\x63\x70\xf1\x62\x80\x53\x80\xf1\x52\x90\x43\x90\xf1"
            "\x42\xa0\x33\xa0\xf1\x32\xb0\x23\xb0\xf1\x22\xc0\x13"
            "\xc0\xf1\x12\xd3\xdf\x12\xe0" }  },
      /* --- pixel bitmap for cmex210 char#44 / --- */
      {  44,64697,                      /* character number, location */
          1, 2,  -85, 2,      /* topleft row,col, and botleft row,col */
          { 33,   86, 3,429, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x31\xe0\xe0\x33\xe0\xe0\x14\xf1\xe0\xe0\x13"
            "\x10\xe0\xe4\x10\xf1\xe0\xe3\x20\xe0\xd4\x20\xf1\xe0"
            "\xd3\x30\xe0\xc4\xe0\xe0\x13\xe0\xe0\x14\x40\xf1\xe0"
            "\xb3\x50\xe0\xa4\x50\xf1\xe0\xa3\x60\xe0\x94\x60\xf1"
            "\xe0\x93\x70\xe0\x84\x70\xf1\xe0\x83\x80\xe0\x74\xe0"
            "\xe0\x13\xe0\xe0\x14\x90\xf1\xe0\x63\xa0\xe0\x54\xa0"
            "\xf1\xe0\x53\xb0\xe0\x44\xb0\xf1\xe0\x43\xc0\xe0\x34"
            "\xe0\xe0\x13\xe0\xe0\x14\xd0\xf1\xe0\x23\xe0\xe0\x14"
            "\xe0\xf1\xe0\x13\xe0\x10\xe4\xe0\x10\xf1\xe3\xe0\x20"
            "\xd4\xe0\xe0\x13\xe0\xe0\x14\xe0\x30\xf1\xc3\xe0\x40"
            "\xb4\xe0\x40\xf1\xb3\xe0\x50\xa4\xe0\x50\xf1\xa3\xe0"
            "\x60\x94\xe0\xe0\x13\xe0\xe0\x14\xe0\x70\xf1\x83\xe0"
            "\x80\x74\xe0\x80\xf1\x73\xe0\x90\x64\xe0\x90\xf1\x63"
            "\xe0\xa0\x54\xe0\xa0\xf1\x53\xe0\xb0\x44\xe0\xe0\x13"
            "\xe0\xe0\x14\xe0\xc0\xf1\x33\xe0\xd0\x24\xe0\xd0\xf1"
            "\x23\xe0\xe0\x14\xe0\xe0\xf1\x13\xe0\xe0\x14\xe0\xe0"
            "\x13\xe0\xe0\x31\xe0\xe0\x30" }  },
      /* --- pixel bitmap for cmex210 char#45 \ --- */
      {  45,67963,                      /* character number, location */
          1, 2,  -85, 2,      /* topleft row,col, and botleft row,col */
          { 33,   86, 3,433, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x11\xe0\xe0\x33\xe0\xe0\x24\xe0\xe0\x10\xf1\x13\xe0"
            "\xe0\x10\x14\xe0\xe0\xf1\x23\xe0\xe0\x24\xe0\xd0\xf1"
            "\x33\xe0\xd0\x34\xe0\xe0\x23\xe0\xe0\x24\xe0\xb0\xf1"
            "\x53\xe0\xb0\x54\xe0\xa0\xf1\x63\xe0\xa0\x64\xe0\x90"
            "\xf1\x73\xe0\x90\x74\xe0\x80\xf1\x83\xe0\x80\x84\xe0"
            "\xe0\x23\xe0\xe0\x24\xe0\x60\xf1\xa3\xe0\x60\xa4\xe0"
            "\x50\xf1\xb3\xe0\x50\xb4\xe0\x40\xf1\xc3\xe0\x40\xc4"
            "\xe0\xe0\x23\xe0\xe0\x24\xe0\x20\xf1\xe3\xe0\x20\xe4"
            "\xe0\x10\xf1\xe0\x13\xe0\x10\xe0\x14\xe0\xf1\xe0\x23"
            "\xe0\xe0\x24\xe0\xe0\x23\xe0\xe0\x24\xc0\xf1\xe0\x43"
            "\xc0\xe0\x44\xb0\xf1\xe0\x53\xb0\xe0\x54\xa0\xf1\xe0"
            "\x63\xa0\xe0\x64\xe0\xe0\x23\xe0\xe0\x24\x80\xf1\xe0"
            "\x83\x80\xe0\x84\x70\xf1\xe0\x93\x70\xe0\x94\x60\xf1"
            "\xe0\xa3\x60\xe0\xa4\x50\xf1\xe0\xb3\x50\xe0\xb4\xe0"
            "\xe0\x23\xe0\xe0\x24\x30\xf1\xe0\xd3\x30\xe0\xd4\x20"
            "\xf1\xe0\xe3\x20\xe0\xe4\x10\xf1\xe0\xe0\x13\x10\xe0"
            "\xe0\x14\xe0\xe0\x23\xe0\xe0\x31\x10" }  },
      /* --- pixel bitmap for cmex210 char#46 / --- */
      {  46,62837,                      /* character number, location */
          1, 2,  -50, 2,      /* topleft row,col, and botleft row,col */
          { 20,   51, 3,187, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x42\xe0\x33\xf1\xe0\x32\x10\xe0\x23\xe0\x32"
            "\xe0\x33\x20\xf1\xe0\x12\x30\xe3\x30\xf1\xe2\x40\xd3"
            "\xe0\x32\xe0\x33\x50\xf1\xc2\x60\xb3\x60\xf1\xb2\x70"
            "\xa3\x70\xf1\xa2\x80\x93\xe0\x32\xe0\x33\x90\xf1\x82"
            "\xa0\x73\xa0\xf1\x72\xb0\x63\xb0\xf1\x62\xc0\x53\xe0"
            "\x32\xe0\x33\xd0\xf1\x42\xe0\x33\xe0\xf1\x32\xe0\x10"
            "\x23\xe0\x32\xe0\x33\xe0\x20\xf1\x12\xe0\x33\xe0\x3f"
            "\x12\xe0\x40" }  },
      /* --- pixel bitmap for cmex210 char#47 \ --- */
      {  47,66095,                      /* character number, location */
          1, 2,  -50, 2,      /* topleft row,col, and botleft row,col */
          { 20,   51, 3,190, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x43\xe0\x30\xf1\x12\xe0\x30\x13\xe0\x42"
            "\xe0\x43\xe0\x10\xf1\x32\xe0\x10\x33\xe0\xf1\x42\xe0"
            "\x43\xe0\x42\xe0\x43\xc0\xf1\x62\xc0\x63\xb0\xf1\x72"
            "\xb0\x73\xa0\xf1\x82\xa0\x83\xe0\x42\xe0\x43\x80\xf1"
            "\xa2\x80\xa3\x70\xf1\xb2\x70\xb3\x60\xf1\xc2\x60\xc3"
            "\xe0\x42\xe0\x43\x40\xf1\xe2\x40\xe3\x30\xf1\xe0\x12"
            "\x30\xe0\x13\xe0\x42\xe0\x43\x10\xf1\xe0\x32\x10\xe0"
            "\x33\xf1\xe0\x42" }  },
      /* --- pixel bitmap for cmex210 char#48 \leftparentop --- */
      {  48, 4160,                      /* character number, location */
          0, 8,  -52, 8,      /* topleft row,col, and botleft row,col */
          { 16,   52, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe2\xd2\xd3\xd2\xd2\xd3\xd2\x40\xf1\x92\x50\xf1\x82"
            "\x60\x73\xd2\xd3\xd2\x80\xf1\x53\x80\x52\x90\xf1\x43"
            "\x90\x42\xa0\xf2\x33\xa0\x32\xb0\xf3\x23\xb0\x22\xc0"
            "\xf6\x13\xc0\x12\xdf\xd3\xd3" }  },
      /* --- pixel bitmap for cmex210 char#49 \rightparentop --- */
      {  49,10019,                      /* character number, location */
          0, 1,  -52, 1,      /* topleft row,col, and botleft row,col */
          { 16,   52, 3,96, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x12\xe3\xe2\xe0\x12\xe3\xe2\xa0\xf1\x52\x90"
            "\xf1\x62\x80\x63\xe2\xe3\xe2\x60\xf1\x83\x50\x92\x50"
            "\xf1\x93\x40\xa2\x40\xf2\xa3\x30\xb2\x30\xf3\xb3\x20"
            "\xc2\x20\xf6\xc3\x10\xd2\x10\xfd\xd3" }  },
      /* --- pixel bitmap for cmex210 char#50 (noname) --- */
      {  50,16191,                      /* character number, location */
          0, 9,  -51, 9,      /* topleft row,col, and botleft row,col */
          { 10,   51, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0a\x00\xff\x30\x02\x08" }  },
      /* --- pixel bitmap for cmex210 char#51 (noname) --- */
      {  51,22143,                      /* character number, location */
          0, 0,  -51, 0,      /* topleft row,col, and botleft row,col */
          { 10,   51, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0a\xff\x30\x08\x02" }  },
      /* --- pixel bitmap for cmex210 char#52 (noname) --- */
      {  52,17081,                      /* character number, location */
          1, 9,  -50, 9,      /* topleft row,col, and botleft row,col */
          { 10,   51, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x30\x00\x02\x08\xff\x01\x0a" }  },
      /* --- pixel bitmap for cmex210 char#53 (noname) --- */
      {  53,23020,                      /* character number, location */
          1, 0,  -50, 0,      /* topleft row,col, and botleft row,col */
          { 10,   51, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x30\x08\x02\x00\xff\x01\x0a" }  },
      /* --- pixel bitmap for cmex210 char#54 (noname) --- */
      {  54,17868,                      /* character number, location */
          1, 9,  -18, 9,      /* topleft row,col, and botleft row,col */
          {  2,   19, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x32" }  },
      /* --- pixel bitmap for cmex210 char#55 (noname) --- */
      {  55,23794,                      /* character number, location */
          1, 8,  -18, 8,      /* topleft row,col, and botleft row,col */
          {  2,   19, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x32" }  },
      /* --- pixel bitmap for cmex210 char#56 \leftbracetop --- */
      {  56,43487,                      /* character number, location */
         -1,11,  -27,11,      /* topleft row,col, and botleft row,col */
          { 11,   26, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x74\x55\x54\x64\x73\x74\x50\xf1\x14\x6f\xe4\x7f"
            "\x14\x73" }  },
      /* --- pixel bitmap for cmex210 char#57 \rightbracetop --- */
      {  57,51322,                      /* character number, location */
         -1, 4,  -27, 4,      /* topleft row,col, and botleft row,col */
          { 11,   26, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x84\x85\x84\x84\x83\x84\x20\xf1\x64\x10\xfe\x74"
            "\xf1\x74" }  },
      /* --- pixel bitmap for cmex210 char#58 \leftbracebot --- */
      {  58,44388,                      /* character number, location */
          1,11,  -25,11,      /* topleft row,col, and botleft row,col */
          { 11,   26, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x04\x7f\x14\x70\xf1\x14\x60\x24\x83\x84\x84\x85"
            "\x84\x83" }  },
      /* --- pixel bitmap for cmex210 char#59 \rightbracebot --- */
      {  59,52224,                      /* character number, location */
          1, 4,  -25, 4,      /* topleft row,col, and botleft row,col */
          { 11,   26, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x74\xf1\x74\xf1\x64\x10\x54\x73\x74\x64\x55\x54"
            "\x73\x84" }  },
      /* --- pixel bitmap for cmex210 char#60 \leftbracemid --- */
      {  60,45364,                      /* character number, location */
          1, 4,  -53, 4,      /* topleft row,col, and botleft row,col */
          { 11,   54, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x74\xf1\x74\xf2\x64\x10\x54\x73\x74\x64\x73\x64"
            "\x6f\x13\x80\x14\x93\x84\x84\x83\x84\x20\xf2\x64\x10"
            "\xfe\x74\xf1\x74" }  },
      /* --- pixel bitmap for cmex210 char#61 \rightbracemid --- */
      {  61,53201,                      /* character number, location */
          1,11,  -53,11,      /* topleft row,col, and botleft row,col */
          { 11,   54, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x04\x7f\x14\x70\xf2\x14\x60\x24\x83\x84\x84\x83"
            "\x94\x10\xf1\x83\x64\x63\x74\x64\x73\x74\x50\xf2\x14"
            "\x6f\xe4\x7f\x14\x73" }  },
      /* --- pixel bitmap for cmex210 char#62 \leftbracebar --- */
      {  62,46260,                      /* character number, location */
          1,11,  -10,11,      /* topleft row,col, and botleft row,col */
          {  4,   11, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x04" }  },
      /* --- pixel bitmap for cmex210 char#63 (noname) --- */
      {  63,71841,                      /* character number, location */
          1, 9,  -18, 9,      /* topleft row,col, and botleft row,col */
          {  2,   19, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x32" }  },
      /* --- pixel bitmap for cmex210 char#64 \leftparenbot --- */
      {  64, 5066,                      /* character number, location */
          2, 8,  -50, 8,      /* topleft row,col, and botleft row,col */
          { 16,   52, 3,96, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x03\xd0\x12\xd0\xf6\x13\xc0\x22\xc0\xf3\x23\xb0"
            "\x32\xb0\xf2\x33\xa0\x42\xa0\xf1\x43\x90\x52\x90\xf1"
            "\x53\x80\x62\xe3\xe2\xe3\x60\xf1\x82\x60\xf1\x92\x50"
            "\xa2\xe3\xe2\xe0\x12\xe3\xe2\xe0\x12" }  },
      /* --- pixel bitmap for cmex210 char#65 \rightparenbot --- */
      {  65,10912,                      /* character number, location */
          2, 1,  -50, 1,      /* topleft row,col, and botleft row,col */
          { 16,   52, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\xd3\xd2\x10\xf6\xc3\x10\xc2\x20\xf3\xb3\x20\xb2"
            "\x30\xf2\xa3\x30\xa2\x40\xf1\x93\x40\x92\x50\xf1\x83"
            "\x50\x82\xd3\xd2\xd3\x70\xf1\x62\x80\xf1\x52\x90\x42"
            "\xd3\xd2\xd2\xd3\xd2\xd2\xe0" }  },
      /* --- pixel bitmap for cmex210 char#66 \leftparenbar --- */
      {  66, 5966,                      /* character number, location */
          1, 8,  -18, 8,      /* topleft row,col, and botleft row,col */
          {  3,   19, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x03\x0f\x33" }  },
      /* --- pixel bitmap for cmex210 char#67 \rightparenbar --- */
      {  67,11799,                      /* character number, location */
          1,14,  -18,14,      /* topleft row,col, and botleft row,col */
          {  3,   19, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x03\x0f\x33" }  },
      /* --- pixel bitmap for cmex210 char#68 \Big< --- */
      {  68,56853,                      /* character number, location */
          1, 4,  -51, 4,      /* topleft row,col, and botleft row,col */
          { 11,   52, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x30\xc0\x01\x06\x30\xc0\x01\x06\x38\xc0\x00"
            "\x06\x38\xc0\x00\x06\x38\xc0\x00\x06\x38\xc0\x00\x06"
            "\x38\xc0\x00\x07\x18\xc0\x00\x07\x18\xc0\x00\x0e\x60"
            "\x00\x03\x38\x80\x01\x1c\xc0\x00\x06\x70\x00\x03\x18"
            "\xc0\x01\x0c\x60\x00\x07\x30\x80\x01\x1c\xc0\x00\x0e"
            "\x60\x00\x03\x38\x80\x01\x0c" }  },
      /* --- pixel bitmap for cmex210 char#69 \Big> --- */
      {  69,59835,                      /* character number, location */
          1, 3,  -51, 3,      /* topleft row,col, and botleft row,col */
          { 11,   52, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x18\xc0\x01\x0c\x60\x00\x07\x30\x80\x03\x18\xc0"
            "\x00\x0e\x60\x00\x03\x38\x80\x01\x0c\xe0\x00\x06\x30"
            "\x80\x03\x18\xc0\x01\x0c\x60\x00\x07\x30\x80\x01\x0e"
            "\x30\x80\x01\x0e\x30\xc0\x01\x06\x30\xc0\x01\x06\x30"
            "\xc0\x01\x06\x30\xc0\x01\x06\x30\xc0\x01\x06\x38\xc0"
            "\x00\x06\x38\xc0\x00\x06\x00" }  },
      /* --- pixel bitmap for cmex210 char#70 \bigsqcup --- */
      {  70,82858,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1a\x00\x02\x10\x02\x00\xff\x01\x14" }  },
      /* --- pixel bitmap for cmex210 char#71 \Bigsqcup --- */
      {  71,83827,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x26\x00\x02\x18\x02\x00\xff\x01\x1c" }  },
      /* --- pixel bitmap for cmex210 char#72 \oint --- */
      {  72,103449,                     /* character number, location */
          0, 2,  -32, 2,      /* topleft row,col, and botleft row,col */
          { 16,   32, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb4\xb1\x32\xf1\x92\x32\xf5\x82\x60\x64\xa8\x73\x12"
            "\x13\x53\x22\x23\x20\xf3\x22\x32\x32\x20\x23\x22\x23"
            "\x53\x12\x13\x78\xa4\x60\xf5\x62\x8f\x12\x32\x92\x31"
            "\xb4\xb3" }  },
      /* --- pixel bitmap for cmex210 char#73 \Bigoint --- */
      {  73,104543,                     /* character number, location */
          0, 2,  -65, 2,      /* topleft row,col, and botleft row,col */
          { 25,   65, 3,245, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x72\xe0\x81\x21\xe0\x62\x22\xe0\x42\x23\xe0\x42"
            "\x31\x10\xf2\xe0\x32\x60\xe0\x23\x60\xf2\xe0\x22\x70"
            "\xf1\xe0\x13\x70\xf1\xe0\x12\x80\xf2\xe3\x80\xf1\xe2"
            "\x90\xf2\xd3\x90\x97\xe0\x2b\xd3\x33\x13\xb3\x43\x23"
            "\xa2\x53\x32\x93\x53\x33\x40\xf4\x42\x53\x52\x40\x43"
            "\x33\x53\x92\x33\x52\xa3\x23\x43\xb3\x13\x33\xdb\xe0"
            "\x27\x90\xf2\x93\xd0\xf1\x92\xe0\xf2\x83\xe0\xf1\x82"
            "\xe0\x10\xf1\x73\xe0\x10\xf2\x72\xe0\x20\x63\xe0\x20"
            "\xf2\x62\xe0\x30\x11\x32\xe0\x43\x22\xe0\x42\x22\xe0"
            "\x61\x21\xe0\x82\xe0\x76" }  },
      /* --- pixel bitmap for cmex210 char#74 \bigodot --- */
      {  74,84899,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 28,   29, 3,133, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xa8\xe0\x4c\xe4\x84\xb3\xc3\x93\xe3\x73\xe0\x23\x53"
            "\xe0\x43\x42\xe0\x62\x33\xe0\x63\x22\xe0\x82\x13\xe0"
            "\x83\x0f\x12\xe0\xa2\x0f\x22\xa4\xa2\x0f\x12\xe0\xa2"
            "\x03\xe0\x83\x12\xe0\x82\x23\xe0\x63\x32\xe0\x62\x43"
            "\xe0\x43\x53\xe0\x23\x73\xe3\x93\xc3\xb4\x84\xec\xe0"
            "\x48\xa2" }  },
      /* --- pixel bitmap for cmex210 char#75 \Bigodot --- */
      {  75,86110,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 40,   41, 3,249, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x28\xe0\xe0\x1e\xe0\xa5\x85\xe0\x64\xe4\xe0\x24"
            "\xe0\x44\xd3\xe0\x83\xb3\xe0\xa3\x93\xe0\xc3\x82\xe0"
            "\xe2\x73\xe0\xe3\x53\xe0\xe0\x23\x42\xe0\xe0\x42\x33"
            "\xe0\xe0\x43\x10\xf2\x12\xe0\xe0\x62\x13\xe0\xe0\x65"
            "\xe0\xe0\x84\xe0\x32\xe0\x32\x0f\x22\xe0\x24\xe0\x22"
            "\x02\xe0\x32\xe0\x34\xe0\xe0\x85\xe0\xe0\x63\xf2\x12"
            "\xe0\xe0\x62\x10\x13\xe0\xe0\x43\x32\xe0\xe0\x42\x43"
            "\xe0\xe0\x23\x53\xe0\xe3\x72\xe0\xe2\x83\xe0\xc3\x93"
            "\xe0\xa3\xb3\xe0\x83\xd4\xe0\x44\xe0\x24\xe4\xe0\x65"
            "\x85\xe0\xae\xe0\xe0\x18\xe0\x20" }  },
      /* --- pixel bitmap for cmex210 char#76 \bigoplus --- */
      {  76,87189,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 28,   29, 3,143, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xa8\xe0\x4c\xe4\x32\x34\xb3\x52\x53\x93\x62\x63\x73"
            "\x72\x73\x53\x82\x83\x42\x92\x92\x33\x92\x93\x22\xa2"
            "\xa2\x13\xa2\xa3\x0f\x12\xb2\xb2\x0f\x1e\x0e\x0f\x22"
            "\xb2\xb2\x03\xa2\xa3\x12\xa2\xa2\x23\x92\x93\x32\x92"
            "\x92\x43\x82\x83\x53\x72\x73\x73\x62\x63\x93\x52\x53"
            "\xb4\x32\x34\xec\xe0\x48\xa0" }  },
      /* --- pixel bitmap for cmex210 char#77 \Bigoplus --- */
      {  77,88437,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 40,   41, 3,261, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x28\xe0\xe0\x1e\xe0\xa5\x32\x35\xe0\x64\x62\x64"
            "\xe0\x24\x82\x84\xd3\xa2\xa3\xb3\xb2\xb3\x93\xc2\xc3"
            "\x82\xd2\xd2\x73\xd2\xd3\x53\xe2\xe3\x42\xe0\x12\xe0"
            "\x12\x33\xe0\x12\xe0\x13\x10\xf2\x12\xe0\x22\xe0\x22"
            "\x13\xe0\x22\xe0\x23\x0f\x12\xe0\x32\xe0\x32\x0f\x1e"
            "\x0e\x0c\x0f\x22\xe0\x32\xe0\x32\x03\xe0\x22\xe0\x23"
            "\xf2\x12\xe0\x22\xe0\x22\x10\x13\xe0\x12\xe0\x13\x32"
            "\xe0\x12\xe0\x12\x43\xe2\xe3\x53\xd2\xd3\x72\xd2\xd2"
            "\x83\xc2\xc3\x93\xb2\xb3\xb3\xa2\xa3\xd4\x82\x84\xe0"
            "\x24\x62\x64\xe0\x65\x32\x35\xe0\xae\xe0\xe0\x18\xe0"
            "\x25" }  },
      /* --- pixel bitmap for cmex210 char#78 \bigotimes --- */
      {  78,89573,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 28,   29, 3,147, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xa8\xe0\x4c\xe4\x84\xb3\xc3\x93\xe3\x74\xe4\x56\xc6"
            "\x42\x23\xa3\x22\x33\x33\x83\x33\x22\x53\x63\x52\x13"
            "\x63\x43\x65\x83\x23\x84\x96\x94\xa4\xa4\xb2\xb4\xa4"
            "\xa4\x96\x94\x83\x23\x85\x63\x43\x63\x12\x53\x63\x52"
            "\x23\x33\x83\x33\x32\x23\xa3\x22\x46\xc6\x54\xe4\x73"
            "\xe3\x93\xc3\xb4\x84\xec\xe0\x48\xa3" }  },
      /* --- pixel bitmap for cmex210 char#79 \Bigotimes --- */
      {  79,90830,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 40,   41, 3,303, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x28\xe0\xe0\x1e\xe0\xa5\x85\xe0\x64\xe4\xe0\x24"
            "\xe0\x44\xd3\xe0\x83\xb3\xe0\xa3\x95\xe0\x85\x82\x13"
            "\xe0\x63\x12\x73\x23\xe0\x43\x23\x53\x43\xe0\x23\x43"
            "\x42\x63\xe3\x62\x33\x73\xc3\x73\x22\x93\xa3\x92\x22"
            "\xa3\x83\xa2\x22\xb3\x63\xb2\x13\xc3\x43\xc5\xe3\x23"
            "\xe4\xe0\x16\xe0\x14\xe0\x24\xe0\x24\xe0\x32\xe0\x34"
            "\xe0\x24\xe0\x24\xe0\x16\xe0\x14\xe3\x23\xe5\xc3\x43"
            "\xc3\x12\xb3\x63\xb2\x22\xa3\x83\xa2\x22\x93\xa3\x92"
            "\x23\x73\xc3\x73\x32\x63\xe3\x62\x43\x43\xe0\x23\x43"
            "\x53\x23\xe0\x43\x23\x72\x13\xe0\x63\x12\x85\xe0\x85"
            "\x93\xe0\xa3\xb3\xe0\x83\xd4\xe0\x44\xe0\x24\xe4\xe0"
            "\x65\x85\xe0\xae\xe0\xe0\x18\xe0\x20" }  },
      /* --- pixel bitmap for cmex210 char#80 \sum --- */
      {  80,92324,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 27,   29, 3,143, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x0e\x0a\x3e\x0b\x32\xe0\x26\x42\xe0\x43\x43\xe0\x43"
            "\x42\xe0\x61\x52\xe0\x51\x62\xe0\x51\x53\xe0\xb2\xe0"
            "\xc2\xe0\xc2\xe0\xc2\xe0\xb3\xe0\xb2\xe0\xa3\xe0\xa2"
            "\xe0\xa2\xe0\x30\xf1\x72\xe0\x40\x62\xe0\xa2\xe0\x51"
            "\x43\xe0\x41\x52\xe0\x51\x42\xe0\x52\x32\xe0\x43\x33"
            "\xe0\x25\x3e\x0a\x2e\x0a\x34" }  },
      /* --- pixel bitmap for cmex210 char#81 \prod --- */
      {  81,95344,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 23,   29, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x09\x24\xb4\x20\xfe\x33\xb3\x30\xf7\x33\xb3"
            "\x30\x25\x95\x2f\x19\x59" }  },
      /* --- pixel bitmap for cmex210 char#82 \int --- */
      {  82,101318,                     /* character number, location */
          0, 2,  -32, 2,      /* topleft row,col, and botleft row,col */
          { 16,   32, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb4\xb1\x32\xf1\x92\x32\xf6\x82\x60\xf9\x72\x70\xf6"
            "\x62\x8f\x12\x32\x92\x31\xb4\xb0" }  },
      /* --- pixel bitmap for cmex210 char#83 \bigcup --- */
      {  83,105473,                     /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\xe0\x22\x0f\x52\xe0\x22\x03\xe3\x12\xe2\x23"
            "\xc3\x32\xc2\x43\xa3\x54\x64\x8a\xc6\x72" }  },
      /* --- pixel bitmap for cmex210 char#84 \bigcap --- */
      {  84,107349,                     /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 3,44, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\xca\x84\x64\x53\xa3\x42\xc2\x33\xc3\x22\xe2\x13"
            "\xe3\x0f\xe2\xe0\x22\x0f\x52\xe0\x22" }  },
      /* --- pixel bitmap for cmex210 char#85 \biguplus --- */
      {  85,109290,                     /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x02\xe0\x22\x0f\x42\x72\x72\x02\x2c\x24\x3a\x32"
            "\x0f\x32\x72\x72\x0f\x12\xe0\x22\x03\xe3\x12\xe2\x23"
            "\xc3\x32\xc2\x43\xa3\x54\x64\x8a\xc6\x73" }  },
      /* --- pixel bitmap for cmex210 char#86 \bigwedge --- */
      {  86,111260,                     /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 3,118, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x92\x90\xf2\x84\x80\x76\x70\xf1\x72\x22\x70\x63"
            "\x23\x60\xf1\x62\x42\x60\x53\x43\x50\xf1\x52\x62\x50"
            "\x43\x63\x40\xf1\x42\x82\x40\x33\x83\x30\xf1\x32\xa2"
            "\x30\x23\xa3\x20\xf1\x22\xc2\x20\x13\xc3\x10\xf1\x12"
            "\xe2\x13\xe3\x0f\x12\xe0\x22" }  },
      /* --- pixel bitmap for cmex210 char#87 \bigvee --- */
      {  87,113066,                     /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 3,119, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x22\x03\xe3\xf1\x12\xe2\x10\x13\xc3\x10"
            "\xf1\x22\xc2\x20\x23\xa3\x20\xf1\x32\xa2\x30\x33\x83"
            "\x30\xf1\x42\x82\x40\x43\x63\x40\xf1\x52\x62\x50\x53"
            "\x43\x50\xf1\x62\x42\x60\x63\x23\x60\xf1\x72\x22\x70"
            "\x76\x70\xf2\x84\x80\xf1\x92\x90" }  },
      /* --- pixel bitmap for cmex210 char#88 \Bigsum --- */
      {  88,93839,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 38,   41, 2,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x00\x22\x04\x23\x04\x05\x15\x08\x04\x05\x19\x05\x04"
            "\x05\x1a\x03\x05\x05\x1a\x02\x06\x04\x1b\x02\x05\x05"
            "\x1b\x01\x06\x05\x1b\x01\x06\x05\x22\x04\x22\x05\x22"
            "\x05\x22\x05\x22\x04\x22\x05\x22\x05\x22\x05\x22\x04"
            "\x22\x05\x22\x05\x22\x03\x22\x03\x23\x02\x23\x03\x22"
            "\x03\x22\x03\x22\x03\x23\x02\x23\x03\x22\x03\x22\x03"
            "\x1b\x01\x06\x03\x1b\x01\x07\x02\x1b\x02\x06\x03\x1a"
            "\x03\x05\x03\x1a\x03\x05\x03\x19\x05\x04\x03\x17\x07"
            "\x05\x21\x04\x22\x03\x22\x04" }  },
      /* --- pixel bitmap for cmex210 char#89 \Bigprod --- */
      {  89,97010,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 33,   41, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0e\x05\x36\xe0\x16\x30\xfe\x54\xe0\x14\x50"
            "\xfe\x54\xe0\x14\x50\xf4\x54\xe0\x14\x50\x38\xb8\x3f"
            "\x1e\x5e" }  },
      /* --- pixel bitmap for cmex210 char#90 \Bigint --- */
      {  90,102372,                     /* character number, location */
          0, 2,  -65, 2,      /* topleft row,col, and botleft row,col */
          { 25,   65, 3,189, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x72\xe0\x81\x21\xe0\x62\x22\xe0\x42\x23\xe0\x42"
            "\x31\x10\xf2\xe0\x32\x60\xe0\x23\x60\xf2\xe0\x22\x70"
            "\xf1\xe0\x13\x70\xf1\xe0\x12\x80\xf2\xe3\x80\xf1\xe2"
            "\x90\xf3\xd3\x90\xf4\xc3\xa0\xf4\xb3\xb0\xf4\xa3\xc0"
            "\xf3\x93\xd0\xf1\x92\xe0\xf2\x83\xe0\xf1\x82\xe0\x10"
            "\xf1\x73\xe0\x10\xf2\x72\xe0\x20\x63\xe0\x20\xf2\x62"
            "\xe0\x30\x11\x32\xe0\x43\x22\xe0\x42\x22\xe0\x61\x21"
            "\xe0\x82\xe0\x70" }  },
      /* --- pixel bitmap for cmex210 char#91 \Bigcup --- */
      {  91,106450,                     /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\xe0\xa2\x0f\xe2\xe0\xa2\x03\xe0\x83\xf1\x12"
            "\xe0\x82\x10\x13\xe0\x63\x33\xe0\x43\x53\xe0\x23\x73"
            "\xe3\x93\xc3\xb4\x84\xec\xe0\x48\xa2" }  },
      /* --- pixel bitmap for cmex210 char#92 \Bigcap --- */
      {  92,108333,                     /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 3,68, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa8\xe0\x4c\xe4\x84\xb3\xc3\x93\xe3\x73\xe0\x23\x53"
            "\xe0\x43\x33\xe0\x63\x10\xf1\x12\xe0\x82\x13\xe0\x83"
            "\x0f\xe2\xe0\xa2\x0f\xe2\xe0\xa2" }  },
      /* --- pixel bitmap for cmex210 char#93 \Biguplus --- */
      {  93,110354,                     /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 3,95, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x02\xe0\xa2\x0f\x72\xb2\xb2\x02\x3e\x04\x34\x2e"
            "\x06\x22\x0f\x82\xb2\xb2\x02\xe0\xa5\xe0\x83\xf1\x12"
            "\xe0\x82\x10\x13\xe0\x63\x33\xe0\x43\x53\xe0\x23\x73"
            "\xe3\x93\xc3\xb4\x84\xec\xe0\x48\xa3" }  },
      /* --- pixel bitmap for cmex210 char#94 \Bigwedge --- */
      {  94,112205,                     /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 3,190, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xd2\xd0\xf2\xc4\xc0\xb6\xb0\xf1\xb2\x22\xb0\xa3"
            "\x23\xa0\xf1\xa2\x42\xa0\x93\x43\x90\xf1\x92\x62\x90"
            "\x83\x63\x80\xf1\x82\x82\x80\x73\x83\x70\xf1\x72\xa2"
            "\x70\x63\xa3\x60\xf1\x62\xc2\x60\x53\xc3\x50\xf1\x52"
            "\xe2\x50\x43\xe3\x40\xf1\x42\xe0\x22\x40\x33\xe0\x23"
            "\x30\xf1\x32\xe0\x42\x30\x23\xe0\x43\x20\xf1\x22\xe0"
            "\x62\x20\x13\xe0\x63\x10\xf1\x12\xe0\x82\x13\xe0\x83"
            "\x0f\x12\xe0\xa2" }  },
      /* --- pixel bitmap for cmex210 char#95 \Bigvee --- */
      {  95,114012,                     /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 3,191, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\xa2\x03\xe0\x83\xf1\x12\xe0\x82\x10\x13"
            "\xe0\x63\x10\xf1\x22\xe0\x62\x20\x23\xe0\x43\x20\xf1"
            "\x32\xe0\x42\x30\x33\xe0\x23\x30\xf1\x42\xe0\x22\x40"
            "\x43\xe3\x40\xf1\x52\xe2\x50\x53\xc3\x50\xf1\x62\xc2"
            "\x60\x63\xa3\x60\xf1\x72\xa2\x70\x73\x83\x70\xf1\x82"
            "\x82\x80\x83\x63\x80\xf1\x92\x62\x90\x93\x43\x90\xf1"
            "\xa2\x42\xa0\xa3\x23\xa0\xf1\xb2\x22\xb0\xb6\xb0\xf2"
            "\xc4\xc0\xf1\xd2\xd0" }  },
      /* --- pixel bitmap for cmex210 char#96 \coprod --- */
      {  96,98567,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 23,   29, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x09\x59\x25\x95\x20\xfe\x33\xb3\x30\xf7\x33\xb3"
            "\x30\x24\xb4\x2f\x1e\x09" }  },
      /* --- pixel bitmap for cmex210 char#97 \Bigcoprod --- */
      {  97,100235,                     /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 33,   41, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x5e\x38\xb8\x30\xfe\x54\xe0\x14\x50\xfe\x54"
            "\xe0\x14\x50\xf4\x54\xe0\x14\x50\x36\xe0\x16\x3f\x1e"
            "\x0e\x05" }  },
      /* --- pixel bitmap for cmex210 char#98 ^ --- */
      {  98,114835,                     /* character number, location */
         22, 0,   17, 0,      /* topleft row,col, and botleft row,col */
          { 16,    5, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\xc6\x83\x43\x52\x82\x22\xc2" }  },
      /* --- pixel bitmap for cmex210 char#99 ^ --- */
      {  99,115712,                     /* character number, location */
         23, 0,   17, 0,      /* topleft row,col, and botleft row,col */
          { 29,    6, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd3\xe0\x99\xe0\x34\x74\xb4\xd4\x54\xe0\x54\x11\xe0"
            "\xd1" }  },
      /* --- pixel bitmap for cmex210 char#100 ^ --- */
      { 100,116802,                     /* character number, location */
         23, 0,   17, 0,      /* topleft row,col, and botleft row,col */
          { 42,    6, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x54\xe0\xe0\x6c\xe0\xb7\x87\xe0\x26\xe0\x46\x85"
            "\xe0\xe5\x22\xe0\xe0\xa2" }  },
      /* --- pixel bitmap for cmex210 char#101 ~ --- */
      { 101,117521,                     /* character number, location */
         21, 0,   18, 0,      /* topleft row,col, and botleft row,col */
          { 16,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x80\xfe\x7f\x01\x3f" }  },
      /* --- pixel bitmap for cmex210 char#102 ~ --- */
      { 102,118439,                     /* character number, location */
         22, 0,   18, 0,      /* topleft row,col, and botleft row,col */
          { 29,    4, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xe2\x3d\x93\x23\x9d\x32\xe7\x60" }  },
      /* --- pixel bitmap for cmex210 char#103 ~ --- */
      { 103,119572,                     /* character number, location */
         22, 0,   18, 0,      /* topleft row,col, and botleft row,col */
          { 42,    4, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9a\xe0\x72\x56\x47\xe0\x13\x43\xe0\x17\x46\x52\xe0"
            "\x7a\x95" }  },
      /* --- pixel bitmap for cmex210 char#104 \Big[ --- */
      { 104,13393,                      /* character number, location */
          1, 6,  -50, 6,      /* topleft row,col, and botleft row,col */
          {  8,   51, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x08\x0f\xe2\x6f\xe2\x6f\xe2\x6f\x12\x6f\x18" }  },
      /* --- pixel bitmap for cmex210 char#105 \Big] --- */
      { 105,19410,                      /* character number, location */
          1, 0,  -50, 0,      /* topleft row,col, and botleft row,col */
          {  8,   51, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x08\xfe\x62\xfe\x62\xfe\x62\xf1\x62\x0f\x18" }  },
      /* --- pixel bitmap for cmex210 char#106 (noname) --- */
      { 106,25452,                      /* character number, location */
          1, 6,  -50, 6,      /* topleft row,col, and botleft row,col */
          {  9,   51, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x30\x00\x02\x07\xff\x01\x09" }  },
      /* --- pixel bitmap for cmex210 char#107 (noname) --- */
      { 107,29116,                      /* character number, location */
          1, 0,  -50, 0,      /* topleft row,col, and botleft row,col */
          {  9,   51, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x30\x07\x02\x00\xff\x01\x09" }  },
      /* --- pixel bitmap for cmex210 char#108 (noname) --- */
      { 108,32758,                      /* character number, location */
          1, 6,  -50, 6,      /* topleft row,col, and botleft row,col */
          {  9,   51, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x09\x00\xff\x30\x02\x07" }  },
      /* --- pixel bitmap for cmex210 char#109 (noname) --- */
      { 109,36430,                      /* character number, location */
          1, 0,  -50, 0,      /* topleft row,col, and botleft row,col */
          {  9,   51, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x09\xff\x30\x07\x02" }  },
      /* --- pixel bitmap for cmex210 char#110 \Big{ --- */
      { 110,40318,                      /* character number, location */
          1, 3,  -50, 3,      /* topleft row,col, and botleft row,col */
          { 13,   51, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa3\x85\x74\x83\xa2\x50\xfe\x52\x60\x52\x60\xf1\x42"
            "\x70\x23\x93\x92\xc3\xb3\x80\xf1\x42\x70\xfe\x52\x60"
            "\x52\xc2\xb3\xb4\xa5\xa3" }  },
      /* --- pixel bitmap for cmex210 char#111 \Big} --- */
      { 111,48150,                      /* character number, location */
          1, 3,  -50, 3,      /* topleft row,col, and botleft row,col */
          { 13,   51, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xa4\xb3\xb3\xb3\x60\xfe\x52\x60\x52\xc2\xb3\xb3"
            "\xc4\xa3\x94\x73\x93\xa2\x50\xfe\x52\x60\x52\xa3\x93"
            "\x93\x84\x93\xa4" }  },
      /* --- pixel bitmap for cmex210 char#112 (noname) --- */
      { 112,75930,                      /* character number, location */
          2, 3,  -34, 3,      /* topleft row,col, and botleft row,col */
          { 28,   36, 3,169, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xc2\xe0\xb3\xe0\xb2\xe0\xb3\xe0\xb2\xe0\xb3\xe0"
            "\xb2\xe0\xb3\xe0\xb2\xe0\xb3\xe0\xb2\xe0\xb3\xe0\xb2"
            "\xe0\xb3\xe0\xb2\xe0\xb3\xe0\xb2\xe0\xb3\xb1\xd2\xa3"
            "\xc3\x92\x12\xb2\xd2\xa3\xd2\xa2\xe0\x12\x83\xe0\x12"
            "\x82\xe0\x32\x63\xe0\x32\x62\xe0\x42\x53\xe0\x52\x42"
            "\xe0\x62\x33\xe0\x72\x22\xe0\x82\x13\xe0\x10\xf1\x84"
            "\xe0\x20\x83\xe0\xc2\xe0\x30" }  },
      /* --- pixel bitmap for cmex210 char#113 (noname) --- */
      { 113,76941,                      /* character number, location */
          2, 3,  -51, 3,      /* topleft row,col, and botleft row,col */
          { 28,   53, 3,243, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\xc2\xe0\xb3\xf1\xe0\xb2\x10\xe0\xa3\x10\xf1"
            "\xe0\xa2\x20\xe0\x93\x20\xf1\xe0\x92\x30\xe0\x83\x30"
            "\xf1\xe0\x82\x40\xe0\x73\x40\xf1\xe0\x72\x50\xe0\x63"
            "\x50\xf1\xe0\x62\x60\xe0\x53\x60\xf1\xe0\x52\x70\xe0"
            "\x43\x70\xf1\xe0\x42\x80\xe0\x33\xb1\xd2\xb2\xd2\xa3"
            "\xc3\x91\x22\xb2\xd2\xb2\xd2\xa3\xd2\xa2\xe0\x12\x92"
            "\xe0\x12\x83\xe0\x12\x82\xe0\x32\x72\xe0\x32\x63\xc0"
            "\xf1\x52\x62\xd0\x62\x43\xd0\xf1\x62\x42\xe0\x72\x23"
            "\xe0\xf1\x72\x22\xe0\x10\x72\x13\xe0\x10\xf2\x84\xe0"
            "\x20\xf1\x92\xe0\x30" }  },
      /* --- pixel bitmap for cmex210 char#114 (noname) --- */
      { 114,78001,                      /* character number, location */
          2, 3,  -69, 3,      /* topleft row,col, and botleft row,col */
          { 28,   71, 3,269, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\xc2\xe0\xb3\xf2\xe0\xb2\x10\xe0\xa3\x10\xf2"
            "\xe0\xa2\x20\xe0\x93\x20\xf2\xe0\x92\x30\xe0\x83\x30"
            "\xf2\xe0\x82\x40\xe0\x73\x40\xf2\xe0\x72\x50\xe0\x63"
            "\x50\xf2\xe0\x62\x60\xe0\x53\x60\xf2\xe0\x52\x70\xe0"
            "\x43\x70\xf2\xe0\x42\x80\xe0\x33\xb1\xd2\xb2\xd2\xa3"
            "\xd2\xa3\xc3\x91\x22\xb2\xa0\xf1\x32\xb2\xa0\x32\xa3"
            "\xd2\xa2\xb0\xf1\x42\x92\xb0\x42\x83\xb0\xf1\x42\x82"
            "\xc0\x52\x72\xe0\x32\x63\xc0\xf1\x52\x62\xd0\x62\x52"
            "\xe0\x52\x43\xd0\xf2\x62\x42\xe0\x72\x23\xe0\xf2\x72"
            "\x22\xe0\x10\x72\x13\xe0\x10\xf3\x84\xe0\x20\x83\xe0"
            "\x30\xf1\x92\xe0\x31" }  },
      /* --- pixel bitmap for cmex210 char#115 (noname) --- */
      { 115,79111,                      /* character number, location */
          2, 3,  -86, 3,      /* topleft row,col, and botleft row,col */
          { 28,   88, 3,281, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\xc2\xe0\xb3\xf3\xe0\xb2\x10\xe0\xa3\x10\xf3"
            "\xe0\xa2\x20\xe0\x93\x20\xf3\xe0\x92\x30\xe0\x83\x30"
            "\xf3\xe0\x82\x40\xe0\x73\x40\xf3\xe0\x72\x50\xe0\x63"
            "\x50\xf3\xe0\x62\x60\xe0\x53\x60\xf3\xe0\x52\x70\xe0"
            "\x43\x70\xf3\xe0\x42\x80\xe0\x33\x80\xf1\x31\xd2\x90"
            "\xf1\x22\xd2\x90\x13\xd2\x94\xc3\x91\x22\xb2\xa0\xf2"
            "\x32\xb2\xa0\x32\xa3\xd2\xa2\xb0\xf2\x42\x92\xb0\x42"
            "\x83\xb0\xf1\x42\x82\xc0\xf1\x52\x72\xc0\x52\x63\xc0"
            "\xf1\x52\x62\xd0\xf1\x62\x52\xd0\x62\x43\xd0\xf2\x62"
            "\x42\xe0\x72\x32\xe0\x72\x23\xe0\xf3\x72\x22\xe0\x10"
            "\x85\xe0\x10\xf4\x84\xe0\x20\xf2\x92\xe0\x30" }  },
      /* --- pixel bitmap for cmex210 char#116 (noname) --- */
      { 116,80309,                      /* character number, location */
          1, 3,  -52, 3,      /* topleft row,col, and botleft row,col */
          { 19,   53, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf6\xe0\x32\x31\xd2\x32\xc2\xf1\x23\xc2\xf1\x11\x22"
            "\xb2\x01\x32\xb2\xf2\x52\xa2\xf2\x62\x92\xf2\x72\x82"
            "\xf2\x82\x72\xf2\x92\x62\xf3\xa2\x52\xf2\xb2\x42\xf2"
            "\xc2\x32\xf2\xd2\x22\xf2\xe2\x12\xf2\xe0\x14\xf2\xe0"
            "\x23\xe0\x32\xe0\x31\x10" }  },
      /* --- pixel bitmap for cmex210 char#117 (noname) --- */
      { 117,81286,                      /* character number, location */
          1,20,  -18,20,      /* topleft row,col, and botleft row,col */
          {  2,   19, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x32" }  },
      /* --- pixel bitmap for cmex210 char#118 (noname) --- */
      { 118,82115,                      /* character number, location */
          2,20,  -17,20,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0d\x0f\xe2\xbf\x12\xb2" }  },
      /* --- pixel bitmap for cmex210 char#119 (noname) --- */
      { 119,74945,                      /* character number, location */
          1, 8,  -18, 8,      /* topleft row,col, and botleft row,col */
          {  8,   19, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x42\x0f\x32\x42" }  },
      /* --- pixel bitmap for cmex210 char#120 (noname) --- */
      { 120,70171,                      /* character number, location */
         -1, 4,  -17, 4,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x94\x68\x24\x12\x17\x22\x23\xfa\x52\x51" }  },
      /* --- pixel bitmap for cmex210 char#121 (noname) --- */
      { 121,71110,                      /* character number, location */
          0, 4,  -16, 4,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x52\x53\x22\x27\x12\x14\x28\x64\x92\x51" }  },
      /* --- pixel bitmap for cmex210 char#122 (noname) --- */
      { 122,53876,                      /* character number, location */
          4,-1,   -6,-1,      /* topleft row,col, and botleft row,col */
          { 15,   10, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\x78\x69\x4b\x37\x75\x94\xb3\xb3\xc2\xd4" }  },
      /* --- pixel bitmap for cmex210 char#123 (noname) --- */
      { 123,54464,                      /* character number, location */
          4,-1,   -6,-1,      /* topleft row,col, and botleft row,col */
          { 15,   10, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xa8\x79\x6b\x97\xb5\xc4\xc3\xd3\xd2" }  },
      /* --- pixel bitmap for cmex210 char#124 (noname) --- */
      { 124,55049,                      /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 15,   10, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xd3\xd3\xc4\xc5\xb7\x9b\x69\x78\xa5" }  },
      /* --- pixel bitmap for cmex210 char#125 (noname) --- */
      { 125,55635,                      /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 15,   10, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\xc3\xb3\xb4\x95\x77\x3b\x49\x68\x75\xa4" }  },
      /* --- pixel bitmap for cmex210 char#126 (noname) --- */
      { 126,72909,                      /* character number, location */
         -1, 2,  -17, 2,      /* topleft row,col, and botleft row,col */
          { 20,   16, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x90\xf1\x84\x80\x72\x22\xd2\x42\xa4\x44\x75\x45"
            "\x44\x12\x42\x14\x13\x32\x42\x34\x52\x42\x51\xf5\x62"
            "\x42\x60" }  },
      /* --- pixel bitmap for cmex210 char#127 (noname) --- */
      { 127,74031,                      /* character number, location */
          0, 2,  -16, 2,      /* topleft row,col, and botleft row,col */
          { 20,   16, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x62\x42\x61\x52\x42\x54\x32\x42\x33\x14\x12\x42"
            "\x14\x45\x45\x74\x44\xa2\x42\xd2\x22\x70\xf1\x84\x80"
            "\x92\x90" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=7 for .250gf ---
 * mf '\mode=preview; mag=magstep(-12.84858895680446863032); input cmex10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmex250 --- */
static	chardef  cmex250[] =
   {
      /* --- pixel bitmap for cmex250 char#0 \big( --- */
      {   0,  661,                      /* character number, location */
          1, 5,  -39, 5,      /* topleft row,col, and botleft row,col */
          {  9,   40, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x71\x71\x71\x72\x71\x72\x71\x72\x71\x60\xf3\x12"
            "\x6f\xb2\x70\xf3\x12\x60\x21\x82\x81\x82\x81\x82\x81"
            "\x91\x91\x91" }  },
      /* --- pixel bitmap for cmex250 char#1 \big) --- */
      {   1, 6866,                      /* character number, location */
          1, 2,  -39, 2,      /* topleft row,col, and botleft row,col */
          {  9,   40, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x91\x91\x91\x82\x81\x82\x81\x82\x81\x20\xf3\x62"
            "\x10\xfb\x72\xf3\x62\x10\x61\x72\x71\x72\x71\x72\x71"
            "\x71\x71\x71\x83" }  },
      /* --- pixel bitmap for cmex250 char#2 \big[ --- */
      {   2,13013,                      /* character number, location */
          1, 7,  -39, 7,      /* topleft row,col, and botleft row,col */
          {  7,   40, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x07\x0f\xe2\x5f\xe2\x5f\x52\x5f\x17" }  },
      /* --- pixel bitmap for cmex250 char#3 \big] --- */
      {   3,19311,                      /* character number, location */
          1, 0,  -39, 0,      /* topleft row,col, and botleft row,col */
          {  7,   40, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x07\xfe\x52\xfe\x52\xf5\x52\x0f\x17" }  },
      /* --- pixel bitmap for cmex250 char#4 (noname) --- */
      {   4,25498,                      /* character number, location */
          1, 7,  -39, 7,      /* topleft row,col, and botleft row,col */
          {  9,   40, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x7f\xe2\x7f\x72\x7f\x19" }  },
      /* --- pixel bitmap for cmex250 char#5 (noname) --- */
      {   5,29317,                      /* character number, location */
          1, 0,  -39, 0,      /* topleft row,col, and botleft row,col */
          {  9,   40, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x72\xfe\x72\xf7\x72\x0f\x19" }  },
      /* --- pixel bitmap for cmex250 char#6 (noname) --- */
      {   6,33112,                      /* character number, location */
          1, 7,  -39, 7,      /* topleft row,col, and botleft row,col */
          {  9,   40, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x09\x0f\xe2\x7f\xe2\x7f\x72\x7e" }  },
      /* --- pixel bitmap for cmex250 char#7 (noname) --- */
      {   7,36939,                      /* character number, location */
          1, 0,  -39, 0,      /* topleft row,col, and botleft row,col */
          {  9,   40, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x09\xfe\x72\xfe\x72\xf7\x72" }  },
      /* --- pixel bitmap for cmex250 char#8 \big{ --- */
      {   8,40835,                      /* character number, location */
          1, 3,  -39, 3,      /* topleft row,col, and botleft row,col */
          { 14,   40, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\x93\x93\xb2\x50\xfc\x62\x60\x52\xa3\x80\xf1\x13"
            "\xa0\x33\xd2\x70\xfc\x62\x60\x72\xc3\xd3\xe2" }  },
      /* --- pixel bitmap for cmex250 char#9 \big} --- */
      {   9,48902,                      /* character number, location */
          1, 3,  -39, 3,      /* topleft row,col, and botleft row,col */
          { 14,   40, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe3\xd3\xc2\x70\xfc\x62\x60\x72\xd3\xd4\xa3\x93"
            "\xa2\x50\xfc\x62\x60\x52\xb3\x93\x92\xc4" }  },
      /* --- pixel bitmap for cmex250 char#10 \big< --- */
      {  10,58164,                      /* character number, location */
          1, 3,  -39, 3,      /* topleft row,col, and botleft row,col */
          { 11,   40, 3,80, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x92\x83\x82\x83\x82\x83\x82\x83\x82\x83\x82\x83"
            "\x82\x83\x82\x83\x82\x83\x8f\x12\x93\x92\x93\x92\x93"
            "\x92\x93\x92\x93\x92\x93\x92\x93\x92\x93\x92\x93\xf1"
            "\x92" }  },
      /* --- pixel bitmap for cmex250 char#11 \big> --- */
      {  11,61259,                      /* character number, location */
          1, 2,  -39, 2,      /* topleft row,col, and botleft row,col */
          { 11,   40, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x02\x93\x92\x93\x92\x93\x92\x93\x92\x93\x92\x93"
            "\x92\x93\x92\x93\x92\x93\xf1\x92\x83\x82\x83\x82\x83"
            "\x82\x83\x82\x83\x82\x83\x82\x83\x82\x83\x82\x83\x8f"
            "\x12\x90" }  },
      /* --- pixel bitmap for cmex250 char#12 (noname) --- */
      {  12,71017,                      /* character number, location */
          1, 5,  -22, 5,      /* topleft row,col, and botleft row,col */
          {  2,   23, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x72" }  },
      /* --- pixel bitmap for cmex250 char#13 (noname) --- */
      {  13,71656,                      /* character number, location */
          1, 5,  -22, 5,      /* topleft row,col, and botleft row,col */
          {  9,   23, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x52\x0f\x72\x52" }  },
      /* --- pixel bitmap for cmex250 char#14 (noname) --- */
      {  14,64340,                      /* character number, location */
          1, 2,  -39, 2,      /* topleft row,col, and botleft row,col */
          { 16,   40, 3,113, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe2\xd3\xf1\xd2\x10\xc3\xd2\xd3\x20\xf1\xb2\x30"
            "\xa3\x30\xf1\xa2\x40\x93\xd2\xd3\x50\xf1\x82\x60\x73"
            "\x60\xf1\x72\x70\x63\x70\xf1\x62\x80\x53\xd2\xd3\x90"
            "\xf1\x42\xa0\x33\xa0\xf1\x32\xb0\x23\xd2\xd3\xc0\xf1"
            "\x12\xd3\xdf\x12\xe3" }  },
      /* --- pixel bitmap for cmex250 char#15 (noname) --- */
      {  15,67710,                      /* character number, location */
          1, 2,  -39, 2,      /* topleft row,col, and botleft row,col */
          { 16,   40, 3,116, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe3\xd0\xf1\x12\xd0\x13\xe2\xe3\xb0\xf1\x32"
            "\xb0\x33\xa0\xf1\x42\xa0\x43\xe2\xe3\x80\xf1\x62\x80"
            "\x63\x70\xf1\x72\x70\x73\x60\xf1\x82\x60\x83\xe2\xe3"
            "\x40\xf1\xa2\x40\xa3\x30\xf1\xb2\x30\xb3\xe2\xe3\x10"
            "\xf1\xd2\x10\xd3\xf1\xe2" }  },
      /* --- pixel bitmap for cmex250 char#16 \Big( --- */
      {  16, 1452,                      /* character number, location */
          1, 6,  -60, 6,      /* topleft row,col, and botleft row,col */
          { 14,   61, 3,106, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc2\xb2\xb2\xb2\xb2\x40\xf1\x72\x50\x62\x60\xf1\x52"
            "\x70\xf1\x42\x80\xf2\x32\x90\xf2\x22\xa0\xf4\x12\xbf"
            "\xe2\xc0\xf4\x12\xb0\xf2\x22\xa0\xf2\x32\x90\xf1\x42"
            "\x80\xf1\x52\x70\x62\x60\xf1\x72\x50\x82\xd2\xd2\xd2"
            "\xd2" }  },
      /* --- pixel bitmap for cmex250 char#17 \Big) --- */
      {  17, 7618,                      /* character number, location */
          1, 1,  -60, 1,      /* topleft row,col, and botleft row,col */
          { 14,   61, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xd2\xd2\xd2\xd2\x80\xf1\x52\x70\x62\x60\xf1\x72"
            "\x50\xf1\x82\x40\xf2\x92\x30\xf2\xa2\x20\xf4\xb2\x10"
            "\xfe\xc2\xf4\xb2\x10\xf2\xa2\x20\xf2\x92\x30\xf1\x82"
            "\x40\xf1\x72\x50\x62\x60\xf1\x52\x70\x42\xb2\xb2\xb2"
            "\xb2\xc3" }  },
      /* --- pixel bitmap for cmex250 char#18 \bigg( --- */
      {  18, 2338,                      /* character number, location */
          1, 7,  -81, 7,      /* topleft row,col, and botleft row,col */
          { 17,   82, 3,172, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x12\xe2\xe2\xe2\xe2\xe3\xe2\xe2\xe3\xe2\xe3\x70"
            "\xf1\x63\x80\xf1\x53\x90\x52\xe3\xe2\xb0\xf2\x33\xb0"
            "\xf3\x23\xc0\x22\xd0\xf4\x13\xd0\x12\xef\xe3\xef\x23"
            "\xe0\x12\xe0\xf4\x13\xd0\x22\xd0\xf3\x23\xc0\xf2\x33"
            "\xb0\x42\xe0\x13\xe0\x12\xa0\xf1\x53\x90\xf1\x63\x80"
            "\x73\xe0\x12\xe0\x13\xe0\x12\xe0\x22\xe0\x13\xe0\x12"
            "\xe0\x22\xe0\x22\xe0\x22\xe0\x22" }  },
      /* --- pixel bitmap for cmex250 char#19 \bigg) --- */
      {  19, 8491,                      /* character number, location */
          1, 1,  -81, 1,      /* topleft row,col, and botleft row,col */
          { 17,   82, 3,173, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x22\xe0\x22\xe0\x22\xe0\x22\xe0\x13\xe0\x12"
            "\xe0\x22\xe0\x13\xe0\x12\xe0\x13\x70\xf1\x83\x60\xf1"
            "\x93\x50\xa2\xe0\x13\xe0\x12\x40\xf2\xb3\x30\xf3\xc3"
            "\x20\xd2\x20\xf4\xd3\x10\xe2\x10\xfe\xe3\xf2\xe3\xe2"
            "\x10\xf4\xd3\x10\xd2\x20\xf3\xc3\x20\xf2\xb3\x30\xb2"
            "\xe3\xe2\x50\xf1\x93\x50\xf1\x83\x60\x73\xe2\xe3\xe2"
            "\xe2\xe3\xe2\xe2\xe2\xe2\xe2\xe0\x10" }  },
      /* --- pixel bitmap for cmex250 char#20 \bigg[ --- */
      {  20,14782,                      /* character number, location */
          1, 9,  -81, 9,      /* topleft row,col, and botleft row,col */
          {  9,   82, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x09\x00\xff\x4d\x02\x07\xff\x01\x09" }  },
      /* --- pixel bitmap for cmex250 char#21 \bigg] --- */
      {  21,21054,                      /* character number, location */
          1, 0,  -81, 0,      /* topleft row,col, and botleft row,col */
          {  9,   82, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x09\xff\x4d\x07\x02\x00\xff\x01\x09" }  },
      /* --- pixel bitmap for cmex250 char#22 (noname) --- */
      {  22,27331,                      /* character number, location */
          1, 9,  -81, 9,      /* topleft row,col, and botleft row,col */
          { 11,   82, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x4f\x00\x02\x09\xff\x01\x0b" }  },
      /* --- pixel bitmap for cmex250 char#23 (noname) --- */
      {  23,31124,                      /* character number, location */
          1, 0,  -81, 0,      /* topleft row,col, and botleft row,col */
          { 11,   82, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x4f\x09\x02\x00\xff\x01\x0b" }  },
      /* --- pixel bitmap for cmex250 char#24 (noname) --- */
      {  24,34949,                      /* character number, location */
          1, 9,  -81, 9,      /* topleft row,col, and botleft row,col */
          { 11,   82, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0b\x00\xff\x4f\x02\x09" }  },
      /* --- pixel bitmap for cmex250 char#25 (noname) --- */
      {  25,38750,                      /* character number, location */
          1, 0,  -81, 0,      /* topleft row,col, and botleft row,col */
          { 11,   82, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0b\xff\x4f\x09\x02" }  },
      /* --- pixel bitmap for cmex250 char#26 \bigg{ --- */
      {  26,42914,                      /* character number, location */
          1, 4,  -81, 4,      /* topleft row,col, and botleft row,col */
          { 18,   82, 3,122, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x13\xe4\xc4\xd4\xd4\xe3\x50\xf1\x93\x60\xfe\x83"
            "\x70\xf9\x83\x70\xf1\x73\x80\xf1\x63\x90\x53\xd4\xd3"
            "\xdf\x14\xe0\x23\xe0\x24\xe0\x23\xa0\xf1\x63\x90\xf1"
            "\x73\x80\xfe\x83\x70\xf9\x83\x70\xf1\x93\x60\xa3\xe0"
            "\x14\xe0\x14\xe0\x14\xe0\x24\xe0\x13" }  },
      /* --- pixel bitmap for cmex250 char#27 \bigg} --- */
      {  27,50983,                      /* character number, location */
          1, 4,  -81, 4,      /* topleft row,col, and botleft row,col */
          { 18,   82, 3,119, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x03\xe0\x15\xe0\x14\xe0\x23\xe0\x23\xe0\x23\x90\xf1"
            "\x73\x80\xfe\x83\x70\xfa\x83\x70\xf1\x93\x60\xa3\xe0"
            "\x23\xe0\x23\xe0\x24\x10\xf1\xe0\x13\xd4\xd3\xe3\xe3"
            "\x50\xf1\x93\x60\xfe\x83\x70\xfa\x83\x70\xf1\x73\x80"
            "\x63\xe3\xe3\xd4\xc5\xd3\xe0\x13" }  },
      /* --- pixel bitmap for cmex250 char#28 \bigg< --- */
      {  28,59655,                      /* character number, location */
          1, 4,  -81, 4,      /* topleft row,col, and botleft row,col */
          { 19,   82, 3,302, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x32\xe0\x23\xe0\x22\xe0\x23\xe0\x22\xe0\x23"
            "\x20\xf1\xe2\x30\xd3\xe0\x22\xe0\x23\xe0\x22\xe0\x23"
            "\x50\xf1\xb2\x60\xa3\xe0\x22\xe0\x23\xe0\x22\xe0\x23"
            "\x80\xf1\x82\x90\x73\xe0\x22\xe0\x23\xa0\xf1\x62\xb0"
            "\x53\xe0\x22\xe0\x23\xe0\x22\xe0\x23\xd0\xf1\x32\xe0"
            "\x23\xe0\x22\xe0\x23\xe0\x22\xe0\x23\xe0\x2f\x12\xe0"
            "\x33\xe0\x32\xe0\x33\xe0\x32\xe0\x33\xe0\xf1\x32\xe0"
            "\x33\xe0\x32\xe0\x33\xe0\x32\xe0\x33\xb0\xf1\x62\xb0"
            "\x63\xe0\x32\xe0\x33\x90\xf1\x82\x90\x83\xe0\x32\xe0"
            "\x33\xe0\x32\xe0\x33\x60\xf1\xb2\x60\xb3\xe0\x32\xe0"
            "\x33\xe0\x32\xe0\x33\x30\xf1\xe2\x30\xe3\xe0\x32\xe0"
            "\x33\xe0\x32\xe0\x33\xf1\xe0\x32" }  },
      /* --- pixel bitmap for cmex250 char#29 \bigg> --- */
      {  29,62752,                      /* character number, location */
          1, 3,  -81, 3,      /* topleft row,col, and botleft row,col */
          { 19,   82, 3,303, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x33\xe0\x32\xe0\x33\xe0\x32\xe0\x33\xe0"
            "\xf1\x32\xe0\x33\xe0\x32\xe0\x33\xe0\x32\xe0\x33\xb0"
            "\xf1\x62\xb0\x63\xe0\x32\xe0\x33\xe0\x32\xe0\x33\x80"
            "\xf1\x92\x80\x93\xe0\x32\xe0\x33\x60\xf1\xb2\x60\xb3"
            "\xe0\x32\xe0\x33\xe0\x32\xe0\x33\x30\xf1\xe2\x30\xe3"
            "\xe0\x32\xe0\x33\xe0\x32\xe0\x33\xf1\xe0\x32\xe0\x23"
            "\xe0\x22\xe0\x23\xe0\x22\xe0\x23\x20\xf1\xe2\x30\xd3"
            "\xe0\x22\xe0\x23\xe0\x22\xe0\x23\x50\xf1\xb2\x60\xa3"
            "\xe0\x22\xe0\x23\x70\xf1\x92\x80\x83\xe0\x22\xe0\x23"
            "\xe0\x22\xe0\x23\xa0\xf1\x62\xb0\x53\xe0\x22\xe0\x23"
            "\xe0\x22\xe0\x23\xd0\xf1\x32\xe0\x23\xe0\x22\xe0\x23"
            "\xe0\x22\xe0\x23\xe0\x2f\x12\xe0\x30" }  },
      /* --- pixel bitmap for cmex250 char#30 (noname) --- */
      {  30,65953,                      /* character number, location */
          1, 2,  -81, 2,      /* topleft row,col, and botleft row,col */
          { 32,   82, 3,375, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x22\xf1\xe0\xe0\x13\xe0\xe0\x12\x10\xf1\xe0"
            "\xe3\x10\xe0\xe2\x20\xf1\xe0\xd3\x20\xf1\xe0\xc3\x30"
            "\xe0\xc2\x40\xf1\xe0\xb3\x40\xe0\xb2\x50\xf1\xe0\xa3"
            "\x50\xf1\xe0\x93\x60\xe0\x92\x70\xf1\xe0\x83\x70\xe0"
            "\x82\x80\xf1\xe0\x73\x80\xf1\xe0\x63\x90\xe0\x62\xa0"
            "\xf1\xe0\x53\xa0\xe0\x52\xb0\xf1\xe0\x43\xb0\xf1\xe0"
            "\x33\xc0\xe0\x32\xd0\xf1\xe0\x23\xd0\xe0\x22\xe0\xf1"
            "\xe0\x13\xe0\xf1\xe3\xe0\x10\xe2\xe0\x20\xf1\xd3\xe0"
            "\x20\xd2\xe0\x30\xf1\xc3\xe0\x30\xf1\xb3\xe0\x40\xb2"
            "\xe0\x50\xf1\xa3\xe0\x50\xa2\xe0\x60\xf1\x93\xe0\x60"
            "\xf1\x83\xe0\x70\x82\xe0\x80\xf1\x73\xe0\x80\x72\xe0"
            "\x90\xf1\x63\xe0\x90\xf1\x53\xe0\xa0\x52\xe0\xb0\xf1"
            "\x43\xe0\xb0\x42\xe0\xc0\xf1\x33\xe0\xc0\xf1\x23\xe0"
            "\xd0\x22\xe0\xe0\xf1\x13\xe0\xe0\x12\xe0\xe0\x1f\x13"
            "\xe0\xe0\x12\xe0\xe0\x20" }  },
      /* --- pixel bitmap for cmex250 char#31 (noname) --- */
      {  31,69331,                      /* character number, location */
          1, 2,  -81, 2,      /* topleft row,col, and botleft row,col */
          { 32,   82, 3,378, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe0\xe0\x2f\x13\xe0\xe0\x10\x12\xe0\xe0\x10\xf1"
            "\x13\xe0\xe0\x22\xe0\xe0\xf1\x23\xe0\xd0\xf1\x33\xe0"
            "\xc0\x42\xe0\xc0\xf1\x43\xe0\xb0\x52\xe0\xb0\xf1\x53"
            "\xe0\xa0\xf1\x63\xe0\x90\x72\xe0\x90\xf1\x73\xe0\x80"
            "\x82\xe0\x80\xf1\x83\xe0\x70\xf1\x93\xe0\x60\xa2\xe0"
            "\x60\xf1\xa3\xe0\x50\xb2\xe0\x50\xf1\xb3\xe0\x40\xf1"
            "\xc3\xe0\x30\xd2\xe0\x30\xf1\xd3\xe0\x20\xe2\xe0\x20"
            "\xf1\xe3\xe0\x10\xf1\xe0\x13\xe0\xe0\x22\xe0\xf1\xe0"
            "\x23\xd0\xe0\x32\xd0\xf1\xe0\x33\xc0\xf1\xe0\x43\xb0"
            "\xe0\x52\xb0\xf1\xe0\x53\xa0\xe0\x62\xa0\xf1\xe0\x63"
            "\x90\xf1\xe0\x73\x80\xe0\x82\x80\xf1\xe0\x83\x70\xe0"
            "\x92\x70\xf1\xe0\x93\x60\xf1\xe0\xa3\x50\xe0\xb2\x50"
            "\xf1\xe0\xb3\x40\xe0\xc2\x40\xf1\xe0\xc3\x30\xf1\xe0"
            "\xd3\x20\xe0\xe2\x20\xf1\xe0\xe3\x10\xe0\xe0\x12\x10"
            "\xf1\xe0\xe0\x13\xe0\xe0\x22" }  },
      /* --- pixel bitmap for cmex250 char#32 \Bigg( --- */
      {  32, 3292,                      /* character number, location */
          1, 8,  -101, 8,     /* topleft row,col, and botleft row,col */
          { 18,  102, 3,240, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x22\xe0\x12\xe0\x12\xe0\x13\xe0\x12\xe0\x12\xe0"
            "\x12\xe0\x13\xe0\x12\xe0\x13\xe0\x12\xe0\x13\xe0\x12"
            "\xe0\x13\xe0\x12\xe0\x13\xe0\x12\xa0\xf1\x53\xa0\x52"
            "\xb0\xf1\x43\xb0\x42\xc0\xf2\x33\xc0\x32\xd0\xf3\x23"
            "\xd0\x22\xe0\xf6\x13\xef\xe3\xe0\x1f\x83\xe0\x10\xf6"
            "\x13\xe0\x22\xe0\xf3\x23\xd0\x32\xd0\xf2\x33\xc0\x42"
            "\xc0\xf1\x43\xb0\x52\xb0\xf1\x53\xa0\x62\xe0\x23\xe0"
            "\x22\xe0\x23\xe0\x22\xe0\x23\xe0\x22\xe0\x23\xe0\x22"
            "\xe0\x23\xe0\x22\xe0\x32\xe0\x32\xe0\x23\xe0\x22\xe0"
            "\x32\xe0\x32" }  },
      /* --- pixel bitmap for cmex250 char#33 \Bigg) --- */
      {  33, 9432,                      /* character number, location */
          1, 1,  -101, 1,     /* topleft row,col, and botleft row,col */
          { 18,  102, 3,241, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x32\xe0\x32\xe0\x23\xe0\x22\xe0\x32\xe0\x32"
            "\xe0\x23\xe0\x22\xe0\x23\xe0\x22\xe0\x23\xe0\x22\xe0"
            "\x23\xe0\x22\xe0\x23\xe0\x22\x60\xf1\xa3\x50\xb2\x50"
            "\xf1\xb3\x40\xc2\x40\xf2\xc3\x30\xd2\x30\xf3\xd3\x20"
            "\xe2\x20\xf6\xe3\x10\xfe\xe0\x13\xf8\xe0\x13\xf6\xe3"
            "\x10\xe2\x20\xf3\xd3\x20\xd2\x30\xf2\xc3\x30\xc2\x40"
            "\xf1\xb3\x40\xb2\x50\xf1\xa3\x50\xa2\xe0\x13\xe0\x12"
            "\xe0\x13\xe0\x12\xe0\x13\xe0\x12\xe0\x13\xe0\x12\xe0"
            "\x13\xe0\x12\xe0\x12\xe0\x12\xe0\x13\xe0\x12\xe0\x12"
            "\xe0\x12\xe0\x20" }  },
      /* --- pixel bitmap for cmex250 char#34 \Bigg[ --- */
      {  34,15769,                      /* character number, location */
          1,10,  -101,10,     /* topleft row,col, and botleft row,col */
          { 10,  102, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0a\x00\xff\x61\x02\x08\xff\x01\x0a" }  },
      /* --- pixel bitmap for cmex250 char#35 \Bigg] --- */
      {  35,22028,                      /* character number, location */
          1, 0,  -101, 0,     /* topleft row,col, and botleft row,col */
          { 10,  102, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0a\xff\x61\x08\x02\x00\xff\x01\x0a" }  },
      /* --- pixel bitmap for cmex250 char#36 (noname) --- */
      {  36,28350,                      /* character number, location */
          1,10,  -101,10,     /* topleft row,col, and botleft row,col */
          { 12,  102, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x63\x00\x02\x0a\xff\x01\x0c" }  },
      /* --- pixel bitmap for cmex250 char#37 (noname) --- */
      {  37,32130,                      /* character number, location */
          1, 0,  -101, 0,     /* topleft row,col, and botleft row,col */
          { 12,  102, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x63\x0a\x02\x00\xff\x01\x0c" }  },
      /* --- pixel bitmap for cmex250 char#38 (noname) --- */
      {  38,35970,                      /* character number, location */
          1,10,  -101,10,     /* topleft row,col, and botleft row,col */
          { 12,  102, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0c\x00\xff\x63\x02\x0a" }  },
      /* --- pixel bitmap for cmex250 char#39 (noname) --- */
      {  39,39758,                      /* character number, location */
          1, 0,  -101, 0,     /* topleft row,col, and botleft row,col */
          { 12,  102, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0c\xff\x63\x0a\x02" }  },
      /* --- pixel bitmap for cmex250 char#40 \Bigg{ --- */
      {  40,44056,                      /* character number, location */
          1, 5,  -101, 5,     /* topleft row,col, and botleft row,col */
          { 18,  102, 3,154, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x13\xe4\xd4\xc4\xd4\xe3\xe3\x60\xf2\x83\x70\xfe"
            "\x73\x80\xfe\x73\x80\xf1\x73\x80\xf1\x63\x90\x62\xe0"
            "\x13\xe3\xe0\x12\xe0\x12\xe3\xef\x13\xe0\x10\x13\xe0"
            "\x32\xe0\x32\xe0\x23\xe0\x23\xe0\x22\xa0\xf1\x63\x90"
            "\xfe\x73\x80\xfe\x73\x80\xf1\x73\x80\xf2\x83\x70\x93"
            "\xe0\x23\xe0\x14\xe0\x14\xe0\x24\xe0\x14\xe0\x13" }  },
      /* --- pixel bitmap for cmex250 char#41 \Bigg} --- */
      {  41,52126,                      /* character number, location */
          1, 5,  -101, 5,     /* topleft row,col, and botleft row,col */
          { 18,  102, 3,149, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x24\xe0\x14\xe0\x23\xe0\x23\xb0\xf1\x53\xa0"
            "\xf1\x63\x90\xfe\x73\x80\xfe\x73\x80\xf2\x73\x80\xf1"
            "\x83\x70\xf1\x93\x60\xa3\xe0\x23\xe0\x23\xe0\x24\x10"
            "\xf1\xe0\x13\xd4\xd3\xe3\xe3\x50\xf1\x93\x60\xf1\x83"
            "\x70\xfe\x73\x80\xfe\x73\x80\xf2\x73\x80\xf1\x63\x90"
            "\xf1\x53\xa0\x43\xe3\xd4\xd4\xe2\xe0\x24" }  },
      /* --- pixel bitmap for cmex250 char#42 \Bigg< --- */
      {  42,60515,                      /* character number, location */
          1, 5,  -101, 5,     /* topleft row,col, and botleft row,col */
          { 19,  102, 3,366, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x32\xe0\x23\xf1\xe0\x22\x10\xe0\x13\x10\xf1"
            "\xe0\x12\x20\xe3\x20\xf1\xe2\x30\xd3\x30\xf1\xd2\x40"
            "\xc3\x40\xf1\xc2\x50\xb3\x50\xf1\xb2\x60\xa3\x60\xf1"
            "\xa2\x70\x93\xe0\x22\xe0\x23\x80\xf1\x82\x90\x73\x90"
            "\xf1\x72\xa0\x63\xa0\xf1\x62\xb0\x53\xb0\xf1\x52\xc0"
            "\x43\xc0\xf1\x42\xd0\x33\xd0\xf1\x32\xe0\x23\xe0\xf1"
            "\x22\xe0\x10\x13\xe0\x10\xf1\x12\xe0\x23\xe0\x2f\x12"
            "\xe0\x33\xe0\x20\xf1\x12\xe0\x20\x13\xe0\x10\xf1\x22"
            "\xe0\x10\x23\xe0\xf1\x32\xe0\x33\xd0\xf1\x42\xd0\x43"
            "\xc0\xf1\x52\xc0\x53\xb0\xf1\x62\xb0\x63\xa0\xf1\x72"
            "\xa0\x73\x90\xf1\x82\x90\x83\xe0\x32\xe0\x33\x70\xf1"
            "\xa2\x70\xa3\x60\xf1\xb2\x60\xb3\x50\xf1\xc2\x50\xc3"
            "\x40\xf1\xd2\x40\xd3\x30\xf1\xe2\x30\xe3\x20\xf1\xe0"
            "\x12\x20\xe0\x13\x10\xf1\xe0\x22\x10\xe0\x23\xf1\xe0"
            "\x32" }  },
      /* --- pixel bitmap for cmex250 char#43 \Bigg> --- */
      {  43,63613,                      /* character number, location */
          1, 4,  -101, 4,     /* topleft row,col, and botleft row,col */
          { 19,  102, 3,367, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x33\xe0\x20\xf1\x12\xe0\x20\x13\xe0\x10"
            "\xf1\x22\xe0\x10\x23\xe0\xf1\x32\xe0\x33\xd0\xf1\x42"
            "\xd0\x43\xc0\xf1\x52\xc0\x53\xb0\xf1\x62\xb0\x63\xa0"
            "\xf1\x72\xa0\x73\xe0\x32\xe0\x33\x80\xf1\x92\x80\x93"
            "\x70\xf1\xa2\x70\xa3\x60\xf1\xb2\x60\xb3\x50\xf1\xc2"
            "\x50\xc3\x40\xf1\xd2\x40\xd3\x30\xf1\xe2\x30\xe3\x20"
            "\xf1\xe0\x12\x20\xe0\x13\x10\xf1\xe0\x22\x10\xe0\x23"
            "\xf1\xe0\x32\xe0\x23\xf1\xe0\x22\x10\xe0\x13\x10\xf1"
            "\xe0\x12\x20\xe3\x20\xf1\xe2\x30\xd3\x30\xf1\xd2\x40"
            "\xc3\x40\xf1\xc2\x50\xb3\x50\xf1\xb2\x60\xa3\x60\xf1"
            "\xa2\x70\x93\x70\xf1\x92\x80\x83\xe0\x22\xe0\x23\x90"
            "\xf1\x72\xa0\x63\xa0\xf1\x62\xb0\x53\xb0\xf1\x52\xc0"
            "\x43\xc0\xf1\x42\xd0\x33\xd0\xf1\x32\xe0\x23\xe0\xf1"
            "\x22\xe0\x10\x13\xe0\x10\xf1\x12\xe0\x23\xe0\x2f\x12"
            "\xe0\x30" }  },
      /* --- pixel bitmap for cmex250 char#44 / --- */
      {  44,66979,                      /* character number, location */
          1, 2,  -101, 2,     /* topleft row,col, and botleft row,col */
          { 40,  102, 3,351, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\xe0\x93\xf2\xe0\xe0\x83\x10\xf1\xe0\xe0\x73"
            "\x20\xf2\xe0\xe0\x63\x30\xf2\xe0\xe0\x53\x40\xf1\xe0"
            "\xe0\x43\x50\xf2\xe0\xe0\x33\x60\xf2\xe0\xe0\x23\x70"
            "\xf1\xe0\xe0\x13\x80\xf2\xe0\xe3\x90\xf2\xe0\xd3\xa0"
            "\xf1\xe0\xc3\xb0\xf2\xe0\xb3\xc0\xf2\xe0\xa3\xd0\xf1"
            "\xe0\x93\xe0\xf2\xe0\x83\xe0\x10\xf2\xe0\x73\xe0\x20"
            "\xf1\xe0\x63\xe0\x30\xf2\xe0\x53\xe0\x40\xf2\xe0\x43"
            "\xe0\x50\xf1\xe0\x33\xe0\x60\xf2\xe0\x23\xe0\x70\xf2"
            "\xe0\x13\xe0\x80\xf1\xe3\xe0\x90\xf2\xd3\xe0\xa0\xf2"
            "\xc3\xe0\xb0\xf1\xb3\xe0\xc0\xf2\xa3\xe0\xd0\xf2\x93"
            "\xe0\xe0\xf1\x83\xe0\xe0\x10\xf2\x73\xe0\xe0\x20\xf2"
            "\x63\xe0\xe0\x30\xf1\x53\xe0\xe0\x40\xf2\x43\xe0\xe0"
            "\x50\xf2\x33\xe0\xe0\x60\xf1\x23\xe0\xe0\x70\xf2\x13"
            "\xe0\xe0\x8f\x23\xe0\xe0\x90" }  },
      /* --- pixel bitmap for cmex250 char#45 \ --- */
      {  45,70361,                      /* character number, location */
          1, 2,  -101, 2,     /* topleft row,col, and botleft row,col */
          { 40,  102, 3,354, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\x03\xe0\xe0\x90\xf2\x13\xe0\xe0\x80\xf1\x23\xe0"
            "\xe0\x70\xf2\x33\xe0\xe0\x60\xf2\x43\xe0\xe0\x50\xf1"
            "\x53\xe0\xe0\x40\xf2\x63\xe0\xe0\x30\xf2\x73\xe0\xe0"
            "\x20\xf1\x83\xe0\xe0\x10\xf2\x93\xe0\xe0\xf2\xa3\xe0"
            "\xd0\xf1\xb3\xe0\xc0\xf2\xc3\xe0\xb0\xf2\xd3\xe0\xa0"
            "\xf1\xe3\xe0\x90\xf2\xe0\x13\xe0\x80\xf2\xe0\x23\xe0"
            "\x70\xf1\xe0\x33\xe0\x60\xf2\xe0\x43\xe0\x50\xf2\xe0"
            "\x53\xe0\x40\xf1\xe0\x63\xe0\x30\xf2\xe0\x73\xe0\x20"
            "\xf2\xe0\x83\xe0\x10\xf1\xe0\x93\xe0\xf2\xe0\xa3\xd0"
            "\xf2\xe0\xb3\xc0\xf1\xe0\xc3\xb0\xf2\xe0\xd3\xa0\xf2"
            "\xe0\xe3\x90\xf1\xe0\xe0\x13\x80\xf2\xe0\xe0\x23\x70"
            "\xf2\xe0\xe0\x33\x60\xf1\xe0\xe0\x43\x50\xf2\xe0\xe0"
            "\x53\x40\xf2\xe0\xe0\x63\x30\xf1\xe0\xe0\x73\x20\xf2"
            "\xe0\xe0\x83\x10\xf2\xe0\xe0\x93" }  },
      /* --- pixel bitmap for cmex250 char#46 / --- */
      {  46,65073,                      /* character number, location */
          1, 2,  -60, 2,      /* topleft row,col, and botleft row,col */
          { 24,   61, 3,247, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x82\xe0\x73\xf1\xe0\x72\x10\xe0\x63\xe0\x72"
            "\xe0\x73\x20\xf1\xe0\x52\x30\xe0\x43\x30\xf1\xe0\x42"
            "\x40\xe0\x33\xe0\x72\xe0\x73\x50\xf1\xe0\x22\x60\xe0"
            "\x13\x60\xf1\xe0\x12\x70\xe3\xe0\x72\xe0\x73\x80\xf1"
            "\xd2\x90\xc3\x90\xf1\xc2\xa0\xb3\xe0\x72\xe0\x73\xb0"
            "\xf1\xa2\xc0\x93\xc0\xf1\x92\xd0\x83\xe0\x72\xe0\x73"
            "\xe0\xf1\x72\xe0\x10\x63\xe0\x10\xf1\x62\xe0\x20\x53"
            "\xe0\x72\xe0\x73\xe0\x30\xf1\x42\xe0\x40\x33\xe0\x40"
            "\xf1\x32\xe0\x50\x23\xe0\x72\xe0\x73\xe0\x60\xf1\x12"
            "\xe0\x73\xe0\x7f\x12\xe0\x80" }  },
      /* --- pixel bitmap for cmex250 char#47 \ --- */
      {  47,68447,                      /* character number, location */
          1, 2,  -60, 2,      /* topleft row,col, and botleft row,col */
          { 24,   61, 3,250, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x83\xe0\x70\xf1\x12\xe0\x70\x13\xe0\x82"
            "\xe0\x83\xe0\x50\xf1\x32\xe0\x50\x33\xe0\x40\xf1\x42"
            "\xe0\x40\x43\xe0\x82\xe0\x83\xe0\x20\xf1\x62\xe0\x20"
            "\x63\xe0\x10\xf1\x72\xe0\x10\x73\xe0\x82\xe0\x83\xd0"
            "\xf1\x92\xd0\x93\xc0\xf1\xa2\xc0\xa3\xe0\x82\xe0\x83"
            "\xa0\xf1\xc2\xa0\xc3\x90\xf1\xd2\x90\xd3\xe0\x82\xe0"
            "\x83\x70\xf1\xe0\x12\x70\xe0\x13\x60\xf1\xe0\x22\x60"
            "\xe0\x23\xe0\x82\xe0\x83\x40\xf1\xe0\x42\x40\xe0\x43"
            "\x30\xf1\xe0\x52\x30\xe0\x53\xe0\x82\xe0\x83\x10\xf1"
            "\xe0\x72\x10\xe0\x73\xf1\xe0\x82" }  },
      /* --- pixel bitmap for cmex250 char#48 \leftparentop --- */
      {  48, 4302,                      /* character number, location */
          0,10,  -62,10,      /* topleft row,col, and botleft row,col */
          { 19,   62, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x32\xe0\x22\xe0\x23\xe0\x22\xe0\x22\xe0\x23\xe0"
            "\x22\xe0\x22\xe0\x23\xe0\x22\xe0\x23\xe0\x22\x70\xf1"
            "\x93\x70\xf1\x83\x80\xf1\x73\x90\x64\x90\xf1\x63\xa0"
            "\x54\xa0\xf1\x53\xb0\xf1\x44\xb0\xf1\x43\xc0\xf1\x34"
            "\xc0\xf1\x33\xd0\xf3\x24\xd0\xf1\x23\xe0\xf7\x14\xe0"
            "\x13\xe0\x1f\xe4\xe0\x13" }  },
      /* --- pixel bitmap for cmex250 char#49 \rightparentop --- */
      {  49,10403,                      /* character number, location */
          0, 1,  -62, 1,      /* topleft row,col, and botleft row,col */
          { 19,   62, 3,140, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x42\xe0\x33\xe0\x32\xe0\x42\xe0\x33\xe0\x32"
            "\xe0\x42\xe0\x33\xe0\x32\xe0\x33\xe0\x32\xa0\xf1\x73"
            "\x90\xf1\x83\x80\xf1\x93\x70\x94\x60\xf1\xa3\x60\xa4"
            "\x50\xf1\xb3\x50\xf1\xb4\x40\xf1\xc3\x40\xf1\xc4\x30"
            "\xf1\xd3\x30\xf3\xd4\x20\xf1\xe3\x20\xf7\xe4\x10\xe0"
            "\x13\x10\xfe\xe0\x14" }  },
      /* --- pixel bitmap for cmex250 char#50 (noname) --- */
      {  50,16765,                      /* character number, location */
          0,12,  -61,12,      /* topleft row,col, and botleft row,col */
          { 11,   61, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0b\x00\xff\x3a\x02\x09" }  },
      /* --- pixel bitmap for cmex250 char#51 (noname) --- */
      {  51,22985,                      /* character number, location */
          0, 0,  -61, 0,      /* topleft row,col, and botleft row,col */
          { 11,   61, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0b\xff\x3a\x09\x02" }  },
      /* --- pixel bitmap for cmex250 char#52 (noname) --- */
      {  52,17701,                      /* character number, location */
          1,12,  -60,12,      /* topleft row,col, and botleft row,col */
          { 11,   61, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3a\x00\x02\x09\xff\x01\x0b" }  },
      /* --- pixel bitmap for cmex250 char#53 (noname) --- */
      {  53,23882,                      /* character number, location */
          1, 0,  -60, 0,      /* topleft row,col, and botleft row,col */
          { 11,   61, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3a\x09\x02\x00\xff\x01\x0b" }  },
      /* --- pixel bitmap for cmex250 char#54 (noname) --- */
      {  54,18534,                      /* character number, location */
          1,12,  -22,12,      /* topleft row,col, and botleft row,col */
          {  2,   23, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x72" }  },
      /* --- pixel bitmap for cmex250 char#55 (noname) --- */
      {  55,24676,                      /* character number, location */
          1, 9,  -22, 9,      /* topleft row,col, and botleft row,col */
          {  2,   23, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x72" }  },
      /* --- pixel bitmap for cmex250 char#56 \leftbracetop --- */
      {  56,45113,                      /* character number, location */
         -1,13,  -32,13,      /* topleft row,col, and botleft row,col */
          { 12,   31, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\x84\x74\x74\x74\x74\x74\x75\x74\x60\xf1\x15\x6f"
            "\xe5\x7f\x45\x73" }  },
      /* --- pixel bitmap for cmex250 char#57 \rightbracetop --- */
      {  57,53184,                      /* character number, location */
         -1, 6,  -32, 6,      /* topleft row,col, and botleft row,col */
          { 12,   31, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xa4\x94\x94\x94\x94\x94\x85\x84\x20\xf1\x65\x10"
            "\xfe\x75\xf4\x75" }  },
      /* --- pixel bitmap for cmex250 char#58 \leftbracebot --- */
      {  58,46050,                      /* character number, location */
          1,13,  -30,13,      /* topleft row,col, and botleft row,col */
          { 12,   31, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x05\x7f\x45\x70\xf1\x15\x60\x24\x85\x84\x94\x94"
            "\x94\x94\x94\xa2" }  },
      /* --- pixel bitmap for cmex250 char#59 \rightbracebot --- */
      {  59,54122,                      /* character number, location */
          1, 6,  -30, 6,      /* topleft row,col, and botleft row,col */
          { 12,   31, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x75\xf4\x75\xf1\x65\x10\x64\x75\x74\x74\x74\x74"
            "\x74\x74\x82\xa5" }  },
      /* --- pixel bitmap for cmex250 char#60 \leftbracemid --- */
      {  60,47062,                      /* character number, location */
          1, 6,  -63, 6,      /* topleft row,col, and botleft row,col */
          { 12,   64, 3,84, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x75\xf4\x75\x74\x10\xf1\x65\x10\x64\x75\x74\x30"
            "\xf1\x44\x40\x34\x74\x74\x7f\x13\x90\x14\x94\x94\x50"
            "\xf1\x44\x40\x54\x85\x84\x20\xf1\x65\x10\x74\x10\xfe"
            "\x75\xf4\x75" }  },
      /* --- pixel bitmap for cmex250 char#61 \rightbracemid --- */
      {  61,55135,                      /* character number, location */
          1,13,  -63,13,      /* topleft row,col, and botleft row,col */
          { 12,   64, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x05\x7f\x45\x70\x14\x70\xf1\x15\x60\x24\x85\x84"
            "\x50\xf1\x44\x40\x54\x94\x94\x10\xf1\x93\x74\x74\x74"
            "\x30\xf1\x44\x40\x34\x75\x74\x60\xf1\x15\x60\x14\x7f"
            "\xe5\x7f\x45\x74" }  },
      /* --- pixel bitmap for cmex250 char#62 \leftbracebar --- */
      {  62,48004,                      /* character number, location */
          1,13,  -11,13,      /* topleft row,col, and botleft row,col */
          {  5,   12, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x05" }  },
      /* --- pixel bitmap for cmex250 char#63 (noname) --- */
      {  63,74327,                      /* character number, location */
          1,11,  -22,11,      /* topleft row,col, and botleft row,col */
          {  2,   23, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x72" }  },
      /* --- pixel bitmap for cmex250 char#64 \leftparenbot --- */
      {  64, 5254,                      /* character number, location */
          2,10,  -60,10,      /* topleft row,col, and botleft row,col */
          { 19,   62, 3,140, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xfe\x04\xe0\x10\x13\xe0\x10\xf7\x14\xe0\xf1\x23\xe0"
            "\xf3\x24\xd0\xf1\x33\xd0\xf1\x34\xc0\xf1\x43\xc0\xf1"
            "\x44\xb0\xf1\x53\xb0\x54\xa0\xf1\x63\xa0\x64\x90\xf1"
            "\x73\x90\xf1\x83\x80\xf1\x93\x70\xa2\xe0\x33\xe0\x32"
            "\xe0\x33\xe0\x32\xe0\x42\xe0\x33\xe0\x32\xe0\x42\xe0"
            "\x33\xe0\x32\xe0\x42" }  },
      /* --- pixel bitmap for cmex250 char#65 \rightparenbot --- */
      {  65,11316,                      /* character number, location */
          2, 1,  -60, 1,      /* topleft row,col, and botleft row,col */
          { 19,   62, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xfe\xe0\x14\xe0\x13\x10\xf7\xe4\x10\xf1\xe3\x20\xf3"
            "\xd4\x20\xf1\xd3\x30\xf1\xc4\x30\xf1\xc3\x40\xf1\xb4"
            "\x40\xf1\xb3\x50\xa4\x50\xf1\xa3\x60\x94\x60\xf1\x93"
            "\x70\xf1\x83\x80\xf1\x73\x90\x72\xe0\x23\xe0\x22\xe0"
            "\x23\xe0\x22\xe0\x22\xe0\x23\xe0\x22\xe0\x22\xe0\x23"
            "\xe0\x22\xe0\x22\xe0\x30" }  },
      /* --- pixel bitmap for cmex250 char#66 \leftparenbar --- */
      {  66, 6200,                      /* character number, location */
          1,10,  -22,10,      /* topleft row,col, and botleft row,col */
          {  4,   23, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x04\x0f\x74" }  },
      /* --- pixel bitmap for cmex250 char#67 \rightparenbar --- */
      {  67,12223,                      /* character number, location */
          1,16,  -22,16,      /* topleft row,col, and botleft row,col */
          {  4,   23, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x04\x0f\x74" }  },
      /* --- pixel bitmap for cmex250 char#68 \Big< --- */
      {  68,58861,                      /* character number, location */
          1, 4,  -61, 4,      /* topleft row,col, and botleft row,col */
          { 14,   62, 3,164, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xc2\xb3\xb2\xb3\x10\xf1\xa2\x20\x93\xb2\xb3\x30"
            "\xf1\x82\x40\x73\xb2\xb3\x50\xf1\x62\x60\x53\xb2\xb3"
            "\x70\xf1\x42\x80\x33\xb2\xb3\x90\xf1\x22\xa0\x13\xb2"
            "\xb3\xbf\x12\xc3\xc2\xc3\xa0\xf1\x22\xa0\x23\xc2\xc3"
            "\x80\xf1\x42\x80\x43\xc2\xc3\x60\xf1\x62\x60\x63\xc2"
            "\xc3\x40\xf1\x82\x40\x83\xc2\xc3\x20\xf1\xa2\x20\xa3"
            "\xc2\xc3\xf1\xc2" }  },
      /* --- pixel bitmap for cmex250 char#69 \Big> --- */
      {  69,61957,                      /* character number, location */
          1, 3,  -61, 3,      /* topleft row,col, and botleft row,col */
          { 14,   62, 3,165, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xc3\xc2\xc3\xa0\xf1\x22\xa0\x23\xc2\xc3\x80"
            "\xf1\x42\x80\x43\xc2\xc3\x60\xf1\x62\x60\x63\xc2\xc3"
            "\x40\xf1\x82\x40\x83\xc2\xc3\x20\xf1\xa2\x20\xa3\xc2"
            "\xc3\xf1\xc2\xb3\xb2\xb3\x10\xf1\xa2\x20\x93\xb2\xb3"
            "\x30\xf1\x82\x40\x73\xb2\xb3\x50\xf1\x62\x60\x53\xb2"
            "\xb3\x70\xf1\x42\x80\x33\xb2\xb3\x90\xf1\x22\xa0\x13"
            "\xb2\xb3\xbf\x12\xc0" }  },
      /* --- pixel bitmap for cmex250 char#70 \bigsqcup --- */
      {  70,85590,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x20\x00\x02\x15\x02\x00\xff\x01\x19" }  },
      /* --- pixel bitmap for cmex250 char#71 \Bigsqcup --- */
      {  71,86583,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x2d\x00\x02\x1e\x02\x00\xff\x01\x22" }  },
      /* --- pixel bitmap for cmex250 char#72 \oint --- */
      {  72,106625,                     /* character number, location */
          0, 2,  -38, 2,      /* topleft row,col, and botleft row,col */
          { 19,   38, 3,123, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd4\xe2\x31\xd1\x42\xb2\x42\xb2\xe0\x31\x70\xf5\xa2"
            "\x70\x84\xd8\xa3\x12\x13\x83\x22\x23\x72\x32\x32\x63"
            "\x32\x33\x20\xf1\x32\x42\x42\x20\x33\x32\x33\x62\x32"
            "\x32\x73\x22\x23\x83\x12\x13\xa8\xd4\x70\xf5\x82\x90"
            "\xf1\x72\xa2\x52\xa2\x42\xc1\x41\xe4\xd0" }  },
      /* --- pixel bitmap for cmex250 char#73 \Bigoint --- */
      {  73,107739,                     /* character number, location */
          0, 2,  -77, 2,      /* topleft row,col, and botleft row,col */
          { 30,   77, 3,301, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xb3\xe0\xc1\x31\xe0\xa2\x32\xe0\x82\x33\xe0\x82"
            "\x41\x10\xf1\xe0\x72\x70\xe0\x63\x70\xf1\xe0\x62\x80"
            "\xf2\xe0\x53\x80\xe0\x52\x90\xf3\xe0\x43\x90\xf3\xe0"
            "\x33\xa0\xf1\xe0\x24\xa0\xf2\xe0\x23\xb0\xf1\xe0\x14"
            "\xb0\xd6\xe0\x89\xe0\x54\x18\xe0\x23\x34\x23\xe3\x44"
            "\x33\xd2\x54\x42\xc3\x54\x43\x50\xf4\x62\x54\x62\x50"
            "\x63\x34\x63\xc2\x34\x62\xd3\x24\x53\xe3\x14\x43\xe0"
            "\x27\x24\xe0\x59\xe0\x77\xc0\xf1\xb4\xe0\x10\xf2\xb3"
            "\xe0\x20\xf1\xa4\xe0\x20\xf3\xa3\xe0\x30\xf3\x93\xe0"
            "\x40\x92\xe0\x50\xf2\x83\xe0\x50\xf1\x82\xe0\x60\x73"
            "\xe0\x60\xf1\x72\xe0\x70\x11\x42\xe0\x83\x32\xe0\x82"
            "\x32\xe0\xa1\x31\xe0\xc3\xe0\xb6" }  },
      /* --- pixel bitmap for cmex250 char#74 \bigodot --- */
      {  74,87683,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 34,   35, 3,181, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd8\xe0\x9e\xe0\x45\x85\xe0\x13\xe3\xd3\xe0\x23\xb3"
            "\xe0\x43\x93\xe0\x63\x73\xe0\x83\x53\xe0\xa3\x42\xe0"
            "\xc2\x33\xe0\xc3\x10\xf1\x12\xe0\xe2\x13\xe0\xe5\xe0"
            "\xe0\x24\xe2\xe2\x0f\x22\xd4\xd2\x02\xe2\xe4\xe0\xe0"
            "\x25\xe0\xe3\xf1\x12\xe0\xe2\x10\x13\xe0\xc3\x32\xe0"
            "\xc2\x43\xe0\xa3\x53\xe0\x83\x73\xe0\x63\x93\xe0\x43"
            "\xb3\xe0\x23\xd3\xe3\xe0\x15\x85\xe0\x4e\xe0\x98\xd2" }  },
      /* --- pixel bitmap for cmex250 char#75 \Bigodot --- */
      {  75,88922,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 48,   48, 3,345, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x5a\xe0\xe0\x7e\x02\xe0\xe0\x25\xa5\xe0\xc4\xe0"
            "\x24\xe0\x84\xe0\x64\xe0\x53\xe0\xa3\xe0\x33\xe0\xc3"
            "\xe4\xe0\xe4\xc2\xe0\xe0\x42\xb3\xe0\xe0\x43\x93\xe0"
            "\xe0\x63\x73\xe0\xe0\x83\x62\xe0\xe0\xa2\x53\xe0\xe0"
            "\xa3\x42\xe0\xe0\xc2\x33\xe0\xe0\xc3\x10\xf2\x12\xe0"
            "\xe0\xe2\x13\xe0\xe0\xe5\xe0\xe0\xe0\x24\xe0\x72\xe0"
            "\x74\xe0\x64\xe0\x62\x0f\x12\xe0\x56\xe0\x52\x02\xe0"
            "\x64\xe0\x64\xe0\x72\xe0\x74\xe0\xe0\xe0\x25\xe0\xe0"
            "\xe3\xf2\x12\xe0\xe0\xe2\x10\x13\xe0\xe0\xc3\x32\xe0"
            "\xe0\xc2\x43\xe0\xe0\xa3\x52\xe0\xe0\xa2\x63\xe0\xe0"
            "\x83\x73\xe0\xe0\x63\x93\xe0\xe0\x43\xb2\xe0\xe0\x42"
            "\xc4\xe0\xe4\xe3\xe0\xc3\xe0\x33\xe0\xa3\xe0\x54\xe0"
            "\x64\xe0\x84\xe0\x24\xe0\xc5\xa5\xe0\xe0\x2e\x02\xe0"
            "\xe0\x7a\xe0\x50" }  },
      /* --- pixel bitmap for cmex250 char#76 \bigoplus --- */
      {  76,90031,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 34,   35, 3,185, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd8\xe0\x9e\xe0\x45\x32\x35\xe0\x13\x62\x63\xd3\x72"
            "\x73\xb3\x82\x83\x93\x92\x93\x73\xa2\xa3\x53\xb2\xb3"
            "\x42\xc2\xc2\x33\xc2\xc3\x10\xf1\x12\xd2\xd2\x13\xd2"
            "\xd3\x0f\x12\xe2\xe2\x0f\x1e\x0e\x06\x0f\x22\xe2\xe2"
            "\x03\xd2\xd3\xf1\x12\xd2\xd2\x10\x13\xc2\xc3\x32\xc2"
            "\xc2\x43\xb2\xb3\x53\xa2\xa3\x73\x92\x93\x93\x82\x83"
            "\xb3\x72\x73\xd3\x62\x63\xe0\x15\x32\x35\xe0\x4e\xe0"
            "\x98\xd0" }  },
      /* --- pixel bitmap for cmex250 char#77 \Bigoplus --- */
      {  77,91315,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 48,   48, 3,363, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x5a\xe0\xe0\x7e\x02\xe0\xe0\x25\x42\x45\xe0\xc4"
            "\x72\x74\xe0\x84\x92\x94\xe0\x53\xb2\xb3\xe0\x33\xc2"
            "\xc3\xe4\xd2\xd4\xc2\xe0\x12\xe0\x12\xb3\xe0\x12\xe0"
            "\x13\x93\xe0\x22\xe0\x23\x73\xe0\x32\xe0\x33\x62\xe0"
            "\x42\xe0\x42\x53\xe0\x42\xe0\x43\x42\xe0\x52\xe0\x52"
            "\x33\xe0\x52\xe0\x53\x10\xf2\x12\xe0\x62\xe0\x62\x13"
            "\xe0\x62\xe0\x63\x0f\x22\xe0\x72\xe0\x72\x0f\x1e\x0e"
            "\x0e\x06\x0f\x22\xe0\x72\xe0\x72\x03\xe0\x62\xe0\x63"
            "\xf2\x12\xe0\x62\xe0\x62\x10\x13\xe0\x52\xe0\x53\x32"
            "\xe0\x52\xe0\x52\x43\xe0\x42\xe0\x43\x52\xe0\x42\xe0"
            "\x42\x63\xe0\x32\xe0\x33\x73\xe0\x22\xe0\x23\x93\xe0"
            "\x12\xe0\x13\xb2\xe0\x12\xe0\x12\xc4\xd2\xd4\xe3\xc2"
            "\xc3\xe0\x33\xb2\xb3\xe0\x54\x92\x94\xe0\x84\x72\x74"
            "\xe0\xc5\x42\x45\xe0\xe0\x2e\x02\xe0\xe0\x7a\xe0\x50" }  },
      /* --- pixel bitmap for cmex250 char#78 \bigotimes --- */
      {  78,92493,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 34,   35, 3,211, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd8\xe0\x9e\xe0\x45\x85\xe0\x13\xe3\xd3\xe0\x23\xb3"
            "\xe0\x43\x94\xe0\x44\x76\xe0\x26\x53\x23\xe3\x23\x42"
            "\x43\xc3\x42\x33\x53\xa3\x53\x22\x73\x83\x72\x22\x83"
            "\x63\x82\x13\x93\x43\x95\xb3\x23\xb4\xc6\xc4\xd4\xd4"
            "\xe2\xe4\xd4\xd4\xc6\xc4\xb3\x23\xb5\x93\x43\x93\x12"
            "\x83\x63\x82\x22\x73\x83\x72\x23\x53\xa3\x53\x32\x43"
            "\xc3\x42\x43\x23\xe3\x23\x56\xe0\x26\x74\xe0\x44\x93"
            "\xe0\x43\xb3\xe0\x23\xd3\xe3\xe0\x15\x85\xe0\x4e\xe0"
            "\x98\xd2" }  },
      /* --- pixel bitmap for cmex250 char#79 \Bigotimes --- */
      {  79,93790,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 48,   48, 3,397, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x5a\xe0\xe0\x7e\x02\xe0\xe0\x25\xa5\xe0\xc4\xe0"
            "\x24\xe0\x84\xe0\x64\xe0\x53\xe0\xa3\xe0\x33\xe0\xc3"
            "\x80\xf1\x64\xe0\xe4\x60\x56\xe0\xc6\x93\x23\xe0\xa3"
            "\x23\x73\x43\xe0\x83\x43\x62\x63\xe0\x63\x62\x53\x73"
            "\xe0\x43\x73\x42\x93\xe0\x23\x92\x33\xa3\xe3\xa3\x22"
            "\xc3\xc3\xc2\x22\xd3\xa3\xd2\x22\xe3\x83\xe2\x13\xe0"
            "\x13\x63\xe0\x15\xe0\x33\x43\xe0\x34\xe0\x43\x23\xe0"
            "\x44\xe0\x56\xe0\x52\x0f\x12\xe0\x64\xe0\x62\x02\xe0"
            "\x56\xe0\x54\xe0\x43\x23\xe0\x44\xe0\x33\x43\xe0\x35"
            "\xe0\x13\x63\xe0\x13\x12\xe3\x83\xe2\x22\xd3\xa3\xd2"
            "\x22\xc3\xc3\xc2\x23\xa3\xe3\xa3\x32\x93\xe0\x23\x92"
            "\x43\x73\xe0\x43\x73\x52\x63\xe0\x63\x62\x63\x43\xe0"
            "\x83\x43\x73\x23\xe0\xa3\x23\x96\xe0\xc6\x50\xf1\x64"
            "\xe0\xe4\x60\x83\xe0\xc3\xe0\x33\xe0\xa3\xe0\x54\xe0"
            "\x64\xe0\x84\xe0\x24\xe0\xc5\xa5\xe0\xe0\x2e\x02\xe0"
            "\xe0\x7a\xe0\x50" }  },
      /* --- pixel bitmap for cmex250 char#80 \sum --- */
      {  80,95326,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 33,   35, 3,205, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0e\x02\x30\x12\xe0\x77\x42\xe0\x94\x43\xe0"
            "\xa2\x52\xe0\xb2\x52\xe0\xb1\x62\xe0\xa1\x63\xe0\xa1"
            "\x62\xe0\xe0\x42\xe0\xe0\x42\xe0\xe0\x33\xe0\xe0\x32"
            "\xe0\xe0\x42\xe0\xe0\x42\xe0\xe0\x33\xe0\xe0\x32\xe0"
            "\xe0\x23\xe0\xe0\x22\xe0\xe0\x22\xe0\x70\xf1\x92\xe0"
            "\x80\x82\xe0\xe0\x22\xe0\xe0\x23\xe0\xe0\x22\xe0\xa1"
            "\x52\xe0\xa1\x52\xe0\xb1\x52\xe0\xa2\x42\xe0\xa2\x42"
            "\xe0\x94\x33\xe0\x67\x3e\x0e\x01\x3e\x0e\x02\x32" }  },
      /* --- pixel bitmap for cmex250 char#81 \prod --- */
      {  81,98380,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 29,   35, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0e\x01\x34\xe0\x14\x30\xfe\x43\xe0\x13\x40"
            "\xfd\x43\xe0\x13\x40\x35\xd5\x3f\x1b\x7b" }  },
      /* --- pixel bitmap for cmex250 char#82 \int --- */
      {  82,104458,                     /* character number, location */
          0, 2,  -38, 2,      /* topleft row,col, and botleft row,col */
          { 19,   38, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd4\xe2\x31\xd1\x42\xb2\x42\xb2\xe0\x31\x70\xf7\xa2"
            "\x70\xf9\x92\x80\xf7\x82\x90\xf1\x72\xa2\x52\xa2\x42"
            "\xc1\x41\xe4\xd7" }  },
      /* --- pixel bitmap for cmex250 char#83 \bigcup --- */
      {  83,108697,                     /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\xe0\x72\x0f\xa2\xe0\x72\x03\xe0\x53\x12\xe0"
            "\x52\x23\xe0\x33\x33\xe0\x13\x53\xd3\x73\xb3\x94\x74"
            "\xcb\xe0\x27\x90" }  },
      /* --- pixel bitmap for cmex250 char#84 \bigcap --- */
      {  84,110625,                     /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x97\xe0\x2b\xc4\x74\x93\xb3\x73\xd3\x53\xe0\x13\x33"
            "\xe0\x33\x22\xe0\x52\x13\xe0\x53\x0f\xe2\xe0\x72\x0f"
            "\xa2\xe0\x72" }  },
      /* --- pixel bitmap for cmex250 char#85 \biguplus --- */
      {  85,112618,                     /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x02\xe0\x72\x02\xa1\xa2\x0f\x62\xa2\x92\x02\x2e"
            "\x03\x24\x3e\x01\x32\x0f\x62\xa2\x92\x02\xe0\x75\xe0"
            "\x53\x12\xe0\x52\x23\xe0\x33\x33\xe0\x13\x53\xd3\x73"
            "\xb3\x94\x74\xcb\xe0\x27\x92" }  },
      /* --- pixel bitmap for cmex250 char#86 \bigwedge --- */
      {  86,114664,                     /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 3,164, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc2\xb0\xf1\xb3\xb0\xa5\xa0\xf1\xa2\x12\xa0\x93\x13"
            "\x90\xf1\x92\x32\x90\x83\x33\x80\xf1\x82\x52\x80\x73"
            "\x53\x70\xf1\x72\x72\x70\x63\x73\x60\xf1\x62\x92\x60"
            "\x53\x93\x50\xf1\x52\xb2\x50\x43\xb3\x82\xd2\x73\xd3"
            "\x30\xf1\x32\xe0\x12\x30\x23\xe0\x13\x20\xf1\x22\xe0"
            "\x32\x20\x13\xe0\x33\x10\xf1\x12\xe0\x52\x13\xe0\x53"
            "\x0f\x12\xe0\x72" }  },
      /* --- pixel bitmap for cmex250 char#87 \bigvee --- */
      {  87,116526,                     /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 3,165, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\x72\x03\xe0\x53\xf1\x12\xe0\x52\x10\x13"
            "\xe0\x33\x10\xf1\x22\xe0\x32\x20\x23\xe0\x13\x20\xf1"
            "\x32\xe0\x12\x30\x33\xd3\x72\xd2\x83\xb3\x40\xf1\x52"
            "\xb2\x50\x53\x93\x50\xf1\x62\x92\x60\x63\x73\x60\xf1"
            "\x72\x72\x70\x73\x53\x70\xf1\x82\x52\x80\x83\x33\x80"
            "\xf1\x92\x32\x90\x93\x13\x90\xf1\xa2\x12\xa0\xa5\xa0"
            "\xf1\xb3\xb0\xc2\xb0" }  },
      /* --- pixel bitmap for cmex250 char#88 \Bigsum --- */
      {  88,96857,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 46,   48, 2,129, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x00\x2a\x04\x2b\x04\x05\x1b\x0a\x04\x06\x1e\x06\x05"
            "\x06\x20\x04\x05\x06\x20\x03\x06\x05\x22\x02\x05\x06"
            "\x21\x02\x06\x06\x21\x01\x07\x06\x21\x01\x07\x05\x29"
            "\x06\x29\x06\x29\x06\x29\x05\x29\x06\x29\x06\x29\x06"
            "\x29\x05\x29\x06\x29\x06\x29\x06\x29\x05\x29\x06\x29"
            "\x05\x2a\x03\x2b\x02\x2b\x03\x2a\x03\x2a\x03\x2a\x03"
            "\x2a\x03\x2b\x02\x2b\x03\x2a\x03\x2a\x03\x2a\x03\x2a"
            "\x03\x22\x01\x08\x02\x22\x01\x08\x03\x22\x01\x07\x03"
            "\x22\x02\x06\x03\x21\x03\x06\x03\x21\x04\x05\x03\x20"
            "\x06\x05\x02\x1c\x0a\x05\x29\x04\x2a\x03\x2a\x04" }  },
      /* --- pixel bitmap for cmex250 char#89 \Bigprod --- */
      {  89,100070,                     /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 40,   48, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0e\x0c\x47\xe0\x47\x96\xe0\x46\x50\xfe\x65"
            "\xe0\x45\x60\xfe\x65\xe0\x45\x60\xf9\x65\xe0\x45\x60"
            "\x57\xe0\x27\x99\xe9\x4f\x1e\x03\x6e\x03" }  },
      /* --- pixel bitmap for cmex250 char#90 \Bigint --- */
      {  90,105524,                     /* character number, location */
          0, 2,  -77, 2,      /* topleft row,col, and botleft row,col */
          { 30,   77, 3,241, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xb3\xe0\xc1\x31\xe0\xa2\x32\xe0\x82\x33\xe0\x82"
            "\x41\x10\xf1\xe0\x72\x70\xe0\x63\x70\xf1\xe0\x62\x80"
            "\xf2\xe0\x53\x80\xe0\x52\x90\xf3\xe0\x43\x90\xf3\xe0"
            "\x33\xa0\xf1\xe0\x24\xa0\xf2\xe0\x23\xb0\xf2\xe0\x14"
            "\xb0\xe0\x13\xc0\xf4\xe4\xc0\xf4\xd4\xd0\xf4\xc4\xe0"
            "\xc3\xe0\x10\xf2\xb4\xe0\x10\xf2\xb3\xe0\x20\xf1\xa4"
            "\xe0\x20\xf3\xa3\xe0\x30\xf3\x93\xe0\x40\x92\xe0\x50"
            "\xf2\x83\xe0\x50\xf1\x82\xe0\x60\x73\xe0\x60\xf1\x72"
            "\xe0\x70\x11\x42\xe0\x83\x32\xe0\x82\x32\xe0\xa1\x31"
            "\xe0\xc3\xe0\xb3" }  },
      /* --- pixel bitmap for cmex250 char#91 \Bigcup --- */
      {  91,109698,                     /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\xe0\xe0\x22\x0f\xe2\xe0\xe0\x22\x0f\x42\xe0"
            "\xe0\x22\x03\xe0\xe3\xf1\x12\xe0\xe2\x10\x13\xe0\xc3"
            "\x33\xe0\xa3\x52\xe0\xa2\x63\xe0\x83\x73\xe0\x63\x93"
            "\xe0\x43\xb4\xe4\xe5\x85\xe0\x4e\xe0\x98\xd1" }  },
      /* --- pixel bitmap for cmex250 char#92 \Bigcap --- */
      {  92,111633,                     /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 3,98, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd8\xe0\x9e\xe0\x45\x85\xe4\xe4\xb3\xe0\x43\x93\xe0"
            "\x63\x73\xe0\x83\x62\xe0\xa2\x53\xe0\xa3\x33\xe0\xc3"
            "\x10\xf1\x12\xe0\xe2\x13\xe0\xe3\x0f\xe2\xe0\xe0\x22"
            "\x0f\xe2\xe0\xe0\x22\x0f\x42\xe0\xe0\x22" }  },
      /* --- pixel bitmap for cmex250 char#93 \Biguplus --- */
      {  93,113718,                     /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf9\x02\xe0\xe0\x22\x0f\xb2\xe2\xe2\x02\x2e\x0c\x24"
            "\x3e\x0a\x32\x0f\xa2\xe2\xe2\x03\xe0\xe3\xf1\x12\xe0"
            "\xe2\x10\x13\xe0\xc3\x33\xe0\xa3\x52\xe0\xa2\x63\xe0"
            "\x83\x73\xe0\x63\x93\xe0\x43\xb4\xe4\xe5\x85\xe0\x4e"
            "\xe0\x98\xd0" }  },
      /* --- pixel bitmap for cmex250 char#94 \Bigwedge --- */
      {  94,115637,                     /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 3,246, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x22\xe0\x20\xf2\xe0\x14\xe0\x10\xe6\xe0\xf1"
            "\xe2\x22\xe0\xd3\x23\xd0\xf1\xd2\x42\xd0\xc3\x43\xe0"
            "\xa2\x62\xe0\x93\x63\xb0\xf1\xb2\x82\xb0\xa3\x83\xa0"
            "\xf1\xa2\xa2\xa0\x93\xa3\x90\xf1\x92\xc2\x90\x83\xc3"
            "\x80\xf1\x82\xe2\x80\x73\xe3\x70\xf1\x72\xe0\x22\x70"
            "\x63\xe0\x23\x60\xf1\x62\xe0\x42\x60\x53\xe0\x43\x50"
            "\xf1\x52\xe0\x62\x50\x43\xe0\x63\x82\xe0\x82\x73\xe0"
            "\x83\x30\xf1\x32\xe0\xa2\x30\x23\xe0\xa3\x20\xf1\x22"
            "\xe0\xc2\x20\x13\xe0\xc3\x10\xf1\x12\xe0\xe2\x13\xe0"
            "\xe3\x0f\x12\xe0\xe0\x22" }  },
      /* --- pixel bitmap for cmex250 char#95 \Bigvee --- */
      {  95,117500,                     /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 3,247, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\xe0\x22\x03\xe0\xe3\xf1\x12\xe0\xe2\x10"
            "\x13\xe0\xc3\x10\xf1\x22\xe0\xc2\x20\x23\xe0\xa3\x20"
            "\xf1\x32\xe0\xa2\x30\x33\xe0\x83\x72\xe0\x82\x83\xe0"
            "\x63\x40\xf1\x52\xe0\x62\x50\x53\xe0\x43\x50\xf1\x62"
            "\xe0\x42\x60\x63\xe0\x23\x60\xf1\x72\xe0\x22\x70\x73"
            "\xe3\x70\xf1\x82\xe2\x80\x83\xc3\x80\xf1\x92\xc2\x90"
            "\x93\xa3\x90\xf1\xa2\xa2\xa0\xa3\x83\xa0\xf1\xb2\x82"
            "\xb0\xb3\x63\xe0\x92\x62\xe0\xa3\x43\xc0\xf1\xd2\x42"
            "\xd0\xd3\x23\xd0\xf1\xe2\x22\xe0\xe6\xe0\xf2\xe0\x14"
            "\xe0\x10\xf1\xe0\x22\xe0\x20" }  },
      /* --- pixel bitmap for cmex250 char#96 \coprod --- */
      {  96,101655,                     /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 29,   35, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0b\x7b\x35\xd5\x30\xfe\x43\xe0\x13\x40\xfd\x43"
            "\xe0\x13\x40\x34\xe0\x14\x3f\x1e\x0e\x01" }  },
      /* --- pixel bitmap for cmex250 char#97 \Bigcoprod --- */
      {  97,103347,                     /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 40,   48, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x03\x6e\x03\x49\xe9\x97\xe0\x27\x50\xfe\x65"
            "\xe0\x45\x60\xfe\x65\xe0\x45\x60\xf9\x65\xe0\x45\x60"
            "\x56\xe0\x46\x97\xe0\x47\x4f\x1e\x0e\x0c" }  },
      /* --- pixel bitmap for cmex250 char#98 ^ --- */
      {  98,118351,                     /* character number, location */
         26, 0,   20, 0,      /* topleft row,col, and botleft row,col */
          { 19,    6, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\xe0\x25\xc3\x33\x83\x73\x43\xb3\x12\xe0\x12" }  },
      /* --- pixel bitmap for cmex250 char#99 ^ --- */
      {  99,119232,                     /* character number, location */
         27, 0,   20, 0,      /* topleft row,col, and botleft row,col */
          { 35,    7, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x23\xe0\xe0\x19\xe0\x95\x55\xe0\x34\xd4\xb4\xe0"
            "\x54\x54\xe0\xb4\x11\xe0\xe0\x51" }  },
      /* --- pixel bitmap for cmex250 char#100 ^ --- */
      { 100,120326,                     /* character number, location */
         27, 0,   20, 0,      /* topleft row,col, and botleft row,col */
          { 50,    7, 2,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x17\x04\x2a\x0c\x21\x07\x08\x07\x18\x06\x12\x06\x10"
            "\x05\x1c\x05\x08\x05\x24\x05\x02\x02\x2e\x02" }  },
      /* --- pixel bitmap for cmex250 char#101 ~ --- */
      { 101,121049,                     /* character number, location */
         25, 0,   21, 0,      /* topleft row,col, and botleft row,col */
          { 19,    4, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\xa1\x28\x62\x22\x68\x21\xa4\x47" }  },
      /* --- pixel bitmap for cmex250 char#102 ~ --- */
      { 102,121973,                     /* character number, location */
         26, 0,   21, 0,      /* topleft row,col, and botleft row,col */
          { 35,    5, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\xe0\x51\x6b\xe3\x43\xa3\xa3\x43\xeb\x61\xe0\x56"
            "\x90" }  },
      /* --- pixel bitmap for cmex250 char#103 ~ --- */
      { 103,123112,                     /* character number, location */
         26, 0,   21, 0,      /* topleft row,col, and botleft row,col */
          { 50,    5, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd9\xe0\xc2\x87\x46\xe0\x63\x74\xe4\xe4\x73\xe0\x66"
            "\x47\x82\xe0\xc9\xd5" }  },
      /* --- pixel bitmap for cmex250 char#104 \Big[ --- */
      { 104,13863,                      /* character number, location */
          1, 8,  -60, 8,      /* topleft row,col, and botleft row,col */
          {  8,   61, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x08\x0f\xe2\x6f\xe2\x6f\xe2\x6f\xb2\x6f\x18" }  },
      /* --- pixel bitmap for cmex250 char#105 \Big] --- */
      { 105,20148,                      /* character number, location */
          1, 0,  -60, 0,      /* topleft row,col, and botleft row,col */
          {  8,   61, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x08\xfe\x62\xfe\x62\xfe\x62\xfb\x62\x0f\x18" }  },
      /* --- pixel bitmap for cmex250 char#106 (noname) --- */
      { 106,26380,                      /* character number, location */
          1, 8,  -60, 8,      /* topleft row,col, and botleft row,col */
          { 10,   61, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3a\x00\x02\x08\xff\x01\x0a" }  },
      /* --- pixel bitmap for cmex250 char#107 (noname) --- */
      { 107,30186,                      /* character number, location */
          1, 0,  -60, 0,      /* topleft row,col, and botleft row,col */
          { 10,   61, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3a\x08\x02\x00\xff\x01\x0a" }  },
      /* --- pixel bitmap for cmex250 char#108 (noname) --- */
      { 108,33996,                      /* character number, location */
          1, 8,  -60, 8,      /* topleft row,col, and botleft row,col */
          { 10,   61, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0a\x00\xff\x3a\x02\x08" }  },
      /* --- pixel bitmap for cmex250 char#109 (noname) --- */
      { 109,37810,                      /* character number, location */
          1, 0,  -60, 0,      /* topleft row,col, and botleft row,col */
          { 10,   61, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0a\xff\x3a\x08\x02" }  },
      /* --- pixel bitmap for cmex250 char#110 \Big{ --- */
      { 110,41840,                      /* character number, location */
          1, 4,  -60, 4,      /* topleft row,col, and botleft row,col */
          { 15,   61, 3,82, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc3\xa5\x94\xa3\x40\xf1\x72\x60\xfe\x62\x70\xf3\x62"
            "\x70\xf1\x52\x80\x42\xb3\xb3\xb3\xd3\xd3\xe2\x90\xf1"
            "\x52\x80\xfe\x62\x70\xf3\x62\x70\xf1\x72\x60\x83\xd4"
            "\xc5\xc3" }  },
      /* --- pixel bitmap for cmex250 char#111 \Big} --- */
      { 111,49908,                      /* character number, location */
          1, 4,  -60, 4,      /* topleft row,col, and botleft row,col */
          { 15,   61, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xc4\xd3\xe2\xe2\xd3\x70\xfe\x62\x70\xf3\x62\x70"
            "\xf1\x72\x60\x83\xd3\xe4\xc3\xb4\x93\xb3\x40\xf1\x72"
            "\x60\xfe\x62\x70\xf3\x62\x70\x53\xc2\xc2\xb3\xa4\xb3"
            "\xc5" }  },
      /* --- pixel bitmap for cmex250 char#112 (noname) --- */
      { 112,78472,                      /* character number, location */
          2, 4,  -40, 4,      /* topleft row,col, and botleft row,col */
          { 33,   42, 2,121, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1f\x02\x1e\x03\x1e\x02\x1e\x03\x1e\x02\x1e\x03\x1e"
            "\x02\x1e\x03\x1e\x02\x1e\x03\x1e\x02\x1e\x03\x1e\x02"
            "\x1e\x03\x1e\x02\x1e\x03\x1e\x02\x1e\x03\x1e\x02\x1e"
            "\x03\x1e\x02\x0d\x01\x10\x03\x0c\x03\x0f\x02\x0b\x02"
            "\x01\x02\x0e\x03\x0f\x01\x0e\x02\x10\x02\x0c\x03\x10"
            "\x02\x0c\x02\x12\x02\x0a\x03\x12\x02\x0a\x02\x14\x02"
            "\x08\x03\x14\x02\x08\x02\x16\x02\x06\x03\x16\x02\x06"
            "\x02\x17\x02\x05\x03\x18\x02\x04\x02\x19\x02\x03\x03"
            "\x1a\x02\x02\x02\x1b\x02\x01\x03\x1b\x05\x1d\x04\x1d"
            "\x03\x1f\x02\x14" }  },
      /* --- pixel bitmap for cmex250 char#113 (noname) --- */
      { 113,79501,                      /* character number, location */
          2, 4,  -61, 4,      /* topleft row,col, and botleft row,col */
          { 33,   63, 3,321, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\xe0\x32\xe0\xe0\x23\xf1\xe0\xe0\x22\x10\xe0"
            "\xe0\x13\x10\xf1\xe0\xe0\x12\x20\xe0\xe3\x20\xf1\xe0"
            "\xe2\x30\xe0\xd3\x30\xf1\xe0\xd2\x40\xe0\xc3\x40\xf1"
            "\xe0\xc2\x50\xe0\xb3\x50\xf1\xe0\xb2\x60\xe0\xa3\x60"
            "\xf1\xe0\xa2\x70\xe0\x93\x70\xf1\xe0\x92\x80\xe0\x83"
            "\x80\xf1\xe0\x82\x90\xe0\x73\x90\xf1\xe0\x72\xa0\x31"
            "\xe0\x32\xc3\xe0\x13\xb4\xe0\x12\xb2\x12\xe0\x12\xe2"
            "\xe3\xb0\xf1\x42\xd2\xc0\x42\xc3\xc0\xf1\x52\xb2\xd0"
            "\x52\xa3\xe0\x42\xa2\xe0\x62\x92\xe0\x62\x83\xe0\x62"
            "\x82\xe0\x82\x72\xe0\x82\x63\xe0\x10\xf1\x72\x62\xe0"
            "\x20\x82\x43\xe0\x20\xf1\x82\x42\xe0\x30\x92\x23\xe0"
            "\x30\xf1\x92\x22\xe0\x40\x92\x13\xe0\x40\xf2\xa4\xe0"
            "\x50\xf1\xb2\xe0\x60" }  },
      /* --- pixel bitmap for cmex250 char#114 (noname) --- */
      { 114,80591,                      /* character number, location */
          2, 4,  -82, 4,      /* topleft row,col, and botleft row,col */
          { 33,   84, 3,347, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\xe0\x32\xe0\xe0\x23\xf2\xe0\xe0\x22\x10\xe0"
            "\xe0\x13\x10\xf2\xe0\xe0\x12\x20\xe0\xe3\x20\xf2\xe0"
            "\xe2\x30\xe0\xd3\x30\xf2\xe0\xd2\x40\xe0\xc3\x40\xf2"
            "\xe0\xc2\x50\xe0\xb3\x50\xf2\xe0\xb2\x60\xe0\xa3\x60"
            "\xf2\xe0\xa2\x70\xe0\x93\x70\xf2\xe0\x92\x80\xe0\x83"
            "\x80\xf2\xe0\x82\x90\xe0\x73\x90\xf2\xe0\x72\xa0\x31"
            "\xe0\x32\xc3\xe0\x13\xc3\xe0\x12\xc1\x12\xe0\x12\xb1"
            "\x22\xe0\x12\xe2\xe3\xb0\xf2\x42\xd2\xc0\x42\xc3\xe0"
            "\x22\xc2\xd0\xf1\x52\xb2\xd0\x52\xa3\xe0\x42\xa2\xe0"
            "\xf1\x62\x92\xe0\x62\x83\xe0\xf1\x62\x82\xe0\x10\x72"
            "\x72\xe0\x82\x63\xe0\x10\xf2\x72\x62\xe0\x20\x82\x43"
            "\xe0\x20\xf2\x82\x42\xe0\x30\x92\x23\xe0\x30\xf2\x92"
            "\x22\xe0\x40\x92\x13\xe0\x40\xf3\xa4\xe0\x50\xa3\xe0"
            "\x60\xf1\xb2\xe0\x62" }  },
      /* --- pixel bitmap for cmex250 char#115 (noname) --- */
      { 115,81741,                      /* character number, location */
          2, 4,  -102, 4,     /* topleft row,col, and botleft row,col */
          { 33,  104, 3,363, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf2\xe0\xe0\x32\xe0\xe0\x23\xf3\xe0\xe0\x22\x10\xe0"
            "\xe0\x13\x10\xf3\xe0\xe0\x12\x20\xe0\xe3\x20\xf3\xe0"
            "\xe2\x30\xe0\xd3\x30\xf3\xe0\xd2\x40\xe0\xc3\x40\xf4"
            "\xe0\xc2\x50\xe0\xb3\x50\xf3\xe0\xb2\x60\xe0\xa3\x60"
            "\xf3\xe0\xa2\x70\xe0\x93\x70\xf3\xe0\x92\x80\xe0\x83"
            "\x80\xf3\xe0\x82\x90\xe0\x73\x90\xf2\xe0\x72\xa0\x31"
            "\xe0\x32\xd1\xe0\x23\xa0\xf1\x23\xe0\x12\xb0\x11\x12"
            "\xe0\x12\xb2\x12\xe0\x12\xb1\x22\xe3\xe2\xe2\xc0\xf2"
            "\x42\xd2\xc0\x42\xc3\xe0\x22\xc2\xd0\xf2\x52\xb2\xd0"
            "\x52\xa3\xd0\xf1\x52\xa2\xe0\xf1\x62\x92\xe0\x62\x83"
            "\xe0\xf2\x62\x82\xe0\x10\xf1\x72\x72\xe0\x10\x72\x63"
            "\xe0\x10\xf2\x72\x62\xe0\x20\x82\x52\xe0\xa2\x43\xe0"
            "\x20\xf3\x82\x42\xe0\x30\x92\x23\xe0\x30\xf3\x92\x22"
            "\xe0\x40\xa5\xe0\x40\xf4\xa4\xe0\x50\xf2\xb2\xe0\x60" }  },
      /* --- pixel bitmap for cmex250 char#116 (noname) --- */
      { 116,82989,                      /* character number, location */
          1, 4,  -62, 4,      /* topleft row,col, and botleft row,col */
          { 22,   63, 3,145, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf7\xe0\x62\x31\xe0\x22\x32\xe0\x12\xf1\x23\xe0\x12"
            "\xf1\x11\x22\xe2\x01\x32\xe2\xf2\x52\xd2\xf2\x62\xc2"
            "\xf2\x72\xb2\xf2\x82\xa2\xf2\x92\x92\xf2\xa2\x82\xf3"
            "\xb2\x72\xf2\xc2\x62\xf2\xd2\x52\xf2\xe2\x42\xf2\xe0"
            "\x12\x32\xf2\xe0\x22\x22\xf2\xe0\x32\x12\xf2\xe0\x44"
            "\xf2\xe0\x53\xe0\x62\xe0\x61\x10" }  },
      /* --- pixel bitmap for cmex250 char#117 (noname) --- */
      { 117,84004,                      /* character number, location */
          1,24,  -22,24,      /* topleft row,col, and botleft row,col */
          {  2,   23, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x0f\x72" }  },
      /* --- pixel bitmap for cmex250 char#118 (noname) --- */
      { 118,84841,                      /* character number, location */
          2,24,  -20,24,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x01\x0f\xe2\xdf\x42\xd0" }  },
      /* --- pixel bitmap for cmex250 char#119 (noname) --- */
      { 119,77471,                      /* character number, location */
          1,10,  -22,10,      /* topleft row,col, and botleft row,col */
          {  8,   23, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x42\x0f\x72\x42" }  },
      /* --- pixel bitmap for cmex250 char#120 (noname) --- */
      { 120,72625,                      /* character number, location */
         -1, 4,  -21, 4,      /* topleft row,col, and botleft row,col */
          { 16,   20, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\xd4\xb6\x83\x12\x13\x53\x22\x23\x24\x32\x36\x52"
            "\x52\xfc\x72\x73" }  },
      /* --- pixel bitmap for cmex250 char#121 (noname) --- */
      { 121,73580,                      /* character number, location */
          0, 4,  -20, 4,      /* topleft row,col, and botleft row,col */
          { 16,   20, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x72\x72\x52\x56\x32\x34\x23\x22\x23\x53\x12\x13"
            "\x86\xb4\xd2\x73" }  },
      /* --- pixel bitmap for cmex250 char#122 (noname) --- */
      { 122,55830,                      /* character number, location */
          5,-1,   -7,-1,      /* topleft row,col, and botleft row,col */
          { 18,   12, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd5\xa8\x8a\x6c\x5d\x48\x95\xc4\xd4\xe3\xe3\xe0\x12"
            "\xe0\x21" }  },
      /* --- pixel bitmap for cmex250 char#123 (noname) --- */
      { 123,56422,                      /* character number, location */
          5,-1,   -7,-1,      /* topleft row,col, and botleft row,col */
          { 18,   12, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xd8\xaa\x8c\x6d\xb8\xe5\xe0\x14\xe0\x14\xe0\x13"
            "\xe0\x23\xe0\x22" }  },
      /* --- pixel bitmap for cmex250 char#124 (noname) --- */
      { 124,57011,                      /* character number, location */
         12,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 18,   12, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x23\xe0\x23\xe0\x14\xe0\x14\xe0\x15\xe8\xbd"
            "\x6c\x8a\xa8\xd5" }  },
      /* --- pixel bitmap for cmex250 char#125 (noname) --- */
      { 125,57601,                      /* character number, location */
         12,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 18,   12, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x22\xe0\x13\xe3\xe4\xd4\xc5\x98\x4d\x5c\x6a\x88"
            "\xa5\xda" }  },
      /* --- pixel bitmap for cmex250 char#126 (noname) --- */
      { 126,75403,                      /* character number, location */
         -1, 3,  -21, 3,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xa2\xa0\x94\xe0\x32\x22\xe0\x13\x23\xd3\x43\xb4"
            "\x44\x95\x45\x64\x12\x42\x14\x24\x32\x42\x36\x52\x42"
            "\x52\xf8\x72\x42\x72" }  },
      /* --- pixel bitmap for cmex250 char#127 (noname) --- */
      { 127,76541,                      /* character number, location */
          0, 3,  -20, 3,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x72\x42\x72\x52\x42\x56\x32\x42\x34\x24\x12\x42"
            "\x14\x65\x45\x94\x44\xb3\x43\xd3\x23\xe0\x12\x22\xe0"
            "\x34\x90\xf1\xa2\xa2" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* ------------------------------------------------------------------------
font sizes 0-7 for bbold10
------------------------------------------------------------------------ */

/* --- size=0 for .83gf ---
 * mf '\mode=eighthre;  input bbold10'
 * --------------------------------------------------------------------- */
/* --- fontdef for bbold83 --- */
static	chardef  bbold83[] =
   {
      /* --- pixel bitmap for bbold83 char#0 \Gamma --- */
      {   0,   35,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\x62\x40" }  },
      /* --- pixel bitmap for bbold83 char#1 \Delta --- */
      {   1,   58,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x87\x63\x32\x0d\xff" }  },
      /* --- pixel bitmap for bbold83 char#2 \Theta --- */
      {   2,   87,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x34\xee\xe3\x28\x31" }  },
      /* --- pixel bitmap for bbold83 char#3 \Lambda --- */
      {   3,  122,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x87\x63\x32\x0d\x87" }  },
      /* --- pixel bitmap for bbold83 char#4 \Xi --- */
      {   4,  153,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x00\x00\x03\x00\x00\xfe" }  },
      /* --- pixel bitmap for bbold83 char#5 \Pi --- */
      {   5,  170,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\x62\x31" }  },
      /* --- pixel bitmap for bbold83 char#6 \Sigma --- */
      {   6,  207,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\x61\x30\x8c\x61\xfc" }  },
      /* --- pixel bitmap for bbold83 char#7 \Upsilon --- */
      {   7,  230,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\xdb\x32\x0c\xc3\x30" }  },
      /* --- pixel bitmap for bbold83 char#8 \Phi --- */
      {   8,  263,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xe3\xb5\xad\xc7\x30" }  },
      /* --- pixel bitmap for bbold83 char#9 \Psi --- */
      {   9,  294,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xd3\x7a\x1e\xc3\x30" }  },
      /* --- pixel bitmap for bbold83 char#10 \Omega --- */
      {  10,  321,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x34\x8e\xe3\x38\xce" }  },
      /* --- pixel bitmap for bbold83 char#11 \alpha --- */
      {  11,  358,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\x3a\x4f\x3e" }  },
      /* --- pixel bitmap for bbold83 char#12 \beta --- */
      {  12,  385,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\xce\x35\xe7\x7c\x63\x00" }  },
      /* --- pixel bitmap for bbold83 char#13 \gamma --- */
      {  13,  424,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdb\xa9\x39\xa7\x03" }  },
      /* --- pixel bitmap for bbold83 char#14 \delta --- */
      {  14,  455,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x06\x37\xe7\x74" }  },
      /* --- pixel bitmap for bbold83 char#15 \epsilon --- */
      {  15,  486,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x9e\xe9\x00" }  },
      /* --- pixel bitmap for bbold83 char#16 \zeta --- */
      {  16,  507,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x32\x33\x63\x48" }  },
      /* --- pixel bitmap for bbold83 char#17 \eta --- */
      {  17,  534,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xce\x39\x21\x04" }  },
      /* --- pixel bitmap for bbold83 char#18 \theta --- */
      {  18,  563,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xce\x3f\xe7\x74" }  },
      /* --- pixel bitmap for bbold83 char#19 \iota --- */
      {  19,  596,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x02" }  },
      /* --- pixel bitmap for bbold83 char#20 \kappa --- */
      {  20,  613,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x9d\xb1\x01" }  },
      /* --- pixel bitmap for bbold83 char#21 \lambda --- */
      {  21,  634,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x18\xc3\x9c\xce" }  },
      /* --- pixel bitmap for bbold83 char#22 \mu --- */
      {  22,  661,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\xce\xf9\xc7\x00" }  },
      /* --- pixel bitmap for bbold83 char#23 \nu --- */
      {  23,  690,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\xae\x37\x00" }  },
      /* --- pixel bitmap for bbold83 char#24 \xi --- */
      {  24,  713,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e\x63\x33\x63\x48" }  },
      /* --- pixel bitmap for bbold83 char#25 \pi --- */
      {  25,  740,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\x39\xe7\x00" }  },
      /* --- pixel bitmap for bbold83 char#26 \rho --- */
      {  26,  757,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xce\xf9\xc6\x00" }  },
      /* --- pixel bitmap for bbold83 char#27 \sigma --- */
      {  27,  784,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x34\x4d\x0e" }  },
      /* --- pixel bitmap for bbold83 char#28 \tau --- */
      {  28,  807,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\x66\x04" }  },
      /* --- pixel bitmap for bbold83 char#29 \upsilon --- */
      {  29,  824,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\xce\xe9\x00" }  },
      /* --- pixel bitmap for bbold83 char#30 \phi --- */
      {  30,  849,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x66\xff\x6f\x66" }  },
      /* --- pixel bitmap for bbold83 char#31 \chi --- */
      {  31,  876,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x59\x3b\xe6\xdc\x04" }  },
      /* --- pixel bitmap for bbold83 char#32 \psi --- */
      {  32,  903,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xf6\xff\x6f\x66" }  },
      /* --- pixel bitmap for bbold83 char#33 ! --- */
      {  33, 2697,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  2,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff" }  },
      /* --- pixel bitmap for bbold83 char#34 (noname) --- */
      {  34, 3464,                      /* character number, location */
          8, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  5,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7b\xcb\x04" }  },
      /* --- pixel bitmap for bbold83 char#35 # --- */
      {  35, 2720,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,   10, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x23\x27\x23\x27\xf3\x23\x21" }  },
      /* --- pixel bitmap for bbold83 char#36 $ --- */
      {  36, 2747,                      /* character number, location */
          9, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\xd7\x36\x1e\xcb\xb6\x1e\x03" }  },
      /* --- pixel bitmap for bbold83 char#37 % --- */
      {  37, 2788,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x8c\x61\x18\xc3\x30\x86\x61\xcc\x33" }  },
      /* --- pixel bitmap for bbold83 char#38 & --- */
      {  38, 2829,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x14\x14\x0c\x0b\x4b\xb3\x7e" }  },
      /* --- pixel bitmap for bbold83 char#39 ' --- */
      {  39, 2866,                      /* character number, location */
          8, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  2,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f" }  },
      /* --- pixel bitmap for bbold83 char#40 ( --- */
      {  40, 2881,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xde\xb6\x6d\xdb\x0c" }  },
      /* --- pixel bitmap for bbold83 char#41 ) --- */
      {  41, 2912,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb3\x6d\xdb\xb6\x07" }  },
      /* --- pixel bitmap for bbold83 char#42 * --- */
      {  42, 2943,                      /* character number, location */
          7, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xd3\x7a\x5e\xcb\x30" }  },
      /* --- pixel bitmap for bbold83 char#43 + --- */
      {  43, 2974,                      /* character number, location */
          7, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x22\x37\xf3\x22\x31" }  },
      /* --- pixel bitmap for bbold83 char#44 , --- */
      {  44, 2997,                      /* character number, location */
          2, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  2,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f" }  },
      /* --- pixel bitmap for bbold83 char#45 - --- */
      {  45, 3012,                      /* character number, location */
          3, 0,    2, 0,      /* topleft row,col, and botleft row,col */
          {  4,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for bbold83 char#46 . --- */
      {  46, 3021,                      /* character number, location */
          2, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for bbold83 char#47 / --- */
      {  47, 3032,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x8c\x61\x18\xc3\x18\x86\x31\x0c" }  },
      /* --- pixel bitmap for bbold83 char#48 0 --- */
      {  48,  961,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xce\x39\xa7\x03" }  },
      /* --- pixel bitmap for bbold83 char#49 1 --- */
      {  49,  992,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\xd3\x30\x0c\xf3\x03" }  },
      /* --- pixel bitmap for bbold83 char#50 2 --- */
      {  50, 1015,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x67\x64\xc2\x07" }  },
      /* --- pixel bitmap for bbold83 char#51 3 --- */
      {  51, 1040,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\x67\x96\xb3\x03" }  },
      /* --- pixel bitmap for bbold83 char#52 4 --- */
      {  52, 1069,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x31\xe7\x3e\x03" }  },
      /* --- pixel bitmap for bbold83 char#53 5 --- */
      {  53, 1090,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x41\x18\xa3\x03" }  },
      /* --- pixel bitmap for bbold83 char#54 6 --- */
      {  54, 1115,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\xcf\x39\xa7\x03" }  },
      /* --- pixel bitmap for bbold83 char#55 7 --- */
      {  55, 1144,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x33\x66\xcc\x00" }  },
      /* --- pixel bitmap for bbold83 char#56 8 --- */
      {  56, 1165,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x4e\x37\xa7\x03" }  },
      /* --- pixel bitmap for bbold83 char#57 9 --- */
      {  57, 1194,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xce\x39\xbf\x03" }  },
      /* --- pixel bitmap for bbold83 char#58 : --- */
      {  58, 3063,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  2,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x03" }  },
      /* --- pixel bitmap for bbold83 char#59 ; --- */
      {  59, 3080,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  2,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x1b" }  },
      /* --- pixel bitmap for bbold83 char#60 < --- */
      {  60, 3101,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x38\x06\x0a\x3c\xf0" }  },
      /* --- pixel bitmap for bbold83 char#61 \cdot --- */
      {  61, 3122,                      /* character number, location */
          4, 0,    2, 0,      /* topleft row,col, and botleft row,col */
          {  2,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for bbold83 char#62 > --- */
      {  62, 3133,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x1c\xe0\x70\x1c\x07" }  },
      /* --- pixel bitmap for bbold83 char#63 ? --- */
      {  63, 3152,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x62\x0c\xc3\x30" }  },
      /* --- pixel bitmap for bbold83 char#64 @ --- */
      {  64, 3179,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xce\xbd\xe7\x74" }  },
      /* --- pixel bitmap for bbold83 char#65 A --- */
      {  65, 1223,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xc3\x58\x96\xf5\x8f" }  },
      /* --- pixel bitmap for bbold83 char#66 B --- */
      {  66, 1254,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\x38\x7e\xe3\x38\x7e" }  },
      /* --- pixel bitmap for bbold83 char#67 C --- */
      {  67, 1287,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x38\x0e\xc3\x28\x72" }  },
      /* --- pixel bitmap for bbold83 char#68 D --- */
      {  68, 1318,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\x34\x8e\xe3\x38\x3d" }  },
      /* --- pixel bitmap for bbold83 char#69 E --- */
      {  69, 1353,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x30\x3c\xc3\x30\xfc" }  },
      /* --- pixel bitmap for bbold83 char#70 F --- */
      {  70, 1376,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x30\x3c\xc3\x30\x0c" }  },
      /* --- pixel bitmap for bbold83 char#71 G --- */
      {  71, 1399,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x38\x0e\xfb\x28\x72" }  },
      /* --- pixel bitmap for bbold83 char#72 H --- */
      {  72, 1432,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe3\x38\xfe\xe3\x38\x8e" }  },
      /* --- pixel bitmap for bbold83 char#73 I --- */
      {  73, 1469,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  2,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff" }  },
      /* --- pixel bitmap for bbold83 char#74 J --- */
      {  74, 1492,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x0c\xc3\x70\x1c\x39" }  },
      /* --- pixel bitmap for bbold83 char#75 K --- */
      {  75, 1519,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe3\xb4\x2c\xcf\x34\x8d" }  },
      /* --- pixel bitmap for bbold83 char#76 L --- */
      {  76, 1556,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x02\x46" }  },
      /* --- pixel bitmap for bbold83 char#77 M --- */
      {  77, 1579,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xf1\x75\x39\x1c\x0e\x87" }  },
      /* --- pixel bitmap for bbold83 char#78 N --- */
      {  78, 1622,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\x38\x9e\xeb\x3c\x8f" }  },
      /* --- pixel bitmap for bbold83 char#79 O --- */
      {  79, 1663,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x34\x8e\xe3\x28\x31" }  },
      /* --- pixel bitmap for bbold83 char#80 P --- */
      {  80, 1698,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\x38\x7e\xc3\x30\x0c" }  },
      /* --- pixel bitmap for bbold83 char#81 Q --- */
      {  81, 1725,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x34\x8e\xe3\xa8\x31\x10\x08" }  },
      /* --- pixel bitmap for bbold83 char#82 R --- */
      {  82, 1764,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\x38\x7e\xcb\x34\x8d" }  },
      /* --- pixel bitmap for bbold83 char#83 S --- */
      {  83, 1799,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xde\x38\x7a\x60\x18\x7a" }  },
      /* --- pixel bitmap for bbold83 char#84 T --- */
      {  84, 1830,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 3, 7, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xf6\x22\x21" }  },
      /* --- pixel bitmap for bbold83 char#85 U --- */
      {  85, 1853,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe3\x38\x8e\xe3\x28\x31" }  },
      /* --- pixel bitmap for bbold83 char#86 V --- */
      {  86, 1890,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc3\xa1\xc9\xc4\xe1\x20\x10" }  },
      /* --- pixel bitmap for bbold83 char#87 W --- */
      {  87, 1921,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x07\x1a\xb2\xe4\xc9\x15\x1b\x22" }  },
      /* --- pixel bitmap for bbold83 char#88 X --- */
      {  88, 1964,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\xa6\x31\x8c\x65\x8d" }  },
      /* --- pixel bitmap for bbold83 char#89 Y --- */
      {  89, 1999,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa3\x65\x31\x0c\xc3\x30" }  },
      /* --- pixel bitmap for bbold83 char#90 Z --- */
      {  90, 2028,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x86\x31\x8c\x61\xfc" }  },
      /* --- pixel bitmap for bbold83 char#91 [ --- */
      {  91, 3214,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,   12, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x0f\x92\x13" }  },
      /* --- pixel bitmap for bbold83 char#92 \\ --- */
      {  92, 3245,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc3\x60\x18\x06\xc3\x60\x18\x06\xc3" }  },
      /* --- pixel bitmap for bbold83 char#93 ] --- */
      {  93, 3276,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,   12, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xf9\x12\x03" }  },
      /* --- pixel bitmap for bbold83 char#94 (noname) --- */
      {  94, 3307,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\xed\xd6\x36\x09" }  },
      /* --- pixel bitmap for bbold83 char#95 (noname) --- */
      {  95, 3342,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc9\xb6\x76\x5b\x02" }  },
      /* --- pixel bitmap for bbold83 char#96 (noname) --- */
      {  96, 3377,                      /* character number, location */
          8, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  2,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6" }  },
      /* --- pixel bitmap for bbold83 char#97 a --- */
      {  97, 2051,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\xce\xe9\x01" }  },
      /* --- pixel bitmap for bbold83 char#98 b --- */
      {  98, 2074,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc3\x30\x7c\xe3\x38\x7e" }  },
      /* --- pixel bitmap for bbold83 char#99 c --- */
      {  99, 2103,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\x8e\xe9\x00" }  },
      /* --- pixel bitmap for bbold83 char#100 d --- */
      { 100, 2124,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x42\x3f\xe7\xf4" }  },
      /* --- pixel bitmap for bbold83 char#101 e --- */
      { 101, 2153,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xfe\xe9\x00" }  },
      /* --- pixel bitmap for bbold83 char#102 f --- */
      { 102, 2174,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb6\x73\x33\x33" }  },
      /* --- pixel bitmap for bbold83 char#103 g --- */
      { 103, 2199,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\xce\xe9\xe1\x03" }  },
      /* --- pixel bitmap for bbold83 char#104 h --- */
      { 104, 2226,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x8c\x37\xe7\x9c" }  },
      /* --- pixel bitmap for bbold83 char#105 i --- */
      { 105, 2257,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  2,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcf\xff" }  },
      /* --- pixel bitmap for bbold83 char#106 j --- */
      { 106, 2280,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xcc\xc0\xcc\xcc\x7c" }  },
      /* --- pixel bitmap for bbold83 char#107 k --- */
      { 107, 2307,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x8c\xb9\xce\x9a" }  },
      /* --- pixel bitmap for bbold83 char#108 l --- */
      { 108, 2338,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  2,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xbf" }  },
      /* --- pixel bitmap for bbold83 char#109 m --- */
      { 109, 2361,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\xed\x74\x3a\x05" }  },
      /* --- pixel bitmap for bbold83 char#110 n --- */
      { 110, 2394,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xce\x39\x01" }  },
      /* --- pixel bitmap for bbold83 char#111 o --- */
      { 111, 2419,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xce\xe9\x00" }  },
      /* --- pixel bitmap for bbold83 char#112 p --- */
      { 112, 2442,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\x38\x8e\xdf\x30\x00" }  },
      /* --- pixel bitmap for bbold83 char#113 q --- */
      { 113, 2469,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\xce\xe9\x21\x04" }  },
      /* --- pixel bitmap for bbold83 char#114 r --- */
      { 114, 2496,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\x8e\x31\x00" }  },
      /* --- pixel bitmap for bbold83 char#115 s --- */
      { 115, 2515,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb6\x96\x06" }  },
      /* --- pixel bitmap for bbold83 char#116 t --- */
      { 116, 2536,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\xf3\x33\x6b" }  },
      /* --- pixel bitmap for bbold83 char#117 u --- */
      { 117, 2561,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\xce\xe9\x01" }  },
      /* --- pixel bitmap for bbold83 char#118 v --- */
      { 118, 2586,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\x39\x46\x00" }  },
      /* --- pixel bitmap for bbold83 char#119 w --- */
      { 119, 2607,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc3\xa1\xcb\x46\x02" }  },
      /* --- pixel bitmap for bbold83 char#120 x --- */
      { 120, 2634,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd9\x19\x37\x01" }  },
      /* --- pixel bitmap for bbold83 char#121 y --- */
      { 121, 2655,                      /* character number, location */
          5, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\x39\x42\x44\x00" }  },
      /* --- pixel bitmap for bbold83 char#122 z --- */
      { 122, 2680,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x19\xf3\x01" }  },
      /* --- pixel bitmap for bbold83 char#123 \- --- */
      { 123, 3423,                      /* character number, location */
          3, 0,    2, 0,      /* topleft row,col, and botleft row,col */
          {  4,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f" }  },
      /* --- pixel bitmap for bbold83 char#124 | --- */
      { 124, 3392,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  2,   12, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x02" }  },
      /* --- pixel bitmap for bbold83 char#125 (noname) --- */
      { 125, 3432,                      /* character number, location */
          3, 0,    2, 0,      /* topleft row,col, and botleft row,col */
          {  9,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09" }  },
      /* --- pixel bitmap for bbold83 char#126 (noname) --- */
      { 126, 3441,                      /* character number, location */
          8, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  5,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\xed\x0d" }  },
      /* --- pixel bitmap for bbold83 char#127 \omega --- */
      { 127,  930,                      /* character number, location */
          5, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\xe1\x72\x69\x03" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=1 for .100gf ---
 * mf '\mode=preview; mag=magstep(-17.87427405946994351363); input bbold10'
 * --------------------------------------------------------------------- */
/* --- fontdef for bbold100 --- */
static	chardef  bbold100[] =
   {
      /* --- pixel bitmap for bbold100 char#0 \Gamma --- */
      {   0,  246,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\x61\x11\x43\x40" }  },
      /* --- pixel bitmap for bbold100 char#1 \Delta --- */
      {   1,  496,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x85\xa2\x51\xa9\x8a\x7f" }  },
      /* --- pixel bitmap for bbold100 char#2 \Theta --- */
      {   2,  750,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x85\xb5\x85\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold100 char#3 \Lambda --- */
      {   3, 1013,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x85\xa2\x51\xa9\x8a\x47" }  },
      /* --- pixel bitmap for bbold100 char#4 \Xi --- */
      {   4, 1266,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xf2\x70\x23\x20\xf2\x77" }  },
      /* --- pixel bitmap for bbold100 char#5 \Pi --- */
      {   5, 1491,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\x61\x11\x31\x03\x31" }  },
      /* --- pixel bitmap for bbold100 char#6 \Sigma --- */
      {   6, 1757,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0a\x0a\x14\x28\x14\x0a\x0a\xff" }  },
      /* --- pixel bitmap for bbold100 char#7 \Upsilon --- */
      {   7, 2009,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\x6a\x95\xc2\xa1\x50\x28\x1c" }  },
      /* --- pixel bitmap for bbold100 char#8 \Phi --- */
      {   8, 2265,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x8a\xad\x5a\xad\xda\x28\x1c" }  },
      /* --- pixel bitmap for bbold100 char#9 \Psi --- */
      {   9, 2525,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x4a\xd5\x66\xb5\x51\x28\x1c" }  },
      /* --- pixel bitmap for bbold100 char#10 \Omega --- */
      {  10, 2781,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x85\x85\x85\x85\x46\xe7" }  },
      /* --- pixel bitmap for bbold100 char#11 \alpha --- */
      {  11, 3043,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xce\x6a\xb5\x56\xf2\x03" }  },
      /* --- pixel bitmap for bbold100 char#12 \beta --- */
      {  12, 3294,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x59\x96\x55\x59\x96\x65\x57\x14\x07" }  },
      /* --- pixel bitmap for bbold100 char#13 \gamma --- */
      {  13, 3574,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x63\x95\x65\x59\x5a\x0c" }  },
      /* --- pixel bitmap for bbold100 char#14 \delta --- */
      {  14, 3830,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x0c\x4e\x55\x96\xa5\x07" }  },
      /* --- pixel bitmap for bbold100 char#15 \epsilon --- */
      {  15, 4088,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\xd9\x14\xa5\x07" }  },
      /* --- pixel bitmap for bbold100 char#16 \zeta --- */
      {  16, 4329,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x90\x11\x53\x4a\x29\x86\x41\x88\x00" }  },
      /* --- pixel bitmap for bbold100 char#17 \eta --- */
      {  17, 4579,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5f\x59\x96\xe5\x09\x82\x20" }  },
      /* --- pixel bitmap for bbold100 char#18 \theta --- */
      {  18, 4833,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x55\x96\x7d\x59\x96\x16\x03" }  },
      /* --- pixel bitmap for bbold100 char#19 \iota --- */
      {  19, 5096,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\x5b\x01" }  },
      /* --- pixel bitmap for bbold100 char#20 \kappa --- */
      {  20, 5334,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\x57\x34\xd5\x09" }  },
      /* --- pixel bitmap for bbold100 char#21 \lambda --- */
      {  21, 5579,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\xa1\x28\x0a\x45\x59\x6a\x0e" }  },
      /* --- pixel bitmap for bbold100 char#22 \mu --- */
      {  22, 5834,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\x59\x96\x65\x5f\x14\x07" }  },
      /* --- pixel bitmap for bbold100 char#23 \nu --- */
      {  23, 6091,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\x59\x56\xcd\x01" }  },
      /* --- pixel bitmap for bbold100 char#24 \xi --- */
      {  24, 6334,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x94\xe2\x4c\x29\x86\x41\x88\x00" }  },
      /* --- pixel bitmap for bbold100 char#25 \pi --- */
      {  25, 6583,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\xa6\x69\x9a\x07" }  },
      /* --- pixel bitmap for bbold100 char#26 \rho --- */
      {  26, 6819,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x59\x96\x65\x57\x14\x07" }  },
      /* --- pixel bitmap for bbold100 char#27 \sigma --- */
      {  27, 7077,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x52\xa9\x54\xf2\x00" }  },
      /* --- pixel bitmap for bbold100 char#28 \tau --- */
      {  28, 7321,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5f\x29\xa5\x18" }  },
      /* --- pixel bitmap for bbold100 char#29 \upsilon --- */
      {  29, 7561,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\x59\x96\xa5\x07" }  },
      /* --- pixel bitmap for bbold100 char#30 \phi --- */
      {  30, 7807,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x29\xa5\xf6\xde\x5b\x29\xe5\x00" }  },
      /* --- pixel bitmap for bbold100 char#31 \chi --- */
      {  31, 8071,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb9\x6a\x51\x8a\xa2\x55\x27" }  },
      /* --- pixel bitmap for bbold100 char#32 \psi --- */
      {  32, 8327,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x29\xb5\xf7\xde\x5b\x29\xe5\x00" }  },
      /* --- pixel bitmap for bbold100 char#33 ! --- */
      {  33,24040,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\x7b\xa8\x02" }  },
      /* --- pixel bitmap for bbold100 char#34 (noname) --- */
      {  34,31584,                      /* character number, location */
         10, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x6b\x4b\x09" }  },
      /* --- pixel bitmap for bbold100 char#35 # --- */
      {  35,24280,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4e\x4a\x4a\xfb\x4a\x4a\x4a\xfb\x4a\x4a\x4a\x4e" }  },
      /* --- pixel bitmap for bbold100 char#36 $ --- */
      {  36,24556,                      /* character number, location */
         11, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x8a\xbd\x52\xa9\xd8\xa8\xd4\xaa\x8d\x03" }  },
      /* --- pixel bitmap for bbold100 char#37 % --- */
      {  37,24828,                      /* character number, location */
         10, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\xaa\x0a\x85\xa2\x50\x28\x14\x85\x42\x55\x3d\x01" }  },
      /* --- pixel bitmap for bbold100 char#38 & --- */
      {  38,25106,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x28\x50\x60\xe0\xa0\x42\x95\x92\xde\x00" }  },
      /* --- pixel bitmap for bbold100 char#39 ' --- */
      {  39,25357,                      /* character number, location */
         10, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x15" }  },
      /* --- pixel bitmap for bbold100 char#40 ( --- */
      {  40,25582,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xdb\xb6\x6d\x6b" }  },
      /* --- pixel bitmap for bbold100 char#41 ) --- */
      {  41,25844,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6b\xdb\xb6\x6d\x3b" }  },
      /* --- pixel bitmap for bbold100 char#42 * --- */
      {  42,26097,                      /* character number, location */
          8, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x4a\xd5\x46\xb1\x55\x29\x1c" }  },
      /* --- pixel bitmap for bbold100 char#43 + --- */
      {  43,26347,                      /* character number, location */
          8, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x50\xa0\x40\xf1\x1e\x05\x0a\x14\x38\x00" }  },
      /* --- pixel bitmap for bbold100 char#44 , --- */
      {  44,26585,                      /* character number, location */
          3, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xa9\x00" }  },
      /* --- pixel bitmap for bbold100 char#45 - --- */
      {  45,26806,                      /* character number, location */
          4, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          {  5,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e" }  },
      /* --- pixel bitmap for bbold100 char#46 . --- */
      {  46,27018,                      /* character number, location */
          3, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x00" }  },
      /* --- pixel bitmap for bbold100 char#47 / --- */
      {  47,27242,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x28\x0a\x85\xa2\x50\x28\x0a\x85\xa2\x70\x00" }  },
      /* --- pixel bitmap for bbold100 char#48 0 --- */
      {  48, 8840,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x55\x96\x65\x59\x5a\x0c" }  },
      /* --- pixel bitmap for bbold100 char#49 1 --- */
      {  49, 9091,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x4e\x85\x42\xa1\x50\x28\x7f" }  },
      /* --- pixel bitmap for bbold100 char#50 2 --- */
      {  50, 9332,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x9a\xa2\x18\x23\x04\x3f" }  },
      /* --- pixel bitmap for bbold100 char#51 3 --- */
      {  51, 9569,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x9a\xa2\x18\x9a\xa6\x1e" }  },
      /* --- pixel bitmap for bbold100 char#52 4 --- */
      {  52, 9816,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x86\x51\x96\x75\x53\x1c" }  },
      /* --- pixel bitmap for bbold100 char#53 5 --- */
      {  53,10053,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\xf1\x40\x20\x18\x46\x0e" }  },
      /* --- pixel bitmap for bbold100 char#54 6 --- */
      {  54,10286,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\xd8\x5e\x65\x59\x5a\x0c" }  },
      /* --- pixel bitmap for bbold100 char#55 7 --- */
      {  55,10535,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x4a\x51\x8a\xa2\x14\x07" }  },
      /* --- pixel bitmap for bbold100 char#56 8 --- */
      {  56,10776,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x59\x96\x5e\x59\x96\x1e" }  },
      /* --- pixel bitmap for bbold100 char#57 9 --- */
      {  57,11027,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x55\x96\xa5\xdd\x86\x1e" }  },
      /* --- pixel bitmap for bbold100 char#58 : --- */
      {  58,27496,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x54\x01" }  },
      /* --- pixel bitmap for bbold100 char#59 ; --- */
      {  59,27722,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x54\x53\x01" }  },
      /* --- pixel bitmap for bbold100 char#60 < --- */
      {  60,27959,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\xe1\x30\x58\x60\x03\x1b\x78" }  },
      /* --- pixel bitmap for bbold100 char#61 \cdot --- */
      {  61,28187,                      /* character number, location */
          5, 0,    2, 0,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x00" }  },
      /* --- pixel bitmap for bbold100 char#62 > --- */
      {  62,28413,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x18\xc0\x01\x8d\xcd\xc6\x03" }  },
      /* --- pixel bitmap for bbold100 char#63 ? --- */
      {  63,28647,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x61\x10\xc7\x01\x20\x28\x08" }  },
      /* --- pixel bitmap for bbold100 char#64 @ --- */
      {  64,28879,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x55\xd6\x6d\x55\x9a\x1c" }  },
      /* --- pixel bitmap for bbold100 char#65 A --- */
      {  65,11276,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x18\x18\x34\x34\x4a\x7a\x85\x87" }  },
      /* --- pixel bitmap for bbold100 char#66 B --- */
      {  66,11519,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\x62\xb1\xd8\x2b\x16\x8b\x3f" }  },
      /* --- pixel bitmap for bbold100 char#67 C --- */
      {  67,11772,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x05\x05\x05\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold100 char#68 D --- */
      {  68,12017,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x45\x85\x85\x85\x85\x85\x45\x3f" }  },
      /* --- pixel bitmap for bbold100 char#69 E --- */
      {  69,12272,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x42\xa1\xd0\x29\x14\x0a\x7f" }  },
      /* --- pixel bitmap for bbold100 char#70 F --- */
      {  70,12513,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x42\xa1\xd0\x29\x14\x0a\x07" }  },
      /* --- pixel bitmap for bbold100 char#71 G --- */
      {  71,12754,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x05\xe5\x85\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold100 char#72 H --- */
      {  72,13003,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x85\x85\x85\xfd\x85\x85\x85\x87" }  },
      /* --- pixel bitmap for bbold100 char#73 I --- */
      {  73,13260,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xb6\x07" }  },
      /* --- pixel bitmap for bbold100 char#74 J --- */
      {  74,13501,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x28\x14\x0a\x85\x46\x65\x1c" }  },
      /* --- pixel bitmap for bbold100 char#75 K --- */
      {  75,13744,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc7\x52\xa5\xd2\xa8\x54\x4a\x47" }  },
      /* --- pixel bitmap for bbold100 char#76 L --- */
      {  76,14001,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x4f\x61\x11\x47" }  },
      /* --- pixel bitmap for bbold100 char#77 M --- */
      {  77,14242,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xf1\xb5\xda\x2c\x16\x8b\x47" }  },
      /* --- pixel bitmap for bbold100 char#78 N --- */
      {  78,14501,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x83\x85\x8d\x8d\x95\xa5\xc5\x87" }  },
      /* --- pixel bitmap for bbold100 char#79 O --- */
      {  79,14762,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x85\x85\x85\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold100 char#80 P --- */
      {  80,15013,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\x62\xb1\xd8\x2b\x14\x0a\x07" }  },
      /* --- pixel bitmap for bbold100 char#81 Q --- */
      {  81,15260,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x85\x85\x85\x95\x56\x3c\x40\x40\x80" }  },
      /* --- pixel bitmap for bbold100 char#82 R --- */
      {  82,15521,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\x62\xb1\xd8\xab\x54\x4a\x47" }  },
      /* --- pixel bitmap for bbold100 char#83 S --- */
      {  83,15776,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x52\xb1\xe0\x03\x06\x85\x3c" }  },
      /* --- pixel bitmap for bbold100 char#84 T --- */
      {  84,16017,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xf6\x21\x11\x20\x23\x22" }  },
      /* --- pixel bitmap for bbold100 char#85 U --- */
      {  85,16258,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x85\x85\x85\x85\x85\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold100 char#86 V --- */
      {  86,16513,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc7\xa2\x4a\xa5\xa1\x50\x10\x08" }  },
      /* --- pixel bitmap for bbold100 char#87 W --- */
      {  87,16760,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x2c\xa0\x82\x14\xa4\x22\xaa\x50\x85\x31\x08\x01" }  },
      /* --- pixel bitmap for bbold100 char#88 X --- */
      {  88,17023,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\x52\x54\x28\x14\x14\x2a\x4a\x87" }  },
      /* --- pixel bitmap for bbold100 char#89 Y --- */
      {  89,17276,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc7\x92\x4a\x43\xa1\x50\x28\x1c" }  },
      /* --- pixel bitmap for bbold100 char#90 Z --- */
      {  90,17523,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x50\x50\x28\x14\x14\x0a\x0a\xff" }  },
      /* --- pixel bitmap for bbold100 char#91 [ --- */
      {  91,29141,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xb6\x6d\x7b" }  },
      /* --- pixel bitmap for bbold100 char#92 \\ --- */
      {  92,29403,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x82\x42\xa1\xa0\x50\x28\x28\x14\x0a\x0a\x07" }  },
      /* --- pixel bitmap for bbold100 char#93 ] --- */
      {  93,29672,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xb6\x6d\x7b" }  },
      /* --- pixel bitmap for bbold100 char#94 (noname) --- */
      {  94,29935,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\xed\xb6\xb6\x49" }  },
      /* --- pixel bitmap for bbold100 char#95 (noname) --- */
      {  95,30183,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc9\xb6\xb6\xdb\x12" }  },
      /* --- pixel bitmap for bbold100 char#96 (noname) --- */
      {  96,30434,                      /* character number, location */
         10, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd4\x2a" }  },
      /* --- pixel bitmap for bbold100 char#97 a --- */
      {  97,17764,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x59\x96\xa5\x0f" }  },
      /* --- pixel bitmap for bbold100 char#98 b --- */
      {  98,18001,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x05\x05\x05\x7d\x85\x85\x85\x85\x7f" }  },
      /* --- pixel bitmap for bbold100 char#99 c --- */
      {  99,18254,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x59\x14\xa5\x07" }  },
      /* --- pixel bitmap for bbold100 char#100 d --- */
      { 100,18487,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x82\x7e\x59\x96\xa5\x0f" }  },
      /* --- pixel bitmap for bbold100 char#101 e --- */
      { 101,18732,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\xd9\x17\xa5\x07" }  },
      /* --- pixel bitmap for bbold100 char#102 f --- */
      { 102,18965,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xae\x96\xd2\x4a\x29\xe5\x00" }  },
      /* --- pixel bitmap for bbold100 char#103 g --- */
      { 103,19212,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x59\x96\xa5\x0f\x46\x0e" }  },
      /* --- pixel bitmap for bbold100 char#104 h --- */
      { 104,19457,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x51\x14\x5d\x59\x96\xe5\x09" }  },
      /* --- pixel bitmap for bbold100 char#105 i --- */
      { 105,19712,                      /* character number, location */
          9, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xde\xb6\x07" }  },
      /* --- pixel bitmap for bbold100 char#106 j --- */
      { 106,19949,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x22\x4e\x29\xa5\x94\x56\x07" }  },
      /* --- pixel bitmap for bbold100 char#107 k --- */
      { 107,20200,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x51\x14\x65\xd5\x34\xd5\x09" }  },
      /* --- pixel bitmap for bbold100 char#108 l --- */
      { 108,20453,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xb6\x15" }  },
      /* --- pixel bitmap for bbold100 char#109 m --- */
      { 109,20698,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\x4a\x96\x2c\x59\xf2\x24" }  },
      /* --- pixel bitmap for bbold100 char#110 n --- */
      { 110,20949,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5f\x59\x96\xe5\x09" }  },
      /* --- pixel bitmap for bbold100 char#111 o --- */
      { 111,21188,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x59\x96\xa5\x07" }  },
      /* --- pixel bitmap for bbold100 char#112 p --- */
      { 112,21425,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x85\x85\x85\x85\x7d\x05\x05\x07" }  },
      /* --- pixel bitmap for bbold100 char#113 q --- */
      { 113,21674,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x59\x96\xa5\x0f\x82\x20" }  },
      /* --- pixel bitmap for bbold100 char#114 r --- */
      { 114,21917,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5f\x59\x14\xc5\x01" }  },
      /* --- pixel bitmap for bbold100 char#115 s --- */
      { 115,22148,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xae\x3a\x18\x1d" }  },
      /* --- pixel bitmap for bbold100 char#116 t --- */
      { 116,22375,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa7\x94\xd2\x4b\x29\xd5\x01" }  },
      /* --- pixel bitmap for bbold100 char#117 u --- */
      { 117,22622,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\x59\x96\xa5\x0f" }  },
      /* --- pixel bitmap for bbold100 char#118 v --- */
      { 118,22861,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb7\x2a\x45\x08" }  },
      /* --- pixel bitmap for bbold100 char#119 w --- */
      { 119,23092,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0b\x6a\x52\xc5\x86\x08" }  },
      /* --- pixel bitmap for bbold100 char#120 x --- */
      { 120,23333,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb9\x45\x29\xda\x09" }  },
      /* --- pixel bitmap for bbold100 char#121 y --- */
      { 121,23566,                      /* character number, location */
          6, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb7\x2a\x45\x08\x11\x01" }  },
      /* --- pixel bitmap for bbold100 char#122 z --- */
      { 122,23803,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x45\x29\xca\x0f" }  },
      /* --- pixel bitmap for bbold100 char#123 \- --- */
      { 123,30916,                      /* character number, location */
          4, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          {  5,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for bbold100 char#124 | --- */
      { 124,30659,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xb6\x6d\x7b" }  },
      /* --- pixel bitmap for bbold100 char#125 (noname) --- */
      { 125,31128,                      /* character number, location */
          4, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          { 11,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b" }  },
      /* --- pixel bitmap for bbold100 char#126 (noname) --- */
      { 126,31346,                      /* character number, location */
         10, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\xb4\xb5\x12" }  },
      /* --- pixel bitmap for bbold100 char#127 \omega --- */
      { 127, 8593,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\x0a\x56\xac\x58\xd1\x1d" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=2 for .118gf ---
 * mf '\mode=preview; mag=magstep(-16.96645799324018499600); input bbold10'
 * --------------------------------------------------------------------- */
/* --- fontdef for bbold118 --- */
static	chardef  bbold118[] =
   {
      /* --- pixel bitmap for bbold118 char#0 \Gamma --- */
      {   0,  246,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x0f\x81\x11\x53\x50" }  },
      /* --- pixel bitmap for bbold118 char#1 \Delta --- */
      {   1,  504,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x20\xa0\x40\x41\x85\x0a\x15\x45\x8a\x0a\xfe\x07" }  },
      /* --- pixel bitmap for bbold118 char#2 \Theta --- */
      {   2,  772,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x88\x18\x2a\x58\xb0\x6e\xc1\x82\x86\x88\xe0\x00" }  },
      /* --- pixel bitmap for bbold118 char#3 \Lambda --- */
      {   3, 1043,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x20\xa0\x40\x41\x85\x0a\x15\x45\x8a\x0a\x1e\x04" }  },
      /* --- pixel bitmap for bbold118 char#4 \Xi --- */
      {   4, 1310,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xf3\x90\x33\x30\xf3\x99" }  },
      /* --- pixel bitmap for bbold118 char#5 \Pi --- */
      {   5, 1535,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x0f\x81\x11\x41\x03\x41" }  },
      /* --- pixel bitmap for bbold118 char#6 \Sigma --- */
      {   6, 1813,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x15\x28\xa0\x40\x01\x05\x05\x0a\x0a\x14\xfc\x07" }  },
      /* --- pixel bitmap for bbold118 char#7 \Upsilon --- */
      {   7, 2073,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\x52\xa6\x44\x81\x02\x07\x0a\x14\x28\x50\xe0\x00" }  },
      /* --- pixel bitmap for bbold118 char#8 \Phi --- */
      {   8, 2337,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x50\xb0\x51\x95\x32\x65\x4a\x55\x6c\x50\xe0\x00" }  },
      /* --- pixel bitmap for bbold118 char#9 \Psi --- */
      {   9, 2613,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x50\xa4\x54\xa5\x4a\x95\x2a\x36\x28\x50\xe0\x00" }  },
      /* --- pixel bitmap for bbold118 char#10 \Omega --- */
      {  10, 2891,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x88\x18\x2a\x58\xb0\x60\xc1\x82\x86\x0c\x1d\x07" }  },
      /* --- pixel bitmap for bbold118 char#11 \alpha --- */
      {  11, 3161,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\xa6\xa5\xa5\x65\x26\xdc" }  },
      /* --- pixel bitmap for bbold118 char#12 \beta --- */
      {  12, 3418,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x86\x86\x85\x65\x45\x85\x85\x85\x45\x3d\x05\x05"
            "\x07" }  },
      /* --- pixel bitmap for bbold118 char#13 \gamma --- */
      {  13, 3702,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x04\xc5\x54\x2c\x16\x8b\x26\x0e" }  },
      /* --- pixel bitmap for bbold118 char#14 \delta --- */
      {  14, 3964,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbe\x60\x60\xc0\x31\x15\x8b\x45\x13\x07" }  },
      /* --- pixel bitmap for bbold118 char#15 \epsilon --- */
      {  15, 4224,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x63\xa1\x51\x30\xf2\x00" }  },
      /* --- pixel bitmap for bbold118 char#16 \zeta --- */
      {  16, 4465,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x11\x63\x4a\x29\xc5\x30\x08\x11" }  },
      /* --- pixel bitmap for bbold118 char#17 \eta --- */
      {  17, 4717,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x45\x85\x85\x85\x85\x87\x80\x80\x80" }  },
      /* --- pixel bitmap for bbold118 char#18 \theta --- */
      {  18, 4977,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x93\xa9\x58\xec\x17\x8b\x26\x13\x07" }  },
      /* --- pixel bitmap for bbold118 char#19 \iota --- */
      {  19, 5242,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\x1a" }  },
      /* --- pixel bitmap for bbold118 char#20 \kappa --- */
      {  20, 5484,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x65\x1d\x0d\x15\x25\xc7" }  },
      /* --- pixel bitmap for bbold118 char#21 \lambda --- */
      {  21, 5737,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x82\x42\x41\xa1\x50\x58\x2a\x69\x1c" }  },
      /* --- pixel bitmap for bbold118 char#22 \mu --- */
      {  22, 5998,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x85\x85\x85\x85\xc5\xbd\x05\x05\x07" }  },
      /* --- pixel bitmap for bbold118 char#23 \nu --- */
      {  23, 6263,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc7\x62\xb1\x54\x69\x1c\x00" }  },
      /* --- pixel bitmap for bbold118 char#24 \xi --- */
      {  24, 6512,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x94\xe2\x4c\x29\xc5\x30\x08\x11" }  },
      /* --- pixel bitmap for bbold118 char#25 \pi --- */
      {  25, 6765,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x4a\x4a\x4a\x4a\x4a\x4e" }  },
      /* --- pixel bitmap for bbold118 char#26 \rho --- */
      {  26, 7017,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x53\xb1\x58\x2c\x75\x0a\x85\x03" }  },
      /* --- pixel bitmap for bbold118 char#27 \sigma --- */
      {  27, 7279,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x26\x45\x45\x45\x26\x1c" }  },
      /* --- pixel bitmap for bbold118 char#28 \tau --- */
      {  28, 7525,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x0a\x85\x42\xa1\x60\x00" }  },
      /* --- pixel bitmap for bbold118 char#29 \upsilon --- */
      {  29, 7769,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc7\x62\xb1\x58\x34\x71\x00" }  },
      /* --- pixel bitmap for bbold118 char#30 \phi --- */
      {  30, 8019,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x0a\x85\x42\xb1\x55\xab\x55\x1b\x85\x42\xe1\x00" }  },
      /* --- pixel bitmap for bbold118 char#31 \chi --- */
      {  31, 8299,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\xa9\x8a\x45\xa1\x68\x54\xa5\x23" }  },
      /* --- pixel bitmap for bbold118 char#32 \psi --- */
      {  32, 8563,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x0a\x85\x52\xad\x56\xab\x55\x1b\x85\x42\xe1\x00" }  },
      /* --- pixel bitmap for bbold118 char#33 ! --- */
      {  33,24750,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\x1e\xaa\x00" }  },
      /* --- pixel bitmap for bbold118 char#34 (noname) --- */
      {  34,32504,                      /* character number, location */
         11, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\xaa\x99\x28\x8a\x00" }  },
      /* --- pixel bitmap for bbold118 char#35 # --- */
      {  35,24998,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x50\x42\x09\x25\xf7\x53\x42\x09\x25\xf7\x53\x42"
            "\x09\x25\x94\x70\x02" }  },
      /* --- pixel bitmap for bbold118 char#36 $ --- */
      {  36,25286,                      /* character number, location */
         13, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x50\xb0\x57\x91\x22\x85\x0a\x36\xa8\x50\xa2\x5c"
            "\xc5\x06\x07" }  },
      /* --- pixel bitmap for bbold118 char#37 % --- */
      {  37,25570,                      /* character number, location */
         12, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  9,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\x8b\x8a\x02\x05\x05\x0a\x14\x14\x28\x50\x50\xa0"
            "\xa0\x40\x81\xa2\xa2\x87\x00" }  },
      /* --- pixel bitmap for bbold118 char#38 & --- */
      {  38,25860,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x40\x01\x0a\x50\x80\x01\x0b\x54\xa0\x24\xc5\x30"
            "\x26\xcf\x00" }  },
      /* --- pixel bitmap for bbold118 char#39 ' --- */
      {  39,26121,                      /* character number, location */
         11, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xa9\x00" }  },
      /* --- pixel bitmap for bbold118 char#40 ( --- */
      {  40,26348,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  4,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6c\x55\x55\x55\x55\x55\x55\xc6" }  },
      /* --- pixel bitmap for bbold118 char#41 ) --- */
      {  41,26618,                      /* character number, location */
         12, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  4,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\xaa\xaa\xaa\xaa\xaa\xaa\x36" }  },
      /* --- pixel bitmap for bbold118 char#42 * --- */
      {  42,26879,                      /* character number, location */
         10, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x50\xa0\x48\xed\x0e\x05\x9b\xd5\x28\x50\xe0\x00" }  },
      /* --- pixel bitmap for bbold118 char#43 + --- */
      {  43,27137,                      /* character number, location */
         10, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x40\xf3\x41\x11\x45\x15\xf3\x41\x11\x40\x43\x41" }  },
      /* --- pixel bitmap for bbold118 char#44 , --- */
      {  44,27383,                      /* character number, location */
          3, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xa9\x00" }  },
      /* --- pixel bitmap for bbold118 char#45 - --- */
      {  45,27604,                      /* character number, location */
          4, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          {  5,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for bbold118 char#46 . --- */
      {  46,27816,                      /* character number, location */
          3, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x00" }  },
      /* --- pixel bitmap for bbold118 char#47 / --- */
      {  47,28040,                      /* character number, location */
         12, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  8,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xa0\x50\x50\x50\x28\x28\x28\x14\x14\x14\x0a\x0a"
            "\x0a\x05\x07" }  },
      /* --- pixel bitmap for bbold118 char#48 0 --- */
      {  48, 9104,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x93\xa9\x58\x2c\x16\x8b\x26\x13\x07" }  },
      /* --- pixel bitmap for bbold118 char#49 1 --- */
      {  49, 9363,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x4e\x85\x42\xa1\x50\x28\x14\xca\x1f" }  },
      /* --- pixel bitmap for bbold118 char#50 2 --- */
      {  50, 9612,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x59\x14\x0a\x85\x61\x08\x82\xc0\x1f" }  },
      /* --- pixel bitmap for bbold118 char#51 3 --- */
      {  51, 9853,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x59\x14\x0a\xc3\xc0\xa0\x51\x19\x07" }  },
      /* --- pixel bitmap for bbold118 char#52 4 --- */
      {  52,10100,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x18\x0c\xc5\x62\xa9\x54\x6f\x14\x0e" }  },
      /* --- pixel bitmap for bbold118 char#53 5 --- */
      {  53,10349,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x42\xe1\x03\x02\x02\x81\x41\x11\x07" }  },
      /* --- pixel bitmap for bbold118 char#54 6 --- */
      {  54,10588,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\xb0\x73\x2a\x16\x8b\x45\x13\x07" }  },
      /* --- pixel bitmap for bbold118 char#55 7 --- */
      {  55,10845,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x28\x0a\x45\xa1\x50\x14\x8a\xc2\x01" }  },
      /* --- pixel bitmap for bbold118 char#56 8 --- */
      {  56,11094,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x53\xb1\x68\xe2\x98\x8a\x45\x13\x07" }  },
      /* --- pixel bitmap for bbold118 char#57 9 --- */
      {  57,11349,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x53\xb1\x58\x2c\x9a\xb9\x41\x11\x07" }  },
      /* --- pixel bitmap for bbold118 char#58 : --- */
      {  58,28306,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xa0\x0a" }  },
      /* --- pixel bitmap for bbold118 char#59 ; --- */
      {  59,28534,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xa0\x9a\x0a" }  },
      /* --- pixel bitmap for bbold118 char#60 < --- */
      {  60,28773,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x0e\x0e\x1c\x20\x01\x36\xc0\x06\xf8" }  },
      /* --- pixel bitmap for bbold118 char#61 \cdot --- */
      {  61,29003,                      /* character number, location */
          6, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x00" }  },
      /* --- pixel bitmap for bbold118 char#62 > --- */
      {  62,29229,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xe0\x00\x38\x00\x0e\x6c\xd8\xb0\xe0\x01" }  },
      /* --- pixel bitmap for bbold118 char#63 ? --- */
      {  63,29465,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x07\x04\x08\x0f\x05\x0e\x00\x10\x50\x40\x00" }  },
      /* --- pixel bitmap for bbold118 char#64 @ --- */
      {  64,29703,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x93\xa9\x58\xae\x96\x0a\x46\x13\x07" }  },
      /* --- pixel bitmap for bbold118 char#65 A --- */
      {  65,11606,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x20\xa0\x40\x41\x85\x0a\x15\x45\xfa\x0a\x1e\x04" }  },
      /* --- pixel bitmap for bbold118 char#66 B --- */
      {  66,11865,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x45\x85\x85\x45\x3d\x45\x85\x85\x45\x3f" }  },
      /* --- pixel bitmap for bbold118 char#67 C --- */
      {  67,12130,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x08\x19\x2c\x50\xa0\x40\x81\x02\x06\x09\xe1\x01" }  },
      /* --- pixel bitmap for bbold118 char#68 D --- */
      {  68,12379,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x8a\x14\x2a\x58\xb0\x60\xc1\x82\x85\x8a\xfc\x00" }  },
      /* --- pixel bitmap for bbold118 char#69 E --- */
      {  69,12646,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x0f\x31\x11\x51\x13\x3f\x31\x11\x58" }  },
      /* --- pixel bitmap for bbold118 char#70 F --- */
      {  70,12895,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x05\x05\x05\x05\x1d\x05\x05\x05\x05\x07" }  },
      /* --- pixel bitmap for bbold118 char#71 G --- */
      {  71,13144,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x08\x19\x2c\x50\xa0\x78\xc1\x82\x06\x09\xe1\x01" }  },
      /* --- pixel bitmap for bbold118 char#72 H --- */
      {  72,13399,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0b\x16\x2c\x58\xb0\x7f\xc1\x82\x05\x0b\x1e\x04" }  },
      /* --- pixel bitmap for bbold118 char#73 I --- */
      {  73,13668,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xb6\xed\x01" }  },
      /* --- pixel bitmap for bbold118 char#74 J --- */
      {  74,13917,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   11, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\xf6\x51\x11\x01\x42\x21\x32\x34\x21" }  },
      /* --- pixel bitmap for bbold118 char#75 K --- */
      {  75,14166,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x45\x45\x25\x15\x1d\x1d\x25\x45\x45\x87" }  },
      /* --- pixel bitmap for bbold118 char#76 L --- */
      {  76,14433,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x5f\x81\x11\x58" }  },
      /* --- pixel bitmap for bbold118 char#77 M --- */
      {  77,14682,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x07\x17\x2d\xda\xb2\x62\xc1\x82\x05\x0b\x1e\x04" }  },
      /* --- pixel bitmap for bbold118 char#78 N --- */
      {  78,14959,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x07\x16\x2c\xd8\xb0\x62\xc9\xa2\x45\x0b\x1f\x04" }  },
      /* --- pixel bitmap for bbold118 char#79 O --- */
      {  79,15236,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x88\x18\x2a\x58\xb0\x60\xc1\x82\x86\x88\xe0\x00" }  },
      /* --- pixel bitmap for bbold118 char#80 P --- */
      {  80,15495,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x45\x85\x85\x45\x3d\x05\x05\x05\x05\x07" }  },
      /* --- pixel bitmap for bbold118 char#81 Q --- */
      {  81,15752,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x88\x18\x2a\x58\xb0\x60\xc1\x82\x96\xc8\xe0\x01"
            "\x02\x08\x20" }  },
      /* --- pixel bitmap for bbold118 char#82 R --- */
      {  82,16019,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x45\x85\x85\x45\x3d\x15\x25\x45\x45\x87" }  },
      /* --- pixel bitmap for bbold118 char#83 S --- */
      {  83,16286,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x05\x06\x3c\x40\x80\x81\x42\x3c" }  },
      /* --- pixel bitmap for bbold118 char#84 T --- */
      {  84,16529,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xf8\x31\x11\x30\x33\x31" }  },
      /* --- pixel bitmap for bbold118 char#85 U --- */
      {  85,16778,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x51\x0f\x61\x11\x51\x12\x41\x31\x31\x53\x31" }  },
      /* --- pixel bitmap for bbold118 char#86 V --- */
      {  86,17043,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0b\x2a\x52\x44\x85\x0a\x15\x14\x28\x20\x40\x00" }  },
      /* --- pixel bitmap for bbold118 char#87 W --- */
      {  87,17304,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xb0\x00\x2a\x20\x05\xa4\x80\xb4\x08\x2d\xa1\x25"
            "\x14\x05\x63\x20\x08" }  },
      /* --- pixel bitmap for bbold118 char#88 X --- */
      {  88,17581,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x45\x91\xa2\x82\x05\x05\x0d\x2a\x4a\x14\x1d\x04" }  },
      /* --- pixel bitmap for bbold118 char#89 Y --- */
      {  89,17846,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x15\x29\xa2\x42\x05\x05\x0a\x14\x28\x50\xe0\x00" }  },
      /* --- pixel bitmap for bbold118 char#90 Z --- */
      {  90,18105,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x41\x81\x82\x02\x05\x05\x05\x0a\x0a\x14\xfc\x07" }  },
      /* --- pixel bitmap for bbold118 char#91 [ --- */
      {  91,29973,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  4,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xd1\x11\x14" }  },
      /* --- pixel bitmap for bbold118 char#92 \\ --- */
      {  92,30247,                      /* character number, location */
         12, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  8,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x05\x0a\x0a\x0a\x14\x14\x14\x28\x28\x28\x50\x50"
            "\x50\xa0\xe0" }  },
      /* --- pixel bitmap for bbold118 char#93 ] --- */
      {  93,30528,                      /* character number, location */
         12, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  4,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfd\x11\x11\x04" }  },
      /* --- pixel bitmap for bbold118 char#94 (noname) --- */
      {  94,30803,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  4,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\xcc\xaa\x9a\xa9\xaa\xcc\x88" }  },
      /* --- pixel bitmap for bbold118 char#95 (noname) --- */
      {  95,31067,                      /* character number, location */
         12, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  4,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x33\x55\x95\x59\x55\x33\x11" }  },
      /* --- pixel bitmap for bbold118 char#96 (noname) --- */
      {  96,31334,                      /* character number, location */
         11, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  3,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x56\x01" }  },
      /* --- pixel bitmap for bbold118 char#97 a --- */
      {  97,18354,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x63\xb1\x58\x34\xf2\x01" }  },
      /* --- pixel bitmap for bbold118 char#98 b --- */
      {  98,18593,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0a\x14\x28\xd0\xa7\x50\xc1\x82\x05\x0b\xfd\x01" }  },
      /* --- pixel bitmap for bbold118 char#99 c --- */
      {  99,18852,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x63\xa1\x50\x30\xf2\x00" }  },
      /* --- pixel bitmap for bbold118 char#100 d --- */
      { 100,19085,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x10\xc8\x37\x16\x8b\x45\x23\x1f" }  },
      /* --- pixel bitmap for bbold118 char#101 e --- */
      { 101,19332,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x53\xb1\x5f\x30\xf2\x00" }  },
      /* --- pixel bitmap for bbold118 char#102 f --- */
      { 102,19567,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xae\x96\xd2\x4a\x29\xa5\x1c" }  },
      /* --- pixel bitmap for bbold118 char#103 g --- */
      { 103,19818,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x63\xb1\x58\x34\xf2\x81\x21\x0f" }  },
      /* --- pixel bitmap for bbold118 char#104 h --- */
      { 104,20065,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x05\x05\x05\x3d\x45\x85\x85\x85\x85\x87" }  },
      /* --- pixel bitmap for bbold118 char#105 i --- */
      { 105,20326,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xf0\xb6\xed\x01" }  },
      /* --- pixel bitmap for bbold118 char#106 j --- */
      { 106,20569,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x22\xc0\x29\xa5\x94\x52\x5a\x1d" }  },
      /* --- pixel bitmap for bbold118 char#107 k --- */
      { 107,20826,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x05\x05\x05\x85\x45\x25\x1d\x25\x45\x87" }  },
      /* --- pixel bitmap for bbold118 char#108 l --- */
      { 108,21087,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  3,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xb6\xad\x01" }  },
      /* --- pixel bitmap for bbold118 char#109 m --- */
      { 109,21336,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdf\x4a\x96\x2c\x59\xb2\xe4\x49" }  },
      /* --- pixel bitmap for bbold118 char#110 n --- */
      { 110,21595,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x45\x85\x85\x85\x85\x87" }  },
      /* --- pixel bitmap for bbold118 char#111 o --- */
      { 111,21840,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x53\xb1\x58\x34\x71\x00" }  },
      /* --- pixel bitmap for bbold118 char#112 p --- */
      { 112,22079,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x0a\x15\x2c\x58\xb0\x50\x9f\x02\x05\x0e\x00" }  },
      /* --- pixel bitmap for bbold118 char#113 q --- */
      { 113,22334,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x63\xb1\x58\x34\xf2\x81\x40\x20" }  },
      /* --- pixel bitmap for bbold118 char#114 r --- */
      { 114,22579,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x85\x05\x05\x05\x05\x07" }  },
      /* --- pixel bitmap for bbold118 char#115 s --- */
      { 115,22814,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xae\x16\x07\xa3\x03" }  },
      /* --- pixel bitmap for bbold118 char#116 t --- */
      { 116,23045,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa7\x94\xd2\x4b\x29\xa5\x3a" }  },
      /* --- pixel bitmap for bbold118 char#117 u --- */
      { 117,23296,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc7\x62\xb1\x58\x34\x73\x01" }  },
      /* --- pixel bitmap for bbold118 char#118 v --- */
      { 118,23541,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\xa5\x8a\x46\xc1\x20\x00" }  },
      /* --- pixel bitmap for bbold118 char#119 w --- */
      { 119,23778,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0b\x2a\xd2\xa4\x8a\x0d\x11" }  },
      /* --- pixel bitmap for bbold118 char#120 x --- */
      { 120,24025,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x15\x8b\xa2\x51\x1d\x01" }  },
      /* --- pixel bitmap for bbold118 char#121 y --- */
      { 121,24266,                      /* character number, location */
          7, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x95\x8a\x42\xc1\x20\x08\x82\x00" }  },
      /* --- pixel bitmap for bbold118 char#122 z --- */
      { 122,24509,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x14\x8a\xa2\x50\xfc\x01" }  },
      /* --- pixel bitmap for bbold118 char#123 \- --- */
      { 123,31830,                      /* character number, location */
          5, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  6,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f" }  },
      /* --- pixel bitmap for bbold118 char#124 | --- */
      { 124,31561,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  3,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x0f\xd1\x11\x03" }  },
      /* --- pixel bitmap for bbold118 char#125 (noname) --- */
      { 125,32042,                      /* character number, location */
          5, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          { 13,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d" }  },
      /* --- pixel bitmap for bbold118 char#126 (noname) --- */
      { 126,32260,                      /* character number, location */
         11, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  7,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x51\x64\x56\x15\x01" }  },
      /* --- pixel bitmap for bbold118 char#127 \omega --- */
      { 127, 8853,                      /* character number, location */
          7, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x0c\x15\xac\x58\xb1\xa2\x3b" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=3 for .131gf ---
 * mf '\mode=preview; mag=magstep(-16.39322518098640003469); input bbold10'
 * --------------------------------------------------------------------- */
/* --- fontdef for bbold131 --- */
static	chardef  bbold131[] =
   {
      /* --- pixel bitmap for bbold131 char#0 \Gamma --- */
      {   0,  246,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\x91\x11\x63\x60" }  },
      /* --- pixel bitmap for bbold131 char#1 \Delta --- */
      {   1,  508,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x00\x01\x14\xa0\x80\x0a\x54\x50\x84\x22\x0a\x52"
            "\x50\x01\xff\x0f" }  },
      /* --- pixel bitmap for bbold131 char#2 \Theta --- */
      {   2,  782,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x62\x50\x81\x05\x96\x5b\x60\x81\x05\x1a\x44"
            "\x08\x1e" }  },
      /* --- pixel bitmap for bbold131 char#3 \Lambda --- */
      {   3, 1059,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x00\x01\x14\xa0\x80\x0a\x54\x50\x84\x22\x0a\x52"
            "\x50\x01\x0f\x08" }  },
      /* --- pixel bitmap for bbold131 char#4 \Xi --- */
      {   4, 1332,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\xf3\xb0\x44\x30\xf4\xbb" }  },
      /* --- pixel bitmap for bbold131 char#5 \Pi --- */
      {   5, 1557,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\x91\x11\x51\x03\x51" }  },
      /* --- pixel bitmap for bbold131 char#6 \Sigma --- */
      {   6, 1841,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x2b\xa0\x00\x05\x28\xa0\x80\x02\x0a\x14\x28\xa0"
            "\xc0\xff" }  },
      /* --- pixel bitmap for bbold131 char#7 \Upsilon --- */
      {   7, 2105,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8e\x8b\x62\x14\xa1\x00\x05\x38\x40\x01\x0a\x50\x80"
            "\x02\x14\xe0\x00" }  },
      /* --- pixel bitmap for bbold131 char#8 \Phi --- */
      {   8, 2373,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x80\x02\x36\xac\x16\xc5\x28\x46\x31\x8a\x56\xc3"
            "\x06\x14\xe0\x00" }  },
      /* --- pixel bitmap for bbold131 char#9 \Psi --- */
      {   9, 2657,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x80\xc2\x94\xa5\x24\x25\x29\x51\x85\x2a\xd8\x80"
            "\x02\x14\xe0\x00" }  },
      /* --- pixel bitmap for bbold131 char#10 \Omega --- */
      {  10, 2943,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x51\x41\x32\x51\x1f\x51\x11\x61\xf1\x12\x51\x13"
            "\x43" }  },
      /* --- pixel bitmap for bbold131 char#11 \alpha --- */
      {  11, 3219,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x9a\x58\x64\x51\x45\x15\x62\x0c\xcf" }  },
      /* --- pixel bitmap for bbold131 char#12 \beta --- */
      {  12, 3484,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x84\x86\x85\x85\x65\x45\x85\x85\x85\x85\x45\x3d"
            "\x05\x05\x05\x07" }  },
      /* --- pixel bitmap for bbold131 char#13 \gamma --- */
      {  13, 3784,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe7\x18\x24\x46\x46\x85\x85\x85\x85\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#14 \delta --- */
      {  14, 4056,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x42\x81\x01\x02\x1c\x66\x85\x85\x85\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#15 \epsilon --- */
      {  15, 4326,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x1d\x05\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#16 \zeta --- */
      {  16, 4575,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x46\x10\x86\x51\x14\x45\x51\x18\x0c\x0c\x82\x18" }  },
      /* --- pixel bitmap for bbold131 char#17 \eta --- */
      {  17, 4835,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x45\x85\x85\x85\x85\x85\x87\x80\x80\x80\x80" }  },
      /* --- pixel bitmap for bbold131 char#18 \theta --- */
      {  18, 5103,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x46\x85\x85\x85\xfd\x85\x85\x85\x46\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#19 \iota --- */
      {  19, 5380,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xd6" }  },
      /* --- pixel bitmap for bbold131 char#20 \kappa --- */
      {  20, 5626,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x65\x1d\x0d\x15\x35\x25\xc7" }  },
      /* --- pixel bitmap for bbold131 char#21 \lambda --- */
      {  21, 5885,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x05\x0a\x0a\x14\x14\x14\x28\x2c\x54\x52\xa2\xe1" }  },
      /* --- pixel bitmap for bbold131 char#22 \mu --- */
      {  22, 6156,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x85\x85\x85\x85\x85\xc5\xbd\x05\x05\x05\x07" }  },
      /* --- pixel bitmap for bbold131 char#23 \nu --- */
      {  23, 6431,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x85\x85\x45\x45\x25\x1d\x07" }  },
      /* --- pixel bitmap for bbold131 char#24 \xi --- */
      {  24, 6686,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x51\x14\x06\x67\x14\x45\x51\x18\x0c\x0c\x82\x18" }  },
      /* --- pixel bitmap for bbold131 char#25 \pi --- */
      {  25, 6947,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xf5\x21\x12\x20\x24\x22" }  },
      /* --- pixel bitmap for bbold131 char#26 \rho --- */
      {  26, 7191,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x85\x85\x85\x45\x3d\x05\x05\x05\x07" }  },
      /* --- pixel bitmap for bbold131 char#27 \sigma --- */
      {  27, 7463,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x1b\x51\x48\x21\x85\x14\x62\x04\x0f" }  },
      /* --- pixel bitmap for bbold131 char#28 \tau --- */
      {  28, 7715,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x0a\x85\x42\xa1\x50\x30" }  },
      /* --- pixel bitmap for bbold131 char#29 \upsilon --- */
      {  29, 7963,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x85\x85\x85\x85\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#30 \phi --- */
      {  30, 8219,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  7,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x0a\x85\x42\xa1\xd8\xaa\xd5\x6a\xd5\x46\xa1\x50"
            "\x28\x1c" }  },
      /* --- pixel bitmap for bbold131 char#31 \chi --- */
      {  31, 8515,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\xa2\x52\x54\x28\x28\x14\x14\x2a\x4a\x45\x87" }  },
      /* --- pixel bitmap for bbold131 char#32 \psi --- */
      {  32, 8791,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x0a\x85\x42\xa9\x56\xab\xd5\x6a\xd5\x46\xa1\x50"
            "\x28\x1c" }  },
      /* --- pixel bitmap for bbold131 char#33 ! --- */
      {  33,25408,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xf6\x50\x05" }  },
      /* --- pixel bitmap for bbold131 char#34 (noname) --- */
      {  34,33332,                      /* character number, location */
         13, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\xa5\xc6\x84\x42\x42\x21" }  },
      /* --- pixel bitmap for bbold131 char#35 # --- */
      {  35,25660,                      /* character number, location */
         12, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 11,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x41\x09\x4a\x50\x82\x92\xf7\xa3\x04\x25\x28\x79"
            "\x3f\x4a\x50\x82\x12\x94\xa0\x04\x27" }  },
      /* --- pixel bitmap for bbold131 char#36 $ --- */
      {  36,25960,                      /* character number, location */
         14, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  9,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x50\xb0\x57\x91\x22\x85\x0a\x36\xa8\x50\xa2\x44"
            "\x89\xea\x0d\x0a\x1c" }  },
      /* --- pixel bitmap for bbold131 char#37 % --- */
      {  37,26252,                      /* character number, location */
         14, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  9,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\x8b\x8a\x02\x05\x0a\x0a\x14\x28\x28\x50\xa0\x40"
            "\x41\x81\x02\x05\x05\x0a\x14\x15\x3d\x04" }  },
      /* --- pixel bitmap for bbold131 char#38 & --- */
      {  38,26554,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x80\x04\x48\x80\x02\x18\x40\x01\x26\x50\x02\x45"
            "\x52\x94\xc6\xc8\x73" }  },
      /* --- pixel bitmap for bbold131 char#39 ' --- */
      {  39,26823,                      /* character number, location */
         13, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x29\x05" }  },
      /* --- pixel bitmap for bbold131 char#40 ( --- */
      {  40,27052,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\x18\x53\x4a\x29\xa5\x94\x52\x4a\x31\x86\x60" }  },
      /* --- pixel bitmap for bbold131 char#41 ) --- */
      {  41,27326,                      /* character number, location */
         14, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x30\x46\x29\xa5\x94\x52\x4a\x29\x65\x8c\x0c" }  },
      /* --- pixel bitmap for bbold131 char#42 * --- */
      {  42,27591,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x80\x02\x14\xa2\x68\x35\x6c\x40\x01\x1b\x56\x8b"
            "\x22\x14\xa0\x00\x07" }  },
      /* --- pixel bitmap for bbold131 char#43 + --- */
      {  43,27865,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\x40\xf4\x51\x11\x46\x15\xf4\x51\x11\x40\x53\x42" }  },
      /* --- pixel bitmap for bbold131 char#44 , --- */
      {  44,28119,                      /* character number, location */
          3, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x29\x05" }  },
      /* --- pixel bitmap for bbold131 char#45 - --- */
      {  45,28342,                      /* character number, location */
          5, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  6,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3e" }  },
      /* --- pixel bitmap for bbold131 char#46 . --- */
      {  46,28554,                      /* character number, location */
          3, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x00" }  },
      /* --- pixel bitmap for bbold131 char#47 / --- */
      {  47,28778,                      /* character number, location */
         14, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  9,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x81\x82\x02\x05\x0a\x0a\x14\x28\x28\x50\xa0\xa0"
            "\x40\x81\x82\x02\x05\x0a\x0a\x1c\x00" }  },
      /* --- pixel bitmap for bbold131 char#48 0 --- */
      {  48, 9356,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x46\x85\x85\x85\x85\x85\x85\x46\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#49 1 --- */
      {  49, 9621,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x52\x11\x32\x11\x11\x30\xf7\x31\x11\x39" }  },
      /* --- pixel bitmap for bbold131 char#50 2 --- */
      {  50, 9876,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x62\xa1\xa0\xa0\x60\x30\x08\x04\x02\x01\xff" }  },
      /* --- pixel bitmap for bbold131 char#51 3 --- */
      {  51,10119,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x62\xa1\xa0\x60\x30\x60\xa0\xa0\xa1\x62\x3c" }  },
      /* --- pixel bitmap for bbold131 char#52 4 --- */
      {  52,10370,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x30\x30\x28\x2c\x2c\x2a\x2a\xef\x28\x28\x38" }  },
      /* --- pixel bitmap for bbold131 char#53 5 --- */
      {  53,10623,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x05\x05\x3f\x40\x80\x80\x80\x80\x81\x42\x3c" }  },
      /* --- pixel bitmap for bbold131 char#54 6 --- */
      {  54,10864,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x42\x81\x3d\x47\x85\x85\x85\x85\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#55 7 --- */
      {  55,11127,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xa0\x50\x50\x28\x28\x14\x14\x0a\x0a\x05\x07" }  },
      /* --- pixel bitmap for bbold131 char#56 8 --- */
      {  56,11380,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x85\x46\x3c\x46\x85\x85\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#57 9 --- */
      {  57,11641,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x85\x85\x85\x85\xc6\xbc\x81\x42\x3c" }  },
      /* --- pixel bitmap for bbold131 char#58 : --- */
      {  58,29056,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x00\x55" }  },
      /* --- pixel bitmap for bbold131 char#59 ; --- */
      {  59,29284,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x00\xd5\x94\x02" }  },
      /* --- pixel bitmap for bbold131 char#60 < --- */
      {  60,29525,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    9, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\x73\x72\x73\x74\x92\x12\x92\x12\x92\x12\x95" }  },
      /* --- pixel bitmap for bbold131 char#61 \cdot --- */
      {  61,29757,                      /* character number, location */
          6, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          {  3,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x00" }  },
      /* --- pixel bitmap for bbold131 char#62 > --- */
      {  62,29983,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    9, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xc3\xc2\xc3\x95\x53\x11\x62\x11\x62\x11\x65\x71" }  },
      /* --- pixel bitmap for bbold131 char#63 ? --- */
      {  63,30221,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x05\x04\x08\x08\x0e\x0a\x1c\x00\x20\xa0\x80"
            "\x00" }  },
      /* --- pixel bitmap for bbold131 char#64 @ --- */
      {  64,30461,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x46\x85\xc5\xa5\xa5\x45\x05\x86\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#65 A --- */
      {  65,11904,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\xc0\x00\x03\x1a\x68\x50\x42\x09\x25\xfa\x29\x54"
            "\xe0\x81" }  },
      /* --- pixel bitmap for bbold131 char#66 B --- */
      {  66,12165,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x0a\x15\x2c\x58\xa8\x4f\xa1\x82\x05\x0b\x16\xfa"
            "\x03" }  },
      /* --- pixel bitmap for bbold131 char#67 C --- */
      {  67,12436,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x66\x60\x01\x05\x14\x50\x40\x01\x05\x18\x48"
            "\x18\x1e" }  },
      /* --- pixel bitmap for bbold131 char#68 D --- */
      {  68,12689,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x14\x52\x50\x81\x05\x16\x58\x60\x81\x05\x16\x54"
            "\xc8\x1f" }  },
      /* --- pixel bitmap for bbold131 char#69 E --- */
      {  69,12962,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\x31\x11\x61\x14\x3f\x41\x11\x69" }  },
      /* --- pixel bitmap for bbold131 char#70 F --- */
      {  70,13215,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\x31\x11\x61\x14\x3f\x41\x11\x63\x61" }  },
      /* --- pixel bitmap for bbold131 char#71 G --- */
      {  71,13468,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x66\x60\x01\x05\x14\x5f\x60\x81\x05\x1a\x48"
            "\x18\x1e" }  },
      /* --- pixel bitmap for bbold131 char#72 H --- */
      {  72,13729,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x61\x0f\x31\x11\x61\x01\x18\x0f\x41\x11\x61\x03"
            "\x61" }  },
      /* --- pixel bitmap for bbold131 char#73 I --- */
      {  73,14004,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xb6\x6d\x0f" }  },
      /* --- pixel bitmap for bbold131 char#74 J --- */
      {  74,14257,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\xf7\x61\x11\x01\x52\x21\x41\x44\x31" }  },
      /* --- pixel bitmap for bbold131 char#75 K --- */
      {  75,14510,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0b\x15\x29\x52\xa2\x42\x8b\x12\x45\x0a\x15\x3a"
            "\x08" }  },
      /* --- pixel bitmap for bbold131 char#76 L --- */
      {  76,14787,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x6f\x91\x11\x69" }  },
      /* --- pixel bitmap for bbold131 char#77 M --- */
      {  77,15040,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x1c\x70\x41\x1b\x59\xc5\x12\x16\xb0\x80\x05\x2c"
            "\x60\x01\x0f\x08" }  },
      /* --- pixel bitmap for bbold131 char#78 N --- */
      {  78,15325,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x0e\x58\x60\x81\x0d\x56\x58\x62\x91\x85\x16\x5a"
            "\xf0\x81" }  },
      /* --- pixel bitmap for bbold131 char#79 O --- */
      {  79,15610,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x62\x50\x81\x05\x16\x58\x60\x81\x05\x1a\x44"
            "\x08\x1e" }  },
      /* --- pixel bitmap for bbold131 char#80 P --- */
      {  80,15875,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x0a\x15\x2c\x58\xa8\x4f\x81\x02\x05\x0a\x14\x38"
            "\x00" }  },
      /* --- pixel bitmap for bbold131 char#81 Q --- */
      {  81,16136,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x62\x50\x81\x05\x16\x58\x60\x81\x05\x9a\x44"
            "\x0a\x1e\x80\x00\x04\x10\x80" }  },
      /* --- pixel bitmap for bbold131 char#82 R --- */
      {  82,16413,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x0a\x15\x2c\x58\xa8\x4f\x89\x12\x45\x0a\x15\x3a"
            "\x08" }  },
      /* --- pixel bitmap for bbold131 char#83 S --- */
      {  83,16686,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x0c\x15\x2c\x60\x80\x0f\x20\x80\x00\x03\x0a\xe2"
            "\x03" }  },
      /* --- pixel bitmap for bbold131 char#84 T --- */
      {  84,16931,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   12, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\xf9\x41\x11\x40\x43\x41" }  },
      /* --- pixel bitmap for bbold131 char#85 U --- */
      {  85,17184,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x61\x0f\x71\x11\x61\x12\x51\x31\x41\x54\x31" }  },
      /* --- pixel bitmap for bbold131 char#86 V --- */
      {  86,17455,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x2c\xa0\x82\x14\x44\x11\x8a\xa0\x02\x15\x50\x80"
            "\x02\x08\x40\x00" }  },
      /* --- pixel bitmap for bbold131 char#87 W --- */
      {  87,17722,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xc0\x02\xa0\x02\x48\x01\xa4\x00\xa2\x84\x50\x45"
            "\xa8\x22\x28\x0a\x14\x05\x06\x03\x02\x01" }  },
      /* --- pixel bitmap for bbold131 char#88 X --- */
      {  88,18011,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x0b\x45\x14\x29\x58\x40\x81\x02\x1a\x94\x28\xa2"
            "\xd0\x81" }  },
      /* --- pixel bitmap for bbold131 char#89 Y --- */
      {  89,18280,                      /* character number, location */
         12, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x54\x10\x45\x28\x82\x0a\x28\x40\x01\x0a\x50\x80"
            "\x02\x14\xe0\x00" }  },
      /* --- pixel bitmap for bbold131 char#90 Z --- */
      {  90,18543,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03\x05\x14\x28\x50\x40\x81\x02\x0a\x14\x28\xa0"
            "\xc0\xff" }  },
      /* --- pixel bitmap for bbold131 char#91 [ --- */
      {  91,30739,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x11\x2f\x11\x11\x25" }  },
      /* --- pixel bitmap for bbold131 char#92 \\ --- */
      {  92,31025,                      /* character number, location */
         14, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  9,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0a\x28\x50\xa0\x80\x02\x05\x0a\x28\x50\xa0\x80"
            "\x02\x05\x0a\x28\x50\xa0\x80\x02\x07" }  },
      /* --- pixel bitmap for bbold131 char#93 ] --- */
      {  93,31318,                      /* character number, location */
         14, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x21\x11\xf1\x21\x11\x05" }  },
      /* --- pixel bitmap for bbold131 char#94 (noname) --- */
      {  94,31605,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x22\xc4\x98\x52\x29\x25\xa5\x18\x43\x08\x42" }  },
      /* --- pixel bitmap for bbold131 char#95 (noname) --- */
      {  95,31873,                      /* character number, location */
         14, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x08\x61\x8c\x52\x52\x4a\xa5\x8c\x11\x22\x04" }  },
      /* --- pixel bitmap for bbold131 char#96 (noname) --- */
      {  96,32144,                      /* character number, location */
         13, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  3,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x94\xb2\x0a" }  },
      /* --- pixel bitmap for bbold131 char#97 a --- */
      {  97,18796,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\xc6\x85\x85\x85\x85\xc6\xbc" }  },
      /* --- pixel bitmap for bbold131 char#98 b --- */
      {  98,19045,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x14\x50\x40\x01\x05\xd4\xd3\x50\x81\x05\x16\x58"
            "\x60\x43\xf7\x00" }  },
      /* --- pixel bitmap for bbold131 char#99 c --- */
      {  99,19318,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x05\x05\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#100 d --- */
      { 100,19559,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x80\x80\x80\x80\xbc\xc6\x85\x85\x85\x85\xc6\xbc" }  },
      /* --- pixel bitmap for bbold131 char#101 e --- */
      { 101,19818,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\xfd\x05\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#102 f --- */
      { 102,20059,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9c\x59\x16\x45\x57\x14\x45\x51\x14\x07" }  },
      /* --- pixel bitmap for bbold131 char#103 g --- */
      { 103,20318,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\xc6\x85\x85\x85\x85\xc6\xbc\x80\x80\x41\x3e" }  },
      /* --- pixel bitmap for bbold131 char#104 h --- */
      { 104,20577,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x05\x05\x05\x05\x3d\x45\x85\x85\x85\x85\x85\x87" }  },
      /* --- pixel bitmap for bbold131 char#105 i --- */
      { 105,20848,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xf0\xb6\x6d\x0f" }  },
      /* --- pixel bitmap for bbold131 char#106 j --- */
      { 106,21095,                      /* character number, location */
         12, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  6,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x0a\x01\x38\x8a\xa2\x28\x8a\xa2\x28\x9a\x39" }  },
      /* --- pixel bitmap for bbold131 char#107 k --- */
      { 107,21358,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x05\x05\x05\x05\x85\x45\x25\x1d\x15\x25\x45\x87" }  },
      /* --- pixel bitmap for bbold131 char#108 l --- */
      { 108,21629,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xb6\x6d\x6b" }  },
      /* --- pixel bitmap for bbold131 char#109 m --- */
      { 109,21886,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    8, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x13\x1f\x51\x11\x31\x31\x03\x31\x31" }  },
      /* --- pixel bitmap for bbold131 char#110 n --- */
      { 110,22153,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x45\x85\x85\x85\x85\x85\x87" }  },
      /* --- pixel bitmap for bbold131 char#111 o --- */
      { 111,22404,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x46\x85\x85\x85\x85\x46\x3c" }  },
      /* --- pixel bitmap for bbold131 char#112 p --- */
      { 112,22649,                      /* character number, location */
          8, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x34\x54\x60\x81\x05\x16\xd8\x50\x3d\x05\x14\x50"
            "\xc0\x01" }  },
      /* --- pixel bitmap for bbold131 char#113 q --- */
      { 113,22918,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  8,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\xc6\x85\x85\x85\x85\xc6\xbc\x80\x80\x80\x80" }  },
      /* --- pixel bitmap for bbold131 char#114 r --- */
      { 114,23175,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x85\x85\x05\x05\x05\x05\x07" }  },
      /* --- pixel bitmap for bbold131 char#115 s --- */
      { 115,23416,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x59\x7a\x60\x18\x7a" }  },
      /* --- pixel bitmap for bbold131 char#116 t --- */
      { 116,23653,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x51\x14\x45\x5f\x14\x45\x51\x9a\x1c" }  },
      /* --- pixel bitmap for bbold131 char#117 u --- */
      { 117,23912,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x85\x85\x85\x85\x85\xc6\xbc" }  },
      /* --- pixel bitmap for bbold131 char#118 v --- */
      { 118,24163,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc7\xa2\x4a\x45\xa1\x20\x10" }  },
      /* --- pixel bitmap for bbold131 char#119 w --- */
      { 119,24406,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x2c\xa0\x82\x54\xa4\x25\xaa\x30\x06\x21" }  },
      /* --- pixel bitmap for bbold131 char#120 x --- */
      { 120,24663,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\x52\x54\x28\x14\x2a\x4a\x87" }  },
      /* --- pixel bitmap for bbold131 char#121 y --- */
      { 121,24912,                      /* character number, location */
          8, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc7\xa2\x4a\x45\xa1\x20\x10\x04\x82\x20\x00" }  },
      /* --- pixel bitmap for bbold131 char#122 z --- */
      { 122,25163,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x50\x50\x28\x14\x0a\x0a\xff" }  },
      /* --- pixel bitmap for bbold131 char#123 \- --- */
      { 123,32654,                      /* character number, location */
          5, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  7,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f" }  },
      /* --- pixel bitmap for bbold131 char#124 | --- */
      { 124,32373,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  3,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6f\xdb\xb6\x6d\xdb\xb6\xed\x01" }  },
      /* --- pixel bitmap for bbold131 char#125 (noname) --- */
      { 125,32866,                      /* character number, location */
          5, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          { 14,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e" }  },
      /* --- pixel bitmap for bbold131 char#126 (noname) --- */
      { 126,33084,                      /* character number, location */
         13, 1,    6, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x42\x42\x21\x63\xa5\x42" }  },
      /* --- pixel bitmap for bbold131 char#127 \omega --- */
      { 127, 9097,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x31\x50\x01\x4b\x58\xc2\x12\x5a\x89\x31" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=4 for .160gf ---
 * mf '\mode=preview; mag=magstep(-15.29639112828755784636); input bbold10'
 * --------------------------------------------------------------------- */
/* --- fontdef for bbold160 --- */
static	chardef  bbold160[] =
   {
      /* --- pixel bitmap for bbold160 char#0 \Gamma --- */
      {   0,  246,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x0f\xc1\x21\x74\x70" }  },
      /* --- pixel bitmap for bbold160 char#1 \Delta --- */
      {   1,  520,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x08\x80\x02\x50\x00\x19\x20\x03\x92\x40\x12"
            "\x48\x82\x84\x90\x10\x09\x24\x81\x12\xe0\xff\x07" }  },
      /* --- pixel bitmap for bbold160 char#2 \Theta --- */
      {   2,  808,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x10\x0c\xa2\x40\x0a\x94\x80\x09\x98\xbe\x09"
            "\x98\x80\x0a\xa4\x40\x0c\x82\x10\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#3 \Lambda --- */
      {   3, 1103,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x08\x80\x02\x50\x00\x19\x20\x03\x92\x40\x12"
            "\x48\x82\x84\x90\x10\x09\x24\x81\x12\xe0\x03\x04" }  },
      /* --- pixel bitmap for bbold160 char#4 \Xi --- */
      {   4, 1390,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\xf5\xd0\x45\x40\xf5\xdd" }  },
      /* --- pixel bitmap for bbold160 char#5 \Pi --- */
      {   5, 1615,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x0f\xc1\x21\x61\x04\x61" }  },
      /* --- pixel bitmap for bbold160 char#6 \Sigma --- */
      {   6, 1917,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x2f\x01\x12\x40\x02\x24\x80\x04\x48\x00\x09\x48"
            "\x80\x04\x24\x40\x02\x12\x20\x01\xff\x0f" }  },
      /* --- pixel bitmap for bbold160 char#7 \Upsilon --- */
      {   7, 2193,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x13\x43\x1f\x21\x31\x21\x31\xf2\x41\x21\x40\x44\x40"
            "\xf5\x41\x21\x40\x44\x41" }  },
      /* --- pixel bitmap for bbold160 char#8 \Phi --- */
      {   8, 2477,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x00\x09\x90\x80\x19\x94\x22\x49\x91\x18\x89\x91"
            "\x28\x49\x94\x82\x19\x90\x00\x09\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#9 \Psi --- */
      {   9, 2777,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x00\x09\x90\x30\xc9\x92\x24\x49\x92\x24\x49\x92"
            "\x44\x29\x98\x01\x09\x90\x00\x09\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#10 \Omega --- */
      {  10, 3079,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x10\x0c\xa2\x40\x0a\x94\x80\x09\x98\x80\x09"
            "\x98\x80\x09\xa8\x40\x0a\xc4\x20\x0f\x0f" }  },
      /* --- pixel bitmap for bbold160 char#11 \alpha --- */
      {  11, 3375,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x74\xa2\x12\x13\x99\xa8\x44\x25\x4a\x21\x8e\xc1"
            "\x33" }  },
      /* --- pixel bitmap for bbold160 char#12 \beta --- */
      {  12, 3656,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x30\xa4\x60\x82\x09\x25\x93\x50\x82\x09\x26\x98"
            "\x60\x82\x09\x66\x94\x4e\x02\x09\x24\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#13 \gamma --- */
      {  13, 3972,                      /* character number, location */
         10, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc7\x71\xa0\x60\xa2\x48\x51\xc2\x84\x09\x13\x26\x54"
            "\xe4\x0c\x07" }  },
      /* --- pixel bitmap for bbold160 char#14 \delta --- */
      {  14, 4258,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x05\x0c\x60\x00\x87\x13\x45\x09\x13\x26\x4c"
            "\xa8\xc8\x19\x0e" }  },
      /* --- pixel bitmap for bbold160 char#15 \epsilon --- */
      {  15, 4540,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x1c\x29\x4c\x90\x23\x41\x02\x85\x8e\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#16 \zeta --- */
      {  16, 4797,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x18\x82\xc1\x50\x28\x12\x89\x44\x22\xa1\x70\x60"
            "\xc0\x40\x20\x0c" }  },
      /* --- pixel bitmap for bbold160 char#17 \eta --- */
      {  17, 5067,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x13\x21\x22\x31\x1f\x61\x21\x51\x04\x51\xf3\x91" }  },
      /* --- pixel bitmap for bbold160 char#18 \theta --- */
      {  18, 5349,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x98\x28\x52\x94\x30\x61\xc2\xfc\x09\x13\x26\x54"
            "\xa4\x88\x09\x0e" }  },
      /* --- pixel bitmap for bbold160 char#19 \iota --- */
      {  19, 5642,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x99\x99\x99\xca" }  },
      /* --- pixel bitmap for bbold160 char#20 \kappa --- */
      {  20, 5896,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x26\x96\x44\x0e\x19\xa4\x90\x44\x12\x89\x3c\x0c" }  },
      /* --- pixel bitmap for bbold160 char#21 \lambda --- */
      {  21, 6167,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x12\x48\x90\x20\x81\x04\x09\x12\x48\x90\x50\xa2"
            "\x24\x49\x64\x78" }  },
      /* --- pixel bitmap for bbold160 char#22 \mu --- */
      {  22, 6448,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x51\x0f\x61\x21\x51\x01\x22\x33\x21\x13\x11\x0f"
            "\x21\x21\x64\x61" }  },
      /* --- pixel bitmap for bbold160 char#23 \nu --- */
      {  23, 6737,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x13\x26\x4c\x94\x28\x49\x92\x14\x19\x0e\x00" }  },
      /* --- pixel bitmap for bbold160 char#24 \xi --- */
      {  24, 7004,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  7,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x45\x22\xa1\xe0\x31\x14\x89\x44\x22\xa1\x70\x60"
            "\xc0\x40\x20\x0c" }  },
      /* --- pixel bitmap for bbold160 char#25 \pi --- */
      {  25, 7277,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   10, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\xf7\x21\x21\x11\x20\x24\x11\x21" }  },
      /* --- pixel bitmap for bbold160 char#26 \rho --- */
      {  26, 7547,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x9c\x29\x4a\x98\x30\x61\xc2\x44\xc9\x72\x24\x48"
            "\x90\xe0\x01" }  },
      /* --- pixel bitmap for bbold160 char#27 \sigma --- */
      {  27, 7831,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x77\x86\x22\x12\x92\x90\x84\x24\x44\x11\xce\xc0"
            "\x01" }  },
      /* --- pixel bitmap for bbold160 char#28 \tau --- */
      {  28, 8095,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   10, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\xf6\x31\x21\x30\x41\x11\x82\x31" }  },
      /* --- pixel bitmap for bbold160 char#29 \upsilon --- */
      {  29, 8351,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x13\x26\x4c\x98\x30\x61\x42\x45\xce\x70\x00" }  },
      /* --- pixel bitmap for bbold160 char#30 \phi --- */
      {  30, 8619,                      /* character number, location */
         15, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 10,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x20\x81\x04\x12\x48\x20\xc1\x8c\x52\x49\x26\x99"
            "\x64\x92\x4a\x31\x83\x04\x12\x48\x20\x81\x07" }  },
      /* --- pixel bitmap for bbold160 char#31 \chi --- */
      {  31, 8931,                      /* character number, location */
         10, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\x45\x4a\xa2\xc4\x04\x09\x12\x12\x24\xc8\x48\x91"
            "\x94\xe8\x21" }  },
      /* --- pixel bitmap for bbold160 char#32 \psi --- */
      {  32, 9215,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   19, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x30\xf3\x31\x21\x3f\x61\x21\x21\x21\x11\x11\x21"
            "\x11\x23\x23\x10\xf3\x31\x21\x30\x34\x31" }  },
      /* --- pixel bitmap for bbold160 char#33 ! --- */
      {  33,26690,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x99\x99\x99\xf9\x60\x99\x06" }  },
      /* --- pixel bitmap for bbold160 char#34 (noname) --- */
      {  34,34970,                      /* character number, location */
         15, 1,    7, 1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\x25\x99\xa4\xe3\x08\x12\x24\x48\x10" }  },
      /* --- pixel bitmap for bbold160 char#35 # --- */
      {  35,26954,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x21\x30\xf5\x51\x21\x21\x36\x27\xf2\x51\x21\x21"
            "\x36\x27\xf5\x51\x21\x21\x30\x54\x21\x30" }  },
      /* --- pixel bitmap for bbold160 char#36 $ --- */
      {  36,27272,                      /* character number, location */
         17, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x00\x09\x98\x63\xc9\x91\x10\x09\x91\x10\x09\x96"
            "\x80\x19\x90\x06\x89\x90\x08\x89\x90\x38\x69\x9c\x01"
            "\x09\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#37 % --- */
      {  37,27586,                      /* character number, location */
         17, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 12,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x9f\x90\x89\x64\x48\x80\x04\x24\x40\x02\x24\x20"
            "\x01\x12\x20\x01\x09\x90\x80\x04\x48\x80\x04\x24\x40"
            "\x02\x24\x20\x01\x12\x26\x91\x09\xf9\x60" }  },
      /* --- pixel bitmap for bbold160 char#38 & --- */
      {  38,27912,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x00\x48\x00\x24\x00\x12\x00\x05\x80\x01\xb0\x00"
            "\x94\x00\x49\x80\x44\x40\x42\x24\x21\xa1\x60\x54\x2c"
            "\xf2\xe1\x00" }  },
      /* --- pixel bitmap for bbold160 char#39 ' --- */
      {  39,28203,                      /* character number, location */
         15, 1,    7, 1,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\xe9\x48\x12" }  },
      /* --- pixel bitmap for bbold160 char#40 ( --- */
      {  40,28436,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xc3\x28\x4a\x92\x24\x49\x92\x24\x49\x92\x24\x49"
            "\xa2\x28\x0c\x83\x03" }  },
      /* --- pixel bitmap for bbold160 char#41 ) --- */
      {  41,28730,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  6,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xc3\x50\x14\x49\x92\x24\x49\x92\x24\x49\x92\x24"
            "\x49\x51\x0c\x73\x00" }  },
      /* --- pixel bitmap for bbold160 char#42 * --- */
      {  42,29015,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x00\x09\x90\x00\x09\x91\x68\x69\x98\x01\x09\x98"
            "\x61\x69\x91\x08\x09\x90\x00\x09\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#43 + --- */
      {  43,29297,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\x50\xf5\x61\x21\x57\x26\xf5\x61\x21\x50\x64\x52" }  },
      /* --- pixel bitmap for bbold160 char#44 , --- */
      {  44,29559,                      /* character number, location */
          4, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\xe9\x48\x12" }  },
      /* --- pixel bitmap for bbold160 char#45 - --- */
      {  45,29786,                      /* character number, location */
          6, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  7,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e" }  },
      /* --- pixel bitmap for bbold160 char#46 . --- */
      {  46,29998,                      /* character number, location */
          4, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x69" }  },
      /* --- pixel bitmap for bbold160 char#47 / --- */
      {  47,30226,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 11,   23, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x74\x71\x21\xf2\x61\x21\x10\xf2\x51\x21\x20\xf2\x41"
            "\x21\x30\xf3\x31\x21\x40\xf2\x21\x21\x50\xf2\x11\x21"
            "\x61\x21\x74\x71" }  },
      /* --- pixel bitmap for bbold160 char#48 0 --- */
      {  48, 9814,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\xa2\x90\x42\x09\x26\x98\x60\x82\x09\x26\xa8"
            "\x90\x42\x8c\xe0\x01" }  },
      /* --- pixel bitmap for bbold160 char#49 1 --- */
      {  49,10095,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x73\x52\x21\x32\x11\x21\x30\xf8\x31\x21\x3a" }  },
      /* --- pixel bitmap for bbold160 char#50 2 --- */
      {  50,10356,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x18\x25\x64\x90\x40\x02\x05\x1c\x10\x30\x20\x60"
            "\x80\x00\x01\xfc\x0f" }  },
      /* --- pixel bitmap for bbold160 char#51 3 --- */
      {  51,10609,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x18\x25\x64\x90\x40\x02\x05\x0e\x70\x40\x02\x19"
            "\xa4\x90\xc6\xe1\x01" }  },
      /* --- pixel bitmap for bbold160 char#52 4 --- */
      {  52,10876,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x03\x0c\x28\x90\x60\x82\x09\x25\x92\x48\xf2"
            "\x39\x24\x90\xc0\x03" }  },
      /* --- pixel bitmap for bbold160 char#53 5 --- */
      {  53,11139,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x27\x90\xc0\x1f\x80\x00\x04\x20\x80\x00\x02\x18"
            "\xa0\x40\x86\xe0\x01" }  },
      /* --- pixel bitmap for bbold160 char#54 6 --- */
      {  54,11386,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x08\x16\x50\x9e\x8d\x2c\x94\x60\x82\x09\x26\x98"
            "\xa0\x42\x8c\xe0\x01" }  },
      /* --- pixel bitmap for bbold160 char#55 7 --- */
      {  55,11665,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03\x09\x12\x48\x90\x40\x82\x04\x12\x24\x90\x20"
            "\x81\x04\x09\x3c\x00" }  },
      /* --- pixel bitmap for bbold160 char#56 8 --- */
      {  56,11926,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x28\x94\x60\x82\x09\x2a\xc4\x8f\x63\x09\x26\x98"
            "\x60\x82\x8e\xe1\x01" }  },
      /* --- pixel bitmap for bbold160 char#57 9 --- */
      {  57,12203,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\xa2\x50\x82\x09\x26\x98\x60\x82\x0a\x33\x9a"
            "\xa7\x80\x06\xe1\x03" }  },
      /* --- pixel bitmap for bbold160 char#58 : --- */
      {  58,30520,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x69\x00\x96\x69" }  },
      /* --- pixel bitmap for bbold160 char#59 ; --- */
      {  59,30756,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  4,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x69\x00\x96\xe9\x48\x12" }  },
      /* --- pixel bitmap for bbold160 char#60 < --- */
      {  60,31005,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd2\xa3\xa2\xa3\x93\xa2\x12\xb2\x22\xb2\x22\xb2\x22"
            "\xb2\x22\xb6" }  },
      /* --- pixel bitmap for bbold160 char#61 \cdot --- */
      {  61,31245,                      /* character number, location */
          8, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x69" }  },
      /* --- pixel bitmap for bbold160 char#62 > --- */
      {  62,31475,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x00\x0e\x00\x18\x00\x70\x00\xc0\x01\x60\x03\xcc"
            "\x80\x19\xb0\x03\x32\xc0\x07\x00" }  },
      /* --- pixel bitmap for bbold160 char#63 ? --- */
      {  63,31721,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x60\x02\x18\x80\x00\x08\x40\xc0\x03\x0a\x90"
            "\x00\x0f\x00\x00\x06\x90\x00\x09\x60\x00" }  },
      /* --- pixel bitmap for bbold160 char#64 @ --- */
      {  64,31973,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x98\x28\x52\x94\x30\x61\xfa\x94\xe9\x13\x24\x50"
            "\xa8\x90\x19\x0e" }  },
      /* --- pixel bitmap for bbold160 char#65 A --- */
      {  65,12482,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x06\x60\x00\x09\x90\x00\x09\x48\x81\x14\x24"
            "\x42\x22\x24\x22\x7f\x12\x94\x80\x0f\x08" }  },
      /* --- pixel bitmap for bbold160 char#66 B --- */
      {  66,12759,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x48\x58\x02\x13\x98\xc0\x04\x26\x2c\x1f\x09\x4b"
            "\x60\x02\x13\x98\xc0\x84\xfd\x03" }  },
      /* --- pixel bitmap for bbold160 char#67 C --- */
      {  67,13048,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x81\x20\x0c\xa4\x80\x0a\x90\x00\x09\x90\x00\x09"
            "\x90\x00\x0a\xa0\x80\x0c\x84\x20\xf0\x01" }  },
      /* --- pixel bitmap for bbold160 char#68 D --- */
      {  68,13317,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x90\x10\x09\x92\x40\x09\x94\x80\x09\x98\x80\x09"
            "\x98\x80\x09\x94\x40\x09\x92\x10\xff\x00" }  },
      /* --- pixel bitmap for bbold160 char#69 E --- */
      {  69,13608,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x0f\x51\x21\x71\x24\x4f\x51\x21\x7b" }  },
      /* --- pixel bitmap for bbold160 char#70 F --- */
      {  70,13873,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x0f\x51\x21\x71\x24\x4f\x51\x21\x74\x71" }  },
      /* --- pixel bitmap for bbold160 char#71 G --- */
      {  71,14138,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x81\x20\x0c\xa4\x80\x0a\x90\x00\x09\x90\xf0\x09"
            "\x98\x80\x0a\xa8\x80\x0c\x84\x20\xf0\x01" }  },
      /* --- pixel bitmap for bbold160 char#72 H --- */
      {  72,14415,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x71\x0f\x51\x21\x71\x01\x29\x0f\x51\x21\x71\x04"
            "\x71" }  },
      /* --- pixel bitmap for bbold160 char#73 I --- */
      {  73,14708,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xc1\x21\x04" }  },
      /* --- pixel bitmap for bbold160 char#74 J --- */
      {  74,14973,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x74\xf9\x71\x21\x01\x61\x11\x21\x51\x11\x31\x42\x54"
            "\x41" }  },
      /* --- pixel bitmap for bbold160 char#75 K --- */
      {  75,15242,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x4c\x50\x82\x12\x92\x88\x24\x24\x21\x05\x59\xc8"
            "\x42\x22\x12\x92\xa0\x04\x3d\x10" }  },
      /* --- pixel bitmap for bbold160 char#76 L --- */
      {  76,15537,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x7f\xc1\x21\x7b" }  },
      /* --- pixel bitmap for bbold160 char#77 M --- */
      {  77,15802,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x70\x00\x17\xd0\x04\x99\x20\x33\x62\x2a\x4c\x82"
            "\x09\x30\x01\x26\xc0\x04\x98\x00\x13\xe0\x03\x04" }  },
      /* --- pixel bitmap for bbold160 char#78 N --- */
      {  78,16109,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x38\x80\x05\x58\x80\x09\x98\x81\x29\x98\x82\x49"
            "\x98\x88\x09\x99\xa0\x09\x9a\xc0\x0f\x08" }  },
      /* --- pixel bitmap for bbold160 char#79 O --- */
      {  79,16416,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x10\x0c\xa2\x40\x0a\x94\x80\x09\x98\x80\x09"
            "\x98\x80\x0a\xa4\x40\x0c\x82\x10\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#80 P --- */
      {  80,16699,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x31\x21\x42\x1f\x31\x21\x61\x01\x21\x42\x11\x25"
            "\x3f\x51\x21\x74\x71" }  },
      /* --- pixel bitmap for bbold160 char#81 Q --- */
      {  81,16976,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x10\x0c\xa2\x40\x0a\x94\x80\x09\x98\x80\x09"
            "\x98\x80\x0a\xa4\x44\x4c\x82\x18\xf0\x01\x20\x00\x02"
            "\x40\x00\x08" }  },
      /* --- pixel bitmap for bbold160 char#82 R --- */
      {  82,17271,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x48\x58\x02\x13\x98\xc0\x04\x26\x2c\x1f\x49\x48"
            "\x42\x22\x12\x92\xa0\x04\x3d\x10" }  },
      /* --- pixel bitmap for bbold160 char#83 S --- */
      {  83,17562,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x70\x48\x82\x12\x98\x80\x04\x38\x00\x1f\x00\x03"
            "\x20\x00\x03\x28\x40\x82\xe1\x03" }  },
      /* --- pixel bitmap for bbold160 char#84 T --- */
      {  84,17821,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\xfc\x41\x21\x40\x44\x41" }  },
      /* --- pixel bitmap for bbold160 char#85 U --- */
      {  85,18086,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x71\x0f\x81\x21\x71\xf1\x11\x11\x61\x10\x22\x51"
            "\x51\x41\x74\x40" }  },
      /* --- pixel bitmap for bbold160 char#86 V --- */
      {  86,18375,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x30\x01\x4a\x20\x09\x44\x42\x48\x08\x92\x40\x12"
            "\x48\x02\x32\x40\x06\x50\x00\x0a\x80\x00\x10\x00" }  },
      /* --- pixel bitmap for bbold160 char#87 W --- */
      {  87,18656,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x00\x13\x00\x4a\x00\x92\x00\x24\x01\x48\x02\x10"
            "\x09\x10\x92\x20\xa4\x42\x90\x45\x20\x91\x40\x22\x81"
            "\x82\x02\x06\x03\x04\x04" }  },
      /* --- pixel bitmap for bbold160 char#88 X --- */
      {  88,18963,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x2f\x48\x84\x44\x24\x48\x02\x13\x20\x01\x09\x48"
            "\x80\x0c\x24\x41\x22\x12\x22\x41\x0f\x08" }  },
      /* --- pixel bitmap for bbold160 char#89 Y --- */
      {  89,19248,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x28\x41\x12\x44\x22\x24\x82\x14\x48\x01\x09\x90"
            "\x00\x09\x90\x00\x09\x90\x00\x09\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#90 Z --- */
      {  90,19527,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x48\x80\x04\x24\x40\x02\x12\x20\x01\x09\x48"
            "\x80\x04\x24\x40\x02\x12\x20\x01\xff\x0f" }  },
      /* --- pixel bitmap for bbold160 char#91 [ --- */
      {  91,32269,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   23, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x21\x2f\x51\x21\x26" }  },
      /* --- pixel bitmap for bbold160 char#92 \\ --- */
      {  92,32571,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 11,   23, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x71\x21\x70\xf2\x11\x21\x60\xf2\x21\x21\x50\xf3"
            "\x31\x21\x40\xf2\x41\x21\x30\xf2\x51\x21\x20\xf2\x61"
            "\x21\x10\x71\x21\x74" }  },
      /* --- pixel bitmap for bbold160 char#93 ] --- */
      {  93,32880,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  6,   23, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x21\x21\xf5\x21\x21\x06" }  },
      /* --- pixel bitmap for bbold160 char#94 (noname) --- */
      {  94,33183,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x41\x18\x46\x51\x92\x14\x45\x91\x24\x51\x14"
            "\x86\x41\x10\x08\x02" }  },
      /* --- pixel bitmap for bbold160 char#95 (noname) --- */
      {  95,33467,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  6,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x20\x08\x86\xa1\x28\x92\x24\x8a\xa2\x24\x29\x8a"
            "\x61\x08\x42\x10\x00" }  },
      /* --- pixel bitmap for bbold160 char#96 (noname) --- */
      {  96,33754,                      /* character number, location */
         15, 1,    7, 1,      /* topleft row,col, and botleft row,col */
          {  4,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x12\x97\x69" }  },
      /* --- pixel bitmap for bbold160 char#97 a --- */
      {  97,19792,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x1d\x2b\x4c\x98\x30\x61\x42\x85\x8e\xf1\x02" }  },
      /* --- pixel bitmap for bbold160 char#98 b --- */
      {  98,20053,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x90\x00\x09\x90\x00\x09\x90\x1e\x19\x96\x40\x09"
            "\x98\x80\x09\x98\x80\x09\x94\x61\xef\x01" }  },
      /* --- pixel bitmap for bbold160 char#99 c --- */
      {  99,20338,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x1c\x29\x4c\x90\x20\x41\x02\x85\x8e\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#100 d --- */
      { 100,20587,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x02\x04\x08\x10\xaf\x63\x85\x09\x13\x26\x4c"
            "\xa8\xd0\x31\x5e" }  },
      /* --- pixel bitmap for bbold160 char#101 e --- */
      { 101,20858,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x9c\x29\x4a\x98\x3f\x41\x02\x85\x8e\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#102 f --- */
      { 102,21109,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x55\x32\x91\xc8\x25\x12\x89\x44\x22\x91\x48\x3c"
            "\x00" }  },
      /* --- pixel bitmap for bbold160 char#103 g --- */
      { 103,21378,                      /* character number, location */
         10, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x1d\x2b\x4c\x98\x30\x61\x42\x85\x8e\xf1\x02\x04"
            "\x34\x8c\x07" }  },
      /* --- pixel bitmap for bbold160 char#104 h --- */
      { 104,21649,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x6f\x31\x21\x61\x21\x13\x21\x22\x31\x1f\x61\x21"
            "\x51\x04\x51" }  },
      /* --- pixel bitmap for bbold160 char#105 i --- */
      { 105,21934,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x69\xf0\x99\x99\x99\x99\x0f" }  },
      /* --- pixel bitmap for bbold160 char#106 j --- */
      { 106,22193,                      /* character number, location */
         15, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  7,   19, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x10\xf1\x31\x21\x42\xb4\xfa\x31\x21\x01\x21\x11"
            "\x24\x24" }  },
      /* --- pixel bitmap for bbold160 char#107 k --- */
      { 107,22470,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x24\x90\x40\x02\x09\x24\x98\x50\x22\x49\xe4\x90"
            "\x42\x12\x89\x24\xf4\x20" }  },
      /* --- pixel bitmap for bbold160 char#108 l --- */
      { 108,22753,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xb1\x21\x11\x11\x22" }  },
      /* --- pixel bitmap for bbold160 char#109 m --- */
      { 109,23018,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x26\x31\x25\xc6\xc4\x98\x10\x13\x62\x42\x4c\x88"
            "\x09\xf1\x21\x02" }  },
      /* --- pixel bitmap for bbold160 char#110 n --- */
      { 110,23301,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x13\x21\x22\x31\x1f\x61\x21\x51\x04\x51" }  },
      /* --- pixel bitmap for bbold160 char#111 o --- */
      { 111,23566,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x9c\x29\x4a\x98\x30\x61\x42\x45\xce\x70\x00" }  },
      /* --- pixel bitmap for bbold160 char#112 p --- */
      { 112,23823,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xef\x91\x61\x09\x94\x80\x09\x98\x80\x09\x98\x40\x19"
            "\x96\x1e\x09\x90\x00\x09\xf0\x00" }  },
      /* --- pixel bitmap for bbold160 char#113 q --- */
      { 113,24104,                      /* character number, location */
         10, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x1d\x2b\x4c\x98\x30\x61\x42\x85\x8e\xf1\x02\x04"
            "\x08\x10\x20" }  },
      /* --- pixel bitmap for bbold160 char#114 r --- */
      { 114,24373,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xef\x64\x94\x60\x02\x09\x24\x90\x40\x02\x09\x3c\x00" }  },
      /* --- pixel bitmap for bbold160 char#115 s --- */
      { 115,24624,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9e\x54\x32\xe1\x01\x01\x83\x22\x0e" }  },
      /* --- pixel bitmap for bbold160 char#116 t --- */
      { 116,24867,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8f\x44\x22\x91\xc8\x27\x12\x89\x44\x22\x91\x54\x71"
            "\x00" }  },
      /* --- pixel bitmap for bbold160 char#117 u --- */
      { 117,25136,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x13\x26\x4c\x98\x30\x61\x42\xc5\xce\x71\x02" }  },
      /* --- pixel bitmap for bbold160 char#118 v --- */
      { 118,25399,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x13\x4a\x92\x44\x86\x0c\x0a\x14\x10\x20\x00" }  },
      /* --- pixel bitmap for bbold160 char#119 w --- */
      { 119,25650,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x30\x01\x4a\x20\x09\x24\x85\x48\x09\x29\xa1\x28"
            "\x18\x03\x41\x00" }  },
      /* --- pixel bitmap for bbold160 char#120 x --- */
      { 120,25921,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\x25\x51\x42\x82\x84\x04\x09\x29\x92\x1e\x02" }  },
      /* --- pixel bitmap for bbold160 char#121 y --- */
      { 121,26178,                      /* character number, location */
         10, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  9,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x13\x4a\x92\x44\x86\x0c\x0a\x14\x10\x20\x20\x40"
            "\x60\x20\x00" }  },
      /* --- pixel bitmap for bbold160 char#122 z --- */
      { 122,26437,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x21\x41\x42\x82\x84\x04\x09\x09\x12\xfe\x03" }  },
      /* --- pixel bitmap for bbold160 char#123 \- --- */
      { 123,34284,                      /* character number, location */
          7, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          {  9,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09" }  },
      /* --- pixel bitmap for bbold160 char#124 | --- */
      { 124,33987,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  4,   23, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x21\x0f\x51\x21\x04" }  },
      /* --- pixel bitmap for bbold160 char#125 (noname) --- */
      { 125,34496,                      /* character number, location */
          7, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          { 17,    1, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03" }  },
      /* --- pixel bitmap for bbold160 char#126 (noname) --- */
      { 126,34714,                      /* character number, location */
         15, 1,    7, 1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x12\x24\x48\x10\xc7\x25\x99\xa4\x61" }  },
      /* --- pixel bitmap for bbold160 char#127 \omega --- */
      { 127, 9537,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xc2\x81\x29\xa0\x04\x98\x04\x93\x60\x12\x4c\x85"
            "\xaa\x88\xe3\x00" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=5 for .180gf ---
 * mf '\mode=preview; mag=magstep(-14.65037297372839890542); input bbold10'
 * --------------------------------------------------------------------- */
/* --- fontdef for bbold180 --- */
static	chardef  bbold180[] =
   {
      /* --- pixel bitmap for bbold180 char#0 \Gamma --- */
      {   0,  246,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0f\xe1\x21\x84\x80" }  },
      /* --- pixel bitmap for bbold180 char#1 \Delta --- */
      {   1,  528,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x08\x80\x02\x50\x00\x19\x20\x03\x64\x40\x12"
            "\x48\x02\x49\x90\x10\x12\x22\x41\x24\x90\x04\x4a\x80"
            "\xff\x1f" }  },
      /* --- pixel bitmap for bbold180 char#2 \Theta --- */
      {   2,  826,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 14,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\x86\xc1\x80\x30\x20\x0a\x90\x02\x94\x00\x26"
            "\x80\x09\x60\xf2\x99\x00\x26\x80\x09\xa0\x02\xa4\x00"
            "\x31\x20\x0c\x08\x86\x01\x1e\x00" }  },
      /* --- pixel bitmap for bbold180 char#3 \Lambda --- */
      {   3, 1141,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x08\x80\x02\x50\x00\x19\x20\x03\x64\x40\x12"
            "\x48\x02\x49\x90\x10\x12\x22\x41\x24\x90\x04\x4a\x80"
            "\x0f\x10" }  },
      /* --- pixel bitmap for bbold180 char#4 \Xi --- */
      {   4, 1438,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   17, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\xf6\xd0\x45\x40\xf6\xdd" }  },
      /* --- pixel bitmap for bbold180 char#5 \Pi --- */
      {   5, 1663,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0f\xe1\x21\x71\x04\x71" }  },
      /* --- pixel bitmap for bbold180 char#6 \Sigma --- */
      {   6, 1977,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xbf\x04\x20\x01\x90\x00\x24\x00\x12\x00\x09\x40"
            "\x02\x20\x01\x24\x00\x09\x20\x01\x24\x00\x09\x20\x01"
            "\x48\x00\xff\x3f" }  },
      /* --- pixel bitmap for bbold180 char#7 \Upsilon --- */
      {   7, 2261,                      /* character number, location */
         18, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   18, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x62\x31\x21\x41\x21\x1f\x21\x41\x21\x41\xf3\x51"
            "\x21\x50\x54\x50\xf6\x51\x21\x50\x54\x50" }  },
      /* --- pixel bitmap for bbold180 char#8 \Phi --- */
      {   8, 2561,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\x48\x00\x12\xc0\x0c\x2c\x8d\x48\x24\x12\x85"
            "\x84\x21\x61\x48\x28\x12\x89\x44\x2c\x0d\xcc\x00\x12"
            "\x80\x04\xe0\x01" }  },
      /* --- pixel bitmap for bbold180 char#9 \Psi --- */
      {   9, 2877,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\x48\x00\x12\x8c\xc4\x22\x11\x49\x42\x92\x90"
            "\x24\x24\x09\x49\x42\x92\xa0\x14\x30\x03\x48\x00\x12"
            "\x80\x04\xe0\x01" }  },
      /* --- pixel bitmap for bbold180 char#10 \Omega --- */
      {  10, 3195,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   18, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x82\x42\x30\xf1\x22\x71\x20\xf1\x11\x11\x81\x1f"
            "\x61\x21\x91\xf1\x11\x11\x81\x10\xf1\x22\x71\x24\x64" }  },
      /* --- pixel bitmap for bbold180 char#11 \alpha --- */
      {  11, 3505,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\xc0\x88\x8a\xa8\x88\x09\x99\x90\x09\x95\x50\x09"
            "\xa5\x30\x0a\xc2\xd8\x78\x00" }  },
      /* --- pixel bitmap for bbold180 char#12 \beta --- */
      {  12, 3806,                      /* character number, location */
         18, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xc1\x10\x03\x15\xa8\xc0\x04\x26\x28\x31\x09\x4a"
            "\x50\x02\x13\x98\xc0\x04\x26\x30\x81\x09\xca\x50\x7a"
            "\x12\x90\x80\x04\x3c\x00" }  },
      /* --- pixel bitmap for bbold180 char#13 \gamma --- */
      {  13, 4144,                      /* character number, location */
         11, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 10,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\xe3\x01\x03\x12\x8c\x28\xa4\x50\x82\x09\x26\x98"
            "\x60\x82\x09\x2a\xa4\x10\x23\x78\x00" }  },
      /* --- pixel bitmap for bbold180 char#14 \delta --- */
      {  14, 4444,                      /* character number, location */
         18, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 10,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x18\x26\x50\x80\x01\x04\x60\x00\x0e\xcc\x28\x94"
            "\x60\x82\x09\x26\x98\xa0\x42\x0a\x31\x82\x07" }  },
      /* --- pixel bitmap for bbold180 char#15 \epsilon --- */
      {  15, 4744,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\xa6\x90\x82\x09\xe4\x90\x40\x02\x09\x28\xa8"
            "\x10\x63\x78\x00" }  },
      /* --- pixel bitmap for bbold180 char#16 \zeta --- */
      {  16, 5017,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  8,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x60\x10\x08\x0c\x0c\x0a\x0a\x09\x09\x09\x09\x09"
            "\x09\x0a\x0c\x18\x60\x80\x80\x80\x60" }  },
      /* --- pixel bitmap for bbold180 char#17 \eta --- */
      {  17, 5295,                      /* character number, location */
         12, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   17, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x25\x41\x11\x21\x51\x1f\x71\x21\x61\x04\x61\xf4"
            "\xa1" }  },
      /* --- pixel bitmap for bbold180 char#18 \theta --- */
      {  18, 5587,                      /* character number, location */
         18, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 10,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\xa2\x90\x42\x0a\x25\x98\x60\x82\x09\xe6\x9f"
            "\x60\x82\x09\x26\xa8\x90\x42\x0a\x31\x82\x07" }  },
      /* --- pixel bitmap for bbold180 char#19 \iota --- */
      {  19, 5904,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x9f\x99\x99\x99\xa9\x0c" }  },
      /* --- pixel bitmap for bbold180 char#20 \kappa --- */
      {  20, 6162,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x4c\x58\x32\x72\x90\x81\x14\x24\x21\x01\x89\x48"
            "\xc8\x83\x01" }  },
      /* --- pixel bitmap for bbold180 char#21 \lambda --- */
      {  21, 6437,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x24\x20\x81\x04\x12\x90\x40\x02\x12\x48\x20\x81"
            "\x09\x26\x94\x90\x24\x92\x90\xc1\x03" }  },
      /* --- pixel bitmap for bbold180 char#22 \mu --- */
      {  22, 6726,                      /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   16, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x61\x0f\x71\x21\x61\x01\x21\x53\x22\x43\x21\x14"
            "\x2f\x21\x21\x74\x72" }  },
      /* --- pixel bitmap for bbold180 char#23 \nu --- */
      {  23, 7025,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x26\x98\x60\x82\x09\x25\x94\x48\x12\x29\x64\x70"
            "\x00" }  },
      /* --- pixel bitmap for bbold180 char#24 \xi --- */
      {  24, 7298,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  8,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x0e\x09\x09\x09\x0e\x38\x0c\x0a\x09\x09\x09\x09"
            "\x09\x0a\x0c\x18\x60\x80\x80\x80\x60" }  },
      /* --- pixel bitmap for bbold180 char#25 \pi --- */
      {  25, 7577,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\xf8\x21\x21\x21\x20\x24\x21\x22" }  },
      /* --- pixel bitmap for bbold180 char#26 \rho --- */
      {  26, 7853,                      /* character number, location */
         12, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 10,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\xa2\x90\x42\x09\x26\x98\x60\x82\x09\x26\x94"
            "\x50\x22\x79\x24\x90\x40\x02\x0f\x00" }  },
      /* --- pixel bitmap for bbold180 char#27 \sigma --- */
      {  27, 8155,                      /* character number, location */
         11, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xcf\x08\x0a\x91\x20\x09\x92\x20\x09\x92\x20\x0a"
            "\xa1\x10\x8c\x80\x07" }  },
      /* --- pixel bitmap for bbold180 char#28 \tau --- */
      {  28, 8431,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\xf7\x31\x21\x30\x41\x11\x82\x31" }  },
      /* --- pixel bitmap for bbold180 char#29 \upsilon --- */
      {  29, 8691,                      /* character number, location */
         11, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x51\x0f\x71\x21\x51\x11\x11\x41\x32\x31\x54\x31" }  },
      /* --- pixel bitmap for bbold180 char#30 \phi --- */
      {  30, 8971,                      /* character number, location */
         17, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 10,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x20\x81\x04\x12\x48\x20\x81\x04\x33\x4a\x25\x99"
            "\x64\x92\x49\x26\xa9\x14\x33\x48\x20\x81\x04\x12\x48"
            "\xe0\x01" }  },
      /* --- pixel bitmap for bbold180 char#31 \chi --- */
      {  31, 9299,                      /* character number, location */
         11, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 10,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x0b\x29\x12\x49\x94\x60\x02\x09\x12\x48\x90\x40"
            "\x06\x29\x92\x48\x94\xd0\x83" }  },
      /* --- pixel bitmap for bbold180 char#32 \psi --- */
      {  32, 9595,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 10,   22, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x30\xf4\x31\x21\x3f\x71\x21\x21\x21\x11\x11\x21"
            "\x11\x23\x23\x10\xf4\x31\x21\x30\x34\x30" }  },
      /* --- pixel bitmap for bbold180 char#33 ! --- */
      {  33,27898,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  6,   18, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x14\x10\xf8\x11\x21\x10\x14\x84\x1f\x31\x41\x14\x11" }  },
      /* --- pixel bitmap for bbold180 char#34 (noname) --- */
      {  34,36498,                      /* character number, location */
         18, 0,    8, 0,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x2f\x14\x86\xc2\x50\x18\x0a\x7d\x3e\x04\x42\x20"
            "\x0c\x46\x20\x00" }  },
      /* --- pixel bitmap for bbold180 char#35 # --- */
      {  35,28174,                      /* character number, location */
         17, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x41\x30\xf5\x41\x21\x41\x35\x29\xf4\x41\x21\x41"
            "\x35\x29\xf6\x41\x21\x41\x30\x44\x41\x30" }  },
      /* --- pixel bitmap for bbold180 char#36 $ --- */
      {  36,28510,                      /* character number, location */
         19, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x00\x09\x98\x43\xc9\x92\x10\x09\x91\x10\x09\x92"
            "\x40\x09\x90\x00\x29\x90\x04\x89\x90\x08\x89\x90\x34"
            "\x29\x9c\x01\x09\xf0\x00" }  },
      /* --- pixel bitmap for bbold180 char#37 % --- */
      {  37,28836,                      /* character number, location */
         20, 0,   -9, 0,      /* topleft row,col, and botleft row,col */
          { 14,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x40\x88\x17\x22\x85\x24\x21\x89\x47\x02\x48\x00"
            "\x12\x80\x04\x20\x01\x24\x00\x09\x40\x02\x48\x00\x12"
            "\x80\x04\x90\x00\x24\x00\x09\x20\x01\x48\x00\x12\x80"
            "\x04\x90\x78\x24\x21\x49\x28\x11\x7a\x84\x00\x1e" }  },
      /* --- pixel bitmap for bbold180 char#38 & --- */
      {  38,29190,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x00\x40\x02\x40\x08\x80\x10\x00\x12\x00\x24\x00"
            "\x28\x00\x30\x00\x58\x00\x18\x01\x28\x02\x48\x08\x90"
            "\x10\x22\x41\x44\x82\x84\x04\x86\x0a\x0c\x19\x26\xe2"
            "\x83\x03" }  },
      /* --- pixel bitmap for bbold180 char#39 ' --- */
      {  39,29501,                      /* character number, location */
         18, 0,    8, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\xa1\x0f\x21\x8c\x00" }  },
      /* --- pixel bitmap for bbold180 char#40 ( --- */
      {  40,29742,                      /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  6,   25, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\x22\x20\xf2\x11\x11\x2f\xe1\x21\x20\xf2\x11\x11"
            "\x20\x22\x53" }  },
      /* --- pixel bitmap for bbold180 char#41 ) --- */
      {  41,30048,                      /* character number, location */
         19, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  6,   25, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x52\x20\xf2\x21\x11\x10\xfe\x21\x21\xf2\x21\x11"
            "\x10\x22\x23\x31" }  },
      /* --- pixel bitmap for bbold180 char#42 * --- */
      {  42,30345,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\x48\x00\x12\x80\x04\x21\xa1\x49\x86\x73\x80"
            "\x04\x20\x01\x48\x80\x73\x98\x64\x21\x21\x48\x00\x12"
            "\x80\x04\xe0\x01" }  },
      /* --- pixel bitmap for bbold180 char#43 + --- */
      {  43,30635,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x74\x60\xf6\x71\x21\x68\x27\xf6\x71\x21\x60\x74\x62" }  },
      /* --- pixel bitmap for bbold180 char#44 , --- */
      {  44,30905,                      /* character number, location */
          5, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\xa1\x0f\x21\x8c\x00" }  },
      /* --- pixel bitmap for bbold180 char#45 - --- */
      {  45,31140,                      /* character number, location */
          6, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  8,    1, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff" }  },
      /* --- pixel bitmap for bbold180 char#46 . --- */
      {  46,31352,                      /* character number, location */
          5, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\xa1\x07" }  },
      /* --- pixel bitmap for bbold180 char#47 / --- */
      {  47,31588,                      /* character number, location */
         19, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 12,   25, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x81\x21\xf2\x71\x21\x10\xf2\x61\x21\x20\xf2\x51"
            "\x21\x30\xf2\x41\x21\x40\xf2\x31\x21\x50\xf2\x21\x21"
            "\x60\xf2\x11\x21\x71\x21\x84\x80" }  },
      /* --- pixel bitmap for bbold180 char#48 0 --- */
      {  48,10226,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x60\x0c\x43\x14\xa4\xa0\x04\x26\x30\x81\x09\x4c"
            "\x60\x02\x13\x98\x40\x05\x29\x88\x21\x8c\x81\x03" }  },
      /* --- pixel bitmap for bbold180 char#49 1 --- */
      {  49,10527,                      /* character number, location */
         16, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x62\x82\x11\x63\x21\x42\x21\x21\x40\xfa\x41\x21\x4c" }  },
      /* --- pixel bitmap for bbold180 char#50 2 --- */
      {  50,10798,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x8c\xa0\x02\x19\x48\x40\x02\x12\x50\x80\x01"
            "\x04\x18\x30\x40\x00\x01\x04\x20\x00\xff\x07" }  },
      /* --- pixel bitmap for bbold180 char#51 3 --- */
      {  51,11061,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x8c\xa0\x02\x19\x48\x40\x02\x12\x70\xe0\x00"
            "\x0c\xa0\x00\x09\xc8\x40\x06\x52\x50\x84\xc1\x07" }  },
      /* --- pixel bitmap for bbold180 char#52 4 --- */
      {  52,11344,                      /* character number, location */
         16, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x0c\x60\x80\x02\x12\x98\xc0\x04\x25\x24\x11"
            "\x89\x48\x7e\x0e\x12\x90\x80\x04\x3c" }  },
      /* --- pixel bitmap for bbold180 char#53 5 --- */
      {  53,11617,                      /* character number, location */
         16, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   17, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x0f\x21\x21\x78\xb1\x20\xf1\x91\x10\xf3\xa1\x01"
            "\x92\x81\x21\x71\x31\x42\x54\x40" }  },
      /* --- pixel bitmap for bbold180 char#54 6 --- */
      {  54,11874,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x80\x02\x18\xc0\x7c\x34\x64\x41\x0b\x4a"
            "\x60\x02\x13\x98\xc0\x04\x2a\x48\x41\x8c\x81\x03" }  },
      /* --- pixel bitmap for bbold180 char#55 7 --- */
      {  55,12171,                      /* character number, location */
         16, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x07\x24\x90\x80\x04\x12\x90\x40\x02\x12\x48\x40"
            "\x02\x09\x48\x20\x01\x09\x24\xe0\x01" }  },
      /* --- pixel bitmap for bbold180 char#56 8 --- */
      {  56,12440,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x60\x88\x82\x12\x98\xc0\x04\x26\xd0\x61\xf8\x60"
            "\x88\x82\x12\x98\xc0\x04\x26\x50\x41\x0c\xc1\x07" }  },
      /* --- pixel bitmap for bbold180 char#57 9 --- */
      {  57,12737,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x60\x8c\x82\x14\x94\xc0\x04\x26\x30\x81\x09\x54"
            "\xb0\x82\x19\x8a\xcf\x00\x06\x50\x40\x04\xc1\x07" }  },
      /* --- pixel bitmap for bbold180 char#58 : --- */
      {  58,31890,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\xa1\x07\x78\x61\x18\x86\x1e" }  },
      /* --- pixel bitmap for bbold180 char#59 ; --- */
      {  59,32142,                      /* character number, location */
         12, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  6,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\xa1\x07\x78\x61\x18\x86\x3e\x84\x30\x02" }  },
      /* --- pixel bitmap for bbold180 char#60 < --- */
      {  60,32407,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   13, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x12\xc3\xc2\xc3\xb3\xc3\xc2\x31\xc2\x32\xc2\x32"
            "\xc2\x32\xc2\x32\xc2\x32\xc6" }  },
      /* --- pixel bitmap for bbold180 char#61 \cdot --- */
      {  61,32653,                      /* character number, location */
          9, 0,    3, 0,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\xa1\x07" }  },
      /* --- pixel bitmap for bbold180 char#62 > --- */
      {  62,32891,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   13, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x32\xe0\x33\xe0\x33\xe0\x32\xe0\x33\xd1\x32"
            "\x92\x32\x82\x32\x82\x32\x82\x32\x82\x32\x96\xb1" }  },
      /* --- pixel bitmap for bbold180 char#63 ? --- */
      {  63,33143,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   19, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x52\x51\x31\x81\x1f\x11\xa1\xb1\xa1\xa2\x73\x81"
            "\x11\x81\x21\x84\xe0\x64\x40\xf3\x31\x41\x30\x44\x41" }  },
      /* --- pixel bitmap for bbold180 char#64 @ --- */
      {  64,33409,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc0\x10\x0c\xa2\x40\x0a\x94\x40\x09\x98\xf8\x49"
            "\x98\x84\x49\x98\x78\x09\x90\x00\x0a\xa4\x40\x0c\xc2"
            "\x10\xf0\x00" }  },
      /* --- pixel bitmap for bbold180 char#65 A --- */
      {  65,13034,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x30\x00\x0c\x80\x04\x20\x01\xa4\x00\x29\x40"
            "\x0a\x48\x04\x12\x41\x82\x90\x20\xe4\x8f\x04\x24\x01"
            "\x25\x80\x0f\x20" }  },
      /* --- pixel bitmap for bbold180 char#66 B --- */
      {  66,13325,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x91\x20\x09\x94\x80\x09\x98\x80\x09\x94\x20\xf9"
            "\x91\x20\x09\x94\x80\x09\x98\x80\x09\x94\x20\xff\x01" }  },
      /* --- pixel bitmap for bbold180 char#67 C --- */
      {  67,13626,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 14,   19, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x72\x51\x52\x72\x32\x81\x21\x11\x91\x11\x11\xaf"
            "\x61\x21\xa0\x11\x11\xb1\x11\x91\x22\x81\x32\x72\x42"
            "\x51\x85\x41" }  },
      /* --- pixel bitmap for bbold180 char#68 D --- */
      {  68,13911,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   17, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x51\x21\x52\x31\x21\x71\x2f\x11\x21\x81\x1f\x61"
            "\x21\x91\x0f\x11\x21\x81\x11\x21\x71\x21\x21\x52\x39"
            "\x51" }  },
      /* --- pixel bitmap for bbold180 char#69 E --- */
      {  69,14214,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0f\x61\x21\x81\x24\x5f\x61\x21\x8c" }  },
      /* --- pixel bitmap for bbold180 char#70 F --- */
      {  70,14487,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0f\x61\x21\x81\x24\x5f\x61\x21\x84\x81" }  },
      /* --- pixel bitmap for bbold180 char#71 G --- */
      {  71,14760,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 14,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x06\xc1\x80\x31\x40\x0a\xa0\x02\x90\x00\x24"
            "\x00\x09\x40\x02\x9f\x00\x26\x80\x09\xa0\x02\xa8\x00"
            "\x32\x40\x0c\x18\x06\x01\x3e\x00" }  },
      /* --- pixel bitmap for bbold180 char#72 H --- */
      {  72,15055,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   17, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x91\x0f\x61\x21\x91\x01\x2b\x0f\x61\x21\x91\x04"
            "\x91" }  },
      /* --- pixel bitmap for bbold180 char#73 I --- */
      {  73,15360,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  4,   17, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x21\x04" }  },
      /* --- pixel bitmap for bbold180 char#74 J --- */
      {  74,15633,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   18, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\xfb\x81\x21\x0f\x11\x71\x11\x10\x11\x62\x42\x41"
            "\x74\x41" }  },
      /* --- pixel bitmap for bbold180 char#75 K --- */
      {  75,15914,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x98\x40\x09\x94\x20\x09\x91\x10\x89\x90\x04\x69"
            "\x90\x06\x99\x90\x10\x09\x91\x20\x09\x94\x40\x0f\x08" }  },
      /* --- pixel bitmap for bbold180 char#76 L --- */
      {  76,16221,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x8f\xe1\x21\x8c" }  },
      /* --- pixel bitmap for bbold180 char#77 M --- */
      {  77,16494,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x70\x00\x0f\xd0\x02\x9a\x20\x33\x62\x26\x4c\x85"
            "\x49\x30\x01\x26\xc0\x04\x98\x00\x13\x60\x02\x4c\x80"
            "\x0f\x10" }  },
      /* --- pixel bitmap for bbold180 char#78 N --- */
      {  78,16813,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x00\x58\x00\x16\x80\x09\x60\x06\x98\x02\x26"
            "\x81\x49\x60\x22\x98\x10\x26\x88\x09\x64\x02\x9a\x80"
            "\x26\xc0\x0f\x20" }  },
      /* --- pixel bitmap for bbold180 char#79 O --- */
      {  79,17136,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 14,   19, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x82\x42\x30\xf1\x22\x71\x20\xf1\x11\x11\x81\x1f"
            "\x61\x21\x91\xf1\x11\x11\x81\x10\xf1\x22\x71\x20\x32"
            "\x42\x84\x51" }  },
      /* --- pixel bitmap for bbold180 char#80 P --- */
      {  80,17439,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x31\x21\x51\x21\x21\x61\x1f\x21\x21\x71\x01\x21"
            "\x61\x11\x21\x51\x21\x26\x3f\x61\x21\x84\x81" }  },
      /* --- pixel bitmap for bbold180 char#81 Q --- */
      {  81,17726,                      /* character number, location */
         18, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 14,   23, 3,76, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x82\x42\x30\xf1\x22\x71\x20\xf1\x11\x11\x81\x1f"
            "\x61\x21\x91\xf1\x11\x11\x31\x41\x10\x22\x41\x21\x42"
            "\x51\x11\x52\x42\x84\x11\xe1\x20\xf1\xc1\x10\xd1" }  },
      /* --- pixel bitmap for bbold180 char#82 R --- */
      {  82,18047,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x91\x20\x09\x94\x80\x09\x98\x80\x09\x94\x20\xf9"
            "\x91\x04\x89\x90\x10\x09\x91\x20\x09\x94\x40\x0f\x08" }  },
      /* --- pixel bitmap for bbold180 char#83 S --- */
      {  83,18350,                      /* character number, location */
         18, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\xc0\x30\x0a\x94\x80\x09\x98\x00\x09\xa0\x00\x0c"
            "\x80\x0f\x00\x02\x40\x00\x08\x80\x01\x18\x80\x02\xc4"
            "\x30\xf0\x00" }  },
      /* --- pixel bitmap for bbold180 char#84 T --- */
      {  84,18625,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   17, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xfe\x51\x21\x50\x54\x5f" }  },
      /* --- pixel bitmap for bbold180 char#85 U --- */
      {  85,18898,                      /* character number, location */
         17, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 14,   18, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x91\x0f\xa1\x21\x91\xf1\x11\x11\x81\x10\xf1\x22"
            "\x71\x20\x32\x42\x84\x51" }  },
      /* --- pixel bitmap for bbold180 char#86 V --- */
      {  86,19203,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x30\x01\x4a\x20\x09\x24\x41\x48\x08\x09\x41\x12"
            "\x48\x02\x49\x40\x06\xc8\x00\x19\x40\x01\x28\x00\x02"
            "\x40\x00" }  },
      /* --- pixel bitmap for bbold180 char#87 W --- */
      {  87,19494,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x00\x4c\x00\xa0\x04\x80\x24\x00\x24\x01\x20\x09"
            "\x00\x91\x00\x84\x04\x20\x24\x02\x41\x2a\x04\x52\x21"
            "\x90\x11\x81\x8c\x08\x28\x28\x40\x41\x01\x06\x0c\x20"
            "\x40\x00" }  },
      /* --- pixel bitmap for bbold180 char#88 X --- */
      {  88,19817,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xbc\x80\x44\x20\x11\x24\x88\x04\x24\x01\x26\x00"
            "\x09\x20\x01\x24\x00\x19\x20\x09\x24\x04\x09\x22\x81"
            "\x48\x40\x0f\x20" }  },
      /* --- pixel bitmap for bbold180 char#89 Y --- */
      {  89,20114,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   17, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x91\xf1\x11\x21\x71\x10\x21\x21\x51\x41\x21\x41"
            "\x61\x21\x31\x30\xf1\x41\x21\x11\x40\xf7\x51\x21\x50"
            "\x54\x51" }  },
      /* --- pixel bitmap for bbold180 char#90 Z --- */
      {  90,20403,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3f\x80\x04\x20\x01\x24\x80\x04\x20\x01\x24\x00"
            "\x09\x20\x01\x24\x00\x09\x20\x01\x24\x00\x09\x20\x01"
            "\x48\x00\xff\x3f" }  },
      /* --- pixel bitmap for bbold180 char#91 [ --- */
      {  91,33729,                      /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  6,   25, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x21\x2f\x71\x21\x26" }  },
      /* --- pixel bitmap for bbold180 char#92 \\ --- */
      {  92,34039,                      /* character number, location */
         19, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 12,   25, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x81\x21\x80\xf2\x11\x21\x70\xf2\x21\x21\x60\xf2"
            "\x31\x21\x50\xf2\x41\x21\x40\xf2\x51\x21\x30\xf2\x61"
            "\x21\x20\xf2\x71\x21\x10\x81\x21\x84" }  },
      /* --- pixel bitmap for bbold180 char#93 ] --- */
      {  93,34356,                      /* character number, location */
         19, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  6,   25, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x21\x21\xf7\x21\x21\x06" }  },
      /* --- pixel bitmap for bbold180 char#94 (noname) --- */
      {  94,34667,                      /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  6,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x41\x18\x46\x51\x94\x24\x45\x51\x24\x49\x14"
            "\x45\x61\x18\x04\x81\x20" }  },
      /* --- pixel bitmap for bbold180 char#95 (noname) --- */
      {  95,34959,                      /* character number, location */
         19, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  6,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x20\x08\x86\x61\x28\x8a\x24\x89\xa2\x28\x49\x8a"
            "\x62\x18\x86\x20\x04\x01" }  },
      /* --- pixel bitmap for bbold180 char#96 (noname) --- */
      {  96,35250,                      /* character number, location */
         17, 0,    7, 0,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x43\x08\x5f\x18\x86\xa1\x07" }  },
      /* --- pixel bitmap for bbold180 char#97 a --- */
      {  97,20676,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\xae\xb0\x82\x09\x26\x98\x60\x82\x09\x2a\xa8"
            "\x30\xe3\x78\x00" }  },
      /* --- pixel bitmap for bbold180 char#98 b --- */
      {  98,20951,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 14,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x40\x02\x90\x00\x24\x00\x09\x40\xf2\x91\x82\x64"
            "\x40\x09\x50\x02\x98\x00\x26\x80\x09\x60\x02\x98\x00"
            "\x65\x40\x2f\x08\xf0\x01" }  },
      /* --- pixel bitmap for bbold180 char#99 c --- */
      {  99,21254,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\xa6\x90\x82\x09\x24\x90\x40\x02\x09\x28\xa8"
            "\x10\x63\x78\x00" }  },
      /* --- pixel bitmap for bbold180 char#100 d --- */
      { 100,21519,                      /* character number, location */
         17, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x08\x20\x80\x00\xe2\xc9\xb8\xc2\x0a\x26\x98"
            "\x60\x82\x09\x26\xa8\xa0\xc2\x8c\xe3\x01" }  },
      /* --- pixel bitmap for bbold180 char#101 e --- */
      { 101,21806,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\xa2\x90\x82\x09\xe6\x9f\x40\x02\x09\x28\xa8"
            "\x10\x63\x78\x00" }  },
      /* --- pixel bitmap for bbold180 char#102 f --- */
      { 102,22073,                      /* character number, location */
         18, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x4a\x8a\x89\x09\x09\x09\x39\x09\x09\x09\x09\x09"
            "\x09\x09\x09\x09\x0f" }  },
      /* --- pixel bitmap for bbold180 char#103 g --- */
      { 103,22356,                      /* character number, location */
         12, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 10,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\xae\xb0\x82\x09\x26\x98\x60\x82\x09\x2a\xa8"
            "\x30\xe3\x78\x02\x08\x50\x40\x86\xe0\x01" }  },
      /* --- pixel bitmap for bbold180 char#104 h --- */
      { 104,22647,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   17, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x7f\x31\x21\x71\x21\x14\x21\x22\x41\x11\x21\x51"
            "\x1f\x71\x21\x61\x04\x61" }  },
      /* --- pixel bitmap for bbold180 char#105 i --- */
      { 105,22944,                      /* character number, location */
         18, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  6,   18, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x14\x1f\x31\x41\x14\x84\x10\xf8\x11\x21\x10\x14\x11" }  },
      /* --- pixel bitmap for bbold180 char#106 j --- */
      { 106,23215,                      /* character number, location */
         18, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  9,   24, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x10\xf3\x31\x41\x44\xe4\x10\xfc\x41\x21\x11\x31"
            "\x11\x31\x21\x11\x44\x31" }  },
      /* --- pixel bitmap for bbold180 char#107 k --- */
      { 107,23514,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x48\x40\x02\x12\x90\x80\x04\x24\x30\x41\x89\x49"
            "\x42\x0a\xb2\x90\x88\x44\x24\x24\x41\x0f\x04" }  },
      /* --- pixel bitmap for bbold180 char#108 l --- */
      { 108,23809,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  4,   17, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xd1\x21\x11\x11\x22" }  },
      /* --- pixel bitmap for bbold180 char#109 m --- */
      { 109,24082,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   12, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\x23\x25\x32\x31\x1f\x21\x21\x42\x41\x0f\x51\x21"
            "\x51\x41\x04\x51\x41" }  },
      /* --- pixel bitmap for bbold180 char#110 n --- */
      { 110,24379,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x25\x41\x11\x21\x51\x1f\x71\x21\x61\x04\x61" }  },
      /* --- pixel bitmap for bbold180 char#111 o --- */
      { 111,24652,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 10,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\xa2\x90\x42\x09\x26\x98\x60\x82\x09\x2a\xa4"
            "\x10\x23\x78\x00" }  },
      /* --- pixel bitmap for bbold180 char#112 p --- */
      { 112,24927,                      /* character number, location */
         12, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\xc7\x0b\x92\x01\x25\x40\x09\x60\x02\x98\x00\x26"
            "\x80\x09\x60\x02\x94\x01\xa5\x20\xc9\x47\x02\x90\x00"
            "\x24\x00\x0f\x00" }  },
      /* --- pixel bitmap for bbold180 char#113 q --- */
      { 113,25226,                      /* character number, location */
         12, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 10,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x30\xae\xb0\x82\x09\x26\x98\x60\x82\x09\x2a\xa8"
            "\x30\xe3\x78\x02\x08\x20\x80\x00\x02" }  },
      /* --- pixel bitmap for bbold180 char#114 r --- */
      { 114,25511,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x25\x41\x1f\x11\x21\x61\x0f\x61\x21\x74\x71" }  },
      /* --- pixel bitmap for bbold180 char#115 s --- */
      { 115,25768,                      /* character number, location */
         12, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x4a\x89\x89\x09\x3e\x40\x80\x80\x81\x81\x42\x3c" }  },
      /* --- pixel bitmap for bbold180 char#116 t --- */
      { 116,26023,                      /* character number, location */
         17, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  8,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x09\x09\x09\x09\x09\xf9\x09\x09\x09\x09\x09\x09"
            "\x09\x89\x8a\x4a\x3c" }  },
      /* --- pixel bitmap for bbold180 char#117 u --- */
      { 117,26306,                      /* character number, location */
         11, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x26\x98\x60\x82\x09\x26\x98\x60\x82\x0a\x2b\xcc"
            "\x28\x1e" }  },
      /* --- pixel bitmap for bbold180 char#118 v --- */
      { 118,26581,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x0c\x90\x84\x44\x42\x12\x62\x20\x03\x09\x50\x80"
            "\x01\x08\x00" }  },
      /* --- pixel bitmap for bbold180 char#119 w --- */
      { 119,26836,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\xc0\x04\xa0\x04\x48\x02\x24\x09\x22\x8b\x90\x45"
            "\x48\x24\x28\x0a\x0c\x06\x04\x02" }  },
      /* --- pixel bitmap for bbold180 char#120 x --- */
      { 120,27115,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x8b\x44\x12\x26\x90\x20\x41\x02\x19\x92\x48\xf4"
            "\x20" }  },
      /* --- pixel bitmap for bbold180 char#121 y --- */
      { 121,27376,                      /* character number, location */
         11, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 11,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x04\x90\x84\x48\x42\x12\x64\x20\x03\x0a\x50\x00"
            "\x01\x08\x20\x00\x01\x04\x10\x40\x00\x01\x00" }  },
      /* --- pixel bitmap for bbold180 char#122 z --- */
      { 122,27641,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x83\x04\x12\x24\x90\x20\x41\x02\x09\x12\x48\xf0"
            "\x3f" }  },
      /* --- pixel bitmap for bbold180 char#123 \- --- */
      { 123,35796,                      /* character number, location */
          7, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          { 10,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a" }  },
      /* --- pixel bitmap for bbold180 char#124 | --- */
      { 124,35491,                      /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  4,   25, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x21\x0f\x71\x21\x04" }  },
      /* --- pixel bitmap for bbold180 char#125 (noname) --- */
      { 125,36008,                      /* character number, location */
          7, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          { 19,    1, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x05" }  },
      /* --- pixel bitmap for bbold180 char#126 (noname) --- */
      { 126,36226,                      /* character number, location */
         17, 0,    7, 0,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x88\xc1\x10\x08\x81\xf0\xf9\x42\x61\x28\x0c\x85"
            "\xa1\xd0\xe3\x01" }  },
      /* --- pixel bitmap for bbold180 char#127 \omega --- */
      { 127, 9933,                      /* character number, location */
         11, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 15,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x08\x06\x88\x02\x28\x01\x98\x08\x4c\x04\x26\x02"
            "\x13\x81\x89\x40\xa5\x90\x52\x88\xc7\x03" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=6 for .210gf ---
 * mf '\mode=preview; mag=magstep(-13.80488502080647873125); input bbold10'
 * --------------------------------------------------------------------- */
/* --- fontdef for bbold210 --- */
static	chardef  bbold210[] =
   {
      /* --- pixel bitmap for bbold210 char#0 \Gamma --- */
      {   0,  246,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\x0f\xe1\x31\xaf\x21\x31\xa5\xa0" }  },
      /* --- pixel bitmap for bbold210 char#1 \Delta --- */
      {   1,  540,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,78, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\x80\xf1\x71\x11\x70\xf1\x61\x31\x60\xf2\x51"
            "\x31\x11\x50\xf1\x41\x31\x31\x40\xf2\x31\x31\x51\x30"
            "\xf1\x21\x31\x71\x20\xf1\x11\x31\x91\x11\x31\xbe\x04" }  },
      /* --- pixel bitmap for bbold210 char#2 \Theta --- */
      {   2,  858,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\xa2\x42\x72\x71\x30\xf1\x21\x11\x81\x20\xf1\x11"
            "\x21\x91\x1f\x21\x31\xa1\x01\x31\x35\x21\x0f\x31\x31"
            "\xa1\xf1\x11\x21\x91\x10\xf1\x21\x11\x81\x20\x32\x71"
            "\x72\x42\xa4\x60" }  },
      /* --- pixel bitmap for bbold210 char#3 \Lambda --- */
      {   3, 1195,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,78, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\x80\xf1\x71\x11\x70\xf1\x61\x31\x60\xf2\x51"
            "\x31\x11\x50\xf1\x41\x31\x31\x40\xf2\x31\x31\x51\x30"
            "\xf1\x21\x31\x71\x20\xf1\x11\x31\x91\x11\x31\xb6\xb1" }  },
      /* --- pixel bitmap for bbold210 char#4 \Xi --- */
      {   4, 1512,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\xf7\xe0\x30\x66\x50\xf8\xe0\x3e\x03" }  },
      /* --- pixel bitmap for bbold210 char#5 \Pi --- */
      {   5, 1737,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\x0f\xe1\x31\x91\x0f\x21\x31\x91\x05\x91" }  },
      /* --- pixel bitmap for bbold210 char#6 \Sigma --- */
      {   6, 2069,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   20, 3,74, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\xf1\x11\x31\xa0\xf1\x21\x31\x90\xf1\x31\x31"
            "\x80\x41\x31\x70\xf3\x51\x31\x60\x41\x31\x70\xf1\x31"
            "\x31\x80\xf1\x21\x31\x90\xf1\x11\x31\xae\x02" }  },
      /* --- pixel bitmap for bbold210 char#7 \Upsilon --- */
      {   7, 2365,                      /* character number, location */
         21, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   21, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x73\x20\xf1\x11\x31\x51\x31\x1f\x21\x51\x31\x51"
            "\xf3\x61\x31\x60\x65\x60\xf8\x61\x31\x60\x65\x61" }  },
      /* --- pixel bitmap for bbold210 char#8 \Phi --- */
      {   8, 2681,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x80\x08\x00\x11\x00\x22\x00\xc6\x00\x8b\x06"
            "\x11\x11\x21\x42\x41\x04\x83\x08\x06\x11\x0c\x22\x28"
            "\x44\x88\x88\x08\x16\x0d\x30\x06\x40\x04\x80\x08\x00"
            "\x11\x00\x3e\x00" }  },
      /* --- pixel bitmap for bbold210 char#9 \Psi --- */
      {   9, 3013,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x60\xf2\x61\x31\x62\x41\x31\x42\xf6\x21\x31\x31"
            "\x31\x20\xf1\x31\x21\x31\x21\x30\x43\x33\x40\xf3\x61"
            "\x31\x60\x65\x61" }  },
      /* --- pixel bitmap for bbold210 char#10 \Omega --- */
      {  10, 3347,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   21, 3,66, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\xa2\x42\x72\x71\x30\xf1\x21\x11\x81\x20\xf1\x11"
            "\x21\x91\x1f\x71\x31\xa1\xf1\x11\x21\x91\x10\xf1\x21"
            "\x11\x81\x20\x32\x71\x35\x65" }  },
      /* --- pixel bitmap for bbold210 char#11 \alpha --- */
      {  11, 3679,                      /* character number, location */
         14, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x00\x46\x48\x21\x4a\x88\x12\x62\x84\x18\x21\x46"
            "\x48\x11\x52\x84\x24\xc1\x48\x30\x14\x0c\xc6\x0c\x0f"
            "\x00" }  },
      /* --- pixel bitmap for bbold210 char#12 \beta --- */
      {  12, 3994,                      /* character number, location */
         21, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   27, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x03\x86\x61\x20\x0a\x28\x01\x25\x60\x04\x8c\x40"
            "\x11\x27\x82\x44\xa0\x08\x18\x01\x23\x60\x04\x8c\x80"
            "\x11\x30\x02\x46\xa0\x18\x14\x47\x22\x47\x04\x88\x00"
            "\x11\x20\x02\x7c\x00" }  },
      /* --- pixel bitmap for bbold210 char#13 \gamma --- */
      {  13, 4354,                      /* character number, location */
         13, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 12,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x0f\x0f\x60\x00\x09\x18\x41\x21\x14\x22\x41\x12"
            "\x14\x81\x11\x18\x81\x11\x18\x81\x11\x28\x41\x12\x44"
            "\x21\x18\x01\x0f" }  },
      /* --- pixel bitmap for bbold210 char#14 \delta --- */
      {  14, 4672,                      /* character number, location */
         21, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x40\x30\x02\x14\x80\x01\x18\x00\x02\xc0\x00\x70"
            "\xc0\x19\x12\x22\x41\x11\x18\x81\x11\x18\x81\x11\x28"
            "\x41\x12\x44\x21\x18\x01\x0f" }  },
      /* --- pixel bitmap for bbold210 char#15 \epsilon --- */
      {  15, 4988,                      /* character number, location */
         14, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x31\x14\x24\x81\x12\x18\x01\x71\x10\x01\x11"
            "\x10\x01\x12\x28\x81\x14\x84\x31\xf0\x00" }  },
      /* --- pixel bitmap for bbold210 char#16 \zeta --- */
      {  16, 5273,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 10,   26, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x82\x71\x72\x71\x50\xf1\x32\x50\x21\x11\x62\x11\x50"
            "\xf1\x11\x21\x5f\x51\x31\x50\xf1\x11\x21\x50\x23\x93"
            "\xa2\x10\xf3\x91\x72\x11" }  },
      /* --- pixel bitmap for bbold210 char#17 \eta --- */
      {  17, 5565,                      /* character number, location */
         14, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   20, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x37\x31\x21\x32\x51\x1f\x91\x31\x71\x05\x71\xf5"
            "\xc1" }  },
      /* --- pixel bitmap for bbold210 char#18 \theta --- */
      {  18, 5871,                      /* character number, location */
         21, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x11\x14\x22\x41\x12\x24\x41\x11\x18\x81\x11"
            "\x18\x81\xf1\x1f\x81\x11\x18\x81\x11\x18\x81\x12\x24"
            "\x41\x12\x44\x21\x18\x01\x0f" }  },
      /* --- pixel bitmap for bbold210 char#19 \iota --- */
      {  19, 6206,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\xc6\x18\x63\x8c\x31\x4a\x8a\x01" }  },
      /* --- pixel bitmap for bbold210 char#20 \kappa --- */
      {  20, 6472,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x30\x82\x45\x88\xc8\x10\x07\x62\x40\x14\x88\x04"
            "\x11\x21\x22\x44\x88\x08\xf2\x81\x01" }  },
      /* --- pixel bitmap for bbold210 char#21 \lambda --- */
      {  21, 6761,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x10\x01\x22\x20\x02\x22\x40\x04\x44\x80\x08\x88"
            "\x80\x08\x10\x01\x11\x10\x81\x22\x28\x42\x44\x44\x24"
            "\x44\x82\x18\xf8" }  },
      /* --- pixel bitmap for bbold210 char#22 \mu --- */
      {  22, 7066,                      /* character number, location */
         13, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x71\x0f\x91\x31\x71\x01\x32\x53\x33\x31\x12\x31"
            "\x23\x3f\x31\x31\x85\x81" }  },
      /* --- pixel bitmap for bbold210 char#23 \nu --- */
      {  23, 7383,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x18\x81\x11\x18\x81\x11\x14\x41\x11\x12\x21\x11"
            "\x11\x09\x71\x90\x01\x07\x00" }  },
      /* --- pixel bitmap for bbold210 char#24 \xi --- */
      {  24, 7666,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 10,   26, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\x12\x11\x5f\x31\x31\x50\x12\x11\x84\x62\x71\x11"
            "\x61\x21\x5f\x41\x31\x50\xf1\x11\x21\x50\x23\x93\xa2"
            "\x10\xf3\x91\x72\x11" }  },
      /* --- pixel bitmap for bbold210 char#25 \pi --- */
      {  25, 7963,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\xfa\x21\x31\x31\x20\x25\x31\x21" }  },
      /* --- pixel bitmap for bbold210 char#26 \rho --- */
      {  26, 8251,                      /* character number, location */
         14, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 12,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x11\x14\x22\x41\x12\x14\x81\x11\x18\x81\x11"
            "\x18\x81\x11\x14\x41\x11\x12\x11\xf1\x10\x01\x11\x10"
            "\x01\x11\xf0\x01" }  },
      /* --- pixel bitmap for bbold210 char#27 \sigma --- */
      {  27, 8569,                      /* character number, location */
         13, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x3f\xc7\x20\x41\x48\x10\x11\x48\x04\x12\x81\x44"
            "\x20\x11\x88\x04\x21\x41\x50\x08\x18\x01\x3c\x00" }  },
      /* --- pixel bitmap for bbold210 char#28 \tau --- */
      {  28, 8857,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\xf8\x41\x31\x40\x51\x21\xa1\x11\xb2\x41" }  },
      /* --- pixel bitmap for bbold210 char#29 \upsilon --- */
      {  29, 9125,                      /* character number, location */
         13, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x61\x0f\x81\x31\x61\xf1\x11\x21\x51\x10\x23\x32"
            "\x64\x41" }  },
      /* --- pixel bitmap for bbold210 char#30 \phi --- */
      {  30, 9417,                      /* character number, location */
         20, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 13,   26, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x40\xf6\x41\x31\x40\x32\x32\x51\x11\x31\x11\x31"
            "\x21\x31\x21\x1f\x41\x31\x31\x31\x11\x21\x31\x21\x31"
            "\x11\x31\x11\x52\x32\x30\xf5\x41\x31\x40\x45\x43" }  },
      /* --- pixel bitmap for bbold210 char#31 \chi --- */
      {  31, 9769,                      /* character number, location */
         13, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 12,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x2f\x88\x42\x44\x44\x24\x82\x22\x30\x02\x11\x10"
            "\x81\x08\x88\x80\x08\xc4\x40\x14\x44\x22\x22\x22\x14"
            "\x41\x1f\x08" }  },
      /* --- pixel bitmap for bbold210 char#32 \psi --- */
      {  32,10081,                      /* character number, location */
         20, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   26, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x40\xf5\x41\x31\x4f\x91\x31\x31\x31\x11\x21\x31"
            "\x21\x33\x33\x20\xf5\x41\x31\x40\x45\x41" }  },
      /* --- pixel bitmap for bbold210 char#33 ! --- */
      {  33,29390,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,   21, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x15\x10\xfa\x11\x31\x10\x15\xa3\x31\x31\x1f\x21\x51"
            "\x11\x31\x33\x21" }  },
      /* --- pixel bitmap for bbold210 char#34 (noname) --- */
      {  34,38376,                      /* character number, location */
         21, 0,   10, 0,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x1c\x11\x51\x50\x30\x28\x18\x14\x14\x13\xf3\xf0"
            "\x40\x40\x10\x10\x04\x84\x81\x01" }  },
      /* --- pixel bitmap for bbold210 char#35 # --- */
      {  35,29678,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 18,   26, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x31\x40\xf7\x51\x31\x31\x46\x39\xf4\x51\x31\x31"
            "\x46\x39\xf8\x51\x31\x31\x40\x55\x31\x41" }  },
      /* --- pixel bitmap for bbold210 char#36 $ --- */
      {  36,30038,                      /* character number, location */
         22, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x10\x01\x8c\x81\x45\x27\x22\x0c\x11\x84\x08"
            "\x42\x04\x21\x02\x11\x01\x8b\x00\xc6\x00\xa2\x01\x11"
            "\x81\x88\x40\x84\x20\x42\x10\x21\x88\x28\x44\xe4\xa2"
            "\x81\x31\x80\x08\xc0\x07" }  },
      /* --- pixel bitmap for bbold210 char#37 % --- */
      {  37,30386,                      /* character number, location */
         23, 0,  -10, 0,      /* topleft row,col, and botleft row,col */
          { 17,   33, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x00\x44\xf0\x05\x21\x0a\x22\x12\x44\x44\x84\x08"
            "\x87\x08\x00\x11\x00\x22\x00\x22\x00\x44\x00\x88\x00"
            "\x88\x00\x10\x01\x20\x02\x20\x02\x40\x04\x80\x08\x80"
            "\x08\x00\x11\x00\x22\x00\x22\x00\x44\x00\x88\x00\x88"
            "\x00\x10\x01\x20\xc2\x21\x42\x44\x44\x90\x88\xa0\x08"
            "\x41\x1f\x44\x00\x70\x00" }  },
      /* --- pixel bitmap for bbold210 char#38 & --- */
      {  38,30764,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x01\x00\x11\x00\x88\x00\x40\x04\x00\x22\x00\x10"
            "\x01\x80\x04\x00\x38\x00\x40\x00\x80\x05\x00\x27\x00"
            "\x24\x02\x20\x11\x80\x08\x01\x44\x08\x22\x82\x10\x11"
            "\x48\x88\x40\xa1\x04\x04\x25\x58\x48\x31\x44\x7c\xc0"
            "\x01" }  },
      /* --- pixel bitmap for bbold210 char#39 ' --- */
      {  39,31097,                      /* character number, location */
         21, 0,   10, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\xf3\x40\x10\x84\x01" }  },
      /* --- pixel bitmap for bbold210 char#40 ( --- */
      {  40,31342,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x32\x41\x11\x20\xf3\x11\x21\x2f\xe1\x31\x20\xf3"
            "\x11\x21\x20\x21\x11\x52\x63" }  },
      /* --- pixel bitmap for bbold210 char#41 ) --- */
      {  41,31664,                      /* character number, location */
         22, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x62\x51\x11\x20\xf3\x21\x21\x10\xfe\x21\x31\xf3"
            "\x21\x21\x10\x21\x11\x42\x33\x41" }  },
      /* --- pixel bitmap for bbold210 char#42 * --- */
      {  42,31977,                      /* character number, location */
         17, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x80\x08\x00\x11\x00\x22\x00\x44\x20\x88\xa0"
            "\x11\x31\x2c\x1a\x60\x0c\x80\x08\x00\x11\x80\xe2\x40"
            "\x44\x26\x88\x30\x10\x01\x20\x02\x40\x04\x80\x08\x00"
            "\x1f\x00" }  },
      /* --- pixel bitmap for bbold210 char#43 + --- */
      {  43,32281,                      /* character number, location */
         17, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 19,   19, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x70\xf7\x71\x31\x78\x38\xf7\x71\x31\x70\x75\x72" }  },
      /* --- pixel bitmap for bbold210 char#44 , --- */
      {  44,32559,                      /* character number, location */
          6, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  7,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\xf3\x40\x10\x08\x43\x00" }  },
      /* --- pixel bitmap for bbold210 char#45 - --- */
      {  45,32800,                      /* character number, location */
          7, 0,    6, 0,      /* topleft row,col, and botleft row,col */
          { 10,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a" }  },
      /* --- pixel bitmap for bbold210 char#46 . --- */
      {  46,33012,                      /* character number, location */
          6, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\x71\x00" }  },
      /* --- pixel bitmap for bbold210 char#47 / --- */
      {  47,33252,                      /* character number, location */
         22, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 15,   29, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\xa1\x31\xf2\x91\x31\x10\xf1\x81\x31\x20\xf2\x71"
            "\x31\x30\xf2\x61\x31\x40\xf2\x51\x31\x50\xf2\x41\x31"
            "\x60\xf1\x31\x31\x70\xf2\x21\x31\x80\xf2\x11\x31\x91"
            "\x31\xa5\xa1" }  },
      /* --- pixel bitmap for bbold210 char#48 0 --- */
      {  48,10752,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x72\x41\x51\x11\x51\x20\xf2\x11\x21\x61\x1f\x81"
            "\x31\x71\xf2\x11\x21\x61\x10\x21\x11\x51\x52\x41\x75"
            "\x41" }  },
      /* --- pixel bitmap for bbold210 char#49 1 --- */
      {  49,11075,                      /* character number, location */
         19, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\x94\x82\x21\x63\x31\x42\x21\x31\x40\xfc\x41\x31"
            "\x4d" }  },
      /* --- pixel bitmap for bbold210 char#50 2 --- */
      {  50,11356,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   20, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x43\x31\x61\x21\x21\x61\x31\x0f\x11\x71\x31"
            "\xf1\x81\x31\x81\x21\x91\x11\xa2\xa2\xa1\xa2\xa1\xb1"
            "\xb1\xbf\x11\xcd" }  },
      /* --- pixel bitmap for bbold210 char#51 3 --- */
      {  51,11631,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x81\xe1\x08\x24\x81\x18\x10\x03\x22\x40\x04\x48"
            "\x00\x05\x78\x00\x1c\x80\x04\x10\x01\x22\x40\x0c\x88"
            "\x01\x51\x20\x09\x14\x86\x01\x1f\x00" }  },
      /* --- pixel bitmap for bbold210 char#52 4 --- */
      {  52,11932,                      /* character number, location */
         19, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x04\xc0\x00\x18\x80\x02\x48\x80\x08\x10\x01\x23"
            "\x50\x04\x8a\x20\x11\x22\x22\x44\x84\xc8\x1f\x07\x22"
            "\x40\x04\x88\x00\x1f" }  },
      /* --- pixel bitmap for bbold210 char#53 5 --- */
      {  53,12221,                      /* character number, location */
         19, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   20, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\x31\x31\x89\xd1\xd1\xd1\x10\xf4\xc1\x01\xb2"
            "\xa1\x21\x91\x21\x81\x42\x51\x75\x40" }  },
      /* --- pixel bitmap for bbold210 char#54 6 --- */
      {  54,12488,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\xc1\x10\x20\x01\x14\x00\x03\x60\x7c\xc8\x10"
            "\x15\x64\x02\x45\xc0\x08\x18\x01\x23\x60\x04\x8c\x80"
            "\x12\x48\x02\x51\x10\x0c\x01\x1f\x00" }  },
      /* --- pixel bitmap for bbold210 char#55 7 --- */
      {  55,12803,                      /* character number, location */
         19, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f\x20\x02\x22\x40\x04\x44\x80\x08\x88\x00\x11"
            "\x10\x01\x22\x40\x04\x44\x80\x08\x88\x00\x11\x10\x01"
            "\x22\x20\x02\x7c\x00" }  },
      /* --- pixel bitmap for bbold210 char#56 8 --- */
      {  56,13084,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x81\xc3\x48\xa0\x08\x18\x01\x23\x60\x04\x94\x40"
            "\x14\x04\x7f\x70\x18\x09\x14\x01\x23\x60\x04\x8c\x80"
            "\x11\x50\x02\x51\x10\x0c\x01\x1f\x00" }  },
      /* --- pixel bitmap for bbold210 char#57 9 --- */
      {  57,13401,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x43\x50\x10\x09\x24\x81\x22\x60\x04\x8c\x80"
            "\x11\x30\x02\x46\x40\x09\x4c\x41\x31\x24\x7c\x0c\x80"
            "\x01\x50\x00\x09\x10\x06\x01\x1f\x00" }  },
      /* --- pixel bitmap for bbold210 char#58 : --- */
      {  58,33570,                      /* character number, location */
         14, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  7,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\x71\x00\x1c\x51\x30\x18\x14\x71"
            "\x00" }  },
      /* --- pixel bitmap for bbold210 char#59 ; --- */
      {  59,33830,                      /* character number, location */
         14, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          {  7,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\x71\x00\x1c\x51\x30\x18\x14\xf3"
            "\x40\x10\x08\x43\x00" }  },
      /* --- pixel bitmap for bbold210 char#60 < --- */
      {  60,34105,                      /* character number, location */
         15, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   16, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x32\xe0\x12\xe3\xe3\xe2\xe3\xe2\xe0\x12\x22\xd1"
            "\x51\xd2\x42\xd1\x51\xd2\x42\xd1\x51\xd2\x42\xd2\x42"
            "\xd7" }  },
      /* --- pixel bitmap for bbold210 char#61 \cdot --- */
      {  61,34361,                      /* character number, location */
         11, 0,    4, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\x71\x00" }  },
      /* --- pixel bitmap for bbold210 char#62 > --- */
      {  62,34603,                      /* character number, location */
         15, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   16, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x52\xe0\x52\xe0\x53\xe0\x52\xe0\x53\xe0\x52"
            "\xe0\x21\x23\xb1\x51\xa2\x42\xa1\x51\xa2\x42\x92\x42"
            "\xa1\x51\xa2\x42\xa7\xc2" }  },
      /* --- pixel bitmap for bbold210 char#63 ? --- */
      {  63,34865,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x72\x62\x41\xa1\x21\xb1\x1f\x11\xd1\xe1\xd1\xd1"
            "\xa4\x92\x11\xb1\x21\xa1\x31\xa5\xe0\xc3\xb1\x31\x50"
            "\xf2\x41\x51\x40\x51\x31\xb3\x61" }  },
      /* --- pixel bitmap for bbold210 char#64 @ --- */
      {  64,35143,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 13,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x00\x63\x50\x10\x09\x22\x81\x24\x50\x04\x8a\x90"
            "\x91\x3d\x0a\x46\xc1\x28\x18\x05\x23\x5b\x84\x88\x00"
            "\x12\x48\x02\x49\x10\x0a\x82\x31\xe0\x01" }  },
      /* --- pixel bitmap for bbold210 char#65 A --- */
      {  65,13716,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   20, 3,78, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x70\xf1\x72\x70\xf2\x61\x21\x60\xf1\x51\x32\x50"
            "\xf2\x41\x31\x21\x40\xf1\x31\x31\x41\x30\xf1\x21\x31"
            "\x61\x20\x21\x38\x20\xf1\x11\x31\x81\x11\x31\xa6\xa1" }  },
      /* --- pixel bitmap for bbold210 char#66 B --- */
      {  66,14019,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x87\x08\x4c\x04\x28\x02\x18\x01\x8c\x00\x46\x00"
            "\x23\x40\x11\x98\xf8\x43\x04\x26\x02\x14\x01\x8a\x00"
            "\x46\x00\x23\x80\x11\xa0\x08\x50\x04\xe6\xff\x00" }  },
      /* --- pixel bitmap for bbold210 char#67 C --- */
      {  67,14338,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x92\x52\x62\x81\x41\x11\x91\x31\x11\xa1\x11\x21"
            "\xa1\x11\x21\xbf\x71\x31\xb0\x11\x21\xc1\x21\xa1\x21"
            "\x11\xa1\x21\x11\x91\x42\x81\x62\x52\x95\x52" }  },
      /* --- pixel bitmap for bbold210 char#68 D --- */
      {  68,14643,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   20, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x61\x31\x52\x41\x31\x71\x3f\x11\x31\x81\x2f\x11"
            "\x31\x91\x1f\x51\x31\xa1\x0f\x11\x31\x91\x1f\x11\x31"
            "\x81\x21\x31\x71\x31\x31\x52\x4a\x62" }  },
      /* --- pixel bitmap for bbold210 char#69 E --- */
      {  69,14964,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\x0f\x71\x31\xa1\x35\x6f\x81\x31\xae\x01" }  },
      /* --- pixel bitmap for bbold210 char#70 F --- */
      {  70,15249,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\x0f\x71\x31\xa1\x35\x6f\x81\x31\xa5\xa1" }  },
      /* --- pixel bitmap for bbold210 char#71 G --- */
      {  71,15534,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x92\x52\x62\x81\x41\x11\x91\x31\x11\xa1\x11\x21"
            "\xa1\x11\x21\xbf\x31\x31\xb1\x31\x65\x0f\x21\x31\xa1"
            "\xf1\x11\x21\xa1\x21\x11\xa1\x21\x11\x91\x42\x81\x62"
            "\x52\x95\x51" }  },
      /* --- pixel bitmap for bbold210 char#72 H --- */
      {  72,15849,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   20, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xa1\x0f\x71\x31\xa1\x01\x3c\x0f\x81\x31\xa1\x05"
            "\xa1" }  },
      /* --- pixel bitmap for bbold210 char#73 I --- */
      {  73,16172,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  5,   20, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x31\x0f\x21\x31\x05" }  },
      /* --- pixel bitmap for bbold210 char#74 J --- */
      {  74,16457,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   21, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\xfc\xa1\x31\xa1\x21\x1f\x11\x91\x21\x10\x11\x81"
            "\x11\x41\x72\x62\x51\x95\x51" }  },
      /* --- pixel bitmap for bbold210 char#75 K --- */
      {  75,16752,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\xc0\x08\x50\x04\x24\x02\x12\x81\x88\x20\x44\x08"
            "\x22\x04\x11\x81\x48\x40\x54\x20\x26\x10\x23\x88\x20"
            "\x44\x10\x22\x10\x11\x90\x08\x50\x04\xe8\x03\x08" }  },
      /* --- pixel bitmap for bbold210 char#76 L --- */
      {  76,17079,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xaf\xe1\x31\xaf\x21\x31\xae\x01" }  },
      /* --- pixel bitmap for bbold210 char#77 M --- */
      {  77,17364,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x13\xd3\x11\xb1\x12\x21\x91\x21\x0f\x11\x31"
            "\x71\x31\x01\x32\x51\x42\x31\x11\x31\x52\x31\x21\x11"
            "\x62\x31\x31\x71\x0f\x81\x31\xb1\x05\xb1" }  },
      /* --- pixel bitmap for bbold210 char#78 N --- */
      {  78,17707,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x80\x03\x80\x05\x80\x05\x80\x09\x80\x11\x80\x31"
            "\x80\x51\x80\x51\x80\x91\x80\x11\x81\x11\x82\x11\x82"
            "\x11\x84\x11\x88\x11\x90\x11\xa0\x11\xa0\x11\xc0\x1f"
            "\x80" }  },
      /* --- pixel bitmap for bbold210 char#79 O --- */
      {  79,18052,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x64\xa2\x42\x72\x71\x30\xf1\x21\x11\x81\x20\xf1\x11"
            "\x21\x91\x1f\x71\x31\xa1\xf1\x11\x21\x91\x10\xf1\x21"
            "\x11\x81\x20\x32\x71\x72\x42\xa4\x62" }  },
      /* --- pixel bitmap for bbold210 char#80 P --- */
      {  80,18377,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x41\x31\x62\x21\x31\x81\x1f\x31\x31\x91\x01\x31"
            "\x81\x11\x31\x62\x21\x37\x4f\x81\x31\xa5\xa0" }  },
      /* --- pixel bitmap for bbold210 char#81 Q --- */
      {  81,18678,                      /* character number, location */
         21, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 16,   27, 3,100, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x64\xa2\x42\x72\x71\x30\xf1\x21\x11\x81\x20\xf1\x11"
            "\x21\x91\x1f\x71\x31\xa1\xf1\x11\x21\x31\x51\x10\x21"
            "\x11\x41\x31\x41\x11\x51\x21\x52\x51\x11\x72\x42\xa4"
            "\x21\xe0\x11\xe0\x21\x20\xf1\xe1\x10\xe0\x11" }  },
      /* --- pixel bitmap for bbold210 char#82 R --- */
      {  82,19025,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x87\x08\x4c\x04\x28\x02\x18\x01\x8c\x00\x46\x00"
            "\x23\x40\x11\x98\xf8\x43\x44\x20\x22\x10\x21\x88\x20"
            "\x44\x10\x22\x10\x11\x90\x08\x50\x04\xe8\x03\x08" }  },
      /* --- pixel bitmap for bbold210 char#83 S --- */
      {  83,19346,                      /* character number, location */
         21, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x51\x11\x71\x31\x21\x81\x1f\x11\x31\x91"
            "\x0f\x11\x31\xa0\x11\x21\xc3\xe7\xe0\x12\x20\xf1\xd1"
            "\x10\xf1\xe1\x0f\x11\xd1\x11\xb1\x31\x91\x52\x52\x85"
            "\x51" }  },
      /* --- pixel bitmap for bbold210 char#84 T --- */
      {  84,19633,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\xfe\x61\x31\x60\xf2\x61\x31\x60\x65\x61" }  },
      /* --- pixel bitmap for bbold210 char#85 U --- */
      {  85,19918,                      /* character number, location */
         20, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 16,   21, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xa1\x0f\xc1\x31\xa1\xf1\x11\x21\x91\x10\xf1\x21"
            "\x11\x81\x20\x32\x71\x72\x42\xa4\x60" }  },
      /* --- pixel bitmap for bbold210 char#86 V --- */
      {  86,20243,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xb2\x31\xb1\xf1\x11\x31\x91\x10\xf1\x21\x31\x71"
            "\x20\xf2\x31\x31\x51\x30\xf1\x41\x31\x31\x40\xf2\x51"
            "\x31\x11\x50\xf1\x61\x31\x60\xf1\x71\x11\x70\xf1\x81"
            "\x81" }  },
      /* --- pixel bitmap for bbold210 char#87 W --- */
      {  87,20554,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x05\xe0\x32\x31\xe0\x31\xf3\x11\x31\xe0\x11\x10\xf2"
            "\x21\x31\xd1\x20\x31\x31\x31\x71\x30\xf1\x31\x31\x21"
            "\x11\x61\x30\x31\x31\x11\x31\x51\x71\x32\x31\x41\x40"
            "\xf1\x41\x31\x51\x31\x40\xf1\x51\x11\x71\x11\x50\x52"
            "\x92\xb1\xa1\x50" }  },
      /* --- pixel bitmap for bbold210 char#88 X --- */
      {  88,20901,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xf8\x02\x44\x04\x44\x04\x22\x08\x22\x10\x11\x20"
            "\x11\xc0\x08\x40\x04\x40\x04\x20\x02\x20\x02\x10\x03"
            "\x88\x04\x88\x08\x44\x10\x44\x20\x22\x20\x22\x40\x1f"
            "\x80" }  },
      /* --- pixel bitmap for bbold210 char#89 Y --- */
      {  89,21214,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   20, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xb1\xf1\x11\x31\x91\x10\x21\x31\x71\x20\xf1\x31"
            "\x31\x51\x30\x41\x31\x31\x40\xf1\x51\x31\x11\x50\xf9"
            "\x61\x31\x60\x65\x60" }  },
      /* --- pixel bitmap for bbold210 char#90 Z --- */
      {  90,21517,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\x00\x44\x00\x44\x00\x22\x00\x22\x00\x11\x00"
            "\x11\x80\x08\x40\x04\x40\x04\x20\x02\x20\x02\x10\x01"
            "\x88\x00\x88\x00\x44\x00\x44\x00\x22\x00\x22\x00\xff"
            "\xff" }  },
      /* --- pixel bitmap for bbold210 char#91 [ --- */
      {  91,35495,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\xe1\x31\x2f\xb1\x31\x27" }  },
      /* --- pixel bitmap for bbold210 char#92 \\ --- */
      {  92,35821,                      /* character number, location */
         22, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 15,   29, 3,86, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xa1\x31\xa0\xf2\x11\x31\x90\xf2\x21\x31\x80\xf1"
            "\x31\x31\x70\xf2\x41\x31\x60\xf2\x51\x31\x50\xf2\x61"
            "\x31\x40\xf2\x71\x31\x30\xf1\x81\x31\x20\xf2\x91\x31"
            "\x10\xa1\x31\xa5" }  },
      /* --- pixel bitmap for bbold210 char#93 ] --- */
      {  93,36154,                      /* character number, location */
         22, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xfe\x21\x31\xfb\x21\x31\x07" }  },
      /* --- pixel bitmap for bbold210 char#94 (noname) --- */
      {  94,36481,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  7,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x08\x04\x83\xa1\x50\x28\x12\x49\x24\x0a\x85"
            "\x42\x22\x11\x89\x84\x42\xa1\x60\x30\x10\x08\x08\x04" }  },
      /* --- pixel bitmap for bbold210 char#95 (noname) --- */
      {  95,36789,                      /* character number, location */
         22, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          {  7,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\x40\x60\x30\x28\x14\x0a\x89\x44\x24\x12\x0a"
            "\x85\x22\x91\x44\xa2\x50\x28\x0c\x06\x81\x20\x10\x00" }  },
      /* --- pixel bitmap for bbold210 char#96 (noname) --- */
      {  96,37100,                      /* character number, location */
         20, 0,    9, 0,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x04\x41\xe0\x19\x05\x83\x41\x11\x07" }  },
      /* --- pixel bitmap for bbold210 char#97 a --- */
      {  97,21802,                      /* character number, location */
         14, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\xb1\x14\x2c\x81\x12\x18\x81\x11\x18\x81\x11"
            "\x18\x81\x12\x28\x81\x14\x8c\xb1\xf0\x00" }  },
      /* --- pixel bitmap for bbold210 char#98 b --- */
      {  98,22093,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   21, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xbf\x41\x31\xb1\x31\x34\x41\x31\x12\x41\x31\x32"
            "\x71\x2f\x11\x31\x91\x1f\x41\x31\xa1\x0f\x11\x31\x91"
            "\x11\x32\x71\x25\x12\x41\xb4\x41" }  },
      /* --- pixel bitmap for bbold210 char#99 c --- */
      {  99,22412,                      /* character number, location */
         14, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x31\x14\x24\x81\x12\x18\x01\x11\x10\x01\x11"
            "\x10\x01\x12\x28\x81\x14\x84\x31\xf0\x00" }  },
      /* --- pixel bitmap for bbold210 char#100 d --- */
      { 100,22689,                      /* character number, location */
         20, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   21, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\xb1\x44\x31\x32\x32\x11\x21\x11\x52\xf1\x11\x21"
            "\x61\x0f\x41\x31\x61\xf1\x11\x21\x61\x21\x11\x52\x32"
            "\x32\x11\x44\x45" }  },
      /* --- pixel bitmap for bbold210 char#101 e --- */
      { 101,22994,                      /* character number, location */
         14, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x31\x14\x24\x41\x12\x18\x81\xf1\x1f\x01\x11"
            "\x10\x01\x12\x28\x81\x14\x84\x31\xf0\x00" }  },
      /* --- pixel bitmap for bbold210 char#102 f --- */
      { 102,23273,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   21, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x34\x51\x11\x21\x31\x21\x31\x21\x21\x42\x31\x41\x0f"
            "\x21\x31\x51\x33\x3f\xa1\x31\x55\x51" }  },
      /* --- pixel bitmap for bbold210 char#103 g --- */
      { 103,23570,                      /* character number, location */
         14, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 12,   21, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\xb1\x14\x2c\x81\x12\x18\x81\x11\x18\x81\x11"
            "\x18\x81\x12\x28\x81\x14\x8c\xb1\xf0\x08\x80\x00\x04"
            "\x40\x01\x62\x10\xf8\x00" }  },
      /* --- pixel bitmap for bbold210 char#104 h --- */
      { 104,23879,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   20, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x8f\x41\x31\x81\x31\x23\x31\x33\x31\x21\x32\x51"
            "\x1f\x91\x31\x71\x05\x71" }  },
      /* --- pixel bitmap for bbold210 char#105 i --- */
      { 105,24192,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   20, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x31\x31\x1f\x21\x51\x11\x31\x33\x35\x10\xfa\x11"
            "\x31\x10\x15\x11" }  },
      /* --- pixel bitmap for bbold210 char#106 j --- */
      { 106,24473,                      /* character number, location */
         20, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 11,   27, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x71\x31\x10\xf2\x41\x51\x51\x31\x73\x75\x10\xfe"
            "\x51\x31\x10\x51\x21\x21\x41\x21\x32\x21\x11\x64\x44" }  },
      /* --- pixel bitmap for bbold210 char#107 k --- */
      { 107,24786,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x20\x02\x44\x80\x08\x10\x01\x22\x40\x04\x88\x80"
            "\x11\x28\xc2\x44\x84\x48\x10\x05\x62\x41\x44\x88\x10"
            "\x11\x22\x82\x44\xa0\x0f\x08" }  },
      /* --- pixel bitmap for bbold210 char#108 l --- */
      { 108,25097,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,   20, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x31\x01\x31\x11\x21\x21\x11\x32" }  },
      /* --- pixel bitmap for bbold210 char#109 m --- */
      { 109,25382,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   14, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x33\x26\x31\x11\x31\x11\x31\x41\x11\x31\x1f\x91"
            "\x31\x51\x51\x05\x51\x51" }  },
      /* --- pixel bitmap for bbold210 char#110 n --- */
      { 110,25699,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x37\x31\x21\x32\x51\x1f\x91\x31\x71\x05\x71" }  },
      /* --- pixel bitmap for bbold210 char#111 o --- */
      { 111,25984,                      /* character number, location */
         14, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x11\x14\x22\x41\x12\x14\x81\x11\x18\x81\x11"
            "\x18\x81\x12\x24\x41\x14\x82\x11\xf0\x00" }  },
      /* --- pixel bitmap for bbold210 char#112 p --- */
      { 112,26271,                      /* character number, location */
         14, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 16,   20, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x45\x12\x41\x31\x32\x71\x2f\x11\x31\x91\x1f\x41"
            "\x31\xa1\x0f\x11\x31\x91\x11\x32\x71\x21\x31\x12\x41"
            "\x31\x31\x34\x4f\x31\x31\xb5\xb1" }  },
      /* --- pixel bitmap for bbold210 char#113 q --- */
      { 113,26586,                      /* character number, location */
         14, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 12,   20, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x72\x32\x11\x21\x11\x52\xf1\x11\x21\x61\x0f\x41"
            "\x31\x61\xf1\x11\x21\x61\x21\x11\x52\x32\x32\x11\x44"
            "\x31\xf4\xb1" }  },
      /* --- pixel bitmap for bbold210 char#114 r --- */
      { 114,26889,                      /* character number, location */
         14, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   14, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x37\x32\x11\x32\x51\x1f\x11\x31\x71\x0f\x71\x31"
            "\x85\x81" }  },
      /* --- pixel bitmap for bbold210 char#115 s --- */
      { 115,27156,                      /* character number, location */
         14, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x58\x12\x51\x84\x11\x4a\xc0\x07\x60\x00\x02\x18"
            "\x60\x80\x02\x11\x82\x07" }  },
      /* --- pixel bitmap for bbold210 char#116 t --- */
      { 116,27421,                      /* character number, location */
         20, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 10,   21, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x5f\x51\x31\x51\x36\x0f\x71\x31\x51\x31\x41\x11"
            "\x21\x41\x11\x21\x31\x31\x11\x21\x54\x31" }  },
      /* --- pixel bitmap for bbold210 char#117 u --- */
      { 117,27718,                      /* character number, location */
         13, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   14, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x61\x0f\x71\x31\x61\xf1\x11\x21\x52\x21\x11\x41"
            "\x11\x32\x31\x21\x44\x41" }  },
      /* --- pixel bitmap for bbold210 char#118 v --- */
      { 118,28007,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x50\x04\x8a\x20\x22\x44\x44\x10\x09\xa2\x80\x18"
            "\x10\x01\x24\x80\x02\x60\x00\x04\x00" }  },
      /* --- pixel bitmap for bbold210 char#119 w --- */
      { 119,28276,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x00\x23\x00\x8a\x00\x12\x01\x24\x02\x88\x28\x08"
            "\xb1\x10\x62\x21\x48\x24\x90\x48\xa0\xa0\x80\xc1\x00"
            "\x01\x01" }  },
      /* --- pixel bitmap for bbold210 char#120 x --- */
      { 120,28569,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x2f\x44\x44\x84\x22\x30\x02\x11\x88\x80\x08\xc4"
            "\x40\x14\x22\x22\x42\x1f\x08" }  },
      /* --- pixel bitmap for bbold210 char#121 y --- */
      { 121,28842,                      /* character number, location */
         13, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 13,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x50\x04\x89\x20\x22\x42\x44\x10\x05\xa2\x80\x08"
            "\x10\x01\x34\x80\x02\x60\x00\x04\x40\x00\x08\x80\x00"
            "\x08\x80\x00\x08\x80\x00\x00" }  },
      /* --- pixel bitmap for bbold210 char#122 z --- */
      { 122,29125,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x44\x40\x04\x22\x20\x02\x11\x88\x80\x08\x44"
            "\x40\x04\x22\x20\x02\xff\x0f" }  },
      /* --- pixel bitmap for bbold210 char#123 \- --- */
      { 123,37666,                      /* character number, location */
          8, 0,    7, 0,      /* topleft row,col, and botleft row,col */
          { 11,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b" }  },
      /* --- pixel bitmap for bbold210 char#124 | --- */
      { 124,37345,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  5,   29, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x31\x0f\xb1\x31\x05" }  },
      /* --- pixel bitmap for bbold210 char#125 (noname) --- */
      { 125,37878,                      /* character number, location */
          8, 0,    7, 0,      /* topleft row,col, and botleft row,col */
          { 23,    1, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x09" }  },
      /* --- pixel bitmap for bbold210 char#126 (noname) --- */
      { 126,38096,                      /* character number, location */
         20, 0,    9, 0,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x30\x04\x04\x01\x41\x40\xe0\xe1\x19\x19\x05\x05"
            "\x83\x82\x41\x41\x11\x11\x07\x07" }  },
      /* --- pixel bitmap for bbold210 char#127 \omega --- */
      { 127,10443,                      /* character number, location */
         13, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 17,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x10\x38\xc0\x48\x00\x92\x00\x14\x01\x30\x22\x60"
            "\x44\xc0\x88\x80\x11\x01\x23\x02\x4a\x0a\x92\x14\x44"
            "\x45\x04\x07\x07" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=7 for .250gf ---
 * mf '\mode=preview; mag=magstep(-12.84858895680446863032); input bbold10'
 * --------------------------------------------------------------------- */
/* --- fontdef for bbold250 --- */
static	chardef  bbold250[] =
   {
      /* --- pixel bitmap for bbold250 char#0 \Gamma --- */
      {   0,  246,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\x0f\xe1\x31\xcf\x61\x31\xc5\xc0" }  },
      /* --- pixel bitmap for bbold250 char#1 \Delta --- */
      {   1,  556,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x91\x90\xf1\x81\x11\x80\xf2\x71\x31\x70\xf1\x61"
            "\x31\x11\x60\xf2\x51\x31\x31\x50\xf2\x41\x31\x51\x40"
            "\xf1\x31\x31\x71\x30\xf2\x21\x31\x91\x20\xf1\x11\x31"
            "\xb1\x11\x31\xde\x06" }  },
      /* --- pixel bitmap for bbold250 char#2 \Theta --- */
      {   2,  896,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   26, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\xc2\x52\x91\x91\x72\xa1\x30\xf1\x21\x11\xb1\x20"
            "\xf2\x11\x21\xc1\x1f\x21\x31\xd1\x01\x31\x46\x31\x0f"
            "\x31\x31\xd1\xf2\x11\x21\xc1\x10\xf1\x21\x11\xb1\x20"
            "\x32\xa1\x71\x91\x92\x52\xc5\x70" }  },
      /* --- pixel bitmap for bbold250 char#3 \Lambda --- */
      {   3, 1253,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x91\x90\xf1\x81\x11\x80\xf2\x71\x31\x70\xf1\x61"
            "\x31\x11\x60\xf2\x51\x31\x31\x50\xf2\x41\x31\x51\x40"
            "\xf1\x31\x31\x71\x30\xf2\x21\x31\x91\x20\xf1\x11\x31"
            "\xb1\x11\x31\xd6\xd1" }  },
      /* --- pixel bitmap for bbold250 char#4 \Xi --- */
      {   4, 1592,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,22, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x05\xf9\xe0\x50\x76\x60\xfa\xe0\x5e\x05" }  },
      /* --- pixel bitmap for bbold250 char#5 \Pi --- */
      {   5, 1817,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\x0f\xe1\x31\xb1\x0f\x61\x31\xb1\x05\xb1" }  },
      /* --- pixel bitmap for bbold250 char#6 \Sigma --- */
      {   6, 2173,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,102, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x0e\x05\xf1\x11\x31\xd0\xf1\x21\x31\xc0\x31\x31\xb0"
            "\xf1\x41\x31\xa0\xf1\x51\x31\x90\x61\x31\x80\xf1\x71"
            "\x31\x70\x61\x31\x80\xf1\x51\x31\x90\xf1\x41\x31\xa0"
            "\x31\x31\xb0\xf1\x21\x31\xc0\xf1\x11\x31\xde\x05" }  },
      /* --- pixel bitmap for bbold250 char#7 \Upsilon --- */
      {   7, 2485,                      /* character number, location */
         25, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x74\x20\xf1\x11\x41\x51\x41\x1f\x31\x61\x31\x61"
            "\xf4\x71\x31\x70\x75\x70\xfa\x71\x31\x70\x75\x71" }  },
      /* --- pixel bitmap for bbold250 char#8 \Phi --- */
      {   8, 2821,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x70\xf3\x71\x31\x70\x62\x32\xa2\x11\x31\x12\x62"
            "\x31\x31\x32\x20\xf1\x11\x51\x31\x51\x1f\x31\x61\x31"
            "\x61\xf1\x11\x51\x31\x51\x10\x22\x31\x31\x32\x62\x11"
            "\x31\x12\xa2\x32\x60\xf3\x71\x31\x70\x75\x7e" }  },
      /* --- pixel bitmap for bbold250 char#9 \Psi --- */
      {   9, 3177,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x70\xf3\x71\x31\x72\x51\x31\x52\xf4\x21\x41\x31"
            "\x41\x20\xf3\x31\x31\x31\x31\x30\xf1\x41\x21\x31\x21"
            "\x40\x53\x33\x50\xf4\x71\x31\x70\x75\x71" }  },
      /* --- pixel bitmap for bbold250 char#10 \Omega --- */
      {  10, 3535,                      /* character number, location */
         25, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\xc2\x52\x91\x91\x72\xa1\x30\xf1\x21\x11\xb1\x20"
            "\xf2\x11\x21\xc1\x1f\x71\x31\xd1\xf2\x11\x21\xc1\x10"
            "\xf1\x21\x11\xb1\x20\xf1\x32\xa1\x35\x95" }  },
      /* --- pixel bitmap for bbold250 char#11 \alpha --- */
      {  11, 3887,                      /* character number, location */
         16, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\x30\x04\x52\x10\x94\x20\x28\x81\x30\x02\x61"
            "\x04\xc2\x08\x44\x11\x88\x22\x10\x45\x40\x89\x80\x22"
            "\x01\x43\x02\x04\x05\x0c\x0c\xe6\xe0\x03\x00" }  },
      /* --- pixel bitmap for bbold250 char#12 \beta --- */
      {  12, 4218,                      /* character number, location */
         25, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 16,   32, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x75\x92\x52\x61\x91\x42\x91\x31\x11\xa1\xf1\x11\x21"
            "\xa1\x01\x31\xa2\x31\x91\x11\x31\x81\x21\x31\x53\x31"
            "\x31\x71\x31\x31\x81\x2f\x11\x31\x91\x1f\x51\x31\xa1"
            "\x0f\x11\x31\x91\x11\x32\x71\x21\x31\x12\x41\x31\x31"
            "\x34\x4f\x41\x31\xb5\xb0" }  },
      /* --- pixel bitmap for bbold250 char#13 \gamma --- */
      {  13, 4606,                      /* character number, location */
         15, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 14,   23, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x64\x42\x22\xa2\xb1\x21\x91\x41\x72\x51\x30\xf1"
            "\x21\x11\x61\x20\xf2\x11\x21\x71\x1f\x61\x31\x81\xf1"
            "\x11\x21\x71\x10\x21\x11\x61\x52\x42\x84\x51" }  },
      /* --- pixel bitmap for bbold250 char#14 \delta --- */
      {  14, 4942,                      /* character number, location */
         25, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   26, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x71\x61\x42\x82\x21\xa1\x11\xc1\x0f\x21\xd0\x12"
            "\xe2\xe3\x92\x32\x61\x11\x52\x31\x21\x61\x31\x21\x71"
            "\x1f\x51\x31\x81\xf1\x11\x21\x71\x10\x21\x11\x61\x52"
            "\x42\x84\x51" }  },
      /* --- pixel bitmap for bbold250 char#15 \epsilon --- */
      {  15, 5274,                      /* character number, location */
         16, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x06\x41\x81\x49\x40\x12\x60\x04\x10\x01\xc4"
            "\x03\x11\x40\x04\x10\x01\x44\x00\x12\xa0\x04\x44\x81"
            "\x61\x10\xe0\x03" }  },
      /* --- pixel bitmap for bbold250 char#16 \zeta --- */
      {  16, 5567,                      /* character number, location */
         24, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 12,   31, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa2\x91\x92\x91\xa1\xa1\x70\xf1\x32\x70\x21\x11\x70"
            "\xf2\x11\x21\x7f\x61\x31\x70\xf1\x11\x21\x70\x21\x11"
            "\xa2\xc3\xc2\xc1\x10\xf2\xb1\xa1\x92\x21" }  },
      /* --- pixel bitmap for bbold250 char#17 \eta --- */
      {  17, 5873,                      /* character number, location */
         16, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x45\x12\x41\x31\x32\x71\x2f\x11\x31\x91\x1f\x91"
            "\x31\xa1\x05\xa1\xf6\xe0\x11" }  },
      /* --- pixel bitmap for bbold250 char#18 \theta --- */
      {  18, 6195,                      /* character number, location */
         25, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   26, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x82\x42\x30\xf1\x21\x11\x61\x20\xf2\x11\x21\x71"
            "\x1f\x41\x31\x81\x01\x3a\x0f\x51\x31\x81\xf2\x11\x21"
            "\x71\x10\xf1\x21\x11\x61\x20\x32\x42\x84\x51" }  },
      /* --- pixel bitmap for bbold250 char#19 \iota --- */
      {  19, 6554,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  5,   15, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xb1\x31\x11\x21\x22\x11" }  },
      /* --- pixel bitmap for bbold250 char#20 \kappa --- */
      {  20, 6828,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x80\x11\x60\x11\x18\x11\x06\x91\x01\x71\x00\x71"
            "\x00\x91\x00\x11\x01\x11\x02\x11\x02\x11\x04\x11\x08"
            "\x11\x10\x1f\xe0" }  },
      /* --- pixel bitmap for bbold250 char#21 \lambda --- */
      {  21, 7129,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x40\x04\x20\x02\x88\x00\x44\x00\x11\x40\x04\x20"
            "\x02\x88\x00\x44\x00\x11\x40\x04\x20\x02\x88\x00\x22"
            "\x80\x11\x50\x04\x22\x82\x88\x10\x22\x04\x91\x40\x24"
            "\x20\x06\xf8" }  },
      /* --- pixel bitmap for bbold250 char#22 \mu --- */
      {  22, 7452,                      /* character number, location */
         15, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xa1\x0f\x91\x31\xa1\x0f\x11\x31\x92\x01\x32\x71"
            "\x12\x31\x12\x41\x22\x31\x34\x4f\x41\x31\xb5\xb2" }  },
      /* --- pixel bitmap for bbold250 char#23 \nu --- */
      {  23, 7789,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x60\x04\x18\x01\x46\x80\x11\x50\x04\x14\x01\x45"
            "\x20\x11\x44\x04\x11\x21\x44\x04\xd1\x40\x0e\x70\x00"
            "\x00" }  },
      /* --- pixel bitmap for bbold250 char#24 \xi --- */
      {  24, 8086,                      /* character number, location */
         24, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 12,   31, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x23\x81\x21\x7f\x31\x31\x70\x11\x21\x93\xb4\x72"
            "\x91\x11\x70\xf1\x11\x21\x7f\x41\x31\x70\xf1\x11\x21"
            "\x70\x21\x11\xa2\xc3\xc2\xc1\x10\xf2\xb1\xa1\x92\x21" }  },
      /* --- pixel bitmap for bbold250 char#25 \pi --- */
      {  25, 8397,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   15, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\xfc\x31\x31\x41\x30\x35\x41\x31" }  },
      /* --- pixel bitmap for bbold250 char#26 \rho --- */
      {  26, 8697,                      /* character number, location */
         16, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 14,   23, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x82\x42\x51\x11\x61\x20\xf1\x11\x21\x71\x1f\x61"
            "\x31\x81\x0f\x11\x31\x71\x11\x31\x61\x21\x31\x42\x31"
            "\x35\x5f\x41\x31\x95\x92" }  },
      /* --- pixel bitmap for bbold250 char#27 \sigma --- */
      {  27, 9031,                      /* character number, location */
         15, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 17,   16, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x32\x42\x81\x11\x61\x50\xf1\x11\x21\x71\x4f\x51"
            "\x31\x81\x30\xf1\x11\x21\x71\x40\x21\x11\x61\x82\x42"
            "\xb4\x8f" }  },
      /* --- pixel bitmap for bbold250 char#28 \tau --- */
      {  28, 9331,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\xfa\x51\x31\x50\x61\x21\xc1\x11\xd2\x5f" }  },
      /* --- pixel bitmap for bbold250 char#29 \upsilon --- */
      {  29, 9607,                      /* character number, location */
         15, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 14,   16, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x81\x0f\x91\x31\x81\xf1\x11\x21\x71\x10\x21\x11"
            "\x61\x52\x42\x84\x51" }  },
      /* --- pixel bitmap for bbold250 char#30 \phi --- */
      {  30, 9911,                      /* character number, location */
         24, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 15,   31, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x50\xf8\x51\x31\x50\x33\x33\x51\x21\x31\x21\x20"
            "\xf1\x11\x31\x31\x31\x1f\x41\x41\x31\x41\xf1\x11\x31"
            "\x31\x31\x10\x21\x21\x31\x21\x53\x33\x30\xf6\x51\x31"
            "\x50\x55\x51" }  },
      /* --- pixel bitmap for bbold250 char#31 \chi --- */
      {  31,10291,                      /* character number, location */
         15, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 14,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xbe\x80\x28\x10\x11\x44\x84\x08\x22\x02\x45\x40"
            "\x11\x60\x04\x88\x00\x22\x40\x04\x10\x01\x62\x80\x28"
            "\x20\x0a\x44\x04\x11\x22\x82\x88\x40\x11\xd0\x07\x08" }  },
      /* --- pixel bitmap for bbold250 char#32 \psi --- */
      {  32,10623,                      /* character number, location */
         24, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 15,   31, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x50\xf7\x51\x31\x5f\xa1\x41\x31\x41\x11\x31\x31"
            "\x31\x31\x21\x31\x21\x53\x33\x30\xf6\x51\x31\x50\x55"
            "\x51" }  },
      /* --- pixel bitmap for bbold250 char#33 ! --- */
      {  33,31030,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,   25, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x15\x10\xfd\x11\x31\x10\x15\x10\xf1\x70\x23\x31\x31"
            "\x1f\x21\x51\x11\x31\x33\x21" }  },
      /* --- pixel bitmap for bbold250 char#34 (noname) --- */
      {  34,40440,                      /* character number, location */
         25, 0,   11, 0,      /* topleft row,col, and botleft row,col */
          { 17,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x70\x44\x10\x05\x11\x0c\x22\x18\x44\x50\x0c\x31"
            "\x17\x5c\x10\x40\x20\x80\x20\x80\x40\x00\x41\x00\x41"
            "\x00\x41\x00\x01" }  },
      /* --- pixel bitmap for bbold250 char#35 # --- */
      {  35,31330,                      /* character number, location */
         24, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x51\x50\xf9\x71\x31\x51\x58\x3c\xf6\x71\x31\x51"
            "\x58\x3c\xf9\x71\x31\x51\x50\x75\x51\x50" }  },
      /* --- pixel bitmap for bbold250 char#36 $ --- */
      {  36,31720,                      /* character number, location */
         27, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 17,   30, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x80\x08\x00\x11\x00\xe3\x80\x45\x86\x88\xb0"
            "\x10\x81\x20\x02\x41\x04\x82\x08\x04\x11\x10\x22\x40"
            "\x44\x00\x8b\x00\x18\x03\x20\x1a\x40\x44\x80\x08\x01"
            "\x11\x04\x22\x08\x44\x10\x88\x20\x10\x41\x20\x42\x43"
            "\x44\x98\x68\xc0\x31\x00\x22\x00\x44\x00\xf8\x00" }  },
      /* --- pixel bitmap for bbold250 char#37 % --- */
      {  37,32100,                      /* character number, location */
         27, 0,  -12, 0,      /* topleft row,col, and botleft row,col */
          { 19,   39, 3,163, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x23\xe0\x11\x31\x75\x11\x51\x61\x31\x1f\x11\x51\x51"
            "\x31\x20\x11\x31\x61\x31\x43\x61\x31\x30\xf1\xb1\x31"
            "\x30\xf2\xa1\x31\x40\xf2\x91\x31\x50\xf2\x81\x31\x60"
            "\xf2\x71\x31\x70\xf2\x61\x31\x80\xf2\x51\x31\x90\xf2"
            "\x41\x31\xa0\xf1\x31\x31\xb0\x31\x31\x63\x41\x31\x61"
            "\x31\x10\xf1\x21\x31\x51\x51\x11\x31\x61\x51\x15\x71"
            "\x31\xe0\x13\x20" }  },
      /* --- pixel bitmap for bbold250 char#38 & --- */
      {  38,32502,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 23,   26, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x83\xe0\x51\x31\xb0\xf4\x61\x51\xa0\x71\x31\xe0\x41"
            "\x21\xe0\x51\x11\xe0\x62\xe0\x52\x11\xe0\x32\x41\xe0"
            "\x11\x11\x41\xe1\x21\x51\xc1\x31\x51\xc1\x31\x61\xb1"
            "\x31\x61\x61\x4f\x11\x31\x71\x41\x51\x31\x81\x21\x71"
            "\x21\x92\x61\x11\x21\x91\x71\x21\x11\x72\x11\x61\x32"
            "\x52\x42\x31\x56\x83\x21" }  },
      /* --- pixel bitmap for bbold250 char#39 ' --- */
      {  39,32855,                      /* character number, location */
         25, 0,   11, 0,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\x73\x41\x20\x08\x04\x41\x10\x00" }  },
      /* --- pixel bitmap for bbold250 char#40 ( --- */
      {  40,33108,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          {  9,   35, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x42\x30\xf1\x32\x40\xf1\x21\x11\x40\xf3\x11\x21"
            "\x4f\xe1\x31\x40\xf3\x11\x21\x40\xf1\x21\x11\x40\xf1"
            "\x32\x40\x42\x93" }  },
      /* --- pixel bitmap for bbold250 char#41 ) --- */
      {  41,33446,                      /* character number, location */
         26, 0,   -9, 0,      /* topleft row,col, and botleft row,col */
          {  9,   35, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x92\x40\xf1\x42\x30\xf1\x41\x11\x20\xf3\x41\x21"
            "\x10\xfe\x41\x31\xf3\x41\x21\x10\xf1\x41\x11\x20\xf1"
            "\x42\x30\x32\x43\x61" }  },
      /* --- pixel bitmap for bbold250 char#42 * --- */
      {  42,33775,                      /* character number, location */
         20, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 19,   23, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\x70\xf4\x71\x31\x71\x61\x31\x61\x12\x41\x31\x42"
            "\x42\x21\x31\x22\x83\x33\x50\xf2\x71\x31\x70\x53\x33"
            "\x82\x21\x31\x22\x42\x41\x31\x42\x11\x61\x31\x61\xf4"
            "\x71\x31\x70\x75\x71" }  },
      /* --- pixel bitmap for bbold250 char#43 + --- */
      {  43,34097,                      /* character number, location */
         20, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 23,   23, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x95\x90\xf9\x91\x31\x9a\x3a\xf9\x91\x31\x90\x95\x92" }  },
      /* --- pixel bitmap for bbold250 char#44 , --- */
      {  44,34391,                      /* character number, location */
          6, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\x73\x41\x20\x08\x82\x20\x00" }  },
      /* --- pixel bitmap for bbold250 char#45 - --- */
      {  45,34636,                      /* character number, location */
          8, 0,    7, 0,      /* topleft row,col, and botleft row,col */
          { 12,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c" }  },
      /* --- pixel bitmap for bbold250 char#46 . --- */
      {  46,34848,                      /* character number, location */
          6, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\x71\x00" }  },
      /* --- pixel bitmap for bbold250 char#47 / --- */
      {  47,35088,                      /* character number, location */
         26, 0,   -9, 0,      /* topleft row,col, and botleft row,col */
          { 17,   35, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc5\xc1\x31\xf2\xb1\x31\x10\xf2\xa1\x31\x20\xf1\x91"
            "\x31\x30\xf2\x81\x31\x40\xf2\x71\x31\x50\xf2\x61\x31"
            "\x60\xf2\x51\x31\x70\xf2\x41\x31\x80\xf1\x31\x31\x90"
            "\xf2\x21\x31\xa0\xf2\x11\x31\xb1\x31\xc5\xc1" }  },
      /* --- pixel bitmap for bbold250 char#48 0 --- */
      {  48,11336,                      /* character number, location */
         23, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x91\x51\x72\x61\x51\x11\x71\x20\xf2\x11\x21\x81"
            "\x1f\x91\x31\x91\xf2\x11\x21\x81\x10\x21\x11\x71\x52"
            "\x61\x71\x51\x95\x51" }  },
      /* --- pixel bitmap for bbold250 char#49 1 --- */
      {  49,11673,                      /* character number, location */
         22, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\xc3\xa2\x21\x83\x31\x62\x21\x31\x51\x41\x31\x50"
            "\xfe\x51\x31\x5e\x01" }  },
      /* --- pixel bitmap for bbold250 char#50 2 --- */
      {  50,11968,                      /* character number, location */
         23, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   23, 3,76, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x51\x71\x11\x31\x81\x21\x21\x81\x31\x0f"
            "\x11\x91\x31\xa1\x31\xf1\xa1\x21\x10\xa1\x11\xc2\xd1"
            "\xc2\xb2\xc1\xc2\xc1\xc0\xf1\x11\xdf\x11\xee\x01" }  },
      /* --- pixel bitmap for bbold250 char#51 3 --- */
      {  51,12253,                      /* character number, location */
         23, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x45\x80\x24\x40\x0c\x20\x06\x10"
            "\x01\x88\x00\x24\x00\x0e\xe0\x01\x80\x01\x40\x01\x20"
            "\x01\x10\x01\x88\x00\xc4\x00\x62\x00\x51\x80\x24\x40"
            "\x22\xa0\x60\x30\xc0\x07" }  },
      /* --- pixel bitmap for bbold250 char#52 4 --- */
      {  52,12568,                      /* character number, location */
         22, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x00\x06\x00\x03\x40\x01\x90\x00\x48\x00\x22"
            "\x80\x11\xa0\x08\x50\x04\x24\x02\x11\x81\x88\x20\x44"
            "\x08\x22\x04\x11\xff\x78\x40\x04\x20\x02\x10\x01\x88"
            "\x00\x7c\x00" }  },
      /* --- pixel bitmap for bbold250 char#53 5 --- */
      {  53,12873,                      /* character number, location */
         22, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   23, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\x0f\x41\x31\xaa\xe0\x12\xe0\x11\x20\xf1\xd1"
            "\x10\xf4\xe1\x01\xd2\xc1\x21\xb1\x21\xa1\x41\x91\x52"
            "\x52\x85\x51" }  },
      /* --- pixel bitmap for bbold250 char#54 6 --- */
      {  54,13150,                      /* character number, location */
         23, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x51\x91\x20\xf1\x11\xb1\x1f\x11\xd1\x01"
            "\x45\x51\x22\x52\x31\x11\x11\x71\x2f\x12\x21\x81\x1f"
            "\x51\x31\x91\xf1\x11\x21\x81\x10\xf1\x21\x11\x71\x20"
            "\x32\x52\x85\x51" }  },
      /* --- pixel bitmap for bbold250 char#55 7 --- */
      {  55,13481,                      /* character number, location */
         22, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x7f\x00\x22\x80\x08\x40\x04\x10\x01\x88\x00\x22"
            "\x00\x11\x40\x04\x20\x02\x88\x00\x44\x00\x11\x80\x08"
            "\x20\x02\x10\x01\x44\x00\x22\x80\x08\x40\x04\x10\x01"
            "\xf8\x00\x00" }  },
      /* --- pixel bitmap for bbold250 char#56 8 --- */
      {  56,13774,                      /* character number, location */
         23, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x51\x11\x71\x31\x21\x81\x1f\x31\x31\x91"
            "\x11\x21\x81\x33\x62\x67\x72\x52\x51\x11\x71\x31\x21"
            "\x81\x1f\x41\x31\x91\xf1\x11\x21\x81\x10\x21\x11\x71"
            "\x52\x52\x85\x51" }  },
      /* --- pixel bitmap for bbold250 char#57 9 --- */
      {  57,14107,                      /* character number, location */
         23, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x30\xf1\x21\x11\x71\x20\xf1\x11\x21\x81"
            "\x1f\x51\x31\x91\xf1\x11\x21\x82\x21\x11\x71\x11\x32"
            "\x52\x21\x55\x41\x0f\x11\xd1\xf1\x11\xb1\x10\x21\x91"
            "\x52\x52\x85\x51" }  },
      /* --- pixel bitmap for bbold250 char#58 : --- */
      {  58,35430,                      /* character number, location */
         16, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          {  7,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\x71\x00\x00\x00\x47\x14\x0c\x06"
            "\x45\x1c" }  },
      /* --- pixel bitmap for bbold250 char#59 ; --- */
      {  59,35690,                      /* character number, location */
         16, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          {  7,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\x71\x00\x00\x00\x47\x14\x0c\x06"
            "\xc5\x5c\x10\x08\x82\x20\x08\x00" }  },
      /* --- pixel bitmap for bbold250 char#60 < --- */
      {  60,35969,                      /* character number, location */
         18, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   19, 3,96, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x72\xe0\x52\xe0\x43\xe0\x42\xe0\x43\xe0\x42\xe0"
            "\x52\xe0\x43\xe0\x42\x12\xe0\x22\x51\xe0\x22\x52\xe0"
            "\x22\x52\xe0\x21\x61\xe0\x22\x52\xe0\x22\x52\xe0\x21"
            "\x61\xe0\x22\x52\xe0\x22\x52\xe0\x28" }  },
      /* --- pixel bitmap for bbold250 char#61 \cdot --- */
      {  61,36235,                      /* character number, location */
         12, 0,    5, 0,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x18\x14\x71\x00" }  },
      /* --- pixel bitmap for bbold250 char#62 > --- */
      {  62,36477,                      /* character number, location */
         18, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   19, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x92\xe0\x93\xe0\x92\xe0\x92\xe0\x93\xe0\x92"
            "\xe0\x93\xe0\x62\x12\xe0\x31\x52\xd2\x52\xc2\x52\xd1"
            "\x61\xd2\x52\xc2\x52\xd1\x61\xd2\x52\xc2\x52\xd8\xe0"
            "\x11" }  },
      /* --- pixel bitmap for bbold250 char#63 ? --- */
      {  63,36749,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   26, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\x92\x62\x61\xa1\x41\xc1\x21\xe1\x0f\x11\xe0\x11"
            "\xf1\xe0\x21\xe0\x11\xe2\xb4\xc1\x11\xd1\x21\x60\xf1"
            "\x61\x31\x60\x65\x60\xf1\xe0\x30\x73\xd1\x31\x60\xf2"
            "\x51\x51\x50\x61\x31\xd3\x72" }  },
      /* --- pixel bitmap for bbold250 char#64 @ --- */
      {  64,37037,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 16,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x10\x0c\x18\x10\x14\x10\x14\x20\x12\x40\x12"
            "\x40\x12\x40\x11\x80\x11\x90\x11\xec\x11\x82\x11\x82"
            "\x11\x82\x11\x82\x11\x6c\x11\x10\x11\x00\x12\x00\x12"
            "\x40\x12\x40\x14\x20\x14\x20\x18\x10\x10\x0c\xe0\x03" }  },
      /* --- pixel bitmap for bbold250 char#65 A --- */
      {  65,14438,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,96, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x91\x90\xf1\x81\x11\x80\xf2\x71\x31\x70\xf1\x61"
            "\x31\x11\x60\xf2\x51\x31\x31\x50\xf2\x41\x31\x51\x40"
            "\xf1\x31\x31\x71\x30\x21\x31\x91\x41\x3b\x41\x31\x91"
            "\x20\xf1\x11\x31\xb1\x11\x31\xd6\xd1" }  },
      /* --- pixel bitmap for bbold250 char#66 B --- */
      {  66,14769,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x51\x31\x72\x31\x31\x91\x21\x31\xa1\x1f\x31\x31"
            "\xb1\x01\x31\xa1\x11\x31\x91\x21\x31\x72\x31\x38\x51"
            "\x31\x72\x31\x31\x91\x21\x31\xa1\x1f\x41\x31\xb1\x01"
            "\x31\xa1\x11\x31\x91\x21\x31\x72\x3c\x51" }  },
      /* --- pixel bitmap for bbold250 char#67 C --- */
      {  67,15112,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   26, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\xb2\x62\x81\xa1\x62\xb1\x41\x11\xc1\x31\x11\xd1"
            "\x11\x21\xd1\xf1\x11\x21\xef\x71\x31\xe0\xf1\x11\x21"
            "\xe0\x11\x21\xd1\x21\x11\xd1\x21\x11\xc1\x42\xb1\x61"
            "\xa1\x82\x62\xb6\x61" }  },
      /* --- pixel bitmap for bbold250 char#68 D --- */
      {  68,15433,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x71\x31\x72\x51\x31\x91\x41\x31\xa1\x3f\x11\x31"
            "\xb1\x2f\x11\x31\xc1\x1f\x71\x31\xd1\x0f\x11\x31\xc1"
            "\x1f\x11\x31\xb1\x21\x31\xa1\x31\x31\x91\x41\x31\x72"
            "\x5c\x72" }  },
      /* --- pixel bitmap for bbold250 char#69 E --- */
      {  69,15778,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\x0f\x91\x31\xc1\x36\x7f\xa1\x31\xce\x03" }  },
      /* --- pixel bitmap for bbold250 char#70 F --- */
      {  70,16079,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\x0f\x91\x31\xc1\x36\x7f\xa1\x31\xc5\xc3" }  },
      /* --- pixel bitmap for bbold250 char#71 G --- */
      {  71,16380,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   26, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\xb2\x62\x81\xa1\x62\xb1\x41\x11\xc1\x31\x11\xd1"
            "\x11\x21\xd1\xf1\x11\x21\xef\x31\x31\xe1\x31\x86\x0f"
            "\x21\x31\xd1\xf2\x11\x21\xd1\x21\x11\xd1\x21\x11\xc1"
            "\x42\xb1\x61\xa1\x82\x62\xb6\x62" }  },
      /* --- pixel bitmap for bbold250 char#72 H --- */
      {  72,16713,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xd1\x0f\x91\x31\xd1\x01\x3e\x01\x0f\xa1\x31\xd1"
            "\x05\xd1" }  },
      /* --- pixel bitmap for bbold250 char#73 I --- */
      {  73,17060,                      /* character number, location */
         24, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          {  5,   24, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x31\x0f\x61\x31\x05" }  },
      /* --- pixel bitmap for bbold250 char#74 J --- */
      {  74,17361,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   25, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc5\xfe\xc1\x31\xc1\x31\xc1\x21\x1f\x11\xb1\x21\x10"
            "\x11\xa1\x11\x41\x92\x61\x82\x72\x52\xa5\x61" }  },
      /* --- pixel bitmap for bbold250 char#75 K --- */
      {  75,17672,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x00\x23\x00\x45\x00\x8a\x00\x12\x01\x22\x02\x42"
            "\x04\x84\x08\x04\x11\x04\x22\x04\x44\x08\x88\x08\x10"
            "\x29\x20\x52\x40\x14\x81\x18\x04\x11\x08\x22\x20\x44"
            "\x80\x88\x00\x11\x01\x24\x02\x50\x04\xa0\x0f\x80" }  },
      /* --- pixel bitmap for bbold250 char#76 L --- */
      {  76,18027,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xcf\xe1\x31\xcf\x61\x31\xce\x03" }  },
      /* --- pixel bitmap for bbold250 char#77 M --- */
      {  77,18328,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x33\xe0\x12\x0f\x11\x11\xd1\x11\x01\x21\xb1"
            "\x22\x31\x91\x32\x32\x71\x42\x31\x11\x51\x51\x0f\x11"
            "\x31\x21\x31\x61\x01\x31\x31\x11\x72\x31\x41\x81\x0f"
            "\xa1\x31\xd1\x05\xd1" }  },
      /* --- pixel bitmap for bbold250 char#78 N --- */
      {  78,18703,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x00\x1c\x00\x60\x01\x00\x0b\x00\x98\x00\xc0\x08"
            "\x00\xc6\x00\x30\x06\x80\x51\x00\x8c\x04\x60\x44\x00"
            "\x23\x04\x18\x21\xc0\x08\x02\x46\x20\x30\x02\x82\x11"
            "\x20\x8c\x00\x61\x04\x10\x23\x00\x19\x01\xd0\x08\x80"
            "\x46\x00\xf8\x03\x80" }  },
      /* --- pixel bitmap for bbold250 char#79 O --- */
      {  79,19078,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   26, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\xc2\x52\x91\x91\x72\xa1\x30\xf1\x21\x11\xb1\x20"
            "\xf2\x11\x21\xc1\x1f\x71\x31\xd1\xf2\x11\x21\xc1\x10"
            "\xf1\x21\x11\xb1\x20\x32\xa1\x71\x91\x92\x52\xc5\x71" }  },
      /* --- pixel bitmap for bbold250 char#80 P --- */
      {  80,19423,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x51\x31\x72\x31\x31\x91\x21\x31\xa1\x1f\x31\x31"
            "\xb1\x01\x31\xa1\x11\x31\x91\x21\x31\x72\x31\x38\x5f"
            "\xa1\x31\xc5\xc1" }  },
      /* --- pixel bitmap for bbold250 char#81 Q --- */
      {  81,19744,                      /* character number, location */
         25, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 19,   32, 3,128, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x75\xc2\x52\x91\x91\x72\xa1\x30\xf1\x21\x11\xb1\x20"
            "\xf2\x11\x21\xc1\x1f\x71\x31\xd1\x11\x21\xc1\x21\x21"
            "\x41\x71\x21\x21\x51\x61\x31\x11\x51\x51\x41\x11\x61"
            "\x41\x52\x71\x21\x71\x71\x11\x92\x52\xc5\x21\x40\xf1"
            "\xe0\x11\x30\xe0\x21\x20\xf1\xe0\x31\x10\xe0\x41" }  },
      /* --- pixel bitmap for bbold250 char#82 R --- */
      {  82,20115,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x22\x60\x44\x00\x89\x00\x14\x01\x30\x02\x60"
            "\x04\xc0\x08\x80\x11\x80\x22\x80\x44\xc0\x88\x7f\x10"
            "\x21\x20\x42\x40\x04\x81\x08\x04\x11\x08\x22\x20\x44"
            "\x80\x88\x00\x11\x01\x24\x02\x50\x04\xa0\x0f\x80" }  },
      /* --- pixel bitmap for bbold250 char#83 S --- */
      {  83,20460,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   26, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x56\x92\x62\x61\x11\x81\x41\x21\x91\x31\x21\xa1\x1f"
            "\x11\x31\xb1\x0f\x11\x31\xc0\x11\x21\xe1\x11\xe0\x12"
            "\xe0\x37\xe0\x32\xe0\x31\xe0\x31\x10\xf2\xe0\x21\x0f"
            "\x11\xe0\x11\x11\xd1\x31\xc1\x41\x92\x62\x52\xa5\x61" }  },
      /* --- pixel bitmap for bbold250 char#84 T --- */
      {  84,20763,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x05\xfe\x71\x31\x70\xf6\x71\x31\x70\x75\x71" }  },
      /* --- pixel bitmap for bbold250 char#85 U --- */
      {  85,21064,                      /* character number, location */
         24, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xd1\x0f\xe1\x31\xd1\xf2\x11\x21\xc1\x10\xf1\x21"
            "\x11\xb1\x20\x32\xa1\x71\x91\x92\x52\xc5\x71" }  },
      /* --- pixel bitmap for bbold250 char#86 V --- */
      {  86,21411,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xd2\x31\xd1\xf1\x11\x31\xb1\x10\xf2\x21\x31\x91"
            "\x20\xf1\x31\x31\x71\x30\xf2\x41\x31\x51\x40\xf2\x51"
            "\x31\x31\x50\xf1\x61\x31\x11\x60\xf2\x71\x31\x70\xf1"
            "\x81\x11\x80\xf1\x91\x91" }  },
      /* --- pixel bitmap for bbold250 char#87 W --- */
      {  87,21744,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 27,   24, 3,137, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x05\xe0\x72\x31\xe0\x71\xf3\x11\x31\xe0\x51\x10\xf2"
            "\x21\x31\xe0\x31\x20\xf1\x31\x31\xe0\x11\x30\x31\x31"
            "\x51\x91\x61\x31\x41\x11\x81\x71\x31\x31\x11\x71\x40"
            "\xf1\x41\x31\x21\x31\x61\x40\xf1\x51\x32\x51\x41\x50"
            "\xf1\x51\x31\x71\x31\x50\xf1\x61\x11\x91\x11\x60\x62"
            "\xb2\xd1\xc1\x60" }  },
      /* --- pixel bitmap for bbold250 char#88 X --- */
      {  88,22121,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xc0\x17\x00\x11\x01\x88\x08\x20\x82\x00\x11\x08"
            "\x44\x80\x10\x01\x84\x08\x40\x22\x00\x14\x01\x40\x04"
            "\x00\x11\x00\x88\x00\x20\x02\x80\x28\x00\x44\x02\x10"
            "\x21\x80\x08\x01\x22\x10\x88\x00\x41\x04\x10\x11\x80"
            "\x88\x00\xe8\x03\x80" }  },
      /* --- pixel bitmap for bbold250 char#89 Y --- */
      {  89,22462,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xd1\xf1\x11\x31\xb1\x10\x21\x31\x91\x20\xf1\x31"
            "\x31\x71\x30\xf1\x41\x31\x51\x40\x51\x31\x31\x50\xf1"
            "\x61\x31\x11\x60\xfb\x71\x31\x70\x75\x70" }  },
      /* --- pixel bitmap for bbold250 char#90 Z --- */
      {  90,22785,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,102, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x0e\x05\xf1\xd1\x31\x10\xf1\xc1\x31\x20\xb1\x31\x30"
            "\xf1\xa1\x31\x40\xf1\x91\x31\x50\x81\x31\x60\xf1\x71"
            "\x31\x70\x61\x31\x80\xf1\x51\x31\x90\xf1\x41\x31\xa0"
            "\x31\x31\xb0\xf1\x21\x31\xc0\xf1\x11\x31\xde\x05" }  },
      /* --- pixel bitmap for bbold250 char#91 [ --- */
      {  91,37407,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          {  9,   35, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x09\x00\xff\x20\x01\x03\x01\x04\x09" }  },
      /* --- pixel bitmap for bbold250 char#92 \\ --- */
      {  92,37757,                      /* character number, location */
         26, 0,   -9, 0,      /* topleft row,col, and botleft row,col */
          { 17,   35, 3,102, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x05\xc1\x31\xc0\xf2\x11\x31\xb0\xf2\x21\x31\xa0\xf1"
            "\x31\x31\x90\xf2\x41\x31\x80\xf2\x51\x31\x70\xf2\x61"
            "\x31\x60\xf2\x71\x31\x50\xf2\x81\x31\x40\xf1\x91\x31"
            "\x30\xf2\xa1\x31\x20\xf2\xb1\x31\x10\xc1\x31\xc5" }  },
      /* --- pixel bitmap for bbold250 char#93 ] --- */
      {  93,38114,                      /* character number, location */
         26, 0,   -9, 0,      /* topleft row,col, and botleft row,col */
          {  9,   35, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x09\xff\x20\x04\x01\x03\x01\x00\x09" }  },
      /* --- pixel bitmap for bbold250 char#94 (noname) --- */
      {  94,38465,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          {  9,   35, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x02\x02\x04\x04\x08\x18\x30\x50\xa0\x20\x41"
            "\x42\x84\x88\x10\x21\x41\x82\x04\x11\x22\x84\x08\x11"
            "\x24\x48\xa0\x40\x01\x03\x06\x08\x10\x40\x80\x00\x02"
            "\x04" }  },
      /* --- pixel bitmap for bbold250 char#95 (noname) --- */
      {  95,38789,                      /* character number, location */
         26, 0,   -9, 0,      /* topleft row,col, and botleft row,col */
          {  9,   35, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x02\x08\x10\x40\x80\x00\x03\x06\x14\x28\x90\x20"
            "\x41\x84\x08\x21\x42\x04\x09\x12\x24\x44\x88\x08\x11"
            "\x12\x24\x28\x50\x60\xc0\x80\x00\x01\x01\x02\x02\x04"
            "\x00" }  },
      /* --- pixel bitmap for bbold250 char#96 (noname) --- */
      {  96,39116,                      /* character number, location */
         24, 0,   10, 0,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x82\x40\x10\x08\x3a\xa3\x60\x30\x28\xe2\x00" }  },
      /* --- pixel bitmap for bbold250 char#97 a --- */
      {  97,23086,                      /* character number, location */
         16, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x06\x49\x81\x4b\xc0\x12\x60\x04\x18\x01\x46"
            "\x80\x11\x60\x04\x18\x01\x46\x80\x12\xa0\x04\x4c\x81"
            "\x63\x90\xe0\x03" }  },
      /* --- pixel bitmap for bbold250 char#98 b --- */
      {  98,23389,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xef\x61\x31\xe1\x31\x45\x51\x31\x22\x52\x31\x31"
            "\x11\x91\x21\x32\xa1\x2f\x11\x31\xc1\x1f\x41\x31\xd1"
            "\x0f\x11\x31\xc1\x11\x32\xa1\x21\x31\x11\x91\x25\x22"
            "\x52\xc5\x50" }  },
      /* --- pixel bitmap for bbold250 char#99 c --- */
      {  99,23732,                      /* character number, location */
         16, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   17, 3,57, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x72\x51\x51\x11\x62\x21\x21\x71\x21\x21\x81\x0f"
            "\x61\x31\x90\x11\x21\x81\x11\x21\x71\x31\x11\x62\x42"
            "\x51\x85\x41" }  },
      /* --- pixel bitmap for bbold250 char#100 d --- */
      { 100,24017,                      /* character number, location */
         24, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   25, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\xd1\x55\x31\x32\x51\x21\x21\x11\x63\x11\x21\x72"
            "\x11\x21\x81\x0f\x61\x31\x81\x11\x21\x81\x11\x21\x72"
            "\x21\x11\x63\x32\x51\x21\x55\x41" }  },
      /* --- pixel bitmap for bbold250 char#101 e --- */
      { 101,24338,                      /* character number, location */
         16, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x06\x41\x81\x48\x40\x12\x60\x04\x18\x01\xc6"
            "\xff\x11\x40\x04\x10\x01\x44\x00\x12\xa0\x04\x44\x81"
            "\x61\x10\xe0\x03" }  },
      /* --- pixel bitmap for bbold250 char#102 f --- */
      { 102,24627,                      /* character number, location */
         25, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   25, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x72\x32\x41\x11\x51\x10\xf1\x11\x21\x61\x0f\x41"
            "\x31\x71\x34\x4f\xc1\x31\x75\x71" }  },
      /* --- pixel bitmap for bbold250 char#103 g --- */
      { 103,24938,                      /* character number, location */
         16, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 14,   24, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x72\x51\x21\x21\x11\x63\x11\x21\x72\x11\x21\x81"
            "\x0f\x61\x31\x81\x11\x21\x81\x11\x21\x72\x21\x11\x63"
            "\x32\x51\x21\x55\x31\xf1\xd1\xf1\xc1\x11\xa1\x33\x52"
            "\x75\x55" }  },
      /* --- pixel bitmap for bbold250 char#104 h --- */
      { 104,25261,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   24, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xbf\x61\x31\xb1\x31\x34\x41\x31\x12\x41\x31\x32"
            "\x71\x2f\x11\x31\x91\x1f\x91\x31\xa1\x05\xa1" }  },
      /* --- pixel bitmap for bbold250 char#105 i --- */
      { 105,25596,                      /* character number, location */
         24, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  7,   24, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x31\x31\x1f\x21\x51\x11\x31\x33\x20\xf1\x70\x15"
            "\x10\xfc\x11\x31\x10\x15\x11" }  },
      /* --- pixel bitmap for bbold250 char#106 j --- */
      { 106,25887,                      /* character number, location */
         24, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 13,   32, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x83\x91\x31\x10\xf2\x61\x51\x71\x31\x93\x20\xf1\xd0"
            "\x75\x10\xfe\x71\x31\x10\xf1\x71\x31\x10\xf1\x71\x21"
            "\x21\x61\x11\x42\x42\x75\x51" }  },
      /* --- pixel bitmap for bbold250 char#107 k --- */
      { 107,26212,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   24, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x00\x11\x00\x11\x00\x11\x00\x11\x00\x11\x00\x11"
            "\x00\x11\x00\x11\x00\x11\x80\x11\x40\x11\x30\x11\x08"
            "\x11\x04\x11\x02\x91\x01\x51\x01\x31\x02\x11\x04\x11"
            "\x08\x11\x10\x11\x20\x11\x40\x1f\x80" }  },
      /* --- pixel bitmap for bbold250 char#108 l --- */
      { 108,26545,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  5,   24, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x31\x0f\x51\x31\x11\x21\x22\x11" }  },
      /* --- pixel bitmap for bbold250 char#109 m --- */
      { 109,26846,                      /* character number, location */
         16, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   16, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x53\x37\x31\x31\x31\x21\x32\x51\x11\x51\x11\x31"
            "\x61\x11\x51\x1f\xa1\x31\x71\x71\x05\x71\x71" }  },
      /* --- pixel bitmap for bbold250 char#110 n --- */
      { 110,27181,                      /* character number, location */
         16, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x45\x12\x41\x31\x32\x71\x2f\x11\x31\x91\x1f\x91"
            "\x31\xa1\x05\xa1" }  },
      /* --- pixel bitmap for bbold250 char#111 o --- */
      { 111,27480,                      /* character number, location */
         16, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 14,   17, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x82\x42\x51\x11\x61\x20\xf1\x11\x21\x71\x1f\x61"
            "\x31\x81\xf1\x11\x21\x71\x10\x21\x11\x61\x52\x42\x84"
            "\x51" }  },
      /* --- pixel bitmap for bbold250 char#112 p --- */
      { 112,27779,                      /* character number, location */
         16, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          { 19,   23, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x95\x55\x22\x52\x31\x31\x11\x91\x21\x32\xa1\x2f\x11"
            "\x31\xc1\x1f\x41\x31\xd1\x0f\x11\x31\xc1\x11\x32\xa1"
            "\x21\x31\x11\x91\x21\x31\x22\x52\x31\x31\x45\x5f\x41"
            "\x31\xe5\xe1" }  },
      /* --- pixel bitmap for bbold250 char#113 q --- */
      { 113,28114,                      /* character number, location */
         16, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 14,   23, 3,66, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x72\x51\x21\x21\x11\x63\x11\x21\x72\x11\x21\x81"
            "\x0f\x61\x31\x81\x11\x21\x81\x11\x21\x72\x21\x11\x63"
            "\x32\x51\x21\x55\x31\xf5\xd1" }  },
      /* --- pixel bitmap for bbold250 char#114 r --- */
      { 114,28431,                      /* character number, location */
         16, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x45\x12\x42\x21\x32\x81\x1f\x11\x31\xa1\x0f\x91"
            "\x31\xb5\xb1" }  },
      /* --- pixel bitmap for bbold250 char#115 s --- */
      { 115,28708,                      /* character number, location */
         16, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x40\x31\x12\x14\x81\x11\x18\x01\x16\x80\x0f\x00"
            "\x02\x40\x00\x08\x80\x01\x18\x80\x02\xc4\x30\xf0\x00" }  },
      /* --- pixel bitmap for bbold250 char#116 t --- */
      { 116,28979,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 12,   25, 3,41, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x7f\x71\x31\x71\x38\x0f\x91\x31\x70\xf1\x11\x21"
            "\x61\x21\x11\x51\x42\x32\x64\x41" }  },
      /* --- pixel bitmap for bbold250 char#117 u --- */
      { 117,29290,                      /* character number, location */
         15, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 14,   16, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x81\x0f\x91\x31\x81\xf1\x11\x21\x72\x21\x11\x61"
            "\x11\x32\x42\x21\x54\x52" }  },
      /* --- pixel bitmap for bbold250 char#118 v --- */
      { 118,29591,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x40\x08\x90\x08\x08\x04\x42\x04\x41\x42\x20\x22"
            "\x20\x09\x10\x05\x90\x01\x88\x00\x68\x00\x14\x00\x0c"
            "\x00\x02\x00" }  },
      /* --- pixel bitmap for bbold250 char#119 w --- */
      { 119,29868,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 21,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x00\x30\x02\x00\x8a\x00\x20\x11\x00\x24\x02\x80"
            "\x88\x00\x08\x11\x01\x21\x52\x10\x88\x0a\x02\x31\x42"
            "\x40\x42\x04\x48\x90\x00\x05\x14\xc0\x80\x01\x08\x20"
            "\x00" }  },
      /* --- pixel bitmap for bbold250 char#120 x --- */
      { 120,30179,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xbe\x40\x44\x10\x21\x22\x50\x04\x18\x01\x22\x40"
            "\x04\x10\x01\x62\x80\x28\x10\x11\x22\x88\x08\xf4\x01"
            "\x02" }  },
      /* --- pixel bitmap for bbold250 char#121 y --- */
      { 121,30464,                      /* character number, location */
         15, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 15,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x40\x08\x90\x08\x08\x04\x42\x04\x41\x42\x20\x22"
            "\x20\x09\x10\x05\x90\x01\x88\x00\x68\x00\x14\x00\x0c"
            "\x00\x02\x80\x00\x40\x00\x10\x00\x04\x00\x02\xc0\x00"
            "\x10\x00\x04\x00\x00" }  },
      /* --- pixel bitmap for bbold250 char#122 z --- */
      { 122,30757,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3f\x40\x04\x10\x01\x22\x40\x04\x10\x01\x22\x40"
            "\x04\x10\x01\x22\x80\x08\x10\x01\x22\x80\x08\xf0\xff"
            "\x03" }  },
      /* --- pixel bitmap for bbold250 char#123 \- --- */
      { 123,39714,                      /* character number, location */
         10, 0,    9, 0,      /* topleft row,col, and botleft row,col */
          { 13,    1, 3, 2, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d" }  },
      /* --- pixel bitmap for bbold250 char#124 | --- */
      { 124,39369,                      /* character number, location */
         26, 3,   -9, 3,      /* topleft row,col, and botleft row,col */
          {  5,   35, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x05\x00\xff\x20\x01\x03\x01\x00\x05" }  },
      /* --- pixel bitmap for bbold250 char#125 (noname) --- */
      { 125,39926,                      /* character number, location */
         10, 0,    9, 0,      /* topleft row,col, and botleft row,col */
          { 27,    1, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0d" }  },
      /* --- pixel bitmap for bbold250 char#126 (noname) --- */
      { 126,40144,                      /* character number, location */
         24, 0,   10, 0,      /* topleft row,col, and botleft row,col */
          { 17,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x80\x20\x80\x20\x80\x20\x80\x40\x00\x41\x00\x81"
            "\x00\x82\x0e\x3a\x23\x8c\x82\x08\x06\x11\x0c\x22\x28"
            "\x82\x88\x03\x0e" }  },
      /* --- pixel bitmap for bbold250 char#127 \omega --- */
      { 127,11013,                      /* character number, location */
         15, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 21,   16, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\xb1\x72\xc1\x51\x11\xd1\x20\xf1\x11\x21\xe1\x11"
            "\x31\xe0\x11\x0f\x41\x31\x51\x91\xf1\x11\x21\x41\x11"
            "\x71\x10\x21\x11\x31\x31\x51\x43\x22\x32\x32\x63\x73"
            "\x41" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* ------------------------------------------------------------------------
font sizes 0-7 for rsfs10
------------------------------------------------------------------------ */

/* --- size=0 for .83gf ---
 * mf '\mode=eighthre;  input rsfs10'
 * --------------------------------------------------------------------- */
/* --- fontdef for rsfs83 --- */
static	chardef  rsfs83[] =
   {
      /* --- pixel bitmap for rsfs83 char#65 A --- */
      {  65,   35,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x03\x06\x0c\x1b\x52\xe8\x70\xc5\x0e" }  },
      /* --- pixel bitmap for rsfs83 char#66 B --- */
      {  66,   72,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xc3\x8c\x2a\x69\xdc\x81\x07\x8b\x1b" }  },
      /* --- pixel bitmap for rsfs83 char#67 C --- */
      {  67,  113,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe4\x92\x69\x1e\x12\x1e\x16\x0e" }  },
      /* --- pixel bitmap for rsfs83 char#68 D --- */
      {  68,  150,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x48\x4b\x96\xea\x0a\x12\x12\x1f" }  },
      /* --- pixel bitmap for rsfs83 char#69 E --- */
      {  69,  195,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\xce\x33\xc6\x92\x1c" }  },
      /* --- pixel bitmap for rsfs83 char#70 F --- */
      {  70,  222,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x61\xa1\xc1\x06\x0f\x4b\x86\x03" }  },
      /* --- pixel bitmap for rsfs83 char#71 G --- */
      {  71,  255,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc8\xa4\x52\x7a\x2e\x38\x10\x0e" }  },
      /* --- pixel bitmap for rsfs83 char#72 H --- */
      {  72,  292,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x1a\xb6\x82\x6b\xf0\x83\x0b\x20\x01\x96\x30\x0c" }  },
      /* --- pixel bitmap for rsfs83 char#73 I --- */
      {  73,  337,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x83\x03\x0d\x2c\x70\xc0\x80\x80\x01" }  },
      /* --- pixel bitmap for rsfs83 char#74 J --- */
      {  74,  364,                      /* character number, location */
          8, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x1c\xd0\x40\x05\x16\x60\x80\x02\x0e\x0e\x28"
            "\xc0\x00\x00" }  },
      /* --- pixel bitmap for rsfs83 char#75 K --- */
      {  75,  405,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x19\x96\x80\x0b\xa0\x00\x0e\xa0\x00\x52\x30\x06" }  },
      /* --- pixel bitmap for rsfs83 char#76 L --- */
      {  76,  446,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x06\x91\x90\x04\x3f\x40\x00\x02\x10\xf1\x0f" }  },
      /* --- pixel bitmap for rsfs83 char#77 M --- */
      {  77,  481,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x05\x3c\xf0\xe0\x85\x1a\xac\xb0\x62\x13" }  },
      /* --- pixel bitmap for rsfs83 char#78 N --- */
      {  78,  524,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x11\x10\x01\x12\x60\x01\x2a\x20\x03\x22\x30\x04" }  },
      /* --- pixel bitmap for rsfs83 char#79 O --- */
      {  79,  565,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\xce\x5b\x4a\x52\x0c" }  },
      /* --- pixel bitmap for rsfs83 char#80 P --- */
      {  80,  596,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x87\x19\xaa\xe8\xc2\x0e\x10\x40\xc0\x01" }  },
      /* --- pixel bitmap for rsfs83 char#81 Q --- */
      {  81,  633,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xa0\x21\x25\x85\x05\xc4\x95\x1f" }  },
      /* --- pixel bitmap for rsfs83 char#82 R --- */
      {  82,  672,                      /* character number, location */
          8,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xc3\x8c\x2a\x75\xcc\x80\x02\x8d\x13" }  },
      /* --- pixel bitmap for rsfs83 char#83 S --- */
      {  83,  715,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x06\x29\xa4\xe0\x03\x02\x08\x60\xc0\x00" }  },
      /* --- pixel bitmap for rsfs83 char#84 T --- */
      {  84,  748,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x60\xa2\xc2\x02\x02\x04\x04\x07" }  },
      /* --- pixel bitmap for rsfs83 char#85 U --- */
      {  85,  779,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\xb0\xa8\x52\x25\x4b\x20\x41\x06\x0f" }  },
      /* --- pixel bitmap for rsfs83 char#86 V --- */
      {  86,  826,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x90\x4a\x2f\x14\x14\x0c\x02\x01" }  },
      /* --- pixel bitmap for rsfs83 char#87 W --- */
      {  87,  861,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x50\x57\xd9\xe2\x44\xc5\x85\x86\x02" }  },
      /* --- pixel bitmap for rsfs83 char#88 X --- */
      {  88,  910,                      /* character number, location */
          8, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 10,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x63\x43\x07\x1f\x70\x40\xd0\xc5\x0c" }  },
      /* --- pixel bitmap for rsfs83 char#89 Y --- */
      {  89,  945,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x59\xaa\xaa\x32\x03\x86\x04\x07" }  },
      /* --- pixel bitmap for rsfs83 char#90 Z --- */
      {  90,  990,                      /* character number, location */
          8, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 11,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x86\x3f\x26\xd0\x01\x0e\x10\x40\xe1\x07" }  },
      /* --- pixel bitmap for rsfs83 char#127 (noname) --- */
      { 127, 1021,                      /* character number, location */
          6, 4,    4, 4,      /* topleft row,col, and botleft row,col */
          {  3,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=1 for .100gf ---
 * mf '\mode=preview; mag=magstep(-17.87427405946994351363); input rsfs10'
 * --------------------------------------------------------------------- */
/* --- fontdef for rsfs100 --- */
static	chardef  rsfs100[] =
   {
      /* --- pixel bitmap for rsfs100 char#65 A --- */
      {  65, 1279,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x10\x80\x01\x28\x80\xc2\x2b\x88\x04\x59\xa0\x06"
            "\x59\xe3\x1c\x00" }  },
      /* --- pixel bitmap for rsfs100 char#66 B --- */
      {  66, 2926,                      /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 14,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x3f\x18\x06\x89\x42\x52\x48\x1e\xce\x03\x90\x00"
            "\x2e\xe2\x84\xc7\x00" }  },
      /* --- pixel bitmap for rsfs100 char#67 C --- */
      {  67, 4039,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0b\x1a\x54\x38\x3e\x20\x80\x07\x15\x54\xf0\x00" }  },
      /* --- pixel bitmap for rsfs100 char#68 D --- */
      {  68, 5294,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x10\x24\x72\xa8\x51\x3e\x09\x12\x24\xcb\xfc\x00" }  },
      /* --- pixel bitmap for rsfs100 char#69 E --- */
      {  69, 5908,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xa0\x23\x45\xc6\x43\x40\x8e\x12\x15\x1c\x00" }  },
      /* --- pixel bitmap for rsfs100 char#70 F --- */
      {  70, 7190,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x03\xc7\x88\x82\x14\xb8\x00\x38\x70\x81\x04\x31"
            "\xf0\x00" }  },
      /* --- pixel bitmap for rsfs100 char#71 G --- */
      {  71, 8436,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x85\xc6\x8a\x92\xdb\x09\x1e\x10\x22\x3c\x00" }  },
      /* --- pixel bitmap for rsfs100 char#72 H --- */
      {  72, 9995,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x88\x81\xc9\x82\x5e\x04\x90\x06\xfe\x03\x92\x00"
            "\x92\x00\x20\x01\x32\x12\x1c\x1c\x00" }  },
      /* --- pixel bitmap for rsfs100 char#73 I --- */
      {  73,11242,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x18\xf0\x00\x09\x90\x02\x4a\x40\x05\x70\x00\x01"
            "\x12\xc0\x01\x00" }  },
      /* --- pixel bitmap for rsfs100 char#74 J --- */
      {  74,12649,                      /* character number, location */
         10, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 16,   14, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe2\xa4\xb1\x21\xb1\x21\x11\xa1\x11\x21\xa1\x11\x11"
            "\xc3\xd1\xe3\xb3\xa4\xa2\x21\xa1\x31\xc3\xc2" }  },
      /* --- pixel bitmap for rsfs100 char#75 K --- */
      {  75,14288,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x88\x81\x89\x80\x8e\x00\x90\x00\xd0\x00\x70\x00"
            "\x50\x00\x90\x00\x32\x09\x1c\x0e\x00" }  },
      /* --- pixel bitmap for rsfs100 char#76 L --- */
      {  76,15525,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x38\x08\x09\x41\x42\x48\xf0\x0f\x20\x00\x08\x00"
            "\x01\x3e\xc6\x7f\x00" }  },
      /* --- pixel bitmap for rsfs100 char#77 M --- */
      {  77,17030,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x90\x00\x4c\x00\x26\x00\x33\xc0\x19\xa0\x0c\x60"
            "\x06\x50\x05\xa9\x12\x47\x0e" }  },
      /* --- pixel bitmap for rsfs100 char#78 N --- */
      {  78,18154,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x01\x08\x01\x18\x01\x30\x02\x50\x02\x90\x02"
            "\x10\x03\x20\x06\x32\x04\x1c\x04\x00" }  },
      /* --- pixel bitmap for rsfs100 char#79 O --- */
      {  79,19286,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x41\x88\x17\x33\x46\x14\x31\xc2\x08\x11\x38\x00" }  },
      /* --- pixel bitmap for rsfs100 char#80 P --- */
      {  80,20796,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x2f\x58\x04\x91\x41\x52\x48\x13\xce\x03\x08\x00"
            "\x02\x62\x80\x07\x00" }  },
      /* --- pixel bitmap for rsfs100 char#81 Q --- */
      {  81,22059,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x03\x56\x10\x09\x51\x88\x04\x27\x00\x01\x08\x7f"
            "\xf2\x1f" }  },
      /* --- pixel bitmap for rsfs100 char#82 R --- */
      {  82,23640,                      /* character number, location */
         10,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x1f\x0c\x43\x52\x48\x89\xe4\x60\x06\xa0\x00\x14"
            "\x62\xc5\x63\x00" }  },
      /* --- pixel bitmap for rsfs100 char#83 S --- */
      {  83,24807,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 15,   10, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc3\x64\x11\x21\x51\x41\x21\x61\x31\x21\x86\xb1\xd1"
            "\xd1\x91\x31\xa4\xa1" }  },
      /* --- pixel bitmap for rsfs100 char#84 T --- */
      {  84,26033,                      /* character number, location */
         10, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x07\x1c\x43\x12\x48\x02\x27\x00\x02\x40\x00\x04"
            "\x42\xc0\x07\x00" }  },
      /* --- pixel bitmap for rsfs100 char#85 U --- */
      {  85,27332,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x80\x13\x4a\x22\x49\x92\x24\x4e\x02\x44\x80\x04"
            "\x48\x01\x1f\x00" }  },
      /* --- pixel bitmap for rsfs100 char#86 V --- */
      {  86,28423,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x34\x51\x4d\x3a\x01\x09\x28\xa0\x00\x03\x04\x10"
            "\x00" }  },
      /* --- pixel bitmap for rsfs100 char#87 W --- */
      {  87,29756,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\xd9\xb2\x74\x13\x34\x81\x25\x68\x02\x2b\xb0\x03"
            "\x12\x20\x01\x00" }  },
      /* --- pixel bitmap for rsfs100 char#88 X --- */
      {  88,31157,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x70\xa8\x04\x52\x01\x69\x80\x1f\x00\x0e\x00\x03"
            "\xc0\x08\x51\x82\xc7\x00" }  },
      /* --- pixel bitmap for rsfs100 char#89 Y --- */
      {  89,32544,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x90\x13\x49\x12\x49\x92\x24\x4c\x02\x30\x00\x04"
            "\x62\xc0\x03\x00" }  },
      /* --- pixel bitmap for rsfs100 char#90 Z --- */
      {  90,34185,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x8c\xa8\x94\x47\x11\xcc\x01\x1c\x20\x00\x01\x8f"
            "\x70\x07" }  },
      /* --- pixel bitmap for rsfs100 char#127 (noname) --- */
      { 127,34731,                      /* character number, location */
          7, 6,    5, 6,      /* topleft row,col, and botleft row,col */
          {  6,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x08" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=2 for .118gf ---
 * mf '\mode=preview; mag=magstep(-16.96645799324018499600); input rsfs10'
 * --------------------------------------------------------------------- */
/* --- fontdef for rsfs118 --- */
static	chardef  rsfs118[] =
   {
      /* --- pixel bitmap for rsfs118 char#65 A --- */
      {  65, 1279,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x40\x00\x38\x00\x0a\x80\x82\xa7\x20\x4c\x10\x15"
            "\x88\x06\x24\x8b\xfc\xc2\xe1\x00" }  },
      /* --- pixel bitmap for rsfs118 char#66 B --- */
      {  66, 2934,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x3f\x0c\x86\x88\x12\x91\x44\x12\xc9\xc3\xb1\x00"
            "\x2e\xc0\x48\x1c\xf1\x38\x00" }  },
      /* --- pixel bitmap for rsfs118 char#67 C --- */
      {  67, 4057,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x4e\x20\x06\xa2\x20\xe3\x1f\x20\x00\x72\x40\x09"
            "\x28\x01\x25\xe0\x03" }  },
      /* --- pixel bitmap for rsfs118 char#68 D --- */
      {  68, 5322,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x03\x81\x10\x61\x21\x17\xa4\x62\x92\x23\x02\x22"
            "\x20\xc2\x22\xf8\x03" }  },
      /* --- pixel bitmap for rsfs118 char#69 E --- */
      {  69, 5916,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x03\x39\x24\x21\x07\x07\x36\x88\x41\x12\x89\x50"
            "\x02\x0f\x00" }  },
      /* --- pixel bitmap for rsfs118 char#70 F --- */
      {  70, 7232,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x0f\xb0\x38\x44\x02\xa1\x80\x2f\x00\xd0\x00\x3f"
            "\x40\x0a\x80\x80\x30\x80\x07\x00" }  },
      /* --- pixel bitmap for rsfs118 char#71 G --- */
      {  71, 8510,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 12,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x46\x98\x42\x14\x22\xa1\x15\x25\x3e\x01\x1f\x80"
            "\x20\x08\x7e\x00" }  },
      /* --- pixel bitmap for rsfs118 char#72 H --- */
      {  72,10131,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x10\x03\x46\x26\xa8\x09\x01\x47\x04\xf0\x1f\xf0"
            "\x04\x40\x12\x00\x88\x00\x20\x22\x88\x90\xc1\x03\x03"
            "\x00" }  },
      /* --- pixel bitmap for rsfs118 char#73 I --- */
      {  73,11358,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x30\xc0\x03\x4c\x00\x29\x20\x09\x48\x01\x6e\x00"
            "\x07\x40\x40\x0c\xf0\x00\x00" }  },
      /* --- pixel bitmap for rsfs118 char#74 J --- */
      {  74,12743,                      /* character number, location */
         11, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 17,   16, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x12\xb4\xb2\x21\xc1\x21\x11\x20\xf1\x81\x21\x21"
            "\x20\x83\x12\xc3\xe1\xe0\x11\x12\xc3\xa4\xb2\x21\xb1"
            "\x31\xc1\x21\xe2\xe2" }  },
      /* --- pixel bitmap for rsfs118 char#75 K --- */
      {  75,14366,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x10\x06\x46\x08\x28\x23\x20\x8f\x00\x20\x03\x80"
            "\x07\x00\x1a\x00\x50\x00\x40\x22\x88\x91\xc1\x03\x03"
            "\x00" }  },
      /* --- pixel bitmap for rsfs118 char#76 L --- */
      {  76,15613,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\xe3\xc0\x20\x82\x20\x82\x40\x02\x43\x03\xf8\x01"
            "\x40\x00\x80\x00\x80\x10\xfc\x30\xfc\x1f\x00" }  },
      /* --- pixel bitmap for rsfs118 char#77 M --- */
      {  77,17178,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x20\x02\x40\x04\x80\x18\x80\x31\x00\x63\x00\x4a"
            "\x01\x94\x02\x28\x05\x50\x12\x24\x25\x71\x88\x03" }  },
      /* --- pixel bitmap for rsfs118 char#78 N --- */
      {  78,18368,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   11, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\x52\xb1\x41\xc1\x41\xc2\x31\xd1\x11\x21\xc1\x21"
            "\x11\xc1\x32\xc1\x42\xb1\x51\x71\x31\x51\x84\x61\x81" }  },
      /* --- pixel bitmap for rsfs118 char#79 O --- */
      {  79,19504,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x83\x21\x7a\xa9\xc7\x10\x85\x14\xa2\x08\x43\x88"
            "\x81\x03\x00" }  },
      /* --- pixel bitmap for rsfs118 char#80 P --- */
      {  80,21000,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x4f\x58\x18\x22\x96\x90\x48\x58\x24\x1b\x71\x7c"
            "\x00\x01\x40\x80\x10\xc0\x07\x00" }  },
      /* --- pixel bitmap for rsfs118 char#81 Q --- */
      {  81,22247,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x07\x2c\x41\x48\x04\x89\xb0\xe0\x11\x00\x01\x10"
            "\x80\xe1\x0f\xfd\x1f" }  },
      /* --- pixel bitmap for rsfs118 char#82 R --- */
      {  82,23830,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x2f\x0c\x84\x88\x12\x51\x44\x0a\xc9\xc1\x51\x00"
            "\x0a\x40\x42\x4c\xf2\x60\x00" }  },
      /* --- pixel bitmap for rsfs118 char#83 S --- */
      {  83,25035,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x60\xe0\x2d\x08\x11\x82\x04\xa2\x01\x3e\x00\x02"
            "\x00\x01\x40\x80\x18\xc0\x03\x00" }  },
      /* --- pixel bitmap for rsfs118 char#84 T --- */
      {  84,26267,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x2c\x8e\x88\x10\x12\x7c\x02\x80\x00\x10\x00"
            "\x04\x80\x40\x18\xf0\x01\x00" }  },
      /* --- pixel bitmap for rsfs118 char#85 U --- */
      {  85,27570,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x00\x56\xa0\x48\x28\x12\x92\x89\x30\x22\x80\x08"
            "\x20\x04\x10\x01\x44\x02\xfc\x00" }  },
      /* --- pixel bitmap for rsfs118 char#86 V --- */
      {  86,28641,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x21\x20\xe4\x85\xc4\x11\x40\x02\x48\x00\x0a\x80"
            "\x01\x30\x00\x04\x80\x00\x00" }  },
      /* --- pixel bitmap for rsfs118 char#87 W --- */
      {  87,29946,                      /* character number, location */
         11, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x88\x4c\x44\x6a\x26\x38\x23\xa0\x11\x50\x11\xb0"
            "\x08\x90\x06\xd8\x01\x48\x00\x24\x00" }  },
      /* --- pixel bitmap for rsfs118 char#88 X --- */
      {  88,31357,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x61\xa8\x08\x92\x03\xc5\x80\x3d\x00\x1e\x00\x02"
            "\x80\x01\x60\x88\x28\x82\xe3\x00" }  },
      /* --- pixel bitmap for rsfs118 char#89 Y --- */
      {  89,32746,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x20\x47\x24\x91\x44\x12\x91\x44\x12\x71\x22\x00"
            "\x07\x80\x81\x10\xc0\x03\x00" }  },
      /* --- pixel bitmap for rsfs118 char#90 Z --- */
      {  90,34369,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x30\x8c\x24\xc9\x8f\x44\xc0\x79\x00\x3c\x00\x02"
            "\x80\x00\x20\x80\x0f\xc1\x7d\x00" }  },
      /* --- pixel bitmap for rsfs118 char#127 (noname) --- */
      { 127,34943,                      /* character number, location */
          8, 6,    6, 6,      /* topleft row,col, and botleft row,col */
          {  9,    2, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x04\x02" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=3 for .131gf ---
 * mf '\mode=preview; mag=magstep(-16.39322518098640003469); input rsfs10'
 * --------------------------------------------------------------------- */
/* --- fontdef for rsfs131 --- */
static	chardef  rsfs131[] =
   {
      /* --- pixel bitmap for rsfs131 char#65 A --- */
      {  65, 1331,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x00\x01\x00\x03\x80\x03\x80\x02\x80\x04\xbe\x04"
            "\x86\x0c\x8c\x0d\x88\x0c\x90\x18\xe0\x58\x88\x7f\xe0"
            "\x30\x00" }  },
      /* --- pixel bitmap for rsfs131 char#66 B --- */
      {  66, 2962,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xbf\xc0\xc0\x20\xa1\x10\x91\x08\xd9\x88\x6d\xc4"
            "\x3e\x78\x6f\x00\x63\x80\x3f\xc1\x31\x61\x19\x1f\x0e" }  },
      /* --- pixel bitmap for rsfs131 char#67 C --- */
      {  67, 4101,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x98\x83\x39\x30\x0d\x66\xc3\x86\x7f\x00\x06\xc0"
            "\x06\x58\x03\xce\x80\x32\xa0\x06\xf8\x00" }  },
      /* --- pixel bitmap for rsfs131 char#68 D --- */
      {  68, 5376,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 14,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0e\xc3\x08\x1b\x72\x46\xd6\xd0\x34\x32\x79"
            "\x26\xc0\x08\x18\x01\x22\x5c\x04\xff\x00" }  },
      /* --- pixel bitmap for rsfs131 char#69 E --- */
      {  69, 5982,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x07\xee\x30\x09\x4b\x10\x03\x07\x6c\x60\x00\xf3"
            "\xb0\x0c\xc9\x30\x06\x1e\x00" }  },
      /* --- pixel bitmap for rsfs131 char#70 F --- */
      {  70, 7304,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   13, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\x93\x16\x61\x22\x23\x61\x32\x12\x71\x32\x12\x85"
            "\x12\xe0\x12\x12\xa6\x85\x11\x50\xf1\x72\x81\x42\xb5"
            "\xb2" }  },
      /* --- pixel bitmap for rsfs131 char#71 G --- */
      {  71, 8586,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\x1c\x41\x13\x34\xc3\x36\x6c\xc6\xdb\xb8\xf1\x39"
            "\xa0\x03\x38\x08\x06\x61\xe0\x07\x00" }  },
      /* --- pixel bitmap for rsfs131 char#72 H --- */
      {  72,10215,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x40\x1c\x60\x98\x09\x34\x33\x82\x76\x46\x00\xcf"
            "\x08\x80\xff\x01\x7c\x06\x80\xcc\x00\x90\x19\x00\x30"
            "\x06\x10\xcc\x08\xc4\x20\x01\x1f\x38\x00" }  },
      /* --- pixel bitmap for rsfs131 char#73 I --- */
      {  73,11486,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   13, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe2\xa5\x93\x12\x92\x23\x92\x12\x11\x82\x22\x11\x82"
            "\x12\x11\x94\x11\xb4\xc2\x71\x52\x81\x42\x95\xb2" }  },
      /* --- pixel bitmap for rsfs131 char#74 J --- */
      {  74,12827,                      /* character number, location */
         13, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 20,   18, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x42\xd6\xc3\x22\xc3\x22\xd2\x22\x11\x20\xf1\x92"
            "\x22\x11\x30\xa1\x12\x11\xe0\x14\xe0\x22\xe0\x32\x21"
            "\xe5\xd4\xc6\xc2\x41\xc1\x42\xd1\x32\xe0\x13\xe0\x21" }  },
      /* --- pixel bitmap for rsfs131 char#75 K --- */
      {  75,14484,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x40\x1c\x30\xcc\x00\xcd\x0c\xd0\xce\x00\xe0\x08"
            "\x00\xc8\x00\x80\x0f\x00\xf8\x00\x80\x0d\x00\x98\x01"
            "\x04\x1b\x81\x18\x12\xf0\xc1\x01\x00" }  },
      /* --- pixel bitmap for rsfs131 char#76 L --- */
      {  76,15767,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x07\x07\x0c\x24\x30\x10\xc1\xc0\x0c\x06\x33\x60"
            "\x6c\x00\xfe\x00\x80\x01\x00\x06\x00\x18\x00\x60\x10"
            "\xfc\x7f\xf0\xfb\x01" }  },
      /* --- pixel bitmap for rsfs131 char#77 M --- */
      {  77,17340,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x00\x11\x00\x10\x01\x80\x19\x00\x38\x03\xc0\x33"
            "\x00\x34\x07\x40\x73\x00\x64\x0d\x40\xd6\x00\x68\x0d"
            "\x80\x96\x81\xcc\x91\x70\x18\x0e\x00" }  },
      /* --- pixel bitmap for rsfs131 char#78 N --- */
      {  78,18540,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   13, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd1\x52\xc2\x42\xd1\x42\xd2\x41\xd1\x11\x31\xe1\x11"
            "\x21\xe1\x22\x11\xd1\x33\x60\xf1\x71\x42\x71\x51\x42"
            "\x81\x32\x51\x94\x71\x92" }  },
      /* --- pixel bitmap for rsfs131 char#79 O --- */
      {  79,19688,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x07\x86\xb0\x89\xa5\x2c\x67\x61\x0e\x73\x30\x87"
            "\x51\x0c\xc3\x30\x02\x1e\x00" }  },
      /* --- pixel bitmap for rsfs131 char#80 P --- */
      {  80,21194,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x3f\x81\x85\x81\x08\x87\x10\x8d\x70\x1b\x71\x1b"
            "\xb1\x13\x1c\x1f\x00\x06\x00\x06\x04\x06\x08\x03\xf0"
            "\x01\x00" }  },
      /* --- pixel bitmap for rsfs131 char#81 Q --- */
      {  81,22477,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x1f\xc0\x10\x10\x19\x8c\x0c\x63\x86\x99\x41\xc6"
            "\xc0\x31\x00\x0c\x1e\x83\x7f\x68\xfc\xe3\x7b\x00" }  },
      /* --- pixel bitmap for rsfs131 char#82 R --- */
      {  82,24076,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 17,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xbf\x81\x81\x81\x80\x82\x88\x84\x98\x0c\x99\x0d"
            "\x92\x07\x1c\x0b\x00\x1b\x00\x1b\x04\x33\x09\x33\xf1"
            "\xc1\x01" }  },
      /* --- pixel bitmap for rsfs131 char#83 S --- */
      {  83,25321,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   13, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x22\x84\x22\x11\x62\x52\x11\x62\x52\x21\x61\x62"
            "\x11\x81\x44\xa6\xe2\x70\xf1\x82\x81\x62\x91\x43\xa6"
            "\xc2" }  },
      /* --- pixel bitmap for rsfs131 char#84 T --- */
      {  84,26587,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   13, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x77\x83\x16\x51\x22\x32\x51\x32\x22\x51\x32\x22\x65"
            "\x22\xe2\xd2\xd2\xd2\x71\x62\x71\x42\x96\xa1" }  },
      /* --- pixel bitmap for rsfs131 char#85 U --- */
      {  85,27898,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x00\x18\xc1\x24\x63\x32\x61\x99\x31\xcd\x18\xc7"
            "\x18\x60\x0c\x30\x06\x18\x03\x18\x03\xc8\x05\xb8\x03" }  },
      /* --- pixel bitmap for rsfs131 char#86 V --- */
      {  86,29007,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x41\xc0\x10\x2f\x44\x1e\x01\x4f\x00\x13\x80\x09"
            "\xc0\x02\xa0\x00\x38\x00\x0c\x00\x03\x40\x00\x00" }  },
      /* --- pixel bitmap for rsfs131 char#87 W --- */
      {  87,30346,                      /* character number, location */
         13, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x11\x66\xcc\x98\x26\x23\xda\x99\x81\x67\x04\xb0"
            "\x13\x80\x9b\x00\x6e\x02\x30\x0b\x80\x3d\x00\x66\x00"
            "\x90\x01\x40\x04\x00" }  },
      /* --- pixel bitmap for rsfs131 char#88 X --- */
      {  88,31769,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x83\x07\x2b\x02\x64\x0b\x20\x3b\x00\xcd\x00\xb8"
            "\x07\x00\x3c\x00\x60\x00\x80\x01\x00\x0e\x00\x58\x08"
            "\x62\x22\xe0\xe0\x00" }  },
      /* --- pixel bitmap for rsfs131 char#89 Y --- */
      {  89,33170,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 17,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x03\xe1\x8c\x21\x99\x21\x33\x23\x36\x43\x36\x83"
            "\x66\x06\x67\x06\x80\x07\x00\x06\x00\x06\x10\x06\xc0"
            "\x03\x00" }  },
      /* --- pixel bitmap for rsfs131 char#90 Z --- */
      {  90,34829,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\xc3\x41\x6c\x42\x59\x42\xf6\x43\xc6\x00\xe7\x03"
            "\xc0\x07\x80\x01\x80\x01\x80\x01\x80\x21\xf8\x3f\xf0"
            "\x3e\x00" }  },
      /* --- pixel bitmap for rsfs131 char#127 (noname) --- */
      { 127,35415,                      /* character number, location */
          9, 7,    6, 7,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x82\x81" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=4 for .160gf ---
 * mf '\mode=preview; mag=magstep(-15.29639112828755784636); input rsfs10'
 * --------------------------------------------------------------------- */
/* --- fontdef for rsfs160 --- */
static	chardef  rsfs160[] =
   {
      /* --- pixel bitmap for rsfs160 char#65 A --- */
      {  65, 1331,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 21,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x00\x10\x00\x80\x01\x00\x38\x00\xc0\x02\x00\x24"
            "\x80\x43\x06\x98\x45\x80\x41\x04\x18\xd4\x00\x43\x0a"
            "\x60\xc4\x01\x48\x18\x00\x86\x09\x42\xff\x80\x07\x03"
            "\x00" }  },
      /* --- pixel bitmap for rsfs160 char#66 B --- */
      {  66, 2982,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xfe\x05\x18\x30\x60\x00\x05\x41\xc8\x08\x46\x84"
            "\x60\x66\x04\x33\x43\x98\x1f\xf8\x7c\x03\xc0\x30\x00"
            "\x76\x03\xb0\x18\x81\x85\x10\x4e\x06\x3e\x38\x00" }  },
      /* --- pixel bitmap for rsfs160 char#67 C --- */
      {  67, 4139,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x30\xe0\x71\xc0\x68\xc0\xe0\x80\x41\x03\xc3\x0c\xc6"
            "\xe0\xff\x00\x18\x00\x60\x00\xc0\x7c\x00\x8b\x01\x24"
            "\x06\x98\x18\x40\x30\x00\x3e\x00" }  },
      /* --- pixel bitmap for rsfs160 char#68 D --- */
      {  68, 5422,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 16,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\x70\x30\x18\x40\x0c\xe1\x06\x71\x02\x59\x83"
            "\x4c\x43\x46\x3e\x46\x00\x23\x80\x21\xc0\x10\x40\x08"
            "\x3f\x06\xff\x01" }  },
      /* --- pixel bitmap for rsfs160 char#69 E --- */
      {  69, 6034,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x3e\x80\x31\x60\x16\x98\x08\x4c\x02\xc2\x80\x07"
            "\x30\x03\x0c\x00\xe3\xc1\x88\x61\xc2\x30\x31\x30\x0c"
            "\xf0\x03\x00" }  },
      /* --- pixel bitmap for rsfs160 char#70 F --- */
      {  70, 7394,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 21,   15, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa8\xbd\x72\x31\x35\x61\x42\x22\xa1\x42\x12\xa1\x42"
            "\x12\xc5\x22\x21\xe0\x12\x22\xe0\x15\xb6\x12\xb1\x32"
            "\xe0\x51\xb1\x62\xb1\x62\xd6\xe1" }  },
      /* --- pixel bitmap for rsfs160 char#71 G --- */
      {  71, 8688,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 16,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\xf0\x18\xd8\x0c\xc4\x06\x63\x02\x31\x83\x19\xc3"
            "\x6e\xc2\x33\xfc\x38\x40\x1c\x80\x0f\x00\x0c\x04\x0c"
            "\x04\x06\xf8\x03" }  },
      /* --- pixel bitmap for rsfs160 char#72 H --- */
      {  72,10301,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 27,   15, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x41\x43\xe0\x41\x32\x31\x84\x41\x32\x41\x71\x22"
            "\x22\x32\x41\xa6\x32\x42\xe2\x22\x32\xeb\xd5\x32\xe0"
            "\x12\x22\x32\xe0\x11\x42\x22\xe0\x62\x32\xe0\x52\x41"
            "\xc1\x62\x42\x41\x71\x52\x61\x31\x95\x93\x90" }  },
      /* --- pixel bitmap for rsfs160 char#73 I --- */
      {  73,11578,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   15, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x42\xd6\xc3\x13\xc2\x22\xd2\x33\xb2\x32\x11\xb2"
            "\x22\x21\xb1\x32\x21\xb2\x12\x12\xd5\xe0\x22\xe0\x32"
            "\x91\x72\xa1\x52\xd5\xe2" }  },
      /* --- pixel bitmap for rsfs160 char#74 J --- */
      {  74,12979,                      /* character number, location */
         15, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 23,   21, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x72\xe0\x26\xe0\x13\x12\xe0\x22\x22\xe0\x22\x22"
            "\x11\xe2\x32\x11\xe2\x22\x21\xe1\x22\x21\xe0\x12\x12"
            "\x11\xe0\x35\x60\xf1\xc2\x90\xb2\x22\xe0\x22\x12\xe0"
            "\x34\xe0\x15\xe0\x22\x31\xe0\x12\x41\xe0\x21\x41\xe0"
            "\x21\x32\xe0\x43\xe0\x50" }  },
      /* --- pixel bitmap for rsfs160 char#75 K --- */
      {  75,14624,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 26,   15, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x41\x43\xe0\x31\x42\xa4\x41\x41\xb1\x22\x22\x42"
            "\xa1\x35\x42\xe0\x42\x32\xe0\x42\x31\xe0\x56\xe0\x52"
            "\x13\xe0\x62\x12\xe0\x62\x22\xe0\x52\x22\xc1\x62\x32"
            "\x41\x71\x52\x51\x31\x95\x74\x92" }  },
      /* --- pixel bitmap for rsfs160 char#76 L --- */
      {  76,15915,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   15, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\x53\x93\x72\x21\x72\x82\x31\x72\x72\x32\x62\x72"
            "\x32\x72\x62\x32\x92\x42\x13\xc9\xe0\x42\x90\xf1\xb2"
            "\xa0\xa2\xe0\x62\x61\x6e\x02\x67\x26\x82" }  },
      /* --- pixel bitmap for rsfs160 char#77 M --- */
      {  77,17496,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 25,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x00\x08\x01\x00\x18\x03\x00\x18\x03\x00\x1c\x03"
            "\x00\x1c\x03\x00\x36\x07\x00\x32\x07\x00\x32\x0d\x00"
            "\x32\x0d\x00\x32\x19\x00\x34\x19\x00\x64\x19\x00\x64"
            "\x32\x22\xc6\x22\x82\x83\xc3\x03" }  },
      /* --- pixel bitmap for rsfs160 char#78 N --- */
      {  78,18742,                      /* character number, location */
         16, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 26,   16, 3,95, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xb1\xe0\x21\x63\xe0\x11\x62\xe0\x31\x51\xe0\x42"
            "\x41\x50\xf1\xd3\x31\x60\xc1\x12\x21\xe0\x41\x22\x11"
            "\xe0\x41\x32\x11\xe0\x41\x33\xe0\x41\x42\xe0\x41\x52"
            "\xa1\x61\x61\xb1\x42\x71\xc4\x81\xc1" }  },
      /* --- pixel bitmap for rsfs160 char#79 O --- */
      {  79,19900,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x3e\xc0\x20\x30\x10\xe4\x09\x6b\xc3\xc2\xb0\x60"
            "\x2c\x30\x16\x0c\x05\xc6\x82\x61\x61\x70\x10\x30\x06"
            "\xf0\x00\x00" }  },
      /* --- pixel bitmap for rsfs160 char#80 P --- */
      {  80,21422,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 21,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xfe\x19\x30\xe0\x81\x21\x38\x08\x86\x8c\xc0\x98"
            "\x11\xac\x31\x81\x1a\x23\xcc\x31\xf8\xf8\x03\x00\x03"
            "\x00\x30\x00\x00\x03\x10\x30\x00\x82\x01\x80\x0f\x00"
            "\x00" }  },
      /* --- pixel bitmap for rsfs160 char#81 Q --- */
      {  81,22717,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 18,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x7c\x00\x0e\x06\x8c\x10\x18\xc4\x30\x18\xc3\x60"
            "\x06\xc3\x18\x8c\x31\xe0\xc1\x00\x80\x01\x00\x03\x0f"
            "\x03\xfe\x87\x0d\xff\xe3\xe3\x03" }  },
      /* --- pixel bitmap for rsfs160 char#82 R --- */
      {  82,24350,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 20,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xfe\x0d\x18\x30\x60\x00\x07\x41\xc8\x08\x42\x86"
            "\x30\x62\x88\xb1\x83\x8c\x0f\x70\xd8\x00\xc0\x0c\x00"
            "\x66\x00\x30\x03\x81\x31\x12\x8c\x19\x3e\x70\x00" }  },
      /* --- pixel bitmap for rsfs160 char#83 S --- */
      {  83,25605,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 21,   15, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x52\xa4\x32\x11\x82\x62\x21\x71\x72\x21\x72\x62"
            "\x21\x81\x72\x11\xa1\x54\xc7\xe0\x32\x80\xf1\xa2\x90"
            "\x92\xa1\x72\xb1\x52\xe5\xe0\x12" }  },
      /* --- pixel bitmap for rsfs160 char#84 T --- */
      {  84,26879,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   15, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x9d\x52\x31\x44\x41\x42\x41\x71\x42\x32\x61\x42"
            "\x32\x85\x32\xe0\x32\xe0\x22\x60\xf1\xa2\x70\x92\x81"
            "\x72\x91\x53\xb6\xc2" }  },
      /* --- pixel bitmap for rsfs160 char#85 U --- */
      {  85,28222,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 20,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x07\x00\x86\x80\x98\x18\x4c\x88\x61\xc2\x0c\x23"
            "\xcc\x18\x61\xc6\x10\x33\x0c\x0e\x63\x00\x18\x03\xc0"
            "\x18\x00\xc6\x00\x60\x8c\x00\x76\x06\xc0\x1c\x00" }  },
      /* --- pixel bitmap for rsfs160 char#86 V --- */
      {  86,29375,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x02\x10\x8c\x27\x88\xd9\x10\xb1\x23\x80\x47"
            "\x00\x18\x01\x60\x02\x80\x04\x00\x0b\x00\x1c\x00\x30"
            "\x00\x60\x00\xc0\x00\x00\x01\x00" }  },
      /* --- pixel bitmap for rsfs160 char#87 W --- */
      {  87,30700,                      /* character number, location */
         15, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x41\x00\x42\x18\x8f\x30\x46\x66\x0c\x81\x1f"
            "\x47\x00\xcc\x21\x00\xd6\x08\x80\x35\x02\xc0\x99\x00"
            "\xa0\x26\x00\x38\x0b\x00\x8c\x03\x00\x63\x00\x80\x10"
            "\x00\x20\x04\x00\x00" }  },
      /* --- pixel bitmap for rsfs160 char#88 X --- */
      {  88,32137,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x0f\x3c\x30\x84\x00\x22\x13\x40\xcc\x02\x90\x71"
            "\x00\x64\x0e\x00\xee\x07\x00\xf8\x01\x00\x0c\x00\x80"
            "\x01\x00\x70\x00\x00\x0e\x04\xc2\x02\x41\x18\x31\xe0"
            "\x81\x03\x00" }  },
      /* --- pixel bitmap for rsfs160 char#89 Y --- */
      {  89,33576,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 19,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x84\x61\x18\x13\x63\x84\x98\x11\x66\x8c\x30"
            "\x33\xc4\x8c\x21\x33\x06\x8f\x31\x00\xc4\x00\xc0\x03"
            "\x00\x0c\x20\x30\x80\xe0\x00\xf8\x01\x00" }  },
      /* --- pixel bitmap for rsfs160 char#90 Z --- */
      {  90,35223,                      /* character number, location */
         15, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 20,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x0f\x0e\xc6\x90\x10\x8d\x88\xd0\x64\x88\xf9\x81"
            "\x18\x03\x78\xfc\x00\xc0\x0f\x00\x0c\x00\x60\x00\x00"
            "\x03\x00\x18\x00\xc0\x40\xf0\xff\x03\xdf\x0f\x00" }  },
      /* --- pixel bitmap for rsfs160 char#127 (noname) --- */
      { 127,35821,                      /* character number, location */
         11, 9,    8, 9,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x86\x81" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=5 for .180gf ---
 * mf '\mode=preview; mag=magstep(-14.65037297372839890542); input rsfs10'
 * --------------------------------------------------------------------- */
/* --- fontdef for rsfs180 --- */
static	chardef  rsfs180[] =
   {
      /* --- pixel bitmap for rsfs180 char#65 A --- */
      {  65, 1331,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 24,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x00\x80\x00\x00\x60\x00\x00\x30\x00\x00\x2c\x00"
            "\x00\x12\x00\x00\x19\xc0\x8f\x0c\x60\x30\x04\x20\x30"
            "\x06\x30\x28\x03\x30\x24\x01\x30\xa4\x01\x30\xe2\x00"
            "\x60\x61\x00\xc6\x61\x03\x61\xff\x00\x1e\x18\x00" }  },
      /* --- pixel bitmap for rsfs180 char#66 B --- */
      {  66, 3020,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xf0\x67\x00\x07\x0c\x60\x00\x0a\x08\x82\x0d\x02"
            "\x61\x86\xc0\x18\x43\x20\xc6\x10\x98\x31\x08\xc6\x0f"
            "\xc8\xf1\x0d\x38\x0c\x06\x00\x26\x03\x80\x8d\x11\x60"
            "\x61\x0c\x58\x18\x02\x23\x06\x7e\xe0\x00" }  },
      /* --- pixel bitmap for rsfs180 char#67 C --- */
      {  67, 4197,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 19,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x80\xc7\x01\xa7\x03\x0c\x0d\x10\x38\x40\xb0\x01"
            "\x41\x08\xcc\x81\xff\x01\xc0\x00\x00\x03\x00\x18\x0f"
            "\x60\x44\x00\x13\x02\x58\x18\xc0\x64\x00\x86\x01\xe0"
            "\x07\x00" }  },
      /* --- pixel bitmap for rsfs180 char#68 D --- */
      {  68, 5492,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x3f\x00\x07\x06\x0e\x40\x18\x08\x6e\x40\x38\x03"
            "\x21\x0d\x88\x69\x20\x46\x83\x18\x31\x63\x08\x07\x43"
            "\x00\x0c\x01\x30\x04\xc0\x20\x00\xc3\xe0\x0f\x01\xff"
            "\x07\x00" }  },
      /* --- pixel bitmap for rsfs180 char#69 E --- */
      {  69, 6146,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 16,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x7c\x00\xc7\x80\xb1\x80\x89\xc0\x44\x40\x38\x40"
            "\x00\xe0\x03\x98\x03\x0c\x00\xc6\x03\x23\x06\x23\x04"
            "\x11\x06\x11\x03\x82\x01\x7c\x00" }  },
      /* --- pixel bitmap for rsfs180 char#70 F --- */
      {  70, 7488,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   17, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa8\xce\x71\x41\x44\x71\x42\x32\x91\x52\x22\x91\x62"
            "\x12\xa1\x52\x12\xc6\x22\x22\xe0\x12\x21\x11\xe0\x12"
            "\x13\xc8\xc2\x22\x21\xe0\x32\xb1\x72\xb2\x62\xc1\x52"
            "\xe0\x15\xe0\x27" }  },
      /* --- pixel bitmap for rsfs180 char#71 G --- */
      {  71, 8796,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 18,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\xc0\xc3\xc0\x88\x81\x31\x03\x63\x06\x86\x0d\x0c"
            "\x31\x18\xc3\x60\x26\xc6\x47\xf0\x83\x01\x8c\x07\xe0"
            "\x0d\x00\x30\x20\x60\xc0\x80\x01\x01\x03\xf8\x07\x00" }  },
      /* --- pixel bitmap for rsfs180 char#72 H --- */
      {  72,10421,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 31,   17, 3,125, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x61\x63\xe0\x62\x42\x31\x94\x52\x42\x41\x81\x32"
            "\x32\x41\x61\x71\x32\x23\x42\x51\xc4\x11\x42\x51\xe0"
            "\x32\x32\x33\xe0\x1d\xe0\x13\x12\x42\xe0\x32\x32\x42"
            "\xe0\x31\x51\x42\xe0\x92\x42\xe0\x82\x42\xe1\x72\x52"
            "\xd2\x62\x61\x51\x81\x62\x72\x22\xa6\xa3\xb0" }  },
      /* --- pixel bitmap for rsfs180 char#73 I --- */
      {  73,11718,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 22,   17, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x62\xe0\x25\xe4\x12\xd3\x32\xd2\x42\xe2\x32\x11"
            "\xc2\x32\x21\xc2\x22\x31\xc2\x22\x21\xd2\x12\x21\xe0"
            "\x16\xe0\x33\xe0\x42\xb1\x72\xb2\x62\xc1\x53\xe6\xe0"
            "\x10" }  },
      /* --- pixel bitmap for rsfs180 char#74 J --- */
      {  74,13129,                      /* character number, location */
         17, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 26,   24, 3,139, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xa2\xe0\x56\xe0\x34\x12\xe0\x42\x32\xe0\x42\x32"
            "\xe0\x42\x32\x21\xe0\x12\x42\x21\xe0\x12\x32\x21\xe0"
            "\x22\x22\x31\xe0\x22\x22\x21\xe0\x47\xe0\x63\xe0\x92"
            "\xe0\x92\xe0\x92\x32\xe0\x42\x13\xe0\x54\xe0\x46\xe0"
            "\x33\x32\xe0\x22\x52\xe0\x31\x52\xe0\x31\x51\xe0\x51"
            "\x32\xe0\x74\xe0\x70" }  },
      /* --- pixel bitmap for rsfs180 char#75 K --- */
      {  75,14810,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 29,   17, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x61\x53\xe0\x51\x52\xb4\x51\x51\xc1\x22\x42\x42"
            "\xb1\x32\x23\x42\xe0\x35\x42\xe0\x62\x42\xe0\x71\x41"
            "\xe0\x86\xe0\x86\xb0\xf1\xb2\x22\xc0\xa2\x22\xe1\x72"
            "\x32\xd2\x62\x41\x51\x81\x53\x52\x22\xa6\x83\xb6" }  },
      /* --- pixel bitmap for rsfs180 char#76 L --- */
      {  76,16111,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 25,   17, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\x63\xa3\x72\x22\x82\x82\x32\x72\x91\x42\x62\x92"
            "\x32\x72\x82\x32\x82\x72\x32\xa2\x52\x13\xe8\xe0\x72"
            "\xe0\x82\xb0\xf1\xb2\xc0\xa2\xe0\x22\x33\x62\x72\x2d"
            "\x86\x36\x92" }  },
      /* --- pixel bitmap for rsfs180 char#77 M --- */
      {  77,17704,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 30,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x00\x40\x30\x00\x00\x08\x06\x00\x00\xc1\x00\x00"
            "\x70\x18\x00\x00\x0e\x03\x00\xe0\x61\x00\x00\x34\x1e"
            "\x00\x80\x46\x03\x00\x90\xc9\x00\x00\x32\x1a\x00\x40"
            "\x46\x03\x00\xc8\xc8\x00\x00\x31\x19\x00\x40\x26\x06"
            "\x20\x8c\xc4\x10\x8c\xa0\x30\x02\x1e\x18\x7c\x00" }  },
      /* --- pixel bitmap for rsfs180 char#78 N --- */
      {  78,18940,                      /* character number, location */
         18, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 30,   18, 3,113, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x11\xe0\x51\x82\xe0\x41\x72\xe0\x52\x62\xe0"
            "\x61\x71\xe0\x62\x61\xe0\x61\x11\x51\xe0\x71\x12\x31"
            "\xe0\x71\x22\x31\xe0\x61\x32\x21\x80\xf1\xc1\x42\x11"
            "\x90\xb1\x53\xe0\x61\x62\xc1\x71\x72\xb2\x61\x81\xc1"
            "\x52\x82\xd5\xa1\xd2" }  },
      /* --- pixel bitmap for rsfs180 char#79 O --- */
      {  79,20140,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xfc\x00\x06\x02\x06\x04\xe3\x08\x33\x12\x13\x1f"
            "\x13\x18\x16\x30\x26\x20\x2c\x60\x4c\xc0\x58\xc0\xb0"
            "\xc0\x60\xc1\xc0\xc0\x00\xc3\x00\x7c\x00\x00" }  },
      /* --- pixel bitmap for rsfs180 char#80 P --- */
      {  80,21674,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 24,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xf8\xc7\x00\x06\x38\x80\x21\x70\x40\x20\x48\x20"
            "\x30\xc4\x10\x10\xc6\x10\x58\x63\x08\xac\x61\x08\xd6"
            "\x30\x90\xe1\x1c\x60\xe0\x03\x00\x30\x00\x00\x18\x00"
            "\x02\x0c\x00\x03\x06\x00\x81\x01\x00\x7e\x00\x00" }  },
      /* --- pixel bitmap for rsfs180 char#81 Q --- */
      {  81,22989,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 21,   17, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb7\xc3\x52\xa2\x31\x42\x82\x51\x41\x72\x52\x42\x52"
            "\x62\x41\x10\xf1\x52\x52\x42\x10\x52\x32\x52\x85\x52"
            "\xe0\x42\xe0\x42\xe0\x42\x85\x52\x8b\x52\x22\x5a\x56"
            "\x36\x50" }  },
      /* --- pixel bitmap for rsfs180 char#82 R --- */
      {  82,24604,                      /* character number, location */
         17,-1,    0,-1,      /* topleft row,col, and botleft row,col */
          { 22,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xf8\x27\x80\x01\x06\x18\xc0\x03\x41\x98\x20\x08"
            "\x23\x04\x62\x0c\x41\x88\x21\x18\x3b\x08\xe3\x03\x62"
            "\x4c\x00\x07\x1b\x00\x60\x06\x00\xcc\x80\x80\x19\x30"
            "\x30\x86\x04\x87\x18\x7e\xc0\x01" }  },
      /* --- pixel bitmap for rsfs180 char#83 S --- */
      {  83,25877,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 24,   17, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x73\xc5\x32\x11\xa2\x71\x31\x82\x82\x31\x72\x82"
            "\x31\x81\x82\x31\x92\x62\x31\xb2\x52\x12\xd9\xe0\x52"
            "\x90\xf1\xc2\xa0\xb2\xc1\x82\xc2\x72\xd1\x62\xe0\x26"
            "\xe0\x32" }  },
      /* --- pixel bitmap for rsfs180 char#84 T --- */
      {  84,27163,                      /* character number, location */
         17, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 23,   17, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa9\xce\x01\x71\x41\x54\x71\x51\x51\x91\x52\x41\x91"
            "\x62\x32\x91\x52\x32\xb6\x32\xe0\x72\x70\xf1\xd2\x80"
            "\xc2\xe0\x62\xb1\x82\xb2\x72\xc1\x63\xe7\xe0\x10" }  },
      /* --- pixel bitmap for rsfs180 char#85 U --- */
      {  85,28516,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x1f\x00\x60\x18\x00\x4c\x08\x18\x21\x0c\x46\x10"
            "\x82\x11\x8c\x61\x08\x63\x18\x82\x31\x06\x71\x8c\x01"
            "\x0f\xc3\x00\x80\x31\x00\x60\x0c\x00\x18\x03\x00\xcc"
            "\x00\x00\x63\x08\x80\x3d\x03\xc0\x71\x00" }  },
      /* --- pixel bitmap for rsfs180 char#86 V --- */
      {  86,29653,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 20,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x10\x08\x80\xc0\x70\x0c\xc2\x64\x10\x62\x87\x10"
            "\x6e\x0c\x00\x43\x00\x30\x02\x00\x13\x00\x18\x01\x80"
            "\x09\x00\x78\x00\x80\x03\x00\x0c\x00\x40\x00\x00\x02"
            "\x00\x10\x00\x00" }  },
      /* --- pixel bitmap for rsfs180 char#87 W --- */
      {  87,31014,                      /* character number, location */
         17, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 25,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x10\x02\x01\x10\x06\xf3\x30\x06\x11\x23\x06\x11"
            "\x73\x0e\x01\x7e\x0c\x02\xc0\x1c\x02\xc0\x34\x04\x80"
            "\x35\x04\x00\x27\x04\x00\x67\x04\x00\x46\x04\x00\xce"
            "\x06\x00\x8c\x03\x00\x8c\x01\x00\x08\x01\x00\x08\x01"
            "\x00\x00" }  },
      /* --- pixel bitmap for rsfs180 char#88 X --- */
      {  88,32465,                      /* character number, location */
         17, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 25,   17, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x85\x84\x71\x52\x51\x31\x52\x31\x31\x32\xa1\x32\x31"
            "\x21\xb1\x42\x31\x11\xc1\x32\x33\xd1\x22\x43\xe3\x27"
            "\xe0\x47\x80\xf1\xb2\xc0\xa2\xe0\x83\x71\x61\x62\x11"
            "\x61\x62\x52\x21\x51\x71\x42\x41\x41\x94\x74\x92" }  },
      /* --- pixel bitmap for rsfs180 char#89 Y --- */
      {  89,33922,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 24,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x1f\xc0\xc0\x60\x20\x30\x61\x18\x08\x61\x18\x04"
            "\x61\x0c\x82\x31\x06\xc2\x18\x06\xc1\x18\x03\x62\x0c"
            "\x03\x1c\x84\x01\x00\xc4\x01\x00\xfc\x00\x00\x60\x00"
            "\x08\x30\x00\x0c\x18\x00\x04\x06\x00\xf8\x01\x00" }  },
      /* --- pixel bitmap for rsfs180 char#90 Z --- */
      {  90,35607,                      /* character number, location */
         17, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 23,   17, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x85\x63\x72\x41\x42\x31\x51\x52\x32\x31\x51\x32\x12"
            "\x22\x22\x51\x42\x27\x61\x42\x52\xa1\x22\x52\xb4\x37"
            "\xe0\x27\xe0\x32\xe0\x62\xe0\x62\xe0\x71\xe0\x62\xe0"
            "\x17\x71\x71\x3b\x85\x35\xa2" }  },
      /* --- pixel bitmap for rsfs180 char#127 (noname) --- */
      { 127,36213,                      /* character number, location */
         13,10,    9,10,      /* topleft row,col, and botleft row,col */
          { 10,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x31\x28\x60\x80" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=6 for .210gf ---
 * mf '\mode=preview; mag=magstep(-13.80488502080647873125); input rsfs10'
 * --------------------------------------------------------------------- */
/* --- fontdef for rsfs210 --- */
static	chardef  rsfs210[] =
   {
      /* --- pixel bitmap for rsfs210 char#65 A --- */
      {  65, 1305,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 27,   20, 3,127, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xb2\xe0\xa2\xe0\xa3\xe0\x82\x11\xe0\x81\x21\xe0"
            "\x81\x22\xe0\x62\x22\xb5\x41\x42\xa2\x42\x11\x42\xa2"
            "\x71\x42\xa2\x71\x11\x32\xa2\x61\x21\x22\xb2\x51\x31"
            "\x12\xc1\x51\x41\x12\xc2\x31\x53\xe1\x31\x53\xa2\x33"
            "\x53\x21\x73\x35\x32\x12\x81\x32\x47\xa4\x83\xc0" }  },
      /* --- pixel bitmap for rsfs210 char#66 B --- */
      {  66, 2990,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 26,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xc0\x3f\x03\xe0\x80\x07\x40\x00\x1c\xc0\x00\xdc"
            "\x80\x40\x38\x03\x81\x71\x0c\x04\xe2\x18\x08\x8c\x61"
            "\x20\x18\xc7\x40\x60\xfe\x01\xc1\xbc\x07\xf8\xf8\x11"
            "\x00\xe0\xc0\x00\xc0\x01\x01\x80\x7b\x06\x01\x17\x18"
            "\x0e\x2e\x30\x1c\x9c\x60\x20\x38\xc2\x00\x1f\xf0\x00" }  },
      /* --- pixel bitmap for rsfs210 char#67 C --- */
      {  67, 4181,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 23,   20, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x44\x54\x83\x31\x32\xa2\x51\x22\x93\x61\x12\x93"
            "\x61\x22\x83\x61\x31\x83\x52\x42\x63\x33\x72\x43\x13"
            "\xb9\xe0\x43\xe0\x53\xe0\x62\x35\xc3\x21\x42\xb2\x21"
            "\x52\x60\xf1\x52\x21\x42\x70\x52\x21\x32\xd2\x52\xe0"
            "\x17\xa1" }  },
      /* --- pixel bitmap for rsfs210 char#68 D --- */
      {  68, 5492,                      /* character number, location */
         20, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xa6\xd3\x62\xa2\xa1\x73\xc1\x11\x32\x61\x64\x32\x61"
            "\x52\x11\x32\x71\x42\x21\x32\x71\x32\x31\x22\x71\x33"
            "\x31\x22\x61\x33\x31\x32\x51\x33\x41\x46\x43\x41\xd3"
            "\x41\xd3\x51\xc3\x51\xd2\x51\xd2\x51\xd2\x51\x78\x42"
            "\x8c\xa1" }  },
      /* --- pixel bitmap for rsfs210 char#69 E --- */
      {  69, 6136,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc5\xc3\x32\xa2\x42\x11\x82\x32\x31\x72\x41\x41\x63"
            "\x31\x41\x72\x54\x82\xe0\x44\xd7\xa3\xe0\x13\xe0\x13"
            "\x44\x82\x32\x41\x63\x31\x52\x5f\x12\x31\x52\x62\x82"
            "\x82\x53\xb6\xa3" }  },
      /* --- pixel bitmap for rsfs210 char#70 F --- */
      {  70, 7488,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 27,   20, 3,113, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd9\xe0\x2e\x02\xa2\xa5\x91\x51\x51\xd1\x62\x31\xd1"
            "\x71\x31\xe1\x62\x22\xe1\x52\x22\xe0\x11\x42\x22\x41"
            "\xb5\x42\x32\xe0\x53\x23\xe0\x47\xe0\x27\x12\xe0\x12"
            "\x33\x21\xe0\x11\x43\xe1\x83\xd3\x82\xe3\x63\xe0\x11"
            "\x73\xe0\x37\xe0\x53" }  },
      /* --- pixel bitmap for rsfs210 char#71 G --- */
      {  71, 8838,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 21,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x00\x0e\x1c\x30\xc2\x00\x63\x0c\x38\xcc\x80\xc3"
            "\x0c\x38\x8c\x01\xc7\x18\x70\x0c\x03\x67\x46\x60\x67"
            "\x18\x3e\x0e\xfc\xe1\x00\x18\x1e\x00\xbe\x01\x00\x19"
            "\x80\x80\x03\x38\x38\x80\x03\x07\x20\x70\x00\xf8\x03"
            "\x00" }  },
      /* --- pixel bitmap for rsfs210 char#72 H --- */
      {  72,10507,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 35,   20, 3,153, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x91\x64\xe0\x91\x53\x31\xb3\x71\x52\x51\xa1\x22"
            "\x52\x42\x51\xa1\x32\x33\x42\x61\xa1\x22\x33\x42\x61"
            "\xe0\x16\x43\x51\xe0\x53\x33\x42\xe0\x53\x1a\xe0\x3c"
            "\xe0\x72\x32\x43\xe0\x61\x43\x33\xe0\x61\x43\x33\xe0"
            "\xb3\x43\xe0\xa3\x43\xe0\x31\x73\x43\xe0\x23\x53\x52"
            "\x51\xa3\x52\x72\x41\xc1\x43\x82\x31\xe5\xb4\xd0" }  },
      /* --- pixel bitmap for rsfs210 char#73 I --- */
      {  73,11824,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 26,   20, 3,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xa2\xe0\x56\xe0\x34\x12\xe0\x33\x32\xe0\x32\x42"
            "\xe0\x32\x42\xe0\x32\x42\x21\x40\xf1\xa2\x42\x31\x40"
            "\xa2\x32\x31\xe0\x12\x23\x31\xe0\x21\x23\x12\xe0\x46"
            "\xe0\x73\xe0\x83\xd1\x83\xd3\x63\xd3\x63\xe0\x11\x53"
            "\xe0\x46\xe0\x43" }  },
      /* --- pixel bitmap for rsfs210 char#74 J --- */
      {  74,13275,                      /* character number, location */
         20, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 30,   28, 3,157, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe2\xe0\x95\xe0\x84\x12\xe0\x73\x23\xe0\x63\x32"
            "\xe0\x82\x42\xe0\x72\x42\x21\xe0\x42\x42\x31\x40\xf1"
            "\xe2\x32\x31\x50\xe1\x33\x21\xe0\x62\x13\x21\xe0\x87"
            "\xe0\xa3\xb0\xf1\xe0\x13\xc0\xe3\x21\xe0\x93\x12\xe0"
            "\xa4\xe0\x95\xe0\x78\xe0\x62\x43\xe0\x52\x53\xe0\x51"
            "\x63\xe0\x51\x62\xe0\x71\x52\xe0\x81\x42\xe0\xa4\xe0"
            "\xb0" }  },
      /* --- pixel bitmap for rsfs210 char#75 K --- */
      {  75,14972,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 34,   20, 3,137, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x91\x64\xe0\x81\x62\xe0\x12\x72\x52\xe2\x12\x52"
            "\x52\xe0\x11\x22\x42\x52\xe0\x11\x22\x33\x52\xe0\x67"
            "\x42\xe0\xa3\x42\xe0\xa3\x42\xe0\xb7\xe0\xc7\xe0\xc3"
            "\x22\xe0\xc3\x23\xe0\xb3\x32\xe0\xc3\x23\xe0\x31\x73"
            "\x32\xe0\x33\x53\x42\x51\xa3\x53\x52\x41\xc1\x43\x72"
            "\x31\xe5\xa4\xd2" }  },
      /* --- pixel bitmap for rsfs210 char#76 L --- */
      {  76,16293,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 30,   20, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe4\x74\xd3\x92\x22\xb2\xa2\x41\xa2\xa2\x42\x92\xa2"
            "\x51\xa2\x93\x42\xa2\x83\x42\xb2\x73\x42\xc2\x63\x23"
            "\xe0\x2c\xe0\x84\xb0\xf1\xe0\x13\xc0\xe3\xe0\xc3\xe0"
            "\xc3\xe0\xc3\x81\x9b\x81\x92\x5d\xa8\x46\xb0" }  },
      /* --- pixel bitmap for rsfs210 char#77 M --- */
      {  77,17870,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 34,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x00\x00\x04\x02\x00\x00\x08\x06\x00\x00\x18\x0c"
            "\x00\x00\x70\x38\x00\x00\xf0\x70\x00\x00\xa0\xe1\x00"
            "\x00\x40\xc3\x03\x00\xc0\x8e\x07\x00\x80\x1c\x0d\x00"
            "\x00\x39\x3a\x00\x00\x62\x74\x00\x00\xc4\xc9\x01\x00"
            "\x88\x93\x03\x00\x20\x27\x0e\x00\x40\x8e\x1c\x00\x80"
            "\x38\x39\x00\x04\x71\xe2\x08\x38\xc2\x85\x21\x50\x06"
            "\x0b\x66\x80\x07\x1c\x78\x00" }  },
      /* --- pixel bitmap for rsfs210 char#78 N --- */
      {  78,19136,                      /* character number, location */
         21, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 34,   21, 3,145, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x51\xe0\x71\x93\xe0\x61\x92\xe0\x81\x81\xe0"
            "\x92\x71\xe0\x93\x61\xe0\xa3\x51\xe0\xa1\x12\x51\xe0"
            "\x91\x22\x41\xe0\xa1\x22\x31\xe0\xa1\x33\x11\xe0\xa1"
            "\x43\x11\xe0\x91\x54\xe0\xa1\x52\x11\xe0\x91\x63\xe0"
            "\x91\x72\xe0\x11\x71\x82\xe3\x51\x91\xe3\x51\x92\xe0"
            "\x11\x42\xa1\xe0\x34\xc1\xe0\x11" }  },
      /* --- pixel bitmap for rsfs210 char#79 O --- */
      {  79,20324,                      /* character number, location */
         20, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc6\xc2\x61\x93\x81\x72\xa1\x62\x25\x41\x52\x21\x42"
            "\x21\x53\x11\x36\x53\x11\x62\x63\x11\x72\x62\x11\x82"
            "\x54\x82\x53\x11\x82\x54\x82\x62\x11\x82\x62\x11\x72"
            "\x73\x72\x83\x62\x92\x62\xb2\x33\xd5\xd0" }  },
      /* --- pixel bitmap for rsfs210 char#80 P --- */
      {  80,21866,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 28,   20, 3,125, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe8\x42\xb3\x82\x12\xb1\x41\x82\xa2\x51\x73\x91\x71"
            "\x62\x12\x71\x72\x52\x22\x71\x71\x52\x32\x61\x72\x21"
            "\x13\x23\x61\x62\x12\x13\x32\x61\x62\x21\x13\x32\x71"
            "\x52\x34\x32\x95\x67\xe0\x63\xe0\xa3\xe0\xa3\xe1\x93"
            "\xe3\x73\xe3\x73\xe0\x21\x54\xe0\x56\xe0\x61" }  },
      /* --- pixel bitmap for rsfs210 char#81 Q --- */
      {  81,23221,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 24,   20, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x16\xe0\x22\x52\xd2\x82\xb2\x51\x42\x92\x61\x42"
            "\x82\x71\x33\x82\x62\x33\x72\x72\x32\x82\x62\x33\x82"
            "\x52\x33\x92\x33\x43\xa5\x53\xe0\x63\xe0\x63\xe0\x63"
            "\xe0\x63\x97\x33\x61\x3d\x61\x41\x6c\x67\x37\x51" }  },
      /* --- pixel bitmap for rsfs210 char#82 R --- */
      {  82,24876,                      /* character number, location */
         20, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          { 26,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\xc0\x3f\x02\xe0\x80\x07\x40\x00\x1c\xc0\x00\xc8"
            "\x80\x40\x10\x03\x81\x20\x0c\x04\xc3\x30\x08\x86\x61"
            "\x20\x0c\xc3\x40\x18\xce\x00\x32\xfc\x00\x70\x30\x03"
            "\x00\xe0\x0e\x00\xc0\x39\x00\x80\x73\x00\x01\xe6\x00"
            "\x0e\xcc\x21\x1c\x1c\x87\x20\x38\x9c\x01\x1f\xe0\x01" }  },
      /* --- pixel bitmap for rsfs210 char#83 S --- */
      {  83,26167,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 28,   20, 3,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xb3\xe0\x14\x42\x21\xc3\x72\x31\xb2\x82\x41\xa1"
            "\x93\x31\xa1\x93\x31\xa2\x83\x31\xb2\x83\x21\xd1\x73"
            "\x12\xe0\x12\x45\xe0\x57\xe0\xa3\xe0\xa3\xe0\xa3\xe0"
            "\xa3\xe0\x11\x92\xe0\x13\x63\xe0\x13\x63\xe0\x31\x53"
            "\xe0\x66\xe0\x63" }  },
      /* --- pixel bitmap for rsfs210 char#84 T --- */
      {  84,27467,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 25,   20, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc9\xe5\x19\x92\x95\x81\x51\x62\x91\x61\x52\x91\x62"
            "\x42\xa1\x62\x32\xb1\x52\x32\xc1\x33\x42\xc5\x52\xe0"
            "\x83\xe0\x82\xe0\x83\x80\xf1\xd3\x90\x21\x93\xb3\x73"
            "\xb3\x72\xe1\x63\xe0\x27\xe0\x20" }  },
      /* --- pixel bitmap for rsfs210 char#85 U --- */
      {  85,28836,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 25,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x1f\x00\x80\x41\x00\xc0\x80\x01\x47\x08\x03\x4e"
            "\x10\x06\x4e\x30\x0e\x8e\x20\x0c\x8e\x60\x1c\x0e\x61"
            "\x18\x0e\x62\x18\x1c\x38\x38\x1c\x00\x38\x1c\x00\x38"
            "\x1c\x00\x70\x38\x00\x70\x38\x00\x70\x38\x00\xe0\x38"
            "\x02\xc0\x78\x04\x80\x69\x06\x00\x8e\x03\x00" }  },
      /* --- pixel bitmap for rsfs210 char#86 V --- */
      {  86,29991,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   20, 3,107, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc1\x81\xb2\x72\xb1\x71\x53\x42\x61\x42\x22\x22\x61"
            "\x41\x32\x23\x51\x51\x32\x14\x41\xa3\x13\x41\xd3\x41"
            "\x70\xf1\x73\x31\x80\x73\x21\xe0\x22\x21\xe0\x23\x11"
            "\xe0\x32\x11\xe0\x43\xe0\x42\xe0\x61\xe0\x61\xe0\x61"
            "\xe0\x41" }  },
      /* --- pixel bitmap for rsfs210 char#87 W --- */
      {  87,31368,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 28,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x10\x08\x0c\x80\xc1\x60\x1c\x0c\x06\x21\x43\x70"
            "\x08\x31\x86\x43\x90\x71\x34\x04\xf0\xa3\x21\x00\x38"
            "\x1d\x02\x80\xd3\x10\x00\x9c\x8e\x00\xc0\x75\x08\x00"
            "\x2c\x47\x00\xe0\x39\x02\x00\x8e\x19\x00\x60\x48\x00"
            "\x00\xc3\x02\x00\x30\x1c\x00\x80\x61\x00\x00\x08\x02"
            "\x00\x40\x10\x00\x00" }  },
      /* --- pixel bitmap for rsfs210 char#88 X --- */
      {  88,32851,                      /* character number, location */
         20, 3,    0, 3,      /* topleft row,col, and botleft row,col */
          { 28,   20, 3,127, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb4\x94\x92\x42\x61\x22\x81\x31\x22\x51\xc1\x41\x32"
            "\x31\xc1\x42\x32\x21\xc1\x52\x23\x11\xd1\x52\x24\xe1"
            "\x42\x33\xe0\x11\x32\x33\xe0\x33\x27\xe0\x77\xe0\x83"
            "\xd0\xf1\xb3\xe0\xa3\xe0\x31\x62\x11\x71\x73\x52\x21"
            "\x61\x83\x42\x31\x51\x91\x43\x51\x31\xb5\x83\xb2" }  },
      /* --- pixel bitmap for rsfs210 char#89 Y --- */
      {  89,34328,                      /* character number, location */
         20, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 26,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x7e\x00\x03\x06\x03\x06\x26\x1c\x04\x84\x70\x18"
            "\x08\xc3\x31\x10\x8c\x63\x40\x18\x8e\x81\x60\x1c\x03"
            "\xc2\x38\x0e\x84\x71\x1c\x20\xc3\x71\x00\x87\xe3\x00"
            "\x00\xce\x01\x00\x30\x07\x00\x80\x0f\x00\x04\x1c\x00"
            "\x1c\x38\x00\x70\x30\x00\x40\x70\x00\x00\x7e\x00\x00" }  },
      /* --- pixel bitmap for rsfs210 char#90 Z --- */
      {  90,36035,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 28,   20, 3,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc4\x74\xa3\x32\x51\x41\x81\x53\x41\x41\x81\x31\x23"
            "\x32\x32\x71\x42\x13\x22\x22\x81\x52\x37\xa1\x52\x43"
            "\xd1\x42\x52\xe1\x32\x53\xe4\x48\xe0\x68\xe0\x73\xe0"
            "\xa3\xe0\xa3\xe0\xa3\xe0\xa3\xe0\xa3\x61\xa9\x72\x91"
            "\x5b\xb7\x45\xc3" }  },
      /* --- pixel bitmap for rsfs210 char#127 (noname) --- */
      { 127,36661,                      /* character number, location */
         15,12,   11,12,      /* topleft row,col, and botleft row,col */
          { 11,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xc3\xa0\x01\x03\x08" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=7 for .250gf ---
 * mf '\mode=preview; mag=magstep(-12.84858895680446863032); input rsfs10'
 * --------------------------------------------------------------------- */
/* --- fontdef for rsfs250 --- */
static	chardef  rsfs250[] =
   {
      /* --- pixel bitmap for rsfs250 char#65 A --- */
      {  65, 1331,                      /* character number, location */
         25, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 33,   25, 3,183, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x41\xe0\xe0\x31\xe0\xe0\x23\xe0\xe0\x13\xe0"
            "\xe0\x11\x12\xe0\xe1\x21\xe0\xd2\x21\xe0\xd1\x32\xe0"
            "\xc1\x32\xe0\x13\x81\x41\xe3\x23\x41\x42\xd2\x71\x11"
            "\x52\xd2\x91\x62\xd2\x81\x11\x42\xd2\x81\x21\x32\xe2"
            "\x71\x31\x32\xe2\x61\x51\x12\xe0\x12\x51\x64\xe0\x12"
            "\x51\x54\xe0\x31\x41\x63\xd2\x42\x11\x73\x31\x84\x43"
            "\x63\x22\x93\x42\x16\x15\xb1\x42\x93\xe0\x14\xa3\xe0"
            "\x10" }  },
      /* --- pixel bitmap for rsfs250 char#66 B --- */
      {  66, 3046,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 31,   24, 3,169, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x29\x41\xe3\x94\xd2\xd3\xc1\xe2\x12\x92\xe2\x32"
            "\x71\x81\x62\x42\x61\x82\x53\x42\x61\x82\x43\x42\x61"
            "\x82\x43\x52\x61\x82\x33\x52\x61\x82\x43\x42\x71\x72"
            "\x49\x81\x62\x44\x24\x91\x33\x47\x31\xa4\x63\x72\xe0"
            "\x43\x82\xe0\x33\x42\x32\xe0\x23\x23\x42\xe0\x33\x11"
            "\x72\x52\x93\x11\x72\x53\x82\x31\x62\x61\x83\x31\x62"
            "\x71\x63\x61\x42\x97\x94\xa1" }  },
      /* --- pixel bitmap for rsfs250 char#67 C --- */
      {  67, 4267,                      /* character number, location */
         24, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 27,   24, 3,133, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x84\x64\xa3\x31\x43\xc2\x61\x22\xd2\x61\x22\xc3"
            "\x71\x12\xc3\x71\x22\xb3\x71\x31\xb3\x62\x42\x93\x52"
            "\x62\x83\x42\x93\x67\xda\xe0\x83\xe0\x93\xe0\xa3\x44"
            "\xe0\x13\x32\x32\xe3\x21\x52\xe2\x21\x62\xd3\x21\x62"
            "\xd3\x21\x52\xe2\x31\x52\xe0\x12\x72\xe0\x22\x53\xe0"
            "\x47\xd2" }  },
      /* --- pixel bitmap for rsfs250 char#68 D --- */
      {  68, 5598,                      /* character number, location */
         24, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 27,   25, 3,153, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd7\xe0\x33\x72\xd3\xb1\xb2\xe1\x92\xe0\x23\x52\x81"
            "\x73\x52\x91\x63\x52\x91\x62\x11\x52\x91\x52\x21\x42"
            "\x91\x52\x31\x42\x91\x42\x41\x42\x81\x43\x41\x42\x62"
            "\x43\x51\x52\x32\x53\x51\x74\x73\x51\xe0\x33\x51\xe0"
            "\x33\x61\xe0\x23\x61\xe0\x32\x71\xe0\x23\x61\xe0\x23"
            "\x61\xe0\x23\x61\xe0\x23\x61\x99\x62\xb6\x17\xc1" }  },
      /* --- pixel bitmap for rsfs250 char#69 E --- */
      {  69, 6294,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   24, 3,111, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe6\xe4\x32\xc2\x81\xa2\x52\x21\x92\x51\x41\x83\x41"
            "\x51\x82\x51\x41\x83\x51\x31\x92\x73\xa2\xe0\x76\xd3"
            "\x15\xc2\xe0\x52\xe0\x52\x62\xb3\x42\x23\x73\x41\x62"
            "\x62\x51\x62\x62\x41\x72\x62\x41\x62\x72\xa2\x91\x92"
            "\xb2\x53\xd7\xc3" }  },
      /* --- pixel bitmap for rsfs250 char#70 F --- */
      {  70, 7668,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 32,   26, 3,171, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x61\xe0\xda\xe0\x6e\x02\xe3\xa7\xb2\x51\x71\x22"
            "\xb1\x71\x52\xe0\x11\x82\x32\xe0\x11\x92\x22\xe0\x21"
            "\x82\x22\xe0\x31\x72\x22\xe0\x31\x73\x22\xe0\x41\x43"
            "\x32\x51\xe5\x52\x32\x11\xe0\x82\x32\x11\xe0\x83\x24"
            "\xe0\x6a\xe0\x53\x23\x23\xe0\x32\x53\x21\xe0\x51\x53"
            "\xe0\xe3\xe0\x23\x93\xe0\x32\x93\xe0\x31\xa3\xe0\x41"
            "\x92\xe0\x71\x63\xe0\x96\xe0\xa2" }  },
      /* --- pixel bitmap for rsfs250 char#71 G --- */
      {  71, 9050,                      /* character number, location */
         25, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 25,   26, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x73\xe0\x62\x31\x73\x82\x41\x52\x93\x42\x42\x93"
            "\x42\x42\x93\x52\x32\x93\x52\x32\xa2\x52\x42\x93\x42"
            "\x51\x93\x42\x52\x83\x32\x31\x41\x83\x22\x31\x52\x63"
            "\x12\x42\x62\x54\x52\x97\x63\xd3\x53\xe0\x12\x43\xe0"
            "\x35\x12\xe0\x83\xe0\x82\xb2\x93\xa3\x83\xb1\xa3\xb1"
            "\x93\xc2\x63\xe0\x27\xe0" }  },
      /* --- pixel bitmap for rsfs250 char#72 H --- */
      {  72,10745,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 42,   26, 3,207, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe1\xe0\xe0\xc2\x75\xe0\xd2\x63\x31\xe0\x12\x92"
            "\x62\x61\xd1\x12\x72\x62\x71\xc1\x32\x52\x62\x71\xc1"
            "\x32\x53\x52\x81\xb1\x42\x34\x53\x71\xe0\x35\x12\x53"
            "\x71\xe0\x92\x53\x62\xe0\x93\x43\x43\xe0\x9e\x02\xe0"
            "\x87\x53\xe0\xb2\x33\x53\xe0\xa2\x53\x43\xe0\xa1\x63"
            "\x53\xe0\xa1\x53\x53\xe0\x30\xf1\xd3\x53\xe0\x40\xc3"
            "\x62\xe0\x62\x83\x63\x71\xb3\x73\x73\x61\xc1\x83\x92"
            "\x51\xd1\x73\xa2\x32\xe2\x43\xd4\xe0\x45\xe0\xe0\x70" }  },
      /* --- pixel bitmap for rsfs250 char#73 I --- */
      {  73,12098,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 31,   26, 3,161, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x12\xe0\xc4\xe0\x96\xe0\x84\x22\xe0\x73\x42"
            "\xe0\x72\x52\xe0\x72\x52\xe0\x72\x52\xe0\x72\x52\x31"
            "\xe0\x32\x52\x41\xe0\x32\x52\x31\xe0\x41\x52\x41\xe0"
            "\x32\x43\x31\xe0\x42\x42\x41\xe0\x51\x33\x31\xe0\x71"
            "\x22\x22\xe0\x96\xe0\xb3\xe0\xf1\xd3\xe0\x10\x12\x93"
            "\xe0\x23\x83\xe0\x31\x92\xe0\x51\x73\xe0\x61\x53\xe0"
            "\x96\xe0\xa2" }  },
      /* --- pixel bitmap for rsfs250 char#74 J --- */
      {  74,13547,                      /* character number, location */
         25, 3,  -11, 3,      /* topleft row,col, and botleft row,col */
          { 37,   36, 3,237, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x72\xe0\xe0\x44\xe0\xe0\x16\xe0\xe4\x22\xe0"
            "\xd3\x42\xe0\xd2\x52\xe0\xd2\x52\xe0\xd2\x52\xe0\xd2"
            "\x52\x31\xe0\x92\x52\x41\xe0\x92\x52\x31\xe0\xa1\x52"
            "\x41\xe0\x92\x43\x31\xe0\xb1\x42\x41\xe0\xb1\x33\x31"
            "\xe0\xd1\x22\x22\xe0\xe0\x16\xb0\xf1\xe0\x63\xe0\xe0"
            "\x53\xe0\xe0\x53\x41\xe0\xe3\x41\xe0\xe0\x13\x22\xe0"
            "\xe0\x16\xe0\xe0\x14\xe0\xe0\x17\xe0\xd3\x42\xe0\xb3"
            "\x62\xe0\xb1\x82\xe0\xb1\x82\xe0\xb1\x82\xe0\xc1\x72"
            "\xe0\xc1\x72\xe0\xd1\x62\xe0\xe1\x42\xe0\xe0\x34\xe0"
            "\xe0\x40" }  },
      /* --- pixel bitmap for rsfs250 char#75 K --- */
      {  75,15278,                      /* character number, location */
         25, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 40,   26, 3,213, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe1\xe0\xe0\xa2\x83\xe0\xc2\x72\xe0\x32\x92\x72"
            "\xe0\x31\x21\x72\x71\xe0\x41\x32\x52\x72\xe0\x31\x32"
            "\x53\x62\xe0\x31\x42\x34\x62\xe0\x95\x12\x62\xe0\xe0"
            "\x12\x62\xe0\xe0\x12\x62\xe0\xe0\x13\x52\xe0\xe0\x16"
            "\x12\xe0\xe0\x24\x22\xe0\xe0\x43\x14\xe0\xe0\x33\x32"
            "\xe0\xe0\x33\x33\xe0\xe0\x23\x33\xe0\xe0\x33\x32\xe0"
            "\xe0\x33\x33\xe0\x62\x83\x42\x81\xb3\x73\x52\x71\xc1"
            "\x83\x62\x61\xd1\x73\x72\x51\xe2\x43\xa1\x32\xe0\x35"
            "\xd3\xe0\x32" }  },
      /* --- pixel bitmap for rsfs250 char#76 L --- */
      {  76,16637,                      /* character number, location */
         25, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 36,   26, 3,159, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x34\xe0\x35\x83\x22\xe0\x13\xa3\x41\xd3\xb3"
            "\x51\xc2\xc3\x52\xb2\xc3\x61\xc2\xb3\x62\xb2\xc2\x71"
            "\xc2\xb3\x61\xd2\xa3\x52\xe2\x93\x43\xe0\x22\x83\x23"
            "\xe0\x5e\xe0\xe0\x13\xe0\xf1\xe0\x43\xe0\x10\xe0\x33"
            "\xe0\x20\xf1\xe0\x23\xe0\x30\xe0\x13\xe0\xe0\x43\xa1"
            "\xe0\x73\xa1\xbc\xa2\xb2\x75\x82\xb2\x63\x2a\xe7\x76"
            "\xe0\x13" }  },
      /* --- pixel bitmap for rsfs250 char#77 M --- */
      {  77,18270,                      /* character number, location */
         25, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 41,   27, 3,243, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x31\x81\xe0\xe0\x21\x81\xe0\xe0\x22\x72\xe0"
            "\xe0\x12\x72\xe0\xe3\x72\xe0\xe3\x72\xe0\xe3\x72\xe0"
            "\xd4\x64\xe0\xc1\x13\x54\xe0\xc1\x13\x51\x12\xe0\xc1"
            "\x22\x51\x13\xe0\xa2\x23\x41\x13\xe0\xa1\x33\x41\x22"
            "\xe0\xa1\x33\x41\x23\xe0\xa1\x32\x41\x23\xe0\xa1\x33"
            "\x31\x33\xe0\x91\x33\x41\x23\xe0\x91\x33\x41\x23\xe0"
            "\x91\x43\x31\x33\xe0\x81\x43\x31\x33\xe0\x81\x43\x31"
            "\x33\x61\x82\x51\x53\x21\x43\x51\x83\x41\x62\x21\x52"
            "\x61\x81\x42\x63\x11\x62\x42\xa4\x84\x72\x31\xe0\xb2"
            "\x85\xe0\xe0\xa1\xe0" }  },
      /* --- pixel bitmap for rsfs250 char#78 N --- */
      {  78,19602,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 40,   25, 3,181, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xb1\xc2\xe0\xa2\xa2\xe0\xc1\xa2\xe0\xc2\x91\xe0"
            "\xd2\x91\xe0\xe2\x81\xe0\xe1\x11\x71\xe0\xe1\x12\x71"
            "\xe0\xd1\x23\x51\xe0\xe1\x23\x41\xe0\xe1\x33\x41\xe0"
            "\xd1\x43\x31\xe0\xe1\x43\x21\xe0\xe1\x53\x21\xe0\xd1"
            "\x72\x11\xe0\xe1\x73\xe0\xe1\x83\xe0\xd1\x92\xe0\xd1"
            "\x93\xe0\x22\x91\x92\xe0\x23\x81\xa1\xe0\x31\x91\xb1"
            "\xe0\x31\x72\xb1\xe0\x42\x51\xd1\xe0\x65\xe0\xe0\x51" }  },
      /* --- pixel bitmap for rsfs250 char#79 O --- */
      {  79,20840,                      /* character number, location */
         24, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 24,   24, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x16\xe0\x13\x61\xd2\x91\xa3\xb1\x82\x43\x51\x82"
            "\x32\x22\x41\x73\x21\x61\x21\x73\x21\x32\x21\x11\x73"
            "\x21\x64\x73\x21\x91\x83\x11\x92\x73\x11\xa2\x63\x21"
            "\xa2\x63\x11\xa2\x63\x21\xa2\x63\x11\xa2\x72\x21\x92"
            "\x82\x11\xa2\x82\x11\x92\x92\x11\x82\xa2\x92\xc1\x72"
            "\xe2\x52\xe0\x35\xe0\x20" }  },
      /* --- pixel bitmap for rsfs250 char#80 P --- */
      {  80,22418,                      /* character number, location */
         25, 4,   -1, 4,      /* topleft row,col, and botleft row,col */
          { 32,   26, 3,175, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x39\xe0\x63\x83\x31\xc2\xe3\xc1\x51\xa3\xa2\x61"
            "\x92\x11\x91\x81\x82\x22\x71\x91\x72\x32\x61\xa1\x63"
            "\x32\x61\x92\x53\x42\x51\xa1\x53\x43\x51\x91\x22\x13"
            "\x52\x51\x91\x31\x22\x53\x51\x81\x31\x23\x43\x61\x62"
            "\x41\x13\x43\x81\x33\x63\x33\xb4\x87\xe0\xa3\xe0\xe3"
            "\xe0\xe3\xe0\xe3\xe0\x22\xa3\xe0\x23\x93\xe0\x31\xa3"
            "\xe0\x41\x83\xe0\x61\x63\xe0\x97\xe0\xa5" }  },
      /* --- pixel bitmap for rsfs250 char#81 Q --- */
      {  81,23783,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 28,   26, 3,139, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x46\xe0\x53\x62\xe0\x22\x92\xd2\xc2\xb2\x51\x72"
            "\xa2\x71\x62\x92\x81\x62\x82\x91\x53\x82\x82\x53\x72"
            "\x92\x52\x82\x82\x53\x82\x72\x53\x92\x62\x63\xa1\x43"
            "\x63\xc5\x73\xe0\xb2\xe0\xb3\xe0\xa3\xe0\xa2\xe0\xb2"
            "\xb6\x73\x71\x39\x43\x71\x31\x77\x81\x41\x94\x72\x52"
            "\x63\x1a\x77\x75\x80" }  },
      /* --- pixel bitmap for rsfs250 char#82 R --- */
      {  82,25446,                      /* character number, location */
         25, 0,   -1, 0,      /* topleft row,col, and botleft row,col */
          { 30,   26, 3,177, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x38\xe0\x53\x83\x11\xc2\xd2\xc1\xe4\x92\xe2\x12"
            "\x81\xe0\x11\x41\x71\x81\x62\x32\x61\x82\x52\x42\x61"
            "\x81\x52\x52\x51\x82\x42\x52\x61\x72\x43\x42\x61\x82"
            "\x42\x42\x71\x72\x42\x23\x91\x62\x46\xc1\x33\x43\x32"
            "\xc4\x63\x23\xe0\x73\x33\xe0\x63\x33\xe0\x63\x43\xe0"
            "\x63\x33\x92\x93\x33\x51\x33\x82\x43\x51\x41\x83\x53"
            "\x51\x41\x63\x73\x32\x67\x92\x31\xe0\xb4\x80" }  },
      /* --- pixel bitmap for rsfs250 char#83 S --- */
      {  83,26773,                      /* character number, location */
         24, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 34,   25, 3,153, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x23\xe0\x63\x62\x31\xe0\x14\x82\x31\xe3\xa2"
            "\x41\xd2\xb2\x51\xc1\xc2\x51\xc1\xc3\x41\xc2\xb3\x41"
            "\xd2\xa3\x41\xe0\x11\xa3\x31\xe0\x22\x83\x22\xe0\x43"
            "\x53\x12\xe0\x8a\xb0\xf1\xe0\x33\xe0\xe0\x23\xe0\xe0"
            "\x23\xe0\x20\xf1\xe3\xe0\x30\x12\xa3\xe0\x43\x93\xe0"
            "\x51\x93\xe0\x71\x83\xe0\x81\x63\xe0\xb6\xe0\xd3" }  },
      /* --- pixel bitmap for rsfs250 char#84 T --- */
      {  84,28095,                      /* character number, location */
         25, 4,   -1, 4,      /* topleft row,col, and botleft row,col */
          { 30,   26, 3,135, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x41\xe0\xba\xe0\x4e\x02\xc3\xa7\x92\x51\x93\x91"
            "\x71\x72\xb1\x82\x52\xb1\x91\x52\xc1\x82\x42\xd1\x72"
            "\x42\xd1\x72\x52\xe1\x43\x52\xe0\x25\x63\xe0\xd2\xa0"
            "\xf1\xe0\x33\xa0\xe0\x23\xb0\xf1\xe0\x13\xc0\xe3\xe2"
            "\xa3\xe3\x93\xe0\x11\xa3\xe0\x21\x92\xe0\x42\x63\xe0"
            "\x76\xe0\x80" }  },
      /* --- pixel bitmap for rsfs250 char#85 U --- */
      {  85,29484,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 31,   26, 3,183, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc5\xe0\xa2\x52\xe0\x62\x81\xe0\x42\xa2\xe0\x21\x51"
            "\x62\x83\x41\x61\x53\x73\x41\x71\x52\x83\x31\x72\x52"
            "\x73\x41\x71\x52\x73\x41\x72\x43\x63\x51\x62\x52\x63"
            "\x51\x62\x53\x53\x61\x52\x53\x53\x81\x32\x53\x53\x94"
            "\x72\x63\xe0\x53\x53\xe0\x53\x53\xa0\xf1\x93\x53\xb0"
            "\x83\x53\xe0\x53\x53\x51\xe3\x44\x41\xe0\x12\x44\x41"
            "\xe0\x22\x31\x13\x31\xe0\x32\x21\x22\x22\xe0\x44\x43"
            "\xd3" }  },
      /* --- pixel bitmap for rsfs250 char#86 V --- */
      {  86,30679,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 28,   26, 3,147, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x31\xe0\xc1\x92\xe0\x11\x92\xe0\x12\x82\x64\x61"
            "\x81\x71\x31\x43\x71\x71\x32\x42\x71\x71\x32\x43\x62"
            "\x61\x42\x25\x61\xd3\x23\x51\x80\xf1\xa3\x51\x90\xa3"
            "\x41\xe0\x53\x41\xe0\x63\x31\xe0\x73\x21\xe0\x82\x22"
            "\xe0\x73\x12\xe0\x82\x11\xe0\xa3\xe0\xa3\xe0\xb2\xe0"
            "\xb2\xe0\xc1\xe0\xc1\xe0\xc1\xe0\x91" }  },
      /* --- pixel bitmap for rsfs250 char#87 W --- */
      {  87,32078,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 34,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x00\x02\x01\x00\x00\x04\x02\x08\x00\x08\x0c\x38"
            "\x0c\x30\x18\x30\x48\x60\x30\x60\x10\x83\xe1\xc0\x20"
            "\x06\x43\x01\x41\x18\x0e\x07\x02\xe0\x1f\x1e\x04\x00"
            "\x70\x34\x10\x00\xc0\xe8\x20\x00\x80\xd3\x41\x00\x00"
            "\x2e\x07\x01\x00\x9c\x0e\x02\x00\x70\x39\x04\x00\xc0"
            "\x72\x08\x00\x80\xc7\x10\x00\x00\x8e\x23\x00\x00\x1c"
            "\x46\x00\x00\x70\xcc\x00\x00\xe0\xb0\x00\x00\x80\x41"
            "\x01\x00\x00\x83\x03\x00\x00\x04\x03\x00\x00\x08\x04"
            "\x00\x00\x10\x08\x00\x00\x00" }  },
      /* --- pixel bitmap for rsfs250 char#88 X --- */
      {  88,33601,                      /* character number, location */
         25, 4,   -1, 4,      /* topleft row,col, and botleft row,col */
          { 35,   26, 3,193, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe5\xc4\xc2\x52\x82\x22\xb1\x82\x61\x33\xa1\x92\x51"
            "\xe0\x21\x51\x42\x41\xe0\x21\x61\x42\x31\xe0\x21\x71"
            "\x42\x21\xe0\x31\x62\x33\x11\xe0\x31\x72\x34\xe0\x41"
            "\x62\x43\xe0\x51\x52\x43\xe0\x61\x42\x44\xe0\x74\x39"
            "\xe0\xc9\xc0\xf1\xe0\x13\xe0\x30\xe3\xe0\xe0\x34\xe0"
            "\xe0\x24\xe0\xe0\x32\x11\xa1\x93\x72\x21\x91\xa2\x72"
            "\x31\x81\xa1\x82\x41\x71\xb1\x72\x51\x61\xd1\x42\x72"
            "\x32\xe0\x14\xb3\xe0\x11" }  },
      /* --- pixel bitmap for rsfs250 char#89 Y --- */
      {  89,35088,                      /* character number, location */
         25, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 32,   26, 3,173, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc6\xe0\xa2\x52\xb2\x82\x82\x82\x91\xa2\x72\x82\x41"
            "\x62\x62\x81\x62\x43\x52\x81\x72\x43\x42\x81\x82\x33"
            "\x43\x81\x72\x43\x42\x81\x82\x33\x42\x91\x72\x33\x52"
            "\x81\x72\x43\x43\x91\x61\x43\x52\xa1\x42\x43\x53\xb4"
            "\x63\x43\xe0\x73\x53\xe0\x82\x43\xe0\x92\x33\xe0\xb6"
            "\xe0\xe0\x13\xe0\x23\x93\xe0\x32\x92\xe0\x41\xa2\xe0"
            "\x51\x83\xe0\x71\x53\xe0\xa6\xe0\x81" }  },
      /* --- pixel bitmap for rsfs250 char#90 Z --- */
      {  90,36823,                      /* character number, location */
         25, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 33,   26, 3,171, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe5\xe0\xc2\x52\x74\xb2\x72\x52\x41\x91\x83\x41\x61"
            "\x81\x83\x41\x61\x81\x52\x23\x32\x52\x71\x62\x32\x22"
            "\x33\x81\x72\x48\xb1\x72\x62\xe0\x11\x62\x62\xe0\x11"
            "\x62\x63\xe0\x21\x42\x63\xe0\x44\x5a\xe0\x9a\xe0\xa3"
            "\xe0\xe0\x22\xe0\xe0\x23\xe0\xe0\x13\xe0\xe0\x13\xe0"
            "\xe0\x13\xe0\xe0\x12\x91\xc6\x22\x91\xc1\x63\x91\xc1"
            "\x57\x52\xe6\x48\xe0\xc5\xe0\x20" }  },
      /* --- pixel bitmap for rsfs250 char#127 (noname) --- */
      { 127,37481,                      /* character number, location */
         18,14,   13,14,      /* topleft row,col, and botleft row,col */
          { 14,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x0f\x1c\x84\x00\x12\x80\x02\x10" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* ------------------------------------------------------------------------
font sizes 0-7 for stmary10
------------------------------------------------------------------------ */

/* --- size=0 for .83gf ---
 * mf '\mode=eighthre;  input stmary10'
 * --------------------------------------------------------------------- */
/* --- fontdef for stmary83 --- */
static	chardef  stmary83[] =
   {
      /* --- pixel bitmap for stmary83 char#0 \shortleftarrow --- */
      {   0,   35,                      /* character number, location */
          4, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\x2f\x00" }  },
      /* --- pixel bitmap for stmary83 char#1 \shortrightarrow --- */
      {   1,   48,                      /* character number, location */
          4, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd0\x0f\x01" }  },
      /* --- pixel bitmap for stmary83 char#2 \shortuparrow --- */
      {   2,   61,                      /* character number, location */
          7, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xba\x24\x49" }  },
      /* --- pixel bitmap for stmary83 char#3 \shortdownarrow --- */
      {   3,   84,                      /* character number, location */
          7, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x24\x5d" }  },
      /* --- pixel bitmap for stmary83 char#4 \Yup --- */
      {   4,  107,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x54" }  },
      /* --- pixel bitmap for stmary83 char#5 \Ydown --- */
      {   5,  126,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xad\x24" }  },
      /* --- pixel bitmap for stmary83 char#6 \Yleft --- */
      {   6,  147,                      /* character number, location */
          5, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x68\x84" }  },
      /* --- pixel bitmap for stmary83 char#7 \Yright --- */
      {   7,  162,                      /* character number, location */
          5, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\x12" }  },
      /* --- pixel bitmap for stmary83 char#8 \varcurlyvee --- */
      {   8,  177,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x11\x85\x42\x41\x20\x10\x08\x04" }  },
      /* --- pixel bitmap for stmary83 char#9 \varcurlywedge --- */
      {   9,  214,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x02\x81\xa0\x50\x28\xa2\x20" }  },
      /* --- pixel bitmap for stmary83 char#10 \minuso --- */
      {  10,  251,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\xf8\x87\x1e" }  },
      /* --- pixel bitmap for stmary83 char#11 \baro --- */
      {  11,  272,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  3,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x74\x49\x02" }  },
      /* --- pixel bitmap for stmary83 char#12 \sslash --- */
      {  12,  297,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x94\x52\xa5\x94\x52\xaa\x94\x02" }  },
      /* --- pixel bitmap for stmary83 char#13 \bblash --- */
      {  13,  352,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa5\x14\xa5\x94\x52\x8a\x52\x0a" }  },
      /* --- pixel bitmap for stmary83 char#14 \moo --- */
      {  14,  407,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\xfc\xba\x01" }  },
      /* --- pixel bitmap for stmary83 char#15 \varotimes --- */
      {  15,  430,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xd7\xed\x00" }  },
      /* --- pixel bitmap for stmary83 char#16 \varoast --- */
      {  16,  455,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xae\xde\xea\x00" }  },
      /* --- pixel bitmap for stmary83 char#17 \varobar --- */
      {  17,  482,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xae\xd6\xea\x00" }  },
      /* --- pixel bitmap for stmary83 char#18 \varodot --- */
      {  18,  511,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xd6\xe8\x00" }  },
      /* --- pixel bitmap for stmary83 char#19 \varoslash --- */
      {  19,  536,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xd7\xe9\x00" }  },
      /* --- pixel bitmap for stmary83 char#20 \varobslash --- */
      {  20,  561,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xd6\xec\x00" }  },
      /* --- pixel bitmap for stmary83 char#21 \varocircle --- */
      {  21,  586,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xae\xee\xea\x00" }  },
      /* --- pixel bitmap for stmary83 char#22 \varoplus --- */
      {  22,  613,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xae\xfe\xea\x00" }  },
      /* --- pixel bitmap for stmary83 char#23 \varominus --- */
      {  23,  638,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xfe\xe8\x00" }  },
      /* --- pixel bitmap for stmary83 char#24 \boxast --- */
      {  24,  659,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\xde\xfa\x01" }  },
      /* --- pixel bitmap for stmary83 char#25 \boxbar --- */
      {  25,  686,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbf\xd6\xfa\x01" }  },
      /* --- pixel bitmap for stmary83 char#26 \boxdot --- */
      {  26,  715,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\xd6\xf8\x01" }  },
      /* --- pixel bitmap for stmary83 char#27 \boxslash --- */
      {  27,  740,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\xd7\xf9\x01" }  },
      /* --- pixel bitmap for stmary83 char#28 \boxbslash --- */
      {  28,  765,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\xd6\xfc\x01" }  },
      /* --- pixel bitmap for stmary83 char#29 \boxcircle --- */
      {  29,  790,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\xd8\xb6\xe1\x0f" }  },
      /* --- pixel bitmap for stmary83 char#30 \boxbox --- */
      {  30,  821,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xef\xff\x01" }  },
      /* --- pixel bitmap for stmary83 char#31 \boxempty --- */
      {  31,  840,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\xc6\xf8\x01" }  },
      /* --- pixel bitmap for stmary83 char#32 \lightning --- */
      {  32,  863,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  3,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x74\x4a\x17" }  },
      /* --- pixel bitmap for stmary83 char#33 \merge --- */
      {  33,  890,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x14\x8a\x4a\xa5\x52\x55\xab" }  },
      /* --- pixel bitmap for stmary83 char#34 \vartimes --- */
      {  34,  945,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  3,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xad\x24\xb5" }  },
      /* --- pixel bitmap for stmary83 char#35 \fatsemi --- */
      {  35,  976,                      /* character number, location */
          6, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  2,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x6f" }  },
      /* --- pixel bitmap for stmary83 char#36 \sswarrow --- */
      {  36,  997,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x44\x44\x22\x27" }  },
      /* --- pixel bitmap for stmary83 char#37 \ssearrow --- */
      {  37, 1024,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x22\x22\x44\x4e" }  },
      /* --- pixel bitmap for stmary83 char#38 \curlywedgeuparrow --- */
      {  38, 1051,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x07\x81\xa0\x50\x28\xa2\x20" }  },
      /* --- pixel bitmap for stmary83 char#39 \curlywedgedownarrow --- */
      {  39, 1088,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x02\x81\xa0\x50\xaa\xe3\x31" }  },
      /* --- pixel bitmap for stmary83 char#40 \fatslash --- */
      {  40, 1129,                      /* character number, location */
          9, 3,   -3, 3,      /* topleft row,col, and botleft row,col */
          {  6,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x49\x49\x92\x24\x29\x4a\x92\x3c" }  },
      /* --- pixel bitmap for stmary83 char#41 \fatbslash --- */
      {  41, 1180,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2f\xa5\x14\xa3\x94\x52\x4a\x0f" }  },
      /* --- pixel bitmap for stmary83 char#42 \lbag --- */
      {  42, 1231,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  4,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x24\x22\x12\x11\xe1" }  },
      /* --- pixel bitmap for stmary83 char#43 \rbag --- */
      {  43, 1262,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4b\x24\x89\x24\x07" }  },
      /* --- pixel bitmap for stmary83 char#44 \varbigcirc --- */
      {  44, 1293,                      /* character number, location */
          7, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3c\x42\x81\x81\x81\x81\x42\x3c" }  },
      /* --- pixel bitmap for stmary83 char#45 \leftrightarroweq --- */
      {  45, 1328,                      /* character number, location */
          6, 0,    0, 0,      /* topleft row,col, and botleft row,col */
          {  8,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\xff\x42\x00\x00\x7e" }  },
      /* --- pixel bitmap for stmary83 char#46 \curlyveedownarrow --- */
      {  46, 1349,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x11\x85\x42\x41\x20\x38\x08\x04" }  },
      /* --- pixel bitmap for stmary83 char#47 \curlyveeuparrow --- */
      {  47, 1386,                      /* character number, location */
          8, 0,   -2, 0,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe3\x71\x95\x42\x41\x20\x10\x08\x04" }  },
      /* --- pixel bitmap for stmary83 char#48 \nnwarrow --- */
      {  48, 1427,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\x22\x44\x44\x88" }  },
      /* --- pixel bitmap for stmary83 char#49 \nnearrow --- */
      {  49, 1454,                      /* character number, location */
          8, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe4\x44\x22\x22\x11" }  },
      /* --- pixel bitmap for stmary83 char#50 \leftslice --- */
      {  50, 1481,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x3b\xb2\x10" }  },
      /* --- pixel bitmap for stmary83 char#51 \rightslice --- */
      {  51, 1504,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x13\x37\x02" }  },
      /* --- pixel bitmap for stmary83 char#52 \varolessthan --- */
      {  52, 1527,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xae\xcf\xee\x00" }  },
      /* --- pixel bitmap for stmary83 char#53 \varogreaterthan --- */
      {  53, 1550,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xee\xe6\xeb\x00" }  },
      /* --- pixel bitmap for stmary83 char#54 \varovee --- */
      {  54, 1573,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x6e\xef\xea\x00" }  },
      /* --- pixel bitmap for stmary83 char#55 \varowedge --- */
      {  55, 1598,                      /* character number, location */
          5, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xae\xee\xed\x00" }  },
      /* --- pixel bitmap for stmary83 char#56 \talloblong --- */
      {  56, 1623,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  5,   13, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xa1\x31\x05" }  },
      /* --- pixel bitmap for stmary83 char#57 \interleave --- */
      {  57, 1678,                      /* character number, location */
          9,-1,   -4,-1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x01\x31\x31" }  },
      /* --- pixel bitmap for stmary83 char#58 \obar --- */
      {  58, 1763,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x96\xa6\x69\x9a\x6a\x0c" }  },
      /* --- pixel bitmap for stmary83 char#59 \oslash --- */
      {  59, 1812,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x34\x96\x65\x1a\x4b\x0c" }  },
      /* --- pixel bitmap for stmary83 char#60 \olessthan --- */
      {  60, 1857,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x94\x9e\xe1\x99\x4a\x0c" }  },
      /* --- pixel bitmap for stmary83 char#61 \ogreaterthan --- */
      {  61, 1900,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x54\xe6\x61\x5e\x4a\x0c" }  },
      /* --- pixel bitmap for stmary83 char#62 \ovee --- */
      {  62, 1943,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\x34\xcf\x73\xdb\x7a\x0c" }  },
      /* --- pixel bitmap for stmary83 char#63 \owedge --- */
      {  63, 1984,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8c\xd7\xb6\xf3\x3c\x4b\x0c" }  },
      /* --- pixel bitmap for stmary83 char#64 \oblong --- */
      {  64, 2025,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\xc6\x18\xe3\x07" }  },
      /* --- pixel bitmap for stmary83 char#65 \inplus --- */
      {  65, 2056,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5c\x84\xf2\x4b\x10\x1c" }  },
      /* --- pixel bitmap for stmary83 char#66 \niplus --- */
      {  66, 2085,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x41\xfa\x29\x44\x07" }  },
      /* --- pixel bitmap for stmary83 char#67 \nplus --- */
      {  67, 2114,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  5,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc6\x1a\x63\x04" }  },
      /* --- pixel bitmap for stmary83 char#68 \subsetplus --- */
      {  68, 2149,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x10\x24\x5d\x12\x08\x3c" }  },
      /* --- pixel bitmap for stmary83 char#69 \supsetplus --- */
      {  69, 2180,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x04\x92\x2e\x09\x42\x0f" }  },
      /* --- pixel bitmap for stmary83 char#70 \subsetpluseq --- */
      {  70, 2211,                      /* character number, location */
          7, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xbc\x10\x24\x5d\x12\x08\x3c\x00\x00\x3f" }  },
      /* --- pixel bitmap for stmary83 char#71 \supsetpluseq --- */
      {  71, 2246,                      /* character number, location */
          7, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x04\x92\x2e\x09\x42\x0f\x00\x00\x3f" }  },
      /* --- pixel bitmap for stmary83 char#72 \Lbag --- */
      {  72, 2281,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xad\x55\x95" }  },
      /* --- pixel bitmap for stmary83 char#73 \Rbag --- */
      {  73, 2312,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  2,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\xaa\x6a" }  },
      /* --- pixel bitmap for stmary83 char#74 \llbracket --- */
      {  74, 2343,                      /* character number, location */
          9, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  4,   12, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\x92\x24" }  },
      /* --- pixel bitmap for stmary83 char#75 \rrbracket --- */
      {  75, 2374,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   12, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xf9\x12\x03" }  },
      /* --- pixel bitmap for stmary83 char#76 \llparenthesis --- */
      {  76, 2405,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  2,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\xff\xbf\x02" }  },
      /* --- pixel bitmap for stmary83 char#77 \rrparenthesis --- */
      {  77, 2438,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  2,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\xff\x7f\x01" }  },
      /* --- pixel bitmap for stmary83 char#78 \binampersand --- */
      {  78, 2471,                      /* character number, location */
          6, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\xa2\x98\x79\xec\x00" }  },
      /* --- pixel bitmap for stmary83 char#79 \bindnasrepma --- */
      {  79, 2502,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdc\x78\x66\x14\x85\x00" }  },
      /* --- pixel bitmap for stmary83 char#80 \trianglelefteqslant --- */
      {  80, 2533,                      /* character number, location */
          7, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\xcc\x8a\xa1\xc8\xc2\xa1\xc0\x40\x20" }  },
      /* --- pixel bitmap for stmary83 char#81 \trianglerighteqslant --- */
      {  81, 2578,                      /* character number, location */
          7, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xd0\x44\x61\xd4\x0c\x21\xc4\x08\x01" }  },
      /* --- pixel bitmap for stmary83 char#82 \ntrianglelefteqslant --- */
      {  82, 2623,                      /* character number, location */
          9, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x04\xe3\xac\x5a\x9a\xaa\x3c\x1e\x08\x04\x02" }  },
      /* --- pixel bitmap for stmary83 char#83 \ntrianglerighteqslant --- */
      {  83, 2680,                      /* character number, location */
          9, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x14\x5d\x49\x56\x76\xc7\x30\x66\x84\x10\x00" }  },
      /* --- pixel bitmap for stmary83 char#84 \llfloor --- */
      {  84, 2735,                      /* character number, location */
          9,-4,   -4,-4,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x01\x31\x49" }  },
      /* --- pixel bitmap for stmary83 char#85 \rrfloor --- */
      {  85, 2792,                      /* character number, location */
          9, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x41\x31\x09" }  },
      /* --- pixel bitmap for stmary83 char#86 \llceil --- */
      {  86, 2849,                      /* character number, location */
          8,-4,   -3,-4,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\x91\x31\x43" }  },
      /* --- pixel bitmap for stmary83 char#87 \rrceil --- */
      {  87, 2898,                      /* character number, location */
          8, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xf9\x41\x31" }  },
      /* --- pixel bitmap for stmary83 char#88 \arrownot --- */
      {  88, 2947,                      /* character number, location */
          5, 3,    1, 3,      /* topleft row,col, and botleft row,col */
          {  4,    4, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x12" }  },
      /* --- pixel bitmap for stmary83 char#89 \Arrownot --- */
      {  89, 2962,                      /* character number, location */
          7, 4,   -1, 4,      /* topleft row,col, and botleft row,col */
          {  2,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x55" }  },
      /* --- pixel bitmap for stmary83 char#90 \Mapstochar --- */
      {  90, 2985,                      /* character number, location */
          7, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01" }  },
      /* --- pixel bitmap for stmary83 char#91 \mapsfromchar --- */
      {  91, 3010,                      /* character number, location */
          5,-2,    0,-2,      /* topleft row,col, and botleft row,col */
          {  1,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for stmary83 char#92 \Mapsfromchar --- */
      {  92, 3046,                      /* character number, location */
          7,-2,   -2,-2,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01" }  },
      /* --- pixel bitmap for stmary83 char#93 \leftrightarrowtriangle --- */
      {  93, 3090,                      /* character number, location */
          4, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7e\x99\x7e" }  },
      /* --- pixel bitmap for stmary83 char#94 \leftarrowtriangle --- */
      {  94, 3107,                      /* character number, location */
          4, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfd\x06" }  },
      /* --- pixel bitmap for stmary83 char#95 \rightarrowtriangle --- */
      {  95, 3122,                      /* character number, location */
          4, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  8,    3, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\xbf\x60" }  },
      /* --- pixel bitmap for stmary83 char#96 \bigtriangledown --- */
      {  96, 3137,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xa0\x48\x24\x12\x51\x28\x14\x04\x02" }  },
      /* --- pixel bitmap for stmary83 char#97 \bigtriangleup --- */
      {  97, 3201,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x85\x42\x11\x89\x44\xa2\xe0\x1f" }  },
      /* --- pixel bitmap for stmary83 char#98 \bigcurlyvee --- */
      {  98, 3265,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x11\x85\x82\x40\x20\x10\x08\x04\x02" }  },
      /* --- pixel bitmap for stmary83 char#99 \bigcurlywedge --- */
      {  99, 3321,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x02\x81\x40\x20\x28\x14\x51\x10" }  },
      /* --- pixel bitmap for stmary83 char#100 \bigsqcap --- */
      { 100, 3377,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\x91\x51" }  },
      /* --- pixel bitmap for stmary83 char#101 \bigbox --- */
      { 101, 3445,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\x81\x51\x07" }  },
      /* --- pixel bitmap for stmary83 char#102 \bigparallel --- */
      { 102, 3511,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  2,   11, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x02" }  },
      /* --- pixel bitmap for stmary83 char#103 \biginterleave --- */
      { 103, 3559,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  5,   11, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x01\x11\x11" }  },
      /* --- pixel bitmap for stmary83 char#104 (noname) --- */
      { 104, 3651,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x81\xf3\x11\x61\x10\xf2\x21\x41\x20\xf2\x31\x21"
            "\x30\xf2\x42\x40\x51\x42" }  },
      /* --- pixel bitmap for stmary83 char#105 (noname) --- */
      { 105, 3731,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x40\xf2\x42\x40\xf2\x31\x21\x30\xf2\x21\x41\x20"
            "\xf3\x11\x61\x11\x8b" }  },
      /* --- pixel bitmap for stmary83 char#106 (noname) --- */
      { 106, 3811,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x11\x61\x31\x41\x20\xf1\x31\x21\x30\xf9\x42"
            "\x40\x51\x41" }  },
      /* --- pixel bitmap for stmary83 char#107 (noname) --- */
      { 107, 3879,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x40\xf9\x42\x40\xf1\x31\x21\x30\x21\x41\x31\x61"
            "\x11\x81" }  },
      /* --- pixel bitmap for stmary83 char#108 (noname) --- */
      { 108, 3947,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x0f\xe1\x81" }  },
      /* --- pixel bitmap for stmary83 char#109 (noname) --- */
      { 109, 4035,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x0f\xd1\x81\x0a" }  },
      /* --- pixel bitmap for stmary83 char#110 (noname) --- */
      { 110, 4121,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          {  3,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x11\x01\x11" }  },
      /* --- pixel bitmap for stmary83 char#111 (noname) --- */
      { 111, 4211,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          {  9,   16, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x31\x31\x01\x31\x31" }  },
      /* --- pixel bitmap for stmary83 char#112 \bignplus --- */
      { 112, 4333,                      /* character number, location */
          0, 1,  -11, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\x98\xec\x26\x83\xc1\x60\x10" }  },
      /* --- pixel bitmap for stmary83 char#113 (noname) --- */
      { 113, 4407,                      /* character number, location */
          0, 2,  -12, 2,      /* topleft row,col, and botleft row,col */
          {  3,   12, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x0f\x92\x13" }  },
      /* --- pixel bitmap for stmary83 char#114 (noname) --- */
      { 114, 4457,                      /* character number, location */
          0, 2,  -19, 2,      /* topleft row,col, and botleft row,col */
          {  4,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x11\x1f\x11\x11\x14" }  },
      /* --- pixel bitmap for stmary83 char#115 (noname) --- */
      { 115, 4555,                      /* character number, location */
          0, 3,  -26, 3,      /* topleft row,col, and botleft row,col */
          {  3,   26, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x0f\xe2\x1f\x82\x13" }  },
      /* --- pixel bitmap for stmary83 char#116 (noname) --- */
      { 116, 4633,                      /* character number, location */
          0, 3,  -33, 3,      /* topleft row,col, and botleft row,col */
          {  4,   33, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x11\x1f\xe1\x11\x11\x11\x14" }  },
      /* --- pixel bitmap for stmary83 char#117 (noname) --- */
      { 117, 4787,                      /* character number, location */
         -1, 4,  -20, 4,      /* topleft row,col, and botleft row,col */
          {  4,   19, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x0f\xe1\x11\x1f\x21\x11\x11" }  },
      /* --- pixel bitmap for stmary83 char#118 (noname) --- */
      { 118, 4887,                      /* character number, location */
          0, 4,  -19, 4,      /* topleft row,col, and botleft row,col */
          {  4,   19, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x11\x1f\x21\x11\x14" }  },
      /* --- pixel bitmap for stmary83 char#119 (noname) --- */
      { 119, 4987,                      /* character number, location */
          1, 4,   -8, 4,      /* topleft row,col, and botleft row,col */
          {  3,    9, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x11" }  },
      /* --- pixel bitmap for stmary83 char#120 (noname) --- */
      { 120, 5030,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x22\x50\x80\x01\x06\x18\x62\x88\xfd\x86\x18"
            "\x62\x80\x01\x06\x18\x60\x80" }  },
      /* --- pixel bitmap for stmary83 char#121 (noname) --- */
      { 121, 5128,                      /* character number, location */
          0, 0,  -12, 0,      /* topleft row,col, and botleft row,col */
          {  3,   12, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xf9\x12\x03" }  },
      /* --- pixel bitmap for stmary83 char#122 (noname) --- */
      { 122, 5178,                      /* character number, location */
          0, 0,  -19, 0,      /* topleft row,col, and botleft row,col */
          {  4,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x11\x11\xf1\x11\x11\x04" }  },
      /* --- pixel bitmap for stmary83 char#123 (noname) --- */
      { 123, 5276,                      /* character number, location */
          0, 0,  -26, 0,      /* topleft row,col, and botleft row,col */
          {  3,   26, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xfe\x12\xf8\x12\x03" }  },
      /* --- pixel bitmap for stmary83 char#124 (noname) --- */
      { 124, 5354,                      /* character number, location */
          0, 0,  -33, 0,      /* topleft row,col, and botleft row,col */
          {  4,   33, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x11\x11\xfe\x11\x11\x11\x15" }  },
      /* --- pixel bitmap for stmary83 char#125 (noname) --- */
      { 125, 5508,                      /* character number, location */
         -1, 0,  -20, 0,      /* topleft row,col, and botleft row,col */
          {  4,   19, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfe\x11\x11\xf2\x11\x11" }  },
      /* --- pixel bitmap for stmary83 char#126 (noname) --- */
      { 126, 5608,                      /* character number, location */
          0, 0,  -19, 0,      /* topleft row,col, and botleft row,col */
          {  4,   19, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x11\x11\xf2\x11\x11\x04" }  },
      /* --- pixel bitmap for stmary83 char#127 (noname) --- */
      { 127, 5708,                      /* character number, location */
          1, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          {  3,    9, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x01\x11" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=1 for .100gf ---
 * mf '\mode=preview; mag=magstep(-17.87427405946994351363); input stmary10'
 * --------------------------------------------------------------------- */
/* --- fontdef for stmary100 --- */
static	chardef  stmary100[] =
   {
      /* --- pixel bitmap for stmary100 char#0 \shortleftarrow --- */
      {   0,  922,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x04\xfc\x17\x40\x00" }  },
      /* --- pixel bitmap for stmary100 char#1 \shortrightarrow --- */
      {   1, 1827,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\xfd\x07\x04\x04" }  },
      /* --- pixel bitmap for stmary100 char#2 \shortuparrow --- */
      {   2, 2592,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc4\x55\x42\x08\x21\x04" }  },
      /* --- pixel bitmap for stmary100 char#3 \shortdownarrow --- */
      {   3, 3371,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  5,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x10\x42\x48\x75\x04" }  },
      /* --- pixel bitmap for stmary100 char#4 \Yup --- */
      {   4, 3930,                      /* character number, location */
          7, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x82\x30\x52\x08" }  },
      /* --- pixel bitmap for stmary100 char#5 \Ydown --- */
      {   5, 4471,                      /* character number, location */
          6, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\xc4\x20\x08\x02" }  },
      /* --- pixel bitmap for stmary100 char#6 \Yleft --- */
      {   6, 5053,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa0\x87\x40\x20" }  },
      /* --- pixel bitmap for stmary100 char#7 \Yright --- */
      {   7, 5630,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x4f\x08\x01" }  },
      /* --- pixel bitmap for stmary100 char#8 \varcurlyvee --- */
      {   8, 6223,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x05\x11\x21\x82\x02\x05\x0a\x08\x10\x20\x40\x80"
            "\x00\x01" }  },
      /* --- pixel bitmap for stmary100 char#9 \varcurlywedge --- */
      {   9, 6858,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x20\x40\x80\x00\x01\x02\x0a\x14\x28\x88\x10\x11"
            "\x14\x10" }  },
      /* --- pixel bitmap for stmary100 char#10 \minuso --- */
      {  10, 7621,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x88\xfc\x27\x82\x03" }  },
      /* --- pixel bitmap for stmary100 char#11 \baro --- */
      {  11, 8255,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xe2\xa5\x69\xea\x21\x08" }  },
      /* --- pixel bitmap for stmary100 char#12 \sslash --- */
      {  12, 8875,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x50\x28\x0a\x85\xa2\x50\x28\x0a\x85\xa2\x50\x00" }  },
      /* --- pixel bitmap for stmary100 char#13 \bblash --- */
      {  13, 9518,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x85\x82\x42\xa1\xa0\x50\x28\x28\x14\x0a\x0a\x05" }  },
      /* --- pixel bitmap for stmary100 char#14 \moo --- */
      {  14,10275,                      /* character number, location */
          7, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  7,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\xe2\x8f\x48\xda\x00" }  },
      /* --- pixel bitmap for stmary100 char#15 \varotimes --- */
      {  15,11006,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x19\x4b\x19\x31\xa5\x31\x63\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#16 \varoast --- */
      {  16,11884,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x49\xea\x9b\xb3\xaf\x24\x63\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#17 \varobar --- */
      {  17,12635,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xac\x49\x8a\x18\x31\xa2\x24\x6b\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#18 \varodot --- */
      {  18,13381,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x09\x0a\x18\x31\xa0\x20\x63\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#19 \varoslash --- */
      {  19,14126,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x09\x0b\x19\x31\xa1\x21\x63\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#20 \varobslash --- */
      {  20,14879,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x19\x4a\x18\x31\xa4\x30\x63\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#21 \varocircle --- */
      {  21,15771,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\xe9\x2a\x5a\xb4\xa8\x2e\x63\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#22 \varoplus --- */
      {  22,16529,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xac\x49\x8a\xf8\x3f\xa2\x24\x6b\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#23 \varominus --- */
      {  23,17282,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x09\x0a\xf8\x3f\xa0\x20\x63\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#24 \boxast --- */
      {  24,18071,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03\x46\xec\x9b\xb3\x6f\xc4\x80\xff\x01" }  },
      /* --- pixel bitmap for stmary100 char#25 \boxbar --- */
      {  25,18750,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\x61\x31\x31\x09" }  },
      /* --- pixel bitmap for stmary100 char#26 \boxdot --- */
      {  26,19433,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03\x06\x0c\x18\x31\x60\xc0\x80\xff\x01" }  },
      /* --- pixel bitmap for stmary100 char#27 \boxslash --- */
      {  27,20106,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03\x07\x0d\x19\x31\x61\xc1\x81\xff\x01" }  },
      /* --- pixel bitmap for stmary100 char#28 \boxbslash --- */
      {  28,20788,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x07\x16\x4c\x18\x31\x64\xd0\xc0\xff\x01" }  },
      /* --- pixel bitmap for stmary100 char#29 \boxcircle --- */
      {  29,21448,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x81\x99\xa5\xa5\x99\x81\xff" }  },
      /* --- pixel bitmap for stmary100 char#30 \boxbox --- */
      {  30,22125,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03\xe6\x2c\x5a\xb4\x68\xce\x80\xff\x01" }  },
      /* --- pixel bitmap for stmary100 char#31 \boxempty --- */
      {  31,22806,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\x61\x71\x09" }  },
      /* --- pixel bitmap for stmary100 char#32 \lightning --- */
      {  32,23649,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  5,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x21\x44\x38\x45\x08\x1d\x4f\x00" }  },
      /* --- pixel bitmap for stmary100 char#33 \merge --- */
      {  33,24392,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x30\x43\x0b\x2d\xb4\xc8\x24\x93\x4c\x49\x26\x09" }  },
      /* --- pixel bitmap for stmary100 char#34 \vartimes --- */
      {  34,24995,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  6,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\x24\x31\x0c\xc3\x48\x52\x08" }  },
      /* --- pixel bitmap for stmary100 char#35 \fatsemi --- */
      {  35,25528,                      /* character number, location */
          8, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x00\xd5\x94\x00" }  },
      /* --- pixel bitmap for stmary100 char#36 \sswarrow --- */
      {  36,26367,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x08\x04\x82\x40\x30\x08\xc4\xc1\x43\x00" }  },
      /* --- pixel bitmap for stmary100 char#37 \ssearrow --- */
      {  37,27208,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\x40\x20\x20\x10\x18\x08\x04\x9c\x07\x01" }  },
      /* --- pixel bitmap for stmary100 char#38 \curlywedgeuparrow --- */
      {  38,28160,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x20\xf0\x81\x00\x01\x02\x0a\x14\x28\x88\x10\x11"
            "\x14\x10" }  },
      /* --- pixel bitmap for stmary100 char#39 \curlywedgedownarrow --- */
      {  39,29128,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x41\x40\xf2\x31\x11\x3f\x11\x11\x31\x11\x02\x55"
            "\x33" }  },
      /* --- pixel bitmap for stmary100 char#40 \fatslash --- */
      {  40,29750,                      /* character number, location */
         10, 4,   -3, 4,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x90\x88\x48\x48\x44\x24\x24\x22\x12\x12\x11\x0f" }  },
      /* --- pixel bitmap for stmary100 char#41 \fatbslash --- */
      {  41,30380,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0f\x09\x12\x12\x12\x24\x24\x24\x48\x48\x48\x90\xf0" }  },
      /* --- pixel bitmap for stmary100 char#42 \lbag --- */
      {  42,30909,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\x44\x24\x22\x22\x22\x0c" }  },
      /* --- pixel bitmap for stmary100 char#43 \rbag --- */
      {  43,31419,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xac\x22\x42\x44\x44\x44\x03" }  },
      /* --- pixel bitmap for stmary100 char#44 \varbigcirc --- */
      {  44,32267,                      /* character number, location */
         10, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   12, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x36\x51\x61\x31\x81\x1f\x51\xa1\x11\x81\x31\x61\x56"
            "\x31" }  },
      /* --- pixel bitmap for stmary100 char#45 \leftrightarroweq --- */
      {  45,33245,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x04\xfd\x17\x44\x04\xc0\x7f" }  },
      /* --- pixel bitmap for stmary100 char#46 \curlyveedownarrow --- */
      {  46,33813,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x05\x11\x21\x82\x02\x05\x0a\x08\x10\x20\xf0\x81"
            "\x00\x01" }  },
      /* --- pixel bitmap for stmary100 char#47 \curlyveeuparrow --- */
      {  47,34401,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc7\x07\x17\x2d\x8a\x02\x05\x0a\x08\x10\x20\x40\x80"
            "\x00\x01" }  },
      /* --- pixel bitmap for stmary100 char#48 \nnwarrow --- */
      {  48,34952,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xcf\x01\x81\xc0\x40\x20\x20\x10\x08\x08\x04" }  },
      /* --- pixel bitmap for stmary100 char#49 \nnearrow --- */
      {  49,35481,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x1e\x1c\x81\x60\x10\x08\x02\x81\x20\x10\x00" }  },
      /* --- pixel bitmap for stmary100 char#50 \leftslice --- */
      {  50,36198,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\xe0\x31\x1c\xc8\x10\x1e\x20" }  },
      /* --- pixel bitmap for stmary100 char#51 \rightslice --- */
      {  51,36910,                      /* character number, location */
          7, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x3c\x84\x09\x1c\xc6\x83\x00" }  },
      /* --- pixel bitmap for stmary100 char#52 \varolessthan --- */
      {  52,37644,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\xc9\x6b\x38\xb0\xa1\x3c\x63\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#53 \varogreaterthan --- */
      {  53,38397,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x79\x0a\x1b\x38\xac\x27\x63\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#54 \varovee --- */
      {  54,39142,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x8c\x19\x2b\x5a\x34\xa5\x2a\x6b\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#55 \varowedge --- */
      {  55,39903,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\xac\xa9\x4a\x59\xb4\xa8\x31\x63\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#56 \talloblong --- */
      {  56,40480,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xa1\x31\x05" }  },
      /* --- pixel bitmap for stmary100 char#57 \interleave --- */
      {  57,41188,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x01\x31\x31" }  },
      /* --- pixel bitmap for stmary100 char#58 \obar --- */
      {  58,41966,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x24\x45\x8c\x18\x31\x62\x44\x49\x7c\x00" }  },
      /* --- pixel bitmap for stmary100 char#59 \oslash --- */
      {  59,42718,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x15\x4c\x18\x31\x64\x50\x41\x7c\x00" }  },
      /* --- pixel bitmap for stmary100 char#60 \olessthan --- */
      {  60,43465,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\xc5\x6d\x38\xb0\x61\x5c\x41\x7c\x00" }  },
      /* --- pixel bitmap for stmary100 char#61 \ogreaterthan --- */
      {  61,44213,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x75\x0c\x1b\x38\x6c\x47\x41\x7c\x00" }  },
      /* --- pixel bitmap for stmary100 char#62 \ovee --- */
      {  62,44953,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x15\x2d\x5a\x34\x65\x4a\x49\x7c\x00" }  },
      /* --- pixel bitmap for stmary100 char#63 \owedge --- */
      {  63,45709,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x24\xa5\x4c\x59\xb4\x68\x51\x41\x7c\x00" }  },
      /* --- pixel bitmap for stmary100 char#64 \oblong --- */
      {  64,46353,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\x61\x51\x07" }  },
      /* --- pixel bitmap for stmary100 char#65 \inplus --- */
      {  65,47032,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x41\x20\xf1\x4f\x04\x04\x7c" }  },
      /* --- pixel bitmap for stmary100 char#66 \niplus --- */
      {  66,47710,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x10\x10\xf9\x47\x02\x41\x1f" }  },
      /* --- pixel bitmap for stmary100 char#67 \nplus --- */
      {  67,48392,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x51\x30\xd9\x4d\x06\x83\x41" }  },
      /* --- pixel bitmap for stmary100 char#68 \subsetplus --- */
      {  68,49150,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x05\x04\x08\x11\x27\x44\x00\x01\xfc\x01" }  },
      /* --- pixel bitmap for stmary100 char#69 \supsetplus --- */
      {  69,49894,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x00\x01\x44\xc8\x11\x21\x40\x40\x7f\x00" }  },
      /* --- pixel bitmap for stmary100 char#70 \subsetpluseq --- */
      {  70,50656,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x27\x11\x71\x81\x41\x31\x33\x21\x41\x31\x91\x97\xf2"
            "\x99" }  },
      /* --- pixel bitmap for stmary100 char#71 \supsetpluseq --- */
      {  71,51424,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x00\x01\x44\xc8\x11\x21\x40\x40\x7f\x00\x00\x00"
            "\xf0\x1f" }  },
      /* --- pixel bitmap for stmary100 char#72 \Lbag --- */
      {  72,52155,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x44\x22\x12\x11\x21\x0c" }  },
      /* --- pixel bitmap for stmary100 char#73 \Rbag --- */
      {  73,52605,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa4\x22\x44\x84\x88\x48\x03" }  },
      /* --- pixel bitmap for stmary100 char#74 \llbracket --- */
      {  74,53438,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  5,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xa2\x35" }  },
      /* --- pixel bitmap for stmary100 char#75 \rrbracket --- */
      {  75,54270,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xfa\x22\x04" }  },
      /* --- pixel bitmap for stmary100 char#76 \llparenthesis --- */
      {  76,54934,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb4\xdb\xb6\xad\x4d" }  },
      /* --- pixel bitmap for stmary100 char#77 \rrparenthesis --- */
      {  77,55613,                      /* character number, location */
         10, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd9\xda\xb6\xed\x16" }  },
      /* --- pixel bitmap for stmary100 char#78 \binampersand --- */
      {  78,56348,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x88\x10\x21\xc1\x51\x62\xb8\x70\x1e\x01" }  },
      /* --- pixel bitmap for stmary100 char#79 \bindnasrepma --- */
      {  79,56989,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x1c\x3a\x8c\x14\x07\x09\x11\x22\x38\x00" }  },
      /* --- pixel bitmap for stmary100 char#80 \trianglelefteqslant --- */
      {  80,57705,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x81\xc3\x64\x38\xd0\x20\x46\xb0\x81\x0d\x60\x00"
            "\x03\x18" }  },
      /* --- pixel bitmap for stmary100 char#81 \trianglerighteqslant --- */
      {  81,58428,                      /* character number, location */
          9, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x0e\x64\x08\x13\x38\x58\x8c\x06\x03\x81\xc1\x60"
            "\x30\x00" }  },
      /* --- pixel bitmap for stmary100 char#82 \ntrianglelefteqslant --- */
      {  82,59197,                      /* character number, location */
         11, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x01\x05\x0e\x93\xe5\x44\x8b\x18\xd1\x26\x36"
            "\xc0\x41\x8c\x60" }  },
      /* --- pixel bitmap for stmary100 char#83 \ntrianglerighteqslant --- */
      {  83,59989,                      /* character number, location */
         11, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x00\x05\x39\x92\x23\x4c\xe4\x68\x31\x1a\x2c\x24"
            "\x46\xc3\xc1\x00" }  },
      /* --- pixel bitmap for stmary100 char#84 \llfloor --- */
      {  84,60625,                      /* character number, location */
         10,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x01\x31\x49" }  },
      /* --- pixel bitmap for stmary100 char#85 \rrfloor --- */
      {  85,61255,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x41\x31\x09" }  },
      /* --- pixel bitmap for stmary100 char#86 \llceil --- */
      {  86,61871,                      /* character number, location */
         10,-1,   -3,-1,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\xb1\x31\x43" }  },
      /* --- pixel bitmap for stmary100 char#87 \rrceil --- */
      {  87,62488,                      /* character number, location */
         10, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   13, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xfb\x41\x31" }  },
      /* --- pixel bitmap for stmary100 char#88 \arrownot --- */
      {  88,62863,                      /* character number, location */
          6, 5,    1, 5,      /* topleft row,col, and botleft row,col */
          {  4,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x22\x01" }  },
      /* --- pixel bitmap for stmary100 char#89 \Arrownot --- */
      {  89,63205,                      /* character number, location */
          8, 5,   -1, 5,      /* topleft row,col, and botleft row,col */
          {  4,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x44\x22\x22\x01" }  },
      /* --- pixel bitmap for stmary100 char#90 \Mapstochar --- */
      {  90,63578,                      /* character number, location */
          8, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01" }  },
      /* --- pixel bitmap for stmary100 char#91 \mapsfromchar --- */
      {  91,63863,                      /* character number, location */
          6,-2,    1,-2,      /* topleft row,col, and botleft row,col */
          {  1,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f" }  },
      /* --- pixel bitmap for stmary100 char#92 \Mapsfromchar --- */
      {  92,64159,                      /* character number, location */
          8,-2,   -1,-2,      /* topleft row,col, and botleft row,col */
          {  1,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01" }  },
      /* --- pixel bitmap for stmary100 char#93 \leftrightarrowtriangle --- */
      {  93,64974,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 12,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\x61\x69\xf1\x68\x69\x98\x01" }  },
      /* --- pixel bitmap for stmary100 char#94 \leftarrowtriangle --- */
      {  94,65775,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 12,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x60\x01\xf1\x6f\x01\x18\x00" }  },
      /* --- pixel bitmap for stmary100 char#95 \rightarrowtriangle --- */
      {  95,66563,                      /* character number, location */
          6, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 12,    5, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x01\x68\xff\x08\x68\x80\x01" }  },
      /* --- pixel bitmap for stmary100 char#96 \bigtriangledown --- */
      {  96,67237,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x07\x28\x90\x40\x02\x11\x42\x08\x21\x48\x20\x81"
            "\x04\x0c\x30\x80\x00" }  },
      /* --- pixel bitmap for stmary100 char#97 \bigtriangleup --- */
      {  97,67962,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\xc0\x00\x03\x12\x48\x20\x41\x08\x21\x84\x08\x24"
            "\x90\x40\x01\xfe\x0f" }  },
      /* --- pixel bitmap for stmary100 char#98 \bigcurlyvee --- */
      {  98,68685,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x11\x61\x31\x41\x20\xf1\x31\x21\x30\xf7\x42"
            "\x40\x51\x41" }  },
      /* --- pixel bitmap for stmary100 char#99 \bigcurlywedge --- */
      {  99,69400,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x40\xf7\x42\x40\xf1\x31\x21\x30\x21\x41\x31\x61"
            "\x11\x81" }  },
      /* --- pixel bitmap for stmary100 char#100 \bigsqcap --- */
      { 100,70143,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x0f\xc1\x81" }  },
      /* --- pixel bitmap for stmary100 char#101 \bigbox --- */
      { 101,70882,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x0f\xb1\x81\x0a" }  },
      /* --- pixel bitmap for stmary100 char#102 \bigparallel --- */
      { 102,71449,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          {  4,   14, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x01\x21" }  },
      /* --- pixel bitmap for stmary100 char#103 \biginterleave --- */
      { 103,72169,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          {  7,   14, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x01\x21\x21" }  },
      /* --- pixel bitmap for stmary100 char#104 (noname) --- */
      { 104,73063,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xb1\xf2\x11\x91\x10\xf2\x21\x71\x20\xf2\x31\x51"
            "\x30\xf2\x41\x31\x40\xf2\x51\x11\x50\xf1\x61\x61" }  },
      /* --- pixel bitmap for stmary100 char#105 (noname) --- */
      { 105,73943,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x61\x60\xf2\x51\x11\x50\xf2\x41\x31\x40\xf2\x31"
            "\x51\x30\xf2\x21\x71\x20\xf2\x11\x91\x11\xbe" }  },
      /* --- pixel bitmap for stmary100 char#106 (noname) --- */
      { 106,74821,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xb1\x11\x91\x31\x71\x51\x51\x30\xf1\x41\x31\x40"
            "\xf3\x51\x11\x50\xf8\x61\x62" }  },
      /* --- pixel bitmap for stmary100 char#107 (noname) --- */
      { 107,75689,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x61\x60\xf3\x51\x11\x50\xf1\x41\x31\x40\x31\x51"
            "\x51\x71\x31\x91\x11\xb1" }  },
      /* --- pixel bitmap for stmary100 char#108 (noname) --- */
      { 108,76578,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xe1\xb1\x0f\x21\xb1" }  },
      /* --- pixel bitmap for stmary100 char#109 (noname) --- */
      { 109,77470,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xe1\xb1\x0f\x11\xb1\x0d" }  },
      /* --- pixel bitmap for stmary100 char#110 (noname) --- */
      { 110,78112,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          {  6,   19, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x41\x0f\x31\x41" }  },
      /* --- pixel bitmap for stmary100 char#111 (noname) --- */
      { 111,78985,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 11,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x41\x41\x0f\x31\x41\x41" }  },
      /* --- pixel bitmap for stmary100 char#112 \bignplus --- */
      { 112,79877,                      /* character number, location */
          0, 1,  -14, 1,      /* topleft row,col, and botleft row,col */
          { 10,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x10\x22\x50\x80\x01\x86\x18\x62\xbf\x21\x86\x18"
            "\x60\x80\x01\x06\x08" }  },
      /* --- pixel bitmap for stmary100 char#113 (noname) --- */
      { 113,80833,                      /* character number, location */
          1, 2,  -15, 2,      /* topleft row,col, and botleft row,col */
          {  5,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xd1\x11\x25" }  },
      /* --- pixel bitmap for stmary100 char#114 (noname) --- */
      { 114,81818,                      /* character number, location */
          1, 3,  -23, 3,      /* topleft row,col, and botleft row,col */
          {  5,   24, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x11\x2f\x61\x11\x25" }  },
      /* --- pixel bitmap for stmary100 char#115 (noname) --- */
      { 115,82836,                      /* character number, location */
          1, 3,  -32, 3,      /* topleft row,col, and botleft row,col */
          {  6,   33, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x11\x3f\xe1\x11\x31\x11\x36" }  },
      /* --- pixel bitmap for stmary100 char#116 (noname) --- */
      { 116,83916,                      /* character number, location */
          1, 4,  -40, 4,      /* topleft row,col, and botleft row,col */
          {  6,   41, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x00\xff\x26\x01\x02\x01\x02\x06" }  },
      /* --- pixel bitmap for stmary100 char#117 (noname) --- */
      { 117,84971,                      /* character number, location */
          0, 5,  -24, 5,      /* topleft row,col, and botleft row,col */
          {  6,   24, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x21\x2f\x71\x21\x2f" }  },
      /* --- pixel bitmap for stmary100 char#118 (noname) --- */
      { 118,85888,                      /* character number, location */
          1, 5,  -23, 5,      /* topleft row,col, and botleft row,col */
          {  6,   24, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x21\x2f\x71\x21\x26" }  },
      /* --- pixel bitmap for stmary100 char#119 (noname) --- */
      { 119,86796,                      /* character number, location */
          1, 5,   -9, 5,      /* topleft row,col, and botleft row,col */
          {  4,   10, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x01\x21" }  },
      /* --- pixel bitmap for stmary100 char#120 (noname) --- */
      { 120,87728,                      /* character number, location */
          0, 1,  -19, 1,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x71\x51\x51\x71\x31\x91\x1f\x11\xb1\x0f\x31\x51"
            "\x51\x01\x19\x11\x0f\x31\x51\x51\x0f\x31\xb1" }  },
      /* --- pixel bitmap for stmary100 char#121 (noname) --- */
      { 121,88699,                      /* character number, location */
          1, 0,  -15, 0,      /* topleft row,col, and botleft row,col */
          {  5,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfd\x21\x11\x05" }  },
      /* --- pixel bitmap for stmary100 char#122 (noname) --- */
      { 122,89645,                      /* character number, location */
          1, 0,  -23, 0,      /* topleft row,col, and botleft row,col */
          {  5,   24, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x21\x11\xf6\x21\x11\x05" }  },
      /* --- pixel bitmap for stmary100 char#123 (noname) --- */
      { 123,90650,                      /* character number, location */
          1, 0,  -32, 0,      /* topleft row,col, and botleft row,col */
          {  6,   33, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x31\x11\xfe\x31\x11\x31\x17" }  },
      /* --- pixel bitmap for stmary100 char#124 (noname) --- */
      { 124,91691,                      /* character number, location */
          1, 0,  -40, 0,      /* topleft row,col, and botleft row,col */
          {  6,   41, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\xff\x26\x02\x01\x02\x01\x00\x06" }  },
      /* --- pixel bitmap for stmary100 char#125 (noname) --- */
      { 125,92733,                      /* character number, location */
          0, 0,  -24, 0,      /* topleft row,col, and botleft row,col */
          {  6,   24, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x21\x21\xf7\x21\x21" }  },
      /* --- pixel bitmap for stmary100 char#126 (noname) --- */
      { 126,93731,                      /* character number, location */
          1, 0,  -23, 0,      /* topleft row,col, and botleft row,col */
          {  6,   24, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x21\x21\xf7\x21\x21\x06" }  },
      /* --- pixel bitmap for stmary100 char#127 (noname) --- */
      { 127,94626,                      /* character number, location */
          1, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          {  4,   10, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf9\x01\x21" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=2 for .118gf ---
 * mf '\mode=preview; mag=magstep(-16.96645799324018499600); input stmary10'
 * --------------------------------------------------------------------- */
/* --- fontdef for stmary118 --- */
static	chardef  stmary118[] =
   {
      /* --- pixel bitmap for stmary118 char#0 \shortleftarrow --- */
      {   0,  922,                      /* character number, location */
          7, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 11,    5, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\x91\x9b\x11\xb1\x80" }  },
      /* --- pixel bitmap for stmary118 char#1 \shortrightarrow --- */
      {   1, 1827,                      /* character number, location */
          7, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 11,    5, 3,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\xb1\x1b\x91\x91\x20" }  },
      /* --- pixel bitmap for stmary118 char#2 \shortuparrow --- */
      {   2, 2592,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc4\x55\x42\x08\x21\x84\x10" }  },
      /* --- pixel bitmap for stmary118 char#3 \shortdownarrow --- */
      {   3, 3375,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          {  5,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x84\x10\x42\x08\x21\xd5\x11" }  },
      /* --- pixel bitmap for stmary118 char#4 \Yup --- */
      {   4, 3938,                      /* character number, location */
          9, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x02\x81\xa0\x88\x82" }  },
      /* --- pixel bitmap for stmary118 char#5 \Ydown --- */
      {   5, 4485,                      /* character number, location */
          8, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x11\x05\x81\x40\x20\x10" }  },
      /* --- pixel bitmap for stmary118 char#6 \Yleft --- */
      {   6, 5073,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x40\x3e\x10\x20\x40\x80" }  },
      /* --- pixel bitmap for stmary118 char#7 \Yright --- */
      {   7, 5654,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          {  8,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x02\xfc\x08\x04\x02\x01" }  },
      /* --- pixel bitmap for stmary118 char#8 \varcurlyvee --- */
      {   8, 6251,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 11,   14, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x91\x11\x71\x31\x51\x20\xf1\x31\x31\x30\xf2\x41"
            "\x11\x40\xf5\x51\x50" }  },
      /* --- pixel bitmap for stmary118 char#9 \varcurlywedge --- */
      {   9, 6890,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 11,   14, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x51\x50\xf2\x41\x11\x40\xf1\x31\x31\x30\x21\x51"
            "\x31\x71\x11\x91" }  },
      /* --- pixel bitmap for stmary118 char#10 \minuso --- */
      {  10, 7657,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 11,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x40\x04\x41\xfe\x4f\x10\x44\xc0\x01" }  },
      /* --- pixel bitmap for stmary118 char#11 \baro --- */
      {  11, 8299,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x04\x47\x95\x4c\x26\x55\x1c\x04\x02" }  },
      /* --- pixel bitmap for stmary118 char#12 \sslash --- */
      {  12, 8931,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x41\x42\x82\x04\x09\x09\x12\x24\x24\x48\x90\x90"
            "\x20\x41\x42\x82\x04" }  },
      /* --- pixel bitmap for stmary118 char#13 \bblash --- */
      {  13, 9586,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x12\x48\x90\x20\x81\x04\x09\x12\x48\x90\x20\x81"
            "\x04\x09\x12\x48\x90" }  },
      /* --- pixel bitmap for stmary118 char#14 \moo --- */
      {  14,10355,                      /* character number, location */
          9, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x20\x40\x80\xf0\x1f\x02\x84\x94\xc6\x00" }  },
      /* --- pixel bitmap for stmary118 char#15 \varotimes --- */
      {  15,11092,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\xc1\x12\x19\xc5\x10\x46\x31\x91\x06\x23"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#16 \varoast --- */
      {  16,11986,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x88\x42\x98\xcf\x18\xe6\x33\x84\x22\x22"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#17 \varobar --- */
      {  17,12749,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x89\x88\x42\x18\xc2\x10\x86\x30\x84\x22\x22"
            "\x09\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#18 \varodot --- */
      {  18,13507,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x80\x02\x18\xc2\x38\x86\x30\x80\x02\x22"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#19 \varoslash --- */
      {  19,14264,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\xc0\x02\x19\xc4\x10\x46\x30\x81\x06\x22"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#20 \varobslash --- */
      {  20,15029,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x81\x12\x18\xc1\x10\x06\x31\x90\x02\x23"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#21 \varocircle --- */
      {  21,15933,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x88\xb2\x99\xc8\x82\x26\x32\x9b\x22\x22"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#22 \varoplus --- */
      {  22,16707,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x89\x88\x42\x18\xc2\xff\x87\x30\x84\x22\x22"
            "\x09\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#23 \varominus --- */
      {  23,17472,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x80\x02\x18\xc0\xff\x07\x30\x80\x02\x22"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#24 \boxast --- */
      {  24,18269,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x60\x08\x43\x98\xcf\x18\xe6\x33\x84\x21\x0c"
            "\xe0\xff\x01" }  },
      /* --- pixel bitmap for stmary118 char#25 \boxbar --- */
      {  25,18960,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x0f\x81\x41\x41\x0b" }  },
      /* --- pixel bitmap for stmary118 char#26 \boxdot --- */
      {  26,19655,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x0f\x21\x91\x01\x41\x42\x33\x32\x41\x41\x0f\x21"
            "\x91\x0b" }  },
      /* --- pixel bitmap for stmary118 char#27 \boxslash --- */
      {  27,20340,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x70\x40\x03\x19\xc4\x10\x46\x30\x81\x05\x1c"
            "\xe0\xff\x01" }  },
      /* --- pixel bitmap for stmary118 char#28 \boxbslash --- */
      {  28,21034,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f\x60\x01\x13\x18\xc1\x10\x06\x31\x90\x01\x0d"
            "\xf0\xff\x01" }  },
      /* --- pixel bitmap for stmary118 char#29 \boxcircle --- */
      {  29,21706,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x07\x18\x60\x8c\x49\x26\x19\x63\x80\x01\xfe\x0f" }  },
      /* --- pixel bitmap for stmary118 char#30 \boxbox --- */
      {  30,22391,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x60\x00\xf3\x99\xc8\x44\x26\x32\x9f\x01\x0c"
            "\xe0\xff\x01" }  },
      /* --- pixel bitmap for stmary118 char#31 \boxempty --- */
      {  31,23080,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x0f\x81\x91\x0b" }  },
      /* --- pixel bitmap for stmary118 char#32 \lightning --- */
      {  32,23931,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x84\x20\x08\xc9\x43\x10\x82\x28\x3e\x01" }  },
      /* --- pixel bitmap for stmary118 char#33 \merge --- */
      {  33,24678,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x01\x63\xa0\x0a\x54\x41\x44\x88\x88\x10\x12\x45"
            "\xa2\x28\x14\x46\x44" }  },
      /* --- pixel bitmap for stmary118 char#34 \vartimes --- */
      {  34,25295,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  7,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x41\x91\x88\x42\x41\x50\x28\x22\x51\x10" }  },
      /* --- pixel bitmap for stmary118 char#35 \fatsemi --- */
      {  35,25838,                      /* character number, location */
          9, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\x00\xa8\xa6\x04" }  },
      /* --- pixel bitmap for stmary118 char#36 \sswarrow --- */
      {  36,26677,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x80\x40\x40\x20\x20\x20\x10\x10\x08\x08\x0e\x3e"
            "\x04" }  },
      /* --- pixel bitmap for stmary118 char#37 \ssearrow --- */
      {  37,27520,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\x40\x40\x20\x10\x10\x08\x08\x04\xce\x07\x01" }  },
      /* --- pixel bitmap for stmary118 char#38 \curlywedgeuparrow --- */
      {  38,28474,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x00\x01\x3e\x40\x00\x02\x10\x40\x01\x0a\x50\x40"
            "\x04\x22\x08\x22\xa0\x00\x02" }  },
      /* --- pixel bitmap for stmary118 char#39 \curlywedgedownarrow --- */
      {  39,29446,                      /* character number, location */
         11, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x00\x01\x08\x40\x00\x02\x10\x40\x01\x0a\x50\x40"
            "\x44\x22\x0b\x3a\xe0\x01\x23\x02" }  },
      /* --- pixel bitmap for stmary118 char#40 \fatslash --- */
      {  40,30076,                      /* character number, location */
         12, 5,   -4, 5,      /* topleft row,col, and botleft row,col */
          { 10,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x83\x04\x11\x44\x90\x20\x82\x08\x12\x44\x10\x41"
            "\x82\x08\x22\x48\x10\xc1\x07" }  },
      /* --- pixel bitmap for stmary118 char#41 \fatbslash --- */
      {  41,30718,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 10,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x44\x20\x81\x08\x22\x90\x40\x04\x11\x48\x20\x82"
            "\x08\x24\x10\x41\x04\x12\xf8" }  },
      /* --- pixel bitmap for stmary118 char#42 \lbag --- */
      {  42,31259,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  5,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x26\x21\x44\x08\x21\x44\x08\x21\x84\xc1" }  },
      /* --- pixel bitmap for stmary118 char#43 \rbag --- */
      {  43,31775,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  5,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\x0a\x41\x08\x21\x04\x21\x84\x10\x1b" }  },
      /* --- pixel bitmap for stmary118 char#44 \varbigcirc --- */
      {  44,32629,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 14,   14, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x82\x42\x51\x81\x20\xf1\x11\xa1\x1f\x31\xc1\xf1"
            "\x11\xa1\x10\x21\x81\x52\x42\x84\x51" }  },
      /* --- pixel bitmap for stmary118 char#45 \leftrightarroweq --- */
      {  45,33615,                      /* character number, location */
          9, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 11,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x11\xd0\xff\x05\x44\x10\x00\xfc\x1f" }  },
      /* --- pixel bitmap for stmary118 char#46 \curlyveedownarrow --- */
      {  46,34183,                      /* character number, location */
         11, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 11,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x14\x10\x41\x10\x81\x08\x28\x40\x01\x0a\x20\x00"
            "\x01\x08\xf0\x01\x02\x10\x00" }  },
      /* --- pixel bitmap for stmary118 char#47 \curlyveeuparrow --- */
      {  47,34775,                      /* character number, location */
         12, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x18\xf0\x80\x0b\x9a\x48\x44\x40\x01\x0a\x50\x00"
            "\x01\x08\x40\x00\x02\x10\x80\x00" }  },
      /* --- pixel bitmap for stmary118 char#48 \nnwarrow --- */
      {  48,35334,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  8,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x3e\x0e\x08\x08\x10\x10\x20\x20\x20\x40\x40\x80"
            "\x80" }  },
      /* --- pixel bitmap for stmary118 char#49 \nnearrow --- */
      {  49,35865,                      /* character number, location */
         11, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  7,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x3e\x1c\x02\x41\x20\x08\x04\x82\x40\x10\x08\x00" }  },
      /* --- pixel bitmap for stmary118 char#50 \leftslice --- */
      {  50,36584,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 11,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x83\x23\x03\x07\xc8\x40\x38\x02\x0e" }  },
      /* --- pixel bitmap for stmary118 char#51 \rightslice --- */
      {  51,37300,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 11,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x88\x43\x60\x02\x1c\x98\x38\x38\x00" }  },
      /* --- pixel bitmap for stmary118 char#52 \varolessthan --- */
      {  52,38038,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\xe0\xe2\xd8\xc0\x01\x36\x30\x8e\x82\x23"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#53 \varogreaterthan --- */
      {  53,38803,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x83\xe2\x18\xd8\x00\x07\x36\x8e\x0e\x22"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#54 \varovee --- */
      {  54,39560,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\xc1\x0a\x9a\xc8\x44\x26\x32\x8a\x52\x22"
            "\x09\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#55 \varowedge --- */
      {  55,40337,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x89\x94\xa2\x98\xc8\x44\x26\xb2\xa0\x06\x23"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#56 \talloblong --- */
      {  56,40930,                      /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  6,   15, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xc1\x41\x06" }  },
      /* --- pixel bitmap for stmary118 char#57 \interleave --- */
      {  57,41646,                      /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  9,   15, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x31\x31" }  },
      /* --- pixel bitmap for stmary118 char#58 \obar --- */
      {  58,42436,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x89\x88\x42\x18\xc2\x10\x86\x30\x84\x22\x22"
            "\x09\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#59 \oslash --- */
      {  59,43200,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x81\x12\x18\xc1\x10\x06\x31\x90\x02\x23"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#60 \olessthan --- */
      {  60,43955,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\xe0\xe2\xd8\xc0\x01\x36\x30\x8e\x82\x23"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#61 \ogreaterthan --- */
      {  61,44711,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\x83\xe2\x18\xd8\x00\x07\x36\x8e\x0e\x22"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#62 \ovee --- */
      {  62,45459,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x88\xc1\x0a\x9a\xc8\x44\x26\x32\x8a\x52\x22"
            "\x09\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#63 \owedge --- */
      {  63,46227,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x20\x89\x94\xa2\x98\xc8\x44\x26\xb2\xa0\x06\x23"
            "\x08\x3e\x00" }  },
      /* --- pixel bitmap for stmary118 char#64 \oblong --- */
      {  64,46883,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\x71\x71\x09" }  },
      /* --- pixel bitmap for stmary118 char#65 \inplus --- */
      {  65,47566,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x09\x08\x88\x10\xe1\x7f\x84\x08\x02\x08\xe0\x07" }  },
      /* --- pixel bitmap for stmary118 char#66 \niplus --- */
      {  66,48252,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  9,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x80\x00\x82\x08\xf1\x3f\x44\x88\x80\x80\xfc\x00" }  },
      /* --- pixel bitmap for stmary118 char#67 \nplus --- */
      {  67,48942,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x04\x05\x8c\x18\xb1\x6f\xc4\x88\x01\x03\x02" }  },
      /* --- pixel bitmap for stmary118 char#68 \subsetplus --- */
      {  68,49708,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x21\x91\x9f\x11\x51\x41\x35\x2f\x11\x51\x40\x11"
            "\xb1\xb8" }  },
      /* --- pixel bitmap for stmary118 char#69 \supsetplus --- */
      {  69,50460,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x00\x08\x80\x20\x08\x41\x3e\x42\x10\x82\x00\x02"
            "\xc8\x3f\x00" }  },
      /* --- pixel bitmap for stmary118 char#70 \subsetpluseq --- */
      {  70,51230,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x38\x21\x91\x9f\x11\x51\x41\x35\x2f\x11\x51\x40\x11"
            "\xb1\xb8\xf2\xbb" }  },
      /* --- pixel bitmap for stmary118 char#71 \supsetpluseq --- */
      {  71,52006,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xb1\xb1\x10\xf1\x41\x51\x25\x31\xf1\x41\x51\x91"
            "\x91\x28\x30\xf2\xbb" }  },
      /* --- pixel bitmap for stmary118 char#72 \Lbag --- */
      {  72,52745,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  5,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x26\x21\x42\x88\x10\x22\x84\x10\x82\xe0" }  },
      /* --- pixel bitmap for stmary118 char#73 \Rbag --- */
      {  73,53201,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  5,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x4c\x0a\x42\x08\x42\x08\x42\x08\x21\x3a" }  },
      /* --- pixel bitmap for stmary118 char#74 \llbracket --- */
      {  74,54040,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xd1\x11\x36" }  },
      /* --- pixel bitmap for stmary118 char#75 \rrbracket --- */
      {  75,54906,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  5,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfd\x21\x11\x05" }  },
      /* --- pixel bitmap for stmary118 char#76 \llparenthesis --- */
      {  76,55604,                      /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc8\xaa\x99\x99\x99\xa9\xca\x08" }  },
      /* --- pixel bitmap for stmary118 char#77 \rrparenthesis --- */
      {  77,56295,                      /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          {  4,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\x55\x99\x99\x99\x59\x35\x01" }  },
      /* --- pixel bitmap for stmary118 char#78 \binampersand --- */
      {  78,57042,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x20\x04\x21\x08\x81\x04\x1e\x8a\x30\x58\x01\x09"
            "\x96\x0f\x01" }  },
      /* --- pixel bitmap for stmary118 char#79 \bindnasrepma --- */
      {  79,57695,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\xd3\x20\x01\x35\x18\xa2\xf0\x40\x02\x21\x08\x41"
            "\x08\x3c\x00" }  },
      /* --- pixel bitmap for stmary118 char#80 \trianglelefteqslant --- */
      {  80,58423,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x04\x38\x30\x61\xc8\xc0\x01\x1a\x10\x83\x60\x0c"
            "\xac\x81\x31\x00\x06\xc0\x00\x18" }  },
      /* --- pixel bitmap for stmary118 char#81 \trianglerighteqslant --- */
      {  81,59156,                      /* character number, location */
         10, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x38\x40\x06\xc2\x10\x98\x00\x07\x2c\x18\x31\x68"
            "\xe0\xc0\x80\x01\x03\x06\x0c\x00" }  },
      /* --- pixel bitmap for stmary118 char#82 \ntrianglelefteqslant --- */
      {  82,59935,                      /* character number, location */
         13, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x08\x40\x00\x0d\x58\x70\x62\xd1\x88\x23\x64"
            "\x21\x0c\xa1\xb9\x70\x06\xe2\x80\x18\x04\x13\x20" }  },
      /* --- pixel bitmap for stmary118 char#83 \ntrianglerighteqslant --- */
      {  83,60743,                      /* character number, location */
         13, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x08\x40\x06\xd1\x88\x58\x04\x23\x68\x21\x0e"
            "\x4d\x1c\x32\xf0\xe0\xc4\xa0\x81\x03\x06\x18\x00" }  },
      /* --- pixel bitmap for stmary118 char#84 \llfloor --- */
      {  84,61393,                      /* character number, location */
         12, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   15, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x01\x31\x49" }  },
      /* --- pixel bitmap for stmary118 char#85 \rrfloor --- */
      {  85,62031,                      /* character number, location */
         12, 0,   -3, 0,      /* topleft row,col, and botleft row,col */
          {  9,   15, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfd\x41\x31\x09" }  },
      /* --- pixel bitmap for stmary118 char#86 \llceil --- */
      {  86,62655,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  9,   17, 3,13, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\xe1\x31\x41\x31\x41" }  },
      /* --- pixel bitmap for stmary118 char#87 \rrceil --- */
      {  87,63288,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          {  9,   17, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xfe\x41\x31\x41\x31" }  },
      /* --- pixel bitmap for stmary118 char#88 \arrownot --- */
      {  88,63679,                      /* character number, location */
          7, 6,    1, 6,      /* topleft row,col, and botleft row,col */
          {  4,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x24\x12" }  },
      /* --- pixel bitmap for stmary118 char#89 \Arrownot --- */
      {  89,64023,                      /* character number, location */
          9, 6,   -1, 6,      /* topleft row,col, and botleft row,col */
          {  4,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x48\x44\x24\x22\x12" }  },
      /* --- pixel bitmap for stmary118 char#90 \Mapstochar --- */
      {  90,64398,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  1,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x07" }  },
      /* --- pixel bitmap for stmary118 char#91 \mapsfromchar --- */
      {  91,64687,                      /* character number, location */
          8,-2,    1,-2,      /* topleft row,col, and botleft row,col */
          {  1,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f" }  },
      /* --- pixel bitmap for stmary118 char#92 \Mapsfromchar --- */
      {  92,64987,                      /* character number, location */
         10,-2,   -1,-2,      /* topleft row,col, and botleft row,col */
          {  1,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x07" }  },
      /* --- pixel bitmap for stmary118 char#93 \leftrightarrowtriangle --- */
      {  93,65806,                      /* character number, location */
          7, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 14,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x86\x85\x16\x3f\x4a\x48\x14\x0a\x86\x01" }  },
      /* --- pixel bitmap for stmary118 char#94 \leftarrowtriangle --- */
      {  94,66615,                      /* character number, location */
          7, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 14,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x80\x05\x10\xff\x4b\x00\x14\x00\x06\x00" }  },
      /* --- pixel bitmap for stmary118 char#95 \rightarrowtriangle --- */
      {  95,67407,                      /* character number, location */
          7, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 14,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x80\xf6\x3f\x02\x48\x00\x0a\x80\x01" }  },
      /* --- pixel bitmap for stmary118 char#96 \bigtriangledown --- */
      {  96,68085,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\xa1\xf2\x11\x81\x10\xf1\x21\x61\x20\xf2\x31\x41"
            "\x30\xf2\x41\x21\x40\xf1\x52\x50\x61\x51" }  },
      /* --- pixel bitmap for stmary118 char#97 \bigtriangleup --- */
      {  97,68818,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,44, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x50\xf1\x52\x50\xf2\x41\x21\x40\xf2\x31\x41\x30"
            "\xf1\x21\x61\x20\xf2\x11\x81\x11\xad" }  },
      /* --- pixel bitmap for stmary118 char#98 \bigcurlyvee --- */
      {  98,69549,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xa1\x11\x81\x31\x61\x51\x41\x30\xf2\x41\x21\x40"
            "\xf7\x52\x50\x61\x52" }  },
      /* --- pixel bitmap for stmary118 char#99 \bigcurlywedge --- */
      {  99,70272,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x50\xf7\x52\x50\xf2\x41\x21\x40\x31\x41\x51\x61"
            "\x31\x81\x11\xa1" }  },
      /* --- pixel bitmap for stmary118 char#100 \bigsqcap --- */
      { 100,71023,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0f\xe1\xa1" }  },
      /* --- pixel bitmap for stmary118 char#101 \bigbox --- */
      { 101,71770,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x0f\xd1\xa1\x0c" }  },
      /* --- pixel bitmap for stmary118 char#102 \bigparallel --- */
      { 102,72345,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          {  5,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x31\x01\x31" }  },
      /* --- pixel bitmap for stmary118 char#103 \biginterleave --- */
      { 103,73099,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          {  9,   16, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x31\x31\x01\x31\x31" }  },
      /* --- pixel bitmap for stmary118 char#104 (noname) --- */
      { 104,74005,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\xe1\xf2\x11\xc1\x10\xf2\x21\xa1\x20\xf2\x31"
            "\x81\x30\xf2\x41\x61\x40\xf2\x51\x41\x50\xf2\x61\x21"
            "\x60\xf1\x72\x70\x81\x72" }  },
      /* --- pixel bitmap for stmary118 char#105 (noname) --- */
      { 105,74899,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x70\xf1\x72\x70\xf2\x61\x21\x60\xf2\x51\x41\x50"
            "\xf2\x41\x61\x40\xf2\x31\x81\x30\xf2\x21\xa1\x20\xf2"
            "\x11\xc1\x11\xee\x03" }  },
      /* --- pixel bitmap for stmary118 char#106 (noname) --- */
      { 106,75791,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe1\x12\xa2\x10\xf1\x31\x81\x30\x41\x61\x40\xf1"
            "\x51\x41\x50\xf2\x61\x21\x60\xfb\x72\x70\x81\x70" }  },
      /* --- pixel bitmap for stmary118 char#107 (noname) --- */
      { 107,76667,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x70\xfb\x72\x70\xf2\x61\x21\x60\xf1\x51\x41\x50"
            "\x41\x61\x40\xf1\x31\x81\x30\x12\xa2\x11\xe1" }  },
      /* --- pixel bitmap for stmary118 char#108 (noname) --- */
      { 108,77564,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x0f\xe1\xe1\x0f\x61\xe1" }  },
      /* --- pixel bitmap for stmary118 char#109 (noname) --- */
      { 109,78472,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x0f\xe1\xe1\x0f\x51\xe1\x0e\x02" }  },
      /* --- pixel bitmap for stmary118 char#110 (noname) --- */
      { 110,79130,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          {  7,   23, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x51\x0f\x71\x51" }  },
      /* --- pixel bitmap for stmary118 char#111 (noname) --- */
      { 111,79993,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 13,   23, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x51\x51\x0f\x71\x51\x51" }  },
      /* --- pixel bitmap for stmary118 char#112 \bignplus --- */
      { 112,80909,                      /* character number, location */
          0, 1,  -16, 1,      /* topleft row,col, and botleft row,col */
          { 12,   16, 3,44, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x44\x62\x42\x31\x81\x1f\x11\xa1\x0f\x21\x51\x41\x01"
            "\x18\x11\x0f\x21\x51\x41\x0f\x31\xa1" }  },
      /* --- pixel bitmap for stmary118 char#113 (noname) --- */
      { 113,81877,                      /* character number, location */
          1, 3,  -18, 3,      /* topleft row,col, and botleft row,col */
          {  6,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x11\x3f\x11\x11\x36" }  },
      /* --- pixel bitmap for stmary118 char#114 (noname) --- */
      { 114,82874,                      /* character number, location */
          1, 4,  -28, 4,      /* topleft row,col, and botleft row,col */
          {  6,   29, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x11\x3f\xb1\x11\x36" }  },
      /* --- pixel bitmap for stmary118 char#115 (noname) --- */
      { 115,83912,                      /* character number, location */
          1, 4,  -38, 4,      /* topleft row,col, and botleft row,col */
          {  6,   39, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x00\xff\x24\x01\x02\x01\x02\x06" }  },
      /* --- pixel bitmap for stmary118 char#116 (noname) --- */
      { 116,85042,                      /* character number, location */
          1, 5,  -47, 5,      /* topleft row,col, and botleft row,col */
          {  6,   48, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\x00\xff\x2d\x01\x02\x01\x02\x06" }  },
      /* --- pixel bitmap for stmary118 char#117 (noname) --- */
      { 117,86151,                      /* character number, location */
          0, 6,  -29, 6,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\xe1\x21\x3f\xc1\x21\x3f" }  },
      /* --- pixel bitmap for stmary118 char#118 (noname) --- */
      { 118,87114,                      /* character number, location */
          1, 6,  -28, 6,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x21\x3f\xc1\x21\x37" }  },
      /* --- pixel bitmap for stmary118 char#119 (noname) --- */
      { 119,88068,                      /* character number, location */
          1, 6,  -11, 6,      /* topleft row,col, and botleft row,col */
          {  4,   12, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x01\x21" }  },
      /* --- pixel bitmap for stmary118 char#120 (noname) --- */
      { 120,89008,                      /* character number, location */
          0, 1,  -23, 1,      /* topleft row,col, and botleft row,col */
          { 16,   23, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x82\x62\x51\xa1\x20\xf1\x11\xc1\x1f\x11\xe1\x0f"
            "\x41\x71\x61\x01\x1c\x11\x0f\x41\x71\x61\x0f\x41\xe1" }  },
      /* --- pixel bitmap for stmary118 char#121 (noname) --- */
      { 121,89999,                      /* character number, location */
          1, 0,  -18, 0,      /* topleft row,col, and botleft row,col */
          {  6,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x31\x11\xf1\x31\x11\x06" }  },
      /* --- pixel bitmap for stmary118 char#122 (noname) --- */
      { 122,90957,                      /* character number, location */
          1, 0,  -28, 0,      /* topleft row,col, and botleft row,col */
          {  6,   29, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x31\x11\xfb\x31\x11\x06" }  },
      /* --- pixel bitmap for stmary118 char#123 (noname) --- */
      { 123,91982,                      /* character number, location */
          1, 0,  -38, 0,      /* topleft row,col, and botleft row,col */
          {  6,   39, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\xff\x24\x02\x01\x02\x01\x00\x06" }  },
      /* --- pixel bitmap for stmary118 char#124 (noname) --- */
      { 124,93073,                      /* character number, location */
          1, 0,  -47, 0,      /* topleft row,col, and botleft row,col */
          {  6,   48, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x06\xff\x2d\x02\x01\x02\x01\x00\x06" }  },
      /* --- pixel bitmap for stmary118 char#125 (noname) --- */
      { 125,94169,                      /* character number, location */
          0, 0,  -29, 0,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xfe\x31\x21\xfc\x31\x21" }  },
      /* --- pixel bitmap for stmary118 char#126 (noname) --- */
      { 126,95213,                      /* character number, location */
          1, 0,  -28, 0,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x31\x21\xfc\x31\x21\x07" }  },
      /* --- pixel bitmap for stmary118 char#127 (noname) --- */
      { 127,96154,                      /* character number, location */
          1, 3,  -11, 3,      /* topleft row,col, and botleft row,col */
          {  4,   12, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x01\x21" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=3 for .131gf ---
 * mf '\mode=preview; mag=magstep(-16.39322518098640003469); input stmary10'
 * --------------------------------------------------------------------- */
/* --- fontdef for stmary131 --- */
static	chardef  stmary131[] =
   {
      /* --- pixel bitmap for stmary131 char#0 \shortleftarrow --- */
      {   0,  948,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 12,    7, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x21\x90\x11\xac\x11\xa0\xf1\x21\x90" }  },
      /* --- pixel bitmap for stmary131 char#1 \shortrightarrow --- */
      {   1, 1883,                      /* character number, location */
          8, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 12,    7, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x91\x20\xa1\x1c\xa1\x10\xf1\x91\x20" }  },
      /* --- pixel bitmap for stmary131 char#2 \shortuparrow --- */
      {   2, 2678,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\x53\x31\x11\x11\x11\x21\x21\xf8\x31\x30" }  },
      /* --- pixel bitmap for stmary131 char#3 \shortdownarrow --- */
      {   3, 3495,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  7,   13, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x31\x31\x21\x21\x11\x11\x11\x33\x51\x30" }  },
      /* --- pixel bitmap for stmary131 char#4 \Yup --- */
      {   4, 4092,                      /* character number, location */
         10, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x10\x10\x10\x10\x10\x18\x24\x42\x81" }  },
      /* --- pixel bitmap for stmary131 char#5 \Ydown --- */
      {   5, 4669,                      /* character number, location */
          9, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  8,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x42\x24\x18\x10\x10\x10\x10\x10\x10" }  },
      /* --- pixel bitmap for stmary131 char#6 \Yleft --- */
      {   6, 5287,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x01\xf1\x01\x02\x08\x10\x40\x00\x01" }  },
      /* --- pixel bitmap for stmary131 char#7 \Yright --- */
      {   7, 5898,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  9,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x04\x10\xc0\x8f\x80\x00\x01\x01\x01\x00" }  },
      /* --- pixel bitmap for stmary131 char#8 \varcurlyvee --- */
      {   8, 6551,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 13,   17, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xb1\x11\x91\x31\x71\x20\xf1\x31\x51\x30\xf1\x41"
            "\x31\x40\xf2\x51\x11\x50\xf6\x61\x60" }  },
      /* --- pixel bitmap for stmary131 char#9 \varcurlywedge --- */
      {   9, 7252,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 13,   17, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x61\x60\xf2\x51\x11\x50\xf1\x41\x31\x40\xf1\x31"
            "\x51\x30\x21\x71\x31\x91\x11\xb1" }  },
      /* --- pixel bitmap for stmary131 char#10 \minuso --- */
      {  10, 8055,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x10\x04\x42\x20\xff\x4f\x20\x04\x82\x10\xf0"
            "\x00" }  },
      /* --- pixel bitmap for stmary131 char#11 \baro --- */
      {  11, 8731,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x10\x10\x3c\x52\x91\x91\x91\x52\x3c\x10\x10\x10" }  },
      /* --- pixel bitmap for stmary131 char#12 \sslash --- */
      {  12, 9393,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 10,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x02\x09\x12\x48\x20\x41\x02\x09\x24\x48\x20\x81"
            "\x04\x09\x24\x90\x20\x81\x04\x12\x24\x90\x00" }  },
      /* --- pixel bitmap for stmary131 char#13 \bblash --- */
      {  13,10086,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 10,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x24\x20\x81\x04\x12\x90\x40\x02\x09\x48\x20\x81"
            "\x04\x24\x90\x40\x02\x12\x48\x20\x01\x09\x24" }  },
      /* --- pixel bitmap for stmary131 char#14 \moo --- */
      {  14,10919,                      /* character number, location */
          9, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 11,    9, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x51\x5b\xf1\x51\x51\x31\x11\x31\x13\x33\x10" }  },
      /* --- pixel bitmap for stmary131 char#15 \varotimes --- */
      {  15,11708,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x10\x05\x15\x11\x43\x61\x10\x0c\x85"
            "\x11\x51\x41\x11\x10\x04\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#16 \varoast --- */
      {  16,12670,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x11\x21\x94\x24\xe3\x63\x18\x8c\x8f"
            "\x49\x52\x08\x11\x11\x04\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#17 \varobar --- */
      {  17,13505,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x49\x10\x11\x21\x14\x04\x83\x60\x10\x0c\x82"
            "\x41\x50\x08\x11\x11\x24\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#18 \varodot --- */
      {  18,14327,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x10\x01\x14\x00\x83\x60\x38\x0c\x82"
            "\x01\x50\x00\x11\x10\x04\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#19 \varoslash --- */
      {  19,15144,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x10\x01\x15\x10\x03\x61\x10\x0c\x81"
            "\x11\x50\x01\x11\x10\x04\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#20 \varobslash --- */
      {  20,15973,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x10\x05\x14\x01\x43\x60\x10\x0c\x84"
            "\x01\x51\x40\x11\x10\x04\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#21 \varocircle --- */
      {  21,16941,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x10\x71\x14\x11\x13\x64\x82\x4c\x90"
            "\x11\x51\x1c\x11\x10\x04\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#22 \varoplus --- */
      {  22,17775,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x49\x10\x11\x21\x14\x04\x83\xe0\xff\x0f\x82"
            "\x41\x50\x08\x11\x11\x24\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#23 \varominus --- */
      {  23,18604,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x10\x01\x14\x00\x03\xe0\xff\x0f\x80"
            "\x01\x50\x00\x11\x10\x04\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#24 \boxast --- */
      {  24,19461,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x60\x08\x43\x98\xcf\x18\xe6\x33\x84\x21\x0c"
            "\xe0\xff\x01" }  },
      /* --- pixel bitmap for stmary131 char#25 \boxbar --- */
      {  25,20204,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x0f\x81\x41\x41\x0b" }  },
      /* --- pixel bitmap for stmary131 char#26 \boxdot --- */
      {  26,20951,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x0f\x21\x91\x01\x41\x42\x33\x32\x41\x41\x0f\x21"
            "\x91\x0b" }  },
      /* --- pixel bitmap for stmary131 char#27 \boxslash --- */
      {  27,21688,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x70\x40\x03\x19\xc4\x10\x46\x30\x81\x05\x1c"
            "\xe0\xff\x01" }  },
      /* --- pixel bitmap for stmary131 char#28 \boxbslash --- */
      {  28,22434,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f\x60\x01\x13\x18\xc1\x10\x06\x31\x90\x01\x0d"
            "\xf0\xff\x01" }  },
      /* --- pixel bitmap for stmary131 char#29 \boxcircle --- */
      {  29,23158,                      /* character number, location */
         10, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 10,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x07\x18\x60\x8c\x49\x26\x19\x63\x80\x01\xfe\x0f" }  },
      /* --- pixel bitmap for stmary131 char#30 \boxbox --- */
      {  30,23895,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0f\x60\x00\xf3\x99\xc8\x44\x26\x32\x9f\x01\x0c"
            "\xe0\xff\x01" }  },
      /* --- pixel bitmap for stmary131 char#31 \boxempty --- */
      {  31,24636,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0b\x0f\x81\x91\x0b" }  },
      /* --- pixel bitmap for stmary131 char#32 \lightning --- */
      {  32,25513,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  6,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x41\x08\x82\xd0\x2c\x04\x41\x48\x62\xf0\x04" }  },
      /* --- pixel bitmap for stmary131 char#33 \merge --- */
      {  33,26294,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 14,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x02\xcc\x80\x52\xa0\x14\xc8\x04\x31\x42\x8c\x10"
            "\x23\xc2\x90\x30\x24\x12\x85\x84\x21\x21" }  },
      /* --- pixel bitmap for stmary131 char#34 \vartimes --- */
      {  34,26947,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          {  8,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x42\x42\x24\x24\x18\x08\x18\x24\x24\x42\x42\x81" }  },
      /* --- pixel bitmap for stmary131 char#35 \fatsemi --- */
      {  35,27520,                      /* character number, location */
         10, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  4,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x96\x69\x00\x96\xe9\x48\x24" }  },
      /* --- pixel bitmap for stmary131 char#36 \sswarrow --- */
      {  36,28395,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x01\x02\x02\x04\x04\x08\x10\x10\x20\x20\x40\x80"
            "\x80\x20\x81\x03\x1e\x04\x00" }  },
      /* --- pixel bitmap for stmary131 char#37 \ssearrow --- */
      {  37,29272,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x02\x08\x10\x40\x80\x00\x01\x04\x08\x20\x40\x80"
            "\x00\x02\x24\x38\x3c\x40\x00" }  },
      /* --- pixel bitmap for stmary131 char#38 \curlywedgeuparrow --- */
      {  38,30286,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x00\x08\x80\x03\xac\x01\x04\x80\x00\x10\x00\x05"
            "\xa0\x00\x14\x40\x04\x88\x80\x20\x10\x04\x01\x11\x40"
            "\x01\x10" }  },
      /* --- pixel bitmap for stmary131 char#39 \curlywedgedownarrow --- */
      {  39,31324,                      /* character number, location */
         13, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x61\x60\xf2\x51\x11\x50\xf1\x41\x31\x40\x31\x51"
            "\x31\x21\x51\x22\x11\x71\x13\x95\x73\x31\x51\x31" }  },
      /* --- pixel bitmap for stmary131 char#40 \fatslash --- */
      {  40,31990,                      /* character number, location */
         14, 5,   -5, 5,      /* topleft row,col, and botleft row,col */
          { 11,   19, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\x61\x31\xf2\x51\x31\x10\xf2\x41\x31\x20\xf2\x31"
            "\x31\x30\xf2\x21\x31\x40\xf2\x11\x31\x51\x31\x65\x61" }  },
      /* --- pixel bitmap for stmary131 char#41 \fatbslash --- */
      {  41,32670,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 11,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x88\x80\x08\x44\x20\x02\x22\x10\x81\x08\x88\x40"
            "\x04\x22\x20\x02\x11\x88\x80\x08\x44\x20\x02\x22\xf0"
            "\x01" }  },
      /* --- pixel bitmap for stmary131 char#42 \lbag --- */
      {  42,33249,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  6,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x82\x20\x08\x82\x20\x04\x41\x10\x82\x20\x08\x02"
            "\x81\x03" }  },
      /* --- pixel bitmap for stmary131 char#43 \rbag --- */
      {  43,33797,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  6,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x49\x10\x04\x41\x10\x08\x82\x20\x10\x04\x41\x10"
            "\x72\x00" }  },
      /* --- pixel bitmap for stmary131 char#44 \varbigcirc --- */
      {  44,34683,                      /* character number, location */
         13, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x82\x62\x51\xa1\x20\xf1\x11\xc1\x1f\x51\xe1\xf1"
            "\x11\xc1\x10\x21\xa1\x52\x62\x86\x51" }  },
      /* --- pixel bitmap for stmary131 char#45 \leftrightarroweq --- */
      {  45,35703,                      /* character number, location */
         10, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 12,    8, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x42\x20\x02\xf4\xff\x02\x44\x20\x04\xf2\xff" }  },
      /* --- pixel bitmap for stmary131 char#46 \curlyveedownarrow --- */
      {  46,36329,                      /* character number, location */
         13, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 13,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x50\x00\x11\x10\x04\x81\x20\x20\x02\x44\x00\x05"
            "\xa0\x00\x14\x00\x01\x20\x00\x04\xb0\x06\x38\x00\x02"
            "\x40\x00" }  },
      /* --- pixel bitmap for stmary131 char#47 \curlyveeuparrow --- */
      {  47,36987,                      /* character number, location */
         14, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\x51\x33\x75\x93\x11\x71\x12\x21\x51\x21\x31\x51"
            "\x30\xf1\x41\x31\x40\xf2\x51\x11\x50\xf6\x61\x62" }  },
      /* --- pixel bitmap for stmary131 char#48 \nnwarrow --- */
      {  48,37582,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\x78\x38\x48\x80\x00\x02\x04\x08\x20\x40\x00\x01"
            "\x02\x04\x10\x20\x80\x00\x01" }  },
      /* --- pixel bitmap for stmary131 char#49 \nnearrow --- */
      {  49,38147,                      /* character number, location */
         13, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  9,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\xf0\x80\x03\x09\x02\x02\x04\x08\x08\x10\x10\x20"
            "\x40\x40\x80\x80\x00\x01\x00" }  },
      /* --- pixel bitmap for stmary131 char#50 \leftslice --- */
      {  50,38900,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x58\x70\xc8\x80\x03\xc8\x80\x70\x08\x58\x00"
            "\x02" }  },
      /* --- pixel bitmap for stmary131 char#51 \rightslice --- */
      {  51,39650,                      /* character number, location */
          9, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xa0\x01\xe1\x10\x30\x01\x1c\x30\xe1\xa0\x01\x04"
            "\x00" }  },
      /* --- pixel bitmap for stmary131 char#52 \varolessthan --- */
      {  52,40448,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x18\xc1\x14\x07\x1b\xe0\x00\x6c\x80"
            "\x71\x50\x30\x11\x18\x04\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#53 \varogreaterthan --- */
      {  53,41277,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x30\x10\x19\x14\x1c\x03\x6c\x00\x0e\xb0"
            "\xc1\x51\x06\x31\x10\x04\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#54 \varovee --- */
      {  54,42098,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x41\x10\x10\x03\x96\x20\x13\x64\x44\x8c\x88"
            "\x11\x51\x14\x91\x12\x24\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#55 \varowedge --- */
      {  55,42939,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x01\x49\x90\x12\x51\x14\x11\x23\x62\x44\x4c\x90"
            "\x09\xd2\x80\x11\x10\x04\x01\x1f\x00" }  },
      /* --- pixel bitmap for stmary131 char#56 \talloblong --- */
      {  56,43570,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x0f\xe1\x31\x0f\x11\x31\x05" }  },
      /* --- pixel bitmap for stmary131 char#57 \interleave --- */
      {  57,44302,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  9,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x31\x31\x0f\x31\x31\x31" }  },
      /* --- pixel bitmap for stmary131 char#58 \obar --- */
      {  58,45142,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x24\x42\x24\x44\x41\x18\x84\x41\x18\x84\x41"
            "\x28\x44\x42\x44\x24\xf8\x01" }  },
      /* --- pixel bitmap for stmary131 char#59 \oslash --- */
      {  59,45944,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x20\x06\xa4\x40\x11\x18\x82\x21\x18\x84\x81"
            "\x28\x50\x02\x46\x20\xf8\x01" }  },
      /* --- pixel bitmap for stmary131 char#60 \olessthan --- */
      {  60,46737,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x20\x02\x27\x4c\x31\xd8\x80\x03\xd8\x80\x31"
            "\x28\x4c\x02\x47\x20\xf8\x01" }  },
      /* --- pixel bitmap for stmary131 char#61 \ogreaterthan --- */
      {  61,47531,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x20\x0e\x24\x43\xc1\x18\xb0\x01\x1c\xb0\xc1"
            "\x28\x43\x0e\x44\x20\xf8\x01" }  },
      /* --- pixel bitmap for stmary131 char#62 \ovee --- */
      {  62,48317,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x20\x06\x66\x60\x05\x9a\x90\x09\x19\x89\x91"
            "\x28\x49\x62\x44\x26\xf8\x01" }  },
      /* --- pixel bitmap for stmary131 char#63 \owedge --- */
      {  63,49121,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x41\x26\x62\x24\x49\x91\x18\x89\x09\x99\x90\x05"
            "\x6a\x60\x06\x46\x20\xf8\x01" }  },
      /* --- pixel bitmap for stmary131 char#64 \oblong --- */
      {  64,49813,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\x0f\x81\x81\x0a" }  },
      /* --- pixel bitmap for stmary131 char#65 \inplus --- */
      {  65,50526,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x04\x02\x11\x11\xff\x11\x11\x02\x04\xf8" }  },
      /* --- pixel bitmap for stmary131 char#66 \niplus --- */
      {  66,51238,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          {  8,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1f\x20\x40\x88\x88\xff\x88\x88\x40\x20\x1f" }  },
      /* --- pixel bitmap for stmary131 char#67 \nplus --- */
      {  67,51954,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x08\x14\x60\x88\x21\xf6\x1b\x62\x88\x21\x06\x18"
            "\x20" }  },
      /* --- pixel bitmap for stmary131 char#68 \subsetplus --- */
      {  68,52752,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x13\x20\x40\x08\x21\xe4\x13\x42\x08\x02\x10\x80"
            "\x3f" }  },
      /* --- pixel bitmap for stmary131 char#69 \supsetplus --- */
      {  69,53530,                      /* character number, location */
         10, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 10,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x00\x02\x10\x84\x10\xf2\x09\x21\x84\x00\x01\xf2"
            "\x07" }  },
      /* --- pixel bitmap for stmary131 char#70 \subsetpluseq --- */
      {  70,54326,                      /* character number, location */
         12, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x37\x21\x81\x8f\x11\x41\x41\x25\x2f\x11\x41\x40\x11"
            "\xa1\xa7\xf2\xaa" }  },
      /* --- pixel bitmap for stmary131 char#71 \supsetpluseq --- */
      {  71,55128,                      /* character number, location */
         12, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 10,   15, 3,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xa1\xa1\x10\xf1\x41\x41\x25\x21\xf1\x41\x41\x81"
            "\x81\x27\x30\xf2\xaa" }  },
      /* --- pixel bitmap for stmary131 char#72 \Lbag --- */
      {  72,55893,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  6,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x46\x92\x20\x08\xc2\x10\x86\x21\x0c\xc3\x30\x0c\x06"
            "\x83\x03" }  },
      /* --- pixel bitmap for stmary131 char#73 \Rbag --- */
      {  73,56383,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  6,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x49\x12\x04\xc1\x20\x18\x06\xc1\x30\x0c\xc3\x18"
            "\x73\x00" }  },
      /* --- pixel bitmap for stmary131 char#74 \llbracket --- */
      {  74,57230,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  6,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x11\x3f\x11\x11\x36" }  },
      /* --- pixel bitmap for stmary131 char#75 \rrbracket --- */
      {  75,58108,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\xfe\x21\x11\xf1\x21\x11\x05" }  },
      /* --- pixel bitmap for stmary131 char#76 \llparenthesis --- */
      {  76,58844,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x53\x29\x65\x8c\x31\xc6\x18\xa5\x94\x14\x43" }  },
      /* --- pixel bitmap for stmary131 char#77 \rrparenthesis --- */
      {  77,59577,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  5,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x94\x94\x52\x8c\x31\xc6\x18\x53\x4a\x65\x04" }  },
      /* --- pixel bitmap for stmary131 char#78 \binampersand --- */
      {  78,60366,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x80\x10\x04\x41\x10\x08\x01\x0d\x3c\x28\x44\x81"
            "\x15\x20\x01\x25\x8c\x3c\x00" }  },
      /* --- pixel bitmap for stmary131 char#79 \bindnasrepma --- */
      {  79,61053,                      /* character number, location */
         11, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x13\x43\x0a\x48\x80\x1a\x28\x42\xc1\x03\x0b\x08"
            "\x81\x20\x08\x82\x10\xf0\x00" }  },
      /* --- pixel bitmap for stmary131 char#80 \trianglelefteqslant --- */
      {  80,61815,                      /* character number, location */
         12, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x0e\x26\x86\x06\x06\x68\x20\x86\x60\x06\x6e"
            "\x20\x06\x60\x00\x06\x20" }  },
      /* --- pixel bitmap for stmary131 char#81 \trianglerighteqslant --- */
      {  81,62572,                      /* character number, location */
         12, 1,   -3, 1,      /* topleft row,col, and botleft row,col */
          { 12,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\xd0\x00\x31\x10\x0c\x01\x13\xc0\x01\x13\x0c\x31"
            "\xd0\xc0\x03\x03\x0c\x30\xc0\x00\x03\x00" }  },
      /* --- pixel bitmap for stmary131 char#82 \ntrianglelefteqslant --- */
      {  82,63379,                      /* character number, location */
         15, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 10,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x04\x10\xa0\x80\x83\x89\xa5\x91\x21\x9a\x88"
            "\x21\x9c\x89\x3b\x88\x01\x19\x84\x09\x28\x80\x00" }  },
      /* --- pixel bitmap for stmary131 char#83 \ntrianglerighteqslant --- */
      {  83,64213,                      /* character number, location */
         15, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 12,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x04\x20\x00\x32\x10\x0d\x11\x0b\xc1\x10\x38\x41"
            "\x1c\x34\xe1\x10\x03\x1d\x3c\x31\xd0\x80\x03\x0c\x70"
            "\x00\x04\x40\x00" }  },
      /* --- pixel bitmap for stmary131 char#84 \llfloor --- */
      {  84,64893,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  9,   19, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x31\x4f\x21\x31\x49" }  },
      /* --- pixel bitmap for stmary131 char#85 \rrfloor --- */
      {  85,65573,                      /* character number, location */
         14, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  9,   19, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x41\x31\xf2\x41\x31\x09" }  },
      /* --- pixel bitmap for stmary131 char#86 \llceil --- */
      {  86,66239,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  9,   19, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x0f\xe1\x31\x4f\x21\x31\x42" }  },
      /* --- pixel bitmap for stmary131 char#87 \rrceil --- */
      {  87,66906,                      /* character number, location */
         14, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          {  9,   19, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\xfe\x41\x31\xf2\x41\x31" }  },
      /* --- pixel bitmap for stmary131 char#88 \arrownot --- */
      {  88,67305,                      /* character number, location */
          8, 7,    1, 7,      /* topleft row,col, and botleft row,col */
          {  4,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x24\x12\x01" }  },
      /* --- pixel bitmap for stmary131 char#89 \Arrownot --- */
      {  89,67651,                      /* character number, location */
         10, 7,   -1, 7,      /* topleft row,col, and botleft row,col */
          {  4,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x44\x24\x22\x12\x01" }  },
      /* --- pixel bitmap for stmary131 char#90 \Mapstochar --- */
      {  90,68028,                      /* character number, location */
         10, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  1,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x07" }  },
      /* --- pixel bitmap for stmary131 char#91 \mapsfromchar --- */
      {  91,68317,                      /* character number, location */
          8,-3,    1,-3,      /* topleft row,col, and botleft row,col */
          {  2,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xea\x2a" }  },
      /* --- pixel bitmap for stmary131 char#92 \Mapsfromchar --- */
      {  92,68617,                      /* character number, location */
         10,-3,   -1,-3,      /* topleft row,col, and botleft row,col */
          {  2,   11, 3, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x11" }  },
      /* --- pixel bitmap for stmary131 char#93 \leftrightarrowtriangle --- */
      {  93,69462,                      /* character number, location */
          8, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 16,    6, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x04\x38\x1c\x26\x64\xe3\xc7\x2c\x34\x30\x0c" }  },
      /* --- pixel bitmap for stmary131 char#94 \leftarrowtriangle --- */
      {  94,70293,                      /* character number, location */
          8, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 16,    6, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\xd3\xb2\x21\xa2\x3b\x22\x11\xe2\xa6" }  },
      /* --- pixel bitmap for stmary131 char#95 \rightarrowtriangle --- */
      {  95,71109,                      /* character number, location */
          8, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 16,    6, 3,21, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\xe0\x13\xd1\x22\x1b\x32\xa1\x12\xc2\x42" }  },
      /* --- pixel bitmap for stmary131 char#96 \bigtriangledown --- */
      {  96,71811,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xb1\xf2\x11\x91\x10\xf2\x21\x71\x20\xf1\x31\x51"
            "\x30\xf2\x41\x31\x40\xf2\x51\x11\x50\xf1\x61\x62" }  },
      /* --- pixel bitmap for stmary131 char#97 \bigtriangleup --- */
      {  97,72580,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x61\x60\xf2\x51\x11\x50\xf2\x41\x31\x40\xf1\x31"
            "\x51\x30\xf2\x21\x71\x20\xf2\x11\x91\x11\xbe" }  },
      /* --- pixel bitmap for stmary131 char#98 \bigcurlyvee --- */
      {  98,73347,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xb1\x11\x91\x31\x71\x51\x51\x30\xf1\x41\x31\x40"
            "\xf3\x51\x11\x50\xf7\x61\x62" }  },
      /* --- pixel bitmap for stmary131 char#99 \bigcurlywedge --- */
      {  99,74106,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x61\x60\xf3\x51\x11\x50\xf1\x41\x31\x40\x31\x51"
            "\x51\x71\x31\x91\x11\xb1" }  },
      /* --- pixel bitmap for stmary131 char#100 \bigsqcap --- */
      { 100,74893,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xe1\xb1\x0f\x11\xb1" }  },
      /* --- pixel bitmap for stmary131 char#101 \bigbox --- */
      { 101,75674,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xe1\xb1\x01\xbe" }  },
      /* --- pixel bitmap for stmary131 char#102 \bigparallel --- */
      { 102,76283,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          {  6,   18, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x41\x0f\x21\x41" }  },
      /* --- pixel bitmap for stmary131 char#103 \biginterleave --- */
      { 103,77019,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 11,   18, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x41\x41\x0f\x21\x41\x41" }  },
      /* --- pixel bitmap for stmary131 char#104 (noname) --- */
      { 104,77963,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x05\xe0\x21\xf2\x11\xe1\x10\xf2\x21\xc1\x20\xf1"
            "\x31\xa1\x30\xf2\x41\x81\x40\xf2\x51\x61\x50\xf2\x61"
            "\x41\x60\xf2\x71\x21\x70\xf1\x82\x80\x91\x81" }  },
      /* --- pixel bitmap for stmary131 char#105 (noname) --- */
      { 105,78891,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x80\xf1\x82\x80\xf2\x71\x21\x70\xf2\x61\x41\x60"
            "\xf2\x51\x61\x50\xf2\x41\x81\x40\xf1\x31\xa1\x30\xf2"
            "\x21\xc1\x20\xf2\x11\xe1\x11\xe0\x2e\x05" }  },
      /* --- pixel bitmap for stmary131 char#106 (noname) --- */
      { 106,79817,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x21\x12\xc2\x41\xa1\x30\xf1\x41\x81\x40\x51"
            "\x61\x50\xf2\x61\x41\x60\xf2\x71\x21\x70\xfb\x82\x80"
            "\x91\x81" }  },
      /* --- pixel bitmap for stmary131 char#107 (noname) --- */
      { 107,80727,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x80\xfb\x82\x80\xf2\x71\x21\x70\xf2\x61\x41\x60"
            "\x51\x61\x50\xf1\x41\x81\x40\x31\xa1\x42\xc2\x11\xe0"
            "\x21" }  },
      /* --- pixel bitmap for stmary131 char#108 (noname) --- */
      { 108,81658,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x12\x00\xff\x17\x01\x10\x01" }  },
      /* --- pixel bitmap for stmary131 char#109 (noname) --- */
      { 109,82600,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x12\x00\xff\x16\x01\x10\x01\x00\x12" }  },
      /* --- pixel bitmap for stmary131 char#110 (noname) --- */
      { 110,83292,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          {  8,   25, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x61\x0f\x91\x61" }  },
      /* --- pixel bitmap for stmary131 char#111 (noname) --- */
      { 111,84163,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 15,   25, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x61\x61\x0f\x91\x61\x61" }  },
      /* --- pixel bitmap for stmary131 char#112 \bignplus --- */
      { 112,85117,                      /* character number, location */
          0, 1,  -18, 1,      /* topleft row,col, and botleft row,col */
          { 13,   18, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x52\x20\xf1\x11\x91\x11\xb1\x0f\x31\x51\x51"
            "\x01\x19\x11\x0f\x31\x51\x51\x0f\x31\xb1" }  },
      /* --- pixel bitmap for stmary131 char#113 (noname) --- */
      { 113,86123,                      /* character number, location */
          1, 4,  -20, 4,      /* topleft row,col, and botleft row,col */
          {  6,   21, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x0f\xe1\x11\x3f\x31\x11\x36" }  },
      /* --- pixel bitmap for stmary131 char#114 (noname) --- */
      { 114,87102,                      /* character number, location */
          1, 4,  -31, 4,      /* topleft row,col, and botleft row,col */
          {  7,   32, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\xe1\x21\x3f\xe1\x21\x37" }  },
      /* --- pixel bitmap for stmary131 char#115 (noname) --- */
      { 115,88178,                      /* character number, location */
          1, 5,  -42, 5,      /* topleft row,col, and botleft row,col */
          {  7,   43, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x07\x00\xff\x28\x01\x02\x01\x03\x07" }  },
      /* --- pixel bitmap for stmary131 char#116 (noname) --- */
      { 116,89298,                      /* character number, location */
          1, 5,  -53, 5,      /* topleft row,col, and botleft row,col */
          {  8,   54, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x00\xff\x33\x01\x02\x01\x04\x08" }  },
      /* --- pixel bitmap for stmary131 char#117 (noname) --- */
      { 117,90431,                      /* character number, location */
          0, 6,  -32, 6,      /* topleft row,col, and botleft row,col */
          {  8,   32, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x00\xff\x1e\x01\x03\x01\x03" }  },
      /* --- pixel bitmap for stmary131 char#118 (noname) --- */
      { 118,91406,                      /* character number, location */
          1, 6,  -31, 6,      /* topleft row,col, and botleft row,col */
          {  8,   32, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1e\x00\x01\x03\x01\x03\x08" }  },
      /* --- pixel bitmap for stmary131 char#119 (noname) --- */
      { 119,92372,                      /* character number, location */
          1, 6,  -12, 6,      /* topleft row,col, and botleft row,col */
          {  5,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x01\x31" }  },
      /* --- pixel bitmap for stmary131 char#120 (noname) --- */
      { 120,93342,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 18,   25, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xa2\x62\x71\xa1\x51\xc1\x20\xf1\x11\xe1\x11\xe0"
            "\x21\x0f\x51\x81\x71\x01\x1e\x11\x0f\x51\x81\x71\x0f"
            "\x41\xe0\x21" }  },
      /* --- pixel bitmap for stmary131 char#121 (noname) --- */
      { 121,94371,                      /* character number, location */
          1, 0,  -20, 0,      /* topleft row,col, and botleft row,col */
          {  6,   21, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x31\x11\xf3\x31\x11\x06" }  },
      /* --- pixel bitmap for stmary131 char#122 (noname) --- */
      { 122,95337,                      /* character number, location */
          1, 0,  -31, 0,      /* topleft row,col, and botleft row,col */
          {  7,   32, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xfe\x31\x21\xfe\x31\x21\x07" }  },
      /* --- pixel bitmap for stmary131 char#123 (noname) --- */
      { 123,96400,                      /* character number, location */
          1, 0,  -42, 0,      /* topleft row,col, and botleft row,col */
          {  7,   43, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x07\xff\x28\x03\x01\x02\x01\x00\x07" }  },
      /* --- pixel bitmap for stmary131 char#124 (noname) --- */
      { 124,97507,                      /* character number, location */
          1, 0,  -53, 0,      /* topleft row,col, and botleft row,col */
          {  8,   54, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\xff\x33\x04\x01\x02\x01\x00\x08" }  },
      /* --- pixel bitmap for stmary131 char#125 (noname) --- */
      { 125,98627,                      /* character number, location */
          0, 0,  -32, 0,      /* topleft row,col, and botleft row,col */
          {  8,   32, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\xff\x1e\x03\x01\x03\x01" }  },
      /* --- pixel bitmap for stmary131 char#126 (noname) --- */
      { 126,99683,                      /* character number, location */
          1, 0,  -31, 0,      /* topleft row,col, and botleft row,col */
          {  8,   32, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x31\x31\xfe\x31\x31\x31\x39" }  },
      /* --- pixel bitmap for stmary131 char#127 (noname) --- */
      { 127,100636,                     /* character number, location */
          1, 3,  -12, 3,      /* topleft row,col, and botleft row,col */
          {  5,   13, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x01\x31" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=4 for .160gf ---
 * mf '\mode=preview; mag=magstep(-15.29639112828755784636); input stmary10'
 * --------------------------------------------------------------------- */
/* --- fontdef for stmary160 --- */
static	chardef  stmary160[] =
   {
      /* --- pixel bitmap for stmary160 char#0 \shortleftarrow --- */
      {   0,  948,                      /* character number, location */
          9, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 15,    7, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\xd1\xd2\xce\x01\x12\xe1\xe0\x11\xb0" }  },
      /* --- pixel bitmap for stmary160 char#1 \shortrightarrow --- */
      {   1, 1883,                      /* character number, location */
          9, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 15,    7, 3,19, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\xe0\x11\xe2\x1e\x01\xc2\xd1\xd1\x30" }  },
      /* --- pixel bitmap for stmary160 char#2 \shortuparrow --- */
      {   2, 2678,                      /* character number, location */
         13, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          {  7,   15, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\x53\x35\x11\x21\x21\xfa\x31\x31" }  },
      /* --- pixel bitmap for stmary160 char#3 \shortdownarrow --- */
      {   3, 3495,                      /* character number, location */
         13, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          {  7,   15, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\x31\x31\x21\x21\x15\x33\x51\x31" }  },
      /* --- pixel bitmap for stmary160 char#4 \Yup --- */
      {   4, 4092,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf5\x51\x40\x42\x71\x21\x51\x41\x31\x61\x11\x81" }  },
      /* --- pixel bitmap for stmary160 char#5 \Ydown --- */
      {   5, 4673,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   11, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x81\x11\x61\x31\x41\x51\x21\x72\x40\xf5\x51\x40" }  },
      /* --- pixel bitmap for stmary160 char#6 \Yleft --- */
      {   6, 5295,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb1\xa1\xa1\xa1\x47\x40\xf1\x71\x40\x81\xc1\xc1\xc1" }  },
      /* --- pixel bitmap for stmary160 char#7 \Yright --- */
      {   7, 5910,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   11, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xc1\xc1\xc1\xc8\xf1\x41\x70\x31\xa1\xa1\xa1\xb1" }  },
      /* --- pixel bitmap for stmary160 char#8 \varcurlyvee --- */
      {   8, 6541,                      /* character number, location */
         15, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xd1\x11\xb1\x31\x91\x51\x71\x30\xf1\x41\x51\x40"
            "\xf1\x51\x31\x50\xf3\x61\x11\x60\xf6\x71\x70" }  },
      /* --- pixel bitmap for stmary160 char#9 \varcurlywedge --- */
      {   9, 7224,                      /* character number, location */
         15, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x71\x70\xf3\x61\x11\x60\xf1\x51\x31\x50\xf1\x41"
            "\x51\x40\x31\x71\x51\x91\x31\xb1\x11\xd1" }  },
      /* --- pixel bitmap for stmary160 char#10 \minuso --- */
      {  10, 8035,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x01\x18\x03\x02\x02\x01\x41\x00\xf9\xff\x13\x40"
            "\x10\x10\x08\x08\x18\x03\x70\x00" }  },
      /* --- pixel bitmap for stmary160 char#11 \baro --- */
      {  11, 8719,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x80\x00\x02\x3f\x22\x85\x18\x62\x88\x21\x86\x28"
            "\x12\x3f\x20\x80\x00\x02" }  },
      /* --- pixel bitmap for stmary160 char#12 \sslash --- */
      {  12, 9393,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   23, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x81\x31\xf2\x71\x31\x10\xf1\x61\x31\x20\xf2\x51"
            "\x31\x30\xf2\x41\x31\x40\xf2\x31\x31\x50\xf1\x21\x31"
            "\x60\xf2\x11\x31\x7f\x11\x31\x80" }  },
      /* --- pixel bitmap for stmary160 char#13 \bblash --- */
      {  13,10102,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   23, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\x31\x80\xf2\x11\x31\x70\xf1\x21\x31\x60\xf2"
            "\x31\x31\x50\xf2\x41\x31\x40\xf2\x51\x31\x30\xf1\x61"
            "\x31\x20\xf2\x71\x31\x10\xf1\x81\x31" }  },
      /* --- pixel bitmap for stmary160 char#14 \moo --- */
      {  14,10925,                      /* character number, location */
         11, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   11, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf4\x61\x6d\xf1\x61\x60\x51\x11\x51\x41\x11\x41\x14"
            "\x34\x11" }  },
      /* --- pixel bitmap for stmary160 char#15 \varotimes --- */
      {  15,11694,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x44\x01\x25\x41\x0a\x11\x06\x05"
            "\x03\x81\x41\xc1\x10\xa1\x04\x49\x01\x45\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#16 \varoast --- */
      {  16,12646,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x44\x10\x24\x08\xca\x64\x86\x0f"
            "\x83\x81\xe1\xc3\x4c\xa6\x20\x48\x10\x44\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#17 \varobar --- */
      {  17,13463,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x4c\x06\x21\x44\x10\x24\x08\x0a\x04\x06\x02"
            "\x03\x81\x81\xc0\x40\xa0\x20\x48\x10\x44\x08\xc1\x64"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#18 \varodot --- */
      {  18,14271,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x51\x91\x20\xf1\x11\xb1\x11\xd2\x61\x62"
            "\x53\x52\x61\x62\xd1\xf1\x11\xb1\x10\x21\x91\x52\x52"
            "\x85\x55" }  },
      /* --- pixel bitmap for stmary160 char#19 \varoslash --- */
      {  19,15070,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x44\x00\x25\x40\x0a\x10\x06\x04"
            "\x03\x81\x41\xc0\x10\xa0\x04\x48\x01\x44\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#20 \varobslash --- */
      {  20,15885,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x44\x01\x24\x01\x0a\x01\x06\x01"
            "\x03\x81\x01\xc1\x00\xa1\x00\x49\x00\x45\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#21 \varocircle --- */
      {  21,16839,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x44\x10\x24\x36\x8a\x20\x46\x10"
            "\x13\x90\x11\xc4\x08\xa2\xd8\x48\x10\x44\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#22 \varoplus --- */
      {  22,17663,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x4c\x06\x21\x44\x10\x24\x08\x0a\x04\x06\x02"
            "\xff\xff\x81\xc0\x40\xa0\x20\x48\x10\x44\x08\xc1\x64"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#23 \varominus --- */
      {  23,18478,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x82\x52\x51\x91\x20\xf1\x11\xb1\x1f\x11\xd1\x0e"
            "\x01\x0f\x11\xd1\xf1\x11\xb1\x10\x21\x91\x52\x52\x85"
            "\x50" }  },
      /* --- pixel bitmap for stmary160 char#24 \boxast --- */
      {  24,19317,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x3f\x00\x06\xc1\x20\x98\x24\xe3\x63\x18\x8c\x8f"
            "\x49\x32\x08\x06\xc1\x00\xf8\xff\x01" }  },
      /* --- pixel bitmap for stmary160 char#25 \boxbar --- */
      {  25,20054,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xa1\x51\x51\x0d" }  },
      /* --- pixel bitmap for stmary160 char#26 \boxdot --- */
      {  26,20787,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,30, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\x31\xb1\x01\x51\x52\x43\x42\x51\x51\x0f\x31"
            "\xb1\x0d" }  },
      /* --- pixel bitmap for stmary160 char#27 \boxslash --- */
      {  27,21506,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\xa3\x91\x12\x81\x22\x71\x32\x61\x42\x51\x52\x41"
            "\x62\x31\x72\x21\x82\x11\x93\xae" }  },
      /* --- pixel bitmap for stmary160 char#28 \boxbslash --- */
      {  28,22238,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x7f\x00\x16\xc0\x04\x18\x01\x43\x60\x10\x0c\x84"
            "\x01\x31\x40\x06\xd0\x00\xfc\xff\x01" }  },
      /* --- pixel bitmap for stmary160 char#29 \boxcircle --- */
      {  29,22974,                      /* character number, location */
         13, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 14,   14, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0f\x21\xc1\x01\x44\x41\x0f\x31\x31\x41\x31\x01"
            "\x44\x41\x0f\x21\xc1\x0e" }  },
      /* --- pixel bitmap for stmary160 char#30 \boxbox --- */
      {  30,23709,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\x21\xb1\x01\x35\x31\x0f\x21\x31\x31\x31\x01"
            "\x35\x31\x0f\x21\xb1\x0d" }  },
      /* --- pixel bitmap for stmary160 char#31 \boxempty --- */
      {  31,24432,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xa1\xb1\x0d" }  },
      /* --- pixel bitmap for stmary160 char#32 \lightning --- */
      {  32,25317,                      /* character number, location */
         15, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          {  7,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x20\x08\x04\x81\x20\x10\x78\x26\x08\x04\x81\x44"
            "\x14\x0a\x3e\x01" }  },
      /* --- pixel bitmap for stmary160 char#33 \merge --- */
      {  33,26104,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 18,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x18\x80\x61\x00\x86\x01\x24\x09\x90\x24\x20\x0c"
            "\x81\x30\x04\xc2\x10\x04\x83\x10\x0c\x42\x48\x88\x20"
            "\x41\x82\x04\x05\x21\x18\x84\x20" }  },
      /* --- pixel bitmap for stmary160 char#34 \vartimes --- */
      {  34,26771,                      /* character number, location */
         15, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 10,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x0a\x24\x10\x21\x48\x20\x01\x03\x04\x30\x20\x81"
            "\x04\x21\x02\x09\x14\x20" }  },
      /* --- pixel bitmap for stmary160 char#35 \fatsemi --- */
      {  35,27352,                      /* character number, location */
         12, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          {  5,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x2e\xc6\xe8\x00\x70\x31\x46\x8f\x10\x11" }  },
      /* --- pixel bitmap for stmary160 char#36 \sswarrow --- */
      {  36,28235,                      /* character number, location */
         15, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 11,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x04\x30\x80\x00\x04\x10\x80\x00\x02\x10\x40\x00"
            "\x02\x08\x40\x00\x03\x08\x44\x40\x01\x0a\xe0\x03\x01"
            "\x00" }  },
      /* --- pixel bitmap for stmary160 char#37 \ssearrow --- */
      {  37,29120,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 11,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x18\x80\x00\x04\x40\x00\x02\x20\x00\x01\x10\x80"
            "\x00\x08\x40\x00\x06\x20\x00\x11\x50\x80\x82\x0f\x40"
            "\x00" }  },
      /* --- pixel bitmap for stmary160 char#38 \curlywedgeuparrow --- */
      {  38,30116,                      /* character number, location */
         15, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x71\x70\x63\xa2\x11\x12\x40\xf2\x71\x70\xf3\x61"
            "\x11\x60\xf1\x51\x31\x50\xf1\x41\x51\x40\x31\x71\x51"
            "\x91\x31\xb1\x11\xd1" }  },
      /* --- pixel bitmap for stmary160 char#39 \curlywedgedownarrow --- */
      {  39,31136,                      /* character number, location */
         15, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x71\x70\xf3\x61\x11\x60\xf1\x51\x31\x50\x41\x51"
            "\x51\x21\x51\x21\x21\x11\x71\x11\x22\x92\x21\xb1\x13"
            "\x93\x32\x52\x31" }  },
      /* --- pixel bitmap for stmary160 char#40 \fatslash --- */
      {  40,31810,                      /* character number, location */
         17, 6,   -6, 6,      /* topleft row,col, and botleft row,col */
          { 14,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x3f\x40\x04\x08\x01\x42\x80\x08\x10\x02\x84\x80"
            "\x10\x20\x04\x88\x00\x21\x40\x08\x10\x01\x42\x80\x10"
            "\x20\x02\x84\x00\x21\x20\x04\x08\x01\x22\x40\x08\xf0"
            "\x03\x00" }  },
      /* --- pixel bitmap for stmary160 char#41 \fatbslash --- */
      {  41,32506,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 14,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x40\x08\x20\x04\x08\x01\x42\x00\x21\x40\x08\x20"
            "\x02\x08\x01\x42\x00\x21\x40\x08\x10\x02\x08\x01\x42"
            "\x80\x10\x40\x08\x10\x02\x88\x00\x42\x80\x10\x40\x08"
            "\xf0\x03" }  },
      /* --- pixel bitmap for stmary160 char#42 \lbag --- */
      {  42,33101,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  8,   23, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x51\x21\x31\x41\x71\x20\xf5\x41\x30\xf3\x31\x40"
            "\xf5\x21\x50\x31\x72\x83" }  },
      /* --- pixel bitmap for stmary160 char#43 \rbag --- */
      {  43,33659,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  8,   23, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x42\x51\x21\x31\x41\x21\x50\xf5\x31\x40\xf3\x41\x30"
            "\xf5\x51\x20\x41\x62\x33\x52" }  },
      /* --- pixel bitmap for stmary160 char#44 \varbigcirc --- */
      {  44,34555,                      /* character number, location */
         16, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\xc2\x62\x91\xa1\x71\xc1\x51\xe1\x20\xf1\x11\xe0"
            "\x21\x1f\x51\xe0\x41\xf1\x11\xe0\x21\x10\x21\xe1\x51"
            "\xc1\x71\xa1\x92\x62\xc6\x71" }  },
      /* --- pixel bitmap for stmary160 char#45 \leftrightarroweq --- */
      {  45,35591,                      /* character number, location */
         12, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x08\x02\x88\x01\xec\xff\x6f\x00\x23\x80\x20\x20"
            "\x00\x00\x00\x80\xff\x3f" }  },
      /* --- pixel bitmap for stmary160 char#46 \curlyveedownarrow --- */
      {  46,36193,                      /* character number, location */
         15, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xd1\x11\xb1\x31\x91\x51\x71\x30\xf1\x41\x51\x40"
            "\xf1\x51\x31\x50\xf3\x61\x11\x60\xf2\x71\x70\x42\x11"
            "\x12\xa3\x60\xf1\x71\x76" }  },
      /* --- pixel bitmap for stmary160 char#47 \curlyveeuparrow --- */
      {  47,36833,                      /* character number, location */
         16, 0,   -4, 0,      /* topleft row,col, and botleft row,col */
          { 15,   20, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x32\x52\x33\x93\x11\xb1\x22\x92\x21\x11\x71\x11\x21"
            "\x21\x51\x21\x51\x51\x40\xf1\x51\x31\x50\xf3\x61\x11"
            "\x60\xf6\x71\x71" }  },
      /* --- pixel bitmap for stmary160 char#48 \nnwarrow --- */
      {  48,37436,                      /* character number, location */
         15, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 11,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x04\xe0\x83\x02\x14\x10\x01\x08\xc0\x00\x04\x20\x00"
            "\x02\x10\x00\x01\x08\x80\x00\x04\x40\x00\x02\x30\x00"
            "\x01" }  },
      /* --- pixel bitmap for stmary160 char#49 \nnearrow --- */
      {  49,38009,                      /* character number, location */
         15, 1,   -4, 1,      /* topleft row,col, and botleft row,col */
          { 11,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x81\x0f\xa0\x00\x05\x44\x20\x80\x01\x04\x20\x80"
            "\x00\x04\x10\x80\x00\x02\x10\x40\x00\x02\x18\x40\x00"
            "\x00" }  },
      /* --- pixel bitmap for stmary160 char#50 \leftslice --- */
      {  50,38770,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb2\xb2\x21\x82\x41\x53\x71\x22\xa3\xc1\x22\xa1\x43"
            "\x71\x72\x41\xa2\x21\xc2\x21" }  },
      /* --- pixel bitmap for stmary160 char#51 \rightslice --- */
      {  51,39528,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 15,   11, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\xc1\x22\xa1\x42\x71\x73\x41\xa2\x21\xc3\xa2\x21"
            "\x73\x51\x42\x81\x22\xb2\xb1" }  },
      /* --- pixel bitmap for stmary160 char#52 \varolessthan --- */
      {  52,40308,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x46\xc0\x24\x18\x8a\x03\x36\x00"
            "\x07\x80\x0d\xc0\x38\xa0\x60\x48\xc0\x44\x80\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#53 \varogreaterthan --- */
      {  53,41123,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x03\x44\x06\x24\x0c\x0a\x38\x06\x60"
            "\x03\xc0\x01\xd8\x80\xa3\x30\x48\x06\xc4\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#54 \varovee --- */
      {  54,41930,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\xc4\x00\xa6\x80\x4a\x40\x46\x10"
            "\x23\x88\x21\xc2\x10\xa1\x88\x48\x28\x44\x14\xc1\x64"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#55 \varowedge --- */
      {  55,42761,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x4c\x06\x51\x44\x28\x24\x22\x0a\x11\x86\x08"
            "\x23\x88\x11\xc4\x04\xa4\x02\xca\x00\x46\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#56 \talloblong --- */
      {  56,43408,                      /* character number, location */
         17, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  7,   23, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\xe1\x51\x0f\x51\x51\x07" }  },
      /* --- pixel bitmap for stmary160 char#57 \interleave --- */
      {  57,44156,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   23, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x51\x51\x0f\x71\x51\x51" }  },
      /* --- pixel bitmap for stmary160 char#58 \obar --- */
      {  58,45020,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x4c\x06\x21\x44\x10\x24\x08\x0a\x04\x06\x02"
            "\x03\x81\x81\xc0\x40\xa0\x20\x48\x10\x44\x08\xc1\x64"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#59 \oslash --- */
      {  59,45834,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x44\x01\x24\x01\x0a\x01\x06\x01"
            "\x03\x81\x01\xc1\x00\xa1\x00\x49\x00\x45\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#60 \olessthan --- */
      {  60,46639,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\x46\xc0\x24\x18\x8a\x03\x36\x00"
            "\x07\x80\x0d\xc0\x38\xa0\x60\x48\xc0\x44\x80\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#61 \ogreaterthan --- */
      {  61,47445,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x03\x44\x06\x24\x0c\x0a\x38\x06\x60"
            "\x03\xc0\x01\xd8\x80\xa3\x30\x48\x06\xc4\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#62 \ovee --- */
      {  62,48243,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x0c\x06\x01\xc4\x00\xa6\x80\x4a\x40\x46\x10"
            "\x23\x88\x21\xc2\x10\xa1\x88\x48\x28\x44\x14\xc1\x64"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#63 \owedge --- */
      {  63,49065,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x03\x4c\x06\x51\x44\x28\x24\x22\x0a\x11\x86\x08"
            "\x23\x88\x11\xc4\x04\xa4\x02\xca\x00\x46\x00\xc1\x60"
            "\x80\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#64 \oblong --- */
      {  64,49775,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xa1\xb1\x0d" }  },
      /* --- pixel bitmap for stmary160 char#65 \inplus --- */
      {  65,50496,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\xc7\x00\x01\x44\x20\x82\x10\xfc\x3f\x04\x22\x10"
            "\x01\x01\x30\x00\x7e" }  },
      /* --- pixel bitmap for stmary160 char#66 \niplus --- */
      {  66,51216,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 11,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x3f\x00\x06\x40\x40\x04\x22\x10\xfe\x1f\x84\x20\x02"
            "\x11\x40\x80\xf1\x03" }  },
      /* --- pixel bitmap for stmary160 char#67 \nplus --- */
      {  67,51940,                      /* character number, location */
         13, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x45\x62\x52\x31\x41\x41\x1f\x21\x51\x51\x01\x19\x11"
            "\x0f\x31\x51\x51\x0f\x11\xb1" }  },
      /* --- pixel bitmap for stmary160 char#68 \subsetplus --- */
      {  68,52752,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x32\xa1\xa0\xf1\x11\x51\x51\x61\x51\x37\x21\x61"
            "\x50\xf1\x11\x51\x50\x21\xd2\xd8" }  },
      /* --- pixel bitmap for stmary160 char#69 \supsetplus --- */
      {  69,53538,                      /* character number, location */
         12, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x00\x60\x00\x10\x10\x04\x82\x40\x20\x7f\x04\x81"
            "\x20\x08\x04\x01\x10\x80\xf1\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#70 \subsetpluseq --- */
      {  70,54342,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x32\xa1\xa0\xf1\x11\x51\x51\x61\x51\x37\x21\x61"
            "\x50\xf1\x11\x51\x50\x21\xd2\xd8\xf4\xdd" }  },
      /* --- pixel bitmap for stmary160 char#71 \supsetpluseq --- */
      {  71,55152,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xd2\xd1\x20\xf1\x51\x51\x10\x51\x61\x27\x31\x51"
            "\x61\xf1\x51\x51\x10\xa1\xa2\x38\x50\xf4\xdd" }  },
      /* --- pixel bitmap for stmary160 char#72 \Lbag --- */
      {  72,55925,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  8,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x11\x21\x20\x10\x10\x10\x18\x08\x0c\x0c\x06\x06"
            "\x06\x03\x03\x03\x03\x03\x06\x04\x18\xe0" }  },
      /* --- pixel bitmap for stmary160 char#73 \Rbag --- */
      {  73,56423,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  8,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x88\x84\x04\x08\x08\x08\x18\x10\x30\x30\x60\x60"
            "\x60\xc0\xc0\xc0\xc0\xc0\x60\x20\x18\x07" }  },
      /* --- pixel bitmap for stmary160 char#74 \llbracket --- */
      {  74,57278,                      /* character number, location */
         17, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  7,   23, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\xe1\x11\x4f\x51\x11\x47" }  },
      /* --- pixel bitmap for stmary160 char#75 \rrbracket --- */
      {  75,58172,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   23, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\xfe\x31\x11\xf5\x31\x11\x06" }  },
      /* --- pixel bitmap for stmary160 char#76 \llparenthesis --- */
      {  76,58924,                      /* character number, location */
         17, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  6,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x8c\x92\xa4\x28\x86\x61\x18\x86\x61\x18\x86\xa2"
            "\x48\x92\x28\x0c\x02" }  },
      /* --- pixel bitmap for stmary160 char#77 \rrparenthesis --- */
      {  77,59673,                      /* character number, location */
         17, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   23, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x50\x24\x49\x14\x85\x61\x18\x86\x61\x18\x86\x51"
            "\x94\x24\xc5\x10\x00" }  },
      /* --- pixel bitmap for stmary160 char#78 \binampersand --- */
      {  78,60478,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x01\x08\x01\x02\x01\x81\x80\x40\x80\x10\x80\x06"
            "\xe0\x80\x8c\x20\x81\x50\x80\x25\x00\x11\x60\x11\x0c"
            "\xf1\x01\x01" }  },
      /* --- pixel bitmap for stmary160 char#79 \bindnasrepma --- */
      {  79,61177,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x1f\x61\x10\x0d\x10\x01\x48\x03\x14\x02\x09\x62"
            "\x02\x0e\xc0\x02\x10\x02\x04\x02\x02\x01\x81\x00\x21"
            "\x00\x0f\x00" }  },
      /* --- pixel bitmap for stmary160 char#80 \trianglelefteqslant --- */
      {  80,61951,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xa3\x82\x21\x62\x41\x42\x61\x22\x83\xa1\x12\x91"
            "\x32\x71\x52\x51\x72\x31\x92\x12\xa2\x12\xd2\xd2\xd2"
            "\xd2\xd2" }  },
      /* --- pixel bitmap for stmary160 char#81 \trianglerighteqslant --- */
      {  81,62720,                      /* character number, location */
         14, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 13,   19, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xc3\xa1\x22\x81\x42\x61\x62\x41\x82\x21\xa3\x92"
            "\x11\x72\x31\x52\x51\x32\x71\x12\x92\xa1\xa2\x92\x92"
            "\x92\x92\x92\xb0" }  },
      /* --- pixel bitmap for stmary160 char#82 \ntrianglelefteqslant --- */
      {  82,63535,                      /* character number, location */
         18, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 13,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x80\x00\x10\x00\x02\xa0\x01\x2c\x60\x04\x8b"
            "\x18\xd1\x10\x0e\x42\x26\x08\x07\x81\x21\xc8\x04\xe1"
            "\x13\x90\x03\xc0\x00\x64\x80\x30\x08\x18\x01\x24\x00"
            "\x02\x00" }  },
      /* --- pixel bitmap for stmary160 char#83 \ntrianglerighteqslant --- */
      {  83,64391,                      /* character number, location */
         18, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 13,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x80\x00\x10\x00\x32\x20\x1a\x44\x4c\x08\x0e"
            "\x01\x23\x90\x05\xe2\x20\x13\x1c\xc2\x40\x0e\x38\x01"
            "\x11\x18\xc2\x40\x06\x34\x80\x01\x0c\x40\x01\x20\x00"
            "\x02\x00" }  },
      /* --- pixel bitmap for stmary160 char#84 \llfloor --- */
      {  84,65091,                      /* character number, location */
         17,-1,   -6,-1,      /* topleft row,col, and botleft row,col */
          { 13,   23, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x51\x6f\x61\x51\x6d" }  },
      /* --- pixel bitmap for stmary160 char#85 \rrfloor --- */
      {  85,65787,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 13,   23, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x61\x51\xf6\x61\x51\x0d" }  },
      /* --- pixel bitmap for stmary160 char#86 \llceil --- */
      {  86,66469,                      /* character number, location */
         17,-1,   -6,-1,      /* topleft row,col, and botleft row,col */
          { 13,   23, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xe1\x51\x6f\x61\x51\x62" }  },
      /* --- pixel bitmap for stmary160 char#87 \rrceil --- */
      {  87,67152,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 13,   23, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\xfe\x61\x51\xf6\x61\x51" }  },
      /* --- pixel bitmap for stmary160 char#88 \arrownot --- */
      {  88,67567,                      /* character number, location */
         10, 8,    1, 8,      /* topleft row,col, and botleft row,col */
          {  6,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x08\x21\x04\x21\x04\x01" }  },
      /* --- pixel bitmap for stmary160 char#89 \Arrownot --- */
      {  89,67917,                      /* character number, location */
         12, 9,   -1, 9,      /* topleft row,col, and botleft row,col */
          {  4,   13, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x88\x48\x44\x24\x22\x11\x01" }  },
      /* --- pixel bitmap for stmary160 char#90 \Mapstochar --- */
      {  90,68298,                      /* character number, location */
         13, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          {  2,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x57\x75\x15" }  },
      /* --- pixel bitmap for stmary160 char#91 \mapsfromchar --- */
      {  91,68595,                      /* character number, location */
         10,-3,    1,-3,      /* topleft row,col, and botleft row,col */
          {  2,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xab\x02" }  },
      /* --- pixel bitmap for stmary160 char#92 \Mapsfromchar --- */
      {  92,68899,                      /* character number, location */
         13,-3,   -2,-3,      /* topleft row,col, and botleft row,col */
          {  2,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xab\xba\x2a" }  },
      /* --- pixel bitmap for stmary160 char#93 \leftrightarrowtriangle --- */
      {  93,69752,                      /* character number, location */
          9, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 20,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x40\x80\x03\x1c\x26\x40\x16\xfe\x87\x26\x40\x86"
            "\x03\x1c\x20\x40\x00" }  },
      /* --- pixel bitmap for stmary160 char#94 \leftarrowtriangle --- */
      {  94,70587,                      /* character number, location */
          9, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 20,    7, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\xe0\x33\xe0\x21\x21\xe2\x3e\x01\x21\x21\xe0\x33"
            "\xe0\x51\xe3" }  },
      /* --- pixel bitmap for stmary160 char#95 \rightarrowtriangle --- */
      {  95,71405,                      /* character number, location */
          9, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 20,    7, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\xe0\x53\xe0\x31\x21\x2e\x01\x32\xe1\x21\xe0\x23"
            "\xe0\x31\x53" }  },
      /* --- pixel bitmap for stmary160 char#96 \bigtriangledown --- */
      {  96,72109,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\xe1\xf2\x11\xc1\x10\xf2\x21\xa1\x20\xf1\x31"
            "\x81\x30\xf2\x41\x61\x40\xf2\x51\x41\x50\xf2\x61\x21"
            "\x60\xf1\x72\x70\x81\x71" }  },
      /* --- pixel bitmap for stmary160 char#97 \bigtriangleup --- */
      {  97,72892,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x70\xf1\x72\x70\xf2\x61\x21\x60\xf2\x51\x41\x50"
            "\xf2\x41\x61\x40\xf1\x31\x81\x30\xf2\x21\xa1\x20\xf2"
            "\x11\xc1\x11\xee\x03" }  },
      /* --- pixel bitmap for stmary160 char#98 \bigcurlyvee --- */
      {  98,73673,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe1\x12\xa2\x10\xf1\x31\x81\x30\x41\x61\x40\xf1"
            "\x51\x41\x50\xf2\x61\x21\x60\xfa\x72\x70\x81\x70" }  },
      /* --- pixel bitmap for stmary160 char#99 \bigcurlywedge --- */
      {  99,74440,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,48, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x70\xfa\x72\x70\xf2\x61\x21\x60\xf1\x51\x41\x50"
            "\x41\x61\x40\xf1\x31\x81\x30\x12\xa2\x11\xe1" }  },
      /* --- pixel bitmap for stmary160 char#100 \bigsqcap --- */
      { 100,75235,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x0f\xe1\xe1\x0f\x51\xe1" }  },
      /* --- pixel bitmap for stmary160 char#101 \bigbox --- */
      { 101,76032,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x0f\xe1\xe1\x0f\x41\xe1\x0e\x02" }  },
      /* --- pixel bitmap for stmary160 char#102 \bigparallel --- */
      { 102,76657,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          {  8,   22, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x61\x0f\x61\x61" }  },
      /* --- pixel bitmap for stmary160 char#103 \biginterleave --- */
      { 103,77409,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 13,   22, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x51\x51\x0f\x61\x51\x51" }  },
      /* --- pixel bitmap for stmary160 char#104 (noname) --- */
      { 104,78377,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x0a\xe0\x71\xf2\x11\xe0\x51\x10\xf1\x21\xe0\x31"
            "\x20\xf2\x31\xe0\x11\x30\xf2\x41\xd1\x40\xf2\x51\xb1"
            "\x50\xf1\x61\x91\x60\xf2\x71\x71\x70\xf2\x81\x51\x80"
            "\xf1\x91\x31\x90\xf2\xa1\x11\xa0\xf1\xb1\xb0" }  },
      /* --- pixel bitmap for stmary160 char#105 (noname) --- */
      { 105,79331,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,98, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xb1\xb0\xf2\xa1\x11\xa0\xf1\x91\x31\x90\xf2\x81"
            "\x51\x80\xf2\x71\x71\x70\xf1\x61\x91\x60\xf2\x51\xb1"
            "\x50\xf2\x41\xd1\x40\xf2\x31\xe0\x11\x30\xf1\x21\xe0"
            "\x31\x20\xf2\x11\xe0\x51\x11\xe0\x7e\x0a" }  },
      /* --- pixel bitmap for stmary160 char#106 (noname) --- */
      { 106,80283,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x71\x12\xe0\x32\x41\xe0\x11\x71\xd1\x91\xb1"
            "\x50\xf1\x61\x91\x60\xf1\x71\x71\x70\xf1\x81\x51\x80"
            "\xf2\x91\x31\x90\xf5\xa1\x11\xa0\xfa\xb1\xb1" }  },
      /* --- pixel bitmap for stmary160 char#107 (noname) --- */
      { 107,81221,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfa\xb1\xb0\xf5\xa1\x11\xa0\xf2\x91\x31\x90\xf1\x81"
            "\x51\x80\xf1\x71\x71\x70\xf1\x61\x91\x60\x51\xb1\x91"
            "\xd1\x71\xe0\x11\x42\xe0\x32\x11\xe0\x71" }  },
      /* --- pixel bitmap for stmary160 char#108 (noname) --- */
      { 108,82180,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x17\x00\xff\x1d\x01\x15\x01" }  },
      /* --- pixel bitmap for stmary160 char#109 (noname) --- */
      { 109,83146,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x17\x00\xff\x1c\x01\x15\x01\x00\x17" }  },
      /* --- pixel bitmap for stmary160 char#110 (noname) --- */
      { 110,83862,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 10,   31, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1e\x00\x01\x08\x01" }  },
      /* --- pixel bitmap for stmary160 char#111 (noname) --- */
      { 111,84731,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 17,   31, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1e\x00\x01\x07\x01\x07\x01" }  },
      /* --- pixel bitmap for stmary160 char#112 \bignplus --- */
      { 112,85721,                      /* character number, location */
          0, 1,  -22, 1,      /* topleft row,col, and botleft row,col */
          { 16,   22, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\x82\x62\x51\xa1\x20\xf1\x11\xc1\x11\xe1\x0f\x41"
            "\x71\x61\x01\x1c\x11\x0f\x41\x71\x61\x0f\x41\xe1" }  },
      /* --- pixel bitmap for stmary160 char#113 (noname) --- */
      { 113,86747,                      /* character number, location */
          1, 5,  -25, 5,      /* topleft row,col, and botleft row,col */
          {  7,   26, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\xe1\x21\x3f\x81\x21\x37" }  },
      /* --- pixel bitmap for stmary160 char#114 (noname) --- */
      { 114,87746,                      /* character number, location */
          1, 5,  -38, 5,      /* topleft row,col, and botleft row,col */
          {  8,   39, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x00\xff\x24\x01\x02\x01\x04\x08" }  },
      /* --- pixel bitmap for stmary160 char#115 (noname) --- */
      { 115,88850,                      /* character number, location */
          1, 6,  -51, 6,      /* topleft row,col, and botleft row,col */
          {  8,   52, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x00\xff\x31\x01\x03\x01\x03\x08" }  },
      /* --- pixel bitmap for stmary160 char#116 (noname) --- */
      { 116,90032,                      /* character number, location */
          1, 6,  -65, 6,      /* topleft row,col, and botleft row,col */
          {  9,   66, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x09\x00\xff\x3f\x01\x03\x01\x04\x09" }  },
      /* --- pixel bitmap for stmary160 char#117 (noname) --- */
      { 117,91239,                      /* character number, location */
          0, 8,  -39, 8,      /* topleft row,col, and botleft row,col */
          {  9,   39, 2, 9, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x09\x00\xff\x25\x01\x03\x01\x04" }  },
      /* --- pixel bitmap for stmary160 char#118 (noname) --- */
      { 118,92268,                      /* character number, location */
          1, 8,  -38, 8,      /* topleft row,col, and botleft row,col */
          {  9,   39, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x25\x00\x01\x03\x01\x04\x09" }  },
      /* --- pixel bitmap for stmary160 char#119 (noname) --- */
      { 119,93288,                      /* character number, location */
          1, 8,  -14, 8,      /* topleft row,col, and botleft row,col */
          {  5,   15, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x31" }  },
      /* --- pixel bitmap for stmary160 char#120 (noname) --- */
      { 120,94266,                      /* character number, location */
          0, 1,  -31, 1,      /* topleft row,col, and botleft row,col */
          { 23,   31, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x72\xa2\xb2\x71\xe0\x11\x51\xe0\x31\x20\xf1"
            "\x11\xe0\x51\x1f\x81\xa1\xa1\x01\x1e\x05\x11\x0f\x81"
            "\xa1\xa1\x0f\x41\xe0\x71" }  },
      /* --- pixel bitmap for stmary160 char#121 (noname) --- */
      { 121,95305,                      /* character number, location */
          1, 0,  -25, 0,      /* topleft row,col, and botleft row,col */
          {  7,   26, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xfe\x31\x21\xf8\x31\x21\x07" }  },
      /* --- pixel bitmap for stmary160 char#122 (noname) --- */
      { 122,96291,                      /* character number, location */
          1, 0,  -38, 0,      /* topleft row,col, and botleft row,col */
          {  8,   39, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\xff\x24\x04\x01\x02\x01\x00\x08" }  },
      /* --- pixel bitmap for stmary160 char#123 (noname) --- */
      { 123,97356,                      /* character number, location */
          1, 0,  -51, 0,      /* topleft row,col, and botleft row,col */
          {  8,   52, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\xff\x31\x03\x01\x03\x01\x00\x08" }  },
      /* --- pixel bitmap for stmary160 char#124 (noname) --- */
      { 124,98525,                      /* character number, location */
          1, 0,  -65, 0,      /* topleft row,col, and botleft row,col */
          {  9,   66, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x09\xff\x3f\x04\x01\x03\x01\x00\x09" }  },
      /* --- pixel bitmap for stmary160 char#125 (noname) --- */
      { 125,99693,                      /* character number, location */
          0, 0,  -39, 0,      /* topleft row,col, and botleft row,col */
          { 10,   39, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x0a\xff\x25\x04\x01\x04\x01" }  },
      /* --- pixel bitmap for stmary160 char#126 (noname) --- */
      { 126,100777,                     /* character number, location */
          1, 0,  -38, 0,      /* topleft row,col, and botleft row,col */
          { 10,   39, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x25\x04\x01\x04\x01\x00\x0a" }  },
      /* --- pixel bitmap for stmary160 char#127 (noname) --- */
      { 127,101758,                     /* character number, location */
          1, 4,  -14, 4,      /* topleft row,col, and botleft row,col */
          {  6,   15, 3, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x41" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=5 for .180gf ---
 * mf '\mode=preview; mag=magstep(-14.65037297372839890542); input stmary10'
 * --------------------------------------------------------------------- */
/* --- fontdef for stmary180 --- */
static	chardef  stmary180[] =
   {
      /* --- pixel bitmap for stmary180 char#0 \shortleftarrow --- */
      {   0,  948,                      /* character number, location */
         11, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 17,    9, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\xc0\x31\xe0\x11\xee\x03\x21\xe0\x31\xd0\xf1"
            "\x41\xc0" }  },
      /* --- pixel bitmap for stmary180 char#1 \shortrightarrow --- */
      {   1, 1887,                      /* character number, location */
         11, 1,    2, 1,      /* topleft row,col, and botleft row,col */
          { 17,    9, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xc1\x40\xd1\xe0\x31\x2e\x03\xe1\xe0\x11\x30\xf1"
            "\xc1\x40" }  },
      /* --- pixel bitmap for stmary180 char#2 \shortuparrow --- */
      {   2, 2686,                      /* character number, location */
         15, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          {  9,   17, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\x40\x33\x51\x11\x11\x22\x21\x22\xfb\x41\x41" }  },
      /* --- pixel bitmap for stmary180 char#3 \shortdownarrow --- */
      {   3, 3511,                      /* character number, location */
         15, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          {  9,   17, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x41\x42\x21\x22\x21\x11\x11\x53\x30\xf1\x41\x41" }  },
      /* --- pixel bitmap for stmary180 char#4 \Yup --- */
      {   4, 4116,                      /* character number, location */
         13, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 11,   12, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x61\x40\x52\x81\x21\x61\x41\x41\x61\x21\x81" }  },
      /* --- pixel bitmap for stmary180 char#5 \Ydown --- */
      {   5, 4699,                      /* character number, location */
         11, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 11,   11, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x81\x21\x61\x41\x41\x61\x21\x82\x40\xf5\x61\x41" }  },
      /* --- pixel bitmap for stmary180 char#6 \Yleft --- */
      {   6, 5321,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xb1\xb1\xa2\x47\xc1\xd1\xd1\x30\xf1\xa1\x20\xb1"
            "\xd1" }  },
      /* --- pixel bitmap for stmary180 char#7 \Yright --- */
      {   7, 5938,                      /* character number, location */
         12, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 13,   12, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xd1\xd1\xd2\xd8\x51\xb1\xb1\x90\xf1\x21\xa0\x11"
            "\xb1\xc0" }  },
      /* --- pixel bitmap for stmary180 char#8 \varcurlyvee --- */
      {   8, 6571,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 17,   23, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x11\x11\xd1\x31\xb1\x51\x91\x71\x71\x40\xf1"
            "\x51\x51\x50\xf2\x61\x31\x60\xf4\x71\x11\x70\xf7\x81"
            "\x80" }  },
      /* --- pixel bitmap for stmary180 char#9 \varcurlywedge --- */
      {   9, 7268,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 17,   23, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x81\x80\xf3\x71\x11\x70\xf2\x61\x31\x60\xf1\x51"
            "\x51\x50\xf1\x41\x71\x40\x31\x91\x51\xb1\x31\xd1\x11"
            "\xe0\x11" }  },
      /* --- pixel bitmap for stmary180 char#10 \minuso --- */
      {  10, 8093,                      /* character number, location */
         12, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   11, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\xc2\x32\x50\xf1\x41\x71\x40\x31\x91\x3e\x03\x31"
            "\x91\x30\xf1\x41\x71\x40\x52\x32\xc3\x71" }  },
      /* --- pixel bitmap for stmary180 char#11 \baro --- */
      {  11, 8777,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x61\x50\x36\x51\x31\x21\x31\x41\x31\x1f\x41\x51"
            "\x41\x11\x41\x31\x31\x31\x21\x56\x30\xf2\x61\x51" }  },
      /* --- pixel bitmap for stmary180 char#12 \sslash --- */
      {  12, 9463,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 15,   25, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xa1\x31\xf1\x91\x31\x10\xf2\x81\x31\x20\xf1\x71"
            "\x31\x30\xf1\x61\x31\x40\xf2\x51\x31\x50\xf1\x41\x31"
            "\x60\xf1\x31\x31\x70\xf2\x21\x31\x80\xf1\x11\x31\x9f"
            "\x11\x31\xa0" }  },
      /* --- pixel bitmap for stmary180 char#13 \bblash --- */
      {  13,10180,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 15,   25, 3,86, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\x31\xa0\xf1\x11\x31\x90\xf2\x21\x31\x80\xf1"
            "\x31\x31\x70\xf1\x41\x31\x60\xf2\x51\x31\x50\xf1\x61"
            "\x31\x40\xf1\x71\x31\x30\xf2\x81\x31\x20\xf1\x91\x31"
            "\x10\xf1\xa1\x31" }  },
      /* --- pixel bitmap for stmary180 char#14 \moo --- */
      {  14,11011,                      /* character number, location */
         14, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x61\x6d\xf3\x61\x6f\x11\x41\x11\x41\x14\x34\x11" }  },
      /* --- pixel bitmap for stmary180 char#15 \varotimes --- */
      {  15,11792,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x60\x00\x23\x01\x49\x04\x51"
            "\x10\xc1\x40\x81\x01\x01\x03\x05\x06\x11\x14\x41\x24"
            "\x01\x89\x01\x0c\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#16 \varoast --- */
      {  16,12752,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x20\x08\x22\x10\x48\x22\x52"
            "\x5c\xc7\xf0\x87\x81\x03\xc3\x1f\xc6\x75\x94\x88\x24"
            "\x10\x88\x20\x08\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#17 \varobar --- */
      {  17,13589,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\xa2\x21\x22\x71\x41\x41\x51\x51\x51\x20\xf1\x11"
            "\x61\x61\x1f\x41\x71\x71\xf1\x11\x61\x61\x10\x21\x51"
            "\x51\x51\x41\x41\x72\x21\x22\xa5\x61" }  },
      /* --- pixel bitmap for stmary180 char#18 \varodot --- */
      {  18,14409,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\xa2\x52\x71\x91\x51\xb1\x20\xf1\x11\xd1\x11\xe0"
            "\x11\x0f\x21\x63\x61\x01\xe0\x11\xf1\x11\xd1\x10\x21"
            "\xb1\x51\x91\x72\x52\xa5\x62" }  },
      /* --- pixel bitmap for stmary180 char#19 \varoslash --- */
      {  19,15216,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x20\x00\x23\x00\x49\x00\x51"
            "\x00\xc1\x00\x81\x01\x01\x03\x01\x06\x01\x14\x01\x24"
            "\x01\x88\x01\x08\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#20 \varobslash --- */
      {  20,16039,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x60\x00\x22\x01\x48\x04\x50"
            "\x10\xc0\x40\x80\x01\x01\x03\x04\x06\x10\x14\x40\x24"
            "\x00\x89\x00\x0c\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#21 \varocircle --- */
      {  21,17001,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x20\x00\x22\x38\x48\x8c\x51"
            "\x08\xc2\x08\x88\x11\x10\x23\x20\x86\x20\x14\x63\x24"
            "\x38\x88\x00\x08\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#22 \varoplus --- */
      {  22,17833,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x32\x20\x84\x20\x08\x22\x10\x48\x20\x50"
            "\x40\xc0\x80\x80\xff\xff\x03\x02\x06\x04\x14\x08\x24"
            "\x10\x88\x20\x08\x42\x08\x98\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#23 \varominus --- */
      {  23,18660,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\xa2\x52\x71\x91\x51\xb1\x20\xf1\x11\xd1\x1f\x11"
            "\xe0\x11\x0e\x03\x0f\x11\xe0\x11\xf1\x11\xd1\x10\x21"
            "\xb1\x51\x91\x72\x52\xa5\x61" }  },
      /* --- pixel bitmap for stmary180 char#24 \boxast --- */
      {  24,19507,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\xff\x00\x60\x00\x30\x38\x18\x08\xcc\x75\xc6\x1f"
            "\x83\x83\xf1\xc7\x5c\x67\x20\x30\x38\x18\x00\x0c\x00"
            "\xfe\xff\x01" }  },
      /* --- pixel bitmap for stmary180 char#25 \boxbar --- */
      {  25,20252,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\x0f\xc1\x61\x61\x0e\x01" }  },
      /* --- pixel bitmap for stmary180 char#26 \boxdot --- */
      {  26,20997,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\x0f\x41\xd1\x0f\x21\x53\x51\x0f\x41\xd1\x0e"
            "\x01" }  },
      /* --- pixel bitmap for stmary180 char#27 \boxslash --- */
      {  27,21724,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\xc3\xb1\x12\xa1\x22\x91\x32\x81\x42\x71\x52"
            "\x61\x62\x51\x72\x41\x82\x31\x92\x21\xa2\x11\xb3\xce"
            "\x02" }  },
      /* --- pixel bitmap for stmary180 char#28 \boxbslash --- */
      {  28,22468,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x03\xc2\x11\xb2\x21\xa2\x31\x92\x41\x82\x51\x72"
            "\x61\x62\x71\x52\x81\x42\x91\x32\xa1\x22\xb1\x12\xce"
            "\x03" }  },
      /* --- pixel bitmap for stmary180 char#29 \boxcircle --- */
      {  29,23216,                      /* character number, location */
         15, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,54, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x02\x0f\x21\xe1\x01\x54\x52\x41\x41\x41\x0f\x31"
            "\x31\x61\x31\x01\x41\x41\x42\x54\x51\x0f\x21\xe1\x0e"
            "\x02" }  },
      /* --- pixel bitmap for stmary180 char#30 \boxbox --- */
      {  30,23967,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,42, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\x0f\x21\xd1\x01\x37\x31\x0f\x41\x31\x51\x31"
            "\x01\x37\x31\x0f\x21\xd1\x0e\x01" }  },
      /* --- pixel bitmap for stmary180 char#31 \boxempty --- */
      {  31,24706,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0e\x01\x0f\xc1\xd1\x0e\x01" }  },
      /* --- pixel bitmap for stmary180 char#32 \lightning --- */
      {  32,25599,                      /* character number, location */
         17, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          {  8,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x40\x40\x40\x20\x20\x10\x10\x08\x88\xe8\x5c\x44"
            "\x20\x20\x20\x11\x12\x0a\xec\x1c\x04" }  },
      /* --- pixel bitmap for stmary180 char#33 \merge --- */
      {  33,26400,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf2\x52\x42\x50\xf2\x41\x21\x21\x21\x40\xf3\x31\x42"
            "\x41\x30\xf2\x21\x52\x51\x20\xf2\x11\x51\x21\x51\x1f"
            "\x11\x51\x41\x51" }  },
      /* --- pixel bitmap for stmary180 char#34 \vartimes --- */
      {  34,27087,                      /* character number, location */
         17, 1,    0, 1,      /* topleft row,col, and botleft row,col */
          { 12,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x28\x40\x02\x44\x20\x08\x81\x10\x90\x00\x06\x20"
            "\x00\x06\x90\x80\x10\x08\x41\x20\x02\x24\x40\x01\x08" }  },
      /* --- pixel bitmap for stmary180 char#35 \fatsemi --- */
      {  35,27676,                      /* character number, location */
         14, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          {  6,   19, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5e\x18\x86\xa1\x07\x00\x5e\x18\x86\xa1\x0f\x41\x08"
            "\x41\x00" }  },
      /* --- pixel bitmap for stmary180 char#36 \sswarrow --- */
      {  36,28569,                      /* character number, location */
         17, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 12,   22, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xb1\xf1\xa1\x10\xf1\x91\x20\xf2\x81\x30\xf1\x71"
            "\x40\xf1\x61\x50\xf2\x51\x61\x31\x81\x21\x81\x11\xa2"
            "\x13\x63\x91\x91" }  },
      /* --- pixel bitmap for stmary180 char#37 \ssearrow --- */
      {  37,29462,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 12,   22, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x01\xb0\xf1\x11\xa0\xf1\x21\x90\xf2\x31\x80\xf1"
            "\x41\x70\xf1\x51\x60\xf2\x61\x50\x71\x31\x71\x21\x91"
            "\x11\x53\x12\x93\xb1\x21" }  },
      /* --- pixel bitmap for stmary180 char#38 \curlywedgeuparrow --- */
      {  38,30466,                      /* character number, location */
         18, 0,   -5, 0,      /* topleft row,col, and botleft row,col */
          { 17,   23, 3,68, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x80\xf1\x73\x70\x57\x99\x40\xf2\x81\x80\xf4\x71"
            "\x11\x70\xf2\x61\x31\x60\xf1\x51\x51\x50\x41\x71\x71"
            "\x91\x51\xb1\x31\xd1\x11\xe0\x11" }  },
      /* --- pixel bitmap for stmary180 char#39 \curlywedgedownarrow --- */
      {  39,31496,                      /* character number, location */
         18, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x81\x80\xf4\x71\x11\x70\xf2\x61\x31\x60\xf1\x11"
            "\x31\x51\x31\x10\x11\x21\x71\x21\x21\x11\x91\x11\x22"
            "\xb2\x21\xd1\x15\x75\x52\x32\x51" }  },
      /* --- pixel bitmap for stmary180 char#40 \fatslash --- */
      {  40,32192,                      /* character number, location */
         19, 7,   -6, 7,      /* topleft row,col, and botleft row,col */
          { 15,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x7e\x00\x21\x40\x10\x20\x04\x10\x02\x84\x00\x42"
            "\x80\x20\x40\x08\x20\x04\x08\x02\x84\x00\x42\x80\x10"
            "\x40\x08\x10\x04\x08\x01\x84\x00\x41\x80\x10\x40\x08"
            "\x10\x02\x08\x01\x82\x00\x3f\x00" }  },
      /* --- pixel bitmap for stmary180 char#41 \fatbslash --- */
      {  41,32896,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 16,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7f\x00\x41\x00\x42\x00\x82\x00\x82\x00\x84\x00\x04"
            "\x01\x08\x01\x08\x02\x08\x02\x10\x02\x10\x04\x10\x04"
            "\x20\x04\x20\x08\x40\x08\x40\x10\x40\x10\x80\x10\x80"
            "\x20\x00\x21\x00\x21\x00\x41\x00\x42\x00\xfe" }  },
      /* --- pixel bitmap for stmary180 char#42 \lbag --- */
      {  42,33499,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  9,   25, 3,34, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x51\x31\x31\x41\x30\xf5\x51\x30\xf3\x41\x40\xf9"
            "\x31\x50\x41\x94" }  },
      /* --- pixel bitmap for stmary180 char#43 \rbag --- */
      {  43,34061,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  9,   25, 3,33, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x51\x31\x41\x41\xf5\x31\x50\xf3\x41\x40\xf9\x51"
            "\x30\x41\x44\x54" }  },
      /* --- pixel bitmap for stmary180 char#44 \varbigcirc --- */
      {  44,34961,                      /* character number, location */
         18, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 23,   23, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\xd3\x73\x91\xd1\x71\xe0\x11\x51\xe0\x31\x20\xf2"
            "\x11\xe0\x51\x1f\x61\xe0\x71\xf2\x11\xe0\x51\x10\x21"
            "\xe0\x31\x51\xe0\x11\x71\xd1\x93\x73\xd7\x81" }  },
      /* --- pixel bitmap for stmary180 char#45 \leftrightarroweq --- */
      {  45,36009,                      /* character number, location */
         14, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 17,   11, 3,44, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x41\x71\x40\x31\x91\x51\xb1\x2e\x03\x21\xb1\x51"
            "\x91\x30\xf1\x41\x71\x40\xe0\x3e\x03" }  },
      /* --- pixel bitmap for stmary180 char#46 \curlyveedownarrow --- */
      {  46,36619,                      /* character number, location */
         17, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 17,   23, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe0\x11\x11\xd1\x31\xb1\x51\x91\x71\x71\x40\xf1"
            "\x51\x51\x50\xf2\x61\x31\x60\xf4\x71\x11\x70\xf2\x81"
            "\x80\x49\x97\x50\xf1\x73\x70\x81\x83" }  },
      /* --- pixel bitmap for stmary180 char#47 \curlyveeuparrow --- */
      {  47,37269,                      /* character number, location */
         18, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 17,   24, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x52\x32\x55\x75\x11\xd1\x22\xb2\x21\x11\x91\x11\x21"
            "\x21\x71\x21\x10\xf1\x11\x31\x51\x31\x10\xf2\x61\x31"
            "\x60\xf4\x71\x11\x70\xf7\x81\x81" }  },
      /* --- pixel bitmap for stmary180 char#48 \nnwarrow --- */
      {  48,37894,                      /* character number, location */
         17, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 12,   22, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x21\xb3\x92\x13\x51\x11\x91\x21\x71\x31\x70\xf2\x51"
            "\x60\xf1\x61\x50\xf1\x71\x40\xf2\x81\x30\xf1\x91\x20"
            "\xf1\xa1\x10\xf1\xb1" }  },
      /* --- pixel bitmap for stmary180 char#49 \nnearrow --- */
      {  49,38475,                      /* character number, location */
         17, 1,   -5, 1,      /* topleft row,col, and botleft row,col */
          { 12,   22, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x91\x93\x63\x12\xa1\x11\x81\x21\x81\x31\xf2\x61\x50"
            "\xf1\x51\x60\xf1\x41\x70\xf2\x31\x80\xf1\x21\x90\xf1"
            "\x11\xaf\x11\xb1" }  },
      /* --- pixel bitmap for stmary180 char#50 \leftslice --- */
      {  50,39244,                      /* character number, location */
         12, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   11, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb4\xb2\x41\x82\x61\x53\x91\x22\xc3\xe1\x22\xc1\x43"
            "\x91\x72\x61\xa2\x41\xc4\x22" }  },
      /* --- pixel bitmap for stmary180 char#51 \rightslice --- */
      {  51,40002,                      /* character number, location */
         12, 1,    1, 1,      /* topleft row,col, and botleft row,col */
          { 17,   11, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\xc1\x42\xa1\x62\x71\x93\x41\xc2\x21\xe3\xc2\x21"
            "\x93\x51\x62\x81\x42\xb4\xb2" }  },
      /* --- pixel bitmap for stmary180 char#52 \varolessthan --- */
      {  52,40782,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x20\xc0\x23\x60\x48\x30\x50"
            "\x1c\xc0\x06\x80\x03\x00\x1b\x00\xc6\x01\x14\x0c\x24"
            "\x60\x88\x00\x0f\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#53 \varogreaterthan --- */
      {  53,41605,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\xe0\x01\x22\x0c\x48\x60\x50"
            "\x00\xc7\x00\xb0\x01\x80\x03\xc0\x06\x70\x14\x18\x24"
            "\x0c\x88\x07\x08\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#54 \varovee --- */
      {  54,42420,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x60\x00\xa3\x00\x4a\x01\x54"
            "\x04\xc4\x08\x88\x21\x08\x43\x10\x06\x11\x14\x22\x24"
            "\x44\x88\x50\x08\xa2\x08\x98\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#55 \varowedge --- */
      {  55,43267,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x32\x20\x8a\x20\x14\x22\x44\x48\x88\x50"
            "\x10\xc1\x10\x84\x21\x08\x23\x20\x46\x40\x54\x00\xa5"
            "\x00\x8a\x01\x0c\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#56 \talloblong --- */
      {  56,43930,                      /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  8,   25, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x0f\xe1\x61\x0f\x71\x61\x08" }  },
      /* --- pixel bitmap for stmary180 char#57 \interleave --- */
      {  57,44686,                      /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 13,   25, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x51\x51\x0f\x91\x51\x51" }  },
      /* --- pixel bitmap for stmary180 char#58 \obar --- */
      {  58,45562,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x65\xa2\x21\x22\x71\x41\x41\x51\x51\x51\x20\xf1\x11"
            "\x61\x61\x1f\x41\x71\x71\xf1\x11\x61\x61\x10\x21\x51"
            "\x51\x51\x41\x41\x72\x21\x22\xa5\x61" }  },
      /* --- pixel bitmap for stmary180 char#59 \oslash --- */
      {  59,46388,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x60\x00\x22\x01\x48\x04\x50"
            "\x10\xc0\x40\x80\x01\x01\x03\x04\x06\x10\x14\x40\x24"
            "\x00\x89\x00\x0c\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#60 \olessthan --- */
      {  60,47201,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x20\xc0\x23\x60\x48\x30\x50"
            "\x1c\xc0\x06\x80\x03\x00\x1b\x00\xc6\x01\x14\x0c\x24"
            "\x60\x88\x00\x0f\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#61 \ogreaterthan --- */
      {  61,48015,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\xe0\x01\x22\x0c\x48\x60\x50"
            "\x00\xc7\x00\xb0\x01\x80\x03\xc0\x06\x70\x14\x18\x24"
            "\x0c\x88\x07\x08\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#62 \ovee --- */
      {  62,48821,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x30\x20\x80\x60\x00\xa3\x00\x4a\x01\x54"
            "\x04\xc4\x08\x88\x21\x08\x43\x10\x06\x11\x14\x22\x24"
            "\x44\x88\x50\x08\xa2\x08\x98\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#63 \owedge --- */
      {  63,49659,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x07\x60\x32\x20\x8a\x20\x14\x22\x44\x48\x88\x50"
            "\x10\xc1\x10\x84\x21\x08\x23\x20\x46\x40\x54\x00\xa5"
            "\x00\x8a\x01\x0c\x02\x08\x18\x0c\xc0\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#64 \oblong --- */
      {  64,50385,                      /* character number, location */
         16, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 13,   16, 3,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xd1\xb1\x0d" }  },
      /* --- pixel bitmap for stmary180 char#65 \inplus --- */
      {  65,51118,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,44, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x58\x32\xa1\xa0\xf1\x11\x41\x6f\x11\x51\x6d\x0f\x11"
            "\x51\x60\xf1\x11\x41\x60\x21\xd2\xd8" }  },
      /* --- pixel bitmap for stmary180 char#66 \niplus --- */
      {  66,51846,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 13,   15, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\xd2\xd1\x20\xf1\x61\x41\x10\xf1\x61\x51\x0d\xf1"
            "\x61\x51\xf1\x61\x41\x10\xa1\xa2\x38\x5f" }  },
      /* --- pixel bitmap for stmary180 char#67 \nplus --- */
      {  67,52578,                      /* character number, location */
         16, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,38, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x47\x62\x72\x31\xb1\x1f\x41\x61\x61\x01\x1b\x11\x0f"
            "\x41\x61\x61\x0f\x21\xd1" }  },
      /* --- pixel bitmap for stmary180 char#68 \subsetplus --- */
      {  68,53410,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x32\xc1\xc0\xf1\x11\x61\x6f\x11\x71\x61\x39\x2f"
            "\x11\x71\x60\xf1\x11\x61\x60\x21\xe0\x12\xe0\x1a" }  },
      /* --- pixel bitmap for stmary180 char#69 \supsetplus --- */
      {  69,54204,                      /* character number, location */
         14, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   15, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\xe0\x12\xe0\x11\x20\xf1\x61\x61\x10\xf1\x61\x71"
            "\x29\x31\xf1\x61\x71\xf1\x61\x61\x10\xc1\xc2\x3a\x51" }  },
      /* --- pixel bitmap for stmary180 char#70 \subsetpluseq --- */
      {  70,55016,                      /* character number, location */
         16, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 15,   21, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x5a\x32\xc1\xc0\xf1\x11\x61\x6f\x11\x71\x61\x39\x2f"
            "\x11\x71\x60\xf1\x11\x61\x60\x21\xe0\x12\xe0\x1a\xf4"
            "\xe0\x1e\x01" }  },
      /* --- pixel bitmap for stmary180 char#71 \supsetpluseq --- */
      {  71,55834,                      /* character number, location */
         16, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 15,   21, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0a\xe0\x12\xe0\x11\x20\xf1\x61\x61\x10\xf1\x61\x71"
            "\x29\x31\xf1\x61\x71\xf1\x61\x61\x10\xc1\xc2\x3a\x50"
            "\xf4\xe0\x1e\x01" }  },
      /* --- pixel bitmap for stmary180 char#72 \Lbag --- */
      {  72,56615,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  9,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x42\x8c\x00\x01\x02\x04\x08\x08\x10\x30\x20\x60"
            "\xc0\xc0\x80\x01\x01\x03\x06\x0c\x18\x30\xc0\x00\x03"
            "\x1c\xe0\x01" }  },
      /* --- pixel bitmap for stmary180 char#73 \Rbag --- */
      {  73,57117,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  9,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf0\x10\x22\x46\x80\x00\x01\x02\x08\x10\x60\x80\x00"
            "\x03\x06\x18\x30\x40\x80\x01\x03\x06\x0c\x18\x18\x18"
            "\x1c\x0f\x00" }  },
      /* --- pixel bitmap for stmary180 char#74 \llbracket --- */
      {  74,57976,                      /* character number, location */
         19, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  8,   25, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x0f\xe1\x21\x4f\x71\x21\x48" }  },
      /* --- pixel bitmap for stmary180 char#75 \rrbracket --- */
      {  75,58878,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  7,   25, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xfe\x31\x21\xf7\x31\x21\x07" }  },
      /* --- pixel bitmap for stmary180 char#76 \llparenthesis --- */
      {  76,59638,                      /* character number, location */
         19, 3,   -6, 3,      /* topleft row,col, and botleft row,col */
          {  6,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x20\x8c\xb2\xa4\x69\x8a\xe3\x38\x8e\xe3\x38\x8e\xa3"
            "\x68\x9a\x24\x8b\xc2\x20" }  },
      /* --- pixel bitmap for stmary180 char#77 \rrparenthesis --- */
      {  77,60395,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          {  6,   25, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\x50\x34\x49\x96\x45\x71\x1c\xc7\x71\x1c\xc7\x71"
            "\x94\x65\x49\x53\x0c\x01" }  },
      /* --- pixel bitmap for stmary180 char#78 \binampersand --- */
      {  78,61208,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x03\x40\x08\x40\x20\x80\x40\x00\x81\x00\x82\x00"
            "\xc8\x00\x70\x00\x98\x00\x09\x06\x09\x10\x0a\x40\x12"
            "\x00\x23\x00\x4e\x00\x23\x81\x81\xfc\x00\x00" }  },
      /* --- pixel bitmap for stmary180 char#79 \bindnasrepma --- */
      {  79,61913,                      /* character number, location */
         15, 1,   -2, 1,      /* topleft row,col, and botleft row,col */
          { 17,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x7e\x02\x03\x89\x01\xe4\x00\x88\x01\x90\x04\xa0"
            "\x10\x20\xc1\x20\x01\x32\x00\x1c\x00\x26\x00\x82\x00"
            "\x02\x01\x04\x02\x08\x04\x20\x04\x80\x07\x00" }  },
      /* --- pixel bitmap for stmary180 char#80 \trianglelefteqslant --- */
      {  80,62693,                      /* character number, location */
         16, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 15,   21, 3,76, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe1\xc3\xa2\x21\x82\x41\x62\x61\x42\x81\x22\xa3\xc1"
            "\x12\xb1\x32\x91\x52\x71\x72\x51\x92\x32\xa2\x11\x12"
            "\xa2\x32\xe0\x12\xe0\x12\xe0\x12\xe0\x12\xe0\x12" }  },
      /* --- pixel bitmap for stmary180 char#81 \trianglerighteqslant --- */
      {  81,63472,                      /* character number, location */
         16, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 15,   21, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\xe3\xc1\x22\xa1\x42\x81\x62\x61\x82\x41\xa2\x21"
            "\xc3\xb2\x11\x92\x31\x72\x51\x52\x71\x32\x91\x12\xa3"
            "\xa2\xb2\xb2\xb2\xb2\xb2\xb2\xd2" }  },
      /* --- pixel bitmap for stmary180 char#82 \ntrianglelefteqslant --- */
      {  82,64297,                      /* character number, location */
         20, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 15,   28, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x10\x00\x08\x00\x04\x00\x01\x80\x04\xa0\x03\x30"
            "\x01\x8e\xc0\x42\x18\x21\x43\x70\x20\x68\x10\xc4\x04"
            "\x82\x03\x81\x83\x40\xc6\x20\xac\x09\x18\x07\x00\x07"
            "\x80\x0c\x40\x18\x10\x30\x08\x60\x02\x00\x01\x80\x00"
            "\x00" }  },
      /* --- pixel bitmap for stmary180 char#83 \ntrianglerighteqslant --- */
      {  83,65169,                      /* character number, location */
         20, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 15,   28, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x10\x00\x08\x00\x04\x00\x11\x80\x38\x20\x64\x10"
            "\xc2\x08\x81\x83\x00\x43\x40\x26\x20\x1c\x10\x0b\x64"
            "\x04\x0e\x82\x01\x71\x80\x26\xe0\x08\x0c\x84\x01\x31"
            "\x80\x06\xc0\x00\x18\x00\x0b\x00\x02\x00\x01\x80\x00"
            "\x00" }  },
      /* --- pixel bitmap for stmary180 char#84 \llfloor --- */
      {  84,65885,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   25, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x01\x51\x6f\x81\x51\x6d" }  },
      /* --- pixel bitmap for stmary180 char#85 \rrfloor --- */
      {  85,66589,                      /* character number, location */
         19, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 13,   25, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x61\x51\xf8\x61\x51\x0d" }  },
      /* --- pixel bitmap for stmary180 char#86 \llceil --- */
      {  86,67279,                      /* character number, location */
         19, 1,   -6, 1,      /* topleft row,col, and botleft row,col */
          { 13,   25, 3,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x0f\xe1\x51\x6f\x81\x51\x61" }  },
      /* --- pixel bitmap for stmary180 char#87 \rrceil --- */
      {  87,67970,                      /* character number, location */
         19, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 13,   25, 3,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\xfe\x61\x51\xf8\x61\x51" }  },
      /* --- pixel bitmap for stmary180 char#88 \arrownot --- */
      {  88,68393,                      /* character number, location */
         11, 9,    1, 9,      /* topleft row,col, and botleft row,col */
          {  7,   10, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x10\x08\x82\x40\x10\x04\x82\x00" }  },
      /* --- pixel bitmap for stmary180 char#89 \Arrownot --- */
      {  89,68745,                      /* character number, location */
         14,10,   -2,10,      /* topleft row,col, and botleft row,col */
          {  5,   16, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x10\x42\x84\x10\x21\x84\x08\x21\x42\x08" }  },
      /* --- pixel bitmap for stmary180 char#90 \Mapstochar --- */
      {  90,69132,                      /* character number, location */
         14, 1,   -1, 1,      /* topleft row,col, and botleft row,col */
          {  2,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x57\x75\x15" }  },
      /* --- pixel bitmap for stmary180 char#91 \mapsfromchar --- */
      {  91,69429,                      /* character number, location */
         11,-3,    2,-3,      /* topleft row,col, and botleft row,col */
          {  2,    9, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xab\x02" }  },
      /* --- pixel bitmap for stmary180 char#92 \Mapsfromchar --- */
      {  92,69733,                      /* character number, location */
         14,-3,   -1,-3,      /* topleft row,col, and botleft row,col */
          {  2,   15, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xaa\xab\xba\x2a" }  },
      /* --- pixel bitmap for stmary180 char#93 \leftrightarrowtriangle --- */
      {  93,70586,                      /* character number, location */
         10, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x00\x03\x2c\x80\x86\x11\x40\x2c\xf8\x3f\x68\x04"
            "\x10\xc3\x02\x68\x80\x01\x0c\x00" }  },
      /* --- pixel bitmap for stmary180 char#94 \leftarrowtriangle --- */
      {  94,71429,                      /* character number, location */
         10, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x53\xe0\x42\x21\xe0\x31\x41\xe0\x12\x5e\x02\x21\x41"
            "\xe0\x42\x21\xe0\x63\xe0\x11" }  },
      /* --- pixel bitmap for stmary180 char#95 \rightarrowtriangle --- */
      {  95,72251,                      /* character number, location */
         10, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 23,    7, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x13\xe0\x61\x22\xe0\x41\x41\x2e\x02\x52\xe0\x11"
            "\x41\xe0\x31\x22\xe0\x43\x51" }  },
      /* --- pixel bitmap for stmary180 char#96 \bigtriangledown --- */
      {  96,72959,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x05\x03\xd3\xf1\x12\xd2\x10\x13\xb3\x32\xb2"
            "\x43\x93\x20\xf1\x32\x92\x30\x33\x73\x30\xf1\x42\x72"
            "\x40\x43\x53\x92\x52\xa3\x33\x50\xf1\x62\x32\x60\x63"
            "\x13\x60\xf1\x72\x12\x70\x75\x70\xf1\x83\x80\x92\x80" }  },
      /* --- pixel bitmap for stmary180 char#97 \bigtriangleup --- */
      {  97,73750,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,102, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x92\x80\xf1\x83\x80\x75\x70\xf1\x72\x12\x70\x63\x13"
            "\x60\xf1\x62\x32\x60\x53\x33\xa2\x52\x93\x53\x40\xf1"
            "\x42\x72\x40\x33\x73\x30\xf1\x32\x92\x30\x23\x93\x42"
            "\xb2\x33\xb3\x10\xf1\x12\xd2\x13\xd3\x0f\x1e\x05" }  },
      /* --- pixel bitmap for stmary180 char#98 \bigcurlyvee --- */
      {  98,74539,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x16\xb4\x23\x93\x53\x73\x72\x72\x83\x53\x93"
            "\x33\x50\xf1\x62\x32\x60\x63\x13\x60\xf1\x72\x12\x70"
            "\x75\x70\xfa\x83\x80\x92\x81" }  },
      /* --- pixel bitmap for stmary180 char#99 \bigcurlywedge --- */
      {  99,75316,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x92\x80\xfa\x83\x80\x75\x70\xf1\x72\x12\x70\x63\x13"
            "\x60\xf1\x62\x32\x60\x53\x33\x93\x53\x82\x72\x73\x73"
            "\x53\x93\x24\xb6\xe0\x12" }  },
      /* --- pixel bitmap for stmary180 char#100 \bigsqcap --- */
      { 100,76121,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x13\x00\xff\x16\x02\x0f\x02" }  },
      /* --- pixel bitmap for stmary180 char#101 \bigbox --- */
      { 101,76928,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x05\x0f\xe2\xe0\x12\x0f\x52\xe0\x12\x0f\x1e"
            "\x05" }  },
      /* --- pixel bitmap for stmary180 char#102 \bigparallel --- */
      { 102,77561,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          {  9,   25, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x52\x0f\x92\x52" }  },
      /* --- pixel bitmap for stmary180 char#103 \biginterleave --- */
      { 103,78299,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 16,   25, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x52\x52\x0f\x92\x52\x52" }  },
      /* --- pixel bitmap for stmary180 char#104 (noname) --- */
      { 104,79285,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 3,157, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0c\x03\xe0\x63\xf1\x12\xe0\x62\x10\x13\xe0"
            "\x43\x32\xe0\x42\x43\xe0\x23\x20\xf1\x32\xe0\x22\x30"
            "\x33\xe3\x30\xf1\x42\xe2\x40\x43\xc3\x40\xf1\x52\xc2"
            "\x50\x53\xa3\xb2\xa2\xc3\x83\x60\xf1\x72\x82\x70\x73"
            "\x63\x70\xf1\x82\x62\x80\x83\x43\x80\xf1\x92\x42\x90"
            "\x93\x23\xe0\x52\x22\xe0\x66\xa0\xf2\xb4\xb0\xf1\xc2"
            "\xc0" }  },
      /* --- pixel bitmap for stmary180 char#105 (noname) --- */
      { 105,80245,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 3,156, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xc2\xc0\xf2\xb4\xb0\xa6\xe0\x62\x22\xe0\x53\x23"
            "\x90\xf1\x92\x42\x90\x83\x43\x80\xf1\x82\x62\x80\x73"
            "\x63\x70\xf1\x72\x82\x70\x63\x83\xc2\xa2\xb3\xa3\x50"
            "\xf1\x52\xc2\x50\x43\xc3\x40\xf1\x42\xe2\x40\x33\xe3"
            "\x30\xf1\x32\xe0\x22\x30\x23\xe0\x23\x42\xe0\x42\x33"
            "\xe0\x43\x10\xf1\x12\xe0\x62\x13\xe0\x63\x0f\x1e\x0c" }  },
      /* --- pixel bitmap for stmary180 char#106 (noname) --- */
      { 106,81203,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x86\xe0\x44\x23\xe0\x23\x53\xe3\x73\xc3\x93"
            "\xa3\xb2\xa2\xc3\x83\xd3\x63\xe0\x12\x62\xe0\x23\x43"
            "\x80\xf1\x92\x42\x90\x93\x23\x90\xf1\xa2\x22\xa0\xa6"
            "\xa0\xf5\xb4\xb0\xfb\xc2\xc0" }  },
      /* --- pixel bitmap for stmary180 char#107 (noname) --- */
      { 107,82141,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 3,90, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\xc2\xc0\xf5\xb4\xb0\xa6\xa0\xf1\xa2\x22\xa0\x93"
            "\x23\x90\xf1\x92\x42\x90\x83\x43\xe0\x22\x62\xe0\x13"
            "\x63\xd3\x83\xc2\xa2\xb3\xa3\x93\xc3\x73\xe3\x53\xe0"
            "\x23\x24\xe0\x46\xe0\x82" }  },
      /* --- pixel bitmap for stmary180 char#108 (noname) --- */
      { 108,83100,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x1a\x00\xff\x20\x02\x16\x02" }  },
      /* --- pixel bitmap for stmary180 char#109 (noname) --- */
      { 109,84080,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x1a\x00\xff\x1e\x02\x16\x02\x00\xff\x01"
            "\x1a" }  },
      /* --- pixel bitmap for stmary180 char#110 (noname) --- */
      { 110,84808,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 12,   35, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x22\x00\x02\x08\x02" }  },
      /* --- pixel bitmap for stmary180 char#111 (noname) --- */
      { 111,85719,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 22,   35, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x22\x00\x02\x08\x02\x08\x02" }  },
      /* --- pixel bitmap for stmary180 char#112 \bignplus --- */
      { 112,86733,                      /* character number, location */
          0, 1,  -25, 1,      /* topleft row,col, and botleft row,col */
          { 19,   25, 3,66, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xab\x73\x73\x53\x93\x33\xb3\x22\xd2\x13\xd5\xe0"
            "\x12\x0f\x32\x72\x62\x0f\x12\x2b\x22\x0f\x32\x72\x62"
            "\x02\x71\x72\x0f\x52\xe0\x12" }  },
      /* --- pixel bitmap for stmary180 char#113 (noname) --- */
      { 113,87769,                      /* character number, location */
          1, 5,  -28, 5,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x0f\xe1\x21\x3f\xb1\x21\x37" }  },
      /* --- pixel bitmap for stmary180 char#114 (noname) --- */
      { 114,88806,                      /* character number, location */
          1, 6,  -43, 6,      /* topleft row,col, and botleft row,col */
          {  8,   44, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\x00\xff\x29\x01\x03\x01\x03\x08" }  },
      /* --- pixel bitmap for stmary180 char#115 (noname) --- */
      { 115,89930,                      /* character number, location */
          1, 6,  -58, 6,      /* topleft row,col, and botleft row,col */
          { 10,   59, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0a\x00\xff\x36\x02\x02\x02\x04\xff\x01"
            "\x0a" }  },
      /* --- pixel bitmap for stmary180 char#116 (noname) --- */
      { 116,91110,                      /* character number, location */
          1, 6,  -73, 6,      /* topleft row,col, and botleft row,col */
          { 11,   74, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0b\x00\xff\x45\x02\x02\x02\x05\xff\x01"
            "\x0b" }  },
      /* --- pixel bitmap for stmary180 char#117 (noname) --- */
      { 117,92345,                      /* character number, location */
          0, 8,  -45, 8,      /* topleft row,col, and botleft row,col */
          { 11,   45, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0b\x0f\xe2\x32\x4f\xe2\x32\x4f\xb2\x32\x42\x31"
            "\x52" }  },
      /* --- pixel bitmap for stmary180 char#118 (noname) --- */
      { 118,93396,                      /* character number, location */
          2, 8,  -43, 8,      /* topleft row,col, and botleft row,col */
          { 11,   45, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x31\x5f\xe2\x32\x4f\xe2\x32\x4f\xb2\x32\x4f\x1b" }  },
      /* --- pixel bitmap for stmary180 char#119 (noname) --- */
      { 119,94438,                      /* character number, location */
          2, 8,  -16, 8,      /* topleft row,col, and botleft row,col */
          {  7,   18, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x31\x1f\xe2\x32\x0f\x12\x32" }  },
      /* --- pixel bitmap for stmary180 char#120 (noname) --- */
      { 120,95428,                      /* character number, location */
          0, 1,  -35, 1,      /* topleft row,col, and botleft row,col */
          { 26,   35, 3,84, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x98\xe0\x2c\xc4\x84\x93\xc3\x73\xe3\x53\xe0\x23\x33"
            "\xe0\x43\x22\xe0\x62\x13\xe0\x65\xe0\x82\x0f\x62\xa2"
            "\xa2\x02\x3e\x02\x34\x2e\x04\x22\x0f\x72\xa2\xa2\x0f"
            "\x72\xe0\x82" }  },
      /* --- pixel bitmap for stmary180 char#121 (noname) --- */
      { 121,96477,                      /* character number, location */
          1, 1,  -28, 1,      /* topleft row,col, and botleft row,col */
          {  7,   29, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\xfe\x31\x21\xfb\x31\x21\x07" }  },
      /* --- pixel bitmap for stmary180 char#122 (noname) --- */
      { 122,97475,                      /* character number, location */
          1, 1,  -43, 1,      /* topleft row,col, and botleft row,col */
          {  8,   44, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x08\xff\x29\x03\x01\x03\x01\x00\x08" }  },
      /* --- pixel bitmap for stmary180 char#123 (noname) --- */
      { 123,98560,                      /* character number, location */
          1, 0,  -58, 0,      /* topleft row,col, and botleft row,col */
          { 10,   59, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0a\xff\x36\x04\x02\x02\x02\x00\xff\x01"
            "\x0a" }  },
      /* --- pixel bitmap for stmary180 char#124 (noname) --- */
      { 124,99727,                      /* character number, location */
          1, 0,  -73, 0,      /* topleft row,col, and botleft row,col */
          { 11,   74, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0b\xff\x45\x05\x02\x02\x02\x00\xff\x01"
            "\x0b" }  },
      /* --- pixel bitmap for stmary180 char#125 (noname) --- */
      { 125,100923,                     /* character number, location */
          0, 0,  -45, 0,      /* topleft row,col, and botleft row,col */
          { 11,   45, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0b\xfe\x42\x32\xfe\x42\x32\xfb\x42\x32\x51\x32" }  },
      /* --- pixel bitmap for stmary180 char#126 (noname) --- */
      { 126,102029,                     /* character number, location */
          2, 0,  -43, 0,      /* topleft row,col, and botleft row,col */
          { 11,   45, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x32\xfe\x42\x32\xfe\x42\x32\xfb\x42\x32\x0f\x1b" }  },
      /* --- pixel bitmap for stmary180 char#127 (noname) --- */
      { 127,103032,                     /* character number, location */
          2, 4,  -16, 4,      /* topleft row,col, and botleft row,col */
          {  7,   18, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x32\x0f\xe2\x32\x0f\x12\x32" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=6 for .210gf ---
 * mf '\mode=preview; mag=magstep(-13.80488502080647873125); input stmary10'
 * --------------------------------------------------------------------- */
/* --- fontdef for stmary210 --- */
static	chardef  stmary210[] =
   {
      /* --- pixel bitmap for stmary210 char#0 \shortleftarrow --- */
      {   0,  948,                      /* character number, location */
         12, 2,    2, 2,      /* topleft row,col, and botleft row,col */
          { 19,   10, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\xd0\xf1\x41\xe0\x22\xe0\x10\xf1\x1e\x04\x22\xe0"
            "\x10\xf1\x41\xe0\x51\xd0" }  },
      /* --- pixel bitmap for stmary210 char#1 \shortrightarrow --- */
      {   1, 1889,                      /* character number, location */
         12, 2,    2, 2,      /* topleft row,col, and botleft row,col */
          { 19,   10, 3,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xd1\x50\xf1\xe1\x40\xe0\x12\x2f\x1e\x05\xe0\x12\x20"
            "\xf1\xe1\x40\xd1\x51" }  },
      /* --- pixel bitmap for stmary210 char#2 \shortuparrow --- */
      {   2, 2690,                      /* character number, location */
         17, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 11,   19, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x92\x84\x61\x12\x11\x41\x22\x21\x21\x32\x31\xfc"
            "\x52\x41" }  },
      /* --- pixel bitmap for stmary210 char#3 \shortdownarrow --- */
      {   3, 3523,                      /* character number, location */
         17, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 11,   19, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfc\x52\x40\x11\x32\x31\x21\x22\x21\x41\x12\x11\x64"
            "\x82\xa1\x40" }  },
      /* --- pixel bitmap for stmary210 char#4 \Yup --- */
      {   4, 4136,                      /* character number, location */
         15, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 12,   14, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf7\x52\x50\x44\x76\x53\x23\x33\x43\x13\x65\x82" }  },
      /* --- pixel bitmap for stmary210 char#5 \Ydown --- */
      {   5, 4723,                      /* character number, location */
         13, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   13, 3,25, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x85\x63\x13\x43\x33\x23\x56\x74\x40\xf6\x52\x54" }  },
      /* --- pixel bitmap for stmary210 char#6 \Yleft --- */
      {   6, 5349,                      /* character number, location */
         13, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\xb3\xa3\xa3\xa3\x3f\x1a\x40\x83\xc3\xc3\xc3\xc2" }  },
      /* --- pixel bitmap for stmary210 char#7 \Yright --- */
      {   7, 5966,                      /* character number, location */
         13, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 14,   12, 3,27, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xc3\xc3\xc3\xc3\x80\xf1\x4a\x33\xa3\xa3\xa3\xb2"
            "\xc2" }  },
      /* --- pixel bitmap for stmary210 char#8 \varcurlyvee --- */
      {   8, 6599,                      /* character number, location */
         20, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 20,   27, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x25\xe3\x13\xc3\x33\xa3\x53\x83\x73\x63\x92"
            "\x62\xa3\x43\xb2\x42\xc3\x23\x60\xf1\x72\x22\x70\x76"
            "\x70\xf4\x84\x80\xf8\x92\x90" }  },
      /* --- pixel bitmap for stmary210 char#9 \varcurlywedge --- */
      {   9, 7298,                      /* character number, location */
         20, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 20,   27, 3,64, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x92\x90\xf4\x84\x80\x76\x70\xf1\x72\x22\x70\x63"
            "\x23\xc2\x42\xb3\x43\xa2\x62\x93\x63\x73\x83\x53\xa3"
            "\x33\xc3\x13\xe5\xe0\x22" }  },
      /* --- pixel bitmap for stmary210 char#10 \minuso --- */
      {  10, 8125,                      /* character number, location */
         13, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   12, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x75\xc9\x93\x53\x82\x72\x73\x73\x3f\x1e\x05\x33\x73"
            "\x72\x72\x83\x53\x99\xc5\x72" }  },
      /* --- pixel bitmap for stmary210 char#11 \baro --- */
      {  11, 8807,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 12,   20, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x52\x50\x44\x68\x33\x12\x13\x13\x22\x23\x0f\x32"
            "\x32\x32\x03\x22\x23\x13\x12\x13\x38\x64\x40\xf3\x52"
            "\x53" }  },
      /* --- pixel bitmap for stmary210 char#12 \sslash --- */
      {  12, 9495,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 15,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x63\x80\x31\xe0\x1c\x30\x06\x18\x03\x8c\x01\xe7"
            "\x80\x31\xc0\x18\x70\x0e\x18\x03\x8c\x01\xe7\x80\x31"
            "\xc0\x18\x60\x0c\x38\x07\x8c\x01\xc6\x80\x73\xc0\x18"
            "\x60\x0c\x38\x07\x8c\x01\xc6\x00\x63\xc0\x39\x60\x0c"
            "\x30\x06\x00" }  },
      /* --- pixel bitmap for stmary210 char#13 \bblash --- */
      {  13,10228,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 15,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x63\x80\x31\xc0\x39\xc0\x18\x60\x0c\x30\x06\x38\x07"
            "\x18\x03\x8c\x01\xce\x01\xc6\x00\x63\x80\x73\x80\x31"
            "\xc0\x18\x60\x0c\x70\x0e\x30\x06\x18\x03\x9c\x03\x8c"
            "\x01\xc6\x00\xe7\x00\x63\x80\x31\xc0\x18\xe0\x1c\x60"
            "\x0c\x30\x06" }  },
      /* --- pixel bitmap for stmary210 char#14 \moo --- */
      {  14,11049,                      /* character number, location */
         15, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 16,   16, 3,37, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf6\x72\x7f\x1e\x02\xf1\x72\x70\x64\x62\x44\x45\x26"
            "\x23\x16\x26\x34\x44\x23" }  },
      /* --- pixel bitmap for stmary210 char#15 \varotimes --- */
      {  15,11804,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\xc0\xff\x80\x03\x07\x07\x38\x3e\xf0\xd9\xe1"
            "\x76\xce\xf9\xf0\xc3\x83\x07\x0f\x1e\x3c\xfc\xf0\x39"
            "\xe7\x76\xb8\xf9\xc0\xc7\x01\x0e\x0e\x1c\xf0\x3f\x00"
            "\x3f\x00" }  },
      /* --- pixel bitmap for stmary210 char#16 \varoast --- */
      {  16,12728,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\xc0\xff\x80\x03\x07\x07\x38\x0e\xc3\x19\x0c"
            "\x76\x33\xfb\xfc\xcf\x83\x07\x0f\x1e\x3c\xff\xf3\xcd"
            "\xec\x06\x83\x39\x0c\xc7\x01\x0e\x0e\x1c\xf0\x3f\x00"
            "\x3f\x00" }  },
      /* --- pixel bitmap for stmary210 char#17 \varobar --- */
      {  17,13529,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,77, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x73\x22\x23\x53\x32\x33\x33\x42\x43\x22\x52"
            "\x52\x13\x52\x53\x0f\x32\x62\x62\x03\x52\x53\x12\x52"
            "\x52\x23\x42\x43\x33\x32\x33\x53\x22\x23\x7a\xa6\x63" }  },
      /* --- pixel bitmap for stmary210 char#18 \varodot --- */
      {  18,14321,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x73\x63\x53\x83\x33\xa3\x22\xc2\x13\xc5\x62"
            "\x62\x0f\x12\x54\x52\x02\x62\x65\xc3\x12\xc2\x23\xa3"
            "\x33\x83\x53\x63\x7a\xa6\x63" }  },
      /* --- pixel bitmap for stmary210 char#19 \varoslash --- */
      {  19,15104,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x73\x63\x53\x83\x33\x85\x22\x83\x12\x13\x73"
            "\x25\x73\x44\x63\x54\x53\x64\x43\x75\x23\x73\x12\x13"
            "\x82\x25\x83\x33\x83\x53\x63\x7a\xa6\x63" }  },
      /* --- pixel bitmap for stmary210 char#20 \varobslash --- */
      {  20,15899,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x73\x63\x53\x83\x35\x83\x22\x13\x82\x13\x23"
            "\x75\x43\x74\x53\x64\x63\x54\x73\x45\x73\x23\x12\x83"
            "\x12\x23\x85\x33\x83\x53\x63\x7a\xa6\x63" }  },
      /* --- pixel bitmap for stmary210 char#21 \varocircle --- */
      {  21,16833,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\xc0\xff\x80\x03\x07\x07\x38\x8e\xc7\x99\x7f"
            "\x76\x86\xf9\x1c\xce\x33\x30\xcf\xc0\x3c\x87\xf3\x19"
            "\xe6\xe6\x9f\x39\x1e\xc7\x01\x0e\x0e\x1c\xf0\x3f\x00"
            "\x3f\x00" }  },
      /* --- pixel bitmap for stmary210 char#22 \varoplus --- */
      {  22,17639,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\xc0\xff\x80\x33\x07\xc7\x38\x0e\xc3\x19\x0c"
            "\x76\x30\xf8\xc0\xc0\xff\xff\xff\xff\x3f\x30\xf0\xc1"
            "\xe0\x06\x83\x39\x0c\xc7\x31\x0e\xce\x1c\xf0\x3f\x00"
            "\x3f\x00" }  },
      /* --- pixel bitmap for stmary210 char#23 \varominus --- */
      {  23,18434,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,59, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x73\x63\x53\x83\x33\xa3\x22\xc2\x13\xc5\xe2"
            "\x0f\x1e\x04\x02\xe5\xc3\x12\xc2\x23\xa3\x33\x83\x53"
            "\x63\x7a\xa6\x62" }  },
      /* --- pixel bitmap for stmary210 char#24 \boxast --- */
      {  24,19253,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,76, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x04\x0f\x12\xe2\x0f\x12\x62\x62\x02\x22\x22"
            "\x22\x24\x2a\x22\x0f\x12\x54\x52\x02\x2a\x24\x22\x22"
            "\x22\x22\x0f\x12\x62\x62\x0f\x12\xe2\x0f\x1e\x04" }  },
      /* --- pixel bitmap for stmary210 char#25 \boxbar --- */
      {  25,19982,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x04\x0f\xd2\x62\x62\x0f\x1e\x04" }  },
      /* --- pixel bitmap for stmary210 char#26 \boxdot --- */
      {  26,20711,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,44, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x04\x0f\x42\xe2\x02\x62\x62\x0f\x12\x54\x52"
            "\x02\x62\x62\x0f\x42\xe2\x0f\x1e\x04" }  },
      /* --- pixel bitmap for stmary210 char#27 \boxslash --- */
      {  27,21422,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x04\x02\xc6\xb7\xa3\x14\x93\x24\x83\x34\x73"
            "\x44\x63\x54\x53\x64\x43\x74\x33\x84\x23\x94\x13\xa7"
            "\xb6\xc2\x0f\x1e\x04" }  },
      /* --- pixel bitmap for stmary210 char#28 \boxbslash --- */
      {  28,22146,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x04\x04\xc7\xb4\x13\xa4\x23\x94\x33\x84\x43"
            "\x74\x53\x64\x63\x54\x73\x44\x83\x34\x93\x24\xa3\x14"
            "\xb7\xc4\x0f\x1e\x04" }  },
      /* --- pixel bitmap for stmary210 char#29 \boxcircle --- */
      {  29,22874,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,66, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x04\x0f\x22\xe2\x02\x62\x64\x46\x44\x33\x23"
            "\x32\x0f\x12\x32\x42\x32\x02\x33\x23\x34\x46\x44\x62"
            "\x62\x0f\x22\xe2\x0f\x1e\x04" }  },
      /* --- pixel bitmap for stmary210 char#30 \boxbox --- */
      {  30,23599,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,50, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x04\x0f\x22\xe2\x0f\x12\x38\x32\x0f\x32\x32"
            "\x42\x32\x0f\x12\x38\x32\x0f\x22\xe2\x0f\x1e\x04" }  },
      /* --- pixel bitmap for stmary210 char#31 \boxempty --- */
      {  31,24320,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x04\x0f\xd2\xe2\x0f\x1e\x04" }  },
      /* --- pixel bitmap for stmary210 char#32 \lightning --- */
      {  32,25221,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 10,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\x01\x06\x1c\x30\xc0\x80\x03\x06\x1c\x30\xc0\x80"
            "\x03\xe6\xfc\xf3\xc7\x18\x70\xc0\x80\x03\x86\x18\x72"
            "\xd0\xc0\x33\x3e\x18\x20\x00" }  },
      /* --- pixel bitmap for stmary210 char#33 \merge --- */
      {  33,26026,                      /* character number, location */
         22, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,116, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf3\x63\x43\x60\x55\x25\x50\xf1\x52\x12\x22\x12\x50"
            "\x43\x16\x13\x40\xf1\x42\x34\x32\x40\x33\x34\x33\x30"
            "\xf1\x32\x52\x52\x30\x23\x44\x43\x20\xf1\x22\x54\x52"
            "\x20\x13\x46\x43\x10\xf1\x12\x52\x22\x52\x13\x43\x23"
            "\x43\x0f\x12\x52\x42\x52" }  },
      /* --- pixel bitmap for stmary210 char#34 \vartimes --- */
      {  34,26731,                      /* character number, location */
         20, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 12,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x03\x7c\xe0\x06\xe6\x70\x0c\xc3\x39\x98\x81\x1f\xf0"
            "\x00\x0f\xf0\x00\x0f\xf8\x81\x19\x9c\xc3\x30\x0e\x67"
            "\x60\x07\x3e\xc0" }  },
      /* --- pixel bitmap for stmary210 char#35 \fatsemi --- */
      {  35,27326,                      /* character number, location */
         16, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          {  6,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xde\x3f\xcf\xbf\x07\x00\x00\xe0\xfd\xf3\xfc\xfb\x38"
            "\xc6\x31\x8e\x01" }  },
      /* --- pixel bitmap for stmary210 char#36 \sswarrow --- */
      {  36,28213,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 14,   26, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xc2\xf2\xb2\x10\xf1\xa2\x20\x93\x20\xf1\x92\x30"
            "\xf2\x82\x40\xf1\x72\x50\xf2\x62\x60\x52\x81\x32\x81"
            "\x22\xa1\x12\xa1\x12\x22\x75\x92\xc1\xa1" }  },
      /* --- pixel bitmap for stmary210 char#37 \ssearrow --- */
      {  37,29116,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 13,   26, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xb0\xf2\x12\xa0\xf1\x22\x90\x23\x80\xf1\x32"
            "\x80\xf2\x42\x70\xf1\x52\x60\xf2\x62\x50\x72\xb2\x31"
            "\x82\x21\x82\x11\x52\x22\x11\x75\xb2\xc1\x22" }  },
      /* --- pixel bitmap for stmary210 char#38 \curlywedgeuparrow --- */
      {  38,30130,                      /* character number, location */
         20, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 20,   26, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x92\x90\x84\xe0\x11\x12\x11\xc2\x22\x22\x50\xf2"
            "\x92\x90\xf4\x84\x80\x76\x70\xf1\x72\x22\x70\x63\x23"
            "\xc2\x42\xb3\x43\xa2\x62\x93\x63\x73\x83\x53\xa3\x33"
            "\xc3\x13\xe5\xe0\x22" }  },
      /* --- pixel bitmap for stmary210 char#39 \curlywedgedownarrow --- */
      {  39,31168,                      /* character number, location */
         21, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 20,   28, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x92\x90\xf4\x84\x80\x76\x70\xf1\x72\x22\x70\x63"
            "\x23\xc2\x42\xb3\x43\x61\x32\x62\x31\x31\x13\x63\x11"
            "\x31\x13\x83\x11\x24\xa4\x23\xc3\x13\xe9\x86\x61\x61"
            "\x63" }  },
      /* --- pixel bitmap for stmary210 char#40 \fatslash --- */
      {  40,31862,                      /* character number, location */
         22, 8,   -7, 8,      /* topleft row,col, and botleft row,col */
          { 18,   29, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x99\x83\x42\x92\x52\x92\x43\x83\x42\x92\x52\x92"
            "\x43\x83\x42\x92\x52\x92\x43\x83\x42\x92\x52\x92\x43"
            "\x83\x42\x92\x52\x92\x43\x83\x42\x92\x52\x92\x43\x83"
            "\x42\x92\x52\x92\x43\x83\x42\x92\x52\x92\x43\x83\x42"
            "\x9f\x19\x92" }  },
      /* --- pixel bitmap for stmary210 char#41 \fatbslash --- */
      {  41,32578,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 17,   29, 3,108, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x08\x99\x83\x42\x92\x42\x92\x43\x83\x42\x92\x42\x92"
            "\x43\x83\x42\x92\x42\x92\x43\x83\x42\x92\x42\x92\x43"
            "\x83\x42\x92\x42\x92\x43\x83\x42\x92\x42\x92\x43\x83"
            "\x42\x92\x42\x92\x43\x83\x42\x92\x42\x92\x43\x83\x42"
            "\xf1\x98" }  },
      /* --- pixel bitmap for stmary210 char#42 \lbag --- */
      {  42,33193,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  9,   29, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\x46\x32\x23\x22\x32\x20\xf1\x52\x20\x43\x20\xf3"
            "\x42\x30\x33\x30\xf3\x32\x40\x23\x40\xf8\x22\x50\x23"
            "\x76\x54" }  },
      /* --- pixel bitmap for stmary210 char#43 \rbag --- */
      {  43,33763,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  9,   29, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x43\x56\x23\x22\x22\x32\xf1\x22\x50\x23\x40\xf3\x32"
            "\x40\x33\x30\xf3\x42\x30\x43\x20\xf8\x52\x20\x43\x26"
            "\x34\x54" }  },
      /* --- pixel bitmap for stmary210 char#44 \varbigcirc --- */
      {  44,34671,                      /* character number, location */
         20, 2,   -5, 2,      /* topleft row,col, and botleft row,col */
          { 25,   25, 3,105, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x97\xe0\x2b\xc4\x74\x93\xb3\x73\xd3\x53\xe0\x13\x42"
            "\xe0\x32\x33\xe0\x33\x22\xe0\x52\x13\xe0\x53\x0f\x42"
            "\xe0\x72\x03\xe0\x53\x12\xe0\x52\x23\xe0\x33\x32\xe0"
            "\x32\x43\xe0\x13\x53\xd3\x73\xb3\x94\x74\xcb\xe0\x27"
            "\x91" }  },
      /* --- pixel bitmap for stmary210 char#45 \leftrightarroweq --- */
      {  45,35723,                      /* character number, location */
         15, 1,    3, 1,      /* topleft row,col, and botleft row,col */
          { 21,   12, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x51\x91\x50\xf1\x41\xb1\x40\x22\xd2\x2e\x07\x1e\x05"
            "\x32\xd2\x20\xf1\x41\xb1\x40\x51\x91\x50\xf1\x1e\x05"
            "\x10" }  },
      /* --- pixel bitmap for stmary210 char#46 \curlyveedownarrow --- */
      {  46,36335,                      /* character number, location */
         20, 0,   -6, 0,      /* topleft row,col, and botleft row,col */
          { 20,   26, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x25\xe3\x13\xc3\x33\xa3\x53\x83\x73\x63\x92"
            "\x62\xa3\x43\xb2\x42\xc3\x23\x60\xf1\x72\x22\x70\x76"
            "\x70\xf4\x84\x80\xf2\x92\x90\x52\x22\x22\xc1\x12\x11"
            "\xe0\x14\x80\xf1\x92\x93" }  },
      /* --- pixel bitmap for stmary210 char#47 \curlyveeuparrow --- */
      {  47,36993,                      /* character number, location */
         21, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 20,   28, 3,79, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\x61\x66\x89\xe3\x13\xc3\x24\xa4\x21\x13\x83\x11"
            "\x31\x13\x63\x11\x31\x32\x62\x31\x63\x43\xb2\x42\xc3"
            "\x23\x60\xf1\x72\x22\x70\x76\x70\xf4\x84\x80\xf8\x92"
            "\x90" }  },
      /* --- pixel bitmap for stmary210 char#48 \nnwarrow --- */
      {  48,37616,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 14,   26, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\xd2\xc5\x81\x12\x22\x61\x12\x91\x22\x91\x32\xc2"
            "\x70\xf2\x62\x60\xf1\x72\x50\xf2\x82\x40\xf1\x92\x30"
            "\x93\x20\xf1\xa2\x20\xf2\xb2\x10\xf1\xc2" }  },
      /* --- pixel bitmap for stmary210 char#49 \nnearrow --- */
      {  49,38207,                      /* character number, location */
         20, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 13,   26, 3,71, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa1\xb2\x85\x62\x22\x11\x92\x11\x92\x21\x72\x31\x72"
            "\x40\xf2\x62\x50\xf1\x52\x60\xf2\x42\x70\xf1\x32\x80"
            "\x23\x80\xf1\x22\x90\xf2\x12\xaf\x12\xb2" }  },
      /* --- pixel bitmap for stmary210 char#50 \leftslice --- */
      {  50,38986,                      /* character number, location */
         14, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   14, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe3\xe5\xb5\x13\x85\x42\x64\x73\x25\xa2\x0f\x15\xc2"
            "\x25\xa2\x54\x73\x75\x42\xa5\x13\xd5\xe0\x23\x22" }  },
      /* --- pixel bitmap for stmary210 char#51 \rightslice --- */
      {  51,39752,                      /* character number, location */
         14, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   14, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x23\xe0\x25\xd3\x15\xa2\x45\x73\x74\x52\xa5\x2f\x12"
            "\xc5\x02\xa5\x23\x74\x62\x45\x83\x15\xb5\xe3\xe2" }  },
      /* --- pixel bitmap for stmary210 char#52 \varolessthan --- */
      {  52,40514,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x73\x63\x53\x74\x33\x58\x22\x45\x32\x13\x24"
            "\x6a\x92\x0f\x15\xb2\x07\x95\x24\x63\x12\x45\x32\x23"
            "\x58\x33\x74\x53\x63\x7a\xa6\x6f" }  },
      /* --- pixel bitmap for stmary210 char#53 \varogreaterthan --- */
      {  53,41303,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x73\x63\x54\x73\x38\x53\x22\x35\x42\x13\x64"
            "\x25\x97\x0f\x12\xb5\x02\x9a\x64\x23\x12\x35\x42\x28"
            "\x53\x34\x73\x53\x63\x7a\xa6\x6f" }  },
      /* --- pixel bitmap for stmary210 char#54 \varovee --- */
      {  54,42084,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\xc0\xff\x80\x03\x07\x07\x38\x1e\xe0\x79\x80"
            "\xf7\x03\xff\x0c\xcc\x73\x38\x8f\x61\x3c\xce\xf1\x31"
            "\xe3\xc6\x8c\x39\x3f\xc7\x79\x0e\xee\x1d\xf0\x3f\x00"
            "\x3f\x00" }  },
      /* --- pixel bitmap for stmary210 char#55 \varowedge --- */
      {  55,42889,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 18,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x0f\xc0\xff\x80\x7b\x07\xe7\x39\xce\xcf\x19\x33"
            "\x76\xcc\xf8\x38\xc7\x63\x18\xcf\xe1\x3c\x03\xf3\x0f"
            "\xfc\x1e\xe0\x79\x80\xc7\x01\x0e\x0e\x1c\xf0\x3f\x00"
            "\x3f\x00" }  },
      /* --- pixel bitmap for stmary210 char#56 \talloblong --- */
      {  56,43536,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          {  9,   30, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x09\x0f\xe2\x52\x0f\xa2\x52\x0f\x19" }  },
      /* --- pixel bitmap for stmary210 char#57 \interleave --- */
      {  57,44308,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 14,   30, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x42\x42\x0f\xe2\x42\x42" }  },
      /* --- pixel bitmap for stmary210 char#58 \obar --- */
      {  58,45214,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,69, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xa2\x31\x32\x71\x51\x51\x51\x61\x61\x20\xf2\x11"
            "\x71\x71\x1f\x51\x81\x81\xf2\x11\x71\x71\x10\x21\x61"
            "\x61\x51\x51\x51\x72\x31\x32\xa7\x64" }  },
      /* --- pixel bitmap for stmary210 char#59 \oslash --- */
      {  59,46058,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xa2\x72\x71\xb1\x52\xc1\x31\x21\xc1\x21\x31\xb1"
            "\x21\x41\xa1\x11\x61\xa2\x71\x91\x0f\x11\x81\x81\x01"
            "\x91\x72\xa1\x61\x11\xa1\x41\x21\xb1\x31\x21\xc1\x21"
            "\x31\xc2\x51\xb1\x72\x72\xa7\x63" }  },
      /* --- pixel bitmap for stmary210 char#60 \olessthan --- */
      {  60,46889,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xa2\x72\x71\xb1\x51\xb3\x31\xa2\x31\x21\x82\x51"
            "\x21\x53\x71\x11\x42\xb2\x22\xd1\x0f\x13\xe0\x11\x01"
            "\x22\xd2\x42\xb1\x11\x53\x71\x21\x82\x51\x21\xa2\x31"
            "\x31\xb3\x51\xb1\x72\x72\xa7\x63" }  },
      /* --- pixel bitmap for stmary210 char#61 \ogreaterthan --- */
      {  61,47719,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xa2\x72\x71\xb1\x53\xb1\x31\x32\xa1\x21\x52\x81"
            "\x21\x73\x51\x11\xb2\x42\xd2\x21\x0f\x11\xe0\x13\x01"
            "\xd2\x22\xb2\x41\x11\x73\x51\x21\x52\x81\x21\x32\xa1"
            "\x33\xb1\x51\xb1\x72\x72\xa7\x63" }  },
      /* --- pixel bitmap for stmary210 char#62 \ovee --- */
      {  62,48541,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x1f\x80\x01\x03\x02\x20\x18\x00\xa3\x00\x28\x09"
            "\x20\x49\x00\x29\x02\x88\x21\x20\x0c\x01\x61\x08\x08"
            "\x83\x20\x18\x04\x41\x41\x04\x09\x22\x48\x10\x41\x04"
            "\x05\x41\x28\x04\x8c\x18\x80\x3f\x00" }  },
      /* --- pixel bitmap for stmary210 char#63 \owedge --- */
      {  63,49403,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc0\x1f\x80\x11\x03\x42\x21\x08\x0a\x22\x88\x20\x41"
            "\x04\x09\x22\x28\x08\x82\x41\x10\x0c\x01\x61\x08\x08"
            "\x43\x40\x18\x01\x44\x09\x20\x49\x00\x49\x01\x50\x0c"
            "\x80\x41\x00\x04\x0c\x18\x80\x3f\x00" }  },
      /* --- pixel bitmap for stmary210 char#64 \oblong --- */
      {  64,50153,                      /* character number, location */
         18, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,18, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x01\x0f\xd2\xb2\x0f\x1e\x01" }  },
      /* --- pixel bitmap for stmary210 char#65 \inplus --- */
      {  65,50890,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x78\x4b\x34\xa3\xb3\xc2\xc3\x42\x62\x52\x6f\x1e\x01"
            "\x02\x52\x63\x42\x72\xd3\xd3\xd4\xcb\x78" }  },
      /* --- pixel bitmap for stmary210 char#66 \niplus --- */
      {  66,51616,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 15,   18, 3,47, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x08\x7b\xc4\xd3\xd3\xd2\x72\x43\x62\x52\x0f\x1e\x01"
            "\x62\x52\x62\x43\xc2\xc3\xb3\xa4\x3b\x48\x7f" }  },
      /* --- pixel bitmap for stmary210 char#67 \nplus --- */
      {  67,52346,                      /* character number, location */
         18, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   19, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x55\x89\x53\x53\x33\x73\x13\x93\x0f\x12\xb2\x0f\x12"
            "\x52\x42\x0f\x12\x27\x22\x0f\x12\x52\x42\x0f\x52\xb2" }  },
      /* --- pixel bitmap for stmary210 char#68 \subsetplus --- */
      {  68,53174,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x5e\x34\xe3\xe0\x13\xe0\x22\xe0\x23\x72\x72\x82"
            "\x7f\x12\x66\x52\x82\x73\x72\x82\xe0\x33\xe0\x33\xe0"
            "\x34\xe0\x3e\x7c" }  },
      /* --- pixel bitmap for stmary210 char#69 \supsetplus --- */
      {  69,53968,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x7e\xe0\x34\xe0\x33\xe0\x33\xe0\x32\x82\x73\x72"
            "\x82\xf1\x56\x62\x72\x82\x72\x73\xe0\x22\xe0\x23\xe0"
            "\x13\xe4\x3e\x5c\x71" }  },
      /* --- pixel bitmap for stmary210 char#70 \subsetpluseq --- */
      {  70,54780,                      /* character number, location */
         18, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x7c\x5e\x34\xe3\xe0\x13\xe0\x22\xe0\x23\x72\x72\x82"
            "\x7f\x12\x66\x52\x82\x73\x72\x82\xe0\x33\xe0\x33\xe0"
            "\x34\xe0\x3e\x7c\xf3\xe0\x50\xf1\x1e\x04" }  },
      /* --- pixel bitmap for stmary210 char#71 \supsetpluseq --- */
      {  71,55600,                      /* character number, location */
         18, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0c\x7e\xe0\x34\xe0\x33\xe0\x33\xe0\x32\x82\x73\x72"
            "\x82\xf1\x56\x62\x72\x82\x72\x73\xe0\x22\xe0\x23\xe0"
            "\x13\xe4\x3e\x5c\x70\xf3\xe0\x5f\x1e\x04\x11" }  },
      /* --- pixel bitmap for stmary210 char#72 \Lbag --- */
      {  72,56383,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  9,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1c\x44\x9c\x38\x21\x02\x04\x08\x10\x30\x20\x40\xc0"
            "\x80\x80\x01\x03\x03\x06\x0c\x0c\x18\x30\x60\xc0\x80"
            "\x01\x06\x0c\x30\xc0\x01\x1e" }  },
      /* --- pixel bitmap for stmary210 char#73 \Rbag --- */
      {  73,56897,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  9,   29, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x70\x10\x21\x47\x8e\x08\x01\x02\x04\x18\x20\x40\x80"
            "\x01\x02\x0c\x18\x60\xc0\x80\x01\x06\x0c\x18\x30\x60"
            "\xc0\xc0\x80\x81\xc1\xf1\x00" }  },
      /* --- pixel bitmap for stmary210 char#74 \llbracket --- */
      {  74,57768,                      /* character number, location */
         22, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 10,   29, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0a\x0f\xe2\x22\x4f\x92\x22\x4f\x1a" }  },
      /* --- pixel bitmap for stmary210 char#75 \rrbracket --- */
      {  75,58682,                      /* character number, location */
         22, 1,   -7, 1,      /* topleft row,col, and botleft row,col */
          {  9,   29, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x09\xfe\x32\x22\xf9\x32\x22\x0f\x19" }  },
      /* --- pixel bitmap for stmary210 char#76 \llparenthesis --- */
      {  76,59454,                      /* character number, location */
         22, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  7,   30, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x30\x1c\x8f\x66\x93\xcd\x62\xf1\x78\x3c\x1e\x8f"
            "\xc7\xe3\xf1\x78\x2c\x16\x9b\xc9\x6c\x34\x1e\x0e\x06"
            "\x02" }  },
      /* --- pixel bitmap for stmary210 char#77 \rrparenthesis --- */
      {  77,60223,                      /* character number, location */
         22, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  7,   30, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\xc1\xe1\xb1\xd8\x4c\x66\xa3\xd1\x78\x3c\x1e\x8f"
            "\xc7\xe3\xf1\x78\x3c\x1a\xcd\x26\x9b\xc5\xe3\x30\x08"
            "\x00" }  },
      /* --- pixel bitmap for stmary210 char#78 \binampersand --- */
      {  78,61048,                      /* character number, location */
         17, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x74\xd7\xb3\x33\x60\xf2\x42\x52\x60\x43\x33\xb3\x13"
            "\xd5\xc6\x72\x24\x24\x52\x13\x63\x36\x83\x22\x12\xa6"
            "\x12\xb4\x22\xb5\x12\x94\x16\x64\x42\x1b\xa6\xa0" }  },
      /* --- pixel bitmap for stmary210 char#79 \bindnasrepma --- */
      {  79,61759,                      /* character number, location */
         18, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 19,   20, 3,75, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa6\xab\x12\x44\x66\x14\x92\x15\xb2\x24\xb2\x16\xa2"
            "\x12\x23\x86\x33\x63\x12\x54\x24\x22\x76\xc5\xd3\x13"
            "\xb3\x33\x40\xf2\x62\x52\x40\x63\x33\xb7\xd4\x70" }  },
      /* --- pixel bitmap for stmary210 char#80 \trianglelefteqslant --- */
      {  80,62545,                      /* character number, location */
         18, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x32\xe0\x14\xd6\xb4\x22\x85\x42\x65\x62\x44\x92"
            "\x24\xb2\x0f\x14\xd2\x24\xb2\x44\x92\x65\x62\x85\x44"
            "\x94\x26\x96\x24\x94\x44\x92\x65\xe0\x25\xe0\x34\xe0"
            "\x34\xe0\x34\xe0\x32" }  },
      /* --- pixel bitmap for stmary210 char#81 \trianglerighteqslant --- */
      {  81,63334,                      /* character number, location */
         18, 2,   -6, 2,      /* topleft row,col, and botleft row,col */
          { 19,   24, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x34\xe0\x16\xd2\x24\xb2\x45\x82\x65\x62\x94"
            "\x42\xb4\x2f\x12\xd4\x02\xb4\x22\x94\x42\x65\x62\x45"
            "\x82\x24\x98\x98\x94\x22\x94\xc5\xc5\xc4\xd4\xd4\xe0"
            "\x12\xe0\x34" }  },
      /* --- pixel bitmap for stmary210 char#82 \ntrianglelefteqslant --- */
      {  82,64169,                      /* character number, location */
         23, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 19,   32, 3,131, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x12\x20\xe3\xe0\x22\xe0\x23\xe0\x22\x22\xf1"
            "\xc7\xa5\x22\x86\x32\x64\x12\x42\x44\x23\x42\x24\x42"
            "\x56\x53\x56\x52\x62\x24\x23\x62\x46\x72\x65\x62\x76"
            "\x44\x52\x24\x26\x23\x46\x26\x74\x45\x82\x56\xd2\x24"
            "\xa3\x44\x82\x74\x53\x94\x32\xc2\x23\xe0\xf1\x22\xe0"
            "\x10" }  },
      /* --- pixel bitmap for stmary210 char#83 \ntrianglerighteqslant --- */
      {  83,65051,                      /* character number, location */
         23, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 19,   32, 3,127, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x12\x20\xe3\xe0\x22\xe0\x23\x32\xb2\x44\x83"
            "\x46\x62\x52\x25\x32\x52\x48\x52\x74\x62\x85\x42\x82"
            "\x14\x22\x73\x36\x72\x46\x63\x24\x22\x67\x42\x65\x62"
            "\x44\x92\x25\x8b\x68\x22\x54\x22\x33\x25\x92\x15\xb5"
            "\xd4\xd4\xd6\xd2\x12\xe0\x23\xe0\xf1\x22\xe0\x12" }  },
      /* --- pixel bitmap for stmary210 char#84 \llfloor --- */
      {  84,65775,                      /* character number, location */
         22, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          { 14,   30, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x42\x6f\xc2\x42\x6f\x1e" }  },
      /* --- pixel bitmap for stmary210 char#85 \rrfloor --- */
      {  85,66497,                      /* character number, location */
         22, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 14,   30, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x62\x42\xfc\x62\x42\x0f\x1e" }  },
      /* --- pixel bitmap for stmary210 char#86 \llceil --- */
      {  86,67205,                      /* character number, location */
         21, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 14,   28, 3,17, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0f\xe2\x42\x6f\xa2\x42\x63" }  },
      /* --- pixel bitmap for stmary210 char#87 \rrceil --- */
      {  87,67906,                      /* character number, location */
         21, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 14,   28, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\xfe\x62\x42\xfa\x62\x42" }  },
      /* --- pixel bitmap for stmary210 char#88 \arrownot --- */
      {  88,68339,                      /* character number, location */
         13,10,    2,10,      /* topleft row,col, and botleft row,col */
          {  9,   11, 3,23, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x71\x73\x53\x62\x63\x53\x53\x62\x63\x53\x71\x74" }  },
      /* --- pixel bitmap for stmary210 char#89 \Arrownot --- */
      {  89,68693,                      /* character number, location */
         16,11,   -1,11,      /* topleft row,col, and botleft row,col */
          {  7,   17, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x60\x30\x1c\x06\xc3\x61\x30\x1c\x06\xc3\x61\x30\x1c"
            "\x06\x03" }  },
      /* --- pixel bitmap for stmary210 char#90 \Mapstochar --- */
      {  90,69082,                      /* character number, location */
         16, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          {  3,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdb\xb6\x7f\xdb\xfe\x6d\x1b" }  },
      /* --- pixel bitmap for stmary210 char#91 \mapsfromchar --- */
      {  91,69385,                      /* character number, location */
         13,-5,    1,-5,      /* topleft row,col, and botleft row,col */
          {  3,   12, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb6\xed\xdf\xb6\x0d" }  },
      /* --- pixel bitmap for stmary210 char#92 \Mapsfromchar --- */
      {  92,69695,                      /* character number, location */
         16,-5,   -2,-5,      /* topleft row,col, and botleft row,col */
          {  3,   18, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb6\xed\xdf\xb6\x7f\xdb\x36" }  },
      /* --- pixel bitmap for stmary210 char#93 \leftrightarrowtriangle --- */
      {  93,70554,                      /* character number, location */
         12, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 25,    9, 3,49, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x73\x53\xc5\x55\x84\x12\x52\x14\x53\x32\x52\x33\x2f"
            "\x14\x49\x44\x25\x12\x52\x15\x66\x56\xb3\x53\x72" }  },
      /* --- pixel bitmap for stmary210 char#94 \leftarrowtriangle --- */
      {  94,71403,                      /* character number, location */
         12, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 25,    9, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\xe0\x74\xe0\x56\xe0\x34\x22\xe0\x23\x4e\x08\x3e"
            "\x04\x24\x12\xe0\x65\xe0\x83\xe0\x26" }  },
      /* --- pixel bitmap for stmary210 char#95 \rightarrowtriangle --- */
      {  95,72227,                      /* character number, location */
         12, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 25,    9, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x22\xe0\x94\xe0\x76\xe0\x52\x24\x1e\x04\x4e\x07"
            "\x34\xe0\x22\x14\xe0\x45\xe0\x63\x66" }  },
      /* --- pixel bitmap for stmary210 char#96 \bigtriangledown --- */
      {  96,72937,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\x03\xe3\xf1\x12\xe2\x10\x13\xc3\x10\xf1"
            "\x22\xc2\x20\x23\xa3\x20\xf1\x32\xa2\x30\x33\x83\x30"
            "\xf1\x42\x82\x40\x43\x63\x40\xf1\x52\x62\x50\x53\x43"
            "\x50\xf1\x62\x42\x60\x63\x23\x60\xf1\x72\x22\x70\x76"
            "\x70\xf2\x84\x80\xf1\x92\x93" }  },
      /* --- pixel bitmap for stmary210 char#97 \bigtriangleup --- */
      {  97,73740,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 3,116, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x92\x90\xf2\x84\x80\x76\x70\xf1\x72\x22\x70\x63"
            "\x23\x60\xf1\x62\x42\x60\x53\x43\x50\xf1\x52\x62\x50"
            "\x43\x63\x40\xf1\x42\x82\x40\x33\x83\x30\xf1\x32\xa2"
            "\x30\x23\xa3\x20\xf1\x22\xc2\x20\x13\xc3\x10\xf1\x12"
            "\xe2\x13\xe3\x0f\x1e\x06" }  },
      /* --- pixel bitmap for stmary210 char#98 \bigcurlyvee --- */
      {  98,74541,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 3,61, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x26\xc4\x23\xa3\x53\x83\x72\x82\x83\x63\x93"
            "\x43\xb2\x42\xc3\x23\x60\xf1\x72\x22\x70\x76\x70\xf4"
            "\x84\x80\xfb\x92\x92" }  },
      /* --- pixel bitmap for stmary210 char#99 \bigcurlywedge --- */
      {  99,75324,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 3,60, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfb\x92\x90\xf4\x84\x80\x76\x70\xf1\x72\x22\x70\x63"
            "\x23\xc2\x42\xb3\x43\x93\x63\x82\x82\x73\x83\x53\xa3"
            "\x24\xc6\xe0\x22" }  },
      /* --- pixel bitmap for stmary210 char#100 \bigsqcap --- */
      { 100,76135,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x14\x00\xff\x1a\x02\x10\x02" }  },
      /* --- pixel bitmap for stmary210 char#101 \bigbox --- */
      { 101,76958,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\x0f\xe2\xe0\x22\x0f\x92\xe0\x22\x0f\x1e"
            "\x06" }  },
      /* --- pixel bitmap for stmary210 char#102 \bigparallel --- */
      { 102,77607,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          {  9,   29, 3,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x52\x0f\xd2\x52" }  },
      /* --- pixel bitmap for stmary210 char#103 \biginterleave --- */
      { 103,78413,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 16,   29, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x02\x52\x52\x0f\xd2\x52\x52" }  },
      /* --- pixel bitmap for stmary210 char#104 (noname) --- */
      { 104,79423,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 3,189, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0e\x03\xe0\x83\xf1\x12\xe0\x82\x10\x13\xe0"
            "\x63\x10\xf1\x22\xe0\x62\x20\x23\xe0\x43\x20\xf1\x32"
            "\xe0\x42\x30\x33\xe0\x23\x30\xf1\x42\xe0\x22\x40\x43"
            "\xe3\x40\xf1\x52\xe2\x50\x53\xc3\x50\xf1\x62\xc2\x60"
            "\x63\xa3\x60\xf1\x72\xa2\x70\x73\x83\x70\xf1\x82\x82"
            "\x80\x83\x63\x80\xf1\x92\x62\x90\x93\x43\x90\xf1\xa2"
            "\x42\xa0\xa3\x23\xa0\xf1\xb2\x22\xb0\xb6\xb0\xf2\xc4"
            "\xc0\xf1\xd2\xd0" }  },
      /* --- pixel bitmap for stmary210 char#105 (noname) --- */
      { 105,80407,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 3,188, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xd2\xd0\xf2\xc4\xc0\xb6\xb0\xf1\xb2\x22\xb0\xa3"
            "\x23\xa0\xf1\xa2\x42\xa0\x93\x43\x90\xf1\x92\x62\x90"
            "\x83\x63\x80\xf1\x82\x82\x80\x73\x83\x70\xf1\x72\xa2"
            "\x70\x63\xa3\x60\xf1\x62\xc2\x60\x53\xc3\x50\xf1\x52"
            "\xe2\x50\x43\xe3\x40\xf1\x42\xe0\x22\x40\x33\xe0\x23"
            "\x30\xf1\x32\xe0\x42\x30\x23\xe0\x43\x20\xf1\x22\xe0"
            "\x62\x20\x13\xe0\x63\x10\xf1\x12\xe0\x82\x13\xe0\x83"
            "\x0f\x1e\x0e" }  },
      /* --- pixel bitmap for stmary210 char#106 (noname) --- */
      { 106,81389,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe0\xa6\xe0\x64\x23\xe0\x43\x53\xe0\x23\x73\xe3"
            "\x93\xc3\xb3\xa3\xd2\xa2\xe3\x83\xe0\x12\x82\xe0\x23"
            "\x63\xe0\x32\x62\xe0\x43\x43\xe0\x52\x42\xe0\x63\x23"
            "\xa0\xf2\xb2\x22\xb0\xb6\xb0\xf6\xc4\xc0\xfe\xd2\xd2" }  },
      /* --- pixel bitmap for stmary210 char#107 (noname) --- */
      { 107,82343,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 3,102, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xfe\xd2\xd0\xf6\xc4\xc0\xb6\xb0\xf2\xb2\x22\xb0\xa3"
            "\x23\xe0\x62\x42\xe0\x53\x43\xe0\x42\x62\xe0\x33\x63"
            "\xe0\x22\x82\xe0\x13\x83\xe2\xa2\xd3\xa3\xb3\xc3\x93"
            "\xe3\x73\xe0\x23\x53\xe0\x43\x24\xe0\x66\xe0\xa2" }  },
      /* --- pixel bitmap for stmary210 char#108 (noname) --- */
      { 108,83318,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x1c\x00\xff\x26\x02\x18\x02" }  },
      /* --- pixel bitmap for stmary210 char#109 (noname) --- */
      { 109,84322,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x1c\x00\xff\x24\x02\x18\x02\x00\xff\x01"
            "\x1c" }  },
      /* --- pixel bitmap for stmary210 char#110 (noname) --- */
      { 110,85074,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 12,   41, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x28\x00\x02\x08\x02" }  },
      /* --- pixel bitmap for stmary210 char#111 (noname) --- */
      { 111,86035,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 22,   41, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x28\x00\x02\x08\x02\x08\x02" }  },
      /* --- pixel bitmap for stmary210 char#112 \bignplus --- */
      { 112,87085,                      /* character number, location */
          0, 2,  -29, 2,      /* topleft row,col, and botleft row,col */
          { 20,   29, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x76\xca\x84\x64\x53\xa3\x42\xc2\x33\xc3\x22\xe2\x13"
            "\xe3\x0f\x12\xe0\x22\x0f\x32\x72\x72\x02\x3a\x34\x2c"
            "\x22\x0f\x42\x72\x72\x0f\x72\xe0\x22" }  },
      /* --- pixel bitmap for stmary210 char#113 (noname) --- */
      { 113,88137,                      /* character number, location */
          1, 5,  -33, 5,      /* topleft row,col, and botleft row,col */
          { 10,   34, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0a\x0f\xe2\x22\x4f\xe2\x22\x4f\x1a" }  },
      /* --- pixel bitmap for stmary210 char#114 (noname) --- */
      { 114,89164,                      /* character number, location */
          1, 6,  -50, 6,      /* topleft row,col, and botleft row,col */
          { 11,   51, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0b\x00\xff\x2e\x02\x02\x02\x05\xff\x01"
            "\x0b" }  },
      /* --- pixel bitmap for stmary210 char#115 (noname) --- */
      { 115,90312,                      /* character number, location */
          1, 7,  -68, 7,      /* topleft row,col, and botleft row,col */
          { 12,   69, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0c\x00\xff\x40\x02\x03\x02\x05\xff\x01"
            "\x0c" }  },
      /* --- pixel bitmap for stmary210 char#116 (noname) --- */
      { 116,91558,                      /* character number, location */
          1, 8,  -85, 8,      /* topleft row,col, and botleft row,col */
          { 12,   86, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0c\x00\xff\x51\x02\x03\x02\x05\xff\x01"
            "\x0c" }  },
      /* --- pixel bitmap for stmary210 char#117 (noname) --- */
      { 117,92815,                      /* character number, location */
          0, 9,  -52, 9,      /* topleft row,col, and botleft row,col */
          { 14,   52, 2,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0e\x00\xff\x30\x02\x04\x02\x06\x02\x05"
            "\x01\x06" }  },
      /* --- pixel bitmap for stmary210 char#118 (noname) --- */
      { 118,93868,                      /* character number, location */
          2, 9,  -50, 9,      /* topleft row,col, and botleft row,col */
          { 14,   52, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x05\x01\x06\xff\x30\x02\x04\x02\x06\xff\x01"
            "\x0e" }  },
      /* --- pixel bitmap for stmary210 char#119 (noname) --- */
      { 119,94912,                      /* character number, location */
          2, 9,  -18, 9,      /* topleft row,col, and botleft row,col */
          {  8,   20, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x51\x0f\xe2\x42\x0f\x32\x42" }  },
      /* --- pixel bitmap for stmary210 char#120 (noname) --- */
      { 120,95910,                      /* character number, location */
          0, 2,  -41, 2,      /* topleft row,col, and botleft row,col */
          { 28,   41, 3,94, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xa8\xe0\x4c\xe4\x84\xb3\xc3\x93\xe3\x73\xe0\x23\x53"
            "\xe0\x43\x33\xe0\x63\x10\xf1\x12\xe0\x82\x13\xe0\x85"
            "\xe0\xa2\x0f\x82\xb2\xb2\x02\x2e\x06\x24\x3e\x04\x32"
            "\x0f\x72\xb2\xb2\x0f\x92\xe0\xa2" }  },
      /* --- pixel bitmap for stmary210 char#121 (noname) --- */
      { 121,96987,                      /* character number, location */
          1, 0,  -33, 0,      /* topleft row,col, and botleft row,col */
          { 10,   34, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0a\xfe\x42\x22\xfe\x42\x22\x0f\x1a" }  },
      /* --- pixel bitmap for stmary210 char#122 (noname) --- */
      { 122,98001,                      /* character number, location */
          1, 0,  -50, 0,      /* topleft row,col, and botleft row,col */
          { 11,   51, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0b\xff\x2e\x05\x02\x02\x02\x00\xff\x01"
            "\x0b" }  },
      /* --- pixel bitmap for stmary210 char#123 (noname) --- */
      { 123,99110,                      /* character number, location */
          1, 0,  -68, 0,      /* topleft row,col, and botleft row,col */
          { 12,   69, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0c\xff\x40\x05\x02\x03\x02\x00\xff\x01"
            "\x0c" }  },
      /* --- pixel bitmap for stmary210 char#124 (noname) --- */
      { 124,100343,                     /* character number, location */
          1, 0,  -85, 0,      /* topleft row,col, and botleft row,col */
          { 12,   86, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0c\xff\x51\x05\x02\x03\x02\x00\xff\x01"
            "\x0c" }  },
      /* --- pixel bitmap for stmary210 char#125 (noname) --- */
      { 125,101561,                     /* character number, location */
          0, 0,  -52, 0,      /* topleft row,col, and botleft row,col */
          { 14,   52, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0e\xff\x30\x06\x02\x04\x02\x06\x01\x05"
            "\x02" }  },
      /* --- pixel bitmap for stmary210 char#126 (noname) --- */
      { 126,102669,                     /* character number, location */
          2, 0,  -50, 0,      /* topleft row,col, and botleft row,col */
          { 14,   52, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x06\x01\x05\x02\xff\x30\x06\x02\x04\x02\x00\xff\x01"
            "\x0e" }  },
      /* --- pixel bitmap for stmary210 char#127 (noname) --- */
      { 127,103674,                     /* character number, location */
          2, 6,  -18, 6,      /* topleft row,col, and botleft row,col */
          {  8,   20, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x52\x0f\xe2\x42\x0f\x32\x42" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


/* --- size=7 for .250gf ---
 * mf '\mode=preview; mag=magstep(-12.84858895680446863032); input stmary10'
 * --------------------------------------------------------------------- */
/* --- fontdef for stmary250 --- */
static	chardef  stmary250[] =
   {
      /* --- pixel bitmap for stmary250 char#0 \shortleftarrow --- */
      {   0,  948,                      /* character number, location */
         15, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 23,   12, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\xe0\x20\xf1\x51\xe0\x30\x41\xe0\x62\xe0\x50\xf1"
            "\x1e\x08\x22\xe0\x91\xe0\x40\xf1\x51\xe0\x30\x61\xe0"
            "\x20" }  },
      /* --- pixel bitmap for stmary250 char#1 \shortrightarrow --- */
      {   1, 1893,                      /* character number, location */
         15, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 23,   12, 3,53, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x21\x60\xf1\xe0\x31\x50\xe0\x41\xe0\x92\x2e\x0e"
            "\x0e\x03\xe0\x62\xe0\x61\x40\xf1\xe0\x31\x50\xe0\x21"
            "\x60" }  },
      /* --- pixel bitmap for stmary250 char#2 \shortuparrow --- */
      {   2, 2698,                      /* character number, location */
         20, 3,   -3, 3,      /* topleft row,col, and botleft row,col */
          { 12,   23, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\xa2\x50\xf1\x44\x40\x31\x12\x11\x42\x22\x22\x11"
            "\x42\x41\xfe\x52\x50\x52\x50" }  },
      /* --- pixel bitmap for stmary250 char#3 \shortdownarrow --- */
      {   3, 3539,                      /* character number, location */
         20, 3,   -3, 3,      /* topleft row,col, and botleft row,col */
          { 12,   23, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xfe\x52\x50\x52\x51\x42\x41\x12\x22\x22\x41\x12\x11"
            "\x30\xf1\x44\x40\x52\xb1\x50" }  },
      /* --- pixel bitmap for stmary250 char#4 \Yup --- */
      {   4, 4160,                      /* character number, location */
         18, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,32, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x72\x60\x63\xb5\x93\x13\x73\x33\x53\x53\x33\x73"
            "\x13\x95\xb2" }  },
      /* --- pixel bitmap for stmary250 char#5 \Ydown --- */
      {   5, 4757,                      /* character number, location */
         16, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 15,   17, 3,31, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xb5\x93\x13\x73\x33\x53\x53\x33\x73\x13\x95\x50"
            "\xf9\x72\x62" }  },
      /* --- pixel bitmap for stmary250 char#6 \Yleft --- */
      {   6, 5395,                      /* character number, location */
         16, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,46, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x12\xe3\xd3\xd3\xd3\xd3\x4c\x5b\xe0\x13\xe0\x13"
            "\xe0\x13\xe0\x13\xe0\x13\xe0\x13\xe0\x12" }  },
      /* --- pixel bitmap for stmary250 char#7 \Yright --- */
      {   7, 6018,                      /* character number, location */
         16, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 17,   15, 3,45, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x13\xe0\x13\xe0\x13\xe0\x13\xe0\x13\xe0\x1c"
            "\x6b\x53\xd3\xd3\xd3\xd3\xd3\xe2\xe0\x12" }  },
      /* --- pixel bitmap for stmary250 char#8 \varcurlyvee --- */
      {   8, 6657,                      /* character number, location */
         24, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 24,   32, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x65\xe0\x43\x13\xe0\x23\x33\xe3\x53\xc3\x73"
            "\xa3\x93\x83\xb2\x82\xc3\x63\xd2\x62\xe3\x43\xe0\x12"
            "\x42\xe0\x23\x23\x80\xf2\x92\x22\x90\x96\x90\xf4\xa4"
            "\xa0\xf9\xb2\xb0" }  },
      /* --- pixel bitmap for stmary250 char#9 \varcurlywedge --- */
      {   9, 7374,                      /* character number, location */
         24, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 24,   32, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\xb2\xb0\xf4\xa4\xa0\x96\x90\xf2\x92\x22\x90\x83"
            "\x23\xe0\x22\x42\xe0\x13\x43\xe2\x62\xd3\x63\xc2\x82"
            "\xb3\x83\xa2\xa2\x93\xa3\x73\xc3\x53\xe3\x33\xe0\x23"
            "\x13\xe0\x45\xe0\x62" }  },
      /* --- pixel bitmap for stmary250 char#10 \minuso --- */
      {  10, 8221,                      /* character number, location */
         16, 2,    2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   14, 3,51, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x95\xe0\x29\xd3\x53\xb3\x73\x50\xf1\x52\x92\x5f\x1e"
            "\x09\xf1\x52\x92\x50\x53\x73\xb3\x53\xd9\xe0\x25\x92" }  },
      /* --- pixel bitmap for stmary250 char#11 \baro --- */
      {  11, 8911,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 15,   22, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf3\x72\x60\x47\x6b\x33\x32\x23\x22\x42\x32\x13\x42"
            "\x33\x0f\x32\x52\x42\x03\x42\x33\x12\x42\x32\x23\x32"
            "\x23\x3b\x67\x40\xf3\x72\x63" }  },
      /* --- pixel bitmap for stmary250 char#12 \sslash --- */
      {  12, 9611,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 19,   35, 3,153, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xb2\x42\xa3\x33\xf1\xa2\x42\x10\x93\x33\x10\xf1"
            "\x92\x42\x20\x83\x33\x20\xf1\x82\x42\x30\x73\x33\x30"
            "\xf1\x72\x42\x40\x63\x33\x40\xf1\x62\x42\x50\x53\x33"
            "\x50\xf1\x52\x42\x60\x43\x33\x60\xf1\x42\x42\x70\x33"
            "\x33\x70\xf1\x32\x42\x80\x23\x33\x80\xf1\x22\x42\x90"
            "\x13\x33\x90\xf1\x12\x42\xa3\x33\xaf\x12\x42\xb0" }  },
      /* --- pixel bitmap for stmary250 char#13 \bblash --- */
      {  13,10368,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 19,   35, 3,156, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x02\x42\xb3\x33\xa0\xf1\x12\x42\xa0\x13\x33\x90"
            "\xf1\x22\x42\x90\x23\x33\x80\xf1\x32\x42\x80\x33\x33"
            "\x70\xf1\x42\x42\x70\x43\x33\x60\xf1\x52\x42\x60\x53"
            "\x33\x50\xf1\x62\x42\x50\x63\x33\x40\xf1\x72\x42\x40"
            "\x73\x33\x30\xf1\x82\x42\x30\x83\x33\x20\xf1\x92\x42"
            "\x20\x93\x33\x10\xf1\xa2\x42\x10\xa3\x33\xf1\xb2\x42" }  },
      /* --- pixel bitmap for stmary250 char#14 \moo --- */
      {  14,11213,                      /* character number, location */
         19, 4,   -1, 4,      /* topleft row,col, and botleft row,col */
          { 18,   20, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf8\x82\x8f\x1e\x04\xf2\x82\x80\xf1\x74\x72\x54\x55"
            "\x36\x33\x17\x27\x34\x64\x20" }  },
      /* --- pixel bitmap for stmary250 char#15 \varotimes --- */
      {  15,11976,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x64\x73\xa3\x54\xa4\x36\x86\x22\x23\x63"
            "\x22\x13\x33\x43\x35\x53\x23\x54\x66\x62\x0f\x12\x74"
            "\x72\x02\x66\x64\x53\x23\x55\x33\x43\x33\x12\x23\x63"
            "\x22\x26\x86\x34\xa4\x53\xa3\x74\x64\xaa\xe6\x82" }  },
      /* --- pixel bitmap for stmary250 char#16 \varoast --- */
      {  16,12924,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,113, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x64\x73\xa3\x53\x52\x53\x33\x62\x63\x22"
            "\x72\x72\x13\x22\x32\x32\x25\x33\x22\x23\x34\x58\x52"
            "\x0f\x12\x74\x72\x02\x58\x54\x33\x22\x23\x35\x22\x32"
            "\x32\x23\x12\x72\x72\x23\x62\x63\x33\x52\x53\x53\xa3"
            "\x74\x64\xaa\xe6\x82" }  },
      /* --- pixel bitmap for stmary250 char#17 \varobar --- */
      {  17,13757,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x22\x24\x73\x42\x43\x53\x52\x53\x33\x62"
            "\x63\x22\x72\x72\x13\x72\x73\x0f\x52\x82\x82\x03\x72"
            "\x73\x12\x72\x72\x23\x62\x63\x33\x52\x53\x53\x42\x43"
            "\x74\x22\x24\xaa\xe6\x83" }  },
      /* --- pixel bitmap for stmary250 char#18 \varodot --- */
      {  18,14573,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x64\x73\xa3\x53\xc3\x33\xe3\x22\xe0\x22"
            "\x13\xe0\x25\x82\x84\x74\x72\x0f\x12\x66\x62\x02\x74"
            "\x74\x82\x85\xe0\x23\x12\xe0\x22\x23\xe3\x33\xc3\x53"
            "\xa3\x74\x64\xaa\xe6\x83" }  },
      /* --- pixel bitmap for stmary250 char#19 \varoslash --- */
      {  19,15376,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x64\x73\xa3\x53\xb4\x33\xb6\x22\xb3\x22"
            "\x13\xa3\x35\xa3\x54\x93\x64\x83\x74\x73\x84\x63\x94"
            "\x53\xa5\x33\xa3\x12\x23\xb2\x26\xb3\x34\xb3\x53\xa3"
            "\x74\x64\xaa\xe6\x86" }  },
      /* --- pixel bitmap for stmary250 char#20 \varobslash --- */
      {  20,16191,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x64\x73\xa3\x54\xb3\x36\xb3\x22\x23\xb2"
            "\x13\x33\xa5\x53\xa4\x63\x94\x73\x84\x83\x74\x93\x64"
            "\xa3\x55\xa3\x33\x12\xb3\x22\x23\xb6\x33\xb4\x53\xa3"
            "\x74\x64\xaa\xe6\x86" }  },
      /* --- pixel bitmap for stmary250 char#21 \varocircle --- */
      {  21,17145,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,95, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x64\x73\xa3\x53\xc3\x33\x54\x53\x22\x48"
            "\x42\x13\x33\x43\x35\x33\x63\x32\x0f\x32\x32\x82\x32"
            "\x02\x33\x63\x35\x33\x43\x33\x12\x48\x42\x23\x54\x53"
            "\x33\xc3\x53\xa3\x74\x64\xaa\xe6\x83" }  },
      /* --- pixel bitmap for stmary250 char#22 \varoplus --- */
      {  22,17975,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x22\x24\x73\x42\x43\x53\x52\x53\x33\x62"
            "\x63\x22\x72\x72\x13\x72\x73\x0f\x12\x82\x82\x0f\x1e"
            "\x08\x0f\x12\x82\x82\x03\x72\x73\x12\x72\x72\x23\x62"
            "\x63\x33\x52\x53\x53\x42\x43\x74\x22\x24\xaa\xe6\x83" }  },
      /* --- pixel bitmap for stmary250 char#23 \varominus --- */
      {  23,18794,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x64\x73\xa3\x53\xc3\x33\xe3\x22\xe0\x22"
            "\x13\xe0\x23\x0f\x12\xe0\x42\x0f\x1e\x08\x0f\x12\xe0"
            "\x42\x03\xe0\x23\x12\xe0\x22\x23\xe3\x33\xc3\x53\xa3"
            "\x74\x64\xaa\xe6\x83" }  },
      /* --- pixel bitmap for stmary250 char#24 \boxast --- */
      {  24,19629,                      /* character number, location */
         19, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,96, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\x0f\x12\xe0\x22\x0f\x12\x72\x72\x02\x31"
            "\x32\x31\x34\x23\x22\x23\x24\x48\x42\x0f\x12\x64\x62"
            "\x02\x48\x44\x23\x22\x23\x24\x31\x32\x31\x32\x0f\x12"
            "\x72\x72\x0f\x12\xe0\x22\x0f\x1e\x06" }  },
      /* --- pixel bitmap for stmary250 char#25 \boxbar --- */
      {  25,20378,                      /* character number, location */
         19, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\x0f\xe2\x72\x72\x02\x72\x72\x0f\x1e\x06" }  },
      /* --- pixel bitmap for stmary250 char#26 \boxdot --- */
      {  26,21119,                      /* character number, location */
         19, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,56, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\x0f\x42\xe0\x22\x02\x72\x74\x64\x62\x0f"
            "\x12\x56\x52\x02\x64\x64\x72\x72\x0f\x42\xe0\x22\x0f"
            "\x1e\x06" }  },
      /* --- pixel bitmap for stmary250 char#27 \boxslash --- */
      {  27,21842,                      /* character number, location */
         19, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\x02\xe6\xd7\xc3\x14\xb3\x24\xa3\x34\x93"
            "\x44\x83\x54\x73\x64\x63\x74\x53\x84\x43\x94\x33\xa4"
            "\x23\xb4\x13\xc7\xd6\xe2\x0f\x1e\x06" }  },
      /* --- pixel bitmap for stmary250 char#28 \boxbslash --- */
      {  28,22578,                      /* character number, location */
         19, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\x04\xe7\xd4\x13\xc4\x23\xb4\x33\xa4\x43"
            "\x94\x53\x84\x63\x74\x73\x64\x83\x54\x93\x44\xa3\x34"
            "\xb3\x24\xc3\x14\xd7\xe4\x0f\x1e\x06" }  },
      /* --- pixel bitmap for stmary250 char#29 \boxcircle --- */
      {  29,23318,                      /* character number, location */
         19, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,70, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\x0f\x32\xe0\x22\x02\x72\x74\x56\x54\x43"
            "\x23\x42\x0f\x12\x42\x42\x42\x02\x43\x23\x44\x56\x54"
            "\x72\x72\x0f\x32\xe0\x22\x0f\x1e\x06" }  },
      /* --- pixel bitmap for stmary250 char#30 \boxbox --- */
      {  30,24051,                      /* character number, location */
         19, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,58, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\x0f\x22\xe0\x22\x02\x48\x44\x3a\x32\x0f"
            "\x52\x32\x62\x32\x02\x3a\x34\x48\x42\x0f\x22\xe0\x22"
            "\x0f\x1e\x06" }  },
      /* --- pixel bitmap for stmary250 char#31 \boxempty --- */
      {  31,24788,                      /* character number, location */
         19, 3,   -1, 3,      /* topleft row,col, and botleft row,col */
          { 20,   20, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x06\x0f\xe2\xe0\x22\x02\xe0\x22\x0f\x1e\x06" }  },
      /* --- pixel bitmap for stmary250 char#32 \lightning --- */
      {  32,25697,                      /* character number, location */
         24, 3,   -7, 3,      /* topleft row,col, and botleft row,col */
          { 11,   31, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x03\x18\xe0\x00\x03\x18\xe0\x00\x03\x18\xe0\x00"
            "\x03\x1c\x60\x00\x03\x9c\x63\x9f\xff\x3c\x43\x1c\x60"
            "\x00\x03\x1c\x60\x80\x23\x0c\x62\xa0\x03\x0d\x70\x8f"
            "\x07\x0c\x20\x00" }  },
      /* --- pixel bitmap for stmary250 char#33 \merge --- */
      {  33,26518,                      /* character number, location */
         26, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 27,   26, 3,158, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x82\x72\x80\xf2\x74\x54\x70\x66\x36\x60\xf1\x62"
            "\x22\x32\x22\x60\x53\x23\x13\x23\xa2\x42\x12\x42\xa2"
            "\x45\x42\x93\x53\x53\x40\xf1\x42\x63\x62\x40\x33\x63"
            "\x63\x62\x73\x72\x62\x65\x62\x53\x62\x12\x63\x42\x72"
            "\x12\x72\x42\x63\x13\x62\x33\x62\x32\x63\x22\x72\x32"
            "\x72\x22\x63\x33\x62\x13\x62\x52\x63\x0f\x12\x72\x52"
            "\x72" }  },
      /* --- pixel bitmap for stmary250 char#34 \vartimes --- */
      {  34,27257,                      /* character number, location */
         24, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 15,   24, 3,88, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xb5\x93\x12\x92\x23\x73\x32\x72\x43\x53\x53\x33"
            "\x72\x32\x83\x13\x92\x12\xa5\x50\xf1\x63\x60\x55\xa2"
            "\x12\x93\x13\x82\x32\x73\x33\x53\x53\x42\x72\x33\x73"
            "\x22\x92\x13\x95\xb2" }  },
      /* --- pixel bitmap for stmary250 char#35 \fatsemi --- */
      {  35,27872,                      /* character number, location */
         19, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          {  8,   26, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x18\x7e\xe7\xc3\xc3\xe7\x7e\x18\x00\x00\x00\x18\x7e"
            "\xe7\xc3\xc3\xe7\xfe\xf8\x60\x70\x30\x38\x18\x1c\x0c" }  },
      /* --- pixel bitmap for stmary250 char#36 \sswarrow --- */
      {  36,28777,                      /* character number, location */
         24, 3,   -7, 3,      /* topleft row,col, and botleft row,col */
          { 16,   31, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\xe2\xf2\xd2\x10\xf1\xc2\x20\xb3\x20\xf1\xb2\x30"
            "\xf1\xa2\x40\x93\x40\xf1\x92\x50\xf2\x82\x60\xf1\x72"
            "\x70\xf2\x62\x81\x42\xa1\x32\x90\xf1\x21\x12\xa0\x33"
            "\x14\x84\xc2\xe1\xc2" }  },
      /* --- pixel bitmap for stmary250 char#37 \ssearrow --- */
      {  37,29690,                      /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 16,   31, 3,93, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x02\xe0\xf2\x12\xd0\xf1\x22\xc0\x23\xb0\xf1\x32"
            "\xb0\xf1\x42\xa0\x43\x90\xf1\x52\x90\xf2\x62\x80\xf1"
            "\x72\x70\xf2\x82\x60\x92\x41\x92\x31\x10\xf1\xa2\x11"
            "\x20\x54\x13\xc4\xe2\xe0\x11\x33" }  },
      /* --- pixel bitmap for stmary250 char#38 \curlywedgeuparrow --- */
      {  38,30714,                      /* character number, location */
         24, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 24,   31, 3,116, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xb2\xb0\xa4\xe0\x51\x12\x11\xe0\x31\x22\x21\xe2"
            "\x32\x32\x60\xf2\xb2\xb0\xf4\xa4\xa0\x96\x90\xf2\x92"
            "\x22\x90\x83\x23\xe0\x22\x42\xe0\x13\x43\xe2\x62\xd3"
            "\x63\xc2\x82\xb3\x83\x93\xa3\x73\xc3\x53\xe3\x33\xe0"
            "\x23\x13\xe0\x45\xe0\x62" }  },
      /* --- pixel bitmap for stmary250 char#39 \curlywedgedownarrow --- */
      {  39,31774,                      /* character number, location */
         25, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 24,   33, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf9\xb2\xb0\xf4\xa4\xa0\x96\x90\xf2\x92\x22\x90\x83"
            "\x23\xe0\x22\x42\xe0\x13\x43\xe2\x62\x81\x43\x63\x41"
            "\x21\x42\x82\x41\x31\x23\x83\x21\x41\x13\xa3\x11\x44"
            "\xc4\x34\xe4\x23\xe0\x23\x13\xe0\x4a\xa7\x72\x62\x70" }  },
      /* --- pixel bitmap for stmary250 char#40 \fatslash --- */
      {  40,32490,                      /* character number, location */
         26,10,   -9,10,      /* topleft row,col, and botleft row,col */
          { 21,   35, 3,133, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xba\xa3\x52\xb2\x62\xb2\x53\xa3\x52\xb2\x62\xb2"
            "\x53\xa3\x52\xb2\x62\xb2\x53\xa3\x52\xb2\x62\xb2\x53"
            "\xa3\x52\xb2\x62\xb2\x53\xa3\x52\xb2\x62\xb2\x53\xa3"
            "\x52\xb2\x62\xb2\x53\xa3\x52\xb2\x62\xb2\x53\xa3\x52"
            "\xb2\x62\xb2\x53\xa3\x52\xb2\x62\xb2\x53\xa3\x52\xbf"
            "\x1a\xb2" }  },
      /* --- pixel bitmap for stmary250 char#41 \fatbslash --- */
      {  41,33230,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 21,   35, 3,134, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x0a\xb3\x52\xc2\x53\xb2\x62\xb3\x52\xc2\x53\xb2"
            "\x62\xb3\x52\xc2\x53\xb2\x62\xb3\x52\xc2\x53\xb2\x62"
            "\xb3\x52\xc2\x53\xb2\x62\xb3\x52\xc2\x53\xb2\x62\xb3"
            "\x52\xc2\x53\xb2\x62\xb3\x52\xc2\x53\xb2\x62\xb3\x52"
            "\xc2\x53\xb2\x62\xb3\x52\xc2\x53\xb2\x62\xb3\x52\x10"
            "\xf1\xba" }  },
      /* --- pixel bitmap for stmary250 char#42 \lbag --- */
      {  42,33869,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 11,   35, 3,74, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x66\x43\x23\x32\x42\x31\x52\x30\xf3\x62\x30\x53"
            "\x30\xf3\x52\x40\x43\x40\xf2\x42\x50\x33\x50\xf3\x32"
            "\x60\x23\x60\xf5\x22\x70\x23\x92\x94\x96\x74" }  },
      /* --- pixel bitmap for stmary250 char#43 \rbag --- */
      {  43,34453,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 11,   35, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x66\x43\x23\x32\x42\x32\x51\xf3\x32\x60\x33\x50"
            "\xf3\x42\x50\x43\x40\xf2\x52\x40\x53\x30\xf3\x62\x30"
            "\x63\x20\xf5\x72\x20\x63\x82\x74\x36\x54\x74" }  },
      /* --- pixel bitmap for stmary250 char#44 \varbigcirc --- */
      {  44,35375,                      /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 31,   31, 3,133, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xb9\xe0\x6d\xe0\x24\x94\xc4\xd4\x93\xe0\x33\x73\xe0"
            "\x53\x53\xe0\x73\x42\xe0\x92\x33\xe0\x93\x10\xf1\x12"
            "\xe0\xb2\x13\xe0\xb3\x0f\x62\xe0\xd2\x03\xe0\xb3\xf1"
            "\x12\xe0\xb2\x10\x13\xe0\x93\x32\xe0\x92\x43\xe0\x73"
            "\x53\xe0\x53\x73\xe0\x33\x94\xd4\xc4\x94\xe0\x2d\xe0"
            "\x69\xba" }  },
      /* --- pixel bitmap for stmary250 char#45 \leftrightarroweq --- */
      {  45,36451,                      /* character number, location */
         19, 1,    4, 1,      /* topleft row,col, and botleft row,col */
          { 25,   15, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x61\xb1\x60\xf1\x51\xd1\x50\x41\xe0\x11\x62\xe0\x32"
            "\x2e\x0b\x1e\x09\x32\xe0\x32\x61\xe0\x11\x40\xf1\x51"
            "\xd1\x50\x61\xb1\xe0\xe0\x30\xf1\x1e\x09\x10" }  },
      /* --- pixel bitmap for stmary250 char#46 \curlyveedownarrow --- */
      {  46,37073,                      /* character number, location */
         24, 0,   -7, 0,      /* topleft row,col, and botleft row,col */
          { 24,   31, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x65\xe0\x43\x13\xe0\x23\x33\xe3\x53\xc3\x73"
            "\xa3\x93\x83\xb2\x82\xc3\x63\xd2\x62\xe3\x43\xe0\x12"
            "\x42\xe0\x23\x23\x80\xf2\x92\x22\x90\x96\x90\xf4\xa4"
            "\xa0\xf2\xb2\xb0\x62\x32\x32\xe1\x22\x21\xe0\x31\x12"
            "\x11\xe0\x54\xa0\xf1\xb2\xb4" }  },
      /* --- pixel bitmap for stmary250 char#47 \curlyveeuparrow --- */
      {  47,37753,                      /* character number, location */
         25, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 24,   33, 3,103, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x72\x62\x77\xaa\xe0\x43\x13\xe0\x23\x24\xe4\x34\xc4"
            "\x41\x13\xa3\x11\x41\x23\x83\x21\x31\x42\x82\x41\x21"
            "\x43\x63\x41\x82\x62\xe3\x43\xe0\x12\x42\xe0\x23\x23"
            "\x80\xf2\x92\x22\x90\x96\x90\xf4\xa4\xa0\xf9\xb2\xb2" }  },
      /* --- pixel bitmap for stmary250 char#48 \nnwarrow --- */
      {  48,38398,                      /* character number, location */
         24, 3,   -7, 3,      /* topleft row,col, and botleft row,col */
          { 16,   31, 3,92, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x31\xe0\x12\xe4\xc3\x14\x50\xf1\x21\x12\xa0\x11\x32"
            "\x91\x42\x90\xf2\x62\x80\xf1\x72\x70\xf2\x82\x60\xf1"
            "\x92\x50\x93\x40\xf1\xa2\x40\xf1\xb2\x30\xb3\x20\xf1"
            "\xc2\x20\xf2\xd2\x10\xf1\xe2" }  },
      /* --- pixel bitmap for stmary250 char#49 \nnearrow --- */
      {  49,38999,                      /* character number, location */
         24, 2,   -7, 2,      /* topleft row,col, and botleft row,col */
          { 16,   31, 3,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc1\xe2\xc4\x84\x13\x30\xf1\xa2\x11\x20\x92\x31\xa2"
            "\x41\xf2\x82\x60\xf1\x72\x70\xf2\x62\x80\xf1\x52\x90"
            "\x43\x90\xf1\x42\xa0\xf1\x32\xb0\x23\xb0\xf1\x22\xc0"
            "\xf2\x12\xdf\x12\xe0" }  },
      /* --- pixel bitmap for stmary250 char#50 \leftslice --- */
      {  50,39788,                      /* character number, location */
         17, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   16, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x33\xe0\x37\xe5\x23\xa5\x62\x85\x83\x54\xc2\x25"
            "\xe2\x0f\x15\xe0\x22\x25\xe2\x54\xc2\x75\x83\x95\x62"
            "\xd5\x23\xe0\x17\xe0\x53\x32" }  },
      /* --- pixel bitmap for stmary250 char#51 \rightslice --- */
      {  51,40562,                      /* character number, location */
         17, 2,    1, 2,      /* topleft row,col, and botleft row,col */
          { 23,   16, 3,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x33\xe0\x57\xe0\x13\x25\xd2\x65\x93\x85\x72\xc4\x52"
            "\xe5\x2f\x12\xe0\x25\x02\xe5\x22\xc4\x53\x85\x82\x65"
            "\xa3\x25\xe7\xe0\x33\xe0\x32" }  },
      /* --- pixel bitmap for stmary250 char#52 \varolessthan --- */
      {  52,41332,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x64\x73\xa3\x53\x96\x33\x85\x13\x22\x65"
            "\x52\x13\x45\x75\x34\xb9\xd2\x0f\x15\xe0\x12\x07\xd4"
            "\x34\xb5\x45\x73\x12\x65\x52\x23\x85\x13\x33\x96\x53"
            "\xa3\x74\x64\xaa\xe6\x81" }  },
      /* --- pixel bitmap for stmary250 char#53 \varogreaterthan --- */
      {  53,42145,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,89, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x64\x73\xa3\x56\x93\x33\x15\x83\x22\x55"
            "\x62\x13\x75\x45\xb4\x34\xd7\x0f\x12\xe0\x15\x02\xd9"
            "\xb4\x35\x75\x43\x12\x55\x62\x23\x15\x83\x36\x93\x53"
            "\xa3\x74\x64\xaa\xe6\x81" }  },
      /* --- pixel bitmap for stmary250 char#54 \varovee --- */
      {  54,42950,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x64\x73\xa3\x53\xc3\x35\xa5\x22\x12\xa2"
            "\x12\x13\x13\x83\x13\x0f\x12\x32\x82\x32\x02\x33\x63"
            "\x34\x42\x62\x44\x43\x43\x44\x52\x42\x55\x43\x23\x43"
            "\x12\x52\x22\x52\x23\x42\x22\x43\x33\x36\x33\x53\x34"
            "\x33\x74\x14\x14\xaa\xe6\x84" }  },
      /* --- pixel bitmap for stmary250 char#55 \varowedge --- */
      {  55,43791,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 22,   22, 3,117, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x86\xea\xa4\x14\x14\x73\x34\x33\x53\x36\x33\x33\x42"
            "\x22\x43\x22\x52\x22\x52\x13\x43\x23\x45\x52\x42\x54"
            "\x43\x43\x44\x42\x62\x44\x33\x63\x32\x0f\x12\x32\x82"
            "\x32\x03\x13\x83\x13\x12\x12\xa2\x12\x25\xa5\x33\xc3"
            "\x53\xa3\x74\x64\xaa\xe6\x84" }  },
      /* --- pixel bitmap for stmary250 char#56 \talloblong --- */
      {  56,44474,                      /* character number, location */
         26, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 11,   34, 3,20, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0b\x0f\xe2\x72\x0f\xe2\x72\x0f\x1b" }  },
      /* --- pixel bitmap for stmary250 char#57 \interleave --- */
      {  57,45262,                      /* character number, location */
         26, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 18,   34, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x21\x00\x02\x06\x02\x06\x02" }  },
      /* --- pixel bitmap for stmary250 char#58 \obar --- */
      {  58,46192,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,81, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x31\x32\xa2\x51\x52\x71\x71\x71\x51\x81\x81"
            "\x20\xf2\x11\x91\x91\x1f\x51\xa1\xa1\xf2\x11\x91\x91"
            "\x10\x21\x81\x81\x51\x71\x71\x72\x51\x52\xa2\x31\x32"
            "\xe7\x83" }  },
      /* --- pixel bitmap for stmary250 char#59 \oslash --- */
      {  59,47048,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x72\xa2\xb2\x71\xe0\x11\x51\x11\xe0\x11\x31"
            "\x31\xe0\x11\x21\x41\xe1\x21\x51\xd1\x11\x71\xd2\x81"
            "\xc2\x91\xb2\xa2\x92\xc1\x82\xd1\x71\x11\xd1\x51\x21"
            "\xe1\x41\x21\xe0\x11\x31\x31\xe0\x11\x11\x51\xe0\x11"
            "\x72\xb2\xa2\x72\xe7\x86" }  },
      /* --- pixel bitmap for stmary250 char#60 \olessthan --- */
      {  60,47891,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x72\xa2\xb2\x71\xe2\x51\xd2\x21\x31\xb3\x51"
            "\x21\x92\x81\x21\x63\xa1\x11\x52\xe2\x23\xe0\x21\x0f"
            "\x13\xe0\x51\x01\x23\xe0\x22\x52\xe1\x11\x63\xa1\x21"
            "\x92\x81\x21\xb3\x51\x31\xd2\x21\x51\xe2\x72\xb2\xa2"
            "\x72\xe7\x82" }  },
      /* --- pixel bitmap for stmary250 char#61 \ogreaterthan --- */
      {  61,48733,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x87\xe2\x72\xa2\xb2\x72\xe1\x51\x22\xd1\x31\x53\xb1"
            "\x21\x82\x91\x21\xa3\x61\x11\xe2\x52\xe0\x23\x21\x0f"
            "\x11\xe0\x53\x01\xe0\x23\x22\xe2\x51\x11\xa3\x61\x21"
            "\x82\x91\x21\x53\xb1\x31\x22\xd1\x52\xe1\x72\xb2\xa2"
            "\x72\xe7\x82" }  },
      /* --- pixel bitmap for stmary250 char#62 \ovee --- */
      {  62,49567,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x7f\x00\x60\xc0\x00\x0c\x80\x01\x01\x00\x41\x01"
            "\x40\x91\x00\x20\x49\x00\x90\x44\x00\x44\x21\x00\xc2"
            "\x20\x80\x60\x10\x40\x30\x10\x10\x18\x08\x08\x0c\x08"
            "\x02\x0a\x04\x81\x04\x82\x40\x02\x22\x20\x02\x11\x08"
            "\x02\x05\x02\x86\xc2\x00\x8c\x18\x00\xf8\x03\x00" }  },
      /* --- pixel bitmap for stmary250 char#63 \owedge --- */
      {  63,50445,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          { 23,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x7f\x00\x60\xc4\x00\x0c\x85\x01\x81\x02\x41\x20"
            "\x02\x11\x10\x01\x09\x04\x81\x04\x82\x40\x01\x41\xc0"
            "\x40\x40\x60\x20\x20\x30\x08\x20\x18\x04\x10\x0c\x01"
            "\x10\x8a\x00\x88\x24\x00\x48\x12\x00\x24\x0a\x00\x0a"
            "\x02\x00\x02\x06\xc0\x00\x0c\x18\x00\xf8\x03\x00" }  },
      /* --- pixel bitmap for stmary250 char#64 \oblong --- */
      {  64,51211,                      /* character number, location */
         21, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 19,   21, 3,28, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x05\x0f\xe2\xe0\x12\x0f\x12\xe0\x12\x0f\x1e"
            "\x05" }  },
      /* --- pixel bitmap for stmary250 char#65 \inplus --- */
      {  65,51960,                      /* character number, location */
         20, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 17,   22, 3,72, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x89\x6b\x44\xc3\xd3\xd3\xd0\xf1\x12\x52\x73\x52\x72"
            "\x62\x7f\x1e\x03\x02\x62\x73\x52\x70\xf1\x12\x52\x70"
            "\x13\xe0\x13\xe0\x13\xe0\x14\xe0\x1b\x89" }  },
      /* --- pixel bitmap for stmary250 char#66 \niplus --- */
      {  66,52702,                      /* character number, location */
         20, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 17,   22, 3,73, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x09\x8b\xe0\x14\xe0\x13\xe0\x13\xe0\x13\x10\xf1\x72"
            "\x52\x10\x72\x53\x72\x62\x0f\x1e\x03\x72\x62\x72\x53"
            "\xf1\x72\x52\x10\xd3\xd3\xd3\xc4\x4b\x69\x81" }  },
      /* --- pixel bitmap for stmary250 char#67 \nplus --- */
      {  67,53448,                      /* character number, location */
         21, 2,   -1, 2,      /* topleft row,col, and botleft row,col */
          { 19,   22, 3,52, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xab\x64\x74\x33\xb3\x13\xd2\x12\xe3\x0f\x42\x72"
            "\x62\x0f\x12\x2b\x22\x0f\x32\x72\x62\x0f\x42\xe0\x12" }  },
      /* --- pixel bitmap for stmary250 char#68 \subsetplus --- */
      {  68,54298,                      /* character number, location */
         20, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,84, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8d\x6e\x01\x44\xe0\x23\xe0\x33\xe0\x33\xe0\x30\xf1"
            "\x12\x82\x83\x82\x82\x92\x8f\x12\x5a\x42\x92\x83\x82"
            "\x80\xf1\x12\x82\x80\x13\xe0\x53\xe0\x53\xe0\x54\xe0"
            "\x5e\x01\x8d" }  },
      /* --- pixel bitmap for stmary250 char#69 \supsetplus --- */
      {  69,55108,                      /* character number, location */
         20, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 21,   22, 3,85, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x8e\x01\xe0\x54\xe0\x53\xe0\x53\xe0\x53\x10\xf1"
            "\x82\x82\x10\x82\x83\x82\x92\xf1\x4a\x52\x82\x92\x82"
            "\x83\xf1\x82\x82\x10\xe0\x33\xe0\x33\xe0\x33\xe0\x24"
            "\x4e\x01\x6d\x81" }  },
      /* --- pixel bitmap for stmary250 char#70 \subsetpluseq --- */
      {  70,55936,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 21,   30, 3,96, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x8d\x6e\x01\x44\xe0\x23\xe0\x33\xe0\x33\xe0\x30\xf1"
            "\x12\x82\x83\x82\x82\x92\x8f\x12\x5a\x42\x92\x83\x82"
            "\x80\xf1\x12\x82\x80\x13\xe0\x53\xe0\x53\xe0\x54\xe0"
            "\x5e\x01\x8d\xf5\xe0\x70\xf1\x1e\x06" }  },
      /* --- pixel bitmap for stmary250 char#71 \supsetpluseq --- */
      {  71,56772,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 21,   30, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x0d\x8e\x01\xe0\x54\xe0\x53\xe0\x53\xe0\x53\x10\xf1"
            "\x82\x82\x10\x82\x83\x82\x92\xf1\x4a\x52\x82\x92\x82"
            "\x83\xf1\x82\x82\x10\xe0\x33\xe0\x33\xe0\x33\xe0\x24"
            "\x4e\x01\x6d\x80\xf5\xe0\x7f\x1e\x06\x10" }  },
      /* --- pixel bitmap for stmary250 char#72 \Lbag --- */
      {  72,57571,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 11,   35, 3,84, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x24\x61\x41\x42\x41\x4f\x13\x41\x30\x71\x30\xf3\x61"
            "\x40\x52\x91\x50\xf1\x42\x50\x41\x60\xf1\x32\x60\x23"
            "\x82\x70\xf1\x13\x70\x12\x8f\x63\x80\xf1\x13\x70\x23"
            "\x93\xa3\xa4" }  },
      /* --- pixel bitmap for stmary250 char#73 \Rbag --- */
      {  73,58097,                      /* character number, location */
         26, 2,   -9, 2,      /* topleft row,col, and botleft row,col */
          { 11,   35, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x54\x61\x41\x51\x42\xf1\x31\x43\x31\x70\xf3\x41\x60"
            "\x42\xa1\x50\xf1\x52\x40\x61\x40\xf1\x62\x30\x63\x92"
            "\x20\xf1\x73\x10\x82\x10\xf6\x83\xf1\x73\x10\x63\x73"
            "\x63\x54\x74" }  },
      /* --- pixel bitmap for stmary250 char#74 \llbracket --- */
      {  74,58980,                      /* character number, location */
         26, 3,   -9, 3,      /* topleft row,col, and botleft row,col */
          { 11,   35, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0b\x0f\xe2\x22\x5f\xe2\x22\x52\x22\x5f\x1b" }  },
      /* --- pixel bitmap for stmary250 char#75 \rrbracket --- */
      {  75,59918,                      /* character number, location */
         26, 1,   -9, 1,      /* topleft row,col, and botleft row,col */
          { 10,   35, 3,24, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0a\xfe\x42\x22\xfe\x42\x22\x42\x22\x0f\x1a" }  },
      /* --- pixel bitmap for stmary250 char#76 \llparenthesis --- */
      {  76,60714,                      /* character number, location */
         26, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          {  8,   34, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x80\xc0\xe0\xd0\xd8\xc8\xcc\xc4\xc6\xc6\xc2\xc2\xc3"
            "\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc2\xc2\xc6\xc6"
            "\xc4\xcc\xc8\xd8\xd0\xe0\xc0\x80" }  },
      /* --- pixel bitmap for stmary250 char#77 \rrparenthesis --- */
      {  77,61503,                      /* character number, location */
         26, 2,   -8, 2,      /* topleft row,col, and botleft row,col */
          {  8,   34, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x01\x03\x07\x0b\x1b\x13\x33\x23\x63\x63\x43\x43\xc3"
            "\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\xc3\x43\x43\x63\x63"
            "\x23\x33\x13\x1b\x0b\x07\x03\x01" }  },
      /* --- pixel bitmap for stmary250 char#78 \binampersand --- */
      {  78,62348,                      /* character number, location */
         21, 2,   -3, 2,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x94\xe0\x38\xe3\x43\xc3\x62\x70\xf1\x52\x72\x70\x53"
            "\x62\xd2\x53\xd3\x33\xe0\x17\xe0\x25\xe0\x27\x92\x34"
            "\x34\x72\x23\x73\x53\x13\x93\x33\x22\xb3\x22\x23\xc6"
            "\x22\xe4\x32\xe5\x22\xd3\x13\x13\xa4\x33\x13\x65\x62"
            "\x2b\xe6\xd0" }  },
      /* --- pixel bitmap for stmary250 char#79 \bindnasrepma --- */
      {  79,63077,                      /* character number, location */
         20, 2,   -4, 2,      /* topleft row,col, and botleft row,col */
          { 23,   24, 3,109, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd6\xeb\x22\x65\x63\x13\x34\xa3\x13\x13\xd2\x25\xe2"
            "\x34\xe2\x26\xc3\x22\x23\xb2\x23\x33\x93\x13\x53\x73"
            "\x22\x74\x34\x32\x97\xe0\x25\xe0\x27\xe0\x13\x33\xd3"
            "\x52\xd2\x63\x50\xf1\x72\x72\x50\x72\x63\xc3\x43\xe8"
            "\xe0\x34\x90" }  },
      /* --- pixel bitmap for stmary250 char#80 \trianglelefteqslant --- */
      {  80,63881,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 21,   30, 3,116, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x52\xe0\x34\xe0\x16\xd4\x22\xb4\x42\xa3\x62\x84"
            "\x72\x64\x92\x44\xb2\x24\xd2\x0f\x14\xe0\x12\x24\xd2"
            "\x44\xb2\x64\x92\x83\x82\x94\x62\xb4\x44\xb4\x26\xb6"
            "\x24\xb4\x44\xb2\x64\xe0\x53\xe0\x54\xe0\x54\xe0\x54"
            "\xe0\x54\xe0\x54\xe0\x52" }  },
      /* --- pixel bitmap for stmary250 char#81 \trianglerighteqslant --- */
      {  81,64690,                      /* character number, location */
         22, 3,   -8, 3,      /* topleft row,col, and botleft row,col */
          { 21,   30, 3,121, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x54\xe0\x36\xe0\x12\x24\xd2\x44\xb2\x63\xa2"
            "\x74\x82\x94\x62\xb4\x42\xd4\x2f\x12\xe0\x14\x02\xd4"
            "\x22\xb4\x42\x94\x62\x83\x82\x64\x92\x44\xb2\x24\xb8"
            "\xb8\xb4\x22\xb4\xe0\x14\xe0\x23\xe0\x24\xe0\x14\xe0"
            "\x14\xe0\x14\xe0\x14\xe0\x32\xe0\x50" }  },
      /* --- pixel bitmap for stmary250 char#82 \ntrianglelefteqslant --- */
      {  82,65545,                      /* character number, location */
         28, 3,  -10, 3,      /* topleft row,col, and botleft row,col */
          { 21,   38, 3,165, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x32\x20\xe0\x23\xe0\x42\xe0\x43\xe0\x42\xe0"
            "\x52\x22\xf1\xe7\xd4\x22\xb4\x42\x96\x42\x74\x12\x52"
            "\x54\x32\x52\x34\x43\x52\x14\x62\x65\x73\x66\x62\x72"
            "\x24\x42\x72\x44\x13\x72\x65\x82\x84\x72\x86\x52\x73"
            "\x24\x34\x52\x54\x16\x32\x75\x27\x93\x44\xb2\x55\xe0"
            "\x22\x14\xd3\x34\xb2\x64\x92\x84\x63\xa4\x42\xd3\x23"
            "\xe2\xf1\x22\xe0\x30" }  },
      /* --- pixel bitmap for stmary250 char#83 \ntrianglerighteqslant --- */
      {  83,66457,                      /* character number, location */
         28, 3,  -10, 3,      /* topleft row,col, and botleft row,col */
          { 21,   38, 3,163, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x32\x20\xe0\x23\xe0\x42\xe0\x43\xe0\x42\x42"
            "\xd2\x44\xa3\x46\x82\x52\x24\x53\x52\x44\x32\x62\x67"
            "\x62\x84\x72\xa4\x52\x97\x32\x92\x34\x12\x83\x55\x82"
            "\x56\x82\x34\x22\x73\x14\x42\x76\x62\x65\x82\x54\xa2"
            "\x35\xb2\x16\xa7\x22\x87\x33\x64\x22\x42\x54\x93\x34"
            "\xb2\x24\xc7\xe5\xe0\x14\xe0\x15\xe0\x1f\x15\xe0\x20"
            "\xf1\x22\xe0\x30" }  },
      /* --- pixel bitmap for stmary250 char#84 \llfloor --- */
      {  84,67207,                      /* character number, location */
         26, 1,   -8, 1,      /* topleft row,col, and botleft row,col */
          { 18,   34, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f\x00\x02\x06\x02\x08\xff\x01\x12" }  },
      /* --- pixel bitmap for stmary250 char#85 \rrfloor --- */
      {  85,67945,                      /* character number, location */
         26, 0,   -8, 0,      /* topleft row,col, and botleft row,col */
          { 18,   34, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x1f\x08\x02\x06\x02\x00\xff\x01\x12" }  },
      /* --- pixel bitmap for stmary250 char#86 \llceil --- */
      {  86,68669,                      /* character number, location */
         27, 1,   -9, 1,      /* topleft row,col, and botleft row,col */
          { 18,   36, 2,11, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x12\x00\xff\x21\x02\x06\x02\x08" }  },
      /* --- pixel bitmap for stmary250 char#87 \rrceil --- */
      {  87,69402,                      /* character number, location */
         27, 0,   -9, 0,      /* topleft row,col, and botleft row,col */
          { 18,   36, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x12\xff\x21\x08\x02\x06\x02" }  },
      /* --- pixel bitmap for stmary250 char#88 \arrownot --- */
      {  88,69867,                      /* character number, location */
         16,13,    2,13,      /* topleft row,col, and botleft row,col */
          {  9,   14, 3,29, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x81\x72\x63\x62\x63\x53\x53\x62\x63\x53\x62\x63\x62"
            "\x71\x84" }  },
      /* --- pixel bitmap for stmary250 char#89 \Arrownot --- */
      {  89,70227,                      /* character number, location */
         20,14,   -2,14,      /* topleft row,col, and botleft row,col */
          {  7,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x40\x30\x18\x0c\x87\xc1\x70\x18\x0c\x87\xc1\x60\x38"
            "\x0c\x86\xc3\x60\x30\x08\x00" }  },
      /* --- pixel bitmap for stmary250 char#90 \Mapstochar --- */
      {  90,70626,                      /* character number, location */
         20, 2,   -2, 2,      /* topleft row,col, and botleft row,col */
          {  3,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xdb\xb6\xfd\xdb\xb6\xfd\xdb\xb6\x01" }  },
      /* --- pixel bitmap for stmary250 char#91 \mapsfromchar --- */
      {  91,70937,                      /* character number, location */
         16,-5,    2,-5,      /* topleft row,col, and botleft row,col */
          {  3,   14, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb6\x6d\xff\xb6\x6d\x03" }  },
      /* --- pixel bitmap for stmary250 char#92 \Mapsfromchar --- */
      {  92,71251,                      /* character number, location */
         20,-5,   -2,-5,      /* topleft row,col, and botleft row,col */
          {  3,   22, 1, 1, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xb6\x6d\xff\xb6\x6d\xff\xb6\x6d\x03" }  },
      /* --- pixel bitmap for stmary250 char#93 \leftrightarrowtriangle --- */
      {  93,72118,                      /* character number, location */
         14, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 31,   11, 3,63, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\xd2\xc4\xd4\x86\xd6\x53\x22\xd2\x23\x24\x3e\x03"
            "\x37\x4e\x03\x43\x14\x22\xd2\x24\x43\x12\xd2\x13\x75"
            "\xd5\xa3\xd3\xd2\xd2\x77" }  },
      /* --- pixel bitmap for stmary250 char#94 \leftarrowtriangle --- */
      {  94,72975,                      /* character number, location */
         14, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 31,   11, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x72\xe0\xd4\xe0\xb6\xe0\xa3\x22\xe0\x84\x3e\x0d\x4e"
            "\x0a\x14\x22\xe0\xb3\x12\xe0\xc5\xe0\xe3\xe0\xe0\x12"
            "\xe0\x83" }  },
      /* --- pixel bitmap for stmary250 char#95 \rightarrowtriangle --- */
      {  95,73805,                      /* character number, location */
         14, 2,    3, 2,      /* topleft row,col, and botleft row,col */
          { 31,   11, 3,55, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x82\xe0\xe0\x14\xe0\xd6\xe0\xb2\x23\x2e\x0a\x3e"
            "\x0e\x43\xe0\x82\x24\xe0\x92\x13\xe0\xb5\xe0\xc3\xe0"
            "\xe2\x73" }  },
      /* --- pixel bitmap for stmary250 char#96 \bigtriangledown --- */
      {  96,74521,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 3,163, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0b\x03\xe0\x53\xf1\x12\xe0\x52\x10\x13\xe0"
            "\x33\x10\xf1\x22\xe0\x32\x20\x23\xe0\x13\x20\xf1\x32"
            "\xe0\x12\x30\x33\xd3\x72\xd2\x83\xb3\x40\xf1\x52\xb2"
            "\x50\x53\x93\x50\xf1\x62\x92\x60\x63\x73\x60\xf1\x72"
            "\x72\x70\x73\x53\x70\xf1\x82\x52\x80\x83\x33\x80\xf1"
            "\x92\x32\x90\x93\x13\x90\xf1\xa2\x12\xa0\xa5\xa0\xf1"
            "\xb3\xb0\xc2\xb0" }  },
      /* --- pixel bitmap for stmary250 char#97 \bigtriangleup --- */
      {  97,75352,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 3,162, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc2\xb0\xf1\xb3\xb0\xa5\xa0\xf1\xa2\x12\xa0\x93\x13"
            "\x90\xf1\x92\x32\x90\x83\x33\x80\xf1\x82\x52\x80\x73"
            "\x53\x70\xf1\x72\x72\x70\x63\x73\x60\xf1\x62\x92\x60"
            "\x53\x93\x50\xf1\x52\xb2\x50\x43\xb3\x82\xd2\x73\xd3"
            "\x30\xf1\x32\xe0\x12\x30\x23\xe0\x13\x20\xf1\x22\xe0"
            "\x32\x20\x13\xe0\x33\x10\xf1\x12\xe0\x52\x13\xe0\x53"
            "\x0f\x1e\x0b" }  },
      /* --- pixel bitmap for stmary250 char#98 \bigcurlyvee --- */
      {  98,76181,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 3,91, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\xe0\x76\xe0\x34\x23\xe0\x13\x53\xd3\x73\xb3\x93"
            "\x93\xb2\x92\xc3\x73\xd3\x53\x70\xf1\x82\x52\x80\x83"
            "\x33\x80\xf1\x92\x32\x90\x93\x13\x90\xf2\xa2\x12\xa0"
            "\xa5\xa0\xfe\xb3\xb0\xc2\xb0" }  },
      /* --- pixel bitmap for stmary250 char#99 \bigcurlywedge --- */
      {  99,76990,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 3,90, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xc2\xb0\xfe\xb3\xb0\xa5\xa0\xf2\xa2\x12\xa0\x93\x13"
            "\x90\xf1\x92\x32\x90\x83\x33\x80\xf1\x82\x52\x80\x73"
            "\x53\xd3\x73\xc2\x92\xb3\x93\x93\xb3\x73\xd3\x53\xe0"
            "\x13\x24\xe0\x36\xe0\x72" }  },
      /* --- pixel bitmap for stmary250 char#100 \bigsqcap --- */
      { 100,77827,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x19\x00\xff\x20\x02\x15\x02" }  },
      /* --- pixel bitmap for stmary250 char#101 \bigbox --- */
      { 101,78674,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x19\x00\xff\x1e\x02\x15\x02\x00\xff\x01"
            "\x19" }  },
      /* --- pixel bitmap for stmary250 char#102 \bigparallel --- */
      { 102,79347,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 11,   35, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x22\x00\x02\x07\x02" }  },
      /* --- pixel bitmap for stmary250 char#103 \biginterleave --- */
      { 103,80177,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 20,   35, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x22\x00\x02\x07\x02\x07\x02" }  },
      /* --- pixel bitmap for stmary250 char#104 (noname) --- */
      { 104,81223,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 3,245, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\x0e\x0e\x06\x03\xe0\xe3\xf1\x12\xe0\xe2\x10\x13"
            "\xe0\xc3\x10\xf1\x22\xe0\xc2\x20\x23\xe0\xa3\x20\xf1"
            "\x32\xe0\xa2\x30\x33\xe0\x83\x72\xe0\x82\x83\xe0\x63"
            "\x40\xf1\x52\xe0\x62\x50\x53\xe0\x43\x50\xf1\x62\xe0"
            "\x42\x60\x63\xe0\x23\x60\xf1\x72\xe0\x22\x70\x73\xe3"
            "\x70\xf1\x82\xe2\x80\x83\xc3\x80\xf1\x92\xc2\x90\x93"
            "\xa3\x90\xf1\xa2\xa2\xa0\xa3\x83\xa0\xf1\xb2\x82\xb0"
            "\xb3\x63\xe0\x92\x62\xe0\xa3\x43\xc0\xf1\xd2\x42\xd0"
            "\xd3\x23\xd0\xf1\xe2\x22\xe0\xe6\xe0\xf2\xe0\x14\xe0"
            "\x10\xf1\xe0\x22\xe0\x20" }  },
      /* --- pixel bitmap for stmary250 char#105 (noname) --- */
      { 105,82235,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 3,244, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf1\xe0\x22\xe0\x20\xf2\xe0\x14\xe0\x10\xe6\xe0\xf1"
            "\xe2\x22\xe0\xd3\x23\xd0\xf1\xd2\x42\xd0\xc3\x43\xe0"
            "\xa2\x62\xe0\x93\x63\xb0\xf1\xb2\x82\xb0\xa3\x83\xa0"
            "\xf1\xa2\xa2\xa0\x93\xa3\x90\xf1\x92\xc2\x90\x83\xc3"
            "\x80\xf1\x82\xe2\x80\x73\xe3\x70\xf1\x72\xe0\x22\x70"
            "\x63\xe0\x23\x60\xf1\x62\xe0\x42\x60\x53\xe0\x43\x50"
            "\xf1\x52\xe0\x62\x50\x43\xe0\x63\x82\xe0\x82\x73\xe0"
            "\x83\x30\xf1\x32\xe0\xa2\x30\x23\xe0\xa3\x20\xf1\x22"
            "\xe0\xc2\x20\x13\xe0\xc3\x10\xf1\x12\xe0\xe2\x13\xe0"
            "\xe3\x0f\x1e\x0e\x06" }  },
      /* --- pixel bitmap for stmary250 char#106 (noname) --- */
      { 106,83245,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 3,147, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x02\xe0\xe0\x26\xe0\xc4\x23\xe0\xa3\x53\xe0\x83\x73"
            "\xe0\x63\x93\xe0\x43\xb3\xe0\x23\xd3\xe3\xe0\x13\xc3"
            "\xe0\x32\xc2\xe0\x43\xa3\xe0\x52\xa2\xe0\x63\x83\xe0"
            "\x72\x82\xe0\x83\x63\xe0\x92\x62\xe0\xa3\x43\xc0\xf2"
            "\xd2\x42\xd0\xd3\x23\xd0\xf2\xe2\x22\xe0\xe6\xe0\xf7"
            "\xe0\x14\xe0\x10\xfe\xe0\x22\xe0\x20" }  },
      /* --- pixel bitmap for stmary250 char#107 (noname) --- */
      { 107,84225,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 3,146, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xfe\xe0\x22\xe0\x20\xf7\xe0\x14\xe0\x10\xe6\xe0\xf2"
            "\xe2\x22\xe0\xd3\x23\xd0\xf2\xd2\x42\xd0\xc3\x43\xe0"
            "\xa2\x62\xe0\x93\x63\xe0\x82\x82\xe0\x73\x83\xe0\x62"
            "\xa2\xe0\x53\xa3\xe0\x42\xc2\xe0\x33\xc3\xe0\x13\xe3"
            "\xd3\xe0\x23\xb3\xe0\x43\x93\xe0\x63\x73\xe0\x83\x53"
            "\xe0\xa3\x24\xe0\xc6\xe0\xe0\x22" }  },
      /* --- pixel bitmap for stmary250 char#108 (noname) --- */
      { 108,85226,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 2,10, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x22\x00\xff\x2d\x02\x1e\x02" }  },
      /* --- pixel bitmap for stmary250 char#109 (noname) --- */
      { 109,86258,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x22\x00\xff\x2b\x02\x1e\x02\x00\xff\x01"
            "\x22" }  },
      /* --- pixel bitmap for stmary250 char#110 (noname) --- */
      { 110,87038,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 15,   48, 2, 6, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x2f\x00\x02\x0b\x02" }  },
      /* --- pixel bitmap for stmary250 char#111 (noname) --- */
      { 111,88027,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 28,   48, 2, 8, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x2f\x00\x02\x0b\x02\x0b\x02" }  },
      /* --- pixel bitmap for stmary250 char#112 \bignplus --- */
      { 112,89119,                      /* character number, location */
          0, 2,  -35, 2,      /* topleft row,col, and botleft row,col */
          { 25,   35, 3,90, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x97\xe0\x2b\xc4\x74\x93\xb3\x73\xd3\x53\xe0\x13\x33"
            "\xe0\x33\x22\xe0\x52\x13\xe0\x55\xe0\x72\x0f\x62\xa2"
            "\x92\x02\x3e\x01\x34\x2e\x03\x22\x0f\x62\xa2\x92\x02"
            "\xa1\xa2\x0f\x72\xe0\x72" }  },
      /* --- pixel bitmap for stmary250 char#113 (noname) --- */
      { 113,90207,                      /* character number, location */
          1, 7,  -39, 7,      /* topleft row,col, and botleft row,col */
          { 11,   40, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0b\x0f\xe2\x22\x5f\xe2\x22\x5f\x52\x22\x5f\x1b" }  },
      /* --- pixel bitmap for stmary250 char#114 (noname) --- */
      { 114,91284,                      /* character number, location */
          1, 8,  -60, 8,      /* topleft row,col, and botleft row,col */
          { 12,   61, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0c\x00\xff\x38\x02\x03\x02\x05\xff\x01"
            "\x0c" }  },
      /* --- pixel bitmap for stmary250 char#115 (noname) --- */
      { 115,92472,                      /* character number, location */
          1, 9,  -81, 9,      /* topleft row,col, and botleft row,col */
          { 13,   82, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0d\x00\xff\x4d\x02\x03\x02\x06\xff\x01"
            "\x0d" }  },
      /* --- pixel bitmap for stmary250 char#116 (noname) --- */
      { 116,93770,                      /* character number, location */
          1,10,  -101,10,     /* topleft row,col, and botleft row,col */
          { 14,  102, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0e\x00\xff\x61\x02\x04\x02\x06\xff\x01"
            "\x0e" }  },
      /* --- pixel bitmap for stmary250 char#117 (noname) --- */
      { 117,95117,                      /* character number, location */
          0,12,  -62,12,      /* topleft row,col, and botleft row,col */
          { 15,   62, 2,15, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0f\x00\xff\x3a\x02\x05\x02\x06\x02\x05"
            "\x01\x07" }  },
      /* --- pixel bitmap for stmary250 char#118 (noname) --- */
      { 118,96236,                      /* character number, location */
          2,12,  -60,12,      /* topleft row,col, and botleft row,col */
          { 15,   62, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x00\x02\x05\x01\x07\xff\x3a\x02\x05\x02\x06\xff\x01"
            "\x0f" }  },
      /* --- pixel bitmap for stmary250 char#119 (noname) --- */
      { 119,97346,                      /* character number, location */
          2,12,  -22,12,      /* topleft row,col, and botleft row,col */
          {  9,   24, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x02\x51\x1f\xe2\x52\x0f\x72\x52" }  },
      /* --- pixel bitmap for stmary250 char#120 (noname) --- */
      { 120,98360,                      /* character number, location */
          0, 2,  -48, 2,      /* topleft row,col, and botleft row,col */
          { 34,   48, 3,108, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd8\xe0\x9e\xe0\x45\x85\xe4\xe4\xb3\xe0\x43\x93\xe0"
            "\x63\x73\xe0\x83\x62\xe0\xa2\x53\xe0\xa3\x33\xe0\xc3"
            "\x10\xf1\x12\xe0\xe2\x13\xe0\xe3\x0f\xa2\xe2\xe2\x02"
            "\x3e\x0a\x34\x2e\x0c\x22\x0f\xb2\xe2\xe2\x0f\x92\xe0"
            "\xe0\x22" }  },
      /* --- pixel bitmap for stmary250 char#121 (noname) --- */
      { 121,99503,                      /* character number, location */
          1, 0,  -39, 0,      /* topleft row,col, and botleft row,col */
          { 11,   40, 3,26, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xf1\x0b\xfe\x52\x22\xfe\x52\x22\xf5\x52\x22\x0f\x1b" }  },
      /* --- pixel bitmap for stmary250 char#122 (noname) --- */
      { 122,100567,                     /* character number, location */
          1, 0,  -60, 0,      /* topleft row,col, and botleft row,col */
          { 12,   61, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0c\xff\x38\x05\x02\x03\x02\x00\xff\x01"
            "\x0c" }  },
      /* --- pixel bitmap for stmary250 char#123 (noname) --- */
      { 123,101742,                     /* character number, location */
          1, 0,  -81, 0,      /* topleft row,col, and botleft row,col */
          { 13,   82, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0d\xff\x4d\x06\x02\x03\x02\x00\xff\x01"
            "\x0d" }  },
      /* --- pixel bitmap for stmary250 char#124 (noname) --- */
      { 124,103027,                     /* character number, location */
          1, 0,  -101, 0,     /* topleft row,col, and botleft row,col */
          { 14,  102, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0e\xff\x61\x06\x02\x04\x02\x00\xff\x01"
            "\x0e" }  },
      /* --- pixel bitmap for stmary250 char#125 (noname) --- */
      { 125,104335,                     /* character number, location */
          0, 0,  -62, 0,      /* topleft row,col, and botleft row,col */
          { 15,   62, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x01\x00\x0f\xff\x3a\x06\x02\x05\x02\x07\x01\x05"
            "\x02" }  },
      /* --- pixel bitmap for stmary250 char#126 (noname) --- */
      { 126,105509,                     /* character number, location */
          2, 0,  -60, 0,      /* topleft row,col, and botleft row,col */
          { 15,   62, 2,14, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x07\x01\x05\x02\xff\x3a\x06\x02\x05\x02\x00\xff\x01"
            "\x0f" }  },
      /* --- pixel bitmap for stmary250 char#127 (noname) --- */
      { 127,106580,                     /* character number, location */
          2, 6,  -22, 6,      /* topleft row,col, and botleft row,col */
          {  9,   24, 3,16, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x11\x52\x0f\xe2\x52\x0f\x72\x52" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;


#ifdef SSFONTS
/* ------------------------------------------------------------------------
fonts for SuperSampling anti-aliasing algorithm
------------------------------------------------------------------------ */

/* --- size=1200 for .1200gf ---
 * mf '\mode=ultre;  input cmr10'
 * --------------------------------------------------------------------- */
/* --- fontdef for cmr1200 --- */
static	chardef  cmr1200[] =
   {
      /* --- pixel bitmap for cmr1200 char#0 \Gamma --- */
      {   0,20634,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 91,  113, 2,127, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x03\x00\x56\x05\x57\x10\x17\x1e\x16\x13\x12\x25"
            "\x11\x14\x10\x29\x0e\x15\x0f\x2b\x0c\x15\x0f\x2c\x0b"
            "\x15\x0f\x2e\x09\x15\x0f\x2f\x09\x03\x00\xff\x01\x11"
            "\x0f\x30\x08\x03\x00\x11\x0f\x31\x07\x03\x00\xff\x01"
            "\x11\x0f\x32\x06\x03\x00\xff\x01\x11\x0f\x33\x05\x03"
            "\x00\x11\x0f\x33\x06\x02\x00\xff\x02\x11\x0f\x34\x05"
            "\x02\x00\xff\x02\x11\x0f\x35\x04\x02\x00\x11\x0f\x35"
            "\x05\x01\x00\xff\x05\x11\x0f\x36\x04\x01\x00\xff\x03"
            "\x11\x0f\x37\x04\xff\x42\x11\x0f\x3b\x00\x11\x10\x4a"
            "\x11\x49\x13\x45\x1a\x35\xff\x04\x35\x26" }  },
      /* --- pixel bitmap for cmr1200 char#1 \Delta --- */
      {   1,20936,                      /* character number, location */
        119, 8,    0, 8,      /* topleft row,col, and botleft row,col */
          { 121,  119, 2,438, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x3a\x05\x73\x07\x39\x00\xff\x01\x38\x09\x38\x00\xff"
            "\x01\x37\x0b\x37\x00\xff\x02\x36\x0d\x36\x00\xff\x01"
            "\x35\x0f\x35\x00\xff\x01\x34\x11\x34\x00\xff\x01\x33"
            "\x13\x33\x00\xff\x01\x32\x15\x32\x00\x31\x17\x62\x05"
            "\x02\x10\x61\x06\x02\x11\x60\x05\x04\x10\x5f\x06\x04"
            "\x11\x5e\x05\x06\x10\x5d\x06\x06\x11\x5c\x05\x08\x10"
            "\x5b\x06\x08\x11\x5a\x05\x0a\x10\x59\x06\x0a\x11\x58"
            "\x05\x0c\x10\x57\x06\x0c\x11\x56\x05\x0e\x10\x55\x06"
            "\x0e\x11\x54\x05\x10\x10\x53\x06\x10\x11\x52\x05\x12"
            "\x10\x51\x06\x12\x11\x50\x05\x14\x10\x4f\x06\x14\x11"
            "\x4e\x05\x16\x10\x4d\x06\x16\x11\x4c\x05\x18\x10\x4b"
            "\x06\x18\x11\x4a\x05\x1a\x10\x49\x06\x1a\x11\x48\x05"
            "\x1c\x10\x47\x06\x1c\x11\x46\x05\x1e\x10\x45\x06\x1e"
            "\x11\x44\x05\x20\x10\x43\x06\x20\x11\x42\x05\x22\x10"
            "\x41\x06\x22\x11\x40\x05\x24\x10\x3f\x06\x24\x11\x3e"
            "\x05\x26\x10\x3d\x06\x26\x11\x3c\x05\x28\x10\x3b\x06"
            "\x28\x11\x3a\x05\x29\x11\x39\x06\x2a\x11\x38\x05\x2b"
            "\x11\x37\x06\x2c\x11\x36\x05\x2d\x11\x35\x06\x2e\x11"
            "\x34\x05\x2f\x11\x33\x06\x30\x11\x32\x05\x31\x11\x31"
            "\x06\x32\x11\x30\x05\x33\x11\x2f\x06\x34\x11\x2e\x05"
            "\x35\x11\x2d\x06\x36\x11\x2c\x05\x37\x11\x2b\x06\x38"
            "\x11\x2a\x05\x39\x11\x29\x06\x3a\x11\x28\x05\x3b\x11"
            "\x27\x06\x3c\x11\x26\x05\x3d\x11\x25\x06\x3e\x11\x24"
            "\x05\x3f\x11\x23\x06\x40\x11\x22\x05\x41\x11\x21\x06"
            "\x42\x11\x20\x05\x43\x11\x10\x00\xff\x01\x0f\x06\x44"
            "\x11\x0f\x00\xff\x01\x0e\x06\x46\x11\x0e\x00\xff\x01"
            "\x0d\x06\x48\x11\x0d\x00\xff\x01\x0c\x06\x4a\x11\x0c"
            "\x00\xff\x01\x0b\x06\x4c\x11\x0b\x00\xff\x01\x0a\x06"
            "\x4e\x11\x0a\x00\xff\x01\x09\x06\x50\x11\x09\x00\xff"
            "\x01\x08\x06\x52\x11\x08\x00\x08\x05\x54\x10\x0f\x06"
            "\x54\x11\x0e\x05\x56\x10\x0d\x06\x56\x11\x0c\x05\x58"
            "\x10\x06\x00\xff\x01\x05\x6f\x05\x00\xff\x01\x04\x71"
            "\x04\x00\xff\x01\x03\x73\x03\x00\xff\x01\x02\x75\x02"
            "\x00\xff\x01\x01\x77\x01\xff\x02\x79" }  },
      /* --- pixel bitmap for cmr1200 char#2 \Theta --- */
      {   2,21395,                      /* character number, location */
        117, 9,   -4, 9,      /* topleft row,col, and botleft row,col */
          { 110,  121, 2,435, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x30\x0e\x5b\x18\x52\x20\x4c\x24\x47\x10\x0a\x10\x42"
            "\x0e\x12\x0e\x3e\x0d\x18\x0d\x3b\x0c\x1c\x0c\x38\x0c"
            "\x20\x0c\x35\x0b\x24\x0b\x32\x0c\x26\x0c\x2f\x0c\x28"
            "\x0c\x2d\x0c\x2a\x0c\x2a\x0c\x2e\x0c\x27\x0c\x30\x0c"
            "\x25\x0c\x32\x0c\x23\x0d\x32\x0d\x21\x0d\x34\x0d\x20"
            "\x0c\x36\x0c\x1f\x0c\x38\x0c\x1d\x0c\x3a\x0c\x1b\x0d"
            "\x3a\x0d\x0d\x00\xff\x01\x0c\x0d\x3c\x0d\x0c\x00\x0b"
            "\x0d\x3e\x0d\x0b\x00\xff\x01\x0a\x0d\x40\x0d\x0a\x00"
            "\x09\x0d\x42\x0d\x09\x00\xff\x01\x08\x0e\x42\x0e\x08"
            "\x00\xff\x01\x07\x0e\x44\x0e\x07\x00\xff\x01\x06\x0e"
            "\x46\x0e\x06\x00\x05\x0f\x46\x0f\x05\x00\xff\x01\x05"
            "\x0e\x48\x0e\x05\x00\xff\x01\x04\x0f\x48\x0f\x04\x00"
            "\xff\x03\x03\x0f\x4a\x0f\x03\x00\xff\x03\x02\x0f\x4c"
            "\x0f\x02\x00\x01\x10\x4c\x10\x01\x00\xff\x01\x01\x10"
            "\x09\x04\x32\x04\x09\x10\x01\x00\xff\x02\x01\x0f\x0a"
            "\x04\x32\x04\x0a\x0f\x01\x10\x0a\x04\x32\x04\x0a\x10"
            "\x00\xff\x0c\x10\x0a\x3a\x0a\x10\x00\xff\x01\x10\x0a"
            "\x04\x32\x04\x0a\x10\xff\x01\x01\x0f\x0a\x04\x32\x04"
            "\x0a\x0f\x01\x00\xff\x01\x01\x10\x09\x04\x32\x04\x09"
            "\x10\x01\x00\xff\x01\x01\x10\x4c\x10\x01\x00\xff\x02"
            "\x02\x0f\x4c\x0f\x02\x00\x02\x10\x4a\x10\x02\x00\xff"
            "\x02\x03\x0f\x4a\x0f\x03\x00\x04\x0e\x4a\x0e\x04\x00"
            "\xff\x01\x04\x0f\x48\x0f\x04\x00\x05\x0e\x48\x0e\x0a"
            "\x0f\x46\x0f\x05\x00\xff\x01\x06\x0e\x46\x0e\x06\x00"
            "\xff\x01\x07\x0e\x44\x0e\x07\x00\x08\x0d\x44\x0d\x10"
            "\x0e\x42\x0e\x11\x0d\x42\x0d\x12\x0e\x40\x0e\x13\x0d"
            "\x40\x0d\x0a\x00\xff\x01\x0b\x0d\x3e\x0d\x0b\x00\x0c"
            "\x0d\x3c\x0d\x19\x0d\x3a\x0d\x1b\x0c\x3a\x0c\x1c\x0d"
            "\x38\x0d\x1d\x0d\x36\x0d\x1f\x0d\x34\x0d\x21\x0c\x34"
            "\x0c\x23\x0c\x32\x0c\x25\x0c\x30\x0c\x27\x0c\x2e\x0c"
            "\x29\x0c\x2c\x0c\x2c\x0c\x28\x0c\x2f\x0c\x26\x0c\x31"
            "\x0c\x24\x0c\x34\x0c\x20\x0c\x37\x0d\x1c\x0d\x3a\x0d"
            "\x18\x0d\x3e\x0e\x12\x0e\x42\x10\x0a\x10\x47\x24\x4c"
            "\x20\x52\x18\x5b\x0e\x30" }  },
      /* --- pixel bitmap for cmr1200 char#3 \Lambda --- */
      {   3,21990,                      /* character number, location */
        119, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 104,  119, 2,442, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x32\x04\x32\x00\xff\x01\x31\x06\x31\x00\xff\x02\x30"
            "\x08\x30\x00\xff\x02\x2f\x0a\x2f\x00\xff\x02\x2e\x0c"
            "\x2e\x00\xff\x02\x2d\x0e\x2d\x00\xff\x02\x2c\x10\x2c"
            "\x00\xff\x03\x2b\x12\x2b\x00\xff\x02\x2a\x14\x2a\x00"
            "\xff\x01\x29\x05\x01\x10\x29\x00\x29\x05\x02\x0f\x51"
            "\x06\x02\x10\x50\x05\x03\x10\x50\x05\x04\x0f\x4f\x06"
            "\x04\x10\x4e\x05\x05\x10\x4e\x05\x06\x0f\x4d\x06\x06"
            "\x10\x4c\x05\x07\x10\x4c\x05\x08\x0f\x4b\x06\x08\x10"
            "\x25\x00\xff\x01\x25\x05\x09\x10\x25\x00\x24\x06\x0a"
            "\x10\x24\x00\xff\x01\x24\x05\x0b\x10\x24\x00\x24\x05"
            "\x0c\x0f\x24\x00\xff\x01\x23\x05\x0d\x10\x23\x00\x23"
            "\x05\x0e\x0f\x23\x00\xff\x01\x22\x05\x0f\x10\x22\x00"
            "\x22\x05\x10\x0f\x43\x06\x10\x10\x42\x05\x11\x10\x42"
            "\x05\x12\x0f\x41\x06\x12\x10\x40\x05\x13\x10\x40\x05"
            "\x14\x0f\x3f\x06\x14\x10\x3e\x05\x15\x10\x3e\x05\x16"
            "\x0f\x3d\x06\x16\x10\x1e\x00\xff\x01\x1e\x05\x17\x10"
            "\x1e\x00\x1d\x06\x18\x10\x1d\x00\xff\x01\x1d\x05\x19"
            "\x10\x1d\x00\x1d\x05\x1a\x0f\x1d\x00\xff\x01\x1c\x05"
            "\x1b\x10\x1c\x00\x1c\x05\x1c\x0f\x1c\x00\xff\x01\x1b"
            "\x05\x1d\x10\x1b\x00\x1b\x05\x1e\x0f\x35\x06\x1e\x10"
            "\x34\x05\x1f\x10\x34\x05\x20\x0f\x33\x06\x20\x10\x32"
            "\x05\x21\x10\x32\x05\x22\x0f\x31\x06\x22\x10\x30\x05"
            "\x23\x10\x30\x05\x24\x0f\x2f\x06\x24\x10\x17\x00\xff"
            "\x01\x17\x05\x25\x10\x17\x00\x16\x06\x26\x10\x16\x00"
            "\xff\x01\x16\x05\x27\x10\x16\x00\x15\x06\x28\x10\x15"
            "\x00\xff\x01\x15\x05\x29\x10\x15\x00\x15\x05\x2a\x0f"
            "\x15\x00\xff\x01\x14\x05\x2b\x10\x14\x00\x14\x05\x2c"
            "\x0f\x27\x06\x2c\x10\x26\x05\x2d\x10\x26\x05\x2e\x0f"
            "\x25\x06\x2e\x10\x24\x05\x2f\x10\x24\x05\x30\x0f\x23"
            "\x06\x30\x10\x22\x05\x31\x10\x22\x05\x32\x0f\x11\x00"
            "\xff\x01\x10\x06\x32\x10\x10\x00\x0f\x07\x33\x0f\x1f"
            "\x07\x33\x10\x0f\x00\xff\x01\x0e\x08\x33\x10\x0f\x00"
            "\x0d\x0a\x32\x11\x1a\x0c\x31\x11\x18\x0f\x2f\x13\x15"
            "\x13\x2b\x16\x11\x19\x25\x1c\x09\xff\x04\x22\x19\x2d" }  },
      /* --- pixel bitmap for cmr1200 char#4 \Xi --- */
      {   4,22423,                      /* character number, location */
        112, 7,    0, 7,      /* topleft row,col, and botleft row,col */
          { 96,  112, 2,87, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x0b\x02\x5c\x02\x00\x02\x07\x4e\x07\x03\x06\x52"
            "\x06\x01\x00\xff\x03\x01\x05\x54\x05\x01\x00\xff\x07"
            "\x01\x04\x56\x04\x01\x00\xff\x0d\x60\x00\xff\x07\x10"
            "\x04\x38\x04\x10\x00\xff\x0b\x10\x40\x10\x00\xff\x07"
            "\x10\x04\x38\x04\x10\x00\xff\x0f\x60\xff\x08\x04\x58"
            "\x04\x00\xff\x04\x05\x56\x05\x01\x05\x54\x05\x02\x08"
            "\x4e\x08\x01\x00\xff\x0b\x01\x5e\x01" }  },
      /* --- pixel bitmap for cmr1200 char#5 \Pi --- */
      {   5,22756,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 114,  113, 2,44, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x04\x00\x72\x0c\x14\x32\x14\x1b\x11\x32\x11\x1f"
            "\x10\x32\x10\x10\x00\xff\x60\x11\x0f\x32\x0f\x11\x00"
            "\x10\x11\x30\x11\x1f\x13\x2e\x13\x1b\x19\x28\x19\x0c"
            "\xff\x04\x31\x10\x31" }  },
      /* --- pixel bitmap for cmr1200 char#6 \Sigma --- */
      {   6,23210,                      /* character number, location */
        113, 9,    0, 9,      /* topleft row,col, and botleft row,col */
          { 101,  113, 2,353, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x01\x5f\x05\xff\x02\x60\x05\x61\x05\x13\x30\x1d\x06"
            "\x12\x37\x16\x06\x13\x3a\x12\x07\x13\x3c\x0f\x08\x12"
            "\x3e\x0d\x08\x13\x3e\x0c\x09\x13\x3f\x0b\x09\x13\x3f"
            "\x0a\x0a\x12\x40\x09\x0a\x13\x3f\x09\x0b\x13\x3f\x08"
            "\x0c\x12\x40\x07\x0c\x13\x3f\x07\x0d\x13\x3f\x06\x0e"
            "\x12\x3f\x07\x0d\x13\x3f\x06\x0e\x13\x3e\x06\x0f\x12"
            "\x3f\x05\x0f\x13\x3e\x05\x10\x13\x3d\x05\x11\x12\x3e"
            "\x04\x11\x13\x3d\x05\x11\x13\x3c\x05\x12\x12\x3d\x04"
            "\x12\x13\x3c\x04\x13\x13\x3b\x04\x14\x13\x3a\x04\x15"
            "\x12\x3a\x04\x15\x13\x39\x05\x15\x13\x39\x04\x16\x12"
            "\x39\x04\x16\x13\x38\x04\x17\x13\x53\x12\x53\x13\x53"
            "\x13\x53\x12\x53\x13\x53\x13\x53\x12\x53\x13\x53\x13"
            "\x53\x12\x53\x13\x53\x13\x53\x13\x53\x12\x53\x13\x53"
            "\x13\x53\x12\x53\x13\x53\x12\x54\x11\x54\x10\x56\x0e"
            "\x58\x0c\x59\x0b\x5b\x09\x5d\x08\x5d\x07\x5d\x07\x5d"
            "\x07\x5d\x07\x5d\x07\x5d\x07\x5d\x07\x5d\x07\x5d\x08"
            "\x5d\x07\x5d\x07\x3a\x04\x1f\x07\x3b\x04\x1e\x07\x3c"
            "\x04\x1d\x07\x3c\x05\x1c\x07\x3d\x04\x1c\x07\x3e\x04"
            "\x1b\x07\x3f\x04\x1a\x08\x3f\x04\x1a\x07\x40\x04\x19"
            "\x07\x40\x05\x18\x07\x41\x05\x17\x07\x42\x05\x16\x07"
            "\x42\x05\x16\x07\x43\x05\x15\x07\x44\x05\x14\x07\x44"
            "\x06\x13\x08\x44\x06\x12\x08\x44\x07\x12\x07\x45\x07"
            "\x11\x07\x45\x07\x11\x07\x46\x07\x10\x07\x46\x08\x0f"
            "\x07\x46\x09\x0e\x07\x46\x0a\x0d\x07\x47\x0a\x0c\x07"
            "\x46\x0c\x0b\x08\x45\x0d\x0b\x07\x45\x0d\x0b\x07\x44"
            "\x0f\x0a\x07\x42\x12\x09\x07\x3f\x16\x08\x07\x38\x1e"
            "\x07\x5e\x06\x5f\x05\x60\x04\xff\x02\x60\x05\x00\x01"
            "\x5f\x05" }  },
      /* --- pixel bitmap for cmr1200 char#7 \Upsilon --- */
      {   7,23607,                      /* character number, location */
        117, 9,    0, 9,      /* topleft row,col, and botleft row,col */
          { 110,  117, 2,253, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x11\x0a\x38\x0a\x1f\x11\x30\x11\x1a\x15\x2c\x15\x17"
            "\x18\x28\x18\x14\x1c\x24\x1c\x11\x1e\x22\x1e\x0f\x20"
            "\x20\x20\x0d\x23\x1d\x22\x0c\x24\x1b\x23\x0b\x25\x1a"
            "\x25\x09\x27\x18\x27\x08\x28\x16\x28\x07\x2a\x15\x29"
            "\x06\x0d\x0b\x13\x13\x12\x0b\x0d\x05\x0b\x11\x10\x12"
            "\x10\x11\x0b\x04\x0a\x14\x0f\x11\x0e\x14\x0a\x04\x08"
            "\x17\x0e\x10\x0e\x17\x08\x03\x08\x1a\x0d\x0f\x0d\x19"
            "\x08\x02\x07\x1c\x0d\x0d\x0c\x1c\x07\x02\x06\x1e\x0c"
            "\x0d\x0c\x1d\x06\x02\x06\x1f\x0c\x0b\x0c\x1e\x06\x01"
            "\x06\x20\x0c\x0b\x0b\x20\x0c\x21\x0b\x0a\x0b\x21\x0b"
            "\x23\x0b\x09\x0b\x22\x0a\x23\x0b\x08\x0b\x23\x0a\x24"
            "\x0b\x07\x0a\x24\x0a\x25\x0a\x07\x0a\x24\x0a\x25\x0a"
            "\x06\x0b\x24\x05\x01\x03\x26\x0b\x05\x0a\x26\x03\x2c"
            "\x0a\x05\x0a\x55\x0a\x05\x09\x57\x09\x04\x0a\x57\x0a"
            "\x03\x0a\x57\x0a\x03\x09\x59\x09\x03\x09\x59\x09\x02"
            "\x0a\x59\x0a\x01\x0a\x59\x0a\x01\x09\x2d\x00\xff\x01"
            "\x2e\x09\x01\x09\x2d\x00\x2e\x13\x5b\x12\x2e\x00\xff"
            "\x06\x2f\x11\x2e\x00\x2f\x10\x2f\x00\xff\x39\x30\x0f"
            "\x2f\x00\xff\x01\x2f\x11\x2e\x00\x2e\x13\x57\x1b\x29"
            "\x00\xff\x04\x1b\x39\x1a" }  },
      /* --- pixel bitmap for cmr1200 char#8 \Phi --- */
      {   8,23992,                      /* character number, location */
        113, 9,    0, 9,      /* topleft row,col, and botleft row,col */
          { 101,  113, 2,365, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x04\x17\x38\x16\x00\x26\x1a\x4f\x12\x29\x00\xff"
            "\x01\x2b\x10\x2a\x00\xff\x0c\x2c\x0e\x2b\x00\x2a\x11"
            "\x4d\x1f\x42\x27\x3b\x2d\x35\x12\x01\x20\x30\x0f\x06"
            "\x0e\x05\x0f\x2c\x0e\x09\x0e\x08\x0e\x28\x0d\x0c\x0e"
            "\x0b\x0d\x24\x0d\x0e\x0e\x0d\x0d\x21\x0d\x0f\x0e\x0e"
            "\x0d\x1e\x0d\x11\x0e\x10\x0d\x1b\x0d\x12\x0e\x11\x0d"
            "\x19\x0d\x13\x0e\x12\x0d\x16\x0e\x14\x0e\x13\x0e\x13"
            "\x0e\x15\x0e\x14\x0e\x11\x0e\x16\x0e\x15\x0e\x08\x00"
            "\xff\x01\x07\x0e\x17\x0e\x16\x0e\x07\x00\x06\x0e\x18"
            "\x0e\x17\x0e\x0b\x0f\x18\x0e\x17\x0f\x05\x00\xff\x01"
            "\x04\x0f\x19\x0e\x18\x0f\x04\x00\x03\x10\x19\x0e\x18"
            "\x10\x06\x0f\x1a\x0e\x19\x0f\x03\x00\xff\x01\x02\x10"
            "\x1a\x0e\x19\x10\x02\x00\x01\x11\x1a\x0e\x19\x11\x01"
            "\x00\xff\x02\x01\x10\x1b\x0e\x1a\x10\x01\xff\x08\x11"
            "\x1b\x0e\x1a\x11\xff\x02\x01\x10\x1b\x0e\x1a\x10\x01"
            "\x00\x01\x11\x1a\x0e\x19\x11\x01\x00\xff\x01\x02\x10"
            "\x1a\x0e\x19\x10\x02\x00\x03\x0f\x1a\x0e\x19\x0f\x06"
            "\x10\x19\x0e\x18\x10\x03\x00\xff\x01\x04\x0f\x19\x0e"
            "\x18\x0f\x04\x00\x05\x0f\x18\x0e\x17\x0f\x0b\x0e\x18"
            "\x0e\x17\x0e\x06\x00\xff\x01\x07\x0e\x17\x0e\x16\x0e"
            "\x07\x00\x08\x0e\x16\x0e\x15\x0e\x11\x0e\x15\x0e\x14"
            "\x0e\x13\x0e\x14\x0e\x13\x0e\x16\x0d\x13\x0e\x12\x0d"
            "\x19\x0d\x12\x0e\x11\x0d\x1b\x0d\x11\x0e\x10\x0d\x1e"
            "\x0d\x0f\x0e\x0e\x0d\x21\x0d\x0e\x0e\x0d\x0d\x24\x0d"
            "\x0c\x0e\x0b\x0d\x28\x0e\x09\x0e\x08\x0e\x2c\x0f\x06"
            "\x0e\x05\x0f\x30\x12\x01\x20\x35\x2d\x3b\x27\x42\x1f"
            "\x4d\x11\x2a\x00\xff\x0c\x2c\x0e\x2b\x00\xff\x01\x2b"
            "\x10\x2a\x00\x2a\x12\x4f\x1a\x25\x00\xff\x04\x17\x38"
            "\x16" }  },
      /* --- pixel bitmap for cmr1200 char#9 \Psi --- */
      {   9,24465,                      /* character number, location */
        113, 9,    0, 9,      /* topleft row,col, and botleft row,col */
          { 110,  113, 2,301, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x04\x1b\x38\x1b\x00\x2a\x1a\x58\x12\x2e\x00\xff"
            "\x01\x2f\x10\x2f\x00\xff\x0b\x30\x0e\x30\x00\x01\x0f"
            "\x20\x0e\x20\x0f\x01\x11\x1f\x0e\x1f\x24\x1d\x0e\x1d"
            "\x13\x01\x13\x1c\x0e\x1c\x13\x06\x10\x1b\x0e\x1b\x10"
            "\x0b\x10\x1a\x0e\x1a\x10\x0d\x0f\x1a\x0e\x1a\x0f\x07"
            "\x00\xff\x01\x08\x0f\x19\x0e\x19\x0f\x08\x00\x09\x0e"
            "\x19\x0e\x19\x0e\x09\x00\xff\x01\x09\x0f\x18\x0e\x18"
            "\x0f\x09\x00\xff\x02\x0a\x0e\x18\x0e\x18\x0e\x0a\x00"
            "\xff\x01\x0a\x0f\x17\x0e\x17\x0f\x0a\x00\xff\x0f\x0b"
            "\x0e\x17\x0e\x17\x0e\x0b\x00\xff\x05\x0c\x0e\x16\x0e"
            "\x16\x0e\x0c\x00\xff\x03\x0d\x0e\x15\x0e\x15\x0e\x0d"
            "\x00\xff\x02\x0e\x0e\x14\x0e\x14\x0e\x0e\x00\xff\x01"
            "\x0f\x0e\x13\x0e\x13\x0e\x0f\x00\x10\x0d\x13\x0e\x13"
            "\x0d\x20\x0e\x12\x0e\x12\x0e\x21\x0d\x12\x0e\x12\x0d"
            "\x22\x0e\x11\x0e\x11\x0e\x23\x0d\x11\x0e\x11\x0d\x25"
            "\x0d\x10\x0e\x10\x0d\x26\x0e\x0f\x0e\x0f\x0e\x27\x0d"
            "\x0f\x0e\x0f\x0d\x29\x0d\x0e\x0e\x0e\x0d\x2b\x0d\x0d"
            "\x0e\x0d\x0d\x2d\x0d\x0c\x0e\x0c\x0d\x2f\x0d\x0b\x0e"
            "\x0b\x0d\x31\x0d\x0a\x0e\x0a\x0d\x34\x0c\x09\x0e\x09"
            "\x0c\x37\x0d\x07\x0e\x07\x0d\x3a\x0d\x05\x0e\x05\x0d"
            "\x3d\x0f\x02\x0e\x02\x0f\x40\x2c\x44\x28\x49\x22\x50"
            "\x1a\x59\x10\x2f\x00\xff\x0c\x30\x0e\x30\x00\xff\x01"
            "\x2f\x10\x2f\x00\x2e\x12\x58\x1a\x2a\x00\xff\x04\x1b"
            "\x38\x1b" }  },
      /* --- pixel bitmap for cmr1200 char#10 \Omega --- */
      {  10,24958,                      /* character number, location */
        117, 7,    0, 7,      /* topleft row,col, and botleft row,col */
          { 105,  117, 2,457, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x2c\x11\x53\x1b\x4a\x23\x43\x29\x3d\x12\x0b\x12\x38"
            "\x10\x13\x10\x34\x0f\x19\x0f\x31\x0e\x1d\x0e\x2e\x0e"
            "\x21\x0e\x2a\x0e\x25\x0e\x27\x0e\x27\x0e\x25\x0e\x29"
            "\x0e\x22\x0f\x2b\x0f\x1f\x0f\x2d\x0f\x1d\x0f\x2f\x0f"
            "\x1b\x0f\x31\x0f\x19\x0f\x33\x0f\x17\x0f\x35\x0f\x15"
            "\x10\x35\x10\x14\x0f\x37\x0f\x13\x0f\x39\x0f\x11\x10"
            "\x39\x10\x08\x00\xff\x01\x07\x10\x3b\x10\x07\x00\xff"
            "\x01\x06\x10\x3d\x10\x06\x00\x05\x11\x3d\x11\x0a\x10"
            "\x3f\x10\x05\x00\xff\x01\x04\x11\x3f\x11\x04\x00\x04"
            "\x10\x41\x10\x04\x00\xff\x03\x03\x11\x41\x11\x03\x00"
            "\xff\x0c\x02\x11\x43\x11\x02\x00\x02\x12\x41\x12\x02"
            "\x00\xff\x03\x03\x11\x41\x11\x03\x00\x04\x10\x41\x10"
            "\x04\x00\xff\x02\x04\x11\x3f\x11\x04\x00\xff\x01\x05"
            "\x10\x3f\x10\x05\x00\xff\x01\x06\x10\x3d\x10\x06\x00"
            "\x07\x0f\x3d\x0f\x07\x00\xff\x01\x07\x10\x3b\x10\x07"
            "\x00\x08\x0f\x3b\x0f\x11\x0e\x3b\x0e\x12\x0f\x39\x0f"
            "\x09\x00\xff\x01\x0a\x0e\x39\x0e\x0a\x00\xff\x01\x0b"
            "\x0e\x37\x0e\x0b\x00\x0c\x0d\x37\x0d\x0c\x00\xff\x01"
            "\x0d\x0d\x35\x0d\x0d\x00\x0e\x0c\x35\x0c\x0e\x00\xff"
            "\x01\x0f\x0c\x33\x0c\x0f\x00\xff\x01\x10\x0c\x31\x0c"
            "\x10\x00\x11\x0b\x31\x0b\x11\x00\xff\x01\x12\x0b\x2f"
            "\x0b\x12\x00\x13\x0a\x2f\x0a\x13\x00\xff\x01\x14\x0a"
            "\x2d\x0a\x14\x00\x15\x09\x2d\x09\x15\x00\xff\x01\x16"
            "\x09\x2b\x09\x16\x00\x17\x08\x2b\x08\x2e\x09\x29\x09"
            "\x17\x04\x14\x08\x29\x08\x14\x08\x15\x07\x29\x07\x15"
            "\x08\x15\x08\x27\x08\x15\x04\xff\x01\x01\x04\x15\x07"
            "\x27\x07\x15\x04\x01\x00\x01\x04\x16\x06\x27\x06\x16"
            "\x04\x02\x04\x16\x07\x25\x07\x16\x04\x02\x04\x17\x06"
            "\x25\x06\x17\x04\x01\x00\xff\x01\x02\x04\x16\x06\x25"
            "\x06\x16\x04\x02\x00\xff\x01\x02\x04\x17\x06\x23\x06"
            "\x17\x04\x02\x00\x02\x05\x17\x05\x23\x05\x17\x05\x05"
            "\x04\x17\x05\x23\x05\x17\x04\x06\x05\x16\x05\x23\x05"
            "\x16\x05\x06\x08\x14\x04\x23\x04\x14\x08\x03\x00\xff"
            "\x02\x03\x21\x21\x21\x03\x00\xff\x04\x04\x20\x21\x20"
            "\x04\x00\xff\x01\x05\x1f\x21\x1f\x05\x00\x05\x1e\x23"
            "\x1e\x05" }  },
      /* --- pixel bitmap for cmr1200 char#11 \ff --- */
      {  11,41715,                      /* character number, location */
        117, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 100,  117, 2,165, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x2a\x0e\x18\x0a\x2f\x17\x11\x10\x29\x1c\x0c\x15\x24"
            "\x21\x08\x18\x21\x0f\x0a\x0b\x06\x0b\x07\x08\x1e\x0d"
            "\x12\x08\x03\x0b\x09\x09\x1b\x0d\x17\x06\x01\x0b\x09"
            "\x0b\x19\x0c\x18\x11\x0a\x0c\x18\x0b\x18\x13\x0a\x0d"
            "\x15\x0c\x18\x13\x0a\x0e\x14\x0c\x19\x12\x0b\x0e\x13"
            "\x0c\x19\x13\x0b\x0e\x12\x0c\x1a\x12\x0c\x0e\x12\x0b"
            "\x1b\x12\x0c\x0e\x11\x0c\x1b\x11\x0d\x0e\x10\x0c\x1c"
            "\x11\x0e\x0c\x10\x0c\x1d\x10\x10\x0a\x11\x0c\x1e\x0f"
            "\x11\x08\x11\x0d\x1f\x0e\x13\x04\x13\x0c\x21\x0d\x2a"
            "\x0c\x22\x0b\x2a\x0d\x21\x0c\x1d\x00\xff\x17\x0d\x0c"
            "\x22\x0c\x1d\xff\x04\x59\x0b\x00\xff\x39\x0d\x0c\x22"
            "\x0c\x1d\x00\x0c\x0e\x20\x0e\x28\x0e\x20\x0f\x24\x14"
            "\x1a\x15\x18\xff\x04\x26\x08\x29\x0d" }  },
      /* --- pixel bitmap for cmr1200 char#12 \fi --- */
      {  12,42221,                      /* character number, location */
        117, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 83,  117, 2,148, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x2a\x0d\x41\x15\x3a\x1b\x36\x1f\x32\x0f\x09\x0a\x2f"
            "\x0d\x10\x08\x2c\x0d\x15\x06\x2a\x0c\x18\x06\x27\x0c"
            "\x1c\x05\x25\x0c\x1b\x08\x23\x0c\x1a\x0a\x22\x0c\x1a"
            "\x0c\x20\x0c\x1a\x0d\x20\x0b\x1a\x0e\x1f\x0b\x1b\x0e"
            "\x1e\x0c\x1b\x0e\x1d\x0c\x1b\x10\x1c\x0c\x1c\x0e\x0e"
            "\x00\xff\x02\x0e\x0c\x1d\x0e\x0e\x00\x0d\x0d\x1e\x0c"
            "\x1c\x0c\x20\x0a\x1d\x0c\x22\x06\x12\x00\xff\x13\x0d"
            "\x0c\x3a\x00\x0d\x0c\x21\x0c\x1a\x0c\x14\x19\x0d\xff"
            "\x04\x46\x0d\x00\x0d\x0c\x1e\x0f\x1a\x0c\x1f\x0e\x1a"
            "\x0c\x20\x0d\x0d\x00\xff\x36\x0d\x0c\x21\x0c\x0d\x00"
            "\xff\x01\x0c\x0e\x1f\x0e\x0c\x00\x09\x14\x19\x14\x09"
            "\xff\x04\x26\x07\x26" }  },
      /* --- pixel bitmap for cmr1200 char#13 \fl --- */
      {  13,42643,                      /* character number, location */
        117, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 83,  117, 2,120, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x2a\x0e\x40\x17\x38\x1e\x04\x03\x2c\x27\x2a\x0f\x0b"
            "\x0f\x28\x0d\x12\x0c\x26\x0d\x13\x0d\x25\x0c\x14\x0e"
            "\x23\x0c\x16\x0e\x22\x0c\x16\x0f\x21\x0c\x17\x0f\x20"
            "\x0c\x18\x0f\x1f\x0c\x19\x0f\x1e\x0c\x1a\x0f\x1e\x0b"
            "\x1c\x0e\x1d\x0c\x1c\x0e\x1c\x0c\x1e\x0d\x1c\x0c\x1f"
            "\x0c\x0d\x00\xff\x02\x0e\x0c\x20\x0c\x0d\x00\x0d\x0d"
            "\x20\x0c\x0d\x00\xff\x17\x0d\x0c\x21\x0c\x0d\xff\x04"
            "\x46\x0d\x00\xff\x39\x0d\x0c\x21\x0c\x0d\x00\xff\x01"
            "\x0c\x0e\x1f\x0e\x0c\x00\x09\x14\x19\x14\x09\xff\x04"
            "\x26\x07\x26" }  },
      /* --- pixel bitmap for cmr1200 char#14 \ffi --- */
      {  14,43107,                      /* character number, location */
        117, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 129,  117, 2,226, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x2a\x0d\x21\x0d\x41\x15\x19\x15\x3b\x1b\x12\x1b\x36"
            "\x1f\x0f\x1f\x32\x0f\x09\x0b\x0b\x0f\x09\x0a\x2f\x0d"
            "\x11\x08\x08\x0d\x10\x08\x2c\x0d\x15\x07\x05\x0d\x15"
            "\x06\x2a\x0c\x19\x06\x03\x0c\x18\x06\x28\x0b\x1c\x12"
            "\x1c\x05\x25\x0c\x1b\x13\x1b\x08\x23\x0c\x1a\x14\x1a"
            "\x0a\x22\x0c\x1a\x14\x1a\x0c\x20\x0c\x1a\x14\x1a\x0d"
            "\x20\x0b\x1b\x13\x1a\x0e\x1f\x0c\x1a\x13\x1b\x0e\x1e"
            "\x0c\x1b\x13\x1b\x0e\x1d\x0c\x1c\x12\x1b\x10\x1c\x0c"
            "\x1c\x12\x1c\x0e\x1c\x0d\x1c\x11\x1d\x0e\x1c\x0c\x1d"
            "\x11\x1d\x0e\x1c\x0c\x1e\x10\x1d\x0e\x1b\x0d\x1f\x0f"
            "\x1e\x0c\x1c\x0c\x21\x0d\x20\x0a\x1d\x0c\x22\x0c\x22"
            "\x06\x12\x00\xff\x13\x0d\x0c\x22\x0c\x3a\x00\x0d\x0c"
            "\x22\x0c\x21\x0c\x1a\x0c\x22\x0c\x14\x19\x0d\xff\x04"
            "\x74\x0d\x00\x0d\x0c\x22\x0c\x1e\x0f\x1a\x0c\x22\x0c"
            "\x1f\x0e\x1a\x0c\x22\x0c\x20\x0d\x0d\x00\xff\x36\x0d"
            "\x0c\x22\x0c\x21\x0c\x0d\x00\xff\x01\x0c\x0e\x20\x0e"
            "\x1f\x0e\x0c\x00\x09\x14\x1a\x14\x19\x14\x09\xff\x04"
            "\x26\x08\x26\x07\x26" }  },
      /* --- pixel bitmap for cmr1200 char#15 \ffl --- */
      {  15,43761,                      /* character number, location */
        117, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 129,  117, 2,184, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x2a\x0e\x20\x0e\x40\x17\x17\x17\x39\x1c\x11\x1e\x04"
            "\x03\x2c\x21\x0d\x27\x2a\x0f\x0a\x0b\x0a\x0f\x0b\x0f"
            "\x28\x0d\x12\x08\x07\x0d\x12\x0c\x26\x0d\x17\x06\x04"
            "\x0d\x13\x0d\x25\x0c\x18\x08\x02\x0c\x14\x0e\x24\x0b"
            "\x19\x15\x16\x0e\x22\x0c\x19\x15\x16\x0f\x21\x0c\x19"
            "\x15\x17\x0f\x20\x0c\x19\x15\x18\x0f\x1f\x0c\x1a\x14"
            "\x19\x0f\x1f\x0b\x1b\x13\x1a\x0f\x1e\x0c\x1b\x12\x1c"
            "\x0e\x1d\x0c\x1c\x12\x1c\x0e\x1c\x0c\x1d\x11\x1e\x0d"
            "\x1c\x0c\x1e\x10\x1f\x0c\x1b\x0d\x1f\x0e\x20\x0c\x1b"
            "\x0c\x21\x0d\x20\x0c\x1b\x0c\x22\x0c\x20\x0c\x1a\x0d"
            "\x21\x0d\x20\x0c\x0d\x00\xff\x17\x0d\x0c\x22\x0c\x21"
            "\x0c\x0d\xff\x04\x74\x0d\x00\xff\x39\x0d\x0c\x22\x0c"
            "\x21\x0c\x0d\x00\xff\x01\x0c\x0e\x20\x0e\x1f\x0e\x0c"
            "\x00\x09\x14\x1a\x14\x19\x14\x09\xff\x04\x26\x08\x26"
            "\x07\x26" }  },
      /* --- pixel bitmap for cmr1200 char#16 \imath --- */
      {  16,30954,                      /* character number, location */
         73, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 36,   73, 3,78, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xe0\x56\xe0\x4e\x04\xb0\xf4\x1e\x0a\xb0\x9e\x02\xe0"
            "\x8e\xb0\xf1\xcd\xb0\xfe\xdc\xb0\xfe\xdc\xb0\xfe\xdc"
            "\xb0\xf8\xdc\xb0\xf1\xce\xa0\x9e\x05\x8f\x4e\x0e\x08" }  },
      /* --- pixel bitmap for cmr1200 char#17 \jmath --- */
      {  17,31107,                      /* character number, location */
         73,-7,  -34,-7,      /* topleft row,col, and botleft row,col */
          { 42,  107, 3,185, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x86\xe0\x9e\x05\xf4\xe0\x2e\x0c\xe0\xbe\x03"
            "\xe0\xee\xf1\xe0\xe0\x1d\xfe\xe0\xe0\x2c\xfe\xe0\xe0"
            "\x2c\xfe\xe0\xe0\x2c\xfe\xe0\xe0\x2c\xfe\xe0\xe0\x2c"
            "\x55\xe0\x6c\x39\xe0\x4c\x2b\xe0\x2c\x2d\xe0\x1c\x1e"
            "\x01\xec\x1f\x1e\x01\xeb\x2e\x01\xdc\x2f\x1e\x01\xdb"
            "\x3e\x01\xcb\x4e\xda\x6d\xca\x7b\xea\x89\xea\xa8\xd9"
            "\xda\x8a\xe0\x2e\x0b\xe0\x4e\x08\xe0\x9e\x03\xe0\xeb"
            "\xe0\x40" }  },
      /* --- pixel bitmap for cmr1200 char#18 \gravesym --- */
      {  18,40739,                      /* character number, location */
        116,17,   85,17,      /* topleft row,col, and botleft row,col */
          { 31,   31, 2,67, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x05\x03\x1a\x07\x17\x09\x15\x0b\x14\x0c\x12\x0d\x12"
            "\x0e\x11\x0f\x10\x00\xff\x01\x01\x0f\x0f\x00\x02\x0f"
            "\x11\x0f\x11\x0f\x12\x0d\x13\x0d\x13\x0d\x13\x0d\x14"
            "\x0b\x15\x0b\x15\x0b\x15\x0b\x16\x09\x17\x09\x17\x09"
            "\x17\x09\x17\x08\x19\x07\x19\x07\x19\x07\x19\x06\x1b"
            "\x02\x02" }  },
      /* --- pixel bitmap for cmr1200 char#19 \acutesym --- */
      {  19,40808,                      /* character number, location */
        116,34,   85,34,      /* topleft row,col, and botleft row,col */
          { 31,   31, 2,65, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x17\x03\x1a\x07\x17\x09\x15\x0b\x13\x0c\x13\x0d\x11"
            "\x0e\x10\x0f\xff\x01\x0f\x0f\x01\x00\x0e\x0f\x0f\x0f"
            "\x0f\x0f\x10\x0d\x11\x0d\x11\x0d\x11\x0d\x12\x0b\x13"
            "\x0b\x13\x0b\x13\x0b\x14\x09\x15\x09\x15\x09\x15\x09"
            "\x16\x08\x16\x07\x17\x07\x17\x07\x18\x06\x1b\x02\x1b" }  },
      /* --- pixel bitmap for cmr1200 char#20 \checksym --- */
      {  20,40877,                      /* character number, location */
        105,20,   86,20,      /* topleft row,col, and botleft row,col */
          { 42,   19, 3,113, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x13\xe0\xe0\x63\x25\xe0\xe0\x25\x17\xe0\xe7\x18\xe0"
            "\xa8\x39\xe0\x69\x59\xe0\x49\x89\xe9\xba\xaa\xda\x8a"
            "\xe0\x1b\x4b\xe0\x4e\x08\xe0\x7e\x06\xe0\x9e\x04\xe0"
            "\xbe\x02\xe0\xec\xe0\xe0\x3a\xe0\xe0\x58\xe0\xe0\x76"
            "\xe0\xe0\x94\xe0\x50" }  },
      /* --- pixel bitmap for cmr1200 char#21 \brevesym --- */
      {  21,40942,                      /* character number, location */
        115,16,   86,16,      /* topleft row,col, and botleft row,col */
          { 50,   29, 3,173, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf4\x04\xe0\xe0\xe4\x05\xe0\xe0\xc5\xf1\x14\xe0\xe0"
            "\xc4\x10\xf1\x15\xe0\xe0\xa5\x10\xf1\x25\xe0\xe0\x85"
            "\x20\x26\xe0\xe0\x66\x55\xe0\xe0\x65\x66\xe0\xe0\x46"
            "\x76\xe0\xe0\x26\x87\xe0\xe7\x97\xe0\xc7\xb8\xe0\x88"
            "\xc9\xe0\x69\xda\xe0\x2a\xe0\x1d\x8d\xe0\x3e\x0e\x04"
            "\xe0\x5e\x0e\x02\xe0\x7e\x0e\xe0\xae\x0a\xe0\xee\x06"
            "\xe0\xe0\x4e\x02\xe0\xe0\x9a\xe0\x60" }  },
      /* --- pixel bitmap for cmr1200 char#22 (noname) --- */
      {  22,41051,                      /* character number, location */
         98,11,   92,11,      /* topleft row,col, and botleft row,col */
          { 60,    6, 2, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x05\x00\x3c" }  },
      /* --- pixel bitmap for cmr1200 char#23 (noname) --- */
      {  23,41070,                      /* character number, location */
        119,46,   90,46,      /* topleft row,col, and botleft row,col */
          { 32,   29, 3,101, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc8\xe0\x7e\xe0\x2e\x04\xde\x06\xa7\xa7\x76\xe6\x64"
            "\xe0\x44\x54\xe0\x64\x20\xf2\x14\xe0\x84\x1f\x64\xe0"
            "\xa4\xf2\x14\xe0\x84\x10\x24\xe0\x64\x54\xe0\x44\x66"
            "\xe6\x77\xa7\xae\x06\xde\x04\xe0\x2e\xe0\x78\xc0" }  },
      /* --- pixel bitmap for cmr1200 char#24 (noname) --- */
      {  24,41177,                      /* character number, location */
         -4,21,  -34,21,      /* topleft row,col, and botleft row,col */
          { 40,   30, 3,115, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xf4\xec\xe0\xee\xe0\xce\x03\xe0\x9e\x06\xe0\xbe\x02"
            "\xe0\xde\x01\xe0\xdd\xe0\xed\xe0\xed\x10\xf1\xe0\xdc"
            "\x10\xf3\xe0\xec\xf1\xe0\xdc\x10\xe0\xcd\xe0\xcd\xe0"
            "\xbe\xe0\x9e\x02\xe0\x5e\x06\x5e\x0e\x05\x7e\x0e\x02"
            "\xae\x0c\xee\x05\xe0\x7a" }  },
      /* --- pixel bitmap for cmr1200 char#25 \ss --- */
      {  25,31362,                      /* character number, location */
        117, 4,   -2, 4,      /* topleft row,col, and botleft row,col */
          { 73,  119, 3,769, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x7c\xe0\xe0\xe0\xe0\x1e\x06\xe0\xe0\xe0\x8e"
            "\x0c\xe0\xe0\xe0\x3e\x0e\x02\xe0\xe0\xdd\x7d\xe0\xe0"
            "\xbc\xcc\xe0\xe0\x8b\xe0\x2b\xe0\xe0\x6a\xe0\x5b\xe0"
            "\xe0\x4a\xe0\x7b\xe0\xe0\x2a\xe0\x9b\xe0\xeb\xe0\xab"
            "\xe0\xcb\xe0\xbc\x80\xf1\xe0\x2b\xe0\xdc\x70\xe0\x1c"
            "\xe0\xec\xe0\x7b\xe0\xe0\x1c\x60\xf1\xec\xe0\xe0\x1d"
            "\x50\xec\xe0\xe0\x2c\x50\xf9\xdc\xe0\xe0\x3d\x40\xf2"
            "\xdc\xe0\xe0\x2d\x50\xdc\xe0\xe0\x2c\xe0\x5c\xe0\xe0"
            "\x1d\xe0\x5c\xe0\xe0\x1c\xe0\x6c\xe0\xed\xe0\x6c\xe0"
            "\xec\xe0\x7c\xe0\xdc\xe0\x8c\xe0\xdb\xe0\x9c\xe0\xcb"
            "\xe0\xac\xe0\xbb\xe0\xbc\xe0\xab\xe0\xcc\xe0\x8c\xe0"
            "\xdc\xe0\x6d\xe0\xec\xe0\x4d\xe0\xe0\x2c\xe0\x1e\x01"
            "\xe0\x4e\x0b\xae\x04\xe0\x6e\x0b\x9e\x02\xe0\x9e\x0b"
            "\x9e\xe0\xbe\x0b\x9e\x02\xe0\x9e\x0b\xed\xe0\xe0\x6c"
            "\xe0\x3c\xe0\xe0\x4c\xe0\x5b\xe0\xe0\x3c\xe0\x7b\xe0"
            "\xe0\x1c\xe0\x8b\xe0\xec\xe0\xaa\xe0\xdc\xe0\xba\xe0"
            "\xcc\xe0\xca\xe0\xbc\xe0\xcb\xe0\xac\xe0\xdb\xa0\xf1"
            "\xdc\xe0\xeb\x90\xdc\xe0\xe0\x1b\x80\xf1\xdc\xe0\xe0"
            "\x2b\x70\xdc\xe0\xe0\x3b\x60\xf1\xdc\xe0\xe0\x3c\x50"
            "\xf1\xdc\xe0\xe0\x4c\x40\xf2\xdc\xe0\xe0\x5c\x30\xdc"
            "\xe0\xe0\x5d\x20\xf1\xdc\xe0\xe0\x6c\x20\xf3\xdc\xe0"
            "\xe0\x6d\x10\xdc\xe0\xe0\x7c\x10\xfd\xdc\xe0\xe0\x7d"
            "\xf1\xdc\xe0\xe0\x7c\x10\xf1\xdc\xe0\xe0\x6d\x10\xdc"
            "\xe0\xe0\x6c\xe0\x1c\xa4\xe0\x6c\xe0\x1c\x88\xe0\x3c"
            "\xe0\x2c\x7a\xe0\x2c\xe0\x2c\x6b\xe0\x2c\xe0\x2c\x6c"
            "\xec\x40\xf1\xdc\x6c\xeb\x50\xdc\x6c\xdb\xe0\x5c\x6b"
            "\xdb\xe0\x5d\x6b\xda\xe0\x6d\x79\xda\xe0\x4e\x02\x78"
            "\xda\xae\x0b\x85\xea\xbe\x0b\x96\xab\xce\x0b\xa7\x6c"
            "\xde\x0b\xbe\x08\xe0\x1e\x0b\xce\x05\xe0\xe0\xe0\xde"
            "\x02\xe0\xe0\xe0\xe0\x4a\xe0\x8d" }  },
      /* --- pixel bitmap for cmr1200 char#26 \ae --- */
      {  26,31863,                      /* character number, location */
         74, 7,   -2, 7,      /* topleft row,col, and botleft row,col */
          { 107,   76, 2,391, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x17\x0d\x26\x0b\x28\x16\x1e\x13\x22\x1b\x19\x17\x1d"
            "\x20\x15\x1b\x1a\x0c\x09\x0e\x11\x0c\x07\x0c\x17\x08"
            "\x11\x0d\x0e\x0a\x0d\x0a\x14\x08\x15\x0c\x0b\x0a\x10"
            "\x0b\x11\x07\x19\x0b\x09\x0a\x12\x0b\x10\x05\x1c\x0b"
            "\x07\x0a\x14\x0b\x0e\x09\x1a\x0b\x05\x0a\x16\x0a\x0d"
            "\x0b\x1a\x0b\x03\x0a\x18\x0a\x0c\x0c\x19\x0c\x01\x0a"
            "\x19\x0b\x0a\x0e\x19\x15\x1b\x0a\x0a\x0f\x18\x15\x1b"
            "\x0b\x04\x00\xff\x01\x05\x0f\x19\x13\x1d\x0b\x03\x00"
            "\x05\x0f\x1a\x11\x1f\x0a\x08\x0f\x1a\x11\x1f\x0b\x07"
            "\x0f\x1a\x10\x20\x0b\x08\x0d\x1c\x0f\x20\x0b\x08\x0d"
            "\x1c\x0e\x22\x0b\x08\x0b\x1d\x0e\x22\x0b\x09\x09\x1e"
            "\x0e\x22\x0b\x0b\x05\x20\x0e\x22\x0b\x30\x0d\x23\x0b"
            "\x01\x00\xff\x03\x2f\x0d\x24\x0b\xff\x02\x2f\x0c\x25"
            "\x0b\x2f\x3c\x24\x47\x1d\x4e\x19\x51\x16\x19\x01\x0c"
            "\x42\x13\x0a\x0c\x40\x11\x0e\x0c\x3e\x10\x11\x0c\x3c"
            "\x0f\x14\x0c\x3a\x0f\x16\x0c\x39\x0e\x18\x0c\x38\x0d"
            "\x1a\x0c\x37\x0d\x1b\x0c\x36\x0d\x1d\x0c\x34\x0d\x1e"
            "\x0c\x33\x0d\x1f\x0c\x2f\x00\xff\x01\x03\x0d\x20\x0c"
            "\x2f\x00\x02\x0d\x22\x0b\x31\x0d\x22\x0c\x2f\x0d\x23"
            "\x0c\x2f\x0d\x23\x0c\x2b\x02\x01\x0e\x23\x0d\x29\x11"
            "\x24\x0d\x29\x11\x23\x0e\x28\x12\x23\x0f\x27\x12\x23"
            "\x0f\x26\x05\x01\x0d\x22\x11\x25\x05\x01\x0d\x22\x11"
            "\x24\x05\x02\x0d\x21\x13\x23\x05\x02\x0e\x20\x08\x01"
            "\x0b\x21\x05\x04\x0d\x1f\x08\x03\x0a\x21\x05\x04\x0d"
            "\x1e\x09\x04\x0a\x1f\x05\x06\x0d\x1c\x09\x06\x0a\x1d"
            "\x06\x06\x0e\x1a\x09\x08\x0a\x1b\x06\x08\x0d\x19\x09"
            "\x0a\x0a\x19\x06\x0a\x0e\x15\x0a\x0c\x0a\x16\x07\x0c"
            "\x0e\x13\x0a\x0e\x0b\x13\x07\x0e\x0f\x0e\x0b\x12\x0b"
            "\x0f\x07\x12\x10\x08\x0d\x15\x0c\x08\x0a\x14\x22\x18"
            "\x1c\x17\x1d\x1d\x18\x1c\x17\x23\x13\x23\x0e\x2b\x0b"
            "\x14" }  },
      /* --- pixel bitmap for cmr1200 char#27 \oe --- */
      {  27,32283,                      /* character number, location */
         74, 5,   -2, 5,      /* topleft row,col, and botleft row,col */
          { 118,   76, 2,409, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x1d\x0c\x2c\x0b\x2f\x14\x24\x13\x29\x19\x1f\x17\x24"
            "\x1e\x1b\x1b\x21\x0c\x08\x0d\x17\x0c\x07\x0c\x1d\x0b"
            "\x0e\x0b\x15\x0a\x0d\x0a\x1b\x0a\x13\x0a\x11\x0a\x10"
            "\x0b\x17\x0a\x16\x0a\x0f\x0a\x12\x0b\x15\x0a\x19\x09"
            "\x0d\x0a\x14\x0b\x13\x0a\x1b\x09\x0b\x0a\x16\x0a\x12"
            "\x0a\x1d\x09\x09\x0a\x18\x0a\x10\x0a\x1f\x09\x07\x0a"
            "\x19\x0b\x0e\x0a\x21\x09\x05\x0a\x1b\x0a\x0d\x0a\x22"
            "\x0a\x03\x0b\x1b\x0b\x0c\x0a\x23\x0a\x02\x0a\x1d\x0b"
            "\x0a\x0a\x24\x0a\x01\x0b\x1d\x0b\x09\x0b\x25\x14\x1f"
            "\x0a\x09\x0a\x26\x14\x1f\x0b\x07\x0b\x27\x12\x20\x0b"
            "\x06\x0c\x27\x12\x20\x0b\x06\x0b\x29\x10\x22\x0b\x01"
            "\x00\xff\x01\x03\x0c\x29\x10\x22\x0b\x01\x00\x03\x0b"
            "\x2b\x0f\x22\x0b\x03\x0c\x2b\x0e\x23\x0b\x01\x00\xff"
            "\x01\x02\x0c\x2b\x0e\x24\x0b\x01\x0d\x2b\x0e\x24\x0b"
            "\x01\x0c\x2c\x0e\x24\x0b\xff\x01\x01\x0c\x2d\x0c\x25"
            "\x0b\x00\x0d\x2d\x0c\x25\x0b\x00\xff\x02\x0d\x2d\x3c"
            "\x00\x0d\x2d\x3b\x01\xff\x08\x0d\x2d\x0c\x30\x00\x01"
            "\x0c\x2d\x0d\x30\x0c\x2c\x0e\x2f\x00\xff\x01\x01\x0d"
            "\x2b\x0e\x2f\x00\xff\x01\x02\x0c\x2b\x0e\x2f\x00\x02"
            "\x0c\x2b\x0f\x31\x0c\x29\x10\x31\x0c\x29\x10\x2b\x02"
            "\x04\x0c\x29\x11\x29\x04\x04\x0b\x28\x12\x29\x04\x04"
            "\x0c\x27\x12\x28\x05\x05\x0b\x27\x13\x27\x05\x06\x0b"
            "\x25\x14\x26\x05\x07\x0b\x25\x15\x25\x05\x08\x0b\x23"
            "\x0a\x02\x0a\x24\x05\x0a\x0a\x23\x0a\x02\x0b\x23\x05"
            "\x0a\x0b\x21\x0a\x04\x0b\x21\x05\x0c\x0a\x20\x0a\x06"
            "\x0a\x21\x05\x0d\x0a\x1e\x0a\x08\x0a\x1f\x05\x0f\x0a"
            "\x1d\x09\x0a\x0a\x1d\x06\x10\x0a\x1b\x09\x0c\x0a\x1b"
            "\x06\x12\x0a\x18\x0a\x0e\x0a\x19\x06\x14\x0b\x15\x0a"
            "\x10\x0a\x16\x07\x17\x0a\x12\x0b\x12\x0b\x13\x07\x19"
            "\x0b\x0e\x0b\x16\x0b\x0f\x07\x1d\x0c\x08\x0d\x19\x0c"
            "\x08\x0a\x1f\x1e\x1c\x1c\x22\x1a\x20\x18\x27\x14\x26"
            "\x13\x2d\x0c\x2e\x0b\x14" }  },
      /* --- pixel bitmap for cmr1200 char#28 (noname) --- */
      {  28,32736,                      /* character number, location */
         89, 5,  -17, 5,      /* topleft row,col, and botleft row,col */
          { 72,  106, 2,459, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x40\x01\x07\x00\xff\x01\x3f\x04\x05\x00\x3e\x05\x43"
            "\x04\x43\x05\x43\x04\x43\x05\x42\x05\x43\x04\x43\x05"
            "\x43\x04\x43\x05\x0a\x00\xff\x01\x38\x05\x0b\x00\x1e"
            "\x0c\x0d\x05\x26\x14\x09\x04\x24\x1a\x05\x05\x22\x1e"
            "\x03\x04\x21\x0c\x0a\x11\x20\x0a\x10\x0d\x1f\x0a\x14"
            "\x0a\x1f\x09\x18\x09\x1d\x09\x1a\x09\x1a\x09\x1d\x0a"
            "\x17\x09\x1e\x0b\x15\x09\x1e\x0d\x14\x09\x1d\x0e\x13"
            "\x09\x1e\x04\x02\x09\x11\x09\x1e\x05\x03\x09\x0f\x0a"
            "\x1e\x04\x04\x0a\x0e\x09\x1e\x05\x05\x09\x0d\x09\x1f"
            "\x04\x07\x09\x0b\x0a\x1e\x05\x07\x0a\x0a\x0a\x1d\x05"
            "\x08\x0a\x09\x0a\x1e\x04\x0a\x0a\x08\x0a\x1d\x05\x0a"
            "\x0a\x07\x0b\x1d\x04\x0b\x0b\x06\x0a\x1d\x05\x0c\x0a"
            "\x06\x0a\x1c\x05\x0d\x0a\x05\x0b\x1c\x05\x0d\x0b\x04"
            "\x0b\x1b\x05\x0e\x0b\x04\x0b\x1b\x04\x0f\x0b\x03\x0c"
            "\x1a\x05\x0f\x0c\x02\x0b\x1b\x04\x11\x0b\x02\x0b\x1a"
            "\x05\x11\x0b\x02\x0b\x19\x05\x12\x0b\x01\x0c\x19\x04"
            "\x13\x18\x18\x05\x13\x18\x18\x04\x14\x18\x17\x05\x14"
            "\x18\x17\x04\x15\x18\x16\x05\x15\x18\x15\x05\x16\x18"
            "\x15\x04\x17\x18\x14\x05\x17\x18\x14\x04\x18\x18\x13"
            "\x05\x18\x18\x13\x04\x19\x18\x12\x05\x19\x0c\x01\x0b"
            "\x11\x05\x1a\x0b\x02\x0b\x11\x04\x1b\x0b\x02\x0b\x10"
            "\x05\x1b\x0b\x02\x0b\x10\x04\x1c\x0b\x02\x0c\x0e\x05"
            "\x1b\x0c\x01\x00\xff\x01\x02\x0b\x0d\x05\x1c\x0b\x02"
            "\x00\x02\x0b\x0c\x05\x1d\x0b\x05\x0a\x0c\x04\x1e\x0a"
            "\x06\x0b\x0a\x05\x1d\x0b\x07\x0a\x0a\x04\x1e\x0a\x08"
            "\x0a\x09\x05\x1e\x0a\x09\x0a\x07\x05\x1e\x0a\x0a\x0a"
            "\x07\x04\x1f\x0a\x0b\x0a\x05\x05\x1e\x0a\x0d\x09\x05"
            "\x04\x1f\x09\x0e\x0a\x03\x05\x1e\x0a\x0f\x09\x03\x04"
            "\x1f\x09\x11\x09\x01\x05\x1e\x09\x13\x0d\x1e\x09\x15"
            "\x0b\x1e\x09\x17\x0a\x1d\x09\x19\x09\x1c\x09\x1b\x0a"
            "\x18\x0a\x1e\x09\x16\x09\x1f\x0d\x10\x0b\x1f\x11\x0a"
            "\x0c\x21\x04\x03\x1e\x22\x05\x05\x1a\x24\x04\x09\x14"
            "\x26\x05\x0d\x0c\x1e\x00\xff\x01\x0b\x05\x38\x00\x0a"
            "\x05\x43\x04\x43\x05\x43\x04\x43\x05\x42\x05\x43\x04"
            "\x43\x05\x43\x04\x43\x05\x3e\x00\xff\x01\x05\x04\x3f"
            "\x00\x07\x01\x40" }  },
      /* --- pixel bitmap for cmr1200 char#29 \AE --- */
      {  29,33210,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 139,  113, 2,635, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x03\x26\x5c\x09\x00\x26\x5d\x3c\x1d\x1c\x16\x3c"
            "\x05\x04\x12\x23\x11\x3b\x06\x05\x10\x27\x0e\x3b\x05"
            "\x07\x0f\x29\x0c\x3b\x05\x08\x0e\x2b\x0a\x3a\x06\x08"
            "\x0e\x2c\x09\x3a\x05\x09\x0e\x2d\x09\x39\x05\x09\x0e"
            "\x2e\x08\x38\x06\x09\x0e\x2f\x07\x38\x05\x0a\x0e\x2f"
            "\x07\x38\x05\x0a\x0e\x30\x06\x37\x05\x0b\x0e\x30\x06"
            "\x37\x05\x0b\x0e\x31\x05\x36\x06\x0b\x0e\x31\x05\x07"
            "\x00\xff\x01\x2f\x05\x0c\x0e\x32\x05\x06\x00\x2e\x06"
            "\x0c\x0e\x32\x05\x34\x05\x0d\x0e\x32\x05\x34\x05\x0d"
            "\x0e\x33\x04\x33\x06\x0d\x0e\x33\x04\x33\x05\x0e\x0e"
            "\x33\x04\x33\x05\x0e\x0e\x33\x05\x31\x06\x0e\x0e\x34"
            "\x04\x31\x05\x0f\x0e\x34\x04\x30\x06\x0f\x0e\x34\x04"
            "\x05\x00\xff\x01\x2b\x05\x10\x0e\x34\x04\x05\x00\x2a"
            "\x06\x10\x0e\x34\x04\x05\x00\xff\x01\x2a\x05\x11\x0e"
            "\x35\x04\x04\x00\x29\x06\x11\x0e\x35\x04\x2d\x05\x12"
            "\x0e\x35\x04\x2d\x05\x12\x0e\x1e\x04\x43\x06\x12\x0e"
            "\x1e\x04\x43\x05\x13\x0e\x1e\x04\x42\x06\x13\x0e\x1e"
            "\x04\x1b\x00\xff\x01\x27\x05\x14\x0e\x1e\x04\x1b\x00"
            "\x26\x06\x14\x0e\x1e\x04\x1b\x00\xff\x01\x26\x05\x15"
            "\x0e\x1e\x04\x1b\x00\x25\x06\x15\x0e\x1d\x05\x1b\x00"
            "\xff\x01\x25\x05\x16\x0e\x1d\x05\x1b\x00\x24\x06\x16"
            "\x0e\x1d\x05\x3f\x05\x17\x0e\x1c\x06\x3e\x06\x17\x0e"
            "\x1b\x07\x3e\x05\x18\x0e\x1b\x07\x3e\x05\x18\x0e\x19"
            "\x09\x3d\x06\x18\x0e\x18\x0a\x3d\x05\x19\x0e\x14\x0e"
            "\x3d\x4e\x1b\x00\xff\x02\x21\x4f\x1b\x00\x20\x50\x3b"
            "\x05\x1b\x0e\x14\x0e\x3a\x06\x1b\x0e\x18\x0a\x3a\x05"
            "\x1c\x0e\x19\x09\x3a\x05\x1c\x0e\x1b\x07\x39\x06\x1c"
            "\x0e\x1b\x07\x39\x05\x1d\x0e\x1c\x06\x39\x05\x1d\x0e"
            "\x1d\x05\x38\x06\x1d\x0e\x1d\x05\x38\x05\x1e\x0e\x1d"
            "\x05\x38\x05\x1e\x0e\x1d\x05\x17\x04\x1c\x06\x1e\x0e"
            "\x1e\x04\x17\x04\x1c\x05\x1f\x0e\x1e\x04\x17\x04\x1c"
            "\x05\x1f\x0e\x1e\x04\x16\x04\x01\x00\xff\x01\x1b\x05"
            "\x20\x0e\x1e\x04\x16\x04\x01\x00\x1a\x06\x20\x0e\x1e"
            "\x04\x16\x04\x01\x00\xff\x01\x1a\x05\x21\x0e\x1e\x04"
            "\x16\x04\x01\x00\x19\x06\x21\x0e\x1e\x04\x15\x04\x02"
            "\x00\xff\x01\x19\x05\x22\x0e\x37\x04\x02\x00\x18\x06"
            "\x22\x0e\x37\x04\x1a\x05\x23\x0e\x37\x04\x1a\x05\x23"
            "\x0e\x36\x05\x02\x00\xff\x01\x17\x05\x24\x0e\x36\x04"
            "\x03\x00\x16\x06\x24\x0e\x35\x05\x03\x00\xff\x01\x16"
            "\x05\x25\x0e\x35\x05\x03\x00\x15\x06\x25\x0e\x35\x05"
            "\x03\x00\xff\x01\x15\x05\x26\x0e\x34\x05\x04\x00\x14"
            "\x06\x26\x0e\x33\x06\x04\x00\xff\x01\x14\x05\x27\x0e"
            "\x33\x06\x04\x00\x13\x05\x28\x0e\x32\x07\x17\x05\x28"
            "\x0e\x31\x08\x16\x06\x28\x0e\x31\x07\x17\x06\x28\x0e"
            "\x30\x08\x16\x07\x28\x0e\x2f\x09\x15\x08\x28\x0e\x2e"
            "\x0a\x15\x09\x27\x0e\x2d\x0b\x14\x0a\x27\x0e\x2b\x0d"
            "\x12\x0d\x26\x0e\x2a\x0d\x12\x0f\x24\x0f\x27\x10\x10"
            "\x13\x22\x10\x23\x13\x0c\x1a\x1c\x15\x1c\x18\x06\xff"
            "\x01\x24\x0f\x52\x06\xff\x02\x24\x0f\x51\x07" }  },
      /* --- pixel bitmap for cmr1200 char#30 \OE --- */
      {  30,33878,                      /* character number, location */
        117,11,   -4,11,      /* topleft row,col, and botleft row,col */
          { 151,  121, 2,631, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x30\x0d\x85\x17\x7d\x1e\x76\x26\x6e\x10\x0b\x51\x29"
            "\x0e\x12\x4e\x27\x0e\x16\x4c\x26\x0d\x1a\x4a\x24\x0d"
            "\x1d\x4a\x22\x0c\x1f\x15\x1f\x16\x20\x0d\x21\x12\x26"
            "\x11\x1f\x0d\x23\x10\x2a\x0e\x1e\x0d\x24\x10\x2c\x0c"
            "\x1d\x0d\x25\x10\x2d\x0b\x1b\x0e\x27\x0f\x2f\x09\x1a"
            "\x0e\x28\x0f\x30\x09\x18\x0e\x29\x0f\x31\x08\x17\x0e"
            "\x2a\x0f\x31\x08\x17\x0d\x2b\x0f\x32\x07\x16\x0d\x2d"
            "\x0e\x33\x06\x15\x0e\x2d\x0e\x33\x06\x14\x0e\x2e\x0e"
            "\x34\x05\x13\x0e\x2f\x0e\x34\x05\x13\x0e\x2f\x0e\x34"
            "\x06\x11\x0e\x30\x0e\x35\x05\x10\x0f\x30\x0e\x35\x05"
            "\x10\x0e\x31\x0e\x35\x05\x0f\x0f\x31\x0e\x36\x04\x06"
            "\x00\xff\x01\x08\x0f\x32\x0e\x36\x04\x06\x00\x07\x0f"
            "\x33\x0e\x36\x05\x0c\x0f\x33\x0e\x37\x04\x0b\x10\x33"
            "\x0e\x37\x04\x0b\x0f\x34\x0e\x37\x04\x0a\x10\x34\x0e"
            "\x37\x04\x05\x00\xff\x01\x05\x0f\x35\x0e\x37\x04\x05"
            "\x00\xff\x01\x04\x10\x35\x0e\x24\x04\x10\x04\x04\x00"
            "\x04\x0f\x36\x0e\x24\x04\x10\x04\x07\x10\x36\x0e\x24"
            "\x04\x10\x04\x07\x10\x36\x0e\x24\x04\x1b\x10\x37\x0d"
            "\x24\x04\x18\x00\xff\x02\x02\x10\x38\x0d\x24\x04\x18"
            "\x00\x02\x10\x38\x0d\x23\x05\x18\x00\xff\x01\x01\x11"
            "\x38\x0d\x23\x05\x18\x00\xff\x01\x01\x10\x39\x0d\x22"
            "\x06\x18\x00\x01\x10\x39\x0d\x21\x07\x19\x10\x39\x0d"
            "\x20\x08\x18\x11\x39\x0d\x1f\x09\x18\x11\x39\x0d\x1d"
            "\x0b\x18\x11\x39\x0d\x19\x0f\x18\xff\x04\x11\x39\x35"
            "\x18\x11\x39\x0d\x19\x0f\x18\x11\x39\x0d\x1d\x0b\x18"
            "\x11\x39\x0d\x1f\x09\x18\x11\x39\x0d\x20\x08\x18\x11"
            "\x39\x0d\x21\x07\x18\xff\x01\x11\x39\x0d\x22\x06\x18"
            "\x12\x38\x0d\x23\x05\x18\x00\xff\x01\x01\x11\x38\x0d"
            "\x23\x05\x18\x00\xff\x02\x01\x11\x38\x0d\x24\x04\x18"
            "\x00\x01\x11\x38\x0d\x24\x04\x14\x04\xff\x01\x02\x11"
            "\x37\x0d\x24\x04\x14\x04\xff\x01\x02\x11\x37\x0d\x24"
            "\x04\x13\x04\x01\x00\x03\x10\x36\x0e\x24\x04\x13\x04"
            "\x01\x00\xff\x01\x03\x11\x35\x0e\x3b\x04\x01\x00\x04"
            "\x10\x35\x0e\x3b\x04\x01\x00\xff\x01\x04\x11\x34\x0e"
            "\x3a\x04\x02\x00\x05\x10\x34\x0e\x3a\x04\x07\x11\x33"
            "\x0e\x3a\x04\x02\x00\xff\x01\x06\x10\x33\x0e\x39\x05"
            "\x02\x00\xff\x01\x07\x10\x32\x0e\x39\x04\x03\x00\xff"
            "\x01\x08\x10\x31\x0e\x38\x05\x03\x00\xff\x01\x09\x10"
            "\x30\x0e\x38\x05\x03\x00\x0a\x10\x2f\x0e\x37\x05\x0f"
            "\x0f\x2f\x0e\x37\x05\x0f\x10\x2e\x0e\x36\x06\x10\x0f"
            "\x2e\x0e\x36\x06\x11\x0f\x2d\x0e\x35\x07\x12\x0f\x2c"
            "\x0e\x35\x07\x12\x0f\x2c\x0e\x34\x08\x13\x0f\x2a\x0f"
            "\x34\x07\x15\x0f\x29\x0f\x33\x08\x16\x0f\x28\x0f\x32"
            "\x09\x17\x0f\x27\x0f\x31\x0a\x18\x0e\x27\x0f\x30\x0b"
            "\x19\x0e\x25\x10\x2e\x0d\x1a\x0e\x24\x10\x2c\x0e\x1d"
            "\x0e\x22\x10\x2a\x10\x1e\x0e\x20\x12\x26\x13\x1f\x0e"
            "\x1e\x15\x1f\x18\x21\x0e\x1c\x4c\x22\x0e\x1a\x4d\x24"
            "\x0e\x16\x4e\x27\x0f\x11\x50\x29\x10\x0b\x53\x2c\x26"
            "\x73\x1f\x7c\x17\x85\x0d\x5a" }  },
      /* --- pixel bitmap for cmr1200 char#31 (noname) --- */
      {  31,34579,                      /* character number, location */
        123, 9,   -9, 9,      /* topleft row,col, and botleft row,col */
          { 110,  132, 2,671, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x60\x02\x6c\x03\x6a\x05\x0a\x00\xff\x01\x5e\x05\x0b"
            "\x00\x5d\x05\x3c\x0e\x1e\x05\x38\x18\x19\x05\x34\x20"
            "\x14\x05\x33\x24\x11\x05\x31\x0f\x0c\x0f\x0e\x05\x2f"
            "\x0d\x14\x0d\x0b\x05\x2e\x0c\x1a\x0c\x08\x05\x2e\x0b"
            "\x1e\x0b\x07\x05\x2c\x0b\x22\x0b\x04\x05\x2c\x0a\x26"
            "\x0a\x02\x05\x2b\x0b\x28\x10\x2a\x0a\x2c\x0d\x2a\x0a"
            "\x2e\x0b\x29\x0b\x30\x0b\x27\x0b\x32\x0b\x25\x0b\x34"
            "\x0b\x23\x0b\x36\x0b\x21\x0b\x36\x0d\x20\x0a\x36\x0e"
            "\x1f\x0a\x37\x0f\x1d\x0b\x36\x05\x01\x0b\x1b\x0b\x36"
            "\x05\x03\x0b\x19\x0b\x37\x05\x04\x0b\x18\x0b\x36\x05"
            "\x05\x0b\x17\x0b\x36\x05\x07\x0b\x15\x0c\x36\x04\x08"
            "\x0c\x14\x0b\x36\x05\x09\x0b\x13\x0c\x35\x05\x0a\x0c"
            "\x11\x0c\x36\x04\x0c\x0c\x10\x0c\x35\x05\x0c\x0c\x0f"
            "\x0d\x34\x05\x0d\x0d\x0e\x0c\x35\x04\x0f\x0c\x0d\x0d"
            "\x34\x05\x0f\x0d\x0c\x0c\x34\x05\x11\x0c\x0b\x0d\x34"
            "\x04\x12\x0d\x0a\x0d\x33\x05\x12\x0d\x0a\x0d\x32\x05"
            "\x13\x0d\x09\x0d\x33\x04\x15\x0d\x08\x0d\x32\x05\x15"
            "\x0d\x07\x0e\x31\x05\x16\x0e\x06\x0e\x31\x04\x17\x0e"
            "\x06\x0e\x30\x05\x17\x0e\x06\x0d\x30\x05\x19\x0d\x05"
            "\x0e\x30\x04\x1a\x0e\x04\x0e\x2f\x05\x1a\x0e\x04\x0e"
            "\x2e\x05\x1b\x0e\x04\x0e\x2e\x04\x1c\x0e\x03\x0f\x2d"
            "\x05\x1c\x0f\x02\x0f\x2c\x05\x1d\x0f\x02\x0e\x2d\x04"
            "\x1f\x0e\x02\x0e\x2c\x05\x1f\x0e\x02\x0e\x2b\x05\x20"
            "\x0e\x02\x0e\x2b\x04\x21\x0e\x01\x0f\x2a\x05\x21\x1e"
            "\x29\x05\x22\x1e\x29\x04\x23\x1e\x28\x05\x23\x1e\x27"
            "\x05\x24\x1e\x27\x04\x25\x1e\x26\x05\x25\x1e\x25\x05"
            "\x26\x1e\x25\x04\x27\x1e\x24\x05\x27\x1e\x23\x05\x28"
            "\x1e\x23\x04\x29\x1e\x22\x05\x29\x1e\x21\x05\x2a\x1e"
            "\x21\x04\x2b\x1e\x20\x05\x2b\x0f\x01\x0e\x1f\x05\x2c"
            "\x0e\x02\x0e\x1f\x04\x2d\x0e\x02\x0e\x1e\x05\x2d\x0e"
            "\x02\x0e\x1d\x05\x2e\x0e\x02\x0f\x1c\x04\x2e\x0f\x02"
            "\x0f\x1b\x05\x2e\x0f\x03\x0e\x1a\x05\x2f\x0e\x04\x0e"
            "\x1a\x04\x30\x0e\x04\x0e\x19\x05\x30\x0e\x04\x0e\x18"
            "\x05\x31\x0e\x05\x0d\x18\x04\x32\x0d\x06\x0e\x16\x05"
            "\x31\x0e\x06\x0e\x15\x05\x32\x0e\x07\x0d\x15\x04\x33"
            "\x0d\x08\x0d\x14\x05\x33\x0d\x08\x0d\x13\x05\x34\x0d"
            "\x09\x0d\x12\x04\x34\x0d\x0a\x0d\x11\x05\x34\x0d\x0b"
            "\x0c\x10\x05\x35\x0c\x0c\x0d\x0f\x04\x35\x0d\x0d\x0c"
            "\x0e\x05\x35\x0c\x0e\x0c\x0d\x05\x36\x0c\x0f\x0c\x0c"
            "\x04\x36\x0c\x10\x0c\x0b\x05\x36\x0c\x11\x0c\x09\x05"
            "\x36\x0c\x12\x0c\x09\x04\x37\x0c\x13\x0c\x07\x05\x36"
            "\x0c\x15\x0b\x06\x05\x37\x0b\x16\x0c\x04\x05\x37\x0c"
            "\x17\x0b\x04\x05\x37\x0b\x19\x0b\x02\x05\x37\x0b\x0d"
            "\x00\xff\x01\x0e\x10\x37\x0b\x0e\x00\x0f\x0e\x37\x0b"
            "\x1f\x0c\x37\x0b\x21\x0b\x36\x0b\x23\x0b\x34\x0b\x25"
            "\x0b\x32\x0b\x27\x0b\x30\x0b\x28\x0c\x2e\x0b\x28\x0e"
            "\x2c\x0a\x2a\x10\x28\x0b\x2a\x05\x02\x0b\x26\x0b\x2a"
            "\x05\x05\x0b\x22\x0b\x2c\x05\x06\x0c\x1e\x0c\x2c\x05"
            "\x09\x0c\x1a\x0c\x2d\x05\x0c\x0d\x14\x0d\x2f\x05\x0e"
            "\x0f\x0c\x0f\x30\x05\x12\x24\x32\x05\x15\x20\x34\x05"
            "\x19\x18\x37\x05\x1f\x0e\x30\x00\xff\x01\x0b\x05\x5e"
            "\x00\x0a\x05\x6a\x03\x6c\x02\x60" }  },
      /* --- pixel bitmap for cmr1200 char#32 (noname) --- */
      {  32,41263,                      /* character number, location */
         64, 4,   47, 4,      /* topleft row,col, and botleft row,col */
          { 39,   17, 2,35, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x04\x20\x07\x1e\x09\x1b\x0d\x17\x0f\x15\x0f\x16"
            "\x0e\x16\x0e\x16\x0f\x15\x0f\x16\x0e\x16\x0e\x16\x0f"
            "\x17\x0d\x1b\x09\x1e\x06\x21\x04\x22" }  },
      /* --- pixel bitmap for cmr1200 char#33 ! --- */
      {  33,35277,                      /* character number, location */
        119,14,    0,14,      /* topleft row,col, and botleft row,col */
          { 18,  119, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x7c\x5e\x3e\x02\x1f\x9e\x04\xfa\x1e\x02\x10"
            "\xfa\x2e\x20\xfa\x3c\x30\xfa\x4a\x40\xfa\x58\x50\xfa"
            "\x66\x60\xf5\x74\x70\xfd\xe0\x40\x66\xaa\x7c\x5e\x3e"
            "\x02\x1f\x7e\x04\x1e\x02\x3e\x5c\x7a\xa6\x60" }  },
      /* --- pixel bitmap for cmr1200 char#34 " --- */
      {  34,44457,                      /* character number, location */
        115, 5,   65, 5,      /* topleft row,col, and botleft row,col */
          { 52,   50, 3,297, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x66\xe0\xc6\xca\xe0\x8a\x9c\xe0\x6c\x7e\xe0\x4e\x5e"
            "\x02\xe0\x2e\x02\x4e\x03\xe0\x1e\x03\x2f\x1e\x04\xee"
            "\x04\x2f\x2e\x05\xde\x05\x1e\x06\xce\x06\xf1\x1e\x05"
            "\xde\x05\x2e\x04\xee\x04\x3c\x14\xe0\x1c\x14\x4a\x24"
            "\xe0\x2a\x24\x66\x44\xe0\x46\x44\xf4\xe0\x24\xe0\xe4"
            "\xe0\x15\xe0\xd5\xf3\xe0\x14\xe0\xe4\x10\xe5\xe0\xd5"
            "\x10\xf1\xe4\xe0\xe4\x20\xd5\xe0\xd5\xe0\x14\xe0\xe4"
            "\x30\xf1\xc5\xe0\xd5\x30\xc4\xe0\xe4\xe0\x15\xe0\xd5"
            "\x40\xf1\xa5\xe0\xd5\x50\x95\xe0\xd5\xe0\x14\xe0\xe4"
            "\xe0\x15\xe0\xd5\xe5\xe0\xd5\xe5\xe0\xd5\xe6\xe0\xc6"
            "\xd6\xe0\xc6\xd6\xe0\xc6\xe5\xe0\xd5\xe0\x14\xe0\xe4"
            "\xe0\x32\xe0\xe0\x22\xe0" }  },
      /* --- pixel bitmap for cmr1200 char#35 # --- */
      {  35,35715,                      /* character number, location */
        115, 9,  -32, 9,      /* topleft row,col, and botleft row,col */
          { 119,  147, 2,567, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x01\x39\x05\x21\x05\x13\x00\xff\x01\x38\x07\x1f"
            "\x07\x12\x00\xff\x01\x37\x08\x1e\x08\x12\x00\xff\x01"
            "\x37\x07\x1f\x07\x13\x00\xff\x01\x36\x08\x1e\x08\x13"
            "\x00\xff\x01\x36\x07\x1f\x07\x14\x00\xff\x01\x35\x08"
            "\x1e\x08\x14\x00\xff\x01\x35\x07\x1f\x07\x15\x00\xff"
            "\x01\x34\x08\x1e\x08\x15\x00\xff\x01\x34\x07\x1f\x07"
            "\x16\x00\xff\x01\x33\x08\x1e\x08\x16\x00\x33\x07\x1f"
            "\x07\x17\x00\xff\x01\x32\x08\x1e\x08\x17\x00\xff\x01"
            "\x32\x07\x1f\x07\x18\x00\xff\x01\x31\x08\x1e\x08\x18"
            "\x00\xff\x01\x31\x07\x1f\x07\x19\x00\xff\x01\x30\x08"
            "\x1e\x08\x19\x00\xff\x01\x30\x07\x1f\x07\x1a\x00\xff"
            "\x01\x2f\x08\x1e\x08\x1a\x00\x2f\x07\x1f\x07\x1b\x00"
            "\xff\x01\x2e\x08\x1e\x08\x1b\x00\xff\x01\x2e\x07\x1f"
            "\x07\x1c\x00\xff\x01\x2d\x08\x1e\x08\x1c\x00\xff\x01"
            "\x2d\x07\x1f\x07\x1d\x00\xff\x01\x2c\x08\x1e\x08\x1d"
            "\x00\xff\x01\x2c\x07\x1f\x07\x1e\x00\xff\x01\x2b\x08"
            "\x1e\x08\x1e\x00\x2b\x07\x1f\x07\x1f\x00\xff\x01\x01"
            "\x75\x01\xff\x02\x77\x01\x75\x03\x73\x02\x00\xff\x01"
            "\x28\x07\x1f\x07\x22\x00\xff\x01\x27\x08\x1e\x08\x22"
            "\x00\xff\x01\x27\x07\x1f\x07\x23\x00\xff\x01\x26\x08"
            "\x1e\x08\x23\x00\xff\x01\x26\x07\x1f\x07\x24\x00\xff"
            "\x01\x25\x08\x1e\x08\x24\x00\xff\x02\x25\x07\x1f\x07"
            "\x25\x00\xff\x01\x24\x08\x1e\x08\x25\x00\xff\x01\x24"
            "\x07\x1f\x07\x26\x00\xff\x01\x23\x08\x1e\x08\x26\x00"
            "\xff\x01\x23\x07\x1f\x07\x27\x00\xff\x01\x22\x08\x1e"
            "\x08\x27\x00\xff\x01\x22\x07\x1f\x07\x28\x00\x02\x73"
            "\x03\x75\x01\xff\x02\x77\xff\x01\x01\x75\x01\x00\x1f"
            "\x07\x1f\x07\x2b\x00\xff\x01\x1e\x08\x1e\x08\x2b\x00"
            "\xff\x01\x1e\x07\x1f\x07\x2c\x00\xff\x01\x1d\x08\x1e"
            "\x08\x2c\x00\xff\x01\x1d\x07\x1f\x07\x2d\x00\xff\x01"
            "\x1c\x08\x1e\x08\x2d\x00\xff\x01\x1c\x07\x1f\x07\x2e"
            "\x00\xff\x01\x1b\x08\x1e\x08\x2e\x00\x1b\x07\x1f\x07"
            "\x2f\x00\xff\x01\x1a\x08\x1e\x08\x2f\x00\xff\x01\x1a"
            "\x07\x1f\x07\x30\x00\xff\x01\x19\x08\x1e\x08\x30\x00"
            "\xff\x01\x19\x07\x1f\x07\x31\x00\xff\x01\x18\x08\x1e"
            "\x08\x31\x00\xff\x01\x18\x07\x1f\x07\x32\x00\xff\x01"
            "\x17\x08\x1e\x08\x32\x00\x17\x07\x1f\x07\x33\x00\xff"
            "\x01\x16\x08\x1e\x08\x33\x00\xff\x01\x16\x07\x1f\x07"
            "\x34\x00\xff\x01\x15\x08\x1e\x08\x34\x00\xff\x01\x15"
            "\x07\x1f\x07\x35\x00\xff\x01\x14\x08\x1e\x08\x35\x00"
            "\xff\x01\x14\x07\x1f\x07\x36\x00\xff\x01\x13\x08\x1e"
            "\x08\x36\x00\xff\x01\x13\x07\x1f\x07\x37\x00\xff\x01"
            "\x12\x08\x1e\x08\x37\x00\xff\x01\x12\x07\x1f\x07\x38"
            "\x00\xff\x01\x13\x05\x21\x05\x39" }  },
      /* --- pixel bitmap for cmr1200 char#36 $ --- */
      {  36,29208,                      /* character number, location */
        125, 9,   -9, 9,      /* topleft row,col, and botleft row,col */
          { 64,  134, 2,525, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x07\x1e\x05\x1d\x00\x1a\x0d\x2f\x16\x27\x1c\x22"
            "\x20\x1f\x23\x1b\x0d\x03\x05\x03\x0e\x19\x0b\x06\x05"
            "\x08\x0a\x16\x0a\x09\x05\x0b\x09\x13\x0a\x0a\x05\x0d"
            "\x08\x11\x09\x0c\x05\x0f\x07\x0f\x09\x0d\x05\x10\x07"
            "\x0d\x09\x0e\x05\x11\x06\x0d\x08\x0f\x05\x13\x05\x0b"
            "\x08\x10\x05\x13\x06\x09\x08\x11\x05\x14\x05\x09\x07"
            "\x12\x05\x15\x05\x07\x08\x12\x05\x16\x04\x06\x08\x13"
            "\x05\x16\x05\x05\x08\x13\x05\x17\x04\x02\x00\xff\x01"
            "\x02\x08\x14\x05\x17\x05\x01\x00\x02\x08\x14\x05\x18"
            "\x04\x02\x09\x14\x05\x14\x03\x01\x04\x02\x08\x15\x05"
            "\x11\x0c\x01\x08\x15\x05\x10\x0d\x01\x08\x15\x05\x0f"
            "\x17\x15\x05\x0f\x0e\x00\xff\x03\x09\x15\x05\x0e\x0f"
            "\x00\xff\x01\x0a\x14\x05\x0e\x0f\x00\x0a\x14\x05\x0f"
            "\x0d\x01\x0b\x13\x05\x10\x0b\x02\x0b\x13\x05\x11\x09"
            "\x03\x0b\x13\x05\x12\x07\x04\x0c\x12\x05\x1d\x00\xff"
            "\x01\x01\x0c\x11\x05\x1d\x00\x01\x0d\x10\x05\x1e\x0e"
            "\x0f\x05\x1f\x0e\x0e\x05\x1f\x0f\x0d\x05\x1f\x10\x0c"
            "\x05\x20\x11\x0a\x05\x20\x13\x08\x05\x21\x15\x05\x05"
            "\x22\x17\x02\x05\x22\x1e\x23\x1e\x23\x21\x20\x23\x1d"
            "\x25\x1c\x26\x1b\x27\x1b\x26\x1b\x27\x1a\x27\x1b\x26"
            "\x1b\x26\x1d\x24\x1e\x22\x22\x1f\x25\x1c\x24\x1d\x23"
            "\x05\x03\x15\x23\x05\x06\x13\x22\x05\x08\x11\x22\x05"
            "\x09\x11\x21\x05\x0b\x0f\x21\x05\x0c\x0f\x20\x05\x0d"
            "\x0e\x20\x05\x0e\x0d\x20\x05\x0f\x0d\x01\x00\xff\x01"
            "\x1e\x05\x10\x0c\x01\x00\x1e\x05\x11\x0b\x1f\x05\x11"
            "\x0c\x06\x03\x15\x05\x12\x0b\x03\x09\x12\x05\x12\x0b"
            "\x02\x0b\x11\x05\x13\x0a\xff\x01\x01\x0d\x10\x05\x13"
            "\x0a\x00\x0f\x0f\x05\x13\x0a\x00\xff\x04\x0f\x0f\x05"
            "\x14\x09\x00\x0e\x10\x05\x14\x16\x11\x05\x14\x08\x01"
            "\x0c\x12\x05\x14\x08\x01\x0b\x13\x05\x14\x08\x02\x04"
            "\x19\x05\x13\x09\x01\x00\xff\x01\x01\x04\x19\x05\x13"
            "\x08\x02\x00\x01\x05\x18\x05\x13\x08\x04\x04\x18\x05"
            "\x12\x08\x05\x05\x17\x05\x12\x08\x05\x05\x17\x05\x12"
            "\x07\x07\x05\x16\x05\x11\x08\x07\x05\x16\x05\x11\x07"
            "\x09\x05\x15\x05\x10\x08\x09\x06\x14\x05\x0f\x08\x0b"
            "\x05\x14\x05\x0f\x07\x0d\x05\x13\x05\x0e\x08\x0d\x06"
            "\x12\x05\x0d\x08\x0f\x07\x10\x05\x0c\x08\x11\x07\x0f"
            "\x05\x0a\x09\x13\x08\x0d\x05\x09\x09\x15\x09\x0b\x05"
            "\x07\x0a\x17\x0b\x08\x05\x05\x0b\x19\x0e\x04\x05\x01"
            "\x0d\x1d\x22\x20\x1e\x24\x1a\x29\x15\x2f\x0d\x1a\x00"
            "\xff\x06\x1e\x05\x1d" }  },
      /* --- pixel bitmap for cmr1200 char#37 % --- */
      {  37,36296,                      /* character number, location */
        125, 9,   -9, 9,      /* topleft row,col, and botleft row,col */
          { 119,  134, 2,783, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x14\x09\x47\x04\x20\x0e\x44\x05\x1e\x12\x41\x07\x1c"
            "\x14\x3f\x08\x1a\x0a\x06\x07\x3d\x09\x19\x09\x0a\x06"
            "\x3c\x08\x19\x09\x0d\x05\x3a\x09\x18\x08\x10\x06\x37"
            "\x09\x18\x09\x11\x06\x35\x09\x19\x08\x13\x06\x33\x0a"
            "\x18\x08\x14\x07\x30\x0b\x18\x09\x15\x08\x2d\x0b\x18"
            "\x09\x17\x09\x29\x0d\x18\x09\x17\x0b\x26\x0d\x18\x0a"
            "\x18\x0c\x22\x0e\x19\x09\x19\x0e\x1d\x11\x18\x0a\x1a"
            "\x04\x02\x0a\x17\x13\x19\x0a\x1a\x04\x04\x0d\x0e\x0d"
            "\x01\x08\x1a\x09\x1b\x05\x05\x24\x02\x09\x19\x0a\x1c"
            "\x04\x07\x1f\x05\x08\x1a\x0a\x1c\x04\x0b\x18\x07\x08"
            "\x1b\x0a\x1c\x05\x0e\x10\x0a\x09\x1a\x0b\x1d\x04\x28"
            "\x08\x1b\x0a\x1e\x04\x27\x08\x1c\x0a\x1e\x04\x26\x09"
            "\x1c\x0a\x1e\x04\x26\x08\x1d\x0a\x1e\x05\x24\x08\x1d"
            "\x0b\x1f\x04\x23\x09\x1d\x0b\x1f\x04\x23\x08\x1e\x0b"
            "\x1f\x04\x22\x08\x1f\x0b\x1f\x04\x21\x09\x1f\x0b\x1f"
            "\x04\x21\x08\x20\x0b\x1f\x04\x20\x08\x21\x0b\x1f\x04"
            "\x1f\x09\x21\x0b\x1f\x04\x1f\x08\x22\xff\x01\x0b\x1f"
            "\x04\x1e\x08\x23\x0b\x1f\x04\x1d\x08\x24\x0b\x1f\x04"
            "\x1c\x09\x24\x0b\x1f\x04\x1c\x08\x25\x0b\x1f\x04\x1b"
            "\x08\x27\x0a\x1e\x05\x1a\x09\x27\x0a\x1e\x04\x1b\x08"
            "\x28\x0a\x1e\x04\x1a\x08\x29\x0a\x1e\x04\x19\x09\x29"
            "\x0b\x1d\x04\x19\x08\x2b\x0a\x1c\x05\x18\x08\x2c\x0a"
            "\x1c\x04\x18\x09\x2c\x0a\x1c\x04\x18\x08\x2e\x09\x1b"
            "\x05\x17\x08\x2f\x0a\x1a\x04\x17\x09\x2f\x0a\x1a\x04"
            "\x17\x08\x31\x09\x19\x05\x16\x08\x32\x0a\x18\x04\x16"
            "\x09\x33\x09\x17\x05\x16\x08\x34\x09\x17\x04\x16\x08"
            "\x36\x09\x15\x05\x15\x09\x37\x08\x14\x05\x16\x08\x39"
            "\x08\x13\x05\x15\x08\x3a\x09\x11\x05\x15\x09\x3b\x08"
            "\x10\x05\x16\x08\x3d\x09\x0d\x05\x16\x08\x3f\x09\x0a"
            "\x06\x16\x09\x40\x0a\x06\x07\x17\x08\x43\x14\x17\x08"
            "\x45\x12\x17\x09\x47\x0e\x19\x08\x4b\x09\x1a\x08\x1e"
            "\x09\x47\x09\x1b\x0e\x45\x08\x1a\x12\x42\x08\x1a\x14"
            "\x40\x09\x18\x0a\x06\x07\x3f\x08\x18\x09\x0a\x06\x3d"
            "\x08\x18\x09\x0d\x05\x3b\x09\x17\x08\x10\x05\x3a\x08"
            "\x17\x09\x11\x05\x38\x08\x17\x09\x13\x05\x36\x09\x17"
            "\x08\x14\x05\x36\x08\x17\x09\x15\x05\x34\x08\x17\x09"
            "\x17\x04\x33\x09\x17\x09\x17\x05\x32\x08\x17\x09\x19"
            "\x04\x31\x08\x18\x09\x19\x05\x2f\x09\x17\x0a\x1a\x04"
            "\x2f\x08\x18\x09\x1b\x05\x2d\x08\x18\x0a\x1c\x04\x2c"
            "\x09\x18\x0a\x1c\x04\x2c\x08\x19\x0a\x1c\x04\x2b\x08"
            "\x1a\x0a\x1c\x05\x29\x09\x19\x0b\x1d\x04\x29\x08\x1a"
            "\x0a\x1e\x04\x28\x08\x1b\x0a\x1e\x04\x27\x09\x1b\x0a"
            "\x1e\x04\x27\x08\x1b\x0b\x1e\x05\x25\x08\x1c\x0b\x1f"
            "\x04\x24\x09\x1c\x0b\x1f\x04\x24\x08\x1d\x0b\x1f\x04"
            "\xff\x01\x23\x08\x1e\x0b\x1f\x04\x22\x08\x1f\x0b\x1f"
            "\x04\x21\x09\x1f\x0b\x1f\x04\x21\x08\x20\x0b\x1f\x04"
            "\x20\x08\x21\x0b\x1f\x04\x1f\x09\x21\x0b\x1f\x04\x1f"
            "\x08\x22\x0b\x1f\x04\x1e\x08\x23\x0b\x1f\x04\x1d\x09"
            "\x23\x0b\x1f\x04\x1d\x08\x24\x0b\x1e\x05\x1c\x08\x26"
            "\x0a\x1e\x04\x1c\x09\x26\x0a\x1e\x04\x1c\x08\x27\x0a"
            "\x1e\x04\x1b\x08\x28\x0b\x1d\x04\x1a\x09\x29\x0a\x1c"
            "\x05\x1a\x08\x2a\x0a\x1c\x04\x1a\x08\x2b\x0a\x1c\x04"
            "\x19\x09\x2b\x0a\x1c\x04\x19\x08\x2d\x09\x1b\x05\x18"
            "\x08\x2e\x0a\x1a\x04\x18\x09\x2f\x09\x19\x05\x18\x08"
            "\x30\x09\x19\x04\x18\x08\x32\x09\x17\x05\x17\x09\x32"
            "\x09\x17\x04\x18\x08\x34\x09\x15\x05\x17\x08\x36\x08"
            "\x14\x05\x17\x09\x36\x09\x13\x05\x17\x08\x38\x09\x11"
            "\x05\x17\x08\x3a\x08\x10\x05\x17\x09\x3b\x09\x0d\x05"
            "\x18\x08\x3d\x09\x0a\x06\x18\x08\x3f\x0a\x06\x07\x19"
            "\x08\x41\x14\x1a\x07\x43\x12\x1c\x05\x46\x0e\x1f\x04"
            "\x49\x09\x11" }  },
      /* --- pixel bitmap for cmr1200 char#38 & --- */
      {  38,29803,                      /* character number, location */
        119, 7,   -4, 7,      /* topleft row,col, and botleft row,col */
          { 113,  123, 2,603, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x26\x08\x66\x0d\x62\x11\x5e\x14\x5c\x0a\x05\x07\x5a"
            "\x09\x09\x06\x57\x0a\x0b\x05\x57\x09\x0d\x05\x55\x09"
            "\x0e\x05\x54\x09\x10\x04\x53\x0a\x10\x05\x52\x09\x11"
            "\x05\x51\x0a\x12\x04\x51\x09\x13\x04\x3a\x00\xff\x01"
            "\x16\x0a\x13\x05\x39\x00\x15\x0b\x14\x04\x39\x00\xff"
            "\x02\x15\x0a\x15\x04\x39\x00\xff\x04\x14\x0b\x15\x04"
            "\x39\x00\xff\x01\x14\x0b\x14\x05\x39\x00\x14\x0b\x14"
            "\x04\x3a\x00\xff\x01\x14\x0b\x13\x05\x3a\x00\x14\x0b"
            "\x13\x04\x3b\x00\xff\x01\x14\x0c\x11\x05\x3b\x00\x14"
            "\x0c\x10\x05\x50\x0c\x0f\x06\x50\x0c\x0f\x05\x51\x0c"
            "\x0e\x05\x53\x0b\x0e\x05\x53\x0c\x0c\x05\x54\x0c\x0b"
            "\x06\x54\x0c\x0a\x06\x55\x0c\x0a\x05\x56\x0c\x09\x05"
            "\x57\x0d\x07\x06\x58\x0c\x06\x06\x59\x0c\x05\x06\x5a"
            "\x0d\x04\x05\x5b\x0d\x03\x05\x5d\x0c\x02\x06\x22\x24"
            "\x17\x0c\x01\x06\x23\x24\x17\x12\x24\x24\x17\x11\x25"
            "\x24\x18\x0f\x26\x24\x18\x0e\x2c\x19\x1e\x0d\x2f\x14"
            "\x22\x0d\x30\x0f\x25\x0d\x31\x0d\x26\x0d\x32\x0a\x29"
            "\x0d\x31\x09\x2a\x0d\x31\x08\x2b\x0e\x30\x07\x2b\x0f"
            "\x30\x06\x2b\x11\x2f\x05\x2b\x12\x2f\x05\x2a\x13\x2e"
            "\x05\x2a\x06\x01\x0e\x2c\x06\x29\x06\x03\x0d\x2c\x05"
            "\x29\x06\x04\x0e\x2a\x05\x29\x06\x06\x0e\x29\x05\x29"
            "\x05\x07\x0e\x28\x05\x29\x05\x09\x0e\x26\x06\x28\x06"
            "\x09\x0e\x26\x05\x28\x06\x0b\x0e\x24\x05\x28\x06\x0c"
            "\x0e\x24\x05\x27\x06\x0e\x0e\x22\x05\x27\x07\x0e\x0f"
            "\x20\x06\x26\x07\x10\x0e\x20\x05\x26\x07\x11\x0f\x1e"
            "\x05\x26\x08\x12\x0f\x1d\x05\x25\x09\x12\x0f\x1c\x05"
            "\x25\x09\x14\x0f\x1a\x06\x24\x0a\x15\x0f\x19\x05\x24"
            "\x0a\x16\x0f\x18\x05\x25\x0a\x17\x0f\x16\x06\x24\x0b"
            "\x18\x0f\x15\x05\x24\x0c\x18\x0f\x14\x05\x25\x0c\x19"
            "\x0f\x12\x06\x24\x0c\x1b\x0f\x11\x05\x25\x0c\x1b\x0f"
            "\x10\x06\x24\x0d\x1c\x0f\x0e\x06\x25\x0d\x1d\x0f\x0d"
            "\x05\x26\x0d\x1d\x0f\x0c\x06\x25\x0e\x1e\x0f\x0a\x06"
            "\x26\x0e\x1f\x0f\x09\x05\x27\x0e\x20\x0e\x08\x05\x28"
            "\x0e\x20\x0f\x06\x06\x28\x0e\x21\x0f\x04\x06\x29\x0e"
            "\x22\x0f\x03\x05\x2a\x0f\x22\x0e\x02\x05\x2b\x0f\x22"
            "\x15\x26\x04\x01\x0f\x23\x13\x27\x04\x01\x0f\x24\x11"
            "\x28\x04\x01\x0f\x25\x0f\x29\x04\x02\x0f\x25\x0f\x27"
            "\x05\x02\x0f\x26\x0e\x27\x04\x03\x0f\x27\x0e\x26\x04"
            "\x04\x0f\x26\x0f\x24\x05\x04\x0f\x27\x0f\x23\x04\x06"
            "\x0e\x26\x11\x21\x05\x06\x0f\x24\x13\x20\x05\x07\x0f"
            "\x21\x07\x01\x0e\x1e\x05\x09\x0e\x20\x07\x03\x0e\x1c"
            "\x06\x09\x0f\x1e\x07\x05\x0e\x1a\x06\x0b\x0f\x1b\x08"
            "\x07\x0f\x17\x06\x0d\x0f\x18\x08\x0b\x0e\x15\x07\x0e"
            "\x0f\x14\x0a\x0d\x0f\x11\x08\x11\x0e\x10\x0b\x11\x0f"
            "\x0d\x09\x13\x10\x09\x0e\x13\x11\x07\x0b\x16\x23\x17"
            "\x1f\x1a\x1f\x1b\x1c\x1d\x1b\x1f\x18\x21\x16\x25\x13"
            "\x27\x0d\x2f\x0b\x13" }  },
      /* --- pixel bitmap for cmr1200 char#39 ' --- */
      {  39,37100,                      /* character number, location */
        115,14,   65,14,      /* topleft row,col, and botleft row,col */
          { 20,   50, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x66\xca\x9c\x7e\x5e\x02\x4e\x03\x2f\x1e\x04\x2f\x2e"
            "\x05\x1e\x06\xf1\x1e\x05\x2e\x04\x3c\x14\x4a\x24\x66"
            "\x44\xf4\xe0\x24\xe0\x15\xf3\xe0\x14\x10\xe5\x10\xf1"
            "\xe4\x20\xd5\x20\xf1\xd4\x30\xc5\xe0\x14\xe0\x15\x40"
            "\xf1\xa5\x50\x95\xe0\x14\xe0\x15\xe5\xe5\xe6\xd6\xd6"
            "\xe5\xe0\x14\xe0\x32\xe0" }  },
      /* --- pixel bitmap for cmr1200 char#40 ( --- */
      {  40,37213,                      /* character number, location */
        125,16,  -42,16,      /* topleft row,col, and botleft row,col */
          { 39,  167, 3,616, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x74\xe0\xe0\x65\xe0\xe0\x56\xe0\xe0\x45\xe0"
            "\xe0\x55\xe0\xe0\x56\xe0\xe0\x46\xe0\xe0\x46\xe0\xe0"
            "\x46\xe0\xe0\x46\xe0\xe0\x46\xe0\xe0\x46\xe0\xe0\x47"
            "\xe0\xe0\x37\xa0\xf1\xe0\x77\xb0\xe0\x67\xe0\xe0\x37"
            "\xe0\xe0\x38\xe0\xe0\x37\xe0\xe0\x37\xe0\xe0\x38\xe0"
            "\xe0\x37\xe0\xe0\x38\xe0\xe0\x37\xe0\xe0\x38\xe0\x30"
            "\xf1\xd8\xe0\x40\xf1\xc8\xe0\x50\xb9\xe0\xe0\x28\xe0"
            "\xe0\x29\xe0\xe0\x28\xe0\x70\xf1\x99\xe0\x70\x98\xe0"
            "\x80\xf1\x89\xe0\x80\xf2\x79\xe0\x90\xf2\x69\xe0\xa0"
            "\xf3\x59\xe0\xb0\x4a\xe0\xb0\xf1\x49\xe0\xc0\xf2\x3a"
            "\xe0\xc0\xf1\x39\xe0\xd0\xf3\x2a\xe0\xd0\xf1\x29\xe0"
            "\xe0\xf6\x1a\xe0\xe0\x19\xe0\xe0\x1f\xea\xe0\xe0\x1f"
            "\x9a\xe0\xe0\x10\x19\xe0\xe0\x10\xf6\x1a\xe0\xe0\xf1"
            "\x29\xe0\xe0\xf3\x2a\xe0\xd0\xf1\x39\xe0\xd0\xf2\x3a"
            "\xe0\xc0\xf1\x49\xe0\xc0\x4a\xe0\xb0\xf3\x59\xe0\xb0"
            "\xf2\x69\xe0\xa0\xf2\x79\xe0\x90\xf1\x89\xe0\x80\x98"
            "\xe0\x80\xf1\x99\xe0\x70\xa8\xe0\xe0\x39\xe0\xe0\x38"
            "\xe0\xe0\x39\xe0\x50\xf1\xc8\xe0\x50\xf1\xd8\xe0\x40"
            "\xe8\xe0\xe0\x47\xe0\xe0\x48\xe0\xe0\x47\xe0\xe0\x48"
            "\xe0\xe0\x47\xe0\xe0\x57\xe0\xe0\x48\xe0\xe0\x47\xe0"
            "\xe0\x57\xc0\xf1\xe0\x77\xb0\xe0\x87\xe0\xe0\x57\xe0"
            "\xe0\x56\xe0\xe0\x66\xe0\xe0\x66\xe0\xe0\x66\xe0\xe0"
            "\x66\xe0\xe0\x66\xe0\xe0\x66\xe0\xe0\x65\xe0\xe0\x75"
            "\xe0\xe0\x76\xe0\xe0\x65\xe0\xe0\x74" }  },
      /* --- pixel bitmap for cmr1200 char#41 ) --- */
      {  41,37554,                      /* character number, location */
        125, 9,  -42, 9,      /* topleft row,col, and botleft row,col */
          { 39,  167, 3,617, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x13\xe0\xe0\x75\xe0\xe0\x75\xe0\xe0\x75\xe0\xe0\x75"
            "\xe0\xe0\x66\xe0\xe0\x66\xe0\xe0\x66\xe0\xe0\x66\xe0"
            "\xe0\x66\xe0\xe0\x66\xe0\xe0\x66\xe0\xe0\x57\xe0\xe0"
            "\x57\xe0\x80\xf1\xb7\xe0\x70\xc7\xe0\xe0\x57\xe0\xe0"
            "\x48\xe0\xe0\x47\xe0\xe0\x57\xe0\xe0\x48\xe0\xe0\x47"
            "\xe0\xe0\x48\xe0\xe0\x47\xe0\xe0\x48\xe0\xf1\xe0\x48"
            "\xd0\xf1\xe0\x58\xc0\xe0\x59\xe0\xe0\x38\xe0\xe0\x39"
            "\xe0\xe0\x38\xa0\xf1\xe0\x79\x90\xe0\x88\x90\xf1\xe0"
            "\x89\x80\xf2\xe0\x99\x70\xf2\xe0\xa9\x60\xf3\xe0\xb9"
            "\x50\xe0\xba\x40\xf1\xe0\xc9\x40\xf2\xe0\xca\x30\xf1"
            "\xe0\xd9\x30\xf3\xe0\xda\x20\xf1\xe0\xe9\x20\xf6\xe0"
            "\xea\x10\xe0\xe0\x19\x10\xfe\xe0\xe0\x1a\xf9\xe0\xe0"
            "\x1a\xe0\xe0\x19\x10\xf6\xe0\xea\x10\xf1\xe0\xe9\x20"
            "\xf3\xe0\xda\x20\xf1\xe0\xd9\x30\xf2\xe0\xca\x30\xf1"
            "\xe0\xc9\x40\xe0\xba\x40\xf3\xe0\xb9\x50\xf2\xe0\xa9"
            "\x60\xf2\xe0\x99\x70\xf1\xe0\x89\x80\xe0\x88\x90\xf1"
            "\xe0\x79\x90\xe0\x78\xe0\xe0\x29\xe0\xe0\x28\xe0\xe0"
            "\x29\xb0\xf1\xe0\x58\xc0\xf1\xe0\x48\xd0\xe0\x38\xe0"
            "\xe0\x37\xe0\xe0\x38\xe0\xe0\x37\xe0\xe0\x38\xe0\xe0"
            "\x37\xe0\xe0\x37\xe0\xe0\x38\xe0\xe0\x37\xe0\xe0\x37"
            "\xe0\x60\xf1\xb7\xe0\x70\xa7\xe0\xe0\x37\xe0\xe0\x46"
            "\xe0\xe0\x46\xe0\xe0\x46\xe0\xe0\x46\xe0\xe0\x46\xe0"
            "\xe0\x46\xe0\xe0\x46\xe0\xe0\x55\xe0\xe0\x55\xe0\xe0"
            "\x55\xe0\xe0\x55\xe0\xe0\x73\xe0\xe0\x74" }  },
      /* --- pixel bitmap for cmr1200 char#42 * --- */
      {  42,37895,                      /* character number, location */
        125,11,   54,11,      /* topleft row,col, and botleft row,col */
          { 60,   71, 3,455, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe4\xe0\xe0\xe0\xd6\xe0\xd0\xf1\xe0\xc8\xe0\xc0"
            "\xe0\xc9\xe0\xb0\xf9\xe0\xc8\xe0\xc0\x41\xe0\x86\xe0"
            "\x81\x56\xe0\x66\xe0\x66\x27\xe0\x56\xe0\x57\x1a\xe0"
            "\x36\xe0\x3e\x07\xe0\x26\xe0\x2e\x09\xe0\x16\xe0\x1e"
            "\x0c\xd6\xde\x0e\x01\xc6\xce\x01\x1e\x01\xb6\xbe\x01"
            "\x4e\x01\x96\x9e\x01\x8e\x94\x9e\xcd\x84\x8d\xe0\x3c"
            "\x64\x6c\xe0\x8b\x54\x5b\xe0\xca\x44\x4a\xe0\xe0\x2a"
            "\x24\x2a\xe0\xe0\x69\x14\x19\xe0\xe0\xae\x06\xe0\xe0"
            "\xee\x02\xe0\xe0\xe0\x4c\xe0\xe0\xe0\x96\xe0\xe0\xe0"
            "\x9c\xe0\xe0\xe0\x4e\x02\xe0\xe0\xee\x06\xe0\xe0\xa9"
            "\x14\x19\xe0\xe0\x6a\x24\x2a\xe0\xe0\x2a\x44\x4a\xe0"
            "\xcb\x54\x5b\xe0\x8c\x64\x6c\xe0\x3d\x84\x8d\xce\x94"
            "\x9e\x8e\x01\x96\x9e\x01\x4e\x01\xb6\xbe\x01\x1e\x01"
            "\xc6\xce\x0e\x01\xd6\xde\x0c\xe0\x16\xe0\x1e\x09\xe0"
            "\x26\xe0\x2e\x07\xe0\x36\xe0\x3a\x17\xe0\x56\xe0\x57"
            "\x26\xe0\x66\xe0\x66\x51\xe0\x86\xe0\x81\x40\xf9\xe0"
            "\xc8\xe0\xc0\xe0\xc9\xe0\xb0\xf1\xe0\xc8\xe0\xc0\xe0"
            "\xd6\xe0\xe0\xe0\xd4\xe0\xe1" }  },
      /* --- pixel bitmap for cmr1200 char#43 + --- */
      {  43,38180,                      /* character number, location */
         97, 9,  -14, 9,      /* topleft row,col, and botleft row,col */
          { 110,  111, 2,37, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x01\x35\x05\x34\x00\xff\x31\x34\x07\x33\x00\xff"
            "\x01\x01\x6c\x01\xff\x02\x6e\xff\x01\x01\x6c\x01\x00"
            "\xff\x31\x34\x07\x33\x00\xff\x01\x35\x05\x34" }  },
      /* --- pixel bitmap for cmr1200 char#44 (noname) --- */
      {  44,38416,                      /* character number, location */
         18,14,  -32,14,      /* topleft row,col, and botleft row,col */
          { 20,   50, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x66\xca\x9c\x7e\x5e\x02\x4e\x03\x2f\x1e\x04\x2f\x2e"
            "\x05\x1e\x06\xf1\x1e\x05\x2e\x04\x3c\x14\x4a\x24\x66"
            "\x44\xf4\xe0\x24\xe0\x15\xf3\xe0\x14\x10\xe5\x10\xf1"
            "\xe4\x20\xd5\x20\xf1\xd4\x30\xc5\xe0\x14\xe0\x15\x40"
            "\xf1\xa5\x50\x95\xe0\x14\xe0\x15\xe5\xe5\xe6\xd6\xd6"
            "\xe5\xe0\x14\xe0\x32\xee" }  },
      /* --- pixel bitmap for cmr1200 char#45 (noname) --- */
      {  45,44676,                      /* character number, location */
         41, 2,   31, 2,      /* topleft row,col, and botleft row,col */
          { 43,   10, 2, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x09\x00\x2b" }  },
      /* --- pixel bitmap for cmr1200 char#46 (noname) --- */
      {  46,38529,                      /* character number, location */
         18,14,    0,14,      /* topleft row,col, and botleft row,col */
          { 18,   18, 3,39, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x7c\x5e\x20\xf1\x1e\x02\x1f\x5e\x04\xf1\x1e"
            "\x02\x10\x2e\x5c\x7a\xa6\x6e" }  },
      /* --- pixel bitmap for cmr1200 char#47 / --- */
      {  47,38572,                      /* character number, location */
        125, 9,  -42, 9,      /* topleft row,col, and botleft row,col */
          { 64,  167, 2,537, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x3b\x04\x3b\x05\x01\x00\xff\x01\x39\x07\xff\x01\x38"
            "\x08\x38\x07\x01\x00\xff\x01\x37\x08\x01\x00\x37\x07"
            "\x02\x00\xff\x01\x36\x08\x02\x00\xff\x01\x35\x08\x03"
            "\x00\x35\x07\x04\x00\xff\x01\x34\x08\x04\x00\x34\x07"
            "\x05\x00\xff\x01\x33\x08\x05\x00\x33\x07\x06\x00\xff"
            "\x01\x32\x08\x06\x00\x32\x07\x07\x00\xff\x01\x31\x08"
            "\x07\x00\xff\x01\x30\x08\x08\x00\x30\x07\x09\x00\xff"
            "\x01\x2f\x08\x09\x00\x2f\x07\x0a\x00\xff\x01\x2e\x08"
            "\x0a\x00\x2e\x07\x0b\x00\xff\x01\x2d\x08\x0b\x00\x2d"
            "\x07\x0c\x00\xff\x01\x2c\x08\x0c\x00\xff\x01\x2b\x08"
            "\x0d\x00\x2b\x07\x0e\x00\xff\x01\x2a\x08\x0e\x00\x2a"
            "\x07\x0f\x00\xff\x01\x29\x08\x0f\x00\x29\x07\x10\x00"
            "\xff\x01\x28\x08\x10\x00\x28\x07\x11\x00\xff\x01\x27"
            "\x08\x11\x00\xff\x01\x26\x08\x12\x00\x26\x07\x13\x00"
            "\xff\x01\x25\x08\x13\x00\x25\x07\x14\x00\xff\x01\x24"
            "\x08\x14\x00\x24\x07\x15\x00\xff\x01\x23\x08\x15\x00"
            "\x23\x07\x16\x00\xff\x01\x22\x08\x16\x00\xff\x01\x21"
            "\x08\x17\x00\x21\x07\x18\x00\xff\x01\x20\x08\x18\x00"
            "\x20\x07\x19\x00\xff\x01\x1f\x08\x19\x00\x1f\x07\x1a"
            "\x00\xff\x01\x1e\x08\x1a\x00\x1e\x07\x1b\x00\xff\x01"
            "\x1d\x08\x1b\x00\xff\x01\x1c\x08\x1c\x00\x1c\x07\x1d"
            "\x00\xff\x01\x1b\x08\x1d\x00\x1b\x07\x1e\x00\xff\x01"
            "\x1a\x08\x1e\x00\x1a\x07\x1f\x00\xff\x01\x19\x08\x1f"
            "\x00\x19\x07\x20\x00\xff\x01\x18\x08\x20\x00\x18\x07"
            "\x21\x00\xff\x01\x17\x08\x21\x00\xff\x01\x16\x08\x22"
            "\x00\x16\x07\x23\x00\xff\x01\x15\x08\x23\x00\x15\x07"
            "\x24\x00\xff\x01\x14\x08\x24\x00\x14\x07\x25\x00\xff"
            "\x01\x13\x08\x25\x00\x13\x07\x26\x00\xff\x01\x12\x08"
            "\x26\x00\xff\x01\x11\x08\x27\x00\x11\x07\x28\x00\xff"
            "\x01\x10\x08\x28\x00\x10\x07\x29\x00\xff\x01\x0f\x08"
            "\x29\x00\x0f\x07\x2a\x00\xff\x01\x0e\x08\x2a\x00\x0e"
            "\x07\x2b\x00\xff\x01\x0d\x08\x2b\x00\xff\x01\x0c\x08"
            "\x2c\x00\x0c\x07\x2d\x00\xff\x01\x0b\x08\x2d\x00\x0b"
            "\x07\x2e\x00\xff\x01\x0a\x08\x2e\x00\x0a\x07\x2f\x00"
            "\xff\x01\x09\x08\x2f\x00\x09\x07\x30\x00\xff\x01\x08"
            "\x08\x30\x00\xff\x01\x07\x08\x31\x00\x07\x07\x32\x00"
            "\xff\x01\x06\x08\x32\x00\x06\x07\x33\x00\xff\x01\x05"
            "\x08\x33\x00\x05\x07\x34\x00\xff\x01\x04\x08\x34\x00"
            "\x04\x07\x35\x00\xff\x01\x03\x08\x35\x00\xff\x01\x02"
            "\x08\x36\x00\x02\x07\x37\x00\xff\x01\x01\x08\x37\x00"
            "\x01\x07\x38\xff\x01\x08\x38\xff\x01\x07\x39\x00\xff"
            "\x01\x01\x05\x3a" }  },
      /* --- pixel bitmap for cmr1200 char#48 0 --- */
      {  48,25513,                      /* character number, location */
        111, 6,   -4, 6,      /* topleft row,col, and botleft row,col */
          { 70,  115, 3,513, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\xe0\x1c\xe0\xe0\xe0\xce\x06\xe0\xe0\xe0\x6e\x0a"
            "\xe0\xe0\xe0\x2e\x0e\xe0\xe0\xcc\x8c\xe0\xe0\x8b\xeb"
            "\xe0\xe0\x5a\xe0\x4a\xe0\xe0\x3a\xe0\x6a\xe0\xe0\x19"
            "\xe0\xa9\xe0\xd9\xe0\xc9\xe0\xb9\xe0\xe9\xe0\x99\xe0"
            "\xe0\x29\xe0\x7a\xe0\xe0\x2a\xe0\x69\xe0\xe0\x49\xe0"
            "\x5a\xe0\xe0\x4a\x90\xf1\x8a\xe0\xe0\x6a\x80\xf1\x7a"
            "\xe0\xe0\x8a\x70\x6b\xe0\xe0\x8b\xca\xe0\xe0\xaa\x60"
            "\xf2\x5b\xe0\xe0\xab\x50\xf2\x4b\xe0\xe0\xcb\x40\xf3"
            "\x3c\xe0\xe0\xcc\x30\xf1\x2d\xe0\xe0\xcd\x20\xf1\x2c"
            "\xe0\xe0\xec\x20\xf8\x1d\xe0\xe0\xed\x1f\xee\xe0\xe0"
            "\xee\x0f\xce\xe0\xe0\xee\xf6\x1d\xe0\xe0\xed\x10\x1e"
            "\xe0\xe0\xce\x10\xf4\x2d\xe0\xe0\xcd\x20\xf3\x3c\xe0"
            "\xe0\xcc\x30\xf2\x4c\xe0\xe0\xac\x40\xf1\x5b\xe0\xe0"
            "\xab\x50\xf1\x6b\xe0\xe0\x8b\x60\x7a\xe0\xe0\x8a\xeb"
            "\xe0\xe0\x6b\x70\xf1\x8a\xe0\xe0\x6a\x80\xf1\x9a\xe0"
            "\xe0\x4a\x90\xaa\xe0\xe0\x2a\xe0\x7a\xe0\xea\xe0\x9a"
            "\xe0\xca\xe0\xba\xe0\xaa\xe0\xda\xe0\x8a\xe0\xe0\x1a"
            "\xe0\x6a\xe0\xe0\x3a\xe0\x4a\xe0\xe0\x5b\xeb\xe0\xe0"
            "\x8c\x8c\xe0\xe0\xce\x0e\xe0\xe0\xe0\x2e\x0a\xe0\xe0"
            "\xe0\x6e\x06\xe0\xe0\xe0\xcc\xe0\xe0\x13" }  },
      /* --- pixel bitmap for cmr1200 char#49 1 --- */
      {  49,25964,                      /* character number, location */
        111,15,    0,15,      /* topleft row,col, and botleft row,col */
          { 55,  111, 2,62, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x1e\x03\x32\x06\x30\x07\x2f\x08\x2e\x09\x2c\x0b\x2a"
            "\x0d\x28\x0f\x25\x12\x21\x16\x1a\x1d\x15\x22\x15\x13"
            "\x02\x0d\x15\x10\x05\x0d\x15\x0c\x09\x0d\x15\x05\x10"
            "\x0d\x15\x00\xff\x55\x15\x0d\x15\x00\xff\x01\x14\x0f"
            "\x14\x00\x13\x11\x22\x19\x0f\xff\x04\x37" }  },
      /* --- pixel bitmap for cmr1200 char#50 2 --- */
      {  50,26201,                      /* character number, location */
        111, 8,    0, 8,      /* topleft row,col, and botleft row,col */
          { 66,  111, 2,319, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x19\x0d\x31\x15\x2a\x1b\x25\x20\x21\x23\x1d\x0c\x08"
            "\x12\x1b\x09\x10\x10\x18\x08\x14\x0f\x16\x07\x17\x0f"
            "\x14\x06\x1b\x0e\x12\x06\x1d\x0e\x10\x06\x1f\x0e\x0e"
            "\x06\x21\x0e\x0c\x06\x22\x0f\x0b\x05\x24\x0f\x09\x06"
            "\x25\x0e\x09\x05\x26\x0f\x07\x06\x27\x0e\x07\x05\x28"
            "\x0f\x05\x06\x28\x0f\x05\x05\x2a\x0f\x03\x06\x2a\x0f"
            "\x03\x05\x2b\x10\x02\x0b\x26\x0f\x02\x0d\x24\x0f\x01"
            "\x0f\x23\x0f\x01\xff\x01\x10\x22\x10\x00\xff\x05\x11"
            "\x22\x0f\xff\x01\x01\x0f\x23\x0f\x02\x0d\x24\x0f\x03"
            "\x0b\x24\x10\x04\x09\x25\x10\x06\x05\x27\x0f\x01\x00"
            "\xff\x01\x32\x0f\x01\x00\x31\x10\x01\x00\xff\x01\x31"
            "\x0f\x02\x00\xff\x01\x30\x0f\x03\x00\x30\x0e\x33\x0f"
            "\x33\x0e\x33\x0f\x33\x0e\x06\x00\xff\x01\x2d\x0e\x07"
            "\x00\x2c\x0e\x34\x0d\x34\x0d\x0a\x00\xff\x01\x2a\x0d"
            "\x0b\x00\x29\x0d\x34\x0d\x35\x0c\x35\x0c\x35\x0c\x35"
            "\x0c\x36\x0b\x36\x0a\x37\x0a\x37\x0a\x37\x0a\x37\x0a"
            "\x38\x09\x38\x09\x38\x09\x38\x09\x38\x08\x39\x08\x39"
            "\x08\x39\x08\x39\x08\x3a\x07\x3a\x07\x3a\x07\x21\x04"
            "\x15\x07\x22\x04\x14\x07\x23\x04\x13\x07\x23\x04\x13"
            "\x07\x24\x04\x12\x07\x25\x04\x11\x07\x26\x04\x11\x06"
            "\x27\x04\x10\x06\x27\x05\x0f\x06\x28\x04\x0f\x06\x29"
            "\x04\x0e\x06\x2a\x04\x0d\x06\x2a\x05\x0c\x06\x2b\x05"
            "\x0b\x06\x2b\x05\x0b\x06\x2a\x07\x0b\x37\x0a\x38\x09"
            "\x39\x08\x3a\x07\x3a\x07\x3b\x06\x3c\x05\x3d\x04\xff"
            "\x01\x3e\x04\xff\x02\x3d\x05" }  },
      /* --- pixel bitmap for cmr1200 char#51 3 --- */
      {  51,26532,                      /* character number, location */
        111, 7,   -4, 7,      /* topleft row,col, and botleft row,col */
          { 68,  115, 2,359, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1b\x0d\x32\x17\x2a\x1d\x25\x21\x21\x0d\x09\x0f\x1e"
            "\x09\x11\x0d\x1c\x08\x15\x0d\x18\x07\x19\x0d\x16\x07"
            "\x1b\x0d\x14\x06\x1e\x0d\x12\x06\x20\x0d\x11\x05\x21"
            "\x0e\x0f\x05\x23\x0e\x0d\x05\x24\x0e\x0d\x04\x25\x0f"
            "\x0b\x0b\x20\x0f\x0a\x0d\x1e\x0f\x0a\x0e\x1d\x0f\x09"
            "\x0f\x1d\x10\x08\x10\x1c\x10\x04\x00\xff\x01\x04\x10"
            "\x1d\x0f\x04\x00\xff\x01\x04\x11\x1c\x0f\x04\x00\xff"
            "\x01\x04\x10\x1d\x0f\x04\x00\x05\x0f\x1c\x10\x09\x0e"
            "\x1d\x10\x0a\x0c\x1e\x0f\x0c\x0a\x1f\x0f\x0e\x07\x20"
            "\x0f\x35\x0f\x05\x00\xff\x01\x2f\x0f\x06\x00\xff\x01"
            "\x2f\x0e\x07\x00\xff\x01\x2e\x0e\x08\x00\xff\x01\x2d"
            "\x0e\x09\x00\x2d\x0d\x36\x0d\x36\x0d\x37\x0c\x37\x0c"
            "\x37\x0c\x37\x0c\x37\x0b\x37\x0c\x35\x0d\x30\x12\x2b"
            "\x17\x2d\x14\x30\x18\x2c\x1b\x39\x0e\x39\x0c\x3a\x0c"
            "\x39\x0d\x39\x0c\x39\x0c\x38\x0d\x38\x0d\x38\x0d\x37"
            "\x0e\x37\x0e\x36\x0f\x05\x00\xff\x01\x31\x0f\x04\x00"
            "\x31\x10\x35\x0f\x03\x00\xff\x01\x32\x10\x02\x00\xff"
            "\x01\x32\x11\x01\x00\xff\x01\x33\x10\x01\x00\xff\x01"
            "\x33\x11\x05\x08\x26\x11\x04\x0a\x25\x11\x03\x0c\x24"
            "\x11\x02\x0e\x23\x11\x01\x10\x22\x11\x00\xff\x03\x12"
            "\x21\x11\x00\xff\x01\x12\x21\x10\x01\x12\x20\x11\x01"
            "\x11\x21\x11\x01\x11\x21\x10\x03\x0f\x22\x10\x03\x0e"
            "\x23\x10\x03\x0d\x23\x10\x05\x0a\x25\x10\x05\x06\x29"
            "\x0f\x06\x06\x28\x10\x07\x06\x27\x0f\x09\x06\x25\x0f"
            "\x0a\x07\x24\x0e\x0c\x07\x22\x0f\x0d\x07\x21\x0e\x0f"
            "\x07\x1f\x0e\x11\x08\x1c\x0e\x13\x09\x19\x0e\x15\x0a"
            "\x15\x0e\x18\x0c\x10\x0f\x1b\x0e\x09\x11\x1e\x24\x21"
            "\x21\x26\x1c\x2b\x16\x32\x0e\x1c" }  },
      /* --- pixel bitmap for cmr1200 char#52 4 --- */
      {  52,26885,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 72,  113, 2,340, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x33\x04\x11\x00\xff\x01\x32\x06\x10\x00\x31\x07\x10"
            "\x00\xff\x01\x30\x08\x10\x00\x2f\x09\x10\x00\xff\x01"
            "\x2e\x0a\x10\x00\xff\x01\x2d\x0b\x10\x00\x2c\x0c\x10"
            "\x00\xff\x01\x2b\x0d\x10\x00\x2a\x0e\x10\x00\xff\x01"
            "\x29\x0f\x10\x00\x28\x10\x10\x00\xff\x01\x27\x11\x10"
            "\x00\x26\x05\x01\x0c\x10\x00\xff\x01\x25\x05\x02\x0c"
            "\x10\x00\x24\x05\x03\x0c\x34\x04\x04\x0c\x33\x05\x04"
            "\x0c\x32\x05\x05\x0c\x32\x04\x06\x0c\x31\x05\x06\x0c"
            "\x30\x05\x07\x0c\x30\x04\x08\x0c\x2f\x05\x08\x0c\x10"
            "\x00\xff\x01\x1e\x05\x09\x0c\x10\x00\x1d\x05\x0a\x0c"
            "\x2d\x04\x0b\x0c\x2c\x05\x0b\x0c\x2b\x05\x0c\x0c\x2b"
            "\x04\x0d\x0c\x2a\x05\x0d\x0c\x29\x05\x0e\x0c\x29\x04"
            "\x0f\x0c\x28\x05\x0f\x0c\x27\x05\x10\x0c\x27\x04\x11"
            "\x0c\x26\x05\x11\x0c\x10\x00\xff\x01\x15\x05\x12\x0c"
            "\x10\x00\x14\x05\x13\x0c\x24\x04\x14\x0c\x23\x05\x14"
            "\x0c\x22\x05\x15\x0c\x22\x04\x16\x0c\x21\x05\x16\x0c"
            "\x20\x05\x17\x0c\x20\x04\x18\x0c\x1f\x05\x18\x0c\x10"
            "\x00\xff\x01\x0e\x05\x19\x0c\x10\x00\x0d\x05\x1a\x0c"
            "\x10\x00\xff\x01\x0c\x05\x1b\x0c\x10\x00\x0b\x05\x1c"
            "\x0c\x1b\x04\x1d\x0c\x1a\x05\x1d\x0c\x19\x05\x1e\x0c"
            "\x19\x04\x1f\x0c\x18\x05\x1f\x0c\x17\x05\x20\x0c\x17"
            "\x04\x21\x0c\x16\x05\x21\x0c\x10\x00\xff\x01\x05\x05"
            "\x22\x0c\x10\x00\x04\x05\x23\x0c\x14\x04\x24\x0c\x13"
            "\x05\x24\x0c\x12\x05\x25\x0c\x12\x04\x26\x0c\x11\x05"
            "\x26\x0c\x10\x05\x27\x0c\x10\xff\x04\x48\xff\x13\x2b"
            "\x0d\x10\x00\x2a\x0f\x38\x11\x34\x17\x0b\x00\xff\x04"
            "\x1b\x2d" }  },
      /* --- pixel bitmap for cmr1200 char#53 5 --- */
      {  53,27243,                      /* character number, location */
        111, 8,   -4, 8,      /* topleft row,col, and botleft row,col */
          { 66,  115, 2,307, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x09\x03\x2c\x03\x10\x05\x27\x06\x10\x08\x21\x09\x10"
            "\x0c\x19\x0d\x10\x12\x0e\x11\x11\x30\x12\x2f\x13\x2e"
            "\x14\x2d\x15\x2c\x16\x2b\x17\x29\x19\x28\x1a\x26\x1c"
            "\x24\x1e\x22\x20\x20\x22\x05\x02\x16\x25\x05\x09\x09"
            "\x22\x00\xff\x15\x09\x05\x34\x00\x09\x05\x0f\x0b\x23"
            "\x05\x0b\x13\x1f\x05\x08\x18\x1d\x05\x06\x1c\x1b\x05"
            "\x05\x0b\x08\x0c\x19\x05\x03\x09\x0e\x0b\x18\x05\x02"
            "\x07\x13\x0a\x17\x05\x01\x06\x16\x0b\x15\x0b\x18\x0b"
            "\x14\x0a\x1a\x0b\x13\x08\x1d\x0b\x12\x07\x1e\x0b\x12"
            "\x07\x1f\x0b\x11\x06\x21\x0b\x10\x05\x22\x0c\x0f\x04"
            "\x23\x0c\x0f\x03\x25\x0c\x36\x0c\x36\x0d\x36\x0c\x04"
            "\x00\xff\x01\x32\x0d\x03\x00\xff\x01\x32\x0e\x02\x00"
            "\x33\x0d\x02\x00\xff\x04\x33\x0e\x01\x00\xff\x03\x33"
            "\x0f\x07\x02\x2a\x0f\x04\x08\x27\x0f\x03\x0a\x26\x0f"
            "\x02\x0c\x25\x0f\x01\x0e\x24\x0f\x00\xff\x03\x10\x23"
            "\x0f\x00\xff\x02\x10\x23\x0e\x01\x0f\x23\x0f\x01\x0e"
            "\x24\x0f\x01\x0d\x25\x0e\x03\x0b\x26\x0e\x03\x04\x02"
            "\x02\x29\x0e\x03\x05\x2c\x0d\x04\x05\x2b\x0e\x05\x04"
            "\x2b\x0d\x06\x05\x2a\x0d\x07\x04\x29\x0d\x08\x05\x28"
            "\x0d\x09\x05\x26\x0d\x0a\x05\x26\x0c\x0c\x05\x24\x0c"
            "\x0d\x06\x23\x0c\x0e\x06\x21\x0c\x10\x06\x1f\x0c\x12"
            "\x06\x1d\x0c\x14\x06\x1b\x0c\x16\x07\x18\x0c\x18\x08"
            "\x14\x0d\x1a\x09\x10\x0d\x1d\x0c\x09\x0f\x1f\x21\x23"
            "\x1d\x27\x19\x2b\x14\x32\x0c\x1e" }  },
      /* --- pixel bitmap for cmr1200 char#54 6 --- */
      {  54,27608,                      /* character number, location */
        111, 7,   -4, 7,      /* topleft row,col, and botleft row,col */
          { 68,  115, 2,395, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x25\x0c\x34\x14\x2d\x19\x29\x1d\x25\x0d\x09\x0a\x23"
            "\x0b\x10\x07\x20\x0b\x14\x06\x1e\x0a\x17\x06\x1c\x09"
            "\x1a\x06\x19\x0a\x1c\x05\x18\x0a\x1c\x01\x01\x05\x16"
            "\x0a\x1a\x0a\x15\x0a\x19\x0c\x14\x0a\x19\x0e\x12\x0a"
            "\x1a\x0e\x12\x0a\x19\x0f\x11\x0a\x1a\x0f\x10\x0a\x1b"
            "\x0f\x0f\x0b\x1b\x0f\x0f\x0a\x1c\x0f\x0e\x0b\x1c\x0f"
            "\x04\x00\xff\x01\x09\x0b\x1e\x0d\x05\x00\x08\x0b\x20"
            "\x0b\x0e\x0b\x22\x07\x0f\x0c\x38\x0b\x32\x00\xff\x01"
            "\x06\x0c\x32\x00\xff\x01\x05\x0c\x33\x00\xff\x02\x04"
            "\x0d\x33\x00\xff\x02\x03\x0d\x34\x00\xff\x01\x02\x0e"
            "\x34\x00\x02\x0e\x13\x01\x22\x0e\x0d\x0f\x1a\x0d\x0c"
            "\x14\x16\x0e\x0a\x18\x14\x0e\x09\x1b\x12\x0e\x08\x07"
            "\x0b\x0b\x11\x0e\x07\x05\x10\x0a\x10\x0e\x06\x05\x12"
            "\x0b\x0e\x0e\x05\x04\x16\x0a\x0c\x0f\x04\x04\x18\x0a"
            "\x0b\x0f\x03\x04\x19\x0b\x0a\x0f\x03\x04\x1a\x0a\x0a"
            "\x0f\x02\x04\x1c\x0a\x09\x0f\x02\x03\x1d\x0b\x08\x0f"
            "\x01\x04\x1e\x0b\x07\x0f\x01\x03\x1f\x0c\x06\x13\x20"
            "\x0b\x06\x13\x20\x0c\x05\x12\x21\x0d\x04\x12\x22\x0c"
            "\x04\xff\x02\x11\x23\x0d\x03\x11\x23\x0e\x02\x10\x25"
            "\x0d\x02\xff\x04\x10\x25\x0e\x01\xff\x01\x0f\x26\x0f"
            "\xff\x07\x01\x0e\x26\x0f\xff\x01\x02\x0d\x26\x0f\xff"
            "\x02\x02\x0e\x25\x0f\x03\x0d\x25\x0f\xff\x01\x03\x0d"
            "\x25\x0e\x01\x00\xff\x01\x04\x0c\x25\x0e\x01\x00\x04"
            "\x0c\x25\x0d\x06\x0d\x23\x0e\x07\x0c\x23\x0e\x07\x0c"
            "\x23\x0d\x03\x00\xff\x01\x06\x0b\x23\x0d\x03\x00\x07"
            "\x0b\x21\x0d\x0b\x0b\x21\x0c\x0d\x0a\x21\x0c\x0d\x0b"
            "\x1f\x0c\x0f\x0a\x1f\x0c\x0f\x0b\x1e\x0b\x11\x0a\x1d"
            "\x0b\x13\x0a\x1b\x0b\x14\x0b\x1a\x0a\x16\x0a\x19\x0a"
            "\x18\x0a\x17\x0a\x1a\x0b\x14\x0a\x1c\x0b\x11\x0b\x1e"
            "\x0c\x0d\x0c\x21\x0d\x07\x0e\x23\x20\x26\x1c\x2a\x18"
            "\x2e\x14\x34\x0c\x1b" }  },
      /* --- pixel bitmap for cmr1200 char#55 7 --- */
      {  55,28053,                      /* character number, location */
        112, 9,   -4, 9,      /* topleft row,col, and botleft row,col */
          { 71,  116, 2,255, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x01\x06\x04\x3d\x00\x05\x06\x41\x08\x3f\x0e\x34"
            "\x00\xff\x02\x05\x42\xff\x01\x04\x43\x04\x42\x01\x00"
            "\xff\x01\x04\x41\x02\x00\x04\x40\x06\x40\x04\x00\xff"
            "\x01\x03\x3f\x05\x00\x03\x3e\x09\x07\x30\x06\x0a\x05"
            "\x31\x07\x09\x05\x32\x06\x0a\x05\x31\x06\x0b\x05\x30"
            "\x07\x0b\x04\x30\x07\x0c\x04\x30\x06\x0c\x05\x2f\x06"
            "\x0d\x04\x2f\x07\x0d\x04\x2f\x06\x0e\x04\x2e\x06\x0f"
            "\x04\x2d\x07\x0f\x04\x2c\x07\x0f\x04\x2d\x06\x10\x04"
            "\x2c\x06\x11\x04\x2b\x07\x40\x06\x40\x06\x40\x07\x40"
            "\x06\x40\x06\x40\x07\x3f\x07\x40\x06\x40\x06\x40\x07"
            "\x40\x06\x40\x07\x40\x06\x40\x06\x40\x07\x40\x06\x1c"
            "\x00\xff\x01\x24\x07\x1c\x00\x23\x07\x3f\x08\x3f\x07"
            "\x1e\x00\xff\x01\x21\x08\x1e\x00\xff\x01\x20\x08\x1f"
            "\x00\x1f\x09\x3e\x08\x20\x00\xff\x02\x1e\x09\x20\x00"
            "\xff\x01\x1d\x09\x21\x00\xff\x01\x1c\x0a\x21\x00\xff"
            "\x02\x1b\x0a\x22\x00\xff\x02\x1a\x0b\x22\x00\x19\x0c"
            "\x22\x00\xff\x01\x19\x0b\x23\x00\xff\x03\x18\x0c\x23"
            "\x00\xff\x03\x17\x0d\x23\x00\xff\x04\x16\x0d\x24\x00"
            "\xff\x06\x15\x0e\x24\x00\xff\x0e\x14\x0f\x24\x00\x15"
            "\x0d\x3b\x0b\x3d\x09\x40\x05\x29" }  },
      /* --- pixel bitmap for cmr1200 char#56 8 --- */
      {  56,28334,                      /* character number, location */
        111, 7,   -4, 7,      /* topleft row,col, and botleft row,col */
          { 68,  115, 2,401, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1c\x0c\x34\x15\x2c\x1a\x28\x1f\x24\x0b\x09\x0d\x21"
            "\x09\x11\x0b\x1e\x08\x15\x0a\x1c\x07\x19\x0a\x19\x06"
            "\x1d\x09\x17\x06\x1f\x09\x15\x06\x21\x09\x13\x06\x23"
            "\x08\x12\x06\x25\x08\x10\x06\x26\x09\x0f\x06\x27\x08"
            "\x07\x00\xff\x01\x07\x06\x29\x08\x06\x00\x06\x07\x2a"
            "\x08\x0b\x06\x2b\x08\x0a\x07\x2b\x08\x0a\x07\x2b\x09"
            "\x09\x07\x2c\x08\x04\x00\xff\x02\x04\x08\x2c\x08\x04"
            "\x00\xff\x02\x04\x09\x2b\x08\x04\x00\x04\x0a\x2a\x08"
            "\x08\x0a\x29\x09\x08\x0b\x28\x08\x09\x0c\x27\x08\x09"
            "\x0d\x25\x09\x0a\x0d\x24\x08\x0b\x0e\x23\x08\x0b\x10"
            "\x20\x08\x0c\x11\x1f\x08\x0d\x12\x1c\x08\x0e\x13\x1a"
            "\x08\x10\x14\x17\x09\x10\x15\x16\x08\x12\x16\x13\x08"
            "\x13\x17\x11\x08\x15\x18\x0e\x08\x17\x18\x0b\x09\x19"
            "\x19\x08\x08\x1c\x19\x06\x08\x1e\x1a\x02\x09\x20\x22"
            "\x23\x1f\x26\x1d\x29\x1b\x2a\x1c\x2a\x1b\x2a\x1c\x29"
            "\x1c\x26\x20\x22\x23\x20\x09\x01\x1c\x1c\x09\x05\x1b"
            "\x1a\x08\x08\x1b\x17\x09\x0b\x1a\x15\x08\x0e\x1a\x13"
            "\x08\x11\x19\x11\x08\x14\x18\x0f\x08\x16\x17\x0e\x08"
            "\x19\x16\x0c\x08\x1b\x16\x0a\x08\x1e\x14\x0a\x08\x1f"
            "\x14\x08\x08\x22\x12\x07\x08\x24\x12\x06\x08\x26\x10"
            "\x05\x08\x28\x0f\x04\x09\x2a\x0e\x03\x08\x2c\x0d\x03"
            "\x08\x2d\x0c\x02\x09\x2e\x0c\x01\x08\x2f\x0c\x01\x08"
            "\x30\x0b\x01\x08\x31\x12\x32\x0a\x00\xff\x02\x08\x33"
            "\x09\x00\xff\x03\x08\x34\x08\x00\x08\x34\x07\x01\xff"
            "\x01\x09\x33\x07\x01\x00\x01\x08\x33\x07\x02\x08\x32"
            "\x07\x03\x09\x31\x07\x04\x08\x31\x06\x05\x09\x2f\x07"
            "\x06\x08\x2f\x06\x07\x09\x2d\x07\x08\x08\x2d\x06\x09"
            "\x09\x2b\x07\x0a\x09\x29\x07\x0c\x09\x27\x07\x0e\x09"
            "\x25\x07\x10\x09\x23\x07\x12\x0a\x1f\x08\x14\x0b\x1b"
            "\x09\x16\x0c\x17\x0a\x18\x0d\x12\x0c\x1b\x0f\x0a\x0e"
            "\x1f\x24\x22\x20\x26\x1b\x2c\x16\x32\x0d\x1c" }  },
      /* --- pixel bitmap for cmr1200 char#57 9 --- */
      {  57,28763,                      /* character number, location */
        111, 7,   -4, 7,      /* topleft row,col, and botleft row,col */
          { 68,  115, 2,399, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1c\x0c\x34\x14\x2d\x19\x2a\x1c\x26\x0d\x07\x0c\x22"
            "\x0b\x0e\x0a\x20\x0a\x12\x09\x1e\x0a\x14\x09\x1c\x0a"
            "\x16\x09\x1a\x0a\x18\x09\x18\x0a\x1a\x09\x16\x0a\x1b"
            "\x0a\x14\x0b\x1c\x0a\x12\x0b\x1d\x0a\x11\x0b\x1f\x0a"
            "\x10\x0b\x1f\x0b\x0e\x0b\x21\x0a\x0d\x0c\x21\x0b\x0c"
            "\x0c\x22\x0a\x0b\x0c\x23\x0b\x09\x0d\x23\x0b\x06\x00"
            "\xff\x01\x03\x0d\x23\x0c\x05\x00\x02\x0e\x24\x0b\x07"
            "\x0e\x24\x0c\x06\x0d\x25\x0c\x05\x0e\x25\x0c\x04\x00"
            "\xff\x02\x01\x0e\x25\x0d\x03\x0f\x25\x0d\x03\xff\x01"
            "\x0f\x25\x0e\x02\xff\x02\x0f\x26\x0d\x02\xff\x06\x0f"
            "\x26\x0e\x01\xff\x02\x0f\x26\x0f\xff\x03\x01\x0e\x25"
            "\x10\x02\x0d\x25\x10\x02\x0e\x24\x10\x02\x0e\x23\x11"
            "\xff\x02\x03\x0d\x23\x11\x04\x0c\x22\x12\x05\x0c\x21"
            "\x12\x05\x0c\x20\x13\x06\x0b\x20\x13\x06\x0c\x1f\x03"
            "\x01\x0f\x07\x0b\x1e\x04\x01\x0f\x08\x0b\x1d\x03\x02"
            "\x0f\x09\x0a\x1c\x04\x02\x0f\x0a\x0a\x1a\x04\x03\x0f"
            "\x0b\x0a\x18\x05\x03\x0f\x0b\x0a\x18\x04\x04\x0f\x0c"
            "\x0a\x16\x04\x05\x0e\x0f\x0a\x12\x05\x06\x0e\x10\x0a"
            "\x10\x05\x07\x0e\x11\x0b\x0b\x07\x08\x0e\x12\x1b\x09"
            "\x0e\x14\x18\x0a\x0e\x16\x14\x0c\x0d\x1a\x0f\x0d\x0e"
            "\x22\x01\x13\x0e\x02\x00\xff\x01\x34\x0e\x02\x00\xff"
            "\x02\x34\x0d\x03\x00\x34\x0c\x04\x00\xff\x01\x33\x0d"
            "\x04\x00\xff\x01\x33\x0c\x05\x00\x32\x0d\x05\x00\xff"
            "\x01\x32\x0c\x06\x00\x32\x0b\x0f\x07\x22\x0c\x0d\x0b"
            "\x20\x0b\x0d\x0d\x1e\x0c\x0d\x0d\x1e\x0b\x0d\x0f\x1d"
            "\x0a\x0e\x0f\x1c\x0b\x0e\x0f\x1c\x0a\x0f\x0f\x1b\x0a"
            "\x10\x0f\x1a\x0b\x10\x0f\x1a\x0a\x11\x0e\x1a\x0a\x12"
            "\x0e\x19\x0a\x14\x0c\x19\x0a\x15\x0a\x1b\x0a\x15\x05"
            "\x01\x01\x1c\x0b\x17\x05\x1c\x0b\x19\x06\x19\x0a\x1b"
            "\x08\x15\x0b\x1d\x09\x11\x0c\x1f\x0c\x0a\x0e\x22\x20"
            "\x25\x1d\x29\x19\x2d\x15\x33\x0d\x23" }  },
      /* --- pixel bitmap for cmr1200 char#58 : --- */
      {  58,38913,                      /* character number, location */
         71,14,    0,14,      /* topleft row,col, and botleft row,col */
          { 18,   71, 3,97, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x7c\x5e\x20\xf1\x1e\x02\x1f\x5e\x04\xf1\x1e"
            "\x02\x10\x2e\x5c\x7a\xa6\x60\xfe\xe0\x40\xfe\xe0\x40"
            "\xf4\xe0\x40\x66\xaa\x7c\x5e\x20\xf1\x1e\x02\x1f\x5e"
            "\x04\xf1\x1e\x02\x10\x2e\x5c\x7a\xa6\x68" }  },
      /* --- pixel bitmap for cmr1200 char#59 ; --- */
      {  59,38994,                      /* character number, location */
         71,14,  -32,14,      /* topleft row,col, and botleft row,col */
          { 18,  103, 3,175, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x7c\x5e\x20\xf1\x1e\x02\x1f\x5e\x04\xf1\x1e"
            "\x02\x10\x2e\x5c\x7a\xa6\x60\xfe\xe0\x40\xfe\xe0\x40"
            "\xf4\xe0\x40\x66\xa9\x8b\x6d\x30\xf1\x1e\x01\x2f\x2e"
            "\x03\x1f\x2e\x04\xf1\x1e\x03\x2e\x02\x3e\x01\x4e\x66"
            "\x24\xf5\xe4\xd5\xf3\xd4\x10\xc5\x10\xf1\xc4\x20\xb5"
            "\x20\xf1\xb4\x30\xa5\xd4\xd5\xd4\xd5\xd4\xd5\xc5\xd4"
            "\xd5\xc5\x90\xf1\x35\xa0\x34\xe0\x12\xc0" }  },
      /* --- pixel bitmap for cmr1200 char#60 (noname) --- */
      {  60,35496,                      /* character number, location */
         83,14,  -36,14,      /* topleft row,col, and botleft row,col */
          { 18,  119, 3,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x66\xaa\x7c\x5e\x3e\x02\x1f\x7e\x04\x1e\x02\x3e\x5c"
            "\x7a\xa6\x60\xfd\xe0\x40\xf5\x74\x70\xfa\x66\x60\xfa"
            "\x58\x50\xfa\x4a\x40\xfa\x3c\x30\xfa\x2e\x20\xfa\x1e"
            "\x02\x1f\x9e\x04\x1e\x02\x3e\x5c\x7a\xa6\x60" }  },
      /* --- pixel bitmap for cmr1200 char#61 = --- */
      {  61,39141,                      /* character number, location */
         62, 9,   21, 9,      /* topleft row,col, and botleft row,col */
          { 110,   41, 2,31, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x01\x01\x6c\x01\xff\x02\x6e\x01\x6c\x03\x6a\x02"
            "\x00\xff\x1a\x6e\x00\x02\x6a\x03\x6c\x01\xff\x02\x6e"
            "\xff\x01\x01\x6c\x01" }  },
      /* --- pixel bitmap for cmr1200 char#62 (noname) --- */
      {  62,30687,                      /* character number, location */
         83, 9,  -34, 9,      /* topleft row,col, and botleft row,col */
          { 59,  117, 2,225, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x18\x06\x33\x0a\x30\x0c\x2e\x0e\x2c\x10\x18\x00\xff"
            "\x07\x12\x12\x17\x00\x13\x10\x2c\x0e\x2e\x0c\x30\x0a"
            "\x33\x06\x1d\x00\xff\x0d\x3b\x00\xff\x0f\x19\x04\x1e"
            "\x00\xff\x02\x18\x05\x1e\x00\xff\x01\x18\x04\x1f\x00"
            "\xff\x02\x17\x05\x1f\x00\xff\x01\x16\x06\x1f\x00\x16"
            "\x05\x20\x00\xff\x01\x15\x06\x20\x00\x14\x07\x34\x06"
            "\x21\x00\xff\x01\x13\x07\x21\x00\x12\x07\x22\x00\xff"
            "\x01\x11\x08\x22\x00\x10\x08\x32\x09\x32\x08\x32\x09"
            "\x31\x0a\x30\x0a\x30\x0b\x2f\x0b\x2f\x0b\x2f\x0c\x2e"
            "\x0c\x2e\x0c\x2e\x0d\x2d\x0d\x2d\x0e\x2d\x0d\x2d\x0e"
            "\x2d\x0d\x2d\x0e\x2d\x0e\x22\x05\x06\x0e\x20\x09\x03"
            "\x0e\x20\x0b\x02\xff\x01\x0e\x1f\x0d\x01\xff\x05\x0e"
            "\x1e\x0f\x00\x0e\x1f\x1c\x20\x0c\x02\x0d\x21\x0b\x02"
            "\x0d\x22\x0a\x02\x0d\x27\x04\x04\x0c\x26\x05\x04\x0d"
            "\x24\x05\x06\x0c\x23\x05\x07\x0c\x22\x06\x08\x0c\x20"
            "\x06\x0a\x0b\x1e\x07\x0c\x0b\x1b\x08\x0e\x0b\x17\x09"
            "\x11\x0c\x12\x0b\x13\x0e\x0a\x0e\x17\x22\x1b\x1e\x1f"
            "\x18\x28\x0e\x19" }  },
      /* --- pixel bitmap for cmr1200 char#63 ? --- */
      {  63,30420,                      /* character number, location */
        117, 9,    0, 9,      /* topleft row,col, and botleft row,col */
          { 59,  117, 2,225, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x15\x0f\x28\x18\x20\x1e\x1b\x23\x17\x0b\x0b\x0f\x14"
            "\x09\x13\x0d\x11\x07\x18\x0c\x0f\x06\x1b\x0c\x0d\x06"
            "\x1e\x0b\x0b\x05\x20\x0c\x09\x05\x22\x0c\x07\x05\x24"
            "\x0c\x06\x04\x25\x0d\x04\x05\x25\x0d\x04\x04\x26\x0e"
            "\x02\x0a\x22\x0d\x02\x0b\x21\x0d\x02\x0c\x20\x0d\x01"
            "\x0e\x1f\x0e\x00\xff\x05\x0f\x1e\x0e\xff\x01\x01\x0d"
            "\x1f\x0e\x02\x0b\x1f\x0e\x04\x09\x20\x0e\x06\x05\x22"
            "\x0e\x2d\x0d\x2d\x0e\x2d\x0d\x2d\x0e\x2d\x0d\x2d\x0d"
            "\x2d\x0d\x2d\x0d\x2d\x0d\x2d\x0d\x2d\x0c\x2f\x0b\x2f"
            "\x0b\x2f\x0b\x30\x09\x31\x09\x11\x00\xff\x01\x20\x09"
            "\x12\x00\x1f\x09\x32\x08\x32\x08\x33\x07\x33\x08\x33"
            "\x07\x34\x06\x34\x07\x18\x00\xff\x01\x1c\x06\x19\x00"
            "\xff\x01\x1b\x06\x1a\x00\xff\x01\x1b\x05\x1b\x00\xff"
            "\x02\x1a\x05\x1c\x00\xff\x01\x1a\x04\x1d\x00\xff\x02"
            "\x19\x05\x1d\x00\xff\x0e\x19\x04\x1e\x00\xff\x0d\x3b"
            "\x00\x18\x06\x33\x0a\x30\x0c\x2e\x0e\x2c\x10\x18\x00"
            "\xff\x07\x12\x12\x17\x00\x13\x10\x2c\x0e\x2e\x0c\x30"
            "\x0a\x33\x06\x1d" }  },
      /* --- pixel bitmap for cmr1200 char#64 @ --- */
      {  64,39192,                      /* character number, location */
        117, 9,   -2, 9,      /* topleft row,col, and botleft row,col */
          { 110,  119, 2,601, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x30\x0e\x5a\x1a\x51\x20\x4b\x26\x46\x0f\x0c\x0f\x42"
            "\x0c\x16\x0c\x3e\x0a\x1e\x0a\x3a\x09\x24\x09\x37\x08"
            "\x28\x08\x34\x08\x2c\x08\x31\x07\x30\x07\x2f\x06\x34"
            "\x06\x2c\x07\x36\x07\x29\x06\x3a\x06\x27\x06\x3c\x06"
            "\x25\x06\x3e\x06\x23\x06\x40\x06\x21\x06\x42\x06\x1f"
            "\x06\x44\x06\x1d\x06\x46\x06\x1b\x06\x48\x06\x1a\x05"
            "\x4a\x05\x19\x05\x4c\x05\x17\x05\x21\x0b\x22\x05\x15"
            "\x05\x1e\x12\x20\x05\x14\x05\x1c\x17\x1d\x05\x13\x05"
            "\x1b\x1a\x1d\x05\x12\x04\x1a\x0d\x07\x0a\x1c\x04\x11"
            "\x05\x19\x0b\x0d\x08\x1b\x05\x0f\x05\x18\x0b\x11\x07"
            "\x1b\x05\x0e\x05\x17\x0b\x14\x07\x19\x05\x0d\x05\x17"
            "\x0a\x18\x06\x19\x05\x0c\x04\x17\x0a\x1a\x05\x1a\x04"
            "\x0b\x05\x16\x0a\x1c\x05\x19\x05\x0a\x05\x15\x0b\x1d"
            "\x05\x18\x05\x0a\x04\x15\x0b\x1f\x05\x18\x04\x09\x05"
            "\x14\x0b\x21\x05\x17\x05\x08\x04\x15\x0b\x21\x0e\x0f"
            "\x04\x07\x05\x14\x0b\x23\x0e\x0e\x05\x06\x04\x14\x0c"
            "\x24\x0d\x0f\x04\x06\x04\x14\x0b\x25\x0d\x0f\x04\x05"
            "\x05\x13\x0c\x26\x0c\x0f\x05\x04\x05\x13\x0b\x27\x0c"
            "\x0f\x05\x04\x04\x13\x0c\x27\x0c\x10\x04\x04\x04\x13"
            "\x0b\x28\x0c\x10\x04\x03\x05\x12\x0c\x28\x0c\x10\x05"
            "\x01\x00\xff\x01\x01\x04\x13\x0c\x28\x0c\x11\x04\x01"
            "\x00\xff\x02\x01\x04\x12\x0c\x29\x0c\x11\x04\x01\x05"
            "\x12\x0c\x29\x0c\x11\x09\x13\x0c\x29\x0c\x12\x04\x00"
            "\xff\x0c\x04\x12\x0c\x2a\x0c\x12\x04\x00\x04\x13\x0c"
            "\x29\x0c\x12\x09\x12\x0c\x29\x0c\x12\x04\xff\x02\x01"
            "\x04\x12\x0c\x29\x0c\x12\x04\xff\x01\x01\x04\x13\x0c"
            "\x28\x0c\x12\x04\x01\x05\x12\x0c\x28\x0c\x12\x03\x03"
            "\x04\x13\x0b\x28\x0c\x11\x04\x03\x04\x13\x0c\x27\x0c"
            "\x11\x04\x03\x05\x13\x0b\x27\x0c\x11\x04\x03\x05\x13"
            "\x0c\x26\x0c\x11\x04\x04\x04\x14\x0b\x25\x0d\x11\x04"
            "\x04\x04\x14\x0c\x24\x0d\x11\x04\x04\x05\x14\x0b\x23"
            "\x0e\x11\x03\x06\x04\x15\x0b\x21\x0f\x10\x04\x06\x05"
            "\x14\x0b\x21\x0f\x10\x04\x07\x04\x15\x0b\x1f\x10\x10"
            "\x04\x07\x05\x15\x0b\x1d\x11\x0f\x04\x08\x05\x16\x0a"
            "\x1c\x05\x01\x0c\x0f\x04\x09\x04\x17\x0a\x1a\x05\x03"
            "\x0c\x0d\x05\x09\x05\x17\x0a\x18\x06\x03\x0c\x0d\x04"
            "\x0b\x05\x17\x0b\x14\x07\x05\x0b\x0c\x05\x0b\x05\x18"
            "\x0b\x11\x07\x07\x0c\x0a\x05\x0d\x05\x19\x0b\x0d\x08"
            "\x09\x0b\x09\x05\x0f\x04\x1a\x0d\x07\x0a\x0b\x0c\x05"
            "\x06\x10\x05\x1b\x1a\x0e\x15\x12\x05\x1c\x17\x11\x12"
            "\x13\x05\x1e\x12\x16\x0f\x15\x05\x21\x0b\x1c\x09\x19"
            "\x05\x6a\x05\x69\x06\x69\x06\x69\x06\x69\x06\x69\x06"
            "\x69\x06\x69\x06\x4b\x0a\x14\x06\x48\x0c\x15\x07\x44"
            "\x0e\x17\x06\x41\x0e\x1a\x07\x3c\x0f\x1d\x08\x37\x0f"
            "\x22\x08\x32\x10\x25\x09\x2d\x10\x2a\x0a\x25\x12\x2f"
            "\x0c\x1c\x14\x34\x0f\x10\x18\x39\x31\x40\x29\x48\x21"
            "\x53\x13\x2b" }  },
      /* --- pixel bitmap for cmr1200 char#65 A --- */
      {  65,   35,                      /* character number, location */
        119, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 114,  119, 2,448, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x37\x04\x6d\x06\x36\x00\xff\x02\x35\x08\x35\x00\xff"
            "\x02\x34\x0a\x34\x00\xff\x02\x33\x0c\x33\x00\xff\x02"
            "\x32\x0e\x32\x00\xff\x02\x31\x10\x31\x00\xff\x02\x30"
            "\x12\x30\x00\xff\x02\x2f\x14\x2f\x00\x2e\x16\x2e\x00"
            "\xff\x01\x2e\x05\x02\x0f\x2e\x00\x2d\x05\x03\x10\x2d"
            "\x00\xff\x01\x2d\x05\x04\x0f\x2d\x00\x2c\x05\x05\x10"
            "\x58\x05\x06\x0f\x57\x06\x06\x10\x56\x05\x07\x10\x56"
            "\x05\x08\x0f\x55\x06\x08\x10\x2a\x00\xff\x01\x2a\x05"
            "\x0a\x0f\x2a\x00\x29\x06\x0a\x10\x29\x00\xff\x01\x29"
            "\x05\x0c\x0f\x29\x00\x28\x06\x0c\x10\x28\x00\xff\x01"
            "\x28\x05\x0e\x0f\x28\x00\x27\x06\x0e\x10\x27\x00\xff"
            "\x01\x27\x05\x10\x0f\x27\x00\x26\x06\x10\x10\x26\x00"
            "\xff\x01\x26\x05\x12\x0f\x26\x00\x25\x06\x12\x10\x25"
            "\x00\xff\x01\x25\x05\x14\x0f\x25\x00\x24\x06\x14\x10"
            "\x24\x00\xff\x01\x24\x05\x16\x0f\x24\x00\x23\x05\x17"
            "\x10\x23\x00\xff\x01\x23\x05\x18\x0f\x23\x00\x22\x05"
            "\x19\x10\x44\x05\x1a\x0f\x43\x06\x1a\x10\x42\x05\x1b"
            "\x10\x42\x05\x1c\x0f\x41\x06\x1c\x10\x20\x00\xff\x01"
            "\x20\x05\x1e\x0f\x20\x00\x1f\x06\x1e\x10\x1f\x00\xff"
            "\x01\x1f\x05\x20\x0f\x1f\x00\x1e\x06\x20\x10\x1e\x00"
            "\xff\x01\x1e\x05\x22\x0f\x1e\x00\x1d\x06\x22\x10\x1d"
            "\x00\xff\x01\x1d\x05\x24\x0f\x1d\x00\x1c\x06\x24\x10"
            "\x1c\x00\xff\x01\x1c\x3a\x1c\x00\xff\x02\x1b\x3c\x1b"
            "\x00\x1a\x06\x28\x10\x1a\x00\xff\x01\x1a\x05\x2a\x0f"
            "\x1a\x00\x19\x05\x2b\x10\x32\x05\x2c\x0f\x31\x06\x2c"
            "\x10\x30\x05\x2d\x10\x30\x05\x2e\x0f\x2f\x06\x2e\x10"
            "\x17\x00\xff\x01\x17\x05\x30\x0f\x17\x00\x16\x06\x30"
            "\x10\x16\x00\xff\x01\x16\x05\x32\x0f\x16\x00\x15\x06"
            "\x32\x10\x15\x00\xff\x01\x15\x05\x34\x0f\x15\x00\x14"
            "\x06\x34\x10\x14\x00\xff\x01\x14\x05\x36\x0f\x14\x00"
            "\x13\x06\x36\x10\x26\x05\x38\x0f\x25\x06\x38\x0f\x25"
            "\x06\x38\x10\x24\x06\x39\x0f\x23\x07\x39\x0f\x22\x08"
            "\x39\x10\x20\x0a\x38\x10\x1f\x0b\x38\x11\x1d\x0d\x37"
            "\x11\x1c\x0f\x35\x13\x19\x13\x32\x15\x14\x1a\x2c\x1b"
            "\x0b\xff\x04\x24\x20\x2e" }  },
      /* --- pixel bitmap for cmr1200 char#66 B --- */
      {  66,  460,                      /* character number, location */
        113, 6,    0, 6,      /* topleft row,col, and botleft row,col */
          { 102,  113, 2,355, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x00\x44\x22\x48\x1e\x4c\x1a\x4e\x18\x50\x22\x16\x1f"
            "\x11\x23\x11\x24\x10\x22\x0f\x27\x0f\x22\x0e\x28\x10"
            "\x20\x0e\x2a\x0f\x1f\x0e\x2b\x0f\x1e\x0e\x2c\x0f\x1d"
            "\x0e\x2d\x0f\x1c\x0e\x2d\x10\x1b\x0e\x2e\x0f\x1b\x0e"
            "\x2f\x0f\x1a\x0e\x2f\x10\x19\x0e\x30\x0f\x08\x00\xff"
            "\x01\x11\x0e\x30\x10\x07\x00\xff\x02\x11\x0e\x31\x10"
            "\x06\x00\xff\x09\x11\x0e\x32\x10\x05\x00\xff\x02\x11"
            "\x0e\x31\x10\x06\x00\xff\x01\x11\x0e\x30\x10\x07\x00"
            "\xff\x01\x11\x0e\x2f\x10\x08\x00\x11\x0e\x2e\x10\x1a"
            "\x0e\x2e\x0f\x1b\x0e\x2d\x0f\x1c\x0e\x2c\x0f\x1d\x0e"
            "\x2b\x10\x1d\x0e\x2a\x0f\x1f\x0e\x29\x0f\x20\x0e\x28"
            "\x0f\x21\x0e\x26\x0f\x23\x0e\x25\x0f\x24\x0e\x22\x10"
            "\x26\x0e\x1f\x11\x28\x3b\x2b\x38\x2e\x3b\x2b\x3e\x28"
            "\x0e\x23\x10\x25\x0e\x27\x0e\x23\x0e\x29\x0e\x21\x0e"
            "\x2b\x0e\x1f\x0e\x2c\x0e\x1e\x0e\x2d\x0f\x1c\x0e\x2e"
            "\x0f\x1b\x0e\x2f\x0f\x1a\x0e\x30\x0f\x19\x0e\x31\x0f"
            "\x18\x0e\x32\x0f\x17\x0e\x32\x10\x16\x0e\x33\x0f\x16"
            "\x0e\x33\x10\x04\x00\xff\x01\x11\x0e\x34\x10\x03\x00"
            "\xff\x01\x11\x0e\x35\x10\x02\x00\x11\x0e\x35\x11\x01"
            "\x00\xff\x02\x11\x0e\x36\x10\x01\x00\xff\x09\x11\x0e"
            "\x36\x11\xff\x01\x11\x0e\x36\x10\x01\x00\x11\x0e\x35"
            "\x11\x01\x00\xff\x01\x11\x0e\x35\x10\x02\x00\x11\x0e"
            "\x34\x11\x13\x0e\x34\x10\x14\x0e\x33\x11\x14\x0e\x32"
            "\x11\x15\x0e\x32\x10\x16\x0e\x31\x11\x16\x0e\x30\x11"
            "\x17\x0e\x2f\x11\x18\x0e\x2e\x11\x19\x0e\x2d\x11\x1a"
            "\x0e\x2c\x11\x1b\x0e\x2a\x12\x1b\x0f\x28\x12\x1c\x11"
            "\x25\x13\x1a\x16\x20\x14\x10\x55\x11\x52\x14\x50\x16"
            "\x4d\x19\x48\x1e" }  },
      /* --- pixel bitmap for cmr1200 char#67 C --- */
      {  67,  901,                      /* character number, location */
        117, 9,   -4, 9,      /* topleft row,col, and botleft row,col */
          { 101,  121, 2,385, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x32\x0f\x21\x03\x2d\x18\x1c\x04\x29\x1f\x18\x05\x26"
            "\x24\x16\x05\x24\x28\x13\x06\x22\x14\x0b\x0d\x10\x07"
            "\x20\x11\x14\x0a\x0f\x07\x1e\x10\x1a\x09\x0c\x08\x1c"
            "\x10\x1e\x08\x0a\x09\x1b\x0f\x22\x07\x09\x09\x19\x0f"
            "\x25\x07\x07\x0a\x18\x0e\x29\x06\x05\x0b\x17\x0e\x2b"
            "\x06\x04\x0b\x16\x0d\x2e\x06\x02\x0c\x14\x0e\x30\x13"
            "\x13\x0e\x32\x12\x12\x0e\x34\x11\x11\x0e\x36\x10\x10"
            "\x0e\x37\x10\x0f\x0e\x39\x0f\x0f\x0d\x3b\x0e\x0e\x0d"
            "\x3d\x0d\x0d\x0e\x3d\x0d\x0c\x0e\x3f\x0c\x0b\x0e\x40"
            "\x0c\x0b\x0e\x41\x0b\x0a\x0e\x42\x0b\x09\x0f\x43\x0a"
            "\x09\x0e\x44\x0a\x08\x0f\x45\x09\x08\x0e\x46\x09\xff"
            "\x01\x07\x0f\x47\x08\x06\x0f\x48\x08\x06\x0f\x49\x07"
            "\xff\x01\x05\x0f\x4a\x07\x04\x10\x4a\x07\x04\x10\x4b"
            "\x06\x04\x0f\x4c\x06\xff\x02\x03\x10\x4c\x06\xff\x02"
            "\x02\x10\x4e\x05\xff\x01\x01\x11\x4e\x05\xff\x01\x01"
            "\x11\x53\x00\xff\x01\x01\x10\x54\xff\x10\x11\x54\x00"
            "\xff\x01\x01\x10\x54\x00\xff\x03\x01\x11\x53\x00\xff"
            "\x02\x02\x10\x4f\x04\xff\x02\x03\x10\x4e\x04\x04\x0f"
            "\x4e\x04\x04\x10\x4d\x04\x04\x10\x4c\x05\xff\x01\x05"
            "\x0f\x4c\x04\x01\x00\x06\x0f\x4b\x04\x07\x0f\x4a\x05"
            "\x01\x00\xff\x01\x07\x0f\x49\x04\x02\x00\x08\x0e\x49"
            "\x04\x0a\x0f\x47\x05\x0b\x0e\x47\x04\x0c\x0f\x45\x05"
            "\x0d\x0e\x45\x04\x0f\x0e\x43\x05\x0f\x0e\x43\x04\x11"
            "\x0e\x41\x05\x12\x0e\x40\x04\x14\x0d\x3f\x05\x15\x0d"
            "\x3d\x05\x16\x0e\x3c\x05\x17\x0e\x3a\x05\x19\x0e\x38"
            "\x05\x1b\x0e\x36\x05\x1d\x0e\x34\x06\x1e\x0e\x32\x06"
            "\x21\x0d\x30\x06\x23\x0e\x2d\x06\x25\x0e\x2a\x07\x27"
            "\x0f\x27\x07\x2a\x0f\x23\x08\x2c\x10\x1f\x08\x30\x10"
            "\x1b\x09\x33\x11\x15\x0a\x37\x14\x0b\x0e\x3a\x29\x3e"
            "\x25\x43\x20\x49\x18\x52\x0f\x24" }  },
      /* --- pixel bitmap for cmr1200 char#68 D --- */
      {  68, 1394,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 112,  113, 2,339, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x00\x44\x2c\x49\x27\x4c\x24\x4f\x21\x51\x2b\x17\x1c"
            "\x14\x2c\x12\x22\x12\x2b\x10\x26\x10\x2b\x0f\x29\x0f"
            "\x29\x0f\x2b\x0e\x28\x0f\x2c\x0e\x27\x0f\x2e\x0e\x25"
            "\x0f\x2f\x0e\x24\x0f\x30\x0e\x23\x0f\x32\x0d\x22\x0f"
            "\x33\x0d\x21\x0f\x34\x0d\x20\x0f\x35\x0d\x1f\x0f\x35"
            "\x0e\x1e\x0f\x36\x0d\x1e\x0f\x37\x0d\x1d\x0f\x38\x0d"
            "\x1c\x0f\x38\x0e\x1b\x0f\x39\x0d\x1b\x0f\x39\x0e\x1a"
            "\x0f\x3a\x0d\x1a\x0f\x3a\x0e\x08\x00\xff\x01\x11\x0f"
            "\x3b\x0e\x07\x00\xff\x01\x11\x0f\x3c\x0e\x06\x00\x11"
            "\x0f\x3c\x0f\x05\x00\xff\x01\x11\x0f\x3d\x0e\x05\x00"
            "\xff\x01\x11\x0f\x3d\x0f\x04\x00\xff\x03\x11\x0f\x3e"
            "\x0f\x03\x00\x11\x0f\x3e\x10\x02\x00\xff\x02\x11\x0f"
            "\x3f\x0f\x02\x00\xff\x04\x11\x0f\x3f\x10\x01\x00\xff"
            "\x0f\x11\x0f\x3f\x11\xff\x05\x11\x0f\x3f\x10\x01\x00"
            "\xff\x01\x11\x0f\x3f\x0f\x02\x00\xff\x01\x11\x0f\x3e"
            "\x10\x02\x00\xff\x02\x11\x0f\x3e\x0f\x03\x00\xff\x01"
            "\x11\x0f\x3d\x0f\x04\x00\xff\x01\x11\x0f\x3d\x0e\x05"
            "\x00\x11\x0f\x3c\x0f\x05\x00\xff\x01\x11\x0f\x3c\x0e"
            "\x06\x00\xff\x01\x11\x0f\x3b\x0e\x07\x00\x11\x0f\x3a"
            "\x0e\x19\x0f\x3a\x0d\x1a\x0f\x39\x0e\x1a\x0f\x39\x0d"
            "\x1b\x0f\x38\x0d\x1c\x0f\x37\x0e\x1c\x0f\x37\x0d\x1d"
            "\x0f\x36\x0d\x1e\x0f\x35\x0d\x1f\x0f\x34\x0d\x20\x0f"
            "\x33\x0d\x21\x0f\x32\x0d\x22\x0f\x31\x0d\x23\x0f\x30"
            "\x0d\x24\x0f\x2e\x0e\x25\x0f\x2d\x0e\x26\x0f\x2b\x0f"
            "\x27\x0f\x29\x0f\x28\x10\x27\x10\x28\x12\x23\x11\x27"
            "\x17\x1c\x14\x1d\x51\x1f\x4f\x21\x4c\x24\x49\x27\x44"
            "\x2c" }  },
      /* --- pixel bitmap for cmr1200 char#69 E --- */
      {  69, 1843,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 102,  113, 2,349, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x03\x00\x5d\x09\x5e\x14\x17\x23\x18\x17\x12\x2b"
            "\x12\x18\x10\x2f\x0f\x19\x0f\x31\x0d\x19\x0f\x33\x0b"
            "\x19\x0f\x34\x0a\x19\x0f\x35\x0a\x18\x0f\x36\x09\x18"
            "\x0f\x37\x08\x07\x00\xff\x01\x11\x0f\x38\x07\x07\x00"
            "\xff\x01\x11\x0f\x39\x06\x07\x00\x11\x0f\x3a\x05\x18"
            "\x0f\x3a\x06\x06\x00\xff\x02\x11\x0f\x3b\x05\x06\x00"
            "\xff\x02\x11\x0f\x3c\x04\x06\x00\x11\x0f\x3c\x05\x05"
            "\x00\xff\x05\x11\x0f\x3d\x04\x05\x00\xff\x03\x11\x0f"
            "\x21\x04\x19\x04\x04\x00\xff\x04\x11\x0f\x21\x04\x21"
            "\x00\xff\x02\x11\x0f\x20\x05\x21\x00\xff\x01\x11\x0f"
            "\x1f\x06\x21\x00\x11\x0f\x1e\x07\x32\x0f\x1d\x08\x32"
            "\x0f\x1c\x09\x32\x0f\x1a\x0b\x32\x0f\x16\x0f\x21\x00"
            "\xff\x04\x11\x34\x21\x00\x11\x0f\x16\x0f\x32\x0f\x1a"
            "\x0b\x32\x0f\x1c\x09\x32\x0f\x1d\x08\x32\x0f\x1e\x07"
            "\x21\x00\xff\x01\x11\x0f\x1f\x06\x21\x00\xff\x02\x11"
            "\x0f\x20\x05\x21\x00\xff\x02\x11\x0f\x21\x04\x21\x00"
            "\xff\x02\x11\x0f\x21\x04\x1d\x04\xff\x02\x11\x0f\x21"
            "\x04\x1c\x04\x01\x00\xff\x02\x11\x0f\x41\x04\x01\x00"
            "\xff\x03\x11\x0f\x40\x04\x02\x00\xff\x01\x11\x0f\x3f"
            "\x05\x02\x00\xff\x01\x11\x0f\x3f\x04\x03\x00\xff\x02"
            "\x11\x0f\x3e\x05\x03\x00\x11\x0f\x3d\x06\x03\x00\xff"
            "\x01\x11\x0f\x3d\x05\x04\x00\xff\x01\x11\x0f\x3c\x06"
            "\x04\x00\xff\x01\x11\x0f\x3b\x07\x04\x00\x11\x0f\x3a"
            "\x08\x15\x0f\x39\x08\x16\x0f\x38\x09\x16\x0f\x37\x0a"
            "\x16\x0f\x36\x0b\x16\x0f\x35\x0c\x16\x0f\x33\x0e\x16"
            "\x0f\x32\x0e\x16\x10\x2f\x11\x15\x12\x2b\x14\x12\x17"
            "\x23\x1a\x06\xff\x01\x60\x06\xff\x02\x5f\x07" }  },
      /* --- pixel bitmap for cmr1200 char#70 F --- */
      {  70, 2309,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 95,  113, 2,231, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x03\x00\x5a\x05\x5b\x10\x17\x21\x17\x13\x12\x28"
            "\x12\x14\x10\x2c\x0f\x15\x0f\x2e\x0d\x15\x0f\x30\x0b"
            "\x15\x0f\x31\x0a\x15\x0f\x32\x0a\x14\x0f\x33\x09\x14"
            "\x0f\x34\x08\x03\x00\xff\x01\x11\x0f\x35\x07\x03\x00"
            "\xff\x01\x11\x0f\x36\x06\x03\x00\x11\x0f\x37\x05\x14"
            "\x0f\x37\x06\x02\x00\xff\x02\x11\x0f\x38\x05\x02\x00"
            "\xff\x02\x11\x0f\x39\x04\x02\x00\x11\x0f\x39\x05\x01"
            "\x00\xff\x05\x11\x0f\x3a\x04\x01\x00\xff\x01\x11\x0f"
            "\x3b\x04\xff\x01\x11\x0f\x1f\x04\x18\x04\xff\x06\x11"
            "\x0f\x1f\x04\x1c\x00\xff\x02\x11\x0f\x1e\x05\x1c\x00"
            "\xff\x01\x11\x0f\x1d\x06\x1c\x00\x11\x0f\x1c\x07\x2d"
            "\x0f\x1b\x08\x2d\x0f\x1a\x09\x2d\x0f\x18\x0b\x2d\x0f"
            "\x15\x0e\x1c\x00\xff\x04\x11\x32\x1c\x00\x11\x0f\x15"
            "\x0e\x2d\x0f\x18\x0b\x2d\x0f\x1a\x09\x2d\x0f\x1b\x08"
            "\x2d\x0f\x1c\x07\x1c\x00\xff\x01\x11\x0f\x1d\x06\x1c"
            "\x00\xff\x02\x11\x0f\x1e\x05\x1c\x00\xff\x08\x11\x0f"
            "\x1f\x04\x1c\x00\xff\x19\x11\x0f\x3f\x00\x11\x10\x4e"
            "\x11\x4d\x13\x49\x1a\x39\xff\x04\x35\x2a" }  },
      /* --- pixel bitmap for cmr1200 char#71 G --- */
      {  71, 2687,                      /* character number, location */
        117, 9,   -4, 9,      /* topleft row,col, and botleft row,col */
          { 112,  121, 2,435, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x32\x0f\x21\x03\x38\x18\x1c\x04\x34\x1f\x18\x05\x31"
            "\x24\x16\x05\x2f\x28\x13\x06\x2d\x14\x0b\x0d\x10\x07"
            "\x2b\x11\x14\x0a\x0f\x07\x29\x10\x1a\x09\x0c\x08\x27"
            "\x10\x1e\x08\x0a\x09\x26\x0f\x22\x07\x09\x09\x24\x0f"
            "\x25\x07\x07\x0a\x23\x0e\x29\x06\x05\x0b\x22\x0e\x2b"
            "\x06\x04\x0b\x21\x0d\x2e\x06\x02\x0c\x1f\x0e\x30\x13"
            "\x1e\x0e\x32\x12\x1d\x0e\x34\x11\x1c\x0e\x36\x10\x1b"
            "\x0e\x37\x10\x1a\x0e\x39\x0f\x1a\x0d\x3b\x0e\x19\x0d"
            "\x3d\x0d\x18\x0e\x3d\x0d\x17\x0e\x3f\x0c\x16\x0e\x40"
            "\x0c\x16\x0e\x41\x0b\x15\x0e\x42\x0b\x14\x0f\x43\x0a"
            "\x14\x0e\x44\x0a\x13\x0f\x45\x09\x13\x0e\x46\x09\x0b"
            "\x00\xff\x01\x07\x0f\x47\x08\x0b\x00\x06\x0f\x48\x08"
            "\x11\x0f\x49\x07\x0b\x00\xff\x01\x05\x0f\x4a\x07\x0b"
            "\x00\x04\x10\x4a\x07\x0f\x10\x4b\x06\x0f\x0f\x4c\x06"
            "\x0b\x00\xff\x02\x03\x10\x4c\x06\x0b\x00\xff\x02\x02"
            "\x10\x4e\x05\x0b\x00\xff\x01\x01\x11\x4e\x05\x0b\x00"
            "\xff\x01\x01\x11\x5e\x00\xff\x01\x01\x10\x5f\xff\x10"
            "\x11\x5f\x00\xff\x01\x01\x10\x5f\x00\xff\x03\x01\x11"
            "\x2f\x2f\x02\x10\x2f\x2f\x02\x10\x3e\x18\x0a\x10\x42"
            "\x12\x0d\x10\x42\x11\x0d\x10\x42\x10\x0e\x10\x43\x0f"
            "\x0f\x0f\x43\x0f\x0b\x00\xff\x01\x04\x10\x42\x0f\x0b"
            "\x00\x05\x0f\x42\x0f\x10\x10\x41\x0f\x0b\x00\xff\x01"
            "\x06\x0f\x41\x0f\x0b\x00\xff\x01\x07\x0f\x40\x0f\x0b"
            "\x00\x08\x0e\x40\x0f\x13\x0f\x3f\x0f\x14\x0e\x3f\x0f"
            "\x14\x0f\x3e\x0f\x15\x0e\x3e\x0f\x16\x0e\x3d\x0f\x16"
            "\x0f\x3c\x0f\x17\x0e\x3c\x0f\x18\x0e\x3b\x0f\x19\x0e"
            "\x3a\x0f\x1a\x0d\x3a\x0f\x1a\x0e\x38\x10\x1b\x0e\x37"
            "\x10\x1c\x0e\x36\x10\x1d\x0e\x34\x11\x1e\x0e\x32\x12"
            "\x1f\x0e\x31\x12\x21\x0e\x2e\x06\x01\x0c\x22\x0e\x2c"
            "\x06\x03\x0b\x23\x0f\x29\x07\x04\x0a\x24\x0f\x27\x07"
            "\x06\x09\x26\x0f\x23\x08\x08\x08\x27\x10\x1f\x09\x0a"
            "\x07\x29\x11\x1a\x09\x0d\x06\x2b\x12\x14\x0b\x0f\x05"
            "\x2d\x15\x0b\x0e\x11\x04\x2f\x2a\x14\x03\x31\x26\x4d"
            "\x20\x54\x19\x5c\x0f\x2f" }  },
      /* --- pixel bitmap for cmr1200 char#72 H --- */
      {  72, 3198,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 114,  113, 2,60, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x04\x00\x31\x10\x31\x0c\x19\x28\x19\x1b\x13\x2e"
            "\x13\x1f\x11\x30\x11\x10\x00\xff\x2b\x11\x0f\x32\x0f"
            "\x11\x00\xff\x04\x11\x50\x11\x00\xff\x2f\x11\x0f\x32"
            "\x0f\x11\x00\x10\x11\x30\x11\x1f\x13\x2e\x13\x1b\x19"
            "\x28\x19\x0c\xff\x04\x31\x10\x31" }  },
      /* --- pixel bitmap for cmr1200 char#73 I --- */
      {  73, 3652,                      /* character number, location */
        113, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 51,  113, 2,36, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x04\x00\x33\x0d\x19\x1d\x13\x10\x00\xff\x01\x11"
            "\x11\x11\x00\xff\x5e\x12\x0f\x12\x00\xff\x01\x11\x11"
            "\x11\x00\x10\x13\x1d\x19\x0d\xff\x04\x33" }  },
      /* --- pixel bitmap for cmr1200 char#74 J --- */
      {  74, 3885,                      /* character number, location */
        113, 7,   -4, 7,      /* topleft row,col, and botleft row,col */
          { 70,  117, 2,125, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x04\x14\x32\x23\x1a\x30\x13\x35\x11\x35\x10\x0d"
            "\x00\xff\x4b\x2a\x0f\x0d\x00\x06\x06\x1e\x0f\x11\x0a"
            "\x1c\x0f\x10\x0c\x1b\x0f\x0f\x0e\x1a\x0f\x0e\x10\x19"
            "\x0f\x0d\xff\x03\x12\x18\x0f\x0d\x12\x17\x10\x0d\xff"
            "\x02\x12\x17\x0f\x0e\x11\x18\x0e\x0f\x11\x17\x0f\x10"
            "\x0f\x18\x0f\x10\x0d\x19\x0f\x11\x0c\x1a\x0f\x12\x06"
            "\x1f\x0e\x13\x07\x1d\x0e\x15\x06\x1c\x0e\x17\x06\x1b"
            "\x0d\x19\x06\x19\x0e\x19\x07\x17\x0d\x1d\x07\x14\x0d"
            "\x1f\x08\x11\x0d\x21\x09\x0e\x0c\x25\x0a\x08\x0e\x27"
            "\x1d\x2b\x19\x30\x13\x36\x0c\x26" }  },
      /* --- pixel bitmap for cmr1200 char#75 K --- */
      {  75, 4182,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 116,  113, 2,462, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x04\x00\x31\x1f\x22\x02\x00\x0c\x19\x2e\x1a\x16"
            "\x13\x33\x14\x1b\x11\x35\x11\x1e\x0f\x37\x0d\x21\x0f"
            "\x37\x0c\x22\x0f\x37\x0a\x24\x0f\x37\x09\x25\x0f\x37"
            "\x07\x27\x0f\x36\x07\x28\x0f\x36\x06\x29\x0f\x35\x06"
            "\x2a\x0f\x34\x06\x2b\x0f\x33\x06\x2c\x0f\x32\x06\x2d"
            "\x0f\x30\x07\x2e\x0f\x2f\x07\x2f\x0f\x2e\x06\x31\x0f"
            "\x2d\x06\x32\x0f\x2c\x06\x33\x0f\x2b\x06\x34\x0f\x2a"
            "\x06\x35\x0f\x29\x06\x36\x0f\x28\x06\x37\x0f\x27\x06"
            "\x38\x0f\x26\x06\x39\x0f\x25\x06\x3a\x0f\x24\x06\x3b"
            "\x0f\x23\x06\x3c\x0f\x22\x06\x3d\x0f\x21\x06\x3e\x0f"
            "\x20\x06\x3f\x0f\x1e\x07\x40\x0f\x1d\x07\x41\x0f\x1c"
            "\x06\x43\x0f\x1b\x06\x44\x0f\x1a\x06\x45\x0f\x19\x06"
            "\x46\x0f\x18\x06\x47\x0f\x17\x06\x48\x0f\x16\x08\x47"
            "\x0f\x15\x09\x47\x0f\x14\x0b\x46\x0f\x13\x0d\x45\x0f"
            "\x12\x0e\x45\x0f\x11\x10\x44\x0f\x10\x12\x43\x0f\x0f"
            "\x13\x43\x0f\x0e\x15\x42\x0f\x0d\x17\x41\x0f\x0b\x07"
            "\x02\x10\x41\x0f\x0a\x07\x03\x11\x40\x0f\x09\x06\x06"
            "\x11\x3f\x0f\x08\x06\x08\x11\x3e\x0f\x07\x06\x09\x11"
            "\x3e\x0f\x06\x06\x0b\x11\x3d\x0f\x05\x06\x0d\x11\x3c"
            "\x0f\x04\x06\x0e\x11\x3c\x0f\x03\x06\x10\x11\x3b\x0f"
            "\x02\x06\x12\x11\x3a\x0f\x01\x06\x13\x11\x3a\x15\x15"
            "\x11\x39\x14\x17\x11\x38\x13\x18\x11\x38\x12\x1a\x11"
            "\x37\x11\x1c\x11\x36\x10\x1d\x11\x36\x0f\x1f\x11\x24"
            "\x00\xff\x01\x11\x0f\x20\x11\x23\x00\x11\x0f\x21\x11"
            "\x22\x00\xff\x01\x11\x0f\x22\x11\x21\x00\x11\x0f\x23"
            "\x11\x20\x00\xff\x01\x11\x0f\x24\x11\x1f\x00\x11\x0f"
            "\x25\x11\x1e\x00\xff\x01\x11\x0f\x26\x11\x1d\x00\x11"
            "\x0f\x27\x11\x1c\x00\xff\x01\x11\x0f\x28\x11\x1b\x00"
            "\x11\x0f\x29\x11\x2b\x0f\x2a\x11\x2a\x0f\x2b\x10\x2a"
            "\x0f\x2b\x11\x29\x0f\x2c\x11\x28\x0f\x2d\x10\x28\x0f"
            "\x2d\x11\x27\x0f\x2e\x11\x15\x00\xff\x01\x11\x0f\x2f"
            "\x11\x14\x00\x11\x0f\x30\x11\x13\x00\xff\x01\x11\x0f"
            "\x31\x11\x12\x00\x11\x0f\x32\x11\x22\x0f\x32\x12\x21"
            "\x0f\x33\x11\x21\x0f\x33\x12\x20\x0f\x33\x13\x1f\x0f"
            "\x33\x14\x1d\x11\x31\x16\x1b\x13\x2f\x19\x16\x19\x2a"
            "\x1e\x07\xff\x04\x31\x18\x2b" }  },
      /* --- pixel bitmap for cmr1200 char#76 L --- */
      {  76, 4663,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 91,  113, 2,145, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x04\x00\x35\x26\x00\x0c\x1a\x44\x13\x49\x11\x4b"
            "\x10\x3a\x00\xff\x3c\x11\x0f\x3b\x00\xff\x03\x11\x0f"
            "\x37\x04\x11\x0f\x36\x05\xff\x05\x11\x0f\x36\x04\x01"
            "\x00\xff\x01\x11\x0f\x35\x05\x01\x00\xff\x02\x11\x0f"
            "\x35\x04\x02\x00\xff\x02\x11\x0f\x34\x05\x02\x00\xff"
            "\x02\x11\x0f\x33\x06\x02\x00\xff\x01\x11\x0f\x32\x06"
            "\x03\x00\x11\x0f\x31\x07\x03\x00\xff\x01\x11\x0f\x30"
            "\x08\x03\x00\x11\x0f\x2f\x09\x14\x0f\x2e\x0a\x14\x0f"
            "\x2d\x0b\x14\x0f\x2c\x0b\x15\x0f\x2b\x0c\x15\x0f\x2a"
            "\x0d\x15\x0f\x28\x0f\x15\x0f\x26\x11\x14\x10\x24\x13"
            "\x13\x12\x20\x16\x10\x17\x1a\x1a\x04\x57\x04\xff\x03"
            "\x56\x05" }  },
      /* --- pixel bitmap for cmr1200 char#77 M --- */
      {  77, 4977,                      /* character number, location */
        113, 6,    0, 6,      /* topleft row,col, and botleft row,col */
          { 139,  113, 2,522, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x00\x20\x4a\x21\x00\xff\x02\x21\x48\x22\x00\x22\x46"
            "\x23\x0c\x16\x46\x17\x1b\x06\x01\x0d\x44\x04\x01\x10"
            "\x1f\x05\x01\x0d\x44\x04\x01\x0f\x21\x04\x01\x0d\x44"
            "\x04\x01\x0e\x11\x00\xff\x02\x11\x04\x02\x0d\x42\x04"
            "\x02\x0e\x11\x00\xff\x01\x11\x04\x03\x0d\x40\x04\x03"
            "\x0e\x11\x00\xff\x02\x11\x04\x04\x0d\x3e\x04\x04\x0e"
            "\x11\x00\xff\x01\x11\x04\x05\x0d\x3c\x04\x05\x0e\x11"
            "\x00\xff\x02\x11\x04\x06\x0d\x3a\x04\x06\x0e\x11\x00"
            "\xff\x02\x11\x04\x07\x0d\x38\x04\x07\x0e\x11\x00\xff"
            "\x01\x11\x04\x08\x0d\x36\x04\x08\x0e\x11\x00\xff\x02"
            "\x11\x04\x09\x0d\x34\x04\x09\x0e\x11\x00\xff\x01\x11"
            "\x04\x0a\x0d\x32\x04\x0a\x0e\x11\x00\xff\x02\x11\x04"
            "\x0b\x0d\x30\x04\x0b\x0e\x11\x00\xff\x02\x11\x04\x0c"
            "\x0d\x2e\x04\x0c\x0e\x11\x00\xff\x01\x11\x04\x0d\x0d"
            "\x2c\x04\x0d\x0e\x11\x00\xff\x02\x11\x04\x0e\x0d\x2a"
            "\x04\x0e\x0e\x11\x00\xff\x01\x11\x04\x0f\x0d\x28\x04"
            "\x0f\x0e\x11\x00\xff\x02\x11\x04\x10\x0d\x26\x04\x10"
            "\x0e\x11\x00\xff\x02\x11\x04\x11\x0d\x24\x04\x11\x0e"
            "\x11\x00\xff\x01\x11\x04\x12\x0d\x22\x04\x12\x0e\x11"
            "\x00\xff\x02\x11\x04\x13\x0d\x20\x04\x13\x0e\x11\x00"
            "\xff\x01\x11\x04\x14\x0d\x1e\x04\x14\x0e\x11\x00\xff"
            "\x02\x11\x04\x15\x0d\x1c\x04\x15\x0e\x11\x00\xff\x02"
            "\x11\x04\x16\x0d\x1a\x04\x16\x0e\x11\x00\xff\x01\x11"
            "\x04\x17\x0d\x18\x04\x17\x0e\x11\x00\xff\x02\x11\x04"
            "\x18\x0d\x16\x04\x18\x0e\x11\x00\xff\x01\x11\x04\x19"
            "\x0d\x14\x04\x19\x0e\x11\x00\xff\x02\x11\x04\x1a\x0d"
            "\x12\x04\x1a\x0e\x11\x00\xff\x02\x11\x04\x1b\x0d\x10"
            "\x04\x1b\x0e\x11\x00\xff\x01\x11\x04\x1c\x0d\x0e\x04"
            "\x1c\x0e\x11\x00\xff\x02\x11\x04\x1d\x0d\x0c\x04\x1d"
            "\x0e\x11\x00\xff\x01\x11\x04\x1e\x0d\x0a\x04\x1e\x0e"
            "\x11\x00\xff\x02\x11\x04\x1f\x0d\x08\x04\x1f\x0e\x11"
            "\x00\xff\x02\x11\x04\x20\x0d\x06\x04\x20\x0e\x11\x00"
            "\xff\x01\x11\x04\x21\x0d\x04\x04\x21\x0e\x11\x00\xff"
            "\x02\x11\x04\x22\x0d\x02\x04\x22\x0e\x11\x00\xff\x01"
            "\x11\x04\x23\x11\x23\x0e\x11\x00\xff\x02\x11\x04\x24"
            "\x0f\x24\x0e\x11\x00\xff\x02\x10\x06\x24\x0d\x25\x0e"
            "\x11\x00\x0f\x08\x24\x0b\x26\x0e\x1f\x0a\x23\x0b\x26"
            "\x0e\x1d\x0e\x22\x09\x26\x10\x1a\x12\x20\x09\x25\x12"
            "\x16\x18\x1d\x09\x22\x18\x0c\xff\x01\x26\x17\x07\x17"
            "\x30\x00\xff\x01\x26\x18\x05\x18\x30\x00\x26\x19\x03"
            "\x19\x30" }  },
      /* --- pixel bitmap for cmr1200 char#78 N --- */
      {  78, 5842,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 114,  113, 2,609, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x00\x20\x2c\x47\x2b\x26\x00\xff\x01\x22\x2a\x26\x00"
            "\x23\x29\x26\x0d\x17\x2f\x18\x18\x14\x31\x12\x1b\x14"
            "\x33\x0e\x1d\x15\x34\x0a\x1f\x16\x34\x08\x20\x04\x01"
            "\x11\x34\x08\x20\x04\x02\x11\x34\x06\x21\x04\x03\x11"
            "\x33\x06\x21\x04\x03\x11\x34\x04\x22\x04\x04\x11\x33"
            "\x04\x22\x04\x05\x11\x32\x04\x22\x04\x05\x12\x31\x04"
            "\x22\x04\x06\x11\x31\x04\x22\x04\x07\x11\x30\x04\x11"
            "\x00\xff\x01\x11\x04\x08\x11\x2f\x04\x11\x00\x11\x04"
            "\x09\x11\x2e\x04\x11\x00\xff\x01\x11\x04\x0a\x11\x2d"
            "\x04\x11\x00\x11\x04\x0b\x11\x2c\x04\x22\x04\x0c\x11"
            "\x2b\x04\x22\x04\x0c\x12\x2a\x04\x22\x04\x0d\x11\x2a"
            "\x04\x22\x04\x0e\x11\x29\x04\x22\x04\x0e\x12\x28\x04"
            "\x22\x04\x0f\x11\x28\x04\x22\x04\x10\x11\x27\x04\x11"
            "\x00\xff\x01\x11\x04\x11\x11\x26\x04\x11\x00\x11\x04"
            "\x12\x11\x25\x04\x11\x00\xff\x01\x11\x04\x13\x11\x24"
            "\x04\x11\x00\x11\x04\x14\x11\x23\x04\x22\x04\x15\x11"
            "\x22\x04\x22\x04\x15\x12\x21\x04\x22\x04\x16\x11\x21"
            "\x04\x22\x04\x17\x11\x20\x04\x11\x00\xff\x01\x11\x04"
            "\x18\x11\x1f\x04\x11\x00\x11\x04\x19\x11\x1e\x04\x11"
            "\x00\xff\x01\x11\x04\x1a\x11\x1d\x04\x11\x00\x11\x04"
            "\x1b\x11\x1c\x04\x22\x04\x1c\x11\x1b\x04\x22\x04\x1c"
            "\x12\x1a\x04\x22\x04\x1d\x11\x1a\x04\x22\x04\x1e\x11"
            "\x19\x04\x11\x00\xff\x01\x11\x04\x1f\x11\x18\x04\x11"
            "\x00\x11\x04\x20\x11\x17\x04\x11\x00\xff\x01\x11\x04"
            "\x21\x11\x16\x04\x11\x00\x11\x04\x22\x11\x15\x04\x22"
            "\x04\x23\x11\x14\x04\x22\x04\x23\x12\x13\x04\x22\x04"
            "\x24\x11\x13\x04\x22\x04\x25\x11\x12\x04\x22\x04\x25"
            "\x12\x11\x04\x22\x04\x26\x11\x11\x04\x22\x04\x27\x11"
            "\x10\x04\x11\x00\xff\x01\x11\x04\x28\x11\x0f\x04\x11"
            "\x00\x11\x04\x29\x11\x0e\x04\x11\x00\xff\x01\x11\x04"
            "\x2a\x11\x0d\x04\x11\x00\x11\x04\x2b\x11\x0c\x04\x22"
            "\x04\x2c\x11\x0b\x04\x22\x04\x2c\x12\x0a\x04\x22\x04"
            "\x2d\x11\x0a\x04\x22\x04\x2e\x11\x09\x04\x11\x00\xff"
            "\x01\x11\x04\x2f\x11\x08\x04\x11\x00\x11\x04\x30\x11"
            "\x07\x04\x11\x00\xff\x01\x11\x04\x31\x11\x06\x04\x11"
            "\x00\x11\x04\x32\x11\x05\x04\x22\x04\x33\x11\x04\x04"
            "\x22\x04\x33\x12\x03\x04\x22\x04\x34\x11\x03\x04\x22"
            "\x04\x35\x11\x02\x04\x11\x00\xff\x01\x11\x04\x36\x11"
            "\x01\x04\x11\x00\x11\x04\x37\x15\x11\x00\xff\x01\x11"
            "\x04\x38\x14\x11\x00\x11\x04\x39\x13\x11\x00\xff\x01"
            "\x11\x04\x3a\x12\x11\x00\x11\x04\x3b\x11\x11\x00\xff"
            "\x01\x11\x04\x3c\x10\x11\x00\x11\x04\x3d\x0f\x22\x04"
            "\x3e\x0e\x11\x00\xff\x01\x11\x04\x3f\x0d\x11\x00\x10"
            "\x06\x3f\x0c\x21\x06\x40\x0b\x20\x08\x3f\x0b\x20\x08"
            "\x40\x0a\x1f\x0a\x40\x09\x1d\x0e\x3e\x09\x1b\x12\x3d"
            "\x08\x18\x18\x3b\x07\x11\xff\x01\x26\x35\x06\x11\x26"
            "\x36\x05\x11\x26\x37\x04\x11\x26\x38\x02\x12" }  },
      /* --- pixel bitmap for cmr1200 char#79 O --- */
      {  79, 6458,                      /* character number, location */
        117, 9,   -4, 9,      /* topleft row,col, and botleft row,col */
          { 110,  121, 2,369, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x30\x0e\x5b\x18\x52\x20\x4c\x24\x47\x10\x0a\x10\x42"
            "\x0e\x12\x0e\x3e\x0d\x18\x0d\x3b\x0c\x1c\x0c\x38\x0c"
            "\x20\x0c\x35\x0b\x24\x0b\x32\x0c\x26\x0c\x2f\x0c\x28"
            "\x0c\x2d\x0c\x2a\x0c\x2a\x0c\x2e\x0c\x27\x0c\x30\x0c"
            "\x25\x0d\x30\x0d\x23\x0d\x32\x0d\x21\x0d\x34\x0d\x20"
            "\x0c\x36\x0c\x1f\x0c\x38\x0c\x1d\x0d\x38\x0d\x1b\x0d"
            "\x3a\x0d\x0d\x00\xff\x01\x0c\x0d\x3c\x0d\x0c\x00\x0b"
            "\x0d\x3e\x0d\x15\x0e\x3e\x0e\x14\x0d\x40\x0d\x13\x0e"
            "\x40\x0e\x09\x00\xff\x01\x08\x0e\x42\x0e\x08\x00\xff"
            "\x01\x07\x0e\x44\x0e\x07\x00\x06\x0f\x44\x0f\x0c\x0e"
            "\x46\x0e\x06\x00\xff\x02\x05\x0f\x46\x0f\x05\x00\xff"
            "\x01\x04\x0f\x48\x0f\x04\x00\xff\x01\x03\x10\x48\x10"
            "\x03\x00\xff\x01\x03\x0f\x4a\x0f\x03\x00\xff\x03\x02"
            "\x10\x4a\x10\x02\x00\x01\x11\x4a\x11\x01\x00\xff\x04"
            "\x01\x10\x4c\x10\x01\xff\x0f\x11\x4c\x11\xff\x05\x01"
            "\x11\x4a\x11\x01\x00\xff\x01\x02\x10\x4a\x10\x02\x00"
            "\xff\x01\x02\x11\x48\x11\x02\x00\xff\x02\x03\x10\x48"
            "\x10\x03\x00\xff\x02\x04\x10\x46\x10\x04\x00\xff\x01"
            "\x05\x10\x44\x10\x05\x00\x06\x0f\x44\x0f\x0c\x10\x42"
            "\x10\x06\x00\xff\x01\x07\x0f\x42\x0f\x07\x00\xff\x01"
            "\x08\x0f\x40\x0f\x08\x00\xff\x01\x09\x0f\x3e\x0f\x09"
            "\x00\x0a\x0f\x3c\x0f\x15\x0e\x3c\x0e\x16\x0f\x3a\x0f"
            "\x17\x0f\x38\x0f\x19\x0e\x38\x0e\x1b\x0e\x36\x0e\x1c"
            "\x0f\x34\x0f\x1d\x0e\x34\x0e\x1f\x0e\x32\x0e\x21\x0e"
            "\x30\x0e\x23\x0e\x2e\x0e\x25\x0e\x2c\x0e\x27\x0e\x2a"
            "\x0e\x29\x0e\x28\x0e\x2c\x0d\x26\x0d\x2f\x0e\x22\x0e"
            "\x31\x0e\x20\x0e\x34\x0e\x1c\x0e\x37\x0f\x18\x0f\x3a"
            "\x10\x12\x10\x3e\x12\x0a\x12\x42\x2a\x47\x24\x4c\x20"
            "\x52\x18\x5b\x0e\x30" }  },
      /* --- pixel bitmap for cmr1200 char#80 P --- */
      {  80, 6998,                      /* character number, location */
        113, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 98,  113, 2,209, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x00\x42\x20\x47\x1b\x4b\x17\x4d\x15\x4f\x1f\x17\x1b"
            "\x13\x20\x12\x21\x11\x1f\x10\x25\x10\x1e\x0f\x27\x0f"
            "\x1d\x0f\x29\x0e\x1c\x0f\x2a\x0e\x1b\x0f\x2b\x0e\x1a"
            "\x0f\x2c\x0e\x19\x0f\x2d\x0e\x18\x0f\x2e\x0e\x17\x0f"
            "\x2e\x0f\x05\x00\xff\x01\x11\x0f\x2f\x0f\x04\x00\xff"
            "\x01\x11\x0f\x30\x0f\x03\x00\xff\x01\x11\x0f\x30\x10"
            "\x02\x00\x11\x0f\x30\x11\x01\x00\xff\x02\x11\x0f\x31"
            "\x10\x01\x00\xff\x08\x11\x0f\x31\x11\xff\x02\x11\x0f"
            "\x31\x10\x01\x00\x11\x0f\x30\x11\x01\x00\xff\x01\x11"
            "\x0f\x30\x10\x02\x00\xff\x01\x11\x0f\x30\x0f\x03\x00"
            "\x11\x0f\x2f\x0f\x15\x0f\x2f\x0e\x16\x0f\x2e\x0f\x16"
            "\x0f\x2e\x0e\x17\x0f\x2d\x0e\x18\x0f\x2c\x0e\x19\x0f"
            "\x2b\x0e\x1a\x0f\x2a\x0e\x1b\x0f\x28\x0f\x1c\x0f\x27"
            "\x0e\x1e\x0f\x25\x0f\x1f\x0f\x22\x10\x21\x0f\x1d\x14"
            "\x22\x3d\x25\x3b\x27\x38\x2a\x34\x1d\x00\xff\x2c\x11"
            "\x0f\x42\x00\x10\x11\x50\x13\x4c\x19\x3d\xff\x04\x31"
            "\x31" }  },
      /* --- pixel bitmap for cmr1200 char#81 Q --- */
      {  81, 7338,                      /* character number, location */
        117, 9,  -32, 9,      /* topleft row,col, and botleft row,col */
          { 111,  149, 2,559, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x30\x0e\x5c\x18\x53\x20\x4d\x24\x48\x10\x0a\x10\x43"
            "\x0e\x12\x0e\x3f\x0d\x18\x0d\x3c\x0c\x1c\x0c\x39\x0c"
            "\x20\x0c\x36\x0c\x22\x0c\x33\x0c\x26\x0c\x30\x0c\x28"
            "\x0c\x2e\x0c\x2a\x0c\x2b\x0d\x2c\x0d\x28\x0d\x2e\x0d"
            "\x26\x0d\x30\x0d\x24\x0d\x32\x0d\x12\x00\xff\x01\x10"
            "\x0d\x34\x0d\x11\x00\x0f\x0d\x36\x0d\x1e\x0d\x38\x0d"
            "\x1c\x0d\x3a\x0d\x1a\x0e\x3a\x0e\x19\x0d\x3c\x0d\x18"
            "\x0e\x3c\x0e\x0c\x00\xff\x01\x0a\x0e\x3e\x0e\x0b\x00"
            "\x09\x0e\x40\x0e\x12\x0f\x40\x0f\x11\x0e\x42\x0e\x09"
            "\x00\xff\x01\x07\x0f\x42\x0f\x08\x00\xff\x01\x06\x0f"
            "\x44\x0f\x07\x00\x05\x10\x44\x10\x06\x00\xff\x01\x05"
            "\x0f\x46\x0f\x06\x00\x04\x10\x46\x10\x09\x0f\x48\x0f"
            "\x05\x00\xff\x03\x03\x10\x48\x10\x04\x00\xff\x03\x02"
            "\x10\x4a\x10\x03\x00\xff\x02\x01\x11\x4a\x11\x02\x00"
            "\xff\x02\x01\x10\x4c\x10\x02\xff\x0f\x11\x4c\x11\x01"
            "\x00\xff\x02\x01\x10\x4c\x10\x02\x00\xff\x02\x01\x11"
            "\x4a\x11\x02\x00\xff\x03\x02\x10\x4a\x10\x03\x00\xff"
            "\x02\x03\x10\x48\x10\x04\x00\x04\x0f\x48\x0f\x05\x00"
            "\xff\x01\x04\x10\x46\x10\x05\x00\xff\x01\x05\x0f\x46"
            "\x0f\x06\x00\xff\x01\x06\x0f\x44\x0f\x07\x00\x07\x0e"
            "\x44\x0e\x0f\x0f\x42\x0f\x10\x0e\x42\x0e\x11\x0f\x1c"
            "\x08\x1c\x0f\x12\x0e\x1a\x0d\x19\x0e\x13\x0e\x19\x10"
            "\x17\x0e\x14\x0e\x16\x13\x15\x0e\x16\x0e\x14\x07\x07"
            "\x07\x13\x0e\x17\x0e\x14\x05\x0b\x06\x12\x0e\x18\x0e"
            "\x12\x05\x0e\x05\x10\x0e\x1a\x0d\x11\x06\x0f\x05\x0f"
            "\x0d\x1c\x0d\x10\x05\x11\x05\x0d\x0d\x1d\x0e\x0f\x04"
            "\x12\x05\x0c\x0e\x1e\x0d\x0e\x05\x13\x05\x0b\x0d\x20"
            "\x0d\x0d\x05\x13\x06\x09\x0d\x22\x0d\x0c\x04\x15\x05"
            "\x08\x0d\x24\x0d\x0b\x04\x15\x05\x07\x0d\x26\x0d\x0a"
            "\x04\x16\x05\x05\x0d\x28\x0d\x09\x04\x16\x05\x04\x0d"
            "\x2a\x0d\x08\x04\x16\x06\x02\x0d\x2d\x0c\x07\x05\x16"
            "\x05\x01\x0c\x30\x0c\x06\x05\x16\x11\x32\x0d\x05\x04"
            "\x16\x10\x35\x0c\x04\x05\x15\x0e\x38\x0d\x02\x06\x14"
            "\x0d\x3b\x0d\x01\x05\x12\x0d\x3f\x12\x0e\x0e\x1e\x02"
            "\x23\x12\x08\x11\x1e\x04\x25\x28\x1e\x04\x27\x27\x1d"
            "\x04\x2b\x18\x04\x07\x1d\x04\x30\x0e\x09\x08\x1b\x05"
            "\x47\x08\x1b\x05\x47\x09\x1a\x05\x47\x09\x19\x06\x47"
            "\x0a\x18\x06\x48\x09\x17\x07\x48\x0a\x15\x07\x49\x0b"
            "\x14\x07\x49\x0c\x12\x08\x49\x0d\x0f\x0a\x4a\x0d\x0d"
            "\x0b\x4a\x10\x07\x0d\x02\x00\xff\x01\x49\x24\x02\x00"
            "\x4a\x23\x02\x00\xff\x01\x4a\x22\x03\x00\xff\x01\x4b"
            "\x20\x04\x00\xff\x01\x4c\x1e\x05\x00\x4d\x1c\x53\x1b"
            "\x55\x19\x57\x17\x59\x15\x5c\x12\x5f\x0e\x63\x09\x10" }  },
      /* --- pixel bitmap for cmr1200 char#82 R --- */
      {  82, 8046,                      /* character number, location */
        113, 5,   -4, 5,      /* topleft row,col, and botleft row,col */
          { 116,  117, 2,391, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x00\x3c\x38\x42\x32\x45\x2f\x48\x2c\x4b\x35\x17\x16"
            "\x14\x36\x12\x1d\x11\x35\x10\x21\x10\x34\x0f\x23\x0f"
            "\x33\x0f\x25\x0f\x31\x0f\x26\x0f\x30\x0f\x28\x0e\x2f"
            "\x0f\x29\x0e\x2e\x0f\x2a\x0e\x2d\x0f\x2a\x0f\x2c\x0f"
            "\x2b\x0f\x1a\x00\xff\x01\x11\x0f\x2c\x0f\x19\x00\x11"
            "\x0f\x2c\x10\x29\x0f\x2d\x0f\x18\x00\xff\x01\x11\x0f"
            "\x2d\x10\x17\x00\x11\x0f\x2d\x11\x16\x00\xff\x01\x11"
            "\x0f\x2e\x10\x16\x00\xff\x08\x11\x0f\x2e\x11\x15\x00"
            "\xff\x01\x11\x0f\x2e\x10\x16\x00\x11\x0f\x2d\x11\x16"
            "\x00\xff\x01\x11\x0f\x2d\x10\x17\x00\x11\x0f\x2d\x0f"
            "\x29\x0f\x2c\x10\x29\x0f\x2c\x0f\x2a\x0f\x2c\x0e\x2b"
            "\x0f\x2b\x0e\x2c\x0f\x2a\x0f\x2c\x0f\x2a\x0e\x2d\x0f"
            "\x29\x0d\x2f\x0f\x28\x0d\x30\x0f\x26\x0e\x31\x0f\x25"
            "\x0e\x32\x0f\x23\x0e\x34\x0f\x21\x0e\x36\x0f\x1e\x0f"
            "\x38\x0f\x19\x12\x3a\x38\x3c\x35\x3f\x33\x41\x35\x3f"
            "\x0f\x18\x10\x3d\x0f\x1b\x0f\x3b\x0f\x1e\x0e\x39\x0f"
            "\x1f\x0e\x38\x0f\x21\x0d\x37\x0f\x22\x0e\x35\x0f\x23"
            "\x0e\x34\x0f\x23\x0f\x33\x0f\x24\x0e\x33\x0f\x25\x0e"
            "\x32\x0f\x25\x0f\x20\x00\xff\x01\x11\x0f\x26\x0f\x1f"
            "\x00\x11\x0f\x27\x0e\x1f\x00\xff\x01\x11\x0f\x27\x0f"
            "\x1e\x00\xff\x06\x11\x0f\x28\x0f\x1d\x00\xff\x06\x11"
            "\x0f\x28\x10\x1c\x00\xff\x06\x11\x0f\x28\x11\x1b\x00"
            "\x11\x0f\x28\x12\x17\x02\x01\x00\xff\x02\x11\x0f\x28"
            "\x12\x16\x04\xff\x01\x11\x0f\x29\x11\x16\x04\x11\x0f"
            "\x29\x12\x14\x05\x11\x0f\x2a\x11\x14\x05\x11\x0f\x2a"
            "\x11\x14\x04\x12\x0f\x2b\x10\x14\x04\x11\x11\x2a\x11"
            "\x12\x05\x10\x13\x2a\x10\x12\x05\x0d\x19\x28\x10\x10"
            "\x05\x02\x31\x1c\x10\x0f\x06\x02\x31\x1d\x10\x0e\x05"
            "\x03\x31\x1f\x0e\x0d\x05\x04\x31\x20\x0e\x0b\x06\x04"
            "\x31\x22\x0e\x06\x08\x59\x1a\x5c\x16\x61\x12\x66\x0b"
            "\x0c" }  },
      /* --- pixel bitmap for cmr1200 char#83 S --- */
      {  83, 8535,                      /* character number, location */
        117, 9,   -4, 9,      /* topleft row,col, and botleft row,col */
          { 73,  121, 2,389, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1a\x0d\x1a\x03\x1b\x15\x15\x04\x18\x1b\x11\x05\x16"
            "\x1f\x0f\x05\x15\x22\x0c\x06\x13\x0e\x0a\x0d\x0b\x06"
            "\x12\x0b\x12\x0b\x08\x07\x11\x0a\x17\x09\x06\x08\x0f"
            "\x0b\x1a\x08\x05\x08\x0e\x0a\x1e\x07\x03\x09\x0d\x0a"
            "\x20\x07\x01\x0a\x0d\x09\x23\x10\x0c\x09\x25\x0f\x0b"
            "\x09\x27\x0e\x0a\x0a\x28\x0d\x0a\x09\x29\x0d\x09\x09"
            "\x2b\x0c\x08\x0a\x2c\x0b\x08\x0a\x2d\x0a\x08\x09\x2e"
            "\x0a\x05\x00\xff\x01\x02\x0a\x2f\x09\x05\x00\xff\x02"
            "\x01\x0a\x31\x08\x05\x00\x01\x0a\x32\x07\x05\x0b\x32"
            "\x07\x05\xff\x03\x0b\x33\x06\x05\xff\x02\x0c\x33\x05"
            "\x05\xff\x01\x0d\x32\x05\x05\x0d\x33\x04\x05\x0e\x32"
            "\x04\x05\x00\xff\x01\x01\x0e\x31\x04\x05\x00\x01\x0f"
            "\x30\x04\x06\x10\x3a\x10\x39\x11\x38\x12\x38\x13\x36"
            "\x15\x35\x18\x31\x1c\x2e\x1f\x2b\x22\x27\x26\x24\x29"
            "\x21\x2b\x1f\x2d\x1d\x2e\x1c\x2e\x1c\x2f\x1b\x2f\x1c"
            "\x2e\x1c\x2e\x1d\x2d\x1e\x2c\x20\x2a\x23\x27\x26\x24"
            "\x29\x20\x2d\x1d\x30\x19\x34\x16\x36\x14\x36\x13\x38"
            "\x11\x39\x11\x39\x10\x3a\x0f\x3b\x0f\x01\x00\xff\x01"
            "\x3a\x0e\x01\x00\x3b\x0d\x02\x03\x37\x0e\x00\xff\x02"
            "\x04\x38\x0d\x00\xff\x02\x04\x39\x0c\x00\x04\x3a\x0b"
            "\x00\xff\x03\x05\x39\x0b\x00\x06\x38\x0b\x00\xff\x01"
            "\x06\x38\x0a\x01\xff\x01\x07\x37\x0a\x01\x07\x36\x0a"
            "\x02\xff\x01\x08\x35\x0a\x02\x09\x34\x09\x03\x0a\x32"
            "\x0a\x03\x0a\x32\x09\x04\x0b\x30\x0a\x04\x0c\x2f\x09"
            "\x05\x0d\x2d\x0a\x05\x0e\x2c\x09\x06\x0f\x2a\x09\x07"
            "\x10\x28\x0a\x07\x11\x27\x09\x08\x0a\x01\x08\x24\x09"
            "\x09\x09\x03\x09\x20\x0a\x0a\x08\x06\x09\x1d\x0a\x0b"
            "\x08\x07\x0b\x18\x0b\x0c\x07\x09\x0d\x13\x0c\x0d\x06"
            "\x0c\x10\x0b\x0d\x0f\x06\x0e\x25\x10\x05\x11\x21\x12"
            "\x05\x14\x1c\x14\x04\x18\x17\x16\x03\x1e\x0e\x1a" }  },
      /* --- pixel bitmap for cmr1200 char#84 T --- */
      {  84, 8972,                      /* character number, location */
        112, 6,    0, 6,      /* topleft row,col, and botleft row,col */
          { 107,  112, 2,129, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x04\x03\x65\x03\x00\x03\x13\x15\x15\x15\x13\x05"
            "\x10\x1b\x11\x1b\x10\x04\x0d\x1f\x0f\x1f\x0d\x04\x0b"
            "\x21\x0f\x21\x0b\x04\x0a\x22\x0f\x22\x0a\x04\x09\x23"
            "\x0f\x23\x09\x04\x08\x24\x0f\x24\x08\x02\x00\xff\x01"
            "\x02\x07\x25\x0f\x25\x07\x02\x00\xff\x01\x02\x06\x26"
            "\x0f\x26\x06\x02\x00\xff\x02\x02\x05\x27\x0f\x27\x05"
            "\x02\x00\xff\x04\x01\x05\x28\x0f\x28\x05\x01\x00\xff"
            "\x06\x01\x04\x29\x0f\x29\x04\x01\xff\x05\x04\x2a\x0f"
            "\x2a\x04\xff\x41\x2e\x0f\x2e\x00\xff\x01\x2d\x11\x2d"
            "\x00\x2b\x15\x52\x1d\x27\x00\xff\x04\x16\x3f\x16" }  },
      /* --- pixel bitmap for cmr1200 char#85 U --- */
      {  85, 9336,                      /* character number, location */
        113, 5,   -4, 5,      /* topleft row,col, and botleft row,col */
          { 114,  117, 2,181, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x04\x00\x31\x1a\x27\x0c\x19\x2d\x19\x16\x13\x33"
            "\x13\x1a\x11\x36\x0f\x1d\x0f\x39\x0b\x0e\x00\xff\x01"
            "\x11\x0f\x3a\x09\x0f\x00\xff\x01\x11\x0f\x3b\x07\x10"
            "\x00\xff\x43\x11\x0f\x3c\x05\x11\x00\xff\x01\x11\x0f"
            "\x3b\x06\x11\x00\xff\x02\x12\x0f\x3a\x05\x12\x00\x12"
            "\x0f\x39\x06\x25\x0e\x39\x06\x25\x0e\x39\x05\x26\x0f"
            "\x37\x06\x27\x0e\x37\x06\x27\x0e\x37\x05\x14\x00\xff"
            "\x01\x15\x0e\x35\x06\x14\x00\x16\x0d\x34\x06\x2b\x0e"
            "\x33\x06\x2c\x0d\x32\x06\x2d\x0e\x30\x07\x2e\x0d\x30"
            "\x06\x30\x0d\x2e\x06\x31\x0d\x2d\x07\x32\x0d\x2b\x07"
            "\x34\x0d\x29\x07\x36\x0d\x27\x07\x38\x0d\x25\x07\x3a"
            "\x0d\x23\x08\x3b\x0d\x21\x08\x3d\x0d\x1e\x08\x41\x0d"
            "\x1b\x08\x43\x0e\x16\x0a\x46\x0e\x12\x0b\x48\x11\x0a"
            "\x0d\x4c\x24\x50\x21\x54\x1b\x5a\x16\x61\x0d\x30" }  },
      /* --- pixel bitmap for cmr1200 char#86 V --- */
      {  86, 9801,                      /* character number, location */
        113, 3,   -4, 3,      /* topleft row,col, and botleft row,col */
          { 118,  117, 2,433, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x04\x00\x2d\x26\x23\x0a\x1c\x31\x19\x13\x15\x38"
            "\x13\x17\x13\x3b\x0f\x1a\x11\x3d\x0c\x1c\x11\x3e\x0a"
            "\x1e\x10\x3e\x09\x1f\x10\x3e\x08\x21\x0f\x3f\x07\x21"
            "\x10\x3e\x06\x23\x0f\x3e\x06\x11\x00\xff\x01\x12\x10"
            "\x3c\x06\x12\x00\x13\x0f\x3c\x05\x26\x10\x3b\x05\x26"
            "\x10\x3a\x06\x27\x0f\x3a\x05\x28\x10\x38\x06\x29\x0f"
            "\x38\x05\x2a\x10\x37\x05\x2a\x10\x36\x06\x2b\x0f\x36"
            "\x05\x2c\x10\x35\x05\x16\x00\xff\x01\x17\x0f\x34\x05"
            "\x17\x00\x17\x10\x32\x06\x2f\x0f\x32\x05\x30\x10\x31"
            "\x05\x30\x10\x30\x06\x31\x0f\x30\x05\x32\x10\x2f\x05"
            "\x19\x00\xff\x01\x1a\x0f\x2e\x05\x1a\x00\x1a\x10\x2c"
            "\x06\x35\x0f\x2c\x05\x36\x10\x2b\x05\x36\x10\x2a\x06"
            "\x37\x0f\x2a\x05\x38\x10\x28\x06\x1c\x00\xff\x01\x1d"
            "\x0f\x28\x05\x1d\x00\x1d\x10\x26\x06\x3b\x0f\x26\x05"
            "\x3c\x10\x25\x05\x3c\x10\x24\x06\x3d\x0f\x24\x05\x3e"
            "\x10\x22\x06\x1f\x00\xff\x01\x20\x0f\x22\x05\x20\x00"
            "\x20\x10\x20\x06\x41\x0f\x20\x05\x42\x10\x1f\x05\x42"
            "\x10\x1e\x06\x43\x0f\x1e\x05\x44\x10\x1c\x06\x45\x0f"
            "\x1c\x05\x46\x10\x1b\x05\x46\x10\x1a\x06\x47\x0f\x1a"
            "\x05\x48\x10\x19\x05\x48\x10\x18\x06\x49\x0f\x18\x05"
            "\x4a\x10\x16\x06\x4b\x0f\x16\x05\x4c\x10\x15\x05\x4c"
            "\x10\x14\x06\x4d\x0f\x14\x05\x4e\x10\x13\x05\x27\x00"
            "\xff\x01\x28\x0f\x12\x05\x28\x00\x28\x10\x10\x06\x51"
            "\x0f\x10\x05\x52\x10\x0f\x05\x52\x10\x0e\x06\x53\x0f"
            "\x0e\x05\x54\x10\x0c\x06\x2a\x00\xff\x01\x2b\x0f\x0c"
            "\x05\x2b\x00\x2b\x10\x0a\x06\x57\x0f\x0a\x05\x58\x10"
            "\x09\x05\x58\x10\x08\x06\x59\x0f\x08\x05\x5a\x10\x06"
            "\x06\x2d\x00\xff\x01\x2e\x0f\x06\x05\x2e\x00\x2e\x10"
            "\x04\x06\x5d\x0f\x04\x05\x5e\x10\x03\x05\x5e\x10\x02"
            "\x06\x5f\x0f\x02\x05\x60\x16\x30\x00\xff\x02\x31\x14"
            "\x31\x00\xff\x02\x32\x12\x32\x00\xff\x01\x33\x10\x33"
            "\x00\xff\x02\x34\x0e\x34\x00\xff\x02\x35\x0c\x35\x00"
            "\xff\x01\x36\x0a\x36\x00\xff\x02\x37\x08\x37\x00\x38"
            "\x06\x71\x04\x39" }  },
      /* --- pixel bitmap for cmr1200 char#87 W --- */
      {  87,10232,                      /* character number, location */
        113, 3,   -4, 3,      /* topleft row,col, and botleft row,col */
          { 164,  117, 2,753, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x04\x00\x2c\x11\x2c\x18\x23\x09\x1b\x22\x1c\x24"
            "\x19\x11\x15\x28\x15\x2b\x13\x15\x12\x2b\x13\x2e\x0f"
            "\x18\x11\x2c\x11\x31\x0c\x19\x10\x2d\x11\x32\x09\x1b"
            "\x10\x2e\x10\x32\x09\x1c\x0f\x2e\x10\x33\x07\x1d\x10"
            "\x2e\x0f\x33\x06\x1f\x0f\x2e\x0f\x33\x06\x1f\x0f\x2e"
            "\x10\x32\x05\x20\x10\x2e\x0f\x32\x05\x21\x0f\x2e\x0f"
            "\x32\x04\x22\x0f\x2e\x10\x31\x04\x22\x10\x2e\x0f\x31"
            "\x04\x11\x00\xff\x01\x12\x0f\x2e\x0f\x30\x04\x12\x00"
            "\x12\x10\x2e\x0f\x2f\x04\x12\x00\xff\x01\x13\x0f\x2e"
            "\x0f\x2e\x04\x13\x00\x13\x0f\x2d\x11\x2d\x04\x13\x00"
            "\xff\x01\x14\x0f\x2c\x11\x2c\x04\x14\x00\x14\x0f\x2b"
            "\x13\x2b\x04\x14\x00\xff\x01\x15\x0f\x2a\x13\x2a\x04"
            "\x15\x00\x15\x0f\x29\x15\x29\x04\x2a\x10\x28\x04\x02"
            "\x0f\x28\x05\x2b\x0f\x28\x04\x02\x0f\x28\x04\x2c\x0f"
            "\x27\x05\x02\x10\x27\x04\x2c\x10\x26\x04\x04\x0f\x26"
            "\x05\x2d\x0f\x26\x04\x04\x0f\x26\x04\x2e\x0f\x25\x05"
            "\x04\x10\x25\x04\x2e\x10\x24\x04\x06\x0f\x24\x05\x2f"
            "\x0f\x24\x04\x06\x0f\x24\x04\x30\x0f\x23\x05\x06\x10"
            "\x23\x04\x30\x10\x22\x04\x08\x0f\x22\x05\x31\x0f\x22"
            "\x04\x08\x0f\x22\x04\x32\x0f\x21\x05\x08\x10\x21\x04"
            "\x32\x10\x20\x04\x0a\x0f\x20\x05\x33\x0f\x20\x04\x0a"
            "\x0f\x20\x04\x34\x0f\x1f\x05\x0a\x10\x1f\x04\x34\x10"
            "\x1e\x04\x0c\x0f\x1e\x05\x35\x0f\x1e\x04\x0c\x0f\x1e"
            "\x04\x36\x0f\x1d\x05\x0c\x10\x1d\x04\x36\x10\x1c\x04"
            "\x0e\x0f\x1c\x05\x37\x0f\x1c\x04\x0e\x0f\x1c\x04\x38"
            "\x0f\x1c\x04\x0e\x10\x1b\x04\x38\x10\x1a\x04\x10\x0f"
            "\x1a\x05\x39\x0f\x1a\x04\x10\x0f\x1a\x04\x3a\x0f\x1a"
            "\x04\x10\x10\x19\x04\x3a\x10\x18\x04\x12\x0f\x19\x04"
            "\x3b\x0f\x18\x04\x12\x0f\x18\x04\x3c\x0f\x18\x04\x12"
            "\x10\x17\x04\x3c\x10\x16\x04\x14\x0f\x17\x04\x1e\x00"
            "\xff\x01\x1f\x0f\x16\x04\x14\x0f\x16\x04\x1f\x00\x1f"
            "\x10\x14\x04\x16\x0f\x15\x04\x1f\x00\xff\x01\x20\x0f"
            "\x14\x04\x16\x0f\x14\x04\x20\x00\x20\x0f\x13\x05\x16"
            "\x10\x13\x04\x20\x00\xff\x01\x21\x0f\x12\x04\x18\x0f"
            "\x12\x04\x21\x00\x21\x0f\x11\x05\x18\x10\x11\x04\x42"
            "\x10\x10\x04\x1a\x0f\x10\x05\x43\x0f\x10\x04\x1a\x0f"
            "\x10\x04\x44\x0f\x0f\x05\x1a\x10\x0f\x04\x44\x10\x0e"
            "\x04\x1c\x0f\x0e\x05\x45\x0f\x0e\x04\x1c\x0f\x0e\x04"
            "\x46\x0f\x0d\x05\x1c\x10\x0d\x04\x46\x10\x0c\x04\x1e"
            "\x0f\x0c\x05\x47\x0f\x0c\x04\x1e\x0f\x0c\x04\x48\x0f"
            "\x0b\x05\x1e\x10\x0b\x04\x48\x10\x0a\x04\x20\x0f\x0a"
            "\x05\x49\x0f\x0a\x04\x20\x0f\x0a\x04\x4a\x0f\x09\x05"
            "\x20\x10\x09\x04\x4a\x10\x08\x04\x22\x0f\x08\x05\x4b"
            "\x0f\x08\x04\x22\x0f\x08\x04\x4c\x0f\x07\x05\x22\x10"
            "\x07\x04\x4c\x10\x06\x04\x24\x0f\x06\x05\x4d\x0f\x06"
            "\x04\x24\x0f\x06\x04\x4e\x0f\x05\x05\x24\x10\x05\x04"
            "\x4e\x10\x04\x04\x26\x0f\x04\x05\x4f\x0f\x04\x04\x26"
            "\x0f\x04\x04\x50\x0f\x04\x04\x26\x10\x03\x04\x50\x10"
            "\x02\x04\x28\x0f\x02\x05\x51\x0f\x02\x04\x28\x0f\x02"
            "\x04\x52\x0f\x02\x04\x28\x10\x01\x04\x52\x14\x2a\x0f"
            "\x01\x04\x29\x00\xff\x01\x2a\x13\x2a\x13\x2a\x00\x2a"
            "\x12\x2c\x12\x2a\x00\xff\x01\x2b\x11\x2c\x11\x2b\x00"
            "\x2b\x10\x2e\x10\x2b\x00\xff\x01\x2c\x0f\x2e\x0f\x2c"
            "\x00\x2c\x0e\x30\x0e\x2c\x00\xff\x02\x2d\x0d\x30\x0d"
            "\x2d\x00\xff\x02\x2e\x0b\x32\x0b\x2e\x00\x2e\x0a\x34"
            "\x0a\x2e\x00\xff\x01\x2f\x09\x34\x09\x2f\x00\x2f\x08"
            "\x36\x08\x2f\x00\xff\x01\x30\x07\x36\x07\x30\x00\x30"
            "\x06\x38\x06\x61\x05\x38\x05\x63\x03\x3a\x03\x32" }  },
      /* --- pixel bitmap for cmr1200 char#88 X --- */
      {  88,11015,                      /* character number, location */
        113, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 116,  113, 2,412, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x04\x02\x2e\x15\x28\x07\x00\x0d\x1f\x1d\x1d\x1e"
            "\x19\x22\x17\x23\x16\x26\x12\x27\x14\x28\x0f\x2a\x13"
            "\x29\x0d\x2c\x12\x29\x0b\x2f\x11\x29\x0a\x31\x11\x29"
            "\x08\x32\x11\x29\x07\x34\x11\x27\x07\x1e\x00\xff\x01"
            "\x18\x11\x26\x06\x1f\x00\x19\x11\x24\x06\x3a\x11\x22"
            "\x06\x3b\x11\x21\x07\x3c\x11\x20\x06\x3e\x10\x1f\x06"
            "\x3f\x11\x1d\x07\x40\x11\x1c\x06\x42\x10\x1b\x06\x43"
            "\x11\x19\x06\x45\x11\x18\x06\x46\x10\x17\x06\x47\x11"
            "\x15\x06\x49\x11\x14\x06\x4a\x10\x13\x06\x4b\x11\x11"
            "\x06\x4d\x11\x10\x06\x4e\x10\x0f\x06\x4f\x11\x0d\x06"
            "\x51\x11\x0c\x06\x52\x10\x0b\x06\x53\x11\x09\x06\x55"
            "\x11\x08\x06\x55\x11\x07\x06\x57\x11\x05\x06\x59\x11"
            "\x04\x06\x59\x11\x03\x06\x5b\x11\x01\x06\x5d\x17\x5d"
            "\x16\x5f\x14\x61\x13\x61\x12\x63\x11\x35\x00\xff\x01"
            "\x2f\x11\x34\x00\x30\x11\x33\x00\xff\x01\x31\x11\x32"
            "\x00\x32\x11\x31\x00\xff\x01\x33\x11\x30\x00\x32\x13"
            "\x2f\x00\xff\x01\x31\x15\x2e\x00\x30\x17\x5c\x07\x01"
            "\x11\x5b\x06\x02\x11\x5a\x06\x04\x11\x2b\x00\xff\x01"
            "\x2d\x06\x06\x11\x2a\x00\x2c\x06\x08\x11\x29\x00\xff"
            "\x01\x2b\x06\x0a\x11\x28\x00\x2a\x06\x0c\x11\x50\x06"
            "\x0e\x10\x50\x06\x0e\x11\x4e\x06\x10\x11\x4c\x06\x12"
            "\x10\x4c\x06\x12\x11\x4a\x06\x14\x11\x48\x06\x16\x10"
            "\x48\x06\x16\x11\x46\x06\x18\x11\x44\x06\x1a\x10\x44"
            "\x06\x1a\x11\x42\x06\x1c\x11\x40\x06\x1e\x10\x40\x06"
            "\x1e\x11\x3e\x06\x20\x11\x3c\x06\x22\x10\x3c\x06\x22"
            "\x11\x3a\x06\x24\x11\x38\x06\x26\x10\x38\x06\x26\x11"
            "\x36\x06\x28\x11\x34\x06\x29\x11\x34\x06\x2a\x11\x32"
            "\x06\x2c\x11\x30\x06\x2d\x11\x30\x06\x2e\x11\x2e\x06"
            "\x30\x11\x2c\x07\x30\x11\x2b\x07\x32\x11\x29\x08\x33"
            "\x11\x27\x0a\x32\x11\x26\x0b\x33\x11\x23\x0d\x33\x12"
            "\x21\x0f\x31\x14\x1e\x12\x2f\x16\x1a\x17\x2b\x19\x15"
            "\x1d\x26\x20\x0a\xff\x04\x28\x1e\x2e" }  },
      /* --- pixel bitmap for cmr1200 char#89 Y --- */
      {  89,11438,                      /* character number, location */
        113, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 120,  113, 2,261, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x04\x00\x2e\x27\x23\x0a\x1d\x32\x19\x13\x17\x37"
            "\x14\x18\x14\x3a\x0f\x1c\x13\x3a\x0d\x1f\x12\x3b\x0b"
            "\x20\x12\x3b\x0a\x22\x11\x3b\x09\x24\x11\x3a\x08\x26"
            "\x11\x39\x07\x27\x11\x39\x06\x29\x11\x37\x07\x29\x11"
            "\x37\x06\x2b\x11\x35\x06\x2d\x11\x34\x05\x2e\x11\x33"
            "\x06\x2f\x11\x31\x06\x31\x11\x30\x06\x31\x11\x2f\x06"
            "\x33\x11\x2e\x05\x34\x11\x2d\x06\x35\x11\x2b\x06\x37"
            "\x11\x2a\x06\x37\x11\x29\x06\x39\x11\x28\x05\x3a\x11"
            "\x27\x06\x3b\x11\x25\x06\x3d\x11\x24\x06\x3d\x11\x23"
            "\x06\x3f\x11\x22\x05\x41\x11\x20\x06\x41\x11\x1f\x06"
            "\x43\x11\x1e\x06\x43\x11\x1d\x06\x45\x11\x1b\x06\x47"
            "\x11\x1a\x06\x47\x11\x19\x06\x49\x11\x18\x06\x49\x11"
            "\x17\x06\x4b\x11\x15\x06\x4d\x11\x14\x06\x4d\x11\x13"
            "\x06\x4f\x11\x12\x05\x51\x11\x10\x06\x51\x11\x0f\x06"
            "\x53\x11\x0e\x06\x53\x11\x0d\x06\x55\x11\x0c\x05\x57"
            "\x11\x0a\x06\x57\x11\x09\x06\x59\x11\x08\x06\x59\x12"
            "\x06\x06\x5b\x11\x06\x05\x5d\x11\x04\x06\x5d\x11\x03"
            "\x06\x5f\x11\x02\x06\x60\x17\x61\x16\x63\x15\x63\x14"
            "\x65\x13\x66\x11\x67\x10\x34\x00\xff\x25\x35\x0f\x34"
            "\x00\x34\x11\x66\x13\x62\x19\x2f\x00\xff\x04\x24\x31"
            "\x23" }  },
      /* --- pixel bitmap for cmr1200 char#90 Z --- */
      {  90,11791,                      /* character number, location */
        113, 9,    0, 9,      /* topleft row,col, and botleft row,col */
          { 83,  113, 2,415, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x04\x4d\x02\x00\xff\x03\x04\x4e\x01\x00\x04\x1b\x21"
            "\x11\x06\x16\x26\x11\x06\x12\x29\x11\x07\x10\x2a\x11"
            "\x07\x0f\x2c\x11\x07\x0e\x2c\x11\x08\x0d\x2d\x11\x08"
            "\x0b\x2e\x11\x06\x00\xff\x01\x03\x0a\x2e\x11\x07\x00"
            "\x03\x09\x2e\x11\x08\x00\xff\x01\x03\x08\x2e\x11\x09"
            "\x00\xff\x01\x03\x07\x2e\x11\x0a\x00\x03\x06\x2e\x11"
            "\x0e\x06\x2d\x11\x0f\x05\x2e\x11\x0f\x05\x2d\x11\x10"
            "\x05\x2d\x10\x11\x05\x2c\x11\x0e\x00\xff\x01\x03\x04"
            "\x2c\x11\x0f\x00\x02\x05\x2b\x11\x10\x00\xff\x01\x02"
            "\x05\x2a\x11\x11\x00\x02\x04\x2a\x11\x14\x04\x2a\x10"
            "\x15\x04\x29\x11\x13\x00\xff\x01\x02\x04\x28\x11\x14"
            "\x00\x02\x04\x27\x11\x15\x00\xff\x01\x2c\x11\x16\x00"
            "\x2b\x11\x42\x10\x42\x11\x18\x00\xff\x01\x29\x11\x19"
            "\x00\x28\x11\x1a\x00\xff\x01\x27\x11\x1b\x00\x26\x11"
            "\x42\x10\x42\x11\x1d\x00\xff\x01\x24\x11\x1e\x00\x23"
            "\x11\x1f\x00\xff\x01\x22\x11\x20\x00\x21\x11\x42\x10"
            "\x42\x11\x22\x00\xff\x01\x1f\x11\x23\x00\x1e\x11\x24"
            "\x00\xff\x01\x1d\x11\x25\x00\x1c\x11\x42\x10\x42\x11"
            "\x27\x00\xff\x01\x1a\x11\x28\x00\x19\x11\x29\x00\xff"
            "\x01\x18\x11\x26\x04\x17\x11\x27\x04\x17\x10\x28\x04"
            "\x16\x11\x28\x04\xff\x01\x15\x11\x29\x04\x14\x11\x29"
            "\x04\x01\x00\xff\x01\x13\x11\x2a\x04\x01\x00\x12\x11"
            "\x2b\x04\x13\x10\x2c\x04\x12\x11\x2c\x04\x11\x11\x2d"
            "\x04\x11\x11\x2c\x05\x10\x11\x2d\x05\x01\x00\xff\x01"
            "\x0e\x11\x2e\x05\x01\x00\x0d\x11\x2f\x05\x0e\x10\x2f"
            "\x06\x0d\x11\x2f\x06\x0c\x11\x30\x06\x0c\x11\x2f\x06"
            "\x0c\x11\x30\x06\x02\x00\xff\x01\x09\x11\x30\x07\x02"
            "\x00\xff\x01\x08\x11\x30\x08\x02\x00\x07\x11\x30\x09"
            "\x02\x00\xff\x01\x06\x11\x30\x0a\x02\x00\x05\x11\x30"
            "\x0b\x06\x11\x2f\x0d\x06\x11\x2e\x0e\x05\x11\x2d\x10"
            "\x05\x11\x2c\x11\x04\x11\x2a\x14\x03\x11\x28\x16\x04"
            "\x11\x22\x1c\x03\xff\x03\x50\x03\x00\x01\x4f\x03" }  },
      /* --- pixel bitmap for cmr1200 char#91 [ --- */
      {  91,39944,                      /* character number, location */
        125,18,  -42,18,      /* topleft row,col, and botleft row,col */
          { 24,  167, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x06\x00\x18\x00\xff\x98\x07\x11\xff\x06\x18" }  },
      /* --- pixel bitmap for cmr1200 char#92 (noname) --- */
      {  92,44703,                      /* character number, location */
        115,25,   65,25,      /* topleft row,col, and botleft row,col */
          { 52,   50, 3,297, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe2\xe0\xe0\x22\xe0\x34\xe0\xe4\xe0\x15\xe0\xd5\xe6"
            "\xe0\xc6\xd6\xe0\xc6\xd6\xe0\xc6\xe5\xe0\xd5\xe5\xe0"
            "\xd5\xe5\xe0\xd5\xe0\x14\xe0\xe4\xe0\x15\xe0\xd5\x90"
            "\xf1\x55\xe0\xd5\xa0\x45\xe0\xd5\xe0\x14\xe0\xe4\xc0"
            "\xf1\x35\xe0\xd5\xc0\x34\xe0\xe4\xe0\x15\xe0\xd5\xd0"
            "\xf1\x24\xe0\xe4\xe0\x15\xe0\xd5\xe0\xf3\x14\xe0\xe4"
            "\xe0\x15\xe0\xd5\xe0\x1f\x44\xe0\xe4\xe0\x24\x46\xe0"
            "\x44\x46\x64\x2a\xe0\x24\x2a\x44\x1c\xe0\x14\x1c\x3e"
            "\x04\xee\x04\x2f\x1e\x05\xde\x05\x1e\x06\xce\x06\xf2"
            "\x1e\x05\xde\x05\xf1\x2e\x04\xee\x04\x2e\x03\xe0\x1e"
            "\x03\x4e\x02\xe0\x2e\x02\x5e\xe0\x4e\x7c\xe0\x6c\x9a"
            "\xe0\x8a\xc6\xe0\xc6\x60" }  },
      /* --- pixel bitmap for cmr1200 char#93 ] --- */
      {  93,40285,                      /* character number, location */
        125, 3,  -42, 3,      /* topleft row,col, and botleft row,col */
          { 24,  167, 2,12, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x06\x00\x18\xff\x98\x11\x07\x00\xff\x06\x18" }  },
      /* --- pixel bitmap for cmr1200 char#94 \^ --- */
      {  94,41304,                      /* character number, location */
        114,20,   89,20,      /* topleft row,col, and botleft row,col */
          { 42,   25, 3,153, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x62\xe0\xe0\xb4\xe0\xe0\x96\xe0\xe0\x78\xe0\xe0"
            "\x5a\xe0\xe0\x3c\xe0\xe0\x1e\xe0\xde\x02\xe0\xb8\x28"
            "\xe0\x98\x48\xe0\x78\x68\xe0\x58\x88\xe0\x38\xa8\xe0"
            "\x18\xc8\xd8\xe8\xc7\xe0\x27\xb7\xe0\x47\x96\xe0\x86"
            "\x76\xe0\xa6\x56\xe0\xc6\x36\xe0\xe6\x16\xe0\xe0\x2b"
            "\xe0\xe0\x45\x13\xe0\xe0\x63\x31\xe0\xe0\x81\x2e" }  },
      /* --- pixel bitmap for cmr1200 char#95 (noname) --- */
      {  95,41395,                      /* character number, location */
        112,13,   94,13,      /* topleft row,col, and botleft row,col */
          { 19,   18, 3,43, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x67\xb9\x8d\x5e\x01\x20\xf3\x1e\x03\x1f\x1e\x05\xf3"
            "\x1e\x03\x10\x2e\x01\x5d\x89\xb7\x6e" }  },
      /* --- pixel bitmap for cmr1200 char#96 (noname) --- */
      {  96,40626,                      /* character number, location */
        115,12,   65,12,      /* topleft row,col, and botleft row,col */
          { 20,   50, 3,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe2\xe0\x34\xe0\x15\xe6\xd6\xd6\xe5\xe5\xe5\xe0\x14"
            "\xe0\x15\x90\xf1\x55\xa0\x45\xe0\x14\xe0\x15\xc0\xf1"
            "\x34\xd0\x25\xd0\xf1\x24\xe0\x15\xe0\xf3\x14\xe0\x15"
            "\xe0\x1f\x44\xe0\x24\x46\x64\x2a\x44\x1c\x3e\x04\x2f"
            "\x1e\x05\x1e\x06\xf2\x1e\x05\xf1\x2e\x04\x2e\x03\x4e"
            "\x02\x5e\x7c\x9a\xc6\x60" }  },
      /* --- pixel bitmap for cmr1200 char#97 a --- */
      {  97,12176,                      /* character number, location */
         74, 7,   -2, 7,      /* topleft row,col, and botleft row,col */
          { 74,   76, 2,289, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x17\x0d\x38\x16\x32\x1b\x2c\x20\x29\x0c\x09\x0d\x27"
            "\x08\x11\x0c\x23\x08\x14\x0c\x21\x07\x18\x0b\x20\x05"
            "\x1b\x0b\x1e\x09\x19\x0b\x1c\x0b\x19\x0b\x1b\x0c\x18"
            "\x0c\x19\x0e\x18\x0c\x18\x0f\x18\x0b\x13\x00\xff\x01"
            "\x05\x0f\x18\x0c\x12\x00\xff\x02\x05\x0f\x19\x0c\x11"
            "\x00\xff\x01\x06\x0d\x1b\x0c\x10\x00\x07\x0b\x1c\x0c"
            "\x18\x09\x1d\x0c\x1a\x05\x1f\x0c\x10\x00\xff\x06\x2e"
            "\x0c\x10\x00\x24\x16\x2d\x1d\x29\x21\x25\x15\x04\x0c"
            "\x23\x11\x0a\x0c\x20\x10\x0e\x0c\x1e\x0f\x11\x0c\x1d"
            "\x0e\x13\x0c\x1b\x0e\x15\x0c\x1a\x0d\x17\x0c\x18\x0e"
            "\x18\x0c\x17\x0d\x1a\x0c\x16\x0d\x1b\x0c\x15\x0d\x1c"
            "\x0c\x15\x0c\x1d\x0c\x14\x0d\x1d\x0c\x13\x0d\x1e\x0c"
            "\x12\x0e\x1e\x0c\x12\x0d\x1f\x0c\x12\x0d\x1f\x0c\x0c"
            "\x04\xff\x02\x01\x0d\x20\x0c\x0c\x04\x00\xff\x01\x0d"
            "\x21\x0c\x0c\x04\x00\xff\x03\x0d\x20\x0d\x0c\x04\x00"
            "\xff\x01\x0d\x1f\x0e\x0c\x04\x01\x0d\x1d\x0f\x0c\x04"
            "\x01\x0d\x1d\x03\x01\x0b\x0c\x04\x01\x0e\x1b\x04\x01"
            "\x0c\x0a\x04\x03\x0d\x1a\x04\x03\x0b\x0a\x04\x04\x0d"
            "\x18\x04\x04\x0b\x0a\x04\x04\x0e\x16\x05\x05\x0b\x08"
            "\x04\x06\x0e\x14\x05\x06\x0c\x06\x05\x07\x0e\x11\x06"
            "\x08\x15\x0a\x0e\x0d\x07\x0a\x13\x0c\x10\x07\x08\x0d"
            "\x11\x0f\x1c\x0f\x0f\x12\x18\x12\x0c\x17\x13\x17\x07"
            "\x1d\x0c\x2b" }  },
      /* --- pixel bitmap for cmr1200 char#98 b --- */
      {  98,12513,                      /* character number, location */
        115, 4,   -2, 4,      /* topleft row,col, and botleft row,col */
          { 82,  117, 2,301, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x13\x06\x3f\x13\x39\xff\x04\x19\x39\x00\x08\x11\x44"
            "\x0e\x39\x00\xff\x01\x0c\x0d\x39\x00\xff\x1e\x0d\x0c"
            "\x39\x00\x0d\x0c\x10\x0c\x2a\x0c\x0d\x13\x26\x0c\x0a"
            "\x19\x23\x0c\x08\x1d\x21\x0c\x06\x0b\x08\x0e\x1f\x0c"
            "\x05\x08\x0f\x0c\x1e\x0c\x04\x07\x13\x0c\x1c\x0c\x03"
            "\x06\x17\x0b\x1b\x0c\x02\x05\x1a\x0b\x1a\x0c\x01\x05"
            "\x1c\x0b\x19\x11\x1e\x0b\x18\x10\x20\x0b\x17\x0f\x22"
            "\x0b\x16\x0e\x24\x0b\x15\x0d\x25\x0c\x14\x0d\x26\x0b"
            "\x14\x0c\x27\x0c\x06\x00\xff\x01\x0d\x0c\x28\x0c\x05"
            "\x00\xff\x01\x0d\x0c\x29\x0c\x04\x00\x0d\x0c\x29\x0d"
            "\x10\x0c\x2a\x0c\x03\x00\xff\x02\x0d\x0c\x2a\x0d\x02"
            "\x00\xff\x01\x0d\x0c\x2a\x0e\x01\x00\xff\x02\x0d\x0c"
            "\x2b\x0d\x01\x00\xff\x0c\x0d\x0c\x2b\x0e\xff\x01\x0d"
            "\x0c\x2b\x0d\x01\x00\xff\x01\x0d\x0c\x2a\x0e\x01\x00"
            "\xff\x02\x0d\x0c\x2a\x0d\x02\x00\x0d\x0c\x2a\x0c\x03"
            "\x00\xff\x01\x0d\x0c\x29\x0d\x03\x00\x0d\x0c\x29\x0c"
            "\x11\x0c\x28\x0d\x11\x0c\x28\x0c\x12\x0c\x27\x0c\x13"
            "\x0d\x26\x0c\x13\x0d\x25\x0c\x14\x0e\x24\x0b\x15\x0e"
            "\x23\x0b\x16\x0f\x21\x0c\x16\x0a\x01\x05\x20\x0b\x17"
            "\x0a\x02\x05\x1e\x0b\x18\x09\x04\x05\x1c\x0b\x19\x08"
            "\x06\x05\x19\x0b\x1b\x08\x07\x05\x17\x0b\x1c\x07\x09"
            "\x06\x13\x0c\x1d\x06\x0b\x07\x0f\x0c\x1f\x06\x0c\x09"
            "\x08\x0f\x20\x05\x0e\x1d\x22\x04\x11\x19\x3b\x14\x42"
            "\x0b\x1f" }  },
      /* --- pixel bitmap for cmr1200 char#99 c --- */
      {  99,12928,                      /* character number, location */
         74, 5,   -2, 5,      /* topleft row,col, and botleft row,col */
          { 63,   76, 2,215, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1e\x0d\x2e\x16\x26\x1c\x21\x20\x1d\x0d\x0b\x0c\x19"
            "\x0c\x12\x09\x17\x0b\x17\x08\x14\x0b\x1a\x07\x12\x0a"
            "\x1e\x05\x10\x0b\x1c\x09\x0e\x0b\x1c\x0b\x0c\x0b\x1c"
            "\x0c\x0c\x0b\x1b\x0e\x0a\x0b\x1b\x0f\x09\x0b\x1c\x0f"
            "\x08\x0c\x1c\x0f\x01\x00\xff\x01\x06\x0c\x1d\x0f\x01"
            "\x00\x05\x0c\x1e\x0f\x06\x0c\x1f\x0d\x06\x0d\x1f\x0d"
            "\x06\x0c\x21\x0b\x06\x0d\x22\x09\x07\x0d\x24\x05\x06"
            "\x00\xff\x02\x02\x0d\x30\x00\xff\x02\x01\x0e\x30\x00"
            "\xff\x01\x01\x0d\x31\xff\x0c\x0e\x31\x00\x01\x0d\x31"
            "\x00\xff\x03\x01\x0e\x30\x00\x02\x0d\x32\x0e\x32\x0d"
            "\x2f\x00\xff\x01\x03\x0d\x2b\x04\x04\x0d\x2a\x04\x04"
            "\x0d\x29\x05\x05\x0d\x28\x04\x07\x0c\x27\x05\x07\x0d"
            "\x26\x04\x09\x0c\x26\x04\x0a\x0c\x24\x05\x0a\x0c\x23"
            "\x05\x0c\x0c\x22\x04\x0e\x0c\x20\x05\x0f\x0c\x1e\x05"
            "\x11\x0c\x1c\x05\x13\x0c\x1a\x05\x15\x0c\x17\x06\x18"
            "\x0c\x14\x06\x1a\x0d\x0f\x08\x1d\x0e\x09\x0a\x20\x1d"
            "\x24\x19\x29\x14\x2f\x0c\x15" }  },
      /* --- pixel bitmap for cmr1200 char#100 d --- */
      { 100,13165,                      /* character number, location */
        115, 5,   -2, 5,      /* topleft row,col, and botleft row,col */
          { 82,  117, 2,303, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x3f\x06\x3f\x13\x0d\x00\xff\x04\x2c\x19\x0d\x00\x34"
            "\x11\x44\x0e\x0d\x00\xff\x01\x38\x0d\x0d\x00\xff\x1e"
            "\x39\x0c\x0d\x00\x1f\x0b\x0f\x0c\x27\x14\x0b\x0c\x24"
            "\x19\x09\x0c\x22\x1d\x07\x0c\x20\x0f\x08\x09\x06\x0c"
            "\x1f\x0c\x0f\x08\x04\x0c\x1d\x0c\x13\x07\x03\x0c\x1c"
            "\x0b\x17\x06\x02\x0c\x1b\x0b\x1a\x05\x01\x0c\x19\x0b"
            "\x1d\x11\x18\x0b\x1f\x10\x17\x0b\x21\x0f\x16\x0c\x22"
            "\x0e\x16\x0b\x23\x0e\x15\x0b\x25\x0d\x14\x0c\x25\x0d"
            "\x0d\x00\xff\x01\x06\x0c\x27\x0c\x0d\x00\x05\x0c\x28"
            "\x0c\x11\x0d\x28\x0c\x11\x0c\x29\x0c\x0d\x00\xff\x01"
            "\x03\x0d\x29\x0c\x0d\x00\x03\x0c\x2a\x0c\x0d\x00\xff"
            "\x02\x02\x0d\x2a\x0c\x0d\x00\xff\x01\x01\x0e\x2a\x0c"
            "\x0d\x00\xff\x01\x01\x0d\x2b\x0c\x0d\xff\x0c\x0e\x2b"
            "\x0c\x0d\x00\xff\x02\x01\x0d\x2b\x0c\x0d\x00\xff\x01"
            "\x01\x0e\x2a\x0c\x0d\x00\xff\x02\x02\x0d\x2a\x0c\x0d"
            "\x00\x03\x0c\x2a\x0c\x10\x0d\x29\x0c\x0d\x00\xff\x01"
            "\x04\x0c\x29\x0c\x0d\x00\xff\x01\x05\x0c\x28\x0c\x0d"
            "\x00\x06\x0c\x26\x0d\x14\x0b\x26\x0d\x14\x0c\x24\x0e"
            "\x15\x0b\x23\x0f\x16\x0b\x21\x10\x17\x0b\x20\x10\x18"
            "\x0b\x1e\x12\x18\x0b\x1c\x05\x01\x0d\x19\x0b\x19\x06"
            "\x02\x0e\x19\x0b\x17\x06\x03\x11\x17\x0c\x13\x07\x04"
            "\x19\x11\x0c\x0f\x07\x06\x19\x12\x0e\x08\x0a\x07\x19"
            "\x14\x1d\x08\x19\x16\x19\x0a\x19\x19\x13\x0d\x13\x23"
            "\x0c\x10\x06\x13" }  },
      /* --- pixel bitmap for cmr1200 char#101 e --- */
      { 101,13578,                      /* character number, location */
         74, 5,   -2, 5,      /* topleft row,col, and botleft row,col */
          { 63,   76, 2,239, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1c\x0c\x2f\x14\x29\x18\x25\x1c\x21\x0c\x07\x0d\x1d"
            "\x0b\x0d\x0c\x1a\x0b\x10\x0b\x18\x0a\x13\x0b\x15\x0b"
            "\x15\x0b\x13\x0b\x17\x0b\x11\x0b\x19\x0b\x0f\x0c\x1a"
            "\x0a\x0e\x0c\x1b\x0b\x0d\x0b\x1d\x0b\x0b\x0c\x1d\x0b"
            "\x04\x00\xff\x01\x06\x0c\x1f\x0b\x03\x00\x05\x0c\x20"
            "\x0c\x07\x0c\x21\x0b\x06\x0c\x22\x0b\x06\x0c\x22\x0c"
            "\x01\x00\xff\x01\x03\x0d\x23\x0b\x01\x00\xff\x01\x02"
            "\x0d\x24\x0b\x01\x00\x02\x0d\x24\x0c\xff\x01\x01\x0e"
            "\x24\x0c\x01\x0e\x25\x0b\xff\x01\x01\x0d\x26\x0b\x00"
            "\x0e\x26\x0b\x00\xff\x02\x3f\x00\x3e\x01\xff\x08\x0e"
            "\x31\x00\xff\x01\x01\x0d\x31\x00\xff\x02\x01\x0e\x30"
            "\x00\xff\x01\x02\x0d\x30\x00\x02\x0e\x32\x0d\x2c\x02"
            "\x04\x0d\x2b\x04\x04\x0c\x2b\x04\x04\x0d\x29\x05\x05"
            "\x0c\x29\x05\x05\x0d\x27\x05\x07\x0c\x27\x05\x01\x00"
            "\xff\x01\x07\x0c\x25\x05\x02\x00\x08\x0c\x23\x05\x0c"
            "\x0c\x21\x06\x0d\x0b\x20\x06\x0f\x0b\x1e\x06\x11\x0b"
            "\x1c\x06\x13\x0b\x1a\x06\x16\x0a\x18\x06\x18\x0b\x14"
            "\x07\x1a\x0c\x0f\x09\x1d\x0d\x09\x0a\x21\x1d\x24\x19"
            "\x29\x13\x30\x0c\x15" }  },
      /* --- pixel bitmap for cmr1200 char#102 f --- */
      { 102,13831,                      /* character number, location */
        117, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 54,  117, 2,99, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x22\x0a\x29\x10\x23\x15\x1f\x18\x1d\x0b\x07\x08\x1a"
            "\x0b\x09\x09\x18\x0b\x09\x0b\x16\x0a\x0a\x0c\x15\x0b"
            "\x0a\x0d\x13\x0b\x0a\x0e\xff\x01\x12\x0b\x0b\x0e\x11"
            "\x0b\x0c\x0e\x10\x0c\x0c\x0e\x10\x0b\x0d\x0e\x0f\x0c"
            "\x0e\x0c\x10\x0b\x10\x0a\x10\x0c\x11\x08\x11\x0c\x13"
            "\x04\x13\x0c\x2a\x0b\x1d\x00\xff\x18\x0d\x0c\x1d\xff"
            "\x04\x2b\x0b\x00\xff\x39\x0d\x0c\x1d\x00\x0c\x0e\x28"
            "\x0f\x24\x15\x18\xff\x04\x29\x0d" }  },
      /* --- pixel bitmap for cmr1200 char#103 g --- */
      { 103,14102,                      /* character number, location */
         75, 5,  -35, 5,      /* topleft row,col, and botleft row,col */
          { 75,  110, 2,347, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x3e\x08\x3f\x0e\x1c\x0c\x13\x11\x17\x14\x0d\x14\x14"
            "\x18\x0a\x0a\x04\x07\x12\x1c\x07\x07\x07\x09\x0f\x0d"
            "\x06\x0d\x03\x07\x09\x09\x0e\x0b\x0c\x0b\x01\x06\x0b"
            "\x09\x0d\x0a\x10\x0e\x0c\x0a\x0b\x0b\x12\x0c\x0e\x09"
            "\x0a\x0b\x14\x0b\x0e\x09\x0a\x0a\x16\x0a\x0f\x07\x0a"
            "\x0b\x16\x0b\x0f\x05\x0a\x0b\x18\x0b\x1c\x0c\x18\x0c"
            "\x1b\x0b\x1a\x0b\x14\x00\xff\x01\x06\x0c\x1a\x0c\x13"
            "\x00\xff\x02\x05\x0c\x1c\x0c\x12\x00\xff\x09\x04\x0d"
            "\x1c\x0d\x11\x00\xff\x02\x05\x0c\x1c\x0c\x12\x00\xff"
            "\x01\x06\x0c\x1a\x0c\x13\x00\x07\x0b\x1a\x0b\x1b\x0c"
            "\x18\x0c\x1c\x0b\x18\x0b\x1e\x0b\x16\x0b\x20\x0a\x16"
            "\x0a\x21\x0b\x14\x0b\x22\x0b\x12\x0b\x23\x0c\x10\x0a"
            "\x25\x0e\x0c\x0b\x25\x04\x01\x0d\x06\x0d\x25\x04\x04"
            "\x1c\x27\x04\x06\x18\x28\x04\x09\x14\x2a\x04\x0d\x0c"
            "\x2e\x04\x3f\x00\xff\x05\x07\x05\x3f\x00\xff\x01\x07"
            "\x06\x3e\x00\xff\x01\x07\x07\x3d\x00\x07\x08\x43\x0a"
            "\x42\x0b\x40\x27\x25\x2c\x1f\x2f\x1d\x31\x1b\x32\x1a"
            "\x33\x19\x33\x19\x33\x16\x36\x13\x39\x10\x0b\x1b\x16"
            "\x0e\x09\x23\x12\x0c\x09\x27\x0f\x0b\x08\x2b\x0e\x09"
            "\x09\x2d\x0c\x08\x09\x2f\x0c\x06\x09\x31\x0b\x06\x09"
            "\x32\x0a\x05\x09\x33\x0a\x05\x09\x34\x0a\x03\x0a\x34"
            "\x0a\x03\xff\x06\x09\x36\x09\x03\x00\xff\x01\x01\x09"
            "\x34\x09\x04\x00\x01\x0a\x32\x0a\x06\x09\x32\x09\x07"
            "\x0a\x30\x0a\x08\x0a\x2e\x0a\x0a\x0a\x2c\x0a\x0c\x0a"
            "\x2a\x0a\x0e\x0a\x28\x0a\x10\x0b\x24\x0b\x13\x0b\x20"
            "\x0b\x16\x0c\x1c\x0c\x19\x0d\x16\x0d\x1d\x10\x0c\x10"
            "\x21\x28\x26\x22\x2c\x1c\x35\x10\x1f" }  },
      /* --- pixel bitmap for cmr1200 char#104 h --- */
      { 104,14513,                      /* character number, location */
        115, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 83,  115, 2,160, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x13\x06\x40\x13\x3a\xff\x04\x19\x3a\x00\x08\x11\x45"
            "\x0e\x3a\x00\xff\x01\x0c\x0d\x3a\x00\xff\x1e\x0d\x0c"
            "\x3a\x00\x0d\x0c\x11\x0c\x2a\x0c\x0e\x13\x26\x0c\x0c"
            "\x17\x24\x0c\x0a\x1b\x22\x0c\x09\x09\x07\x0d\x21\x0c"
            "\x08\x06\x0d\x0c\x20\x0c\x06\x06\x11\x0b\x1f\x0c\x05"
            "\x06\x13\x0b\x1e\x0c\x04\x05\x15\x0c\x1d\x0c\x04\x04"
            "\x17\x0b\x1d\x0c\x03\x04\x18\x0c\x1c\x0c\x02\x04\x1a"
            "\x0b\x0f\x00\xff\x01\x0d\x0c\x01\x04\x1b\x0c\x0e\x00"
            "\x0d\x10\x1c\x0c\x1b\x0f\x1e\x0b\x1b\x0f\x1e\x0c\x0d"
            "\x00\xff\x02\x0d\x0e\x1f\x0c\x0d\x00\xff\x03\x0d\x0d"
            "\x20\x0c\x0d\x00\xff\x28\x0d\x0c\x21\x0c\x0d\x00\xff"
            "\x01\x0c\x0e\x1f\x0e\x0c\x00\x09\x14\x19\x14\x09\xff"
            "\x04\x26\x07\x26" }  },
      /* --- pixel bitmap for cmr1200 char#105 i --- */
      { 105,14916,                      /* character number, location */
        112, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 36,  112, 3,148, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xd6\xe0\xea\xe0\xbc\xe0\x9e\xe0\x7e\x02\xc0\xf7\x7e"
            "\x04\xb0\x8e\x02\xe0\x7e\xe0\x9c\xe0\xba\xe0\xe6\xe0"
            "\x30\xfe\xe0\xe0\x80\xf5\xe0\xe0\x80\xe0\x56\xe0\x4e"
            "\x04\xb0\xf4\x1e\x0a\xb0\x9e\x02\xe0\x8e\xb0\xf1\xcd"
            "\xb0\xfe\xdc\xb0\xfe\xdc\xb0\xfe\xdc\xb0\xf8\xdc\xb0"
            "\xf1\xce\xa0\x9e\x05\x8f\x4e\x0e\x08" }  },
      /* --- pixel bitmap for cmr1200 char#106 j --- */
      { 106,15107,                      /* character number, location */
        112,-7,  -34,-7,      /* topleft row,col, and botleft row,col */
          { 42,  146, 2,125, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1e\x06\x22\x0a\x1f\x0c\x1d\x0e\x1b\x10\x01\x00\xff"
            "\x07\x18\x12\x19\x10\x1b\x0e\x1d\x0c\x1f\x0a\x22\x06"
            "\x06\x00\xff\x14\x2a\x00\x24\x06\x17\x13\xff\x04\x10"
            "\x1a\x19\x11\x1c\x0e\xff\x01\x1d\x0d\xff\x4a\x1e\x0c"
            "\x05\x05\x14\x0c\x03\x09\x12\x0c\x02\x0b\x10\x0c\x02"
            "\x0d\x0f\x0c\x01\x0f\x0e\x0c\x01\xff\x01\x0f\x0e\x0b"
            "\x02\x0f\x0d\x0c\x02\xff\x01\x0f\x0d\x0b\x03\x0f\x0c"
            "\x0b\x04\x0e\x0d\x0a\x06\x0d\x0c\x0a\x07\x0b\x0e\x0a"
            "\x08\x09\x0e\x0a\x0a\x08\x0d\x09\x0d\x0a\x08\x0a\x10"
            "\x19\x12\x16\x17\x11\x1c\x0b\x12" }  },
      /* --- pixel bitmap for cmr1200 char#107 k --- */
      { 107,15400,                      /* character number, location */
        115, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 81,  115, 2,298, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x13\x06\x3e\x13\x38\xff\x04\x19\x38\x00\x08\x11\x43"
            "\x0e\x38\x00\xff\x01\x0c\x0d\x38\x00\xff\x20\x0d\x0c"
            "\x38\x00\xff\x04\x0d\x0c\x16\x1e\x04\x00\x0d\x0c\x18"
            "\x17\x16\x0c\x1a\x12\x19\x0c\x1a\x0f\x1c\x0c\x1b\x0c"
            "\x1e\x0c\x1b\x0b\x1f\x0c\x1a\x0a\x21\x0c\x1a\x09\x22"
            "\x0c\x1a\x07\x24\x0c\x19\x07\x25\x0c\x18\x07\x26\x0c"
            "\x17\x06\x28\x0c\x16\x06\x29\x0c\x15\x06\x2a\x0c\x13"
            "\x07\x2b\x0c\x12\x07\x2c\x0c\x11\x06\x2e\x0c\x10\x06"
            "\x2f\x0c\x0f\x06\x30\x0c\x0e\x06\x31\x0c\x0c\x07\x32"
            "\x0c\x0b\x07\x33\x0c\x0a\x08\x33\x0c\x09\x0a\x32\x0c"
            "\x08\x0c\x31\x0c\x07\x0e\x30\x0c\x05\x10\x30\x0c\x04"
            "\x12\x2f\x0c\x03\x14\x2e\x0c\x02\x06\x01\x0e\x2e\x0c"
            "\x01\x06\x03\x0e\x2d\x12\x05\x0e\x2c\x11\x07\x0e\x2b"
            "\x10\x08\x0e\x2b\x0e\x0b\x0e\x2a\x0d\x0d\x0e\x29\x0c"
            "\x0e\x0e\x29\x0b\x10\x0e\x28\x0b\x11\x0e\x1a\x00\xff"
            "\x01\x0d\x0b\x12\x0e\x19\x00\x0d\x0b\x13\x0e\x18\x00"
            "\xff\x01\x0d\x0b\x14\x0e\x17\x00\x0d\x0b\x15\x0e\x23"
            "\x0b\x16\x0e\x15\x00\xff\x01\x0d\x0b\x17\x0e\x14\x00"
            "\x0d\x0b\x18\x0e\x13\x00\xff\x01\x0d\x0b\x19\x0e\x12"
            "\x00\x0d\x0b\x1a\x0e\x1e\x0b\x1b\x0e\x1d\x0b\x1b\x0f"
            "\x1c\x0b\x1c\x0e\x1c\x0b\x1d\x0e\x1b\x0b\x1d\x0f\x1a"
            "\x0b\x1d\x10\x19\x0b\x1d\x11\x17\x0d\x1c\x12\x16\x0d"
            "\x1c\x13\x12\x13\x17\x18\x06\xff\x04\x25\x0b\x21" }  },
      /* --- pixel bitmap for cmr1200 char#108 l --- */
      { 108,15783,                      /* character number, location */
        115, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 38,  115, 2,40, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x13\x06\x14\x12\x0d\xff\x04\x19\x0d\x00\x08\x11\x18"
            "\x0e\x0d\x00\xff\x01\x0c\x0d\x0d\x00\xff\x5f\x0d\x0c"
            "\x0d\x00\xff\x01\x0c\x0e\x0c\x00\x09\x14\x09\xff\x04"
            "\x26" }  },
      /* --- pixel bitmap for cmr1200 char#109 m --- */
      { 109,16020,                      /* character number, location */
         73, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 130,   73, 2,210, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\x12\x06\x13\x0c\x22\x0c\x23\x12\x0f\x14\x1a\x14\x19"
            "\x18\x0d\x18\x16\x18\x17\x18\x0b\x1c\x12\x1c\x15\x18"
            "\x0a\x09\x07\x0e\x10\x09\x07\x0e\x14\x18\x09\x07\x0d"
            "\x0c\x0e\x07\x0d\x0c\x13\x18\x08\x05\x12\x0b\x0c\x05"
            "\x12\x0b\x1a\x10\x07\x05\x14\x0b\x0a\x05\x14\x0b\x1c"
            "\x0d\x06\x04\x16\x0c\x08\x04\x16\x0c\x1c\x0c\x05\x04"
            "\x18\x0b\x07\x04\x18\x0b\x1c\x0c\x04\x04\x19\x0c\x05"
            "\x04\x19\x0c\x1c\x0b\x03\x04\x1b\x0b\x04\x04\x1b\x0b"
            "\x1c\x0b\x03\x03\x1c\x0c\x03\x03\x1c\x0c\x1b\x0b\x02"
            "\x04\x1c\x0c\x02\x04\x1c\x0c\x1b\x0b\x01\x04\x1d\x0c"
            "\x01\x04\x1d\x0c\x1b\x0b\x01\x04\x1e\x0b\x01\x04\x1e"
            "\x0b\x0e\x00\xff\x01\x0d\x0f\x1f\x0f\x1f\x0c\x0d\x00"
            "\xff\x01\x0d\x0e\x20\x0e\x20\x0c\x0d\x00\xff\x03\x0d"
            "\x0d\x21\x0d\x21\x0c\x0d\x00\xff\x28\x0d\x0c\x22\x0c"
            "\x22\x0c\x0d\x00\xff\x01\x0c\x0e\x20\x0e\x20\x0e\x0c"
            "\x00\x09\x14\x1a\x14\x1a\x14\x09\xff\x04\x26\x08\x26"
            "\x08\x26" }  },
      /* --- pixel bitmap for cmr1200 char#110 n --- */
      { 110,16513,                      /* character number, location */
         73, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 83,   73, 3,272, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x46\xe0\x4c\xe0\xe0\x7e\x04\xe0\x1e\x05\xe0\xbe"
            "\x0a\xde\x09\xe0\x9e\x0a\xbe\x0d\xe0\x7e\x0a\xa9\x7d"
            "\xe0\x6e\x0a\x96\xdc\xe0\x5e\x0a\x76\xe0\x3b\xe0\xce"
            "\x02\x66\xe0\x5b\xe0\xed\x55\xe0\x7c\xe0\xec\x54\xe0"
            "\x9b\xe0\xec\x44\xe0\xac\xe0\xeb\x34\xe0\xcb\xe0\x10"
            "\xf1\xdb\x24\xe0\xdc\xe0\xdb\x14\xe0\xec\xe0\xdb\x13"
            "\xe0\xe0\x2b\xe0\xde\x01\xe0\xe0\x2c\xd0\xf2\xde\xe0"
            "\xe0\x3c\xd0\xf3\xdd\xe0\xe0\x4c\xd0\xfe\xdc\xe0\xe0"
            "\x5c\xd0\xfe\xdc\xe0\xe0\x5c\xd0\xfa\xdc\xe0\xe0\x5c"
            "\xd0\xf1\xce\xe0\xe0\x3e\xc0\x9e\x06\xe0\xbe\x06\x9f"
            "\x4e\x0e\x0a\x7e\x0e\x0a" }  },
      /* --- pixel bitmap for cmr1200 char#111 o --- */
      { 111,16836,                      /* character number, location */
         74, 5,   -2, 5,      /* topleft row,col, and botleft row,col */
          { 72,   76, 2,227, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1e\x0c\x38\x14\x31\x1a\x2c\x1e\x28\x0d\x08\x0d\x25"
            "\x0a\x10\x0a\x22\x0a\x14\x0a\x1f\x0a\x16\x0a\x1d\x09"
            "\x1a\x09\x1a\x0a\x1c\x0a\x17\x0a\x1e\x0a\x15\x0a\x20"
            "\x0a\x14\x09\x22\x09\x13\x0a\x22\x0a\x11\x0a\x24\x0a"
            "\x0f\x0b\x24\x0b\x0e\x0a\x26\x0a\x0d\x0b\x26\x0b\x06"
            "\x00\xff\x01\x05\x0b\x28\x0b\x05\x00\x04\x0c\x28\x0c"
            "\x08\x0b\x2a\x0b\x04\x00\xff\x02\x03\x0c\x2a\x0c\x03"
            "\x00\x02\x0d\x2a\x0d\x02\x00\xff\x01\x02\x0c\x2c\x0c"
            "\x02\x00\xff\x03\x01\x0d\x2c\x0d\x01\xff\x0c\x0e\x2c"
            "\x0e\xff\x03\x01\x0d\x2c\x0d\x01\x00\x01\x0e\x2a\x0e"
            "\x01\x00\xff\x02\x02\x0d\x2a\x0d\x02\x00\xff\x01\x03"
            "\x0c\x2a\x0c\x03\x00\xff\x01\x04\x0c\x28\x0c\x04\x00"
            "\x05\x0b\x28\x0b\x0a\x0c\x26\x0c\x0b\x0b\x26\x0b\x06"
            "\x00\xff\x01\x07\x0b\x24\x0b\x07\x00\x08\x0b\x22\x0b"
            "\x11\x0b\x20\x0b\x13\x0a\x20\x0a\x15\x0a\x1e\x0a\x17"
            "\x0a\x1c\x0a\x19\x0a\x1a\x0a\x1b\x0b\x16\x0b\x1e\x0a"
            "\x14\x0a\x21\x0b\x10\x0b\x24\x0d\x08\x0d\x28\x1e\x2c"
            "\x1a\x31\x14\x38\x0c\x1e" }  },
      /* --- pixel bitmap for cmr1200 char#112 p --- */
      { 112,17131,                      /* character number, location */
         73, 4,  -32, 4,      /* topleft row,col, and botleft row,col */
          { 82,  105, 2,289, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x13\x06\x10\x0c\x23\x13\x0d\x13\x19\x19\x0a\x19\x16"
            "\x19\x08\x1d\x14\x19\x06\x0b\x07\x0f\x12\x19\x05\x08"
            "\x0e\x0d\x11\x19\x04\x07\x12\x0d\x17\x11\x03\x06\x16"
            "\x0c\x19\x0e\x02\x05\x19\x0c\x19\x0d\x01\x05\x1b\x0c"
            "\x18\x12\x1d\x0c\x18\x10\x1f\x0c\x17\x0f\x21\x0c\x16"
            "\x0e\x22\x0d\x15\x0d\x24\x0d\x14\x0d\x25\x0c\x14\x0c"
            "\x26\x0d\x06\x00\xff\x01\x0d\x0c\x27\x0d\x05\x00\x0d"
            "\x0c\x27\x0e\x11\x0c\x28\x0d\x11\x0c\x28\x0e\x10\x0c"
            "\x29\x0d\x03\x00\xff\x01\x0d\x0c\x29\x0e\x02\x00\x0d"
            "\x0c\x2a\x0d\x02\x00\xff\x04\x0d\x0c\x2a\x0e\x01\x00"
            "\xff\x0c\x0d\x0c\x2b\x0e\xff\x03\x0d\x0c\x2a\x0e\x01"
            "\x00\x0d\x0c\x2a\x0d\x02\x00\xff\x01\x0d\x0c\x29\x0e"
            "\x02\x00\x0d\x0c\x29\x0d\x03\x00\xff\x01\x0d\x0c\x28"
            "\x0e\x03\x00\x0d\x0c\x28\x0d\x11\x0c\x27\x0e\x11\x0c"
            "\x27\x0d\x12\x0c\x26\x0d\x13\x0d\x25\x0d\x13\x0d\x24"
            "\x0d\x14\x0e\x22\x0d\x15\x0e\x22\x0c\x16\x0f\x20\x0d"
            "\x16\x10\x1e\x0d\x17\x11\x1c\x0d\x18\x0c\x01\x05\x1a"
            "\x0d\x19\x0c\x02\x05\x18\x0c\x1b\x0c\x03\x05\x16\x0c"
            "\x1c\x0c\x04\x06\x12\x0d\x1d\x0c\x05\x07\x0e\x0d\x1f"
            "\x0c\x06\x09\x08\x0f\x20\x0c\x07\x1d\x22\x0c\x09\x19"
            "\x24\x0c\x0b\x14\x27\x0c\x0f\x0b\x1f\x00\xff\x15\x0d"
            "\x0c\x39\x00\xff\x01\x0c\x0e\x38\x00\x09\x14\x35\xff"
            "\x04\x26\x2c" }  },
      /* --- pixel bitmap for cmr1200 char#113 q --- */
      { 113,17522,                      /* character number, location */
         73, 6,  -32, 6,      /* topleft row,col, and botleft row,col */
          { 82,  105, 2,304, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x1e\x0c\x17\x04\x27\x13\x13\x05\x24\x18\x11\x05\x22"
            "\x1c\x0e\x06\x20\x0f\x07\x09\x0d\x06\x1e\x0e\x0d\x07"
            "\x0b\x07\x1d\x0d\x11\x06\x0a\x07\x1c\x0c\x15\x05\x09"
            "\x07\x1a\x0d\x17\x05\x07\x08\x19\x0c\x1a\x05\x06\x08"
            "\x18\x0c\x1c\x05\x04\x09\x17\x0d\x1d\x04\x04\x09\x16"
            "\x0d\x1f\x04\x02\x0a\x15\x0d\x20\x05\x01\x0a\x15\x0c"
            "\x22\x0f\x14\x0d\x22\x0f\x0d\x00\xff\x01\x06\x0d\x24"
            "\x0e\x0d\x00\x05\x0d\x26\x0d\x11\x0e\x26\x0d\x11\x0d"
            "\x27\x0d\x0d\x00\xff\x01\x03\x0e\x28\x0c\x0d\x00\x03"
            "\x0d\x29\x0c\x0d\x00\xff\x01\x02\x0e\x29\x0c\x0d\x00"
            "\x02\x0d\x2a\x0c\x0d\x00\xff\x03\x01\x0e\x2a\x0c\x0d"
            "\xff\x0c\x0e\x2b\x0c\x0d\x00\xff\x04\x01\x0e\x2a\x0c"
            "\x0d\x00\x02\x0d\x2a\x0c\x0d\x00\xff\x01\x02\x0e\x29"
            "\x0c\x0d\x00\x03\x0d\x29\x0c\x10\x0e\x28\x0c\x0d\x00"
            "\xff\x01\x04\x0d\x28\x0c\x0d\x00\xff\x01\x05\x0d\x26"
            "\x0d\x0d\x00\x06\x0d\x24\x0e\x14\x0c\x24\x0e\x14\x0d"
            "\x22\x0f\x15\x0d\x20\x10\x16\x0c\x1f\x11\x17\x0c\x1e"
            "\x04\x01\x0c\x18\x0c\x1c\x05\x01\x0c\x19\x0c\x1a\x05"
            "\x02\x0c\x1a\x0c\x17\x06\x03\x0c\x1b\x0c\x15\x06\x04"
            "\x0c\x1c\x0c\x12\x07\x05\x0c\x1e\x0c\x0e\x08\x06\x0c"
            "\x1f\x0e\x08\x09\x08\x0c\x21\x1c\x09\x0c\x23\x18\x0b"
            "\x0c\x26\x13\x0d\x0c\x2a\x0b\x11\x0c\x0d\x00\xff\x15"
            "\x39\x0c\x0d\x00\xff\x01\x38\x0e\x0c\x00\x35\x14\x09"
            "\x00\xff\x04\x2c\x26" }  },
      /* --- pixel bitmap for cmr1200 char#114 r --- */
      { 114,17925,                      /* character number, location */
         73, 4,    0, 4,      /* topleft row,col, and botleft row,col */
          { 56,   73, 3,213, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe0\x46\xe0\x19\xee\x04\xce\x6e\x0a\xbe\x03\x4e\x0a"
            "\x9e\x06\x3e\x0a\x88\x59\x2e\x0a\x76\x7b\x1e\x0a\x66"
            "\x7c\x9e\x02\x55\x8e\xbd\x54\x9e\xcc\x44\xae\xcc\x34"
            "\xbe\xdb\x34\xbe\xdb\x24\xce\xdb\x24\xdc\xeb\x14\xec"
            "\xeb\x14\xe0\x1a\xe0\x1b\x13\xe0\x46\xe0\x3e\x01\xe0"
            "\xe0\xf3\xde\xe0\xe0\x10\xf4\xdd\xe0\xe0\x20\xfe\xdc"
            "\xe0\xe0\x30\xfe\xdc\xe0\xe0\x30\xf7\xdc\xe0\xe0\x30"
            "\xce\xe0\xe0\xee\x01\xe0\xe0\xae\x07\xe0\xcf\x4e\x0e"
            "\x0d\xe0\x1d" }  },
      /* --- pixel bitmap for cmr1200 char#115 s --- */
      { 115,18138,                      /* character number, location */
         74, 5,   -2, 5,      /* topleft row,col, and botleft row,col */
          { 54,   76, 2,249, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x13\x0e\x0e\x03\x13\x15\x0a\x04\x10\x1b\x06\x05\x0e"
            "\x1e\x04\x06\x0c\x0c\x0c\x0a\x01\x07\x0b\x0a\x12\x0f"
            "\x0a\x08\x17\x0d\x09\x07\x1b\x0b\x08\x07\x1d\x0a\x07"
            "\x07\x1f\x09\x07\x07\x20\x08\x04\x00\xff\x01\x02\x07"
            "\x22\x07\x04\x00\xff\x01\x01\x07\x24\x06\x04\x00\x01"
            "\x07\x25\x05\x04\xff\x02\x08\x25\x05\x04\xff\x01\x09"
            "\x25\x04\x04\xff\x01\x0a\x24\x04\x04\x0c\x22\x04\x04"
            "\x0d\x21\x04\x05\x0e\x28\x10\x26\x13\x24\x16\x20\x1c"
            "\x1b\x1f\x18\x22\x15\x23\x14\x24\x13\x25\x12\x25\x12"
            "\x25\x13\x24\x14\x23\x15\x22\x17\x20\x1b\x1c\x1f\x17"
            "\x24\x13\x26\x10\x28\x0f\x02\x03\x24\x0d\x01\x04\x25"
            "\x0c\x01\x04\x26\x11\x26\x0b\x00\xff\x01\x05\x27\x0a"
            "\x00\x05\x28\x0f\x27\x09\x00\xff\x01\x06\x28\x08\x00"
            "\xff\x01\x07\x27\x08\x00\x07\x27\x07\x01\xff\x01\x08"
            "\x26\x07\x01\x09\x24\x08\x01\xff\x01\x0a\x23\x07\x02"
            "\x0b\x21\x07\x03\x0c\x20\x07\x03\x0d\x1e\x07\x04\x0e"
            "\x1c\x07\x05\x0f\x1a\x07\x06\x08\x02\x07\x16\x08\x07"
            "\x08\x03\x08\x12\x09\x08\x07\x05\x0a\x0b\x0c\x09\x06"
            "\x08\x1d\x0b\x05\x0b\x19\x0d\x04\x0e\x15\x0f\x03\x12"
            "\x0d\x14" }  },
      /* --- pixel bitmap for cmr1200 char#116 t --- */
      { 116,18415,                      /* character number, location */
        102, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 52,  104, 2,137, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x06\x16\x04\x1a\x00\xff\x04\x15\x05\x1a\x00\xff"
            "\x02\x14\x06\x1a\x00\xff\x02\x13\x07\x1a\x00\xff\x01"
            "\x12\x08\x1a\x00\xff\x01\x11\x09\x1a\x00\x10\x0a\x1a"
            "\x00\xff\x01\x0f\x0b\x1a\x00\x0e\x0c\x27\x0d\x26\x0e"
            "\x25\x0f\x23\x11\x21\x13\x1e\x2d\x03\xff\x03\x31\x03"
            "\x00\xff\x23\x0e\x0c\x1a\x00\xff\x0e\x0e\x0c\x16\x04"
            "\x0e\x0c\x15\x05\xff\x02\x0f\x0c\x14\x04\x01\x00\x10"
            "\x0b\x13\x05\x01\x00\xff\x01\x10\x0c\x12\x04\x02\x00"
            "\x11\x0b\x11\x05\x14\x0b\x10\x04\x15\x0c\x0e\x04\x17"
            "\x0c\x0c\x05\x18\x0c\x0a\x05\x1a\x0d\x06\x06\x1d\x16"
            "\x1f\x14\x23\x10\x27\x0a\x0c" }  },
      /* --- pixel bitmap for cmr1200 char#117 u --- */
      { 117,18686,                      /* character number, location */
         73, 5,   -2, 5,      /* topleft row,col, and botleft row,col */
          { 83,   75, 2,141, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x13\x06\x27\x06\x13\x13\x1a\x13\x0d\xff\x04\x19\x14"
            "\x19\x0d\x00\x08\x11\x1c\x11\x18\x0e\x1f\x0e\x0d\x00"
            "\xff\x01\x0c\x0d\x20\x0d\x0d\x00\xff\x28\x0d\x0c\x21"
            "\x0c\x0d\x00\xff\x03\x0d\x0c\x20\x0d\x0d\x00\xff\x02"
            "\x0d\x0c\x1f\x0e\x0d\x00\xff\x01\x0e\x0b\x1e\x0f\x0d"
            "\x00\x0e\x0b\x1d\x10\x1b\x0c\x1b\x04\x01\x0c\x1c\x0b"
            "\x1b\x04\x01\x0c\x1c\x0b\x1a\x04\x02\x0d\x1c\x0b\x18"
            "\x04\x03\x0d\x1d\x0a\x17\x05\x03\x0e\x1c\x0b\x15\x05"
            "\x04\x11\x1a\x0b\x13\x05\x05\x19\x13\x0c\x0f\x06\x06"
            "\x19\x14\x0e\x09\x08\x07\x19\x16\x1c\x08\x19\x18\x18"
            "\x0a\x19\x1a\x14\x0c\x13\x24\x0d\x0f\x06\x13" }  },
      /* --- pixel bitmap for cmr1200 char#118 v --- */
      { 118,19011,                      /* character number, location */
         71, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 81,   73, 2,271, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x04\x00\x23\x13\x1b\x08\x15\x1c\x14\x0e\x11\x20"
            "\x0f\x12\x0f\x22\x0c\x15\x0e\x23\x0a\x16\x0e\x23\x09"
            "\x18\x0d\x24\x07\x0c\x00\xff\x01\x0e\x0c\x24\x06\x0d"
            "\x00\x0e\x0d\x23\x05\x1d\x0c\x23\x05\x1d\x0d\x21\x05"
            "\x0f\x00\xff\x01\x10\x0c\x21\x04\x10\x00\x10\x0d\x1f"
            "\x05\x21\x0c\x1f\x04\x22\x0d\x1e\x04\x11\x00\xff\x01"
            "\x12\x0c\x1d\x04\x12\x00\x12\x0d\x1b\x05\x25\x0c\x1b"
            "\x04\x26\x0d\x19\x05\x13\x00\xff\x01\x14\x0c\x19\x04"
            "\x14\x00\x14\x0d\x17\x05\x29\x0c\x17\x04\x2a\x0d\x15"
            "\x05\x15\x00\xff\x01\x16\x0c\x15\x04\x16\x00\x16\x0d"
            "\x13\x05\x2d\x0c\x13\x04\x2e\x0d\x11\x05\x17\x00\xff"
            "\x01\x18\x0c\x11\x04\x18\x00\x18\x0d\x0f\x05\x31\x0c"
            "\x0f\x04\x32\x0d\x0d\x05\x19\x00\xff\x01\x1a\x0c\x0d"
            "\x04\x1a\x00\x1a\x0d\x0b\x05\x35\x0c\x0b\x04\x36\x0d"
            "\x09\x05\x37\x0c\x09\x04\x38\x0d\x08\x04\x38\x0d\x07"
            "\x05\x39\x0c\x07\x04\x3a\x0d\x05\x05\x3b\x0c\x05\x04"
            "\x3c\x0d\x04\x04\x3c\x0d\x03\x05\x3d\x0c\x03\x04\x3e"
            "\x0d\x01\x05\x3f\x0c\x01\x04\x20\x00\xff\x01\x20\x11"
            "\x20\x00\xff\x01\x21\x0f\x21\x00\xff\x01\x22\x0d\x22"
            "\x00\xff\x02\x23\x0b\x23\x00\xff\x01\x24\x09\x24\x00"
            "\xff\x02\x25\x07\x25\x00\x26\x05\x4d\x03\x27" }  },
      /* --- pixel bitmap for cmr1200 char#119 w --- */
      { 119,19278,                      /* character number, location */
         71, 3,   -2, 3,      /* topleft row,col, and botleft row,col */
          { 113,   73, 2,443, (pixbyte *)/* width,ht, fmt,pixsz,map.. */
            "\xff\x04\x00\x22\x06\x21\x0d\x1b\x07\x15\x13\x14\x16"
            "\x14\x0d\x11\x18\x0f\x1b\x0f\x10\x0f\x19\x0e\x1d\x0c"
            "\x13\x0e\x1a\x0c\x1f\x0a\x14\x0d\x1c\x0b\x1f\x09\x16"
            "\x0d\x1b\x0b\x20\x07\x17\x0d\x1c\x0a\x20\x06\x19\x0c"
            "\x1c\x0b\x1f\x06\x19\x0c\x1c\x0b\x1f\x05\x1a\x0d\x1c"
            "\x0a\x1f\x05\x0d\x00\xff\x01\x0e\x0c\x1c\x0b\x1e\x04"
            "\x0e\x00\x0e\x0d\x1b\x0c\x1c\x05\x1d\x0c\x1b\x0c\x1c"
            "\x04\x1e\x0c\x1a\x0d\x1c\x04\x0f\x00\xff\x01\x10\x0c"
            "\x19\x0e\x1a\x04\x10\x00\x10\x0d\x17\x04\x01\x0a\x19"
            "\x05\x10\x00\xff\x01\x11\x0c\x17\x04\x01\x0b\x18\x04"
            "\x11\x00\x11\x0d\x15\x04\x03\x0a\x17\x05\x23\x0c\x15"
            "\x04\x03\x0b\x16\x04\x24\x0c\x14\x05\x03\x0b\x16\x04"
            "\x24\x0d\x13\x04\x05\x0a\x15\x05\x25\x0c\x13\x04\x05"
            "\x0b\x14\x04\x26\x0c\x12\x05\x05\x0b\x14\x04\x26\x0d"
            "\x11\x04\x07\x0b\x12\x05\x27\x0c\x11\x04\x07\x0b\x12"
            "\x04\x28\x0c\x10\x05\x07\x0b\x12\x04\x14\x00\xff\x01"
            "\x15\x0c\x0f\x04\x09\x0b\x10\x04\x15\x00\x15\x0d\x0d"
            "\x05\x09\x0b\x0f\x05\x15\x00\xff\x01\x16\x0c\x0d\x04"
            "\x0b\x0b\x0e\x04\x16\x00\x16\x0d\x0b\x04\x0d\x0a\x0d"
            "\x05\x2d\x0c\x0b\x04\x0d\x0b\x0c\x04\x2e\x0c\x0a\x05"
            "\x0d\x0b\x0c\x04\x2e\x0d\x09\x04\x0f\x0a\x0b\x05\x2f"
            "\x0c\x09\x04\x0f\x0b\x0a\x04\x30\x0c\x08\x05\x0f\x0b"
            "\x0a\x04\x30\x0d\x07\x04\x11\x0a\x09\x05\x31\x0c\x07"
            "\x04\x11\x0b\x08\x04\x32\x0c\x06\x05\x11\x0b\x08\x04"
            "\x19\x00\xff\x01\x1a\x0c\x05\x04\x13\x0b\x06\x04\x1a"
            "\x00\x1a\x0d\x03\x05\x13\x0b\x06\x04\x1a\x00\xff\x01"
            "\x1b\x0c\x03\x04\x15\x0b\x04\x04\x1b\x00\x1b\x0d\x01"
            "\x04\x17\x0a\x03\x05\x37\x0c\x01\x04\x17\x0b\x02\x04"
            "\x38\x11\x17\x0b\x02\x04\x38\x10\x19\x0a\x01\x05\x1c"
            "\x00\xff\x01\x1d\x0f\x19\x0f\x1d\x00\x1d\x0e\x1b\x0e"
            "\x1d\x00\xff\x01\x1e\x0d\x1b\x0d\x1e\x00\xff\x02\x1f"
            "\x0b\x1d\x0b\x1f\x00\xff\x01\x20\x09\x1f\x09\x20\x00"
            "\x20\x08\x21\x08\x20\x00\xff\x01\x21\x07\x21\x07\x21"
            "\x00\x21\x06\x23\x06\x43\x05\x23\x05\x45\x03\x25\x03"
            "\x23" }  },
      /* --- pixel bitmap for cmr1200 char#120 x --- */
      { 120,19757,                      /* character number, location */
         71, 2,    0, 2,      /* topleft row,col, and botleft row,col */
          { 83,   71, 2,236, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x04\x01\x22\x10\x1d\x03\x00\x09\x17\x15\x16\x14"
            "\x13\x17\x11\x19\x11\x19\x0e\x1d\x0f\x19\x0c\x1f\x0e"
            "\x1a\x0a\x22\x0e\x19\x09\x24\x0d\x19\x08\x26\x0d\x18"
            "\x07\x28\x0d\x17\x06\x2a\x0c\x16\x06\x2b\x0d\x14\x06"
            "\x2d\x0d\x13\x05\x2f\x0d\x11\x05\x31\x0c\x10\x05\x32"
            "\x0d\x0e\x05\x34\x0d\x0d\x05\x35\x0d\x0b\x05\x37\x0c"
            "\x0a\x05\x38\x0d\x08\x05\x3a\x0d\x06\x05\x3c\x0d\x05"
            "\x05\x3d\x0c\x04\x05\x3e\x0d\x02\x05\x40\x12\x42\x10"
            "\x44\x0f\x24\x00\xff\x01\x21\x0d\x25\x00\x22\x0d\x47"
            "\x0d\x47\x0c\x47\x0d\x46\x0e\x44\x10\x42\x11\x42\x12"
            "\x40\x05\x02\x0d\x3e\x05\x04\x0d\x3c\x05\x06\x0c\x3b"
            "\x05\x07\x0d\x3a\x05\x08\x0d\x38\x05\x0a\x0d\x36\x05"
            "\x0c\x0c\x35\x05\x0d\x0d\x33\x05\x0f\x0d\x32\x05\x10"
            "\x0d\x30\x05\x12\x0d\x2e\x05\x14\x0c\x2d\x05\x15\x0d"
            "\x2b\x05\x17\x0d\x29\x06\x18\x0d\x27\x06\x1a\x0c\x27"
            "\x06\x1a\x0d\x25\x06\x1c\x0d\x22\x08\x1d\x0d\x20\x09"
            "\x1d\x0e\x1e\x0a\x1d\x0e\x1c\x0c\x1d\x0f\x19\x0f\x1c"
            "\x10\x16\x11\x1b\x13\x10\x17\x18\x17\x08\xff\x04\x1e"
            "\x13\x22" }  },
      /* --- pixel bitmap for cmr1200 char#121 y --- */
      { 121,20022,                      /* character number, location */
         71, 3,  -34, 3,      /* topleft row,col, and botleft row,col */
          { 81,  105, 2,371, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x04\x00\x23\x13\x1b\x08\x15\x1c\x14\x0e\x11\x20"
            "\x0f\x12\x0f\x22\x0c\x15\x0e\x23\x0a\x17\x0d\x23\x09"
            "\x18\x0d\x24\x07\x1a\x0c\x24\x06\x1b\x0d\x23\x05\x1d"
            "\x0c\x23\x05\x1d\x0c\x22\x05\x1e\x0d\x21\x05\x1f\x0c"
            "\x21\x04\x20\x0d\x20\x04\x10\x00\xff\x01\x11\x0c\x1f"
            "\x04\x11\x00\x11\x0d\x1d\x05\x23\x0c\x1d\x04\x24\x0d"
            "\x1b\x05\x25\x0c\x1b\x04\x26\x0d\x1a\x04\x26\x0d\x19"
            "\x05\x27\x0c\x19\x04\x28\x0d\x17\x05\x29\x0c\x17\x04"
            "\x2a\x0d\x16\x04\x15\x00\xff\x01\x16\x0c\x15\x04\x16"
            "\x00\x16\x0d\x13\x05\x2d\x0c\x13\x04\x2e\x0d\x11\x05"
            "\x2f\x0c\x11\x04\x30\x0d\x10\x04\x30\x0d\x0f\x05\x31"
            "\x0c\x0f\x04\x32\x0d\x0d\x05\x33\x0c\x0d\x04\x34\x0d"
            "\x0c\x04\x1a\x00\xff\x01\x1b\x0c\x0b\x04\x1b\x00\x1b"
            "\x0d\x09\x05\x37\x0c\x09\x04\x38\x0d\x07\x05\x1c\x00"
            "\xff\x01\x1d\x0c\x07\x04\x1d\x00\x1d\x0d\x05\x05\x3b"
            "\x0c\x05\x04\x3c\x0d\x03\x05\x3d\x0c\x03\x04\x3e\x0d"
            "\x02\x04\x3e\x0d\x01\x05\x3f\x0c\x01\x04\x40\x11\x20"
            "\x00\xff\x01\x21\x0f\x21\x00\xff\x02\x22\x0d\x22\x00"
            "\xff\x01\x23\x0b\x23\x00\xff\x02\x24\x09\x24\x00\xff"
            "\x01\x25\x07\x25\x00\xff\x01\x26\x05\x26\x00\xff\x01"
            "\x26\x04\x27\x00\x25\x05\x4c\x04\x4c\x05\x28\x00\xff"
            "\x01\x24\x04\x29\x00\x23\x05\x4c\x04\x4c\x05\x2a\x00"
            "\xff\x01\x22\x04\x2b\x00\x21\x04\x31\x04\x18\x04\x2f"
            "\x08\x15\x05\x2e\x0a\x14\x04\x2e\x0c\x12\x05\x2d\x0e"
            "\x11\x04\x2e\x0e\x10\x05\x2e\x0e\x10\x04\x2f\x0e\x0f"
            "\x05\x2f\x0e\x0f\x04\x30\x0e\x0e\x05\x30\x0d\x0e\x05"
            "\x32\x0c\x0d\x05\x33\x0b\x0d\x05\x35\x08\x0e\x06\x35"
            "\x06\x0f\x06\x37\x06\x0c\x07\x39\x08\x07\x08\x3b\x14"
            "\x3f\x11\x41\x0e\x46\x08\x3e" }  },
      /* --- pixel bitmap for cmr1200 char#122 z --- */
      { 122,20385,                      /* character number, location */
         71, 5,    0, 5,      /* topleft row,col, and botleft row,col */
          { 61,   71, 2,243, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\x04\x38\x01\x00\xff\x02\x04\x39\x04\x11\x19\x0e\x05"
            "\x0c\x1d\x0f\x05\x0a\x1f\x0e\x05\x0a\x1f\x0e\x06\x08"
            "\x20\x0e\x07\x07\x20\x0f\x07\x07\x20\x0e\x08\x06\x20"
            "\x0e\x09\x06\x1f\x0f\x09\x05\x1f\x0f\x0a\x05\x1f\x0e"
            "\x0b\x05\x1e\x0e\x0c\x04\x1e\x0f\x0c\x04\x1d\x0f\x0d"
            "\x04\x1d\x0e\x0e\x04\x1c\x0e\x0e\x05\x1b\x0f\x0e\x04"
            "\x1c\x0e\x0f\x04\x1b\x0e\x10\x04\x1a\x0e\x11\x04\x19"
            "\x0f\x11\x04\x19\x0e\x12\x04\x18\x0e\x2e\x0f\x2d\x0f"
            "\x2e\x0e\x2e\x0e\x2e\x0f\x2e\x0e\x2e\x0e\x2e\x0e\x2e"
            "\x0f\x2e\x0e\x2e\x0e\x2e\x0e\x2e\x0f\x2e\x0e\x17\x04"
            "\x13\x0e\x18\x04\x12\x0f\x18\x04\x11\x0f\x19\x04\x11"
            "\x0e\x1a\x04\x10\x0e\x1a\x04\x10\x0f\x1a\x04\x10\x0e"
            "\x1b\x04\x0f\x0e\x1c\x04\x0e\x0e\x1d\x04\x0d\x0f\x1d"
            "\x04\x0d\x0e\x1d\x05\x0c\x0e\x1e\x05\x0b\x0f\x1e\x05"
            "\x0a\x0f\x1f\x05\x0a\x0e\x1f\x05\x0a\x0e\x20\x05\x09"
            "\x0f\x20\x05\x08\x0f\x20\x06\x08\x0e\x21\x06\x07\x0e"
            "\x21\x07\x06\x0f\x20\x08\x06\x0e\x20\x09\x05\x0e\x20"
            "\x0a\x04\x0e\x1f\x0c\x03\x0f\x1d\x0e\x03\x0e\x19\x12"
            "\x03\xff\x02\x3a\x03\x00\x01\x39\x03" }  },
      /* --- pixel bitmap for cmr1200 char#123 (noname) --- */
      { 123,44922,                      /* character number, location */
         46, 0,   42, 0,      /* topleft row,col, and botleft row,col */
          { 82,    4, 2, 4, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\xff\x03\x00\x52" }  },
      /* --- pixel bitmap for cmr1200 char#124 (noname) --- */
      { 124,44941,                      /* character number, location */
         46, 0,   42, 0,      /* topleft row,col, and botleft row,col */
          { 165,    4, 2, 4, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xff\x03\x00\xa5" }  },
      /* --- pixel bitmap for cmr1200 char#125 (noname) --- */
      { 125,41438,                      /* character number, location */
        116,21,   85,21,      /* topleft row,col, and botleft row,col */
          { 48,   31, 3,189, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xc5\xe0\x85\xe8\xe0\x58\xd9\xe0\x49\x20\xf1\x9b\xe0"
            "\x2b\x10\xf1\x8d\xed\x8c\xe0\x1c\x10\xf1\x7d\xed\x10"
            "\x7c\xe0\x1c\x8c\xe0\x1c\x9b\xe0\x2b\x9c\xe0\x1c\x9b"
            "\xe0\x2b\xaa\xe0\x3a\x60\xf1\x4a\xe0\x3a\x70\x49\xe0"
            "\x49\xb9\xe0\x49\x90\xf1\x38\xe0\x58\xa0\x28\xe0\x58"
            "\xb0\xf1\x27\xe0\x67\xc0\x17\xe0\x67\xe6\xe0\x76\xe0"
            "\x15\xe0\x85\xe0\x16\xe0\x76\xe0\x15\xe0\x85\xe0\x42"
            "\xe0\xb2\xe0\x30" }  },
      /* --- pixel bitmap for cmr1200 char#126 \~ --- */
      { 126,41569,                      /* character number, location */
        111,14,   95,14,      /* topleft row,col, and botleft row,col */
          { 54,   16, 3,121, (pixbyte *)/* width,ht, fmt,pixsz,map... */
            "\xe7\xe0\xe0\x21\xeb\xe0\xd3\xbe\x01\xe0\xa5\x9e\x04"
            "\xe0\x75\x9e\x07\xe0\x36\x9e\x09\xe0\x17\x8e\x0c\xb8"
            "\x8e\x0e\x02\x69\x89\x6e\x0e\x02\x88\xbe\x0c\x87\xe0"
            "\x1e\x09\x96\xe0\x3e\x07\x95\xe0\x7e\x04\x95\xe0\xae"
            "\x01\xb3\xe0\xdb\xe1\xe0\xe0\x27\xe8" }  },
      /* --- pixel bitmap for cmr1200 char#127 (noname) --- */
      { 127,41640,                      /* character number, location */
        112,17,   95,17,      /* topleft row,col, and botleft row,col */
          { 48,   17, 3,83, (pixbyte *) /* width,ht, fmt,pixsz,map... */
            "\x56\xe0\xc6\x8a\xe0\x8a\x5c\xe0\x6c\x3e\xe0\x4e\x1f"
            "\x2e\x02\xe0\x2e\x02\x0f\x2e\x03\xee\x03\x0f\x2e\x02"
            "\xe0\x2e\x02\x1e\xe0\x4e\x3c\xe0\x6c\x5a\xe0\x8a\x86"
            "\xe0\xc6\x56" }  },
      /* --- trailer  --- */
      { -99, -999,  0,0,0,0, { 0,0,0,0, (pixbyte *)"\0" }  }
   } ;
#endif


/* ==================== end-of-file texfonts.h ========================= */
#endif
